/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(W){for(var t=[],F=0,y=W.length;F<y;F++)t[F]=ie[W[F]];return t};const je=this,Ce=typeof global=="object"?global:{};var he;(function(W){W.global=je;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof W.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}W.Environment=t})(he||(he={}));var he;(function(W){class t{constructor(o,N,f){this.type=o,this.detail=N,this.timestamp=f}}W.LoaderEvent=t;class F{constructor(o){this._events=[new t(1,"",o)]}record(o,N){this._events.push(new t(o,N,W.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}W.LoaderEventRecorder=F;class y{record(o,N){}getEvents(){return[]}}y.INSTANCE=new y,W.NullLoaderEventRecorder=y})(he||(he={}));var he;(function(W){class t{static fileUriToFilePath(y,r){if(r=decodeURI(r).replace(/%23/g,"#"),y){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(y,r){return y.length>=r.length&&y.substr(0,r.length)===r}static endsWith(y,r){return y.length>=r.length&&y.substr(y.length-r.length)===r}static containsQueryString(y){return/^[^\#]*\?/gi.test(y)}static isAbsolutePath(y){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(y)}static forEachProperty(y,r){if(y){let o;for(o in y)y.hasOwnProperty(o)&&r(o,y[o])}}static isEmpty(y){let r=!0;return t.forEachProperty(y,()=>{r=!1}),r}static recursiveClone(y){if(!y||typeof y!="object"||y instanceof RegExp||!Array.isArray(y)&&Object.getPrototypeOf(y)!==Object.prototype)return y;let r=Array.isArray(y)?[]:{};return t.forEachProperty(y,(o,N)=>{N&&typeof N=="object"?r[o]=t.recursiveClone(N):r[o]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(y){return t.startsWith(y,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=W.global.performance&&typeof W.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?W.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,W.Utilities=t})(he||(he={}));var he;(function(W){function t(r){if(r instanceof Error)return r;const o=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(o.stack=r.stack),o}W.ensureError=t;class F{static validateConfigurationOptions(o){function N(f){if(f.phase==="loading"){console.error('Loading "'+f.moduleId+'" failed'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}if(f.phase==="factory"){console.error('The factory function of "'+f.moduleId+'" has thrown an exception'),console.error(f),console.error("Here are the modules that depend on it:"),console.error(f.neededBy);return}}if(o=o||{},typeof o.baseUrl!="string"&&(o.baseUrl=""),typeof o.isBuild!="boolean"&&(o.isBuild=!1),typeof o.paths!="object"&&(o.paths={}),typeof o.config!="object"&&(o.config={}),typeof o.catchError>"u"&&(o.catchError=!1),typeof o.recordStats>"u"&&(o.recordStats=!1),typeof o.urlArgs!="string"&&(o.urlArgs=""),typeof o.onError!="function"&&(o.onError=N),Array.isArray(o.ignoreDuplicateModules)||(o.ignoreDuplicateModules=[]),o.baseUrl.length>0&&(W.Utilities.endsWith(o.baseUrl,"/")||(o.baseUrl+="/")),typeof o.cspNonce!="string"&&(o.cspNonce=""),typeof o.preferScriptTags>"u"&&(o.preferScriptTags=!1),o.nodeCachedData&&typeof o.nodeCachedData=="object"&&(typeof o.nodeCachedData.seed!="string"&&(o.nodeCachedData.seed="seed"),(typeof o.nodeCachedData.writeDelay!="number"||o.nodeCachedData.writeDelay<0)&&(o.nodeCachedData.writeDelay=1e3*7),!o.nodeCachedData.path||typeof o.nodeCachedData.path!="string")){const f=t(new Error("INVALID cached data configuration, 'path' MUST be set"));f.phase="configuration",o.onError(f),o.nodeCachedData=void 0}return o}static mergeConfigurationOptions(o=null,N=null){let f=W.Utilities.recursiveClone(N||{});return W.Utilities.forEachProperty(o,(a,s)=>{a==="ignoreDuplicateModules"&&typeof f.ignoreDuplicateModules<"u"?f.ignoreDuplicateModules=f.ignoreDuplicateModules.concat(s):a==="paths"&&typeof f.paths<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.paths[h]=A):a==="config"&&typeof f.config<"u"?W.Utilities.forEachProperty(s,(h,A)=>f.config[h]=A):f[a]=W.Utilities.recursiveClone(s)}),F.validateConfigurationOptions(f)}}W.ConfigurationOptionsUtil=F;class y{constructor(o,N){if(this._env=o,this.options=F.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let f=this.options.nodeRequire.main.filename,a=Math.max(f.lastIndexOf("/"),f.lastIndexOf("\\"));this.options.baseUrl=f.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let o=0;o<this.options.ignoreDuplicateModules.length;o++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[o]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],W.Utilities.forEachProperty(this.options.paths,(o,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:o,to:N}):this.sortedPathsRules.push({from:o,to:[N]})}),this.sortedPathsRules.sort((o,N)=>N.from.length-o.from.length)}cloneAndMerge(o){return new y(this._env,F.mergeConfigurationOptions(o,this.options))}getOptionsLiteral(){return this.options}_applyPaths(o){let N;for(let f=0,a=this.sortedPathsRules.length;f<a;f++)if(N=this.sortedPathsRules[f],W.Utilities.startsWith(o,N.from)){let s=[];for(let h=0,A=N.to.length;h<A;h++)s.push(N.to[h]+o.substr(N.from.length));return s}return[o]}_addUrlArgsToUrl(o){return W.Utilities.containsQueryString(o)?o+"&"+this.options.urlArgs:o+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(o){return this.options.urlArgs?this._addUrlArgsToUrl(o):o}_addUrlArgsIfNecessaryToUrls(o){if(this.options.urlArgs)for(let N=0,f=o.length;N<f;N++)o[N]=this._addUrlArgsToUrl(o[N]);return o}moduleIdToPaths(o){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(o))return this.isBuild()?["empty:"]:["node|"+o];let N=o,f;if(!W.Utilities.endsWith(N,".js")&&!W.Utilities.isAbsolutePath(N)){f=this._applyPaths(N);for(let a=0,s=f.length;a<s;a++)this.isBuild()&&f[a]==="empty:"||(W.Utilities.isAbsolutePath(f[a])||(f[a]=this.options.baseUrl+f[a]),!W.Utilities.endsWith(f[a],".js")&&!W.Utilities.containsQueryString(f[a])&&(f[a]=f[a]+".js"))}else!W.Utilities.endsWith(N,".js")&&!W.Utilities.containsQueryString(N)&&(N=N+".js"),f=[N];return this._addUrlArgsIfNecessaryToUrls(f)}requireToUrl(o){let N=o;return W.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],W.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(o){return!!(!this.options.isBuild||W.Utilities.isAnonymousModule(o)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[o])}isDuplicateMessageIgnoredFor(o){return this.ignoreDuplicateModulesMap.hasOwnProperty(o)}getConfigForModule(o){if(this.options.config)return this.options.config[o]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(o){this.options.onError(o)}}W.Configuration=y})(he||(he={}));var he;(function(W){class t{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,h,A,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=s.getConfig().getOptionsLiteral();e?this._scriptLoader=new F:this._scriptLoader=new o(this._env)}else this._env.isNode?this._scriptLoader=new o(this._env):this._scriptLoader=new F;let g={callback:A,errorback:b};if(this._callbackMap.hasOwnProperty(h)){this._callbackMap[h].push(g);return}this._callbackMap[h]=[g],this._scriptLoader.load(s,h,()=>this.triggerCallback(h),e=>this.triggerErrorback(h,e))}triggerCallback(s){let h=this._callbackMap[s];delete this._callbackMap[s];for(let A=0;A<h.length;A++)h[A].callback()}triggerErrorback(s,h){let A=this._callbackMap[s];delete this._callbackMap[s];for(let b=0;b<A.length;b++)A[b].errorback(h)}}class F{attachListeners(s,h,A){let b=()=>{s.removeEventListener("load",g),s.removeEventListener("error",e)},g=E=>{b(),h()},e=E=>{b(),A(E)};s.addEventListener("load",g),s.addEventListener("error",e)}load(s,h,A,b){if(/^node\|/.test(h)){let g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=h.split("|"),R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],()=>R),A()}else{let g=document.createElement("script");g.setAttribute("async","async"),g.setAttribute("type","text/javascript"),this.attachListeners(g,A,b);const{trustedTypesPolicy:e}=s.getConfig().getOptionsLiteral();e&&(h=e.createScriptURL(h)),g.setAttribute("src",h);const{cspNonce:E}=s.getConfig().getOptionsLiteral();E&&g.setAttribute("nonce",E),document.getElementsByTagName("head")[0].appendChild(g)}}}function y(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=y(s)),this._cachedCanUseEval}load(s,h,A,b){if(/^node\|/.test(h)){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=h.split("|");let R=null;try{R=e(E[1])}catch(L){b(L);return}s.enqueueDefineAnonymousModule([],function(){return R}),A()}else{const{trustedTypesPolicy:g}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(h).then(E=>{if(E.status!==200)throw new Error(E.statusText);return E.text()}).then(E=>{E=`${E}
//# sourceURL=${h}`,(g?self.eval(g.createScript("",E)):new Function(E)).call(self),A()}).then(void 0,b);return}try{g&&(h=g.createScriptURL(h)),importScripts(h),A()}catch(E){b(E)}}}}class o{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,h){const{nodeCachedData:A}=h.getConfig().getOptionsLiteral();if(!A||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,g=s("module");function e(E){const R=E.constructor;let L=function(m){try{return E.require(m)}finally{}};return L.resolve=function(m,u){return R._resolveFilename(m,E,!1,u)},L.resolve.paths=function(m){return R._resolveLookupPaths(m,E)},L.main=process.mainModule,L.extensions=R._extensions,L.cache=R._cache,L}g.prototype._compile=function(E,R){const L=g.wrap(E.replace(/^#!.*/,"")),$=h.getRecorder(),m=b._getCachedDataPath(A,R),u={filename:R};let c;try{const p=b._fs.readFileSync(m);c=p.slice(0,16),u.cachedData=p.slice(16),$.record(60,m)}catch{$.record(61,m)}const i=new b._vm.Script(L,u),l=i.runInThisContext(u),v=b._path.dirname(R),d=e(this),w=[this.exports,d,this,R,v,process,Ce,Buffer],M=l.apply(this.exports,w);return b._handleCachedData(i,L,m,!u.cachedData,h),b._verifyCachedData(i,L,m,c,h),M}}load(s,h,A,b){const g=s.getConfig().getOptionsLiteral(),e=N(s.getRecorder(),g.nodeRequire||W.global.nodeRequire),E=g.nodeInstrumenter||function(L){return L};this._init(e),this._initNodeRequire(e,s);let R=s.getRecorder();if(/^node\|/.test(h)){let L=h.split("|"),$=null;try{$=e(L[1])}catch(m){b(m);return}s.enqueueDefineAnonymousModule([],()=>$),A()}else{h=W.Utilities.fileUriToFilePath(this._env.isWindows,h);const L=this._path.normalize(h),$=this._getElectronRendererScriptPathOrUri(L),m=!!g.nodeCachedData,u=m?this._getCachedDataPath(g.nodeCachedData,h):void 0;this._readSourceAndCachedData(L,u,R,(c,i,l,v)=>{if(c){b(c);return}let d;i.charCodeAt(0)===o._BOM?d=o._PREFIX+i.substring(1)+o._SUFFIX:d=o._PREFIX+i+o._SUFFIX,d=E(d,L);const w={filename:$,cachedData:l},M=this._createAndEvalScript(s,d,w,A,b);this._handleCachedData(M,d,u,m&&!l,s),this._verifyCachedData(M,d,u,v,s)})}}_createAndEvalScript(s,h,A,b,g){const e=s.getRecorder();e.record(31,A.filename);const E=new this._vm.Script(h,A),R=E.runInThisContext(A),L=s.getGlobalAMDDefineFunc();let $=!1;const m=function(){return $=!0,L.apply(null,arguments)};return m.amd=L.amd,R.call(W.global,s.getGlobalAMDRequireFunc(),m,A.filename,this._path.dirname(A.filename)),e.record(32,A.filename),$?b():g(new Error(`Didn't receive define call in ${A.filename}!`)),E}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let h=s.match(/^([a-z])\:(.*)/i);return h?`file:///${(h[1].toUpperCase()+":"+h[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,h){const A=this._crypto.createHash("md5").update(h,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(h).replace(/\.js$/,"");return this._path.join(s.path,`${b}-${A}.code`)}_handleCachedData(s,h,A,b,g){s.cachedDataRejected?this._fs.unlink(A,e=>{g.getRecorder().record(62,A),this._createAndWriteCachedData(s,h,A,g),e&&g.getConfig().onError(e)}):b&&this._createAndWriteCachedData(s,h,A,g)}_createAndWriteCachedData(s,h,A,b){let g=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,E=0,R;const L=()=>{setTimeout(()=>{R||(R=this._crypto.createHash("md5").update(h,"utf8").digest());const $=s.createCachedData();if(!($.length===0||$.length===e||E>=5)){if($.length<e){L();return}e=$.length,this._fs.writeFile(A,Buffer.concat([R,$]),m=>{m&&b.getConfig().onError(m),b.getRecorder().record(63,A),L()})}},g*Math.pow(4,E++))};L()}_readSourceAndCachedData(s,h,A,b){if(!h)this._fs.readFile(s,{encoding:"utf8"},b);else{let g,e,E,R=2;const L=$=>{$?b($):--R===0&&b(void 0,g,e,E)};this._fs.readFile(s,{encoding:"utf8"},($,m)=>{g=m,L($)}),this._fs.readFile(h,($,m)=>{!$&&m&&m.length>0?(E=m.slice(0,16),e=m.slice(16),A.record(60,h)):A.record(61,h),L()})}}_verifyCachedData(s,h,A,b,g){b&&(s.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(h,"utf8").digest();b.equals(e)||(g.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${A}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(A,E=>{E&&g.getConfig().onError(E)}))},Math.ceil(5e3*(1+Math.random()))))}}o._BOM=65279,o._PREFIX="(function (require, define, __filename, __dirname) { ",o._SUFFIX=`
});`;function N(a,s){if(s.__$__isRecorded)return s;const h=function(b){a.record(33,b);try{return s(b)}finally{a.record(34,b)}};return h.__$__isRecorded=!0,h}W.ensureRecordedNodeRequire=N;function f(a){return new t(a)}W.createScriptLoader=f})(he||(he={}));var he;(function(W){class t{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,h;for(h=/\/\.\//;h.test(s);)s=s.replace(h,"/");for(s=s.replace(/^\.\//g,""),h=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;h.test(s);)s=s.replace(h,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return W.Utilities.isAbsolutePath(s)||(W.Utilities.startsWith(s,"./")||W.Utilities.startsWith(s,"../"))&&(s=t._normalizeModuleId(this.fromModulePath+s)),s}}t.ROOT=new t(""),W.ModuleIdResolver=t;class F{constructor(a,s,h,A,b,g){this.id=a,this.strId=s,this.dependencies=h,this._callback=A,this._errorback=b,this.moduleIdResolver=g,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(W.global,s),producedError:null}}catch(h){return{returnedValue:null,producedError:h}}}static _invokeFactory(a,s,h,A){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(h,A):{returnedValue:h.apply(W.global,A),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,h,A){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let g=F._invokeFactory(s,this.strId,this._callback,h);b=g.producedError,a.record(22,this.strId),!b&&typeof g.returnedValue<"u"&&(!this.exportsPassedIn||W.Utilities.isEmpty(this.exports))&&(this.exports=g.returnedValue)}else this.exports=this._callback;if(b){let g=W.ensureError(b);g.phase="factory",g.moduleId=this.strId,g.neededBy=A(this.id),this.error=g,s.onError(g)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}W.Module=F;class y{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),W.RegularDependency=r;class o{constructor(a,s,h){this.id=a,this.pluginId=s,this.pluginParam=h}}W.PluginDependency=o;class N{constructor(a,s,h,A,b=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=b,this._defineFunc=h,this._requireFunc=A,this._moduleIdProvider=new y,this._config=new W.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let h=g=>g.replace(/\\/g,"/"),A=h(a),b=s.split(/\n/);for(let g=0;g<b.length;g++){let e=b[g].match(/(.*):(\d+):(\d+)\)?$/);if(e){let E=e[1],R=e[2],L=e[3],$=Math.max(E.lastIndexOf(" ")+1,E.lastIndexOf("(")+1);if(E=E.substr($),E=h(E),E===A){let m={line:parseInt(R,10),col:parseInt(L,10)};return m.line===1&&(m.col-=53),m}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let h=0,A=this._modules2.length;h<A;h++){let b=this._modules2[h];if(!b)continue;let g=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,E=this._buildInfoDependencies[b.id];a[s++]={id:b.strId,path:g,defineLocation:g&&e?N._findRelevantLocationInStack(g,e):null,dependencies:E,shim:null,exports:b.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new W.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=W.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let h=null;this._config.isBuild()&&(h=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:h,dependencies:a,callback:s}}defineModule(a,s,h,A,b,g=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let E=new F(e,a,this._normalizeDependencies(s,g),h,A,g);this._modules2[e]=E,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(E.dependencies||[]).map(R=>this._moduleIdProvider.getStrModuleId(R.id))),this._resolve(E)}_normalizeDependency(a,s){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let h=a.indexOf("!");if(h>=0){let A=s.resolveModule(a.substr(0,h)),b=s.resolveModule(a.substr(h+1)),g=this._moduleIdProvider.getModuleId(A+"!"+b),e=this._moduleIdProvider.getModuleId(A);return new o(g,e,b)}return new r(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let h=[],A=0;for(let b=0,g=a.length;b<g;b++)h[A++]=this._normalizeDependency(a[b],s);return h}_relativeRequire(a,s,h,A){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(W.Utilities.generateAnonymousModule(),s,h,A,null,a)}synchronousRequire(a,s=new t(a)){let h=this._normalizeDependency(a,s),A=this._modules2[h.id];if(!A)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!A.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(A.error)throw A.error;return A.exports}configure(a,s){let h=this._config.shouldRecordStats();s?this._config=new W.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!h&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let h=this._moduleIdProvider.getStrModuleId(a),A=(this._inverseDependencies2[a]||[]).map(g=>this._moduleIdProvider.getStrModuleId(g));const b=W.ensureError(s);return b.phase="loading",b.moduleId=h,b.neededBy=A,b}_onLoadError(a,s){const h=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new F(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let A=[];for(let e=0,E=this._moduleIdProvider.getMaxModuleId();e<E;e++)A[e]=!1;let b=!1,g=[];for(g.push(a),A[a]=!0;g.length>0;){let e=g.shift(),E=this._modules2[e];E&&(b=E.onDependencyError(h)||b);let R=this._inverseDependencies2[e];if(R)for(let L=0,$=R.length;L<$;L++){let m=R[L];A[m]||(g.push(m),A[m]=!0)}}b||this._config.onError(h)}_hasDependencyPath(a,s){let h=this._modules2[a];if(!h)return!1;let A=[];for(let g=0,e=this._moduleIdProvider.getMaxModuleId();g<e;g++)A[g]=!1;let b=[];for(b.push(h),A[a]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let E=0,R=e.length;E<R;E++){let L=e[E];if(L.id===s)return!0;let $=this._modules2[L.id];$&&!A[L.id]&&(A[L.id]=!0,b.push($))}}return!1}_findCyclePath(a,s,h){if(a===s||h===50)return[a];let A=this._modules2[a];if(!A)return null;let b=A.dependencies;if(b)for(let g=0,e=b.length;g<e;g++){let E=this._findCyclePath(b[g].id,s,h+1);if(E!==null)return E.push(a),E}return null}_createRequire(a){let s=(h,A,b)=>this._relativeRequire(a,h,A,b);return s.toUrl=h=>this._config.requireToUrl(a.resolveModule(h)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(h,A=!1)=>{this.configure(h,A)},s.__$__nodeRequire=W.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),h=this._config.moduleIdToPaths(s),A=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||A.test(s))&&h.push("node|"+s);let b=-1,g=e=>{if(b++,b>=h.length)this._onLoadError(a,e);else{let E=h[b],R=this.getRecorder();if(this._config.isBuild()&&E==="empty:"){this._buildInfoPath[a]=E,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}R.record(10,E),this._scriptLoader.load(this,E,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=E),R.record(11,E),this._onLoad(a)},L=>{R.record(12,E),g(L)})}};g(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let h=A=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],A,null,null)};h.error=A=>{this._config.onError(this._createLoadError(s.id,A))},a.load(s.pluginParam,this._createRequire(t.ROOT),h,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let h=0,A=s.length;h<A;h++){let b=s[h];if(b===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(b===r.MODULE){a.unresolvedDependenciesCount--;continue}if(b===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let g=this._modules2[b.id];if(g&&g.isComplete()){if(g.error){a.onDependencyError(g.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,a.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(E=>this._moduleIdProvider.getStrModuleId(E)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(a.id),b instanceof o){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let E=this._inversePluginDependencies2.get(b.pluginId);E||(E=[],this._inversePluginDependencies2.set(b.pluginId,E)),E.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let h=a.dependencies,A=[];if(h)for(let E=0,R=h.length;E<R;E++){let L=h[E];if(L===r.EXPORTS){A[E]=a.exports;continue}if(L===r.MODULE){A[E]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(L===r.REQUIRE){A[E]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[L.id];if($){A[E]=$.exports;continue}A[E]=null}const b=E=>(this._inverseDependencies2[E]||[]).map(R=>this._moduleIdProvider.getStrModuleId(R));a.complete(s,this._config,A,b);let g=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,g)for(let E=0,R=g.length;E<R;E++){let L=g[E],$=this._modules2[L];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let E=0,R=e.length;E<R;E++)this._loadPluginDependency(a.exports,e[E])}}}W.ModuleManager=N})(he||(he={}));var te,he;(function(W){const t=new W.Environment;let F=null;const y=function(f,a,s){typeof f!="string"&&(s=a,a=f,f=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),f?F.defineModule(f,a,s,null,null):F.enqueueDefineAnonymousModule(a,s)};y.amd={jQuery:!0};const r=function(f,a=!1){F.configure(f,a)},o=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return F.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){F.defineModule(W.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};o.config=r,o.getConfig=function(){return F.getConfig().getOptionsLiteral()},o.reset=function(){F=F.reset()},o.getBuildInfo=function(){return F.getBuildInfo()},o.getStats=function(){return F.getLoaderEvents()},o.define=y;function N(){if(typeof W.global.require<"u"||typeof require<"u"){const f=W.global.require||require;if(typeof f=="function"&&typeof f.resolve=="function"){const a=W.ensureRecordedNodeRequire(F.getRecorder(),f);W.global.nodeRequire=a,o.nodeRequire=a,o.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=o:(t.isElectronRenderer||(W.global.define=y),W.global.require=o)}W.init=N,(typeof W.global.define!="function"||!W.global.define.amd)&&(F=new W.ModuleManager(t,W.createScriptLoader(t),y,o,W.Utilities.getHighPerformanceTimestamp()),typeof W.global.require<"u"&&typeof W.global.require!="function"&&o.config(W.global.require),te=function(){return y.apply(null,arguments)},te.amd=y.amd,typeof doNotInitLoader>"u"&&N())})(he||(he={})),te(ie[69],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function F(f,a,s,h){if(h=h||{},(h["vs/css"]||{}).disabled){s({});return}const b=a.toUrl(f+".css");y(f,b,()=>{s({})},g=>{typeof s.error=="function"&&s.error("Could not find "+b+".")})}t.load=F;function y(f,a,s,h){if(r(f,a)){s();return}o(f,a,s,h)}function r(f,a){const s=window.document.getElementsByTagName("link");for(let h=0,A=s.length;h<A;h++){const b=s[h].getAttribute("data-name"),g=s[h].getAttribute("href");if(b===f||g===a)return!0}return!1}function o(f,a,s,h){const A=document.createElement("link");A.setAttribute("rel","stylesheet"),A.setAttribute("type","text/css"),A.setAttribute("data-name",f),N(f,A,s,h),A.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(A)}function N(f,a,s,h){const A=()=>{a.removeEventListener("load",b),a.removeEventListener("error",g)},b=e=>{A(),s()},g=e=>{A(),h(e)};a.addEventListener("load",b),a.addEventListener("error",g)}}),te("vs/nls",["require","exports"],function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let F=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const y="i-default";function r(R,L){let $;return L.length===0?$=R:$=R.replace(/\{(\d+)\}/g,(m,u)=>{const c=u[0],i=L[c];let l=m;return typeof i=="string"?l=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(l=String(i)),l}),F&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function o(R,L){let $=R[L];return $||($=R["*"],$)?$:null}function N(R){return R.charAt(R.length-1)==="/"?R:R+"/"}async function f(R,L,$){const m=N(R)+N(L)+"vscode/"+N($),u=await fetch(m);if(u.ok)return await u.json();throw new Error(`${u.status} - ${u.statusText}`)}function a(R){return function(L,$){const m=Array.prototype.slice.call(arguments,2);return r(R[L],m)}}function s(R){return(L,$,...m)=>({value:r(R[L],m),original:r($,m)})}function h(R,L,...$){return r(L,$)}t.localize=h;function A(R,L,...$){const m=r(L,$);return{value:m,original:m}}t.localize2=A;function b(R){}t.getConfiguredDefaultLocale=b;function g(R){F=R}t.setPseudoTranslation=g;function e(R,L){return{localize:a(L[R]),localize2:s(L[R]),getConfiguredDefaultLocale:L.getConfiguredDefaultLocale??($=>{})}}t.create=e;function E(R,L,$,m){const u=m["vs/nls"]??{};if(!R||R.length===0)return $({localize:h,localize2:A,getConfiguredDefaultLocale:()=>u.availableLanguages?.["*"]});const c=u.availableLanguages?o(u.availableLanguages,R):null,i=c===null||c===y;let l=".nls";i||(l=l+"."+c);const v=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=s(d)):(d.localize=a(d[R]),d.localize2=s(d[R])),d.getConfiguredDefaultLocale=()=>u.availableLanguages?.["*"],$(d)};typeof u.loadBundle=="function"?u.loadBundle(R,c,(d,w)=>{d?L([R+".nls"],v):v(w)}):u.translationServiceUrl&&!i?(async()=>{try{const d=await f(u.translationServiceUrl,c,R);return v(d)}catch(d){if(!c.includes("-"))return console.error(d),L([R+".nls"],v);try{const w=c.split("-")[0],M=await f(u.translationServiceUrl,w,R);return u.availableLanguages??={},u.availableLanguages["*"]=w,v(M)}catch(w){return console.error(w),L([R+".nls"],v)}}})():L([R+l],v,d=>{if(l===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,d),L([R+".nls"],v)})}t.load=E}),function(){const W=globalThis.MonacoEnvironment,t=W&&W.baseUrl?W.baseUrl:"../../../";function F(h,A){if(W?.createTrustedTypesPolicy)try{return W.createTrustedTypesPolicy(h,A)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(h,A)}catch(b){console.warn(b);return}}const y=F("amdLoader",{createScriptURL:h=>h,createScript:(h,...A)=>{const b=A.slice(0,-1).join(","),g=A.pop().toString();return`(function anonymous(${b}) { ${g}
})`}});function r(){try{return(y?globalThis.eval(y.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function o(){return new Promise((h,A)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return h();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(y?globalThis.eval(y.createScript("",e)):new Function(e)).call(globalThis),h()}).then(void 0,A);return}y?importScripts(y.createScriptURL(b)):importScripts(b),h()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:y,amdModulesPattern:/^vs\//})}function f(h){o().then(()=>{N(),require([h],function(A){setTimeout(function(){const b=A.create((g,e)=>{globalThis.postMessage(g,e)},null);for(globalThis.onmessage=g=>b.onmessage(g.data,g.ports);s.length>0;){const g=s.shift();b.onmessage(g.data,g.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const s=[];globalThis.onmessage=h=>{if(!a){s.push(h);return}a=!1,f(h.data)}}(),te(ie[9],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function F(E,R,L){const $=y(E,R);if($!==-1)return E[$]}t.$fb=F;function y(E,R,L=E.length-1){for(let $=L;$>=0;$--){const m=E[$];if(R(m))return $}return-1}t.$gb=y;function r(E,R){const L=o(E,R);return L===-1?void 0:E[L]}t.$hb=r;function o(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?m=c+1:u=c}return m-1}t.$ib=o;function N(E,R){const L=f(E,R);return L===E.length?void 0:E[L]}t.$jb=N;function f(E,R,L=0,$=E.length){let m=L,u=$;for(;m<u;){const c=Math.floor((m+u)/2);R(E[c])?u=c:m=c+1}return m}t.$kb=f;function a(E,R,L=0,$=E.length){const m=f(E,R,L,$);return m===E.length?-1:m}t.$lb=a;class s{static{this.assertInvariants=!1}constructor(R){this.e=R,this.c=0}findLastMonotonous(R){if(s.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!R($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=R}const L=o(this.e,R,this.c);return this.c=L+1,L===-1?void 0:this.e[L]}}t.$mb=s;function h(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>0&&(L=m)}return L}t.$nb=h;function A(E,R){if(E.length===0)return;let L=E[0];for(let $=1;$<E.length;$++){const m=E[$];R(m,L)>=0&&(L=m)}return L}t.$ob=A;function b(E,R){return h(E,(L,$)=>-R(L,$))}t.$pb=b;function g(E,R){if(E.length===0)return-1;let L=0;for(let $=1;$<E.length;$++){const m=E[$];R(m,E[L])>0&&(L=$)}return L}t.$qb=g;function e(E,R){for(const L of E){const $=R(L);if($!==void 0)return $}}t.$rb=e}),te(ie[34],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function F(N,f){const a=Object.create(null);for(const s of N){const h=f(s);let A=a[h];A||(A=a[h]=[]),A.push(s)}return a}t.$K=F;function y(N,f){const a=[],s=[];for(const h of N)f.has(h)||a.push(h);for(const h of f)N.has(h)||s.push(h);return{removed:a,added:s}}t.$L=y;function r(N,f){const a=[],s=[];for(const[h,A]of N)f.has(h)||a.push(A);for(const[h,A]of f)N.has(h)||s.push(A);return{removed:a,added:s}}t.$M=r;function o(N,f){const a=new Set;for(const s of f)N.has(s)&&a.add(s);return a}t.$N=o}),te(ie[35],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=t.$ut=t.$tt=t.$st=void 0;function F(f,a){const s=Math.pow(10,a);return Math.round(f*s)/s}class y{constructor(a,s,h,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,h))|0,this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}t.$st=y;class r{constructor(a,s,h,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,s),0),3),this.l=F(Math.max(Math.min(1,h),0),3),this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=a.a,g=Math.max(s,h,A),e=Math.min(s,h,A);let E=0,R=0;const L=(e+g)/2,$=g-e;if($>0){switch(R=Math.min(L<=.5?$/(2*L):$/(2-2*L),1),g){case s:E=(h-A)/$+(h<A?6:0);break;case h:E=(A-s)/$+2;break;case A:E=(s-h)/$+4;break}E*=60,E=Math.round(E)}return new r(E,R,L,b)}static i(a,s,h){return h<0&&(h+=1),h>1&&(h-=1),h<1/6?a+(s-a)*6*h:h<1/2?s:h<2/3?a+(s-a)*(2/3-h)*6:a}static toRGBA(a){const s=a.h/360,{s:h,l:A,a:b}=a;let g,e,E;if(h===0)g=e=E=A;else{const R=A<.5?A*(1+h):A+h-A*h,L=2*A-R;g=r.i(L,R,s+1/3),e=r.i(L,R,s),E=r.i(L,R,s-1/3)}return new y(Math.round(g*255),Math.round(e*255),Math.round(E*255),b)}}t.$tt=r;class o{constructor(a,s,h,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=F(Math.max(Math.min(1,s),0),3),this.v=F(Math.max(Math.min(1,h),0),3),this.a=F(Math.max(Math.min(1,A),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,h=a.g/255,A=a.b/255,b=Math.max(s,h,A),g=Math.min(s,h,A),e=b-g,E=b===0?0:e/b;let R;return e===0?R=0:b===s?R=((h-A)/e%6+6)%6:b===h?R=(A-s)/e+2:R=(s-h)/e+4,new o(Math.round(R*60),E,b,a.a)}static toRGBA(a){const{h:s,s:h,v:A,a:b}=a,g=A*h,e=g*(1-Math.abs(s/60%2-1)),E=A-g;let[R,L,$]=[0,0,0];return s<60?(R=g,L=e):s<120?(R=e,L=g):s<180?(L=g,$=e):s<240?(L=e,$=g):s<300?(R=e,$=g):s<=360&&(R=g,$=e),R=Math.round((R+E)*255),L=Math.round((L+E)*255),$=Math.round(($+E)*255),new y(R,L,$,b)}}t.$ut=o;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:o.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof y)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof o)this.j=a,this.rgba=o.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&y.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&o.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),s=N.k(this.rgba.g),h=N.k(this.rgba.b),A=.2126*a+.7152*s+.0722*h;return F(A,4)}static k(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}getContrastRatio(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h?(s+.05)/(h+.05):(h+.05)/(s+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s>h}isDarkerThan(a){const s=this.getRelativeLuminance(),h=a.getRelativeLuminance();return s<h}lighten(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new y(s,h,A,b*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new y(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const s=a.rgba,h=this.rgba.a,A=s.a,b=h+A*(1-h);if(b<1e-6)return N.transparent;const g=this.rgba.r*h/b+s.r*A*(1-h)/b,e=this.rgba.g*h/b+s.g*A*(1-h)/b,E=this.rgba.b*h/b+s.b*A*(1-h)/b;return new N(new y(g,e,E,b))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:h,b:A,a:b}=this.rgba;return new N(new y(a.rgba.r-b*(a.rgba.r-s),a.rgba.g-b*(a.rgba.g-h),a.rgba.b-b*(a.rgba.b-A),1))}flatten(...a){const s=a.reduceRight((h,A)=>N.o(A,h));return N.o(this,s)}static o(a,s){const h=1-a.rgba.a;return new N(new y(h*s.rgba.r+a.rgba.a*a.rgba.r,h*s.rgba.g+a.rgba.a*a.rgba.g,h*s.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,s,h){if(a.isLighterThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(b-A)/b,a.lighten(h)}static getDarkerColor(a,s,h){if(a.isDarkerThan(s))return a;h=h||.5;const A=a.getRelativeLuminance(),b=s.getRelativeLuminance();return h=h*(A-b)/A,a.darken(h)}static{this.white=new N(new y(255,255,255,1))}static{this.black=new N(new y(0,0,0,1))}static{this.red=new N(new y(255,0,0,1))}static{this.blue=new N(new y(0,0,255,1))}static{this.green=new N(new y(0,255,0,1))}static{this.cyan=new N(new y(0,255,255,1))}static{this.lightgrey=new N(new y(211,211,211,1))}static{this.transparent=new N(new y(0,0,0,0))}}t.$vt=N,function(f){let a;(function(s){let h;(function(A){function b(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:f.Format.CSS.formatRGBA(i)}A.formatRGB=b;function g(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}A.formatRGBA=g;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:f.Format.CSS.formatHSLA(i)}A.formatHSL=e;function E(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}A.formatHSLA=E;function R(i){const l=i.toString(16);return l.length!==2?"0"+l:l}function L(i){return`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}`}A.formatHex=L;function $(i,l=!1){return l&&i.rgba.a===1?f.Format.CSS.formatHex(i):`#${R(i.rgba.r)}${R(i.rgba.g)}${R(i.rgba.b)}${R(Math.round(i.rgba.a*255))}`}A.formatHexA=$;function m(i){return i.isOpaque()?f.Format.CSS.formatHex(i):f.Format.CSS.formatRGBA(i)}A.format=m;function u(i){const l=i.length;if(l===0||i.charCodeAt(0)!==35)return null;if(l===7){const v=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6));return new f(new y(v,d,w,1))}if(l===9){const v=16*c(i.charCodeAt(1))+c(i.charCodeAt(2)),d=16*c(i.charCodeAt(3))+c(i.charCodeAt(4)),w=16*c(i.charCodeAt(5))+c(i.charCodeAt(6)),M=16*c(i.charCodeAt(7))+c(i.charCodeAt(8));return new f(new y(v,d,w,M/255))}if(l===4){const v=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3));return new f(new y(16*v+v,16*d+d,16*w+w))}if(l===5){const v=c(i.charCodeAt(1)),d=c(i.charCodeAt(2)),w=c(i.charCodeAt(3)),M=c(i.charCodeAt(4));return new f(new y(16*v+v,16*d+d,16*w+w,(16*M+M)/255))}return null}A.parseHex=u;function c(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(h=s.CSS||(s.CSS={}))})(a=f.Format||(f.Format={}))}(N||(t.$vt=N={}))}),te(ie[36],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7s=void 0;class F{constructor(r,o,N,f){this.originalStart=r,this.originalLength=o,this.modifiedStart=N,this.modifiedLength=f}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$7s=F}),te(ie[3],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class F{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?m.isErrorNoTelemetry(i)?new m(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(l=>{l(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=F,t.$X=new F;function y(c){t.$X.setUnexpectedErrorHandler(c)}t.setUnexpectedErrorHandler=y;function r(c){if(!c||typeof c!="object")return!1;const i=c;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function o(c){s(c)||t.$X.onUnexpectedError(c)}t.$1=o;function N(c){s(c)||t.$X.onUnexpectedExternalError(c)}t.$2=N;function f(c){if(c instanceof Error){const{name:i,message:l}=c,v=c.stacktrace||c.stack;return{$isError:!0,name:i,message:l,stack:v,noTelemetry:m.isErrorNoTelemetry(c)}}return c}t.$3=f;const a="Canceled";function s(c){return c instanceof h?!0:c instanceof Error&&c.name===a&&c.message===a}t.$4=s;class h extends Error{constructor(){super(a),this.name=this.message}}t.$5=h;function A(){const c=new Error(a);return c.name=c.message,c}t.$6=A;function b(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}t.$7=b;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}t.$8=g;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function E(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}t.$0=E;class R extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=R;class L extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=L;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class m extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof m)return i;const l=new m;return l.message=i.message,l.stack=i.stack,l}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=m;class u extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,u.prototype)}}t.$cb=u}),te(ie[6],re([0,1,3,9]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(O,C=0){return O[O.length-(1+C)]}t.$sb=r;function o(O){if(O.length===0)throw new Error("Invalid tail call");return[O.slice(0,O.length-1),O[O.length-1]]}t.$tb=o;function N(O,C,j=(Q,x)=>Q===x){if(O===C)return!0;if(!O||!C||O.length!==C.length)return!1;for(let Q=0,x=O.length;Q<x;Q++)if(!j(O[Q],C[Q]))return!1;return!0}t.$ub=N;function f(O,C){const j=O.length-1;C<j&&(O[C]=O[j]),O.pop()}t.$vb=f;function a(O,C,j){return s(O.length,Q=>j(O[Q],C))}t.$wb=a;function s(O,C){let j=0,Q=O-1;for(;j<=Q;){const x=(j+Q)/2|0,G=C(x);if(G<0)j=x+1;else if(G>0)Q=x-1;else return x}return-(j+1)}t.$xb=s;function h(O,C,j){if(O=O|0,O>=C.length)throw new TypeError("invalid index");const Q=C[Math.floor(C.length*Math.random())],x=[],G=[],Z=[];for(const K of C){const ne=j(K,Q);ne<0?x.push(K):ne>0?G.push(K):Z.push(K)}return O<x.length?h(O,x,j):O<x.length+Z.length?Z[0]:h(O-(x.length+Z.length),G,j)}t.$yb=h;function A(O,C){const j=[];let Q;for(const x of O.slice(0).sort(C))!Q||C(Q[0],x)!==0?(Q=[x],j.push(Q)):Q.push(x);return j}t.$zb=A;function*b(O,C){let j,Q;for(const x of O)Q!==void 0&&C(Q,x)?j.push(x):(j&&(yield j),j=[x]),Q=x;j&&(yield j)}t.$Ab=b;function g(O,C){for(let j=0;j<=O.length;j++)C(j===0?void 0:O[j-1],j===O.length?void 0:O[j])}t.$Bb=g;function e(O,C){for(let j=0;j<O.length;j++)C(j===0?void 0:O[j-1],O[j],j+1===O.length?void 0:O[j+1])}t.$Cb=e;function E(O,C,j){const Q=[];function x(K,ne,ue){if(ne===0&&ue.length===0)return;const ae=Q[Q.length-1];ae&&ae.start+ae.deleteCount===K?(ae.deleteCount+=ne,ae.toInsert.push(...ue)):Q.push({start:K,deleteCount:ne,toInsert:ue})}let G=0,Z=0;for(;;){if(G===O.length){x(G,0,C.slice(Z));break}if(Z===C.length){x(G,O.length-G,[]);break}const K=O[G],ne=C[Z],ue=j(K,ne);ue===0?(G+=1,Z+=1):ue<0?(x(G,1,[]),G+=1):ue>0&&(x(G,0,[ne]),Z+=1)}return Q}t.$Db=E;function R(O,C,j){const Q=E(O,C,j),x=[],G=[];for(const Z of Q)x.push(...O.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:x,added:G}}t.$Eb=R;function L(O,C,j){if(j===0)return[];const Q=O.slice(0,j).sort(C);return m(O,C,Q,j,O.length),Q}t.top=L;function $(O,C,j,Q,x){return j===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const K=O.length,ne=O.slice(0,j).sort(C);for(let ue=j,ae=Math.min(j+Q,K);ue<K;ue=ae,ae=Math.min(ae+Q,K)){if(ue>j&&await new Promise(fe=>setTimeout(fe)),x&&x.isCancellationRequested)throw new F.$5;m(O,C,ne,ue,ae)}return ne})().then(G,Z)})}t.$Gb=$;function m(O,C,j,Q,x){for(const G=j.length;Q<x;Q++){const Z=O[Q];if(C(Z,j[G-1])<0){j.pop();const K=(0,y.$kb)(j,ne=>C(Z,ne)<0);j.splice(K,0,Z)}}}function u(O){return O.filter(C=>!!C)}t.$Hb=u;function c(O){let C=0;for(let j=0;j<O.length;j++)O[j]&&(O[C]=O[j],C+=1);O.length=C}t.$Ib=c;function i(O,C,j){O.splice(j,0,O.splice(C,1)[0])}t.$Jb=i;function l(O){return!Array.isArray(O)||O.length===0}t.$Kb=l;function v(O){return Array.isArray(O)&&O.length>0}t.$Lb=v;function d(O,C=j=>j){const j=new Set;return O.filter(Q=>{const x=C(Q);return j.has(x)?!1:(j.add(x),!0)})}t.$Mb=d;function w(O){const C=new Set;return j=>{const Q=O(j);return C.has(Q)?!1:(C.add(Q),!0)}}t.$Nb=w;function M(O,C){return O.length>0?O[0]:C}t.$Ob=M;function p(O,C){return O.length>0?O[O.length-1]:C}t.$Pb=p;function P(O,C,j=(Q,x)=>Q===x){let Q=0;for(let x=0,G=Math.min(O.length,C.length);x<G&&j(O[x],C[x]);x++)Q++;return Q}t.$Qb=P;function D(O){return[].concat(...O)}t.$Rb=D;function k(O,C){let j=typeof C=="number"?O:0;typeof C=="number"?j=O:(j=0,C=O);const Q=[];if(j<=C)for(let x=j;x<C;x++)Q.push(x);else for(let x=j;x>C;x--)Q.push(x);return Q}t.$Sb=k;function T(O,C,j){return O.reduce((Q,x)=>(Q[C(x)]=j?j(x):x,Q),Object.create(null))}t.$Tb=T;function _(O,C){return O.push(C),()=>q(O,C)}t.$Ub=_;function q(O,C){const j=O.indexOf(C);if(j>-1)return O.splice(j,1),C}t.$Vb=q;function V(O,C,j){const Q=O.slice(0,C),x=O.slice(C);return Q.concat(j,x)}t.$Wb=V;function z(O,C){let j;if(typeof C=="number"){let Q=C;j=()=>{const x=Math.sin(Q++)*179426549;return x-Math.floor(x)}}else j=Math.random;for(let Q=O.length-1;Q>0;Q-=1){const x=Math.floor(j()*(Q+1)),G=O[Q];O[Q]=O[x],O[x]=G}}t.$Xb=z;function S(O,C){const j=O.indexOf(C);j>-1&&(O.splice(j,1),O.unshift(C))}t.$Yb=S;function U(O,C){const j=O.indexOf(C);j>-1&&(O.splice(j,1),O.push(C))}t.$Zb=U;function X(O,C){for(const j of C)O.push(j)}t.$1b=X;function J(O,C){return Array.isArray(O)?O.map(C):C(O)}t.$2b=J;function ee(O){return Array.isArray(O)?O:[O]}t.$3b=ee;function le(O){return O[Math.floor(Math.random()*O.length)]}t.$4b=le;function n(O,C,j){const Q=me(O,C),x=O.length,G=j.length;O.length=x+G;for(let Z=x-1;Z>=Q;Z--)O[Z+G]=O[Z];for(let Z=0;Z<G;Z++)O[Z+Q]=j[Z]}t.$5b=n;function oe(O,C,j,Q){const x=me(O,C);let G=O.splice(x,j);return G===void 0&&(G=[]),n(O,x,Q),G}t.$6b=oe;function me(O,C){return C<0?Math.max(C+O.length,0):Math.min(C,O.length)}var we;(function(O){function C(G){return G<0}O.isLessThan=C;function j(G){return G<=0}O.isLessThanOrEqual=j;function Q(G){return G>0}O.isGreaterThan=Q;function x(G){return G===0}O.isNeitherLessOrGreaterThan=x,O.greaterThan=1,O.lessThan=-1,O.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Ae(O,C){return(j,Q)=>C(O(j),O(Q))}t.$7b=Ae;function $e(...O){return(C,j)=>{for(const Q of O){const x=Q(C,j);if(!we.isNeitherLessOrGreaterThan(x))return x}return we.neitherLessOrGreaterThan}}t.$8b=$e;const Pe=(O,C)=>O-C;t.$9b=Pe;const ye=(O,C)=>(0,t.$9b)(O?1:0,C?1:0);t.$0b=ye;function Se(O){return(C,j)=>-O(C,j)}t.$$b=Se;class Ie{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const Q=j===this.c?null:this.g.slice(this.c,j);return this.c=j,Q}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const Q=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Ie;class Re{static{this.empty=new Re(C=>{})}constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Re(j=>this.iterate(Q=>C(Q)?j(Q):!0))}map(C){return new Re(j=>this.iterate(Q=>j(C(Q))))}some(C){let j=!1;return this.iterate(Q=>(j=C(Q),!j)),j}findFirst(C){let j;return this.iterate(Q=>C(Q)?(j=Q,!1):!0),j}findLast(C){let j;return this.iterate(Q=>(C(Q)&&(j=Q),!0)),j}findLastMaxBy(C){let j,Q=!0;return this.iterate(x=>((Q||we.isGreaterThan(C(x,j)))&&(Q=!1,j=x),!0)),j}}t.$ac=Re}),te(ie[13],re([0,1,3]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function y(s,h){if(!s)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}t.ok=y;function r(s,h="Unreachable"){throw new Error(h)}t.$9c=r;function o(s){if(!s)throw new F.$cb("Assertion Failed")}t.$0c=o;function N(s){s||(0,F.$1)(new F.$cb("Assertion Failed"))}t.$$c=N;function f(s){if(!s()){debugger;s(),(0,F.$1)(new F.$cb("Assertion Failed"))}}t.$_c=f;function a(s,h){let A=0;for(;A<s.length-1;){const b=s[A],g=s[A+1];if(!h(b,g))return!1;A++}return!0}t.$ad=a}),te(ie[19],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function F(y,r){const o=this;let N=!1,f;return function(){if(N)return f;if(N=!0,r)try{f=y.apply(o,arguments)}finally{r()}else f=y.apply(o,arguments);return f}}t.$db=F}),te(ie[20],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var F;(function(y){function r(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}y.is=r;const o=Object.freeze([]);function N(){return o}y.empty=N;function*f(i){yield i}y.single=f;function a(i){return r(i)?i:f(i)}y.wrap=a;function s(i){return i||o}y.from=s;function*h(i){for(let l=i.length-1;l>=0;l--)yield i[l]}y.reverse=h;function A(i){return!i||i[Symbol.iterator]().next().done===!0}y.isEmpty=A;function b(i){return i[Symbol.iterator]().next().value}y.first=b;function g(i,l){for(const v of i)if(l(v))return!0;return!1}y.some=g;function e(i,l){for(const v of i)if(l(v))return v}y.find=e;function*E(i,l){for(const v of i)l(v)&&(yield v)}y.filter=E;function*R(i,l){let v=0;for(const d of i)yield l(d,v++)}y.map=R;function*L(...i){for(const l of i)yield*l}y.concat=L;function $(i,l,v){let d=v;for(const w of i)d=l(d,w);return d}y.reduce=$;function*m(i,l,v=i.length){for(l<0&&(l+=i.length),v<0?v+=i.length:v>i.length&&(v=i.length);l<v;l++)yield i[l]}y.slice=m;function u(i,l=Number.POSITIVE_INFINITY){const v=[];if(l===0)return[v,i];const d=i[Symbol.iterator]();for(let w=0;w<l;w++){const M=d.next();if(M.done)return[v,y.empty()];v.push(M.value)}return[v,{[Symbol.iterator](){return d}}]}y.consume=u;async function c(i){const l=[];for await(const v of i)l.push(v);return Promise.resolve(l)}y.asyncToArray=c})(F||(t.Iterable=F={}))}),te(ie[37],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dr=t.KeyMod=t.KeyCodeUtils=t.$cr=t.$br=t.$ar=t.$_q=t.$$q=t.ScanCode=t.KeyCode=void 0;var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(F||(t.KeyCode=F={}));var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(y||(t.ScanCode=y={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(E,R){this._keyCodeToStr[E]=R,this._strToKeyCode[R.toLowerCase()]=E}keyCodeToStr(E){return this._keyCodeToStr[E]}strToKeyCode(E){return this._strToKeyCode[E.toLowerCase()]||0}}const o=new r,N=new r,f=new r;t.$$q=new Array(230),t.$_q={};const a=[],s=Object.create(null),h=Object.create(null);t.$ar={lowerCaseToEnum:e=>h[e]||0,toEnum:e=>s[e]||0,toString:e=>a[e]||"None"},t.$br=[],t.$cr=[];for(let e=0;e<=193;e++)t.$br[e]=-1;for(let e=0;e<=132;e++)t.$cr[e]=-1;(function(){const e="",E=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],R=[],L=[];for(const $ of E){const[m,u,c,i,l,v,d,w,M]=$;if(L[u]||(L[u]=!0,a[u]=c,s[c]=u,h[c.toLowerCase()]=u,m&&(t.$br[u]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$cr[i]=u))),!R[i]){if(R[i]=!0,!l)throw new Error(`String representation missing for key code ${i} around scan code ${c}`);o.define(i,l),N.define(i,w||l),f.define(i,M||w||l)}v&&(t.$$q[v]=i),d&&(t.$_q[d]=i)}t.$cr[3]=46})();var A;(function(e){function E(c){return o.keyCodeToStr(c)}e.toString=E;function R(c){return o.strToKeyCode(c)}e.fromString=R;function L(c){return N.keyCodeToStr(c)}e.toUserSettingsUS=L;function $(c){return f.keyCodeToStr(c)}e.toUserSettingsGeneral=$;function m(c){return N.strToKeyCode(c)||f.strToKeyCode(c)}e.fromUserSettings=m;function u(c){if(c>=98&&c<=113)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return o.keyCodeToStr(c)}e.toElectronAccelerator=u})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function g(e,E){const R=(E&65535)<<16>>>0;return(e|R)>>>0}t.$dr=g}),te(ie[38],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class F{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=F}),te(ie[21],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class F{static{this.Undefined=new F(void 0)}constructor(o){this.element=o,this.next=F.Undefined,this.prev=F.Undefined}}class y{constructor(){this.a=F.Undefined,this.b=F.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===F.Undefined}clear(){let o=this.a;for(;o!==F.Undefined;){const N=o.next;o.prev=F.Undefined,o.next=F.Undefined,o=N}this.a=F.Undefined,this.b=F.Undefined,this.c=0}unshift(o){return this.d(o,!1)}push(o){return this.d(o,!0)}d(o,N){const f=new F(o);if(this.a===F.Undefined)this.a=f,this.b=f;else if(N){const s=this.b;this.b=f,f.prev=s,s.next=f}else{const s=this.a;this.a=f,f.next=s,s.prev=f}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(f))}}shift(){if(this.a!==F.Undefined){const o=this.a.element;return this.e(this.a),o}}pop(){if(this.b!==F.Undefined){const o=this.b.element;return this.e(this.b),o}}e(o){if(o.prev!==F.Undefined&&o.next!==F.Undefined){const N=o.prev;N.next=o.next,o.next.prev=N}else o.prev===F.Undefined&&o.next===F.Undefined?(this.a=F.Undefined,this.b=F.Undefined):o.next===F.Undefined?(this.b=this.b.prev,this.b.next=F.Undefined):o.prev===F.Undefined&&(this.a=this.a.next,this.a.prev=F.Undefined);this.c-=1}*[Symbol.iterator](){let o=this.a;for(;o!==F.Undefined;)yield o.element,o=o.next}}t.$4c=y}),te(ie[22],re([0,1]),function(W,t){"use strict";var F,y,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function o(m,u,c){let i=m.get(u);return i===void 0&&(i=c,m.set(u,i)),i}t.$xc=o;function N(m){const u=[];return m.forEach((c,i)=>{u.push(`${i} => ${c}`)}),`Map(${m.size}) {${u.join(", ")}}`}t.$yc=N;function f(m){const u=[];return m.forEach(c=>{u.push(c)}),`Set(${m.size}) {${u.join(", ")}}`}t.$zc=f;class a{constructor(u,c){this.uri=u,this.value=c}}function s(m){return Array.isArray(m)}class h{static{this.c=u=>u.toString()}constructor(u,c){if(this[F]="ResourceMap",u instanceof h)this.d=new Map(u.d),this.e=c??h.c;else if(s(u)){this.d=new Map,this.e=c??h.c;for(const[i,l]of u)this.set(i,l)}else this.d=new Map,this.e=u??h.c}set(u,c){return this.d.set(this.e(u),new a(u,c)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,c){typeof c<"u"&&(u=u.bind(c));for(const[i,l]of this.d)u(l.value,l.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(F=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}t.$Ac=h;class A{constructor(u,c){this[y]="ResourceSet",!u||typeof u=="function"?this.c=new h(u):(this.c=new h(c),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,c){this.c.forEach((i,l)=>u.call(c,l,l,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=A;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class g{constructor(){this[r]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,c=0){const i=this.c.get(u);if(i)return c!==0&&this.l(i,c),i.value}set(u,c,i=0){let l=this.c.get(u);if(l)l.value=c,i!==0&&this.l(l,i);else{switch(l={key:u,value:c,next:void 0,previous:void 0},i){case 0:this.j(l);break;case 1:this.i(l);break;case 2:this.j(l);break;default:this.j(l);break}this.c.set(u,l),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const c=this.c.get(u);if(c)return this.c.delete(u),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.k(u),this.f--,u.value}forEach(u,c){const i=this.g;let l=this.d;for(;l;){if(c?u.bind(c)(l.value,l.key,this):u(l.value,l.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.key,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}values(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:i.value,done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}entries(){const u=this,c=this.g;let i=this.d;const l={[Symbol.iterator](){return l},next(){if(u.g!==c)throw new Error("LinkedMap got modified during iteration.");if(i){const v={value:[i.key,i.value],done:!1};return i=i.next,v}else return{value:void 0,done:!0}}};return l}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let c=this.d,i=this.size;for(;c&&i>u;)this.c.delete(c.key),c=c.next,i--;this.d=c,this.f=i,c&&(c.previous=void 0),this.g++}i(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}j(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}k(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const c=u.next,i=u.previous;if(!c||!i)throw new Error("Invalid list");c.previous=i,i.next=c}u.next=void 0,u.previous=void 0,this.g++}l(u,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(u===this.d)return;const i=u.next,l=u.previous;u===this.e?(l.next=void 0,this.e=l):(i.previous=l,l.next=i),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(c===2){if(u===this.e)return;const i=u.next,l=u.previous;u===this.d?(i.previous=void 0,this.d=i):(i.previous=l,l.next=i),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((c,i)=>{u.push([i,c])}),u}fromJSON(u){this.clear();for(const[c,i]of u)this.set(c,i)}}t.$Cc=g;class e extends g{constructor(u,c=1){super(),this.m=u,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(u){this.m=u,this.o()}get ratio(){return this.n}set ratio(u){this.n=Math.min(Math.max(0,u),1),this.o()}get(u,c=2){return super.get(u,c)}peek(u){return super.get(u,0)}set(u,c){return super.set(u,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class E{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let c=this.c.get(u)||0;return c===0?!1:(c--,c===0?this.c.delete(u):this.c.set(u,c),!0)}has(u){return this.c.has(u)}}t.$Ec=E;class R{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[c,i]of u)this.set(c,i)}clear(){this.c.clear(),this.d.clear()}set(u,c){this.c.set(u,c),this.d.set(c,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const c=this.c.get(u);return c===void 0?!1:(this.c.delete(u),this.d.delete(c),!0)}forEach(u,c){this.c.forEach((i,l)=>{u.call(c,i,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=R;class L{constructor(){this.c=new Map}add(u,c){let i=this.c.get(u);i||(i=new Set,this.c.set(u,i)),i.add(c)}delete(u,c){const i=this.c.get(u);i&&(i.delete(c),i.size===0&&this.c.delete(u))}forEach(u,c){const i=this.c.get(u);i&&i.forEach(c)}get(u){const c=this.c.get(u);return c||new Set}}t.$Gc=L;function $(m,u){if(m===u)return!0;if(m.size!==u.size)return!1;for(const[c,i]of m)if(!u.has(c)||u.get(c)!==i)return!1;for(const[c]of u)if(!m.has(c))return!1;return!0}t.$Hc=$}),te(ie[10],re([0,1,6,34,22,19,20]),function(W,t,F,y,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const f=!1;let a=null;class s{constructor(){this.b=new Map}static{this.a=0}c(_){let q=this.b.get(_);return q||(q={parent:null,source:null,isSingleton:!1,value:_,idx:s.a++},this.b.set(_,q)),q}trackDisposable(_){const q=this.c(_);q.source||(q.source=new Error().stack)}setParent(_,q){const V=this.c(_);V.parent=q}markAsDisposed(_){this.b.delete(_)}markAsSingleton(_){this.c(_).isSingleton=!0}f(_,q){const V=q.get(_);if(V)return V;const z=_.parent?this.f(this.c(_.parent),q):_;return q.set(_,z),z}getTrackedDisposables(){const _=new Map;return[...this.b.entries()].filter(([,V])=>V.source!==null&&!this.f(V,_).isSingleton).flatMap(([V])=>V)}computeLeakingDisposables(_=10,q){let V;if(q)V=q;else{const J=new Map,ee=[...this.b.values()].filter(n=>n.source!==null&&!this.f(n,J).isSingleton);if(ee.length===0)return;const le=new Set(ee.map(n=>n.value));if(V=ee.filter(n=>!(n.parent&&le.has(n.parent))),V.length===0)throw new Error("There are cyclic diposable chains!")}if(!V)return;function z(J){function ee(n,oe){for(;n.length>0&&oe.some(me=>typeof me=="string"?me===n[0]:n[0].match(me));)n.shift()}const le=J.source.split(`
`).map(n=>n.trim().replace("at ","")).filter(n=>n!=="");return ee(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const S=new r.$Gc;for(const J of V){const ee=z(J);for(let le=0;le<=ee.length;le++)S.add(ee.slice(0,le).join(`
`),J)}V.sort((0,F.$7b)(J=>J.idx,F.$9b));let U="",X=0;for(const J of V.slice(0,_)){X++;const ee=z(J),le=[];for(let n=0;n<ee.length;n++){let oe=ee[n];oe=`(shared with ${S.get(ee.slice(0,n+1).join(`
`)).size}/${V.length} leaks) at ${oe}`;const we=S.get(ee.slice(0,n).join(`
`)),Ae=(0,y.$K)([...we].map($e=>z($e)[n]),$e=>$e);delete Ae[ee[n]];for(const[$e,Pe]of Object.entries(Ae))le.unshift(`    - stacktraces of ${Pe.length} other leaks continue with ${$e}`);le.unshift(oe)}U+=`


==================== Leaking disposable ${X}/${V.length}: ${J.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return V.length>_&&(U+=`


... and ${V.length-_} more leaking disposables

`),{leaks:V,details:U}}}t.$Ic=s;function h(T){a=T}if(t.$Jc=h,f){const T="__is_disposable_tracked__";h(new class{trackDisposable(_){const q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{_[T]||console.log(q)},3e3)}setParent(_,q){if(_&&_!==i.None)try{_[T]=!0}catch{}}markAsDisposed(_){if(_&&_!==i.None)try{_[T]=!0}catch{}}markAsSingleton(_){}})}function A(T){return a?.trackDisposable(T),T}t.$Kc=A;function b(T){a?.markAsDisposed(T)}t.$Lc=b;function g(T,_){a?.setParent(T,_)}function e(T,_){if(a)for(const q of T)a.setParent(q,_)}function E(T){return a?.markAsSingleton(T),T}t.$Mc=E;function R(T){return typeof T.dispose=="function"&&T.dispose.length===0}t.$Nc=R;function L(T){if(N.Iterable.is(T)){const _=[];for(const q of T)if(q)try{q.dispose()}catch(V){_.push(V)}if(_.length===1)throw _[0];if(_.length>1)throw new AggregateError(_,"Encountered errors while disposing of store");return Array.isArray(T)?[]:T}else if(T)return T.dispose(),T}t.$Oc=L;function $(T){for(const _ of T)R(_)&&_.dispose();return[]}t.$Pc=$;function m(...T){const _=u(()=>L(T));return e(T,_),_}t.$Qc=m;function u(T){const _=A({dispose:(0,o.$db)(()=>{b(_),T()})});return _}t.$Rc=u;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{L(this.f)}finally{this.f.clear()}}add(_){if(!_)return _;if(_===this)throw new Error("Cannot register a disposable on itself!");return g(_,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(_),_}delete(_){if(_){if(_===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(_),_.dispose()}}deleteAndLeak(_){_&&this.f.has(_)&&(this.f.delete(_),g(_,null))}}t.$Sc=c;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,A(this),g(this.q,this)}dispose(){b(this),this.q.dispose()}B(_){if(_===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(_)}}t.$Tc=i;class l{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(_){this.b||_===this.a||(this.a?.dispose(),_&&g(_,this),this.a=_)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const _=this.a;return this.a=void 0,_&&g(_,null),_}}t.$Uc=l;class v{constructor(_){this.a=new l,this.b=!1,this.a.value=_}get value(){return this.a.value}set value(_){this.b||_===this.a.value||(this.a.value=_)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=v;class d{constructor(_){this.b=_,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(_){let q=_;return this.unset=()=>q=void 0,this.isset=()=>q!==void 0,this.dispose=()=>{q&&(q(),q=void 0,b(this))},this}}t.$Xc=w;class M{constructor(){this.a=new Map}acquire(_,...q){let V=this.a.get(_);V||(V={counter:0,object:this.b(_,...q)},this.a.set(_,V));const{object:z}=V,S=(0,o.$db)(()=>{--V.counter===0&&(this.c(_,V.object),this.a.delete(_))});return V.counter++,{object:z,dispose:S}}}t.$Yc=M;class p{constructor(_){this.a=_}async acquire(_,...q){const V=this.a.acquire(_,...q);try{return{object:await V.object,dispose:()=>V.dispose()}}catch(z){throw V.dispose(),z}}}t.$Zc=p;class P{constructor(_){this.object=_}dispose(){}}t.$1c=P;function D(T){const _=new c;try{T(_)}finally{_.dispose()}}t.$2c=D;class k{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{L(this.a.values())}finally{this.a.clear()}}has(_){return this.a.has(_)}get size(){return this.a.size}get(_){return this.a.get(_)}set(_,q,V=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),V||this.a.get(_)?.dispose(),this.a.set(_,q)}deleteAndDispose(_){this.a.get(_)?.dispose(),this.a.delete(_)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=k}),te(ie[23],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=void 0;const F=globalThis.performance&&typeof globalThis.performance.now=="function";class y{static create(o){return new y(o)}constructor(o){this.c=F&&o===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Yd=y}),te(ie[11],re([0,1,3,19,10,21,23]),function(W,t,F,y,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.Event=void 0;const f=!1,a=!1;var s;(function(D){D.None=()=>r.$Tc.None;function k(x){if(a){const{onDidAddListener:G}=x,Z=e.create();let K=0;x.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Z.print()),G?.()}}}function T(x,G){return le(x,()=>{},0,void 0,!0,void 0,G)}D.defer=T;function _(x){return(G,Z=null,K)=>{let ne=!1,ue;return ue=x(ae=>{if(!ne)return ue?ue.dispose():ne=!0,G.call(Z,ae)},null,K),ne&&ue.dispose(),ue}}D.once=_;function q(x,G,Z){return J((K,ne=null,ue)=>x(ae=>K.call(ne,G(ae)),null,ue),Z)}D.map=q;function V(x,G,Z){return J((K,ne=null,ue)=>x(ae=>{G(ae),K.call(ne,ae)},null,ue),Z)}D.forEach=V;function z(x,G,Z){return J((K,ne=null,ue)=>x(ae=>G(ae)&&K.call(ne,ae),null,ue),Z)}D.filter=z;function S(x){return x}D.signal=S;function U(...x){return(G,Z=null,K)=>{const ne=(0,r.$Qc)(...x.map(ue=>ue(ae=>G.call(Z,ae))));return ee(ne,K)}}D.any=U;function X(x,G,Z,K){let ne=Z;return q(x,ue=>(ne=G(ne,ue),ne),K)}D.reduce=X;function J(x,G){let Z;const K={onWillAddFirstListener(){Z=x(ne.fire,ne)},onDidRemoveLastListener(){Z?.dispose()}};G||k(K);const ne=new m(K);return G?.add(ne),ne.event}function ee(x,G){return G instanceof Array?G.push(x):G&&G.add(x),x}function le(x,G,Z=100,K=!1,ne=!1,ue,ae){let fe,de,ke,_e=0,Fe;const qe={leakWarningThreshold:ue,onWillAddFirstListener(){fe=x(ve=>{_e++,de=G(de,ve),K&&!ke&&(De.fire(de),de=void 0),Fe=()=>{const Oe=de;de=void 0,ke=void 0,(!K||_e>1)&&De.fire(Oe),_e=0},typeof Z=="number"?(clearTimeout(ke),ke=setTimeout(Fe,Z)):ke===void 0&&(ke=0,queueMicrotask(Fe))})},onWillRemoveListener(){ne&&_e>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,fe.dispose()}};ae||k(qe);const De=new m(qe);return ae?.add(De),De.event}D.debounce=le;function n(x,G=0,Z){return D.debounce(x,(K,ne)=>K?(K.push(ne),K):[ne],G,void 0,!0,void 0,Z)}D.accumulate=n;function oe(x,G=(K,ne)=>K===ne,Z){let K=!0,ne;return z(x,ue=>{const ae=K||!G(ue,ne);return K=!1,ne=ue,ae},Z)}D.latch=oe;function me(x,G,Z){return[D.filter(x,G,Z),D.filter(x,K=>!G(K),Z)]}D.split=me;function we(x,G=!1,Z=[],K){let ne=Z.slice(),ue=x(de=>{ne?ne.push(de):fe.fire(de)});K&&K.add(ue);const ae=()=>{ne?.forEach(de=>fe.fire(de)),ne=null},fe=new m({onWillAddFirstListener(){ue||(ue=x(de=>fe.fire(de)),K&&K.add(ue))},onDidAddFirstListener(){ne&&(G?setTimeout(ae):ae())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return K&&K.add(fe),fe.event}D.buffer=we;function Ae(x,G){return(K,ne,ue)=>{const ae=G(new Pe);return x(function(fe){const de=ae.evaluate(fe);de!==$e&&K.call(ne,de)},void 0,ue)}}D.chain=Ae;const $e=Symbol("HaltChainable");class Pe{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(Z=>(G(Z),Z)),this}filter(G){return this.f.push(Z=>G(Z)?Z:$e),this}reduce(G,Z){let K=Z;return this.f.push(ne=>(K=G(K,ne),K)),this}latch(G=(Z,K)=>Z===K){let Z=!0,K;return this.f.push(ne=>{const ue=Z||!G(ne,K);return Z=!1,K=ne,ue?ne:$e}),this}evaluate(G){for(const Z of this.f)if(G=Z(G),G===$e)break;return G}}function ye(x,G,Z=K=>K){const K=(...fe)=>ae.fire(Z(...fe)),ne=()=>x.on(G,K),ue=()=>x.removeListener(G,K),ae=new m({onWillAddFirstListener:ne,onDidRemoveLastListener:ue});return ae.event}D.fromNodeEventEmitter=ye;function Se(x,G,Z=K=>K){const K=(...fe)=>ae.fire(Z(...fe)),ne=()=>x.addEventListener(G,K),ue=()=>x.removeEventListener(G,K),ae=new m({onWillAddFirstListener:ne,onDidRemoveLastListener:ue});return ae.event}D.fromDOMEventEmitter=Se;function Ie(x){return new Promise(G=>_(x)(G))}D.toPromise=Ie;function Re(x){const G=new m;return x.then(Z=>{G.fire(Z)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}D.fromPromise=Re;function O(x,G,Z){return G(Z),x(K=>G(K))}D.runAndSubscribe=O;class C{constructor(G,Z){this._observable=G,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Z||k(K),this.emitter=new m(K),Z&&Z.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,Z){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function j(x,G){return new C(x,G).emitter.event}D.fromObservable=j;function Q(x){return(G,Z,K)=>{let ne=0,ue=!1;const ae={beginUpdate(){ne++},endUpdate(){ne--,ne===0&&(x.reportChanges(),ue&&(ue=!1,G.call(Z)))},handlePossibleChange(){},handleChange(){ue=!0}};x.addObserver(ae),x.reportChanges();const fe={dispose(){x.removeObserver(ae)}};return K instanceof r.$Sc?K.add(fe):Array.isArray(K)&&K.push(fe),fe}}D.fromObservableLight=Q})(s||(t.Event=s={}));class h{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${h.f++}`,h.all.add(this)}start(k){this.g=new N.$Yd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}t.$1d=h;let A=-1;function b(D){const k=A;return A=D,{dispose(){A=k}}}t.$2d=b;class g{constructor(k,T=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=T,this.g=0}dispose(){this.f?.clear()}check(k,T){const _=this.threshold;if(_<=0||T<_)return;this.f||(this.f=new Map);const q=this.f.get(k.value)||0;if(this.f.set(k.value,q+1),this.g-=1,this.g<=0){this.g=_*.5;let V,z=0;for(const[S,U]of this.f)(!V||z<U)&&(V=S,z=U);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${z}):`),console.warn(V)}return()=>{const V=this.f.get(k.value)||0;this.f.set(k.value,V-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class R{constructor(k){this.value=k,this.id=E++}}const L=2,$=(D,k)=>{if(D instanceof R)k(D);else for(let T=0;T<D.length;T++){const _=D[T];_&&k(_)}};class m{constructor(k){this.w=0,this.f=k,this.g=A>0||this.f?.leakWarningThreshold?new g(this.f?.leakWarningThreshold??A):void 0,this.j=this.f?._profName?new h(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(f){const k=this.t;queueMicrotask(()=>{$(k,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,T,_)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Tc.None;if(this.m)return r.$Tc.None;T&&(k=k.bind(T));const q=new R(k);let V,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),V=this.g.check(q.stack,this.w+1)),f&&(q.stack=z??e.create()),this.t?this.t instanceof R?(this.u??=new c,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const S=(0,r.$Rc)(()=>{V?.(),this.x(q)});return _ instanceof r.$Sc?_.add(S):Array.isArray(_)&&_.push(S),S},this.q}x(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,_=T.indexOf(k);if(_===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[_]=void 0;const q=this.u.current===this;if(this.w*L<=T.length){let V=0;for(let z=0;z<T.length;z++)T[z]?T[V++]=T[z]:q&&(this.u.end--,V<this.u.i&&this.u.i--);T.length=V}}y(k,T){if(!k)return;const _=this.f?.onListenerError||F.$1;if(!_){k.value(T);return}try{k.value(T)}catch(q){_(q)}}z(k){const T=k.current.t;for(;k.i<k.end;)this.y(T[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof R)this.y(this.t,k);else{const T=this.u;T.enqueue(this,k,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}t.$3d=m;const u=()=>new c;t.$4d=u;class c{constructor(){this.i=-1,this.end=0}enqueue(k,T,_){this.i=0,this.end=_,this.current=k,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends m{async fireAsync(k,T,_){if(this.t)for(this.h||(this.h=new o.$4c),$(this.t,q=>this.h.push([q.value,k]));this.h.size>0&&!T.isCancellationRequested;){const[q,V]=this.h.shift(),z=[],S={...V,token:T,waitUntil:U=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");_&&(U=_(U,q)),z.push(U)}};try{q(S)}catch(U){(0,F.$1)(U);continue}Object.freeze(z),await Promise.allSettled(z).then(U=>{for(const X of U)X.status==="rejected"&&(0,F.$1)(X.reason)})}}}t.$5d=i;class l extends m{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new o.$4c,this.A=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.A(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.w&&(this.h!==0?this.s.push(k):super.fire(k))}}t.$6d=l;class v extends l{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}t.$7d=v;class d extends m{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}t.$8d=d;class w{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const T={event:k,listener:null};this.h.push(T),this.g&&this.m(T);const _=()=>{this.g&&this.o(T);const q=this.h.indexOf(T);this.h.splice(q,1)};return(0,r.$Rc)((0,y.$db)(_))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(T=>this.f.fire(T))}o(k){k.listener?.dispose(),k.listener=null}dispose(){this.f.dispose();for(const k of this.h)k.listener?.dispose();this.h=[]}}t.$9d=w;class M{constructor(k,T,_,q){this.f=new r.$Sc;const V=this.f.add(new w),z=this.f.add(new r.$3c);function S(U){z.set(U,V.add(q(U)))}for(const U of k)S(U);this.f.add(T(U=>{S(U)})),this.f.add(_(U=>{z.deleteAndDispose(U)})),this.event=V.event}dispose(){this.f.dispose()}}t.$0d=M;class p{constructor(){this.f=[]}wrapEvent(k){return(T,_,q)=>k(V=>{const z=this.f[this.f.length-1];z?z.push(()=>T.call(_,V)):T.call(_,V)},void 0,q)}bufferEvents(k){const T=[];this.f.push(T);const _=k();return this.f.pop(),T.forEach(q=>q()),_}}t.$$d=p;class P{constructor(){this.f=!1,this.g=s.None,this.h=r.$Tc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$_d=P}),te(ie[24],re([0,1,11]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.CancellationToken=void 0;const y=Object.freeze(function(f,a){const s=setTimeout(f.bind(a),0);return{dispose(){clearTimeout(s)}}});var r;(function(f){function a(s){return s===f.None||s===f.Cancelled||s instanceof o?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}f.isCancellationToken=a,f.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:F.Event.None}),f.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:y})})(r||(t.CancellationToken=r={}));class o{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?y:(this.b||(this.b=new F.$3d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new o),this.f}cancel(){this.f?this.f instanceof o&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof o&&this.f.dispose():this.f=r.None}}t.$ae=N}),te(ie[39],re([0,1,24]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ne=t.$Me=t.$Le=void 0;class y{constructor(f){this.b=f,this.a=null}get(){if(this.a)return this.a;const f=new F.$ae,a=this.b(f.token);return this.a={promise:a,dispose:()=>{this.a=null,f.cancel(),f.dispose()}},this.a}}t.$Le=y;class r{constructor(f){this.c=f,this.a=void 0,this.b=void 0}get(f){const a=JSON.stringify(f);return this.b!==a&&(this.b=a,this.a=this.c(f)),this.a}}t.$Me=r;class o{get cachedValues(){return this.a}constructor(f){this.b=f,this.a=new Map}get(f){if(this.a.has(f))return this.a.get(f);const a=this.b(f);return this.a.set(f,a),a}}t.$Ne=o}),te(ie[7],re([0,1,39,38]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.GraphemeBreakType=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=void 0;function r(I){return!I||typeof I!="string"?!0:I.trim().length===0}t.$Qe=r;const o=/{(\d+)}/g;function N(I,...B){return B.length===0?I:I.replace(o,function(H,Y){const se=parseInt(Y,10);return isNaN(se)||se<0||se>=B.length?H:B[se]})}t.$Re=N;const f=/{([^}]+)}/g;function a(I,B){return Object.keys(B).length===0?I:I.replace(f,(H,Y)=>B[Y]??H)}t.$Se=a;function s(I){return I.replace(/[<>"'&]/g,B=>{switch(B){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return B})}t.$Te=s;function h(I){return I.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}t.$Ue=h;function A(I){return I.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ve=A;function b(I,B){let H=0;const Y=B.charCodeAt(0);for(let se=I.length-1;se>=0;se--)I.charCodeAt(se)===Y&&H++;return H}t.$We=b;function g(I,B,H="\u2026"){return I.length<=B?I:`${I.substr(0,B)}${H}`}t.$Xe=g;function e(I,B,H="\u2026"){if(I.length<=B)return I;const Y=Math.ceil(B/2)-H.length/2,se=Math.floor(B/2)-H.length/2;return`${I.substr(0,Y)}${H}${I.substr(I.length-se)}`}t.$Ye=e;function E(I,B=" "){const H=R(I,B);return L(H,B)}t.$Ze=E;function R(I,B){if(!I||!B)return I;const H=B.length;if(H===0||I.length===0)return I;let Y=0;for(;I.indexOf(B,Y)===Y;)Y=Y+H;return I.substring(Y)}t.$1e=R;function L(I,B){if(!I||!B)return I;const H=B.length,Y=I.length;if(H===0||Y===0)return I;let se=Y,ce=-1;for(;ce=I.lastIndexOf(B,se-1),!(ce===-1||ce+H!==se);){if(ce===0)return"";se=ce}return I.substring(0,se)}t.$2e=L;function $(I){return I.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$3e=$;function m(I){return I.replace(/\*/g,"")}t.$4e=m;function u(I,B,H={}){if(!I)throw new Error("Cannot create regex from empty string");B||(I=A(I)),H.wholeWord&&(/\B/.test(I.charAt(0))||(I="\\b"+I),/\B/.test(I.charAt(I.length-1))||(I=I+"\\b"));let Y="";return H.global&&(Y+="g"),H.matchCase||(Y+="i"),H.multiline&&(Y+="m"),H.unicode&&(Y+="u"),new RegExp(I,Y)}t.$5e=u;function c(I){return I.source==="^"||I.source==="^$"||I.source==="$"||I.source==="^\\s*$"?!1:!!(I.exec("")&&I.lastIndex===0)}t.$6e=c;function i(I){return I.split(/\r\n|\r|\n/)}t.$7e=i;function l(I){const B=[],H=I.split(/(\r\n|\r|\n)/);for(let Y=0;Y<Math.ceil(H.length/2);Y++)B.push(H[2*Y]+(H[2*Y+1]??""));return B}t.$8e=l;function v(I){for(let B=0,H=I.length;B<H;B++){const Y=I.charCodeAt(B);if(Y!==32&&Y!==9)return B}return-1}t.$9e=v;function d(I,B=0,H=I.length){for(let Y=B;Y<H;Y++){const se=I.charCodeAt(Y);if(se!==32&&se!==9)return I.substring(B,Y)}return I.substring(B,H)}t.$0e=d;function w(I,B=I.length-1){for(let H=B;H>=0;H--){const Y=I.charCodeAt(H);if(Y!==32&&Y!==9)return H}return-1}t.$$e=w;function M(I,B,H){const Y=[];let se=0;for(const ce of I.matchAll(B)){if(Y.push(I.slice(se,ce.index)),ce.index===void 0)throw new Error("match.index should be defined");se=ce.index+ce[0].length,Y.push(H(ce[0],...ce.slice(1),ce.index,I,ce.groups))}return Y.push(I.slice(se)),Promise.all(Y).then(ce=>ce.join(""))}t.$_e=M;function p(I,B){return I<B?-1:I>B?1:0}t.$af=p;function P(I,B,H=0,Y=I.length,se=0,ce=B.length){for(;H<Y&&se<ce;H++,se++){const Le=I.charCodeAt(H),Ne=B.charCodeAt(se);if(Le<Ne)return-1;if(Le>Ne)return 1}const ge=Y-H,Me=ce-se;return ge<Me?-1:ge>Me?1:0}t.$bf=P;function D(I,B){return k(I,B,0,I.length,0,B.length)}t.$cf=D;function k(I,B,H=0,Y=I.length,se=0,ce=B.length){for(;H<Y&&se<ce;H++,se++){let Le=I.charCodeAt(H),Ne=B.charCodeAt(se);if(Le===Ne)continue;if(Le>=128||Ne>=128)return P(I.toLowerCase(),B.toLowerCase(),H,Y,se,ce);_(Le)&&(Le-=32),_(Ne)&&(Ne-=32);const be=Le-Ne;if(be!==0)return be}const ge=Y-H,Me=ce-se;return ge<Me?-1:ge>Me?1:0}t.$df=k;function T(I){return I>=48&&I<=57}t.$ef=T;function _(I){return I>=97&&I<=122}t.$ff=_;function q(I){return I>=65&&I<=90}t.$gf=q;function V(I,B){return I.length===B.length&&k(I,B)===0}t.$hf=V;function z(I,B){const H=B.length;return B.length>I.length?!1:k(I,B,0,H)===0}t.$if=z;function S(I,B){const H=Math.min(I.length,B.length);let Y;for(Y=0;Y<H;Y++)if(I.charCodeAt(Y)!==B.charCodeAt(Y))return Y;return H}t.$jf=S;function U(I,B){const H=Math.min(I.length,B.length);let Y;const se=I.length-1,ce=B.length-1;for(Y=0;Y<H;Y++)if(I.charCodeAt(se-Y)!==B.charCodeAt(ce-Y))return Y;return H}t.$kf=U;function X(I){return 55296<=I&&I<=56319}t.$lf=X;function J(I){return 56320<=I&&I<=57343}t.$mf=J;function ee(I,B){return(I-55296<<10)+(B-56320)+65536}t.$nf=ee;function le(I,B,H){const Y=I.charCodeAt(H);if(X(Y)&&H+1<B){const se=I.charCodeAt(H+1);if(J(se))return ee(Y,se)}return Y}t.$of=le;function n(I,B){const H=I.charCodeAt(B-1);if(J(H)&&B>1){const Y=I.charCodeAt(B-2);if(X(Y))return ee(Y,H)}return H}class oe{get offset(){return this.e}constructor(B,H=0){this.c=B,this.d=B.length,this.e=H}setOffset(B){this.e=B}prevCodePoint(){const B=n(this.c,this.e);return this.e-=B>=65536?2:1,B}nextCodePoint(){const B=le(this.c,this.d,this.e);return this.e+=B>=65536?2:1,B}eol(){return this.e>=this.d}}t.$pf=oe;class me{get offset(){return this.c.offset}constructor(B,H=0){this.c=new oe(B,H)}nextGraphemeLength(){const B=ve.getInstance(),H=this.c,Y=H.offset;let se=B.getGraphemeBreakType(H.nextCodePoint());for(;!H.eol();){const ce=H.offset,ge=B.getGraphemeBreakType(H.nextCodePoint());if(qe(se,ge)){H.setOffset(ce);break}se=ge}return H.offset-Y}prevGraphemeLength(){const B=ve.getInstance(),H=this.c,Y=H.offset;let se=B.getGraphemeBreakType(H.prevCodePoint());for(;H.offset>0;){const ce=H.offset,ge=B.getGraphemeBreakType(H.prevCodePoint());if(qe(ge,se)){H.setOffset(ce);break}se=ge}return Y-H.offset}eol(){return this.c.eol()}}t.$qf=me;function we(I,B){return new me(I,B).nextGraphemeLength()}t.$rf=we;function Ae(I,B){return new me(I,B).prevGraphemeLength()}t.$sf=Ae;function $e(I,B){B>0&&J(I.charCodeAt(B))&&B--;const H=B+we(I,B);return[H-Ae(I,H),H]}t.$tf=$e;function Pe(I){const B=new me(I);let H=0;for(;!B.eol();)H++,B.nextGraphemeLength();return H}t.$uf=Pe;let ye;function Se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ie(I){return ye||(ye=Se()),ye.test(I)}t.$vf=Ie;const Re=/^[\t\n\r\x20-\x7E]*$/;function O(I){return Re.test(I)}t.$wf=O,t.$xf=/[\u2028\u2029]/;function C(I){return t.$xf.test(I)}t.$yf=C;function j(I){return I>=11904&&I<=55215||I>=63744&&I<=64255||I>=65281&&I<=65374}t.$zf=j;function Q(I){return I>=127462&&I<=127487||I===8986||I===8987||I===9200||I===9203||I>=9728&&I<=10175||I===11088||I===11093||I>=127744&&I<=128591||I>=128640&&I<=128764||I>=128992&&I<=129008||I>=129280&&I<=129535||I>=129648&&I<=129782}t.$Af=Q;function x(I,B,H=""){const Y=I.trimStart();if(Y.length<B)return Y;const se=/\b/g;let ce=0;for(;se.test(Y)&&!(Y.length-se.lastIndex<B);)ce=se.lastIndex,se.lastIndex+=1;return ce===0?Y:H+Y.substring(ce).trimStart()}t.$Bf=x;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,Z=/\x1b\].*?\x07/g;function K(I){return I&&(I=I.replace(G,"").replace(Z,"")),I}t.$Cf=K,t.$Df="\uFEFF";function ne(I){return!!(I&&I.length>0&&I.charCodeAt(0)===65279)}t.$Ef=ne;function ue(I){return ne(I)?I.substr(1):I}t.$Ff=ue;function ae(I,B){if(!I||!B||I.length<B.length)return!1;const H=B.length,Y=I.toLowerCase();let se=0,ce=-1;for(;se<H;){const ge=Y.indexOf(B[se],ce+1);if(ge<0)return!1;ce=ge,se++}return!0}t.$Gf=ae;function fe(I,B=!1){return I?(B&&(I=I.replace(/\\./g,"")),I.toLowerCase()!==I):!1}t.$Hf=fe;function de(I){return I.charAt(0).toUpperCase()+I.slice(1)}t.$If=de;function ke(I,B=1){if(B===0)return"";let H=-1;do H=I.indexOf(`
`,H+1),B--;while(B>0&&H>=0);return H===-1?I:(I[H-1]==="\r"&&H--,I.substr(0,H))}t.$Jf=ke;function _e(I){return I=I%(2*26),I<26?String.fromCharCode(97+I):String.fromCharCode(65+I-26)}t.$Kf=_e;function Fe(I){return ve.getInstance().getGraphemeBreakType(I)}t.$Lf=Fe;function qe(I,B){return I===0?B!==5&&B!==7:I===2&&B===3?!1:I===4||I===2||I===3||B===4||B===2||B===3?!0:!(I===8&&(B===8||B===9||B===11||B===12)||(I===11||I===9)&&(B===9||B===10)||(I===12||I===10)&&B===10||B===5||B===13||B===7||I===1||I===13&&B===14||I===6&&B===6)}var De;(function(I){I[I.Other=0]="Other",I[I.Prepend=1]="Prepend",I[I.CR=2]="CR",I[I.LF=3]="LF",I[I.Control=4]="Control",I[I.Extend=5]="Extend",I[I.Regional_Indicator=6]="Regional_Indicator",I[I.SpacingMark=7]="SpacingMark",I[I.L=8]="L",I[I.V=9]="V",I[I.T=10]="T",I[I.LV=11]="LV",I[I.LVT=12]="LVT",I[I.ZWJ=13]="ZWJ",I[I.Extended_Pictographic=14]="Extended_Pictographic"})(De||(t.GraphemeBreakType=De={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Oe()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const H=this.d,Y=H.length/3;let se=1;for(;se<=Y;)if(B<H[3*se])se=2*se;else if(B>H[3*se+1])se=2*se+1;else return H[3*se+2];return 0}}function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(I,B){if(I===0)return 0;const H=ze(I,B);if(H!==void 0)return H;const Y=new oe(B,I);return Y.prevCodePoint(),Y.offset}t.$Mf=xe;function ze(I,B){const H=new oe(B,I);let Y=H.prevCodePoint();for(;He(Y)||Y===65039||Y===8419;){if(H.offset===0)return;Y=H.prevCodePoint()}if(!Q(Y))return;let se=H.offset;return se>0&&H.prevCodePoint()===8205&&(se=H.offset),se}function He(I){return 127995<=I&&I<=127999}var We;(function(I){I[I.zwj=8205]="zwj",I[I.emojiVariantSelector=65039]="emojiVariantSelector",I[I.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),t.$Nf="\xA0";class Te{static{this.c=new y.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new F.$Me(B=>{function H(be){const pe=new Map;for(let Ee=0;Ee<be.length;Ee+=2)pe.set(be[Ee],be[Ee+1]);return pe}function Y(be,pe){const Ee=new Map(be);for(const[Be,Ve]of pe)Ee.set(Be,Ve);return Ee}function se(be,pe){if(!be)return pe;const Ee=new Map;for(const[Be,Ve]of be)pe.has(Be)&&Ee.set(Be,Ve);return Ee}const ce=this.c.value;let ge=B.filter(be=>!be.startsWith("_")&&be in ce);ge.length===0&&(ge=["_default"]);let Me;for(const be of ge){const pe=H(ce[be]);Me=se(Me,pe)}const Le=H(ce._common),Ne=Y(Le,Me);return new Te(Ne)})}static getInstance(B){return Te.d.get(Array.from(B))}static{this.e=new y.$V(()=>Object.keys(Te.c.value).filter(B=>!B.startsWith("_")))}static getLocales(){return Te.e.value}constructor(B){this.f=B}isAmbiguous(B){return this.f.has(B)}getPrimaryConfusable(B){return this.f.get(B)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Of=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(B){return Ue.e().has(B)}static get codePoints(){return Ue.e()}}t.$Pf=Ue}),te(ie[40],re([0,1,7]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9i=t.$8i=t.$7i=t.$6i=t.$5i=t.$4i=t.$3i=void 0;function y(L){return r(L,0)}t.$3i=y;function r(L,$){switch(typeof L){case"object":return L===null?o(349,$):Array.isArray(L)?a(L,$):s(L,$);case"string":return f(L,$);case"boolean":return N(L,$);case"number":return o(L,$);case"undefined":return o(937,$);default:return o(617,$)}}t.$4i=r;function o(L,$){return($<<5)-$+L|0}t.$5i=o;function N(L,$){return o(L?433:863,$)}function f(L,$){$=o(149417,$);for(let m=0,u=L.length;m<u;m++)$=o(L.charCodeAt(m),$);return $}t.$6i=f;function a(L,$){return $=o(104579,$),L.reduce((m,u)=>r(u,m),$)}function s(L,$){return $=o(181387,$),Object.keys(L).sort().reduce((m,u)=>(m=f(u,m),r(L[u],m)),$)}class h{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$7i=h;var A;(function(L){L[L.BLOCK_SIZE=64]="BLOCK_SIZE",L[L.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(L,$,m=32){const u=m-$,c=~((1<<u)-1);return(L<<$|(c&L)>>>u)>>>0}function g(L,$=0,m=L.byteLength,u=0){for(let c=0;c<m;c++)L[$+c]=u}function e(L,$,m="0"){for(;L.length<$;)L=m+L;return L}function E(L,$=32){return L instanceof ArrayBuffer?Array.from(new Uint8Array(L)).map(m=>m.toString(16).padStart(2,"0")).join(""):e((L>>>0).toString(16),$/4)}t.$8i=E;class R{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const m=$.length;if(m===0)return;const u=this.p;let c=this.r,i=this.u,l,v;for(i!==0?(l=i,v=-1,i=0):(l=$.charCodeAt(0),v=0);;){let d=l;if(F.$lf(l))if(v+1<m){const w=$.charCodeAt(v+1);F.$mf(w)?(v++,d=F.$nf(l,w)):d=65533}else{i=l;break}else F.$mf(l)&&(d=65533);if(c=this.w(u,c,d),v++,v<m)l=$.charCodeAt(v);else break}this.r=c,this.u=i}w($,m,u){return u<128?$[m++]=u:u<2048?($[m++]=192|(u&1984)>>>6,$[m++]=128|(u&63)>>>0):u<65536?($[m++]=224|(u&61440)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0):($[m++]=240|(u&1835008)>>>18,$[m++]=128|(u&258048)>>>12,$[m++]=128|(u&4032)>>>6,$[m++]=128|(u&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=R.g,m=this.q;for(let p=0;p<64;p+=4)$.setUint32(p,m.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)$.setUint32(p,b($.getUint32(p-12,!1)^$.getUint32(p-32,!1)^$.getUint32(p-56,!1)^$.getUint32(p-64,!1),1),!1);let u=this.h,c=this.l,i=this.m,l=this.n,v=this.o,d,w,M;for(let p=0;p<80;p++)p<20?(d=c&i|~c&l,w=1518500249):p<40?(d=c^i^l,w=1859775393):p<60?(d=c&i|c&l|i&l,w=2400959708):(d=c^i^l,w=3395469782),M=b(u,5)+d+v+w+$.getUint32(p*4,!1)&4294967295,v=l,l=i,i=b(c,30),c=u,u=M;this.h=this.h+u&4294967295,this.l=this.l+c&4294967295,this.m=this.m+i&4294967295,this.n=this.n+l&4294967295,this.o=this.o+v&4294967295}}t.$9i=R}),te(ie[25],re([0,1,36,40]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=t.$9s=t.$8s=void 0;class r{constructor(b){this.a=b}getElements(){const b=this.a,g=new Int32Array(b.length);for(let e=0,E=b.length;e<E;e++)g[e]=b.charCodeAt(e);return g}}t.$8s=r;function o(A,b,g){return new h(new r(A),new r(b)).ComputeDiff(g).changes}t.$9s=o;class N{static Assert(b,g){if(!b)throw new Error(g)}}class f{static Copy(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}static Copy2(b,g,e,E,R){for(let L=0;L<R;L++)e[E+L]=b[g+L]}}var a;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class s{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new F.$7s(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.d++}AddModifiedElement(b,g){this.b=Math.min(this.b,b),this.c=Math.min(this.c,g),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class h{constructor(b,g,e=null){this.a=e,this.b=b,this.c=g;const[E,R,L]=h.o(b),[$,m,u]=h.o(g);this.d=L&&u,this.e=E,this.f=R,this.g=$,this.h=m,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const g=b.getElements();if(h.n(g)){const e=new Int32Array(g.length);for(let E=0,R=g.length;E<R;E++)e[E]=(0,y.$6i)(g[E],0);return[g,e,!0]}return g instanceof Int32Array?[[],g,!1]:[[],new Int32Array(g),!1]}p(b,g){return this.f[b]!==this.h[g]?!1:this.d?this.e[b]===this.g[g]:!0}q(b,g){if(!this.p(b,g))return!1;const e=h.r(this.b,b),E=h.r(this.c,g);return e===E}static r(b,g){return typeof b.getStrictElement=="function"?b.getStrictElement(g):null}s(b,g){return this.f[b]!==this.f[g]?!1:this.d?this.e[b]===this.e[g]:!0}u(b,g){return this.h[b]!==this.h[g]?!1:this.d?this.g[b]===this.g[g]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,g,e,E,R){const L=[!1];let $=this.w(b,g,e,E,L);return R&&($=this.z($)),{quitEarly:L[0],changes:$}}w(b,g,e,E,R){for(R[0]=!1;b<=g&&e<=E&&this.p(b,e);)b++,e++;for(;g>=b&&E>=e&&this.p(g,E);)g--,E--;if(b>g||e>E){let i;return e<=E?(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),i=[new F.$7s(b,0,e,E-e+1)]):b<=g?(N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[new F.$7s(b,g-b+1,e,0)]):(N.Assert(b===g+1,"originalStart should only be one more than originalEnd"),N.Assert(e===E+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const L=[0],$=[0],m=this.y(b,g,e,E,L,$,R),u=L[0],c=$[0];if(m!==null)return m;if(!R[0]){const i=this.w(b,u,e,c,R);let l=[];return R[0]?l=[new F.$7s(u+1,g-(u+1)+1,c+1,E-(c+1)+1)]:l=this.w(u+1,g,c+1,E,R),this.H(i,l)}return[new F.$7s(b,g-b+1,e,E-e+1)]}x(b,g,e,E,R,L,$,m,u,c,i,l,v,d,w,M,p,P){let D=null,k=null,T=new s,_=g,q=e,V=v[0]-M[0]-E,z=-1073741824,S=this.k.length-1;do{const U=V+b;U===_||U<q&&u[U-1]<u[U+1]?(i=u[U+1],d=i-V-E,i<z&&T.MarkNextChange(),z=i,T.AddModifiedElement(i+1,d),V=U+1-b):(i=u[U-1]+1,d=i-V-E,i<z&&T.MarkNextChange(),z=i-1,T.AddOriginalElement(i,d+1),V=U-1-b),S>=0&&(u=this.k[S],b=u[0],_=1,q=u.length-1)}while(--S>=-1);if(D=T.getReverseChanges(),P[0]){let U=v[0]+1,X=M[0]+1;if(D!==null&&D.length>0){const J=D[D.length-1];U=Math.max(U,J.getOriginalEnd()),X=Math.max(X,J.getModifiedEnd())}k=[new F.$7s(U,l-U+1,X,w-X+1)]}else{T=new s,_=L,q=$,V=v[0]-M[0]-m,z=1073741824,S=p?this.m.length-1:this.m.length-2;do{const U=V+R;U===_||U<q&&c[U-1]>=c[U+1]?(i=c[U+1]-1,d=i-V-m,i>z&&T.MarkNextChange(),z=i+1,T.AddOriginalElement(i+1,d+1),V=U+1-R):(i=c[U-1],d=i-V-m,i>z&&T.MarkNextChange(),z=i,T.AddModifiedElement(i+1,d+1),V=U-1-R),S>=0&&(c=this.m[S],R=c[0],_=1,q=c.length-1)}while(--S>=-1);k=T.getChanges()}return this.H(D,k)}y(b,g,e,E,R,L,$){let m=0,u=0,c=0,i=0,l=0,v=0;b--,e--,R[0]=0,L[0]=0,this.k=[],this.m=[];const d=g-b+(E-e),w=d+1,M=new Int32Array(w),p=new Int32Array(w),P=E-e,D=g-b,k=b-e,T=g-E,q=(D-P)%2===0;M[P]=b,p[D]=g,$[0]=!1;for(let V=1;V<=d/2+1;V++){let z=0,S=0;c=this.J(P-V,V,P,w),i=this.J(P+V,V,P,w);for(let X=c;X<=i;X+=2){X===c||X<i&&M[X-1]<M[X+1]?m=M[X+1]:m=M[X-1]+1,u=m-(X-P)-k;const J=m;for(;m<g&&u<E&&this.p(m+1,u+1);)m++,u++;if(M[X]=m,m+u>z+S&&(z=m,S=u),!q&&Math.abs(X-D)<=V-1&&m>=p[X])return R[0]=m,L[0]=u,J<=p[X]&&1447>0&&V<=1448?this.x(P,c,i,k,D,l,v,T,M,p,m,g,R,u,E,L,q,$):null}const U=(z-b+(S-e)-V)/2;if(this.a!==null&&!this.a(z,U))return $[0]=!0,R[0]=z,L[0]=S,U>0&&1447>0&&V<=1448?this.x(P,c,i,k,D,l,v,T,M,p,m,g,R,u,E,L,q,$):(b++,e++,[new F.$7s(b,g-b+1,e,E-e+1)]);l=this.J(D-V,V,D,w),v=this.J(D+V,V,D,w);for(let X=l;X<=v;X+=2){X===l||X<v&&p[X-1]>=p[X+1]?m=p[X+1]-1:m=p[X-1],u=m-(X-D)-T;const J=m;for(;m>b&&u>e&&this.p(m,u);)m--,u--;if(p[X]=m,q&&Math.abs(X-P)<=V&&m<=M[X])return R[0]=m,L[0]=u,J>=M[X]&&1447>0&&V<=1448?this.x(P,c,i,k,D,l,v,T,M,p,m,g,R,u,E,L,q,$):null}if(V<=1447){let X=new Int32Array(i-c+2);X[0]=P-c+1,f.Copy2(M,c,X,1,i-c+1),this.k.push(X),X=new Int32Array(v-l+2),X[0]=D-l+1,f.Copy2(p,l,X,1,v-l+1),this.m.push(X)}}return this.x(P,c,i,k,D,l,v,T,M,p,m,g,R,u,E,L,q,$)}z(b){for(let g=0;g<b.length;g++){const e=b[g],E=g<b.length-1?b[g+1].originalStart:this.f.length,R=g<b.length-1?b[g+1].modifiedStart:this.h.length,L=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<E&&e.modifiedStart+e.modifiedLength<R&&(!L||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const u=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!u)break;e.originalStart++,e.modifiedStart++}const m=[null];if(g<b.length-1&&this.I(b[g],b[g+1],m)){b[g]=m[0],b.splice(g+1,1),g--;continue}}for(let g=b.length-1;g>=0;g--){const e=b[g];let E=0,R=0;if(g>0){const i=b[g-1];E=i.originalStart+i.originalLength,R=i.modifiedStart+i.modifiedLength}const L=e.originalLength>0,$=e.modifiedLength>0;let m=0,u=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const l=e.originalStart-i,v=e.modifiedStart-i;if(l<E||v<R||L&&!this.s(l,l+e.originalLength)||$&&!this.u(v,v+e.modifiedLength))break;const w=(l===E&&v===R?5:0)+this.G(l,e.originalLength,v,e.modifiedLength);w>u&&(u=w,m=i)}e.originalStart-=m,e.modifiedStart-=m;const c=[null];if(g>0&&this.I(b[g-1],b[g],c)){b[g-1]=c[0],b.splice(g,1),g++;continue}}if(this.d)for(let g=1,e=b.length;g<e;g++){const E=b[g-1],R=b[g],L=R.originalStart-E.originalStart-E.originalLength,$=E.originalStart,m=R.originalStart+R.originalLength,u=m-$,c=E.modifiedStart,i=R.modifiedStart+R.modifiedLength,l=i-c;if(L<5&&u<20&&l<20){const v=this.A($,u,c,l,L);if(v){const[d,w]=v;(d!==E.originalStart+E.originalLength||w!==E.modifiedStart+E.modifiedLength)&&(E.originalLength=d-E.originalStart,E.modifiedLength=w-E.modifiedStart,R.originalStart=d+L,R.modifiedStart=w+L,R.originalLength=m-R.originalStart,R.modifiedLength=i-R.modifiedStart)}}}return b}A(b,g,e,E,R){if(g<R||E<R)return null;const L=b+g-R+1,$=e+E-R+1;let m=0,u=0,c=0;for(let i=b;i<L;i++)for(let l=e;l<$;l++){const v=this.B(i,l,R);v>0&&v>m&&(m=v,u=i,c=l)}return m>0?[u,c]:null}B(b,g,e){let E=0;for(let R=0;R<e;R++){if(!this.p(b+R,g+R))return 0;E+=this.e[b+R].length}return E}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,g){if(this.C(b)||this.C(b-1))return!0;if(g>0){const e=b+g;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,g){if(this.E(b)||this.E(b-1))return!0;if(g>0){const e=b+g;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,g,e,E){const R=this.D(b,g)?1:0,L=this.F(e,E)?1:0;return R+L}H(b,g){const e=[];if(b.length===0||g.length===0)return g.length>0?g:b;if(this.I(b[b.length-1],g[0],e)){const E=new Array(b.length+g.length-1);return f.Copy(b,0,E,0,b.length-1),E[b.length-1]=e[0],f.Copy(g,1,E,b.length,g.length-1),E}else{const E=new Array(b.length+g.length);return f.Copy(b,0,E,0,b.length),f.Copy(g,0,E,b.length,g.length),E}}I(b,g,e){if(N.Assert(b.originalStart<=g.originalStart,"Left change is not less than or equal to right change"),N.Assert(b.modifiedStart<=g.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=g.originalStart||b.modifiedStart+b.modifiedLength>=g.modifiedStart){const E=b.originalStart;let R=b.originalLength;const L=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=g.originalStart&&(R=g.originalStart+g.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=g.modifiedStart&&($=g.modifiedStart+g.modifiedLength-b.modifiedStart),e[0]=new F.$7s(E,R,L,$),!0}else return e[0]=null,!1}J(b,g,e,E){if(b>=0&&b<E)return b;const R=e,L=E-e-1,$=g%2===0;if(b<0){const m=R%2===0;return $===m?0:1}else{const m=L%2===0;return $===m?E-1:E-2}}}t.$0s=h}),te(ie[26],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function F(c){return typeof c=="string"}t.$Qf=F;function y(c){return Array.isArray(c)&&c.every(i=>F(i))}t.$Rf=y;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}t.$Sf=r;function o(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}t.$Tf=o;function N(c){return typeof c=="number"&&!isNaN(c)}t.$Uf=N;function f(c){return!!c&&typeof c[Symbol.iterator]=="function"}t.$Vf=f;function a(c){return c===!0||c===!1}t.$Wf=a;function s(c){return typeof c>"u"}t.$Xf=s;function h(c){return!A(c)}t.$Yf=h;function A(c){return s(c)||c===null}t.$Zf=A;function b(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$1f=b;function g(c){if(A(c))throw new Error("Assertion Failed: argument is undefined or null");return c}t.$2f=g;function e(...c){const i=[];for(let l=0;l<c.length;l++){const v=c[l];if(A(v))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);i.push(v)}return i}t.$3f=e;const E=Object.prototype.hasOwnProperty;function R(c){if(!r(c))return!1;for(const i in c)if(E.call(c,i))return!1;return!0}t.$4f=R;function L(c){return typeof c=="function"}t.$5f=L;function $(...c){return c.length>0&&c.every(L)}t.$6f=$;function m(c,i){const l=Math.min(c.length,i.length);for(let v=0;v<l;v++)u(c[v],i[v])}t.$7f=m;function u(c,i){if(F(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(L(i)){try{if(c instanceof i)return}catch{}if(!A(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$8f=u}),te(ie[41],re([0,1,26]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ik=t.$hk=t.$gk=void 0;const y=Object.create(null);function r(f,a){if((0,F.$Qf)(a)){const s=y[a];if(s===void 0)throw new Error(`${f} references an unknown codicon: ${a}`);a=s}return y[f]=a,{id:f}}function o(){return y}t.$gk=o;function N(){return Object.values(t.$ik)}t.$hk=N,t.$ik={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugBreakpointPending:r("debug-breakpoint-pending",60377),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),lightbulbSparkle:r("lightbulb-sparkle",60447),lightbulbSparkleAutofix:r("lightbulb-sparkle-autofix",60447),robot:r("robot",60448),sparkleFilled:r("sparkle-filled",60449),diffSingle:r("diff-single",60450),diffMultiple:r("diff-multiple",60451),surroundWith:r("surround-with",60452),gitStash:r("git-stash",60454),gitStashApply:r("git-stash-apply",60455),gitStashPop:r("git-stash-pop",60456),coverage:r("coverage",60462),runAllCoverage:r("run-all-coverage",60461),runCoverage:r("run-all-coverage",60460),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),te(ie[14],re([0,1,26]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qn=t.$Pn=t.$On=t.$Nn=t.$Mn=t.$Ln=t.$Kn=t.$Jn=t.$In=t.$Hn=t.$Gn=t.$Fn=void 0;function y(L){if(!L||typeof L!="object"||L instanceof RegExp)return L;const $=Array.isArray(L)?[]:{};return Object.entries(L).forEach(([m,u])=>{$[m]=u&&typeof u=="object"?y(u):u}),$}t.$Fn=y;function r(L){if(!L||typeof L!="object")return L;const $=[L];for(;$.length>0;){const m=$.shift();Object.freeze(m);for(const u in m)if(o.call(m,u)){const c=m[u];typeof c=="object"&&!Object.isFrozen(c)&&!(0,F.$Tf)(c)&&$.push(c)}}return L}t.$Gn=r;const o=Object.prototype.hasOwnProperty;function N(L,$){return f(L,$,new Set)}t.$Hn=N;function f(L,$,m){if((0,F.$Zf)(L))return L;const u=$(L);if(typeof u<"u")return u;if(Array.isArray(L)){const c=[];for(const i of L)c.push(f(i,$,m));return c}if((0,F.$Sf)(L)){if(m.has(L))throw new Error("Cannot clone recursive data-structure");m.add(L);const c={};for(const i in L)o.call(L,i)&&(c[i]=f(L[i],$,m));return m.delete(L),c}return L}function a(L,$,m=!0){return(0,F.$Sf)(L)?((0,F.$Sf)($)&&Object.keys($).forEach(u=>{u in L?m&&((0,F.$Sf)(L[u])&&(0,F.$Sf)($[u])?a(L[u],$[u],m):L[u]=$[u]):L[u]=$[u]}),L):$}t.$In=a;function s(L,$){if(L===$)return!0;if(L==null||$===null||$===void 0||typeof L!=typeof $||typeof L!="object"||Array.isArray(L)!==Array.isArray($))return!1;let m,u;if(Array.isArray(L)){if(L.length!==$.length)return!1;for(m=0;m<L.length;m++)if(!s(L[m],$[m]))return!1}else{const c=[];for(u in L)c.push(u);c.sort();const i=[];for(u in $)i.push(u);if(i.sort(),!s(c,i))return!1;for(m=0;m<c.length;m++)if(!s(L[c[m]],$[c[m]]))return!1}return!0}t.$Jn=s;function h(L){const $=new Set;return JSON.stringify(L,(m,u)=>{if((0,F.$Sf)(u)||Array.isArray(u)){if($.has(u))return"[Circular]";$.add(u)}return u})}t.$Kn=h;function A(L,$){const m=Object.create(null);return!L||!$||Object.keys($).forEach(c=>{const i=L[c],l=$[c];s(i,l)||(m[c]=l)}),m}t.$Ln=A;function b(L,$){const m=$.toLowerCase(),u=Object.keys(L).find(c=>c.toLowerCase()===m);return u?L[u]:L[$]}t.$Mn=b;function g(L,$){const m=Object.create(null);for(const[u,c]of Object.entries(L))$(u,c)&&(m[u]=c);return m}t.$Nn=g;function e(L){let $=[];for(;Object.prototype!==L;)$=$.concat(Object.getOwnPropertyNames(L)),L=Object.getPrototypeOf(L);return $}t.$On=e;function E(L){const $=[];for(const m of e(L))typeof L[m]=="function"&&$.push(m);return $}t.$Pn=E;function R(L,$){const m=c=>function(){const i=Array.prototype.slice.call(arguments,0);return $(c,i)},u={};for(const c of L)u[c]=m(c);return u}t.$Qn=R}),te(ie[27],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=t.$Oe=t.Constants=void 0;var F;(function(o){o[o.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",o[o.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",o[o.MAX_UINT_8=255]="MAX_UINT_8",o[o.MAX_UINT_16=65535]="MAX_UINT_16",o[o.MAX_UINT_32=4294967295]="MAX_UINT_32",o[o.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(F||(t.Constants=F={}));function y(o){return o<0?0:o>255?255:o|0}t.$Oe=y;function r(o){return o<0?0:o>4294967295?4294967295:o|0}t.$Pe=r}),te(ie[28],re([0,1,27]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pt=t.$ot=void 0;class y{constructor(f){const a=(0,F.$Oe)(f);this.c=a,this.a=y.d(a),this.b=new Map}static d(f){const a=new Uint8Array(256);return a.fill(f),a}set(f,a){const s=(0,F.$Oe)(a);f>=0&&f<256?this.a[f]=s:this.b.set(f,s)}get(f){return f>=0&&f<256?this.a[f]:this.b.get(f)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$ot=y;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class o{constructor(){this.a=new y(0)}add(f){this.a.set(f,1)}has(f){return this.a.get(f)===1}clear(){return this.a.clear()}}t.$pt=o}),te(ie[4],re([0,1,3]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.$$s=void 0;class y{static addRange(N,f){let a=0;for(;a<f.length&&f[a].endExclusive<N.start;)a++;let s=a;for(;s<f.length&&f[s].start<=N.endExclusive;)s++;if(a===s)f.splice(a,0,N);else{const h=Math.min(N.start,f[a].start),A=Math.max(N.endExclusive,f[s-1].endExclusive);f.splice(a,s-a,new y(h,A))}}static tryCreate(N,f){if(!(N>f))return new y(N,f)}static ofLength(N){return new y(0,N)}static ofStartAndLength(N,f){return new y(N,N+f)}constructor(N,f){if(this.start=N,this.endExclusive=f,N>f)throw new F.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new y(this.start+N,this.endExclusive+N)}deltaStart(N){return new y(this.start+N,this.endExclusive)}deltaEnd(N){return new y(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new y(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(f<=a)return new y(f,a)}intersects(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<a}intersectsOrTouches(N){const f=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return f<=a}isBefore(N){return this.endExclusive<=N.start}isAfter(N){return this.start>=N.endExclusive}slice(N){return N.slice(this.start,this.endExclusive)}substring(N){return N.substring(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new F.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new F.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const f=[];for(let a=this.start;a<this.endExclusive;a++)f.push(N(a));return f}forEach(N){for(let f=this.start;f<this.endExclusive;f++)N(f)}}t.$$s=y;class r{constructor(){this.a=[]}addRange(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<N.start;)f++;let a=f;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(f===a)this.a.splice(f,0,N);else{const s=Math.min(N.start,this.a[f].start),h=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(f,a-f,new y(s,h))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let f=0;for(;f<this.a.length&&this.a[f].endExclusive<=N.start;)f++;return f<this.a.length&&this.a[f].start<N.endExclusive}intersectWithRange(N){const f=new r;for(const a of this.a){const s=a.intersect(N);s&&f.addRange(s)}return f}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,f)=>N+f.length,0)}}t.$_s=r}),te(ie[5],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=void 0;class F{constructor(r,o){this.lineNumber=r,this.column=o}with(r=this.lineNumber,o=this.column){return r===this.lineNumber&&o===this.column?this:new F(r,o)}delta(r=0,o=0){return this.with(this.lineNumber+r,this.column+o)}equals(r){return F.equals(this,r)}static equals(r,o){return!r&&!o?!0:!!r&&!!o&&r.lineNumber===o.lineNumber&&r.column===o.column}isBefore(r){return F.isBefore(this,r)}static isBefore(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<o.column}isBeforeOrEqual(r){return F.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,o){return r.lineNumber<o.lineNumber?!0:o.lineNumber<r.lineNumber?!1:r.column<=o.column}static compare(r,o){const N=r.lineNumber|0,f=o.lineNumber|0;if(N===f){const a=r.column|0,s=o.column|0;return a-s}return N-f}clone(){return new F(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new F(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$3s=F}),te(ie[2],re([0,1,5]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4s=void 0;class y{constructor(o,N,f,a){o>f||o===f&&N>a?(this.startLineNumber=f,this.startColumn=a,this.endLineNumber=o,this.endColumn=N):(this.startLineNumber=o,this.startColumn=N,this.endLineNumber=f,this.endColumn=a)}isEmpty(){return y.isEmpty(this)}static isEmpty(o){return o.startLineNumber===o.endLineNumber&&o.startColumn===o.endColumn}containsPosition(o){return y.containsPosition(this,o)}static containsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<o.startColumn||N.lineNumber===o.endLineNumber&&N.column>o.endColumn)}static strictContainsPosition(o,N){return!(N.lineNumber<o.startLineNumber||N.lineNumber>o.endLineNumber||N.lineNumber===o.startLineNumber&&N.column<=o.startColumn||N.lineNumber===o.endLineNumber&&N.column>=o.endColumn)}containsRange(o){return y.containsRange(this,o)}static containsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>o.endColumn)}strictContainsRange(o){return y.strictContainsRange(this,o)}static strictContainsRange(o,N){return!(N.startLineNumber<o.startLineNumber||N.endLineNumber<o.startLineNumber||N.startLineNumber>o.endLineNumber||N.endLineNumber>o.endLineNumber||N.startLineNumber===o.startLineNumber&&N.startColumn<=o.startColumn||N.endLineNumber===o.endLineNumber&&N.endColumn>=o.endColumn)}plusRange(o){return y.plusRange(this,o)}static plusRange(o,N){let f,a,s,h;return N.startLineNumber<o.startLineNumber?(f=N.startLineNumber,a=N.startColumn):N.startLineNumber===o.startLineNumber?(f=N.startLineNumber,a=Math.min(N.startColumn,o.startColumn)):(f=o.startLineNumber,a=o.startColumn),N.endLineNumber>o.endLineNumber?(s=N.endLineNumber,h=N.endColumn):N.endLineNumber===o.endLineNumber?(s=N.endLineNumber,h=Math.max(N.endColumn,o.endColumn)):(s=o.endLineNumber,h=o.endColumn),new y(f,a,s,h)}intersectRanges(o){return y.intersectRanges(this,o)}static intersectRanges(o,N){let f=o.startLineNumber,a=o.startColumn,s=o.endLineNumber,h=o.endColumn;const A=N.startLineNumber,b=N.startColumn,g=N.endLineNumber,e=N.endColumn;return f<A?(f=A,a=b):f===A&&(a=Math.max(a,b)),s>g?(s=g,h=e):s===g&&(h=Math.min(h,e)),f>s||f===s&&a>h?null:new y(f,a,s,h)}equalsRange(o){return y.equalsRange(this,o)}static equalsRange(o,N){return!o&&!N?!0:!!o&&!!N&&o.startLineNumber===N.startLineNumber&&o.startColumn===N.startColumn&&o.endLineNumber===N.endLineNumber&&o.endColumn===N.endColumn}getEndPosition(){return y.getEndPosition(this)}static getEndPosition(o){return new F.$3s(o.endLineNumber,o.endColumn)}getStartPosition(){return y.getStartPosition(this)}static getStartPosition(o){return new F.$3s(o.startLineNumber,o.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(o,N){return new y(this.startLineNumber,this.startColumn,o,N)}setStartPosition(o,N){return new y(o,N,this.endLineNumber,this.endColumn)}collapseToStart(){return y.collapseToStart(this)}static collapseToStart(o){return new y(o.startLineNumber,o.startColumn,o.startLineNumber,o.startColumn)}collapseToEnd(){return y.collapseToEnd(this)}static collapseToEnd(o){return new y(o.endLineNumber,o.endColumn,o.endLineNumber,o.endColumn)}delta(o){return new y(this.startLineNumber+o,this.startColumn,this.endLineNumber+o,this.endColumn)}static fromPositions(o,N=o){return new y(o.lineNumber,o.column,N.lineNumber,N.column)}static lift(o){return o?new y(o.startLineNumber,o.startColumn,o.endLineNumber,o.endColumn):null}static isIRange(o){return o&&typeof o.startLineNumber=="number"&&typeof o.startColumn=="number"&&typeof o.endLineNumber=="number"&&typeof o.endColumn=="number"}static areIntersectingOrTouching(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<o.startColumn)}static areIntersecting(o,N){return!(o.endLineNumber<N.startLineNumber||o.endLineNumber===N.startLineNumber&&o.endColumn<=N.startColumn||N.endLineNumber<o.startLineNumber||N.endLineNumber===o.startLineNumber&&N.endColumn<=o.startColumn)}static compareRangesUsingStarts(o,N){if(o&&N){const s=o.startLineNumber|0,h=N.startLineNumber|0;if(s===h){const A=o.startColumn|0,b=N.startColumn|0;if(A===b){const g=o.endLineNumber|0,e=N.endLineNumber|0;if(g===e){const E=o.endColumn|0,R=N.endColumn|0;return E-R}return g-e}return A-b}return s-h}return(o?1:0)-(N?1:0)}static compareRangesUsingEnds(o,N){return o.endLineNumber===N.endLineNumber?o.endColumn===N.endColumn?o.startLineNumber===N.startLineNumber?o.startColumn-N.startColumn:o.startLineNumber-N.startLineNumber:o.endColumn-N.endColumn:o.endLineNumber-N.endLineNumber}static spansMultipleLines(o){return o.endLineNumber>o.startLineNumber}toJSON(){return this}}t.$4s=y}),te(ie[42],re([0,1,2]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=void 0;class y{static insert(o,N){return{range:new F.$4s(o.lineNumber,o.column,o.lineNumber,o.column),text:N,forceMoveMarkers:!0}}static delete(o){return{range:o,text:null}}static replace(o,N){return{range:o,text:N}}static replaceMove(o,N){return{range:o,text:N,forceMoveMarkers:!0}}}t.$5s=y}),te(ie[12],re([0,1,3,4,2,9]),function(W,t,F,y,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bt=t.$at=void 0;class N{static fromRange(s){return new N(s.startLineNumber,s.endLineNumber)}static fromRangeInclusive(s){return new N(s.startLineNumber,s.endLineNumber+1)}static subtract(s,h){return h?s.startLineNumber<h.startLineNumber&&h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(s.startLineNumber,h.startLineNumber),new N(h.endLineNumberExclusive,s.endLineNumberExclusive)]:h.startLineNumber<=s.startLineNumber&&s.endLineNumberExclusive<=h.endLineNumberExclusive?[]:h.endLineNumberExclusive<s.endLineNumberExclusive?[new N(Math.max(h.endLineNumberExclusive,s.startLineNumber),s.endLineNumberExclusive)]:[new N(s.startLineNumber,Math.min(h.startLineNumber,s.endLineNumberExclusive))]:[s]}static joinMany(s){if(s.length===0)return[];let h=new f(s[0].slice());for(let A=1;A<s.length;A++)h=h.getUnion(new f(s[A].slice()));return h.ranges}static ofLength(s,h){return new N(s,s+h)}static deserialize(s){return new N(s[0],s[1])}constructor(s,h){if(s>h)throw new F.$cb(`startLineNumber ${s} cannot be after endLineNumberExclusive ${h}`);this.startLineNumber=s,this.endLineNumberExclusive=h}contains(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(s){return new N(this.startLineNumber+s,this.endLineNumberExclusive+s)}deltaLength(s){return new N(this.startLineNumber,this.endLineNumberExclusive+s)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(s){return new N(Math.min(this.startLineNumber,s.startLineNumber),Math.max(this.endLineNumberExclusive,s.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(s){const h=Math.max(this.startLineNumber,s.startLineNumber),A=Math.min(this.endLineNumberExclusive,s.endLineNumberExclusive);if(h<=A)return new N(h,A)}intersectsStrict(s){return this.startLineNumber<s.endLineNumberExclusive&&s.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(s){return this.startLineNumber<=s.endLineNumberExclusive&&s.startLineNumber<=this.endLineNumberExclusive}equals(s){return this.startLineNumber===s.startLineNumber&&this.endLineNumberExclusive===s.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$4s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$4s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(s){const h=[];for(let A=this.startLineNumber;A<this.endLineNumberExclusive;A++)h.push(s(A));return h}forEach(s){for(let h=this.startLineNumber;h<this.endLineNumberExclusive;h++)s(h)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(s){return this.startLineNumber<=s&&s<this.endLineNumberExclusive}toOffsetRange(){return new y.$$s(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$at=N;class f{constructor(s=[]){this.c=s}get ranges(){return this.c}addRange(s){if(s.length===0)return;const h=(0,o.$kb)(this.c,b=>b.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,b=>b.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)this.c.splice(h,0,s);else if(h===A-1){const b=this.c[h];this.c[h]=b.join(s)}else{const b=this.c[h].join(this.c[A-1]).join(s);this.c.splice(h,A-h,b)}}contains(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<=s);return!!h&&h.endLineNumberExclusive>s}intersects(s){const h=(0,o.$hb)(this.c,A=>A.startLineNumber<s.endLineNumberExclusive);return!!h&&h.endLineNumberExclusive>s.startLineNumber}getUnion(s){if(this.c.length===0)return s;if(s.c.length===0)return this;const h=[];let A=0,b=0,g=null;for(;A<this.c.length||b<s.c.length;){let e=null;if(A<this.c.length&&b<s.c.length){const E=this.c[A],R=s.c[b];E.startLineNumber<R.startLineNumber?(e=E,A++):(e=R,b++)}else A<this.c.length?(e=this.c[A],A++):(e=s.c[b],b++);g===null?g=e:g.endLineNumberExclusive>=e.startLineNumber?g=new N(g.startLineNumber,Math.max(g.endLineNumberExclusive,e.endLineNumberExclusive)):(h.push(g),g=e)}return g!==null&&h.push(g),new f(h)}subtractFrom(s){const h=(0,o.$kb)(this.c,e=>e.endLineNumberExclusive>=s.startLineNumber),A=(0,o.$ib)(this.c,e=>e.startLineNumber<=s.endLineNumberExclusive)+1;if(h===A)return new f([s]);const b=[];let g=s.startLineNumber;for(let e=h;e<A;e++){const E=this.c[e];E.startLineNumber>g&&b.push(new N(g,E.startLineNumber)),g=E.endLineNumberExclusive}return g<s.endLineNumberExclusive&&b.push(new N(g,s.endLineNumberExclusive)),new f(b)}toString(){return this.c.map(s=>s.toString()).join(", ")}getIntersection(s){const h=[];let A=0,b=0;for(;A<this.c.length&&b<s.c.length;){const g=this.c[A],e=s.c[b],E=g.intersect(e);E&&!E.isEmpty&&h.push(E),g.endLineNumberExclusive<e.endLineNumberExclusive?A++:b++}return new f(h)}getWithDelta(s){return new f(this.c.map(h=>h.delta(s)))}}t.$bt=f}),te(ie[43],re([0,1,5,2]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6s=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class o extends y.$4s{constructor(f,a,s,h){super(f,a,s,h),this.selectionStartLineNumber=f,this.selectionStartColumn=a,this.positionLineNumber=s,this.positionColumn=h}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(f){return o.selectionsEqual(this,f)}static selectionsEqual(f,a){return f.selectionStartLineNumber===a.selectionStartLineNumber&&f.selectionStartColumn===a.selectionStartColumn&&f.positionLineNumber===a.positionLineNumber&&f.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(f,a){return this.getDirection()===0?new o(this.startLineNumber,this.startColumn,f,a):new o(f,a,this.startLineNumber,this.startColumn)}getPosition(){return new F.$3s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new F.$3s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(f,a){return this.getDirection()===0?new o(f,a,this.endLineNumber,this.endColumn):new o(this.endLineNumber,this.endColumn,f,a)}static fromPositions(f,a=f){return new o(f.lineNumber,f.column,a.lineNumber,a.column)}static fromRange(f,a){return a===0?new o(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):new o(f.endLineNumber,f.endColumn,f.startLineNumber,f.startColumn)}static liftSelection(f){return new o(f.selectionStartLineNumber,f.selectionStartColumn,f.positionLineNumber,f.positionColumn)}static selectionsArrEqual(f,a){if(f&&!a||!f&&a)return!1;if(!f&&!a)return!0;if(f.length!==a.length)return!1;for(let s=0,h=f.length;s<h;s++)if(!this.selectionsEqual(f[s],a[s]))return!1;return!0}static isISelection(f){return f&&typeof f.selectionStartLineNumber=="number"&&typeof f.selectionStartColumn=="number"&&typeof f.positionLineNumber=="number"&&typeof f.positionColumn=="number"}static createWithDirection(f,a,s,h,A){return A===0?new o(f,a,s,h):new o(s,h,f,a)}}t.$6s=o}),te(ie[44],re([0,1,28]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rt=t.$qt=t.WordCharacterClass=void 0;var y;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(y||(t.WordCharacterClass=y={}));class r extends F.$ot{constructor(f){super(0);for(let a=0,s=f.length;a<s;a++)this.set(f.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$qt=r;function o(N){const f={};return a=>(f.hasOwnProperty(a)||(f[a]=N(a)),f[a])}t.$rt=o(N=>new r(N))}),te(ie[29],re([0,1,20,10,21]),function(W,t,F,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=t.$Fs=t.$Es=t.$Ds=t.$Cs=void 0,t.$Cs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function o(A=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const g of t.$Cs)A.indexOf(g)>=0||(b+="\\"+g);return b+="\\s]+)",new RegExp(b,"g")}t.$Ds=o();function N(A){let b=t.$Ds;if(A&&A instanceof RegExp)if(A.global)b=A;else{let g="g";A.ignoreCase&&(g+="i"),A.multiline&&(g+="m"),A.unicode&&(g+="u"),b=new RegExp(A.source,g)}return b.lastIndex=0,b}t.$Es=N;const f=new r.$4c;f.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(A){const b=f.unshift(A);return(0,y.$Rc)(b)}t.$Fs=a;function s(A,b,g,e,E){if(b=N(b),E||(E=F.Iterable.first(f)),g.length>E.maxLen){let u=A-E.maxLen/2;return u<0?u=0:e+=u,g=g.substring(u,A+E.maxLen/2),s(A,b,g,e,E)}const R=Date.now(),L=A-1-e;let $=-1,m=null;for(let u=1;!(Date.now()-R>=E.timeBudget);u++){const c=L-E.windowSize*u;b.lastIndex=Math.max(0,c);const i=h(b,g,L,$);if(!i&&m||(m=i,c<=0))break;$=c}if(m){const u={word:m[0],startColumn:e+1+m.index,endColumn:e+1+m.index+m[0].length};return b.lastIndex=0,u}return null}t.$Gs=s;function h(A,b,g,e){let E;for(;E=A.exec(b);){const R=E.index||0;if(R<=g&&A.lastIndex>=g)return E;if(e>0&&R>e)return null}return null}}),te(ie[8],re([0,1,6,3,4]),function(W,t,F,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L1=t.$K1=t.$J1=t.$I1=t.$H1=void 0;class o{static trivial(A,b){return new o([new N(r.$$s.ofLength(A.length),r.$$s.ofLength(b.length))],!1)}static trivialTimedOut(A,b){return new o([new N(r.$$s.ofLength(A.length),r.$$s.ofLength(b.length))],!0)}constructor(A,b){this.diffs=A,this.hitTimeout=b}}t.$H1=o;class N{static invert(A,b){const g=[];return(0,F.$Bb)(A,(e,E)=>{g.push(N.fromOffsetPairs(e?e.getEndExclusives():f.zero,E?E.getStarts():new f(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),g}static fromOffsetPairs(A,b){return new N(new r.$$s(A.offset1,b.offset1),new r.$$s(A.offset2,b.offset2))}constructor(A,b){this.seq1Range=A,this.seq2Range=b}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(A){return new N(this.seq1Range.join(A.seq1Range),this.seq2Range.join(A.seq2Range))}delta(A){return A===0?this:new N(this.seq1Range.delta(A),this.seq2Range.delta(A))}deltaStart(A){return A===0?this:new N(this.seq1Range.deltaStart(A),this.seq2Range.deltaStart(A))}deltaEnd(A){return A===0?this:new N(this.seq1Range.deltaEnd(A),this.seq2Range.deltaEnd(A))}intersectsOrTouches(A){return this.seq1Range.intersectsOrTouches(A.seq1Range)||this.seq2Range.intersectsOrTouches(A.seq2Range)}intersect(A){const b=this.seq1Range.intersect(A.seq1Range),g=this.seq2Range.intersect(A.seq2Range);if(!(!b||!g))return new N(b,g)}getStarts(){return new f(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new f(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$I1=N;class f{static{this.zero=new f(0,0)}static{this.max=new f(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(A,b){this.offset1=A,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(A){return A===0?this:new f(this.offset1+A,this.offset2+A)}equals(A){return this.offset1===A.offset1&&this.offset2===A.offset2}}t.$J1=f;class a{static{this.instance=new a}isValid(){return!0}}t.$K1=a;class s{constructor(A){if(this.e=A,this.c=Date.now(),this.d=!0,A<=0)throw new y.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$L1=s}),te(ie[30],re([0,1,4,8]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q1=void 0;class r{compute(s,h,A=y.$K1.instance){if(s.length===0||h.length===0)return y.$H1.trivial(s,h);const b=s,g=h;function e(l,v){for(;l<b.length&&v<g.length&&b.getElement(l)===g.getElement(v);)l++,v++;return l}let E=0;const R=new N;R.set(0,e(0,0));const L=new f;L.set(0,R.get(0)===0?null:new o(null,0,0,R.get(0)));let $=0;e:for(;;){if(E++,!A.isValid())return y.$H1.trivialTimedOut(b,g);const l=-Math.min(E,g.length+E%2),v=Math.min(E,b.length+E%2);for($=l;$<=v;$+=2){let d=0;const w=$===v?-1:R.get($+1),M=$===l?-1:R.get($-1)+1;d++;const p=Math.min(Math.max(w,M),b.length),P=p-$;if(d++,p>b.length||P>g.length)continue;const D=e(p,P);R.set($,D);const k=p===w?L.get($+1):L.get($-1);if(L.set($,D!==p?new o(k,p,P,D-p):k),R.get($)===b.length&&R.get($)-$===g.length)break e}}let m=L.get($);const u=[];let c=b.length,i=g.length;for(;;){const l=m?m.x+m.length:0,v=m?m.y+m.length:0;if((l!==c||v!==i)&&u.push(new y.$I1(new F.$$s(l,c),new F.$$s(v,i))),!m)break;c=m.x,i=m.y,m=m.prev}return u.reverse(),new y.$H1(u,!1)}}t.$Q1=r;class o{constructor(s,h,A,b){this.prev=s,this.x=h,this.y=A,this.length=b}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){if(s<0){if(s=-s-1,s>=this.b.length){const A=this.b;this.b=new Int32Array(A.length*2),this.b.set(A)}this.b[s]=h}else{if(s>=this.a.length){const A=this.a;this.a=new Int32Array(A.length*2),this.a.set(A)}this.a[s]=h}}}class f{constructor(){this.a=[],this.b=[]}get(s){return s<0?(s=-s-1,this.b[s]):this.a[s]}set(s,h){s<0?(s=-s-1,this.b[s]=h):this.a[s]=h}}}),te(ie[45],re([0,1,6,4,8]),function(W,t,F,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Y1=t.$X1=t.$W1=t.$V1=t.$U1=void 0;function o(e,E,R){let L=R;return L=N(e,E,L),L=N(e,E,L),L=f(e,E,L),L}t.$U1=o;function N(e,E,R){if(R.length===0)return R;const L=[];L.push(R[0]);for(let m=1;m<R.length;m++){const u=L[L.length-1];let c=R[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=c.seq1Range.start-u.seq1Range.endExclusive;let l;for(l=1;l<=i&&!(e.getElement(c.seq1Range.start-l)!==e.getElement(c.seq1Range.endExclusive-l)||E.getElement(c.seq2Range.start-l)!==E.getElement(c.seq2Range.endExclusive-l));l++);if(l--,l===i){L[L.length-1]=new r.$I1(new y.$$s(u.seq1Range.start,c.seq1Range.endExclusive-i),new y.$$s(u.seq2Range.start,c.seq2Range.endExclusive-i));continue}c=c.delta(-l)}L.push(c)}const $=[];for(let m=0;m<L.length-1;m++){const u=L[m+1];let c=L[m];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const i=u.seq1Range.start-c.seq1Range.endExclusive;let l;for(l=0;l<i&&!(!e.isStronglyEqual(c.seq1Range.start+l,c.seq1Range.endExclusive+l)||!E.isStronglyEqual(c.seq2Range.start+l,c.seq2Range.endExclusive+l));l++);if(l===i){L[m+1]=new r.$I1(new y.$$s(c.seq1Range.start+i,u.seq1Range.endExclusive),new y.$$s(c.seq2Range.start+i,u.seq2Range.endExclusive));continue}l>0&&(c=c.delta(l))}$.push(c)}return L.length>0&&$.push(L[L.length-1]),$}function f(e,E,R){if(!e.getBoundaryScore||!E.getBoundaryScore)return R;for(let L=0;L<R.length;L++){const $=L>0?R[L-1]:void 0,m=R[L],u=L+1<R.length?R[L+1]:void 0,c=new y.$$s($?$.seq1Range.endExclusive+1:0,u?u.seq1Range.start-1:e.length),i=new y.$$s($?$.seq2Range.endExclusive+1:0,u?u.seq2Range.start-1:E.length);m.seq1Range.isEmpty?R[L]=a(m,e,E,c,i):m.seq2Range.isEmpty&&(R[L]=a(m.swap(),E,e,i,c).swap())}return R}function a(e,E,R,L,$){let u=1;for(;e.seq1Range.start-u>=L.start&&e.seq2Range.start-u>=$.start&&R.isStronglyEqual(e.seq2Range.start-u,e.seq2Range.endExclusive-u)&&u<100;)u++;u--;let c=0;for(;e.seq1Range.start+c<L.endExclusive&&e.seq2Range.endExclusive+c<$.endExclusive&&R.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(u===0&&c===0)return e;let i=0,l=-1;for(let v=-u;v<=c;v++){const d=e.seq2Range.start+v,w=e.seq2Range.endExclusive+v,M=e.seq1Range.start+v,p=E.getBoundaryScore(M)+R.getBoundaryScore(d)+R.getBoundaryScore(w);p>l&&(l=p,i=v)}return e.delta(i)}function s(e,E,R){const L=[];for(const $ of R){const m=L[L.length-1];if(!m){L.push($);continue}$.seq1Range.start-m.seq1Range.endExclusive<=2||$.seq2Range.start-m.seq2Range.endExclusive<=2?L[L.length-1]=new r.$I1(m.seq1Range.join($.seq1Range),m.seq2Range.join($.seq2Range)):L.push($)}return L}t.$V1=s;function h(e,E,R){const L=r.$I1.invert(R,e.length),$=[];let m=new r.$J1(0,0);function u(i,l){if(i.offset1<m.offset1||i.offset2<m.offset2)return;const v=e.findWordContaining(i.offset1),d=E.findWordContaining(i.offset2);if(!v||!d)return;let w=new r.$I1(v,d);const M=w.intersect(l);let p=M.seq1Range.length,P=M.seq2Range.length;for(;L.length>0;){const D=L[0];if(!(D.seq1Range.intersects(v)||D.seq2Range.intersects(d)))break;const T=e.findWordContaining(D.seq1Range.start),_=E.findWordContaining(D.seq2Range.start),q=new r.$I1(T,_),V=q.intersect(D);if(p+=V.seq1Range.length,P+=V.seq2Range.length,w=w.join(q),w.seq1Range.endExclusive>=D.seq1Range.endExclusive)L.shift();else break}p+P<(w.seq1Range.length+w.seq2Range.length)*2/3&&$.push(w),m=w.getEndExclusives()}for(;L.length>0;){const i=L.shift();i.seq1Range.isEmpty||(u(i.getStarts(),i),u(i.getEndExclusives().delta(-1),i))}return A(R,$)}t.$W1=h;function A(e,E){const R=[];for(;e.length>0||E.length>0;){const L=e[0],$=E[0];let m;L&&(!$||L.seq1Range.start<$.seq1Range.start)?m=e.shift():m=E.shift(),R.length>0&&R[R.length-1].seq1Range.endExclusive>=m.seq1Range.start?R[R.length-1]=R[R.length-1].join(m):R.push(m)}return R}function b(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const u=[L[0]];for(let c=1;c<L.length;c++){let v=function(w,M){const p=new y.$$s(l.seq1Range.endExclusive,i.seq1Range.start);return e.getText(p).replace(/\s/g,"").length<=4&&(w.seq1Range.length+w.seq2Range.length>5||M.seq1Range.length+M.seq2Range.length>5)};const i=L[c],l=u[u.length-1];v(l,i)?(m=!0,u[u.length-1]=u[u.length-1].join(i)):u.push(i)}L=u}while($++<10&&m);return L}t.$X1=b;function g(e,E,R){let L=R;if(L.length===0)return L;let $=0,m;do{m=!1;const c=[L[0]];for(let i=1;i<L.length;i++){let d=function(M,p){const P=new y.$$s(v.seq1Range.endExclusive,l.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const k=e.getText(P).trim();if(k.length>20||k.split(/\r\n|\r|\n/).length>1)return!1;const T=e.countLinesIn(M.seq1Range),_=M.seq1Range.length,q=E.countLinesIn(M.seq2Range),V=M.seq2Range.length,z=e.countLinesIn(p.seq1Range),S=p.seq1Range.length,U=E.countLinesIn(p.seq2Range),X=p.seq2Range.length,J=2*40+50;function ee(le){return Math.min(le,J)}return Math.pow(Math.pow(ee(T*40+_),1.5)+Math.pow(ee(q*40+V),1.5),1.5)+Math.pow(Math.pow(ee(z*40+S),1.5)+Math.pow(ee(U*40+X),1.5),1.5)>(J**1.5)**1.5*1.3};const l=L[i],v=c[c.length-1];d(v,l)?(m=!0,c[c.length-1]=c[c.length-1].join(l)):c.push(l)}L=c}while($++<10&&m);const u=[];return(0,F.$Cb)(L,(c,i,l)=>{let v=i;function d(k){return k.length>0&&k.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const w=e.extendToFullLines(i.seq1Range),M=e.getText(new y.$$s(w.start,i.seq1Range.start));d(M)&&(v=v.deltaStart(-M.length));const p=e.getText(new y.$$s(i.seq1Range.endExclusive,w.endExclusive));d(p)&&(v=v.deltaEnd(p.length));const P=r.$I1.fromOffsetPairs(c?c.getEndExclusives():r.$J1.zero,l?l.getStarts():r.$J1.max),D=v.intersect(P);u.length>0&&D.getStarts().equals(u[u.length-1].getEndExclusives())?u[u.length-1]=u[u.length-1].join(D):u.push(D)}),u}t.$Y1=g}),te(ie[46],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T1=void 0;class F{constructor(o,N){this.a=o,this.b=N}getElement(o){return this.a[o]}get length(){return this.a.length}getBoundaryScore(o){const N=o===0?0:y(this.b[o-1]),f=o===this.b.length?0:y(this.b[o]);return 1e3-(N+f)}getText(o){return this.b.slice(o.start,o.endExclusive).join(`
`)}isStronglyEqual(o,N){return this.b[o]===this.b[N]}}t.$T1=F;function y(r){let o=0;for(;o<r.length&&(r.charCodeAt(o)===32||r.charCodeAt(o)===9);)o++;return o}}),te(ie[15],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$O1=t.$N1=t.$M1=void 0;class F{constructor(N,f){this.width=N,this.height=f,this.a=[],this.a=new Array(N*f)}get(N,f){return this.a[N+f*this.width]}set(N,f,a){this.a[N+f*this.width]=a}}t.$M1=F;function y(o){return o===32||o===9}t.$N1=y;class r{static{this.a=new Map}static b(N){let f=this.a.get(N);return f===void 0&&(f=this.a.size,this.a.set(N,f)),f}constructor(N,f,a){this.range=N,this.lines=f,this.source=a,this.d=[];let s=0;for(let h=N.startLineNumber-1;h<N.endLineNumberExclusive-1;h++){const A=f[h];for(let g=0;g<A.length;g++){s++;const e=A[g],E=r.b(e);this.d[E]=(this.d[E]||0)+1}s++;const b=r.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=s}computeSimilarity(N){let f=0;const a=Math.max(this.d.length,N.d.length);for(let s=0;s<a;s++)f+=Math.abs((this.d[s]??0)-(N.d[s]??0));return 1-f/(this.c+N.c)}}t.$O1=r}),te(ie[47],re([0,1,4,8,15]),function(W,t,F,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$P1=void 0;class o{compute(f,a,s=y.$K1.instance,h){if(f.length===0||a.length===0)return y.$H1.trivial(f,a);const A=new r.$M1(f.length,a.length),b=new r.$M1(f.length,a.length),g=new r.$M1(f.length,a.length);for(let u=0;u<f.length;u++)for(let c=0;c<a.length;c++){if(!s.isValid())return y.$H1.trivialTimedOut(f,a);const i=u===0?0:A.get(u-1,c),l=c===0?0:A.get(u,c-1);let v;f.getElement(u)===a.getElement(c)?(u===0||c===0?v=0:v=A.get(u-1,c-1),u>0&&c>0&&b.get(u-1,c-1)===3&&(v+=g.get(u-1,c-1)),v+=h?h(u,c):1):v=-1;const d=Math.max(i,l,v);if(d===v){const w=u>0&&c>0?g.get(u-1,c-1):0;g.set(u,c,w+1),b.set(u,c,3)}else d===i?(g.set(u,c,0),b.set(u,c,1)):d===l&&(g.set(u,c,0),b.set(u,c,2));A.set(u,c,d)}const e=[];let E=f.length,R=a.length;function L(u,c){(u+1!==E||c+1!==R)&&e.push(new y.$I1(new F.$$s(u+1,E),new F.$$s(c+1,R))),E=u,R=c}let $=f.length-1,m=a.length-1;for(;$>=0&&m>=0;)b.get($,m)===3?(L($,m),$--,m--):b.get($,m)===1?$--:m--;return L(-1,-1),e.reverse(),new y.$H1(e,!1)}}t.$P1=o}),te(ie[31],re([0,1,9,4,5,2,15]),function(W,t,F,y,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R1=void 0;class f{constructor(e,E,R){this.lines=e,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let L=!1;E.start>0&&E.endExclusive>=e.length&&(E=new y.$$s(E.start-1,E.endExclusive),L=!0),this.lineRange=E,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let m=e[$],u=0;if(L)u=m.length,m="",L=!1;else if(!R){const c=m.trimStart();u=m.length-c.length,m=c.trimEnd()}this.d.push(u);for(let c=0;c<m.length;c++)this.b.push(m.charCodeAt(c));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new y.$$s(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(E=>String.fromCharCode(E)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const E=b(e>0?this.b[e-1]:-1),R=b(e<this.b.length?this.b[e]:-1);if(E===7&&R===8)return 0;if(E===8)return 150;let L=0;return E!==R&&(L+=10,E===0&&R===1&&(L+=1)),L+=A(E),L+=A(R),L}translateOffset(e){if(this.lineRange.isEmpty)return new r.$3s(this.lineRange.start+1,1);const E=(0,F.$ib)(this.c,R=>R<=e);return new r.$3s(this.lineRange.start+E+1,e-this.c[E]+this.d[E]+1)}translateRange(e){return o.$4s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let E=e;for(;E>0&&a(this.b[E-1]);)E--;let R=e;for(;R<this.b.length&&a(this.b[R]);)R++;return new y.$$s(E,R)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,E){return this.b[e]===this.b[E]}extendToFullLines(e){const E=(0,F.$hb)(this.c,L=>L<=e.start)??0,R=(0,F.$jb)(this.c,L=>e.endExclusive<=L)??this.b.length;return new y.$$s(E,R)}}t.$R1=f;function a(g){return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57}var s;(function(g){g[g.WordLower=0]="WordLower",g[g.WordUpper=1]="WordUpper",g[g.WordNumber=2]="WordNumber",g[g.End=3]="End",g[g.Other=4]="Other",g[g.Separator=5]="Separator",g[g.Space=6]="Space",g[g.LineBreakCR=7]="LineBreakCR",g[g.LineBreakLF=8]="LineBreakLF"})(s||(s={}));const h={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function A(g){return h[g]}function b(g){return g===10?8:g===13?7:(0,N.$N1)(g)?6:g>=97&&g<=122?0:g>=65&&g<=90?1:g>=48&&g<=57?2:g===-1?3:g===44||g===59?5:4}}),te(ie[32],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gt=t.$ft=void 0;class F{constructor(o,N,f){this.changes=o,this.moves=N,this.hitTimeout=f}}t.$ft=F;class y{constructor(o,N){this.lineRangeMapping=o,this.changes=N}flip(){return new y(this.lineRangeMapping.flip(),this.changes.map(o=>o.flip()))}}t.$gt=y}),te(ie[16],re([0,1,12]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$et=t.$dt=t.$ct=void 0;class y{static inverse(f,a,s){const h=[];let A=1,b=1;for(const e of f){const E=new y(new F.$at(A,e.original.startLineNumber),new F.$at(b,e.modified.startLineNumber));E.modified.isEmpty||h.push(E),A=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const g=new y(new F.$at(A,a+1),new F.$at(b,s+1));return g.modified.isEmpty||h.push(g),h}static clip(f,a,s){const h=[];for(const A of f){const b=A.original.intersect(a),g=A.modified.intersect(s);b&&!b.isEmpty&&g&&!g.isEmpty&&h.push(new y(b,g))}return h}constructor(f,a){this.original=f,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new y(this.modified,this.original)}join(f){return new y(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$ct=y;class r extends y{constructor(f,a,s){super(f,a),this.innerChanges=s}flip(){return new r(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}}t.$dt=r;class o{constructor(f,a){this.originalRange=f,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new o(this.modifiedRange,this.originalRange)}}t.$et=o}),te(ie[48],re([0,1,8,16,6,9,22,12,4,31,15,30]),function(W,t,F,y,r,o,N,f,a,s,h,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S1=void 0;function b(m,u,c,i,l,v){let{moves:d,excludedChanges:w}=e(m,u,c,v);if(!v.isValid())return[];const M=m.filter(P=>!w.has(P)),p=E(M,i,l,u,c,v);return(0,r.$1b)(d,p),d=L(d),d=d.filter(P=>{const D=P.original.toOffsetRange().slice(u).map(T=>T.trim());return D.join(`
`).length>=15&&g(D,T=>T.length>=2)>=2}),d=$(m,d),d}t.$S1=b;function g(m,u){let c=0;for(const i of m)u(i)&&c++;return c}function e(m,u,c,i){const l=[],v=m.filter(M=>M.modified.isEmpty&&M.original.length>=3).map(M=>new h.$O1(M.original,u,M)),d=new Set(m.filter(M=>M.original.isEmpty&&M.modified.length>=3).map(M=>new h.$O1(M.modified,c,M))),w=new Set;for(const M of v){let p=-1,P;for(const D of d){const k=M.computeSimilarity(D);k>p&&(p=k,P=D)}if(p>.9&&P&&(d.delete(P),l.push(new y.$ct(M.range,P.range)),w.add(M.source),w.add(P.source)),!i.isValid())return{moves:l,excludedChanges:w}}return{moves:l,excludedChanges:w}}function E(m,u,c,i,l,v){const d=[],w=new N.$Gc;for(const k of m)for(let T=k.original.startLineNumber;T<k.original.endLineNumberExclusive-2;T++){const _=`${u[T-1]}:${u[T+1-1]}:${u[T+2-1]}`;w.add(_,{range:new f.$at(T,T+3)})}const M=[];m.sort((0,r.$7b)(k=>k.modified.startLineNumber,r.$9b));for(const k of m){let T=[];for(let _=k.modified.startLineNumber;_<k.modified.endLineNumberExclusive-2;_++){const q=`${c[_-1]}:${c[_+1-1]}:${c[_+2-1]}`,V=new f.$at(_,_+3),z=[];w.forEach(q,({range:S})=>{for(const X of T)if(X.originalLineRange.endLineNumberExclusive+1===S.endLineNumberExclusive&&X.modifiedLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive){X.originalLineRange=new f.$at(X.originalLineRange.startLineNumber,S.endLineNumberExclusive),X.modifiedLineRange=new f.$at(X.modifiedLineRange.startLineNumber,V.endLineNumberExclusive),z.push(X);return}const U={modifiedLineRange:V,originalLineRange:S};M.push(U),z.push(U)}),T=z}if(!v.isValid())return[]}M.sort((0,r.$$b)((0,r.$7b)(k=>k.modifiedLineRange.length,r.$9b)));const p=new f.$bt,P=new f.$bt;for(const k of M){const T=k.modifiedLineRange.startLineNumber-k.originalLineRange.startLineNumber,_=p.subtractFrom(k.modifiedLineRange),q=P.subtractFrom(k.originalLineRange).getWithDelta(T),V=_.getIntersection(q);for(const z of V.ranges){if(z.length<3)continue;const S=z,U=z.delta(-T);d.push(new y.$ct(U,S)),p.addRange(S),P.addRange(U)}}d.sort((0,r.$7b)(k=>k.original.startLineNumber,r.$9b));const D=new o.$mb(m);for(let k=0;k<d.length;k++){const T=d[k],_=D.findLastMonotonous(ee=>ee.original.startLineNumber<=T.original.startLineNumber),q=(0,o.$hb)(m,ee=>ee.modified.startLineNumber<=T.modified.startLineNumber),V=Math.max(T.original.startLineNumber-_.original.startLineNumber,T.modified.startLineNumber-q.modified.startLineNumber),z=D.findLastMonotonous(ee=>ee.original.startLineNumber<T.original.endLineNumberExclusive),S=(0,o.$hb)(m,ee=>ee.modified.startLineNumber<T.modified.endLineNumberExclusive),U=Math.max(z.original.endLineNumberExclusive-T.original.endLineNumberExclusive,S.modified.endLineNumberExclusive-T.modified.endLineNumberExclusive);let X;for(X=0;X<V;X++){const ee=T.original.startLineNumber-X-1,le=T.modified.startLineNumber-X-1;if(ee>i.length||le>l.length||p.contains(le)||P.contains(ee)||!R(i[ee-1],l[le-1],v))break}X>0&&(P.addRange(new f.$at(T.original.startLineNumber-X,T.original.startLineNumber)),p.addRange(new f.$at(T.modified.startLineNumber-X,T.modified.startLineNumber)));let J;for(J=0;J<U;J++){const ee=T.original.endLineNumberExclusive+J,le=T.modified.endLineNumberExclusive+J;if(ee>i.length||le>l.length||p.contains(le)||P.contains(ee)||!R(i[ee-1],l[le-1],v))break}J>0&&(P.addRange(new f.$at(T.original.endLineNumberExclusive,T.original.endLineNumberExclusive+J)),p.addRange(new f.$at(T.modified.endLineNumberExclusive,T.modified.endLineNumberExclusive+J))),(X>0||J>0)&&(d[k]=new y.$ct(new f.$at(T.original.startLineNumber-X,T.original.endLineNumberExclusive+J),new f.$at(T.modified.startLineNumber-X,T.modified.endLineNumberExclusive+J)))}return d}function R(m,u,c){if(m.trim()===u.trim())return!0;if(m.length>300&&u.length>300)return!1;const l=new A.$Q1().compute(new s.$R1([m],new a.$$s(0,1),!1),new s.$R1([u],new a.$$s(0,1),!1),c);let v=0;const d=F.$I1.invert(l.diffs,m.length);for(const P of d)P.seq1Range.forEach(D=>{(0,h.$N1)(m.charCodeAt(D))||v++});function w(P){let D=0;for(let k=0;k<m.length;k++)(0,h.$N1)(P.charCodeAt(k))||D++;return D}const M=w(m.length>u.length?m:u);return v/M>.6&&M>10}function L(m){if(m.length===0)return m;m.sort((0,r.$7b)(c=>c.original.startLineNumber,r.$9b));const u=[m[0]];for(let c=1;c<m.length;c++){const i=u[u.length-1],l=m[c],v=l.original.startLineNumber-i.original.endLineNumberExclusive,d=l.modified.startLineNumber-i.modified.endLineNumberExclusive;if(v>=0&&d>=0&&v+d<=2){u[u.length-1]=i.join(l);continue}u.push(l)}return u}function $(m,u){const c=new o.$mb(m);return u=u.filter(i=>{const l=c.findLastMonotonous(w=>w.original.startLineNumber<i.original.endLineNumberExclusive)||new y.$ct(new f.$at(1,1),new f.$at(1,1)),v=(0,o.$hb)(m,w=>w.modified.startLineNumber<i.modified.endLineNumberExclusive);return l!==v}),u}}),te(ie[49],re([0,1,6,13,12,4,2,8,47,30,48,45,32,16,31,46]),function(W,t,F,y,r,o,N,f,a,s,h,A,b,g,e,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$21=t.$11=t.$Z1=void 0;class R{constructor(){this.e=new a.$P1,this.f=new s.$Q1}computeDiff(u,c,i){if(u.length<=1&&(0,F.$ub)(u,c,(J,ee)=>J===ee))return new b.$ft([],[],!1);if(u.length===1&&u[0].length===0||c.length===1&&c[0].length===0)return new b.$ft([new g.$dt(new r.$at(1,u.length+1),new r.$at(1,c.length+1),[new g.$et(new N.$4s(1,1,u.length,u[0].length+1),new N.$4s(1,1,c.length,c[0].length+1))])],[],!1);const l=i.maxComputationTimeMs===0?f.$K1.instance:new f.$L1(i.maxComputationTimeMs),v=!i.ignoreTrimWhitespace,d=new Map;function w(J){let ee=d.get(J);return ee===void 0&&(ee=d.size,d.set(J,ee)),ee}const M=u.map(J=>w(J.trim())),p=c.map(J=>w(J.trim())),P=new E.$T1(M,u),D=new E.$T1(p,c),k=P.length+D.length<1700?this.e.compute(P,D,l,(J,ee)=>u[J]===c[ee]?c[ee].length===0?.1:1+Math.log(1+c[ee].length):.99):this.f.compute(P,D);let T=k.diffs,_=k.hitTimeout;T=(0,A.$U1)(P,D,T),T=(0,A.$X1)(P,D,T);const q=[],V=J=>{if(v)for(let ee=0;ee<J;ee++){const le=z+ee,n=S+ee;if(u[le]!==c[n]){const oe=this.j(u,c,new f.$I1(new o.$$s(le,le+1),new o.$$s(n,n+1)),l,v);for(const me of oe.mappings)q.push(me);oe.hitTimeout&&(_=!0)}}};let z=0,S=0;for(const J of T){(0,y.$_c)(()=>J.seq1Range.start-z===J.seq2Range.start-S);const ee=J.seq1Range.start-z;V(ee),z=J.seq1Range.endExclusive,S=J.seq2Range.endExclusive;const le=this.j(u,c,J,l,v);le.hitTimeout&&(_=!0);for(const n of le.mappings)q.push(n)}V(u.length-z);const U=L(q,u,c);let X=[];return i.computeMoves&&(X=this.h(U,u,c,M,p,l,v)),(0,y.$_c)(()=>{function J(le,n){if(le.lineNumber<1||le.lineNumber>n.length)return!1;const oe=n[le.lineNumber-1];return!(le.column<1||le.column>oe.length+1)}function ee(le,n){return!(le.startLineNumber<1||le.startLineNumber>n.length+1||le.endLineNumberExclusive<1||le.endLineNumberExclusive>n.length+1)}for(const le of U){if(!le.innerChanges)return!1;for(const n of le.innerChanges)if(!(J(n.modifiedRange.getStartPosition(),c)&&J(n.modifiedRange.getEndPosition(),c)&&J(n.originalRange.getStartPosition(),u)&&J(n.originalRange.getEndPosition(),u)))return!1;if(!ee(le.modified,c)||!ee(le.original,u))return!1}return!0}),new b.$ft(U,X,_)}h(u,c,i,l,v,d,w){return(0,h.$S1)(u,c,i,l,v,d).map(P=>{const D=this.j(c,i,new f.$I1(P.original.toOffsetRange(),P.modified.toOffsetRange()),d,w),k=L(D.mappings,c,i,!0);return new b.$gt(P,k)})}j(u,c,i,l,v){const d=new e.$R1(u,i.seq1Range,v),w=new e.$R1(c,i.seq2Range,v),M=d.length+w.length<500?this.e.compute(d,w,l):this.f.compute(d,w,l);let p=M.diffs;return p=(0,A.$U1)(d,w,p),p=(0,A.$W1)(d,w,p),p=(0,A.$V1)(d,w,p),p=(0,A.$Y1)(d,w,p),{mappings:p.map(D=>new g.$et(d.translateRange(D.seq1Range),w.translateRange(D.seq2Range))),hitTimeout:M.hitTimeout}}}t.$Z1=R;function L(m,u,c,i=!1){const l=[];for(const v of(0,F.$Ab)(m.map(d=>$(d,u,c)),(d,w)=>d.original.overlapOrTouch(w.original)||d.modified.overlapOrTouch(w.modified))){const d=v[0],w=v[v.length-1];l.push(new g.$dt(d.original.join(w.original),d.modified.join(w.modified),v.map(M=>M.innerChanges[0])))}return(0,y.$_c)(()=>!i&&l.length>0&&l[0].original.startLineNumber!==l[0].modified.startLineNumber?!1:(0,y.$ad)(l,(v,d)=>d.original.startLineNumber-v.original.endLineNumberExclusive===d.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<d.original.startLineNumber&&v.modified.endLineNumberExclusive<d.modified.startLineNumber)),l}t.$11=L;function $(m,u,c){let i=0,l=0;m.modifiedRange.endColumn===1&&m.originalRange.endColumn===1&&m.originalRange.startLineNumber+i<=m.originalRange.endLineNumber&&m.modifiedRange.startLineNumber+i<=m.modifiedRange.endLineNumber&&(l=-1),m.modifiedRange.startColumn-1>=c[m.modifiedRange.startLineNumber-1].length&&m.originalRange.startColumn-1>=u[m.originalRange.startLineNumber-1].length&&m.originalRange.startLineNumber<=m.originalRange.endLineNumber+l&&m.modifiedRange.startLineNumber<=m.modifiedRange.endLineNumber+l&&(i=1);const v=new r.$at(m.originalRange.startLineNumber+i,m.originalRange.endLineNumber+1+l),d=new r.$at(m.modifiedRange.startLineNumber+i,m.modifiedRange.endLineNumber+1+l);return new g.$dt(v,d,[m])}t.$21=$}),te(ie[33],re([0,1,25,32,16,7,2,13,12]),function(W,t,F,y,r,o,N,f,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$it=t.$ht=void 0;const s=3;class h{computeDiff(i,l,v){const w=new L(i,l,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),M=[];let p=null;for(const P of w.changes){let D;P.originalEndLineNumber===0?D=new a.$at(P.originalStartLineNumber+1,P.originalStartLineNumber+1):D=new a.$at(P.originalStartLineNumber,P.originalEndLineNumber+1);let k;P.modifiedEndLineNumber===0?k=new a.$at(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):k=new a.$at(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let T=new r.$dt(D,k,P.charChanges?.map(_=>new r.$et(new N.$4s(_.originalStartLineNumber,_.originalStartColumn,_.originalEndLineNumber,_.originalEndColumn),new N.$4s(_.modifiedStartLineNumber,_.modifiedStartColumn,_.modifiedEndLineNumber,_.modifiedEndColumn))));p&&(p.modified.endLineNumberExclusive===T.modified.startLineNumber||p.original.endLineNumberExclusive===T.original.startLineNumber)&&(T=new r.$dt(p.original.join(T.original),p.modified.join(T.modified),p.innerChanges&&T.innerChanges?p.innerChanges.concat(T.innerChanges):void 0),M.pop()),M.push(T),p=T}return(0,f.$_c)(()=>(0,f.$ad)(M,(P,D)=>D.original.startLineNumber-P.original.endLineNumberExclusive===D.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<D.original.startLineNumber&&P.modified.endLineNumberExclusive<D.modified.startLineNumber)),new y.$ft(M,[],w.quitEarly)}}t.$ht=h;function A(c,i,l,v){return new F.$0s(c,i,l).ComputeDiff(v)}class b{constructor(i){const l=[],v=[];for(let d=0,w=i.length;d<w;d++)l[d]=$(i[d],1),v[d]=m(i[d],1);this.lines=i,this.a=l,this.b=v}getElements(){const i=[];for(let l=0,v=this.lines.length;l<v;l++)i[l]=this.lines[l].substring(this.a[l]-1,this.b[l]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,l,v){const d=[],w=[],M=[];let p=0;for(let P=l;P<=v;P++){const D=this.lines[P],k=i?this.a[P]:1,T=i?this.b[P]:D.length+1;for(let _=k;_<T;_++)d[p]=D.charCodeAt(_-1),w[p]=P+1,M[p]=_,p++;!i&&P<v&&(d[p]=10,w[p]=P+1,M[p]=D.length+1,p++)}return new g(d,w,M)}}class g{constructor(i,l,v){this.a=i,this.b=l,this.d=v}toString(){return"["+this.a.map((i,l)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[l]},${this.d[l]})`).join(", ")+"]"}e(i,l){if(i<0||i>=l.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,l,v,d,w,M,p,P){this.originalStartLineNumber=i,this.originalStartColumn=l,this.originalEndLineNumber=v,this.originalEndColumn=d,this.modifiedStartLineNumber=w,this.modifiedStartColumn=M,this.modifiedEndLineNumber=p,this.modifiedEndColumn=P}static createFromDiffChange(i,l,v){const d=l.getStartLineNumber(i.originalStart),w=l.getStartColumn(i.originalStart),M=l.getEndLineNumber(i.originalStart+i.originalLength-1),p=l.getEndColumn(i.originalStart+i.originalLength-1),P=v.getStartLineNumber(i.modifiedStart),D=v.getStartColumn(i.modifiedStart),k=v.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),T=v.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,w,M,p,P,D,k,T)}}function E(c){if(c.length<=1)return c;const i=[c[0]];let l=i[0];for(let v=1,d=c.length;v<d;v++){const w=c[v],M=w.originalStart-(l.originalStart+l.originalLength),p=w.modifiedStart-(l.modifiedStart+l.modifiedLength);Math.min(M,p)<s?(l.originalLength=w.originalStart+w.originalLength-l.originalStart,l.modifiedLength=w.modifiedStart+w.modifiedLength-l.modifiedStart):(i.push(w),l=w)}return i}class R{constructor(i,l,v,d,w){this.originalStartLineNumber=i,this.originalEndLineNumber=l,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=d,this.charChanges=w}static createFromDiffResult(i,l,v,d,w,M,p){let P,D,k,T,_;if(l.originalLength===0?(P=v.getStartLineNumber(l.originalStart)-1,D=0):(P=v.getStartLineNumber(l.originalStart),D=v.getEndLineNumber(l.originalStart+l.originalLength-1)),l.modifiedLength===0?(k=d.getStartLineNumber(l.modifiedStart)-1,T=0):(k=d.getStartLineNumber(l.modifiedStart),T=d.getEndLineNumber(l.modifiedStart+l.modifiedLength-1)),M&&l.originalLength>0&&l.originalLength<20&&l.modifiedLength>0&&l.modifiedLength<20&&w()){const q=v.createCharSequence(i,l.originalStart,l.originalStart+l.originalLength-1),V=d.createCharSequence(i,l.modifiedStart,l.modifiedStart+l.modifiedLength-1);if(q.getElements().length>0&&V.getElements().length>0){let z=A(q,V,w,!0).changes;p&&(z=E(z)),_=[];for(let S=0,U=z.length;S<U;S++)_.push(e.createFromDiffChange(z[S],q,V))}}return new R(P,D,k,T,_)}}class L{constructor(i,l,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=i,this.g=l,this.h=new b(i),this.j=new b(l),this.k=u(v.maxComputationTime),this.l=u(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=A(this.h,this.j,this.k,this.e),l=i.changes,v=i.quitEarly;if(this.d){const p=[];for(let P=0,D=l.length;P<D;P++)p.push(R.createFromDiffResult(this.d,l[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:p}}const d=[];let w=0,M=0;for(let p=-1,P=l.length;p<P;p++){const D=p+1<P?l[p+1]:null,k=D?D.originalStart:this.f.length,T=D?D.modifiedStart:this.g.length;for(;w<k&&M<T;){const _=this.f[w],q=this.g[M];if(_!==q){{let V=$(_,1),z=$(q,1);for(;V>1&&z>1;){const S=_.charCodeAt(V-2),U=q.charCodeAt(z-2);if(S!==U)break;V--,z--}(V>1||z>1)&&this.m(d,w+1,1,V,M+1,1,z)}{let V=m(_,1),z=m(q,1);const S=_.length+1,U=q.length+1;for(;V<S&&z<U;){const X=_.charCodeAt(V-1),J=_.charCodeAt(z-1);if(X!==J)break;V++,z++}(V<S||z<U)&&this.m(d,w+1,V,S,M+1,z,U)}}w++,M++}D&&(d.push(R.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),w+=D.originalLength,M+=D.modifiedLength)}return{quitEarly:v,changes:d}}m(i,l,v,d,w,M,p){if(this.n(i,l,v,d,w,M,p))return;let P;this.a&&(P=[new e(l,v,l,d,w,M,w,p)]),i.push(new R(l,l,w,w,P))}n(i,l,v,d,w,M,p){const P=i.length;if(P===0)return!1;const D=i[P-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===l&&D.modifiedEndLineNumber===w?(this.a&&D.charChanges&&D.charChanges.push(new e(l,v,l,d,w,M,w,p)),!0):D.originalEndLineNumber+1===l&&D.modifiedEndLineNumber+1===w?(D.originalEndLineNumber=l,D.modifiedEndLineNumber=w,this.a&&D.charChanges&&D.charChanges.push(new e(l,v,l,d,w,M,w,p)),!0):!1}}t.$it=L;function $(c,i){const l=o.$9e(c);return l===-1?i:l+1}function m(c,i){const l=o.$$e(c);return l===-1?i:l+2}function u(c){if(c===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<c}}),te(ie[50],re([0,1,33,49]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$31=void 0,t.$31={getLegacy:()=>new F.$ht,getDefault:()=>new y.$Z1}}),te(ie[51],re([0,1,35]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$41=void 0;function y(b){const g=[];for(const e of b){const E=Number(e);(E||E===0&&e.replace(/\s/g,"")!=="")&&g.push(E)}return g}function r(b,g,e,E){return{red:b/255,blue:e/255,green:g/255,alpha:E}}function o(b,g){const e=g.index,E=g[0].length;if(!e)return;const R=b.positionAt(e);return{startLineNumber:R.lineNumber,startColumn:R.column,endLineNumber:R.lineNumber,endColumn:R.column+E}}function N(b,g){if(!b)return;const e=F.$vt.Format.CSS.parseHex(g);if(e)return{range:b,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function f(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=y(R);return{range:b,color:r(L[0],L[1],L[2],e?L[3]:1)}}function a(b,g,e){if(!b||g.length!==1)return;const R=g[0].values(),L=y(R),$=new F.$vt(new F.$tt(L[0],L[1]/100,L[2]/100,e?L[3]:1));return{range:b,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function s(b,g){return typeof b=="string"?[...b.matchAll(g)]:b.findMatches(g)}function h(b){const g=[],E=s(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(E.length>0)for(const R of E){const L=R.filter(c=>c!==void 0),$=L[1],m=L[2];if(!m)continue;let u;if($==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;u=f(o(b,R),s(m,c),!1)}else if($==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=f(o(b,R),s(m,c),!0)}else if($==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;u=a(o(b,R),s(m,c),!1)}else if($==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;u=a(o(b,R),s(m,c),!0)}else $==="#"&&(u=N(o(b,R),$+m));u&&g.push(u)}return g}function A(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:h(b)}t.$41=A}),te(ie[52],re([0,1,28]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$D1=t.$C1=t.$B1=t.State=void 0;var y;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(y||(t.State=y={}));class r{constructor(e,E,R){const L=new Uint8Array(e*E);for(let $=0,m=e*E;$<m;$++)L[$]=R;this.a=L,this.rows=e,this.cols=E}get(e,E){return this.a[e*this.cols+E]}set(e,E,R){this.a[e*this.cols+E]=R}}class o{constructor(e){let E=0,R=0;for(let $=0,m=e.length;$<m;$++){const[u,c,i]=e[$];c>E&&(E=c),u>R&&(R=u),i>R&&(R=i)}E++,R++;const L=new r(R,E,0);for(let $=0,m=e.length;$<m;$++){const[u,c,i]=e[$];L.set(u,c,i)}this.a=L,this.b=E}nextState(e,E){return E<0||E>=this.b?0:this.a.get(e,E)}}t.$B1=o;let N=null;function f(){return N===null&&(N=new o([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let s=null;function h(){if(s===null){s=new F.$ot(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<g.length;E++)s.set(g.charCodeAt(E),1);const e=".,;:";for(let E=0;E<e.length;E++)s.set(e.charCodeAt(E),2)}return s}class A{static a(e,E,R,L,$){let m=$-1;do{const u=E.charCodeAt(m);if(e.get(u)!==2)break;m--}while(m>L);if(L>0){const u=E.charCodeAt(L-1),c=E.charCodeAt(m);(u===40&&c===41||u===91&&c===93||u===123&&c===125)&&m--}return{range:{startLineNumber:R,startColumn:L+1,endLineNumber:R,endColumn:m+2},url:E.substring(L,m+1)}}static computeLinks(e,E=f()){const R=h(),L=[];for(let $=1,m=e.getLineCount();$<=m;$++){const u=e.getLineContent($),c=u.length;let i=0,l=0,v=0,d=1,w=!1,M=!1,p=!1,P=!1;for(;i<c;){let D=!1;const k=u.charCodeAt(i);if(d===13){let T;switch(k){case 40:w=!0,T=0;break;case 41:T=w?0:1;break;case 91:p=!0,M=!0,T=0;break;case 93:p=!1,T=M?0:1;break;case 123:P=!0,T=0;break;case 125:T=P?0:1;break;case 39:case 34:case 96:v===k?T=1:v===39||v===34||v===96?T=0:T=1;break;case 42:T=v===42?1:0;break;case 124:T=v===124?1:0;break;case 32:T=p?0:1;break;default:T=R.get(k)}T===1&&(L.push(A.a(R,u,$,l,i)),D=!0)}else if(d===12){let T;k===91?(M=!0,T=0):T=R.get(k),T===1?D=!0:d=13}else d=E.nextState(d,k),d===0&&(D=!0);D&&(d=1,w=!1,M=!1,P=!1,l=i+1,v=k),i++}d===13&&L.push(A.a(R,u,$,l,c))}return L}}t.$C1=A;function b(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:A.computeLinks(g)}t.$D1=b}),te(ie[53],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$E1=void 0;class F{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new F}navigateValueSet(r,o,N,f,a){if(r&&o){const s=this.a(o,a);if(s)return{range:r,value:s}}if(N&&f){const s=this.a(f,a);if(s)return{range:N,value:s}}return null}a(r,o){const N=this.b(r,o);return N!==null?N:this.d(r,o)}b(r,o){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let f=Number(r);const a=parseFloat(r);return!isNaN(f)&&!isNaN(a)&&f===a?f===0&&!o?null:(f=Math.floor(f*N),f+=o?N:-N,String(f/N)):null}d(r,o){return this.e(this.c,r,o)}e(r,o,N){let f=null;for(let a=0,s=r.length;f===null&&a<s;a++)f=this.f(r[a],o,N);return f}f(r,o,N){let f=r.indexOf(o);return f>=0?(f+=N?1:-1,f<0?f=r.length-1:f%=r.length,r[f]):null}}t.$E1=F}),te(ie[54],re([0,1,14]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ov=t.$nv=t.$mv=t.$lv=t.ModelConstants=t.PositionAffinity=t.$kv=t.TrackedRangeStickiness=t.$jv=t.$iv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var y;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=4]="Right",u[u.Full=7]="Full"})(y||(t.OverviewRulerLane=y={}));var r;(function(u){u[u.Left=1]="Left",u[u.Center=2]="Center",u[u.Right=3]="Right"})(r||(t.GlyphMarginLane=r={}));var o;(function(u){u[u.Inline=1]="Inline",u[u.Gutter=2]="Gutter"})(o||(t.MinimapPosition=o={}));var N;(function(u){u[u.Both=0]="Both",u[u.Right=1]="Right",u[u.Left=2]="Left",u[u.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var f;(function(u){u[u.TextDefined=0]="TextDefined",u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(f||(t.EndOfLinePreference=f={}));var a;(function(u){u[u.LF=1]="LF",u[u.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var s;(function(u){u[u.LF=0]="LF",u[u.CRLF=1]="CRLF"})(s||(t.EndOfLineSequence=s={}));class h{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,F.$Jn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}t.$iv=h;class A{constructor(c,i){this._findMatchBrand=void 0,this.range=c,this.matches=i}}t.$jv=A;var b;(function(u){u[u.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",u[u.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",u[u.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",u[u.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function g(u){return u&&typeof u.read=="function"}t.$kv=g;var e;(function(u){u[u.Left=0]="Left",u[u.Right=1]="Right",u[u.None=2]="None",u[u.LeftOfInjectedText=3]="LeftOfInjectedText",u[u.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var E;(function(u){u[u.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(t.ModelConstants=E={}));class R{constructor(c,i,l,v,d,w){this.identifier=c,this.range=i,this.text=l,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=d,this._isTracked=w}}t.$lv=R;class L{constructor(c,i,l){this.regex=c,this.wordSeparators=i,this.simpleSearch=l}}t.$mv=L;class ${constructor(c,i,l){this.reverseEdits=c,this.changes=i,this.trimAutoWhitespaceLineNumbers=l}}t.$nv=$;function m(u){return!u.isTooLargeForSyncing()&&!u.isForSimpleWidget}t.$ov=m}),te(ie[55],re([0,1,6,27]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tv=t.$sv=t.$rv=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,s){a=(0,y.$Pe)(a);const h=this.a,A=this.b,b=s.length;return b===0?!1:(this.a=new Uint32Array(h.length+b),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a),a+b),this.a.set(s,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}setValue(a,s){return a=(0,y.$Pe)(a),s=(0,y.$Pe)(s),this.a[a]===s?!1:(this.a[a]=s,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,s){a=(0,y.$Pe)(a),s=(0,y.$Pe)(s);const h=this.a,A=this.b;if(a>=h.length)return!1;const b=h.length-a;return s>=b&&(s=b),s===0?!1:(this.a=new Uint32Array(h.length-s),this.a.set(h.subarray(0,a),0),this.a.set(h.subarray(a+s),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(A.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,y.$Pe)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let s=this.c[0]+1;s===0&&(this.b[0]=this.a[0],s++),a>=this.a.length&&(a=this.a.length-1);for(let h=s;h<=a;h++)this.b[h]=this.b[h-1]+this.a[h];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,h=this.a.length-1,A=0,b=0,g=0;for(;s<=h;)if(A=s+(h-s)/2|0,b=this.b[A],g=b-this.a[A],a<g)h=A-1;else if(a>=b)s=A+1;else break;return new N(A,a-g)}}t.$rv=r;class o{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const s=this.e[a],h=s>0?this.d[s-1]:0;return new N(s,a-h)}removeValues(a,s){this.a.splice(a,s),this.f(a)}insertValues(a,s){this.a=(0,F.$Wb)(this.a,a,s),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,s=this.a.length;a<s;a++){const h=this.a[a],A=a>0?this.d[a-1]:0;this.d[a]=A+h;for(let b=0;b<h;b++)this.e[A+b]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,s){this.a[a]!==s&&(this.a[a]=s,this.f(a))}}t.$sv=o;class N{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}t.$tv=N}),te(ie[56],re([0,1,7,5,55]),function(W,t,F,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uv=void 0;class o{constructor(f,a,s,h){this.d=f,this.f=a,this.g=s,this.h=h,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(f){f.eol&&f.eol!==this.g&&(this.g=f.eol,this.j=null);const a=f.changes;for(const s of a)this.o(s.range),this.p(new y.$3s(s.range.startLineNumber,s.range.startColumn),s.text);this.h=f.versionId,this.k=null}l(){if(!this.j){const f=this.g.length,a=this.f.length,s=new Uint32Array(a);for(let h=0;h<a;h++)s[h]=this.f[h].length+f;this.j=new r.$rv(s)}}n(f,a){this.f[f]=a,this.j&&this.j.setValue(f,this.f[f].length+this.g.length)}o(f){if(f.startLineNumber===f.endLineNumber){if(f.startColumn===f.endColumn)return;this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.startLineNumber-1].substring(f.endColumn-1));return}this.n(f.startLineNumber-1,this.f[f.startLineNumber-1].substring(0,f.startColumn-1)+this.f[f.endLineNumber-1].substring(f.endColumn-1)),this.f.splice(f.startLineNumber,f.endLineNumber-f.startLineNumber),this.j&&this.j.removeValues(f.startLineNumber,f.endLineNumber-f.startLineNumber)}p(f,a){if(a.length===0)return;const s=(0,F.$7e)(a);if(s.length===1){this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]+this.f[f.lineNumber-1].substring(f.column-1));return}s[s.length-1]+=this.f[f.lineNumber-1].substring(f.column-1),this.n(f.lineNumber-1,this.f[f.lineNumber-1].substring(0,f.column-1)+s[0]);const h=new Uint32Array(s.length-1);for(let A=1;A<s.length;A++)this.f.splice(f.lineNumber+A-1,0,s[A]),h[A-1]=s[A].length+this.g.length;this.j&&this.j.insertValues(f.lineNumber,h)}}t.$uv=o}),te(ie[57],re([0,1,7,44,5,2,54]),function(W,t,F,y,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eC=t.$dC=t.$cC=t.$bC=t.$aC=t.$_B=void 0;const f=999;class a{constructor($,m,u,c){this.searchString=$,this.isRegex=m,this.matchCase=u,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=s(this.searchString):$=this.searchString.indexOf(`
`)>=0;let m=null;try{m=F.$5e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!m)return null;let u=!this.isRegex&&!$;return u&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(u=this.matchCase),new N.$mv(m,this.wordSeparators?(0,y.$rt)(this.wordSeparators):null,u?this.searchString:null)}}t.$_B=a;function s(L){if(!L||L.length===0)return!1;for(let $=0,m=L.length;$<m;$++){const u=L.charCodeAt($);if(u===10)return!0;if(u===92){if($++,$>=m)break;const c=L.charCodeAt($);if(c===110||c===114||c===87)return!0}}return!1}t.$aC=s;function h(L,$,m){if(!m)return new N.$jv(L,null);const u=[];for(let c=0,i=$.length;c<i;c++)u[c]=$[c];return new N.$jv(L,u)}t.$bC=h;class A{constructor($){const m=[];let u=0;for(let c=0,i=$.length;c<i;c++)$.charCodeAt(c)===10&&(m[u++]=c);this.a=m}findLineFeedCountBeforeOffset($){const m=this.a;let u=0,c=m.length-1;if(c===-1||$<=m[0])return 0;for(;u<c;){const i=u+((c-u)/2>>0);m[i]>=$?c=i-1:m[i+1]>=$?(u=i,c=i):u=i+1}return u+1}}class b{static findMatches($,m,u,c,i){const l=m.parseSearchRequest();return l?l.regex.multiline?this.b($,u,new R(l.wordSeparators,l.regex),c,i):this.c($,u,l,c,i):[]}static a($,m,u,c,i,l){let v,d=0;c?(d=c.findLineFeedCountBeforeOffset(i),v=m+i+d):v=m+i;let w;if(c){const D=c.findLineFeedCountBeforeOffset(i+l.length)-d;w=v+l.length+D}else w=v+l.length;const M=$.getPositionAt(v),p=$.getPositionAt(w);return new o.$4s(M.lineNumber,M.column,p.lineNumber,p.column)}static b($,m,u,c,i){const l=$.getOffsetAt(m.getStartPosition()),v=$.getValueInRange(m,1),d=$.getEOL()===`\r
`?new A(v):null,w=[];let M=0,p;for(u.reset(0);p=u.next(v);)if(w[M++]=h(this.a($,l,v,d,p.index,p[0]),p,c),M>=i)return w;return w}static c($,m,u,c,i){const l=[];let v=0;if(m.startLineNumber===m.endLineNumber){const w=$.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return v=this.d(u,w,m.startLineNumber,m.startColumn-1,v,l,c,i),l}const d=$.getLineContent(m.startLineNumber).substring(m.startColumn-1);v=this.d(u,d,m.startLineNumber,m.startColumn-1,v,l,c,i);for(let w=m.startLineNumber+1;w<m.endLineNumber&&v<i;w++)v=this.d(u,$.getLineContent(w),w,0,v,l,c,i);if(v<i){const w=$.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);v=this.d(u,w,m.endLineNumber,0,v,l,c,i)}return l}static d($,m,u,c,i,l,v,d){const w=$.wordSeparators;if(!v&&$.simpleSearch){const P=$.simpleSearch,D=P.length,k=m.length;let T=-D;for(;(T=m.indexOf(P,T+D))!==-1;)if((!w||E(w,m,k,T,D))&&(l[i++]=new N.$jv(new o.$4s(u,T+1+c,u,T+1+D+c),null),i>=d))return i;return i}const M=new R($.wordSeparators,$.regex);let p;M.reset(0);do if(p=M.next(m),p&&(l[i++]=h(new o.$4s(u,p.index+1+c,u,p.index+1+p[0].length+c),p,v),i>=d))return i;while(p);return i}static findNextMatch($,m,u,c){const i=m.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.e($,u,l,c):this.f($,u,l,c)}static e($,m,u,c){const i=new r.$3s(m.lineNumber,1),l=$.getOffsetAt(i),v=$.getLineCount(),d=$.getValueInRange(new o.$4s(i.lineNumber,i.column,v,$.getLineMaxColumn(v)),1),w=$.getEOL()===`\r
`?new A(d):null;u.reset(m.column-1);const M=u.next(d);return M?h(this.a($,l,d,w,M.index,M[0]),M,c):m.lineNumber!==1||m.column!==1?this.e($,new r.$3s(1,1),u,c):null}static f($,m,u,c){const i=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l),d=this.g(u,v,l,m.column,c);if(d)return d;for(let w=1;w<=i;w++){const M=(l+w-1)%i,p=$.getLineContent(M+1),P=this.g(u,p,M+1,1,c);if(P)return P}return null}static g($,m,u,c,i){$.reset(c-1);const l=$.next(m);return l?h(new o.$4s(u,l.index+1,u,l.index+1+l[0].length),l,i):null}static findPreviousMatch($,m,u,c){const i=m.parseSearchRequest();if(!i)return null;const l=new R(i.wordSeparators,i.regex);return i.regex.multiline?this.h($,u,l,c):this.j($,u,l,c)}static h($,m,u,c){const i=this.b($,new o.$4s(1,1,m.lineNumber,m.column),u,c,10*f);if(i.length>0)return i[i.length-1];const l=$.getLineCount();return m.lineNumber!==l||m.column!==$.getLineMaxColumn(l)?this.h($,new r.$3s(l,$.getLineMaxColumn(l)),u,c):null}static j($,m,u,c){const i=$.getLineCount(),l=m.lineNumber,v=$.getLineContent(l).substring(0,m.column-1),d=this.k(u,v,l,c);if(d)return d;for(let w=1;w<=i;w++){const M=(i+l-w-1)%i,p=$.getLineContent(M+1),P=this.k(u,p,M+1,c);if(P)return P}return null}static k($,m,u,c){let i=null,l;for($.reset(0);l=$.next(m);)i=h(new o.$4s(u,l.index+1,u,l.index+1+l[0].length),l,c);return i}}t.$cC=b;function g(L,$,m,u,c){if(u===0)return!0;const i=$.charCodeAt(u-1);if(L.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u);if(L.get(l)!==0)return!0}return!1}function e(L,$,m,u,c){if(u+c===m)return!0;const i=$.charCodeAt(u+c);if(L.get(i)!==0||i===13||i===10)return!0;if(c>0){const l=$.charCodeAt(u+c-1);if(L.get(l)!==0)return!0}return!1}function E(L,$,m,u,c){return g(L,$,m,u,c)&&e(L,$,m,u,c)}t.$dC=E;class R{constructor($,m){this._wordSeparators=$,this.a=m,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const m=$.length;let u;do{if(this.b+this.c===m||(u=this.a.exec($),!u))return null;const c=u.index,i=u[0].length;if(c===this.b&&i===this.c){if(i===0){F.$of($,m,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=i,!this._wordSeparators||E(this._wordSeparators,$,m,c,i))return u}while(u);return null}}t.$eC=R}),te(ie[58],re([0,1,2,57,7,13,29]),function(W,t,F,y,r,o,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$A1=void 0;class f{static computeUnicodeHighlights(e,E,R){const L=R?R.startLineNumber:1,$=R?R.endLineNumber:e.getLineCount(),m=new h(E),u=m.getCandidateCodePoints();let c;u==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(u))}`,"g");const i=new y.$eC(null,c),l=[];let v=!1,d,w=0,M=0,p=0;e:for(let P=L,D=$;P<=D;P++){const k=e.getLineContent(P),T=k.length;i.reset(0);do if(d=i.next(k),d){let _=d.index,q=d.index+d[0].length;if(_>0){const U=k.charCodeAt(_-1);r.$lf(U)&&_--}if(q+1<T){const U=k.charCodeAt(q-1);r.$lf(U)&&q++}const V=k.substring(_,q);let z=(0,N.$Gs)(_+1,N.$Ds,k,0);z&&z.endColumn<=_+1&&(z=null);const S=m.shouldHighlightNonBasicASCII(V,z?z.word:null);if(S!==0){if(S===3?w++:S===2?M++:S===1?p++:(0,o.$9c)(S),l.length>=1e3){v=!0;break e}l.push(new F.$4s(P,_+1,P,q+1))}}while(d)}return{ranges:l,hasMore:v,ambiguousCharacterCount:w,invisibleCharacterCount:M,nonBasicAsciiCharacterCount:p}}static computeUnicodeHighlightReason(e,E){const R=new h(E);switch(R.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),m=R.ambiguousCharacters.getPrimaryConfusable($),u=r.$Of.getLocales().filter(c=>!r.$Of.getInstance(new Set([...E.allowedLocales,c])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(m),notAmbiguousInLocales:u}}case 1:return{kind:2}}}}t.$A1=f;function a(g,e){return`[${r.$Ve(g.map(R=>String.fromCodePoint(R)).join(""))}]`}var s;(function(g){g[g.Ambiguous=0]="Ambiguous",g[g.Invisible=1]="Invisible",g[g.NonBasicAscii=2]="NonBasicAscii"})(s||(t.UnicodeHighlighterReasonKind=s={}));class h{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$Of.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const E of r.$Pf.codePoints)A(String.fromCodePoint(E))||e.add(E);if(this.b.ambiguousCharacters)for(const E of this.ambiguousCharacters.getConfusableCodePoints())e.add(E);for(const E of this.a)e.delete(E);return e}shouldHighlightNonBasicASCII(e,E){const R=e.codePointAt(0);if(this.a.has(R))return 0;if(this.b.nonBasicASCII)return 1;let L=!1,$=!1;if(E)for(const m of E){const u=m.codePointAt(0),c=r.$wf(m);L=L||c,!c&&!this.ambiguousCharacters.isAmbiguous(u)&&!r.$Pf.isInvisibleCharacter(u)&&($=!0)}return!L&&$?0:this.b.invisibleCharacters&&!A(e)&&r.$Pf.isInvisibleCharacter(R)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(R)?3:0}}function A(g){return g===" "||g===`
`||g==="	"}var b;(function(g){g[g.None=0]="None",g[g.NonBasicASCII=1]="NonBasicASCII",g[g.Invisible=2]="Invisible",g[g.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ie[59],re([0,1]),function(W,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var F;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(F||(t.AccessibilitySupport=F={}));var y;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(y||(t.CodeActionTriggerType=y={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var o;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(o||(t.CompletionItemKind=o={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var f;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(t.CompletionTriggerKind=f={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var s;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(s||(t.CursorChangeReason=s={}));var h;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(h||(t.DefaultEndOfLine=h={}));var A;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(A||(t.DocumentHighlightKind=A={}));var b;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var g;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.occurrencesHighlight=80]="occurrencesHighlight",n[n.overviewRulerBorder=81]="overviewRulerBorder",n[n.overviewRulerLanes=82]="overviewRulerLanes",n[n.padding=83]="padding",n[n.pasteAs=84]="pasteAs",n[n.parameterHints=85]="parameterHints",n[n.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",n[n.quickSuggestions=88]="quickSuggestions",n[n.quickSuggestionsDelay=89]="quickSuggestionsDelay",n[n.readOnly=90]="readOnly",n[n.readOnlyMessage=91]="readOnlyMessage",n[n.renameOnType=92]="renameOnType",n[n.renderControlCharacters=93]="renderControlCharacters",n[n.renderFinalNewline=94]="renderFinalNewline",n[n.renderLineHighlight=95]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=97]="renderValidationDecorations",n[n.renderWhitespace=98]="renderWhitespace",n[n.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",n[n.roundedSelection=100]="roundedSelection",n[n.rulers=101]="rulers",n[n.scrollbar=102]="scrollbar",n[n.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=104]="scrollBeyondLastLine",n[n.scrollPredominantAxis=105]="scrollPredominantAxis",n[n.selectionClipboard=106]="selectionClipboard",n[n.selectionHighlight=107]="selectionHighlight",n[n.selectOnLineNumbers=108]="selectOnLineNumbers",n[n.showFoldingControls=109]="showFoldingControls",n[n.showUnused=110]="showUnused",n[n.snippetSuggestions=111]="snippetSuggestions",n[n.smartSelect=112]="smartSelect",n[n.smoothScrolling=113]="smoothScrolling",n[n.stickyScroll=114]="stickyScroll",n[n.stickyTabStops=115]="stickyTabStops",n[n.stopRenderingLineAfter=116]="stopRenderingLineAfter",n[n.suggest=117]="suggest",n[n.suggestFontSize=118]="suggestFontSize",n[n.suggestLineHeight=119]="suggestLineHeight",n[n.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",n[n.suggestSelection=121]="suggestSelection",n[n.tabCompletion=122]="tabCompletion",n[n.tabIndex=123]="tabIndex",n[n.unicodeHighlighting=124]="unicodeHighlighting",n[n.unusualLineTerminators=125]="unusualLineTerminators",n[n.useShadowDOM=126]="useShadowDOM",n[n.useTabStops=127]="useTabStops",n[n.wordBreak=128]="wordBreak",n[n.wordSeparators=129]="wordSeparators",n[n.wordWrap=130]="wordWrap",n[n.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=133]="wordWrapColumn",n[n.wordWrapOverride1=134]="wordWrapOverride1",n[n.wordWrapOverride2=135]="wordWrapOverride2",n[n.wrappingIndent=136]="wrappingIndent",n[n.wrappingStrategy=137]="wrappingStrategy",n[n.showDeprecated=138]="showDeprecated",n[n.inlayHints=139]="inlayHints",n[n.editorClassName=140]="editorClassName",n[n.pixelRatio=141]="pixelRatio",n[n.tabFocusMode=142]="tabFocusMode",n[n.layoutInfo=143]="layoutInfo",n[n.wrappingInfo=144]="wrappingInfo",n[n.defaultColorDecorators=145]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(g||(t.EditorOption=g={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var E;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(E||(t.EndOfLineSequence=E={}));var R;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(R||(t.GlyphMarginLane=R={}));var L;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(L||(t.IndentAction=L={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var m;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(m||(t.InlayHintKind=m={}));var u;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(u||(t.InlineCompletionTriggerKind=u={}));var c;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(c||(t.KeyCode=c={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var v;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(v||(t.MinimapPosition=v={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var w;(function(n){n[n.AIGenerated=1]="AIGenerated"})(w||(t.NewSymbolNameTag=w={}));var M;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(M||(t.OverlayWidgetPositionPreference=M={}));var p;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(p||(t.OverviewRulerLane=p={}));var P;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(P||(t.PositionAffinity=P={}));var D;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(D||(t.RenderLineNumbersType=D={}));var k;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(k||(t.RenderMinimap=k={}));var T;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(T||(t.ScrollType=T={}));var _;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(_||(t.ScrollbarVisibility=_={}));var q;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(q||(t.SelectionDirection=q={}));var V;(function(n){n.Off="off",n.OnCode="onCode",n.On="on"})(V||(t.ShowLightbulbIconMode=V={}));var z;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(z||(t.SignatureHelpTriggerKind=z={}));var S;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(S||(t.SymbolKind=S={}));var U;(function(n){n[n.Deprecated=1]="Deprecated"})(U||(t.SymbolTag=U={}));var X;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(X||(t.TextEditorCursorBlinkingStyle=X={}));var J;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(J||(t.TextEditorCursorStyle=J={}));var ee;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(ee||(t.TrackedRangeStickiness=ee={}));var le;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(le||(t.WrappingIndent=le={}))}),te(ie[60],re([0,1,11,10]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ct=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new F.$3d,this.onDidChange=this.c.event,this.d=null}handleChange(f){this.c.fire({changedLanguages:f,changedColorMap:!1})}register(f,a){return this.a.set(f,a),this.handleChange([f]),(0,y.$Rc)(()=>{this.a.get(f)===a&&(this.a.delete(f),this.handleChange([f]))})}get(f){return this.a.get(f)||null}registerFactory(f,a){this.b.get(f)?.dispose();const s=new o(this,f,a);return this.b.set(f,s),(0,y.$Rc)(()=>{const h=this.b.get(f);!h||h!==s||(this.b.delete(f),h.dispose())})}async getOrCreate(f){const a=this.get(f);if(a)return a;const s=this.b.get(f);return!s||s.isResolved?null:(await s.resolve(),this.get(f))}isResolved(f){if(this.get(f))return!0;const s=this.b.get(f);return!!(!s||s.isResolved)}setColorMap(f){this.d=f,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$Ct=r;class o extends y.$Tc{get isResolved(){return this.c}constructor(f,a,s){super(),this.f=f,this.g=a,this.h=s,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const f=await this.h.tokenizationSupport;this.c=!0,f&&!this.a&&this.B(this.f.register(this.g,f))}}}),te(ie[61],re([62,63]),function(W,t){return W.create("vs/base/common/platform",t)}),te(ie[17],re([0,1,61]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let y=!1,r=!1,o=!1,N=!1,f=!1,a=!1,s=!1,h=!1,A=!1,b=!1,g,e=t.$g,E=t.$g,R,L;const $=globalThis;let m;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?m=$.vscode.process:typeof process<"u"&&(m=process);const u=typeof m?.versions?.electron=="string",c=u&&m?.type==="renderer";if(typeof m=="object"){y=m.platform==="win32",r=m.platform==="darwin",o=m.platform==="linux",N=o&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,s=u,A=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=t.$g,e=t.$g;const k=m.env.VSCODE_NLS_CONFIG;if(k)try{const T=JSON.parse(k),_=T.availableLanguages["*"];g=T.locale,E=T.osLocale,e=_||t.$g,R=T._translationsConfigFile}catch{}f=!0}else typeof navigator=="object"&&!c?(L=navigator.userAgent,y=L.indexOf("Windows")>=0,r=L.indexOf("Macintosh")>=0,h=(L.indexOf("Macintosh")>=0||L.indexOf("iPad")>=0||L.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,o=L.indexOf("Linux")>=0,b=L?.indexOf("Mobi")>=0,a=!0,g=F.getConfiguredDefaultLocale(F.localize(0,null))||t.$g,e=g,E=navigator.language):console.error("Unable to resolve platform.");var i;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(i||(t.Platform=i={}));function l(k){switch(k){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=l;let v=0;r?v=1:y?v=3:o&&(v=2),t.$i=y,t.$j=r,t.$k=o,t.$l=N,t.$m=f,t.$n=s,t.$o=a,t.$p=a&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=h,t.$s=b,t.$t=A,t.$u=v,t.$v=L,t.$w=e;var d;(function(k){function T(){return t.$w}k.value=T;function _(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}k.isDefaultVariant=_;function q(){return t.$w==="en"}k.isDefault=q})(d||(t.Language=d={})),t.$x=g,t.$y=E,t.$z=R,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const k=[];$.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let q=0,V=k.length;q<V;q++){const z=k[q];if(z.id===_.data.vscodeScheduleAsyncWork){k.splice(q,1),z.callback();return}}});let T=0;return _=>{const q=++T;k.push({id:q,callback:_}),$.postMessage({vscodeScheduleAsyncWork:q},"*")}}return k=>setTimeout(k)})();var w;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=r||h?2:y?1:3;let M=!0,p=!1;function P(){if(!p){p=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,M=new Uint16Array(k.buffer)[0]===513}return M}t.$D=P,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function D(k){return parseFloat(k)>=20}t.$J=D}),te(ie[64],re([0,1,17]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let y;const r=globalThis.vscode;if(typeof r<"u"&&typeof r.process<"u"){const o=r.process;y={get platform(){return o.platform},get arch(){return o.arch},get env(){return o.env},cwd(){return o.cwd()}}}else typeof process<"u"?y={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:y={get platform(){return F.$i?"win32":F.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=y.cwd,t.env=y.env,t.$dc=y.platform,t.$ec=y.arch}),te(ie[65],re([0,1,64]),function(W,t,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const y=65,r=97,o=90,N=122,f=46,a=47,s=92,h=58,A=63;class b extends Error{constructor(l,v,d){let w;typeof v=="string"&&v.indexOf("not ")===0?(w="must not be",v=v.replace(/^not /,"")):w="must be";const M=l.indexOf(".")!==-1?"property":"argument";let p=`The "${l}" ${M} ${w} of type ${v}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function g(i,l){if(i===null||typeof i!="object")throw new b(l,"Object",i)}function e(i,l){if(typeof i!="string")throw new b(l,"string",i)}const E=F.$dc==="win32";function R(i){return i===a||i===s}function L(i){return i===a}function $(i){return i>=y&&i<=o||i>=r&&i<=N}function m(i,l,v,d){let w="",M=0,p=-1,P=0,D=0;for(let k=0;k<=i.length;++k){if(k<i.length)D=i.charCodeAt(k);else{if(d(D))break;D=a}if(d(D)){if(!(p===k-1||P===1))if(P===2){if(w.length<2||M!==2||w.charCodeAt(w.length-1)!==f||w.charCodeAt(w.length-2)!==f){if(w.length>2){const T=w.lastIndexOf(v);T===-1?(w="",M=0):(w=w.slice(0,T),M=w.length-1-w.lastIndexOf(v)),p=k,P=0;continue}else if(w.length!==0){w="",M=0,p=k,P=0;continue}}l&&(w+=w.length>0?`${v}..`:"..",M=2)}else w.length>0?w+=`${v}${i.slice(p+1,k)}`:w=i.slice(p+1,k),M=k-p-1;p=k,P=0}else D===f&&P!==-1?++P:P=-1}return w}function u(i,l){g(l,"pathObject");const v=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return v?v===l.root?`${v}${d}`:`${v}${i}${d}`:d}t.$fc={resolve(...i){let l="",v="",d=!1;for(let w=i.length-1;w>=-1;w--){let M;if(w>=0){if(M=i[w],e(M,"path"),M.length===0)continue}else l.length===0?M=F.cwd():(M=F.env[`=${l}`]||F.cwd(),(M===void 0||M.slice(0,2).toLowerCase()!==l.toLowerCase()&&M.charCodeAt(2)===s)&&(M=`${l}\\`));const p=M.length;let P=0,D="",k=!1;const T=M.charCodeAt(0);if(p===1)R(T)&&(P=1,k=!0);else if(R(T))if(k=!0,R(M.charCodeAt(1))){let _=2,q=_;for(;_<p&&!R(M.charCodeAt(_));)_++;if(_<p&&_!==q){const V=M.slice(q,_);for(q=_;_<p&&R(M.charCodeAt(_));)_++;if(_<p&&_!==q){for(q=_;_<p&&!R(M.charCodeAt(_));)_++;(_===p||_!==q)&&(D=`\\\\${V}\\${M.slice(q,_)}`,P=_)}}}else P=1;else $(T)&&M.charCodeAt(1)===h&&(D=M.slice(0,2),P=2,p>2&&R(M.charCodeAt(2))&&(k=!0,P=3));if(D.length>0)if(l.length>0){if(D.toLowerCase()!==l.toLowerCase())continue}else l=D;if(d){if(l.length>0)break}else if(v=`${M.slice(P)}\\${v}`,d=k,k&&l.length>0)break}return v=m(v,!d,"\\",R),d?`${l}\\${v}`:`${l}${v}`||"."},normalize(i){e(i,"path");const l=i.length;if(l===0)return".";let v=0,d,w=!1;const M=i.charCodeAt(0);if(l===1)return L(M)?"\\":i;if(R(M))if(w=!0,R(i.charCodeAt(1))){let P=2,D=P;for(;P<l&&!R(i.charCodeAt(P));)P++;if(P<l&&P!==D){const k=i.slice(D,P);for(D=P;P<l&&R(i.charCodeAt(P));)P++;if(P<l&&P!==D){for(D=P;P<l&&!R(i.charCodeAt(P));)P++;if(P===l)return`\\\\${k}\\${i.slice(D)}\\`;P!==D&&(d=`\\\\${k}\\${i.slice(D,P)}`,v=P)}}}else v=1;else $(M)&&i.charCodeAt(1)===h&&(d=i.slice(0,2),v=2,l>2&&R(i.charCodeAt(2))&&(w=!0,v=3));let p=v<l?m(i.slice(v),!w,"\\",R):"";return p.length===0&&!w&&(p="."),p.length>0&&R(i.charCodeAt(l-1))&&(p+="\\"),d===void 0?w?`\\${p}`:p:w?`${d}\\${p}`:`${d}${p}`},isAbsolute(i){e(i,"path");const l=i.length;if(l===0)return!1;const v=i.charCodeAt(0);return R(v)||l>2&&$(v)&&i.charCodeAt(1)===h&&R(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let l,v;for(let M=0;M<i.length;++M){const p=i[M];e(p,"path"),p.length>0&&(l===void 0?l=v=p:l+=`\\${p}`)}if(l===void 0)return".";let d=!0,w=0;if(typeof v=="string"&&R(v.charCodeAt(0))){++w;const M=v.length;M>1&&R(v.charCodeAt(1))&&(++w,M>2&&(R(v.charCodeAt(2))?++w:d=!1))}if(d){for(;w<l.length&&R(l.charCodeAt(w));)w++;w>=2&&(l=`\\${l.slice(w)}`)}return t.$fc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l)return"";const v=t.$fc.resolve(i),d=t.$fc.resolve(l);if(v===d||(i=v.toLowerCase(),l=d.toLowerCase(),i===l))return"";let w=0;for(;w<i.length&&i.charCodeAt(w)===s;)w++;let M=i.length;for(;M-1>w&&i.charCodeAt(M-1)===s;)M--;const p=M-w;let P=0;for(;P<l.length&&l.charCodeAt(P)===s;)P++;let D=l.length;for(;D-1>P&&l.charCodeAt(D-1)===s;)D--;const k=D-P,T=p<k?p:k;let _=-1,q=0;for(;q<T;q++){const z=i.charCodeAt(w+q);if(z!==l.charCodeAt(P+q))break;z===s&&(_=q)}if(q!==T){if(_===-1)return d}else{if(k>T){if(l.charCodeAt(P+q)===s)return d.slice(P+q+1);if(q===2)return d.slice(P+q)}p>T&&(i.charCodeAt(w+q)===s?_=q:q===2&&(_=3)),_===-1&&(_=0)}let V="";for(q=w+_+1;q<=M;++q)(q===M||i.charCodeAt(q)===s)&&(V+=V.length===0?"..":"\\..");return P+=_,V.length>0?`${V}${d.slice(P,D)}`:(d.charCodeAt(P)===s&&++P,d.slice(P,D))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const l=t.$fc.resolve(i);if(l.length<=2)return i;if(l.charCodeAt(0)===s){if(l.charCodeAt(1)===s){const v=l.charCodeAt(2);if(v!==A&&v!==f)return`\\\\?\\UNC\\${l.slice(2)}`}}else if($(l.charCodeAt(0))&&l.charCodeAt(1)===h&&l.charCodeAt(2)===s)return`\\\\?\\${l}`;return i},dirname(i){e(i,"path");const l=i.length;if(l===0)return".";let v=-1,d=0;const w=i.charCodeAt(0);if(l===1)return R(w)?i:".";if(R(w)){if(v=d=1,R(i.charCodeAt(1))){let P=2,D=P;for(;P<l&&!R(i.charCodeAt(P));)P++;if(P<l&&P!==D){for(D=P;P<l&&R(i.charCodeAt(P));)P++;if(P<l&&P!==D){for(D=P;P<l&&!R(i.charCodeAt(P));)P++;if(P===l)return i;P!==D&&(v=d=P+1)}}}}else $(w)&&i.charCodeAt(1)===h&&(v=l>2&&R(i.charCodeAt(2))?3:2,d=v);let M=-1,p=!0;for(let P=l-1;P>=d;--P)if(R(i.charCodeAt(P))){if(!p){M=P;break}}else p=!1;if(M===-1){if(v===-1)return".";M=v}return i.slice(0,M)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let v=0,d=-1,w=!0,M;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===h&&(v=2),l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let p=l.length-1,P=-1;for(M=i.length-1;M>=v;--M){const D=i.charCodeAt(M);if(R(D)){if(!w){v=M+1;break}}else P===-1&&(w=!1,P=M+1),p>=0&&(D===l.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=P))}return v===d?d=P:d===-1&&(d=i.length),i.slice(v,d)}for(M=i.length-1;M>=v;--M)if(R(i.charCodeAt(M))){if(!w){v=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let l=0,v=-1,d=0,w=-1,M=!0,p=0;i.length>=2&&i.charCodeAt(1)===h&&$(i.charCodeAt(0))&&(l=d=2);for(let P=i.length-1;P>=l;--P){const D=i.charCodeAt(P);if(R(D)){if(!M){d=P+1;break}continue}w===-1&&(M=!1,w=P+1),D===f?v===-1?v=P:p!==1&&(p=1):v!==-1&&(p=-1)}return v===-1||w===-1||p===0||p===1&&v===w-1&&v===d+1?"":i.slice(v,w)},format:u.bind(null,"\\"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const v=i.length;let d=0,w=i.charCodeAt(0);if(v===1)return R(w)?(l.root=l.dir=i,l):(l.base=l.name=i,l);if(R(w)){if(d=1,R(i.charCodeAt(1))){let _=2,q=_;for(;_<v&&!R(i.charCodeAt(_));)_++;if(_<v&&_!==q){for(q=_;_<v&&R(i.charCodeAt(_));)_++;if(_<v&&_!==q){for(q=_;_<v&&!R(i.charCodeAt(_));)_++;_===v?d=_:_!==q&&(d=_+1)}}}}else if($(w)&&i.charCodeAt(1)===h){if(v<=2)return l.root=l.dir=i,l;if(d=2,R(i.charCodeAt(2))){if(v===3)return l.root=l.dir=i,l;d=3}}d>0&&(l.root=i.slice(0,d));let M=-1,p=d,P=-1,D=!0,k=i.length-1,T=0;for(;k>=d;--k){if(w=i.charCodeAt(k),R(w)){if(!D){p=k+1;break}continue}P===-1&&(D=!1,P=k+1),w===f?M===-1?M=k:T!==1&&(T=1):M!==-1&&(T=-1)}return P!==-1&&(M===-1||T===0||T===1&&M===P-1&&M===p+1?l.base=l.name=i.slice(p,P):(l.name=i.slice(p,M),l.base=i.slice(p,P),l.ext=i.slice(M,P))),p>0&&p!==d?l.dir=i.slice(0,p-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(E){const i=/\\/g;return()=>{const l=F.cwd().replace(i,"/");return l.slice(l.indexOf("/"))}}return()=>F.cwd()})();t.$gc={resolve(...i){let l="",v=!1;for(let d=i.length-1;d>=-1&&!v;d--){const w=d>=0?i[d]:c();e(w,"path"),w.length!==0&&(l=`${w}/${l}`,v=w.charCodeAt(0)===a)}return l=m(l,!v,"/",L),v?`/${l}`:l.length>0?l:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a,v=i.charCodeAt(i.length-1)===a;return i=m(i,!l,"/",L),i.length===0?l?"/":v?"./":".":(v&&(i+="/"),l?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let l;for(let v=0;v<i.length;++v){const d=i[v];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$gc.normalize(l)},relative(i,l){if(e(i,"from"),e(l,"to"),i===l||(i=t.$gc.resolve(i),l=t.$gc.resolve(l),i===l))return"";const v=1,d=i.length,w=d-v,M=1,p=l.length-M,P=w<p?w:p;let D=-1,k=0;for(;k<P;k++){const _=i.charCodeAt(v+k);if(_!==l.charCodeAt(M+k))break;_===a&&(D=k)}if(k===P)if(p>P){if(l.charCodeAt(M+k)===a)return l.slice(M+k+1);if(k===0)return l.slice(M+k)}else w>P&&(i.charCodeAt(v+k)===a?D=k:k===0&&(D=0));let T="";for(k=v+D+1;k<=d;++k)(k===d||i.charCodeAt(k)===a)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(M+D)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const l=i.charCodeAt(0)===a;let v=-1,d=!0;for(let w=i.length-1;w>=1;--w)if(i.charCodeAt(w)===a){if(!d){v=w;break}}else d=!1;return v===-1?l?"/":".":l&&v===1?"//":i.slice(0,v)},basename(i,l){l!==void 0&&e(l,"ext"),e(i,"path");let v=0,d=-1,w=!0,M;if(l!==void 0&&l.length>0&&l.length<=i.length){if(l===i)return"";let p=l.length-1,P=-1;for(M=i.length-1;M>=0;--M){const D=i.charCodeAt(M);if(D===a){if(!w){v=M+1;break}}else P===-1&&(w=!1,P=M+1),p>=0&&(D===l.charCodeAt(p)?--p===-1&&(d=M):(p=-1,d=P))}return v===d?d=P:d===-1&&(d=i.length),i.slice(v,d)}for(M=i.length-1;M>=0;--M)if(i.charCodeAt(M)===a){if(!w){v=M+1;break}}else d===-1&&(w=!1,d=M+1);return d===-1?"":i.slice(v,d)},extname(i){e(i,"path");let l=-1,v=0,d=-1,w=!0,M=0;for(let p=i.length-1;p>=0;--p){const P=i.charCodeAt(p);if(P===a){if(!w){v=p+1;break}continue}d===-1&&(w=!1,d=p+1),P===f?l===-1?l=p:M!==1&&(M=1):l!==-1&&(M=-1)}return l===-1||d===-1||M===0||M===1&&l===d-1&&l===v+1?"":i.slice(l,d)},format:u.bind(null,"/"),parse(i){e(i,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return l;const v=i.charCodeAt(0)===a;let d;v?(l.root="/",d=1):d=0;let w=-1,M=0,p=-1,P=!0,D=i.length-1,k=0;for(;D>=d;--D){const T=i.charCodeAt(D);if(T===a){if(!P){M=D+1;break}continue}p===-1&&(P=!1,p=D+1),T===f?w===-1?w=D:k!==1&&(k=1):w!==-1&&(k=-1)}if(p!==-1){const T=M===0&&v?1:M;w===-1||k===0||k===1&&w===p-1&&w===M+1?l.base=l.name=i.slice(T,p):(l.name=i.slice(T,w),l.base=i.slice(T,p),l.ext=i.slice(w,p))}return M>0?l.dir=i.slice(0,M-1):v&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=E?t.$fc.normalize:t.$gc.normalize,t.$ic=E?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=E?t.$fc.join:t.$gc.join,t.$kc=E?t.$fc.resolve:t.$gc.resolve,t.$lc=E?t.$fc.relative:t.$gc.relative,t.$mc=E?t.$fc.dirname:t.$gc.dirname,t.$nc=E?t.$fc.basename:t.$gc.basename,t.$oc=E?t.$fc.extname:t.$gc.extname,t.$pc=E?t.$fc.format:t.$gc.format,t.$qc=E?t.$fc.parse:t.$gc.parse,t.$rc=E?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=E?t.$fc.sep:t.$gc.sep,t.$tc=E?t.$fc.delimiter:t.$gc.delimiter}),te(ie[18],re([0,1,65,17]),function(W,t,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,N=/^\/\//;function f(d,w){if(!d.scheme&&w)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!o.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,w){return!d&&!w?"file":d}function s(d,w){switch(d){case"https":case"http":case"file":w?w[0]!==A&&(w=A+w):w=A;break}return w}const h="",A="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(w){return w instanceof g?!0:w?typeof w.authority=="string"&&typeof w.fragment=="string"&&typeof w.path=="string"&&typeof w.query=="string"&&typeof w.scheme=="string"&&typeof w.fsPath=="string"&&typeof w.with=="function"&&typeof w.toString=="function":!1}constructor(w,M,p,P,D,k=!1){typeof w=="object"?(this.scheme=w.scheme||h,this.authority=w.authority||h,this.path=w.path||h,this.query=w.query||h,this.fragment=w.fragment||h):(this.scheme=a(w,k),this.authority=M||h,this.path=s(this.scheme,p||h),this.query=P||h,this.fragment=D||h,f(this,k))}get fsPath(){return u(this,!1)}with(w){if(!w)return this;let{scheme:M,authority:p,path:P,query:D,fragment:k}=w;return M===void 0?M=this.scheme:M===null&&(M=h),p===void 0?p=this.authority:p===null&&(p=h),P===void 0?P=this.path:P===null&&(P=h),D===void 0?D=this.query:D===null&&(D=h),k===void 0?k=this.fragment:k===null&&(k=h),M===this.scheme&&p===this.authority&&P===this.path&&D===this.query&&k===this.fragment?this:new R(M,p,P,D,k)}static parse(w,M=!1){const p=b.exec(w);return p?new R(p[2]||h,v(p[4]||h),v(p[5]||h),v(p[7]||h),v(p[9]||h),M):new R(h,h,h,h,h)}static file(w){let M=h;if(y.$i&&(w=w.replace(/\\/g,A)),w[0]===A&&w[1]===A){const p=w.indexOf(A,2);p===-1?(M=w.substring(2),w=A):(M=w.substring(2,p),w=w.substring(p)||A)}return new R("file",M,w,h,h)}static from(w,M){return new R(w.scheme,w.authority,w.path,w.query,w.fragment,M)}static joinPath(w,...M){if(!w.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return y.$i&&w.scheme==="file"?p=g.file(F.$fc.join(u(w,!0),...M)).path:p=F.$gc.join(w.path,...M),w.with({path:p})}toString(w=!1){return c(this,w)}toJSON(){return this}static revive(w){if(w){if(w instanceof g)return w;{const M=new R(w);return M._formatted=w.external??null,M._fsPath=w._sep===E?w.fsPath??null:null,M}}else return w}}t.URI=g;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const E=y.$i?1:void 0;class R extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(w=!1){return w?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const w={$mid:1};return this._fsPath&&(w.fsPath=this._fsPath,w._sep=E),this._formatted&&(w.external=this._formatted),this.path&&(w.path=this.path),this.scheme&&(w.scheme=this.scheme),this.authority&&(w.authority=this.authority),this.query&&(w.query=this.query),this.fragment&&(w.fragment=this.fragment),w}}const L={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(d,w,M){let p,P=-1;for(let D=0;D<d.length;D++){const k=d.charCodeAt(D);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||w&&k===47||M&&k===91||M&&k===93||M&&k===58)P!==-1&&(p+=encodeURIComponent(d.substring(P,D)),P=-1),p!==void 0&&(p+=d.charAt(D));else{p===void 0&&(p=d.substr(0,D));const T=L[k];T!==void 0?(P!==-1&&(p+=encodeURIComponent(d.substring(P,D)),P=-1),p+=T):P===-1&&(P=D)}}return P!==-1&&(p+=encodeURIComponent(d.substring(P))),p!==void 0?p:d}function m(d){let w;for(let M=0;M<d.length;M++){const p=d.charCodeAt(M);p===35||p===63?(w===void 0&&(w=d.substr(0,M)),w+=L[p]):w!==void 0&&(w+=d[M])}return w!==void 0?w:d}function u(d,w){let M;return d.authority&&d.path.length>1&&d.scheme==="file"?M=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?w?M=d.path.substr(1):M=d.path[1].toLowerCase()+d.path.substr(2):M=d.path,y.$i&&(M=M.replace(/\//g,"\\")),M}t.$wc=u;function c(d,w){const M=w?m:$;let p="",{scheme:P,authority:D,path:k,query:T,fragment:_}=d;if(P&&(p+=P,p+=":"),(D||P==="file")&&(p+=A,p+=A),D){let q=D.indexOf("@");if(q!==-1){const V=D.substr(0,q);D=D.substr(q+1),q=V.lastIndexOf(":"),q===-1?p+=M(V,!1,!1):(p+=M(V.substr(0,q),!1,!1),p+=":",p+=M(V.substr(q+1),!1,!0)),p+="@"}D=D.toLowerCase(),q=D.lastIndexOf(":"),q===-1?p+=M(D,!1,!0):(p+=M(D.substr(0,q),!1,!0),p+=D.substr(q))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const q=k.charCodeAt(1);q>=65&&q<=90&&(k=`/${String.fromCharCode(q+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const q=k.charCodeAt(0);q>=65&&q<=90&&(k=`${String.fromCharCode(q+32)}:${k.substr(2)}`)}p+=M(k,!0,!1)}return T&&(p+="?",p+=M(T,!1,!1)),_&&(p+="#",p+=w?_:$(_,!1,!1)),p}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(d){return d.match(l)?d.replace(l,w=>i(w)):d}}),te(ie[70],re([0,1,3,11,10,14,17,7]),function(W,t,F,y,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function h(v){N.$o&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}t.logOnceWebWorkerWarning=h;var A;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(A||(A={}));class b{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.method=M,this.args=p,this.type=0}}class g{constructor(d,w,M,p){this.vsWorker=d,this.seq=w,this.res=M,this.err=p,this.type=1}}class e{constructor(d,w,M,p){this.vsWorker=d,this.req=w,this.eventName=M,this.arg=p,this.type=2}}class E{constructor(d,w,M){this.vsWorker=d,this.req=w,this.event=M,this.type=3}}class R{constructor(d,w){this.vsWorker=d,this.req=w,this.type=4}}class L{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,w){const M=String(++this.b);return new Promise((p,P)=>{this.c[M]={resolve:p,reject:P},this.o(new b(this.a,M,d,w))})}listen(d,w){let M=null;const p=new y.$3d({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,p),this.o(new e(this.a,M,d,w))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new R(this.a,M)),M=null}});return p.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const w=this.c[d.seq];if(delete this.c[d.seq],d.err){let M=d.err;d.err.$isError&&(M=new Error,M.name=d.err.name,M.message=d.err.message,M.stack=d.err.stack),w.reject(M);return}w.resolve(d.res)}k(d){const w=d.req;this.g.handleMessage(d.method,d.args).then(p=>{this.o(new g(this.a,w,p,void 0))},p=>{p.detail instanceof Error&&(p.detail=(0,F.$3)(p.detail)),this.o(new g(this.a,w,void 0,(0,F.$3)(p)))})}l(d){const w=d.req,M=this.g.handleEvent(d.eventName,d.arg)(p=>{this.o(new E(this.a,w,p))});this.f.set(w,M)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const w=[];if(d.type===0)for(let M=0;M<d.args.length;M++)d.args[M]instanceof ArrayBuffer&&w.push(d.args[M]);else d.type===1&&d.res instanceof ArrayBuffer&&w.push(d.res);this.g.sendMessage(d,w)}}class $ extends r.$Tc{constructor(d,w,M){super();let p=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{p?.(q)})),this.c=new L({sendMessage:(q,V)=>{this.a.postMessage(q,V)},handleMessage:(q,V)=>{if(typeof M[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(M[q].apply(M,V))}catch(z){return Promise.reject(z)}},handleEvent:(q,V)=>{if(u(q)){const z=M[q].call(M,V);if(typeof z!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return z}if(m(q)){const z=M[q];if(typeof z!="function")throw new Error(`Missing event ${q} on main thread host.`);return z}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const D=globalThis.require;typeof D<"u"&&typeof D.getConfig=="function"?P=D.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const k=(0,o.$Pn)(M);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(P)),w,k]);const T=(q,V)=>this.g(q,V),_=(q,V)=>this.c.listen(q,V);this.f=new Promise((q,V)=>{p=V,this.b.then(z=>{q(c(z,T,_))},z=>{V(z),this.h("Worker failed to load "+w,z)})})}getProxyObject(){return this.f}g(d,w){return new Promise((M,p)=>{this.b.then(()=>{this.c.sendMessage(d,w).then(M,p)},p)})}h(d,w){console.error(d),console.info(w)}}t.SimpleWorkerClient=$;function m(v){return v[0]==="o"&&v[1]==="n"&&f.$gf(v.charCodeAt(2))}function u(v){return/^onDynamic/.test(v)&&f.$gf(v.charCodeAt(9))}function c(v,d,w){const M=D=>function(){const k=Array.prototype.slice.call(arguments,0);return d(D,k)},p=D=>function(k){return w(D,k)},P={};for(const D of v){if(u(D)){P[D]=p(D);continue}if(m(D)){P[D]=w(D,void 0);continue}P[D]=M(D)}return P}class i{constructor(d,w){this.a=w,this.b=null,this.c=new L({sendMessage:(M,p)=>{d(M,p)},handleMessage:(M,p)=>this.d(M,p),handleEvent:(M,p)=>this.f(M,p)})}onmessage(d){this.c.handleMessage(d)}d(d,w){if(d===a)return this.g(w[0],w[1],w[2],w[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,w))}catch(M){return Promise.reject(M)}}f(d,w){if(!this.b)throw new Error("Missing requestHandler");if(u(d)){const M=this.b[d].call(this.b,w);if(typeof M!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return M}if(m(d)){const M=this.b[d];if(typeof M!="function")throw new Error(`Missing event ${d} on request handler.`);return M}throw new Error(`Malformed event name ${d}`)}g(d,w,M,p){this.c.setWorkerId(d);const k=c(p,(T,_)=>this.c.sendMessage(T,_),(T,_)=>this.c.listen(T,_));return this.a?(this.b=this.a(k),Promise.resolve((0,o.$Pn)(this.b))):(w&&(typeof w.baseUrl<"u"&&delete w.baseUrl,typeof w.paths<"u"&&typeof w.paths.vs<"u"&&delete w.paths.vs,typeof w.trustedTypesPolicy<"u"&&delete w.trustedTypesPolicy,w.catchError=!0,globalThis.require.config(w)),new Promise((T,_)=>{(globalThis.require||W)([M],V=>{if(this.b=V.create(k),!this.b){_(new Error("No RequestHandler!"));return}T((0,o.$Pn)(this.b))},_)}))}}t.SimpleWorkerServer=i;function l(v){return new i(v,null)}t.create=l}),te(ie[66],re([62,63]),function(W,t){return W.create("vs/editor/common/languages",t)}),te(ie[67],re([0,1,41,18,42,2,60,66]),function(W,t,F,y,r,o,N,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$Vt=t.$Ut=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$Tt=t.$St=t.SymbolKinds=t.SymbolTag=t.$Rt=t.$Qt=t.SymbolKind=t.$Pt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Ot=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Nt=t.$Mt=t.$Lt=void 0;class a{constructor(U,X,J){this.offset=U,this.type=X,this.language=J,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$Lt=a;class s{constructor(U,X){this.tokens=U,this.endState=X,this._tokenizationResultBrand=void 0}}t.$Mt=s;class h{constructor(U,X){this.tokens=U,this.endState=X,this._encodedTokenizationResultBrand=void 0}}t.$Nt=h;var A;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(A||(t.CompletionItemKind=A={}));var b;(function(S){const U=new Map;U.set(0,F.$ik.symbolMethod),U.set(1,F.$ik.symbolFunction),U.set(2,F.$ik.symbolConstructor),U.set(3,F.$ik.symbolField),U.set(4,F.$ik.symbolVariable),U.set(5,F.$ik.symbolClass),U.set(6,F.$ik.symbolStruct),U.set(7,F.$ik.symbolInterface),U.set(8,F.$ik.symbolModule),U.set(9,F.$ik.symbolProperty),U.set(10,F.$ik.symbolEvent),U.set(11,F.$ik.symbolOperator),U.set(12,F.$ik.symbolUnit),U.set(13,F.$ik.symbolValue),U.set(15,F.$ik.symbolEnum),U.set(14,F.$ik.symbolConstant),U.set(15,F.$ik.symbolEnum),U.set(16,F.$ik.symbolEnumMember),U.set(17,F.$ik.symbolKeyword),U.set(27,F.$ik.symbolSnippet),U.set(18,F.$ik.symbolText),U.set(19,F.$ik.symbolColor),U.set(20,F.$ik.symbolFile),U.set(21,F.$ik.symbolReference),U.set(22,F.$ik.symbolCustomColor),U.set(23,F.$ik.symbolFolder),U.set(24,F.$ik.symbolTypeParameter),U.set(25,F.$ik.account),U.set(26,F.$ik.issues);function X(le){let n=U.get(le);return n||(console.info("No codicon found for CompletionItemKind "+le),n=F.$ik.symbolProperty),n}S.toIcon=X;const J=new Map;J.set("method",0),J.set("function",1),J.set("constructor",2),J.set("field",3),J.set("variable",4),J.set("class",5),J.set("struct",6),J.set("interface",7),J.set("module",8),J.set("property",9),J.set("event",10),J.set("operator",11),J.set("unit",12),J.set("value",13),J.set("constant",14),J.set("enum",15),J.set("enum-member",16),J.set("enumMember",16),J.set("keyword",17),J.set("snippet",27),J.set("text",18),J.set("color",19),J.set("file",20),J.set("reference",21),J.set("customcolor",22),J.set("folder",23),J.set("type-parameter",24),J.set("typeParameter",24),J.set("account",25),J.set("issue",26);function ee(le,n){let oe=J.get(le);return typeof oe>"u"&&!n&&(oe=9),oe}S.fromString=ee})(b||(t.CompletionItemKinds=b={}));var g;(function(S){S[S.Deprecated=1]="Deprecated"})(g||(t.CompletionItemTag=g={}));var e;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var E;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(t.CompletionTriggerKind=E={}));var R;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(R||(t.InlineCompletionTriggerKind=R={}));class L{constructor(U,X,J,ee){this.range=U,this.text=X,this.completionKind=J,this.isSnippetText=ee}equals(U){return o.$4s.lift(this.range).equalsRange(U.range)&&this.text===U.text&&this.completionKind===U.completionKind&&this.isSnippetText===U.isSnippetText}}t.$Ot=L;var $;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var m;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(m||(t.SignatureHelpTriggerKind=m={}));var u;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(u||(t.DocumentHighlightKind=u={}));function c(S){return S&&y.URI.isUri(S.uri)&&o.$4s.isIRange(S.range)&&(o.$4s.isIRange(S.originSelectionRange)||o.$4s.isIRange(S.targetSelectionRange))}t.$Pt=c;var i;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$Qt={17:(0,f.localize)(0,null),16:(0,f.localize)(1,null),4:(0,f.localize)(2,null),13:(0,f.localize)(3,null),8:(0,f.localize)(4,null),9:(0,f.localize)(5,null),21:(0,f.localize)(6,null),23:(0,f.localize)(7,null),7:(0,f.localize)(8,null),0:(0,f.localize)(9,null),11:(0,f.localize)(10,null),10:(0,f.localize)(11,null),19:(0,f.localize)(12,null),5:(0,f.localize)(13,null),1:(0,f.localize)(14,null),2:(0,f.localize)(15,null),20:(0,f.localize)(16,null),15:(0,f.localize)(17,null),18:(0,f.localize)(18,null),24:(0,f.localize)(19,null),3:(0,f.localize)(20,null),6:(0,f.localize)(21,null),14:(0,f.localize)(22,null),22:(0,f.localize)(23,null),25:(0,f.localize)(24,null),12:(0,f.localize)(25,null)};function l(S,U){return(0,f.localize)(26,null,S,t.$Qt[U])}t.$Rt=l;var v;(function(S){S[S.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var d;(function(S){const U=new Map;U.set(0,F.$ik.symbolFile),U.set(1,F.$ik.symbolModule),U.set(2,F.$ik.symbolNamespace),U.set(3,F.$ik.symbolPackage),U.set(4,F.$ik.symbolClass),U.set(5,F.$ik.symbolMethod),U.set(6,F.$ik.symbolProperty),U.set(7,F.$ik.symbolField),U.set(8,F.$ik.symbolConstructor),U.set(9,F.$ik.symbolEnum),U.set(10,F.$ik.symbolInterface),U.set(11,F.$ik.symbolFunction),U.set(12,F.$ik.symbolVariable),U.set(13,F.$ik.symbolConstant),U.set(14,F.$ik.symbolString),U.set(15,F.$ik.symbolNumber),U.set(16,F.$ik.symbolBoolean),U.set(17,F.$ik.symbolArray),U.set(18,F.$ik.symbolObject),U.set(19,F.$ik.symbolKey),U.set(20,F.$ik.symbolNull),U.set(21,F.$ik.symbolEnumMember),U.set(22,F.$ik.symbolStruct),U.set(23,F.$ik.symbolEvent),U.set(24,F.$ik.symbolOperator),U.set(25,F.$ik.symbolTypeParameter);function X(J){let ee=U.get(J);return ee||(console.info("No codicon found for SymbolKind "+J),ee=F.$ik.symbolProperty),ee}S.toIcon=X})(d||(t.SymbolKinds=d={}));class w{static asEditOperation(U){return r.$5s.replace(o.$4s.lift(U.range),U.text)}}t.$St=w;class M{static{this.Comment=new M("comment")}static{this.Imports=new M("imports")}static{this.Region=new M("region")}static fromValue(U){switch(U){case"comment":return M.Comment;case"imports":return M.Imports;case"region":return M.Region}return new M(U)}constructor(U){this.value=U}}t.$Tt=M;var p;(function(S){S[S.AIGenerated=1]="AIGenerated"})(p||(t.NewSymbolNameTag=p={}));var P;(function(S){function U(X){return!X||typeof X!="object"?!1:typeof X.id=="string"&&typeof X.title=="string"}S.is=U})(P||(t.Command=P={}));var D;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var k;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(k||(t.CommentThreadState=k={}));var T;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(T||(t.CommentMode=T={}));var _;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(_||(t.CommentState=_={}));var q;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(q||(t.InlayHintKind=q={}));class V{constructor(U){this.b=U,this.a=null}dispose(){this.a&&this.a.then(U=>{U&&U.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$Ut=V,t.$Vt=new N.$Ct;var z;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(z||(t.ExternalUriOpenerPriority=z={}))}),te(ie[68],re([0,1,24,11,37,18,5,2,43,67,59]),function(W,t,F,y,r,o,N,f,a,s,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G1=t.$F1=void 0;class A{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,E){return(0,r.$dr)(e,E)}}t.$F1=A;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:F.$ae,Emitter:y.$3d,KeyCode:h.KeyCode,KeyMod:A,Position:N.$3s,Range:f.$4s,Selection:a.$6s,SelectionDirection:h.SelectionDirection,MarkerSeverity:h.MarkerSeverity,MarkerTag:h.MarkerTag,Uri:o.URI,Token:s.$Lt}}t.$G1=b}),te(ie[71],re([0,1,25,18,5,2,56,29,52,53,68,23,58,33,50,14,3,51]),function(W,t,F,y,r,o,N,f,a,s,h,A,b,g,e,E,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends N.$uv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const l=[];for(let v=0;v<this.f.length;v++){const d=this.f[v],w=this.offsetAt(new r.$3s(v+1,1)),M=d.matchAll(i);for(const p of M)(p.index||p.index===0)&&(p.index=p.index+w),l.push(p)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,l){const v=(0,f.$Gs)(i.column,(0,f.$Es)(l),this.f[i.lineNumber-1],0);return v?new o.$4s(i.lineNumber,v.startColumn,i.lineNumber,v.endColumn):null}getWordUntilPosition(i,l){const v=this.getWordAtPosition(i,l);return v?{word:this.f[i.lineNumber-1].substring(v.startColumn-1,i.column-1),startColumn:v.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const l=this.f,v=this.q.bind(this);let d=0,w="",M=0,p=[];return{*[Symbol.iterator](){for(;;)if(M<p.length){const P=w.substring(p[M].start,p[M].end);M+=1,yield P}else if(d<l.length)w=l[d],p=v(w,i),M=0,d+=1;else break}}}getLineWords(i,l){const v=this.f[i-1],d=this.q(v,l),w=[];for(const M of d)w.push({word:v.substring(M.start,M.end),startColumn:M.start+1,endColumn:M.end+1});return w}q(i,l){const v=[];let d;for(l.lastIndex=0;(d=l.exec(i))&&d[0].length!==0;)v.push({start:d.index,end:d.index+d[0].length});return v}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const l=this.g,v=i.startLineNumber-1,d=i.endLineNumber-1,w=[];w.push(this.f[v].substring(i.startColumn-1));for(let M=v+1;M<d;M++)w.push(this.f[M]);return w.push(this.f[d].substring(0,i.endColumn-1)),w.join(l)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const l=this.j.getIndexOf(i),v=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,v)}}r(i){const l=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),v=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return l.lineNumber!==i.startLineNumber||l.column!==i.startColumn||v.lineNumber!==i.endLineNumber||v.column!==i.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:v.lineNumber,endColumn:v.column}:i}s(i){if(!r.$3s.isIPosition(i))throw new Error("bad position");let{lineNumber:l,column:v}=i,d=!1;if(l<1)l=1,v=1,d=!0;else if(l>this.f.length)l=this.f.length,v=this.f[l-1].length+1,d=!0;else{const w=this.f[l-1].length+1;v<1?(v=1,d=!0):v>w&&(v=w,d=!0)}return d?{lineNumber:l,column:v}:i}}class m{constructor(i,l){this.d=i,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(l=>i.push(this.f[l])),i}acceptNewModel(i){this.f[i.url]=new $(y.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,l){if(!this.f[i])return;this.f[i].onEvents(l)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,l,v){const d=this.j(i);return d?b.$A1.computeUnicodeHighlights(d,l,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,l,v,d){const w=this.j(i),M=this.j(l);return!w||!M?null:m.l(w,M,v,d)}static l(i,l,v,d){const w=d==="advanced"?e.$31.getDefault():e.$31.getLegacy(),M=i.getLinesContent(),p=l.getLinesContent(),P=w.computeDiff(M,p,v),D=P.changes.length>0?!1:this.n(i,l);function k(T){return T.map(_=>[_.original.startLineNumber,_.original.endLineNumberExclusive,_.modified.startLineNumber,_.modified.endLineNumberExclusive,_.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:D,quitEarly:P.hitTimeout,changes:k(P.changes),moves:P.moves.map(T=>[T.lineRangeMapping.original.startLineNumber,T.lineRangeMapping.original.endLineNumberExclusive,T.lineRangeMapping.modified.startLineNumber,T.lineRangeMapping.modified.endLineNumberExclusive,k(T.changes)])}}static n(i,l){const v=i.getLineCount(),d=l.getLineCount();if(v!==d)return!1;for(let w=1;w<=v;w++){const M=i.getLineContent(w),p=l.getLineContent(w);if(M!==p)return!1}return!0}async computeDirtyDiff(i,l,v){const d=this.j(i),w=this.j(l);if(!d||!w)return null;const M=d.getLinesContent(),p=w.getLinesContent();return new g.$it(M,p,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(i,l,v){const d=this.j(i);if(!d)return l;const w=[];let M;l=l.slice(0).sort((P,D)=>{if(P.range&&D.range)return o.$4s.compareRangesUsingStarts(P.range,D.range);const k=P.range?0:1,T=D.range?0:1;return k-T});let p=0;for(let P=1;P<l.length;P++)o.$4s.getEndPosition(l[p].range).equals(o.$4s.getStartPosition(l[P].range))?(l[p].range=o.$4s.fromPositions(o.$4s.getStartPosition(l[p].range),o.$4s.getEndPosition(l[P].range)),l[p].text+=l[P].text):(p++,l[p]=l[P]);l.length=p+1;for(let{range:P,text:D,eol:k}of l){if(typeof k=="number"&&(M=k),o.$4s.isEmpty(P)&&!D)continue;const T=d.getValueInRange(P);if(D=D.replace(/\r\n|\n|\r/g,d.eol),T===D)continue;if(Math.max(D.length,T.length)>m.o){w.push({range:P,text:D});continue}const _=(0,F.$9s)(T,D,v),q=d.offsetAt(o.$4s.lift(P).getStartPosition());for(const V of _){const z=d.positionAt(q+V.originalStart),S=d.positionAt(q+V.originalStart+V.originalLength),U={text:D.substr(V.modifiedStart,V.modifiedLength),range:{startLineNumber:z.lineNumber,startColumn:z.column,endLineNumber:S.lineNumber,endColumn:S.column}};d.getValueInRange(U.range)!==U.text&&w.push(U)}}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}computeHumanReadableDiff(i,l,v){const d=this.j(i);if(!d)return l;const w=[];let M;l=l.slice(0).sort((p,P)=>{if(p.range&&P.range)return o.$4s.compareRangesUsingStarts(p.range,P.range);const D=p.range?0:1,k=P.range?0:1;return D-k});for(let{range:p,text:P,eol:D}of l){let z=function(U,X){return new r.$3s(U.lineNumber+X.lineNumber-1,X.lineNumber===1?U.column+X.column-1:X.column)},S=function(U,X){const J=[];for(let ee=X.startLineNumber;ee<=X.endLineNumber;ee++){const le=U[ee-1];ee===X.startLineNumber&&ee===X.endLineNumber?J.push(le.substring(X.startColumn-1,X.endColumn-1)):ee===X.startLineNumber?J.push(le.substring(X.startColumn-1)):ee===X.endLineNumber?J.push(le.substring(0,X.endColumn-1)):J.push(le)}return J};if(typeof D=="number"&&(M=D),o.$4s.isEmpty(p)&&!P)continue;const k=d.getValueInRange(p);if(P=P.replace(/\r\n|\n|\r/g,d.eol),k===P)continue;if(Math.max(P.length,k.length)>m.o){w.push({range:p,text:P});continue}const T=k.split(/\r\n|\n|\r/),_=P.split(/\r\n|\n|\r/),q=e.$31.getDefault().computeDiff(T,_,v),V=o.$4s.lift(p).getStartPosition();for(const U of q.changes)if(U.innerChanges)for(const X of U.innerChanges)w.push({range:o.$4s.fromPositions(z(V,X.originalRange.getStartPosition()),z(V,X.originalRange.getEndPosition())),text:S(_,X.modifiedRange).join(d.eol)});else throw new R.$cb("The experimental diff algorithm always produces inner changes")}return typeof M=="number"&&w.push({eol:M,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),w}async computeLinks(i){const l=this.j(i);return l?(0,a.$D1)(l):null}async computeDefaultDocumentColors(i){const l=this.j(i);return l?(0,L.$41)(l):null}static{this.p=1e4}async textualSuggest(i,l,v,d){const w=new A.$Yd,M=new RegExp(v,d),p=new Set;e:for(const P of i){const D=this.j(P);if(D){for(const k of D.words(M))if(!(k===l||!isNaN(Number(k)))&&(p.add(k),p.size>m.p))break e}}return{words:Array.from(p),duration:w.elapsed()}}async computeWordRanges(i,l,v,d){const w=this.j(i);if(!w)return Object.create(null);const M=new RegExp(v,d),p=Object.create(null);for(let P=l.startLineNumber;P<l.endLineNumber;P++){const D=w.getLineWords(P,M);for(const k of D){if(!isNaN(Number(k.word)))continue;let T=p[k.word];T||(T=[],p[k.word]=T),T.push({startLineNumber:P,startColumn:k.startColumn,endLineNumber:P,endColumn:k.endColumn})}}return p}async navigateValueSet(i,l,v,d,w){const M=this.j(i);if(!M)return null;const p=new RegExp(d,w);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const P=M.getValueInRange(l),D=M.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},p);if(!D)return null;const k=M.getValueInRange(D);return s.$E1.INSTANCE.navigateValueSet(l,P,D,k,v)}loadForeignModule(i,l,v){const d=(p,P)=>this.d.fhr(p,P),M={host:(0,E.$Qn)(v,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(M,l),Promise.resolve((0,E.$Pn)(this.h))):new Promise((p,P)=>{W([i],D=>{this.h=D.create(M,l),p((0,E.$Pn)(this.h))},P)})}fmr(i,l){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,l))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=m;function u(c){return new m(c,null)}t.create=u,typeof importScripts=="function"&&(globalThis.monaco=(0,h.$G1)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d84c946d27b649d614319c796911871320befd42/core/vs/base/worker/workerMain.js.map
