/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/uri","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],O=0,A=se.length;O<A;O++)e[O]=le[se[O]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const j=new Map,L=new Map,I=new Map,R=new Map;function k(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function g(h,$){const p=h.get($.detail);p&&(p>=0||h.set($.detail,p+$.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of C)switch(h.type){case 10:k(j,h);break;case 11:case 12:g(j,h);break;case 21:k(L,h);break;case 22:g(L,h);break;case 33:k(I,h);break;case 34:g(I,h);break;case 31:k(R,h);break;case 32:g(R,h);break}let S=0;I.forEach(h=>S+=h);function m(h){const $=[];return h.forEach((p,E)=>$.push([E,p])),$}return{amdLoad:m(j),amdInvoke:m(L),nodeRequire:m(I),nodeEval:m(R),nodeRequireTotal:S}}static toMarkdownTable(j,L){let I="";const R=[];return j.forEach((k,g)=>{R[g]=k.length}),L.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;R[C]=Math.max(S,R[C])})}),j.forEach((k,g)=>{I+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),I+=`|
`,j.forEach((k,g)=>{I+=`| ${"-".repeat(R[g])} `}),I+=`|
`,L.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=O}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function O(p,E,l){const u=A(p,E);if(u!==-1)return p[u]}e.$fb=O;function A(p,E,l=p.length-1){for(let u=l;u>=0;u--){const d=p[u];if(E(d))return u}return-1}e.$gb=A;function j(p,E){const l=L(p,E);return l===-1?void 0:p[l]}e.$hb=j;function L(p,E,l=0,u=p.length){let d=l,c=u;for(;d<c;){const y=Math.floor((d+c)/2);E(p[y])?d=y+1:c=y}return d-1}e.$ib=L;function I(p,E){const l=R(p,E);return l===p.length?void 0:p[l]}e.$jb=I;function R(p,E,l=0,u=p.length){let d=l,c=u;for(;d<c;){const y=Math.floor((d+c)/2);E(p[y])?c=y:d=y+1}return d}e.$kb=R;function k(p,E,l=0,u=p.length){const d=R(p,E,l,u);return d===p.length?-1:d}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(E){this.e=E,this.c=0}findLastMonotonous(E){if(g.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!E(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=E}const l=L(this.e,E,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(p,E){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const d=p[u];E(d,l)>0&&(l=d)}return l}e.$nb=C;function S(p,E){if(p.length===0)return;let l=p[0];for(let u=1;u<p.length;u++){const d=p[u];E(d,l)>=0&&(l=d)}return l}e.$ob=S;function m(p,E){return C(p,(l,u)=>-E(l,u))}e.$pb=m;function h(p,E){if(p.length===0)return-1;let l=0;for(let u=1;u<p.length;u++){const d=p[u];E(d,p[l])>0&&(l=u)}return l}e.$qb=h;function $(p,E){for(const l of p){const u=E(l);if(u!==void 0)return u}}e.$rb=$}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function O(I,R){const k=Object.create(null);for(const g of I){const C=R(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$K=O;function A(I,R){const k=[],g=[];for(const C of I)R.has(C)||k.push(C);for(const C of R)I.has(C)||g.push(C);return{removed:k,added:g}}e.$L=A;function j(I,R){const k=[],g=[];for(const[C,S]of I)R.has(C)||k.push(S);for(const[C,S]of R)I.has(C)||g.push(S);return{removed:k,added:g}}e.$M=j;function L(I,R){const k=new Set;for(const g of R)I.has(g)&&k.add(g);return k}e.$N=L}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=void 0;function O(I){return(R,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=I(S,k)}}function A(I,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[g]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[S]}}e.$Gh=A;function j(I,R,k){return O((g,C)=>{const S=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...h){this[m]||(this[m]=k?k():void 0),clearTimeout(this[S]),R&&(this[m]=R(this[m],...h),h=[this[m]]),this[S]=setTimeout(()=>{g.apply(this,h),this[m]=k?k():void 0},I)}})}e.$Hh=j;function L(I,R,k){return O((g,C)=>{const S=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...p){if(this[m]||(this[m]=k?k():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...p)),this[$])return;const E=this[h]+I;E<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0},E-Date.now()))}})}e.$Ih=L}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=O,e.$X=new O;function A(y){e.$X.setUnexpectedErrorHandler(y)}e.setUnexpectedErrorHandler=A;function j(y){if(!y||typeof y!="object")return!1;const i=y;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=j;function L(y){g(y)||e.$X.onUnexpectedError(y)}e.$1=L;function I(y){g(y)||e.$X.onUnexpectedExternalError(y)}e.$2=I;function R(y){if(y instanceof Error){const{name:i,message:o}=y,n=y.stacktrace||y.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(y)}}return y}e.$3=R;const k="Canceled";function g(y){return y instanceof C?!0:y instanceof Error&&y.name===k&&y.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const y=new Error(k);return y.name=y.message,y}e.$6=S;function m(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}e.$7=m;function h(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}e.$8=h;class $ extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function p(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}e.$0=p;class E extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=E;class l extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=l;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=d;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function j(q,X=0){return q[q.length-(1+X)]}e.$sb=j;function L(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=L;function I(q,X,_=(ie,J)=>ie===J){if(q===X)return!0;if(!q||!X||q.length!==X.length)return!1;for(let ie=0,J=q.length;ie<J;ie++)if(!_(q[ie],X[ie]))return!1;return!0}e.$ub=I;function R(q,X){const _=q.length-1;X<_&&(q[X]=q[_]),q.pop()}e.$vb=R;function k(q,X,_){return g(q.length,ie=>_(q[ie],X))}e.$wb=k;function g(q,X){let _=0,ie=q-1;for(;_<=ie;){const J=(_+ie)/2|0,ne=X(J);if(ne<0)_=J+1;else if(ne>0)ie=J-1;else return J}return-(_+1)}e.$xb=g;function C(q,X,_){if(q=q|0,q>=X.length)throw new TypeError("invalid index");const ie=X[Math.floor(X.length*Math.random())],J=[],ne=[],ce=[];for(const fe of X){const de=_(fe,ie);de<0?J.push(fe):de>0?ne.push(fe):ce.push(fe)}return q<J.length?C(q,J,_):q<J.length+ce.length?ce[0]:C(q-(J.length+ce.length),ne,_)}e.$yb=C;function S(q,X){const _=[];let ie;for(const J of q.slice(0).sort(X))!ie||X(ie[0],J)!==0?(ie=[J],_.push(ie)):ie.push(J);return _}e.$zb=S;function*m(q,X){let _,ie;for(const J of q)ie!==void 0&&X(ie,J)?_.push(J):(_&&(yield _),_=[J]),ie=J;_&&(yield _)}e.$Ab=m;function h(q,X){for(let _=0;_<=q.length;_++)X(_===0?void 0:q[_-1],_===q.length?void 0:q[_])}e.$Bb=h;function $(q,X){for(let _=0;_<q.length;_++)X(_===0?void 0:q[_-1],q[_],_+1===q.length?void 0:q[_+1])}e.$Cb=$;function p(q,X,_){const ie=[];function J(fe,de,me){if(de===0&&me.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...me)):ie.push({start:fe,deleteCount:de,toInsert:me})}let ne=0,ce=0;for(;;){if(ne===q.length){J(ne,0,X.slice(ce));break}if(ce===X.length){J(ne,q.length-ne,[]);break}const fe=q[ne],de=X[ce],me=_(fe,de);me===0?(ne+=1,ce+=1):me<0?(J(ne,1,[]),ne+=1):me>0&&(J(ne,0,[de]),ce+=1)}return ie}e.$Db=p;function E(q,X,_){const ie=p(q,X,_),J=[],ne=[];for(const ce of ie)J.push(...q.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:J,added:ne}}e.$Eb=E;function l(q,X,_){if(_===0)return[];const ie=q.slice(0,_).sort(X);return d(q,X,ie,_,q.length),ie}e.top=l;function u(q,X,_,ie,J){return _===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const fe=q.length,de=q.slice(0,_).sort(X);for(let me=_,Ee=Math.min(_+ie,fe);me<fe;me=Ee,Ee=Math.min(Ee+ie,fe)){if(me>_&&await new Promise(Re=>setTimeout(Re)),J&&J.isCancellationRequested)throw new O.$5;d(q,X,de,me,Ee)}return de})().then(ne,ce)})}e.$Gb=u;function d(q,X,_,ie,J){for(const ne=_.length;ie<J;ie++){const ce=q[ie];if(X(ce,_[ne-1])<0){_.pop();const fe=(0,A.$kb)(_,de=>X(ce,de)<0);_.splice(fe,0,ce)}}}function c(q){return q.filter(X=>!!X)}e.$Hb=c;function y(q){let X=0;for(let _=0;_<q.length;_++)q[_]&&(q[X]=q[_],X+=1);q.length=X}e.$Ib=y;function i(q,X,_){q.splice(_,0,q.splice(X,1)[0])}e.$Jb=i;function o(q){return!Array.isArray(q)||q.length===0}e.$Kb=o;function n(q){return Array.isArray(q)&&q.length>0}e.$Lb=n;function s(q,X=_=>_){const _=new Set;return q.filter(ie=>{const J=X(ie);return _.has(J)?!1:(_.add(J),!0)})}e.$Mb=s;function t(q){const X=new Set;return _=>{const ie=q(_);return X.has(ie)?!1:(X.add(ie),!0)}}e.$Nb=t;function r(q,X){return q.length>0?q[0]:X}e.$Ob=r;function a(q,X){return q.length>0?q[q.length-1]:X}e.$Pb=a;function v(q,X,_=(ie,J)=>ie===J){let ie=0;for(let J=0,ne=Math.min(q.length,X.length);J<ne&&_(q[J],X[J]);J++)ie++;return ie}e.$Qb=v;function w(q){return[].concat(...q)}e.$Rb=w;function f(q,X){let _=typeof X=="number"?q:0;typeof X=="number"?_=q:(_=0,X=q);const ie=[];if(_<=X)for(let J=_;J<X;J++)ie.push(J);else for(let J=_;J>X;J--)ie.push(J);return ie}e.$Sb=f;function b(q,X,_){return q.reduce((ie,J)=>(ie[X(J)]=_?_(J):J,ie),Object.create(null))}e.$Tb=b;function P(q,X){return q.push(X),()=>N(q,X)}e.$Ub=P;function N(q,X){const _=q.indexOf(X);if(_>-1)return q.splice(_,1),X}e.$Vb=N;function F(q,X,_){const ie=q.slice(0,X),J=q.slice(X);return ie.concat(_,J)}e.$Wb=F;function M(q,X){let _;if(typeof X=="number"){let ie=X;_=()=>{const J=Math.sin(ie++)*179426549;return J-Math.floor(J)}}else _=Math.random;for(let ie=q.length-1;ie>0;ie-=1){const J=Math.floor(_()*(ie+1)),ne=q[ie];q[ie]=q[J],q[J]=ne}}e.$Xb=M;function U(q,X){const _=q.indexOf(X);_>-1&&(q.splice(_,1),q.unshift(X))}e.$Yb=U;function Y(q,X){const _=q.indexOf(X);_>-1&&(q.splice(_,1),q.push(X))}e.$Zb=Y;function Q(q,X){for(const _ of X)q.push(_)}e.$1b=Q;function x(q,X){return Array.isArray(q)?q.map(X):X(q)}e.$2b=x;function G(q){return Array.isArray(q)?q:[q]}e.$3b=G;function Z(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=Z;function H(q,X,_){const ie=te(q,X),J=q.length,ne=_.length;q.length=J+ne;for(let ce=J-1;ce>=ie;ce--)q[ce+ne]=q[ce];for(let ce=0;ce<ne;ce++)q[ce+ie]=_[ce]}e.$5b=H;function V(q,X,_,ie){const J=te(q,X);let ne=q.splice(J,_);return ne===void 0&&(ne=[]),H(q,J,ie),ne}e.$6b=V;function te(q,X){return X<0?Math.max(X+q.length,0):Math.min(X,q.length)}var oe;(function(q){function X(ne){return ne<0}q.isLessThan=X;function _(ne){return ne<=0}q.isLessThanOrEqual=_;function ie(ne){return ne>0}q.isGreaterThan=ie;function J(ne){return ne===0}q.isNeitherLessOrGreaterThan=J,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function ee(q,X){return(_,ie)=>X(q(_),q(ie))}e.$7b=ee;function ae(...q){return(X,_)=>{for(const ie of q){const J=ie(X,_);if(!oe.isNeitherLessOrGreaterThan(J))return J}return oe.neitherLessOrGreaterThan}}e.$8b=ae;const W=(q,X)=>q-X;e.$9b=W;const z=(q,X)=>(0,e.$9b)(q?1:0,X?1:0);e.$0b=z;function D(q){return(X,_)=>-q(X,_)}e.$$b=D;class T{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let _=this.c;for(;_<this.g.length&&X(this.g[_]);)_++;const ie=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ie}takeFromEndWhile(X){let _=this.d;for(;_>=0&&X(this.g[_]);)_--;const ie=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const _=this.g.slice(this.c,this.c+X);return this.c+=X,_}}e.$_b=T;class B{static{this.empty=new B(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(_=>(X(_),!0))}toArray(){const X=[];return this.iterate(_=>(X.push(_),!0)),X}filter(X){return new B(_=>this.iterate(ie=>X(ie)?_(ie):!0))}map(X){return new B(_=>this.iterate(ie=>_(X(ie))))}some(X){let _=!1;return this.iterate(ie=>(_=X(ie),!_)),_}findFirst(X){let _;return this.iterate(ie=>X(ie)?(_=ie,!1):!0),_}findLast(X){let _;return this.iterate(ie=>(X(ie)&&(_=ie),!0)),_}findLastMaxBy(X){let _,ie=!0;return this.iterate(J=>((ie||oe.isGreaterThan(X(J,_)))&&(ie=!1,_=J),!0)),_}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function A(g,C){if(!g)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=A;function j(g,C="Unreachable"){throw new Error(C)}e.$9c=j;function L(g){if(!g)throw new O.$cb("Assertion Failed")}e.$0c=L;function I(g){g||(0,O.$1)(new O.$cb("Assertion Failed"))}e.$$c=I;function R(g){if(!g()){debugger;g(),(0,O.$1)(new O.$cb("Assertion Failed"))}}e.$_c=R;function k(g,C){let S=0;for(;S<g.length-1;){const m=g[S],h=g[S+1];if(!C(m,h))return!1;S++}return!0}e.$ad=k}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function O(A,j){const L=this;let I=!1,R;return function(){if(I)return R;if(I=!0,j)try{R=A.apply(L,arguments)}finally{j()}else R=A.apply(L,arguments);return R}}e.$db=O}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(A){function j(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}A.is=j;const L=Object.freeze([]);function I(){return L}A.empty=I;function*R(i){yield i}A.single=R;function k(i){return j(i)?i:R(i)}A.wrap=k;function g(i){return i||L}A.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}A.reverse=C;function S(i){return!i||i[Symbol.iterator]().next().done===!0}A.isEmpty=S;function m(i){return i[Symbol.iterator]().next().value}A.first=m;function h(i,o){for(const n of i)if(o(n))return!0;return!1}A.some=h;function $(i,o){for(const n of i)if(o(n))return n}A.find=$;function*p(i,o){for(const n of i)o(n)&&(yield n)}A.filter=p;function*E(i,o){let n=0;for(const s of i)yield o(s,n++)}A.map=E;function*l(...i){for(const o of i)yield*o}A.concat=l;function u(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}A.reduce=u;function*d(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}A.slice=d;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,A.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}A.consume=c;async function y(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}A.asyncToArray=y})(O||(e.Iterable=O={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var A;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var j;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function I(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function w(U){let Y=0,Q=0;for(;Y<U;){const x=i.charCodeAt(n);if(x>=48&&x<=57)Q=Q*16+x-48;else if(x>=65&&x<=70)Q=Q*16+x-65+10;else if(x>=97&&x<=102)Q=Q*16+x-97+10;else break;n++,Y++}return Y<U&&(Q=-1),Q}function f(U){n=U,t="",r=0,a=16,v=0}function b(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return v=3,i.substring(U,n);let Y=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Y=n}else v=3;return i.substring(U,Y)}function P(){let U="",Y=n;for(;;){if(n>=s){U+=i.substring(Y,n),v=2;break}const Q=i.charCodeAt(n);if(Q===34){U+=i.substring(Y,n),n++;break}if(Q===92){if(U+=i.substring(Y,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const G=w(4);G>=0?U+=String.fromCharCode(G):v=4;break}default:v=5}Y=n;continue}if(Q>=0&&Q<=31)if(k(Q)){U+=i.substring(Y,n),v=2;break}else v=6;n++}return U}function N(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let U=i.charCodeAt(n);if(R(U)){do n++,t+=String.fromCharCode(U),U=i.charCodeAt(n);while(R(U));return a=15}if(k(U))return n++,t+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=P(),a=10;case 47:{const Y=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return t=i.substring(Y,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const Q=s-1;let x=!1;for(;n<Q;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,v=1),t=i.substring(Y,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=b(),a=11;default:for(;n<s&&F(U);)n++,U=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function F(U){if(R(U)||k(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:f,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$kn=I;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function S(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,f,b,P){r.value=w,r.offset=f,r.length=b,r.type=P,r.colonOffset=void 0,t=r}try{d(i,{onObjectBegin:(w,f)=>{if(o<=w)throw s;t=void 0,a=o>w,n.push("")},onObjectProperty:(w,f,b)=>{if(o<f||(v(w,f,b,"property"),n[n.length-1]=w,o<=f+b))throw s},onObjectEnd:(w,f)=>{if(o<=w)throw s;t=void 0,n.pop()},onArrayBegin:(w,f)=>{if(o<=w)throw s;t=void 0,n.push(0)},onArrayEnd:(w,f)=>{if(o<=w)throw s;t=void 0,n.pop()},onLiteralValue:(w,f,b)=>{if(o<f||(v(w,f,b,y(w)),o<=f+b))throw s},onSeparator:(w,f,b)=>{if(o<=f)throw s;if(w===":"&&t&&t.type==="property")t.colonOffset=f,a=!1,t=void 0;else if(w===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(w){if(w!==s)throw w}return{path:n,previousNode:t,isAtPropertyKey:a,matches:w=>{let f=0;for(let b=0;f<w.length&&b<n.length;b++)if(w[f]===n[b]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.$ln=S;function m(i,o=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):s!==null&&(t[s]=w)}return d(i,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,s=null},onObjectProperty:w=>{s=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,f,b)=>{o.push({error:w,offset:f,length:b})}},n),t[0]}e.$mn=m;function h(i,o=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){s.type==="property"&&(s.length=w-s.offset,s=s.parent)}function r(w){return s.children.push(w),w}d(i,{onObjectBegin:w=>{s=r({type:"object",offset:w,length:-1,parent:s,children:[]})},onObjectProperty:(w,f,b)=>{s=r({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:w,offset:f,length:b,parent:s})},onObjectEnd:(w,f)=>{s.length=w+f-s.offset,s=s.parent,t(w+f)},onArrayBegin:(w,f)=>{s=r({type:"array",offset:w,length:-1,parent:s,children:[]})},onArrayEnd:(w,f)=>{s.length=w+f-s.offset,s=s.parent,t(w+f)},onLiteralValue:(w,f,b)=>{r({type:y(w),offset:f,length:b,parent:s,value:w}),t(f+b)},onSeparator:(w,f,b)=>{s.type==="property"&&(w===":"?s.colonOffset=f:w===","&&t(f))},onError:(w,f,b)=>{o.push({error:w,offset:f,length:b})}},n);const v=s.children[0];return v&&delete v.parent,v}e.$nn=h;function $(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$on=$;function p(i){if(!i.parent||!i.parent.children)return[];const o=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$pn=p;function E(i){switch(i.type){case"array":return i.children.map(E);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=E(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$qn=E;function l(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$rn=l;function u(i,o,n=!1){if(l(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=u(s[t],o,n);if(r)return r}return i}}e.$sn=u;function d(i,o,n=L.DEFAULT){const s=I(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),f=t(o.onArrayBegin),b=t(o.onArrayEnd),P=r(o.onLiteralValue),N=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),U=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function Q(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:U||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:U?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],W=[]){if(M(ee),ae.length+W.length>0){let z=s.getToken();for(;z!==17;){if(ae.indexOf(z)!==-1){Q();break}else if(W.indexOf(z)!==-1)break;z=Q()}}}function G(ee){const ae=s.getTokenValue();return ee?P(ae):v(ae),Q(),!0}function Z(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}P(ee);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return Q(),!0}function H(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(G(!1),s.getToken()===6?(N(":"),Q(),oe()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),Q();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===2&&Y)break}else ee&&x(6,[],[]);H()||x(4,[],[2,5]),ee=!0}return w(),s.getToken()!==2?x(7,[2],[]):Q(),!0}function te(){f(),Q();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===4&&Y)break}else ee&&x(6,[],[]);oe()||x(4,[],[4,5]),ee=!0}return b(),s.getToken()!==4?x(8,[4],[]):Q(),!0}function oe(){switch(s.getToken()){case 3:return te();case 1:return V();case 10:return G(!0);default:return Z()}}return Q(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):oe()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$tn=d;function c(i,o){const n=I(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$un=c;function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$vn=y}),define(le[42],he([0,1,34]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=e.$wn=void 0;function A(g,C,S){let m,h,$,p,E;if(C){for(p=C.offset,E=p+C.length,$=p;$>0&&!k(g,$-1);)$--;let a=E;for(;a<g.length&&!k(g,a);)a++;h=g.substring($,a),m=I(h,S)}else h=g,m=0,$=0,p=0,E=g.length;const l=R(S,g);let u=!1,d=0,c;S.insertSpaces?c=L(" ",S.tabSize||4):c="	";const y=(0,O.$kn)(h,!1);let i=!1;function o(){return l+L(c,m+d)}function n(){let a=y.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=y.scan();return i=a===16||y.getTokenError()!==0,a}const s=[];function t(a,v,w){!i&&v<E&&w>p&&g.substring(v,w)!==a&&s.push({offset:v,length:w-v,content:a})}let r=n();if(r!==17){const a=y.getTokenOffset()+$,v=L(c,m);t(v,$,a)}for(;r!==17;){let a=y.getTokenOffset()+y.getTokenLength()+$,v=n(),w="";for(;!u&&(v===12||v===13);){const b=y.getTokenOffset()+$;t(" ",a,b),a=y.getTokenOffset()+y.getTokenLength()+$,w=v===12?o():"",v=n()}if(v===2)r!==1&&(d--,w=o());else if(v===4)r!==3&&(d--,w=o());else{switch(r){case 3:case 1:d++,w=o();break;case 5:case 12:w=o();break;case 13:u?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}u&&(v===12||v===13)&&(w=o())}const f=y.getTokenOffset()+$;t(w,a,f),r=v}return s}e.$wn=A;function j(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$xn=j;function L(g,C){let S="";for(let m=0;m<C;m++)S+=g;return S}function I(g,C){let S=0,m=0;const h=C.tabSize||4;for(;S<g.length;){const $=g.charAt(S);if($===" ")m++;else if($==="	")m+=h;else break;S++}return Math.floor(m/h)}function R(g,C){for(let S=0;S<C.length;S++){const m=C.charAt(S);if(m==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.$yn=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$zn=k}),define(le[62],he([0,1,34,42]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=void 0;function j(g,C,S){return L(g,C,void 0,S)}e.$An=j;function L(g,C,S,m,h){const $=C.slice(),p=[],E=(0,O.$nn)(g,p);let l,u;for(;$.length>0&&(u=$.pop(),l=(0,O.$on)(E,$),l===void 0&&S!==void 0);)typeof u=="string"?S={[u]:S}:S=[S];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const d=(0,O.$on)(l,[u]);if(d!==void 0)if(S===void 0){if(!d.parent)throw new Error("Malformed AST");const c=l.children.indexOf(d.parent);let y,i=d.parent.offset+d.parent.length;if(c>0){const o=l.children[c-1];y=o.offset+o.length}else y=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return I(g,{offset:y,length:i-y,content:""},m)}else return I(g,{offset:d.offset,length:d.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const c=`${JSON.stringify(u)}: ${JSON.stringify(S)}`,y=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let i;if(y>0){const o=l.children[y-1];i={offset:o.offset+o.length,length:0,content:","+c}}else l.children.length===0?i={offset:l.offset+1,length:0,content:c}:i={offset:l.offset+1,length:0,content:c+","};return I(g,i,m)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(S!==void 0){const d=`${JSON.stringify(S)}`;let c;if(l.children.length===0||u===0)c={offset:l.offset+1,length:0,content:l.children.length===0?d:d+","};else{const y=u===-1||u>l.children.length?l.children.length:u,i=l.children[y-1];c={offset:i.offset+i.length,length:0,content:","+d}}return I(g,c,m)}else{const d=u,c=l.children[d];let y;if(l.children.length===1)y={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===d){const i=l.children[d-1],o=i.offset+i.length,n=l.offset+l.length;y={offset:o,length:n-2-o,content:""}}else y={offset:c.offset,length:l.children[d+1].offset-c.offset,content:""};return I(g,y,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(S)},m)}}e.$Bn=L;function I(g,C,S){let m=R(g,C),h=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,A.$zn)(m,h-1);)h--;for(;$<m.length&&!(0,A.$zn)(m,$);)$++}const p=(0,A.$wn)(m,{offset:h,length:$-h},S);for(let l=p.length-1;l>=0;l--){const u=p[l];m=R(m,u),h=Math.min(h,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const E=g.length-(m.length-$)-h;return[{offset:h,length:E,content:m.substring(h,$)}]}e.$Cn=I;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$Dn=R;function k(g,C){const S=C.slice(0).sort((h,$)=>{const p=h.offset-$.offset;return p===0?h.length-$.length:p});let m=g.length;for(let h=S.length-1;h>=0;h--){const $=S[h];if($.offset+$.length<=m)g=R(g,$);else throw new Error("Overlapping edit");m=$.offset}return g}e.$En=k}),define(le[52],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class O{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=O}),define(le[87],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class A{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const I=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,I){const R=new O(L);if(this.a===O.Undefined)this.a=R,this.b=R;else if(I){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const I=L.prev;I.next=L.next,L.next.prev=I}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$4c=A}),define(le[35],he([0,1]),function(se,e){"use strict";var O,A,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(d,c,y){let i=d.get(c);return i===void 0&&(i=y,d.set(c,i)),i}e.$xc=L;function I(d){const c=[];return d.forEach((y,i)=>{c.push(`${i} => ${y}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$yc=I;function R(d){const c=[];return d.forEach(y=>{c.push(y)}),`Set(${d.size}) {${c.join(", ")}}`}e.$zc=R;class k{constructor(c,y){this.uri=c,this.value=y}}function g(d){return Array.isArray(d)}class C{static{this.c=c=>c.toString()}constructor(c,y){if(this[O]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=y??C.c;else if(g(c)){this.d=new Map,this.e=y??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,y){return this.d.set(this.e(c),new k(c,y)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,y){typeof y<"u"&&(c=c.bind(y));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Ac=C;class S{constructor(c,y){this[A]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C(y),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,y){this.c.forEach((i,o)=>c.call(y,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class h{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,y=0){const i=this.c.get(c);if(i)return y!==0&&this.l(i,y),i.value}set(c,y,i=0){let o=this.c.get(c);if(o)o.value=y,i!==0&&this.l(o,i);else{switch(o={key:c,value:y,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const y=this.c.get(c);if(y)return this.c.delete(c),this.k(y),this.f--,y.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,y){const i=this.g;let o=this.d;for(;o;){if(y?c.bind(y)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,y=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==y)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let y=this.d,i=this.size;for(;y&&i>c;)this.c.delete(y.key),y=y.next,i--;this.d=y,this.f=i,y&&(y.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const y=c.next,i=c.previous;if(!y||!i)throw new Error("Invalid list");y.previous=i,i.next=y}c.next=void 0,c.previous=void 0,this.g++}l(c,y){if(!this.d||!this.e)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(y===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((y,i)=>{c.push([i,y])}),c}fromJSON(c){this.clear();for(const[y,i]of c)this.set(y,i)}}e.$Cc=h;class $ extends h{constructor(c,y=1){super(),this.m=c,this.n=Math.min(Math.max(0,y),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,y=2){return super.get(c,y)}peek(c){return super.get(c,0)}set(c,y){return super.set(c,y,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class p{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let y=this.c.get(c)||0;return y===0?!1:(y--,y===0?this.c.delete(c):this.c.set(c,y),!0)}has(c){return this.c.has(c)}}e.$Ec=p;class E{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[y,i]of c)this.set(y,i)}clear(){this.c.clear(),this.d.clear()}set(c,y){this.c.set(c,y),this.d.set(y,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const y=this.c.get(c);return y===void 0?!1:(this.c.delete(c),this.d.delete(y),!0)}forEach(c,y){this.c.forEach((i,o)=>{c.call(y,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=E;class l{constructor(){this.c=new Map}add(c,y){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(y)}delete(c,y){const i=this.c.get(c);i&&(i.delete(y),i.size===0&&this.c.delete(c))}forEach(c,y){const i=this.c.get(c);i&&i.forEach(y)}get(c){const y=this.c.get(c);return y||new Set}}e.$Gc=l;function u(d,c){if(d===c)return!0;if(d.size!==c.size)return!1;for(const[y,i]of d)if(!c.has(y)||c.get(y)!==i)return!1;for(const[y]of c)if(!d.has(y))return!1;return!0}e.$Hc=u}),define(le[2],he([0,1,17,126,35,86,61]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:g.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const F=this.c(P);F.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const F=N.get(P);if(F)return F;const M=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,M),M}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,P).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(P=10,N){let F;if(N)F=N;else{const x=new Map,G=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,x).isSingleton);if(G.length===0)return;const Z=new Set(G.map(H=>H.value));if(F=G.filter(H=>!(H.parent&&Z.has(H.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(x){function G(H,V){for(;H.length>0&&V.some(te=>typeof te=="string"?te===H[0]:H[0].match(te));)H.shift()}const Z=x.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return G(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const U=new j.$Gc;for(const x of F){const G=M(x);for(let Z=0;Z<=G.length;Z++)U.add(G.slice(0,Z).join(`
`),x)}F.sort((0,O.$7b)(x=>x.idx,O.$9b));let Y="",Q=0;for(const x of F.slice(0,P)){Q++;const G=M(x),Z=[];for(let H=0;H<G.length;H++){let V=G[H];V=`(shared with ${U.get(G.slice(0,H+1).join(`
`)).size}/${F.length} leaks) at ${V}`;const oe=U.get(G.slice(0,H).join(`
`)),ee=(0,A.$K)([...oe].map(ae=>M(ae)[H]),ae=>ae);delete ee[G[H]];for(const[ae,W]of Object.entries(ee))Z.unshift(`    - stacktraces of ${W.length} other leaks continue with ${ae}`);Z.unshift(V)}Y+=`


==================== Leaking disposable ${Q}/${F.length}: ${x.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return F.length>P&&(Y+=`


... and ${F.length-P} more leaking disposables

`),{leaks:F,details:Y}}}e.$Ic=g;function C(b){k=b}if(e.$Jc=C,R){const b="__is_disposable_tracked__";C(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[b]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==i.None)try{P[b]=!0}catch{}}markAsDisposed(P){if(P&&P!==i.None)try{P[b]=!0}catch{}}markAsSingleton(P){}})}function S(b){return k?.trackDisposable(b),b}e.$Kc=S;function m(b){k?.markAsDisposed(b)}e.$Lc=m;function h(b,P){k?.setParent(b,P)}function $(b,P){if(k)for(const N of b)k.setParent(N,P)}function p(b){return k?.markAsSingleton(b),b}e.$Mc=p;function E(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Nc=E;function l(b){if(I.Iterable.is(b)){const P=[];for(const N of b)if(N)try{N.dispose()}catch(F){P.push(F)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Oc=l;function u(b){for(const P of b)E(P)&&P.dispose();return[]}e.$Pc=u;function d(...b){const P=c(()=>l(b));return $(b,P),P}e.$Qc=d;function c(b){const P=S({dispose:(0,L.$db)(()=>{m(P),b()})});return P}e.$Rc=c;class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return h(P,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),h(P,null))}}e.$Sc=y;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new y,S(this),h(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=i;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&h(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&h(P,null),P}}e.$Uc=o;class n{constructor(P){this.a=new o,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(P,...N){let F=this.a.get(P);F||(F={counter:0,object:this.b(P,...N)},this.a.set(P,F));const{object:M}=F,U=(0,L.$db)(()=>{--F.counter===0&&(this.c(P,F.object),this.a.delete(P))});return F.counter++,{object:M,dispose:U}}}e.$Yc=r;class a{constructor(P){this.a=P}async acquire(P,...N){const F=this.a.acquire(P,...N);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Zc=a;class v{constructor(P){this.object=P}dispose(){}}e.$1c=v;function w(b){const P=new y;try{b(P)}finally{P.dispose()}}e.$2c=w;class f{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=f}),define(le[88],he([0,1,35]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=void 0;const A=new O.$Dc(1e4);function j(g){return k(g,"NFC",A)}e.$Pl=j;const L=new O.$Dc(1e4);function I(g){return k(g,"NFD",L)}e.$Ql=I;const R=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const m=S.get(g);if(m)return m;let h;return R.test(g)?h=g.normalize(C):h=g,S.set(g,h),h}e.$Rl=function(){const g=/[\u0300-\u036f]/g;return function(C){return I(C).replace(g,"")}}()}),function(){function se(j){const L=[];typeof j=="number"&&L.push("code/timeOrigin",j);function I(k){L.push(k,Date.now())}function R(){const k=[];for(let g=0;g<L.length;g+=2)k.push({name:L[g],startTime:L[g+1]});return k}return{mark:I,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(j+I.startTime)});return L}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function O(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=O(A))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var A in O)(typeof exports=="object"?exports:se)[A]=O[A]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function O(A){if(e[A])return e[A].exports;var j=e[A]={i:A,l:!1,exports:{}};return se[A].call(j.exports,j,j.exports,O),j.l=!0,j.exports}return O.m=se,O.c=e,O.d=function(A,j,L){O.o(A,j)||Object.defineProperty(A,j,{enumerable:!0,get:L})},O.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},O.t=function(A,j){if(1&j&&(A=O(A)),8&j||4&j&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&j&&typeof A!="string")for(var I in A)O.d(L,I,function(R){return A[R]}.bind(null,I));return L},O.n=function(A){var j=A&&A.__esModule?function(){return A.default}:function(){return A};return O.d(j,"a",j),j},O.o=function(A,j){return Object.prototype.hasOwnProperty.call(A,j)},O.p="",O(O.s=0)}([function(se,e,O){(function(A){var j;e=se.exports=W,j=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var m=g++;k[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=g++;k[h]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var $=g++;k[$]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var p=g++;k[p]="(?:"+k[C]+"|"+k[m]+")";var E=g++;k[E]="(?:"+k[S]+"|"+k[m]+")";var l=g++;k[l]="(?:-("+k[p]+"(?:\\."+k[p]+")*))";var u=g++;k[u]="(?:-?("+k[E]+"(?:\\."+k[E]+")*))";var d=g++;k[d]="[0-9A-Za-z-]+";var c=g++;k[c]="(?:\\+("+k[d]+"(?:\\."+k[d]+")*))";var y=g++,i="v?"+k[h]+k[l]+"?"+k[c]+"?";k[y]="^"+i+"$";var o="[v=\\s]*"+k[$]+k[u]+"?"+k[c]+"?",n=g++;k[n]="^"+o+"$";var s=g++;k[s]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[l]+")?"+k[c]+"?)?)?";var v=g++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[u]+")?"+k[c]+"?)?)?";var w=g++;k[w]="^"+k[s]+"\\s*"+k[a]+"$";var f=g++;k[f]="^"+k[s]+"\\s*"+k[v]+"$";var b=g++;k[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;k[P]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[P]+"\\s+",R[N]=new RegExp(k[N],"g");var F=g++;k[F]="^"+k[P]+k[a]+"$";var M=g++;k[M]="^"+k[P]+k[v]+"$";var U=g++;k[U]="(?:\\^)";var Y=g++;k[Y]="(\\s*)"+k[U]+"\\s+",R[Y]=new RegExp(k[Y],"g");var Q=g++;k[Q]="^"+k[U]+k[a]+"$";var x=g++;k[x]="^"+k[U]+k[v]+"$";var G=g++;k[G]="^"+k[s]+"\\s*("+o+")$|^$";var Z=g++;k[Z]="^"+k[s]+"\\s*("+i+")$|^$";var H=g++;k[H]="(\\s*)"+k[s]+"\\s*("+o+"|"+k[a]+")",R[H]=new RegExp(k[H],"g");var V=g++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=g++;k[te]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var oe=g++;k[oe]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)j(ee,k[ee]),R[ee]||(R[ee]=new RegExp(k[ee]));function ae(ue,ge){if(ue instanceof W)return ue;if(typeof ue!="string"||ue.length>L||!(ge?R[n]:R[y]).test(ue))return null;try{return new W(ue,ge)}catch{return null}}function W(ue,ge){if(ue instanceof W){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof W))return new W(ue,ge);j("SemVer",ue,ge),this.loose=ge;var be=ue.trim().match(ge?R[n]:R[y]);if(!be)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ce=+Pe;if(Ce>=0&&Ce<I)return Ce}return Pe}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,ge){var be=ae(ue,ge);return be?be.version:null},e.clean=function(ue,ge){var be=ae(ue.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(ue){return j("SemVer.compare",this.version,this.loose,ue),ue instanceof W||(ue=new W(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},W.prototype.compareMain=function(ue){return ue instanceof W||(ue=new W(ue,this.loose)),D(this.major,ue.major)||D(this.minor,ue.minor)||D(this.patch,ue.patch)},W.prototype.comparePre=function(ue){if(ue instanceof W||(ue=new W(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Pe=ue.prerelease[ge];if(j("prerelease compare",ge,be,Pe),be===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(be===void 0)return-1;if(be!==Pe)return D(be,Pe)}while(++ge)},W.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,be,Pe){typeof be=="string"&&(Pe=be,be=void 0);try{return new W(ue,be).inc(ge,Pe).version}catch{return null}},e.diff=function(ue,ge){if(X(ue,ge))return null;var be=ae(ue),Pe=ae(ge);if(be.prerelease.length||Pe.prerelease.length){for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in be)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&be[Ce]!==Pe[Ce])return Ce},e.compareIdentifiers=D;var z=/^[0-9]+$/;function D(ue,ge){var be=z.test(ue),Pe=z.test(ge);return be&&Pe&&(ue=+ue,ge=+ge),be&&!Pe?-1:Pe&&!be?1:ue<ge?-1:ue>ge?1:0}function T(ue,ge,be){return new W(ue,be).compare(new W(ge,be))}function B(ue,ge,be){return T(ue,ge,be)>0}function q(ue,ge,be){return T(ue,ge,be)<0}function X(ue,ge,be){return T(ue,ge,be)===0}function _(ue,ge,be){return T(ue,ge,be)!==0}function ie(ue,ge,be){return T(ue,ge,be)>=0}function J(ue,ge,be){return T(ue,ge,be)<=0}function ne(ue,ge,be,Pe){var Ce;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue===be;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof be=="object"&&(be=be.version),Ce=ue!==be;break;case"":case"=":case"==":Ce=X(ue,be,Pe);break;case"!=":Ce=_(ue,be,Pe);break;case">":Ce=B(ue,be,Pe);break;case">=":Ce=ie(ue,be,Pe);break;case"<":Ce=q(ue,be,Pe);break;case"<=":Ce=J(ue,be,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function ce(ue,ge){if(ue instanceof ce){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,ge);j("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(ue,ge){return D(ge,ue)},e.major=function(ue,ge){return new W(ue,ge).major},e.minor=function(ue,ge){return new W(ue,ge).minor},e.patch=function(ue,ge){return new W(ue,ge).patch},e.compare=T,e.compareLoose=function(ue,ge){return T(ue,ge,!0)},e.rcompare=function(ue,ge,be){return T(ge,ue,be)},e.sort=function(ue,ge){return ue.sort(function(be,Pe){return e.compare(be,Pe,ge)})},e.rsort=function(ue,ge){return ue.sort(function(be,Pe){return e.rcompare(be,Pe,ge)})},e.gt=B,e.lt=q,e.eq=X,e.neq=_,e.gte=ie,e.lte=J,e.cmp=ne,e.Comparator=ce;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof ce)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,be,Pe,Ce,Fe,De,Ue,Te,qe,ze,Le,re){return((ge=me(be)?"":me(Pe)?">="+be+".0.0":me(Ce)?">="+be+"."+Pe+".0":">="+ge)+" "+(Ue=me(Te)?"":me(qe)?"<"+(+Te+1)+".0.0":me(ze)?"<"+Te+"."+(+qe+1)+".0":Le?"<="+Te+"."+qe+"."+ze+"-"+Le:"<="+Ue)).trim()}function Re(ue,ge){for(var be=0;be<ue.length;be++)if(!ue[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ue.length;be++)if(j(ue[be].semver),ue[be].semver!==fe&&ue[be].semver.prerelease.length>0){var Pe=ue[be].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,be,Pe){var Ce,Fe,De,Ue,Te;switch(ue=new W(ue,Pe),ge=new de(ge,Pe),be){case">":Ce=B,Fe=J,De=q,Ue=">",Te=">=";break;case"<":Ce=q,Fe=ie,De=B,Ue="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Pe))return!1;for(var qe=0;qe<ge.set.length;++qe){var ze=ge.set[qe],Le=null,re=null;if(ze.forEach(function($e){$e.semver===fe&&($e=new ce(">=0.0.0")),Le=Le||$e,re=re||$e,Ce($e.semver,Le.semver,Pe)?Le=$e:De($e.semver,re.semver,Pe)&&(re=$e)}),Le.operator===Ue||Le.operator===Te||(!re.operator||re.operator===Ue)&&Fe(ue,re.semver)||re.operator===Te&&De(ue,re.semver))return!1}return!0}ce.prototype.parse=function(ue){var ge=this.loose?R[G]:R[Z],be=ue.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ue);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new W(be[2],this.loose):this.semver=fe},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return j("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new W(ue,this.loose)),ne(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,ge){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ue.value,ge),Oe(this.value,be,ge);if(ue.operator==="")return be=new de(this.value,ge),Oe(ue.semver,be,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Fe=this.semver.version===ue.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),Ue=ne(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ne(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Ce||Fe&&De||Ue||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),j("range",ue,ge);var be=ge?R[te]:R[V];ue=ue.replace(be,Ee),j("hyphen replace",ue),ue=ue.replace(R[H],"$1$2$3"),j("comparator trim",ue,R[H]),ue=(ue=(ue=ue.replace(R[N],"$1~")).replace(R[Y],"$1^")).split(/\s+/).join(" ");var Pe=ge?R[G]:R[Z],Ce=ue.split(" ").map(function(Fe){return function(De,Ue){return j("comp",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(ze){return function(Le,re){j("caret",Le,re);var $e=re?R[x]:R[Q];return Le.replace($e,function(pe,we,ve,ke,Ie){var Ae;return j("caret",Le,pe,we,ve,ke,Ie),me(we)?Ae="":me(ve)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Ae=we==="0"?">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+".0 <"+(+we+1)+".0.0":Ie?(j("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+Ie+" <"+(+we+1)+".0.0"):(j("no pr"),Ae=we==="0"?ve==="0"?">="+we+"."+ve+"."+ke+" <"+we+"."+ve+"."+(+ke+1):">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0":">="+we+"."+ve+"."+ke+" <"+(+we+1)+".0.0"),j("caret return",Ae),Ae})}(ze,qe)}).join(" ")}(De,Ue),j("caret",De),De=function(Te,qe){return Te.trim().split(/\s+/).map(function(ze){return function(Le,re){var $e=re?R[M]:R[F];return Le.replace($e,function(pe,we,ve,ke,Ie){var Ae;return j("tilde",Le,pe,we,ve,ke,Ie),me(we)?Ae="":me(ve)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":me(ke)?Ae=">="+we+"."+ve+".0 <"+we+"."+(+ve+1)+".0":Ie?(j("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+we+"."+ve+"."+ke+Ie+" <"+we+"."+(+ve+1)+".0"):Ae=">="+we+"."+ve+"."+ke+" <"+we+"."+(+ve+1)+".0",j("tilde return",Ae),Ae})}(ze,qe)}).join(" ")}(De,Ue),j("tildes",De),De=function(Te,qe){return j("replaceXRanges",Te,qe),Te.split(/\s+/).map(function(ze){return function(Le,re){Le=Le.trim();var $e=re?R[f]:R[w];return Le.replace($e,function(pe,we,ve,ke,Ie,Ae){j("xRange",Le,pe,we,ve,ke,Ie,Ae);var Ve=me(ve),Be=Ve||me(ke),Me=Be||me(Ie);return we==="="&&Me&&(we=""),Ve?pe=we===">"||we==="<"?"<0.0.0":"*":we&&Me?(Be&&(ke=0),Me&&(Ie=0),we===">"?(we=">=",Be?(ve=+ve+1,ke=0,Ie=0):Me&&(ke=+ke+1,Ie=0)):we==="<="&&(we="<",Be?ve=+ve+1:ke=+ke+1),pe=we+ve+"."+ke+"."+Ie):Be?pe=">="+ve+".0.0 <"+(+ve+1)+".0.0":Me&&(pe=">="+ve+"."+ke+".0 <"+ve+"."+(+ke+1)+".0"),j("xRange return",pe),pe})}(ze,qe)}).join(" ")}(De,Ue),j("xrange",De),De=function(Te,qe){return j("replaceStars",Te,qe),Te.trim().replace(R[oe],"")}(De,Ue),j("stars",De),De}(Fe,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(Pe)})),Ce=Ce.map(function(Fe){return new ce(Fe,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Pe){return ue.set.some(function(Ce){return Ce.every(function(Fe){return Pe.intersects(Fe,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(be){return be.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new W(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(De){Fe.test(De)&&(Pe&&Ce.compare(De)!==-1||(Ce=new W(Pe=De,be)))}),Pe},e.minSatisfying=function(ue,ge,be){var Pe=null,Ce=null;try{var Fe=new de(ge,be)}catch{return null}return ue.forEach(function(De){Fe.test(De)&&(Pe&&Ce.compare(De)!==1||(Ce=new W(Pe=De,be)))}),Pe},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,be){return Ne(ue,ge,"<",be)},e.gtr=function(ue,ge,be){return Ne(ue,ge,">",be)},e.outside=Ne,e.prerelease=function(ue,ge){var be=ae(ue,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ue,ge,be){return ue=new de(ue,be),ge=new de(ge,be),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof W)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[b]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(se,e){var O,A,j=se.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function R(E){if(O===setTimeout)return setTimeout(E,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(E,0);try{return O(E,0)}catch{try{return O.call(null,E,0)}catch{return O.call(this,E,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{A=typeof clearTimeout=="function"?clearTimeout:I}catch{A=I}})();var k,g=[],C=!1,S=-1;function m(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&h())}function h(){if(!C){var E=R(m);C=!0;for(var l=g.length;l;){for(k=g,g=[];++S<l;)k&&k[S].run();S=-1,l=g.length}k=null,C=!1,function(u){if(A===clearTimeout)return clearTimeout(u);if((A===I||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(u);try{A(u)}catch{try{return A.call(null,u)}catch{return A.call(this,u)}}}(E)}}function $(E,l){this.fun=E,this.array=l}function p(){}j.nextTick=function(E){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];g.push(new $(E,l)),g.length!==1||C||R(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=p,j.addListener=p,j.once=p,j.off=p,j.removeListener=p,j.removeAllListeners=p,j.emit=p,j.prependListener=p,j.prependOnceListener=p,j.listeners=function(E){return[]},j.binding=function(E){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(E){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=void 0;class A{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const j=void 0;class L{constructor(R,k=2**16){this.comparator=R,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new A(this.c,j,j)}get size(){return this.f}clear(){this.e=new A(this.c,j,j),this.f=0}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,k){return L.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=L.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const S=[];let m=R.e;for(let h=R.d-1;h>=0;h--){for(;m.forward[h]&&C(m.forward[h].key,k)<0;)m=m.forward[h];S[h]=m}if(m=m.forward[0],m&&C(m.key,k)===0)return m.value=g,!1;{const h=L.j(R);if(h>R.d){for(let $=R.d;$<h;$++)S[$]=R.e;R.d=h}m=new A(h,k,g);for(let $=0;$<h;$++)m.forward[$]=S[$].forward[$],S[$].forward[$]=m;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let S=R.e;for(let m=R.d-1;m>=0;m--){for(;S.forward[m]&&g(S.forward[m].key,k)<0;)S=S.forward[m];C[m]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let m=0;m<R.d&&C[m].forward[m]===S;m++)C[m].forward[m]=S.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===j;)R.d-=1;return!0}}e.$0r=L}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class A{static create(L){return new A(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Yd=A}),define(le[3],he([0,1,7,86,2,87,63]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>j.$Tc.None;function f(J){if(k){const{onDidAddListener:ne}=J,ce=$.create();let fe=0;J.onDidAddListener=()=>{++fe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function b(J,ne){return Z(J,()=>{},0,void 0,!0,void 0,ne)}w.defer=b;function P(J){return(ne,ce=null,fe)=>{let de=!1,me;return me=J(Ee=>{if(!de)return me?me.dispose():de=!0,ne.call(ce,Ee)},null,fe),de&&me.dispose(),me}}w.once=P;function N(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>fe.call(de,ne(Ee)),null,me),ce)}w.map=N;function F(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>{ne(Ee),fe.call(de,Ee)},null,me),ce)}w.forEach=F;function M(J,ne,ce){return x((fe,de=null,me)=>J(Ee=>ne(Ee)&&fe.call(de,Ee),null,me),ce)}w.filter=M;function U(J){return J}w.signal=U;function Y(...J){return(ne,ce=null,fe)=>{const de=(0,j.$Qc)(...J.map(me=>me(Ee=>ne.call(ce,Ee))));return G(de,fe)}}w.any=Y;function Q(J,ne,ce,fe){let de=ce;return N(J,me=>(de=ne(de,me),de),fe)}w.reduce=Q;function x(J,ne){let ce;const fe={onWillAddFirstListener(){ce=J(de.fire,de)},onDidRemoveLastListener(){ce?.dispose()}};ne||f(fe);const de=new d(fe);return ne?.add(de),de.event}function G(J,ne){return ne instanceof Array?ne.push(J):ne&&ne.add(J),J}function Z(J,ne,ce=100,fe=!1,de=!1,me,Ee){let Re,Oe,Ne,ue=0,ge;const be={leakWarningThreshold:me,onWillAddFirstListener(){Re=J(Ce=>{ue++,Oe=ne(Oe,Ce),fe&&!Ne&&(Pe.fire(Oe),Oe=void 0),ge=()=>{const Fe=Oe;Oe=void 0,Ne=void 0,(!fe||ue>1)&&Pe.fire(Fe),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout(ge,ce)):Ne===void 0&&(Ne=0,queueMicrotask(ge))})},onWillRemoveListener(){de&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Re.dispose()}};Ee||f(be);const Pe=new d(be);return Ee?.add(Pe),Pe.event}w.debounce=Z;function H(J,ne=0,ce){return w.debounce(J,(fe,de)=>fe?(fe.push(de),fe):[de],ne,void 0,!0,void 0,ce)}w.accumulate=H;function V(J,ne=(fe,de)=>fe===de,ce){let fe=!0,de;return M(J,me=>{const Ee=fe||!ne(me,de);return fe=!1,de=me,Ee},ce)}w.latch=V;function te(J,ne,ce){return[w.filter(J,ne,ce),w.filter(J,fe=>!ne(fe),ce)]}w.split=te;function oe(J,ne=!1,ce=[],fe){let de=ce.slice(),me=J(Oe=>{de?de.push(Oe):Re.fire(Oe)});fe&&fe.add(me);const Ee=()=>{de?.forEach(Oe=>Re.fire(Oe)),de=null},Re=new d({onWillAddFirstListener(){me||(me=J(Oe=>Re.fire(Oe)),fe&&fe.add(me))},onDidAddFirstListener(){de&&(ne?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return fe&&fe.add(Re),Re.event}w.buffer=oe;function ee(J,ne){return(fe,de,me)=>{const Ee=ne(new W);return J(function(Re){const Oe=Ee.evaluate(Re);Oe!==ae&&fe.call(de,Oe)},void 0,me)}}w.chain=ee;const ae=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ce=>(ne(ce),ce)),this}filter(ne){return this.f.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let fe=ce;return this.f.push(de=>(fe=ne(fe,de),fe)),this}latch(ne=(ce,fe)=>ce===fe){let ce=!0,fe;return this.f.push(de=>{const me=ce||!ne(de,fe);return ce=!1,fe=de,me?de:ae}),this}evaluate(ne){for(const ce of this.f)if(ne=ce(ne),ne===ae)break;return ne}}function z(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.on(ne,fe),me=()=>J.removeListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromNodeEventEmitter=z;function D(J,ne,ce=fe=>fe){const fe=(...Re)=>Ee.fire(ce(...Re)),de=()=>J.addEventListener(ne,fe),me=()=>J.removeEventListener(ne,fe),Ee=new d({onWillAddFirstListener:de,onDidRemoveLastListener:me});return Ee.event}w.fromDOMEventEmitter=D;function T(J){return new Promise(ne=>P(J)(ne))}w.toPromise=T;function B(J){const ne=new d;return J.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}w.fromPromise=B;function q(J,ne,ce){return ne(ce),J(fe=>ne(fe))}w.runAndSubscribe=q;class X{constructor(ne,ce){this._observable=ne,this.f=0,this.g=!1;const fe={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||f(fe),this.emitter=new d(fe),ce&&ce.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ce){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(J,ne){return new X(J,ne).emitter.event}w.fromObservable=_;function ie(J){return(ne,ce,fe)=>{let de=0,me=!1;const Ee={beginUpdate(){de++},endUpdate(){de--,de===0&&(J.reportChanges(),me&&(me=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};J.addObserver(Ee),J.reportChanges();const Re={dispose(){J.removeObserver(Ee)}};return fe instanceof j.$Sc?fe.add(Re):Array.isArray(fe)&&fe.push(Re),Re}}w.fromObservableLight=ie})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${C.f++}`,C.all.add(this)}start(f){this.g=new I.$Yd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$1d=C;let S=-1;function m(w){const f=S;return S=w,{dispose(){S=f}}}e.$2d=m;class h{constructor(f,b=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=b,this.g=0}dispose(){this.f?.clear()}check(f,b){const P=this.threshold;if(P<=0||b<P)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let F,M=0;for(const[U,Y]of this.f)(!F||M<Y)&&(F=U,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(f.value)||0;this.f.set(f.value,F-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class E{constructor(f){this.value=f,this.id=p++}}const l=2,u=(w,f)=>{if(w instanceof E)f(w);else for(let b=0;b<w.length;b++){const P=w[b];P&&f(P)}};class d{constructor(f){this.w=0,this.f=f,this.g=S>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const f=this.t;queueMicrotask(()=>{u(f,b=>b.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,b,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Tc.None;if(this.m)return j.$Tc.None;b&&(f=f.bind(b));const N=new E(f);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=$.create(),F=this.g.check(N.stack,this.w+1)),R&&(N.stack=M??$.create()),this.t?this.t instanceof E?(this.u??=new y,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,j.$Rc)(()=>{F?.(),this.x(N)});return P instanceof j.$Sc?P.add(U):Array.isArray(P)&&P.push(U),U},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const b=this.t,P=b.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,b[P]=void 0;const N=this.u.current===this;if(this.w*l<=b.length){let F=0;for(let M=0;M<b.length;M++)b[M]?b[F++]=b[M]:N&&(this.u.end--,F<this.u.i&&this.u.i--);b.length=F}}y(f,b){if(!f)return;const P=this.f?.onListenerError||O.$1;if(!P){f.value(b);return}try{f.value(b)}catch(N){P(N)}}z(f){const b=f.current.t;for(;f.i<f.end;)this.y(b[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof E)this.y(this.t,f);else{const b=this.u;b.enqueue(this,f,this.t.length),this.z(b)}this.j?.stop()}hasListeners(){return this.w>0}}e.$3d=d;const c=()=>new y;e.$4d=c;class y{constructor(){this.i=-1,this.end=0}enqueue(f,b,P){this.i=0,this.end=P,this.current=f,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(f,b,P){if(this.t)for(this.h||(this.h=new L.$4c),u(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!b.isCancellationRequested;){const[N,F]=this.h.shift(),M=[],U={...F,token:b,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(Y=P(Y,N)),M.push(Y)}};try{N(U)}catch(Y){(0,O.$1)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const Q of Y)Q.status==="rejected"&&(0,O.$1)(Q.reason)})}}}e.$5d=i;class o extends d{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new L.$4c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$6d=o;class n extends o{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$7d=n;class s extends d{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(b=>super.fire(b)),this.h=[]}))}}e.$8d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const b={event:f,listener:null};this.h.push(b),this.g&&this.m(b);const P=()=>{this.g&&this.o(b);const N=this.h.indexOf(b);this.h.splice(N,1)};return(0,j.$Rc)((0,A.$db)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(b=>this.f.fire(b))}o(f){f.listener?.dispose(),f.listener=null}dispose(){this.f.dispose();for(const f of this.h)f.listener?.dispose();this.h=[]}}e.$9d=t;class r{constructor(f,b,P,N){this.f=new j.$Sc;const F=this.f.add(new t),M=this.f.add(new j.$3c);function U(Y){M.set(Y,F.add(N(Y)))}for(const Y of f)U(Y);this.f.add(b(Y=>{U(Y)})),this.f.add(P(Y=>{M.deleteAndDispose(Y)})),this.event=F.event}dispose(){this.f.dispose()}}e.$0d=r;class a{constructor(){this.f=[]}wrapEvent(f){return(b,P,N)=>f(F=>{const M=this.f[this.f.length-1];M?M.push(()=>b.call(P,F)):b.call(P,F)},void 0,N)}bufferEvents(f){const b=[];this.f.push(b);const P=f();return this.f.pop(),b.forEach(N=>N()),P}}e.$$d=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=j.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$_d=v}),define(le[26],he([0,1,3]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.CancellationToken=void 0;const A=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var j;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof L?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(j||(e.CancellationToken=j={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new O.$3d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=j.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=j.None}}e.$ae=I}),define(le[129],he([0,1,26]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=void 0;class A{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new O.$ae,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Le=A;class j{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$Me=j;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$Ne=L}),define(le[47],he([0,1,7,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;function j(c){const y=c;return y?typeof y.read=="function":!1}e.$be=j;function L(c){const y=c;return y?[y.on,y.pause,y.resume,y.destroy].every(i=>typeof i=="function"):!1}e.$ce=L;function I(c){const y=c;return y?L(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$de=I;function R(c,y){return new k(c,y)}e.$ee=R;class k{constructor(y,i){this.e=y,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(i=>i(y))}h(y){this.c.error.length===0?(0,O.$1)(y):this.c.error.slice(0).forEach(i=>i(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,i){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(y,i){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,y){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return y(i)}e.$fe=g;function C(c,y,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}e.$ge=C;function S(c,y){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{y&&n.push(s)},onError:s=>{y?o(s):i(void 0)},onEnd:()=>{i(y?y(n):void 0)}})})}e.$he=S;function m(c,y,i){c.on("error",o=>{i?.isCancellationRequested||y.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||y.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||y.onData(o)})}e.$ie=m;function h(c,y){return new Promise((i,o)=>{const n=new A.$Sc,s=[],t=v=>{if(s.push(v),s.length>y)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=v=>(n.dispose(),o(v)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,A.$Rc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,A.$Rc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,A.$Rc)(()=>c.removeListener("data",t))),c.on("data",t)})}e.$je=h;function $(c,y){const i=R(y);return i.end(c),i}e.$ke=$;function p(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}e.$le=p;function E(c){let y=!1;return{read:()=>y?null:(y=!0,c)}}e.$me=E;function l(c,y,i){const o=R(i);return m(c,{onData:n=>o.write(y.data(n)),onError:n=>o.error(y.error?y.error(n):n),onEnd:()=>o.end()}),o}e.$ne=l;function u(c,y,i){let o=!1;return{read:()=>{const n=y.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}e.$oe=u;function d(c,y,i){let o=!1;const n=R(i);return m(y,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.$pe=d}),define(le[14],he([0,1,52,47]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=void 0;const j=typeof Buffer<"u",L=new O.$V(()=>new Uint8Array(256));let I,R;class k{static alloc(b){return j?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return j&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,P){return!(P?.dontUseNodeBuffer||!1)&&j?new k(Buffer.from(b)):(I||(I=new TextEncoder),new k(I.encode(b)))}static fromByteArray(b){const P=k.alloc(b.length);for(let N=0,F=b.length;N<F;N++)P.buffer[N]=b[N];return P}static concat(b,P){if(typeof P>"u"){P=0;for(let M=0,U=b.length;M<U;M++)P+=b[M].byteLength}const N=k.alloc(P);let F=0;for(let M=0,U=b.length;M<U;M++){const Y=b[M];N.set(Y,F),F+=Y.byteLength}return N}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return j?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(b,P){return new k(this.buffer.subarray(b,P))}set(b,P){if(b instanceof k)this.buffer.set(b.buffer,P);else if(b instanceof Uint8Array)this.buffer.set(b,P);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),P);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return m(this.buffer,b)}writeUInt32BE(b,P){h(this.buffer,b,P)}readUInt32LE(b){return $(this.buffer,b)}writeUInt32LE(b,P){p(this.buffer,b,P)}readUInt8(b){return E(this.buffer,b)}writeUInt8(b,P){l(this.buffer,b,P)}indexOf(b,P=0){return g(this.buffer,b instanceof k?b.buffer:b,P)}}e.$qe=k;function g(f,b,P=0){const N=b.byteLength,F=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(b[0]);if(N>F-P)return-1;const M=L.value;M.fill(b.length);for(let x=0;x<b.length;x++)M[b[x]]=b.length-x-1;let U=P+b.length-1,Y=U,Q=-1;for(;U<F;)if(f[U]===b[Y]){if(Y===0){Q=U;break}U--,Y--}else U+=Math.max(b.length-Y,M[f[U]]),Y=b.length-1;return Q}e.$re=g;function C(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0}e.$se=C;function S(f,b,P){f[P+0]=b&255,b=b>>>8,f[P+1]=b&255}e.$te=S;function m(f,b){return f[b]*2**24+f[b+1]*2**16+f[b+2]*2**8+f[b+3]}e.$ue=m;function h(f,b,P){f[P+3]=b,b=b>>>8,f[P+2]=b,b=b>>>8,f[P+1]=b,b=b>>>8,f[P]=b}e.$ve=h;function $(f,b){return f[b+0]<<0>>>0|f[b+1]<<8>>>0|f[b+2]<<16>>>0|f[b+3]<<24>>>0}e.$we=$;function p(f,b,P){f[P+0]=b&255,b=b>>>8,f[P+1]=b&255,b=b>>>8,f[P+2]=b&255,b=b>>>8,f[P+3]=b&255}e.$xe=p;function E(f,b){return f[b]}e.$ye=E;function l(f,b,P){f[P]=b}e.$ze=l;function u(f){return A.$fe(f,b=>k.concat(b))}e.$Ae=u;function d(f){return A.$me(f)}e.$Be=d;function c(f){return A.$he(f,b=>k.concat(b))}e.$Ce=c;async function y(f){return f.ended?k.concat(f.buffer):k.concat([...f.buffer,await c(f.stream)])}e.$De=y;function i(f){return A.$ke(f,b=>k.concat(b))}e.$Ee=i;function o(f){return A.$ne(f,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.$Fe=o;function n(f){return A.$ee(b=>k.concat(b),f)}e.$Ge=n;function s(f,b){return A.$oe(f,b,P=>k.concat(P))}e.$He=s;function t(f,b){return A.$pe(f,b,P=>k.concat(P))}e.$Ie=t;function r(f){let b=0,P=0,N=0;const F=new Uint8Array(Math.floor(f.length/4*3)),M=Y=>{switch(P){case 3:F[N++]=b|Y,P=0;break;case 2:F[N++]=b|Y>>>2,b=Y<<6,P=3;break;case 1:F[N++]=b|Y>>>4,b=Y<<4,P=2;break;default:b=Y<<2,P=1}};for(let Y=0;Y<f.length;Y++){const Q=f.charCodeAt(Y);if(Q>=65&&Q<=90)M(Q-65);else if(Q>=97&&Q<=122)M(Q-97+26);else if(Q>=48&&Q<=57)M(Q-48+52);else if(Q===43||Q===45)M(62);else if(Q===47||Q===95)M(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${f[Y]}`)}}const U=N;for(;P>0;)M(0);return k.wrap(F).slice(0,U)}e.$Je=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:f},b=!0,P=!1){const N=P?v:a;let F="";const M=f.byteLength%3;let U=0;for(;U<f.byteLength-M;U+=3){const Y=f[U+0],Q=f[U+1],x=f[U+2];F+=N[Y>>>2],F+=N[(Y<<4|Q>>>4)&63],F+=N[(Q<<2|x>>>6)&63],F+=N[x&63]}if(M===1){const Y=f[U+0];F+=N[Y>>>2],F+=N[Y<<4&63],b&&(F+="==")}else if(M===2){const Y=f[U+0],Q=f[U+1];F+=N[Y>>>2],F+=N[(Y<<4|Q>>>4)&63],F+=N[Q<<2&63],b&&(F+="=")}return F}e.$Ke=w}),define(le[27],he([0,1,129,52]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.GraphemeBreakType=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=void 0;function j(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$Qe=j;const L=/{(\d+)}/g;function I(re,...$e){return $e.length===0?re:re.replace(L,function(pe,we){const ve=parseInt(we,10);return isNaN(ve)||ve<0||ve>=$e.length?pe:$e[ve]})}e.$Re=I;const R=/{([^}]+)}/g;function k(re,$e){return Object.keys($e).length===0?re:re.replace(R,(pe,we)=>$e[we]??pe)}e.$Se=k;function g(re){return re.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$Te=g;function C(re){return re.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Ue=C;function S(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ve=S;function m(re,$e){let pe=0;const we=$e.charCodeAt(0);for(let ve=re.length-1;ve>=0;ve--)re.charCodeAt(ve)===we&&pe++;return pe}e.$We=m;function h(re,$e,pe="\u2026"){return re.length<=$e?re:`${re.substr(0,$e)}${pe}`}e.$Xe=h;function $(re,$e,pe="\u2026"){if(re.length<=$e)return re;const we=Math.ceil($e/2)-pe.length/2,ve=Math.floor($e/2)-pe.length/2;return`${re.substr(0,we)}${pe}${re.substr(re.length-ve)}`}e.$Ye=$;function p(re,$e=" "){const pe=E(re,$e);return l(pe,$e)}e.$Ze=p;function E(re,$e){if(!re||!$e)return re;const pe=$e.length;if(pe===0||re.length===0)return re;let we=0;for(;re.indexOf($e,we)===we;)we=we+pe;return re.substring(we)}e.$1e=E;function l(re,$e){if(!re||!$e)return re;const pe=$e.length,we=re.length;if(pe===0||we===0)return re;let ve=we,ke=-1;for(;ke=re.lastIndexOf($e,ve-1),!(ke===-1||ke+pe!==ve);){if(ke===0)return"";ve=ke}return re.substring(0,ve)}e.$2e=l;function u(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$3e=u;function d(re){return re.replace(/\*/g,"")}e.$4e=d;function c(re,$e,pe={}){if(!re)throw new Error("Cannot create regex from empty string");$e||(re=S(re)),pe.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let we="";return pe.global&&(we+="g"),pe.matchCase||(we+="i"),pe.multiline&&(we+="m"),pe.unicode&&(we+="u"),new RegExp(re,we)}e.$5e=c;function y(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$6e=y;function i(re){return re.split(/\r\n|\r|\n/)}e.$7e=i;function o(re){const $e=[],pe=re.split(/(\r\n|\r|\n)/);for(let we=0;we<Math.ceil(pe.length/2);we++)$e.push(pe[2*we]+(pe[2*we+1]??""));return $e}e.$8e=o;function n(re){for(let $e=0,pe=re.length;$e<pe;$e++){const we=re.charCodeAt($e);if(we!==32&&we!==9)return $e}return-1}e.$9e=n;function s(re,$e=0,pe=re.length){for(let we=$e;we<pe;we++){const ve=re.charCodeAt(we);if(ve!==32&&ve!==9)return re.substring($e,we)}return re.substring($e,pe)}e.$0e=s;function t(re,$e=re.length-1){for(let pe=$e;pe>=0;pe--){const we=re.charCodeAt(pe);if(we!==32&&we!==9)return pe}return-1}e.$$e=t;function r(re,$e,pe){const we=[];let ve=0;for(const ke of re.matchAll($e)){if(we.push(re.slice(ve,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ve=ke.index+ke[0].length,we.push(pe(ke[0],...ke.slice(1),ke.index,re,ke.groups))}return we.push(re.slice(ve)),Promise.all(we).then(ke=>ke.join(""))}e.$_e=r;function a(re,$e){return re<$e?-1:re>$e?1:0}e.$af=a;function v(re,$e,pe=0,we=re.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){const Ve=re.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve<Be)return-1;if(Ve>Be)return 1}const Ie=we-pe,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}e.$bf=v;function w(re,$e){return f(re,$e,0,re.length,0,$e.length)}e.$cf=w;function f(re,$e,pe=0,we=re.length,ve=0,ke=$e.length){for(;pe<we&&ve<ke;pe++,ve++){let Ve=re.charCodeAt(pe),Be=$e.charCodeAt(ve);if(Ve===Be)continue;if(Ve>=128||Be>=128)return v(re.toLowerCase(),$e.toLowerCase(),pe,we,ve,ke);P(Ve)&&(Ve-=32),P(Be)&&(Be-=32);const Me=Ve-Be;if(Me!==0)return Me}const Ie=we-pe,Ae=ke-ve;return Ie<Ae?-1:Ie>Ae?1:0}e.$df=f;function b(re){return re>=48&&re<=57}e.$ef=b;function P(re){return re>=97&&re<=122}e.$ff=P;function N(re){return re>=65&&re<=90}e.$gf=N;function F(re,$e){return re.length===$e.length&&f(re,$e)===0}e.$hf=F;function M(re,$e){const pe=$e.length;return $e.length>re.length?!1:f(re,$e,0,pe)===0}e.$if=M;function U(re,$e){const pe=Math.min(re.length,$e.length);let we;for(we=0;we<pe;we++)if(re.charCodeAt(we)!==$e.charCodeAt(we))return we;return pe}e.$jf=U;function Y(re,$e){const pe=Math.min(re.length,$e.length);let we;const ve=re.length-1,ke=$e.length-1;for(we=0;we<pe;we++)if(re.charCodeAt(ve-we)!==$e.charCodeAt(ke-we))return we;return pe}e.$kf=Y;function Q(re){return 55296<=re&&re<=56319}e.$lf=Q;function x(re){return 56320<=re&&re<=57343}e.$mf=x;function G(re,$e){return(re-55296<<10)+($e-56320)+65536}e.$nf=G;function Z(re,$e,pe){const we=re.charCodeAt(pe);if(Q(we)&&pe+1<$e){const ve=re.charCodeAt(pe+1);if(x(ve))return G(we,ve)}return we}e.$of=Z;function H(re,$e){const pe=re.charCodeAt($e-1);if(x(pe)&&$e>1){const we=re.charCodeAt($e-2);if(Q(we))return G(we,pe)}return pe}class V{get offset(){return this.e}constructor($e,pe=0){this.c=$e,this.d=$e.length,this.e=pe}setOffset($e){this.e=$e}prevCodePoint(){const $e=H(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=Z(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$pf=V;class te{get offset(){return this.c.offset}constructor($e,pe=0){this.c=new V($e,pe)}nextGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.nextCodePoint());if(be(ve,Ie)){pe.setOffset(ke);break}ve=Ie}return pe.offset-we}prevGraphemeLength(){const $e=Ce.getInstance(),pe=this.c,we=pe.offset;let ve=$e.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const ke=pe.offset,Ie=$e.getGraphemeBreakType(pe.prevCodePoint());if(be(Ie,ve)){pe.setOffset(ke);break}ve=Ie}return we-pe.offset}eol(){return this.c.eol()}}e.$qf=te;function oe(re,$e){return new te(re,$e).nextGraphemeLength()}e.$rf=oe;function ee(re,$e){return new te(re,$e).prevGraphemeLength()}e.$sf=ee;function ae(re,$e){$e>0&&x(re.charCodeAt($e))&&$e--;const pe=$e+oe(re,$e);return[pe-ee(re,pe),pe]}e.$tf=ae;function W(re){const $e=new te(re);let pe=0;for(;!$e.eol();)pe++,$e.nextGraphemeLength();return pe}e.$uf=W;let z;function D(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function T(re){return z||(z=D()),z.test(re)}e.$vf=T;const B=/^[\t\n\r\x20-\x7E]*$/;function q(re){return B.test(re)}e.$wf=q,e.$xf=/[\u2028\u2029]/;function X(re){return e.$xf.test(re)}e.$yf=X;function _(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$zf=_;function ie(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$Af=ie;function J(re,$e,pe=""){const we=re.trimStart();if(we.length<$e)return we;const ve=/\b/g;let ke=0;for(;ve.test(we)&&!(we.length-ve.lastIndex<$e);)ke=ve.lastIndex,ve.lastIndex+=1;return ke===0?we:pe+we.substring(ke).trimStart()}e.$Bf=J;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function fe(re){return re&&(re=re.replace(ne,"").replace(ce,"")),re}e.$Cf=fe,e.$Df="\uFEFF";function de(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$Ef=de;function me(re){return de(re)?re.substr(1):re}e.$Ff=me;function Ee(re,$e){if(!re||!$e||re.length<$e.length)return!1;const pe=$e.length,we=re.toLowerCase();let ve=0,ke=-1;for(;ve<pe;){const Ie=we.indexOf($e[ve],ke+1);if(Ie<0)return!1;ke=Ie,ve++}return!0}e.$Gf=Ee;function Re(re,$e=!1){return re?($e&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$Hf=Re;function Oe(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$If=Oe;function Ne(re,$e=1){if($e===0)return"";let pe=-1;do pe=re.indexOf(`
`,pe+1),$e--;while($e>0&&pe>=0);return pe===-1?re:(re[pe-1]==="\r"&&pe--,re.substr(0,pe))}e.$Jf=Ne;function ue(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$Kf=ue;function ge(re){return Ce.getInstance().getGraphemeBreakType(re)}e.$Lf=ge;function be(re,$e){return re===0?$e!==5&&$e!==7:re===2&&$e===3?!1:re===4||re===2||re===3||$e===4||$e===2||$e===3?!0:!(re===8&&($e===8||$e===9||$e===11||$e===12)||(re===11||re===9)&&($e===9||$e===10)||(re===12||re===10)&&$e===10||$e===5||$e===13||$e===7||re===1||re===13&&$e===14||re===6&&$e===6)}var Pe;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(e.GraphemeBreakType=Pe={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Fe()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const pe=this.d,we=pe.length/3;let ve=1;for(;ve<=we;)if($e<pe[3*ve])ve=2*ve;else if($e>pe[3*ve+1])ve=2*ve+1;else return pe[3*ve+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function De(re,$e){if(re===0)return 0;const pe=Ue(re,$e);if(pe!==void 0)return pe;const we=new V($e,re);return we.prevCodePoint(),we.offset}e.$Mf=De;function Ue(re,$e){const pe=new V($e,re);let we=pe.prevCodePoint();for(;Te(we)||we===65039||we===8419;){if(pe.offset===0)return;we=pe.prevCodePoint()}if(!ie(we))return;let ve=pe.offset;return ve>0&&pe.prevCodePoint()===8205&&(ve=pe.offset),ve}function Te(re){return 127995<=re&&re<=127999}var qe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$Nf="\xA0";class ze{static{this.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$Me($e=>{function pe(Me){const Je=new Map;for(let He=0;He<Me.length;He+=2)Je.set(Me[He],Me[He+1]);return Je}function we(Me,Je){const He=new Map(Me);for(const[_e,tt]of Je)He.set(_e,tt);return He}function ve(Me,Je){if(!Me)return Je;const He=new Map;for(const[_e,tt]of Me)Je.has(_e)&&He.set(_e,tt);return He}const ke=this.c.value;let Ie=$e.filter(Me=>!Me.startsWith("_")&&Me in ke);Ie.length===0&&(Ie=["_default"]);let Ae;for(const Me of Ie){const Je=pe(ke[Me]);Ae=ve(Ae,Je)}const Ve=pe(ke._common),Be=we(Ve,Ae);return new ze(Be)})}static getInstance($e){return ze.d.get(Array.from($e))}static{this.e=new A.$V(()=>Object.keys(ze.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return ze.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Of=ze;class Le{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Le.c())),this.d}static isInvisibleCharacter($e){return Le.e().has($e)}static get codePoints(){return Le.e()}}e.$Pf=Le}),define(le[53],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=void 0;function A(l){return j(l,0)}e.$3i=A;function j(l,u){switch(typeof l){case"object":return l===null?L(349,u):Array.isArray(l)?k(l,u):g(l,u);case"string":return R(l,u);case"boolean":return I(l,u);case"number":return L(l,u);case"undefined":return L(937,u);default:return L(617,u)}}e.$4i=j;function L(l,u){return(u<<5)-u+l|0}e.$5i=L;function I(l,u){return L(l?433:863,u)}function R(l,u){u=L(149417,u);for(let d=0,c=l.length;d<c;d++)u=L(l.charCodeAt(d),u);return u}e.$6i=R;function k(l,u){return u=L(104579,u),l.reduce((d,c)=>j(c,d),u)}function g(l,u){return u=L(181387,u),Object.keys(l).sort().reduce((d,c)=>(d=R(c,d),j(l[c],d)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=j(u,this.g),this.g}}e.$7i=C;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(l,u,d=32){const c=d-u,y=~((1<<c)-1);return(l<<u|(y&l)>>>c)>>>0}function h(l,u=0,d=l.byteLength,c=0){for(let y=0;y<d;y++)l[u+y]=c}function $(l,u,d="0"){for(;l.length<u;)l=d+l;return l}function p(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),u/4)}e.$8i=p;class E{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const d=u.length;if(d===0)return;const c=this.p;let y=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=u.charCodeAt(0),n=0);;){let s=o;if(O.$lf(o))if(n+1<d){const t=u.charCodeAt(n+1);O.$mf(t)?(n++,s=O.$nf(o,t)):s=65533}else{i=o;break}else O.$mf(o)&&(s=65533);if(y=this.w(c,y,s),n++,n<d)o=u.charCodeAt(n);else break}this.r=y,this.u=i}w(u,d,c){return c<128?u[d++]=c:c<2048?(u[d++]=192|(c&1984)>>>6,u[d++]=128|(c&63)>>>0):c<65536?(u[d++]=224|(c&61440)>>>12,u[d++]=128|(c&4032)>>>6,u[d++]=128|(c&63)>>>0):(u[d++]=240|(c&1835008)>>>18,u[d++]=128|(c&258048)>>>12,u[d++]=128|(c&4032)>>>6,u[d++]=128|(c&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=E.g,d=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let c=this.h,y=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=y&i|~y&o,t=1518500249):a<40?(s=y^i^o,t=1859775393):a<60?(s=y&i|y&o|i&o,t=2400959708):(s=y^i^o,t=3395469782),r=m(c,5)+s+n+t+u.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(y,30),y=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+y&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$9i=E}),define(le[89],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(A||(A={})),function(j){const L="error",I="warning",R="warn",k="info",g="ignore";function C(m){return m?O.$hf(L,m)?j.Error:O.$hf(I,m)||O.$hf(R,m)?j.Warning:O.$hf(k,m)?j.Info:j.Ignore:j.Ignore}j.fromValue=C;function S(m){switch(m){case j.Error:return L;case j.Warning:return I;case j.Info:return k;default:return g}}j.toString=S}(A||(A={})),e.default=A}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=void 0,e.$Zd=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class j{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),p=this.b.charCodeAt(this.c);return $-p}value(){return this.b[this.c]}}e.$ei=j;class L{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,A.$bf)(h,this.b,0,h.length,this.c,this.d):(0,A.$df)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$fi=L;class I{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const p=this.b.charCodeAt($);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,A.$bf)(h,this.b,0,h.length,this.d,this.e):(0,A.$df)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$gi=I;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,A.$cf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,A.$cf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,A.$af)(h,this.c.query);if(this.d[this.e]===5)return(0,A.$af)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$hi=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class S{static forUris(h=()=>!1,$=()=>!1){return new S(new k(h,$))}static forPaths(h=!1){return new S(new I(void 0,!h))}static forStrings(){return new S(new j)}static forConfigKeys(){return new S(new L)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const p=$.slice(0);(0,O.$Xb)(p);for(const E of p)this.set(E,h)}else{const p=h.slice(0);(0,O.$Xb)(p);for(const E of p)this.set(E[0],E[1])}}set(h,$){const p=this.b.reset(h);let E;this.c||(this.c=new g,this.c.segment=p.value());const l=[];for(E=this.c;;){const d=p.cmp(E.segment);if(d>0)E.left||(E.left=new g,E.left.segment=p.value()),l.push([-1,E]),E=E.left;else if(d<0)E.right||(E.right=new g,E.right.segment=p.value()),l.push([1,E]),E=E.right;else if(p.hasNext())p.next(),E.mid||(E.mid=new g,E.mid.segment=p.value()),l.push([0,E]),E=E.mid;else break}const u=E.value;E.value=$,E.key=h;for(let d=l.length-1;d>=0;d--){const c=l[d][1];c.updateHeight();const y=c.balanceFactor();if(y<-1||y>1){const i=l[d][0],o=l[d+1][0];if(i===1&&o===1)l[d][1]=c.rotateLeft();else if(i===-1&&o===-1)l[d][1]=c.rotateRight();else if(i===1&&o===-1)c.right=l[d+1][1]=l[d+1][1].rotateRight(),l[d][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=l[d+1][1]=l[d+1][1].rotateLeft(),l[d][1]=c.rotateRight();else throw new Error;if(d>0)switch(l[d-1][0]){case-1:l[d-1][1].left=l[d][1];break;case 1:l[d-1][1].right=l[d][1];break;case 0:l[d-1][1].mid=l[d][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let p=this.c;for(;p;){const E=$.cmp(p.segment);if(E>0)p=p.left;else if(E<0)p=p.right;else if($.hasNext())$.next(),p=p.mid;else break}return p}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const p=this.b.reset(h),E=[];let l=this.c;for(;l;){const u=p.cmp(l.segment);if(u>0)E.push([-1,l]),l=l.left;else if(u<0)E.push([1,l]),l=l.right;else if(p.hasNext())p.next(),E.push([0,l]),l=l.mid;else break}if(l){if($?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:d,value:c,segment:y}=u;this.e(u.key,!1),l.key=d,l.value=c,l.segment=y}}else{const u=l.left??l.right;if(E.length>0){const[d,c]=E[E.length-1];switch(d){case-1:c.left=u;break;case 0:c.mid=u;break;case 1:c.right=u;break}}else this.c=u}for(let u=E.length-1;u>=0;u--){const d=E[u][1];d.updateHeight();const c=d.balanceFactor();if(c>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),E[u][1]=d.rotateLeft()):c<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),E[u][1]=d.rotateRight()),u>0)switch(E[u-1][0]){case-1:E[u-1][1].left=E[u][1];break;case 1:E[u-1][1].right=E[u][1];break;case 0:E[u-1][1].mid=E[u][1];break}else this.c=E[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let p=this.c,E;for(;p;){const l=$.cmp(p.segment);if(l>0)p=p.left;else if(l<0)p=p.right;else if($.hasNext())$.next(),E=p.value||E,p=p.mid;else break}return p&&p.value||E}findSuperstr(h){return this.g(h,!1)}g(h,$){const p=this.b.reset(h);let E=this.c;for(;E;){const l=p.cmp(E.segment);if(l>0)E=E.left;else if(l<0)E=E.right;else if(p.hasNext())p.next(),E=E.mid;else return E.mid?this.h(E.mid):$?E.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,p]of this)h(p,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const p=$.balanceFactor();return p<-1||p>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$ii=S}),define(le[12],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function O(y){return typeof y=="string"}e.$Qf=O;function A(y){return Array.isArray(y)&&y.every(i=>O(i))}e.$Rf=A;function j(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}e.$Sf=j;function L(y){const i=Object.getPrototypeOf(Uint8Array);return typeof y=="object"&&y instanceof i}e.$Tf=L;function I(y){return typeof y=="number"&&!isNaN(y)}e.$Uf=I;function R(y){return!!y&&typeof y[Symbol.iterator]=="function"}e.$Vf=R;function k(y){return y===!0||y===!1}e.$Wf=k;function g(y){return typeof y>"u"}e.$Xf=g;function C(y){return!S(y)}e.$Yf=C;function S(y){return g(y)||y===null}e.$Zf=S;function m(y,i){if(!y)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$1f=m;function h(y){if(S(y))throw new Error("Assertion Failed: argument is undefined or null");return y}e.$2f=h;function $(...y){const i=[];for(let o=0;o<y.length;o++){const n=y[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.$3f=$;const p=Object.prototype.hasOwnProperty;function E(y){if(!j(y))return!1;for(const i in y)if(p.call(y,i))return!1;return!0}e.$4f=E;function l(y){return typeof y=="function"}e.$5f=l;function u(...y){return y.length>0&&y.every(l)}e.$6f=u;function d(y,i){const o=Math.min(y.length,i.length);for(let n=0;n<o;n++)c(y[n],i[n])}e.$7f=d;function c(y,i){if(O(i)){if(typeof y!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(l(i)){try{if(y instanceof i)return}catch{}if(!S(y)&&y.constructor===i||i.length===1&&i.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$8f=c}),define(le[30],he([0,1,12]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function A(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([d,c])=>{u[d]=c&&typeof c=="object"?A(c):c}),u}e.$Fn=A;function j(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const d=u.shift();Object.freeze(d);for(const c in d)if(L.call(d,c)){const y=d[c];typeof y=="object"&&!Object.isFrozen(y)&&!(0,O.$Tf)(y)&&u.push(y)}}return l}e.$Gn=j;const L=Object.prototype.hasOwnProperty;function I(l,u){return R(l,u,new Set)}e.$Hn=I;function R(l,u,d){if((0,O.$Zf)(l))return l;const c=u(l);if(typeof c<"u")return c;if(Array.isArray(l)){const y=[];for(const i of l)y.push(R(i,u,d));return y}if((0,O.$Sf)(l)){if(d.has(l))throw new Error("Cannot clone recursive data-structure");d.add(l);const y={};for(const i in l)L.call(l,i)&&(y[i]=R(l[i],u,d));return d.delete(l),y}return l}function k(l,u,d=!0){return(0,O.$Sf)(l)?((0,O.$Sf)(u)&&Object.keys(u).forEach(c=>{c in l?d&&((0,O.$Sf)(l[c])&&(0,O.$Sf)(u[c])?k(l[c],u[c],d):l[c]=u[c]):l[c]=u[c]}),l):u}e.$In=k;function g(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let d,c;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(d=0;d<l.length;d++)if(!g(l[d],u[d]))return!1}else{const y=[];for(c in l)y.push(c);y.sort();const i=[];for(c in u)i.push(c);if(i.sort(),!g(y,i))return!1;for(d=0;d<y.length;d++)if(!g(l[y[d]],u[y[d]]))return!1}return!0}e.$Jn=g;function C(l){const u=new Set;return JSON.stringify(l,(d,c)=>{if((0,O.$Sf)(c)||Array.isArray(c)){if(u.has(c))return"[Circular]";u.add(c)}return c})}e.$Kn=C;function S(l,u){const d=Object.create(null);return!l||!u||Object.keys(u).forEach(y=>{const i=l[y],o=u[y];g(i,o)||(d[y]=o)}),d}e.$Ln=S;function m(l,u){const d=u.toLowerCase(),c=Object.keys(l).find(y=>y.toLowerCase()===d);return c?l[c]:l[u]}e.$Mn=m;function h(l,u){const d=Object.create(null);for(const[c,y]of Object.entries(l))u(c,y)&&(d[c]=y);return d}e.$Nn=h;function $(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$On=$;function p(l){const u=[];for(const d of $(l))typeof l[d]=="function"&&u.push(d);return u}e.$Pn=p;function E(l,u){const d=y=>function(){const i=Array.prototype.slice.call(arguments,0);return u(y,i)},c={};for(const y of l)c[y]=d(y);return c}e.$Qn=E}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=e.$xg=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(j){return O.test(j)}e.$xg=A,e.$yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),I=[];for(let R=0;R<256;R++)I.push(R.toString(16).padStart(2,"0"));return function(){j(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,g="";return g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+="-",g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g+=I[L[k++]],g}}()}),define(le[131],he([0,1,36]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(I){const R=I.replace(/\-/g,":").toLowerCase();return!A.has(R)}function L(){const I=(0,O.networkInterfaces)();for(const R in I){const k=I[R];if(k){for(const{mac:g}of k)if(j(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$gn=L}),define(le[132],he([0,1,267,14]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tV=void 0;class j extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const R=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(I,R,k){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,A.$re)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(I){this.a&&this.push(this.a),I()}}e.$tV=j}),define(le[133],he([0,1,64]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=e.$Ag=void 0;function A(R,k,g,C=1){let S=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!S)return S=!0,m(0)},g);j(R,k,C,$=>{if(!S)return S=!0,clearTimeout(h),m($)})})}e.$Ag=A;function j(R,k,g,C){if(k===0)return C(0);const S=new O.Socket;S.once("connect",()=>(I(S),j(R+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",m=>(I(S),m.code!=="ECONNREFUSED"?j(R+g,k-1,g,C):C(R))),S.connect(R,"127.0.0.1")}e.$Bg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,k,g,C="127.0.0.1"){let S=!1,m,h=1;const $=O.createServer({pauseOnConnect:!0});function p(E,l){S||(S=!0,$.removeAllListeners(),$.close(),m&&clearTimeout(m),l(E))}return new Promise(E=>{m=setTimeout(()=>{p(0,E)},g),$.on("listening",()=>{p(R,E)}),$.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<k?(R++,h++,$.listen(R,C)):p(0,E)}),$.on("close",()=>{p(0,E)}),$.listen(R,C)})}e.$Cg=L;function I(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JV=void 0;function O(A){return!!A.parentPort}e.$JV=O}),define(le[135],he([13,10]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;const A=60,j=A*60,L=j*24,I=L*7,R=L*30,k=L*365;function g(m,h,$,p){typeof m!="number"&&(m=m.getTime());const E=Math.round((new Date().getTime()-m)/1e3);if(E<-30)return(0,O.localize)(0,null,g(new Date().getTime()+E*1e3,!1));if(!p&&E<30)return(0,O.localize)(1,null);let l;return E<A?(l=E,h?l===1?$?(0,O.localize)(2,null,l):(0,O.localize)(3,null,l):$?(0,O.localize)(4,null,l):(0,O.localize)(5,null,l):l===1?$?(0,O.localize)(6,null,l):(0,O.localize)(7,null,l):$?(0,O.localize)(8,null,l):(0,O.localize)(9,null,l)):E<j?(l=Math.floor(E/A),h?l===1?$?(0,O.localize)(10,null,l):(0,O.localize)(11,null,l):$?(0,O.localize)(12,null,l):(0,O.localize)(13,null,l):l===1?$?(0,O.localize)(14,null,l):(0,O.localize)(15,null,l):$?(0,O.localize)(16,null,l):(0,O.localize)(17,null,l)):E<L?(l=Math.floor(E/j),h?l===1?$?(0,O.localize)(18,null,l):(0,O.localize)(19,null,l):$?(0,O.localize)(20,null,l):(0,O.localize)(21,null,l):l===1?$?(0,O.localize)(22,null,l):(0,O.localize)(23,null,l):$?(0,O.localize)(24,null,l):(0,O.localize)(25,null,l)):E<I?(l=Math.floor(E/L),h?l===1?(0,O.localize)(26,null,l):(0,O.localize)(27,null,l):l===1?(0,O.localize)(28,null,l):(0,O.localize)(29,null,l)):E<R?(l=Math.floor(E/I),h?l===1?$?(0,O.localize)(30,null,l):(0,O.localize)(31,null,l):$?(0,O.localize)(32,null,l):(0,O.localize)(33,null,l):l===1?$?(0,O.localize)(34,null,l):(0,O.localize)(35,null,l):$?(0,O.localize)(36,null,l):(0,O.localize)(37,null,l)):E<k?(l=Math.floor(E/R),h?l===1?$?(0,O.localize)(38,null,l):(0,O.localize)(39,null,l):$?(0,O.localize)(40,null,l):(0,O.localize)(41,null,l):l===1?$?(0,O.localize)(42,null,l):(0,O.localize)(43,null,l):$?(0,O.localize)(44,null,l):(0,O.localize)(45,null,l)):(l=Math.floor(E/k),h?l===1?$?(0,O.localize)(46,null,l):(0,O.localize)(47,null,l):$?(0,O.localize)(48,null,l):(0,O.localize)(49,null,l):l===1?$?(0,O.localize)(50,null,l):(0,O.localize)(51,null,l):$?(0,O.localize)(52,null,l):(0,O.localize)(53,null,l))}e.$Em=g;function C(m,h){const $=Math.abs(m/1e3);return $<1?h?(0,O.localize)(54,null,m):(0,O.localize)(55,null,m):$<A?h?(0,O.localize)(56,null,Math.round(m)/1e3):(0,O.localize)(57,null,Math.round(m)/1e3):$<j?h?(0,O.localize)(58,null,Math.round(m/(1e3*A))):(0,O.localize)(59,null,Math.round(m/(1e3*A))):$<L?h?(0,O.localize)(60,null,Math.round(m/(1e3*j))):(0,O.localize)(61,null,Math.round(m/(1e3*j))):(0,O.localize)(62,null,Math.round(m/(1e3*L)))}e.$Fm=C;function S(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Gm=S}),define(le[136],he([13,10]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,136]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=void 0;function L(S,m){return m&&(S.stack||S.stacktrace)?j.localize(0,null,R(S),I(S.stack)||I(S.stacktrace)):R(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?j.localize(1,null,S.message):S.message||j.localize(2,null)}function k(S=null,m=!1){if(!S)return j.localize(3,null);if(Array.isArray(S)){const h=O.$Hb(S),$=k(h[0],m);return h.length>1?j.localize(4,null,$,h.length):$}if(A.$Qf(S))return S;if(S.detail){const h=S.detail;if(h.error)return L(h.error,m);if(h.exception)return L(h.exception,m)}return S.stack?L(S,m):S.message?S.message:j.localize(5,null)}e.$Zi=k;function g(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.$1i=g;function C(S,m){let h;return typeof S=="string"?h=new Error(S):h=S,h.actions=m,h}e.$2i=C}),define(le[137],he([13,10]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;function A(j){switch(j){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$7p=A}),define(le[139],he([13,10]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let A=!1,j=!1,L=!1,I=!1,R=!1,k=!1,g=!1,C=!1,S=!1,m=!1,h,$=e.$g,p=e.$g,E,l;const u=globalThis;let d;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?d=u.vscode.process:typeof process<"u"&&(d=process);const c=typeof d?.versions?.electron=="string",y=c&&d?.type==="renderer";if(typeof d=="object"){A=d.platform==="win32",j=d.platform==="darwin",L=d.platform==="linux",I=L&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=c,S=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$g,$=e.$g;const f=d.env.VSCODE_NLS_CONFIG;if(f)try{const b=JSON.parse(f),P=b.availableLanguages["*"];h=b.locale,p=b.osLocale,$=P||e.$g,E=b._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!y?(l=navigator.userAgent,A=l.indexOf("Windows")>=0,j=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=l.indexOf("Linux")>=0,m=l?.indexOf("Mobi")>=0,k=!0,h=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$g,$=h,p=navigator.language):console.error("Unable to resolve platform.");var i;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;j?n=1:A?n=3:L&&(n=2),e.$i=A,e.$j=j,e.$k=L,e.$l=I,e.$m=R,e.$n=g,e.$o=k,e.$p=k&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=C,e.$s=m,e.$t=S,e.$u=n,e.$v=l,e.$w=$;var s;(function(f){function b(){return e.$w}f.value=b;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=P;function N(){return e.$w==="en"}f.isDefault=N})(s||(e.Language=s={})),e.$x=h,e.$y=p,e.$z=E,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const f=[];u.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,F=f.length;N<F;N++){const M=f[N];if(M.id===P.data.vscodeScheduleAsyncWork){f.splice(N,1),M.callback();return}}});let b=0;return P=>{const N=++b;f.push({id:N,callback:P}),u.postMessage({vscodeScheduleAsyncWork:N},"*")}}return f=>setTimeout(f)})();var t;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=j||C?2:A?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,r=new Uint16Array(f.buffer)[0]===513}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(f){return parseFloat(f)>=20}e.$J=w}),define(le[37],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let A;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const L=j.process;A={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.$dc=A.platform,e.$ec=A.arch}),define(le[16],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const A=65,j=97,L=90,I=122,R=46,k=47,g=92,C=58,S=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function $(i,o){if(typeof i!="string")throw new m(o,"string",i)}const p=O.$dc==="win32";function E(i){return i===k||i===g}function l(i){return i===k}function u(i){return i>=A&&i<=L||i>=j&&i<=I}function d(i,o,n,s){let t="",r=0,a=-1,v=0,w=0;for(let f=0;f<=i.length;++f){if(f<i.length)w=i.charCodeAt(f);else{if(s(w))break;w=k}if(s(w)){if(!(a===f-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const b=t.lastIndexOf(n);b===-1?(t="",r=0):(t=t.slice(0,b),r=t.length-1-t.lastIndexOf(n)),a=f,v=0;continue}else if(t.length!==0){t="",r=0,a=f,v=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,f)}`:t=i.slice(a+1,f),r=f-a-1;a=f,v=0}else w===R&&v!==-1?++v:v=-1}return t}function c(i,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],$(r,"path"),r.length===0)continue}else o.length===0?r=O.cwd():(r=O.env[`=${o}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,w="",f=!1;const b=r.charCodeAt(0);if(a===1)E(b)&&(v=1,f=!0);else if(E(b))if(f=!0,E(r.charCodeAt(1))){let P=2,N=P;for(;P<a&&!E(r.charCodeAt(P));)P++;if(P<a&&P!==N){const F=r.slice(N,P);for(N=P;P<a&&E(r.charCodeAt(P));)P++;if(P<a&&P!==N){for(N=P;P<a&&!E(r.charCodeAt(P));)P++;(P===a||P!==N)&&(w=`\\\\${F}\\${r.slice(N,P)}`,v=P)}}}else v=1;else u(b)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,a>2&&E(r.charCodeAt(2))&&(f=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(s){if(o.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=f,f&&o.length>0)break}return n=d(n,!s,"\\",E),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){$(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return l(r)?"\\":i;if(E(r))if(t=!0,E(i.charCodeAt(1))){let v=2,w=v;for(;v<o&&!E(i.charCodeAt(v));)v++;if(v<o&&v!==w){const f=i.slice(w,v);for(w=v;v<o&&E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!E(i.charCodeAt(v));)v++;if(v===o)return`\\\\${f}\\${i.slice(w)}\\`;v!==w&&(s=`\\\\${f}\\${i.slice(w,v)}`,n=v)}}}else n=1;else u(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&E(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?d(i.slice(n),!t,"\\",E):"";return a.length===0&&!t&&(a="."),a.length>0&&E(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){$(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return E(n)||o>2&&u(n)&&i.charCodeAt(1)===C&&E(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&E(n.charCodeAt(0))){++t;const r=n.length;r>1&&E(n.charCodeAt(1))&&(++t,r>2&&(E(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&E(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===g;)w--;const f=w-v,b=a<f?a:f;let P=-1,N=0;for(;N<b;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(v+N))break;M===g&&(P=N)}if(N!==b){if(P===-1)return s}else{if(f>b){if(o.charCodeAt(v+N)===g)return s.slice(v+N+1);if(N===2)return s.slice(v+N)}a>b&&(i.charCodeAt(t+N)===g?P=N:N===2&&(P=3)),P===-1&&(P=0)}let F="";for(N=t+P+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(F+=F.length===0?"..":"\\..");return v+=P,F.length>0?`${F}${s.slice(v,w)}`:(s.charCodeAt(v)===g&&++v,s.slice(v,w))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==S&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){$(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return E(t)?i:".";if(E(t)){if(n=s=1,E(i.charCodeAt(1))){let v=2,w=v;for(;v<o&&!E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&E(i.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!E(i.charCodeAt(v));)v++;if(v===o)return i;v!==w&&(n=s=v+1)}}}}else u(t)&&i.charCodeAt(1)===C&&(n=o>2&&E(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=o-1;v>=s;--v)if(E(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&u(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=n;--r){const w=i.charCodeAt(r);if(E(w)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(E(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&u(i.charCodeAt(0))&&(o=s=2);for(let v=i.length-1;v>=o;--v){const w=i.charCodeAt(v);if(E(w)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return E(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(E(t)){if(s=1,E(i.charCodeAt(1))){let P=2,N=P;for(;P<n&&!E(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&E(i.charCodeAt(P));)P++;if(P<n&&P!==N){for(N=P;P<n&&!E(i.charCodeAt(P));)P++;P===n?s=P:P!==N&&(s=P+1)}}}}else if(u(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,E(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,v=-1,w=!0,f=i.length-1,b=0;for(;f>=s;--f){if(t=i.charCodeAt(f),E(t)){if(!w){a=f+1;break}continue}v===-1&&(w=!1,v=f+1),t===R?r===-1?r=f:b!==1&&(b=1):r!==-1&&(b=-1)}return v!==-1&&(r===-1||b===0||b===1&&r===v-1&&r===a+1?o.base=o.name=i.slice(a,v):(o.name=i.slice(a,r),o.base=i.slice(a,v),o.ext=i.slice(r,v))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const y=(()=>{if(p){const i=/\\/g;return()=>{const o=O.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>O.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:y();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=d(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k,n=i.charCodeAt(i.length-1)===k;return i=d(i,!o,"/",l),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return $(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,v=t<a?t:a;let w=-1,f=0;for(;f<v;f++){const P=i.charCodeAt(n+f);if(P!==o.charCodeAt(r+f))break;P===k&&(w=f)}if(f===v)if(a>v){if(o.charCodeAt(r+f)===k)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else t>v&&(i.charCodeAt(n+f)===k?w=f:f===0&&(w=0));let b="";for(f=n+w+1;f<=s;++f)(f===s||i.charCodeAt(f)===k)&&(b+=b.length===0?"..":"/..");return`${b}${o.slice(r+w)}`},toNamespacedPath(i){return i},dirname(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,v=-1;for(r=i.length-1;r>=0;--r){const w=i.charCodeAt(r);if(w===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===k){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===k;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,w=i.length-1,f=0;for(;w>=s;--w){const b=i.charCodeAt(w);if(b===k){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),b===R?t===-1?t=w:f!==1&&(f=1):t!==-1&&(f=-1)}if(a!==-1){const b=r===0&&n?1:r;t===-1||f===0||f===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(b,a):(o.name=i.slice(b,t),o.base=i.slice(b,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=p?e.$fc.normalize:e.$gc.normalize,e.$ic=p?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=p?e.$fc.join:e.$gc.join,e.$kc=p?e.$fc.resolve:e.$gc.resolve,e.$lc=p?e.$fc.relative:e.$gc.relative,e.$mc=p?e.$fc.dirname:e.$gc.dirname,e.$nc=p?e.$fc.basename:e.$gc.basename,e.$oc=p?e.$fc.extname:e.$gc.extname,e.$pc=p?e.$fc.format:e.$gc.format,e.$qc=p?e.$fc.parse:e.$gc.parse,e.$rc=p?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=p?e.$fc.sep:e.$gc.sep,e.$tc=p?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,16,5,27,12]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function I(r){return r===47||r===92}e.$9f=I;function R(r){return r.replace(/[\\/]/g,O.$gc.sep)}e.$0f=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$$f=k;function g(r,a=O.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(I(w)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let b=3;const P=b;for(;b<v&&!I(r.charCodeAt(b));b++);if(P!==b&&!I(r.charCodeAt(b+1))){for(b+=1;b<v;b++)if(I(r.charCodeAt(b)))return r.slice(0,b+1).replace(/[\\/]/g,a)}}return a}else if(l(w)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<v;f++)if(I(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$_f=g;function C(r){if(!A.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$ag=C;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=A.$i){const v=a?S:m;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$bg=$;function p(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,j.$hf)(r,a)}e.$cg=p;function E(r,a,v,w=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,j.$if)(r,a))return!1;if(a.length===r.length)return!0;let b=a.length;return a.charAt(a.length-1)===w&&b--,r.charAt(b)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$dg=E;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$eg=l;function u(r,a){return A.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$ic)(r)||(r=(0,O.$jc)(a,r)),r=(0,O.$hc)(r),A.$i?(r=(0,j.$2e)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,j.$2e)(r,O.sep),r||(r=O.sep)),r}e.$fg=u;function d(r){const a=(0,O.$hc)(r);return A.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$gc.sep}e.$gg=d;function c(r,a=A.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$hg=c;function y(r,a=A.$i){return c(r,a)?r[0]:void 0}e.$ig=y;function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$jg=i;function o(r){const a=r.split(":");let v,w,f;for(const b of a){const P=Number(b);(0,L.$Uf)(P)?w===void 0?w=P:f===void 0&&(f=P):v=v?[v,b].join(":"):b}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.$kg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let b=0;b<v;b++){let P;b===0&&A.$i&&!a&&(v===3||v===4)?P=s:P=n,w+=P.charAt(Math.floor(Math.random()*P.length))}let f;return a?f=`${a}-${w}`:f=w,r?(0,O.$jc)(r,f):f}e.$lg=t}),define(le[140],he([0,1,16]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.$ps=e.$os=void 0,e.$os=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const S=(0,O.$oc)(C),m=A[S.toLowerCase()];return m!==void 0?m:I(C)}e.$ps=L;function I(C){const S=(0,O.$oc)(C);return j[S.toLowerCase()]}e.$qs=I;function R(C){for(const S in j)if(j[S]===C)return S}e.$rs=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const m=k.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:C}e.$ss=g}),define(le[90],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.TerminateResponseCode=e.Source=void 0;var A;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(A||(e.Source=A={}));var j;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function L(R,...k){const g=k.reduce((m,h)=>(m[h]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!g[m]).forEach(m=>{for(let h=0;h<C.length;h++)if(m.search(C[h])!==-1){delete R[m];break}})}e.$1l=L;function I(R){R&&(delete R.DEBUG,O.$j&&delete R.DYLD_LIBRARY_PATH,O.$k&&delete R.LD_PRELOAD)}e.$2l=I}),define(le[9],he([0,1,16,5]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,L=/^\//,I=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!j.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,f=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,f),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=w||C,R(this,f))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:f}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),f===void 0?f=this.fragment:f===null&&(f=C),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&f===this.fragment?this:new E(r,a,v,w,f)}static parse(t,r=!1){const a=m.exec(t);return a?new E(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new E(C,C,C,C,C)}static file(t){let r=C;if(A.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new E("file",r,t,C,C)}static from(t,r){return new E(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return A.$i&&t.scheme==="file"?a=h.file(O.$fc.join(c(t,!0),...r)).path:a=O.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return y(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new E(t);return r._formatted=t.external??null,r._fsPath=t._sep===p?t.fsPath??null:null,r}}else return t}}e.URI=h;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=$;const p=A.$i?1:void 0;class E extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=p),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,t,r){let a,v=-1;for(let w=0;w<s.length;w++){const f=s.charCodeAt(w);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47||r&&f===91||r&&f===93||r&&f===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,w)),v=-1),a!==void 0&&(a+=s.charAt(w));else{a===void 0&&(a=s.substr(0,w));const b=l[f];b!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,w)),v=-1),a+=b):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function d(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=l[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,A.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=c;function y(s,t){const r=t?d:u;let a="",{scheme:v,authority:w,path:f,query:b,fragment:P}=s;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=S,a+=S),w){let N=w.indexOf("@");if(N!==-1){const F=w.substr(0,N);w=w.substr(N+1),N=F.lastIndexOf(":"),N===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,N),!1,!1),a+=":",a+=r(F.substr(N+1),!1,!0)),a+="@"}w=w.toLowerCase(),N=w.lastIndexOf(":"),N===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,N),!1,!0),a+=w.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return b&&(a+="?",a+=r(b,!1,!1)),P&&(a+="#",a+=t?P:u(P,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[141],he([0,1,9]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$xq=e.$wq=e.$vq=void 0;function A(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$vq=A;function j(g){const C=[];let S;try{const m=JSON.parse(g.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),S=h.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$wq=j;function L(g){if(typeof g!="string")return L(j(g).stack);const C=g;if(C){const S=I(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:O.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$xq=L;function I(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:S,stack:m}=j(g),h=typeof S[0]=="string"&&S.length===1;let $=I(m);$&&($=`(${$.trim()})`);let p=[];if(typeof S[0]=="string"?$&&h?p=[`%c[${C}] %c${S[0]} %c${$}`,k("blue"),k(""),k("grey")]:p=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:p=[`%c[${C}]%`,k("blue"),...S],$&&!h&&p.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function k(g){return`color: ${g}`}}),define(le[66],he([0,1,14,9]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function j(k){return JSON.stringify(k,I)}e.$Jh=j;function L(k){let g=JSON.parse(k);return g=R(g),g}e.$Kh=L;function I(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof O.$qe||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$Lh=R}),define(le[23],he([0,1,7,5,27,9]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.Schemas=void 0;var I;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting",m.codeFeature="code-feature"})(I||(e.Schemas=I={}));function R(m,h){return L.URI.isUri(m)?(0,j.$hf)(m.scheme,h):(0,j.$if)(m,h+":")}e.$mg=R;function k(m,...h){return h.some($=>R(m,$))}e.$ng=k,e.$og="vscode-tkn",e.$pg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${I.vscodeRemoteResource}`}set(h,$,p){this.a[h]=$,this.b[h]=p}setConnectionToken(h,$){this.c[h]=$}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(d){return O.$1(d),h}const $=h.authority;let p=this.a[$];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const E=this.b[$],l=this.c[$];let u=`path=${encodeURIComponent(h.path)}`;return typeof l=="string"&&(u+=`&${e.$pg}=${encodeURIComponent(l)}`),L.URI.from({scheme:A.$o?this.d:I.vscodeRemoteResource,authority:`${p}:${E}`,path:this.f,query:u})}}e.$qg=new g,e.$rg="vs/../../extensions",e.$sg="vs/../../node_modules",e.$tg="vs/../../node_modules.asar",e.$ug="vs/../../node_modules.asar.unpacked",e.$vg="vscode-app";class C{static{this.a=e.$vg}asBrowserUri(h){const $=this.b(h,se);return this.uriToBrowserUri($)}uriToBrowserUri(h){return h.scheme===I.vscodeRemote?e.$qg.rewrite(h):h.scheme===I.file&&(A.$m||A.$q===`${I.vscodeFileResource}://${C.a}`)?h.with({scheme:I.vscodeFileResource,authority:h.authority||C.a,query:null,fragment:null}):h}asFileUri(h){const $=this.b(h,se);return this.uriToFileUri($)}uriToFileUri(h){return h.scheme===I.vscodeFileResource?h.with({scheme:I.file,authority:h.authority!==C.a?h.authority:null,query:null,fragment:null}):h}b(h,$){return L.URI.isUri(h)?h:L.URI.parse($.toUrl(h))}}e.$wg=new C;var S;(function(m){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(h.get("3"));const $="vscode-coi";function p(l){let u;typeof l=="string"?u=new URL(l).searchParams:l instanceof URL?u=l.searchParams:L.URI.isUri(l)&&(u=new URL(l.toString(!0)).searchParams);const d=u?.get($);if(d)return h.get(d)}m.getHeadersFromQuery=p;function E(l,u,d){if(!globalThis.crossOriginIsolated)return;const c=u&&d?"3":d?"2":"1";l instanceof URLSearchParams?l.set($,c):l[$]=c}m.addSearchParam=E})(S||(e.COI=S={}))}),define(le[142],he([0,1,124,23,5,9]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=void 0;class I{constructor(m,h,$){this.id=m,this.dependencies=h,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,$)=>{typeof m!="string"&&($=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new I(m,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,$)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const E=()=>{p.removeEventListener("load",l),p.removeEventListener("error",u)},l=d=>{E(),h(this.c.pop())},u=d=>{E(),$(d)};p.addEventListener("load",l),p.addEventListener("error",u),this.f&&(m=this.f.createScriptURL(m)),p.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(p)})}i(m){return new Promise((h,$)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(p){$(p)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,E=L.URI.parse(m).fsPath,l=h.readFileSync(E).toString(),u=p.wrap(l.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,m,h){if(O.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const $=`${S}/${m}`;if(k.has($))return k.get($);let p;if(/^\w[\w\d+.-]*:\/\//.test($))p=$;else{const d=`${h&&!j.$o?A.$tg:A.$sg}/${$}`;p=A.$wg.asBrowserUri(d).toString(!0)}const E=R.INSTANCE.load(p);return k.set($,E),E}else return await new Promise(($,p)=>{se([S],$,p)})}e.$qD=C}),define(le[20],he([0,1,49,23,16,5,27,9]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=e.DataUri=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function k(h){return(0,R.$wc)(h,!0)}e.$Dg=k;class g{constructor($){this.a=$}compare($,p,E=!1){return $===p?0:(0,I.$af)(this.getComparisonKey($,E),this.getComparisonKey(p,E))}isEqual($,p,E=!1){return $===p?!0:!$||!p?!1:this.getComparisonKey($,E)===this.getComparisonKey(p,E)}getComparisonKey($,p=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,p,E=!1){if($.scheme===p.scheme){if($.scheme===A.Schemas.file)return O.$dg(k($),k(p),this.a($))&&$.query===p.query&&(E||$.fragment===p.fragment);if((0,e.$Ug)($.authority,p.authority))return O.$dg($.path,p.path,this.a($),"/")&&$.query===p.query&&(E||$.fragment===p.fragment)}return!1}joinPath($,...p){return R.URI.joinPath($,...p)}basenameOrAuthority($){return(0,e.$Mg)($)||$.authority}basename($){return j.$gc.basename($.path)}extname($){return j.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let p;return $.scheme===A.Schemas.file?p=R.URI.file(j.$mc(k($))).path:(p=j.$gc.dirname($.path),$.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),p="/")),$.with({path:p})}normalizePath($){if(!$.path.length)return $;let p;return $.scheme===A.Schemas.file?p=R.URI.file(j.$hc(k($))).path:p=j.$gc.normalize($.path),$.with({path:p})}relativePath($,p){if($.scheme!==p.scheme||!(0,e.$Ug)($.authority,p.authority))return;if($.scheme===A.Schemas.file){const u=j.$lc(k($),k(p));return L.$i?O.$0f(u):u}let E=$.path||"/";const l=p.path||"/";if(this.a($)){let u=0;for(const d=Math.min(E.length,l.length);u<d&&!(E.charCodeAt(u)!==l.charCodeAt(u)&&E.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);E=l.substr(0,u)+E.substr(u)}return j.$gc.relative(E,l)}resolvePath($,p){if($.scheme===A.Schemas.file){const E=R.URI.file(j.$kc(k($),p));return $.with({authority:E.authority,path:E.path})}return p=O.$$f(p),$.with({path:j.$gc.resolve($.path,p)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,p){return $===p||$!==void 0&&p!==void 0&&(0,I.$hf)($,p)}hasTrailingPathSeparator($,p=j.sep){if($.scheme===A.Schemas.file){const E=k($);return E.length>O.$_f(E).length&&E[E.length-1]===p}else{const E=$.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,p=j.sep){return(0,e.$Vg)($,p)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,p=j.sep){let E=!1;if($.scheme===A.Schemas.file){const l=k($);E=l!==void 0&&l.length===O.$_f(l).length&&l[l.length-1]===p}else{p="/";const l=$.path;E=l.length===1&&l.charCodeAt(l.length-1)===47}return!E&&!(0,e.$Vg)($,p)?$.with({path:$.path+"/"}):$}}e.$Eg=g,e.$Fg=new g(()=>!1),e.$Gg=new g(h=>h.scheme===A.Schemas.file?!L.$k:!0),e.$Hg=new g(h=>!0),e.$Ig=e.$Fg.isEqual.bind(e.$Fg),e.$Jg=e.$Fg.isEqualOrParent.bind(e.$Fg),e.$Kg=e.$Fg.getComparisonKey.bind(e.$Fg),e.$Lg=e.$Fg.basenameOrAuthority.bind(e.$Fg),e.$Mg=e.$Fg.basename.bind(e.$Fg),e.$Ng=e.$Fg.extname.bind(e.$Fg),e.$Og=e.$Fg.dirname.bind(e.$Fg),e.$Pg=e.$Fg.joinPath.bind(e.$Fg),e.$Qg=e.$Fg.normalizePath.bind(e.$Fg),e.$Rg=e.$Fg.relativePath.bind(e.$Fg),e.$Sg=e.$Fg.resolvePath.bind(e.$Fg),e.$Tg=e.$Fg.isAbsolutePath.bind(e.$Fg),e.$Ug=e.$Fg.isEqualAuthority.bind(e.$Fg),e.$Vg=e.$Fg.hasTrailingPathSeparator.bind(e.$Fg),e.$Wg=e.$Fg.removeTrailingPathSeparator.bind(e.$Fg),e.$Xg=e.$Fg.addTrailingPathSeparator.bind(e.$Fg);function C(h,$){const p=[];for(let E=0;E<h.length;E++){const l=$(h[E]);h.some((u,d)=>d===E?!1:(0,e.$Jg)(l,$(u)))||p.push(h[E])}return p}e.$Yg=C;var S;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(p){const E=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,y]=d.split(":");c&&y&&E.set(c,y)});const u=p.path.substring(0,p.path.indexOf(";"));return u&&E.set(h.META_DATA_MIME,u),E}h.parseMetaData=$})(S||(e.DataUri=S={}));function m(h,$,p){if($){let E=h.path;return E&&E[0]!==j.$gc.sep&&(E=j.$gc.sep+E),h.with({scheme:p,authority:$,path:E})}return h.with({scheme:p})}e.$Zg=m}),define(le[6],he([0,1,26,7,3,2,20,5,130,52]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.Promises=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0;function C(ie){return!!ie&&typeof ie.then=="function"}e.$1g=C;function S(ie){const J=new O.$ae,ne=ie(J.token),ce=new Promise((fe,de)=>{const me=J.token.onCancellationRequested(()=>{me.dispose(),de(new A.$5)});Promise.resolve(ne).then(Ee=>{me.dispose(),J.dispose(),fe(Ee)},Ee=>{me.dispose(),J.dispose(),de(Ee)})});return new class{cancel(){J.cancel(),J.dispose()}then(fe,de){return ce.then(fe,de)}catch(fe){return this.then(void 0,fe)}finally(fe){return ce.finally(fe)}}}e.$2g=S;function m(ie,J,ne){return new Promise((ce,fe)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ce(ne)});ie.then(ce,fe).finally(()=>de.dispose())})}e.$3g=m;function h(ie,J){return new Promise((ne,ce)=>{const fe=J.onCancellationRequested(()=>{fe.dispose(),ce(new A.$5)});ie.then(ne,ce).finally(()=>fe.dispose())})}e.$4g=h;async function $(ie){let J=-1;const ne=ie.map((ce,fe)=>ce.then(de=>(J=fe,de)));try{return await Promise.race(ne)}finally{ie.forEach((ce,fe)=>{fe!==J&&ce.cancel()})}}e.$5g=$;function p(ie,J,ne){let ce;const fe=setTimeout(()=>{ce?.(void 0),ne?.()},J);return Promise.race([ie.finally(()=>clearTimeout(fe)),new Promise(de=>ce=de)])}e.$6g=p;function E(ie){return new Promise((J,ne)=>{const ce=ie();C(ce)?ce.then(J,ne):J(ce)})}e.$7g=E;function l(){let ie,J;return{promise:new Promise((ce,fe)=>{ie=ce,J=fe}),resolve:ie,reject:J}}e.$8g=l;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const ne=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ne,ne).then(ce)})}return new Promise((ne,ce)=>{this.b.then(ne,ce)})}return this.a=J(),new Promise((ne,ce)=>{this.a.then(fe=>{this.a=null,ne(fe)},fe=>{this.a=null,ce(fe)})})}dispose(){this.f=!0}}e.$9g=u;class d{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$0g=d;class c{constructor(){this.a=new Map}queue(J,ne){const fe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(ne).finally(()=>{this.a.get(J)===fe&&this.a.delete(J)});return this.a.set(J,fe),fe}}e.$$g=c;const y=(ie,J)=>{let ne=!0;const ce=setTimeout(()=>{ne=!1,J()},ie);return{isTriggered:()=>ne,dispose:()=>{clearTimeout(ce),ne=!1}}},i=ie=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ie())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class o{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,ne=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((fe,de)=>{this.d=fe,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ne===k.$Zd?i(ce):y(ne,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$_g=o;class n{constructor(J){this.a=new o(J),this.b=new u}trigger(J,ne){return this.a.trigger(()=>this.b.queue(J),ne)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ah=n;class s{constructor(){this.a=!1,this.b=new Promise((J,ne)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$bh=s;class t extends s{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$ch=t;function r(ie,J){return J?new Promise((ne,ce)=>{const fe=setTimeout(()=>{de.dispose(),ne()},ie),de=J.onCancellationRequested(()=>{clearTimeout(fe),de.dispose(),ce(new A.$5)})}):S(ne=>r(ie,ne))}e.$dh=r;function a(ie,J=0,ne){const ce=setTimeout(()=>{ie(),ne&&fe.dispose()},J),fe=(0,L.$Rc)(()=>{clearTimeout(ce),ne?.deleteAndLeak(fe)});return ne?.add(fe),fe}e.$eh=a;function v(ie){const J=[];let ne=0;const ce=ie.length;function fe(){return ne<ce?ie[ne++]():null}function de(me){me!=null&&J.push(me);const Ee=fe();return Ee?Ee.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}e.$fh=v;function w(ie,J=ce=>!!ce,ne=null){let ce=0;const fe=ie.length,de=()=>{if(ce>=fe)return Promise.resolve(ne);const me=ie[ce++];return Promise.resolve(me()).then(Re=>J(Re)?Promise.resolve(Re):de())};return de()}e.$gh=w;function f(ie,J=ce=>!!ce,ne=null){if(ie.length===0)return Promise.resolve(ne);let ce=ie.length;const fe=()=>{ce=-1;for(const de of ie)de.cancel?.()};return new Promise((de,me)=>{for(const Ee of ie)Ee.then(Re=>{--ce>=0&&J(Re)?(fe(),de(Re)):ce===0&&de(ne)}).catch(Re=>{--ce>=0&&(fe(),me(Re))})})}e.$hh=f;class b{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new j.$3d}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ne,ce)=>{this.g.push({factory:J,c:ne,e:ce}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const ne=J.factory();ne.then(J.c,J.e),ne.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ih=b;class P extends b{constructor(){super(1)}}e.$jh=P;class N{constructor(){this.a=new te,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$kh=N;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ae;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,ne=I.$Fg){const ce=ne.getComparisonKey(J);return this.a.get(ce)?.size??0}queueFor(J,ne,ce=I.$Fg){const fe=ce.getComparisonKey(J);let de=this.a.get(fe);if(!de){de=new P;const me=this.f++,Ee=j.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(me,Ee),this.a.set(fe,de)}return de.queue(ne)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$lh=F;class M{constructor(J,ne){this.a=-1,typeof J=="function"&&typeof ne=="number"&&this.setIfNotSet(J,ne)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,ne){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},ne)}setIfNotSet(J,ne){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},ne))}}e.$mh=M;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,ne,ce=globalThis){this.cancel();const fe=ce.setInterval(()=>{J()},ne);this.d=(0,L.$Rc)(()=>{ce.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$nh=U;class Y{constructor(J,ne){this.b=-1,this.a=J,this.d=ne,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$oh=Y;class Q{constructor(J,ne){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.a=J,this.b=ne,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ph=Q;class x extends Y{constructor(J,ne){super(J,ne),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$qh=x;class G extends L.$Tc{constructor(J,ne){super(),this.g=J,this.h=ne,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ne of J)this.a.push(ne);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$rh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$th=(ie,J)=>{(0,R.$B)(()=>{if(ne)return;const ce=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.$th=(ie,J,ne)=>{const ce=ie.requestIdleCallback(J,typeof ne=="number"?{timeout:ne}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ie.cancelIdleCallback(ce))}}},e.$sh=ie=>(0,e.$th)(globalThis,ie)}();class Z{constructor(J,ne){this.g=!1,this.d=()=>{try{this.j=ne()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$th)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$uh=Z;class H extends Z{constructor(J){super(globalThis,J)}}e.$vh=H;async function V(ie,J,ne){let ce;for(let fe=0;fe<ne;fe++)try{return await ie()}catch(de){ce=de,await r(J)}throw ce}e.$wh=V;class te{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,ne,ce){return this.a={taskId:J,cancel:()=>ce?.(),promise:ne},ne.then(()=>this.d(J),()=>this.d(J)),ne}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:ne,resolve:ce,reject:fe}=l();this.b={run:J,promise:ne,promiseResolve:ce,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$xh=te;class oe{constructor(J,ne=()=>Date.now()){this.d=J,this.f=ne,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$yh=oe;var ee;(function(ie){ie[ie.Resolved=0]="Resolved",ie[ie.Rejected=1]="Rejected"})(ee||(ee={}));class ae{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,ne)=>{this.a=J,this.b=ne})}complete(J){return new Promise(ne=>{this.a(J),this.d={outcome:0,value:J},ne()})}error(J){return new Promise(ne=>{this.b(J),this.d={outcome:1,value:J},ne()})}cancel(){return this.error(new A.$5)}}e.$zh=ae;var W;(function(ie){async function J(ce){let fe;const de=await Promise.all(ce.map(me=>me.then(Ee=>Ee,Ee=>{fe||(fe=Ee)})));if(typeof fe<"u")throw fe;return de}ie.settled=J;function ne(ce){return new Promise(async(fe,de)=>{try{await ce(fe,de)}catch(me){de(me)}})}ie.withAsyncBody=ne})(W||(e.Promises=W={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(ne=>(this.a=ne,this.d=!0,ne),ne=>{throw this.b=ne,this.d=!0,ne})}requireValue(){if(!this.d)throw new A.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ah=z;class D{constructor(J){this.b=J,this.a=new g.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Bh=D;var T;(function(ie){ie[ie.Initial=0]="Initial",ie[ie.DoneOK=1]="DoneOK",ie[ie.DoneError=2]="DoneError"})(T||(T={}));class B{static fromArray(J){return new B(ne=>{ne.emitMany(J)})}static fromPromise(J){return new B(async ne=>{ne.emitMany(await J)})}static fromPromises(J){return new B(async ne=>{await Promise.all(J.map(async ce=>ne.emitOne(await ce)))})}static merge(J){return new B(async ne=>{await Promise.all(J.map(async ce=>{for await(const fe of ce)ne.emitOne(fe)}))})}static{this.EMPTY=B.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new j.$3d,queueMicrotask(async()=>{const ne={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(J(ne)),this.j()}catch(ce){this.k(ce)}finally{ne.emitOne=void 0,ne.emitMany=void 0,ne.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(J,ne){return new B(async ce=>{for await(const fe of J)ce.emitOne(ne(fe))})}map(J){return B.map(this,J)}static filter(J,ne){return new B(async ce=>{for await(const fe of J)ne(fe)&&ce.emitOne(fe)})}filter(J){return B.filter(this,J)}static coalesce(J){return B.filter(J,ne=>!!ne)}coalesce(){return B.coalesce(this)}static async toPromise(J){const ne=[];for await(const ce of J)ne.push(ce);return ne}toPromise(){return B.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Ch=B;class q extends B{constructor(J,ne){super(ne),this.l=J}cancel(){this.l.cancel()}}e.$Dh=q;function X(ie){const J=new O.$ae,ne=ie(J.token);return new q(J,async ce=>{const fe=J.token.onCancellationRequested(()=>{fe.dispose(),J.dispose(),ce.reject(new A.$5)});try{for await(const de of ne){if(J.token.isCancellationRequested)return;ce.emitOne(de)}fe.dispose(),J.dispose()}catch(de){fe.dispose(),J.dispose(),ce.reject(de)}})}e.$Eh=X;class _{constructor(){this.a=new ae,this.b=new B(ce=>{if(J){ce.reject(J);return}return ne&&ce.emitMany(ne),this.d=fe=>ce.reject(fe),this.f=fe=>ce.emitOne(fe),this.a.p});let J,ne;this.f=ce=>{ne||(ne=[]),ne.push(ce)},this.d=ce=>{J||(J=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$Fh=_}),define(le[91],he([0,1,17,6,49,35,16,5,27]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;function g(){return Object.create(null)}e.$Qj=g,e.$Rj="**",e.$Sj="/";const C="[/\\\\]",S="[^/\\\\]",m=/\//g;function h(Z,H){switch(Z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${H?`|${C}${S}+`:""})*?`}}function $(Z,H){if(!Z)return[];const V=[];let te=!1,oe=!1,ee="";for(const ae of Z){switch(ae){case H:if(!te&&!oe){V.push(ee),ee="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}ee+=ae}return ee&&V.push(ee),V}e.$Tj=$;function p(Z){if(!Z)return"";let H="";const V=$(Z,e.$Sj);if(V.every(te=>te===e.$Rj))H=".*";else{let te=!1;V.forEach((oe,ee)=>{if(oe===e.$Rj){if(te)return;H+=h(2,ee===V.length-1)}else{let ae=!1,W="",z=!1,D="";for(const T of oe){if(T!=="}"&&ae){W+=T;continue}if(z&&(T!=="]"||!D)){let B;T==="-"?B=T:(T==="^"||T==="!")&&!D?B="^":T===e.$Sj?B="":B=(0,k.$Ve)(T),D+=B;continue}switch(T){case"{":ae=!0;continue;case"[":z=!0;continue;case"}":{const q=`(?:${$(W,",").map(X=>p(X)).join("|")})`;H+=q,ae=!1,W="";break}case"]":{H+="["+D+"]",z=!1,D="";break}case"?":H+=S;continue;case"*":H+=h(1);continue;default:H+=(0,k.$Ve)(T)}}ee<V.length-1&&(V[ee+1]!==e.$Rj||ee+2<V.length)&&(H+=C)}te=oe===e.$Rj})}return H}const E=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,y=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(Z,H){if(!Z)return n;let V;typeof Z!="string"?V=Z.pattern:V=Z,V=V.trim();const te=`${V}_${!!H.trimForExclusions}`;let oe=i.get(te);if(oe)return t(oe,Z);let ee;return E.test(V)?oe=a(V.substr(4),V):(ee=l.exec(r(V,H)))?oe=v(ee[1],V):(H.trimForExclusions?d:u).test(V)?oe=w(V,H):(ee=c.exec(r(V,H)))?oe=f(ee[1].substr(1),V,!0):(ee=y.exec(r(V,H)))?oe=f(ee[1],V,!1):oe=b(V),i.set(te,oe),t(oe,Z)}function t(Z,H){if(typeof H=="string")return Z;const V=function(te,oe){return(0,j.$dg)(te,H.base,!R.$k)?Z((0,k.$1e)(te.substr(H.base.length),I.sep),oe):null};return V.allBasenames=Z.allBasenames,V.allPaths=Z.allPaths,V.basenames=Z.basenames,V.patterns=Z.patterns,V}function r(Z,H){return H.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function a(Z,H){return function(V,te){return typeof V=="string"&&V.endsWith(Z)?H:null}}function v(Z,H){const V=`/${Z}`,te=`\\${Z}`,oe=function(ae,W){return typeof ae!="string"?null:W?W===Z?H:null:ae===Z||ae.endsWith(V)||ae.endsWith(te)?H:null},ee=[Z];return oe.basenames=ee,oe.patterns=[H],oe.allBasenames=ee,oe}function w(Z,H){const V=x(Z.slice(1,-1).split(",").map(W=>s(W,H)).filter(W=>W!==n),Z),te=V.length;if(!te)return n;if(te===1)return V[0];const oe=function(W,z){for(let D=0,T=V.length;D<T;D++)if(V[D](W,z))return Z;return null},ee=V.find(W=>!!W.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=V.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return ae.length&&(oe.allPaths=ae),oe}function f(Z,H,V){const te=I.sep===I.$gc.sep,oe=te?Z:Z.replace(m,I.sep),ee=I.sep+oe,ae=I.$gc.sep+Z;let W;return V?W=function(z,D){return typeof z=="string"&&(z===oe||z.endsWith(ee)||!te&&(z===Z||z.endsWith(ae)))?H:null}:W=function(z,D){return typeof z=="string"&&(z===oe||!te&&z===Z)?H:null},W.allPaths=[(V?"*/":"./")+Z],W}function b(Z){try{const H=new RegExp(`^${p(Z)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?Z:null}}catch{return n}}function P(Z,H,V){return!Z||typeof H!="string"?!1:N(Z)(H,void 0,V)}e.$Uj=P;function N(Z,H={}){if(!Z)return o;if(typeof Z=="string"||F(Z)){const V=s(Z,H);if(V===n)return o;const te=function(oe,ee){return!!V(oe,ee)};return V.allBasenames&&(te.allBasenames=V.allBasenames),V.allPaths&&(te.allPaths=V.allPaths),te}return Y(Z,H)}e.$Vj=N;function F(Z){const H=Z;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Wj=F;function M(Z){return Z.allBasenames||[]}e.$Xj=M;function U(Z){return Z.allPaths||[]}e.$Yj=U;function Y(Z,H){const V=x(Object.getOwnPropertyNames(Z).map(W=>Q(W,Z[W],H)).filter(W=>W!==n)),te=V.length;if(!te)return n;if(!V.some(W=>!!W.requiresSiblings)){if(te===1)return V[0];const W=function(T,B){let q;for(let X=0,_=V.length;X<_;X++){const ie=V[X](T,B);if(typeof ie=="string")return ie;(0,A.$1g)(ie)&&(q||(q=[]),q.push(ie))}return q?(async()=>{for(const X of q){const _=await X;if(typeof _=="string")return _}return null})():null},z=V.find(T=>!!T.allBasenames);z&&(W.allBasenames=z.allBasenames);const D=V.reduce((T,B)=>B.allPaths?T.concat(B.allPaths):T,[]);return D.length&&(W.allPaths=D),W}const oe=function(W,z,D){let T,B;for(let q=0,X=V.length;q<X;q++){const _=V[q];_.requiresSiblings&&D&&(z||(z=(0,I.$nc)(W)),T||(T=z.substr(0,z.length-(0,I.$oc)(W).length)));const ie=_(W,z,T,D);if(typeof ie=="string")return ie;(0,A.$1g)(ie)&&(B||(B=[]),B.push(ie))}return B?(async()=>{for(const q of B){const X=await q;if(typeof X=="string")return X}return null})():null},ee=V.find(W=>!!W.allBasenames);ee&&(oe.allBasenames=ee.allBasenames);const ae=V.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return ae.length&&(oe.allPaths=ae),oe}function Q(Z,H,V){if(H===!1)return n;const te=s(Z,V);if(te===n)return n;if(typeof H=="boolean")return te;if(H){const oe=H.when;if(typeof oe=="string"){const ee=(ae,W,z,D)=>{if(!D||!te(ae,W))return null;const T=oe.replace("$(basename)",()=>z),B=D(T);return(0,A.$1g)(B)?B.then(q=>q?Z:null):B?Z:null};return ee.requiresSiblings=!0,ee}}return te}function x(Z,H){const V=Z.filter(W=>!!W.basenames);if(V.length<2)return Z;const te=V.reduce((W,z)=>{const D=z.basenames;return D?W.concat(D):W},[]);let oe;if(H){oe=[];for(let W=0,z=te.length;W<z;W++)oe.push(H)}else oe=V.reduce((W,z)=>{const D=z.patterns;return D?W.concat(D):W},[]);const ee=function(W,z){if(typeof W!="string")return null;if(!z){let T;for(T=W.length;T>0;T--){const B=W.charCodeAt(T-1);if(B===47||B===92)break}z=W.substr(T)}const D=te.indexOf(z);return D!==-1?oe[D]:null};ee.basenames=te,ee.patterns=oe,ee.allBasenames=te;const ae=Z.filter(W=>!W.basenames);return ae.push(ee),ae}function G(Z,H){return(0,O.$ub)(Z,H,(V,te)=>typeof V=="string"&&typeof te=="string"?V===te:typeof V!="string"&&typeof te!="string"?V.base===te.base&&V.pattern===te.pattern:!1)}e.$Zj=G}),define(le[92],he([0,1,14,9]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=void 0;function j(S){return S.toJSON()}class L{constructor(m){this.a=m}transformIncoming(m){const h=this.a.transformIncoming(m);return h===m?m:j(A.URI.from(h))}transformOutgoing(m){const h=this.a.transformOutgoing(m);return h===m?m:j(A.URI.from(h))}transformOutgoingURI(m){const h=this.a.transformOutgoing(m);return h===m?m:A.URI.from(h)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$bn=L,e.$cn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function I(S,m,h){if(!S||h>200)return null;if(typeof S=="object"){if(S instanceof A.URI)return m.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const p=I(S[$],m,h+1);p!==null&&(S[$]=p)}}return null}function R(S,m){const h=I(S,m,0);return h===null?S:h}e.$dn=R;function k(S,m,h,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return h?A.URI.revive(m.transformIncoming(S)):m.transformIncoming(S);if(S instanceof O.$qe)return null;for(const p in S)if(Object.hasOwnProperty.call(S,p)){const E=k(S[p],m,h,$+1);E!==null&&(S[p]=E)}}return null}function g(S,m){const h=k(S,m,!1,0);return h===null?S:h}e.$en=g;function C(S,m){const h=k(S,m,!0,0);return h===null?S:h}e.$fn=C}),define(le[143],he([0,1,36,48,32,131,5]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=void 0,e.$hn=new class{c(m){return this.a||(this.a=A.$ii.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,h=0;const $=(0,O.networkInterfaces)();for(const p in $){const E=$[p];if(E)for(const{mac:l,internal:u}of E)u||(h+=1,this.c(l.toUpperCase())&&(m+=1))}this.b=h>0?m/h:0}return this.b}};let R;async function k(m){return R||(R=(async()=>await g(m)||j.$yg())()),R}e.$in=k;async function g(m){try{const h=await new Promise((p,E)=>{se(["crypto"],p,E)}),$=(0,L.$gn)();return h.createHash("sha256").update($,"utf8").digest("hex")}catch(h){m(h);return}}const C="Software\\Microsoft\\SQMClient";async function S(m){if(I.$i){const h=await new Promise(($,p)=>{se(["@vscode/windows-registry"],$,p)});try{return h.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return m($),""}}return""}e.$jn=S}),define(le[31],he([0,1,54,36,268,6,49,88,16,5,20,9]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(Q,x=m.UNLINK,G){if((0,I.$gg)(Q))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?p(Q):$(Q,G)}async function $(Q,x=(0,I.$lg)((0,A.tmpdir)())){try{try{await O.promises.rename(Q,x)}catch(G){return G.code==="ENOENT"?void 0:p(Q)}p(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(Q){return(0,j.promisify)(O.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function E(Q){if((0,I.$gg)(Q))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=E;async function l(Q,x){return c(await(x?u(Q):(0,j.promisify)(O.readdir)(Q)))}async function u(Q){try{return await(0,j.promisify)(O.readdir)(Q,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const x=[],G=await l(Q);for(const Z of G){let H=!1,V=!1,te=!1;try{const oe=await e.Promises.lstat((0,k.$jc)(Q,Z));H=oe.isFile(),V=oe.isDirectory(),te=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}x.push({name:Z,isFile:()=>H,isDirectory:()=>V,isSymbolicLink:()=>te})}return x}function d(Q){return c(O.readdirSync(Q))}e.readdirSync=d;function c(Q){return Q.map(x=>typeof x=="string"?g.$j?(0,R.$Pl)(x):x:(x.name=g.$j?(0,R.$Pl)(x.name):x.name,x))}async function y(Q){const x=await l(Q),G=[];for(const Z of x)await o.existsDirectory((0,k.$jc)(Q,Z))&&G.push(Z);return G}function i(Q,x=1e3){return new Promise(G=>{let Z=!1;const H=setInterval(()=>{Z||(Z=!0,O.access(Q,V=>{Z=!1,V&&(clearInterval(H),G(void 0))}))},x)})}e.whenDeleted=i;var o;(function(Q){async function x(H){let V;try{if(V=await e.Promises.lstat(H),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw oe}throw te}}Q.stat=x;async function G(H){try{const{stat:V,symbolicLink:te}=await Q.stat(H);return V.isFile()&&te?.dangling!==!0}catch{}return!1}Q.existsFile=G;async function Z(H){try{const{stat:V,symbolicLink:te}=await Q.stat(H);return V.isDirectory()&&te?.dangling!==!0}catch{}return!1}Q.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const n=new L.$lh;function s(Q,x,G){return n.queueFor(S.URI.file(Q),()=>{const Z=w(G);return new Promise((H,V)=>a(Q,x,Z,te=>te?V(te):H()))},C.$Gg)}let t=!0;function r(Q){t=Q}e.configureFlushOnWrite=r;function a(Q,x,G,Z){if(!t)return O.writeFile(Q,x,{mode:G.mode,flag:G.flag},Z);O.open(Q,G.flag,G.mode,(H,V)=>{if(H)return Z(H);O.writeFile(V,x,te=>{if(te)return O.close(V,()=>Z(te));O.fdatasync(V,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),r(!1)),O.close(V,ee=>Z(ee))))})})}function v(Q,x,G){const Z=w(G);if(!t)return O.writeFileSync(Q,x,{mode:Z.mode,flag:Z.flag});const H=O.openSync(Q,Z.flag,Z.mode);try{O.writeFileSync(H,x);try{O.fdatasyncSync(H)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(H)}}e.writeFileSync=v;function w(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function f(Q,x,G=6e4){if(Q!==x)try{g.$i&&typeof G=="number"?await b(Q,x,Date.now(),G):await(0,j.promisify)(O.rename)(Q,x)}catch(Z){if(Q.toLowerCase()!==x.toLowerCase()&&Z.code==="EXDEV"||Q.endsWith("."))await P(Q,x,{preserveSymlinks:!1}),await h(Q,m.MOVE);else throw Z}}async function b(Q,x,G,Z,H=0){try{return await(0,j.promisify)(O.rename)(Q,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-G>=Z)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${V}`),V;if(H===0){let te=!1;try{const{stat:oe}=await o.stat(x);oe.isFile()||(te=!0)}catch{}if(te)throw V}return await(0,L.$dh)(Math.min(100,H*10)),b(Q,x,G,Z,H+1)}}async function P(Q,x,G){return F(Q,x,{root:{source:Q,target:x},options:G,handledSourcePaths:new Set})}const N=511;async function F(Q,x,G){if(G.handledSourcePaths.has(Q))return;G.handledSourcePaths.add(Q);const{stat:Z,symbolicLink:H}=await o.stat(Q);if(H){if(G.options.preserveSymlinks)try{return await Y(Q,x,G)}catch{}if(H.dangling)return}return Z.isDirectory()?M(Q,x,Z.mode&N,G):U(Q,x,Z.mode&N)}async function M(Q,x,G,Z){await e.Promises.mkdir(x,{recursive:!0,mode:G});const H=await l(Q);for(const V of H)await F((0,k.$jc)(Q,V),(0,k.$jc)(x,V),Z)}async function U(Q,x,G){await e.Promises.copyFile(Q,x),await e.Promises.chmod(x,G)}async function Y(Q,x,G){let Z=await e.Promises.readlink(Q);(0,I.$dg)(Z,G.root.source,!g.$k)&&(Z=(0,k.$jc)(G.root.target,Z.substr(G.root.source.length+1))),await e.Promises.symlink(Z,x)}e.Promises=new class{get access(){return(0,j.promisify)(O.access)}get stat(){return(0,j.promisify)(O.stat)}get lstat(){return(0,j.promisify)(O.lstat)}get utimes(){return(0,j.promisify)(O.utimes)}get read(){return(Q,x,G,Z,H)=>new Promise((V,te)=>{O.read(Q,x,G,Z,H,(oe,ee,ae)=>oe?te(oe):V({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,j.promisify)(O.readFile)}get write(){return(Q,x,G,Z,H)=>new Promise((V,te)=>{O.write(Q,x,G,Z,H,(oe,ee,ae)=>oe?te(oe):V({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,j.promisify)(O.appendFile)}get fdatasync(){return(0,j.promisify)(O.fdatasync)}get truncate(){return(0,j.promisify)(O.truncate)}get copyFile(){return(0,j.promisify)(O.copyFile)}get open(){return(0,j.promisify)(O.open)}get close(){return(0,j.promisify)(O.close)}get symlink(){return(0,j.promisify)(O.symlink)}get readlink(){return(0,j.promisify)(O.readlink)}get chmod(){return(0,j.promisify)(O.chmod)}get mkdir(){return(0,j.promisify)(O.mkdir)}get unlink(){return(0,j.promisify)(O.unlink)}get rmdir(){return(0,j.promisify)(O.rmdir)}get realpath(){return(0,j.promisify)(O.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return y}get writeFile(){return s}get rm(){return h}get rename(){return f}get copy(){return P}}}),define(le[144],he([0,1,54,16,5,27,31]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=void 0;function R(m){if(j.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const E=(0,I.readdirSync)(h).filter(l=>l.toLowerCase()===$);if(E.length===1){const l=R(h);if(l)return(0,A.$jc)(l,E[0])}else if(E.length>1){const l=E.indexOf($);if(l>=0){const u=R(h);if(u)return(0,A.$jc)(u,E[l])}}}catch{}return null}e.$Cq=R;async function k(m){if(j.$k)return m;const h=(0,A.$mc)(m);if(m===h)return m;const $=((0,A.$nc)(m)||m).toLowerCase();try{const E=(await I.Promises.readdir(h)).filter(l=>l.toLowerCase()===$);if(E.length===1){const l=await k(h);if(l)return(0,A.$jc)(l,E[0])}else if(E.length>1){const l=E.indexOf($);if(l>=0){const u=await k(h);if(u)return(0,A.$jc)(u,E[l])}}}catch{}return null}e.$Dq=k;async function g(m){try{return await I.Promises.realpath(m)}catch{const $=S(m);return await I.Promises.access($,O.constants.R_OK),$}}e.$Eq=g;function C(m){try{return O.realpathSync(m)}catch{const $=S(m);return O.accessSync($,O.constants.R_OK),$}}e.$Fq=C;function S(m){return(0,L.$2e)((0,A.$hc)(m),A.sep)}}),define(le[145],he([0,1,16,5,37,90,12,31]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function k(S=j.env){return S.comspec||"cmd.exe"}e.$3l=k;function g(S){let m=[],h=!1;const $=function(p){if(h){m.push(p);return}(!S.send(p,l=>{if(l&&console.error(l),h=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(d=>$(d))}})||A.$i)&&(h=!0)};return{send:$}}e.$4l=g;var C;(function(S){async function m(h,$,p){if(O.$ic(h))return h;if($===void 0&&($=j.cwd()),O.$mc(h)!=="."||(p===void 0&&I.$Qf(j.env.PATH)&&(p=j.env.PATH.split(O.$tc)),p===void 0||p.length===0))return O.$jc($,h);async function l(u){if(await R.Promises.exists(u)){let d;try{d=await R.Promises.stat(u)}catch(c){c.message.startsWith("EACCES")&&(d=await R.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(const u of p){let d;if(O.$ic(u)?d=O.$jc(u,h):d=O.$jc($,u,h),await l(d))return d;let c=d+".com";if(await l(c)||(c=d+".exe",await l(c)))return c}return O.$jc($,h)}S.findExecutable=m})(C||(e.win32=C={}))}),define(le[146],he([0,1,67,23]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;function j(I){return new Promise((R,k)=>{let g;const C=new Map;function S(h,$,p,E,l){const u=C.get($);if(h===I||u){const d={name:m(p),cmd:p,pid:h,ppid:$,load:E,mem:l};C.set(h,d),h===I&&(g=d),u&&(u.children||(u.children=[]),u.children.push(d),u.children.length>1&&(u.children=u.children.sort((c,y)=>c.pid-y.pid)))}}function m(h){const $=/--utility-sub-type=network/i,p=/--crashes-directory/i,E=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(p.exec(h))return"electron-crash-reporter";if(E.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let d=u.exec(h);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const c=/[a-zA-Z-]+\.js/g;let y="";do d=c.exec(h),d&&(y+=d+" ");while(d);return y&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${y})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,p)=>{se(["@vscode/windows-process-tree"],$,p)}).then($=>{$.getProcessList(I,p=>{if(!p){k(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(p,E=>{const l=new Map;E.forEach(u=>{const d=h(u.commandLine||"");l.set(u.pid,{name:m(d),cmd:d,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),g=l.get(I),g?(l.forEach(u=>{const d=l.get(u.ppid);d&&(d.children||(d.children=[]),d.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((d,c)=>d.pid-c.pid))}),R(g)):k(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[g];const p=[];for(;$.length;){const l=$.shift();l&&(p.push(l.pid),l.children&&($=$.concat(l.children)))}let E=JSON.stringify(A.$wg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);E+=" "+p.join(" "),(0,O.exec)(E,{},(l,u,d)=>{if(l||d)k(l||new Error(d.toString()));else{const c=u.toString().split(`
`);for(let y=0;y<p.length;y++){const i=C.get(p[y]);i.load=parseFloat(c[y])}if(!g){k(new Error(`Root process ${I} not found`));return}R(g)}})};(0,O.exec)("which ps",{},($,p,E)=>{if($||E)if(process.platform!=="linux")k($||new Error(E.toString()));else{const l=JSON.stringify(A.$wg.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(l,{},(u,d,c)=>{u||c?k(u||new Error(c.toString())):(L(d,S),h())})}else{const l=p.toString().trim();(0,O.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,y)=>{d||y&&!y.includes("screen size is bogus")?k(d||new Error(y.toString())):(L(c,S),process.platform==="linux"?h():g?R(g):k(new Error(`Root process ${I} not found`)))})}})}})}e.$bs=j;function L(I,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(se,e,O,A){var j=arguments.length,L=j<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,O):A,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(se,e,O,A);else for(var R=se.length-1;R>=0;R--)(I=se[R])&&(L=(j<3?I(L):j>3?I(e,O,L):I(e,O))||L);return j>3&&L&&Object.defineProperty(e,O,L),L};define(le[40],he([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,O,A,j,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.ProxyChannel=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.RequestInitiator=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function $(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function E(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function u(H){let V=0;for(let te=0;;te+=7){const oe=H.read(1);if(V|=(oe.buffer[0]&127)<<te,!(oe.buffer[0]&128))return V}}const d=n(0);function c(H,V){if(V===0){H.write(d);return}let te=0;for(let ee=V;ee!==0;ee=ee>>>7)te++;const oe=j.$qe.alloc(te);for(let ee=0;V!==0;ee++)oe.buffer[ee]=V&127,V=V>>>7,V>0&&(oe.buffer[ee]|=128);H.write(oe)}class y{constructor(V){this.b=V,this.a=0}read(V){const te=this.b.slice(this.a,this.a+V);return this.a+=te.byteLength,te}}e.$Mh=y;class i{constructor(){this.a=[]}get buffer(){return j.$qe.concat(this.a)}write(V){this.a.push(V)}}e.$Nh=i;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const V=j.$qe.alloc(1);return V.writeUInt8(H,0),V}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(H,V){if(typeof V>"u")H.write(s.Undefined);else if(typeof V=="string"){const te=j.$qe.fromString(V);H.write(s.String),c(H,te.byteLength),H.write(te)}else if(t&&Buffer.isBuffer(V)){const te=j.$qe.wrap(V);H.write(s.Buffer),c(H,te.byteLength),H.write(te)}else if(V instanceof j.$qe)H.write(s.VSBuffer),c(H,V.byteLength),H.write(V);else if(Array.isArray(V)){H.write(s.Array),c(H,V.length);for(const te of V)r(H,te)}else if(typeof V=="number"&&(V|0)===V)H.write(s.Uint),c(H,V);else{const te=j.$qe.fromString(JSON.stringify(V));H.write(s.Object),c(H,te.byteLength),H.write(te)}}e.$Oh=r;function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(u(H)).toString();case o.Buffer:return H.read(u(H)).buffer;case o.VSBuffer:return H.read(u(H));case o.Array:{const te=u(H),oe=[];for(let ee=0;ee<te;ee++)oe.push(a(H));return oe}case o.Object:return JSON.parse(H.read(u(H)).toString());case o.Int:return u(H)}}e.$Ph=a;class v{constructor(V,te,oe=null,ee=1e3){this.h=V,this.j=te,this.k=oe,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(V,te){this.b.set(V,te),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const te=this.o([V.type]);this.k?.logOutgoing(te,0,1,E(V.type));return}case 201:case 202:case 204:case 203:{const te=this.o([V.type,V.id],V.data);this.k?.logOutgoing(te,V.id,1,E(V.type),V.data);return}}}o(V,te=void 0){const oe=new i;return r(oe,V),r(oe,te),this.p(oe.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const te=new y(V),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 100:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.s({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 102:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}: ${oe[2]}.${oe[3]}`,ee),this.t({type:ae,id:oe[1],channelName:oe[2],name:oe[3],arg:ee});case 101:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]});case 103:return this.k?.logIncoming(V.byteLength,oe[1],1,`${$(ae)}`),this.u({type:ae,id:oe[1]})}}s(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const oe=new L.$ae;let ee;try{ee=te.call(this.j,V.name,V.arg,oe.token)}catch(z){ee=Promise.reject(z)}const ae=V.id;ee.then(z=>{this.m({id:ae,data:z,type:201})},z=>{z instanceof Error?this.m({id:ae,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ae,data:z,type:203})}).finally(()=>{W.dispose(),this.d.delete(V.id)});const W=(0,g.$Rc)(()=>oe.cancel());this.d.set(V.id,W)}t(V){const te=this.b.get(V.channelName);if(!te){this.v(V);return}const oe=V.id,ae=te.listen(this.j,V.name,V.arg)(W=>this.m({id:oe,data:W,type:204}));this.d.set(V.id,ae)}u(V){const te=this.d.get(V.id);te&&(te.dispose(),this.d.delete(V.id))}v(V){let te=this.g.get(V.channelName);te||(te=[],this.g.set(V.channelName,te));const oe=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:V,timeoutTimer:oe})}w(V){const te=this.g.get(V);if(te){for(const oe of te)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Qh=v;var w;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(V,te=null){this.l=V,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$3d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=te}getChannel(V){const te=this;return{call(oe,ee,ae){return te.a?Promise.reject(new R.$5):te.m(V,oe,ee,ae)},listen(oe,ee){return te.a?k.Event.None:te.o(V,oe,ee)}}}m(V,te,oe,ee=L.CancellationToken.None){const ae=this.g++,z={id:ae,type:100,channelName:V,name:te,arg:oe};if(ee.isCancellationRequested)return Promise.reject(new R.$5);let D;return new Promise((B,q)=>{if(ee.isCancellationRequested)return q(new R.$5);const X=()=>{const ne=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const fe=new Error(ce.data.message);fe.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,fe.name=ce.data.name,q(fe);break}case 203:this.f.delete(ae),q(ce.data);break}};this.f.set(ae,ne),this.p(z)};let _=null;this.b===l.Idle?X():(_=(0,A.$2g)(ne=>this.u()),_.then(()=>{_=null,X()}));const ie=()=>{_?(_.cancel(),_=null):this.p({id:ae,type:101}),q(new R.$5)},J=ee.onCancellationRequested(ie);D=(0,g.$Qc)((0,g.$Rc)(ie),J),this.d.add(D)}).finally(()=>{D.dispose(),this.d.delete(D)})}o(V,te,oe){const ee=this.g++,W={id:ee,type:102,channelName:V,name:te,arg:oe};let z=null;const D=new k.$3d({onWillAddFirstListener:()=>{z=(0,A.$2g)(B=>this.u()),z.then(()=>{z=null,this.d.add(D),this.p(W)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(D),this.p({id:ee,type:103}))}}),T=B=>D.fire(B.data);return this.f.set(ee,T),D.event}p(V){switch(V.type){case 100:case 102:{const te=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(te,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const te=this.q([V.type,V.id]);this.j?.logOutgoing(te,V.id,0,$(V.type));return}}}q(V,te=void 0){const oe=new i;return r(oe,V),r(oe,te),this.r(oe.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const te=new y(V),oe=a(te),ee=a(te),ae=oe[0];switch(ae){case 200:return this.j?.logIncoming(V.byteLength,0,0,E(ae)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,oe[1],0,E(ae),ee),this.t({type:oe[0],id:oe[1],data:ee})}}t(V){if(V.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Rh=f,ye([I.$Gh],f.prototype,"onDidInitializePromise",null);class b{get connections(){const V=[];return this.f.forEach(te=>V.push(te)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$3d,this.onDidAddConnection=this.g.event,this.h=new k.$3d,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(V(({protocol:te,onDidClientDisconnect:oe})=>{const ee=k.Event.once(te.onMessage);this.j.add(ee(ae=>{const W=new y(ae),z=a(W),D=new v(te,z),T=new f(te);this.a.forEach((q,X)=>D.registerChannel(X,q));const B={channelServer:D,channelClient:T,ctx:z};this.f.add(B),this.g.fire(B),this.j.add(oe(()=>{D.dispose(),T.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,te){const oe=this;return{call(ee,ae,W){let z;if((0,m.$5f)(te)){const T=(0,O.$4b)(oe.connections.filter(te));z=T?Promise.resolve(T):k.Event.toPromise(k.Event.filter(oe.onDidAddConnection,te))}else z=te.routeCall(oe,ee,ae);const D=z.then(T=>T.channelClient.getChannel(V));return N(D).call(ee,ae,W)},listen(ee,ae){if((0,m.$5f)(te))return oe.k(V,te,ee,ae);const W=te.routeEvent(oe,ee,ae).then(z=>z.channelClient.getChannel(V));return N(W).listen(ee,ae)}}}k(V,te,oe,ee){const ae=this;let W;const z=new k.$3d({onWillAddFirstListener:()=>{W=new g.$Sc;const D=new k.$9d,T=new Map,B=X=>{const ie=X.channelClient.getChannel(V).listen(oe,ee),J=D.add(ie);T.set(X,J)},q=X=>{const _=T.get(X);_&&(_.dispose(),T.delete(X))};ae.connections.filter(te).forEach(B),k.Event.filter(ae.onDidAddConnection,te)(B,void 0,W),ae.onDidRemoveConnection(q,void 0,W),D.event(z.fire,z,W),W.add(D)},onDidRemoveLastListener:()=>{W?.dispose(),W=void 0}});return z.event}registerChannel(V,te){this.a.set(V,te);for(const oe of this.f)oe.channelServer.registerChannel(V,te)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Sh=b;class P{constructor(V,te,oe=null){const ee=new i;r(ee,te),V.send(ee.buffer),this.a=new f(V,oe),this.d=new v(V,te,oe)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,te){this.d.registerChannel(V,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Th=P;function N(H){return{call(V,te,oe){return H.then(ee=>ee.call(V,te,oe))},listen(V,te){const oe=new k.$_d;return H.then(ee=>oe.input=ee.listen(V,te)),oe.event}}}e.$Uh=N;function F(H){let V=!1;return{call(te,oe,ee){return V?H.call(te,oe,ee):(0,A.$dh)(0).then(()=>V=!0).then(()=>H.call(te,oe,ee))},listen(te,oe){if(V)return H.listen(te,oe);const ee=new k.$_d;return(0,A.$dh)(0).then(()=>V=!0).then(()=>ee.input=H.listen(te,oe)),ee.event}}}e.$Vh=F;class M{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const te of V.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Wh=M;var U;(function(H){function V(ae,W,z){const D=ae,T=z&&z.disableMarshalling,B=new Map;for(const q in D)oe(q)&&B.set(q,k.Event.buffer(D[q],!0,void 0,W));return new class{listen(q,X,_){const ie=B.get(X);if(ie)return ie;if(ee(X)){const J=D[X];if(typeof J=="function")return J.call(D,_)}throw new R.$bb(`Event not found: ${X}`)}call(q,X,_){const ie=D[X];if(typeof ie=="function"){if(!T&&Array.isArray(_))for(let ne=0;ne<_.length;ne++)_[ne]=(0,C.$Lh)(_[ne]);let J=ie.apply(D,_);return J instanceof Promise||(J=Promise.resolve(J)),J}throw new R.$bb(`Method not found: ${X}`)}}}H.fromService=V;function te(ae,W){const z=W&&W.disableMarshalling;return new Proxy({},{get(D,T){if(typeof T=="string")return W?.properties?.has(T)?W.properties.get(T):ee(T)?function(B){return ae.listen(T,B)}:oe(T)?ae.listen(T):async function(...B){let q;W&&!(0,m.$Zf)(W.context)?q=[W.context,...B]:q=B;const X=await ae.call(T,q);return z?X:(0,C.$Lh)(X)};throw new R.$bb(`Property not found: ${String(T)}`)}})}H.toService=te;function oe(ae){return ae[0]==="o"&&ae[1]==="n"&&S.$gf(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&S.$gf(ae.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const V=H.toString();if(V!=="[object Object]")return V}return H}function x(H){return Array.isArray(H)?H.map(Q):Q(H)}function G(H,V,te,oe,ee,ae,W){W=x(W);const z=Y[ee],D=z[oe%z.length];let T=[`%c[${H}]%c[${String(V).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${D}`];/\($/.test(ae)?(T=T.concat(W),T.push(")")):T.push(W),console.log.apply(console,T)}class Z{constructor(V,te){this.d=V,this.f=te,this.a=0,this.b=0}logOutgoing(V,te,oe,ee,ae){this.b+=V,G(this.d,this.b,V,te,oe,ee,ae)}logIncoming(V,te,oe,ee,ae){this.a+=V,G(this.f,this.a,V,te,oe,ee,ae)}}e.$Xh=Z}),define(le[68],he([0,1,14,3,2,40]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.ProtocolConstants=e.$Yh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(w,f){if(!t.has(w)){const b=String(++r);t.set(w,b)}return t.get(w)}function v(w,f,b,P){if(!s.enableDiagnostics)return;const N=a(w,f);if(P instanceof O.$qe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const F=O.$qe.alloc(P.byteLength);F.set(P),s.records.push({timestamp:Date.now(),id:N,label:f,type:b,buff:F})}else s.records.push({timestamp:Date.now(),id:N,label:f,type:b,data:P})}s.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=O.$qe.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const f=this.a[0];return r&&(this.a.shift(),this.b-=t),f}if(this.a[0].byteLength>t){const f=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),f}const a=O.$qe.alloc(t);let v=0,w=0;for(;t>0;){const f=this.a[w];if(f.byteLength>t){const b=f.slice(0,t);a.set(b,v),v+=t,r&&(this.a[w]=f.slice(t),this.b-=t),t-=t}else a.set(f,v),v+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):w++,t-=f.byteLength}return a}}e.$Yh=S;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class p{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends j.$Tc{constructor(t){super(),this.f=this.B(new A.$3d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$qe.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$qe.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class u extends j.$Tc{constructor(t){super(),this.f=new A.$3d,this.onMessage=this.f.event,this.g=new A.$3d,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new E(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new p(1,0,0,t))}}e.$Zh=u;class d extends L.$Th{static fromSocket(t,r){return new d(new u(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$1h=d;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new A.$3d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$2h=c;class y{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new y(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new j.$Sc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new E(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new p(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new p(7,0,0,C());this.p.write(t)}sendResume(){const t=new p(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new j.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new E(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new p(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new p(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new p(9,0,this.h,C());this.p.write(t)}}e.$3h=n}),define(le[93],he([0,1,67,6,14,26,141,7,3,2,30,145,90,40]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class $ extends h.$Qh{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",u=>j.$qe.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$zq=$;class p{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new k.$3d,this.onDidProcessExit=this.h.event;const d=u&&u.timeout?u.timeout:6e4;this.b=new A.$_g(d),this.d=null,this.f=null}getChannel(l){const u=this;return{call(d,c,y){return u.k(l,d,c,y)},listen(d,c){return u.l(l,d,c)}}}k(l,u,d,c=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const y=this.n(l),i=(0,A.$2g)(s=>y.call(u,d,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,u,d){if(!this.b)return k.Event.None;this.b.cancel();let c;const y=new k.$3d({onWillAddFirstListener:()=>{c=this.n(l).listen(u,d)(y.fire,y),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$Fn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,m.$2l)(u.env),this.d=(0,O.fork)(this.i,l,u);const d=new k.$3d;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$vq)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}d.fire(j.$qe.wrap(Buffer.from(t,"base64")))});const y=this.j.useQueue?(0,S.$4l)(this.d):this.d,i=t=>this.d&&this.d.connected&&y.send(t.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this.f=new h.$Rh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Aq=p}),define(le[147],he([0,1,134,14,40,3,12,17]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LV=e.$KV=void 0;class k{constructor(m){this.a=m,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",h=>h.data?A.$qe.wrap(h.data):A.$qe.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class g extends j.$Sh{static b(m){(0,I.$1f)((0,O.$JV)(process),"Electron Utility Process");const h=new L.$3d;return process.parentPort.on("message",$=>{if(m?.handledClientConnection($))return;const p=(0,R.$Ob)($.ports);p&&h.fire(p)}),L.Event.map(h.event,$=>({protocol:new k($),onDidClientDisconnect:L.Event.fromNodeEventEmitter($,"close")}))}constructor(m){super(g.b(m))}}e.$KV=g;function C(S,m,h){const $=p=>{p.data===m&&(S.removeListener("message",$),h())};S.on("message",$)}e.$LV=C}),define(le[69],he([0,1,6,3,2,66,12]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.StorageState=e.$yp=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$yp=k;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends j.$Tc{static{this.a=100}constructor(h,$=Object.create(null)){super(),this.r=h,this.s=$,this.b=this.B(new A.$6d),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new O.$ah(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach(($,p)=>this.w(p,$)),h.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(h,$){if(this.c===g.Closed)return;let p=!1;(0,I.$Zf)($)?p=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),p=!0),p&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,$){const p=this.f.get(h);return(0,I.$Zf)(p)?$:p}getBoolean(h,$){const p=this.get(h);return(0,I.$Zf)(p)?$:p==="true"}getNumber(h,$){const p=this.get(h);return(0,I.$Zf)(p)?$:parseInt(p,10)}getObject(h,$){const p=this.get(h);return(0,I.$Zf)(p)?$:(0,L.$Kh)(p)}async set(h,$,p=!1){if(this.c===g.Closed)return;if((0,I.$Zf)($))return this.delete(h,p);const E=(0,I.$Sf)($)||Array.isArray($)?(0,L.$Jh)($):String($);if(this.f.get(h)!==E)return this.f.set(h,E),this.j.set(h,E),this.h.delete(h),this.b.fire({key:h,external:p}),this.D()}async delete(h,$=!1){if(!(this.c===g.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$zp=C;class S{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,p)=>this.a.set(p,$)),h.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$Ap=S}),define(le[148],he([13,10]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,54,6,16,12,31,148]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.zip=e.$Vp=e.$Up=void 0,e.$Up="end of central directory record signature not found";const k=new RegExp(e.$Up);class g extends Error{constructor(y,i){let o=i.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=i}}e.$Vp=g;function C(c){const y=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>y&i).reduce((i,o)=>i+o,y&61440)}function S(c){if(c instanceof g)return c;let y;return k.test(c.message)&&(y="CorruptZip"),new g(y,c)}function m(c,y,i,o,n,s){const t=j.$mc(y),r=j.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,y)));const a=j.$jc(o,y);let v;return s.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(I.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((w,f)=>{if(!s.isCancellationRequested)try{v=(0,O.createWriteStream)(a,{mode:i}),v.once("close",()=>w()),v.once("error",f),c.once("error",f),c.pipe(v)}catch(b){f(b)}}))}function h(c,y,i,o){let n=(0,A.$2g)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const v=new A.$0g,w=f=>{f.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(R.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",f=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(f.fileName)){w(o);return}const b=f.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(b)){const F=j.$jc(y,b);n=(0,A.$2g)(M=>I.Promises.mkdir(F,{recursive:!0}).then(()=>w(M)).then(void 0,a));return}const P=p(c,f),N=C(f);n=(0,A.$2g)(F=>v.queue(()=>P.then(M=>m(M,b,N,y,i,F).then(()=>w(F)))).then(null,a))})}).finally(()=>t.dispose())}async function $(c,y=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,y?{lazyEntries:!0}:void 0,(s,t)=>{s?n(S(s)):o((0,L.$2f)(t))})})}function p(c,y){return new Promise((i,o)=>{c.openReadStream(y,(n,s)=>{n?o(S(n)):i((0,L.$2f)(s))})})}async function E(c,y){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;y.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,O.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}e.zip=E;function l(c,y,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=$(c,!0);return i.overwrite&&(s=s.then(t=>I.Promises.rm(y).then(()=>t))),s.then(t=>h(t,y,{sourcePathRegex:n},o))}e.$Xp=l;function u(c,y){return $(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===y&&p(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(R.localize(2,null,y))))}))}function d(c,y){return u(c,y).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.$Yp=d}),define(le[149],he([13,10]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[150],he([13,10]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[151],he([13,10]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[152],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[153],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[154],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[155],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[156],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[157],he([13,10]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[158],he([13,10]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[159],he([13,10]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[160],he([13,10]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[161],he([13,10]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[162],he([13,10]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[163],he([13,10]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[164],he([13,10]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[165],he([13,10]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[166],he([13,10]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[167],he([13,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[168],he([13,10]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[169],he([13,10]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[170],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[171],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[172],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[173],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[174],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[175],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[176],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[177],he([13,10]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[178],he([13,10]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[179],he([0,1,7,151]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.TokenType=void 0;var j;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(j||(e.TokenType=j={}));function L(...g){switch(g.length){case 1:return(0,A.localize)(0,null,g[0]);case 2:return(0,A.localize)(1,null,g[0],g[1]);case 3:return(0,A.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,A.localize)(3,null),R=(0,A.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:S,lexeme:m,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),m=k.b.get(S);m?this.k(m):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const $=this.c.charCodeAt(C);if(S)S=!1;else if($===47&&!m){C++;break}else $===91?m=!0:$===92?S=!0:$===93&&(m=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$0i=k}),define(le[180],he([0,1,65,85,23,16,37,20,9]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=e.$Hm=void 0,e.$Hm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,L.$mc)(j.$wg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Pg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Pg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,O.$Gm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",h)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Pg)(k.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Pg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Pg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Pg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=I.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$jc)(h,"argv.json")):(0,R.$Pg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.$kc)(h):(0,L.$hc)((0,L.$jc)(j.$wg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?k.URI.file((0,L.$kc)(h)):k.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.$kc)(h);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const p=I.env.VSCODE_PORTABLE;return p?(0,L.$jc)(p,"extensions"):(0,R.$Pg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,L.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?k.URI.parse(h):k.URI.file((0,L.$hc)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Hm.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const p=e.$Hm.exec($);p&&p[1]&&p[2]&&h.push([p[1],p[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$Pg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=I.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$jc)(h,"policy.json")):(0,R.$Pg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,p){this.a=h,this.b=$,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Im=g,ye([A.$Gh],g.prototype,"appRoot",null),ye([A.$Gh],g.prototype,"userHome",null),ye([A.$Gh],g.prototype,"userDataPath",null),ye([A.$Gh],g.prototype,"appSettingsHome",null),ye([A.$Gh],g.prototype,"tmpDir",null),ye([A.$Gh],g.prototype,"cacheHome",null),ye([A.$Gh],g.prototype,"stateResource",null),ye([A.$Gh],g.prototype,"userRoamingDataHome",null),ye([A.$Gh],g.prototype,"userDataSyncHome",null),ye([A.$Gh],g.prototype,"sync",null),ye([A.$Gh],g.prototype,"machineSettingsResource",null),ye([A.$Gh],g.prototype,"workspaceStorageHome",null),ye([A.$Gh],g.prototype,"localHistoryHome",null),ye([A.$Gh],g.prototype,"keyboardLayoutResource",null),ye([A.$Gh],g.prototype,"argvResource",null),ye([A.$Gh],g.prototype,"isExtensionDevelopment",null),ye([A.$Gh],g.prototype,"untitledWorkspacesHome",null),ye([A.$Gh],g.prototype,"builtinExtensionsPath",null),ye([A.$Gh],g.prototype,"extensionsPath",null),ye([A.$Gh],g.prototype,"extensionDevelopmentLocationURI",null),ye([A.$Gh],g.prototype,"extensionDevelopmentKind",null),ye([A.$Gh],g.prototype,"extensionTestsLocationURI",null),ye([A.$Gh],g.prototype,"debugExtensionHost",null),ye([A.$Gh],g.prototype,"logLevel",null),ye([A.$Gh],g.prototype,"extensionLogLevel",null),ye([A.$Gh],g.prototype,"serviceMachineIdResource",null),ye([A.$Gh],g.prototype,"disableTelemetry",null),ye([A.$Gh],g.prototype,"disableWorkspaceTrust",null),ye([A.$Gh],g.prototype,"useInMemorySecretStorage",null),ye([A.$Gh],g.prototype,"policyFile",null);function C(m,h){return S(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Jm=C;function S(m,h,$,p,E,l){const d=Number(h||m)||(p?null:$),c=d?!!h:!1;let y;if(l)try{y=JSON.parse(l)}catch{}return{port:d,break:c,debugId:E,env:y}}e.$Km=S}),function(){"use strict";function se(e,O,A){function j(I,R){const k=L(I,R),g=[k];return e.isAbsolute(k)||g.unshift(A),e.resolve(...g)}function L(I,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=I["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:j}}if(typeof define=="function")define(le[181],he([269,36,37]),function(e,O,A){return se(e,O,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=se(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[182],he([0,1,36,180,181]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=e.$Mm=e.$Lm=void 0;class L extends A.$Im{constructor(g,C){super(g,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,j.getUserDataPath)(g,C.nameShort)},C)}}e.$Lm=L;function I(k,g){return(0,A.$Km)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Mm=I;function R(k,g){return(0,A.$Km)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Nm=R}),define(le[183],he([0,1,12,154]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;function j(I,R,k,g){try{L(I,R,k,g)}catch(C){I.error(C?.message??C)}return R}e.$8p=j;function L(I,R,k,g){const C=(S,m,h)=>{const $=S[m];if((0,O.$Qf)($)){const p=$,E=p.length;if(E>1&&p[0]==="%"&&p[E-1]==="%"){const l=p.substr(1,E-2);let u=k[l];u===void 0&&g&&(u=g[l]);const d=typeof u=="string"?u:u?.message,c=g?.[l],y=typeof c=="string"?c:c?.message;if(!d){y||I.warn(`[${R.name}]: ${(0,A.localize)(0,null,l)}`);return}if(h&&(m==="title"||m==="category")&&y&&y!==d){const i={value:d,original:y};S[m]=i}else S[m]=d}}else if((0,O.$Sf)($))for(const p in $)$.hasOwnProperty(p)&&(p==="commands"?C($,p,!0):C($,p,h));else if(Array.isArray($))for(let p=0;p<$.length;p++)C($,p,h)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(le[184],he([0,1,70,157]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;function j(L){return(0,O.$Yp)(L,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$dq=j}),define(le[185],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Vac=O;class A{constructor(L){this.a=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,R){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${I}`)}}e.$Wac=A}),define(le[71],he([0,1,20,89,158,55]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(l){return l=l.trim(),l==="*"||I.test(l)}e.$jp=k;function g(l){if(!k(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(I);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$kp=g;function C(l){if(!l)return null;const u=l.majorBase,d=l.majorMustEqual,c=l.minorBase;let y=l.minorMustEqual;const i=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(y=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:d,minorBase:c,minorMustEqual:y,patchBase:i,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$lp=C;function S(l,u,d){let c;typeof l=="string"?c=C(g(l)):c=l;let y;u instanceof Date?y=u.getTime():typeof u=="string"&&(y=new Date(u).getTime());let i;if(typeof d=="string"?i=C(g(d)):i=d,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let w=i.majorMustEqual,f=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||y&&y<v?!1:s>=a:(o===1&&t===0&&(!w||!f||!b)&&(t=1,r=0,a=0,w=!0,f=!1,b=!1),o<t?!1:o>t?!w:n<r?!1:n>r?!f:s<a?!1:s>a?!b:!(y&&y<v))}e.$mp=S;function m(l,u,d,c,y){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([A.default.Error,j.localize(0,null)]),i;if(typeof c.name!="string")return i.push([A.default.Error,j.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([A.default.Error,j.localize(2,null,"version")]),i;if(!c.engines)return i.push([A.default.Error,j.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([A.default.Error,j.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!E(c.extensionDependencies))return i.push([A.default.Error,j.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!E(c.activationEvents))return i.push([A.default.Error,j.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([A.default.Error,j.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([A.default.Warning,j.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([A.default.Error,j.localize(9,null,"main")]),i;{const s=(0,O.$Pg)(d,c.main);(0,O.$Jg)(s,d)||i.push([A.default.Warning,j.localize(10,null,s.path,d.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([A.default.Error,j.localize(11,null,"browser")]),i;{const s=(0,O.$Pg)(d,c.browser);(0,O.$Jg)(s,d)||i.push([A.default.Warning,j.localize(12,null,s.path,d.path)])}}if(!L.valid(c.version))return i.push([A.default.Error,j.localize(13,null)]),i;const o=[];if(!h(l,u,c,y,o))for(const s of o)i.push([A.default.Error,s]);return i}e.$np=m;function h(l,u,d,c,y){return c||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(l,u,d.engines.vscode,y)}e.$op=h;function $(l,u,d){return l==="*"||p(u,d,l)}e.$pp=$;function p(l,u,d,c=[]){const y=C(g(d));if(!y)return c.push(j.localize(14,null,d)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return c.push(j.localize(15,null,d)),!1}else if(!y.majorMustEqual)return c.push(j.localize(16,null,d)),!1;return S(l,u,y)?!0:(c.push(j.localize(17,null,l,d)),!1)}function E(l){if(!Array.isArray(l))return!1;for(let u=0,d=l.length;u<d;u++)if(typeof l[u]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;async function j(L,I,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await I.readFile(L.serviceMachineIdResource)).value.toString();k=(0,A.$xg)(C)?C:null}catch{k=null}if(!k){k=(0,A.$yg)();try{await I.writeFile(L.serviceMachineIdResource,O.$qe.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$Jp=j}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=void 0;class O{constructor(j,L=[],I=!1){this.ctor=j,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.$_h=O}),define(le[186],he([0,1,72]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.InstantiationType=void 0;const A=[];var j;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function L(R,k,g){k instanceof O.$_h||(k=new O.$_h(k,[],!!g)),A.push([R,k])}e.$8r=L;function I(){return A}e.$9r=I}),define(le[187],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class O{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Lq=O;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const R=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(I);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const R of this.a.values())R.outgoing.delete(I),R.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let R=this.a.get(I);return R||(R=new O(I,L),this.a.set(I,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,R]of this.a)L.push(`${I}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const R=new Set([L]),k=this.c(I,R);if(k)return k}}c(L,I){for(const[R,k]of L.outgoing){if(I.has(R))return[...I,R].join(" -> ");I.add(R);const g=this.c(k,I);if(g)return g;I.delete(R)}}}e.$Mq=A}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=R})(O||(e._util=O={})),e.$bi=j("instantiationService");function A(I,R,k){R[O.DI_TARGET]===R?R[O.DI_DEPENDENCIES].push({id:I,index:k}):(R[O.DI_DEPENDENCIES]=[{id:I,index:k}],R[O.DI_TARGET]=R)}function j(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(R,k,C)};return R.toString=()=>I,O.serviceIds.set(I,R),R}e.$ci=j;function L(I){return I}e.$di=L}),define(le[188],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0,e.$vac=(0,O.$ci)("checksumService")}),define(le[21],he([0,1,12,9,4]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ConfigurationTarget=e.$Ki=e.$Ji=e.$Ii=void 0,e.$Ii=(0,j.$ci)("configurationService");function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof A.URI)}e.$Ji=L;function I(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof A.URI)}e.$Ki=I;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Li=k;function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Mi=g;function C(l,u){const d=Object.create(null);for(const c in l)S(d,c,l[c],u);return d}e.$Ni=C;function S(l,u,d,c){const y=u.split("."),i=y.pop();let o=l;for(let n=0;n<y.length;n++){const s=y[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${u} as ${y.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{c(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${u} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Oi=S;function m(l,u){const d=u.split(".");h(l,d)}e.$Pi=m;function h(l,u){const d=u.shift();if(u.length===0){delete l[d];return}if(Object.keys(l).indexOf(d)!==-1){const c=l[d];typeof c=="object"&&!Array.isArray(c)&&(h(c,u),Object.keys(c).length===0&&delete l[d])}}function $(l,u,d){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const y=u.split("."),i=c(l,y);return typeof i>"u"?d:i}e.$Qi=$;function p(l,u,d){Object.keys(u).forEach(c=>{c!=="__proto__"&&(c in l?O.$Sf(l[c])&&O.$Sf(u[c])?p(l[c],u[c],d):d&&(l[c]=u[c]):l[c]=u[c])})}e.$Ri=p;function E(l){return l.replace(/[\[\]]/g,"")}e.$Si=E}),define(le[94],he([0,1,5,27,179,4,150,7]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.ContextKeyExprType=e.$$i=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",O.$j),k.set("isLinux",O.$k),k.set("isWindows",O.$i),k.set("isWeb",O.$o),k.set("isMacNative",O.$j&&!O.$o),k.set("isEdge",O.$H),k.set("isFirefox",O.$F),k.set("isChrome",O.$E),k.set("isSafari",O.$G);function g(z,D){if(k.get(z)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(z,D)}e.$$i=g;const C=Object.prototype.hasOwnProperty;var S;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const m={regexParsingWithErrorRecovery:!0},h=(0,I.localize)(0,null),$=(0,I.localize)(1,null),p=(0,I.localize)(2,null),E=(0,I.localize)(3,null),l=(0,I.localize)(4,null),u=(0,I.localize)(5,null),d=(0,I.localize)(6,null),c=(0,I.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=m){this.k=D,this.d=new j.$0i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const T=this.l();if(!this.E()){const B=this.D(),q=B.type===17?u:void 0;throw this.h.push({message:l,offset:B.offset,lexeme:j.$0i.getLexeme(B),additionalInfo:q}),y.c}return T}catch(T){if(T!==y.c)throw T;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(16);){const T=this.o();D.push(T)}return D.length===1?D[0]:i.or(...D)}o(){const D=[this.s()];for(;this.y(15);){const T=this.s();D.push(T)}return D.length===1?D[0]:i.and(...D)}s(){if(this.y(2)){const D=this.D();switch(D.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const T=this.l();return this.A(1,E),T?.negate()}case 17:return this.z(),P.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const T=this.l();return this.A(1,E),T}case 17:{const T=D.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const X=q.lexeme,_=X.lastIndexOf("/"),ie=_===X.length-1?void 0:this.w(X.substring(_+1));let J;try{J=new RegExp(X.substring(1,_),ie)}catch{throw this.B("REGEX",q)}return Q.create(T,J)}switch(q.type){case 10:case 19:{const X=[q.lexeme];this.z();let _=this.D(),ie=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ie++:q.lexeme.charCodeAt(de)===41&&ie--}if(ie<0)break;X.push(j.$0i.getLexeme(_)),this.z(),_=this.D()}const J=X.join(""),ne=J.lastIndexOf("/"),ce=ne===J.length-1?void 0:this.w(J.substring(ne+1));let fe;try{fe=new RegExp(J.substring(1,ne),ce)}catch{throw this.B("REGEX",q)}return i.regex(T,fe)}case 18:{const X=q.lexeme;this.z();let _=null;if(!(0,A.$Qe)(X)){const ie=X.indexOf("/"),J=X.lastIndexOf("/");if(ie!==J&&ie>=0){const ne=X.slice(ie+1,J),ce=X[J+1]==="i"?"i":"";try{_=new RegExp(ne,ce)}catch{throw this.B("REGEX",q)}}}if(_===null)throw this.B("REGEX",q);return Q.create(T,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const q=this.u();return i.notIn(T,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return i.equals(T,q);switch(q){case"true":return i.has(T);case"false":return i.not(T);default:return i.equals(T,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return i.notEquals(T,q);switch(q){case"true":return i.not(T);case"false":return i.has(T);default:return i.notEquals(T,q)}}case 5:return this.z(),U.create(T,this.u());case 6:return this.z(),Y.create(T,this.u());case 7:return this.z(),F.create(T,this.u());case 8:return this.z(),M.create(T,this.u());case 13:return this.z(),i.in(T,this.u());default:return i.has(T)}}case 20:throw this.h.push({message:d,offset:D.offset,lexeme:"",additionalInfo:c}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case 17:case 18:return this.z(),D.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,T){if(this.C(D))return this.z();throw this.B(T,this.D())}B(D,T,B){const q=(0,I.localize)(8,null,D,j.$0i.getLexeme(T)),X=T.offset,_=j.$0i.getLexeme(T);return this.h.push({message:q,offset:X,lexeme:_,additionalInfo:B}),y.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$_i=y;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(D){return a.create(D)}static equals(D,T){return v.create(D,T)}static notEquals(D,T){return b.create(D,T)}static regex(D,T){return Q.create(D,T)}static in(D,T){return w.create(D,T)}static notIn(D,T){return f.create(D,T)}static not(D){return P.create(D)}static and(...D){return Z.create(D,null,!0)}static or(...D){return H.create(D,null,!0)}static greater(D,T){return F.create(D,T)}static greaterEquals(D,T){return M.create(D,T)}static smaller(D,T){return U.create(D,T)}static smallerEquals(D,T){return Y.create(D,T)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$aj=i;function o(z){const D=new y({regexParsingWithErrorRecovery:!1});return z.map(T=>(D.parse(T),D.lexingErrors.length>0?D.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$bj=o;function n(z,D){const T=z?z.substituteConstants():void 0,B=D?D.substituteConstants():void 0;return!T&&!B?!0:!T||!B?!1:T.equals(B)}e.$cj=n;function s(z,D){return z.cmp(D)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return r.INSTANCE}}e.$dj=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return t.INSTANCE}}e.$ej=r;class a{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(D,T)}constructor(D,T){this.key=D,this.c=T,this.type=2}cmp(D){return D.type!==this.type?this.type-D.type:te(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=k.get(this.key);return typeof D=="boolean"?D?r.INSTANCE:t.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$fj=a;class v{static create(D,T,B=null){if(typeof T=="boolean")return T?a.create(D,B):P.create(D,B);const q=k.get(D);return typeof q=="boolean"?T===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new v(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=4}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?r.INSTANCE:t.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$gj=v;class w{static create(D,T){return new w(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=10,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.f),B=D.getValue(this.d);return Array.isArray(T)?T.includes(B):typeof B=="string"&&typeof T=="object"&&T!==null?C.call(T,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$hj=w;class f{static create(D,T){return new f(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=11,this.c=w.create(D,T)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$ij=f;class b{static create(D,T,B=null){if(typeof T=="boolean")return T?P.create(D,B):a.create(D,B);const q=k.get(D);return typeof q=="boolean"?T===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new b(D,T,B)}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=5}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=k.get(this.c);if(typeof D=="boolean"){const T=D?"true":"false";return this.d===T?t.INSTANCE:r.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$jj=b;class P{static create(D,T=null){const B=k.get(D);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new P(D,T)}constructor(D,T){this.c=D,this.d=T,this.type=3}cmp(D){return D.type!==this.type?this.type-D.type:te(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=k.get(this.c);return typeof D=="boolean"?D?t.INSTANCE:r.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$kj=P;function N(z,D){if(typeof z=="string"){const T=parseFloat(z);isNaN(T)||(z=T)}return typeof z=="string"||typeof z=="number"?D(z):t.INSTANCE}class F{static create(D,T,B=null){return N(T,q=>new F(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=12}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$lj=F;class M{static create(D,T,B=null){return N(T,q=>new M(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=13}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$mj=M;class U{static create(D,T,B=null){return N(T,q=>new U(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=14}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$nj=U;class Y{static create(D,T,B=null){return N(T,q=>new Y(D,q,B))}constructor(D,T,B){this.c=D,this.d=T,this.f=B,this.type=15}cmp(D){return D.type!==this.type?this.type-D.type:oe(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$oj=Y;class Q{static create(D,T){return new Q(D,T)}constructor(D,T){this.d=D,this.f=T,this.type=7,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return T<B?-1:T>B?1:0}equals(D){if(D.type===this.type){const T=this.f?this.f.source:"",B=D.f?D.f.source:"";return this.d===D.d&&T===B}return!1}substituteConstants(){return this}evaluate(D){const T=D.getValue(this.d);return this.f?this.f.test(T):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$pj=Q;class x{static create(D){return new x(D)}constructor(D){this.c=D,this.type=8}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new x(this.c.map(D))}negate(){return this.c}}e.$qj=x;function G(z){let D=null;for(let T=0,B=z.length;T<B;T++){const q=z[T].substituteConstants();if(z[T]!==q&&D===null){D=[];for(let X=0;X<T;X++)D[X]=z[X]}D!==null&&(D[T]=q)}return D===null?z:D}class Z{static create(D,T,B){return Z.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=6}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],D.expr[T]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=G(this.expr);return D===this.expr?this:Z.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].evaluate(D))return!1;return!0}static d(D,T,B){const q=[];let X=!1;for(const _ of D)if(_){if(_.type===1){X=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){q.push(..._.expr);continue}q.push(_)}if(q.length===0&&X)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(s);for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];for(;q.length>1;){const _=q[q.length-1];if(_.type!==9)break;q.pop();const ie=q.pop(),J=q.length===0,ne=H.create(_.expr.map(ce=>Z.create([ce,ie],null,B)),null,J);ne&&(q.push(ne),q.sort(s))}if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return t.INSTANCE;if(q.length===1)return q[0]}return new Z(q,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new Z(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());this.c=H.create(D,this,!0)}return this.c}}e.$rj=Z;class H{static create(D,T,B){return H.d(D,T,B)}constructor(D,T){this.expr=D,this.c=T,this.type=9}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let T=0,B=this.expr.length;T<B;T++){const q=s(this.expr[T],D.expr[T]);if(q!==0)return q}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let T=0,B=this.expr.length;T<B;T++)if(!this.expr[T].equals(D.expr[T]))return!1;return!0}return!1}substituteConstants(){const D=G(this.expr);return D===this.expr?this:H.create(D,this.c,!1)}evaluate(D){for(let T=0,B=this.expr.length;T<B;T++)if(this.expr[T].evaluate(D))return!0;return!1}static d(D,T,B){let q=[],X=!1;if(D){for(let _=0,ie=D.length;_<ie;_++){const J=D[_];if(J){if(J.type===0){X=!0;continue}if(J.type===1)return r.INSTANCE;if(J.type===9){q=q.concat(J.expr);continue}q.push(J)}}if(q.length===0&&X)return t.INSTANCE;q.sort(s)}if(q.length!==0){if(q.length===1)return q[0];for(let _=1;_<q.length;_++)q[_-1].equals(q[_])&&(q.splice(_,1),_--);if(q.length===1)return q[0];if(B){for(let _=0;_<q.length;_++)for(let ie=_+1;ie<q.length;ie++)if(q[_].negate().equals(q[ie]))return r.INSTANCE;if(q.length===1)return q[0]}return new H(q,T)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const T of this.expr)D.push(...T.keys());return D}map(D){return new H(this.expr.map(T=>T.map(D)),null)}negate(){if(!this.c){const D=[];for(const T of this.expr)D.push(T.negate());for(;D.length>1;){const T=D.shift(),B=D.shift(),q=[];for(const X of W(T))for(const _ of W(B))q.push(Z.create([X,_],null,!1));D.unshift(H.create(q,null,!1))}this.c=H.create(D,this,!0)}return this.c}}e.$sj=H;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(D,T,B){super(D,null),this.f=T,typeof B=="object"?V.d.push({...B,key:D}):B!==!0&&V.d.push({key:D,description:B,type:T!=null?typeof T:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return v.create(this.key,D)}notEqualsTo(D){return b.create(this.key,D)}}e.$tj=V,e.$uj=(0,L.$ci)("contextKeyService");function te(z,D){return z<D?-1:z>D?1:0}function oe(z,D,T,B){return z<T?-1:z>T?1:D<B?-1:D>B?1:0}function ee(z,D){if(z.type===0||D.type===1)return!0;if(z.type===9)return D.type===9?ae(z.expr,D.expr):!1;if(D.type===9){for(const T of D.expr)if(ee(z,T))return!0;return!1}if(z.type===6){if(D.type===6)return ae(D.expr,z.expr);for(const T of z.expr)if(ee(T,D))return!0;return!1}return z.equals(D)}e.$vj=ee;function ae(z,D){let T=0,B=0;for(;T<z.length&&B<D.length;){const q=z[T].cmp(D[B]);if(q<0)return!1;q===0&&T++,B++}return T===z.length}function W(z){return z.type===9?z.expr:[z]}}),define(le[95],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.ID=void 0,e.ID="diagnosticsService",e.$Sm=(0,O.$ci)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.$Tm=A;class j{async getPerformanceInfo(I,R){return{}}async getSystemInfo(I,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,R){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$Um=j}),define(le[96],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=void 0,e.$no=(0,O.$ci)("downloadService")}),define(le[15],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=void 0,e.$ji=(0,O.$ci)("environmentService"),e.$ki=(0,O.$di)(e.$ji)}),define(le[29],he([0,1,153,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.ExtensionGalleryErrorCode=e.$Jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$xo=new RegExp(e.$wo),e.$yo="__web_extension",e.$zo="skipWalkthrough",e.$Ao="extensionsSync",e.$Bo="dependecyOrPackExtensionInstall";function j(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Co=j;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Do=L;function I(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Eo=I;function R(d,c){return c==="web"&&!d.includes("web")}e.$Fo=R;function k(d,c,y){return R(c,y)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===y}e.$Go=k;function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$Ho=g;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var m;(function(d){d.Install="install",d.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var h;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(h||(e.InstallOperation=h={})),e.$Io=(0,A.$ci)("extensionGalleryService");var $;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var p;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(p||(e.ExtensionSignaturetErrorCode=p={}));class E extends Error{constructor(c,y){super(c),this.code=y,this.name=y}}e.$Jo=E;var l;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class u extends Error{constructor(c,y){super(c),this.code=y,this.name=y}}e.$Ko=u,e.$Lo=(0,A.$ci)("extensionManagementService"),e.$Mo="extensionsIdentifiers/disabled",e.$No="extensionsIdentifiers/enabled",e.$Oo=(0,A.$ci)("IGlobalExtensionEnablementService"),e.$Po=(0,A.$ci)("IExtensionTipsService"),e.$Qo=(0,O.localize2)(0,"Extensions"),e.$Ro=(0,O.localize2)(1,"Preferences")}),define(le[189],he([0,1,3,2,30,9,92,29]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=void 0;function k(E,l){return E?L.URI.revive(l?l.transformIncoming(E):E):void 0}function g(E,l){return l?l.transformOutgoingURI(E):E}function C(E,l){l=l||I.$cn;const u=E.manifest;return{...(0,I.$fn)({...E,manifest:void 0},l),manifest:u}}function S(E,l){return E?.profileLocation?(0,I.$fn)(E,l??I.$cn):E}function m(E,l){return l?(0,j.$Hn)(E,u=>u instanceof L.URI?l.transformOutgoingURI(u):void 0):E}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=O.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const d=this.b(l);switch(u){case"onInstallExtension":return O.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,c=>c.map(y=>({...y,local:y.local?m(y.local,d):y.local,profileLocation:y.profileLocation?g(y.profileLocation,d):y.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,d))}throw new Error("Invalid listen")}async call(l,u,d){const c=this.b(l);switch(u){case"zip":{const y=C(d[0],c),i=await this.a.zip(y);return g(i,c)}case"unzip":return this.a.unzip(k(d[0],c));case"install":return this.a.install(k(d[0],c),S(d[1],c));case"installFromLocation":return this.a.installFromLocation(k(d[0],c),k(d[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],k(d[1],c),k(d[2],c));case"getManifest":return this.a.getManifest(k(d[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],S(d[1],c));case"installGalleryExtensions":{const y=d[0];return this.a.installGalleryExtensions(y.map(({extension:i,options:o})=>({extension:i,options:S(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(d[0],c),S(d[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(d[0],c));case"getInstalled":return(await this.a.getInstalled(d[0],k(d[1],c))).map(i=>m(i,c));case"toggleAppliationScope":{const y=await this.a.toggleAppliationScope(C(d[0],c),k(d[1],c));return m(y,c)}case"copyExtensions":return this.a.copyExtensions(k(d[0],c),k(d[1],c));case"updateMetadata":{const y=await this.a.updateMetadata(C(d[0],c),d[1],k(d[2],c));return m(y,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Rp=h;class $ extends A.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new O.$3d),this.f=this.B(new O.$3d),this.g=this.B(new O.$3d),this.h=this.B(new O.$3d),this.j=this.B(new O.$3d),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?L.URI.revive(u.source):u.source,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:L.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}n(l,u){l.fire(u)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(d=>(0,R.$Go)(d,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(u=>L.URI.revive(u)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,u){return Promise.resolve(this.m.call("install",[l,u])).then(d=>C(d,null))}installFromLocation(l,u){return Promise.resolve(this.m.call("installFromLocation",[l,u])).then(d=>C(d,null))}async installExtensionsFromProfile(l,u,d){return(await this.m.call("installExtensionsFromProfile",[l,u,d])).map(y=>C(y,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.m.call("installFromGallery",[l,u])).then(d=>C(d,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?L.URI.revive(d.source):d.source,profileLocation:L.URI.revive(d.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.m.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(u=>C(u,null))}getInstalled(l=null,u){return Promise.resolve(this.m.call("getInstalled",[l,u])).then(d=>d.map(c=>C(c,null)))}updateMetadata(l,u,d){return Promise.resolve(this.m.call("updateMetadata",[l,u,d])).then(c=>C(c,null))}toggleAppliationScope(l,u){return this.m.call("toggleAppliationScope",[l,u]).then(d=>C(d,null))}copyExtensions(l,u){return this.m.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,u,d){const c=await this.m.call("download",[l,u,d]);return L.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Sp=$;class p{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,d){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Tp=p}),define(le[97],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Zb=e.RecommendationsNotificationResult=e.$6Zb=e.RecommendationSource=void 0;var A;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(A||(e.RecommendationSource=A={}));function j(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$6Zb=j;var L;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$7Zb=(0,O.$ci)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,16,27,12,9,160,4,5,23,52]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileKind=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileOperationResult=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileChangeType=e.$Rk=e.FileOperation=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileSystemProviderErrorCode=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderCapabilities=e.$Bk=e.FilePermission=e.FileType=e.$Ak=e.$zk=void 0,e.$zk=(0,k.$ci)("fileService");function m(ee){return ee.create===!0}e.$Ak=m;var h;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(h||(e.FileType=h={}));var $;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})($||(e.FilePermission=$={}));function p(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$Bk=p;var E;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(E||(e.FileSystemProviderCapabilities=E={}));function l(ee){return!!(ee.capabilities&2)}e.$Ck=l;function u(ee){return!!(ee.capabilities&8)}e.$Dk=u;function d(ee){return!!(ee.capabilities&131072)}e.$Ek=d;function c(ee){return!!(ee.capabilities&4)}e.$Fk=c;function y(ee){return!!(ee.capabilities&16)}e.$Gk=y;function i(ee){return l(ee)?!!(ee.capabilities&16384):!1}e.$Hk=i;function o(ee){return l(ee)?!!(ee.capabilities&32768):!1}e.$Ik=o;function n(ee){return!!(ee.capabilities&65536)}e.$Jk=n;function s(ee){return!!(ee.capabilities&2048)}e.$Kk=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,W){const z=new r(ae.toString(),W);return w(z,W),z}constructor(ae,W){super(ae),this.code=W}}e.$Lk=r;function a(ee,ae){return r.create(ee,ae)}e.$Mk=a;function v(ee){return ee||a((0,R.localize)(0,null),t.Unknown)}e.$Nk=v;function w(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Ok=w;function f(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Pk=f;function b(ee){if(ee instanceof Y)return ee.fileOperationResult;switch(f(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Qk=b;var P;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(ae,W,z){this.resource=ae,this.operation=W,this.target=z}isOperation(ae){return this.operation===ae}}e.$Rk=N;var F;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(ae,W){this.c=W,this.b=void 0,this.d=new S.$V(()=>{const z=O.$ii.forUris(()=>this.c);return z.fill(this.rawAdded.map(D=>[D,!0])),z}),this.f=new S.$V(()=>{const z=O.$ii.forUris(()=>this.c);return z.fill(this.rawUpdated.map(D=>[D,!0])),z}),this.g=new S.$V(()=>{const z=O.$ii.forUris(()=>this.c);return z.fill(this.rawDeleted.map(D=>[D,!0])),z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const z of ae){switch(z.type){case 1:this.rawAdded.push(z.resource);break;case 0:this.rawUpdated.push(z.resource);break;case 2:this.rawDeleted.push(z.resource);break}this.b!==M.a&&(typeof z.cId=="number"?this.b===void 0?this.b=z.cId:this.b!==z.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...W){return this.h(ae,{includeChildren:!1},...W)}affects(ae,...W){return this.h(ae,{includeChildren:!0},...W)}h(ae,W,...z){if(!ae)return!1;const D=z.length>0;return!!((!D||z.includes(1))&&(this.d.value.get(ae)||W.includeChildren&&this.d.value.findSuperstr(ae))||(!D||z.includes(0))&&(this.f.value.get(ae)||W.includeChildren&&this.f.value.findSuperstr(ae))||(!D||z.includes(2))&&(this.g.value.findSubstr(ae)||W.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Sk=M;function U(ee,ae,W){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==A.sep&&(ae+=A.sep),W?(0,j.$if)(ee,ae):ee.indexOf(ae)===0)}e.$Tk=U;class Y extends Error{constructor(ae,W,z){super(ae),this.fileOperationResult=W,this.options=z}}e.$Uk=Y;class Q extends Y{constructor(ae,W,z,D){super(ae,W,D),this.fileOperationResult=W,this.size=z}}e.$Vk=Q;class x extends Y{constructor(ae,W,z){super(ae,2,z),this.stat=W}}e.$Wk=x;var G;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$Xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Zk="files.associations",e.$1k="files.exclude",e.$2k="files.readonlyInclude",e.$3k="files.readonlyExclude",e.$4k="files.readonlyFromPermissions";var Z;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$5k="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$6k=H;async function V(ee,ae){if(!ae.hasProvider(I.URI.from({scheme:ee.scheme})))return new Promise(W=>{const z=ae.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===ee.scheme&&D.added&&(z.dispose(),W())})})}e.$7k=V;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(ae){return(0,L.$Uf)(ae)||(ae=0),ae<te.KB?(0,R.localize)(1,null,ae.toFixed(0)):ae<te.MB?(0,R.localize)(2,null,(ae/te.KB).toFixed(2)):ae<te.GB?(0,R.localize)(3,null,(ae/te.MB).toFixed(2)):ae<te.TB?(0,R.localize)(4,null,(ae/te.GB).toFixed(2)):(0,R.localize)(5,null,(ae/te.TB).toFixed(2))}}e.$8k=te;function oe(ee){const ae=typeof ee=="string"||ee?.scheme===C.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===C.Schemas.file?1024*te.MB:ae?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$9k=oe});var K=this&&this.__param||function(se,e){return function(O,A){e(O,A,se)}};define(le[190],he([0,1,73,47,11]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const S=(0,O.createHash)("sha256");(0,A.$ie)(k,{onData:m=>S.update(m.buffer),onError:m=>C(m),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$wac=L,e.$wac=L=ye([K(0,j.$zk)],L)}),define(le[98],he([0,1,14,7,161,11]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;async function I(C,S,m,h,$,p){let E;try{await R(C,S,m,h,$,p)}catch(l){E=l}finally{E&&$.errorTransformer&&(E=$.errorTransformer(E)),typeof E<"u"&&m.error(E),m.end()}}e.$kq=I;async function R(C,S,m,h,$,p){k(p);const E=await C.open(S,{create:!1});try{k(p);let l=0,u=0,d=$&&typeof $.length=="number"?$.length:void 0,c=O.$qe.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),y=$&&typeof $.position=="number"?$.position:0,i=0;do u=await C.read(E,y,c.buffer,i,c.byteLength-i),y+=u,i+=u,l+=u,typeof d=="number"&&(d-=u),i===c.byteLength&&(await m.write(h(c)),c=O.$qe.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),i=0);while(u>0&&(typeof d!="number"||d>0)&&k(p)&&g(l,$));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),m.write(h(c.slice(0,o)))}}catch(l){throw(0,L.$Nk)(l)}finally{await C.close(E)}}function k(C){if(C.isCancellationRequested)throw(0,A.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,L.$Mk)((0,j.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],he([0,1,91,2,16,5,9,11]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;function k(l){return l.recursive===!0}e.$mq=k;class g extends A.$Tc{static{this.a=5}constructor(u,d,c,y){super(),this.h=u,this.j=d,this.m=c,this.n=y,this.c=this.B(new A.$Uc),this.f=void 0,this.g=0}s(){const u=new A.$Sc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(d=>this.h(d))),u.add(this.b.onDidLogMessage(d=>this.j(d))),u.add(this.b.onDidError(d=>this.t(d)))}t(u){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$nq=g;class C extends g{constructor(u,d,c){super(u,d,c,{type:"node.js",restartOnError:!1})}}e.$oq=C;class S extends g{constructor(u,d,c){super(u,d,c,{type:"universal",restartOnError:!0})}}e.$pq=S;function m(l){return l.map(u=>({type:u.type,resource:I.URI.revive(u.resource),cId:u.cId}))}e.$qq=m;function h(l){const u=new E;for(const d of l)u.processEvent(d);return u.coalesce()}e.$rq=h;function $(l,u){return typeof u=="string"&&!u.startsWith(O.$Rj)&&!(0,j.$ic)(u)?{base:l,pattern:u}:u}e.$sq=$;function p(l,u){const d=[];for(const c of u)d.push((0,O.$Vj)($(l,c)));return d}e.$tq=p;class E{constructor(){this.a=new Set,this.b=new Map}c(u){return L.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const d=this.b.get(this.c(u));let c=!1;if(d){const y=d.type,i=u.type;d.resource.fsPath!==u.resource.fsPath&&(u.type===2||u.type===1)?c=!0:y===1&&i===2?(this.b.delete(this.c(u)),this.a.delete(d)):y===2&&i===1?d.type=0:y===1&&i===0||(d.type=i)}else c=!0;c&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],d=[];return Array.from(this.a).filter(c=>c.type!==2?(u.push(c),!1):!0).sort((c,y)=>c.resource.fsPath.length-y.resource.fsPath.length).filter(c=>d.some(y=>(0,R.$Tk)(c.resource.fsPath,y,!L.$k))?!1:(d.push(c.resource.fsPath),!0)).concat(u)}}}),define(le[191],he([0,1,14,38,7,3,2,47,32,11,50]),function(se,e,O,A,j,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gP=e.$fP=void 0,e.$fP="localFilesystem";class S extends I.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$3d),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$3d),this.onDidWatchError=this.g.event,this.h=(0,k.$yg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:p}=await this.a.call("readFile",[h,$]);return p}readFileStream(h,$,p){const E=(0,R.$ee)(u=>O.$qe.concat(u.map(d=>O.$qe.wrap(d))).buffer),l=new I.$Sc;return l.add(this.a.listen("readFileStream",[h,$])(u=>{if(u instanceof O.$qe)E.write(u.buffer);else{if(u==="end")E.end();else{let d;if(u instanceof Error)d=u;else{const c=u;d=(0,g.$Mk)(c.message??(0,A.$Zi)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}E.error(d),E.end()}l.dispose()}})),l.add(p.onCancellationRequested(()=>{E.error((0,j.$6)()),E.end(),l.dispose()})),E}writeFile(h,$,p){return this.a.call("writeFile",[h,O.$qe.wrap($),p])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,p,E,l){const[u,d]=await this.a.call("read",[h,$,l]);return p.set(u.buffer.slice(0,d),E),d}write(h,$,p,E,l){return this.a.call("write",[h,$,O.$qe.wrap(p),E,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,p){return this.a.call("rename",[h,$,p])}copy(h,$,p){return this.a.call("copy",[h,$,p])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire((0,C.$qq)($))}else{const $=h;this.g.fire($)}}))}watch(h,$){const p=(0,k.$yg)();return this.a.call("watch",[this.h,p,h,$]),(0,I.$Rc)(()=>this.a.call("unwatch",[this.h,p]))}}e.$gP=S}),define(le[192],he([0,1,54,6,26,49,2,88,16,5,20,9,144,31,50]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class p extends I.$Tc{static{this.a=100}static{this.b=75}constructor(u,d,c,y){super(),this.m=u,this.n=d,this.r=c,this.s=y,this.c=this.B(new A.$rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new A.$qh(i=>this.z(i),p.b)),this.g=(0,$.$tq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$tq)(this.m.path,this.m.includes):void 0,this.j=new j.$ae,this.ready=this.t()}async t(){try{const u=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await h.Promises.stat(u);this.B(await this.w(u,d.isDirectory()))}catch(u){u.code!=="ENOENT"?this.D(u):this.G(u)}}async u(u){let d=u.path;try{d=await h.Promises.realpath(u.path),u.path===d&&(d=await(0,m.$Dq)(u.path)??u.path),u.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${d})`)}catch{}return d}async w(u,d){if(g.$j&&(0,L.$dg)(u,"/Volumes/",!0))return this.D(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Tc.None;const c=new j.$ae(this.j.token),y=new I.$Sc;try{const i=S.URI.file(this.m.path),o=(0,k.$nc)(u),n=(0,O.watch)(u);y.add((0,I.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${u}'`);const s=new Set;if(d)try{for(const r of await h.Promises.readdir(u))s.add(r)}catch(r){this.D(r)}const t=new Map;y.add((0,I.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${u} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$j&&(v=(0,R.$Pl)(v))),!(!v||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await h.Promises.exists(u)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,k.$jc)(u,v));if(c.token.isCancellationRequested)return;let b;f?s.has(v)?b=0:(b=1,s.add(v)):(s.delete(v),b=2),this.y({resource:(0,C.$Pg)(i,v),type:b,cId:this.m.correlationId})},p.a);t.set(v,(0,I.$Rc)(()=>clearTimeout(w)))}else{let w;s.has(v)?w=0:(w=1,s.add(v)),this.y({resource:(0,C.$Pg)(i,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const f=await h.Promises.exists(u);c.token.isCancellationRequested||(f?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),y.add(await this.w(u,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},p.a);y.clear(),y.add((0,I.$Rc)(()=>clearTimeout(w)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await h.Promises.exists(u)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${u} for changes using fs.watch() (${i.toString()})`)}return(0,I.$Rc)(()=>{c.dispose(!0),y.dispose()})}y(u,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!d&&this.g.some(c=>c(u.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${u.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(c=>c(u.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}z(u){const d=(0,$.$rq)(u);if(d.length>0){if(this.s)for(const y of d)this.G(` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(u){if(g.$k)return h.Promises.exists(u);try{const d=(0,k.$nc)(u);return(await h.Promises.readdir((0,k.$mc)(u))).some(y=>y===d)}catch(d){return this.G(d),!1}}setVerboseLogging(u){this.s=u}D(u){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}F(u){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}G(u){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Gq=p;async function E(l,u,d,c,y=512){const i=await h.Promises.open(l,"r"),o=Buffer.allocUnsafe(y),n=new j.$ae(c);let s,t=!1;const r={path:l,excludes:[],recursive:!1},a=new p(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:f}=await h.Promises.read(i,o,0,y,null);if(!f||n.token.isCancellationRequested)break;u(o.slice(0,f))}}catch(f){s=new Error(f),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,d(),new Promise((v,w)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await h.Promises.close(i)}catch(f){s=new Error(f)}s?w(s):v()})})}e.$Hq=E}),define(le[193],he([0,1,3,91,2,5,192]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class R extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$3d),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$3d),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(h=>{const $=this.c.get(h.path);return $?!(0,A.$Zj)($.request.excludes,h.excludes)||!(0,A.$Zj)($.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!C.find($=>$.path===h.path&&(0,A.$Zj)($.excludes,h.excludes)&&(0,A.$Zj)($.includes,h.includes))).map(({request:h})=>h.path);S.length&&this.m(`Request to start watching: ${S.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of S)this.g(h)}g(g){const C=new I.$Gq(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const m=L.$k?S.path:S.path.toLowerCase();let h=C.get(S.correlationId);h||(h=new Map,C.set(S.correlationId,h)),h.set(m,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Iq=R}),define(le[194],he([0,1,50,193]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class j extends O.$oq{constructor(I,R,k){super(I,R,k),this.s()}r(I){return I.add(new A.$Iq)}}e.$Jq=j}),define(le[195],he([0,1,23,40,93,50]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class I extends L.$pq{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new j.$Aq(O.$wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),A.ProxyChannel.toService((0,A.$Vh)(g.getChannel("watcher")))}}e.$Bq=I}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=void 0;class O{constructor(...j){this.a=new Map;for(const[L,I]of j)this.set(L,I)}set(j,L){const I=this.a.get(j);return this.a.set(j,L),I}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$ai=O}),define(le[196],he([0,1,6,7,2,72,187,4,74,87]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;const C=!1;class S extends Error{constructor(E){super("cyclic dependency between services"),this.message=E.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${E.toString()}`}}class m{constructor(E=new k.$ai,l=!1,u,d=C){this.f=E,this.g=l,this.h=u,this.i=d,this.o=new Set,this.f.set(R.$bi,this),this._globalGraph=d?u?._globalGraph??new I.$Mq(c=>c):void 0}createChild(E){return new m(E,this.g,this,this.i)}invokeFunction(E,...l){const u=$.traceInvocation(this.i,E);let d=!1;try{return E({get:y=>{if(d)throw(0,A.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(y,u);if(!i)throw new Error(`[invokeFunction] unknown service '${y}'`);return i}},...l)}finally{d=!0,u.stop()}}createInstance(E,...l){let u,d;return E instanceof L.$_h?(u=$.traceCreation(this.i,E.ctor),d=this.j(E.ctor,E.staticArguments.concat(l),u)):(u=$.traceCreation(this.i,E),d=this.j(E,l,u)),u.stop(),d}j(E,l=[],u){const d=R._util.getServiceDependencies(E).sort((i,o)=>i.index-o.index),c=[];for(const i of d){const o=this.m(i.id,u);o||this.u(`[createInstance] ${E.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const y=d.length>0?d[0].index:l.length;if(l.length!==y){console.trace(`[createInstance] First service dependency of ${E.name} at position ${y+1} conflicts with ${l.length} static arguments`);const i=y-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,y)}return Reflect.construct(E,l.concat(c))}k(E,l){if(this.f.get(E)instanceof L.$_h)this.f.set(E,l);else if(this.h)this.h.k(E,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(E){const l=this.f.get(E);return!l&&this.h?this.h.l(E):l}m(E,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(E));const u=this.l(E);return u instanceof L.$_h?this.q(E,u,l.branch(E,!0)):(l.branch(E,!1),u)}q(E,l,u){if(this.o.has(E))throw new Error(`illegal state - RECURSIVELY instantiating service '${E}'`);this.o.add(E);try{return this.r(E,l,u)}finally{this.o.delete(E)}}r(E,l,u){const d=new I.$Mq(i=>i.id.toString());let c=0;const y=[{id:E,desc:l,_trace:u}];for(;y.length;){const i=y.pop();if(d.lookupOrInsertNode(i),c++>1e3)throw new S(d);for(const o of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${E} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof L.$_h){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,s),y.push(s)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:o}of i){if(this.l(o.id)instanceof L.$_h){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}d.removeNode(o)}}return this.l(E)}s(E,l,u=[],d,c){if(this.f.get(E)instanceof L.$_h)return this.t(E,l,u,d,c);if(this.h)return this.h.s(E,l,u,d,c);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(E,l,u=[],d,c){if(d){const y=new m(void 0,this.g,this,this.i);y.c=String(E);const i=new Map,o=new O.$vh(()=>{const n=y.j(l,u,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(w,f,b)=>{if(o.isInitialized)return o.value[s](w,f,b);{const P={listener:[w,f,b],disposable:void 0},N=a.push(P);return(0,j.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,c)}u(E,l){if(l&&console.warn(E),this.g)throw new Error(E)}}e.$Nq=m;var h;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(h||(h={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(E,l){return E?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(E,l){return E?new $(1,l.name):$.c}static{this.f=0}constructor(E,l){this.type=E,this.name=l,this.g=Date.now(),this.h=[]}branch(E,l){const u=new $(3,E.toString());return this.h.push([E,l,u]),u}stop(){const E=Date.now()-this.g;$.f+=E;let l=!1;function u(c,y){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of y.h)if(s&&t){l=!0,i.push(`${o}CREATES -> ${n}`);const r=u(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${E.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(E>2||l)&&$.all.add(d.join(`
`))}}e.$Oq=$}),define(le[56],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=e.$4_b=void 0,e.$4_b=(0,O.$ci)("mainProcessService");class A{constructor(L,I){this.a=L,this.b=I}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,I){this.a.registerChannel(L,I)}}e.$5_b=A}),define(le[75],he([0,1,26,2,5,163,29,4]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$pr=k,e.$qr=(0,R.$ci)("languagePackService");let g=class extends A.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new O.$ae;setTimeout(()=>S.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const $=m.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(E=>E.startsWith("lp-"))).map(p=>{const E=p.properties.localizedLanguages?.[0],l=k(p);return{...this.f(l,E,p),extensionId:p.identifier.id,galleryExtension:p}});return $.push(this.f("en","English")),$}f(S,m,h){const $=m??S;let p;if($!==S&&(p=`(${S})`),S.toLowerCase()===j.$w.toLowerCase()&&(p??="",p+=(0,L.localize)(0,null)),h?.installCount){p??="";const E=h.installCount;let l;E>1e6?l=`${Math.floor(E/1e5)/10}M`:E>1e3?l=`${Math.floor(E/1e3)}K`:l=String(E),p+=` $(cloud-download) ${l}`}return{id:S,label:$,description:p}}};e.$rr=g,e.$rr=g=ye([K(0,I.$Io)],g)}),define(le[197],he([0,1,2,75]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;let j=class extends O.$Tc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$sac=j,e.$sac=j=ye([K(0,A.$qr)],j)}),define(le[8],he([0,1,38,3,53,2,35,5,20,12,9,94,4]),function(se,e,O,A,j,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.log=e.$zj=e.LogLevel=e.$yj=e.$xj=e.$wj=void 0,e.$wj=(0,m.$ci)("logService"),e.$xj=(0,m.$ci)("loggerService");function h(){return new Date().toISOString()}function $(w){return(0,g.$Uf)(w)}e.$yj=$;var p;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$zj=p.Info;function E(w,f,b){switch(f){case p.Trace:w.trace(b);break;case p.Debug:w.debug(b);break;case p.Info:w.info(b);break;case p.Warning:w.warn(b);break;case p.Error:w.error(b);break;case p.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=E;function l(w,f=!1){let b="";for(let P=0;P<w.length;P++){let N=w[P];if(N instanceof Error&&(N=(0,O.$Zi)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}b+=(P>0?" ":"")+N}return b}class u extends L.$Tc{constructor(){super(...arguments),this.b=e.$zj,this.c=this.B(new A.$3d),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==p.Off&&this.b<=f}}e.$Bj=u;class d extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...b){this.f(p.Trace)&&this.g(p.Trace,l([f,...b],!0))}debug(f,...b){this.f(p.Debug)&&this.g(p.Debug,l([f,...b]))}info(f,...b){this.f(p.Info)&&this.g(p.Info,l([f,...b]))}warn(f,...b){this.f(p.Warning)&&this.g(p.Warning,l([f,...b]))}error(f,...b){if(this.f(p.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(p.Error,l(P))}else this.g(p.Error,l([f,...b]))}flush(){}}e.$Cj=d;class c extends u{constructor(f=e.$zj){super(),this.setLevel(f),this.g=!R.$i}trace(f,...b){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}debug(f,...b){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}info(f,...b){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...b):console.log(`[main ${h()}]`,f,...b))}warn(f,...b){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,f,...b):console.warn(`[main ${h()}]`,f,...b))}error(f,...b){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,f,...b):console.error(`[main ${h()}]`,f,...b))}flush(){}}e.$Dj=c;class y extends u{constructor(f=e.$zj,b=!0){super(),this.g=b,this.setLevel(f)}trace(f,...b){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...b):console.log(f,...b))}debug(f,...b){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...b):console.log(f,...b))}info(f,...b){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...b):console.log(f,...b))}warn(f,...b){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...b):console.log(f,...b))}error(f,...b){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...b):console.error(f,...b))}flush(){}}e.$Ej=y;class i extends u{constructor(f,b=e.$zj){super(),this.g=f,this.setLevel(b)}trace(f,...b){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(f),...b])}debug(f,...b){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(f),...b])}info(f,...b){this.f(p.Info)&&this.g.log(p.Info,[this.h(f),...b])}warn(f,...b){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(f),...b])}error(f,...b){this.f(p.Error)&&this.g.log(p.Error,[this.h(f),...b])}h(f){return typeof f=="string"?f:(0,O.$Zi)(f,this.f(p.Trace))}flush(){}}e.$Fj=i;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const b of this.g)b.setLevel(f);super.setLevel(f)}trace(f,...b){for(const P of this.g)P.trace(f,...b)}debug(f,...b){for(const P of this.g)P.debug(f,...b)}info(f,...b){for(const P of this.g)P.info(f,...b)}warn(f,...b){for(const P of this.g)P.warn(f,...b)}error(f,...b){for(const P of this.g)P.error(f,...b)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$Gj=o;class n extends L.$Tc{constructor(f,b,P){if(super(),this.h=f,this.j=b,this.b=new I.$Ac,this.c=this.B(new A.$3d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$3d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$3d),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,g.$Qf)(f)?[...this.b.values()].find(b=>b.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,b){const P=this.n(f),N=(0,g.$Qf)(f)?f:b?.id??(0,j.$3i)(P.toString()).toString(16);let F=this.b.get(P)?.logger;const M=b?.logLevel==="always"?p.Trace:b?.logLevel;F||(F=this.s(P,M??this.getLogLevel(P)??this.h,{...b,id:N}));const U={logger:F,info:{resource:P,id:N,logLevel:M,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(P,U),F}n(f){return(0,g.$Qf)(f)?(0,k.$Pg)(this.j,`${f}.log`):f}setLogLevel(f,b){if(C.URI.isUri(f)){const P=f,N=b,F=this.b.get(P);F&&N!==F.info.logLevel&&(F.info.logLevel=N===this.h?void 0:N,F.logger?.setLevel(N),this.b.set(F.info.resource,F),this.f.fire([P,N]))}else{this.h=f;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,b){const P=this.m(f);P&&b!==!P.info.hidden&&(P.info.hidden=!b,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,b]))}getLogLevel(f){let b;return f&&(b=this.b.get(f)?.info.logLevel),b??this.h}registerLogger(f){const b=this.b.get(f.resource);b?b.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const b=this.b.get(f);b&&(b.logger&&b.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Hj=n;class s{constructor(){this.onDidChangeLogLevel=new A.$3d().event}setLevel(f){}getLevel(){return p.Info}trace(f,...b){}debug(f,...b){}info(f,...b){}warn(f,...b){}error(f,...b){}critical(f,...b){}dispose(){}flush(){}}e.$Ij=s;class t extends s{}e.$Jj=t;function r(w){if(w.verbose)return p.Trace;if(typeof w.logLevel=="string"){const f=v(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.$zj}e.$Kj=r;function a(w){switch(w){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$Lj=a;function v(w){switch(w){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$Mj=v,e.$Nj=new S.$tj("logLevel",a(p.Info))}),define(le[198],he([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,O,A,j,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;let S=class extends j.$Tc{constructor(h,$){super(),this.a=h,this.b=$,this.B(new O.$oh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$Mg)(this.a.logsHome),$=(0,R.$Og)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,l=(await k.Promises.readdir($)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==h),u=l.slice(0,Math.max(0,l.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(d=>k.Promises.rm((0,I.$jc)($,d)))))}catch(h){(0,A.$1)(h)}}};e.$tac=S,e.$tac=S=ye([K(0,g.$ji),K(1,C.$wj)],S)}),define(le[99],he([0,1,7,4,8]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=void 0,e.$Op=(0,A.$ci)("IExtensionSignatureVerificationService");let L=class{constructor(R){this.b=R}c(){return this.a||(this.a=new Promise((R,k)=>se(["node-vsce-sign"],async g=>R(g),k))),this.a}async verify(R,k,g){let C;try{C=await this.c()}catch(S){return this.b.error("Could not load vsce-sign module",(0,O.$0)(S)),!1}return C.verify(R,k,g)}};e.$Pp=L,e.$Pp=L=ye([K(0,j.$wj)],L)}),define(le[199],he([0,1,17,6,7,3,2,16,50,8]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class C extends I.$Tc{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new L.$3d),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$3d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new A.$ah(0)),this.w=[],this.y=this.B(new A.$ah(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(m,h):this.z(m,h)}n(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive,correlationId:h.correlationId},p=(0,O.$Ub)(this.j,$);return this.r(),(0,I.$Rc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,j.$1)(m))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,k.$qq)(h)),h=>this.G(h),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,k.$mq)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,k.$mq)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,h){const $={path:this.H(m),excludes:h.excludes,includes:h.includes,recursive:!1,correlationId:h.correlationId},p=(0,O.$Ub)(this.w,$);return this.C(),(0,I.$Rc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,j.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,k.$qq)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,R.$hc)(m.fsPath)}}e.$uq=C}),define(le[200],he([0,1,17,6,14,26,3,53,61,2,48,23,100,20,47,159,11,98,8,7]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let y=class extends g.$Tc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$3d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$3d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$3d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$3d),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$3d),this.Y=this.B(new I.$3d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$3d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new A.$lh)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new E.$Sk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await A.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,h.$Tg)(o))throw new E.$Uk((0,p.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new d.$bb;throw s.message=(0,p.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,E.$Fk)(n)||(0,E.$Ck)(n)||(0,E.$Gk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,E.$Fk)(n)||(0,E.$Ck)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,E.$Pk)(s)===E.FileSystemProviderErrorCode.FileNotFound?new E.$Uk((0,p.localize)(2,null,this.sb(o)),1):(0,E.$Nk)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,v=n?.resolveMetadata,w=await s.stat(o);let f;return this.t(s,o,w,void 0,!!v,(b,P)=>(f||(f=C.$ii.forUris(()=>!t),f.set(o,!0),r&&f.fill(!0,r)),f.get(b.resource)||f.findSuperstr(b.resource.with({query:null,fragment:null}))?!0:b.isDirectory&&a?P===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:n,name:v.basename(n),isFile:(s.type&E.FileType.File)!==0,isDirectory:(s.type&E.FileType.Directory)!==0,isSymbolicLink:(s.type&E.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&E.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&E.FilePermission.Locked),etag:(0,E.$6k)({mtime:s.mtime,size:s.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const f=await o.readdir(n),b=await A.Promises.settled(f.map(async([P,N])=>{try{const F=v.joinPath(n,P),M=r?await o.stat(F):{type:N};return await this.t(o,F,M,f.length,r,a)}catch(F){return this.b.trace(F),null}}));w.children=(0,O.$Hb)(b)}catch(f){this.b.trace(f),w.children=[]}return w}return w}async resolveAll(o){return A.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new E.$Uk((0,p.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=j.$qe.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new E.$Rk(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,E.$Ik)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...s,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,E.$Ck)(t)&&!(n instanceof j.$qe))if((0,$.$ce)(n)){const f=await(0,$.$je)(n,3);f.ended?w=j.$qe.concat(f.buffer):w=f}else w=(0,$.$ge)(n,f=>j.$qe.concat(f),3);else w=n;!(0,E.$Fk)(t)||(0,E.$Ck)(t)&&w instanceof j.$qe||(0,E.$Ck)(t)&&(0,E.$Ik)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof j.$qe?(0,j.$Be)(w):w),this.r.fire(new E.$Rk(o,4))}catch(v){throw new E.$Uk((0,p.localize)(4,null,this.sb(o),(0,E.$Nk)(v).toString()),(0,E.$Qk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,p.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,p.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,p.localize)(7,null,this.sb(n)));if(t)throw new Error((0,p.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&E.FileType.Directory)throw new E.$Uk((0,p.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==E.$5k&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,E.$6k)({mtime:s.mtime,size:a.size}))throw new E.$Uk((0,p.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const v=await this.C(o,n,s,t);r(v)}catch(v){a(v)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,j.$Ce)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new L.$ae(t);let a=s;(0,E.$Hk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const v=this.J(n,a).then(f=>f,f=>{throw r.dispose(!0),f});let w;try{return typeof a?.etag=="string"&&a.etag!==E.$5k&&await v,a?.atomic&&(0,E.$Hk)(o)||!((0,E.$Fk)(o)||(0,E.$Gk)(o))||(0,E.$Ck)(o)&&a?.preferUnbuffered?w=this.I(o,n,a):(0,E.$Gk)(o)?w=this.G(o,n,r.token,a):w=this.H(o,n,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(f){throw w&&await(0,$.$he)(w),this.F(f,n,a)}}F(o,n,s){const t=(0,p.localize)(11,null,this.sb(n),(0,E.$Nk)(o).toString());return o instanceof E.$Wk?new E.$Wk(t,o.stat,s):o instanceof E.$Vk?new E.$Vk(t,o.fileOperationResult,o.size,o.options):new E.$Uk(t,(0,E.$Qk)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,$.$ne)(r,{data:a=>a instanceof j.$qe?a:j.$qe.wrap(a),error:a=>this.F(a,n,t)},a=>j.$qe.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,j.$Ge)();return(0,l.$kq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,$.$ee)(r=>j.$qe.concat(r));return(async()=>{try{let r;s?.atomic&&(0,E.$Hk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(j.$qe.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new E.$Uk((0,p.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==E.$5k&&n.etag===s.etag)throw new E.$Wk((0,p.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new E.$Vk((0,p.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$Rk(o,a==="move"?2:3,v)),v}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),v=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new E.$Rk(o,a==="copy"?3:2,v)),v}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,n,s,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,E.$Dk)(o))await o.copy(n,t,{overwrite:a});else{const f=await this.resolve(n);f.isDirectory?await this.P(o,f,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,E.$Fk)(o)&&(0,E.$Fk)(s))return this.jb(o,n,s,t);if((0,E.$Fk)(o)&&(0,E.$Ck)(s))return this.pb(o,n,s,t);if((0,E.$Ck)(o)&&(0,E.$Fk)(s))return this.nb(o,n,s,t);if((0,E.$Ck)(o)&&(0,E.$Ck)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await A.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let v=!1;if(o===s){const{providerExtUri:f,isPathCaseSensitive:b}=this.R(o);if(b||(v=f.isEqual(n,t)),v&&r==="copy")throw new Error((0,p.localize)(15,null,this.sb(n),this.sb(t)));if(!v&&f.isEqualOrParent(t,n))throw new Error((0,p.localize)(16,null,this.sb(n),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new E.$Uk((0,p.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:f}=this.R(o);if(f.isEqualOrParent(n,t))throw new Error((0,p.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const n=this.S(o);return{providerExtUri:n?h.$Fg:h.$Hg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new E.$Rk(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&E.FileType.Directory))throw new Error((0,p.localize)(19,null,this.sb(n)));break}catch(r){if((0,E.$Pk)(r)!==E.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,E.$Pk)(a)!==E.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,p.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,p.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,p.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new E.$Uk((0,p.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,p.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,E.$Jk)(s)&&!t?.atomic){const w=s.enforceAtomicDelete?.(o);w&&(t={...n,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new E.$Rk(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,E.$Ek)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,E.$Dk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const v=await this.bb(o,n);t?(0,g.$Oc)(v):r=()=>(0,g.$Oc)(v)}catch(v){this.b.error(v)}})();const a=n.correlationId;if(typeof a=="number"){const v=s.add(new I.$3d);return s.add(this.X.event(f=>{f.correlates(a)&&v.fire(f)})),{onDidChange:v.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,R.$3i)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,$.$ce)(t)||(0,$.$de)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,E.$Nk)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,$.$de)(s)){if(s.buffer.length>0){const a=j.$qe.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,v)=>{(0,$.$ie)(r,{onData:async w=>{r.pause();try{await this.gb(o,n,w,w.byteLength,t,0)}catch(f){return v(f)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let v=0;for(;v<t;){const w=await o.write(n,r+v,s.buffer,a+v,t-v);v+=w}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof j.$qe?r=t:(0,$.$ce)(t)?r=await(0,j.$Ce)(t):(0,$.$de)(t)?r=await(0,j.$De)(t):r=(0,j.$Ae)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const v=j.$qe.alloc(this.a);let w=0,f=0,b=0;do b=await o.read(r,w,v.buffer,f,v.byteLength-f),await this.gb(s,a,v,b,w,f),w+=b,f+=b,f===v.byteLength&&(f=0);while(b>0)}catch(v){throw(0,E.$Nk)(v)}finally{await A.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,j.$qe.wrap(a),a.byteLength,0,0)}catch(a){throw(0,E.$Nk)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,j.$Ce)(this.H(o,n,L.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new E.$Uk((0,p.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&E.FilePermission.Readonly)throw new E.$Uk((0,p.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$lq=y,e.$lq=y=c=ye([K(0,u.$wj)],y)}),define(le[201],he([0,1,54,270,6,35,14,3,49,2,16,5,20,47,31,162,11,98,199,38,195,194]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0,(()=>{try{(0,A.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$Zi)(o)}`)}})();class i extends u.$uq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$Ac(t=>m.$Gg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:E.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$Pg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=E.FileType.Unknown:n.isFile()?t=E.FileType.File:n.isDirectory()?t=E.FileType.Directory:t=E.FileType.Unknown,s&&(t|=E.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new j.$bh;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,h.$ee)(a=>I.$qe.concat(a.map(v=>I.$qe.wrap(v))).buffer);return(0,l.$kq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$Pg)((0,m.$Og)(n),`${(0,m.$Mg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(v){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const v=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,E.$Mk)((0,p.localize)(0,null),E.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,E.$Mk)((0,p.localize)(1,null),E.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(v){throw await this.gb(n,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,E.$Ak)(s)&&!t&&(a=await this.O(n));let v;try{if((0,E.$Ak)(s)&&s.unlock)try{const{stat:f}=await $.SymlinkSupport.stat(r);f.mode&128||await $.Promises.chmod(r,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let w;if((0,E.$Ak)(s)){if(S.$i)try{await $.Promises.truncate(r,0),w="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}w||(w="w")}else w="r";v=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,E.$Ak)(s)?await this.gb(n,w):this.fb(w)}if(this.U.set(v,0),(0,E.$Ak)(s)&&this.X.set(v,n),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await $.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Z(n,s);let w=null;try{w=(await $.Promises.read(n,t,r,a,v)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(n,v,w)}return w}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,j.$wh)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const v=this.Z(n,s);let w=null;try{w=(await $.Promises.write(n,t,r,a,v)).bytesWritten}catch(f){throw await this.gb(this.X.get(n),f)}finally{this.$(n,v,w)}return w}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${s.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async bb(n,s,t,r){const a=this.H(n),v=this.H(s);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$cg)(a,v,!0)),w){if(t==="copy")throw(0,E.$Mk)((0,p.localize)(4,null),E.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const b=await this.L(n);if(!b)throw(0,E.$Mk)((0,p.localize)(5,null),E.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(s);if(P){if(!r)throw(0,E.$Mk)((0,p.localize)(6,null),E.FileSystemProviderErrorCode.FileExists);b.type&E.FileType.File&&P.type&E.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,k.$cg)(r,a,!v))return;const w=new g.$Sc;try{w.add(await this.O(n)),w.add(await this.O(s)),t&&await $.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(f)}finally{w.dispose()}}t(n,s,t){return new c.$Bq(r=>n(r),r=>s(r),t)}F(n,s,t){return new y.$Jq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof E.$Lk)return n;let s=n,t;switch(n.code){case"ENOENT":t=E.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=E.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=E.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=E.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=E.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=E.FileSystemProviderErrorCode.Unknown;break;default:t=E.FileSystemProviderErrorCode.Unknown}return(0,E.$Mk)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===E.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,E.$Mk)(s,E.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Kq=i}),define(le[101],he([0,1,3,2,4,8]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0,e.$Sac=(0,j.$ci)("sharedProcessLifecycleService");let I=class extends A.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new O.$3d),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Tac=I,e.$Tac=I=ye([K(0,L.$wj)],I)}),define(le[202],he([0,1,9,3,8,2]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=void 0;class I extends j.$Hj{constructor(S,m,h,$,p){super(m,h,$),this.r=S,this.t=p,this.B(p.listen("onDidChangeLogLevel",S)(E=>{(0,j.$yj)(E)?super.setLogLevel(E):super.setLogLevel(O.URI.revive(E[0]),E[1])})),this.B(p.listen("onDidChangeVisibility",S)(([E,l])=>super.setVisibility(O.URI.revive(E),l))),this.B(p.listen("onDidChangeLoggers",S)(({added:E,removed:l})=>{for(const u of E)super.registerLogger({...u,resource:O.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new j.$Fj({log:(S,m)=>{this.t.call("consoleLog",[S,m])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,m){super.setLogLevel(S,m),this.t.call("setLogLevel",[S,m])}setVisibility(S,m){super.setVisibility(S,m),this.t.call("setVisibility",[this.n(S),m])}s(S,m,h){return new R(this.t,S,m,h,this.r)}static setLogLevel(S,m,h){return S.call("setLogLevel",[m,h])}}e.$Jr=I;class R extends j.$Cj{constructor(S,m,h,$,p){super($?.logLevel==="always"),this.r=S,this.s=m,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[m,$,p]).then(()=>{this.u(this.n),this.m=!0})}g(S,m){const h=[[S,m]];this.m?this.u(h):this.n.push(...h)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,m){this.a=S,this.b=m}listen(S,m){const h=this.b(S);switch(m){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(p=>this.c(p,h)),removed:[...$.removed].map(p=>this.c(p,h))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,$=>(0,j.$yj)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${m}`)}async call(S,m,h){const $=this.b(S);switch(m){case"setLogLevel":return(0,j.$yj)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(O.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,$)))}throw new Error(`Call not found: ${m}`)}c(S,m){return{...S,resource:m.transformOutgoingURI(S.resource)}}}e.$Kr=k;class g extends L.$Tc{constructor(S,m){super(),m.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const $ of h)S.registerLogger({...$,resource:O.URI.revive($.resource)})}),this.B(m.listen("onDidChangeVisibility")(([h,$])=>S.setVisibility(O.URI.revive(h),$))),this.B(m.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const p of h)S.registerLogger({...p,resource:O.URI.revive(p.resource)});for(const p of $)S.deregisterLogger(p.resource)}))}}e.$Lr=g}),define(le[203],he([0,1,2,8]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;class j extends O.$Tc{constructor(I,R=[]){super(),this.a=new A.$Gj([I,...R]),this.B(I.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...R){this.a.trace(I,...R)}debug(I,...R){this.a.debug(I,...R)}info(I,...R){this.a.info(I,...R)}warn(I,...R){this.a.warn(I,...R)}error(I,...R){this.a.error(I,...R)}flush(){this.a.flush()}}e.$xP=j}),define(le[57],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0,e.$N$b=(0,O.$ci)("nativeHostService")}),define(le[204],he([0,1,40,56]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=void 0;let j=class{constructor(I,R){return this.windowId=I,O.ProxyChannel.toService(R.getChannel("nativeHost"),{context:I,properties:(()=>{const k=new Map;return k.set("windowId",I),k})()})}};e.$0_b=j,e.$0_b=j=ye([K(1,A.$4_b)],j)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn=(0,L.$ci)("policy");class I extends j.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$3d),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),A.Iterable.reduce(this.g.entries(),(S,[m,h])=>({...S,[m]:h}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$Un=I;class R{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Vn=R}),define(le[205],he([0,1,3,2,58]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=e.$z_b=void 0;class L{constructor(k){this.b=k,this.a=new A.$Sc}listen(k,g){switch(g){case"onDidChange":return O.Event.map(this.b.onDidChange,C=>C.reduce((S,m)=>({...S,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$z_b=L;class I extends j.$Un{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:m}=k[C];this.f[C]=S,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const S in C){const m=C[S];m===null?this.g.delete(S):this.g.set(S,m)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$A_b=I}),define(le[102],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.context<"u"){const L=j.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(le[24],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Oj=(0,O.$ci)("productService"),e.$Pj="vscode://schemas/vscode-product"}),define(le[206],he([0,1,6,7,2,16,31,8,24]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;let g=class extends j.$Tc{constructor(S,m,h){super(),this.b=m,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new O.$oh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,L.$mc)(S),$=(0,L.$nc)(S),p=await I.Promises.readdir(h);await Promise.all(p.map(async E=>{if(E===$)return;const l=(0,L.$jc)(h,E),u=await I.Promises.stat(l);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${E}.`),I.Promises.rm(l)}))}catch(m){(0,A.$1)(m)}}};e.$qac=g,e.$qac=g=ye([K(1,k.$Oj),K(2,R.$wj)],g)}),define(le[207],he([0,1,6,7,2,16,31,15,8,24]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;let C=class extends j.$Tc{constructor(m,h,$){super(),this.b=m,this.c=h,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$oh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await I.Promises.readFile((0,L.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const d=h[u];m[`${d.hash}.${u}`]=!0}const $=(0,L.$jc)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const E=await I.Promises.readdir($);for(const u of E){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await I.Promises.rm((0,L.$jc)($,u))}const l=Date.now();for(const u of Object.keys(m)){const d=(0,L.$jc)($,u),c=await I.Promises.readdir(d);for(const y of c){if(y==="tcf.json")continue;const i=(0,L.$jc)(d,y),o=await I.Promises.stat(i);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$jc)(u,y)}`),await I.Promises.rm(i))}}}catch(m){(0,A.$1)(m)}}};e.$rac=C,e.$rac=C=ye([K(0,R.$ki),K(1,k.$wj),K(2,g.$Oj)],C)}),define(le[208],he([0,1,16,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$yF=void 0,e.$yF=(0,A.$ci)("IV8InspectProfilingService");var j;(function(L){function I(k){return!!(k.samples&&k.timeDeltas)}L.isValidProfile=I;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,O.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,O.$jc)(g,(0,O.$nc)(C.callFrame.url)));return k}L.rewriteAbsolutePaths=R})(j||(e.Utils=j={}))}),define(le[209],he([0,1,32]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class A{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:L.port,checkForPaused:!0}),k=(0,O.$yg)();return this.a.set(k,R),k}async stopProfiling(L){const I=this.a.get(L);if(!I)throw new Error(`UNKNOWN session '${L}'`);const R=await I.stop();return this.a.delete(L),R.profile}}e.$Iac=A}),define(le[41],he([0,1,127,12]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0;class j{constructor(){this.a=new Map}add(I,R){O.ok(A.$Qf(I)),O.ok(A.$Sf(R)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,R)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Rn=new j}),define(le[103],he([0,1,3,41]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn={JSONContribution:"base.contributions.json"};function j(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new O.$3d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[j(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;A.$Rn.add(e.$Sn.JSONContribution,I)}),define(le[44],he([0,1,17,3,12,149,21,103,41]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.ConfigurationScope=e.$Wn=e.EditPresentationTypes=void 0;var g;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Wn={Configuration:"base.contributions.configuration"};var C;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$Xn={properties:{},patternProperties:{}},e.$Yn={properties:{},patternProperties:{}},e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n="vscode://schemas/settings/resourceLanguage",e.$5n="vscode://schemas/settings/configurationDefaults";const S=k.$Rn.as(R.$Sn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.$3d,this.onDidSchemaChange=this.i.event,this.j=new A.$3d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$4n,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),S.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),S.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),S.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$7n.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const P of Object.keys(s[r]))v.set(P,t);const w={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const f=(0,I.$Si)(r),b={type:"object",default:w,description:L.localize(1,null,f),$ref:e.$4n,defaultDefaultValue:w,source:j.$Qf(t)?void 0:t,defaultValueSource:t};n.push(...p(r)),this.d[r]=b,this.b.properties[r]=b}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=j.$Qf(s)?s:s?.id,v=j.$Qf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$7n.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=j.$Zf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const w in a){const f=a[w];if(o&&d(w,f)){delete a[w];continue}if(f.source=n,f.defaultDefaultValue=a[w].default,this.w(w,f),e.$7n.test(w)?f.scope=void 0:(f.scope=j.$Zf(f.scope)?t:f.scope,f.restricted=j.$Zf(f.restricted)?!!s?.includes(w):f.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=i.allOf;if(v)for(const w of v)this.p(w,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Xn.properties[i]=o,o.scope){case 1:e.$Yn.properties[i]=o;break;case 2:e.$Zn.properties[i]=o;break;case 6:e.$1n.properties[i]=o;break;case 3:e.$2n.properties[i]=o;break;case 4:e.$3n.properties[i]=o;break;case 5:e.$3n.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Xn.properties[i],o.scope){case 1:delete e.$Yn.properties[i];break;case 2:delete e.$Zn.properties[i];break;case 6:delete e.$1n.properties[i];break;case 3:delete e.$2n.properties[i];break;case 4:case 5:delete e.$3n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$4n};this.w(o,n),e.$Xn.properties[o]=n,e.$Yn.properties[o]=n,e.$Zn.properties[o]=n,e.$1n.properties[o]=n,e.$2n.properties[o]=n,e.$3n.properties[o]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$4n};e.$Xn.patternProperties[e.$6n]=i,e.$Yn.patternProperties[e.$6n]=i,e.$Zn.patternProperties[e.$6n]=i,e.$1n.patternProperties[e.$6n]=i,e.$2n.patternProperties[e.$6n]=i,e.$3n.patternProperties[e.$6n]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;j.$Xf(s)&&(s=o.defaultDefaultValue,t=void 0),j.$Xf(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$6n=`^(${h})+$`,e.$7n=new RegExp(e.$6n);function p(y){const i=[];if(e.$7n.test(y)){let o=$.exec(y);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=$.exec(y)}}return(0,O.$Mb)(i)}e.$8n=p;function E(y){return y.reduce((i,o)=>`${i}[${o}]`,"")}e.$9n=E;function l(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0n=l;const u=new m;k.$Rn.add(e.$Wn.Configuration,u);function d(y,i){return y.trim()?e.$7n.test(y)?L.localize(7,null,y):u.getConfigurationProperties()[y]!==void 0?L.localize(8,null,y):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,y,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$$n=d;function c(){const y=[],i=u.getConfigurationProperties();for(const o of Object.keys(i))y.push([o,i[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$_n=c}),define(le[76],he([0,1,17,3,34,2,35,30,12,9,21,44,41]),function(se,e,O,A,j,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;function h(o){return Object.isFrozen(o)?o:R.$Gn(o)}class ${constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const t=new p("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Qi)(this.contents,n):this.contents}inspect(n,s){const t=this;return{get value(){return h(t.rawConfiguration.getValue(n))},get override(){return s?h(t.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return h(s?t.rawConfiguration.override(s).getValue(n):t.rawConfiguration.getValue(n))},get overrides(){const r=[];for(const{contents:a,identifiers:v,keys:w}of t.rawConfiguration.overrides){const f=new $(a,w).getValue(n);f!==void 0&&r.push({identifiers:v,value:f})}return r.length?h(r):void 0}}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Qi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Fn(this.contents),t=R.$Fn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const w of v.overrides){const[f]=t.filter(b=>O.$ub(b.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=O.$Mb(f.keys)):t.push(R.$Fn(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new $(s,r,t,a.every(v=>v instanceof $)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Fn(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&k.$Sf(n[t])&&k.$Sf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Fn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Fn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Pi)(this.contents,n),S.$7n.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$ub(t.identifiers,(0,S.$8n)(n))),1))}j(n,s,t){(0,C.$Oi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$7n.test(n)&&this.overrides.push({identifiers:(0,S.$8n)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ni)(this.contents[n],r=>console.error(r))})}}e.$ao=$;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$Zf(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(n,s);this.b=new $(t,r,a,w?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function w(b){Array.isArray(r)?r.push(b):t!==null&&(r[t]=b)}const f={onObjectBegin:()=>{const b={};w(b),a.push(r),r=b,t=null},onObjectProperty:b=>{t=b},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const b=[];w(b),a.push(r),r=b,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(b,P,N)=>{v.push({error:b,offset:P,length:N})}};if(n)try{j.$tn(n,f),s=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return s}h(n,s){const t=m.$Rn.as(S.$Wn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Ni)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),v=Object.keys(n),w=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const f in n)if(S.$7n.test(f)&&t){const b=this.i(n[f],s,!1,r);v[f]=b.raw,a=a||b.hasExcludedProperties,w.push(...b.restricted)}else{const b=s[f],P=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&w.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(P===void 0||r.scopes===void 0||r.scopes.includes(P))&&!(r.skipRestricted&&b?.restricted))?v[f]=n[f]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(S.$7n.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,S.$8n)(r),keys:Object.keys(a),contents:(0,C.$Ni)(a,s)})}return t}}e.$bo=p;class E extends L.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new A.$3d),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$co=E;class l{constructor(n,s,t,r,a,v,w,f,b,P,N,F,M){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=f,this.i=b,this.j=P,this.k=N,this.l=F,this.m=M}get value(){return h(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,t,r,a=new $,v=new $,w=new I.$Ac,f=new $,b=new I.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=f,this.m=b,this.a=null,this.b=new I.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,w=new Set;for(const f of r.overrides)for(const b of f.identifiers)r.getOverrideValue(n,b)!==void 0&&w.add(b);return new l(n,s,r.getValue(n),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=y(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,S.$8n)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),f=[...w.filter(b=>v.indexOf(b)===-1),...v.filter(b=>w.indexOf(b)===-1),...v.filter(b=>!R.$Jn(this.c.override(a).getValue(b),n.override(a).getValue(b)))];t.push([a,f])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=y(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=y(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:v,overrides:w}=y(t,s),f=[...r,...a,...v];return(f.length||!t)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=y(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),v=this.w(n.workspace),w=n.folders.reduce((f,b)=>(f.set(g.URI.revive(b[0]),this.w(b[1])),f),new I.$Ac);return new u(s,t,r,a,new $,v,w,new $,new I.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$do=u;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,I.$xc)(s,a,new Set);v.forEach(f=>w.add(f))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$eo=d;class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const w=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,f=this.g.getValue(n,s,this.h);return!R.$Jn(w,f)}return!0}}e.$fo=c;function y(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=n?.getAllOverrideIdentifiers()||[];if(n){const f=w.filter(b=>!v.includes(b));for(const b of f)a.push([b,n.getKeysForOverrideIdentifier(b)])}if(o){const f=v.filter(b=>!w.includes(b));for(const b of f)a.push([b,o.getKeysForOverrideIdentifier(b)])}if(n&&o){for(const f of v)if(w.includes(f)){const b=i({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$Qi)(n.contents,a),w=(0,C.$Qi)(o.contents,a);R.$Jn(v,w)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[210],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$io=e.$ho=e.$go=void 0;class m extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new A.$3d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$ao}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Rn.as(k.$Wn.Configuration).onDidUpdateConfiguration(({properties:E,defaultsOverrides:l})=>this.c(Array.from(E),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(E,l){this.h(E,S.$Rn.as(k.$Wn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:E})}f(){return{}}g(){this.b=new R.$ao;const E=S.$Rn.as(k.$Wn.Configuration).getConfigurationProperties();this.h(Object.keys(E),E)}h(E,l){const u=this.f();for(const d of E){const c=u[d],y=l[d];c!==void 0?this.b.addValue(d,c):y?this.b.addValue(d,y.default):this.b.removeValue(d)}}}e.$go=m;class h{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new R.$ao}async initialize(){return this.configurationModel}}e.$ho=h;let $=class extends j.$Tc{get configurationModel(){return this.b}constructor(E,l,u){super(),this.c=E,this.f=l,this.g=u,this.a=this.B(new A.$3d),this.onDidChangeConfiguration=this.a.event,this.b=new R.$ao}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(E=>this.j(E))),this.B(this.c.onDidChangeConfiguration(async({properties:E})=>this.m(await this.h(E),!0))),this.b}async h(E){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",E);const l={},u=[],d=S.$Rn.as(k.$Wn.Configuration).getConfigurationProperties();for(const c of E){const y=d[c];if(!y){u.push(c);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}u.push(c),l[y.policy.name]={type:y.type}}}return(0,I.$4f)(l)||await this.f.updatePolicyDefinitions(l),u}j(E){this.g.trace("PolicyConfiguration#onDidChangePolicies",E);const l=S.$Rn.as(k.$Wn.Configuration).getPolicyConfigurations(),u=(0,O.$Hb)(E.map(d=>l.get(d)));this.m(u,!0)}m(E,l){this.g.trace("PolicyConfiguration#update",E);const u=S.$Rn.as(k.$Wn.Configuration).getConfigurationProperties(),d=[],c=this.b.isEmpty();for(const y of E){const i=u[y]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,L.$Jn)(this.b.getValue(y),o))&&d.push([y,o])}else this.b.getValue(y)!==void 0&&d.push([y,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const y=this.b;this.b=new R.$ao;for(const i of y.keys)this.b.setValue(i,y.getValue(i));for(const[i,o]of d)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);l&&this.a.fire(this.b)}}};e.$io=$,e.$io=$=ye([K(1,C.$Tn),K(2,g.$wj)],$)}),define(le[211],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,210,58]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=void 0;class l extends k.$Tc{constructor(c,y,i,o){super(),this.m=c,this.h=this.B(new L.$3d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$go),this.c=i instanceof E.$Vn?new p.$ho:this.B(new p.$io(this.b,i,o)),this.f=this.B(new h.$co(this.m,{},S.$Gg,y)),this.a=new h.$do(this.b.configurationModel,this.c.configurationModel,new h.$ao,new h.$ao),this.j=new u(c,y,this),this.g=this.B(new A.$oh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,y,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new h.$do(c,y,new h.$ao,i)}getConfigurationData(){return this.a.toData()}getValue(c,y){const i=typeof c=="string"?c:void 0,o=(0,m.$Ji)(c)?c:(0,m.$Ji)(y)?y:{};return this.a.getValue(i,o,void 0)}async updateValue(c,y,i,o,n){const s=(0,m.$Ki)(i)?i:(0,m.$Ji)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$Jn)(y,r.defaultValue)&&(y=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const v=s.overrideIdentifiers.sort(),w=this.a.localUserConfiguration.overrides.find(f=>(0,O.$ub)([...f.identifiers].sort(),v));w&&(s.overrideIdentifiers=w.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,$.$9n)(s.overrideIdentifiers),c]:[c];await this.j.write(a,y),await this.reloadConfiguration()}inspect(c,y={}){return this.a.inspect(c,y,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const y=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,y,2)}r(c,y){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,y);this.t(o,i,7)}s(c){const y=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,y,7)}t(c,y,i){const o=new h.$fo(c,{data:y},this.a);o.source=i,this.h.fire(o)}}e.$jo=l;class u{constructor(c,y,i){this.b=c,this.c=y,this.d=i,this.a=new A.$jh}write(c,y){return this.a.queue(()=>this.e(c,y))}async e(c,y){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,I.$mn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,y);i=(0,R.$En)(i,n),await this.c.writeFile(this.b,j.$qe.fromString(i))}f(c,y,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!y.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,R.$Bn)(c,y,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const y=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});y&&typeof y=="string"&&y!=="auto"&&(c=y),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[212],he([0,1,14,3,2,68]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1sb=e.$Zsb=e.$Ysb=e.$Xsb=void 0;const I=(g,C,S)=>{const m=new Uint8Array(16);for(let p=0;p<16;p++)m[p]=Math.round(Math.random()*256);const h=(0,O.$Ke)(O.$qe.wrap(m));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$Xsb=I,e.$Ysb=O.$qe.fromString(`\r
\r
`);async function R(g,C,S,m,h){g.write(O.$qe.fromString((0,e.$Xsb)(C,S,m)));const $=new j.$Sc;try{return await new Promise((p,E)=>{let l;$.add(g.onData(u=>{l?l=O.$qe.concat([l,u],l.byteLength+u.byteLength):l=u;const d=l.indexOf(e.$Ysb);if(d===-1)return;p(g),g.pauseData();const c=l.slice(d+e.$Ysb.byteLength);c.byteLength&&h.onData.fire(c)})),$.add(g.onClose(u=>E(u??new Error("socket closed")))),$.add(g.onEnd(()=>E(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{$.dispose()}}e.$Zsb=R;class k extends j.$Tc{constructor(C,S){super(),this.g=C,this.a=this.B(new A.$6d),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new A.$3d),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(m=>this.a.fire(m))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){L.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$1sb=k}),define(le[213],he([0,1,7,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.RemoteAuthorityResolverErrorCode=e.$gl=e.$fl=e.RemoteConnectionType=e.$el=void 0,e.$el=(0,A.$ci)("remoteAuthorityResolverService");var j;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(j||(e.RemoteConnectionType=j={}));class L{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$fl=L;class I{constructor(S,m){this.host=S,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$gl=I;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends O.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,m=R.Unknown,h){super(S),this._message=S,this._code=m,this._detail=h,this.isHandled=m===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,k.prototype)}}e.$hl=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$il=g}),define(le[77],he([0,1,23]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=void 0;function A(g){return g.scheme===O.Schemas.vscodeRemote?g.authority:void 0}e.$jl=A;function j(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$kl=j;function L(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$ll=L;function I(g){const{host:C,port:S}=k(g);if(typeof S>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:C,port:S}}e.$ml=I;function R(g,C){let{host:S,port:m}=k(g);return typeof m>"u"&&(m=C),{host:S,port:m}}e.$nl=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(le[45],he([0,1,27,4,77]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.TargetPlatform=e.ExtensionType=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0,e.$om="extensions.user.cache",e.$pm="extensions.builtin.cache",e.$qm="undefined_publisher",e.$rm=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$sm=L,e.$tm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(I||(e.ExtensionType=I={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,l){if(typeof E>"u"||E===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof E=="string"||typeof l=="string"){const u=typeof E=="string"?E:E.value,d=typeof l=="string"?l:l.value;return O.$hf(u,d)}return E._lower===l._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.$um=k;class g{get size(){return this.c.size}constructor(E){if(this.c=new Set,E)for(const l of E)this.add(l)}add(E){this.c.add(k.toKey(E))}delete(E){return this.c.delete(k.toKey(E))}has(E){return this.c.has(k.toKey(E))}}e.$vm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(E){this.c.delete(k.toKey(E))}get(E){return this.c.get(k.toKey(E))}has(E){return this.c.has(k.toKey(E))}set(E,l){this.c.set(k.toKey(E),l)}values(){return this.c.values()}forEach(E){this.c.forEach(E)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wm=C;function S(p){return m(p)}e.$xm=S;function m(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$ym=m;function h(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$zm=h;function $(p,E){if(E){const l=`onResolveRemoteAuthority:${(0,j.$kl)(E)}`;return!!p.activationEvents?.includes(l)}return!1}e.$Am=$,e.$Bm=(0,A.$ci)("IBuiltinExtensionsScannerService")}),define(le[214],he([0,1,2,45,11]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class L extends O.$Tc{constructor(R,k,g,C,S){super(),this.a=R,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,A.$om))}catch(k){(0,j.$Qk)(k)!==1&&this.f.error(k)}}}e.$eq=L}),define(le[215],he([0,1,6,14,26,7,3,2,100,63,32,68,213,77]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.PersistentConnectionEventType=e.$ul=e.$tl=e.$sl=e.ConnectionType=void 0;const $=30*1e3;var p;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function E(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(z){const D=new j.$ae;return setTimeout(()=>D.cancel(),z),D.token}function u(z,D){if(z.isCancellationRequested||D.isCancellationRequested)return j.CancellationToken.Cancelled;const T=new j.$ae;return z.onCancellationRequested(()=>T.cancel()),D.onCancellationRequested(()=>T.cancel()),T.token}class d{get didTimeout(){return this.c==="timedout"}constructor(D){this.c="pending",this.d=new R.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,O.$8g)(),D.isCancellationRequested?this.h():this.d.add(D.onCancellationRequested(()=>this.h()))}registerDisposable(D){this.c==="pending"?this.d.add(D):D.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const D=new Error("Time limit reached");return D.code="ETIMEDOUT",D.syscall="connect",D}resolve(D){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(D))}reject(D){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(D))}}function c(z,D){const T=new d(D);return T.registerDisposable(z.onControlMessage(B=>{const q=JSON.parse(B.toString()),X=V(q);X?T.reject(X):T.resolve(q)})),T.promise}function y(z,D,T,B,q,X,_,ie){const J=new d(ie),ne=g.$Yd.create(!1);return z.info(`Creating a socket (${_})...`),k.mark(`code/willCreateSocket/${X}`),D.connect(T,B,q,_).then(ce=>{J.didTimeout?(k.mark(`code/didCreateSocketError/${X}`),z.info(`Creating a socket (${_}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(k.mark(`code/didCreateSocketOK/${X}`),z.info(`Creating a socket (${_}) was successful after ${ne.elapsed()} ms.`),J.resolve(ce))},ce=>{k.mark(`code/didCreateSocketError/${X}`),z.info(`Creating a socket (${_}) returned an error after ${ne.elapsed()} ms.`),z.error(ce),J.reject(ce)}),J.promise}function i(z,D){const T=new d(D);return z.then(B=>{T.didTimeout||T.resolve(B)},B=>{T.didTimeout||T.reject(B)}),T.promise}async function o(z,D,T,B){const q=ae(z,D);z.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let X;try{X=await y(z.logService,z.remoteSocketFactoryService,z.connectTo,(0,h.$ll)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,E(D),`renderer-${E(D)}-${z.reconnectionToken}`,B)}catch(ce){throw z.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let _,ie;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(X,null),_=z.reconnectionProtocol,ie=!1):(_=new S.$3h({socket:X}),ie=!0),z.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const J=await i(z.signService.createNewMessage((0,C.$yg)()),B),ne={type:"auth",auth:z.connectionToken||"00000000000000000000",data:J.data};_.sendControl(A.$qe.fromString(JSON.stringify(ne)));try{const ce=await c(_,u(B,l(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(z.logService.trace(`${q} 4/6. received SignRequest control message.`),!await i(z.signService.validate(J,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(z.signService.sign(ce.data),B),me={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:D};return T&&(me.args=T),z.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(A.$qe.fromString(JSON.stringify(me))),{protocol:_,ownsProtocol:ie}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${q} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${q} received error control message when negotiating connection. Error:`),z.logService.error(ce)),ie&&H(_),ce}}async function n(z,D,T,B){const q=Date.now(),X=ae(z,D),{protocol:_,ownsProtocol:ie}=await o(z,D,T,B),J=new d(B);return J.registerDisposable(_.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),fe=V(ce);fe?(z.logService.error(`${X} received error control message when negotiating connection. Error:`),z.logService.error(fe),ie&&H(_),J.reject(fe)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${W(q)}!`),J.resolve({protocol:_,firstMessage:ce}))})),J.promise}async function s(z,D){const{protocol:T}=await n(z,1,void 0,D);return{protocol:T}}async function t(z,D,T){const{protocol:B,firstMessage:q}=await n(z,2,D,T),X=q&&q.debugPort;return{protocol:B,debugPort:X}}async function r(z,D,T){const B=Date.now(),q=ae(z,3),{protocol:X}=await o(z,3,D,T);return z.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${W(B)}!`),X}async function a(z,D,T){const{connectTo:B,connectionToken:q}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:q,reconnectionToken:D,reconnectionProtocol:T,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function v(z,D,T){return f(z,async B=>{const{protocol:q}=await s(B,j.CancellationToken.None);return new G(z,D,T,B.reconnectionToken,q)})}e.$sl=v;async function w(z,D){return f(z,async T=>{const{protocol:B,debugPort:q}=await t(T,D,j.CancellationToken.None);return new Z(z,D,T.reconnectionToken,B,q)})}e.$tl=w;async function f(z,D){for(let B=1;;B++)try{const q=(0,C.$yg)(),X=await a(z,q,null);return await D(X)}catch(q){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(q);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(q),x.triggerPermanentFailure(0,0,m.$hl.isHandled(q)),q}}async function b(z,D,T){const B=await a(z,(0,C.$yg)(),null);return await r(B,{host:D,port:T},j.CancellationToken.None)}e.$ul=b;function P(z){return(0,O.$2g)(D=>new Promise((T,B)=>{const q=setTimeout(T,z*1e3);D.onCancellationRequested(()=>{clearTimeout(q),T()})}))}var N;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class F{constructor(D,T){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.type=0}}e.$vl=F;class M{constructor(D,T,B,q){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.durationSeconds=B,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$wl=M;class U{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=2}}e.$xl=U;class Y{constructor(D,T,B){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.type=4}}e.$yl=Y;class Q{constructor(D,T,B,q){this.reconnectionToken=D,this.millisSinceLastIncomingData=T,this.attempt=B,this.handled=q,this.type=3}}e.$zl=Q;class x extends R.$Tc{static triggerPermanentFailure(D,T,B){this._permanentFailure=!0,this.f=D,this.g=T,this.h=B,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(D=>D.y())}static debugPauseSocketWriting(){this.j.forEach(D=>D.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(D,T,B,q,X){super(),this.t=D,this.u=T,this.reconnectionToken=B,this.protocol=q,this.w=X,this.m=this.B(new I.$3d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(q.onSocketClose(_=>{const ie=ee(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(_=>{const ie=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const _=x.j.indexOf(this);_>=0&&x.j.splice(_,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const D=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${D} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const T=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const q=B<T.length?T[B]:T[T.length-1];try{if(q>0){const _=P(q);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,_)),this.u.logService.info(`${D} waiting for ${q} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${D} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${D} resolving connection...`);const X=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${D} connecting to ${X.connectTo}...`),await this.G(X,l($)),this.u.logService.info(`${D} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${D} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${D} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(m.$hl.isTemporarilyNotAvailable(X)){this.u.logService.info(`${D} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${D} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,L.$4)(X)){this.u.logService.info(`${D} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof m.$hl){this.u.logService.error(`${D} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,m.$hl.isHandled(X));break}this.u.logService.error(`${D} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(D,T,B){this.w?x.triggerPermanentFailure(D,T,B):this.D(D,T,B)}D(D,T,B){this.m.fire(new Q(this.reconnectionToken,D,T,B)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Al=x;class G extends x{constructor(D,T,B,q,X){super(1,D,q,X,!0),this.client=this.B(new S.$1h(X,{remoteAuthority:T,clientId:B},D.ipcLogger))}async G(D,T){await s(D,T)}}e.$Bl=G;class Z extends x{constructor(D,T,B,q,X){super(2,D,B,q,!1),this.H=T,this.debugPort=X}async G(D,T){await t(D,this.H,T)}}e.$Cl=Z;function H(z){try{z.acceptDisconnect();const D=z.getSocket();z.dispose(),D.dispose()}catch(D){(0,L.$1)(D)}}function V(z){if(z&&z.type==="error"){const D=new Error(`Connection error: ${z.reason}`);return D.code="VSCODE_CONNECTION_ERROR",D}return null}function te(z,D){for(;z.length<D;)z+=" ";return z}function oe(z,D){return`[remote-connection][${te(E(z),13)}][${D.substr(0,5)}\u2026]`}function ee(z,D,T){return`${oe(z,D)}[${T?"reconnect":"initial"}]`}function ae(z,D){return`${ee(D,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function W(z){return`${Date.now()-z} ms`}}),define(le[104],he([0,1,2,4]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=void 0,e.$ol=(0,A.$ci)("remoteSocketFactoryService");class j{constructor(){this.a={}}register(I,R){return this.a[I]??=[],this.a[I].push(R),(0,O.$Rc)(()=>{const k=this.a[I]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[I]?.splice(k,1)})}b(I){return(this.a[I.type]||[]).find(k=>k.supports(I))}connect(I,R,k,g){const C=this.b(I);if(!C)throw new Error(`No socket factory found for ${I}`);return C.connect(I,R,k,g)}}e.$pl=j}),define(le[216],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=e.$Fac=void 0,e.$Fac=(0,O.$ci)("sharedProcessTunnelService"),e.$Gac="sharedProcessTunnel"}),define(le[105],he([0,1,4,164]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=e.$Pac=e.$Oac=e.$Nac=e.$Mac=e.TunnelStates=e.$Lac=e.$Kac=void 0,e.$Kac=(0,O.$ci)("IRemoteTunnelService"),e.$Lac={active:!1};var j;(function(L){L.disconnected=I=>({type:"disconnected",onTokenFailed:I}),L.connected=(I,R)=>({type:"connected",info:I,serviceInstallFailed:R}),L.connecting=I=>({type:"connecting",progress:I}),L.uninitialized={type:"uninitialized"}})(j||(e.TunnelStates=j={})),e.$Mac="remote.tunnels.access",e.$Nac=e.$Mac+".hostNameOverride",e.$Oac=e.$Mac+".preventSleep",e.$Pac="remoteTunnelService",e.$Qac=(0,A.localize)(0,null)}),define(le[59],he([0,1,14,7,2,166,44,4,8,41]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=void 0,e.$qp=(0,R.$ci)("requestService");class C{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?y[i]="*****":y[i]=this.b[i];this.a=y}return this.a}}class S extends j.$Tc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,L.localize)(0,null),when:k.$Nj.isEqualTo((0,k.$Lj)(k.LogLevel.Trace)).serialize()})}async c(y,i,o){const n=`${y} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,A.$0)(s)),s}}}e.$rp=S;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.$sp=m;function h(c){return c.res.statusCode===204}e.$tp=h;async function $(c){return h(c)?null:(await(0,O.$Ce)(c.stream)).toString()}e.$up=$;async function p(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return $(c)}e.$vp=p;async function E(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(h(c))return null;const i=(await(0,O.$Ce)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$wp=E;function l(c){d(c)}e.$xp=l;let u;function d(c){const y=g.$Rn.as(I.$Wn.Configuration),i=u;u={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[u],remove:i?[i]:[]})}d(1)}),define(le[217],he([0,1,26,23,11,59]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=void 0;let I=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=O.CancellationToken.None){if(k.scheme===A.Schemas.file||k.scheme===A.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},m=await this.a.request(S,C);if(m.res.statusCode===200)await this.b.writeFile(g,m.stream);else{const h=await(0,L.$vp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$MP=I,e.$MP=I=ye([K(0,L.$qp),K(1,j.$zk)],I)}),define(le[218],he([0,1,14,26]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class j{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=A.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:m})=>{const h=await(0,O.$Ce)(m);return[{statusCode:S.statusCode,headers:S.headers},h]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$tr=j;class L{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,O.$Ee)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ur=L}),define(le[219],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=e.$$$b=e.$0$b=void 0,e.$0$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$$$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$_$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[220],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(j){try{const L=await this.c();if(L){const I=String(O.a++);return this.b.set(I,L),{id:I,data:L.createNewMessage(j)}}}catch{}return{id:"",data:j}}async validate(j,L){if(!j.id)return!0;const I=this.b.get(j.id);if(!I)return!1;this.b.delete(j.id);try{return I.validate(L)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(j){try{return await this.d(j)}catch{}return j}}e.$67b=O}),define(le[106],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql="signService",e.$rl=(0,O.$ci)(e.$ql)}),define(le[221],he([0,1,220]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;class A extends O.$67b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(I=>new I.signer().sign(L))}h(){return new Promise((L,I)=>se(["vsda"],L,I))}}e.$Z_b=A}),define(le[78],he([0,1,3,2]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Gb=e.$1Gb=e.$ZGb=e.$YGb=void 0;class j extends A.$Tc{constructor(S,m,h){super(),this.a=S,this.b=m,this.c=h}async getItems(){const S={profile:this.b,workspace:this.c},m=await this.a.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.b,workspace:this.c};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.a.call("updateItems",m)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class L extends j{constructor(S,m){super(S,m,void 0),this.f=this.B(new O.$3d),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class I extends L{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$YGb=I;class R extends L{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.$ZGb=R;class k extends j{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$1Gb=k;class g{constructor(S){this.a=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$2Gb=g}),define(le[107],he([0,1,5,37,32]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=void 0;function L(k){if(O.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function I(k,g,C,S,m,h,$,p,E){const l=Object.create(null);l["common.machineId"]=h,l["common.sqmId"]=$,l.sessionID=(0,j.$yg)()+Date.now(),l.commitHash=S,l.version=m,l["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,O.$h)(O.$u),l["common.nodePlatform"]=A.$dc,l["common.nodeArch"]=C,l["common.product"]=E||"desktop",p&&(l["common.msftInternal"]=p);let u=0;const d=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),O.$l&&(l["common.snap"]="true");const c=L(g);return c&&(l["common.platformDetail"]=c),l}e.$So=I;function R(k){const g=A.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$To=R}),define(le[22],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=void 0,e.$Dl=(0,O.$ci)("telemetryService"),e.$El=(0,O.$ci)("customEndpointTelemetryService"),e.$Fl="telemetry.currentSessionDate",e.$Gl="telemetry.firstSessionDate",e.$Hl="telemetry.lastSessionDate",e.$Il="telemetry.machineId",e.$Jl="telemetry.sqmId",e.$Kl="telemetry",e.$Ll="telemetry.telemetryLevel",e.$Ml="telemetry.enableCrashReporter",e.$Nl="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var j;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(le[222],he([0,1,36,6,34,23,16,5,9,143,31,146,95,11,24,22]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=e.$cs=void 0;const E=new Map;async function l(i,o){const n=`${i}::${o.join(":")}`,s=E.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(b,P,N,F){const M=P.substring(b.length+1);return A.Promises.withAsyncBody(async U=>{let Y;try{Y=await C.Promises.readdir(P,{withFileTypes:!0})}catch{U();return}if(F.count>=v){F.count+=Y.length,F.maxReached=!0,U();return}let Q=Y.length;if(Q===0){U();return}let x=Y;F.count+Y.length>v&&(F.maxReached=!0,Q=v-F.count,x=Y.slice(0,Q)),F.count+=Y.length;for(const G of x)if(G.isDirectory()){if(N.includes(G.name)||await w(b,(0,I.$jc)(P,G.name),N,F),--Q===0){U();return}}else{const Z=G.name.lastIndexOf(".");if(Z>=0){const H=G.name.substring(Z+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of t)H.relativePathPattern?.test(M)!==!1&&H.filePattern.test(G.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--Q===0){U();return}}})}const f=A.Promises.withAsyncBody(async b=>{const P={count:0,maxReached:!1};await w(i,i,o,P);const N=await c(i);b({configFiles:u(a),fileTypes:u(r),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:N})});return E.set(n,f),f}e.$cs=l;function u(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function d(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/h.$8k.GB).toFixed(2)}GB (${(O.freemem()/h.$8k.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$hn.value()*100)}%`},o=O.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$ds=d;async function c(i){try{const o=new Map,n=(0,I.$jc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,j.$mn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,j.$vn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return u(o)}catch{return[]}}e.$es=c;let y=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/h.$8k.GB).toFixed(2)}GB (${(O.freemem()/h.$8k.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$hn.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$bs)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(v=>{if((0,m.$Tm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const f=v.workspaceMetadata[w];let b=`${f.fileCount} files`;f.maxFilesReached&&(b=`more than ${b}`),r+=`|    Folder (${w}): ${b}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=d(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${O.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,n){const s=[];return(0,S.$bs)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$Tm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),s.push(`Folder (${a}): ${w}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(f,b)=>{const P=` ${f}(${b})`;t+P.length>60?(n.push(a),a="|                 ",t=a.length):t+=P.length,a+=P};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let f=0;f<w;f++){const b=o.fileTypes[f];r(b.name,b.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(b=>{const P=b.count>1?` ${b.name}(${b.count})`:` ${b.name}`;f+=P}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===L.Schemas.file){const v=a.fsPath;s.push(l(v,["node_modules",".git"]).then(w=>{let f=`${w.fileCount} files`;w.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,I.$nc)(v)}): ${f}`),n.push(this.h(w))}).catch(w=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/h.$8k.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(f=>this.n(o,n,s,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=k.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=k.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$fs=y,e.$fs=y=ye([K(0,p.$Dl),K(1,$.$Oj)],y)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=void 0;class O{constructor(L){this.b=L}listen(L,I){throw new Error(`Event not found: ${I}`)}call(L,I,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$c_b=O;class A{constructor(L){this.b=L}log(L,I){return this.b.call("log",{eventName:L,data:I}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$d_b=A}),define(le[46],he([0,1,30,12,77,107,22]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0;class R{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Uo=R;class k{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Vo=k,e.$Wo=new k;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$Xo=g,e.$Yo="telemetry",e.$Zo="extensionTelemetryLog",e.$1o={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.$2o=C;function S(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$3o=S;function m(i){const o=i.getValue(I.$Ll),n=i.getValue(I.$Ml);if(i.getValue(I.$Nl)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$4o=m;function h(i){const o={},n={},s={};E(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.$5o=h;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const o=(0,j.$kl)(i);return $.has(o)?o:"other"}e.$6o=p;function E(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,O.$Kn)(r):r instanceof Date?o[a]=r.toISOString():(0,A.$Sf)(r)?n<2?E(r,o,n+1,a+"."):o[a]=(0,O.$Kn)(r):o[a]=r}}function l(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,L.$To)(n)||s}e.$7o=l;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$8o=u;function d(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const v of o)for(;;){const w=v.exec(i);if(!w)break;s.push([w.index,v.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const v=r.exec(i);if(!v)break;const w=s.some(([f,b])=>v.index<b&&f<r.lastIndex);!t.test(v[0])&&!w&&(n+=i.substring(a,v.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function y(i,o){return(0,O.$Hn)(i,n=>{if(n instanceof R||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=d(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}e.$9o=y}),define(le[33],he([0,1,27,29,45,5,9,7,37,46]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$cf)(n.id,s.id)===0}e.$0o=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=S.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$$o=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=h.exec(n);return s&&s[1]?[E(s[1]),s[2]]:[E(n),void 0]}e.$_o=$;function p(n,s){return`${n}.${s}`}e.$ap=p;function E(n){return n.toLowerCase()}e.$bp=E;function l(n,s){return E(p(n??j.$qm,s))}e.$cp=l;function u(n,s){const t=[],r=a=>{for(const v of t)if(v.some(w=>C(s(w),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$dp=u;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$ep=d;function c(n){return{id:new g.$Uo(n.identifier.id),name:new g.$Uo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$fp=c,e.$gp=new j.$um("pprice.better-merge");function y(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(w=>C(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$hp=y;async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,A.$Eo)(t?"alpine":L.$u,k.$ec);return s.debug("ComputeTargetPlatform:",r),r}e.$ip=o}),define(le[223],he([0,1,17,2,20,9,11,24,6,3,16,5,37,33]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0b=e.$a0b=void 0;let $=class extends A.$Tc{constructor(d,c){super(),this.b=d,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,y])=>this.a.set(y.configPath,y))}getConfigBasedTips(d){return this.f(d)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(d){const c=[];for(const[y,i]of this.a)if(!(i.configScheme&&i.configScheme!==d.scheme))try{const o=(await this.b.readFile((0,j.$Pg)(d,y))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$a0b=$,e.$a0b=$=ye([K(0,I.$zk),K(1,R.$Oj)],$);const p="extensionTips/promptedExecutableTips",E="extensionTips/lastPromptedMediumImpExeTime";class l extends ${constructor(d,c,y,i,o,n,s,t){super(s,t),this.r=d,this.s=c,this.t=y,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],f=[];Object.entries(a.recommendations).forEach(([b,P])=>{P.important?a.important?v.push({extensionId:b,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):w.push({extensionId:b,extensionName:P.name,isExtensionPack:!!P.isExtensionPack}):f.push({extensionId:b,extensionName:P.name,isExtensionPack:!!P.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,k.$eh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const d=await this.O(this.g),c=await this.O(this.h);return[...d,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const d=await this.O(this.g),c=await this.O(this.h),y=await this.u.getInstalled();this.m=this.D(d,y),this.n=this.D(c,y)}D(d,c){const y=new Map;d.forEach(t=>y.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...y.keys()],c);for(const t of i){const r=y.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=y.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=y.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[d,c]=[...this.m.entries()][0];this.H(c).then(y=>{switch(y){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(d);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new A.$Uc);i.value=(0,k.$eh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const d=this.I(),c=Date.now()-d,y=7*24*60*60*1e3;if(c<y){const n=this.B(new A.$Uc);n.value=(0,k.$eh)(()=>{n.dispose(),this.G()},y-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new A.$Uc);s.value=(0,k.$eh)(()=>{s.dispose(),this.G()},y);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new A.$Uc);s.value=(0,k.$eh)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(d){const c=await this.u.getInstalled(1),y=d.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,h.$0o)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:y,source:3,name:d[0].exeFriendlyName,searchValue:`@exe:"${d[0].exeName}"`})}I(){let d=this.w.getNumber(E,-1);return d||(d=Date.now(),this.J(d)),d}J(d){this.w.store(E,d,-1,1)}L(){return JSON.parse(this.w.get(p,-1,"{}"))}M(d,c){const y=this.L();y[d]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(p,JSON.stringify(y),-1,0)}N(d,c){const y=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return d.forEach(n=>{o.has(n.toLowerCase())?y.push(n):i.push(n)}),{installed:y,uninstalled:i}}async O(d){const c=[],y=new Map;for(const i of d.keys()){const o=d.get(i);if(!o||!(0,O.$Lb)(o.recommendations))continue;const n=[];S.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",i)),n.push((0,C.$jc)("/usr/bin",i)),n.push((0,C.$jc)(this.r.fsPath,i)));for(const s of n){let t=y.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),y.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return c}}e.$b0b=l}),define(le[224],he([0,1,26,33]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k1b=void 0;async function j(L,I,R,k,g){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const S=await L.getInstalled(1);for(const[m,h]of Object.entries(C.deprecated)){if(!h?.extension)continue;const{id:$,autoMigrate:p,preRelease:E}=h.extension;if(!p)continue;const l=S.find(d=>(0,A.$0o)(d.identifier,{id:m}));if(!l)continue;const u=(await I.getExtensions([{id:$,preRelease:E}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!u){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${$}' extension...`);const d=!k.getDisabledExtensions().some(y=>(0,A.$0o)(y,l.identifier));await L.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let c=S.find(y=>(0,A.$0o)(y.identifier,{id:$}));(!c||!c.isPreReleaseVersion&&d)&&(c=await L.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),d||(await k.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,A.$ap)(l.manifest.publisher,l.manifest.name),(0,A.$ap)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${$}' extension.`)}catch(d){g.error(d)}}}catch(C){g.error(C)}}e.$k1b=j}),define(le[225],he([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;let c=class extends j.$Tc{static{d=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,I.$Pg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new $.$Jo(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(w){this.r.error(w)}throw new $.$Jo(S.$Up,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Wf)(o)?o:!0}async u(i){await this.g;const o=(0,I.$Pg)(this.extensionsDownloadDir,`${this.z(i)}${d.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new $.$Jo(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==L.Schemas.file){await n(o);return}const s=(0,I.$Pg)(this.extensionsDownloadDir,`.${(0,g.$yg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,A.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(d.c))s.push(a.resource);else{const v=p.$$o.parse(a.name);v&&n.push([v,a])}const t=(0,p.$dp)(n,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await O.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?p.$$o.create(i).toString().toLowerCase():(0,g.$yg)()}};e.$bq=c,e.$bq=c=d=ye([K(0,h.$ki),K(1,l.$zk),K(2,$.$Io),K(3,m.$Ii),K(4,E.$Op),K(5,u.$wj)],c)}),define(le[226],he([0,1,3,2,35,33,45]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class R extends A.$Tc{constructor(g,C,S,m,h,$,p){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=h,this.n=$,this.r=p,this.a=this.B(new O.$3d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$3c),this.s().then(null,E=>p.error(E))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,A.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const m of g.extensions){const h=this.L(m.identifier,m.version);g.error?this.I(h,g.profileLocation):(this.J(h,g.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),S.push(this.f.scanInstalledExtensionAtLocation(m.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",m.location.toString())},$=>this.r.error($)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(m){this.r.error(m)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],m=await this.j.scanProfileExtensions(g),h=new Set,$=new Set;for(const[p,E]of this.b)E.has(g)&&$.add(p);for(const p of m){const E=this.L(p.identifier,p.version);h.add(E),$.has(E)||(C.push(p.identifier),this.I(E,g))}for(const p of $)if(!h.has(p)){const E=this.M(p);E&&(S.push(E.identifier),this.J(p,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new j.$Bc(m=>this.m.extUri.getComparisonKey(m))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${I.$um.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,L.$_o)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$fq=R}),define(le[227],he([0,1,43,46]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;async function j(L,I,R,k,g,C,S){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,A.$2o)(I,R)&&(0,A.$4o)(k)===3){const h=await(0,O.$Jp)(R,g,C);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=S.machineId||h}return m}e.$Kp=j}),define(le[228],he([0,1,73,17,6,2,23,16,31,15,29,33,8,75,9]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;let p=class extends h.$rr{constructor(d,c,y,i){super(y),this.h=d,this.j=i,this.g=this.B(new E(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(d,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[d];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),c=Object.keys(d).map(y=>{const i=d[y];return{...this.f(y,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((y,i)=>y.label.localeCompare(i.label)),c}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const c=await this.g.getLanguagePacks();Object.keys(c).some(y=>c[y]&&c[y].extensions.some(i=>(0,S.$0o)(i.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(c);return!(0,A.$ub)(Object.keys(d),Object.keys(y))}};e.$sr=p,e.$sr=p=ye([K(0,C.$Lo),K(1,g.$ki),K(2,C.$Io),K(3,m.$wj)],p);let E=class extends L.$Tc{constructor(d,c){super(),this.j=c,this.c={},this.f=(0,R.$jc)(d.userDataPath,"languagepacks.json"),this.g=new j.$jh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(c=>{Object.keys(c).forEach(y=>delete c[y]),this.m(c,...d)}).then(()=>this.c)}m(d,...c){for(const y of c)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(d,y);Object.keys(d).forEach(y=>this.r(d[y]))}n(d,c){const y=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===I.Schemas.file&&l(o)){let n=d[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},d[o.languageId]=n);const s=n.extensions.filter(t=>(0,S.$0o)(t.extensionIdentifier,y))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:y,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,R.$jc)(c.location.fsPath,t.path)}}r(d){if(d){const c=(0,O.createHash)("md5");for(const y of d.extensions)c.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);d.hash=c.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let c=null;return k.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(c=d(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>c,y=>this.j.error(y))})}};E=ye([K(0,g.$ki),K(1,m.$wj)],E);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const d of u.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(le[229],he([0,1,142,7,30,46]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kP=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,m){const h=await(0,O.$qD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,O.$qD)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new h.AppInsightsCore,E=new $.PostChannel,l={instrumentationKey:C,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(m){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};l.extensionConfig[E.identifier]=u}return p.initialize(l,[]),p.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),p}class g{constructor(S,m,h,$,p){this.e=S,this.f=m,this.g=h,this.h=p,this.c=I,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(m=>{S(m)},m=>{(0,A.$1)(m),console.error(m)})}}log(S,m){if(!this.a)return;m=(0,j.$In)(m,this.g),m=(0,L.$5o)(m);const h=this.f+"/"+S;try{this.i($=>{$.pluginVersionString=m?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$kP=g}),define(le[109],he([0,1,2,167,15,8,24,46]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=void 0;let k=class extends O.$Tc{constructor(C,S,m,h,$=""){super(),this.b=$;const p=S.getLogger(R.$Yo);if(p)this.a=this.B(p);else{const l=(0,R.$3o)(h,m)?" (Not Sent)":"",u=()=>(0,R.$2o)(h,m)&&C.getLevel()===L.LogLevel.Trace;this.a=this.B(S.createLogger(R.$Yo,{name:(0,A.localize)(0,null,l),hidden:!u()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$Yo,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$5o)(S))}};e.$A9b=k,e.$A9b=k=ye([K(0,L.$wj),K(1,L.$xj),K(2,j.$ji),K(3,I.$Oj)],k)}),define(le[110],he([0,1,2,30,5,27,168,21,44,102,24,41,22,46]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,d){this.k=u,this.l=d,this.d={},this.i=new O.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,L.$Ve)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ve)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$Ll)||c.affectsConfiguration(m.$Nl)||c.affectsConfiguration(m.$Ml))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$4o)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const d=u.usage?3:u.error?2:0;l=Math.min(l,d)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,d){this.g<u||(d=(0,A.$In)(d,this.d),d=(0,h.$9o)(d,this.j),d=(0,A.$In)(d,this.c),this.b.forEach(c=>c.log(l,d)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$yr=$,e.$yr=$=ye([K(1,R.$Ii),K(2,C.$Oj)],$);function p(){const E=(0,I.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=j.$o?"":(0,I.localize)(3,null),d=(0,I.localize)(4,null),c=(0,I.localize)(5,null),y=(0,I.localize)(6,null),i=(0,I.localize)(7,null),o=`
|       | ${d} | ${c} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${E} ${l} ${u}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}S.$Rn.as(k.$Wn.Configuration).registerConfiguration({id:m.$Kl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[m.$Ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Rn.as(k.$Wn.Configuration).registerConfiguration({id:m.$Kl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[m.$Nl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${m.$Ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[230],he([0,1,14,26,271,229]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=void 0;async function I(C,S){const m=await S.request(C,A.CancellationToken.None),h=(await(0,O.$Ce)(m.stream)).toString(),$=m.res.statusCode??200;return{headers:m.res.headers,statusCode:$,responseData:h}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((h,$)=>{const p=j.request(C.url??"",S,E=>{E.on("data",function(l){h({headers:E.headers,statusCode:E.statusCode??200,responseData:l.toString()})}),E.on("error",function(l){$(l)})});p.write(C.data,E=>{E&&$(E)}),p.end()})}async function k(C,S,m){const h=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),$={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:h};try{const p=C?await I($,C):await R($);m(p.statusCode,p.headers,p.responseData)}catch{m(0,{})}}class g extends L.$kP{constructor(S,m,h,$,p){const E={sendPOST:(l,u)=>{k(S,l,u)}};super(m,h,$,p,E)}}e.$lP=g}),define(le[231],he([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;let m=class{constructor($,p,E,l,u,d){this.b=$,this.c=p,this.d=E,this.e=l,this.f=u,this.g=d,this.a=new Map}h($){if(!this.a.has($.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const E=[$.id,JSON.stringify(p),$.aiKey],u=new A.$Aq(O.$wg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:E,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new g.$d_b(u),new C.$A9b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new S.$yr({appenders:d,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,p,E){this.h($).publicLog(p,E)}publicLogError($,p,E){this.h($).publicLogError(p,E)}};e.$xac=m,e.$xac=m=ye([K(0,j.$Ii),K(1,k.$Dl),K(2,I.$wj),K(3,I.$xj),K(4,L.$ji),K(5,R.$Oj)],m)}),define(le[79],he([0,1,3,9,21,4,8]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.ProvidedOnAutoForward=e.$Lv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Kv=e.$Jv=void 0,e.$Jv=(0,L.$ci)("tunnelService"),e.$Kv=(0,L.$ci)("sharedTunnelsService");var R;(function(l){l.Http="http",l.Https="https"})(R||(e.TunnelProtocol=R={}));var k;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(k||(e.TunnelPrivacyId=k={}));function g(l){return!!l.forwardPort}e.$Lv=g;var C;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(C||(e.ProvidedOnAutoForward=C={}));function S(l,{checkQuery:u=!0}={}){if(l.scheme!=="http"&&l.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(d)return{address:d[1],port:+d[2]};if(!l.query||!u)return;const c=l.query.split("&");for(const y of c){const i=y.split("=")[1];if(/^https?:/.exec(i)){const o=S(A.URI.parse(i));if(o)return o}}}e.$Mv=S,e.$Nv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(l){return e.$Nv.indexOf(l)>=0}e.$Ov=m,e.$Pv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function h(l){return e.$Pv.indexOf(l)>=0}e.$Qv=h;function $(l,u,d,c){if(d===1)return!1;if(d===2&&h(u)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(y?.length===4&&parseInt(y[1])>=18)return!1}return l<1024}e.$Rv=$;class p{constructor(u,d,c){this.remoteAddress=u,this.localAddress=d,this.b=c,this.a=new O.$3d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sv=p;let E=class{constructor(u,d){this.k=u,this.l=d,this.a=new O.$3d,this.onTunnelOpened=this.a.event,this.b=new O.$3d,this.onTunnelClosed=this.b.event,this.c=new O.$3d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const u=this.l.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.i=u.privacyOptions,this.h=u.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const u=[],d=Array.from(this.e.values());for(const c of d){const y=Array.from(c.values());for(const i of y){const o=await i.value;o&&typeof o!="string"&&u.push(o)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:d}of u.values())await d.then(c=>typeof c!="string"?c?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,d,c,y,i){this.q(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:c,privacy:y,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(h(u)||m(u))&&(u=e.$Nv[0]);const c=this.s(u,d);if(c)return++c.refcount,c.value}openTunnel(u,d,c,y,i,o=!1,n,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${i}.`);const t=this.f??u;if(!t)return;if(d||(d="localhost"),y||(y=this.m),this.f&&this.j.has(c)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.t(t,d,c,y,i,o,n,s);return r?r.then(a=>{if(a){if(typeof a=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,c),a}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,c);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.o(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==c)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&a.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}o(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this.e.get(u.tunnelRemoteHost);if(d){const c=d.get(u.tunnelRemotePort);c&&(c.refcount--,await this.p(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async p(u,d,c){if(c.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const y=c.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(d),y}}async closeTunnel(u,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const c=this.e.get(u);if(c&&c.has(d)){const y=c.get(d);y.refcount=0,await this.p(u,d,y)}}q(u,d,c){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(d,{refcount:1,value:c})}async r(u,d){const c=this.e.get(u);if(c){const y=c.get(d),i=y?await y.value:void 0;(!i||typeof i=="string")&&c.delete(d),c.size===0&&this.e.delete(u)}}s(u,d){const c=[u];m(u)?(c.push(...e.$Nv),c.push(...e.$Pv)):h(u)&&c.push(...e.$Pv);const y=c.map(i=>this.e.get(i));for(const i of y){const o=i?.get(d);if(o)return o}}canTunnel(u){return!!S(u)}u(u,d,c,y,i,o,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${y}.`);const s=c;this.j.add(s);const t=y===void 0?c:y,r={elevationRequired:i?this.isPortPrivileged(t):!1},a={remoteAddress:{host:d,port:c},localAddressPort:y,privacy:o,public:o?o!==k.Private:void 0,protocol:n},v=u.forwardPort(a,r);return v?(this.q(d,c,v),v.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),v}};e.$Tv=E,e.$Tv=E=ye([K(0,I.$wj),K(1,j.$Ii)],E)}),define(le[232],he([0,1,8,79,2,7,6]),function(se,e,O,A,j,L,I){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class k extends j.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$zh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends j.$Tc{static{R=this}static{this.a=0}constructor(S,m){super(),this.f=S,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,m,h,$,p,E,l){const u=new k,d=await Promise.resolve(this.f.openTunnel(S,u,h,$,p,E,l));if(!d||typeof d=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${$} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),u.dispose(),await d.dispose(),(0,L.$6)();return u.setTunnel(d),this.b.set(m,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${d.localAddress} (local) to ${h}:${$} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(S,m){const h=this.b.get(S);h&&h.setAddress(m)}async destroyTunnel(S){const m=this.b.get(S);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await m.dispose();return}this.c.add(S)}};e.$Hac=g,e.$Hac=g=R=ye([K(0,A.$Kv),K(1,O.$wj)],g)}),define(le[28],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=void 0,e.$0k=(0,O.$ci)("IUriIdentityService")}),define(le[233],he([0,1,28,186,11,20,128,3,2]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=void 0;class g{static{this._clock=0}constructor(m){this.uri=m,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new k.$Sc,this.f=2**16;const h=new Map,$=p=>{let E=h.get(p.scheme);return E===void 0&&(E=m.hasProvider(p)&&!this.g.hasCapability(p,1024),h.set(p.scheme,E)),E};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(p=>{h.delete(p.scheme)})),this.extUri=new L.$Eg($),this.d=new I.$0r((p,E)=>this.extUri.compare(p,E,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.$Qg)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new g(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort(($,p)=>$[1].time<p[1].time?1:$[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(m[$][0],m[$][1].touch())}};e.$$r=C,e.$$r=C=ye([K(0,j.$zk)],C),(0,A.$8r)(O.$0k,C,1)}),define(le[234],he([0,1,3,2,11,48,35]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=void 0;class R extends A.$Tc{constructor(g,C,S,m,h,$){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=h,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$3d),this.onDidChangeFile=this.a.event,this.b=L.$ii.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Bc(p=>this.m.extUri.getComparisonKey(this.t(p))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(p=>this.s(p)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,m,h){return this.g.read(g,C,S,m,h)}write(g,C,S,m,h){return this.g.write(g,C,S,m,h)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,A.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,j.$Dk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,j.$Ek)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const m=this.u(S.resource);this.b.findSubstr(m)&&C.push({resource:m,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$3_b=R}),define(le[80],he([0,1,62]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FGb=e.$EGb=e.edit=void 0;function A(I,R,k,g){const C=(0,O.$Bn)(I,R,k,g)[0];return C&&(I=I.substring(0,C.offset)+C.content+I.substring(C.offset+C.length)),I}e.edit=A;function j(I,R,k){let g=k;for(;g>=0;){if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&I.charAt(g)===R.charAt(0))return g+2}return 0}e.$EGb=j;function L(I,R,k){let g=k;for(;g>=0;)if(I.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&I.charAt(g)===R.charAt(1)))return g;return I.length-1}e.$FGb=L}),define(le[235],he([0,1,30,55,12]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=void 0;function L(h,$,p,E,l,u){const d=[],c=[],y=[];if(!$){const U=h.filter(({identifier:Y})=>l.every(Q=>Q.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:d,removed:c,updated:y},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}h=h.map(S),$=$.map(S),p=p?p.map(S):null;const i=new Map,o=U=>{U.uuid&&i.set(U.id.toLowerCase(),U.uuid)};h.forEach(({identifier:U})=>o(U)),$.forEach(({identifier:U})=>o(U)),p?.forEach(({identifier:U})=>o(U)),E?.forEach(({identifier:U})=>o(U)),u?.forEach(U=>o(U));const n=U=>{const Y=U.identifier.uuid||i.get(U.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,Y)=>(U.set(n(Y),Y),U),t=h.reduce(s,new Map),r=$.reduce(s,new Map),a=$.reduce((U,Y)=>s(U,(0,O.$Fn)(Y)),new Map),v=p?p.reduce(s,new Map):null,w=E.reduce(s,new Map),f=l.reduce((U,Y)=>{const Q=i.get(Y.toLowerCase());return U.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)},new Set),b=u?u.reduce((U,{id:Y,uuid:Q})=>(Q=Q??i.get(Y.toLowerCase()),U.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)),new Set):null,P=I(t,r,f,!1);if(P.added.size>0||P.removed.size>0||P.updated.size>0){const U=I(v,t,f,!1),Y=I(v,r,f,!0),Q=(x,G,Z,H)=>{let V,te,oe;return G.installed?(V=H.pinned,oe=H.preRelease,V&&(te=H.version)):(V=Z.pinned,oe=Z.preRelease,V&&(te=Z.version)),V===void 0&&(V=G.pinned,V&&(te=G.version)),oe===void 0&&(oe=G.preRelease),{...H,installed:G.installed||Z.installed,pinned:V,preRelease:oe,version:te??(Z.version&&(!G.installed||A.gt(Z.version,G.version))?Z.version:G.version),state:k(G,Z,v?.get(x))}};for(const x of Y.removed.values()){const G=t.get(x);if(!G)continue;const Z=(0,j.$2f)(v?.get(x)),H=b&&!b.has(x)&&Z.installed;G.installed&&H?c.push(G.identifier):a.set(x,G)}for(const x of Y.added.values()){const G=(0,j.$2f)(r.get(x)),Z=t.get(x);if(Z){if(P.updated.has(x)){const H=Q(x,Z,G,G);R(Z,G,!1,!1)||y.push(m(H,x)),a.set(x,H)}}else G.installed&&d.push(m(G,x))}for(const x of Y.updated.values()){const G=(0,j.$2f)(r.get(x)),Z=(0,j.$2f)(v?.get(x)),H=t.get(x);if(H)if(b&&!b.has(x)&&Z.installed&&H.installed&&!G.installed)c.push(H.identifier);else{const te=Q(x,H,G,G);y.push(m(te,x)),a.set(x,te)}else G.installed&&d.push(m(G,x))}for(const x of U.added.values())Y.added.has(x)||a.set(x,(0,j.$2f)(t.get(x)));for(const x of U.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const G=(0,j.$2f)(t.get(x)),Z=(0,j.$2f)(r.get(x));a.set(x,Q(x,G,Z,G))}for(const x of U.removed.values())Y.updated.has(x)||Y.removed.has(x)||w.has(x)||(0,j.$2f)(r.get(x)).installed&&b&&(b.has(x)||!(0,j.$2f)(v?.get(x)).installed||a.delete(x))}const N=[],F=I(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((U,Y)=>N.push(m(U,Y))),{local:{added:d,removed:c,updated:y},remote:M?{added:[...F.added].map(U=>a.get(U)),updated:[...F.updated].map(U=>a.get(U)),removed:[...F.removed].map(U=>r.get(U)),all:N}:null}}e.$g8b=L;function I(h,$,p,E){const l=h?[...h.keys()].filter(i=>!p.has(i)):[],u=[...$.keys()].filter(i=>!p.has(i)),d=u.filter(i=>!l.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=l.filter(i=>!u.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),y=new Set;for(const i of l){if(c.has(i))continue;const o=h.get(i),n=$.get(i);(!n||!R(o,n,E,!0))&&y.add(i)}return{added:d,removed:c,updated:y}}function R(h,$,p,E){return!(h.disabled!==$.disabled||!!h.isApplicationScoped!=!!$.isApplicationScoped||E&&h.installed!==$.installed||h.installed&&$.installed&&(h.preRelease!==$.preRelease||h.pinned!==$.pinned||$.pinned&&h.version!==$.version)||!C(h.state,$.state)||p&&h.version!==$.version)}function k(h,$,p){const E=h.state,l=$.state,u=p?.state;if(!$.version||E&&A.gt(h.version,$.version))return E;if(l&&A.gt($.version,h.version)||!E)return l;if(!l)return E;const d=(0,O.$Fn)(E),c=u?g(u,l):{added:Object.keys(l).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},y=u?g(u,E):{added:Object.keys(E).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])d[i]=l[i];for(const i of c.removed.values())y.updated.has(i)||delete d[i];return d}function g(h,$){const p=Object.keys(h),E=Object.keys($),l=E.filter(c=>!p.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),u=p.filter(c=>!E.includes(c)).reduce((c,y)=>(c.add(y),c),new Set),d=new Set;for(const c of p){if(u.has(c))continue;const y=h[c],i=$[c];(0,O.$Jn)(y,i)||d.add(c)}return{added:l,removed:u,updated:d}}function C(h={},$={}){const{added:p,removed:E,updated:l}=g(h,$);return p.size===0&&E.size===0&&l.size===0}function S(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,$){const p={...h,identifier:{id:h.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete p.disabled,h.installed||delete p.installed,h.state||delete p.state,h.isApplicationScoped||delete p.isApplicationScoped,p}}),define(le[111],he([0,1,17,21,4]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KIb=e.$JIb=void 0,e.$JIb=(0,j.$ci)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.b().map(m=>m.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?S.push(m.substring(1)):C.push(m);return(0,O.$Mb)([...k,...C].filter(m=>!S.includes(m)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$KIb=L,e.$KIb=L=ye([K(0,A.$Ii)],L)}),define(le[236],he([0,1,17,34,30,94,80]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m8b=void 0;function R(c){return(0,A.$mn)(c)||[]}async function k(c,y,i,o,n){const s=R(c),t=R(y),r=i?R(i):null,a=[...s,...t,...r||[]].map(Q=>Q.key),v=await n.resolveUserBindings(a),w=C(s,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:y,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const f=m(s),b=m(t),P=r?m(r):null,N=$(f,b,v),F=P?$(P,f,v):{added:[...f.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},M=P?$(P,b,v):{added:[...b.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},U=g(N,F,M);let Y=c;for(const Q of U.removed.values())U.conflicts.has(Q)||(Y=u(Y,Q,o));for(const Q of U.added.values()){if(U.conflicts.has(Q))continue;const x=b.get(Q);if(x.some(G=>G.command!==`-${Q}`&&w.conflicts.has(v[G.key]))){U.conflicts.add(Q);continue}Y=l(Y,x,o)}for(const Q of U.updated.values()){if(U.conflicts.has(Q))continue;const x=b.get(Q);if(x.some(G=>G.command!==`-${Q}`&&w.conflicts.has(v[G.key]))){U.conflicts.add(Q);continue}Y=d(Y,Q,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.$m8b=k;function g(c,y,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of y.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(y.updated.has(r)?t.add(r):n.add(r));for(const r of y.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(y.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of y.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(y.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,y,i,o){const n=new Set,s=S(c,o),t=S(y,o),r=i?S(i,o):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?h(r,s):{added:[...s.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const w=r?h(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:b,updated:P,conflicts:N}=g(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:b,updated:P,conflicts:N}}function S(c,y){const i=new Map;for(const o of c){const n=y[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const y=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=y.get(o);n||(n=[],y.set(o,n)),n.push(i)}return y}function h(c,y){const i=[...c.keys()],o=[...y.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(w=>({...w,key:r})),v=y.get(r).map(w=>({...w,key:r}));(0,O.$ub)(a,v,(w,f)=>E(w,f))||t.add(r)}return{added:n,removed:s,updated:t}}function $(c,y,i){const o=[...c.keys()],n=[...y.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=c.get(a).map(f=>({...f,key:i[f.key]})),w=y.get(a).map(f=>({...f,key:i[f.key]}));p(v,w)||r.add(a)}return{added:s,removed:t,updated:r}}function p(c,y){return!(!(0,O.$ub)(c.filter(({command:i})=>i[0]!=="-"),y.filter(({command:i})=>i[0]!=="-"),(i,o)=>E(i,o))||!(0,O.$ub)(c.filter(({command:i})=>i[0]==="-"),y.filter(({command:i})=>i[0]==="-"),(i,o)=>E(i,o)))}function E(c,y){if(c.command!==y.command||c.key!==y.key)return!1;const i=L.$aj.deserialize(c.when),o=L.$aj.deserialize(y.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!j.$Jn(c.args,y.args))}function l(c,y,i){for(const o of y)c=I.edit(c,[-1],o,i);return c}function u(c,y,i){const o=R(c);for(let n=o.length-1;n>=0;n--)(o[n].command===y||o[n].command===`-${y}`)&&(c=I.edit(c,[n],void 0,i));return c}function d(c,y,i,o){const n=R(c),s=n.findIndex(t=>t.command===y||t.command===`-${y}`);for(let t=n.length-1;t>=0;t--)(n[t].command===y||n[t].command===`-${y}`)&&(c=I.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=I.edit(c,[s],i[t],o);return c}}),define(le[237],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u8b=e.$t8b=void 0;function O(L,I,R){const k={},g={},C=new Set;if(!I)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const S=A(L,I);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=A(R,L),h=A(R,I),$={},p={},E=new Set,l=new Set;for(const u of m.removed.values())h.updated.has(u)?k[u]=I[u]:E.add(u);for(const u of h.removed.values())l.has(u)||(m.updated.has(u)?l.add(u):C.add(u));for(const u of m.updated.values())l.has(u)||(h.updated.has(u)?S.updated.has(u)&&l.add(u):p[u]=L[u]);for(const u of h.updated.values())l.has(u)||(m.updated.has(u)?S.updated.has(u)&&l.add(u):L[u]!==void 0&&(g[u]=I[u]));for(const u of m.added.values())l.has(u)||(h.added.has(u)?S.updated.has(u)&&l.add(u):$[u]=L[u]);for(const u of h.added.values())l.has(u)||(m.added.has(u)?S.updated.has(u)&&l.add(u):k[u]=I[u]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:$,removed:[...E.values()],updated:p},conflicts:[...l.values()]}}e.$t8b=O;function A(L,I){const R=L?Object.keys(L):[],k=I?Object.keys(I):[],g=k.filter(m=>!R.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),C=R.filter(m=>!k.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),S=new Set;for(const m of R){if(C.has(m))continue;const h=L[m],$=I[m];h!==$&&S.add(m)}return{added:g,removed:C,updated:S}}function j(L,I){const{added:R,removed:k,updated:g}=A(L,I);return R.size===0&&k.size===0&&g.size===0}e.$u8b=j}),define(le[238],he([0,1,30]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;function A(L,I,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!I){const m=L.filter(({id:h})=>!k.includes(h));return m.length?C.added=m:C=null,{local:g,remote:C}}const S=j(L,I,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const m=j(R,L,k),h=j(R,I,k);for(const $ of h.removed){const p=L.find(E=>E.id===$);p&&g.removed.push(p)}for(const $ of h.added){const p=I.find(E=>E.id===$);m.added.includes($)?S.updated.includes($)&&g.updated.push(p):g.added.push(p)}for(const $ of h.updated)g.updated.push(I.find(p=>p.id===$));for(const $ of m.added)h.added.includes($)||C.added.push(L.find(p=>p.id===$));for(const $ of m.updated)h.removed.includes($)||h.updated.includes($)||C.updated.push(L.find(p=>p.id===$));for(const $ of m.removed){const p=I.find(E=>E.id===$);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$e0b=A;function j(L,I,R){L=L?L.filter(({id:h})=>!R.includes(h)):[],I=I.filter(({id:h})=>!R.includes(h));const k=L.map(({id:h})=>h),g=I.map(({id:h})=>h),C=g.filter(h=>!k.includes(h)),S=k.filter(h=>!g.includes(h)),m=[];for(const{id:h,name:$,shortName:p,icon:E,useDefaultFlags:l}of L){if(S.includes(h))continue;const u=I.find(d=>d.id===h);(!u||u.name!==$||u.shortName!==p||u.icon!==E||!(0,O.$Jn)(u.useDefaultFlags,l))&&m.push(h)}return{added:C,removed:S,updated:m}}}),define(le[25],he([0,1,17,12,174,44,29,4,103,41]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wob=e.$Vob=e.$Uob=e.$Tob=e.$Sob=e.$Rob=e.$Qob=e.$Pob=e.$Oob=e.$Nob=e.$Mob=e.MergeState=e.Change=e.SyncStatus=e.$Lob=e.$Kob=e.$Job=e.UserDataSyncErrorCode=e.$Iob=e.$Hob=e.$Gob=e.$Fob=e.$Eob=e.$Dob=e.$Cob=e.$Bob=e.$Aob=e.SyncResource=e.$zob=e.$yob=e.$xob=e.$wob=e.$vob=e.$uob=void 0;function C(){const t=g.$Rn.as(L.$Wn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$uob=C;function S(){const t=g.$Rn.as(L.$Wn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,O.$Mb)([...r,...a,...v])}e.$vob=S,e.$wob="settingsSync",e.$xob="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=g.$Rn.as(L.$Wn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,j.localize)(0,null),type:"object",properties:{[e.$xob]:{type:"boolean",description:(0,j.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,j.localize)(2,null),items:[{type:"string",pattern:I.$wo,errorMessage:(0,j.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,j.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Rn.as(k.$Sn.JSONContribution),v=()=>{const w=C(),f=S(),b=Object.keys(L.$Xn.properties).filter(F=>!f.includes(F)),P=f.filter(F=>!w.includes(F)),N={items:{type:"string",enum:[...b,...P.map(F=>`-${F}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>v())}e.$yob=m;function h(t){return t&&(0,A.$Sf)(t)&&(0,A.$Qf)(t.id)&&Array.isArray(t.scopes)}e.$zob=h;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Aob=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(t,...r){return t?[t,...r]:r}e.$Bob=p;function E(t,r,a,v){return v.joinPath(a.userDataSyncHome,...p(t,r,`lastSync${r}.json`))}e.$Cob=E,e.$Dob=(0,R.$ci)("IUserDataSyncStoreManagementService"),e.$Eob=(0,R.$ci)("IUserDataSyncStoreService"),e.$Fob=(0,R.$ci)("IUserDataSyncLocalStoreService"),e.$Gob="x-operation-id",e.$Hob="X-Execution-Id";function l(t){const r={};return r[e.$Hob]=t,r}e.$Iob=l;var u;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class d extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Job=d;class c extends d{constructor(r,a,v,w,f){super(r,v,void 0,f),this.url=a,this.serverCode=w}}e.$Kob=c;class y extends d{constructor(r,a){super(r,a)}}e.$Lob=y,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],f=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,f)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(d||(e.$Job=d={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Mob="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Nob=s,e.$Oob=(0,R.$ci)("IUserDataSyncEnablementService"),e.$Pob=(0,R.$ci)("IUserDataSyncService"),e.$Qob=(0,R.$ci)("IUserDataSyncResourceProviderService"),e.$Rob=(0,R.$ci)("IUserDataAutoSyncService"),e.$Sob=(0,R.$ci)("IUserDataSyncUtilService"),e.$Tob=(0,R.$ci)("IUserDataSyncLogService"),e.$Uob="userDataSync",e.$Vob="vscode-userdata-sync",e.$Wob="preview"}),define(le[239],he([0,1,30,25]),function(se,e,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Hb=void 0;function j(I,R,k,g,C){if(!R)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const S=L(I,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=k?L(k,R):{added:Object.keys(R).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},h=k?L(k,I):{added:Object.keys(I).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},p=O.$Fn(R),E=!k;for(const u of h.added.values())u!==A.$Mob&&E&&m.added.has(u)||(p[u]=I[u]);for(const u of h.updated.values())p[u]=I[u];for(const u of h.removed.values())g.unregistered.includes(u)||delete p[u];for(const u of m.added.values()){const d=R[u];if(g.machine.includes(u)){C.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(k&&h.added.has(u))continue;const c=I[u];c&&c.value===d.value||u===A.$Mob&&E&&h.added.has(u)||(c?$.updated[u]=d:$.added[u]=d)}for(const u of m.updated.values()){const d=R[u];if(g.machine.includes(u)){C.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const c=I[u];c&&c.value===d.value||($.updated[u]=d)}for(const u of m.removed.values()){if(g.machine.includes(u)){C.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||$.removed.push(u)}const l=L(R,p);return{local:$,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:p}}}e.$5Hb=j;function L(I,R){const k=Object.keys(I),g=Object.keys(R),C=g.filter(h=>!k.includes(h)).reduce((h,$)=>(h.add($),h),new Set),S=k.filter(h=>!g.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of k){if(S.has(h))continue;const $=I[h],p=R[h];O.$Jn($,p)||m.add(h)}return{added:C,removed:S,updated:m}}}),define(le[240],he([0,1,17,34,62,42,30,80,25]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LGb=e.$KGb=e.$JGb=e.$IGb=e.$HGb=e.$GGb=void 0;function g(a,v,w){let f=[];w?f=S(w):f=C(v);const b=[],P=[...(0,k.$uob)()];if(Array.isArray(f))for(const N of f)N.startsWith("-")?P.push(N.substring(1)):b.push(N);return(0,O.$Mb)([...a,...b].filter(N=>!P.includes(N)))}e.$GGb=g;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const v=(0,A.$mn)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function m(a,v){const w=(0,A.$mn)(a)||{};let f="{}";for(const b of Object.keys(w)){const P=(0,j.$Bn)(f,[b],w[b],v);f=(0,j.$En)(f,P)}return f}e.$HGb=m;function h(a,v,w,f){if(w.length){const b=r(v),P=(0,A.$mn)(v)||{},N=(0,A.$mn)(a);if(!N)return a;const F=[];for(const M of w){const U=P[M],Y=N[M];U===void 0?a=R.edit(a,[M],void 0,f):Y!==void 0?a=R.edit(a,[M],U,f):F.push(i(M,b))}F.sort((M,U)=>M.startOffset-U.startOffset),F.forEach(M=>a=u(M.setting.key,v,a,f))}return a}e.$IGb=h;function $(a,v,w,f,b,P){const N=h(a,v,f,P),F=w!==N,M=w!==v;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:h(v,a,f,P),remoteContent:null,hasConflicts:!1};if(w===null&&E(a)){const T=p(a,v,f)?null:h(v,a,f,P);return{conflictsSettings:[],localContent:T,remoteContent:null,hasConflicts:!1}}let U=a,Y=v;const Q=(0,A.$mn)(a),x=(0,A.$mn)(v),G=w?(0,A.$mn)(w):null,Z=f.reduce((T,B)=>(T.add(B),T),new Set),H=l(Q,x,Z),V=l(G,Q,Z),te=l(G,x,Z),oe=new Map,ee=new Set,ae=T=>{ee.add(T);const B=b.filter(({key:q})=>q===T)[0];B?(U=R.edit(U,[T],B.value,P),Y=R.edit(Y,[T],B.value,P)):oe.set(T,{key:T,localValue:Q[T],remoteValue:x[T]})};for(const T of V.removed.values())te.updated.has(T)?ae(T):Y=R.edit(Y,[T],void 0,P);for(const T of te.removed.values())ee.has(T)||(V.updated.has(T)?ae(T):U=R.edit(U,[T],void 0,P));for(const T of V.updated.values())ee.has(T)||(te.updated.has(T)?H.updated.has(T)&&ae(T):Y=R.edit(Y,[T],Q[T],P));for(const T of te.updated.values())ee.has(T)||(V.updated.has(T)?H.updated.has(T)&&ae(T):U=R.edit(U,[T],x[T],P));for(const T of V.added.values())ee.has(T)||(te.added.has(T)?H.updated.has(T)&&ae(T):Y=u(T,U,Y,P));for(const T of te.added.values())ee.has(T)||(V.added.has(T)?H.updated.has(T)&&ae(T):U=u(T,Y,U,P));const W=oe.size>0||!p(U,Y,f),z=W||!p(U,a,[]),D=W||!p(Y,v,[]);return{localContent:z?U:null,remoteContent:D?Y:null,conflictsSettings:[...oe.values()],hasConflicts:W}}e.$JGb=$;function p(a,v,w){if(a===v)return!0;const f=(0,A.$mn)(a),b=(0,A.$mn)(v),P=w.reduce((M,U)=>(M.add(U),M),new Set),N=r(a).filter(M=>!(M.setting&&P.has(M.setting.key))),F=r(v).filter(M=>!(M.setting&&P.has(M.setting.key)));if(N.length!==F.length)return!1;for(let M=0;M<N.length;M++){const U=N[M],Y=F[M];if(U.setting&&Y.setting){if(U.setting.key!==Y.setting.key||!I.$Jn(f[U.setting.key],b[U.setting.key]))return!1}else if(!U.setting&&!Y.setting){if(U.value!==Y.value)return!1}else return!1}return!0}function E(a){return a?r(a).length===0:!0}e.$KGb=E;function l(a,v,w){const f=a?Object.keys(a).filter(M=>!w.has(M)):[],b=Object.keys(v).filter(M=>!w.has(M)),P=b.filter(M=>!f.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),N=f.filter(M=>!b.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),F=new Set;if(a)for(const M of f){if(N.has(M))continue;const U=a[M],Y=v[M];I.$Jn(U,Y)||F.add(M)}return{added:P,removed:N,updated:F}}function u(a,v,w,f){const b=(0,A.$mn)(v),P=r(v),N=r(w),F=d(a,P,N);return c(w,a,b[a],F,N,f)}e.$LGb=u;function d(a,v,w){const f=v.findIndex(P=>P.setting?.key===a),b=v[f-1];if(b){if(b.setting){const N=i(b.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!0}}else{const N=o(f,v);if(N){const F=i(N.setting.key,w);if(F){const M=n(w.indexOf(F),w),U=s(v,N,v[f]);if(M){const Y=s(w,F,M),Q=t(U,Y);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const Y=s(w,F,w[w.length-1]),Q=t(U,Y);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const P=v[f+1];if(P)if(P.setting){const N=i(P.setting.key,w);if(N)return{index:w.indexOf(N),insertAfter:!1}}else{const N=n(f,v);if(N){const F=i(N.setting.key,w);if(F){const M=o(w.indexOf(F),w),U=s(v,v[f],N);if(M){const Y=s(w,M,F),Q=t(U.reverse(),Y.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const Y=s(w,w[0],F),Q=t(U.reverse(),Y.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function c(a,v,w,f,b,P){let N;return f.index===-1?N=(0,j.$Bn)(a,[v],w,P):N=y(a,v,w,f,b,P).map(F=>(0,j.$Cn)(a,F,P)[0]),(0,j.$En)(a,N)}function y(a,v,w,f,b,P){const N=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,F=(0,L.$yn)(P,a),M=b[f.index];if(f.insertAfter){const U=[];if(M.setting)U.push({offset:M.endOffset,length:0,content:","+N});else{const Y=n(f.index,b),Q=o(f.index,b),x=Q?.setting?.commaOffset;Q&&x===void 0&&U.push({offset:Q.endOffset,length:0,content:","});const G=x!==void 0&&x>M.endOffset;U.push({offset:G?x+1:M.endOffset,length:0,content:Y?F+N+",":F+N})}return U}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const U=(b[f.index-1]&&!b[f.index-1].setting?F:"")+N+(n(f.index,b)?",":"")+F;return[{offset:M.startOffset,length:0,content:U}]}}function i(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function n(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function s(a,v,w){const f=a.indexOf(v),b=a.indexOf(w);return a.filter((P,N)=>f<N&&N<b)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,f,b;const P={onObjectBegin:N=>{w++},onObjectProperty:(N,F,M)=>{w===0&&(f=F,b=N)},onObjectEnd:(N,F)=>{w--,w===0&&v.push({startOffset:f,endOffset:N+F,value:a.substring(f,N+F),setting:{key:b,commaOffset:void 0}})},onArrayBegin:(N,F)=>{w++},onArrayEnd:(N,F)=>{w--,w===0&&v.push({startOffset:f,endOffset:N+F,value:a.substring(f,N+F),setting:{key:b,commaOffset:void 0}})},onLiteralValue:(N,F,M)=>{w===0&&v.push({startOffset:f,endOffset:F+M,value:a.substring(f,F+M),setting:{key:b,commaOffset:void 0}})},onSeparator:(N,F,M)=>{if(w===0&&N===","){let U=v.length-1;for(;U>=0&&!v[U].setting;U--);const Y=v[U];Y&&v.splice(U,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:F}})}},onComment:(N,F)=>{w===0&&v.push({startOffset:N,endOffset:N+F,value:a.substring(N,N+F)})}};return(0,A.$tn)(a,P),v}}),define(le[81],he([0,1,3,2,4,25]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rGb=e.$qGb=void 0,e.$qGb=(0,j.$ci)("IUserDataSyncAccountService");let I=class extends A.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new O.$3d),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$3d),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$rGb=I,e.$rGb=I=ye([K(0,L.$Eob),K(1,L.$Tob)],I)}),define(le[241],he([0,1,20,175,15,8,25]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LIb=void 0;let R=class extends L.$Bj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,O.$Pg)(C.logsHome,`${I.$Uob}.log`),{id:I.$Uob,name:(0,A.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$LIb=R,e.$LIb=R=ye([K(0,L.$xj),K(1,j.$ji)],R)}),define(le[242],he([0,1,6,3,2]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;class L extends j.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new j.$Sc),A.Event.latch(A.Event.any(R,k))(this.f,this,this.a),this.b=(0,O.$2g)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$x_b=L}),define(le[112],he([0,1,178,16,48,20,9,4,23]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.WorkbenchState=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=void 0,e.$li=(0,R.$ci)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$mi=g;function C(s){return typeof s?.id=="string"&&!g(s)&&!m(s)}e.$ni=C,e.$oi={id:"ext-dev"},e.$pi={id:"empty-window"};function S(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$nc)(s)}:t?e.$oi:e.$pi;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$qi=S;function m(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$ri=m;function h(s){const t=s;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$si=h;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function p(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ti=p;function E(s){const t=s;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$ui=E;class l{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=j.$ii.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=j.$ii.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$vi=l;class u{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$Pg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$wi=u;function d(s){return new u({uri:s,index:0,name:(0,L.$Lg)(s)},{uri:s.toString()})}e.$xi=d,e.$yi="code-workspace",e.$zi=`.${e.$yi}`,e.$Ai=[{name:(0,O.localize)(0,null),extensions:[e.$yi]}],e.$Bi="workspace.json";function c(s,t){return L.$Gg.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$Ci=c;function y(s){let t;return I.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===k.Schemas.tmp}e.$Di=y,e.$Ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$Ei}e.$Fi=i;function o(s,t){return!c(s,t)&&!y(s)}e.$Gi=o;function n(s){return(typeof s=="string"?(0,A.$oc)(s):(0,L.$Ng)(s))===e.$zi}e.$Hi=n}),define(le[18],he([0,1,53,3,2,20,9,169,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.ProfileResourceType=void 0;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$$k=c,e.$_k=(0,C.$ci)("IUserDataProfilesService");function y(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$al=y;function i(s,t,r,a,v,w){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,L.$Pg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,L.$Pg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,L.$Pg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,L.$Pg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,L.$Pg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,L.$Pg)(r,"extensions.json"),cacheHome:(0,L.$Pg)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$bl=i;let o=class extends j.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new A.$3d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new A.$3d),this.onWillCreateProfile=this.j.event,this.m=this.B(new A.$3d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new A.$3d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$Pg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$Pg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,u.$Qf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(i((0,L.$Mg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new h.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[f,b]of Object.entries(w.workspaces)){const P=I.URI.parse(f),N=r.find(F=>F.id===b);N&&a.set(P,N)}if(w.emptyWindows)for(const[f,b]of Object.entries(w.emptyWindows)){const P=r.find(N=>N.id===b);P&&v.set(f,P)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Ve)(r)}\\s(\\d+)`);let v=0;for(const f of this.profiles){const b=a.exec(f.name),P=b?parseInt(b[1]):0;v=P>v?P:v}const w=`${r} ${v+1}`;return this.createProfile((0,O.$3i)((0,E.$yg)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$3i)((0,E.$yg)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,u.$Qf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(P=>P.name===r||P.id===t);if(w)return w;const f=i(t,r,(0,L.$Pg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(f.location);const b=[];return this.j.fire({profile:f,join(P){b.push(P)}}),await p.Promises.settled(b),this.I([f],[],[]),f}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$Qk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$mi)(t)?t.uri:(0,m.$ri)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let f of v)f.isDefault||r.some(b=>f.id===b.id)||(f=a.find(b=>f.id===b.id)??f,f.isTransient?this.s.profiles.push(f):w.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;I.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,f]of Object.entries(t.workspaces)){const b=I.URI.parse(f);r[w]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}const v={};if(t.emptyWindows)for(const[w,f]of Object.entries(t.emptyWindows)){const b=I.URI.parse(f);v[w]=this.w.extUri.isEqual(b,a.location)?a.id:this.w.extUri.basename(b)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$cl=o,e.$cl=o=ye([K(0,k.$ji),K(1,g.$zk),K(2,$.$0k),K(3,S.$wj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$dl=n}),define(le[243],he([0,1,6,2,18]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;let L=class extends A.$Tc{constructor(R){super(),this.B(new O.$oh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$Jac=L,e.$Jac=L=ye([K(0,j.$_k)],L)}),define(le[244],he([0,1,17,6,26,7,3,2,5,12,9,152,29,33,45,8,24,22,28,18]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=e.$1p=e.$Zp=void 0;let c=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,f){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=f,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$3d),this.s=this.B(new I.$3d),this.t=this.B(new I.$3d),this.u=this.B(new I.$3d),this.w=this.B(new I.$3d),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:b})=>b.cancel()),this.m.forEach(b=>b.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$Go)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,h.$0o)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:new m.$Jo(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$Jo(S.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const f=await this.N(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...f,options:w})}catch(f){r.push({identifier:v.identifier,operation:2,source:v,error:f})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,h.$fp)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,r)}async toggleAppliationScope(t,r){if((0,$.$xm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.$(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(f=>(0,h.$0o)(f.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[],a=new Map,v=[],w=[],f=(P,N)=>`${h.$$o.create(P).toString()}-${N.toString()}`,b=(P,N,F)=>{const M=this.Y(P,N,F),U=C.URI.isUri(N)?N.path:`${N.identifier.id.toLowerCase()}-${F.profileLocation.toString()}`;a.set(U,{task:M,manifest:P}),this.n.fire({identifier:M.identifier,source:N,profileLocation:F.profileLocation}),this.F.info("Installing extension:",M.identifier.id),C.URI.isUri(N)||this.j.set(f(N,F.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:P,extension:N,options:F}of t){const M=F.isApplicationScoped||F.isBuiltin||(0,$.$xm)(P),U={...F,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(N)?F.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X()},Y=C.URI.isUri(N)?void 0:this.j.get(f(N,U.profileLocation));Y?(this.F.info("Extension is already requested to install",Y.task.identifier.id),v.push(Y.task.waitUntilTaskIsFinished())):b(P,N,U)}await Promise.all([...a.values()].map(async({task:P,manifest:N})=>{if(P.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",P.identifier.id);else try{const F=await this.M(P.identifier,N,!!P.options.installOnlyNewlyAddedFromExtensionPack,!!P.options.installPreReleaseVersion,P.options.profileLocation),M=await this.getInstalled(void 0,P.options.profileLocation),U={...P.options,donotIncludePackAndDependencies:!0,context:{...P.options.context,[m.$Bo]:!0}};for(const{gallery:Y,manifest:Q}of(0,O.$Mb)(F,({gallery:x})=>x.identifier.id)){if(a.has(`${Y.identifier.id.toLowerCase()}-${U.profileLocation.toString()}`))continue;const x=this.j.get(f(Y,U.profileLocation));if(x){if(this.J(P,x.task)){const G=x.task.identifier;this.F.info("Waiting for already requested installing extension",G.id,P.identifier.id),x.waitingTasks.push(P),v.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,Z=>Z.some(H=>(0,h.$0o)(H.identifier,G)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",G.id,P.identifier.id),!Z.find(V=>(0,h.$0o)(V.identifier,G))?.local)throw new Error(`Extension ${G.id} is not installed`)}))}}else M.some(({identifier:G})=>(0,h.$0o)(G,Y.identifier))||b(Q,Y,U)}}catch(F){if(C.URI.isUri(P.source))(0,O.$Lb)(N.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",P.identifier.id,F.message),(0,O.$Lb)(N.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",P.identifier.id,F.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",P.identifier.id),F}})),await this.L([...a.values()].map(async({task:P})=>{const N=new Date().getTime();try{const F=await P.run();if(await this.L(this.y.map(M=>M.postInstall(F,P.source,P.options,j.CancellationToken.None))),!C.URI.isUri(P.source)){const M=P.operation===3,U=M?void 0:(new Date().getTime()-P.source.lastUpdated)/1e3;if(o(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$fp)(P.source),verificationStatus:P.verificationStatus,duration:new Date().getTime()-N,durationSinceUpdate:U}),k.$o&&P.operation!==3)try{await this.z.reportStatistic(F.manifest.publisher,F.manifest.name,F.manifest.version,"install")}catch{}}w.push({local:F,identifier:P.identifier,operation:P.operation,source:P.source,context:P.options.context,profileLocation:P.profileLocation,applicationScoped:F.isApplicationScoped})}catch(F){throw this.F.error("Error while installing the extension",P.identifier.id,(0,L.$0)(F)),F}})),v.length&&await this.L(v);for(const P of w)this.F.info("Extension installed successfully:",P.identifier.id),r.push(P);return r}catch(P){w.length&&await Promise.allSettled(w.map(async({local:N,profileLocation:F})=>{try{await this.Z(N,{versionOnly:!0,profileLocation:F}).run(),this.F.info("Rollback: Uninstalled extension",N.identifier.id)}catch(M){this.F.warn("Rollback: Error while uninstalling extension",N.identifier.id,(0,L.$0)(M))}}));for(const{task:N}of a.values())N.cancel(),r.push({identifier:N.identifier,operation:2,source:N.source,context:N.options.context,profileLocation:N.profileLocation,error:P});throw P}finally{for(const{task:P}of a.values())P.source&&!C.URI.isUri(P.source)&&this.j.delete(f(P.source,P.profileLocation));r.length&&this.s.fire(r)}}J(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.J(w,r)))||a===r&&v[0]&&!this.J(t,v[0]))return!1;return!0}async L(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw y(a);return r}async M(t,r,a,v,w){if(!this.z.isEnabled())return[];const f=await this.getInstalled(void 0,w),b=[],P=[],N=async(F,M)=>{b.push(F);const U=M.extensionDependencies||[],Y=[...U];if(M.extensionPack){const Q=a?f.find(x=>(0,h.$0o)(x.identifier,F)):void 0;for(const x of M.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(G=>(0,h.$0o)({id:G},{id:x}))||Y.every(G=>!(0,h.$0o)({id:G},{id:x}))&&Y.push(x)}if(Y.length){const Q=Y.filter(x=>b.every(G=>!(0,h.$0o)(G,{id:x})));if(Q.length){const x=await this.z.getExtensions(Q.map(G=>({id:G,preRelease:v})),j.CancellationToken.None);for(const G of x){if(b.find(V=>(0,h.$0o)(V,G.identifier)))continue;const Z=U.some(V=>(0,h.$0o)({id:V},G.identifier));let H;try{H=await this.N(G,!1,v)}catch(V){if(Z)throw V;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,L.$0)(V));continue}P.push({gallery:H.extension,manifest:H.manifest}),await N(H.extension.identifier,H.manifest)}}}};return await N(t,r),P}async N(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(P=>(0,h.$0o)(t.identifier,P)))throw new m.$Jo(S.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const f=w.deprecated[t.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!v)throw new m.$Jo(S.localize(2,null,t.identifier.id,f.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const P=await this.getTargetPlatform();throw new m.$Jo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$Co)(P)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.O(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],j.CancellationToken.None))[0]?new m.$Jo(S.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$Jo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const b=await this.z.getManifest(v,j.CancellationToken.None);if(b===null)throw new m.$Jo(`Missing manifest for extension ${v.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(b.version!==v.version)throw new m.$Jo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:b}}async O(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},j.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async P(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.X()},v=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const f=F=>{const M=this.Z(F,a);return this.m.set(v(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},b=(F,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$ep)(F),error:M}),this.u.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},P=[],N=[];try{P.push(f(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.S(t,F);for(const U of M)this.m.has(v(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):P.push(f(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(P.map(M=>M.extension),F,t),await this.L(P.map(async M=>{try{if(await M.run(),await this.L(this.y.map(U=>U.postUninstall(M.extension,a,j.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}b(M.extension)}catch(U){const Y=U instanceof m.$Jo?U:new m.$Jo((0,L.$0)(U),m.ExtensionManagementErrorCode.Internal);throw b(M.extension,Y),Y}finally{N.push(M)}}))}catch(F){const M=F instanceof m.$Jo?F:new m.$Jo((0,L.$0)(F),m.ExtensionManagementErrorCode.Internal);for(const U of P){try{U.cancel()}catch{}N.includes(U)||b(U.extension,M)}throw M}finally{for(const F of P)this.m.delete(v(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}Q(t,r,a){for(const v of t){const w=this.U(v,r);if(w.length){const f=w.filter(b=>!t.some(P=>(0,h.$0o)(P.identifier,b.identifier)));if(f.length)throw new Error(this.R(v,f,a))}}}R(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}S(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(b=>!b.isBuiltin&&v.some(P=>(0,h.$0o)({id:P},b.identifier))),f=[];for(const b of w)f.push(...this.S(b,r,a));return[...w,...f]}return[]}U(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,h.$0o)({id:v},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$Zp=c,e.$Zp=c=ye([K(0,m.$Io),K(1,l.$Dl),K(2,u.$0k),K(3,p.$wj),K(4,E.$Oj),K(5,d.$_k)],c);function y(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$1p=y;function i(s){if(s instanceof m.$Jo)return s;if(s instanceof m.$Ko){const r=new m.$Jo(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$Jo(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$2p=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:f}){let b,P;(0,g.$Yf)(a)&&(a===!0?a="Verified":(a===!1||(b=m.ExtensionManagementErrorCode.Signature,P=a),a="Unverified")),w&&(w instanceof m.$Jo||w instanceof m.$Ko?(b=w.code,w.code===m.ExtensionManagementErrorCode.Signature&&(P=w.message)):b=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:b,errorcodeDetail:P,durationSinceUpdate:f})}class n{constructor(){this.d=new A.$bh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$2g)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$2g)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$3p=n}),define(le[51],he([0,1,6,14,2,3,35,9,29,33,11,4,8,18,28,12,7,22]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class d extends Error{constructor(n,s){super(n),this.code=s}}e.$4p=d,e.$5p=(0,S.$ci)("IExtensionsProfileScannerService");let c=class extends j.$Tc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new L.$3d),this.onAddExtensions=this.b.event,this.c=this.B(new L.$3d),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$3d),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$3d),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const v=[];for(const w of a)n.some(([f])=>(0,g.$0o)(f.identifier,w.identifier)&&f.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,f]of n){const b=v.findIndex(N=>(0,g.$0o)(N.identifier,w.identifier)&&N.version===w.manifest.version),P={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:f};b===-1?(r.push(P),v.push(P)):v.splice(b,1,P)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),v}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const w=n.find(([f])=>(0,g.$0o)(f.identifier,v.identifier)&&f.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,g.$0o)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$Qk)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new d((0,E.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const w of a){y(w)||this.w(n);let f;if((0,p.$Qf)(w.relativeLocation)&&w.relativeLocation)f=this.z(w.relativeLocation);else if((0,p.$Qf)(w.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${w.location}`);continue}else{f=R.URI.revive(w.location);const b=this.y(f);b&&(v=!0,w.relativeLocation=b)}(0,p.$Xf)(w.metadata?.hasPreReleaseVersion)&&w.metadata?.preRelease&&(v=!0,w.metadata.hasPreReleaseVersion=!0),r.push({identifier:w.identifier,location:f,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(n,A.$qe.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(n,A.$qe.fromString(JSON.stringify(v)))}return r})}w(n){const s=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$Qk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>y(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,A.$qe.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Qk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$Qk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$Qk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$jh,this.h.set(n,s)),s}};e.$6p=c,e.$6p=c=ye([K(1,C.$zk),K(2,h.$_k),K(3,$.$0k),K(4,l.$Dl),K(5,m.$wj)],c);function y(o){return(0,p.$Sf)(o)&&(0,k.$Ho)(o.identifier)&&(i(o.location)||(0,p.$Qf)(o.location)&&o.location)&&((0,p.$Xf)(o.relativeLocation)||(0,p.$Qf)(o.relativeLocation))&&o.version&&(0,p.$Qf)(o.version)}function i(o){return o?(0,p.$Qf)(o.path)&&(0,p.$Qf)(o.scheme):!1}}),define(le[82],he([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,9,155,15,33,45,71,11,4,8,24,3,66,51,18,28,183]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.Translations=void 0;var P;(function(x){function G(Z,H){if(Z===H)return!0;const V=Object.keys(Z),te=new Set;for(const oe of Object.keys(H))te.add(oe);if(V.length!==te.size)return!1;for(const oe of V){if(Z[oe]!==H[oe])return!1;te.delete(oe)}return te.size===0}x.equals=G})(P||(e.Translations=P={})),e.$9p=(0,n.$ci)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(G,Z,H,V,te,oe,ee,ae,W,z,D,T){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Z,this.r=H,this.s=V,this.t=te,this.u=oe,this.w=ee,this.y=ae,this.z=W,this.C=z,this.D=D,this.F=T,this.g=this.B(new r.$3d),this.onDidChangeCache=this.g.event,this.h=(0,h.$Pg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$ip)(this.w,this.y)),this.G}async scanAllExtensions(G,Z,H){const[V,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Z)]),oe=H?await this.scanExtensionsUnderDevelopment(G,[...V,...te]):[];return this.L(V,te,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Z=[];Z.push(this.M(!!G.useCache,G.language)),Z.push(this.N(G.language,!!G.checkControlFile));const[H,V]=await Promise.all(Z);return this.J([...H,...V],0,G,!1)}async scanUserExtensions(G){const Z=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const H=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Z,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,H),te=G.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let oe;try{oe=await te.scanExtensions(V)}catch(ee){if(ee instanceof v.$4p&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await te.scanExtensions(V);else throw ee}return oe=await this.J(oe,1,G,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(G,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===C.Schemas.file).map(async V=>{const te=await this.P(V,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(ee=>(ee.type=Z.find(ae=>(0,c.$0o)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,te)))}))).flat();return this.J(H,"development",G,!0)}return[]}async scanExistingExtension(G,Z,H){const V=await this.P(G,!1,Z,!0,H.language,!0,void 0),te=await this.n.scanExtension(V);return!te||!H.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,Z,H){const V=await this.P(G,!1,Z,!0,H.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(V);return this.J(te,Z,H,!0)}async scanMetadata(G){const Z=(0,h.$Pg)(G,"package.json"),H=(await this.w.readFile(Z)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(G,Z){const H=(0,h.$Pg)(G,"package.json"),V=(await this.w.readFile(H)).value.toString(),te=JSON.parse(V);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,te.__metadata={...te.__metadata,...Z},await this.w.writeFile((0,h.$Pg)(G,"package.json"),L.$qe.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$4p&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$qe.fromString(JSON.stringify([])))}catch(Z){(0,o.$Qk)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,Z,H,V){return H.includeAllVersions||(G=this.L(Z===0?G:void 0,Z===1?G:void 0,Z==="development"?G:void 0,await this.getTargetPlatform(),V)),H.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,oe)=>{const ee=S.$nc(te.location.fsPath),ae=S.$nc(oe.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(G,Z,H,V,te){const oe=(ae,W,z)=>{if(ae.isValid&&!W.isValid)return!1;if(ae.isValid===W.isValid){if(te&&$.gt(ae.manifest.version,W.manifest.version))return this.y.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if($.eq(ae.manifest.version,W.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${W.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===V)return this.y.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ae.location.path} with ${W.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${W.location.path}.`),!0},ee=new y.$wm;return G?.forEach(ae=>{const W=ee.get(ae.identifier.id);(!W||oe(W,ae,!1))&&ee.set(ae.identifier.id,ae)}),Z?.forEach(ae=>{const W=ee.get(ae.identifier.id);if(!W&&G&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!W||oe(W,ae,!1))&&ee.set(ae.identifier.id,ae)}),H?.forEach(ae=>{const W=ee.get(ae.identifier.id);(!W||oe(W,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(G,Z){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),te=await(G&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",te.length),te}async N(G,Z){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Z?await this.O():{},te=[],oe=l.URI.file(S.$hc(S.$jc(C.$wg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of H){const W=V[ae.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":te.push((0,h.$Pg)(oe,ae.name));break;default:te.push(l.URI.file(W));break}}const ee=await Promise.all(te.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,O.$Hb)(ee)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,Z,H,V,te,oe,ee){const ae=await this.f(te??m.$w),W=await this.Q(G),z=Z&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=z?await this.Q(z):void 0;return new F(G,W,z,D,Z,ee,H,V,oe,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,ae)}async Q(G){try{const Z=await this.w.stat(G);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$0p=N,e.$0p=N=ye([K(4,w.$_k),K(5,v.$5p),K(6,o.$zk),K(7,s.$wj),K(8,d.$ji),K(9,t.$Oj),K(10,f.$0k),K(11,n.$bi)],N);class F{constructor(G,Z,H,V,te,oe,ee,ae,W,z,D,T,B,q,X){this.location=G,this.mtime=Z,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=V,this.profile=te,this.profileScanOptions=oe,this.type=ee,this.excludeObsolete=ae,this.validate=W,this.productVersion=z,this.productDate=D,this.productCommit=T,this.devMode=B,this.language=q,this.translations=X}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Z){return(0,h.$Ig)(G.location,Z.location)&&G.mtime===Z.mtime&&(0,h.$Ig)(G.applicationExtensionslocation,Z.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&G.profile===Z.profile&&j.$Jn(G.profileScanOptions,Z.profileScanOptions)&&G.type===Z.type&&G.excludeObsolete===Z.excludeObsolete&&G.validate===Z.validate&&G.productVersion===Z.productVersion&&G.productDate===Z.productDate&&G.productCommit===Z.productCommit&&G.devMode===Z.devMode&&G.language===Z.language&&P.equals(G.translations,Z.translations)}}e.$$p=F;let M=class extends g.$Tc{constructor(G,Z,H,V,te){super(),this.f=G,this.g=Z,this.h=H,this.j=V,this.m=te}async scanExtensions(G){const Z=G.profile?await this.r(G):await this.n(G);let H={};if(G.excludeObsolete&&G.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(V)}catch{}return(0,E.$4f)(H)?Z:Z.filter(V=>!H[c.$$o.create(V).toString()])}async n(G){const Z=await this.j.resolve(G.location);if(!Z.children?.length)return[];const H=await Promise.all(Z.children.map(async V=>{if(!V.isDirectory||G.type===1&&(0,h.$Mg)(V.resource).indexOf(".")===0)return null;const te=new F(V.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,O.$Hb)(H).sort((V,te)=>V.location.path<te.location.path?-1:1)}async r(G){let Z=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){Z=Z.filter(V=>!V.metadata?.isApplicationScoped);const H=await this.s(G.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,G);Z.push(...H)}return Z}async s(G,Z,H){const V=await this.g.scanProfileExtensions(G,H.profileScanOptions);if(!V.length)return[];const te=await Promise.all(V.map(async oe=>{if(Z(oe)){const ee=new F(oe.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ee,oe.metadata)}return null}));return(0,O.$Hb)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,h.$Pg)(G.location,"package.json"))){const Z=await this.scanExtension(G);return Z?[Z]:[]}else return await this.scanExtensions(G)}catch(Z){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,I.$0)(Z)),[]}}async scanExtension(G,Z){try{let H=await this.scanExtensionManifest(G.location);if(H){H.publisher||(H.publisher=y.$qm),Z=Z??H.__metadata,delete H.__metadata;const V=(0,c.$cp)(H.publisher,H.name),te=Z?.id?{id:V,uuid:Z.id}:{id:V},oe=Z?.isSystem?0:G.type,ee=oe===0||!!Z?.isBuiltin;H=await this.t(G.location,H,F.createNlsConfiguration(G));const ae={type:oe,identifier:te,manifest:H,location:G.location,isBuiltin:ee,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return G.validate?this.validate(ae,G):ae}}catch(H){G.type!==0&&this.m.error(H)}return null}validate(G,Z){let H=!0;const V=(0,i.$np)(Z.productVersion,Z.productDate,Z.location,G.manifest,G.isBuiltin);for(const[te,oe]of V)te===p.default.Error&&(H=!1,this.m.error(this.z(Z.location,oe)));return G.isValid=H,G.validations=V,G}async scanExtensionManifest(G){const Z=(0,h.$Pg)(G,"package.json");let H;try{H=(await this.j.readFile(Z)).value.toString()}catch(te){return(0,o.$Qk)(te)!==1&&this.m.error(this.z(G,(0,u.localize)(0,null,Z.path,te.message))),null}let V;try{V=JSON.parse(H)}catch{const oe=[];(0,R.$mn)(H,oe);for(const ee of oe)this.m.error(this.z(G,(0,u.localize)(1,null,Z.path,ee.offset,ee.length,(0,k.$7p)(ee.error))));return null}return(0,R.$vn)(V)!=="object"?(this.m.error(this.z(G,(0,u.localize)(2,null,Z.path))),null):V}async t(G,Z,H){const V=await this.u(G,Z,H);if(V)try{const te=[],oe=await this.w(V.default,te);if(te.length>0)return te.forEach(ae=>{this.m.error(this.z(G,(0,u.localize)(3,null,V.default?.path,(0,k.$7p)(ae.error))))}),Z;if((0,R.$vn)(V)!=="object")return this.m.error(this.z(G,(0,u.localize)(4,null,V.default?.path))),Z;const ee=V.values||Object.create(null);return(0,b.$8p)(this.m,Z,ee,oe)}catch{}return Z}async u(G,Z,H){const V=(0,h.$Pg)(G,"package.nls.json"),te=(W,z)=>{z.forEach(D=>{this.m.error(this.z(G,(0,u.localize)(5,null,W?.path,(0,k.$7p)(D.error))))})},oe=W=>{this.m.error(this.z(G,(0,u.localize)(6,null,W?.path)))},ee=`${Z.publisher}.${Z.name}`,ae=H.translations[ee];if(ae)try{const W=l.URI.file(ae),z=(await this.j.readFile(W)).value.toString(),D=[],T=(0,R.$mn)(z,D);return D.length>0?(te(W,D),{values:void 0,default:V}):(0,R.$vn)(T)!=="object"?(oe(W),{values:void 0,default:V}):{values:T.contents?T.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let z;try{z=await this.y(G,H)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const D=(await this.j.readFile(z.localized)).value.toString(),T=[],B=(0,R.$mn)(D,T);return T.length>0?(te(z.localized,T),{values:void 0,default:z.original}):(0,R.$vn)(B)!=="object"?(oe(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(G,Z){if(G)try{const H=(await this.j.readFile(G)).value.toString();return(0,R.$mn)(H,Z)}catch{}}y(G,Z){return new Promise((H,V)=>{const te=oe=>{const ee=(0,h.$Pg)(G,`package.nls.${oe}.json`);this.j.exists(ee).then(ae=>{ae&&H({localized:ee,original:(0,h.$Pg)(G,"package.nls.json")});const W=oe.lastIndexOf("-");W===-1?H({localized:(0,h.$Pg)(G,"package.nls.json"),original:null}):(oe=oe.substring(0,W),te(oe))})};if(Z.devMode||Z.pseudo||!Z.language)return H({localized:(0,h.$Pg)(G,"package.nls.json"),original:null});te(Z.language)})}z(G,Z){return`[${G.path}]: ${Z}`}};M=ye([K(1,v.$5p),K(2,f.$0k),K(3,o.$zk),K(4,s.$wj)],M);let U=class extends M{constructor(G,Z,H,V,te,oe,ee){super(Z,V,te,oe,ee),this.G=G,this.H=H,this.D=this.B(new A.$ah(3e3)),this.F=this.B(new r.$3d),this.onDidChangeCache=this.F.event}async scanExtensions(G){const Z=this.M(G),H=await this.I(Z);if(this.C=G,H&&H.input&&F.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),H.result.map(te=>(te.location=l.URI.revive(te.location),te));const V=await super.scanExtensions(G);return await this.J(Z,{input:G,result:V}),V}async I(G){try{const Z=await this.j.readFile(G),H=JSON.parse(Z.value.toString());return{result:H.result,input:(0,a.$Lh)(H.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",G.path,(0,I.$0)(Z))}return null}async J(G,Z){try{await this.j.writeFile(G,L.$qe.fromString(JSON.stringify(Z)))}catch(H){this.m.debug("Error while writing the extension cache file:",G.path,(0,I.$0)(H))}}async L(){if(!this.C)return;const G=this.M(this.C),Z=await this.I(G);if(!Z)return;const H=Z.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$Jn(V,H))try{this.m.info("Invalidating Cache",H,V),await this.j.del(G),this.F.fire()}catch(te){this.m.error(te)}}M(G){const Z=this.N(G);return this.h.extUri.joinPath(Z.cacheHome,G.type===0?y.$pm:y.$om)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(G.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};U=ye([K(2,w.$_k),K(3,v.$5p),K(4,f.$0k),K(5,o.$zk),K(6,s.$wj)],U);function Y(x,G){const Z=(0,c.$ap)(x.manifest.publisher,x.manifest.name);return{id:Z,identifier:new y.$um(Z),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$_p=Y;class Q extends N{constructor(G,Z,H,V,te,oe,ee,ae,W,z,D,T){super(G,Z,(0,h.$Pg)(H,".vscode-oss-dev","extensions","control.json"),V,te,oe,ee,ae,W,z,D,T),this.R=(async()=>{if(m.$z)try{const B=await this.w.readFile(l.URI.file(m.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$aq=Q}),define(le[245],he([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;let m=class extends I.$Tc{constructor($,p){super(),this.b=$,this.f=p,this.a=new A.$ih(5)}async postUninstall($){const p=this.g($,"uninstall");p&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(E){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(E)}}));try{await g.Promises.rm(this.m($))}catch(E){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(E)}}g($,p){const E=`vscode:${p}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[E]=="string"){const l=$.manifest.scripts[E].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${E} should be a node script`),null):{script:(0,k.$jc)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,p,E,l,u){return new Promise((d,c)=>{const y=this.j($,p,E,u);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):d(void 0)};y.on("error",n=>{o((0,j.$Zi)(n)||"Unknown")}),y.on("exit",(n,s)=>{o(n?`post-${p} process exited with code ${n}`:void 0)}),l&&(i=setTimeout(()=>{i=null,y.kill(),c("timed out")},5e3))})}j($,p,E,l){const u={silent:!0,execArgv:void 0},d=(0,O.fork)($,[`--type=extension-post-${p}`,...E],u);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=L.Event.fromNodeEventEmitter(d.stdout,"data"),y=L.Event.fromNodeEventEmitter(d.stderr,"data");c(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${p}`,n)),y(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${p}`,n));const i=L.Event.any(L.Event.map(c,n=>({data:`%c${n}`,format:[""]})),L.Event.map(y,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}m($){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$cq=m,e.$cq=m=ye([K(0,S.$_k),K(1,C.$wj)],m)}),define(le[113],he([0,1,6,14,26,38,7,3,53,2,35,23,16,20,55,12,9,32,31,70,156,96,15,244,29,33,51,82,225,245,184,214,226,71,11,4,8,24,22,28,18]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b,P,N,F,M,U,Y,Q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=e.$gq=void 0,e.$gq=(0,F.$di)(n.$Lo);const G=".vsctmp";let Z=class extends o.$Zp{constructor(W,z,D,T,B,q,X,_,ie,J,ne,ce){super(W,z,ne,D,J,ce),this.eb=B,this.fb=q,this.gb=X,this.hb=ie,this.db=new Map,this.qb=new C.$Bc;const fe=this.B(_.createInstance(v.$cq));this.ab=this.B(_.createInstance(H,me=>fe.postUninstall(me))),this.bb=this.B(new f.$eq(ce,ie,ne,this,this.F)),this.cb=this.B(_.createInstance(a.$bq));const de=this.B(new b.$fq(this,this.eb,ce,q,ne,ie,D));this.B(de.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$ip)(this.hb,this.F)),this.ib}async zip(W){this.F.trace("ExtensionManagementService#zip",W.identifier.id);const z=await this.ob(W),D=await(0,d.zip)((0,h.$Pg)(this.cb.extensionsDownloadDir,(0,l.$yg)()).fsPath,z);return E.URI.file(D)}async unzip(W){return this.F.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:z,cleanup:D}=await this.kb(W),T=m.$kc(z.fsPath);try{return await(0,w.$dq)(T)}finally{await D()}}getInstalled(W,z=this.H.defaultProfile.extensionsResource){return this.ab.scanExtensions(W??null,z)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.ab.scanUserExtensionAtLocation(W)}async install(W,z={}){this.F.trace("ExtensionManagementService#install",W.toString());const{location:D,cleanup:T}=await this.kb(W);try{const B=await(0,w.$dq)(m.$kc(D.fsPath)),q=(0,s.$cp)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,P.$pp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,q,this.G.version));const _=(await this.I([{manifest:B,extension:D,options:z}])).find(({identifier:ie})=>(0,s.$0o)(ie,{id:q}));if(_?.local)return _.local;throw _?.error?_.error:(0,o.$2p)(new Error(`Unknown error while installing extension ${q}`))}finally{await T()}}async installFromLocation(W,z){this.F.trace("ExtensionManagementService#installFromLocation",W.toString());const D=await this.ab.scanUserExtensionAtLocation(W);if(!D||!D.manifest.name||!D.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.tb([[D,void 0]],z),this.F.info("Successfully installed extension",D.identifier.id,z.toString()),D}async installExtensionsFromProfile(W,z,D){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",W,z.toString(),D.toString());const T=(await this.ab.scanExtensions(1,z)).filter(B=>W.some(q=>(0,s.$0o)(q,B.identifier)));if(T.length){const B=await Promise.all(T.map(q=>this.ab.scanMetadata(q,z)));await this.tb(T.map((q,X)=>[q,B[X]]),D),this.F.info("Successfully installed extensions",T.map(q=>q.identifier.id),D.toString())}return T}async updateMetadata(W,z,D=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",W.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),W=await this.ab.updateMetadata(W,z,D),this.bb.invalidate(D),this.w.fire(W),W}async reinstallFromGallery(W){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const z=await this.getTargetPlatform(),[D]=await this.z.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:z,compatible:!0},j.CancellationToken.None);if(!D)throw new Error(c.localize(2,null));await this.ab.setUninstalled(W);try{await this.ab.removeUninstalledExtension(W)}catch(T){throw new Error(c.localize(3,null,(0,L.$Zi)(T)))}return this.installFromGallery(D)}$(W,z,D,T){return this.ab.copyExtension(W,z,D,T)}copyExtensions(W,z){return this.ab.copyExtensions(W,z)}markAsUninstalled(...W){return this.ab.setUninstalled(...W)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(W){this.F.error(W)}}async download(W,z,D){const{location:T}=await this.cb.download(W,z,!D);return T}async kb(W){if(W.scheme===S.Schemas.file)return{location:W,async cleanup(){}};this.F.trace("Downloading extension from",W.toString());const z=(0,h.$Pg)(this.cb.extensionsDownloadDir,(0,l.$yg)());return await this.gb.download(W,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(T){this.F.error(T)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(W,z,D){if(E.URI.isUri(z))return new oe(W,z,D,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const T=s.$$o.create(z).toString();let B=this.db.get(T);return B||(this.db.set(T,B=new te(W,z,D,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(T))),B}Z(W,z){return new ee(W,z.profileLocation,this.fb)}async ob(W){const z=async T=>{let B=await u.Promises.readdir(T);B=B.map(_=>m.$jc(T,_));const q=await Promise.all(B.map(_=>u.Promises.stat(_)));let X=Promise.resolve([]);return q.forEach((_,ie)=>{const J=B[ie];_.isFile()&&(X=X.then(ne=>[...ne,J])),_.isDirectory()&&(X=X.then(ne=>z(J).then(ce=>[...ne,...ce])))}),X};return(await z(W.location.fsPath)).map(T=>({path:`extension/${m.$lc(W.location.fsPath,T)}`,localPath:T}))}async pb({added:W,removed:z}){if(z){const D=W&&this.D.extUri.isEqual(z.profileLocation,W.profileLocation)?z.extensions.filter(T=>W.extensions.every(B=>!(0,s.$0o)(B,T))):z.extensions;for(const T of D)this.F.info("Extensions removed from another source",T.id,z.profileLocation.toString()),this.u.fire({identifier:T,profileLocation:z.profileLocation})}if(W){const T=(await this.ab.scanExtensions(1,W.profileLocation)).filter(B=>W.extensions.some(q=>(0,s.$0o)(q,B.identifier)));this.s.fire(T.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,W.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:W.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const W=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of W.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(W){if(!W.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const D of W.rawAdded){if(this.qb.has(D)||!this.D.extUri.isEqual(this.D.extUri.dirname(D),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(D,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(D).startsWith(".")||!(await this.hb.stat(D)).isDirectory)continue;const T=await this.ab.scanUserExtensionAtLocation(D);T&&T.installedTimestamp===void 0&&(this.qb.add(D),z.push(T))}z.length&&(await this.tb(z.map(D=>[D,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(D=>D.identifier.id)))}async tb(W,z){const D=W.map(T=>T[0]);await this.ub(D),await this.fb.addExtensionsToProfile(W,z),this.s.fire(D.map(T=>({local:T,identifier:T.identifier,operation:1,profileLocation:z})))}async ub(W){const z=await this.ab.getUninstalledExtensions();for(const D of W){const T=s.$$o.create(D);z[T.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",T.id),await this.ab.setInstalled(T),this.F.info("Removed the extension from uninstalled list:",T.id))}}};e.$hq=Z,e.$hq=Z=ye([K(0,n.$Io),K(1,Y.$Dl),K(2,M.$wj),K(3,i.$ki),K(4,r.$9p),K(5,t.$5p),K(6,y.$no),K(7,F.$bi),K(8,N.$zk),K(9,U.$Oj),K(10,Q.$0k),K(11,x.$_k)],Z);let H=class extends g.$Tc{constructor(W,z,D,T,B,q){super(),this.j=W,this.m=z,this.n=D,this.s=T,this.t=B,this.u=q,this.h=this.B(new R.$3d),this.onExtract=this.h.event,this.c=(0,h.$Pg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$jh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(W,z){const D={includeInvalid:!0,profileLocation:z};let T=[];return W===null||W===0?T.push(...await this.n.scanAllExtensions({includeInvalid:!0},D,!1)):W===1&&T.push(...await this.n.scanUserExtensions(D)),T=W!==null?T.filter(B=>B.type===W):T,Promise.all(T.map(B=>this.F(B)))}async scanAllUserExtensions(W){const z=await this.n.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return Promise.all(z.map(D=>this.F(D)))}async scanUserExtensionAtLocation(W){try{const z=await this.n.scanExistingExtension(W,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(W,z,D,T,B){const q=W.toString(),X=E.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$yg)()}`)),_=E.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,q));let ie=await this.m.exists(_);if(ie&&T){try{await this.y(W.id,_,"removeExisting")}catch{throw new n.$Jo(c.localize(4,null,_.fsPath,W.id),n.ExtensionManagementErrorCode.Delete)}ie=!1}if(ie)await this.n.updateMetadata(_,D);else try{try{this.u.trace(`Started extracting the extension from ${z} to ${_.fsPath}`),await(0,d.$Xp)(z,X.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${_}:`,W.id)}catch(J){let ne=n.ExtensionManagementErrorCode.Extract;throw J instanceof d.$Vp&&(J.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:J.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Jo(J.message,ne)}await this.n.updateMetadata(X,D);try{this.u.trace(`Started renaming the extension from ${X.fsPath} to ${_.fsPath}`),await this.C(X.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(J){if(J.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(J)}. Deleted from extracted location`,X),J}this.h.fire(_)}catch(J){try{await this.m.del(X,{recursive:!0})}catch{}throw J}return this.D(_,1)}async scanMetadata(W,z){return z?(await this.w(W,z))?.metadata:this.n.scanMetadata(W.location)}async w(W,z){return(await this.s.scanProfileExtensions(z)).find(T=>(0,s.$0o)(T.identifier,W.identifier))}async updateMetadata(W,z,D){return D?await this.s.updateMetadata([[W,z]],D):await this.n.updateMetadata(W.location,z),this.D(W.location,W.type,D)}getUninstalledExtensions(){return this.z()}async setUninstalled(...W){const z=W.map(D=>s.$$o.create(D));await this.z(D=>z.forEach(T=>{D[T.toString()]=!0,this.u.info("Marked extension as uninstalled",T.toString())}))}async setInstalled(W){await this.z(z=>delete z[W.toString()])}async removeExtension(W,z){if(this.t.extUri.isEqualOrParent(W.location,this.n.userExtensionsLocation))return this.y(W.identifier.id,W.location,z)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.z(z=>delete z[s.$$o.create(W).toString()])}async copyExtension(W,z,D,T){const B=await this.w(W,z),q=await this.w(W,D);if(T={...B?.metadata,...T},q)if(this.t.extUri.isEqual(q.location,W.location))await this.s.updateMetadata([[W,{...q.metadata,...T}]],D);else{const X=await this.D(q.location,W.type,D);await this.s.removeExtensionFromProfile(X,D),await this.s.addExtensionsToProfile([[W,{...q.metadata,...T}]],D)}else await this.s.addExtensionsToProfile([[W,T]],D);return this.D(W.location,W.type,D)}async copyExtensions(W,z){const D=await this.scanExtensions(1,W),T=await Promise.all(D.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,W)]));await this.s.addExtensionsToProfile(T,z)}async y(W,z,D){this.u.trace(`Deleting ${D} extension from disk`,W,z.fsPath);const T=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,k.$3i)((0,l.$yg)()).toString(16)}${G}`);await this.C(z.fsPath,T.fsPath),await this.m.del(T,{recursive:!0}),this.u.info(`Deleted ${D} extension from disk`,W,z.fsPath)}async z(W){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(T){if((0,N.$Qk)(T)!==1)throw T}let D={};if(z)try{D=JSON.parse(z)}catch{}return W&&(W(D),Object.keys(D).length?await this.m.writeFile(this.c,A.$qe.fromString(JSON.stringify(D))):await this.m.del(this.c)),D})}async C(W,z){try{await u.Promises.rename(W,z,2*60*1e3)}catch(D){throw new n.$Jo(D.message||c.localize(5,null,W,z),D.code||n.ExtensionManagementErrorCode.Rename)}}async D(W,z,D){if(D){const B=(await this.n.scanUserExtensions({profileLocation:D})).find(q=>this.t.extUri.isEqual(q.location,W));if(B)return this.F(B)}else{const T=await this.n.scanExistingExtension(W,z,{includeInvalid:!0});if(T)return this.F(T)}throw new Error(c.localize(6,null,W.path))}async F(W){const z=await this.m.resolve(W.location);let D,T;return z.children&&(D=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,T=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:D,changelogUrl:T,publisherDisplayName:W.metadata?.publisherDisplayName||null,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned}}async G(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(W));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),D=new Set;for(const B of z)W[s.$$o.create(B).toString()]||D.add(B.identifier.id.toLowerCase());try{const B=(0,s.$dp)(z,q=>q.identifier);await O.Promises.settled(B.map(async q=>{const X=q.sort((_,ie)=>$.rcompare(_.manifest.version,ie.manifest.version))[0];D.has(X.identifier.id.toLowerCase())||await this.j(await this.F(X))}))}catch(B){this.u.error(B)}const T=z.filter(B=>B.metadata&&W[s.$$o.create(B).toString()]);await Promise.allSettled(T.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,N.$Qk)(z)!==1&&this.u.error(z);return}if(W?.children)try{await Promise.allSettled(W.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(G))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(D){(0,N.$Qk)(D)!==1&&this.u.error(D)}}}))}catch{}}};e.$iq=H,e.$iq=H=ye([K(1,N.$zk),K(2,r.$9p),K(3,t.$5p),K(4,Q.$0k),K(5,M.$wj)],H);class V extends o.$3p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$Xf)(this.options.operation)?this.l:this.options.operation}constructor(W,z,D,T,B,q,X,_,ie){super(),this.identifier=W,this.source=z,this.options=D,this.m=T,this.n=B,this.o=q,this.p=X,this.q=_,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(W){const[z,D]=await this.x(W);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,D]],this.j),z}async u({zipPath:W,key:z,metadata:D},T,B){let q=await this.v(z);return q?q=await this.m.updateMetadata(q,D):(this.s.trace("Extracting extension...",z.id),q=await this.m.extractUserExtension(z,W,D,T,B),this.s.info("Extracting extension completed.",z.id)),q}async v(W){return await this.w(W)?(this.s.trace("Removing the extension from uninstalled list:",W.id),await this.m.setInstalled(W),this.s.info("Removed the extension from uninstalled list:",W.id),(await this.m.scanAllUserExtensions(!0)).find(T=>s.$$o.create(T).equals(W))):void 0}async w(W){return!!(await this.m.getUninstalledExtensions())[W.toString()]}}class te extends V{constructor(W,z,D,T,B,q,X,_,ie,J){super(z.identifier,z,D,B,q,X,_,ie,J),this.y=z,this.z=T}async x(W){let z;try{z=await this.m.scanExtensions(null,this.options.profileLocation)}catch(X){throw new n.$Jo(X,n.ExtensionManagementErrorCode.Scanning)}const D=z.find(X=>(0,s.$0o)(X.identifier,this.y.identifier));D&&(this.l=3);const T={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||D?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||D?.isMachineScoped,isBuiltin:this.options.isBuiltin||D?.isBuiltin,isSystem:D?.type===0?!0:void 0,updated:!!D,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:D?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??D?.pinned,preRelease:(0,p.$Wf)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||D?.preRelease};if(D?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(D,T),T]}catch(X){throw new n.$Jo((0,I.$0)(X),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$$o.create(this.y),metadata:T},!1,W),T]}catch(X){try{await this.z.delete(B)}catch(_){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$0)(_))}throw X}}async B(W){try{await(0,w.$dq)(W)}catch(z){throw new n.$Jo((0,o.$1p)(z).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$jq=te;class oe extends V{constructor(W,z,D,T,B,q,X,_,ie,J){super({id:(0,s.$cp)(W.publisher,W.name)},z,D,B,q,X,_,ie,J),this.y=W,this.z=z,this.A=T}async h(W){const z=await super.h(W);return this.D(z,W),z}async x(W){const z=new s.$$o(this.identifier,this.y.version),T=(await this.m.scanExtensions(1,this.options.profileLocation)).find(X=>(0,s.$0o)(this.identifier,X.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||T?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||T?.isMachineScoped,isBuiltin:this.options.isBuiltin||T?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??T?.pinned};if(T)if(this.l=3,z.equals(new s.$$o(T.identifier,T.manifest.version)))try{await this.m.removeExtension(T,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(T.manifest.version,this.y.version)&&await this.m.setUninstalled(T);else{const X=await this.v(z);if(X)try{await this.m.removeExtension(X,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:z,metadata:B},!0,W),B]}async D(W,z){try{let[D]=await this.A.getExtensions([{id:W.identifier.id,version:W.manifest.version}],z);if(D||([D]=await this.A.getExtensions([{id:W.identifier.id}],z)),D){const T={id:D.identifier.uuid,publisherDisplayName:D.publisherDisplayName,publisherId:D.publisherId,isPreReleaseVersion:D.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||D.properties.isPreReleaseVersion,preRelease:D.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(W,T,this.options.profileLocation)}}catch{}}}class ee extends o.$3p{constructor(W,z,D){super(),this.extension=W,this.j=z,this.k=D}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,18,28,22,51,11,15,9]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=void 0;let C=class extends I.$6p{constructor(m,h,$,p,E,l){super(g.URI.file(m.extensionsPath),h,$,p,E,l)}};e.$wP=C,e.$wP=C=ye([K(0,k.$ki),K(1,R.$zk),K(2,A.$_k),K(3,j.$0k),K(4,L.$Dl),K(5,O.$wj)],C)}),define(le[247],he([0,1,9,15,51,82,11,4,8,24,28,18]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;let m=class extends L.$aq{constructor($,p,E,l,u,d,c,y){super(O.URI.file(u.builtinExtensionsPath),O.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,p,E,l,u,d,c,y)}};e.$B_b=m,e.$B_b=m=ye([K(0,S.$_k),K(1,j.$5p),K(2,I.$zk),K(3,k.$wj),K(4,A.$ki),K(5,g.$Oj),K(6,C.$0k),K(7,R.$bi)],m)}),define(le[19],he([0,1,6,3,2,100,12,69,4,18]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Bp="__$__isNewStorageMarker",e.$Cp="__$__targetStorageMarker",e.$Dp=(0,k.$ci)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(u){const d=u.get(e.$Cp);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$Ep=h;class $ extends j.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:$.a}){super(),this.m=d,this.b=this.B(new A.$6d),this.c=this.B(new A.$6d),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$3d),this.onWillSaveState=this.f.event,this.h=this.B(new O.$oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,c,y){return A.Event.filter(this.b.event,i=>i.scope===d&&(c===void 0||i.key===c),y)}n(){this.j.value=(0,O.$sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,c){const{key:y,external:i}=c;if(y===e.$Cp){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:y,target:this.J(d)[y],external:i})}w(d){this.f.fire({reason:d})}get(d,c,y){return this.P(c)?.get(d,y)}getBoolean(d,c,y){return this.P(c)?.getBoolean(d,y)}getNumber(d,c,y){return this.P(c)?.getNumber(d,y)}getObject(d,c,y){return this.P(c)?.getObject(d,y)}storeAll(d,c){this.y(()=>{for(const y of d)this.store(y.key,y.value,y.scope,y.target,c)})}store(d,c,y,i,o=!1){if((0,I.$Zf)(c)){this.remove(d,y,o);return}this.y(()=>{this.z(d,y,i),this.P(y)?.set(d,c,o)})}remove(d,c,y=!1){this.y(()=>{this.z(d,c,void 0),this.P(c)?.delete(d,y)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,c){const y=[],i=this.J(d);for(const o of Object.keys(i))i[o]===c&&y.push(o);return y}z(d,c,y,i=!1){const o=this.J(c);typeof y=="number"?o[d]!==y&&(o[d]=y,this.P(c)?.set(e.$Cp,JSON.stringify(o),i)):typeof o[d]=="number"&&(delete o[d],this.P(c)?.set(e.$Cp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const c=this.P(d);return c?h(c):Object.create(null)}isNew(d){return this.getBoolean(e.$Bp,d)===!0}async flush(d=C.NONE){this.f.fire({reason:d});const c=this.P(-1),y=this.P(0),i=this.P(1);switch(d){case C.NONE:await O.Promises.settled([c?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await O.Promises.settled([c?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return l(d,c,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,c){return this.w(C.NONE),(0,g.$$k)(d)?this.R(d,c):this.S(d,c)}M(d,c){return!(d.id===c.id||p(c)&&p(d))}N(d,c,y){this.y(()=>{const i=new Set;for(const[o,n]of d)i.add(o),c.get(o)!==n&&this.u(y,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(y,{key:o,external:!0})})}}e.$Fp=$;function p(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$Gp=p;class E extends ${constructor(){super(),this.U=this.B(new R.$zp(new R.$Ap,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$zp(new R.$Ap,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$zp(new R.$Ap,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$Hp=E;async function l(u,d,c,y,i,o){const n=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,t=new Map;u.forEach((P,N)=>{s.set(N,P),t.set(N,n(P))});const r=new Map,a=new Map;d.forEach((P,N)=>{r.set(N,P),a.set(N,n(P))});const v=new Map,w=new Map;c.forEach((P,N)=>{v.set(N,P),w.set(N,n(P))}),console.group(y!==i?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const f=[];if(s.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log(t),y!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const P=[];r.forEach((N,F)=>{P.push({key:F,value:N})}),console.table(P),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const b=[];v.forEach((P,N)=>{b.push({key:N,value:P})}),console.table(b),console.groupEnd(),console.log(w)}e.$Ip=l}),define(le[114],he([0,1,3,2,12,29,33,19]),function(se,e,O,A,j,L,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pGb=e.$oGb=void 0;let k=class extends A.$Tc{constructor(S,m){super(),this.a=new O.$3d,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(m.onDidInstallExtensions(h=>h.forEach(({local:$,operation:p})=>{$&&p===4&&this.f($.identifier)})))}async enableExtension(S,m){return this.f(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this.c(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this.h(L.$Mo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const m=this.getDisabledExtensions();return m.every(h=>!(0,I.$0o)(h,S))?(m.push(S),this.g(m),!0):!1}f(S){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const $=m[h];if((0,I.$0o)($,S))return m.splice(h,1),this.g(m),!0}return!1}g(S){this.j(L.$Mo,S)}h(S){return this.b.get(S,0)}j(S,m){this.b.set(S,m,0)}};e.$oGb=k,e.$oGb=k=ye([K(0,R.$Dp),K(1,L.$Lo)],k);class g extends A.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new O.$3d),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new A.$Sc))(m=>this.f(m)))}get(S,m){let h;return m===0?((0,j.$Zf)(this.a[S])&&(this.a[S]=this.g(S,m)),h=this.a[S]):h=this.g(S,m),JSON.parse(h)}set(S,m,h){const $=JSON.stringify(m.map(({id:E,uuid:l})=>({id:E,uuid:l})));this.g(S,h)!==$&&(h===0&&(m.length?this.a[S]=$:delete this.a[S]),this.h(S,m.length?$:void 0,h))}f(S){if(!(0,j.$Zf)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const h=this.get(S.key,S.scope);delete this.a[S.key];const $=this.get(S.key,S.scope),p=h.filter(l=>!$.some(u=>(0,I.$0o)(l,u))),E=$.filter(l=>!h.some(u=>(0,I.$0o)(u,l)));(p.length||E.length)&&this.b.fire([...p,...E])}}g(S,m){return this.c.get(S,m,"[]")}h(S,m,h){m?this.c.store(S,m,h,1):this.c.remove(S,h)}}e.$pGb=g}),define(le[248],he([0,1,17,26,7,5,37,12,9,21,15,29,33,71,11,8,24,59,227,19,22,63]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=e.$Lp=void 0;const i=L.$o?"web":(0,S.$Eo)(L.$u,I.$ec),o="X-Market-Search-Activity-Id";var n;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished",T[T.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...T){return String(T.reduce((B,q)=>B|q,0))}var t;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class f{constructor(B=w){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,q=this.d.pageSize){return new f({...this.d,pageNumber:B,pageSize:q})}withFilter(B,...q){const X=[...this.d.criteria,...q.length?q.map(_=>({filterType:B,value:_})):[{filterType:B}]];return new f({...this.d,criteria:X})}withSortBy(B){return new f({...this.d,sortBy:B})}withSortOrder(B){return new f({...this.d,sortOrder:B})}withFlags(...B){return new f({...this.d,flags:B.reduce((q,X)=>q|X,0)})}withAssetTypes(...B){return new f({...this.d,assetTypes:B})}withSource(B){return new f({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:q,pageSize:X,sortBy:_,sortOrder:ie,flags:J,assetTypes:ne}=this.d;return{filters:[{criteria:B,pageNumber:q,pageSize:X,sortBy:_,sortOrder:ie}],assetTypes:ne,flags:J}}get searchText(){const B=this.d.criteria.filter(q=>q.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function b(T,B){const q=(T||[]).filter(X=>X.statisticName===B)[0];return q?q.value:0}function P(T){const B="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(X=>X.assetType.indexOf(B)===0).reduce((X,_)=>{const ie=M(T,_.assetType);return ie&&X.push([_.assetType.substring(B.length),ie]),X},[])}function N(T){if(T.properties){const B=T.properties.filter(_=>_.key===r.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),X=B.filter(_=>q.test(_.value))[0];return X?{uri:X.value,fallbackUri:X.value}:null}return M(T,r.Repository)}function F(T){return{uri:`${T.fallbackAssetUri}/${r.VSIX}?redirect=true${T.targetPlatform?`&targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${r.VSIX}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}}function M(T,B){return T.files.filter(X=>X.assetType===B)[0]?{uri:`${T.assetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`,fallbackUri:`${T.fallbackAssetUri}/${B}${T.targetPlatform?`?targetPlatform=${T.targetPlatform}`:""}`}:null}function U(T,B){const q=T.properties?T.properties.filter(_=>_.key===B):[],X=q.length>0&&q[0].value;return X?X.split(",").map(_=>(0,m.$bp)(_)):[]}function Y(T){const B=T.properties?T.properties.filter(q=>q.key===a.Engine):[];return B.length>0&&B[0].value||""}function Q(T){const B=T.properties?T.properties.filter(q=>q.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(T){const B=T.properties?T.properties.filter(X=>X.key===a.LocalizedLanguages):[],q=B.length>0&&B[0].value||"";return q?q.split(","):[]}function G(T){return T.properties?.find(B=>B.key===a.SponsorLink)?.value}function Z(T){return T.properties?.find(B=>B.key===a.SupportLink)?.value}function H(T){return T.indexOf("preview")!==-1}function V(T){return T.targetPlatform?(0,S.$Do)(T.targetPlatform):"undefined"}function te(T){const B=(0,O.$Mb)(T.versions.map(V)),q=!!T.tags?.includes(S.$yo),X=B.indexOf("web");return q?X===-1&&B.push("web"):X!==-1&&B.splice(X,1),B}function oe(T,B){for(let q=0;q<T.length;q++){const X=T[q];if(X.version===T[q-1]?.version){let _=q;if(V(X)===B)for(;_>0&&T[_-1].version===X.version;)_--;_!==q&&(T.splice(q,1),T.splice(_,0,X))}}return T}e.$Lp=oe;function ee(T,B,q){T.telemetryData={index:B,querySource:q,queryActivityId:T.queryContext?.[o]}}function ae(T,B,q,X){const _=T.versions[0],ie={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:F(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:P(B)};return{identifier:{id:(0,m.$cp)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:B.version,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,publisherDomain:T.publisher.domain?{link:T.publisher.domain,verified:!!T.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(_),description:T.shortDescription||"",installCount:b(T.statistics,"install"),rating:b(T.statistics,"averagerating"),ratingCount:b(T.statistics,"ratingcount"),categories:T.categories||[],tags:T.tags||[],releaseDate:Date.parse(T.releaseDate),lastUpdated:Date.parse(T.lastUpdated),allTargetPlatforms:q,assets:ie,properties:{dependencies:U(B,a.Dependency),extensionPack:U(B,a.ExtensionPack),engine:Y(B),localizedLanguages:x(B),targetPlatform:V(B),isPreReleaseVersion:Q(B)},hasPreReleaseVersion:Q(_),hasReleaseVersion:!0,preview:H(T.flags),isSigned:!!ie.signature,queryContext:X,supportLink:Z(_)}}let W=class{constructor(B,q,X,_,ie,J,ne,ce){this.k=q,this.l=X,this.n=_,this.o=ie,this.q=J,this.u=ne,this.w=ce;const fe=ne.extensionsGallery,de=fe?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?fe.servicePPEUrl:fe?.serviceUrl,this.g=de?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,u.$Kp)(ne.version,ne,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,q,X){const _=A.CancellationToken.isCancellationToken(q)?{}:q,ie=A.CancellationToken.isCancellationToken(q)?q:X,J=[],ne=[],ce=[],fe=[];let de=!0;for(const Re of B){Re.uuid?ne.push(Re.uuid):J.push(Re.id);const Oe=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&fe.push({id:Re.id,uuid:Re.uuid,version:Re.version}),de=de&&!!Re.hasPreRelease&&!Oe}if(!ne.length&&!J.length)return[];let me=new f().withPage(1,B.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),J.length&&(me=me.withFilter(t.ExtensionName,...J)),(_.queryAllVersions||de)&&(me=me.withFlags(me.flags,n.IncludeVersions)),_.source&&(me=me.withSource(_.source));const{extensions:Ee}=await this.z(me,{targetPlatform:_.targetPlatform??i,includePreRelease:ce,versions:fe,compatible:!!_.compatible},ie);return _.source&&Ee.forEach((Re,Oe)=>ee(Re,Oe,_.source)),Ee}async getCompatibleExtension(B,q,X){if((0,S.$Fo)(B.allTargetPlatforms,X))return null;if(await this.isExtensionCompatible(B,q,X))return B;const _=new f().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:ie}=await this.z(_,{targetPlatform:X,compatible:!0,includePreRelease:q},A.CancellationToken.None);return ie[0]||null}async isExtensionCompatible(B,q,X){if(!(0,S.$Go)(B.properties.targetPlatform,B.allTargetPlatforms,X)||!q&&B.properties.isPreReleaseVersion)return!1;let _=B.properties.engine;if(!_){const ie=await this.getManifest(B,A.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");_=ie.engines.vscode}return(0,h.$pp)(_,this.u.version,this.u.date)}async y(B,q,X,_,ie){if(!(0,S.$Go)(V(B),_,ie)||q!=="any"&&Q(B)!==(q==="prerelease"))return!1;if(X)try{const J=await this.E(B);if(!(0,h.$pp)(J,this.u.version,this.u.date))return!1}catch(J){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,j.$0)(J)),!1}return!0}async query(B,q){let X=B.text||"";const _=B.pageSize??50;let ie=new f().withPage(1,_);X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Category,Ee||me),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,me,Ee)=>(ie=ie.withFilter(t.Tag,Ee||me),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(ie=ie.withFilter(t.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),ie=ie.withFilter(t.SearchText,X)),ie=ie.withSortBy(0)):B.ids?ie=ie.withFilter(t.ExtensionId,...B.ids):B.names?ie=ie.withFilter(t.ExtensionName,...B.names):ie=ie.withSortBy(4),typeof B.sortBy=="number"&&(ie=ie.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(ie=ie.withSortOrder(B.sortOrder)),B.source&&(ie=ie.withSource(B.source));const J=async(de,me)=>{const{extensions:Ee,total:Re}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},me);return Ee.forEach((Oe,Ne)=>ee(Oe,(de.pageNumber-1)*de.pageSize+Ne,B.source)),{extensions:Ee,total:Re}},{extensions:ne,total:ce}=await J(ie,q),fe=async(de,me)=>{if(me.isCancellationRequested)throw new j.$5;const{extensions:Ee}=await J(ie.withPage(de+1),me);return Ee};return{firstPage:ne,total:ce,pageSize:ie.pageSize,getPage:fe}}async z(B,q,X){const _=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),q.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:ie,total:J,context:ne}=await this.B(B,X);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of ie){const Re=await this.A(Ee,q,ne);Re&&me.push(Re)}return{extensions:me,total:J}}const fe=[],de=new Map;for(let me=0;me<ie.length;me++){const Ee=ie[me],Re={id:(0,m.$cp)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,R.$Wf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ue=>(0,m.$0o)(ue,Re))?.includePreRelease;if(q.compatible&&(0,S.$Fo)(te(Ee),q.targetPlatform))continue;const Ne=await this.A(Ee,q,ne);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==q.targetPlatform&&Ne.hasPreReleaseVersion?de.set(Ee.extensionId,me):fe.push([me,Ne])}if(de.size){const me=new y.$Yd,Ee=new f().withFlags(_&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(t.ExtensionId,...de.keys()),{extensions:Re}=await this.z(Ee,q,X);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:de.size});for(const Oe of Re){const Ne=de.get(Oe.identifier.uuid);fe.push([Ne,Oe])}}return{extensions:fe.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:J}}async A(B,q,X){const _={id:(0,m.$cp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},ie=q.versions?.find(fe=>(0,m.$0o)(fe,_))?.version,J=(0,R.$Wf)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(fe=>(0,m.$0o)(fe,_))?.includePreRelease,ne=te(B),ce=oe(B.versions,q.targetPlatform);if(q.compatible&&(0,S.$Fo)(ne,q.targetPlatform))return null;for(let fe=0;fe<ce.length;fe++){const de=ce[fe];if(!(ie&&de.version!==ie)){if(await this.y(de,J?"any":"release",q.compatible,ne,q.targetPlatform))return ae(B,de,ne,X);if(ie&&de.version===ie)return null}}return ie||q.compatible?null:ae(B,B.versions[0],ne)}async B(B,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const X=await this.j,_=JSON.stringify(B.raw),ie={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},J=new y.$Yd;let ne,ce,fe=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:ie},q),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:fe};const de=await(0,l.$wp)(ne);if(de){const me=de.results[0],Ee=me.extensions,Re=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return fe=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(de){const me=(0,j.$4)(de)?S.ExtensionGalleryErrorCode.Cancelled:(0,j.$0)(de).startsWith("XHR timeout")?S.ExtensionGalleryErrorCode.Timeout:S.ExtensionGalleryErrorCode.Failed;throw ce=new S.$Ko((0,j.$0)(de),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(_.length),duration:J.elapsed(),success:!!ne&&(0,l.$sp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(fe)})}}async reportStatistic(B,q,X,_){if(!this.isEnabled())return;const ie=L.$o?this.x(`/itemName/${B}.${q}/version/${X}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${q}/${X}/stats?statType=${_}`),J=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:J};try{await this.k.request({type:"POST",url:ie,headers:ce},A.CancellationToken.None)}catch{}}async download(B,q,X){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const _=(0,m.$fp)(B),ie=new Date().getTime(),J=me=>this.o.publicLog("galleryService:downloadVSIX",{..._,duration:me}),ne=X===2?"install":X===3?"update":"",ce=ne?{uri:`${B.assets.download.uri}${k.URI.parse(B.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${B.assets.download.fallbackUri}${k.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:B.assets.download,fe=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,de=await this.D(ce,fe?{headers:fe}:void 0);await this.q.writeFile(q,de.stream),J(new Date().getTime()-ie)}async downloadSignatureArchive(B,q){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const X=await this.D(B.assets.signature);await this.q.writeFile(q,X.stream)}async getReadme(B,q){if(B.assets.readme){const X=await this.D(B.assets.readme,{},q);return await(0,l.$vp)(X)||""}return""}async getManifest(B,q){if(B.assets.manifest){const X=await this.D(B.assets.manifest,{},q),_=await(0,l.$vp)(X);return _?JSON.parse(_):null}return null}async C(B,q){const X=M(B,r.Manifest);if(!X)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},ie=await this.D(X,{headers:_});return await(0,l.$wp)(ie)}async getCoreTranslation(B,q){const X=B.assets.coreTranslations.filter(_=>_[0]===q.toUpperCase())[0];if(X){const _=await this.D(X[1]),ie=await(0,l.$vp)(_);return ie?JSON.parse(ie):null}return null}async getChangelog(B,q){if(B.assets.changelog){const X=await this.D(B.assets.changelog,{},q);return await(0,l.$vp)(X)||""}return""}async getAllCompatibleVersions(B,q,X){let _=new f().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?_=_.withFilter(t.ExtensionId,B.identifier.uuid):_=_.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:ie}=await this.B(_,A.CancellationToken.None);if(!ie.length)return[];const J=te(ie[0]);if((0,S.$Fo)(J,X))return[];const ne=[];await Promise.all(ie[0].versions.map(async de=>{try{await this.y(de,q?"any":"release",!0,J,X)&&ne.push(de)}catch{}}));const ce=[],fe=new Set;for(const de of oe(ne,X))fe.has(de.version)||(fe.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:Q(de)}));return ce}async D(B,q={},X=A.CancellationToken.None){const _=await this.j,ie={type:"GET"},J={..._,...q.headers||{}};q={...q,...ie,headers:J};const ne=B.uri,ce=B.fallbackUri,fe={...q,url:ne};try{const de=await this.k.request(fe,X);if(de.res.statusCode===200)return de;const me=await(0,l.$vp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${me}`)}catch(de){if((0,j.$4)(de))throw de;const me=(0,j.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:me});const Ee={...q,url:ce};return this.k.request(Ee,X)}}async E(B){let q=Y(B);if(!q){const X=await this.C(B,A.CancellationToken.None);if(!X)throw new Error("Manifest was not found");q=X.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,l.$wp)(B),X=[],_={},ie=[];if(q){for(const J of q.malicious)X.push({id:J});if(q.migrateToPreRelease)for(const[J,ne]of Object.entries(q.migrateToPreRelease))(!ne.engine||(0,h.$pp)(ne.engine,this.u.version,this.u.date))&&(_[J.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[J,ne]of Object.entries(q.deprecated))ne&&(_[J.toLowerCase()]=(0,R.$Wf)(ne)?{}:ne);if(q.search)for(const J of q.search)ie.push(J)}return{malicious:X,deprecated:_,search:ie}}};W=ye([K(1,l.$qp),K(2,p.$wj),K(3,C.$ji),K(4,c.$Dl),K(5,$.$zk),K(6,E.$Oj),K(7,g.$Ii)],W);let z=class extends W{constructor(B,q,X,_,ie,J,ne,ce){super(B,q,X,_,ie,J,ne,ce)}};e.$Mp=z,e.$Mp=z=ye([K(0,d.$Dp),K(1,l.$qp),K(2,p.$wj),K(3,C.$ji),K(4,c.$Dl),K(5,$.$zk),K(6,E.$Oj),K(7,g.$Ii)],z);let D=class extends W{constructor(B,q,X,_,ie,J,ne){super(void 0,B,q,X,_,ie,J,ne)}};e.$Np=D,e.$Np=D=ye([K(0,l.$qp),K(1,p.$wj),K(2,C.$ji),K(3,c.$Dl),K(4,$.$zk),K(5,E.$Oj),K(6,g.$Ii)],D)}),define(le[83],he([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,O,A,j,L,I,R,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=void 0,e.$vv=(0,O.$ci)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends j.$Tc{static{S=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,I.$bp)(p.id)}@${p.version}`}static c(p){const E=m.exec(p);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(p,E){const l=await p.getInstalled(),u=[];for(const[d,c]of S.f(E)){const y=l.find(i=>(0,I.$0o)(i.identifier,{id:d}))?.manifest.version;for(const i of c)y!==i&&u.push(S.b({id:d,version:i}))}for(const d of u)E.remove(d,0)}static f(p){const E=new Map,l=p.keys(0,1);for(const u of l){const d=S.c(u);if(d){let c=E.get(d.id.toLowerCase());c||E.set(d.id.toLowerCase(),c=[]),c.push(d.version)}}return E}constructor(p,E,l){super(),this.j=p,this.m=E,this.n=l,this.g=this.B(new A.$3d),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(p),this.B(this.j.onDidChangeValue(0,void 0,this.B(new j.$Sc))(u=>this.r(u)))}r(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const E=S.c(p.key);if(E){if(this.j.get(p.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let l=this.h.get(E.id.toLowerCase());l||this.h.set(E.id.toLowerCase(),l=[]),l.push(E.version),this.g.fire()}return}}s(p){if((0,C.$Qf)(p))return p;const E=p.manifest?p.manifest.publisher:p.publisher,l=p.manifest?p.manifest.name:p.name;return(0,I.$ap)(E,l)}getExtensionState(p,E){const l=this.s(p),u=this.getExtensionStateRaw(p,E);if(u)try{return JSON.parse(u)}catch(d){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${E}): ${d}`)}}getExtensionStateRaw(p,E){const l=this.s(p),u=this.j.get(l,E?0:1);return u&&u?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${E}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(p,E,l){const u=this.s(p);E===void 0?this.j.remove(u,l?0:1):this.j.store(u,JSON.stringify(E),l?0:1,1)}setKeysForSync(p,E){this.j.store(S.b(p),JSON.stringify(E),0,1)}getKeysForSync(p){const E=this.m.extensionSyncedKeys?.[p.id.toLowerCase()],l=this.j.get(S.b(p),0),u=l?JSON.parse(l):void 0;return u&&E?(0,k.$Mb)([...u,...E]):u||E}addToMigrationList(p,E){if(p!==E){const l=this.t.filter(u=>!u.includes(p)&&!u.includes(E));l.push([p,E]),this.t=l}}getSourceExtensionToMigrate(p){const E=this.t.find(([,l])=>p===l);return E?E[0]:void 0}get t(){const p=this.j.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(p);if(Array.isArray(E))return E}catch{}return[]}set t(p){p.length?this.j.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$wv=h,e.$wv=h=S=ye([K(0,L.$Dp),K(1,R.$Oj),K(2,g.$wj)],h)}),define(le[249],he([0,1,2,29,83,224,113,8,19]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;let g=class extends O.$Tc{constructor(S,m,h,$,p,E){super(),S.cleanUp(),(0,L.$k1b)(S,m,h,$,E),j.$wv.removeOutdatedExtensionVersions(S,p)}};e.$Rac=g,e.$Rac=g=ye([K(0,I.$gq),K(1,A.$Io),K(2,j.$vv),K(3,A.$Oo),K(4,k.$Dp),K(5,R.$wj)],g)}),define(le[250],he([0,1,29,11,24,15,97,57,19,22,223]),function(se,e,O,A,j,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=void 0;let S=class extends C.$b0b{constructor(h,$,p,E,l,u,d,c){super(h.userHome,l,$,p,E,u,d,c)}};e.$Yac=S,e.$Yac=S=ye([K(0,L.$ki),K(1,g.$Dl),K(2,O.$Lo),K(3,k.$Dp),K(4,R.$N$b),K(5,I.$7Zb),K(6,A.$zk),K(7,j.$Oj)],S)}),define(le[251],he([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,165,36,19,12,132,20]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uac=void 0;const y=[O.$Nac,O.$Oac],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends I.$Tc{constructor(a,v,w,f,b,P,N){super(),this.y=a,this.z=v,this.C=w,this.D=P,this.F=N,this.f=new A.$3d,this.onDidTokenFailed=this.f.event,this.g=new A.$3d,this.onDidChangeTunnelStatus=this.g.event,this.h=new A.$3d,this.onDidChangeMode=this.h.event,this.n=O.$Lac,this.w=!1,this.I=(F,M)=>{M?this.j.error(F):this.j.info(F)},this.j=this.B(f.createLogger((0,c.$Pg)(w.logsHome,`${O.$Pac}.log`),{id:O.$Pac,name:O.$Qac})),this.t=new m.$_g(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,R.$Lj)(F)))),this.B(b.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(P.onDidChangeConfiguration(F=>{y.some(M=>F.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(O.$Lac);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(M,U)=>{U?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,p.localize)(0,null)))},f=this.O("status",["status"],w);this.r=f;try{if(await f,this.r!==f)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(O.TunnelStates.disconnected());return}if(v=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(O.TunnelStates.disconnected());return}finally{this.r===f&&(this.r=void 0)}const b=this.n.active?this.n.session:void 0;if(b&&b.token){const M=b.token;this.G(O.TunnelStates.connecting((0,p.localize)(1,null,b.accountLabel,b.providerId)));const U=(Q,x)=>{Q=Q.replaceAll(M,"*".repeat(4)),w(Q,x)},Y=this.O("login",["user","login","--provider",b.providerId,"--access-token",M,"--log",(0,R.$Lj)(this.j.getLevel())],U);this.r=Y;try{if(await Y,this.r!==Y)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(b),this.G(O.TunnelStates.disconnected(b));return}}const P=this.Q();P?this.G(O.TunnelStates.connecting((0,p.localize)(2,null,P))):this.G(O.TunnelStates.connecting((0,p.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.$Lj)(this.j.getLevel())];P?N.push("--name",P):N.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!v&&(F=await this.M(N)===!1),this.N(b,N,F)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,p.localize)(4,null);return this.j.warn(w),this.G(O.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let f=!1;const b=this.O("tunnel",v,(P,N)=>{N?this.j.error(P):this.j.info(P),P.includes("Connected to an existing tunnel process")&&(f=!0);const F=P.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:f};this.G(O.TunnelStates.connected(M,w))}else P.match(/error refreshing token/)&&(b.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=b,b.finally(()=>{b===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$Lac,this.G(O.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,m.$2g)(f=>new Promise((b,P)=>{f.isCancellationRequested&&b(-1);let N;const F=["ignore","pipe","pipe"];if(f.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:F});else{w(`Running tunnel CLI
`,!1);const M=this.J();w(`${a} Spawning: ${M} tunnel ${v.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...v],{cwd:(0,E.homedir)(),stdio:F})}N.stdout.pipe(new d.$tV(`
`)).on("data",M=>{if(N){const U=M.toString();w(U,!1)}}),N.stderr.pipe(new d.$tV(`
`)).on("data",M=>{if(N){const U=M.toString();w(U,!0)}}),N.on("exit",M=>{N&&(w(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,b(M||0))}),N.on("error",M=>{N&&(w(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,P())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$Oac)}Q(){let a=this.D.getValue(O.$Nac)||(0,E.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,u.$Qf)(w.accountLabel)&&(0,u.$Qf)(w.sessionId)&&(0,u.$Qf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$Lac}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$Uac=n,e.$Uac=n=ye([K(0,j.$Dl),K(1,C.$Oj),K(2,L.$ki),K(3,R.$xj),K(4,h.$Sac),K(5,$.$Ii),K(6,l.$Dp)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,20,69,19,78,18]),function(se,e,O,A,j,L,I,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;class C extends R.$Fp{constructor(m,h,$,p){super(),this.bb=m,this.cb=h,this.db=$,this.eb=p,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new A.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new A.$Sc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new k.$YGb(this.db.getChannel("storage"))),h=this.B(new I.$zp(m));return this.B(h.onDidChangeStorage($=>this.u(-1,$))),h}gb(m){this.X.clear(),this.W=m;let h;if((0,R.$Gp)(m))h=this.U;else{const $=this.X.add(new k.$ZGb(this.db.getChannel("storage"),m));h=this.X.add(new I.$zp($))}return this.X.add(h.onDidChangeStorage($=>this.u(0,$))),h}hb(m){this.$.clear(),this.Z=m?.id;let h;if(m){const $=this.$.add(new k.$1Gb(this.db.getChannel("storage"),m));h=this.$.add(new I.$zp($)),this.$.add(h.onDidChangeStorage(p=>this.u(1,p)))}return h}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:j.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$Pg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:j.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const h=this.Y,$=h.items;h!==this.U&&await h.close(),this.Y=this.gb(m),await this.Y.init(),this.N($,this.Y,0)}async S(m,h){const $=this.ab,p=$?.items??new Map;await $?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(p,this.ab,1)}hasScope(m){return(0,g.$$k)(m)?this.W.id===m.id:this.Z===m.id}}e.$Zac=C}),define(le[253],he([0,1,3,2,18,92]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.$DP=void 0;class I{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,L.$dn)({...h},S)),added:m.added.map(h=>(0,L.$dn)({...h},S)),removed:m.removed.map(h=>(0,L.$dn)({...h},S)),updated:m.updated.map(h=>(0,L.$dn)({...h},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const m=this.b(g);switch(C){case"createProfile":{const h=await this.a.createProfile(S[0],S[1],S[2]);return(0,L.$dn)({...h},m)}case"updateProfile":{let h=(0,j.$al)((0,L.$en)(S[0],m),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,S[1]),(0,L.$dn)({...h},m)}case"removeProfile":{const h=(0,j.$al)((0,L.$en)(S[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$DP=I;class R extends A.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new O.$3d),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(m=>(0,j.$al)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const h=m.added.map(E=>(0,j.$al)(E,this.profilesHome.scheme)),$=m.removed.map(E=>(0,j.$al)(E,this.profilesHome.scheme)),p=m.updated.map(E=>(0,j.$al)(E,this.profilesHome.scheme));this.a=m.all.map(E=>(0,j.$al)(E,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const m=await this.f.call("createNamedProfile",[g,C,S]);return(0,j.$al)(m,this.profilesHome.scheme)}async createProfile(g,C,S,m){const h=await this.f.call("createProfile",[g,C,S,m]);return(0,j.$al)(h,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,j.$al)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,j.$al)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$EP=R}),define(le[60],he([0,1,2,69,4,19,3,78,18]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Gb=e.$4Gb=e.$3Gb=void 0,e.$3Gb=(0,j.$ci)("IUserDataProfileStorageService");let g=class extends O.$Tc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async $=>this.b($))}async updateStorageData(h,$,p){return this.withProfileScopedStorageService(h,async E=>this.c(E,$,p))}async withProfileScopedStorageService(h,$){if(this.a.hasScope(h))return $(this.a);const p=await this.g(h),E=new S(p);try{await E.initialize();const l=await $(E);return await E.flush(),l}finally{E.dispose(),await this.f(p)}}b(h){const $=new Map,p=E=>{for(const l of h.keys(0,E))$.set(l,{value:h.get(l,0),target:E})};return p(0),p(1),$}c(h,$,p){h.storeAll(Array.from($.entries()).map(([E,l])=>({key:E,value:l,scope:0,target:p})),!0)}async f(h){try{await h.close()}finally{(0,O.$Nc)(h)&&h.dispose()}}};e.$4Gb=g,e.$4Gb=g=ye([K(0,L.$Dp)],g);class C extends g{constructor(h,$,p,E){super(p),this.j=h;const l=h.getChannel("profileStorageListener"),u=this.B(new O.$Uc);this.h=this.B(new I.$3d({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(d=>{E.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(c=>(0,k.$al)(c,$.profilesHome.scheme)),valueChanges:d.valueChanges.map(c=>({...c,profile:(0,k.$al)(c.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const $=this.j.getChannel("storage");return(0,L.$Gp)(h)?new R.$YGb($):new R.$ZGb($,h)}}e.$5Gb=C;class S extends L.$Fp{constructor(h){super({flushInterval:100}),this.s=this.B(new A.$zp(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,19,8,18,56,60]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;let R=class extends I.$5Gb{constructor(g,C,S,m){super(g,C,S,m)}};e.$Eac=R,e.$Eac=R=ye([K(0,L.$4_b),K(1,j.$_k),K(2,O.$Dp),K(3,A.$wj)],R)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,170,21,15,11,8,43,19,22,28,25,18]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4Hb=e.$3Hb=e.$2Hb=e.$1Hb=e.$ZHb=e.$YHb=e.$XHb=void 0;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$XHb=i;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$YHb=o;function n(v,w){return`${(0,g.$If)(v)}${w.isDefault?"":` (${w.name})`}`}e.$ZHb=n;let s=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,f,b,P,N,F,M,U,Y,Q,x,G){super(),this.syncResource=w,this.collection=f,this.G=b,this.H=P,this.I=N,this.J=F,this.L=M,this.M=U,this.N=Y,this.O=Q,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$3d),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$3d),this.onDidChangeConflicts=this.t.event,this.u=this.B(new A.$ah(50)),this.w=this.B(new I.$3d),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(w.syncResource,w.profile),this.h=G.extUri,this.f=this.h.joinPath(P.userDataSyncHome,...(0,c.$Bob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,c.$Wob),this.y=(0,c.$Cob)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,P,this.h),this.j=(0,E.$Jp)(P,b,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const f=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(f)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,f={}){await this.U(w,!0,this.ob(),f)}async preview(w,f,b={}){return this.U(w,!1,f,b)}async apply(w,f={}){try{this.F={...f};const b=await this.ab(w);return this.S(b),this.c}finally{this.F={}}}async U(w,f,b,P){try{if(this.F={...P},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const F=await this.getLastSyncUserData(),M=await this.X(w,F);return N=await this.Y(M,F,f,b),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(w){const f=this.kb(w);if(!f)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const b=await this.getLastSyncUserData(),P=await this.X(null,b),N=await this.W(P),F=await this.qb({ref:P.ref,syncData:f},b,N,this.ob(),L.CancellationToken.None),M=[];for(const U of F){const Y=await this.sb(U,U.remoteResource,void 0,L.CancellationToken.None),{remoteChange:Q}=await this.sb(U,U.previewResource,U.remoteContent,L.CancellationToken.None);M.push([U,{...Y,remoteChange:Q!==0?Q:2}])}await this.tb(P,b,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const f=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===f}async X(w,f){if(f){const b=w?w[this.resource]:void 0;if(f.ref===b||b===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async Y(w,f,b,P){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$Job((0,S.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,f,b,P)}catch(N){if(N instanceof c.$Job)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,f,b,P);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.Y(w,f,b,P)}throw N}}async Z(w,f,b,P){try{const N=await this.W(w),F=!N&&f===null&&this.gb()!==void 0,M=b&&!F;this.c||(this.c=(0,A.$2g)(Y=>this.eb(w,f,N,M,P,Y)));let U=await this.c;if(b&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of U.resourcePreviews)U=await this.accept(Y.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":b?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(w){return await this.$(w,async f=>{const b=await this.rb(f,L.CancellationToken.None);await this.G.writeFile(f.previewResource,j.$qe.fromString(b?.content||""));const P=b&&!b.hasConflicts?await this.sb(f,f.previewResource,void 0,L.CancellationToken.None):void 0;return f.acceptResult=P,f.mergeState=b.hasConflicts?"conflict":P?"accepted":"preview",f.localChange=P?P.localChange:b.localChange,f.remoteChange=P?P.remoteChange:b.remoteChange,f}),this.c}async accept(w,f){return await this.$(w,async b=>{const P=await this.sb(b,w,f,L.CancellationToken.None);return b.acceptResult=P,b.mergeState="accepted",b.localChange=P.localChange,b.remoteChange=P.remoteChange,b}),this.c}async discard(w){return await this.$(w,async f=>{const b=await this.rb(f,L.CancellationToken.None);return await this.G.writeFile(f.previewResource,j.$qe.fromString(b.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=b.localChange,f.remoteChange=b.remoteChange,f}),this.c}async $(w,f){if(!this.c)return;let b=await this.c;const P=b.resourcePreviews.findIndex(({localResource:N,remoteResource:F,previewResource:M})=>this.h.isEqual(N,w)||this.h.isEqual(F,w)||this.h.isEqual(M,w));P!==-1&&(this.c=(0,A.$2g)(async N=>{const F=[...b.resourcePreviews];return F[P]=await f(F[P]),{...b,resourcePreviews:F}}),b=await this.c,this.cb(b.resourcePreviews),b.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.tb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(b=>[b,b.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const f=w.filter(({mergeState:b})=>b==="conflict");(0,O.$ub)(this.s,f,(b,P)=>this.h.isEqual(b.previewResource,P.previewResource))||(this.s=f,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const f=this.c?await this.c:null;if(f)for(const b of f.resourcePreviews){if(this.h.isEqual(b.acceptedResource,w))return b.acceptResult?b.acceptResult.content:null;if(this.h.isEqual(b.remoteResource,w))return b.remoteContent;if(this.h.isEqual(b.localResource,w))return b.localContent;if(this.h.isEqual(b.baseResource,w))return b.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$Qk)(w)!==1&&this.O.error(w)}}async eb(w,f,b,P,N,F){const M=await this.qb(w,f,b,N,F),U=[];for(const Y of M){const Q=Y.previewResource.with({scheme:c.$Vob,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)U.push({...Y,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=P?await this.rb(Y,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,j.$qe.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,F):void 0;U.push({...Y,acceptResult:G,mergeState:x?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:x?x.localChange:Y.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:f,resourcePreviews:U,isLastSyncFromCurrentMachine:b}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const f=JSON.parse(w),b=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!f.version&&!!b&&f.version!==b,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;let P,N=1;for(;P===void 0&&N++<6;)try{const F=await this.hb();F&&(F.ref===f.ref?P=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof $.$Uk&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof c.$Job)throw F;this.O.error(F,N)}}if(P===void 0)try{const F=await this.J.resolveResourceContent(this.resource,f.ref,this.collection,this.F);P=F===null?null:this.kb(F),await this.ib({ref:f.ref,syncData:P})}catch(F){if(F instanceof c.$Job&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return P===void 0?null:{...f,syncData:P}}async fb(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const b=this.M.getResourceSyncStateVersion(this.resource),P={ref:w.ref,version:b,...f};this.I.store(this.z,JSON.stringify(P),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const f=w?JSON.parse(w):void 0;if(i(f))return f}catch(f){this.O.error(f)}}async ib(w){await this.G.writeFile(this.y,j.$qe.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),f=JSON.parse(w.value.toString());await this.G.del(this.y),f.ref&&f.content!==void 0?(this.I.store(this.z,JSON.stringify({...f,content:void 0}),-1,1),await this.ib({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,f)}catch(w){w instanceof $.$Uk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:f,content:b}=await this.lb(w);let P=null;return b!==null&&(P=this.kb(b)),{ref:f,syncData:P}}kb(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.O.error(f)}throw new c.$Job((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const f=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,f,this.collection,this.F)}async mb(w,f){const b=await this.j,P={version:this.pb,machineId:b,content:w};try{return f=await this.J.writeResource(this.resource,JSON.stringify(P),f,this.collection,this.F),{ref:f,syncData:P}}catch(N){throw N instanceof c.$Job&&N.code==="TooLarge"&&(N=new c.$Job(N.message,N.code,this.resource)),N}}async nb(w){const f={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(f),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$wob)}};e.$1Hb=s,e.$1Hb=s=ye([K(2,$.$zk),K(3,h.$ji),K(4,l.$Dp),K(5,c.$Eob),K(6,c.$Fob),K(7,c.$Oob),K(8,u.$Dl),K(9,c.$Tob),K(10,m.$Ii),K(11,d.$0k)],s);let t=class extends s{constructor(w,f,b,P,N,F,M,U,Y,Q,x,G,Z){super(f,b,P,N,F,M,U,Y,Q,x,G,Z),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(H=>this.yb(H)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,f,b){try{f?await this.G.writeFile(this.r,j.$qe.fromString(w),b?void 0:f):await this.G.createFile(this.r,j.$qe.fromString(w),{overwrite:b})}catch(P){throw P instanceof $.$Uk&&P.fileOperationResult===1||P instanceof $.$Uk&&P.fileOperationResult===3?new c.$Job(P.message,"LocalPreconditionFailed"):P}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$Uk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$2Hb=t,e.$2Hb=t=ye([K(3,$.$zk),K(4,h.$ji),K(5,l.$Dp),K(6,c.$Eob),K(7,c.$Fob),K(8,c.$Oob),K(9,u.$Dl),K(10,c.$Tob),K(11,m.$Ii),K(12,d.$0k)],t);let r=class extends t{constructor(w,f,b,P,N,F,M,U,Y,Q,x,G,Z,H){super(w,f,b,P,N,F,M,U,Y,Q,x,Z,H),this.zb=G,this.Bb=void 0}Ab(w,f){const b=[],P=(0,R.$mn)(w,b,{allowEmptyContent:!0,allowTrailingComma:!0});return b.length>0||!(0,C.$Xf)(P)&&f!==Array.isArray(P)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$3Hb=r,e.$3Hb=r=ye([K(3,$.$zk),K(4,h.$ji),K(5,l.$Dp),K(6,c.$Eob),K(7,c.$Fob),K(8,c.$Oob),K(9,u.$Dl),K(10,c.$Tob),K(11,c.$Sob),K(12,m.$Ii),K(13,d.$0k)],r);let a=class{constructor(w,f,b,P,N,F,M){this.resource=w,this.g=f,this.h=b,this.j=P,this.k=N,this.l=F,this.d=M.extUri,this.f=(0,c.$Cob)(void 0,this.resource,b,this.d)}async initialize({ref:w,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const b=this.m(f);if(b)try{await this.o({ref:w,syncData:b})}catch(P){this.j.error(P)}}m(w){try{const f=JSON.parse(w);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const b={ref:w.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(b),-1,1),await this.k.writeFile(this.f,j.$qe.fromString(JSON.stringify(w)))}};e.$4Hb=a,e.$4Hb=a=ye([K(1,y.$_k),K(2,h.$ji),K(3,p.$wj),K(4,$.$zk),K(5,l.$Dp),K(6,d.$0k)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,235,111,25,60]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l8b=e.$k8b=e.$j8b=e.$i8b=e.$h8b=void 0;async function v(F,M){const U=JSON.parse(F.content);if(F.version===1||F.version===2){const Y=(await M.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of U)F.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),F.version===2&&Y.every(x=>!(0,h.$0o)(x.identifier,Q.identifier))&&(Q.installed=!0)}return U}function w(F){return JSON.parse(F.content)}e.$h8b=w;function f(F,M){return F.sort((U,Y)=>!U.identifier.uuid&&Y.identifier.uuid?-1:U.identifier.uuid&&!Y.identifier.uuid?1:(0,k.$af)(U.identifier.id,Y.identifier.id)),M?(0,I.$xn)(F,{}):JSON.stringify(F)}e.$i8b=f;let b=class extends n.$1Hb{constructor(M,U,Y,Q,x,G,Z,H,V,te,oe,ee,ae,W,z,D,T){super({syncResource:"extensions",profile:M},U,Q,Y,x,G,Z,ee,ae,te,oe,z),this.Cb=H,this.Db=V,this.Eb=T,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Vob,authority:"base"}),this.yb=this.wb.with({scheme:r.$Vob,authority:"local"}),this.zb=this.wb.with({scheme:r.$Vob,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Vob,authority:"accepted"}),this.Bb=this.Eb.createInstance(P),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:q})=>!!q)),L.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),L.Event.filter(D.onDidChange,B=>B.valueChanges.some(({profile:q,changes:X})=>this.syncResource.profile.id===q.id&&X.some(_=>_.key===m.$Mo))),W.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,U){const Y=M.syncData?await v(M.syncData,this.Cb):null,Q=U?.skippedExtensions??[],x=U?.builtinExtensions??null,G=U?.syncData?await v(U.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:H}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:te}=(0,s.$g8b)(Z,Y,G,Q,H,x),oe={local:V,remote:te,content:this.Hb(Z,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:te!==null?2:0},ee=this.Ob(Z,!1);return[{skippedExtensions:Q,builtinExtensions:x,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ee,localResource:this.yb,localContent:ee,localExtensions:Z,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:oe,localChange:oe.localChange,remoteChange:oe.remoteChange,acceptedResource:this.Ab}]}async ub(M){const U=M.syncData?await v(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$g8b)(Y,U,U,M.skippedExtensions||[],Q,M.builtinExtensions||[]);return x!==null}Hb(M,U,Y,Q){const x=[...U,...Y],G=new Set,Z=H=>{G.add(H.id.toLowerCase()),H.uuid&&G.add(H.uuid)};x.forEach(({identifier:H})=>Z(H)),Q.forEach(Z);for(const H of M)G.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&G.has(H.identifier.uuid)||x.push(H);return this.Ob(x,!1)}async rb(M,U){return{...M.previewResult,hasConflicts:!1}}async sb(M,U,Y,Q){if(this.h.isEqual(U,this.yb))return this.Kb(M);if(this.h.isEqual(U,this.zb))return this.Lb(M);if(this.h.isEqual(U,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),Q=(0,s.$g8b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:G}=Q;return{content:M.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Lb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),Q=M.remoteContent?JSON.parse(M.remoteContent):null;if(Q!==null){const x=(0,s.$g8b)(M.localExtensions,Q,M.localExtensions,[],Y,M.builtinExtensions),{local:G,remote:Z}=x;return{content:M.remoteContent,local:G,remote:Z,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,U,Y,Q){let{skippedExtensions:x,builtinExtensions:G,localExtensions:Z}=Y[0][0];const{local:H,remote:V,localChange:te,remoteChange:oe}=Y[0][1];if(te===0&&oe===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Z)),x=await this.Bb.updateLocalExtensions(H.added,H.removed,H.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(V.all);M=await this.mb(ee,Q?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ae=>ae.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ae=>ae.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ae=>ae.identifier.id))}.`:""}`)}U?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(Z,G),await this.fb(M,{skippedExtensions:x,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,U){const Y=new Set,Q=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||Q.push(x.identifier);if(U)for(const x of U)Y.has(x.id.toLowerCase())||Q.push(x);return Q}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const U=await this.db(M);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(M,U){return f(M,U)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$j8b=b,e.$j8b=b=ye([K(2,C.$ji),K(3,E.$zk),K(4,c.$Dp),K(5,r.$Eob),K(6,r.$Fob),K(7,m.$Lo),K(8,t.$JIb),K(9,r.$Tob),K(10,g.$Ii),K(11,r.$Oob),K(12,y.$Dl),K(13,$.$vv),K(14,i.$0k),K(15,a.$3Gb),K(16,l.$bi)],b);let P=class{constructor(M,U,Y,Q,x,G){this.a=M,this.b=U,this.c=Y,this.d=Q,this.f=x,this.g=G}async getLocalExtensions(M){const U=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(M,async(x,G)=>{const Z=x.getDisabledExtensions();return U.map(H=>{const{identifier:V,isBuiltin:te,manifest:oe,preRelease:ee,pinned:ae,isApplicationScoped:W}=H,z={identifier:V,preRelease:ee,version:oe.version,pinned:!!ae};W&&!(0,p.$xm)(oe)&&(z.isApplicationScoped=W),Z.some(D=>(0,h.$0o)(D,V))&&(z.disabled=!0),te||(z.installed=!0);try{const D=G.getKeysForSync({id:V.id,version:oe.version});if(D){const T=G.getExtensionState(H,!0)||{};z.state=Object.keys(T).reduce((B,q)=>(D.includes(q)&&(B[q]=T[q]),B),{})}}catch(D){this.g.info(`${(0,n.$ZHb)("extensions",M)}: Error while parsing extension state`,(0,j.$0)(D))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(M,U,Y,Q,x){const G=(0,n.$ZHb)("extensions",x),Z=[],H=new Map,V=[],te=[],oe=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(W,z)=>{await O.Promises.settled([...M,...Y].map(async D=>{const T=oe.find(X=>(0,h.$0o)(X.identifier,D.identifier));if(T&&T.isBuiltin){D.state&&T.manifest.version===D.version&&this.h(D.state,T,T.manifest.version,z),W.getDisabledExtensions().some(_=>(0,h.$0o)(_,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${G}: Disabling extension...`,D.identifier.id),await W.disableExtension(D.identifier),this.g.info(`${G}: Disabled extension`,D.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,D.identifier.id),await W.enableExtension(D.identifier),this.g.info(`${G}: Enabled extension`,D.identifier.id))),V.push(D.identifier);return}const B=D.pinned?D.version:void 0,q=(await this.c.getExtensions([{...D.identifier,version:B,preRelease:B?void 0:D.preRelease}],A.CancellationToken.None))[0];if(D.state&&(T?T.manifest.version===D.version:q)&&this.h(D.state,T||q,T?.manifest.version,z),q)try{W.getDisabledExtensions().some(_=>(0,h.$0o)(_,D.identifier))!==!!D.disabled&&(D.disabled?(this.g.trace(`${G}: Disabling extension...`,D.identifier.id,q.version),await W.disableExtension(q.identifier),this.g.info(`${G}: Disabled extension`,D.identifier.id,q.version)):(this.g.trace(`${G}: Enabling extension...`,D.identifier.id,q.version),await W.enableExtension(q.identifier),this.g.info(`${G}: Enabled extension`,D.identifier.id,q.version))),(!T||T.preRelease!==D.preRelease||T.pinned!==D.pinned||B&&T.manifest.version!==B)&&(await this.a.canInstall(q)?(Z.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:D.pinned&&!!D.version,installPreReleaseVersion:D.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:D.isApplicationScoped,context:{[m.$zo]:!0,[m.$Ao]:!0}}}),H.set(q.identifier.id.toLowerCase(),D)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(D)))}catch(X){te.push(D),this.g.error(X),this.g.info(`${G}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(D),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}))}),U.length){const W=oe.filter(({identifier:z,isBuiltin:D})=>!D&&U.some(T=>(0,h.$0o)(z,T)));await O.Promises.settled(W.map(async z=>{this.g.trace(`${G}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,z.identifier.id),V.push(z.identifier)}))}const ee=await this.a.installGalleryExtensions(Z);for(const{identifier:W,local:z,error:D,source:T}of ee){const B=T;if(z)this.g.info(`${G}: Installed extension.`,W.id,B.version),V.push(W);else{const q=H.get(W.id.toLowerCase());q&&(te.push(q),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),D instanceof m.$Jo&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(D.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):D&&this.g.error(D)}}const ae=[];for(const W of Q)V.some(z=>(0,h.$0o)(z,W.identifier))||ae.push(W);for(const W of te)ae.some(z=>(0,h.$0o)(z.identifier,W.identifier))||ae.push(W);return ae}h(M,U,Y,Q){const x=Q.getExtensionState(U,!0)||{},G=Y?Q.getKeysForSync({id:U.identifier.id,version:Y}):void 0;G?G.forEach(Z=>{x[Z]=M[Z]}):Object.keys(M).forEach(Z=>x[Z]=M[Z]),Q.setExtensionState(U,x,!0)}async j(M,U){return this.b.withProfileScopedStorageService(M,async Y=>{const Q=new R.$Sc,x=this.f.createChild(new u.$ai([c.$Dp,Y])),G=Q.add(x.createInstance(S.$oGb)),Z=Q.add(x.createInstance($.$wv));try{return await U(G,Z)}finally{Q.dispose()}})}};e.$k8b=P,e.$k8b=P=ye([K(0,m.$Lo),K(1,a.$3Gb),K(2,m.$Io),K(3,t.$JIb),K(4,l.$bi),K(5,r.$Tob)],P);let N=class extends n.$4Hb{constructor(M,U,Y,Q,x,G,Z,H){super("extensions",Q,x,G,Y,Z,H),this.p=M,this.q=U}async t(M){return M.syncData?await v(M.syncData,this.p):null}u(M,U){const Y=[],Q=[],x=[];for(const G of M){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const Z=U.find(H=>(0,h.$0o)(H.identifier,G.identifier));Z?(Y.push(Z),G.disabled&&x.push(G.identifier)):G.installed&&(Q.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:Y,newExtensions:Q,disabledExtensions:x,remoteExtensions:M}}};e.$l8b=N,e.$l8b=N=ye([K(0,m.$Lo),K(1,t.$JIb),K(2,E.$zk),K(3,o.$_k),K(4,C.$ji),K(5,d.$wj),K(6,c.$Dp),K(7,i.$0k)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,239,25,18,60,4]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Hb=e.$9Hb=e.$8Hb=e.$7Hb=e.$6Hb=void 0;const n="globalState.argv.",s=["locale"];function t(b,P){const N=b.storage?Object.keys(b.storage).sort():[],F={};return N.forEach(M=>F[M]=b.storage[M]),b.storage=F,P?(0,I.$xn)(b,{}):JSON.stringify(b)}e.$6Hb=t;const r=1;let a=class extends l.$1Hb{constructor(P,N,F,M,U,Y,Q,x,G,Z,H,V,te,oe){super({syncResource:"globalState",profile:P},N,M,x,V,U,Y,G,Z,Q,H,te),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$Vob,authority:"base"}),this.xb=this.vb.with({scheme:c.$Vob,authority:"local"}),this.yb=this.vb.with({scheme:c.$Vob,authority:"remote"}),this.zb=this.vb.with({scheme:c.$Vob,authority:"accepted"}),this.Ab=oe.createInstance(v),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(j.Event.any(j.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),j.Event.filter(F.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:W})=>this.syncResource.profile.id===ae.id&&W.some(z=>z.target===0)))))(()=>this.Q()))}async qb(P,N,F){const M=P.syncData?JSON.parse(P.syncData.content):null;N=N===null&&F?P:N;const U=N&&N.syncData?JSON.parse(N.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(U),{local:x,remote:G}=(0,d.$5Hb)(Y.storage,M?M.storage:null,U?U.storage:null,Q,this.O),Z={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:G.all!==null?2:0},H=t(Y,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):H,localResource:this.xb,localContent:H,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(N===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:U}=(0,d.$5Hb)(F.storage,N.storage,N.storage,M,this.O);return U.all!==null}async rb(P,N){return{...P.previewResult,hasConflicts:!1}}async sb(P,N,F,M){if(this.h.isEqual(N,this.xb))return this.Gb(P);if(this.h.isEqual(N,this.yb))return this.Hb(P);if(this.h.isEqual(N,this.vb))return P.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(P){return{content:P.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(P.localUserData.storage),removed:[],updated:[],all:P.localUserData.storage},localChange:0,remoteChange:2}}async Hb(P){if(P.remoteContent!==null){const N=JSON.parse(P.remoteContent),{local:F,remote:M}=(0,d.$5Hb)(P.localUserData.storage,N.storage,null,P.storageKeys,this.O);return{content:P.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:P.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(P,N,F,M){const{localUserData:U}=F[0][0],{local:Y,remote:Q,localChange:x,remoteChange:G}=F[0][1];if(x===0&&G===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Z=JSON.stringify({storage:Q.all});P=await this.mb(Z,M?null:P.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}N?.ref!==P.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(P),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(P){if(this.h.isEqual(this.yb,P)||this.h.isEqual(this.wb,P)||this.h.isEqual(this.xb,P)||this.h.isEqual(this.zb,P)){const N=await this.db(P);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:P}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(P).length>1||P[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(P){const N=await this.Bb.readStorageData(this.syncResource.profile),F=[],M=[];for(const[Q,x]of N)x.target===0?F.push(Q):x.target===1&&M.push(Q);const U=[...F,...M],Y=P?.storage?Object.keys(P.storage).filter(Q=>!Q.startsWith(n)&&!U.includes(Q)&&N.get(Q)!==void 0):[];if(!R.$o){const Q=[...c.$Aob.map(x=>(0,c.$Nob)(x)),c.$Mob];Y.push(...Q),M.push(...Q)}return{user:F,machine:M,unregistered:Y}}};e.$7Hb=a,e.$7Hb=a=ye([K(2,i.$3Gb),K(3,S.$zk),K(4,c.$Eob),K(5,c.$Fob),K(6,c.$Tob),K(7,C.$ji),K(8,c.$Oob),K(9,p.$Dl),K(10,g.$Ii),K(11,$.$Dp),K(12,E.$0k),K(13,o.$bi)],a);let v=class{constructor(P,N,F,M){this.a=P,this.b=N,this.c=F,this.d=M}async getLocalGlobalState(P){const N={};if(P.isDefault){const M=await this.f(),U=(0,L.$mn)(M);for(const Y of s)U[Y]!==void 0&&(N[`${n}${Y}`]={version:1,value:U[Y]})}const F=await this.c.readStorageData(P);for(const[M,U]of F)U.value&&U.target===0&&(N[M]={version:1,value:U.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const P=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),P.value.toString()}catch(P){this.d.debug((0,A.$0)(P))}return"{}"}async writeLocalGlobalState({added:P,removed:N,updated:F},M){const U=(0,l.$ZHb)("globalState",M),Y={},Q=new Map,x=await this.c.readStorageData(M),G=(Z,H)=>{for(const V of Z){if(V.startsWith(n)){Y[V.substring(n.length)]=H?H[V].value:void 0;continue}if(H){const te=H[V];te.value!==x.get(V)?.value&&Q.set(V,te.value)}else x.get(V)!==void 0&&Q.set(V,void 0)}};if(G(Object.keys(P),P),G(Object.keys(F),F),G(N),Object.keys(Y).length){this.d.trace(`${U}: Updating locale...`);const Z=await this.f();let H=Z;for(const V of Object.keys(Y))H=(0,u.edit)(H,[V],Y[V],{});Z!==H&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$qe.fromString(H)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}Q.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(M,Q,0),this.d.info(`${U}: Updated global state`,[...Q.keys()]))}};e.$8Hb=v,e.$8Hb=v=ye([K(0,S.$zk),K(1,C.$ji),K(2,i.$3Gb),K(3,c.$Tob)],v);let w=class extends l.$4Hb{constructor(P,N,F,M,U,Y){super("globalState",F,M,U,N,P,Y)}async o(P){const N=P.syncData?JSON.parse(P.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const U of Object.keys(N.storage))U.startsWith(n)?F[U.substring(n.length)]=N.storage[U].value:this.l.get(U,0)===void 0&&(M[U]=N.storage[U].value);if(Object.keys(F).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(F))U=(0,u.edit)(U,[Y],F[Y],{});await this.k.writeFile(this.h.argvResource,O.$qe.fromString(U))}if(Object.keys(M).length){const U=[];for(const Y of Object.keys(M))U.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$9Hb=w,e.$9Hb=w=ye([K(0,$.$Dp),K(1,S.$zk),K(2,y.$_k),K(3,C.$ji),K(4,c.$Tob),K(5,E.$0k)],w);let f=class{constructor(P,N,F,M,U){this.a=P,this.b=N,this.c=F,this.d=M,this.f=U}getSyncStoreType(P){return this.h(P)?.storage[c.$Mob]?.value}async sync(P){const N=(0,c.$Iob)((0,k.$yg)());try{return await this.g(P,N)}catch(F){if(F instanceof c.$Job)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(P,N)}throw F}}async g(P,N){const F=await this.a.readResource("globalState",null,void 0,N),M=this.h(F)||{storage:{}};M.storage[c.$Mob]={value:P,version:r};const U=await(0,h.$Jp)(this.c,this.d,this.b),Y={version:r,machineId:U,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),F.ref,void 0,N)}h({content:P}){if(!P)return null;const N=JSON.parse(P);if((0,l.$YHb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$0Hb=f,e.$0Hb=f=ye([K(1,$.$Dp),K(2,C.$ji),K(3,S.$zk),K(4,m.$wj)],f)}),define(le[117],he([0,1,17,14,3,34,5,12,171,21,15,11,19,22,28,18,39,236,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p8b=e.$o8b=e.$n8b=void 0;function d(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,R.$Xf)(s.all)?null:s.all;switch(I.OS){case 2:return(0,R.$Xf)(s.mac)?null:s.mac;case 3:return(0,R.$Xf)(s.linux)?null:s.linux;case 1:return(0,R.$Xf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$n8b=d;let c=class extends E.$3Hb{constructor(o,n,s,t,r,a,v,w,f,b,P,N,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,w,f,b,s,t,v,N,r,P,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$Vob,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$Vob,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$Vob,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$Vob,authority:"accepted"}),this.B(j.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?d(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,v=await this.vb(),w=await this.Cb();let f=null,b=!1,P=!1,N=!1;if(r){let U=v?v.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new u.$Job((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,l.$m8b)(U,r,a,w,this.zb);Y.hasChanges&&(f=Y.mergeContent,N=Y.hasConflicts,b=N||Y.mergeContent!==U,P=N||Y.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=v.value.toString(),P=!0);const F={content:N?a:f,localChange:b?v?2:1:0,remoteChange:P?2:0,hasConflicts:N},M=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,l.$m8b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:w}=s[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$Job((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const f=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(f,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,L.$mn)(o.value.toString());if((0,O.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:d(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,I.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$xob)}};e.$o8b=c,e.$o8b=c=ye([K(2,u.$Eob),K(3,u.$Fob),K(4,u.$Tob),K(5,g.$Ii),K(6,u.$Oob),K(7,S.$zk),K(8,C.$ji),K(9,m.$Dp),K(10,u.$Sob),K(11,h.$Dl),K(12,$.$0k)],c);let y=class extends E.$4Hb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,A.$qe.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$mn)(o.value.toString());return!(0,O.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return d(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$p8b=y,e.$p8b=y=ye([K(0,S.$zk),K(1,p.$_k),K(2,C.$ji),K(3,u.$Tob),K(4,m.$Dp),K(5,$.$0k)],y)}),define(le[118],he([0,1,14,3,172,21,76,15,29,11,19,22,28,18,39,240,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=e.$q8b=void 0;function l(y){return y&&y.settings&&typeof y.settings=="string"&&Object.keys(y).length===1}function u(y){const i=JSON.parse(y);return l(i)?i:{settings:y}}e.$q8b=u;let d=class extends $.$3Hb{constructor(i,o,n,s,t,r,a,v,w,f,b,P,N,F){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,b,P,v,w,f,F),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:E.$Vob,authority:"base"}),this.localResource=this.previewResource.with({scheme:E.$Vob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:E.$Vob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:E.$Vob,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new I.$bo(E.$wob);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(E.$wob)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,f=!1,b=!1,P=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,p.$JGb)(U,r.settings,a?a.settings:null,v,[],t);w=Y.localContent||Y.remoteContent,f=Y.localContent!==null,b=Y.remoteContent!==null,P=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=s.value.toString().trim()||"{}",this.Qb(w),b=!0);const N=s?s.value.toString():null,F=a?.settings??null,M={content:P?F:w,localChange:f?2:0,remoteChange:b?2:0,hasConflicts:P};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,p.$JGb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,p.$IGb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,p.$IGb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,p.$IGb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,p.$IGb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),f=this.Lb(i),b=await this.Pb(r);r=(0,p.$IGb)(r,f?f.settings:"{}",b,w),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,p.$KGb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,p.$IGb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return u(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(A.Event.any(A.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),A.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,p.$GGb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new E.$Job((0,j.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$r8b=d,e.$r8b=d=ye([K(2,g.$zk),K(3,R.$ji),K(4,C.$Dp),K(5,E.$Eob),K(6,E.$Fob),K(7,E.$Tob),K(8,E.$Sob),K(9,L.$Ii),K(10,E.$Oob),K(11,S.$Dl),K(12,k.$Lo),K(13,m.$0k)],d);let c=class extends $.$4Hb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$qe.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$KGb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return u(i)}catch(o){this.j.error(o)}return null}};e.$s8b=c,e.$s8b=c=ye([K(0,g.$zk),K(1,h.$_k),K(2,R.$ji),K(3,E.$Tob),K(4,C.$Dp),K(5,m.$0k)],c)}),define(le[119],he([0,1,14,3,30,21,15,11,19,22,28,18,39,237,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x8b=e.$w8b=e.$v8b=void 0;function p(u){return JSON.parse(u.content)}e.$v8b=p;let E=class extends m.$1Hb{constructor(d,c,y,i,o,n,s,t,r,a,v,w){super({syncResource:"snippets",profile:d},c,i,y,o,n,s,a,v,t,r,w),this.pb=1,this.vb=d.snippetsHome,this.B(this.G.watch(y.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(A.Event.filter(this.G.onDidFilesChange,f=>f.affects(this.vb))(()=>this.Q()))}async qb(d,c,y){const i=await this.Hb(),o=this.Gb(i),n=d.syncData?this.Fb(d.syncData):null;c=c===null&&y?d:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.$t8b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(d){const c=d.syncData?this.Fb(d.syncData):null;if(c===null)return!0;const y=await this.Hb(),i=this.Gb(y),o=(0,h.$t8b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(d,c){return d.previewResult}async sb(d,c,y,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$Vob,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$Vob,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return y===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:y,localChange:y===null?d.fileContent!==null?3:0:2,remoteChange:y===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(d,c,y,i){const o=y.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(d=await this.Eb(o,d,i)),c?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(d,c,y,i){const o=new Map;for(const n of Object.keys(d.local.added)){const s={content:d.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of Object.keys(d.local.updated)){const s={content:d.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of d.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of Object.keys(d.remote.added)){const s={content:d.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of Object.keys(d.remote.updated)){const s={content:d.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of d.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of d.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:y[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"remote"}),remoteContent:y[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$Vob,authority:"accepted"})})}return[...o.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:$.$Vob,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$Vob,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$Vob,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$Vob,authority:"accepted"}))?this.db(d):null}async hasLocalData(){try{const d=await this.Hb();if(Object.keys(d).length)return!0}catch{}return!1}async Cb(d){const c={};for(const y of d)y.fileContent&&(c[this.h.basename(y.localResource)]=y.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(d,c){for(const{fileContent:y,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of d)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$qe.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$qe.fromString(i.content),c?void 0:y),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(d,c,y){const i=c.syncData?this.Fb(c.syncData):{},o=(0,j.$Fn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of d)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,h.$u8b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),y?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(d){return p(d)}Gb(d){const c={};for(const y of Object.keys(d))c[y]=d[y].value.toString();return c}async Hb(){const d={};let c;try{c=await this.G.resolve(this.vb)}catch(y){if(y instanceof R.$Uk&&y.fileOperationResult===1)return d;throw y}for(const y of c.children||[]){const i=y.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);d[n]=s}}return d}};e.$w8b=E,e.$w8b=E=ye([K(2,I.$ji),K(3,R.$zk),K(4,k.$Dp),K(5,$.$Eob),K(6,$.$Fob),K(7,$.$Tob),K(8,L.$Ii),K(9,$.$Oob),K(10,g.$Dl),K(11,C.$0k)],E);let l=class extends m.$4Hb{constructor(d,c,y,i,o,n){super("snippets",c,y,i,d,o,n)}async o(d){const c=d.syncData?JSON.parse(d.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$qe.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};e.$x8b=l,e.$x8b=l=ye([K(0,R.$zk),K(1,S.$_k),K(2,I.$ji),K(3,$.$Tob),K(4,k.$Dp),K(5,C.$0k)],l)}),define(le[120],he([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8b=e.$z8b=e.$y8b=void 0;function m(E,l){try{return JSON.parse(E).tasks??null}catch(u){return l.error(u),null}}e.$y8b=m;let h=class extends C.$2Hb{constructor(l,u,d,c,y,i,o,n,s,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,t,d,c,o,r,y,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$Vob,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$Vob,authority:"local"}),this.Db=this.Ab.with({scheme:S.$Vob,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$Vob,authority:"accepted"})}async qb(l,u,d,c){const y=l.syncData?m(l.syncData.content,this.O):null;u=u===null&&d?l:u;const i=u?.syncData?m(u.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(l.syncData){const w=o?o.value.toString():null;if(!i||i!==w||i!==y){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const f=p(w,y,i);n=f.content,r=f.hasConflicts,s=f.hasLocalChanged,t=f.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:y,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const u=l?.syncData?m(l.syncData.content,this.O):null;if(u===null)return!0;const d=await this.vb(),c=d?d.value.toString():null,y=p(c,u,u);return y.hasLocalChanged||y.hasRemoteChanged}async rb(l,u){return l.previewResult}async sb(l,u,d,c){if(this.h.isEqual(u,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return d===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(l,u,d,c){const{fileContent:y}=d[0][0],{content:i,localChange:o,remoteChange:n}=d[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),y&&await this.nb(JSON.stringify(this.Kb(y.value.toString()))),i?await this.wb(i,y,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));l=await this.mb(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$z8b=h,e.$z8b=h=ye([K(2,S.$Eob),K(3,S.$Fob),K(4,S.$Tob),K(5,A.$Ii),K(6,S.$Oob),K(7,L.$zk),K(8,j.$ji),K(9,I.$Dp),K(10,R.$Dl),K(11,k.$0k)],h);let $=class extends C.$4Hb{constructor(l,u,d,c,y,i){super("tasks",u,d,c,l,y,i),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?m(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$qe.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$A8b=$,e.$A8b=$=ye([K(0,L.$zk),K(1,g.$_k),K(2,j.$ji),K(3,S.$Tob),K(4,I.$Dp),K(5,k.$0k)],$);function p(E,l,u){if(E===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(E===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=u!==E,c=u!==l;return!d&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!c?{content:E,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!d?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:E,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,15,11,19,22,28,18,39,238,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h0b=e.$g0b=e.$f0b=void 0;let h=class extends C.$1Hb{constructor(l,u,d,c,y,i,o,n,s,t,r,a,v){super({syncResource:"profiles",profile:l},u,c,y,i,o,n,r,a,s,t,v),this.vb=d,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$Vob,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Vob,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Vob,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Vob,authority:"accepted"}),this.B(d.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?p(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),d=await this.X(l,u);return d?.syncData?p(d.syncData):null}async qb(l,u,d){if(!this.vb.isEnabled())throw new m.$Job("Cannot sync profiles because they are disabled","LocalError");const c=l.syncData?p(l.syncData):null,y=u?.syncData?p(u.syncData):null,i=this.Db(),{local:o,remote:n}=(0,S.$e0b)(i,c,y,[]),s={local:o,remote:n,content:y?this.Eb(y):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(i,!1);return[{baseResource:this.baseResource,baseContent:y?this.Eb(y):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const u=l?.syncData?p(l.syncData):null,d=this.Db(),{remote:c}=(0,S.$e0b)(d,u,u,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(l,u){return{...l.previewResult,hasConflicts:!1}}async sb(l,u,d,c){if(this.h.isEqual(u,this.localResource))return this.Ab(l);if(this.h.isEqual(u,this.remoteResource))return this.Bb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(l){const u=this.Db(),d=(0,S.$e0b)(u,null,null,[]),{local:c,remote:y}=d;return{content:l.localContent,local:c,remote:y,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:y!==null?2:0}}async Bb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,d=[],c=[];for(const y of this.Db()){const i=u?.find(o=>o.id===y.id);i&&(d.push({id:y.id,name:y.name,collection:i.collection}),c.push(y))}if(u!==null){const y=(0,S.$e0b)(c,u,d,[]),{local:i,remote:o}=y;return{content:l.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,u,d,c){const{local:y,remote:i,localChange:o,remoteChange:n}=d[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=d[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$Job("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of y.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of y.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of y.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:w})=>a.id===w);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,c?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.mb(this.Eb(l),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.db(l);return u&&(0,O.$xn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((u,d)=>u.name.localeCompare(d.name)))}};e.$f0b=h,e.$f0b=h=ye([K(2,g.$_k),K(3,L.$zk),K(4,j.$ji),K(5,I.$Dp),K(6,m.$Eob),K(7,m.$Fob),K(8,m.$Tob),K(9,A.$Ii),K(10,m.$Oob),K(11,R.$Dl),K(12,k.$0k)],h);function $(E,l){const u=[...E].sort((d,c)=>d.name.localeCompare(c.name)).map(d=>({id:d.id,name:d.name}));return l?(0,O.$xn)(u,{}):JSON.stringify(u)}e.$g0b=$;function p(E){return JSON.parse(E.content)}e.$h0b=p}),define(le[255],he([0,1,3,2,5,15,19,22,25]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=void 0;const g="sync.enable";let C=class extends A.$Tc{constructor(m,h,$,p){super(),this.c=m,this.f=h,this.g=$,this.h=p,this.a=new O.$3d,this.onDidChangeEnablement=this.a.event,this.b=new O.$3d,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new A.$Sc))(E=>this.m(E)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:m}),this.c.store(g,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,k.$Nob)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const $=(0,k.$Nob)(m);this.j($,h)}}getResourceSyncStateVersion(m){}j(m,h){this.c.store(m,h,-1,j.$o?0:1)}m(m){if(g===m.key){this.a.fire(this.isEnabled());return}const h=k.$Aob.filter($=>(0,k.$Nob)($)===m.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$59b=C,e.$59b=C=ye([K(0,I.$Dp),K(1,R.$Dl),K(2,L.$ji),K(3,k.$Dob)],C)}),define(le[256],he([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,O,A,j,L,I,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=void 0;let m=class extends L.$Tc{constructor($,p,E,l,u){super(),this.a=$,this.b=p,this.c=E,this.f=l,this.g=u,this.h()}async h(){for(const p of this.g.profiles)for(const E of S.$Aob)try{await this.m(this.j(E,p.isDefault?void 0:p.id))}catch(l){this.f.error(l)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$Qk)(p)!==1&&this.f.error(p);return}if($.children){for(const p of $.children)if(p.isDirectory&&!this.g.profiles.some(E=>E.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(E){this.f.error(E)}}}async getAllResourceRefs($,p,E){const l=this.j($,p,E);try{const u=await this.b.resolve(l);if(u.children)return u.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(u){if((0,g.$Qk)(u)!==1)throw u}return[]}async resolveResourceContent($,p,E,l){const u=this.j($,E,l),d=(0,I.$Pg)(u,p);try{return(await this.b.readFile(d)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource($,p,E,l,u){const d=this.j($,l,u),c=(0,I.$Pg)(d,`${(0,j.$Gm)(E).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,A.$qe.fromString(p))}catch(y){this.f.error(y)}}j($,p,E=this.a.userDataSyncHome){return(0,I.$Pg)(E,...p?[p,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const p=await this.b.resolve($);if(p.children){const E=p.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=E.filter(c=>Date.now()-this.n(c)>l);const d=E.length-u.length;d<10&&(u=u.slice(10-d)),await O.Promises.settled(u.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(p){this.f.error(p)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$d0b=m,e.$d0b=m=ye([K(0,k.$ji),K(1,g.$zk),K(2,R.$Ii),K(3,S.$Tob),K(4,C.$_k)],m)}),define(le[84],he([0,1,3,2,5,27,176,15,11,4,24,43,19,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$tob=e.$sob=e.$rob=void 0,e.$rob=(0,g.$ci)("IUserDataSyncMachinesService");const p="sync.currentMachineName",E="Safari",l="Chrome",u="Edge",d="Firefox",c="Android";function y(n){switch(n){case E:case l:case u:case d:case c:case(0,j.$h)(0):return!0}return!1}e.$sob=y;function i(){return j.$G?E:j.$E?l:j.$H?u:j.$F?d:j.$I?c:(0,j.$h)(j.$o?0:j.$u)}let o=class extends A.$Tc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new O.$3d),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$Jp)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===s);if(v){v.name=t,await this.t(a);const w=await this.f;s===w&&this.h.store(p,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(p,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$Ve)(r)}\\s#(\\d+)`);let v=0;for(const w of s){const f=a.exec(w.name),b=f?parseInt(f[1]):0;v=b>v?b:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$tob=o,e.$tob=o=$=ye([K(0,R.$ji),K(1,k.$zk),K(2,m.$Dp),K(3,h.$Eob),K(4,h.$Tob),K(5,C.$Oj)],o)}),define(le[257],he([0,1,6,65,38,7,3,2,5,20,9,173,24,19,22,25,81,84]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j0b=void 0;const u="sync.disableMachineEventually",d="sync.sessionId",c="sync.storeUrl",y="sync.productQuality";let i=class extends R.$Tc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(y,-1)}set s(s){s?this.H.store(y,s,-1,1):this.H.remove(y,-1)}constructor(s,t,r,a,v,w,f,b,P,N){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=f,this.F=b,this.G=P,this.H=N,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$3d),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$ah(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Ig)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(f.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,A.$Gm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(d,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=p.$Job.toUserDataSyncError(s);t instanceof p.$Lob&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(u,!0,-1,1),await(0,O.$dh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$j0b=i,e.$j0b=i=ye([K(0,m.$Oj),K(1,p.$Dob),K(2,p.$Eob),K(3,p.$Oob),K(4,p.$Pob),K(5,p.$Tob),K(6,E.$qGb),K(7,$.$Dl),K(8,l.$rob),K(9,h.$Dp)],i);class o extends R.$Tc{static{this.a="Interval"}constructor(s,t,r,a,v,w,f,b,P){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=f,this.z=b,this.C=P,this.b=this.B(new R.$Uc),this.c=this.B(new I.$3d),this.onDidStartSync=this.c.event,this.f=this.B(new I.$3d),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,O.$eh)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,O.$2g)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$4)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Ig)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Ig)(t.defaultUrl,s.defaultUrl)||!(0,g.$Ig)(t.insidersUrl,s.insidersUrl)||!(0,g.$Ig)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,p.$Job.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new p.$Lob((0,S.localize)(0,null),"DefaultServiceChanged"):new p.$Lob((0,S.localize)(1,null),"ServiceChanged"):new p.$Lob((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(d,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new p.$Lob((0,S.localize)(3,null),"DefaultServiceChanged"):new p.$Lob((0,S.localize)(4,null),"ServiceChanged"):new p.$Lob((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(f=>f.isCurrent);if(v?.disabled)throw new p.$Lob((0,S.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(f){throw new p.$Lob((0,j.$Zi)(f),f instanceof p.$Job?f.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(d,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[258],he([0,1,9,177,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,f,b,P,N,F){this.e=t,this.f=r,this.g=a,this.h=w,this.i=f,this.j=b,this.k=P,this.l=N,this.n=F,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$h0b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,c.$h0b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:f})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:f,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$Jp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:f}=await this.M(r,v,a);return f}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,h.$q8b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$n8b)(t.content,!!this.l.getValue(g.$xob),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,E.$y8b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,m.$v8b)(v),f=[];for(const b of Object.keys(w)){const P=this.d.joinPath(t,b),N=r?this.d.joinPath(r.snippetsHome,b):this.d.joinPath(t,o.a);f.push({resource:P,comparableResource:N})}return f}}return[]}z(t,r){return(0,m.$v8b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$i8b)((0,l.$h8b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$k8b).getLocalExtensions(t);return(0,l.$i8b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,u.$6Hb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(u.$8Hb).getLocalGlobalState(t);return(0,u.$6Hb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,y.$xn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$g0b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$Ze)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:g.$Vob,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$Vob)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const f=[];let b,P,N,F,M;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?v=U.substring(7):U.startsWith("authority:")?w=U.substring(10):U.startsWith("syncResource:")?b=U.substring(13):U.startsWith("profile:")?P=U.substring(8):U.startsWith("collection:")?N=U.substring(11):U.startsWith("ref:")?F=U.substring(4):b?M=U:f.push(U)}return{remote:a,syncResource:b,profile:P,collection:N,ref:F,node:M,location:v&&w!==void 0?this.d.joinPath(O.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...f):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$YHb)(a))return a}catch(a){this.g.error(a)}throw new g.$Job((0,A.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$R0b=n,e.$R0b=n=o=ye([K(0,g.$Eob),K(1,g.$Fob),K(2,g.$Tob),K(3,k.$0k),K(4,j.$ji),K(5,R.$Dp),K(6,L.$zk),K(7,C.$_k),K(8,p.$Ii),K(9,d.$bi)],n)}),define(le[259],he([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(b,P,N,F,M,U,Y,Q,x,G,Z){super(),this.C=b,this.D=P,this.F=N,this.G=F,this.H=M,this.I=U,this.J=Y,this.L=Q,this.M=x,this.N=G,this.O=Z,this.f="uninitialized",this.g=this.B(new I.$3d),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$3d),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$3d),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$3d),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$3d),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$3d),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$3d),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(b,P){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),F=(0,C.$yg)();try{const Q=(0,s.$Iob)(F);P&&(Q["Cache-Control"]="no-cache"),b=await this.D.manifest(b,Q)}catch(Q){const x=s.$Job.toUserDataSyncError(Q);throw w(x,F,this.F,this.I),x}const M=!1,U=this;let Y;return{manifest:b,async run(){if(M)throw new Error("Can run a task only once");Y=(0,A.$2g)(Q=>U.P(b,!1,F,Q)),await Y.finally(()=>Y=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),U.$()},stop(){return Y?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Job("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const b=new Date().getTime(),P=(0,C.$yg)(),N=(0,s.$Iob)(P);let F;try{F=await this.D.manifest(null,N)}catch(Y){const Q=s.$Job.toUserDataSyncError(Y);throw w(Q,P,this.F,this.I),Q}await this.resetLocal();const M=this,U=new j.$ae;return{id:P,async merge(){return M.P(F,!0,P,U.token)},async apply(){try{try{await M.R(F,P,U.token)}catch(Y){if(s.$Job.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(F,P,U.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-b}ms`),M.$()},async stop(){U.cancel(),await M.U(),await M.resetLocal()}}}async P(b,P,N,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,b,P,N,F));const U=M.enabled.find(Y=>Y.resource==="profiles");if(U){const Y=await U.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Y,b,P,N,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(b,P,N,F,M){for(const U of b){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===U.id);if(!Y){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const Q=this.getOrCreateActiveProfileSynchronizer(Y,U);this.n.push(...await this.S(Q,P,N,F,M))}for(const[U,Y]of this.z.entries())this.M.profiles.some(Q=>Q.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(U))}async R(b,P,N){const F=this.ab();for(const x of F){if(N.isCancellationRequested)return;await x.apply(P,N)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const U=M.enabled.find(x=>x.resource==="profiles");if(!U)return;const Q=(await U.getRemoteSyncedProfiles(b?.latest??null)||[]).filter(x=>F.every(G=>G.profile.id!==x.id));Q.length&&await this.Q(Q,b,!1,P,N)}async S(b,P,N,F,M){return(await b.sync(P,N,F,M)).map(([Y,Q])=>({profile:b.profile,syncResource:Y,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(b=>b.stop()))}async resolveContent(b){const P=await this.N.resolveContent(b);if(P)return P;for(const N of this.ab())for(const F of N.enabled){const M=await F.resolveContent(b);if(M)return M}return null}async replace(b){this.cb();const P=this.N.resolveUserDataSyncResource(b);if(!P)return;const N=await this.resolveContent(b.uri);N&&await this.W(P.profile,async F=>{if(P.syncResource===F.resource)return await F.replace(N),!0})}async accept(b,P,N,F){this.cb(),await this.W(b.profile,async M=>{if(b.syncResource===M.resource)return await M.accept(P,N),F&&await M.apply((0,g.$Wf)(F)?!1:F.force,(0,s.$Iob)((0,C.$yg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(b){this.H.error(b)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[b]of this.z.values())try{await b.resetLocal()}catch(P){this.H.error(P)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const b=await this.N.getRemoteSyncedProfiles(),P=b.map(U=>U.collection),N=await this.D.getAllCollections(),F=N.filter(U=>!P.includes(U));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const M=b.filter(U=>N.includes(U.collection));if(M.length!==b.length){const U=this.G.createInstance(n.$f0b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(b){this.cb();const P=await this.D.getActivityData();await this.C.writeFile(b,P)}async extractActivityData(b,P){const N=(await this.C.readFile(b)).value.toString(),F=JSON.parse(N);if(F.resources)for(const M in F.resources)for(const U of F.resources[M])await this.O.writeResource(M,U.content,new Date(U.created*1e3),void 0,P);if(F.collections)for(const M in F.collections)for(const U in F.collections[M].resources)for(const Y of F.collections[M].resources?.[U]??[])await this.O.writeResource(U,Y.content,new Date(Y.created*1e3),M,P)}async W(b,P){const N=new R.$Sc;try{const F=this.z.get(b.id);if(F){const x=await this.X(F[0],P,N);return(0,g.$Xf)(x)?null:x}if(b.isDefault){const x=N.add(this.G.createInstance(a,b,void 0)),G=await this.X(x,P,N);return(0,g.$Xf)(G)?null:G}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(n.$f0b,b,void 0)),U=await this.D.manifest(null),Q=(await M.getRemoteSyncedProfiles(U?.latest??null)||[]).find(x=>x.id===b.id);if(Q){const x=N.add(this.G.createInstance(a,b,Q.collection)),G=await this.X(x,P,N);return(0,g.$Xf)(G)?null:G}return null}finally{N.dispose()}}async X(b,P,N){const F=[...b.enabled,...b.disabled.reduce((M,U)=>(U!=="workspaceState"&&M.push(N.add(b.createSynchronizer(U))),M),[])];for(const M of F){const U=await P(M);if(!(0,g.$Xf)(U))return U}}Y(b){const P=this.f;this.f!==b&&(this.f=b,this.g.fire(b),P==="hasConflicts"&&this.$())}Z(){const b=this.ab().map(P=>P.conflicts).flat();(0,O.$ub)(this.j,b,(P,N)=>P.profile.id===N.profile.id&&P.syncResource===N.syncResource&&(0,O.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Ig)(F.previewResource,M.previewResource)))||(this.j=b,this.m.fire(b))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(b,P){let N=this.z.get(b.id);if(N&&N[0].collection!==P?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(b.id)),!N){const F=new R.$Sc,M=F.add(this.G.createInstance(a,b,P?.collection));F.add(M.onDidChangeStatus(U=>this.Y(U))),F.add(M.onDidChangeConflicts(U=>this.Z())),F.add(M.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(b.id,N=[M,F])}return N[0]}ab(){const b=[];for(const[P]of this.z.values())b.push(P);return b}bb(){this.z.forEach(([,b])=>b.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$i0b=r,e.$i0b=r=ye([K(0,h.$zk),K(1,s.$Eob),K(2,s.$Dob),K(3,$.$bi),K(4,s.$Tob),K(5,E.$Dl),K(6,p.$Dp),K(7,s.$Oob),K(8,l.$_k),K(9,s.$Qob),K(10,s.$Fob)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((b,P)=>b[1]-P[1]).map(([b])=>b)}get disabled(){return s.$Aob.filter(b=>!this.r.isResourceEnabled(b))}get status(){return this.g}get conflicts(){return this.m}constructor(b,P,N,F,M,U,Y,Q,x,G){super(),this.profile=b,this.collection=P,this.r=N,this.t=F,this.u=M,this.w=U,this.y=Y,this.z=Q,this.C=x,this.D=G,this.f=[],this.g="idle",this.h=this.B(new I.$3d),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$3d),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$3d),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([Z,H])=>this.F(Z,H))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Z])=>Z.dispose())));for(const Z of s.$Aob)N.isResourceEnabled(Z)&&this.G(Z)}F(b,P){P?this.G(b):this.H(b)}G(b){if(this.f.some(([M])=>M.resource===b))return;if(b==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(b==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||b==="workspaceState")return;if(b!=="profiles"&&this.profile.useDefaultFlags?.[b]){this.z.debug(`Skipping syncing ${b} in ${this.profile.name} because it is already synced by default profile`);return}const P=new R.$Sc,N=P.add(this.createSynchronizer(b));P.add(N.onDidChangeStatus(()=>this.L())),P.add(N.onDidChangeConflicts(()=>this.M())),P.add(N.onDidChangeLocal(()=>this.j.fire(b)));const F=this.N(b);this.f.push([N,F,P])}H(b){const P=this.f.findIndex(([N])=>N.resource===b);if(P!==-1){const[[N,,F]]=this.f.splice(P,1);F.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(b){switch(b){case"settings":return this.t.createInstance(y.$r8b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$o8b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$w8b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$z8b,this.profile,this.collection);case"globalState":return this.t.createInstance(d.$7Hb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$j8b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$f0b,this.profile,this.collection)}}async sync(b,P,N,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const U=[],Y=(0,s.$Iob)(N),Q=(this.collection?b?.collections?.[this.collection]?.latest:b?.latest)??null,x=P?await this.I(Q):{};for(const G of M){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(P){const Z=await G.preview(Q,x,Y);if(Z)for(const H of Z.resourcePreviews)(H.localChange!==0||H.remoteChange!==0)&&H.mergeState==="preview"&&await G.merge(H.previewResource)}else await G.sync(Q,Y)}catch(Z){const H=s.$Job.toUserDataSyncError(Z);if(w(H,N,this.w,this.y),v(Z))throw H;this.z.error(Z),this.z.error(`${G.resource}: ${(0,L.$Zi)(Z)}`),U.push([G.resource,H])}}return U}finally{this.L()}}async apply(b,P){const N=(0,s.$Iob)(b);for(const F of this.enabled){if(P.isCancellationRequested)return;try{await F.apply(!1,N)}catch(M){const U=s.$Job.toUserDataSyncError(M);if(w(U,b,this.w,this.y),v(M))throw U;this.z.error(M),this.z.error(`${F.resource}: ${(0,L.$Zi)(M)}`)}}}async stop(){for(const b of this.enabled)try{b.status!=="idle"&&await b.stop()}catch(P){this.z.error(P)}}async resetLocal(){for(const b of this.enabled)try{await b.resetLocal()}catch(P){this.z.error(`${b.resource}: ${(0,L.$Zi)(P)}`),this.z.error(P)}}async I(b){if(!this.profile.isDefault)return{};const P=this.D.getValue(s.$wob),N=this.enabled.find(F=>F instanceof y.$r8b);if(N){const F=await N.getRemoteUserDataSyncConfiguration(b);return{...P,...F}}return P}J(b){this.g!==b&&(this.g=b,this.h.fire(b))}L(){return this.M(),this.enabled.some(b=>b.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(b=>b.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const b=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,O.$ub)(this.m,b,(P,N)=>P.syncResource===N.syncResource&&(0,O.$ub)(P.conflicts,N.conflicts,(F,M)=>(0,k.$Ig)(F.previewResource,M.previewResource)))||(this.m=b,this.n.fire(b))}N(b){switch(b){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([K(2,s.$Oob),K(3,$.$bi),K(4,m.$Io),K(5,s.$Dob),K(6,E.$Dl),K(7,s.$Tob),K(8,l.$_k),K(9,S.$Ii)],a);function v(f){if(f instanceof s.$Job)switch(f.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(f,b,P,N){N.publicLog2("sync/error",{code:f.code,serverCode:f instanceof s.$Kob?String(f.serverCode):void 0,url:f instanceof s.$Kob?f.url:void 0,resource:f.resource,executionId:b,service:P.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,9,18,25]),function(se,e,O,A,j,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=void 0;function R(m,h){return{...m,profile:(0,L.$al)(m.profile,h.profilesHome.scheme)}}function k(m){return{created:m.created,uri:j.URI.revive(m.uri)}}class g{constructor(h,$,p){this.c=h,this.d=$,this.f=p,this.a=new Map,this.b=new O.$3d}listen(h,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${$}`)}async call(h,$,p){try{return await this.g(h,$,p)}catch(E){throw this.f.error(E),E}}async g(h,$,p){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(j.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),j.URI.revive(p[1]),p[2],p[3]);case"replace":return this.c.replace(k(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(j.URI.revive(p[0]));case"extractActivityData":return this.c.extractActivityData(j.URI.revive(p[0]),j.URI.revive(p[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const E=$.substring(11),l=p[0],u=this.h(l);switch(p=p.slice(1),E){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const $=this.a.get(this.j(h));if(!$)throw new Error(`Manual sync taks not found: ${h}`);return $}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$Cac=g;let C=class extends A.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new O.$3d),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$3d),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$3d),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$3d),this.onSyncErrors=this.m.event,this.a={call(p,E,l){return h.call(p,E,l).then(null,u=>{throw I.$Job.toUserDataSyncError(u)})},listen(p,E){return h.listen(p,E)}},this.a.call("_getInitialData").then(([p,E,l])=>{this.s(p),this.t(E),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.t(p))),this.B(this.a.listen("onSyncErrors")(p=>this.m.fire(p.map(E=>({...E,error:I.$Job.toUserDataSyncError(E.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),$=this;return new S(h,{async call(E,l,u){return $.a.call(`manualSync/${E}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,$,p,E){return this.a.call("accept",[h,$,p,E])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,$){return this.a.call("extractActivityData",[h,$])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map($=>({syncResource:$.syncResource,profile:(0,L.$al)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(p=>({...p,baseResource:j.URI.revive(p.baseResource),localResource:j.URI.revive(p.localResource),remoteResource:j.URI.revive(p.remoteResource),previewResource:j.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$Dac=C,e.$Dac=C=ye([K(1,L.$_k)],C);class S extends A.$Tc{constructor(h,$){super(),this.id=h,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,140,5,20,12,9,32,21,15,11,24,59,43,19,25]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WHb=e.$VHb=e.$UHb=e.$THb=e.$SHb=void 0;const y="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Mob,-1)}set c(N){this.h.store(c.$Mob,N,-1,k.$o?0:1)}constructor(N,F,M){super(),this.f=N,this.g=F,this.h=M,this.a=this.B(new L.$3d),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new I.$Sc);this.B(L.Event.filter(M.onDidChangeValue(-1,c.$Mob,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[y]),this.a.fire()}m(N){if(N&&(N=k.$o&&N.web?{...N,...N.web}:N,(0,C.$Qf)(N.url)&&(0,C.$Sf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(F=>Array.isArray(N.authenticationProviders[F].scopes)))){const F=N,M=!!F.canSwitch,U=F.url===F.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||U,Q=Y==="insiders"?F.insidersUrl:Y==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(Q),type:Y,defaultType:U,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:F.authenticationProviders[G].scopes}),x),[])}}}};e.$SHb=a,e.$SHb=a=ye([K(0,E.$Oj),K(1,h.$Ii),K(2,d.$Dp)],a);let v=class extends a{constructor(N,F,M){super(N,F,M);const U=this.h.get(i,-1);U&&(this.n=JSON.parse(U));const Y=this.f[y];Y?this.h.store(i,JSON.stringify(Y),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$THb=v,e.$THb=v=ye([K(0,E.$Oj),K(1,h.$Ii),K(2,d.$Dp)],v);let w=class extends I.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,F,M,U,Y,Q,x){super(),this.n=M,this.r=U,this.s=x,this.g=this.B(new L.$3d),this.onTokenFailed=this.g.event,this.h=this.B(new L.$3d),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$3d),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,u.$Jp)(Y,Q,x).then(G=>{const Z={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Z["X-Client-Commit"]=F.commit),Z}),this.f=new b(t,r,this.n,this.r),this.u(),this.B((0,I.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,F){this.b={token:N,type:F}}t(N){this.a=N?(0,g.$Pg)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,O.$2g)(F=>(0,O.$dh)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Pg)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(F,{type:"GET",headers:N},[],A.CancellationToken.None);return(await(0,l.$wp)(M))?.map(({id:U})=>U)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Pg)(this.a,"collection").toString();N={...N},N["Content-Type"]=R.$os.text;const M=await this.D(F,{type:"POST",headers:N},[],A.CancellationToken.None),U=await(0,l.$vp)(M);if(!U)throw new c.$Kob("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[c.$Gob]);return U}async deleteCollection(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Pg)(this.a,"collection",N).toString():(0,g.$Pg)(this.a,"collection").toString();F={...F},await this.D(M,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async getAllResourceRefs(N,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,F,N),U={},Y=await this.D(M.toString(),{type:"GET",headers:U},[],A.CancellationToken.None);return(await(0,l.$wp)(Y)||[]).map(({url:x,created:G})=>({ref:(0,g.$Rg)(M,M.with({path:x})),created:G*1e3}))}async resolveResourceContent(N,F,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Pg)(this.z(this.a,M,N),F).toString();U={...U},U["Cache-Control"]="no-cache";const Q=await this.D(Y,{type:"GET",headers:U},[],A.CancellationToken.None);return await(0,l.$vp)(Q)}async deleteResource(N,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=F!==null?(0,g.$Pg)(this.z(this.a,M,N),F).toString():this.z(this.a,M,N).toString(),Y={};await this.D(U,{type:"DELETE",headers:Y},[],A.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Pg)(this.a,"resource").toString(),F={"Content-Type":R.$os.text};await this.D(N,{type:"DELETE",headers:F},[],A.CancellationToken.None)}async readResource(N,F,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Pg)(this.z(this.a,M,N),"latest").toString();U={...U},U["Cache-Control"]="no-cache",F&&(U["If-None-Match"]=F.ref);const Q=await this.D(Y,{type:"GET",headers:U},[304],A.CancellationToken.None);let x=null;if(Q.res.statusCode===304&&(x=F),x===null){const G=Q.res.headers.etag;if(!G)throw new c.$Kob("Server did not return the ref",Y,"NoRef",Q.res.statusCode,Q.res.headers[c.$Gob]);const Z=await(0,l.$vp)(Q);if(!Z&&Q.res.statusCode===304)throw new c.$Kob("Empty response",Y,"EmptyResponse",Q.res.statusCode,Q.res.headers[c.$Gob]);x={ref:G,content:Z}}return x}async writeResource(N,F,M,U,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,U,N).toString();Y={...Y},Y["Content-Type"]=R.$os.text,M&&(Y["If-Match"]=M);const x=await this.D(Q,{type:"POST",data:F,headers:Y},[],A.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new c.$Kob("Server did not return the ref",Q,"NoRef",x.res.statusCode,x.res.headers[c.$Gob]);return G}async manifest(N,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Pg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",N&&(F["If-None-Match"]=N.ref);const U=await this.D(M,{type:"GET",headers:F},[304],A.CancellationToken.None);let Y=null;if(U.res.statusCode===304&&(Y=N),!Y){const x=U.res.headers.etag;if(!x)throw new c.$Kob("Server did not return the ref",M,"NoRef",U.res.statusCode,U.res.headers[c.$Gob]);const G=await(0,l.$vp)(U);if(!G&&U.res.statusCode===304)throw new c.$Kob("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[c.$Gob]);G&&(Y={...JSON.parse(G),ref:x})}const Q=this.s.get(n,-1);return Q&&Y&&Q!==Y.session&&this.C(),Y===null&&Q&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Pg)(this.a,"download").toString(),F={},M=await this.D(N,{type:"GET",headers:F},[],A.CancellationToken.None);if(!(0,l.$sp)(M))throw new c.$Kob("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Gob]);if((0,l.$tp)(M))throw new c.$Kob("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Gob]);return M.stream}z(N,F,M){return F?(0,g.$Pg)(N,"collection",F,"resource",M):(0,g.$Pg)(N,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(N,F,M,U){if(!this.b)throw new c.$Kob("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Kob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;F.headers={...F.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:N,type:F.type,headers:{...F.headers,authorization:void 0}});let Q;try{Q=await this.f.request(N,F,U)}catch(V){if(!(V instanceof c.$Kob)){let te="RequestFailed";const oe=(0,j.$0)(V).toLowerCase();oe.includes("xhr timeout")?te="RequestTimeout":oe.includes("protocol")&&oe.includes("not supported")?te="RequestProtocolNotSupported":oe.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":oe.includes("headers must be an object")?te="RequestHeadersNotObject":(0,j.$4)(V)&&(te="RequestCanceled"),V=new c.$Kob(`Connection refused for the request '${N}'.`,N,te,void 0,void 0)}throw this.r.info("Request failed",N),V}const x=Q.res.headers[c.$Gob],G={url:N,status:Q.res.statusCode,"execution-id":F.headers[c.$Hob],"operation-id":x},Z=(0,l.$sp)(Q)||Q.res.statusCode&&M.includes(Q.res.statusCode);let H="";if(Z?this.r.trace("Request succeeded",G):(H=await(0,l.$up)(Q)||"",this.r.info("Request failed",G,H)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Kob(`${F.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",Q.res.statusCode,x);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Kob(`${F.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",Q.res.statusCode,x)}if(this.h.fire(),Q.res.statusCode===404)throw new c.$Kob(`${F.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",Q.res.statusCode,x);if(Q.res.statusCode===405)throw new c.$Kob(`${F.type} request '${N}' failed because the requested endpoint is not found (405). ${H}`,N,"MethodNotFound",Q.res.statusCode,x);if(Q.res.statusCode===409)throw new c.$Kob(`${F.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",Q.res.statusCode,x);if(Q.res.statusCode===410)throw new c.$Kob(`${F.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",Q.res.statusCode,x);if(Q.res.statusCode===412)throw new c.$Kob(`${F.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",Q.res.statusCode,x);if(Q.res.statusCode===413)throw new c.$Kob(`${F.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",Q.res.statusCode,x);if(Q.res.statusCode===426)throw new c.$Kob(`${F.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",Q.res.statusCode,x);if(Q.res.statusCode===429){const V=Q.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new c.$Kob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",Q.res.statusCode,x)):new c.$Kob(`${F.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",Q.res.statusCode,x)}if(!Z)throw new c.$Kob("Server returned "+Q.res.statusCode,N,"Unknown",Q.res.statusCode,x);return Q}F(N){let F=this.s.get(s,-1);F===void 0&&(F=(0,m.$yg)(),this.s.store(s,F,-1,1)),N["X-Machine-Session-Id"]=F;const M=this.s.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$UHb=w,e.$UHb=w=ye([K(1,E.$Oj),K(2,l.$qp),K(3,c.$Tob),K(4,$.$ji),K(5,p.$zk),K(6,d.$Dp)],w);let f=class extends w{constructor(N,F,M,U,Y,Q,x){super(N.userDataSyncStore?.url,F,M,U,Y,Q,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$VHb=f,e.$VHb=f=ye([K(0,c.$Dob),K(1,E.$Oj),K(2,l.$qp),K(3,c.$Tob),K(4,$.$ji),K(5,p.$zk),K(6,d.$Dp)],f);class b{constructor(N,F,M,U){this.c=N,this.d=F,this.f=M,this.g=U,this.a=[],this.b=void 0}request(N,F,M){if(this.h()&&this.i(),F.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Kob(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$WHb=b}),define(le[261],he([0,1,3,2,9,21,24,19,122]),function(se,e,O,A,j,L,I,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=e.$Aac=e.$zac=e.$yac=void 0;class g{constructor($){this.a=$}listen($,p){switch(p){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${p}`)}call($,p,E){switch(p){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(E)}throw new Error("Invalid call")}}e.$yac=g;class C extends A.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor($){super(),this.c=$,this.b=this.B(new O.$3d),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(p=>{this.a=p,this.B(this.c.listen("onDidChangeAccount")(E=>{this.a=E,this.b.fire(E)}))})}updateAccount($){return this.c.call("updateAccount",$)}}e.$zac=C;class S{constructor($){this.a=$}listen($,p){switch(p){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${p}`)}call($,p,E){switch(p){case"switch":return this.a.switch(E[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Aac=S;let m=class extends k.$SHb{constructor($,p,E,l){super(p,E,l),this.n=$,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch($){return this.n.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.n.call("getPreviousUserDataSyncStore");return this.r($)}r($){return{url:j.URI.revive($.url),type:$.type,defaultUrl:j.URI.revive($.defaultUrl),insidersUrl:j.URI.revive($.insidersUrl),stableUrl:j.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}};e.$Bac=m,e.$Bac=m=ye([K(1,I.$Oj),K(2,L.$Ii),K(3,R.$Dp)],m)}),define(le[262],he([0,1,3,57,24,19,22,257,25,81,84]),function(se,e,O,A,j,L,I,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;let S=class extends R.$j0b{constructor(h,$,p,E,l,u,d,c,y,i,o){super(h,$,p,E,l,d,c,y,i,o),this.B(O.Event.debounce(O.Event.any(O.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),O.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Xac=S,e.$Xac=S=ye([K(0,j.$Oj),K(1,k.$Dob),K(2,k.$Eob),K(3,k.$Oob),K(4,k.$Pob),K(5,A.$N$b),K(6,k.$Tob),K(7,g.$qGb),K(8,I.$Dl),K(9,C.$rob),K(10,L.$Dp)],S)}),define(le[263],he([0,1,73,23,5,20]),function(se,e,O,A,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=e.$d$b=e.$c$b=e.$b$b=void 0,e.$b$b=128/4;function I(g){function C(){let S=g.scheme===A.Schemas.file?(0,L.$Dg)(g):g.toString();return j.$k||(S=S.toLowerCase()),(0,O.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$c$b=I;function R(g,C){function S(){if(g.scheme!==A.Schemas.file)return(0,O.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let h;return j.$k?h=C.ino:j.$j?h=C.birthtime.getTime():j.$i&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,O.createHash)("md5").update(g.fsPath).update(h?String(h):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:g}}e.$d$b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$e$b=k}),define(le[264],he([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;let p=class extends j.$Tc{constructor(l,u,d,c){super(),this.a=l,this.b=u,this.c=d,this.f=c,this.B(new O.$oh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,u=await I.Promises.readdir(l),d=new g.$2Gb(this.f.getChannel("storage"));await Promise.all(u.map(async c=>{const y=(0,L.$jc)(l,c);c.length===S.$b$b||c===C.$oi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await d.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await I.Promises.rm(y))}))}catch(l){(0,A.$1)(l)}}};e.$uac=p,e.$uac=p=ye([K(0,R.$ki),K(1,k.$wj),K(2,m.$N$b),K(3,h.$4_b)],p)}),define(le[123],he([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class p{traceSocketEvent(f,b){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,b)}constructor(f,b=""){this.f=!0,this.debugLabel=b,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,R.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const b=P=>{this.traceSocketEvent("read",P),f(I.$qe.wrap(P))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(f){const b=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(f){const b=()=>{f()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,R.$1)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,R.$1)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$4h=p;var E;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(E||(E={}));var l;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(l||(l={}));class u extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,b){this.socket.traceSocketEvent(f,b)}constructor(f,b,P,N){super(),this.f=this.B(new k.$3d),this.g=this.B(new k.$3d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new d(this,b,P,N,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,R.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$Yh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let b=0;for(;b<f.byteLength;)this.a.writeMessage(f.slice(b,Math.min(b+262144,f.byteLength)),{compressed:!0,opcode:2}),b+=262144}m(f,{compressed:b,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const F=I.$qe.alloc(N),M=b?64:0,U=P&15;if(F.writeUInt8(128|M|U,0),f.byteLength<126)F.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){F.writeUInt8(126,1);let Y=1;F.writeUInt8(f.byteLength>>>8&255,++Y),F.writeUInt8(f.byteLength>>>0&255,++Y)}else{F.writeUInt8(127,1);let Y=1;F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(0,++Y),F.writeUInt8(f.byteLength>>>24&255,++Y),F.writeUInt8(f.byteLength>>>16&255,++Y),F.writeUInt8(f.byteLength>>>8&255,++Y),F.writeUInt8(f.byteLength>>>0&255,++Y)}this.socket.write(I.$qe.concat([F,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const b=this.b.peek(this.j.readLen),P=b.readUInt8(0),N=(P&128)>>>7,F=(P&64)>>>6,M=P&15,U=b.readUInt8(1),Y=(U&128)>>>7,Q=U&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const b=this.b.read(this.j.readLen),P=b.readUInt8(1),N=(P&128)>>>7;let F=P&127,M=1;F===126?F=b.readUInt8(++M)*2**8+b.readUInt8(++M):F===127&&(F=b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*0+b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M));let U=0;N&&(U=b.readUInt8(++M)*2**24+b.readUInt8(++M)*2**16+b.readUInt8(++M)*2**8+b.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const b=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),i(b,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(b,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$5h=u;class d extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$qe.alloc(0)}constructor(f,b,P,N,F,M){super(),this.n=f,this.r=F,this.s=M,this.a=this.B(new k.$3d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$3d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$3d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new c(this.n,N,P,{windowBits:15})),this.f=this.B(new y(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(f,b){this.g.push({data:f,options:b}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:b}=this.g.shift();if(this.f&&b.compressed){const P=await this.w(this.f,f);this.s(P,b)}else this.s(f,{...b,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,b){return new Promise((P,N)=>{f.write(b),f.flush(F=>P(F))})}acceptFrame(f,b,P){this.h.push({data:f,isCompressed:b,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const b=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,b,P){return new Promise((N,F)=>{f.write(b),P&&f.write(I.$qe.fromByteArray([0,0,255,255])),f.flush(M=>N(M))})}}class c extends g.$Tc{get recordedInflateBytes(){return this.j?I.$qe.concat(this.f):I.$qe.alloc(0)}constructor(f,b,P,N){super(),this.h=f,this.j=b,this.a=this.B(new k.$3d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(N),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(I.$qe.wrap(F))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const b=I.$qe.concat(this.g);this.g.length=0,f(b)})}}class y extends g.$Tc{constructor(f,b){super(),this.g=f,this.a=this.B(new k.$3d),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(I.$qe.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let b=I.$qe.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),f(b)})}}function i(w,f){if(f===0)return;const b=w.byteLength>>>2;for(let Y=0;Y<b;Y++){const Q=w.readUInt32BE(Y*4);w.writeUInt32BE(Q^f,Y*4)}const P=b*4,N=w.byteLength-P,F=f>>>24&255,M=f>>>16&255,U=f>>>8&255;N>=1&&w.writeUInt8(w.readUInt8(P)^F,P),N>=2&&w.writeUInt8(w.readUInt8(P+1)^M,P+1),N>=3&&w.writeUInt8(w.readUInt8(P+2)^U,P+2)}e.$6h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function n(){const w=(0,m.$yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.$6h?e.$6h:(0,j.tmpdir)(),b=(0,C.$jc)(f,`vscode-ipc-${w}.sock`);return t(b),b}e.$7h=n;function s(w,f,b){const N=(0,O.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${b}-${f}-sock`;const F=b.substr(0,4),M=f.substr(0,6);let U;return process.platform!=="darwin"&&e.$6h&&!process.env.VSCODE_PORTABLE?U=(0,C.$jc)(e.$6h,`vscode-${N}-${F}-${M}.sock`):U=(0,C.$jc)(w,`${F}-${M}.sock`),t(U),U}e.$8h=s;function t(w){const f=o[S.$u];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends h.$Sh{static b(f){const b=k.Event.fromNodeEventEmitter(f,"connection");return k.Event.map(b,P=>({protocol:new $.$Zh(new p(P,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$9h=r;function a(w){return new Promise((f,b)=>{const P=(0,A.createServer)();P.on("error",b),P.listen(w,()=>{P.removeListener("error",b),f(new r(P))})})}e.$0h=a;function v(w,f){return new Promise((b,P)=>{const N=(0,A.createConnection)(w,()=>{N.removeListener("error",P),b($.$1h.fromSocket(new p(N,`ipc-client${f}`),f))});N.once("error",P)})}e.$$h=v}),define(le[265],he([0,1,64,123,212]),function(se,e,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0,e.$1ac=new class{supports(L){return!0}connect({host:L,port:I},R,k,g){return new Promise((C,S)=>{const m=O.createConnection({host:L,port:I},()=>{m.removeListener("error",S),m.write((0,j.$Xsb)(R,k,g));const h=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),C(new A.$4h(m,g)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",S)})}}}),define(le[266],he([0,1,64,36,133,123,6,2,5,21,8,24,215,104,106,79,14]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=void 0;async function l(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new u(i,o,n,s,t).waitForReady(),!(t&&j.$Bg[t]||!j.$Bg[r.tunnelLocalPort]));a--);return r}class u extends R.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=p.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=O.createServer(),this.c=new I.$bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,p.$Qv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,j.$Cg)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,p.$Ov)(this.tunnelRemoteHost)||(0,p.$Qv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$ul)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof L.$4h?t.socket.destroy():t.end()}),t instanceof L.$4h?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(E.$qe.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$U_b=u;let d=class extends p.$Tv{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,p.$Rv)(o,this.m,k.OS,A.release())}t(o,n,s,t,r,a,v,w){const f=this.s(n,s);if(f)return++f.refcount,f.value;if((0,p.$Lv)(o))return this.u(o,n,s,r,a,v,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const b={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=l(b,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,P),P}}};e.$V_b=d,e.$V_b=d=ye([K(0,h.$ol),K(1,C.$wj),K(2,$.$rl),K(3,S.$Oj),K(4,g.$Ii)],d);let c=class extends d{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$W_b=c,e.$W_b=c=ye([K(0,h.$ol),K(1,C.$wj),K(2,$.$rl),K(3,S.$Oj),K(4,g.$Ii)],c);let y=class extends R.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,v,w,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const b=new c(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(o,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,v,w,f)}};e.$X_b=y,e.$X_b=y=ye([K(0,h.$ol),K(1,C.$wj),K(2,S.$Oj),K(3,$.$rl),K(4,g.$Ii)],y)}),define(le[273],he([0,1,36,38,7,2,23,9,17,3,40,147,206,207,197,198,264,188,190,21,211,95,222,96,217,15,114,248,29,99,189,113,97,11,200,201,72,4,196,74,75,228,8,202,102,24,59,19,107,22,108,109,110,46,231,83,111,25,81,256,261,241,84,255,259,260,122,60,254,242,106,221,79,266,216,232,28,233,5,234,191,209,208,82,247,18,51,205,58,253,230,243,105,258,249,10,203,101,251,246,218,185,57,204,262,250,56,252,104,265,182,219]),function(se,e,O,A,j,L,I,R,k,g,C,S,m,h,$,p,E,l,u,d,c,y,i,o,n,s,t,r,a,v,w,f,b,P,N,F,M,U,Y,Q,x,G,Z,H,V,te,oe,ee,ae,W,z,D,T,B,q,X,_,ie,J,ne,ce,fe,de,me,Ee,Re,Oe,Ne,ue,ge,be,Pe,Ce,Fe,De,Ue,Te,qe,ze,Le,re,$e,pe,we,ve,ke,Ie,Ae,Ve,Be,Me,Je,He,_e,tt,Et,St,$t,kt,Pt,Ct,Rt,It,Ot,Dt,jt,gt,Lt,mt,At,Nt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends L.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$KV(this)),this.b=void 0,this.c=this.B(new g.$3d),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,S.$LV)(process.parentPort,st.$0$b.exit,je)}async init(){const Se=await this.h();(0,ie.$yob)(),Se.invokeFunction(je=>{const Ze=je.get(Z.$wj),Ge=je.get(W.$Dl),Xe=je.get(ke.$_k);Ze.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ze),this.n(Ge,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(Ge,Xe)))}),this.B((0,L.$Qc)(Se.createInstance(m.$qac,this.f.codeCachePath),Se.createInstance(h.$rac),Se.createInstance(E.$uac),Se.createInstance(p.$tac),Se.createInstance($.$sac),Se.createInstance(tt.$Rac),Se.createInstance(Je.$Jac)))}async h(){const Se=new Q.$ai,je={_serviceBrand:void 0,...V.default};Se.set(te.$Oj,je);const Ze=new C.$Wh(We=>We==="main"),Ge=new gt.$5_b(this.a,Ze);Se.set(gt.$4_b,Ge);const Xe=this.f.policiesData?new Ae.$A_b(this.f.policiesData,Ge.getChannel("policy")):new Ve.$Vn;Se.set(Ve.$Tn,Xe);const Ke=new Nt.$Lm(this.f.args,je);Se.set(s.$ki,Ke);const et=new H.$Jr(void 0,this.f.logLevel,Ke.logsHome,this.f.loggers.map(We=>({...We,resource:R.URI.revive(We.resource)})),Ge.getChannel("logger"));Se.set(Z.$xj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new Z.$Ej(ot.getLevel())),Qe=this.B(new St.$xP(ot,[ht]));Se.set(Z.$wj,Qe),this.b=this.B(new $t.$Tac(Qe)),Se.set($t.$Sac,this.b);const Ye=this.B(new N.$lq(Qe));Se.set(P.$zk,Ye);const ut=this.B(new F.$Kq(Qe));Ye.registerProvider(I.Schemas.file,ut);const at=new qe.$$r(Ye);Se.set(Te.$0k,at);const xe=this.B(new Be.$EP(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Se.set(ke.$_k,xe);const ft=this.B(new Le.$3_b(I.Schemas.file,this.B(new re.$gP(Ge.getChannel(re.$fP),{pathCaseSensitive:ze.$k})),I.Schemas.vscodeUserData,xe,at,Qe));Ye.registerProvider(I.Schemas.vscodeUserData,ft);const it=this.B(new c.$jo(xe.defaultProfile.settingsResource,Ye,Xe,Qe));Se.set(d.$Ii,it);const dt=new Lt.$Zac(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ge,Ke);Se.set(ee.$Dp,dt),this.B((0,L.$Rc)(()=>dt.flush())),await Promise.all([it.initialize(),dt.initialize()]);const bt=new Ct.$ur(Ge.getChannel("request"));Se.set(oe.$qp,bt),Se.set(l.$vac,new M.$_h(u.$wac,void 0,!1)),Se.set(pe.$yF,new M.$_h($e.$Iac,void 0,!1));const pt=new Ot.$0_b(-1,Ge);Se.set(It.$N$b,pt),Se.set(o.$no,new M.$_h(n.$MP,void 0,!0));const Ft=this.B(new ge.$x_b(pt)),Mt=new C.$Wh(We=>Ft.getActiveClientId().then(lt=>We===lt));Se.set(b.$7Zb,new Rt.$Vac(this.a.getChannel("extensionRecommendationNotification",Mt)));let ct;const nt=[],yt=(0,B.$7o)(je,it);if((0,B.$2o)(je,Ke)){const We=new D.$A9b(Qe,et,Ke,je);if(nt.push(We),!(0,B.$3o)(je,Ke)&&je.aiConfig?.ariaKey){const lt=new Me.$lP(bt,yt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,L.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new T.$yr({appenders:nt,commonProperties:(0,ae.$So)((0,O.release)(),(0,O.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,yt),sendErrorTelemetry:!0,piiPaths:(0,B.$8o)(Ke)},it,je)}else{ct=B.$Wo;const We=B.$1o;nt.push(We)}this.a.registerChannel("telemetryAppender",new z.$c_b(nt)),Se.set(W.$Dl,ct);const qt=new q.$xac(it,ct,Qe,et,Ke,je);Se.set(W.$El,qt),Se.set(Ie.$5p,new M.$_h(Pt.$wP,void 0,!0)),Se.set(we.$9p,new M.$_h(ve.$B_b,void 0,!0)),Se.set(v.$Op,new M.$_h(v.$Pp,void 0,!0)),Se.set(f.$gq,new M.$_h(f.$hq,void 0,!0)),Se.set(a.$Io,new M.$_h(r.$Mp,void 0,!0)),Se.set(a.$Po,new M.$_h(jt.$Yac,void 0,!1)),Se.set(x.$qr,new M.$_h(G.$sr,void 0,!1)),Se.set(y.$Sm,new M.$_h(i.$fs,void 0,!1)),Se.set(J.$qGb,new M.$_h(J.$rGb,void 0,!0)),Se.set(ie.$Tob,new M.$_h(fe.$LIb,void 0,!0)),Se.set(ie.$Sob,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),Se.set(a.$Oo,new M.$_h(t.$oGb,void 0,!1)),Se.set(_.$JIb,new M.$_h(_.$KIb,void 0,!0)),Se.set(X.$vv,new M.$_h(X.$wv)),Se.set(ie.$Dob,new M.$_h(Oe.$THb,void 0,!0)),Se.set(ie.$Eob,new M.$_h(Oe.$VHb,void 0,!0)),Se.set(de.$rob,new M.$_h(de.$tob,void 0,!0)),Se.set(ie.$Fob,new M.$_h(ne.$d0b,void 0,!1)),Se.set(ie.$Oob,new M.$_h(me.$59b,void 0,!0)),Se.set(ie.$Pob,new M.$_h(Ee.$i0b,void 0,!1)),Se.set(Ne.$3Gb,new M.$_h(ue.$Eac,void 0,!0)),Se.set(ie.$Qob,new M.$_h(_e.$R0b,void 0,!0)),Se.set(be.$rl,new M.$_h(Pe.$Z_b,void 0,!1));const vt=new mt.$pl;return Se.set(mt.$ol,vt),vt.register(0,At.$1ac),Se.set(Ce.$Kv,new M.$_h(Fe.$X_b)),Se.set(De.$Fac,new M.$_h(Ue.$Hac)),Se.set(He.$Kac,new M.$_h(kt.$Uac)),new Y.$Nq(Se)}j(Se){const je=new w.$Rp(Se.get(a.$Lo),()=>null);this.a.registerChannel("extensions",je);const Ze=C.ProxyChannel.fromService(Se.get(x.$qr),this.q);this.a.registerChannel("languagePacks",Ze);const Ge=C.ProxyChannel.fromService(Se.get(y.$Sm),this.q);this.a.registerChannel("diagnostics",Ge);const Xe=new w.$Tp(Se.get(a.$Po));this.a.registerChannel("extensionTipsService",Xe);const Ke=C.ProxyChannel.fromService(Se.get(l.$vac),this.q);this.a.registerChannel("checksum",Ke);const et=C.ProxyChannel.fromService(Se.get(pe.$yF),this.q);this.a.registerChannel("v8InspectProfiling",et);const ot=C.ProxyChannel.fromService(Se.get(de.$rob),this.q);this.a.registerChannel("userDataSyncMachines",ot);const ht=C.ProxyChannel.fromService(Se.get(W.$El),this.q);this.a.registerChannel("customEndpointTelemetry",ht);const Qe=new ce.$yac(Se.get(J.$qGb));this.a.registerChannel("userDataSyncAccount",Qe);const Ye=new ce.$Aac(Se.get(ie.$Dob));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ut=new Re.$Cac(Se.get(ie.$Pob),Se.get(ke.$_k),Se.get(Z.$wj));this.a.registerChannel("userDataSync",ut);const at=this.B(Se.get(U.$bi).createInstance(Dt.$Xac));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(at,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(ie.$Qob),this.q));const xe=C.ProxyChannel.fromService(Se.get(De.$Fac),this.q);this.a.registerChannel(De.$Gac,xe);const ft=C.ProxyChannel.fromService(Se.get(He.$Kac),this.q);this.a.registerChannel("remoteTunnel",ft)}m(Se){process.on("uncaughtException",je=>(0,j.$1)(je)),process.on("unhandledRejection",je=>(0,j.$1)(je)),(0,j.setUnexpectedErrorHandler)(je=>{const Ze=(0,A.$Zi)(je,!0);Ze&&Se.error(`[uncaught exception in sharedProcess]: ${Ze}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}handledClientConnection(Se){if(Se.data!==st.$_$b.response)return!1;const je=(0,k.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function wt(rt){const Se=new Tt(rt);process.parentPort.postMessage(st.$0$b.ipcReady),await Se.init(),process.parentPort.postMessage(st.$0$b.initDone)}e.main=wt,process.parentPort.once("message",rt=>{wt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d84c946d27b649d614319c796911871320befd42/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
