/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","vs/base/common/htmlContent","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ie=function(me){for(var e=[],I=0,O=me.length;I<O;I++)e[I]=Ce[me[I]];return e};define(Ce[158],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class I{static get(){const $=new Map,A=new Map,R=new Map,v=new Map;function p(E,k){E.has(k.detail)||E.set(k.detail,-k.timestamp)}function S(E,k){const u=E.get(k.detail);u&&(u>=0||E.set(k.detail,u+k.timestamp))}let L=[];typeof me=="function"&&typeof me.getStats=="function"&&(L=me.getStats().slice(0).sort((E,k)=>E.timestamp-k.timestamp));for(const E of L)switch(E.type){case 10:p($,E);break;case 11:case 12:S($,E);break;case 21:p(A,E);break;case 22:S(A,E);break;case 33:p(R,E);break;case 34:S(R,E);break;case 31:p(v,E);break;case 32:S(v,E);break}let C=0;R.forEach(E=>C+=E);function w(E){const k=[];return E.forEach((u,m)=>k.push([m,u])),k}return{amdLoad:w($),amdInvoke:w(A),nodeRequire:w(R),nodeEval:w(v),nodeRequireTotal:C}}static toMarkdownTable($,A){let R="";const v=[];return $.forEach((p,S)=>{v[S]=p.length}),A.forEach(p=>{p.forEach((S,L)=>{typeof S>"u"&&(S=p[L]="-");const C=S.toString().length;v[L]=Math.max(C,v[L])})}),$.forEach((p,S)=>{R+=`| ${p+" ".repeat(v[S]-p.toString().length)} `}),R+=`|
`,$.forEach((p,S)=>{R+=`| ${"-".repeat(v[S])} `}),R+=`|
`,A.forEach(p=>{p.forEach((S,L)=>{typeof S<"u"&&(R+=`| ${S+" ".repeat(v[L]-S.toString().length)} `)}),R+=`|
`}),R}}e.$U=I}),define(Ce[159],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function I(u,m,o){const i=O(u,m);if(i!==-1)return u[i]}e.$fb=I;function O(u,m,o=u.length-1){for(let i=o;i>=0;i--){const n=u[i];if(m(n))return i}return-1}e.$gb=O;function $(u,m){const o=A(u,m);return o===-1?void 0:u[o]}e.$hb=$;function A(u,m,o=0,i=u.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);m(u[a])?n=a+1:r=a}return n-1}e.$ib=A;function R(u,m){const o=v(u,m);return o===u.length?void 0:u[o]}e.$jb=R;function v(u,m,o=0,i=u.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);m(u[a])?r=a:n=a+1}return n}e.$kb=v;function p(u,m,o=0,i=u.length){const n=v(u,m,o,i);return n===u.length?-1:n}e.$lb=p;class S{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(S.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=A(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=S;function L(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>0&&(o=n)}return o}e.$nb=L;function C(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>=0&&(o=n)}return o}e.$ob=C;function w(u,m){return L(u,(o,i)=>-m(o,i))}e.$pb=w;function E(u,m){if(u.length===0)return-1;let o=0;for(let i=1;i<u.length;i++){const n=u[i];m(n,u[o])>0&&(o=i)}return o}e.$qb=E;function k(u,m){for(const o of u){const i=m(o);if(i!==void 0)return i}}e.$rb=k}),define(Ce[74],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function I(R,v){const p=Object.create(null);for(const S of R){const L=v(S);let C=p[L];C||(C=p[L]=[]),C.push(S)}return p}e.$K=I;function O(R,v){const p=[],S=[];for(const L of R)v.has(L)||p.push(L);for(const L of v)R.has(L)||S.push(L);return{removed:p,added:S}}e.$L=O;function $(R,v){const p=[],S=[];for(const[L,C]of R)v.has(L)||p.push(C);for(const[L,C]of v)R.has(L)||S.push(C);return{removed:p,added:S}}e.$M=$;function A(R,v){const p=new Set;for(const S of v)R.has(S)&&p.add(S);return p}e.$N=A}),define(Ce[52],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=void 0;function I(R){return(v,p,S)=>{let L=null,C=null;if(typeof S.value=="function"?(L="value",C=S.value):typeof S.get=="function"&&(L="get",C=S.get),!C)throw new Error("not supported");S[L]=R(C,p)}}function O(R,v,p){let S=null,L=null;if(typeof p.value=="function"?(S="value",L=p.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(S="get",L=p.get),!L)throw new Error("not supported");const C=`$memoize$${v}`;p[S]=function(...w){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,w)}),this[C]}}e.$Gh=O;function $(R,v,p){return I((S,L)=>{const C=`$debounce$${L}`,w=`$debounce$result$${L}`;return function(...E){this[w]||(this[w]=p?p():void 0),clearTimeout(this[C]),v&&(this[w]=v(this[w],...E),E=[this[w]]),this[C]=setTimeout(()=>{S.apply(this,E),this[w]=p?p():void 0},R)}})}e.$Hh=$;function A(R,v,p){return I((S,L)=>{const C=`$throttle$timer$${L}`,w=`$throttle$result$${L}`,E=`$throttle$lastRun$${L}`,k=`$throttle$pending$${L}`;return function(...u){if(this[w]||(this[w]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[w]=v(this[w],...u)),this[k])return;const m=this[E]+R;m<=Date.now()?(this[E]=Date.now(),S.apply(this,[this[w]]),this[w]=p?p():void 0):(this[k]=!0,this[C]=setTimeout(()=>{this[k]=!1,this[E]=Date.now(),S.apply(this,[this[w]]),this[w]=p?p():void 0},m-Date.now()))}})}e.$Ih=A}),define(Ce[14],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class I{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(d=>{d(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=I,e.$X=new I;function O(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=O;function $(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=$;function A(a){S(a)||e.$X.onUnexpectedError(a)}e.$1=A;function R(a){S(a)||e.$X.onUnexpectedExternalError(a)}e.$2=R;function v(a){if(a instanceof Error){const{name:t,message:d}=a,c=a.stacktrace||a.stack;return{$isError:!0,name:t,message:d,stack:c,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$3=v;const p="Canceled";function S(a){return a instanceof L?!0:a instanceof Error&&a.name===p&&a.message===p}e.$4=S;class L extends Error{constructor(){super(p),this.name=this.message}}e.$5=L;function C(){const a=new Error(p);return a.name=a.message,a}e.$6=C;function w(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=w;function E(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=E;class k extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=k;function u(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=u;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const d=new n;return d.message=t.message,d.stack=t.stack,d}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Ce[19],Ie([1,0,14,159]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function $(le,de=0){return le[le.length-(1+de)]}e.$sb=$;function A(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=A;function R(le,de,ue=(ge,V)=>ge===V){if(le===de)return!0;if(!le||!de||le.length!==de.length)return!1;for(let ge=0,V=le.length;ge<V;ge++)if(!ue(le[ge],de[ge]))return!1;return!0}e.$ub=R;function v(le,de){const ue=le.length-1;de<ue&&(le[de]=le[ue]),le.pop()}e.$vb=v;function p(le,de,ue){return S(le.length,ge=>ue(le[ge],de))}e.$wb=p;function S(le,de){let ue=0,ge=le-1;for(;ue<=ge;){const V=(ue+ge)/2|0,X=de(V);if(X<0)ue=V+1;else if(X>0)ge=V-1;else return V}return-(ue+1)}e.$xb=S;function L(le,de,ue){if(le=le|0,le>=de.length)throw new TypeError("invalid index");const ge=de[Math.floor(de.length*Math.random())],V=[],X=[],he=[];for(const be of de){const Pe=ue(be,ge);Pe<0?V.push(be):Pe>0?X.push(be):he.push(be)}return le<V.length?L(le,V,ue):le<V.length+he.length?he[0]:L(le-(V.length+he.length),X,ue)}e.$yb=L;function C(le,de){const ue=[];let ge;for(const V of le.slice(0).sort(de))!ge||de(ge[0],V)!==0?(ge=[V],ue.push(ge)):ge.push(V);return ue}e.$zb=C;function*w(le,de){let ue,ge;for(const V of le)ge!==void 0&&de(ge,V)?ue.push(V):(ue&&(yield ue),ue=[V]),ge=V;ue&&(yield ue)}e.$Ab=w;function E(le,de){for(let ue=0;ue<=le.length;ue++)de(ue===0?void 0:le[ue-1],ue===le.length?void 0:le[ue])}e.$Bb=E;function k(le,de){for(let ue=0;ue<le.length;ue++)de(ue===0?void 0:le[ue-1],le[ue],ue+1===le.length?void 0:le[ue+1])}e.$Cb=k;function u(le,de,ue){const ge=[];function V(be,Pe,pe){if(Pe===0&&pe.length===0)return;const Ae=ge[ge.length-1];Ae&&Ae.start+Ae.deleteCount===be?(Ae.deleteCount+=Pe,Ae.toInsert.push(...pe)):ge.push({start:be,deleteCount:Pe,toInsert:pe})}let X=0,he=0;for(;;){if(X===le.length){V(X,0,de.slice(he));break}if(he===de.length){V(X,le.length-X,[]);break}const be=le[X],Pe=de[he],pe=ue(be,Pe);pe===0?(X+=1,he+=1):pe<0?(V(X,1,[]),X+=1):pe>0&&(V(X,0,[Pe]),he+=1)}return ge}e.$Db=u;function m(le,de,ue){const ge=u(le,de,ue),V=[],X=[];for(const he of ge)V.push(...le.slice(he.start,he.start+he.deleteCount)),X.push(...he.toInsert);return{removed:V,added:X}}e.$Eb=m;function o(le,de,ue){if(ue===0)return[];const ge=le.slice(0,ue).sort(de);return n(le,de,ge,ue,le.length),ge}e.top=o;function i(le,de,ue,ge,V){return ue===0?Promise.resolve([]):new Promise((X,he)=>{(async()=>{const be=le.length,Pe=le.slice(0,ue).sort(de);for(let pe=ue,Ae=Math.min(ue+ge,be);pe<be;pe=Ae,Ae=Math.min(Ae+ge,be)){if(pe>ue&&await new Promise(Fe=>setTimeout(Fe)),V&&V.isCancellationRequested)throw new I.$5;n(le,de,Pe,pe,Ae)}return Pe})().then(X,he)})}e.$Gb=i;function n(le,de,ue,ge,V){for(const X=ue.length;ge<V;ge++){const he=le[ge];if(de(he,ue[X-1])<0){ue.pop();const be=(0,O.$kb)(ue,Pe=>de(he,Pe)<0);ue.splice(be,0,he)}}}function r(le){return le.filter(de=>!!de)}e.$Hb=r;function a(le){let de=0;for(let ue=0;ue<le.length;ue++)le[ue]&&(le[de]=le[ue],de+=1);le.length=de}e.$Ib=a;function t(le,de,ue){le.splice(ue,0,le.splice(de,1)[0])}e.$Jb=t;function d(le){return!Array.isArray(le)||le.length===0}e.$Kb=d;function c(le){return Array.isArray(le)&&le.length>0}e.$Lb=c;function s(le,de=ue=>ue){const ue=new Set;return le.filter(ge=>{const V=de(ge);return ue.has(V)?!1:(ue.add(V),!0)})}e.$Mb=s;function l(le){const de=new Set;return ue=>{const ge=le(ue);return de.has(ge)?!1:(de.add(ge),!0)}}e.$Nb=l;function h(le,de){return le.length>0?le[0]:de}e.$Ob=h;function b(le,de){return le.length>0?le[le.length-1]:de}e.$Pb=b;function D(le,de,ue=(ge,V)=>ge===V){let ge=0;for(let V=0,X=Math.min(le.length,de.length);V<X&&ue(le[V],de[V]);V++)ge++;return ge}e.$Qb=D;function g(le){return[].concat(...le)}e.$Rb=g;function f(le,de){let ue=typeof de=="number"?le:0;typeof de=="number"?ue=le:(ue=0,de=le);const ge=[];if(ue<=de)for(let V=ue;V<de;V++)ge.push(V);else for(let V=ue;V>de;V--)ge.push(V);return ge}e.$Sb=f;function y(le,de,ue){return le.reduce((ge,V)=>(ge[de(V)]=ue?ue(V):V,ge),Object.create(null))}e.$Tb=y;function P(le,de){return le.push(de),()=>N(le,de)}e.$Ub=P;function N(le,de){const ue=le.indexOf(de);if(ue>-1)return le.splice(ue,1),de}e.$Vb=N;function U(le,de,ue){const ge=le.slice(0,de),V=le.slice(de);return ge.concat(ue,V)}e.$Wb=U;function z(le,de){let ue;if(typeof de=="number"){let ge=de;ue=()=>{const V=Math.sin(ge++)*179426549;return V-Math.floor(V)}}else ue=Math.random;for(let ge=le.length-1;ge>0;ge-=1){const V=Math.floor(ue()*(ge+1)),X=le[ge];le[ge]=le[V],le[V]=X}}e.$Xb=z;function F(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.unshift(de))}e.$Yb=F;function M(le,de){const ue=le.indexOf(de);ue>-1&&(le.splice(ue,1),le.push(de))}e.$Zb=M;function T(le,de){for(const ue of de)le.push(ue)}e.$1b=T;function j(le,de){return Array.isArray(le)?le.map(de):de(le)}e.$2b=j;function J(le){return Array.isArray(le)?le:[le]}e.$3b=J;function ne(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=ne;function _(le,de,ue){const ge=Y(le,de),V=le.length,X=ue.length;le.length=V+X;for(let he=V-1;he>=ge;he--)le[he+X]=le[he];for(let he=0;he<X;he++)le[he+ge]=ue[he]}e.$5b=_;function Z(le,de,ue,ge){const V=Y(le,de);let X=le.splice(V,ue);return X===void 0&&(X=[]),_(le,V,ge),X}e.$6b=Z;function Y(le,de){return de<0?Math.max(de+le.length,0):Math.min(de,le.length)}var ce;(function(le){function de(X){return X<0}le.isLessThan=de;function ue(X){return X<=0}le.isLessThanOrEqual=ue;function ge(X){return X>0}le.isGreaterThan=ge;function V(X){return X===0}le.isNeitherLessOrGreaterThan=V,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function ie(le,de){return(ue,ge)=>de(le(ue),le(ge))}e.$7b=ie;function fe(...le){return(de,ue)=>{for(const ge of le){const V=ge(de,ue);if(!ce.isNeitherLessOrGreaterThan(V))return V}return ce.neitherLessOrGreaterThan}}e.$8b=fe;const re=(le,de)=>le-de;e.$9b=re;const K=(le,de)=>(0,e.$9b)(le?1:0,de?1:0);e.$0b=K;function B(le){return(de,ue)=>-le(de,ue)}e.$$b=B;class ae{constructor(de){this.g=de,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(de){let ue=this.c;for(;ue<this.g.length&&de(this.g[ue]);)ue++;const ge=ue===this.c?null:this.g.slice(this.c,ue);return this.c=ue,ge}takeFromEndWhile(de){let ue=this.d;for(;ue>=0&&de(this.g[ue]);)ue--;const ge=ue===this.d?null:this.g.slice(ue+1,this.d+1);return this.d=ue,ge}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const de=this.g[this.c];return this.c++,de}removeLast(){const de=this.g[this.d];return this.d--,de}takeCount(de){const ue=this.g.slice(this.c,this.c+de);return this.c+=de,ue}}e.$_b=ae;class ye{static{this.empty=new ye(de=>{})}constructor(de){this.iterate=de}forEach(de){this.iterate(ue=>(de(ue),!0))}toArray(){const de=[];return this.iterate(ue=>(de.push(ue),!0)),de}filter(de){return new ye(ue=>this.iterate(ge=>de(ge)?ue(ge):!0))}map(de){return new ye(ue=>this.iterate(ge=>ue(de(ge))))}some(de){let ue=!1;return this.iterate(ge=>(ue=de(ge),!ue)),ue}findFirst(de){let ue;return this.iterate(ge=>de(ge)?(ue=ge,!1):!0),ue}findLast(de){let ue;return this.iterate(ge=>(de(ge)&&(ue=ge),!0)),ue}findLastMaxBy(de){let ue,ge=!0;return this.iterate(V=>((ge||ce.isGreaterThan(de(V,ue)))&&(ge=!1,ue=V),!0)),ue}}e.$ac=ye}),define(Ce[61],Ie([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function O(S,L){if(!S)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=O;function $(S,L="Unreachable"){throw new Error(L)}e.$9c=$;function A(S){if(!S)throw new I.$cb("Assertion Failed")}e.$0c=A;function R(S){S||(0,I.$1)(new I.$cb("Assertion Failed"))}e.$$c=R;function v(S){if(!S()){debugger;S(),(0,I.$1)(new I.$cb("Assertion Failed"))}}e.$_c=v;function p(S,L){let C=0;for(;C<S.length-1;){const w=S[C],E=S[C+1];if(!L(w,E))return!1;C++}return!0}e.$ad=p}),define(Ce[75],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function I(O,$){const A=this;let R=!1,v;return function(){if(R)return v;if(R=!0,$)try{v=O.apply(A,arguments)}finally{$()}else v=O.apply(A,arguments);return v}}e.$db=I}),define(Ce[121],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0;class I{constructor($){this.a=$,this.b=0}nextId(){return this.a+ ++this.b}}e.$fO=I,e.$gO=new I("id#")}),define(Ce[53],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(O){function $(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}O.is=$;const A=Object.freeze([]);function R(){return A}O.empty=R;function*v(t){yield t}O.single=v;function p(t){return $(t)?t:v(t)}O.wrap=p;function S(t){return t||A}O.from=S;function*L(t){for(let d=t.length-1;d>=0;d--)yield t[d]}O.reverse=L;function C(t){return!t||t[Symbol.iterator]().next().done===!0}O.isEmpty=C;function w(t){return t[Symbol.iterator]().next().value}O.first=w;function E(t,d){for(const c of t)if(d(c))return!0;return!1}O.some=E;function k(t,d){for(const c of t)if(d(c))return c}O.find=k;function*u(t,d){for(const c of t)d(c)&&(yield c)}O.filter=u;function*m(t,d){let c=0;for(const s of t)yield d(s,c++)}O.map=m;function*o(...t){for(const d of t)yield*d}O.concat=o;function i(t,d,c){let s=c;for(const l of t)s=d(s,l);return s}O.reduce=i;function*n(t,d,c=t.length){for(d<0&&(d+=t.length),c<0?c+=t.length:c>t.length&&(c=t.length);d<c;d++)yield t[d]}O.slice=n;function r(t,d=Number.POSITIVE_INFINITY){const c=[];if(d===0)return[c,t];const s=t[Symbol.iterator]();for(let l=0;l<d;l++){const h=s.next();if(h.done)return[c,O.empty()];c.push(h.value)}return[c,{[Symbol.iterator](){return s}}]}O.consume=r;async function a(t){const d=[];for await(const c of t)d.push(c);return Promise.resolve(d)}O.asyncToArray=a})(I||(e.Iterable=I={}))}),define(Ce[160],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var $;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})($||(e.ParseErrorCode=$={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,d=!1){let c=0;const s=t.length;let l="",h=0,b=16,D=0;function g(F){let M=0,T=0;for(;M<F;){const j=t.charCodeAt(c);if(j>=48&&j<=57)T=T*16+j-48;else if(j>=65&&j<=70)T=T*16+j-65+10;else if(j>=97&&j<=102)T=T*16+j-97+10;else break;c++,M++}return M<F&&(T=-1),T}function f(F){c=F,l="",h=0,b=16,D=0}function y(){const F=c;if(t.charCodeAt(c)===48)c++;else for(c++;c<t.length&&S(t.charCodeAt(c));)c++;if(c<t.length&&t.charCodeAt(c)===46)if(c++,c<t.length&&S(t.charCodeAt(c)))for(c++;c<t.length&&S(t.charCodeAt(c));)c++;else return D=3,t.substring(F,c);let M=c;if(c<t.length&&(t.charCodeAt(c)===69||t.charCodeAt(c)===101))if(c++,(c<t.length&&t.charCodeAt(c)===43||t.charCodeAt(c)===45)&&c++,c<t.length&&S(t.charCodeAt(c))){for(c++;c<t.length&&S(t.charCodeAt(c));)c++;M=c}else D=3;return t.substring(F,M)}function P(){let F="",M=c;for(;;){if(c>=s){F+=t.substring(M,c),D=2;break}const T=t.charCodeAt(c);if(T===34){F+=t.substring(M,c),c++;break}if(T===92){if(F+=t.substring(M,c),c++,c>=s){D=2;break}switch(t.charCodeAt(c++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const J=g(4);J>=0?F+=String.fromCharCode(J):D=4;break}default:D=5}M=c;continue}if(T>=0&&T<=31)if(p(T)){F+=t.substring(M,c),D=2;break}else D=6;c++}return F}function N(){if(l="",D=0,h=c,c>=s)return h=s,b=17;let F=t.charCodeAt(c);if(v(F)){do c++,l+=String.fromCharCode(F),F=t.charCodeAt(c);while(v(F));return b=15}if(p(F))return c++,l+=String.fromCharCode(F),F===13&&t.charCodeAt(c)===10&&(c++,l+=`
`),b=14;switch(F){case 123:return c++,b=1;case 125:return c++,b=2;case 91:return c++,b=3;case 93:return c++,b=4;case 58:return c++,b=6;case 44:return c++,b=5;case 34:return c++,l=P(),b=10;case 47:{const M=c-1;if(t.charCodeAt(c+1)===47){for(c+=2;c<s&&!p(t.charCodeAt(c));)c++;return l=t.substring(M,c),b=12}if(t.charCodeAt(c+1)===42){c+=2;const T=s-1;let j=!1;for(;c<T;){if(t.charCodeAt(c)===42&&t.charCodeAt(c+1)===47){c+=2,j=!0;break}c++}return j||(c++,D=1),l=t.substring(M,c),b=13}return l+=String.fromCharCode(F),c++,b=16}case 45:if(l+=String.fromCharCode(F),c++,c===s||!S(t.charCodeAt(c)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=y(),b=11;default:for(;c<s&&U(F);)c++,F=t.charCodeAt(c);if(h!==c){switch(l=t.substring(h,c),l){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return l+=String.fromCharCode(F),c++,b=16}}function U(F){if(v(F)||p(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let F;do F=N();while(F>=12&&F<=15);return F}return{setPosition:f,getPosition:()=>c,scan:d?z:N,getToken:()=>b,getTokenValue:()=>l,getTokenOffset:()=>h,getTokenLength:()=>c-h,getTokenError:()=>D}}e.$kn=R;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function S(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function C(t,d){const c=[],s=new Object;let l;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function D(g,f,y,P){h.value=g,h.offset=f,h.length=y,h.type=P,h.colonOffset=void 0,l=h}try{n(t,{onObjectBegin:(g,f)=>{if(d<=g)throw s;l=void 0,b=d>g,c.push("")},onObjectProperty:(g,f,y)=>{if(d<f||(D(g,f,y,"property"),c[c.length-1]=g,d<=f+y))throw s},onObjectEnd:(g,f)=>{if(d<=g)throw s;l=void 0,c.pop()},onArrayBegin:(g,f)=>{if(d<=g)throw s;l=void 0,c.push(0)},onArrayEnd:(g,f)=>{if(d<=g)throw s;l=void 0,c.pop()},onLiteralValue:(g,f,y)=>{if(d<f||(D(g,f,y,a(g)),d<=f+y))throw s},onSeparator:(g,f,y)=>{if(d<=f)throw s;if(g===":"&&l&&l.type==="property")l.colonOffset=f,b=!1,l=void 0;else if(g===","){const P=c[c.length-1];typeof P=="number"?c[c.length-1]=P+1:(b=!0,c[c.length-1]=""),l=void 0}}})}catch(g){if(g!==s)throw g}return{path:c,previousNode:l,isAtPropertyKey:b,matches:g=>{let f=0;for(let y=0;f<g.length&&y<c.length;y++)if(g[f]===c[y]||g[f]==="*")f++;else if(g[f]!=="**")return!1;return f===g.length}}}e.$ln=C;function w(t,d=[],c=A.DEFAULT){let s=null,l=[];const h=[];function b(g){Array.isArray(l)?l.push(g):s!==null&&(l[s]=g)}return n(t,{onObjectBegin:()=>{const g={};b(g),h.push(l),l=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{l=h.pop()},onArrayBegin:()=>{const g=[];b(g),h.push(l),l=g,s=null},onArrayEnd:()=>{l=h.pop()},onLiteralValue:b,onError:(g,f,y)=>{d.push({error:g,offset:f,length:y})}},c),l[0]}e.$mn=w;function E(t,d=[],c=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(g){s.type==="property"&&(s.length=g-s.offset,s=s.parent)}function h(g){return s.children.push(g),g}n(t,{onObjectBegin:g=>{s=h({type:"object",offset:g,length:-1,parent:s,children:[]})},onObjectProperty:(g,f,y)=>{s=h({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:g,offset:f,length:y,parent:s})},onObjectEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,l(g+f)},onArrayBegin:(g,f)=>{s=h({type:"array",offset:g,length:-1,parent:s,children:[]})},onArrayEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,l(g+f)},onLiteralValue:(g,f,y)=>{h({type:a(g),offset:f,length:y,parent:s,value:g}),l(f+y)},onSeparator:(g,f,y)=>{s.type==="property"&&(g===":"?s.colonOffset=f:g===","&&l(f))},onError:(g,f,y)=>{d.push({error:g,offset:f,length:y})}},c);const D=s.children[0];return D&&delete D.parent,D}e.$nn=E;function k(t,d){if(!t)return;let c=t;for(const s of d)if(typeof s=="string"){if(c.type!=="object"||!Array.isArray(c.children))return;let l=!1;for(const h of c.children)if(Array.isArray(h.children)&&h.children[0].value===s){c=h.children[1],l=!0;break}if(!l)return}else{const l=s;if(c.type!=="array"||l<0||!Array.isArray(c.children)||l>=c.children.length)return;c=c.children[l]}return c}e.$on=k;function u(t){if(!t.parent||!t.parent.children)return[];const d=u(t.parent);if(t.parent.type==="property"){const c=t.parent.children[0].value;d.push(c)}else if(t.parent.type==="array"){const c=t.parent.children.indexOf(t);c!==-1&&d.push(c)}return d}e.$pn=u;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const d=Object.create(null);for(const c of t.children){const s=c.children[1];s&&(d[c.children[0].value]=m(s))}return d}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$qn=m;function o(t,d,c=!1){return d>=t.offset&&d<t.offset+t.length||c&&d===t.offset+t.length}e.$rn=o;function i(t,d,c=!1){if(o(t,d,c)){const s=t.children;if(Array.isArray(s))for(let l=0;l<s.length&&s[l].offset<=d;l++){const h=i(s[l],d,c);if(h)return h}return t}}e.$sn=i;function n(t,d,c=A.DEFAULT){const s=R(t,!1);function l(ie){return ie?()=>ie(s.getTokenOffset(),s.getTokenLength()):()=>!0}function h(ie){return ie?fe=>ie(fe,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=l(d.onObjectBegin),D=h(d.onObjectProperty),g=l(d.onObjectEnd),f=l(d.onArrayBegin),y=l(d.onArrayEnd),P=h(d.onLiteralValue),N=h(d.onSeparator),U=l(d.onComment),z=h(d.onError),F=c&&c.disallowComments,M=c&&c.allowTrailingComma;function T(){for(;;){const ie=s.scan();switch(s.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:F||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(ie){case 12:case 13:F?j(10):U();break;case 16:j(1);break;case 15:case 14:break;default:return ie}}}function j(ie,fe=[],re=[]){if(z(ie),fe.length+re.length>0){let K=s.getToken();for(;K!==17;){if(fe.indexOf(K)!==-1){T();break}else if(re.indexOf(K)!==-1)break;K=T()}}}function J(ie){const fe=s.getTokenValue();return ie?P(fe):D(fe),T(),!0}function ne(){switch(s.getToken()){case 11:{let ie=0;try{ie=JSON.parse(s.getTokenValue()),typeof ie!="number"&&(j(2),ie=0)}catch{j(2)}P(ie);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return T(),!0}function _(){return s.getToken()!==10?(j(3,[],[2,5]),!1):(J(!1),s.getToken()===6?(N(":"),T(),ce()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Z(){b(),T();let ie=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ie||j(4,[],[]),N(","),T(),s.getToken()===2&&M)break}else ie&&j(6,[],[]);_()||j(4,[],[2,5]),ie=!0}return g(),s.getToken()!==2?j(7,[2],[]):T(),!0}function Y(){f(),T();let ie=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ie||j(4,[],[]),N(","),T(),s.getToken()===4&&M)break}else ie&&j(6,[],[]);ce()||j(4,[],[4,5]),ie=!0}return y(),s.getToken()!==4?j(8,[4],[]):T(),!0}function ce(){switch(s.getToken()){case 3:return Y();case 1:return Z();case 10:return J(!0);default:return ne()}}return T(),s.getToken()===17?c.allowEmptyContent?!0:(j(4,[],[]),!1):ce()?(s.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.$tn=n;function r(t,d){const c=R(t),s=[];let l,h=0,b;do switch(b=c.getPosition(),l=c.scan(),l){case 12:case 13:case 17:h!==b&&s.push(t.substring(h,b)),d!==void 0&&s.push(c.getTokenValue().replace(/[^\r\n]/g,d)),h=c.getPosition();break}while(l!==17);return s.join("")}e.$un=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$vn=a}),define(Ce[43],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class I{constructor($){this.d=$,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch($){this.c=$}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=I}),define(Ce[76],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class I{static{this.Undefined=new I(void 0)}constructor(A){this.element=A,this.next=I.Undefined,this.prev=I.Undefined}}class O{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let A=this.a;for(;A!==I.Undefined;){const R=A.next;A.prev=I.Undefined,A.next=I.Undefined,A=R}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const v=new I(A);if(this.a===I.Undefined)this.a=v,this.b=v;else if(R){const S=this.b;this.b=v,v.prev=S,S.next=v}else{const S=this.a;this.a=v,v.next=S,S.prev=v}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(v))}}shift(){if(this.a!==I.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==I.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==I.Undefined&&A.next!==I.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===I.Undefined&&A.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):A.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):A.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==I.Undefined;)yield A.element,A=A.next}}e.$4c=O}),define(Ce[28],Ie([1,0]),function(me,e){"use strict";var I,O,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(n,r,a){let t=n.get(r);return t===void 0&&(t=a,n.set(r,t)),t}e.$xc=A;function R(n){const r=[];return n.forEach((a,t)=>{r.push(`${t} => ${a}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.$yc=R;function v(n){const r=[];return n.forEach(a=>{r.push(a)}),`Set(${n.size}) {${r.join(", ")}}`}e.$zc=v;class p{constructor(r,a){this.uri=r,this.value=a}}function S(n){return Array.isArray(n)}class L{static{this.c=r=>r.toString()}constructor(r,a){if(this[I]="ResourceMap",r instanceof L)this.d=new Map(r.d),this.e=a??L.c;else if(S(r)){this.d=new Map,this.e=a??L.c;for(const[t,d]of r)this.set(t,d)}else this.d=new Map,this.e=r??L.c}set(r,a){return this.d.set(this.e(r),new p(r,a)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,a){typeof a<"u"&&(r=r.bind(a));for(const[t,d]of this.d)r(d.value,d.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Ac=L;class C{constructor(r,a){this[O]="ResourceSet",!r||typeof r=="function"?this.c=new L(r):(this.c=new L(a),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,a){this.c.forEach((t,d)=>r.call(a,d,d,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var w;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class E{constructor(){this[$]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,a=0){const t=this.c.get(r);if(t)return a!==0&&this.l(t,a),t.value}set(r,a,t=0){let d=this.c.get(r);if(d)d.value=a,t!==0&&this.l(d,t);else{switch(d={key:r,value:a,next:void 0,previous:void 0},t){case 0:this.j(d);break;case 1:this.i(d);break;case 2:this.j(d);break;default:this.j(d);break}this.c.set(r,d),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this.c.get(r);if(a)return this.c.delete(r),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,a){const t=this.g;let d=this.d;for(;d;){if(a?r.bind(a)(d.value,d.key,this):r(d.value,d.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const r=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.key,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return d}values(){const r=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:t.value,done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return d}entries(){const r=this,a=this.g;let t=this.d;const d={[Symbol.iterator](){return d},next(){if(r.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const c={value:[t.key,t.value],done:!1};return t=t.next,c}else return{value:void 0,done:!0}}};return d}[($=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>r;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const a=r.next,t=r.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}r.next=void 0,r.previous=void 0,this.g++}l(r,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this.d)return;const t=r.next,d=r.previous;r===this.e?(d.next=void 0,this.e=d):(t.previous=d,d.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(a===2){if(r===this.e)return;const t=r.next,d=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=d,d.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((a,t)=>{r.push([t,a])}),r}fromJSON(r){this.clear();for(const[a,t]of r)this.set(a,t)}}e.$Cc=E;class k extends E{constructor(r,a=1){super(),this.m=r,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=k;class u{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let a=this.c.get(r)||0;return a===0?!1:(a--,a===0?this.c.delete(r):this.c.set(r,a),!0)}has(r){return this.c.has(r)}}e.$Ec=u;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[a,t]of r)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(r,a){this.c.set(r,a),this.d.set(a,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const a=this.c.get(r);return a===void 0?!1:(this.c.delete(r),this.d.delete(a),!0)}forEach(r,a){this.c.forEach((t,d)=>{r.call(a,t,d,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class o{constructor(){this.c=new Map}add(r,a){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(a)}delete(r,a){const t=this.c.get(r);t&&(t.delete(a),t.size===0&&this.c.delete(r))}forEach(r,a){const t=this.c.get(r);t&&t.forEach(a)}get(r){const a=this.c.get(r);return a||new Set}}e.$Gc=o;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[a,t]of n)if(!r.has(a)||r.get(a)!==t)return!1;for(const[a]of r)if(!n.has(a))return!1;return!0}e.$Hc=i}),define(Ce[3],Ie([1,0,19,74,28,75,53]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const v=!1;let p=null;class S{constructor(){this.b=new Map}static{this.a=0}c(P){let N=this.b.get(P);return N||(N={parent:null,source:null,isSingleton:!1,value:P,idx:S.a++},this.b.set(P,N)),N}trackDisposable(P){const N=this.c(P);N.source||(N.source=new Error().stack)}setParent(P,N){const U=this.c(P);U.parent=N}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,N){const U=N.get(P);if(U)return U;const z=P.parent?this.f(this.c(P.parent),N):P;return N.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,N){let U;if(N)U=N;else{const j=new Map,J=[...this.b.values()].filter(_=>_.source!==null&&!this.f(_,j).isSingleton);if(J.length===0)return;const ne=new Set(J.map(_=>_.value));if(U=J.filter(_=>!(_.parent&&ne.has(_.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(j){function J(_,Z){for(;_.length>0&&Z.some(Y=>typeof Y=="string"?Y===_[0]:_[0].match(Y));)_.shift()}const ne=j.source.split(`
`).map(_=>_.trim().replace("at ","")).filter(_=>_!=="");return J(ne,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ne.reverse()}const F=new $.$Gc;for(const j of U){const J=z(j);for(let ne=0;ne<=J.length;ne++)F.add(J.slice(0,ne).join(`
`),j)}U.sort((0,I.$7b)(j=>j.idx,I.$9b));let M="",T=0;for(const j of U.slice(0,P)){T++;const J=z(j),ne=[];for(let _=0;_<J.length;_++){let Z=J[_];Z=`(shared with ${F.get(J.slice(0,_+1).join(`
`)).size}/${U.length} leaks) at ${Z}`;const ce=F.get(J.slice(0,_).join(`
`)),ie=(0,O.$K)([...ce].map(fe=>z(fe)[_]),fe=>fe);delete ie[J[_]];for(const[fe,re]of Object.entries(ie))ne.unshift(`    - stacktraces of ${re.length} other leaks continue with ${fe}`);ne.unshift(Z)}M+=`


==================== Leaking disposable ${T}/${U.length}: ${j.value.constructor.name} ====================
${ne.join(`
`)}
============================================================

`}return U.length>P&&(M+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:M}}}e.$Ic=S;function L(y){p=y}if(e.$Jc=L,v){const y="__is_disposable_tracked__";L(new class{trackDisposable(P){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[y]||console.log(N)},3e3)}setParent(P,N){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[y]=!0}catch{}}markAsSingleton(P){}})}function C(y){return p?.trackDisposable(y),y}e.$Kc=C;function w(y){p?.markAsDisposed(y)}e.$Lc=w;function E(y,P){p?.setParent(y,P)}function k(y,P){if(p)for(const N of y)p.setParent(N,P)}function u(y){return p?.markAsSingleton(y),y}e.$Mc=u;function m(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=m;function o(y){if(R.Iterable.is(y)){const P=[];for(const N of y)if(N)try{N.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=o;function i(y){for(const P of y)m(P)&&P.dispose();return[]}e.$Pc=i;function n(...y){const P=r(()=>o(y));return k(y,P),P}e.$Qc=n;function r(y){const P=C({dispose:(0,A.$db)(()=>{w(P),y()})});return P}e.$Rc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return E(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),E(P,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),E(this.q,this)}dispose(){w(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class d{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&E(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&E(P,null),P}}e.$Uc=d;class c{constructor(P){this.a=new d,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=c;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let N=P;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,w(this))},this}}e.$Xc=l;class h{constructor(){this.a=new Map}acquire(P,...N){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...N)},this.a.set(P,U));const{object:z}=U,F=(0,A.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:z,dispose:F}}}e.$Yc=h;class b{constructor(P){this.a=P}async acquire(P,...N){const U=this.a.acquire(P,...N);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Zc=b;class D{constructor(P){this.object=P}dispose(){}}e.$1c=D;function g(y){const P=new a;try{y(P)}finally{P.dispose()}}e.$2c=g;class f{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,N,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,N)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=f}),function(me,e){typeof define=="function"&&define.amd?define(Ce[161],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(de,ue){for(var ge=0;ge<ue.length;ge++){var V=ue[ge];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(de,V.key,V)}}function I(de,ue,ge){return ue&&e(de.prototype,ue),ge&&e(de,ge),Object.defineProperty(de,"prototype",{writable:!1}),de}function O(de,ue){if(de){if(typeof de=="string")return $(de,ue);var ge=Object.prototype.toString.call(de).slice(8,-1);if(ge==="Object"&&de.constructor&&(ge=de.constructor.name),ge==="Map"||ge==="Set")return Array.from(de);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return $(de,ue)}}function $(de,ue){(ue==null||ue>de.length)&&(ue=de.length);for(var ge=0,V=new Array(ue);ge<ue;ge++)V[ge]=de[ge];return V}function A(de,ue){var ge=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(ge)return(ge=ge.call(de)).next.bind(ge);if(Array.isArray(de)||(ge=O(de))||ue&&de&&typeof de.length=="number"){ge&&(de=ge);var V=0;return function(){return V>=de.length?{done:!0}:{done:!1,value:de[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function v(de){me.defaults=de}var p=/[&<>"']/,S=/[&<>"']/g,L=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ue){return w[ue]};function k(de,ue){if(ue){if(p.test(de))return de.replace(S,E)}else if(L.test(de))return de.replace(C,E);return de}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(de){return de.replace(u,function(ue,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(de,ue){de=typeof de=="string"?de:de.source,ue=ue||"";var ge={replace:function(X,he){return he=he.source||he,he=he.replace(o,"$1"),de=de.replace(X,he),ge},getRegex:function(){return new RegExp(de,ue)}};return ge}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(de,ue,ge){if(de){var V;try{V=decodeURIComponent(m(ge)).replace(n,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ue&&!r.test(ge)&&(ge=l(ue,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},d=/^[^:]+:\/*[^/]*$/,c=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(de,ue){t[" "+de]||(d.test(de)?t[" "+de]=de+"/":t[" "+de]=g(de,"/",!0)),de=t[" "+de];var ge=de.indexOf(":")===-1;return ue.substring(0,2)==="//"?ge?ue:de.replace(c,"$1")+ue:ue.charAt(0)==="/"?ge?ue:de.replace(s,"$1")+ue:de+ue}var h={exec:function(){}};function b(de){for(var ue=1,ge,V;ue<arguments.length;ue++){ge=arguments[ue];for(V in ge)Object.prototype.hasOwnProperty.call(ge,V)&&(de[V]=ge[V])}return de}function D(de,ue){var ge=de.replace(/\|/g,function(he,be,Pe){for(var pe=!1,Ae=be;--Ae>=0&&Pe[Ae]==="\\";)pe=!pe;return pe?"|":" |"}),V=ge.split(/ \|/),X=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>ue)V.splice(ue);else for(;V.length<ue;)V.push("");for(;X<V.length;X++)V[X]=V[X].trim().replace(/\\\|/g,"|");return V}function g(de,ue,ge){var V=de.length;if(V===0)return"";for(var X=0;X<V;){var he=de.charAt(V-X-1);if(he===ue&&!ge)X++;else if(he!==ue&&ge)X++;else break}return de.slice(0,V-X)}function f(de,ue){if(de.indexOf(ue[1])===-1)return-1;for(var ge=de.length,V=0,X=0;X<ge;X++)if(de[X]==="\\")X++;else if(de[X]===ue[0])V++;else if(de[X]===ue[1]&&(V--,V<0))return X;return-1}function y(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(de,ue){if(ue<1)return"";for(var ge="";ue>1;)ue&1&&(ge+=de),ue>>=1,de+=de;return ge+de}function N(de,ue,ge,V){var X=ue.href,he=ue.title?k(ue.title):null,be=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){V.state.inLink=!0;var Pe={type:"link",raw:ge,href:X,title:he,text:be,tokens:V.inlineTokens(be)};return V.state.inLink=!1,Pe}return{type:"image",raw:ge,href:X,title:he,text:k(be)}}function U(de,ue){var ge=de.match(/^(\s+)(?:```)/);if(ge===null)return ue;var V=ge[1];return ue.split(`
`).map(function(X){var he=X.match(/^\s+/);if(he===null)return X;var be=he[0];return be.length>=V.length?X.slice(V.length):X}).join(`
`)}var z=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.space=function(V){var X=this.rules.block.newline.exec(V);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},ue.code=function(V){var X=this.rules.block.code.exec(V);if(X){var he=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?he:g(he,`
`)}}},ue.fences=function(V){var X=this.rules.block.fences.exec(V);if(X){var he=X[0],be=U(he,X[3]||"");return{type:"code",raw:he,lang:X[2]?X[2].trim():X[2],text:be}}},ue.heading=function(V){var X=this.rules.block.heading.exec(V);if(X){var he=X[2].trim();if(/#$/.test(he)){var be=g(he,"#");(this.options.pedantic||!be||/ $/.test(be))&&(he=be.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:he,tokens:this.lexer.inline(he)}}},ue.hr=function(V){var X=this.rules.block.hr.exec(V);if(X)return{type:"hr",raw:X[0]}},ue.blockquote=function(V){var X=this.rules.block.blockquote.exec(V);if(X){var he=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ue.list=function(V){var X=this.rules.block.list.exec(V);if(X){var he,be,Pe,pe,Ae,Fe,W,x,H,Q,oe,ve,Le=X[1].trim(),qe=Le.length>1,Ge={type:"list",raw:"",ordered:qe,start:qe?+Le.slice(0,-1):"",loose:!1,items:[]};Le=qe?"\\d{1,9}\\"+Le.slice(-1):"\\"+Le,this.options.pedantic&&(Le=qe?Le:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+Le+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(ve=!1,!(!(X=Ye.exec(V))||this.rules.block.hr.test(V)));){if(he=X[0],V=V.substring(he.length),x=X[2].split(`
`,1)[0],H=V.split(`
`,1)[0],this.options.pedantic?(pe=2,oe=x.trimLeft()):(pe=X[2].search(/[^ ]/),pe=pe>4?1:pe,oe=x.slice(pe),pe+=X[1].length),Fe=!1,!x&&/^ *$/.test(H)&&(he+=H+`
`,V=V.substring(H.length+1),ve=!0),!ve)for(var it=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ut=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");V&&(Q=V.split(`
`,1)[0],x=Q,this.options.pedantic&&(x=x.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(x)||et.test(x)||it.test(x)||ut.test(V)));){if(x.search(/[^ ]/)>=pe||!x.trim())oe+=`
`+x.slice(pe);else if(!Fe)oe+=`
`+x;else break;!Fe&&!x.trim()&&(Fe=!0),he+=Q+`
`,V=V.substring(Q.length+1)}Ge.loose||(W?Ge.loose=!0:/\n *\n *$/.test(he)&&(W=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(oe),be&&(Pe=be[0]!=="[ ] ",oe=oe.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:he,task:!!be,checked:Pe,loose:!1,text:oe}),Ge.raw+=he}Ge.items[Ge.items.length-1].raw=he.trimRight(),Ge.items[Ge.items.length-1].text=oe.trimRight(),Ge.raw=Ge.raw.trimRight();var Re=Ge.items.length;for(Ae=0;Ae<Re;Ae++){this.lexer.state.top=!1,Ge.items[Ae].tokens=this.lexer.blockTokens(Ge.items[Ae].text,[]);var ke=Ge.items[Ae].tokens.filter(function(ee){return ee.type==="space"}),He=ke.every(function(ee){for(var se=ee.raw.split(""),Se=0,Ve=A(se),Ze;!(Ze=Ve()).done;){var nt=Ze.value;if(nt===`
`&&(Se+=1),Se>1)return!0}return!1});!Ge.loose&&ke.length&&He&&(Ge.loose=!0,Ge.items[Ae].loose=!0)}return Ge}},ue.html=function(V){var X=this.rules.block.html.exec(V);if(X){var he={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(X[0]):k(X[0]);he.type="paragraph",he.text=be,he.tokens=this.lexer.inline(be)}return he}},ue.def=function(V){var X=this.rules.block.def.exec(V);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var he=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:X[0],href:X[2],title:X[3]}}},ue.table=function(V){var X=this.rules.block.table.exec(V);if(X){var he={type:"table",header:D(X[1]).map(function(W){return{text:W}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=X[0];var be=he.align.length,Pe,pe,Ae,Fe;for(Pe=0;Pe<be;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(be=he.rows.length,Pe=0;Pe<be;Pe++)he.rows[Pe]=D(he.rows[Pe],he.header.length).map(function(W){return{text:W}});for(be=he.header.length,pe=0;pe<be;pe++)he.header[pe].tokens=this.lexer.inline(he.header[pe].text);for(be=he.rows.length,pe=0;pe<be;pe++)for(Fe=he.rows[pe],Ae=0;Ae<Fe.length;Ae++)Fe[Ae].tokens=this.lexer.inline(Fe[Ae].text);return he}}},ue.lheading=function(V){var X=this.rules.block.lheading.exec(V);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},ue.paragraph=function(V){var X=this.rules.block.paragraph.exec(V);if(X){var he=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:he,tokens:this.lexer.inline(he)}}},ue.text=function(V){var X=this.rules.block.text.exec(V);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},ue.escape=function(V){var X=this.rules.inline.escape.exec(V);if(X)return{type:"escape",raw:X[0],text:k(X[1])}},ue.tag=function(V){var X=this.rules.inline.tag.exec(V);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):k(X[0]):X[0]}},ue.link=function(V){var X=this.rules.inline.link.exec(V);if(X){var he=X[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var be=g(he.slice(0,-1),"\\");if((he.length-be.length)%2===0)return}else{var Pe=f(X[2],"()");if(Pe>-1){var pe=X[0].indexOf("!")===0?5:4,Ae=pe+X[1].length+Pe;X[2]=X[2].substring(0,Pe),X[0]=X[0].substring(0,Ae).trim(),X[3]=""}}var Fe=X[2],W="";if(this.options.pedantic){var x=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Fe);x&&(Fe=x[1],W=x[3])}else W=X[3]?X[3].slice(1,-1):"";return Fe=Fe.trim(),/^</.test(Fe)&&(this.options.pedantic&&!/>$/.test(he)?Fe=Fe.slice(1):Fe=Fe.slice(1,-1)),N(X,{href:Fe&&Fe.replace(this.rules.inline._escapes,"$1"),title:W&&W.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},ue.reflink=function(V,X){var he;if((he=this.rules.inline.reflink.exec(V))||(he=this.rules.inline.nolink.exec(V))){var be=(he[2]||he[1]).replace(/\s+/g," ");if(be=X[be.toLowerCase()],!be||!be.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return N(he,be,he[0],this.lexer)}},ue.emStrong=function(V,X,he){he===void 0&&(he="");var be=this.rules.inline.emStrong.lDelim.exec(V);if(be&&!(be[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=be[1]||be[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var pe=be[0].length-1,Ae,Fe,W=pe,x=0,H=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,X=X.slice(-1*V.length+pe);(be=H.exec(X))!=null;)if(Ae=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Ae){if(Fe=Ae.length,be[3]||be[4]){W+=Fe;continue}else if((be[5]||be[6])&&pe%3&&!((pe+Fe)%3)){x+=Fe;continue}if(W-=Fe,!(W>0)){if(Fe=Math.min(Fe,Fe+W+x),Math.min(pe,Fe)%2){var Q=V.slice(1,pe+be.index+Fe);return{type:"em",raw:V.slice(0,pe+be.index+Fe+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var oe=V.slice(2,pe+be.index+Fe-1);return{type:"strong",raw:V.slice(0,pe+be.index+Fe+1),text:oe,tokens:this.lexer.inlineTokens(oe)}}}}}},ue.codespan=function(V){var X=this.rules.inline.code.exec(V);if(X){var he=X[2].replace(/\n/g," "),be=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return be&&Pe&&(he=he.substring(1,he.length-1)),he=k(he,!0),{type:"codespan",raw:X[0],text:he}}},ue.br=function(V){var X=this.rules.inline.br.exec(V);if(X)return{type:"br",raw:X[0]}},ue.del=function(V){var X=this.rules.inline.del.exec(V);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},ue.autolink=function(V,X){var he=this.rules.inline.autolink.exec(V);if(he){var be,Pe;return he[2]==="@"?(be=k(this.options.mangle?X(he[1]):he[1]),Pe="mailto:"+be):(be=k(he[1]),Pe=be),{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.url=function(V,X){var he;if(he=this.rules.inline.url.exec(V)){var be,Pe;if(he[2]==="@")be=k(this.options.mangle?X(he[0]):he[0]),Pe="mailto:"+be;else{var pe;do pe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(pe!==he[0]);be=k(he[0]),he[1]==="www."?Pe="http://"+be:Pe=be}return{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ue.inlineText=function(V,X){var he=this.rules.inline.text.exec(V);if(he){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):k(he[0]):he[0]:be=k(this.options.smartypants?X(he[0]):he[0]),{type:"text",raw:he[0],text:be}}},de}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=i(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=i(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=i(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=i(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=i(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=b({},F),F.gfm=b({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=i(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=i(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=b({},F.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(F._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",F._label).getRegex(),M.nolink=i(M.nolink).replace("ref",F._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=b({},M),M.pedantic=b({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=b({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=b({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(de){var ue="",ge,V,X=de.length;for(ge=0;ge<X;ge++)V=de.charCodeAt(ge),Math.random()>.5&&(V="x"+V.toString(16)),ue+="&#"+V+";";return ue}var J=function(){function de(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:F.normal,inline:M.normal};this.options.pedantic?(V.block=F.pedantic,V.inline=M.pedantic):this.options.gfm&&(V.block=F.gfm,this.options.breaks?V.inline=M.breaks:V.inline=M.gfm),this.tokenizer.rules=V}de.lex=function(V,X){var he=new de(X);return he.lex(V)},de.lexInline=function(V,X){var he=new de(X);return he.inlineTokens(V)};var ue=de.prototype;return ue.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},ue.blockTokens=function(V,X){var he=this;X===void 0&&(X=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(W,x,H){return x+"    ".repeat(H.length)});for(var be,Pe,pe,Ae;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(W){return(be=W.call({lexer:he},V,X))?(V=V.substring(be.raw.length),X.push(be),!0):!1}))){if(be=this.tokenizer.space(V)){V=V.substring(be.raw.length),be.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(be);continue}if(be=this.tokenizer.code(V)){V=V.substring(be.raw.length),Pe=X[X.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):X.push(be);continue}if(be=this.tokenizer.fences(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.heading(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.hr(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.blockquote(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.list(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.html(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.def(V)){V=V.substring(be.raw.length),Pe=X[X.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.lheading(V)){V=V.substring(be.raw.length),X.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var W=1/0,x=V.slice(1),H=void 0;he.options.extensions.startBlock.forEach(function(Q){H=Q.call({lexer:this},x),typeof H=="number"&&H>=0&&(W=Math.min(W,H))}),W<1/0&&W>=0&&(pe=V.substring(0,W+1))}(),this.state.top&&(be=this.tokenizer.paragraph(pe))){Pe=X[X.length-1],Ae&&Pe.type==="paragraph"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):X.push(be),Ae=pe.length!==V.length,V=V.substring(be.raw.length);continue}if(be=this.tokenizer.text(V)){V=V.substring(be.raw.length),Pe=X[X.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):X.push(be);continue}if(V){var Fe="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return this.state.top=!0,X},ue.inline=function(V,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:V,tokens:X}),X},ue.inlineTokens=function(V,X){var he=this;X===void 0&&(X=[]);var be,Pe,pe,Ae=V,Fe,W,x;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(Fe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)H.includes(Fe[0].slice(Fe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Fe.index)+"["+P("a",Fe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Fe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Fe.index)+"["+P("a",Fe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Fe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Fe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(W||(x=""),W=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(oe){return(be=oe.call({lexer:he},V,X))?(V=V.substring(be.raw.length),X.push(be),!0):!1}))){if(be=this.tokenizer.escape(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.tag(V)){V=V.substring(be.raw.length),Pe=X[X.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):X.push(be);continue}if(be=this.tokenizer.link(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(be.raw.length),Pe=X[X.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):X.push(be);continue}if(be=this.tokenizer.emStrong(V,Ae,x)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.codespan(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.br(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.del(V)){V=V.substring(be.raw.length),X.push(be);continue}if(be=this.tokenizer.autolink(V,j)){V=V.substring(be.raw.length),X.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(V,j))){V=V.substring(be.raw.length),X.push(be);continue}if(pe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var oe=1/0,ve=V.slice(1),Le=void 0;he.options.extensions.startInline.forEach(function(qe){Le=qe.call({lexer:this},ve),typeof Le=="number"&&Le>=0&&(oe=Math.min(oe,Le))}),oe<1/0&&oe>=0&&(pe=V.substring(0,oe+1))}(),be=this.tokenizer.inlineText(pe,T)){V=V.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(x=be.raw.slice(-1)),W=!0,Pe=X[X.length-1],Pe&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):X.push(be);continue}if(V){var Q="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return X},I(de,null,[{key:"rules",get:function(){return{block:F,inline:M}}}]),de}(),ne=function(){function de(ge){this.options=ge||me.defaults}var ue=de.prototype;return ue.code=function(V,X,he){var be=(X||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(V,be);Pe!=null&&Pe!==V&&(he=!0,V=Pe)}return V=V.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+k(be,!0)+'">'+(he?V:k(V,!0))+`</code></pre>
`:"<pre><code>"+(he?V:k(V,!0))+`</code></pre>
`},ue.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ue.html=function(V){return V},ue.heading=function(V,X,he,be){if(this.options.headerIds){var Pe=this.options.headerPrefix+be.slug(he);return"<h"+X+' id="'+Pe+'">'+V+"</h"+X+`>
`}return"<h"+X+">"+V+"</h"+X+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(V,X,he){var be=X?"ol":"ul",Pe=X&&he!==1?' start="'+he+'"':"";return"<"+be+Pe+`>
`+V+"</"+be+`>
`},ue.listitem=function(V){return"<li>"+V+`</li>
`},ue.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(V){return"<p>"+V+`</p>
`},ue.table=function(V,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+X+`</table>
`},ue.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ue.tablecell=function(V,X){var he=X.header?"th":"td",be=X.align?"<"+he+' align="'+X.align+'">':"<"+he+">";return be+V+("</"+he+`>
`)},ue.strong=function(V){return"<strong>"+V+"</strong>"},ue.em=function(V){return"<em>"+V+"</em>"},ue.codespan=function(V){return"<code>"+V+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(V){return"<del>"+V+"</del>"},ue.link=function(V,X,he){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<a href="'+k(V)+'"';return X&&(be+=' title="'+X+'"'),be+=">"+he+"</a>",be},ue.image=function(V,X,he){if(V=a(this.options.sanitize,this.options.baseUrl,V),V===null)return he;var be='<img src="'+V+'" alt="'+he+'"';return X&&(be+=' title="'+X+'"'),be+=this.options.xhtml?"/>":">",be},ue.text=function(V){return V},de}(),_=function(){function de(){}var ue=de.prototype;return ue.strong=function(V){return V},ue.em=function(V){return V},ue.codespan=function(V){return V},ue.del=function(V){return V},ue.html=function(V){return V},ue.text=function(V){return V},ue.link=function(V,X,he){return""+he},ue.image=function(V,X,he){return""+he},ue.br=function(){return""},de}(),Z=function(){function de(){this.seen={}}var ue=de.prototype;return ue.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(V,X){var he=V,be=0;if(this.seen.hasOwnProperty(he)){be=this.seen[V];do be++,he=V+"-"+be;while(this.seen.hasOwnProperty(he))}return X||(this.seen[V]=be,this.seen[he]=0),he},ue.slug=function(V,X){X===void 0&&(X={});var he=this.serialize(V);return this.getNextSafeSlug(he,X.dryrun)},de}(),Y=function(){function de(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Z}de.parse=function(V,X){var he=new de(X);return he.parse(V)},de.parseInline=function(V,X){var he=new de(X);return he.parseInline(V)};var ue=de.prototype;return ue.parse=function(V,X){X===void 0&&(X=!0);var he="",be,Pe,pe,Ae,Fe,W,x,H,Q,oe,ve,Le,qe,Ge,Ye,it,ut,ot,et,Re=V.length;for(be=0;be<Re;be++){if(oe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[oe.type]&&(et=this.options.extensions.renderers[oe.type].call({parser:this},oe),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(oe.type))){he+=et||"";continue}switch(oe.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(oe.tokens),oe.depth,m(this.parseInline(oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(oe.text,oe.lang,oe.escaped);continue}case"table":{for(H="",x="",Ae=oe.header.length,Pe=0;Pe<Ae;Pe++)x+=this.renderer.tablecell(this.parseInline(oe.header[Pe].tokens),{header:!0,align:oe.align[Pe]});for(H+=this.renderer.tablerow(x),Q="",Ae=oe.rows.length,Pe=0;Pe<Ae;Pe++){for(W=oe.rows[Pe],x="",Fe=W.length,pe=0;pe<Fe;pe++)x+=this.renderer.tablecell(this.parseInline(W[pe].tokens),{header:!1,align:oe.align[pe]});Q+=this.renderer.tablerow(x)}he+=this.renderer.table(H,Q);continue}case"blockquote":{Q=this.parse(oe.tokens),he+=this.renderer.blockquote(Q);continue}case"list":{for(ve=oe.ordered,Le=oe.start,qe=oe.loose,Ae=oe.items.length,Q="",Pe=0;Pe<Ae;Pe++)Ye=oe.items[Pe],it=Ye.checked,ut=Ye.task,Ge="",Ye.task&&(ot=this.renderer.checkbox(it),qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=ot+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=ot+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ye.tokens,qe),Q+=this.renderer.listitem(Ge,ut,it);he+=this.renderer.list(Q,ve,Le);continue}case"html":{he+=this.renderer.html(oe.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(oe.tokens));continue}case"text":{for(Q=oe.tokens?this.parseInline(oe.tokens):oe.text;be+1<Re&&V[be+1].type==="text";)oe=V[++be],Q+=`
`+(oe.tokens?this.parseInline(oe.tokens):oe.text);he+=X?this.renderer.paragraph(Q):Q;continue}default:{var ke='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return he},ue.parseInline=function(V,X){X=X||this.renderer;var he="",be,Pe,pe,Ae=V.length;for(be=0;be<Ae;be++){if(Pe=V[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(pe=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=pe||"";continue}switch(Pe.type){case"escape":{he+=X.text(Pe.text);break}case"html":{he+=X.html(Pe.text);break}case"link":{he+=X.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,X));break}case"image":{he+=X.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=X.strong(this.parseInline(Pe.tokens,X));break}case"em":{he+=X.em(this.parseInline(Pe.tokens,X));break}case"codespan":{he+=X.codespan(Pe.text);break}case"br":{he+=X.br();break}case"del":{he+=X.del(this.parseInline(Pe.tokens,X));break}case"text":{he+=X.text(Pe.text);break}default:{var Fe='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Fe);return}else throw new Error(Fe)}}}return he},de}();function ce(de,ue,ge){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof ue=="function"&&(ge=ue,ue=null),ue=b({},ce.defaults,ue||{}),y(ue),ge){var V=ue.highlight,X;try{X=J.lex(de,ue)}catch(Ae){return ge(Ae)}var he=function(Fe){var W;if(!Fe)try{ue.walkTokens&&ce.walkTokens(X,ue.walkTokens),W=Y.parse(X,ue)}catch(x){Fe=x}return ue.highlight=V,Fe?ge(Fe):ge(null,W)};if(!V||V.length<3||(delete ue.highlight,!X.length))return he();var be=0;ce.walkTokens(X,function(Ae){Ae.type==="code"&&(be++,setTimeout(function(){V(Ae.text,Ae.lang,function(Fe,W){if(Fe)return he(Fe);W!=null&&W!==Ae.text&&(Ae.text=W,Ae.escaped=!0),be--,be===0&&he()})},0))}),be===0&&he();return}function Pe(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+k(Ae.message+"",!0)+"</pre>";throw Ae}try{var pe=J.lex(de,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ce.walkTokens(pe,ue.walkTokens)).then(function(){return Y.parse(pe,ue)}).catch(Pe);ce.walkTokens(pe,ue.walkTokens)}return Y.parse(pe,ue)}catch(Ae){Pe(Ae)}}ce.options=ce.setOptions=function(de){return b(ce.defaults,de),v(ce.defaults),ce},ce.getDefaults=R,ce.defaults=me.defaults,ce.use=function(){for(var de=arguments.length,ue=new Array(de),ge=0;ge<de;ge++)ue[ge]=arguments[ge];var V=b.apply(void 0,[{}].concat(ue)),X=ce.defaults.extensions||{renderers:{},childTokens:{}},he;ue.forEach(function(be){if(be.extensions&&(he=!0,be.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Ae=X.renderers?X.renderers[pe.name]:null;Ae?X.renderers[pe.name]=function(){for(var Fe=arguments.length,W=new Array(Fe),x=0;x<Fe;x++)W[x]=arguments[x];var H=pe.renderer.apply(this,W);return H===!1&&(H=Ae.apply(this,W)),H}:X.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[pe.level]?X[pe.level].unshift(pe.tokenizer):X[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?X.startBlock?X.startBlock.push(pe.start):X.startBlock=[pe.start]:pe.level==="inline"&&(X.startInline?X.startInline.push(pe.start):X.startInline=[pe.start]))}pe.childTokens&&(X.childTokens[pe.name]=pe.childTokens)})),be.renderer&&function(){var pe=ce.defaults.renderer||new ne,Ae=function(x){var H=pe[x];pe[x]=function(){for(var Q=arguments.length,oe=new Array(Q),ve=0;ve<Q;ve++)oe[ve]=arguments[ve];var Le=be.renderer[x].apply(pe,oe);return Le===!1&&(Le=H.apply(pe,oe)),Le}};for(var Fe in be.renderer)Ae(Fe);V.renderer=pe}(),be.tokenizer&&function(){var pe=ce.defaults.tokenizer||new z,Ae=function(x){var H=pe[x];pe[x]=function(){for(var Q=arguments.length,oe=new Array(Q),ve=0;ve<Q;ve++)oe[ve]=arguments[ve];var Le=be.tokenizer[x].apply(pe,oe);return Le===!1&&(Le=H.apply(pe,oe)),Le}};for(var Fe in be.tokenizer)Ae(Fe);V.tokenizer=pe}(),be.walkTokens){var Pe=ce.defaults.walkTokens;V.walkTokens=function(pe){var Ae=[];return Ae.push(be.walkTokens.call(this,pe)),Pe&&(Ae=Ae.concat(Pe.call(this,pe))),Ae}}he&&(V.extensions=X),ce.setOptions(V)})},ce.walkTokens=function(de,ue){for(var ge=[],V=function(){var Pe=he.value;switch(ge=ge.concat(ue.call(ce,Pe)),Pe.type){case"table":{for(var pe=A(Pe.header),Ae;!(Ae=pe()).done;){var Fe=Ae.value;ge=ge.concat(ce.walkTokens(Fe.tokens,ue))}for(var W=A(Pe.rows),x;!(x=W()).done;)for(var H=x.value,Q=A(H),oe;!(oe=Q()).done;){var ve=oe.value;ge=ge.concat(ce.walkTokens(ve.tokens,ue))}break}case"list":{ge=ge.concat(ce.walkTokens(Pe.items,ue));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Pe.type]?ce.defaults.extensions.childTokens[Pe.type].forEach(function(Le){ge=ge.concat(ce.walkTokens(Pe[Le],ue))}):Pe.tokens&&(ge=ge.concat(ce.walkTokens(Pe.tokens,ue)))}},X=A(de),he;!(he=X()).done;)V();return ge},ce.parseInline=function(de,ue){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");ue=b({},ce.defaults,ue||{}),y(ue);try{var ge=J.lexInline(de,ue);return ue.walkTokens&&ce.walkTokens(ge,ue.walkTokens),Y.parseInline(ge,ue)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+k(V.message+"",!0)+"</pre>";throw V}},ce.Parser=Y,ce.parser=Y.parse,ce.Renderer=ne,ce.TextRenderer=_,ce.Lexer=J,ce.lexer=J.lex,ce.Tokenizer=z,ce.Slugger=Z,ce.parse=ce;var ie=ce.options,fe=ce.setOptions,re=ce.use,K=ce.walkTokens,B=ce.parseInline,ae=ce,ye=Y.parse,le=J.lex;me.Lexer=J,me.Parser=Y,me.Renderer=ne,me.Slugger=Z,me.TextRenderer=_,me.Tokenizer=z,me.getDefaults=R,me.lexer=le,me.marked=ce,me.options=ie,me.parse=ae,me.parseInline=B,me.parser=ye,me.setOptions=fe,me.use=re,me.walkTokens=K,Object.defineProperty(me,"__esModule",{value:!0})}),define(Ce[162],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0;function I(u){const m=A(u);if(m&&m.length>0)return new Uint32Array(m)}e.$1j=I;let O=0;const $=new Uint32Array(10);function A(u){if(O=0,R(u,C,4352),O>0||(R(u,w,4449),O>0)||(R(u,E,4520),O>0)||(R(u,k,12593),O))return $.subarray(0,O);if(u>=44032&&u<=55203){const m=u-44032,o=m%588,i=Math.floor(m/588),n=Math.floor(o/28),r=o%28-1;if(i<C.length?R(i,C,0):4352+i-12593<k.length&&R(4352+i,k,12593),n<w.length?R(n,w,0):4449+n-12593<k.length&&R(4449+n-12593,k,12593),r>=0&&(r<E.length?R(r,E,0):4520+r-12593<k.length&&R(4520+r-12593,k,12593)),O>0)return $.subarray(0,O)}}function R(u,m,o){u>=o&&u<o+m.length&&v(m[u-o])}function v(u){u!==0&&($[O++]=u&255,u>>8&&($[O++]=u>>8&255),u>>16&&($[O++]=u>>16&255))}var p;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var S;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(S||(S={}));var L;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(L||(L={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),k=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[77],Ie([1,0,28]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=e.$Pl=void 0;const O=new I.$Dc(1e4);function $(S){return p(S,"NFC",O)}e.$Pl=$;const A=new I.$Dc(1e4);function R(S){return p(S,"NFD",A)}e.$Ql=R;const v=/[^\u0000-\u0080]/;function p(S,L,C){if(!S)return S;const w=C.get(S);if(w)return w;let E;return v.test(S)?E=S.normalize(L):E=S,C.set(S,E),E}e.$Rl=function(){const S=/[\u0300-\u036f]/g;return function(L){return R(L).replace(S,"")}}()}),define(Ce[122],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.rot=e.$dm=void 0;function I(v,p,S){return Math.min(Math.max(v,p),S)}e.$dm=I;function O(v,p){return(p+v%p)%p}e.rot=O;class ${constructor(){this.a=0}getNext(){return this.a++}}e.$fm=$;class A{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$gm=A;class R{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const S=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=S,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$hm=R}),function(){function me($){const A=[];typeof $=="number"&&A.push("code/timeOrigin",$);function R(p){A.push(p,Date.now())}function v(){const p=[];for(let S=0;S<A.length;S+=2)p.push({name:A[S],startTime:A[S+1]});return p}return{mark:R,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark($){performance.mark($)},getMarks(){let $=performance.timeOrigin;typeof $!="number"&&($=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round($)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round($+R.startTime)});return A}};if(typeof process=="object"){const $=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me($)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function I($){return $.MonacoPerformanceMarks||($.MonacoPerformanceMarks=e()),$.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=I(O))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var O in I)(typeof exports=="object"?exports:me)[O]=I[O]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function I(O){if(e[O])return e[O].exports;var $=e[O]={i:O,l:!1,exports:{}};return me[O].call($.exports,$,$.exports,I),$.l=!0,$.exports}return I.m=me,I.c=e,I.d=function(O,$,A){I.o(O,$)||Object.defineProperty(O,$,{enumerable:!0,get:A})},I.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},I.t=function(O,$){if(1&$&&(O=I(O)),8&$||4&$&&typeof O=="object"&&O&&O.__esModule)return O;var A=Object.create(null);if(I.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:O}),2&$&&typeof O!="string")for(var R in O)I.d(A,R,function(v){return O[v]}.bind(null,R));return A},I.n=function(O){var $=O&&O.__esModule?function(){return O.default}:function(){return O};return I.d($,"a",$),$},I.o=function(O,$){return Object.prototype.hasOwnProperty.call(O,$)},I.p="",I(I.s=0)}([function(me,e,I){(function(O){var $;e=me.exports=re,$=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],p=e.src=[],S=0,L=S++;p[L]="0|[1-9]\\d*";var C=S++;p[C]="[0-9]+";var w=S++;p[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=S++;p[E]="("+p[L]+")\\.("+p[L]+")\\.("+p[L]+")";var k=S++;p[k]="("+p[C]+")\\.("+p[C]+")\\.("+p[C]+")";var u=S++;p[u]="(?:"+p[L]+"|"+p[w]+")";var m=S++;p[m]="(?:"+p[C]+"|"+p[w]+")";var o=S++;p[o]="(?:-("+p[u]+"(?:\\."+p[u]+")*))";var i=S++;p[i]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var n=S++;p[n]="[0-9A-Za-z-]+";var r=S++;p[r]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var a=S++,t="v?"+p[E]+p[o]+"?"+p[r]+"?";p[a]="^"+t+"$";var d="[v=\\s]*"+p[k]+p[i]+"?"+p[r]+"?",c=S++;p[c]="^"+d+"$";var s=S++;p[s]="((?:<|>)?=?)";var l=S++;p[l]=p[C]+"|x|X|\\*";var h=S++;p[h]=p[L]+"|x|X|\\*";var b=S++;p[b]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var D=S++;p[D]="[v=\\s]*("+p[l]+")(?:\\.("+p[l]+")(?:\\.("+p[l]+")(?:"+p[i]+")?"+p[r]+"?)?)?";var g=S++;p[g]="^"+p[s]+"\\s*"+p[b]+"$";var f=S++;p[f]="^"+p[s]+"\\s*"+p[D]+"$";var y=S++;p[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=S++;p[P]="(?:~>?)";var N=S++;p[N]="(\\s*)"+p[P]+"\\s+",v[N]=new RegExp(p[N],"g");var U=S++;p[U]="^"+p[P]+p[b]+"$";var z=S++;p[z]="^"+p[P]+p[D]+"$";var F=S++;p[F]="(?:\\^)";var M=S++;p[M]="(\\s*)"+p[F]+"\\s+",v[M]=new RegExp(p[M],"g");var T=S++;p[T]="^"+p[F]+p[b]+"$";var j=S++;p[j]="^"+p[F]+p[D]+"$";var J=S++;p[J]="^"+p[s]+"\\s*("+d+")$|^$";var ne=S++;p[ne]="^"+p[s]+"\\s*("+t+")$|^$";var _=S++;p[_]="(\\s*)"+p[s]+"\\s*("+d+"|"+p[b]+")",v[_]=new RegExp(p[_],"g");var Z=S++;p[Z]="^\\s*("+p[b]+")\\s+-\\s+("+p[b]+")\\s*$";var Y=S++;p[Y]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ce=S++;p[ce]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)$(ie,p[ie]),v[ie]||(v[ie]=new RegExp(p[ie]));function fe(H,Q){if(H instanceof re)return H;if(typeof H!="string"||H.length>A||!(Q?v[c]:v[a]).test(H))return null;try{return new re(H,Q)}catch{return null}}function re(H,Q){if(H instanceof re){if(H.loose===Q)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof re))return new re(H,Q);$("SemVer",H,Q),this.loose=Q;var oe=H.trim().match(Q?v[c]:v[a]);if(!oe)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+oe[1],this.minor=+oe[2],this.patch=+oe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");oe[4]?this.prerelease=oe[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Le=+ve;if(Le>=0&&Le<R)return Le}return ve}):this.prerelease=[],this.build=oe[5]?oe[5].split("."):[],this.format()}e.parse=fe,e.valid=function(H,Q){var oe=fe(H,Q);return oe?oe.version:null},e.clean=function(H,Q){var oe=fe(H.trim().replace(/^[=v]+/,""),Q);return oe?oe.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(H){return $("SemVer.compare",this.version,this.loose,H),H instanceof re||(H=new re(H,this.loose)),this.compareMain(H)||this.comparePre(H)},re.prototype.compareMain=function(H){return H instanceof re||(H=new re(H,this.loose)),B(this.major,H.major)||B(this.minor,H.minor)||B(this.patch,H.patch)},re.prototype.comparePre=function(H){if(H instanceof re||(H=new re(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var Q=0;do{var oe=this.prerelease[Q],ve=H.prerelease[Q];if($("prerelease compare",Q,oe,ve),oe===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(oe===void 0)return-1;if(oe!==ve)return B(oe,ve)}while(++Q)},re.prototype.inc=function(H,Q){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var oe=this.prerelease.length;--oe>=0;)typeof this.prerelease[oe]=="number"&&(this.prerelease[oe]++,oe=-2);oe===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,Q,oe,ve){typeof oe=="string"&&(ve=oe,oe=void 0);try{return new re(H,oe).inc(Q,ve).version}catch{return null}},e.diff=function(H,Q){if(de(H,Q))return null;var oe=fe(H),ve=fe(Q);if(oe.prerelease.length||ve.prerelease.length){for(var Le in oe)if((Le==="major"||Le==="minor"||Le==="patch")&&oe[Le]!==ve[Le])return"pre"+Le;return"prerelease"}for(var Le in oe)if((Le==="major"||Le==="minor"||Le==="patch")&&oe[Le]!==ve[Le])return Le},e.compareIdentifiers=B;var K=/^[0-9]+$/;function B(H,Q){var oe=K.test(H),ve=K.test(Q);return oe&&ve&&(H=+H,Q=+Q),oe&&!ve?-1:ve&&!oe?1:H<Q?-1:H>Q?1:0}function ae(H,Q,oe){return new re(H,oe).compare(new re(Q,oe))}function ye(H,Q,oe){return ae(H,Q,oe)>0}function le(H,Q,oe){return ae(H,Q,oe)<0}function de(H,Q,oe){return ae(H,Q,oe)===0}function ue(H,Q,oe){return ae(H,Q,oe)!==0}function ge(H,Q,oe){return ae(H,Q,oe)>=0}function V(H,Q,oe){return ae(H,Q,oe)<=0}function X(H,Q,oe,ve){var Le;switch(Q){case"===":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Le=H===oe;break;case"!==":typeof H=="object"&&(H=H.version),typeof oe=="object"&&(oe=oe.version),Le=H!==oe;break;case"":case"=":case"==":Le=de(H,oe,ve);break;case"!=":Le=ue(H,oe,ve);break;case">":Le=ye(H,oe,ve);break;case">=":Le=ge(H,oe,ve);break;case"<":Le=le(H,oe,ve);break;case"<=":Le=V(H,oe,ve);break;default:throw new TypeError("Invalid operator: "+Q)}return Le}function he(H,Q){if(H instanceof he){if(H.loose===Q)return H;H=H.value}if(!(this instanceof he))return new he(H,Q);$("comparator",H,Q),this.loose=Q,this.parse(H),this.semver===be?this.value="":this.value=this.operator+this.semver.version,$("comp",this)}e.rcompareIdentifiers=function(H,Q){return B(Q,H)},e.major=function(H,Q){return new re(H,Q).major},e.minor=function(H,Q){return new re(H,Q).minor},e.patch=function(H,Q){return new re(H,Q).patch},e.compare=ae,e.compareLoose=function(H,Q){return ae(H,Q,!0)},e.rcompare=function(H,Q,oe){return ae(Q,H,oe)},e.sort=function(H,Q){return H.sort(function(oe,ve){return e.compare(oe,ve,Q)})},e.rsort=function(H,Q){return H.sort(function(oe,ve){return e.rcompare(oe,ve,Q)})},e.gt=ye,e.lt=le,e.eq=de,e.neq=ue,e.gte=ge,e.lte=V,e.cmp=X,e.Comparator=he;var be={};function Pe(H,Q){if(H instanceof Pe)return H.loose===Q?H:new Pe(H.raw,Q);if(H instanceof he)return new Pe(H.value,Q);if(!(this instanceof Pe))return new Pe(H,Q);if(this.loose=Q,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(oe){return this.parseRange(oe.trim())},this).filter(function(oe){return oe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function pe(H){return!H||H.toLowerCase()==="x"||H==="*"}function Ae(H,Q,oe,ve,Le,qe,Ge,Ye,it,ut,ot,et,Re){return((Q=pe(oe)?"":pe(ve)?">="+oe+".0.0":pe(Le)?">="+oe+"."+ve+".0":">="+Q)+" "+(Ye=pe(it)?"":pe(ut)?"<"+(+it+1)+".0.0":pe(ot)?"<"+it+"."+(+ut+1)+".0":et?"<="+it+"."+ut+"."+ot+"-"+et:"<="+Ye)).trim()}function Fe(H,Q){for(var oe=0;oe<H.length;oe++)if(!H[oe].test(Q))return!1;if(Q.prerelease.length){for(oe=0;oe<H.length;oe++)if($(H[oe].semver),H[oe].semver!==be&&H[oe].semver.prerelease.length>0){var ve=H[oe].semver;if(ve.major===Q.major&&ve.minor===Q.minor&&ve.patch===Q.patch)return!0}return!1}return!0}function W(H,Q,oe){try{Q=new Pe(Q,oe)}catch{return!1}return Q.test(H)}function x(H,Q,oe,ve){var Le,qe,Ge,Ye,it;switch(H=new re(H,ve),Q=new Pe(Q,ve),oe){case">":Le=ye,qe=V,Ge=le,Ye=">",it=">=";break;case"<":Le=le,qe=ge,Ge=ye,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(W(H,Q,ve))return!1;for(var ut=0;ut<Q.set.length;++ut){var ot=Q.set[ut],et=null,Re=null;if(ot.forEach(function(ke){ke.semver===be&&(ke=new he(">=0.0.0")),et=et||ke,Re=Re||ke,Le(ke.semver,et.semver,ve)?et=ke:Ge(ke.semver,Re.semver,ve)&&(Re=ke)}),et.operator===Ye||et.operator===it||(!Re.operator||Re.operator===Ye)&&qe(H,Re.semver)||Re.operator===it&&Ge(H,Re.semver))return!1}return!0}he.prototype.parse=function(H){var Q=this.loose?v[J]:v[ne],oe=H.match(Q);if(!oe)throw new TypeError("Invalid comparator: "+H);this.operator=oe[1],this.operator==="="&&(this.operator=""),oe[2]?this.semver=new re(oe[2],this.loose):this.semver=be},he.prototype.toString=function(){return this.value},he.prototype.test=function(H){return $("Comparator.test",H,this.loose),this.semver===be||(typeof H=="string"&&(H=new re(H,this.loose)),X(H,this.operator,this.semver,this.loose))},he.prototype.intersects=function(H,Q){if(!(H instanceof he))throw new TypeError("a Comparator is required");var oe;if(this.operator==="")return oe=new Pe(H.value,Q),W(this.value,oe,Q);if(H.operator==="")return oe=new Pe(this.value,Q),W(H.semver,oe,Q);var ve=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Le=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Ye=X(this.semver,"<",H.semver,Q)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),it=X(this.semver,">",H.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ve||Le||qe&&Ge||Ye||it},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(H){var Q=this.loose;H=H.trim(),$("range",H,Q);var oe=Q?v[Y]:v[Z];H=H.replace(oe,Ae),$("hyphen replace",H),H=H.replace(v[_],"$1$2$3"),$("comparator trim",H,v[_]),H=(H=(H=H.replace(v[N],"$1~")).replace(v[M],"$1^")).split(/\s+/).join(" ");var ve=Q?v[J]:v[ne],Le=H.split(" ").map(function(qe){return function(Ge,Ye){return $("comp",Ge),Ge=function(it,ut){return it.trim().split(/\s+/).map(function(ot){return function(et,Re){$("caret",et,Re);var ke=Re?v[j]:v[T];return et.replace(ke,function(He,ee,se,Se,Ve){var Ze;return $("caret",et,He,ee,se,Se,Ve),pe(ee)?Ze="":pe(se)?Ze=">="+ee+".0.0 <"+(+ee+1)+".0.0":pe(Se)?Ze=ee==="0"?">="+ee+"."+se+".0 <"+ee+"."+(+se+1)+".0":">="+ee+"."+se+".0 <"+(+ee+1)+".0.0":Ve?($("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=ee==="0"?se==="0"?">="+ee+"."+se+"."+Se+Ve+" <"+ee+"."+se+"."+(+Se+1):">="+ee+"."+se+"."+Se+Ve+" <"+ee+"."+(+se+1)+".0":">="+ee+"."+se+"."+Se+Ve+" <"+(+ee+1)+".0.0"):($("no pr"),Ze=ee==="0"?se==="0"?">="+ee+"."+se+"."+Se+" <"+ee+"."+se+"."+(+Se+1):">="+ee+"."+se+"."+Se+" <"+ee+"."+(+se+1)+".0":">="+ee+"."+se+"."+Se+" <"+(+ee+1)+".0.0"),$("caret return",Ze),Ze})}(ot,ut)}).join(" ")}(Ge,Ye),$("caret",Ge),Ge=function(it,ut){return it.trim().split(/\s+/).map(function(ot){return function(et,Re){var ke=Re?v[z]:v[U];return et.replace(ke,function(He,ee,se,Se,Ve){var Ze;return $("tilde",et,He,ee,se,Se,Ve),pe(ee)?Ze="":pe(se)?Ze=">="+ee+".0.0 <"+(+ee+1)+".0.0":pe(Se)?Ze=">="+ee+"."+se+".0 <"+ee+"."+(+se+1)+".0":Ve?($("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ze=">="+ee+"."+se+"."+Se+Ve+" <"+ee+"."+(+se+1)+".0"):Ze=">="+ee+"."+se+"."+Se+" <"+ee+"."+(+se+1)+".0",$("tilde return",Ze),Ze})}(ot,ut)}).join(" ")}(Ge,Ye),$("tildes",Ge),Ge=function(it,ut){return $("replaceXRanges",it,ut),it.split(/\s+/).map(function(ot){return function(et,Re){et=et.trim();var ke=Re?v[f]:v[g];return et.replace(ke,function(He,ee,se,Se,Ve,Ze){$("xRange",et,He,ee,se,Se,Ve,Ze);var nt=pe(se),rt=nt||pe(Se),je=rt||pe(Ve);return ee==="="&&je&&(ee=""),nt?He=ee===">"||ee==="<"?"<0.0.0":"*":ee&&je?(rt&&(Se=0),je&&(Ve=0),ee===">"?(ee=">=",rt?(se=+se+1,Se=0,Ve=0):je&&(Se=+Se+1,Ve=0)):ee==="<="&&(ee="<",rt?se=+se+1:Se=+Se+1),He=ee+se+"."+Se+"."+Ve):rt?He=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(He=">="+se+"."+Se+".0 <"+se+"."+(+Se+1)+".0"),$("xRange return",He),He})}(ot,ut)}).join(" ")}(Ge,Ye),$("xrange",Ge),Ge=function(it,ut){return $("replaceStars",it,ut),it.trim().replace(v[ce],"")}(Ge,Ye),$("stars",Ge),Ge}(qe,Q)}).join(" ").split(/\s+/);return this.loose&&(Le=Le.filter(function(qe){return!!qe.match(ve)})),Le=Le.map(function(qe){return new he(qe,Q)})},Pe.prototype.intersects=function(H,Q){if(!(H instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(oe){return oe.every(function(ve){return H.set.some(function(Le){return Le.every(function(qe){return ve.intersects(qe,Q)})})})})},e.toComparators=function(H,Q){return new Pe(H,Q).set.map(function(oe){return oe.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new re(H,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Fe(this.set[Q],H))return!0;return!1},e.satisfies=W,e.maxSatisfying=function(H,Q,oe){var ve=null,Le=null;try{var qe=new Pe(Q,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ve&&Le.compare(Ge)!==-1||(Le=new re(ve=Ge,oe)))}),ve},e.minSatisfying=function(H,Q,oe){var ve=null,Le=null;try{var qe=new Pe(Q,oe)}catch{return null}return H.forEach(function(Ge){qe.test(Ge)&&(ve&&Le.compare(Ge)!==1||(Le=new re(ve=Ge,oe)))}),ve},e.validRange=function(H,Q){try{return new Pe(H,Q).range||"*"}catch{return null}},e.ltr=function(H,Q,oe){return x(H,Q,"<",oe)},e.gtr=function(H,Q,oe){return x(H,Q,">",oe)},e.outside=x,e.prerelease=function(H,Q){var oe=fe(H,Q);return oe&&oe.prerelease.length?oe.prerelease:null},e.intersects=function(H,Q,oe){return H=new Pe(H,oe),Q=new Pe(Q,oe),H.intersects(Q)},e.coerce=function(H){if(H instanceof re)return H;if(typeof H!="string")return null;var Q=H.match(v[y]);return Q==null?null:fe((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,I(1))},function(me,e){var I,O,$=me.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function v(m){if(I===setTimeout)return setTimeout(m,0);if((I===A||!I)&&setTimeout)return I=setTimeout,setTimeout(m,0);try{return I(m,0)}catch{try{return I.call(null,m,0)}catch{return I.call(this,m,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:A}catch{I=A}try{O=typeof clearTimeout=="function"?clearTimeout:R}catch{O=R}})();var p,S=[],L=!1,C=-1;function w(){L&&p&&(L=!1,p.length?S=p.concat(S):C=-1,S.length&&E())}function E(){if(!L){var m=v(w);L=!0;for(var o=S.length;o;){for(p=S,S=[];++C<o;)p&&p[C].run();C=-1,o=S.length}p=null,L=!1,function(i){if(O===clearTimeout)return clearTimeout(i);if((O===R||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(i);try{O(i)}catch{try{return O.call(null,i)}catch{return O.call(this,i)}}}(m)}}function k(m,o){this.fun=m,this.array=o}function u(){}$.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];S.push(new k(m,o)),S.length!==1||L||v(E)},k.prototype.run=function(){this.fun.apply(null,this.array)},$.title="browser",$.browser=!0,$.env={},$.argv=[],$.version="",$.versions={},$.on=u,$.addListener=u,$.once=u,$.off=u,$.removeListener=u,$.removeAllListeners=u,$.emit=u,$.prependListener=u,$.prependOnceListener=u,$.listeners=function(m){return[]},$.binding=function(m){throw new Error("process.binding is not supported")},$.cwd=function(){return"/"},$.chdir=function(m){throw new Error("process.chdir is not supported")},$.umask=function(){return 0}}])}),define(Ce[38],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(A){return new O(A)}constructor(A){this.c=I&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Yd=O}),define(Ce[4],Ie([1,0,14,75,3,76,38]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.Event=void 0;const v=!1,p=!1;var S;(function(g){g.None=()=>$.$Tc.None;function f(V){if(p){const{onDidAddListener:X}=V,he=k.create();let be=0;V.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),X?.()}}}function y(V,X){return ne(V,()=>{},0,void 0,!0,void 0,X)}g.defer=y;function P(V){return(X,he=null,be)=>{let Pe=!1,pe;return pe=V(Ae=>{if(!Pe)return pe?pe.dispose():Pe=!0,X.call(he,Ae)},null,be),Pe&&pe.dispose(),pe}}g.once=P;function N(V,X,he){return j((be,Pe=null,pe)=>V(Ae=>be.call(Pe,X(Ae)),null,pe),he)}g.map=N;function U(V,X,he){return j((be,Pe=null,pe)=>V(Ae=>{X(Ae),be.call(Pe,Ae)},null,pe),he)}g.forEach=U;function z(V,X,he){return j((be,Pe=null,pe)=>V(Ae=>X(Ae)&&be.call(Pe,Ae),null,pe),he)}g.filter=z;function F(V){return V}g.signal=F;function M(...V){return(X,he=null,be)=>{const Pe=(0,$.$Qc)(...V.map(pe=>pe(Ae=>X.call(he,Ae))));return J(Pe,be)}}g.any=M;function T(V,X,he,be){let Pe=he;return N(V,pe=>(Pe=X(Pe,pe),Pe),be)}g.reduce=T;function j(V,X){let he;const be={onWillAddFirstListener(){he=V(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};X||f(be);const Pe=new n(be);return X?.add(Pe),Pe.event}function J(V,X){return X instanceof Array?X.push(V):X&&X.add(V),V}function ne(V,X,he=100,be=!1,Pe=!1,pe,Ae){let Fe,W,x,H=0,Q;const oe={leakWarningThreshold:pe,onWillAddFirstListener(){Fe=V(Le=>{H++,W=X(W,Le),be&&!x&&(ve.fire(W),W=void 0),Q=()=>{const qe=W;W=void 0,x=void 0,(!be||H>1)&&ve.fire(qe),H=0},typeof he=="number"?(clearTimeout(x),x=setTimeout(Q,he)):x===void 0&&(x=0,queueMicrotask(Q))})},onWillRemoveListener(){Pe&&H>0&&Q?.()},onDidRemoveLastListener(){Q=void 0,Fe.dispose()}};Ae||f(oe);const ve=new n(oe);return Ae?.add(ve),ve.event}g.debounce=ne;function _(V,X=0,he){return g.debounce(V,(be,Pe)=>be?(be.push(Pe),be):[Pe],X,void 0,!0,void 0,he)}g.accumulate=_;function Z(V,X=(be,Pe)=>be===Pe,he){let be=!0,Pe;return z(V,pe=>{const Ae=be||!X(pe,Pe);return be=!1,Pe=pe,Ae},he)}g.latch=Z;function Y(V,X,he){return[g.filter(V,X,he),g.filter(V,be=>!X(be),he)]}g.split=Y;function ce(V,X=!1,he=[],be){let Pe=he.slice(),pe=V(W=>{Pe?Pe.push(W):Fe.fire(W)});be&&be.add(pe);const Ae=()=>{Pe?.forEach(W=>Fe.fire(W)),Pe=null},Fe=new n({onWillAddFirstListener(){pe||(pe=V(W=>Fe.fire(W)),be&&be.add(pe))},onDidAddFirstListener(){Pe&&(X?setTimeout(Ae):Ae())},onDidRemoveLastListener(){pe&&pe.dispose(),pe=null}});return be&&be.add(Fe),Fe.event}g.buffer=ce;function ie(V,X){return(be,Pe,pe)=>{const Ae=X(new re);return V(function(Fe){const W=Ae.evaluate(Fe);W!==fe&&be.call(Pe,W)},void 0,pe)}}g.chain=ie;const fe=Symbol("HaltChainable");class re{constructor(){this.f=[]}map(X){return this.f.push(X),this}forEach(X){return this.f.push(he=>(X(he),he)),this}filter(X){return this.f.push(he=>X(he)?he:fe),this}reduce(X,he){let be=he;return this.f.push(Pe=>(be=X(be,Pe),be)),this}latch(X=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const pe=he||!X(Pe,be);return he=!1,be=Pe,pe?Pe:fe}),this}evaluate(X){for(const he of this.f)if(X=he(X),X===fe)break;return X}}function K(V,X,he=be=>be){const be=(...Fe)=>Ae.fire(he(...Fe)),Pe=()=>V.on(X,be),pe=()=>V.removeListener(X,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Ae.event}g.fromNodeEventEmitter=K;function B(V,X,he=be=>be){const be=(...Fe)=>Ae.fire(he(...Fe)),Pe=()=>V.addEventListener(X,be),pe=()=>V.removeEventListener(X,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:pe});return Ae.event}g.fromDOMEventEmitter=B;function ae(V){return new Promise(X=>P(V)(X))}g.toPromise=ae;function ye(V){const X=new n;return V.then(he=>{X.fire(he)},()=>{X.fire(void 0)}).finally(()=>{X.dispose()}),X.event}g.fromPromise=ye;function le(V,X,he){return X(he),V(be=>X(be))}g.runAndSubscribe=le;class de{constructor(X,he){this._observable=X,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};he||f(be),this.emitter=new n(be),he&&he.add(this.emitter)}beginUpdate(X){this.f++}handlePossibleChange(X){}handleChange(X,he){this.g=!0}endUpdate(X){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(V,X){return new de(V,X).emitter.event}g.fromObservable=ue;function ge(V){return(X,he,be)=>{let Pe=0,pe=!1;const Ae={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(V.reportChanges(),pe&&(pe=!1,X.call(he)))},handlePossibleChange(){},handleChange(){pe=!0}};V.addObserver(Ae),V.reportChanges();const Fe={dispose(){V.removeObserver(Ae)}};return be instanceof $.$Sc?be.add(Fe):Array.isArray(be)&&be.push(Fe),Fe}}g.fromObservableLight=ge})(S||(e.Event=S={}));class L{static{this.all=new Set}static{this.f=0}constructor(f){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${f}_${L.f++}`,L.all.add(this)}start(f){this.g=new R.$Yd,this.listenerCount=f}stop(){if(this.g){const f=this.g.elapsed();this.durations.push(f),this.elapsedOverall+=f,this.invocationCount+=1,this.g=void 0}}}e.$1d=L;let C=-1;function w(g){const f=C;return C=g,{dispose(){C=f}}}e.$2d=w;class E{constructor(f,y=Math.random().toString(18).slice(2,5)){this.threshold=f,this.name=y,this.g=0}dispose(){this.f?.clear()}check(f,y){const P=this.threshold;if(P<=0||y<P)return;this.f||(this.f=new Map);const N=this.f.get(f.value)||0;if(this.f.set(f.value,N+1),this.g-=1,this.g<=0){this.g=P*.5;let U,z=0;for(const[F,M]of this.f)(!U||z<M)&&(U=F,z=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(f.value)||0;this.f.set(f.value,U-1)}}}class k{static create(){return new k(new Error().stack??"")}constructor(f){this.value=f}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class m{constructor(f){this.value=f,this.id=u++}}const o=2,i=(g,f)=>{if(g instanceof m)f(g);else for(let y=0;y<g.length;y++){const P=g[y];P&&f(P)}};class n{constructor(f){this.w=0,this.f=f,this.g=C>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new L(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const f=this.t;queueMicrotask(()=>{i(f,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(f,y,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),$.$Tc.None;if(this.m)return $.$Tc.None;y&&(f=f.bind(y));const N=new m(f);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=k.create(),U=this.g.check(N.stack,this.w+1)),v&&(N.stack=z??k.create()),this.t?this.t instanceof m?(this.u??=new a,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,$.$Rc)(()=>{U?.(),this.x(N)});return P instanceof $.$Sc?P.add(F):Array.isArray(P)&&P.push(F),F},this.q}x(f){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,P=y.indexOf(f);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[P]=void 0;const N=this.u.current===this;if(this.w*o<=y.length){let U=0;for(let z=0;z<y.length;z++)y[z]?y[U++]=y[z]:N&&(this.u.end--,U<this.u.i&&this.u.i--);y.length=U}}y(f,y){if(!f)return;const P=this.f?.onListenerError||I.$1;if(!P){f.value(y);return}try{f.value(y)}catch(N){P(N)}}z(f){const y=f.current.t;for(;f.i<f.end;)this.y(y[f.i++],f.value);f.reset()}fire(f){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,f);else{const y=this.u;y.enqueue(this,f,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$3d=n;const r=()=>new a;e.$4d=r;class a{constructor(){this.i=-1,this.end=0}enqueue(f,y,P){this.i=0,this.end=P,this.current=f,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(f,y,P){if(this.t)for(this.h||(this.h=new A.$4c),i(this.t,N=>this.h.push([N.value,f]));this.h.size>0&&!y.isCancellationRequested;){const[N,U]=this.h.shift(),z=[],F={...U,token:y,waitUntil:M=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(M=P(M,N)),z.push(M)}};try{N(F)}catch(M){(0,I.$1)(M);continue}Object.freeze(z),await Promise.allSettled(z).then(M=>{for(const T of M)T.status==="rejected"&&(0,I.$1)(T.reason)})}}}e.$5d=t;class d extends n{get isPaused(){return this.h!==0}constructor(f){super(f),this.h=0,this.s=new A.$4c,this.A=f?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const f=Array.from(this.s);this.s.clear(),super.fire(this.A(f))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(f){this.w&&(this.h!==0?this.s.push(f):super.fire(f))}}e.$6d=d;class c extends d{constructor(f){super(f),this.k=f.delay??100}fire(f){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(f)}}e.$7d=c;class s extends n{constructor(f){super(f),this.h=[],this.k=f?.merge}fire(f){this.hasListeners()&&(this.h.push(f),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$8d=s;class l{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(f){const y={event:f,listener:null};this.h.push(y),this.g&&this.m(y);const P=()=>{this.g&&this.o(y);const N=this.h.indexOf(y);this.h.splice(N,1)};return(0,$.$Rc)((0,O.$db)(P))}j(){this.g=!0,this.h.forEach(f=>this.m(f))}k(){this.g=!1,this.h.forEach(f=>this.o(f))}m(f){f.listener=f.event(y=>this.f.fire(y))}o(f){f.listener?.dispose(),f.listener=null}dispose(){this.f.dispose();for(const f of this.h)f.listener?.dispose();this.h=[]}}e.$9d=l;class h{constructor(f,y,P,N){this.f=new $.$Sc;const U=this.f.add(new l),z=this.f.add(new $.$3c);function F(M){z.set(M,U.add(N(M)))}for(const M of f)F(M);this.f.add(y(M=>{F(M)})),this.f.add(P(M=>{z.deleteAndDispose(M)})),this.event=U.event}dispose(){this.f.dispose()}}e.$0d=h;class b{constructor(){this.f=[]}wrapEvent(f){return(y,P,N)=>f(U=>{const z=this.f[this.f.length-1];z?z.push(()=>y.call(P,U)):y.call(P,U)},void 0,N)}bufferEvents(f){const y=[];this.f.push(y);const P=f();return this.f.pop(),y.forEach(N=>N()),P}}e.$$d=b;class D{constructor(){this.f=!1,this.g=S.None,this.h=$.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(f){this.g=f,this.f&&(this.h.dispose(),this.h=f(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$_d=D}),define(Ce[22],Ie([1,0,4]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=e.CancellationToken=void 0;const O=Object.freeze(function(v,p){const S=setTimeout(v.bind(p),0);return{dispose(){clearTimeout(S)}}});var $;(function(v){function p(S){return S===v.None||S===v.Cancelled||S instanceof A?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}v.isCancellationToken=p,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})($||(e.CancellationToken=$={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new I.$3d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=$.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=$.None}}e.$ae=R}),define(Ce[163],Ie([1,0,22]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=void 0;class O{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new I.$ae,p=this.b(v.token);return this.a={promise:p,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$Le=O;class ${constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const p=JSON.stringify(v);return this.b!==p&&(this.b=p,this.a=this.c(v)),this.a}}e.$Me=$;class A{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const p=this.b(v);return this.a.set(v,p),p}}e.$Ne=A}),define(Ce[98],Ie([1,0,14,3]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;function $(r){const a=r;return a?typeof a.read=="function":!1}e.$be=$;function A(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$ce=A;function R(r){const a=r;return a?A(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$de=R;function v(r,a){return new p(r,a)}e.$ee=v;class p{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,I.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let d;switch(a){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const c=d.indexOf(t);c>=0&&d.splice(c,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(r,a){const t=[];let d;for(;(d=r.read())!==null;)t.push(d);return a(t)}e.$fe=S;function L(r,a,t){const d=[];let c;for(;(c=r.read())!==null&&d.length<t;)d.push(c);return c===null&&d.length>0?a(d):{read:()=>{if(d.length>0)return d.shift();if(typeof c<"u"){const s=c;return c=void 0,s}return r.read()}}}e.$ge=L;function C(r,a){return new Promise((t,d)=>{const c=[];w(r,{onData:s=>{a&&c.push(s)},onError:s=>{a?d(s):t(void 0)},onEnd:()=>{t(a?a(c):void 0)}})})}e.$he=C;function w(r,a,t){r.on("error",d=>{t?.isCancellationRequested||a.onError(d)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",d=>{t?.isCancellationRequested||a.onData(d)})}e.$ie=w;function E(r,a){return new Promise((t,d)=>{const c=new O.$Sc,s=[],l=D=>{if(s.push(D),s.length>a)return c.dispose(),r.pause(),t({stream:r,buffer:s,ended:!1})},h=D=>(c.dispose(),d(D)),b=()=>(c.dispose(),t({stream:r,buffer:s,ended:!0}));c.add((0,O.$Rc)(()=>r.removeListener("error",h))),r.on("error",h),c.add((0,O.$Rc)(()=>r.removeListener("end",b))),r.on("end",b),c.add((0,O.$Rc)(()=>r.removeListener("data",l))),r.on("data",l)})}e.$je=E;function k(r,a){const t=v(a);return t.end(r),t}e.$ke=k;function u(){const r=v(()=>{throw new Error("not supported")});return r.end(),r}e.$le=u;function m(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$me=m;function o(r,a,t){const d=v(t);return w(r,{onData:c=>d.write(a.data(c)),onError:c=>d.error(a.error?a.error(c):c),onEnd:()=>d.end()}),d}e.$ne=o;function i(r,a,t){let d=!1;return{read:()=>{const c=a.read();return d?c:(d=!0,c!==null?t([r,c]):r)}}}e.$oe=i;function n(r,a,t){let d=!1;const c=v(t);return w(a,{onData:s=>d?c.write(s):(d=!0,c.write(t([r,s]))),onError:s=>c.error(s),onEnd:()=>{d||(d=!0,c.write(r)),c.end()}}),c}e.$pe=n}),define(Ce[21],Ie([1,0,43,98]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=void 0;const $=typeof Buffer<"u",A=new I.$V(()=>new Uint8Array(256));let R,v;class p{static alloc(y){return $?new p(Buffer.allocUnsafe(y)):new p(new Uint8Array(y))}static wrap(y){return $&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new p(y)}static fromString(y,P){return!(P?.dontUseNodeBuffer||!1)&&$?new p(Buffer.from(y)):(R||(R=new TextEncoder),new p(R.encode(y)))}static fromByteArray(y){const P=p.alloc(y.length);for(let N=0,U=y.length;N<U;N++)P.buffer[N]=y[N];return P}static concat(y,P){if(typeof P>"u"){P=0;for(let z=0,F=y.length;z<F;z++)P+=y[z].byteLength}const N=p.alloc(P);let U=0;for(let z=0,F=y.length;z<F;z++){const M=y[z];N.set(M,U),U+=M.byteLength}return N}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=p.alloc(this.byteLength);return y.set(this),y}toString(){return $?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(y,P){return new p(this.buffer.subarray(y,P))}set(y,P){if(y instanceof p)this.buffer.set(y.buffer,P);else if(y instanceof Uint8Array)this.buffer.set(y,P);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),P);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,P){E(this.buffer,y,P)}readUInt32LE(y){return k(this.buffer,y)}writeUInt32LE(y,P){u(this.buffer,y,P)}readUInt8(y){return m(this.buffer,y)}writeUInt8(y,P){o(this.buffer,y,P)}indexOf(y,P=0){return S(this.buffer,y instanceof p?y.buffer:y,P)}}e.$qe=p;function S(f,y,P=0){const N=y.byteLength,U=f.byteLength;if(N===0)return 0;if(N===1)return f.indexOf(y[0]);if(N>U-P)return-1;const z=A.value;z.fill(y.length);for(let j=0;j<y.length;j++)z[y[j]]=y.length-j-1;let F=P+y.length-1,M=F,T=-1;for(;F<U;)if(f[F]===y[M]){if(M===0){T=F;break}F--,M--}else F+=Math.max(y.length-M,z[f[F]]),M=y.length-1;return T}e.$re=S;function L(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}e.$se=L;function C(f,y,P){f[P+0]=y&255,y=y>>>8,f[P+1]=y&255}e.$te=C;function w(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}e.$ue=w;function E(f,y,P){f[P+3]=y,y=y>>>8,f[P+2]=y,y=y>>>8,f[P+1]=y,y=y>>>8,f[P]=y}e.$ve=E;function k(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}e.$we=k;function u(f,y,P){f[P+0]=y&255,y=y>>>8,f[P+1]=y&255,y=y>>>8,f[P+2]=y&255,y=y>>>8,f[P+3]=y&255}e.$xe=u;function m(f,y){return f[y]}e.$ye=m;function o(f,y,P){f[P]=y}e.$ze=o;function i(f){return O.$fe(f,y=>p.concat(y))}e.$Ae=i;function n(f){return O.$me(f)}e.$Be=n;function r(f){return O.$he(f,y=>p.concat(y))}e.$Ce=r;async function a(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await r(f.stream)])}e.$De=a;function t(f){return O.$ke(f,y=>p.concat(y))}e.$Ee=t;function d(f){return O.$ne(f,{data:y=>typeof y=="string"?p.fromString(y):p.wrap(y)},y=>p.concat(y))}e.$Fe=d;function c(f){return O.$ee(y=>p.concat(y),f)}e.$Ge=c;function s(f,y){return O.$oe(f,y,P=>p.concat(P))}e.$He=s;function l(f,y){return O.$pe(f,y,P=>p.concat(P))}e.$Ie=l;function h(f){let y=0,P=0,N=0;const U=new Uint8Array(Math.floor(f.length/4*3)),z=M=>{switch(P){case 3:U[N++]=y|M,P=0;break;case 2:U[N++]=y|M>>>2,y=M<<6,P=3;break;case 1:U[N++]=y|M>>>4,y=M<<4,P=2;break;default:y=M<<2,P=1}};for(let M=0;M<f.length;M++){const T=f.charCodeAt(M);if(T>=65&&T<=90)z(T-65);else if(T>=97&&T<=122)z(T-97+26);else if(T>=48&&T<=57)z(T-48+52);else if(T===43||T===45)z(62);else if(T===47||T===95)z(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${f[M]}`)}}const F=N;for(;P>0;)z(0);return p.wrap(U).slice(0,F)}e.$Je=h;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:f},y=!0,P=!1){const N=P?D:b;let U="";const z=f.byteLength%3;let F=0;for(;F<f.byteLength-z;F+=3){const M=f[F+0],T=f[F+1],j=f[F+2];U+=N[M>>>2],U+=N[(M<<4|T>>>4)&63],U+=N[(T<<2|j>>>6)&63],U+=N[j&63]}if(z===1){const M=f[F+0];U+=N[M>>>2],U+=N[M<<4&63],y&&(U+="==")}else if(z===2){const M=f[F+0],T=f[F+1];U+=N[M>>>2],U+=N[(M<<4|T>>>4)&63],U+=N[T<<2&63],y&&(U+="=")}return U}e.$Ke=g}),define(Ce[12],Ie([1,0,163,43]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.GraphemeBreakType=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=void 0;function $(Re){return!Re||typeof Re!="string"?!0:Re.trim().length===0}e.$Qe=$;const A=/{(\d+)}/g;function R(Re,...ke){return ke.length===0?Re:Re.replace(A,function(He,ee){const se=parseInt(ee,10);return isNaN(se)||se<0||se>=ke.length?He:ke[se]})}e.$Re=R;const v=/{([^}]+)}/g;function p(Re,ke){return Object.keys(ke).length===0?Re:Re.replace(v,(He,ee)=>ke[ee]??He)}e.$Se=p;function S(Re){return Re.replace(/[<>"'&]/g,ke=>{switch(ke){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ke})}e.$Te=S;function L(Re){return Re.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.$Ue=L;function C(Re){return Re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ve=C;function w(Re,ke){let He=0;const ee=ke.charCodeAt(0);for(let se=Re.length-1;se>=0;se--)Re.charCodeAt(se)===ee&&He++;return He}e.$We=w;function E(Re,ke,He="\u2026"){return Re.length<=ke?Re:`${Re.substr(0,ke)}${He}`}e.$Xe=E;function k(Re,ke,He="\u2026"){if(Re.length<=ke)return Re;const ee=Math.ceil(ke/2)-He.length/2,se=Math.floor(ke/2)-He.length/2;return`${Re.substr(0,ee)}${He}${Re.substr(Re.length-se)}`}e.$Ye=k;function u(Re,ke=" "){const He=m(Re,ke);return o(He,ke)}e.$Ze=u;function m(Re,ke){if(!Re||!ke)return Re;const He=ke.length;if(He===0||Re.length===0)return Re;let ee=0;for(;Re.indexOf(ke,ee)===ee;)ee=ee+He;return Re.substring(ee)}e.$1e=m;function o(Re,ke){if(!Re||!ke)return Re;const He=ke.length,ee=Re.length;if(He===0||ee===0)return Re;let se=ee,Se=-1;for(;Se=Re.lastIndexOf(ke,se-1),!(Se===-1||Se+He!==se);){if(Se===0)return"";se=Se}return Re.substring(0,se)}e.$2e=o;function i(Re){return Re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$3e=i;function n(Re){return Re.replace(/\*/g,"")}e.$4e=n;function r(Re,ke,He={}){if(!Re)throw new Error("Cannot create regex from empty string");ke||(Re=C(Re)),He.wholeWord&&(/\B/.test(Re.charAt(0))||(Re="\\b"+Re),/\B/.test(Re.charAt(Re.length-1))||(Re=Re+"\\b"));let ee="";return He.global&&(ee+="g"),He.matchCase||(ee+="i"),He.multiline&&(ee+="m"),He.unicode&&(ee+="u"),new RegExp(Re,ee)}e.$5e=r;function a(Re){return Re.source==="^"||Re.source==="^$"||Re.source==="$"||Re.source==="^\\s*$"?!1:!!(Re.exec("")&&Re.lastIndex===0)}e.$6e=a;function t(Re){return Re.split(/\r\n|\r|\n/)}e.$7e=t;function d(Re){const ke=[],He=Re.split(/(\r\n|\r|\n)/);for(let ee=0;ee<Math.ceil(He.length/2);ee++)ke.push(He[2*ee]+(He[2*ee+1]??""));return ke}e.$8e=d;function c(Re){for(let ke=0,He=Re.length;ke<He;ke++){const ee=Re.charCodeAt(ke);if(ee!==32&&ee!==9)return ke}return-1}e.$9e=c;function s(Re,ke=0,He=Re.length){for(let ee=ke;ee<He;ee++){const se=Re.charCodeAt(ee);if(se!==32&&se!==9)return Re.substring(ke,ee)}return Re.substring(ke,He)}e.$0e=s;function l(Re,ke=Re.length-1){for(let He=ke;He>=0;He--){const ee=Re.charCodeAt(He);if(ee!==32&&ee!==9)return He}return-1}e.$$e=l;function h(Re,ke,He){const ee=[];let se=0;for(const Se of Re.matchAll(ke)){if(ee.push(Re.slice(se,Se.index)),Se.index===void 0)throw new Error("match.index should be defined");se=Se.index+Se[0].length,ee.push(He(Se[0],...Se.slice(1),Se.index,Re,Se.groups))}return ee.push(Re.slice(se)),Promise.all(ee).then(Se=>Se.join(""))}e.$_e=h;function b(Re,ke){return Re<ke?-1:Re>ke?1:0}e.$af=b;function D(Re,ke,He=0,ee=Re.length,se=0,Se=ke.length){for(;He<ee&&se<Se;He++,se++){const nt=Re.charCodeAt(He),rt=ke.charCodeAt(se);if(nt<rt)return-1;if(nt>rt)return 1}const Ve=ee-He,Ze=Se-se;return Ve<Ze?-1:Ve>Ze?1:0}e.$bf=D;function g(Re,ke){return f(Re,ke,0,Re.length,0,ke.length)}e.$cf=g;function f(Re,ke,He=0,ee=Re.length,se=0,Se=ke.length){for(;He<ee&&se<Se;He++,se++){let nt=Re.charCodeAt(He),rt=ke.charCodeAt(se);if(nt===rt)continue;if(nt>=128||rt>=128)return D(Re.toLowerCase(),ke.toLowerCase(),He,ee,se,Se);P(nt)&&(nt-=32),P(rt)&&(rt-=32);const je=nt-rt;if(je!==0)return je}const Ve=ee-He,Ze=Se-se;return Ve<Ze?-1:Ve>Ze?1:0}e.$df=f;function y(Re){return Re>=48&&Re<=57}e.$ef=y;function P(Re){return Re>=97&&Re<=122}e.$ff=P;function N(Re){return Re>=65&&Re<=90}e.$gf=N;function U(Re,ke){return Re.length===ke.length&&f(Re,ke)===0}e.$hf=U;function z(Re,ke){const He=ke.length;return ke.length>Re.length?!1:f(Re,ke,0,He)===0}e.$if=z;function F(Re,ke){const He=Math.min(Re.length,ke.length);let ee;for(ee=0;ee<He;ee++)if(Re.charCodeAt(ee)!==ke.charCodeAt(ee))return ee;return He}e.$jf=F;function M(Re,ke){const He=Math.min(Re.length,ke.length);let ee;const se=Re.length-1,Se=ke.length-1;for(ee=0;ee<He;ee++)if(Re.charCodeAt(se-ee)!==ke.charCodeAt(Se-ee))return ee;return He}e.$kf=M;function T(Re){return 55296<=Re&&Re<=56319}e.$lf=T;function j(Re){return 56320<=Re&&Re<=57343}e.$mf=j;function J(Re,ke){return(Re-55296<<10)+(ke-56320)+65536}e.$nf=J;function ne(Re,ke,He){const ee=Re.charCodeAt(He);if(T(ee)&&He+1<ke){const se=Re.charCodeAt(He+1);if(j(se))return J(ee,se)}return ee}e.$of=ne;function _(Re,ke){const He=Re.charCodeAt(ke-1);if(j(He)&&ke>1){const ee=Re.charCodeAt(ke-2);if(T(ee))return J(ee,He)}return He}class Z{get offset(){return this.e}constructor(ke,He=0){this.c=ke,this.d=ke.length,this.e=He}setOffset(ke){this.e=ke}prevCodePoint(){const ke=_(this.c,this.e);return this.e-=ke>=65536?2:1,ke}nextCodePoint(){const ke=ne(this.c,this.d,this.e);return this.e+=ke>=65536?2:1,ke}eol(){return this.e>=this.d}}e.$pf=Z;class Y{get offset(){return this.c.offset}constructor(ke,He=0){this.c=new Z(ke,He)}nextGraphemeLength(){const ke=Le.getInstance(),He=this.c,ee=He.offset;let se=ke.getGraphemeBreakType(He.nextCodePoint());for(;!He.eol();){const Se=He.offset,Ve=ke.getGraphemeBreakType(He.nextCodePoint());if(oe(se,Ve)){He.setOffset(Se);break}se=Ve}return He.offset-ee}prevGraphemeLength(){const ke=Le.getInstance(),He=this.c,ee=He.offset;let se=ke.getGraphemeBreakType(He.prevCodePoint());for(;He.offset>0;){const Se=He.offset,Ve=ke.getGraphemeBreakType(He.prevCodePoint());if(oe(Ve,se)){He.setOffset(Se);break}se=Ve}return ee-He.offset}eol(){return this.c.eol()}}e.$qf=Y;function ce(Re,ke){return new Y(Re,ke).nextGraphemeLength()}e.$rf=ce;function ie(Re,ke){return new Y(Re,ke).prevGraphemeLength()}e.$sf=ie;function fe(Re,ke){ke>0&&j(Re.charCodeAt(ke))&&ke--;const He=ke+ce(Re,ke);return[He-ie(Re,He),He]}e.$tf=fe;function re(Re){const ke=new Y(Re);let He=0;for(;!ke.eol();)He++,ke.nextGraphemeLength();return He}e.$uf=re;let K;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ae(Re){return K||(K=B()),K.test(Re)}e.$vf=ae;const ye=/^[\t\n\r\x20-\x7E]*$/;function le(Re){return ye.test(Re)}e.$wf=le,e.$xf=/[\u2028\u2029]/;function de(Re){return e.$xf.test(Re)}e.$yf=de;function ue(Re){return Re>=11904&&Re<=55215||Re>=63744&&Re<=64255||Re>=65281&&Re<=65374}e.$zf=ue;function ge(Re){return Re>=127462&&Re<=127487||Re===8986||Re===8987||Re===9200||Re===9203||Re>=9728&&Re<=10175||Re===11088||Re===11093||Re>=127744&&Re<=128591||Re>=128640&&Re<=128764||Re>=128992&&Re<=129008||Re>=129280&&Re<=129535||Re>=129648&&Re<=129782}e.$Af=ge;function V(Re,ke,He=""){const ee=Re.trimStart();if(ee.length<ke)return ee;const se=/\b/g;let Se=0;for(;se.test(ee)&&!(ee.length-se.lastIndex<ke);)Se=se.lastIndex,se.lastIndex+=1;return Se===0?ee:He+ee.substring(Se).trimStart()}e.$Bf=V;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function be(Re){return Re&&(Re=Re.replace(X,"").replace(he,"")),Re}e.$Cf=be,e.$Df="\uFEFF";function Pe(Re){return!!(Re&&Re.length>0&&Re.charCodeAt(0)===65279)}e.$Ef=Pe;function pe(Re){return Pe(Re)?Re.substr(1):Re}e.$Ff=pe;function Ae(Re,ke){if(!Re||!ke||Re.length<ke.length)return!1;const He=ke.length,ee=Re.toLowerCase();let se=0,Se=-1;for(;se<He;){const Ve=ee.indexOf(ke[se],Se+1);if(Ve<0)return!1;Se=Ve,se++}return!0}e.$Gf=Ae;function Fe(Re,ke=!1){return Re?(ke&&(Re=Re.replace(/\\./g,"")),Re.toLowerCase()!==Re):!1}e.$Hf=Fe;function W(Re){return Re.charAt(0).toUpperCase()+Re.slice(1)}e.$If=W;function x(Re,ke=1){if(ke===0)return"";let He=-1;do He=Re.indexOf(`
`,He+1),ke--;while(ke>0&&He>=0);return He===-1?Re:(Re[He-1]==="\r"&&He--,Re.substr(0,He))}e.$Jf=x;function H(Re){return Re=Re%(2*26),Re<26?String.fromCharCode(97+Re):String.fromCharCode(65+Re-26)}e.$Kf=H;function Q(Re){return Le.getInstance().getGraphemeBreakType(Re)}e.$Lf=Q;function oe(Re,ke){return Re===0?ke!==5&&ke!==7:Re===2&&ke===3?!1:Re===4||Re===2||Re===3||ke===4||ke===2||ke===3?!0:!(Re===8&&(ke===8||ke===9||ke===11||ke===12)||(Re===11||Re===9)&&(ke===9||ke===10)||(Re===12||Re===10)&&ke===10||ke===5||ke===13||ke===7||Re===1||Re===13&&ke===14||Re===6&&ke===6)}var ve;(function(Re){Re[Re.Other=0]="Other",Re[Re.Prepend=1]="Prepend",Re[Re.CR=2]="CR",Re[Re.LF=3]="LF",Re[Re.Control=4]="Control",Re[Re.Extend=5]="Extend",Re[Re.Regional_Indicator=6]="Regional_Indicator",Re[Re.SpacingMark=7]="SpacingMark",Re[Re.L=8]="L",Re[Re.V=9]="V",Re[Re.T=10]="T",Re[Re.LV=11]="LV",Re[Re.LVT=12]="LVT",Re[Re.ZWJ=13]="ZWJ",Re[Re.Extended_Pictographic=14]="Extended_Pictographic"})(ve||(e.GraphemeBreakType=ve={}));class Le{static{this.c=null}static getInstance(){return Le.c||(Le.c=new Le),Le.c}constructor(){this.d=qe()}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const He=this.d,ee=He.length/3;let se=1;for(;se<=ee;)if(ke<He[3*se])se=2*se;else if(ke>He[3*se+1])se=2*se+1;else return He[3*se+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(Re,ke){if(Re===0)return 0;const He=Ye(Re,ke);if(He!==void 0)return He;const ee=new Z(ke,Re);return ee.prevCodePoint(),ee.offset}e.$Mf=Ge;function Ye(Re,ke){const He=new Z(ke,Re);let ee=He.prevCodePoint();for(;it(ee)||ee===65039||ee===8419;){if(He.offset===0)return;ee=He.prevCodePoint()}if(!ge(ee))return;let se=He.offset;return se>0&&He.prevCodePoint()===8205&&(se=He.offset),se}function it(Re){return 127995<=Re&&Re<=127999}var ut;(function(Re){Re[Re.zwj=8205]="zwj",Re[Re.emojiVariantSelector=65039]="emojiVariantSelector",Re[Re.enclosingKeyCap=8419]="enclosingKeyCap"})(ut||(ut={})),e.$Nf="\xA0";class ot{static{this.c=new O.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$Me(ke=>{function He(je){const Et=new Map;for(let St=0;St<je.length;St+=2)Et.set(je[St],je[St+1]);return Et}function ee(je,Et){const St=new Map(je);for(const[jt,Lt]of Et)St.set(jt,Lt);return St}function se(je,Et){if(!je)return Et;const St=new Map;for(const[jt,Lt]of je)Et.has(jt)&&St.set(jt,Lt);return St}const Se=this.c.value;let Ve=ke.filter(je=>!je.startsWith("_")&&je in Se);Ve.length===0&&(Ve=["_default"]);let Ze;for(const je of Ve){const Et=He(Se[je]);Ze=se(Ze,Et)}const nt=He(Se._common),rt=ee(nt,Ze);return new ot(rt)})}static getInstance(ke){return ot.d.get(Array.from(ke))}static{this.e=new O.$V(()=>Object.keys(ot.c.value).filter(ke=>!ke.startsWith("_")))}static getLocales(){return ot.e.value}constructor(ke){this.f=ke}isAmbiguous(ke){return this.f.has(ke)}getPrimaryConfusable(ke){return this.f.get(ke)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Of=ot;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(ke){return et.e().has(ke)}static get codePoints(){return et.e()}}e.$Pf=et}),define(Ce[123],Ie([1,0,28,162,12]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.FuzzyScore=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.or=void 0;function A(...pe){return function(Ae,Fe){for(let W=0,x=pe.length;W<x;W++){const H=pe[W](Ae,Fe);if(H)return H}return null}}e.or=A,e.$3j=R.bind(void 0,!1),e.$4j=R.bind(void 0,!0);function R(pe,Ae,Fe){if(!Fe||Fe.length<Ae.length)return null;let W;return pe?W=$.$if(Fe,Ae):W=Fe.indexOf(Ae)===0,W?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function v(pe,Ae){const Fe=Ae.toLowerCase().indexOf(pe.toLowerCase());return Fe===-1?null:[{start:Fe,end:Fe+pe.length}]}e.$5j=v;function p(pe,Ae){return S(pe.toLowerCase(),Ae.toLowerCase(),0,0)}e.$6j=p;function S(pe,Ae,Fe,W){if(Fe===pe.length)return[];if(W===Ae.length)return null;if(pe[Fe]===Ae[W]){let x=null;return(x=S(pe,Ae,Fe+1,W+1))?r({start:W,end:W+1},x):null}return S(pe,Ae,Fe,W+1)}function L(pe){return 97<=pe&&pe<=122}function C(pe){return 65<=pe&&pe<=90}e.$7j=C;function w(pe){return 48<=pe&&pe<=57}function E(pe){return pe===32||pe===9||pe===10||pe===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(pe=>k.add(pe.charCodeAt(0)));function u(pe){return E(pe)||k.has(pe)}function m(pe,Ae){return pe===Ae||u(pe)&&u(Ae)}const o=new Map;function i(pe){if(o.has(pe))return o.get(pe);let Ae;const Fe=(0,O.$1j)(pe);return Fe&&(Ae=Fe),o.set(pe,Ae),Ae}function n(pe){return L(pe)||C(pe)||w(pe)}function r(pe,Ae){return Ae.length===0?Ae=[pe]:pe.end===Ae[0].start?Ae[0].start=pe.start:Ae.unshift(pe),Ae}function a(pe,Ae){for(let Fe=Ae;Fe<pe.length;Fe++){const W=pe.charCodeAt(Fe);if(C(W)||w(W)||Fe>0&&!n(pe.charCodeAt(Fe-1)))return Fe}return pe.length}function t(pe,Ae,Fe,W){if(Fe===pe.length)return[];if(W===Ae.length)return null;if(pe[Fe]!==Ae[W].toLowerCase())return null;{let x=null,H=W+1;for(x=t(pe,Ae,Fe+1,W+1);!x&&(H=a(Ae,H))<Ae.length;)x=t(pe,Ae,Fe+1,H),H++;return x===null?null:r({start:W,end:W+1},x)}}function d(pe){let Ae=0,Fe=0,W=0,x=0,H=0;for(let qe=0;qe<pe.length;qe++)H=pe.charCodeAt(qe),C(H)&&Ae++,L(H)&&Fe++,n(H)&&W++,w(H)&&x++;const Q=Ae/pe.length,oe=Fe/pe.length,ve=W/pe.length,Le=x/pe.length;return{upperPercent:Q,lowerPercent:oe,alphaPercent:ve,numericPercent:Le}}function c(pe){const{upperPercent:Ae,lowerPercent:Fe}=pe;return Fe===0&&Ae>.6}function s(pe){const{upperPercent:Ae,lowerPercent:Fe,alphaPercent:W,numericPercent:x}=pe;return Fe>.2&&Ae<.8&&W>.6&&x<.2}function l(pe){let Ae=0,Fe=0,W=0,x=0;for(let H=0;H<pe.length;H++)W=pe.charCodeAt(H),C(W)&&Ae++,L(W)&&Fe++,E(W)&&x++;return(Ae===0||Fe===0)&&x===0?pe.length<=30:Ae<=5}function h(pe,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!l(pe))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Fe=d(Ae);if(!s(Fe)){if(!c(Fe))return null;Ae=Ae.toLowerCase()}let W=null,x=0;for(pe=pe.toLowerCase();x<Ae.length&&(W=t(pe,Ae,0,x))===null;)x=a(Ae,x+1);return W}e.$8j=h;function b(pe,Ae,Fe=!1){if(!Ae||Ae.length===0)return null;let W=null,x=0;for(pe=pe.toLowerCase(),Ae=Ae.toLowerCase();x<Ae.length&&(W=D(pe,Ae,0,x,Fe),W===null);)x=g(Ae,x+1);return W}e.$9j=b;function D(pe,Ae,Fe,W,x){let H=0;if(Fe===pe.length)return[];if(W===Ae.length)return null;if(!m(pe.charCodeAt(Fe),Ae.charCodeAt(W))){const ve=i(pe.charCodeAt(Fe));if(!ve)return null;for(let Le=0;Le<ve.length;Le++)if(!m(ve[Le],Ae.charCodeAt(W+Le)))return null;H+=ve.length-1}let Q=null,oe=W+H+1;if(Q=D(pe,Ae,Fe+1,oe,x),!x)for(;!Q&&(oe=g(Ae,oe))<Ae.length;)Q=D(pe,Ae,Fe+1,oe,x),oe++;if(!Q)return null;if(pe.charCodeAt(Fe)!==Ae.charCodeAt(W)){const ve=i(pe.charCodeAt(Fe));if(!ve)return Q;for(let Le=0;Le<ve.length;Le++)if(ve[Le]!==Ae.charCodeAt(W+Le))return Q}return r({start:W,end:W+H+1},Q)}function g(pe,Ae){for(let Fe=Ae;Fe<pe.length;Fe++)if(u(pe.charCodeAt(Fe))||Fe>0&&u(pe.charCodeAt(Fe-1)))return Fe;return pe.length}const f=A(e.$4j,h,v),y=A(e.$4j,h,p),P=new I.$Dc(1e4);function N(pe,Ae,Fe=!1){if(typeof pe!="string"||typeof Ae!="string")return null;let W=P.get(pe);W||(W=new RegExp($.$3e(pe),"i"),P.set(pe,W));const x=W.exec(Ae);return x?[{start:x.index,end:x.index+x[0].length}]:Fe?y(pe,Ae):f(pe,Ae)}e.$0j=N;function U(pe,Ae){const Fe=ue(pe,pe.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Fe?F(Fe):null}e.$$j=U;function z(pe,Ae,Fe,W,x,H){const Q=Math.min(13,pe.length);for(;Fe<Q;Fe++){const oe=ue(pe,Ae,Fe,W,x,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,H]}e.$_j=z;function F(pe){if(typeof pe>"u")return[];const Ae=[],Fe=pe[1];for(let W=pe.length-1;W>1;W--){const x=pe[W]+Fe,H=Ae[Ae.length-1];H&&H.end===x?H.end=x+1:Ae.push({start:x,end:x+1})}return Ae}e.$ak=F;const M=128;function T(){const pe=[],Ae=[];for(let Fe=0;Fe<=M;Fe++)Ae[Fe]=0;for(let Fe=0;Fe<=M;Fe++)pe.push(Ae.slice(0));return pe}function j(pe){const Ae=[];for(let Fe=0;Fe<=pe;Fe++)Ae[Fe]=0;return Ae}const J=j(2*M),ne=j(2*M),_=T(),Z=T(),Y=T(),ce=!1;function ie(pe,Ae,Fe,W,x){function H(oe,ve,Le=" "){for(;oe.length<ve;)oe=Le+oe;return oe}let Q=` |   |${W.split("").map(oe=>H(oe,3)).join("|")}
`;for(let oe=0;oe<=Fe;oe++)oe===0?Q+=" |":Q+=`${Ae[oe-1]}|`,Q+=pe[oe].slice(0,x+1).map(ve=>H(ve.toString(),3)).join("|")+`
`;return Q}function fe(pe,Ae,Fe,W){pe=pe.substr(Ae),Fe=Fe.substr(W),console.log(ie(Z,pe,pe.length,Fe,Fe.length)),console.log(ie(Y,pe,pe.length,Fe,Fe.length)),console.log(ie(_,pe,pe.length,Fe,Fe.length))}function re(pe,Ae){if(Ae<0||Ae>=pe.length)return!1;const Fe=pe.codePointAt(Ae);switch(Fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!$.$Af(Fe)}}function K(pe,Ae){if(Ae<0||Ae>=pe.length)return!1;switch(pe.charCodeAt(Ae)){case 32:case 9:return!0;default:return!1}}function B(pe,Ae,Fe){return Ae[pe]!==Fe[pe]}function ae(pe,Ae,Fe,W,x,H,Q=!1){for(;Ae<Fe&&x<H;)pe[Ae]===W[x]&&(Q&&(J[Ae]=x),Ae+=1),x+=1;return Ae===Fe}e.$bk=ae;var ye;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var le;(function(pe){pe.Default=[-100,0];function Ae(Fe){return!Fe||Fe.length===2&&Fe[0]===-100&&Fe[1]===0}pe.isDefault=Ae})(le||(e.FuzzyScore=le={}));class de{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Fe){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Fe}}e.$ck=de;function ue(pe,Ae,Fe,W,x,H,Q=de.default){const oe=pe.length>M?M:pe.length,ve=W.length>M?M:W.length;if(Fe>=oe||H>=ve||oe-Fe>ve-H||!ae(Ae,Fe,oe,x,H,ve,!0))return;ge(oe,ve,Fe,H,Ae,x);let Le=1,qe=1,Ge=Fe,Ye=H;const it=[!1];for(Le=1,Ge=Fe;Ge<oe;Le++,Ge++){const ke=J[Ge],He=ne[Ge],ee=Ge+1<oe?ne[Ge+1]:ve;for(qe=ke-H+1,Ye=ke;Ye<ee;qe++,Ye++){let se=Number.MIN_SAFE_INTEGER,Se=!1;Ye<=He&&(se=V(pe,Ae,Ge,Fe,W,x,Ye,ve,H,_[Le-1][qe-1]===0,it));let Ve=0;se!==Number.MAX_SAFE_INTEGER&&(Se=!0,Ve=se+Z[Le-1][qe-1]);const Ze=Ye>ke,nt=Ze?Z[Le][qe-1]+(_[Le][qe-1]>0?-5:0):0,rt=Ye>ke+1&&_[Le][qe-1]>0,je=rt?Z[Le][qe-2]+(_[Le][qe-2]>0?-5:0):0;if(rt&&(!Ze||je>=nt)&&(!Se||je>=Ve))Z[Le][qe]=je,Y[Le][qe]=3,_[Le][qe]=0;else if(Ze&&(!Se||nt>=Ve))Z[Le][qe]=nt,Y[Le][qe]=2,_[Le][qe]=0;else if(Se)Z[Le][qe]=Ve,Y[Le][qe]=1,_[Le][qe]=_[Le-1][qe-1]+1;else throw new Error("not possible")}}if(ce&&fe(pe,Fe,W,H),!it[0]&&!Q.firstMatchCanBeWeak)return;Le--,qe--;const ut=[Z[Le][qe],H];let ot=0,et=0;for(;Le>=1;){let ke=qe;do{const He=Y[Le][ke];if(He===3)ke=ke-2;else if(He===2)ke=ke-1;else break}while(ke>=1);ot>1&&Ae[Fe+Le-1]===x[H+qe-1]&&!B(ke+H-1,W,x)&&ot+1>_[Le][ke]&&(ke=qe),ke===qe?ot++:ot=1,et||(et=ke),Le--,qe=ke-1,ut.push(qe)}ve===oe&&Q.boostFullMatch&&(ut[0]+=2);const Re=et-oe;return ut[0]-=Re,ut}e.$dk=ue;function ge(pe,Ae,Fe,W,x,H){let Q=pe-1,oe=Ae-1;for(;Q>=Fe&&oe>=W;)x[Q]===H[oe]&&(ne[Q]=oe,Q--),oe--}function V(pe,Ae,Fe,W,x,H,Q,oe,ve,Le,qe){if(Ae[Fe]!==H[Q])return Number.MIN_SAFE_INTEGER;let Ge=1,Ye=!1;return Q===Fe-W?Ge=pe[Fe]===x[Q]?7:5:B(Q,x,H)&&(Q===0||!B(Q-1,x,H))?(Ge=pe[Fe]===x[Q]?7:5,Ye=!0):re(H,Q)&&(Q===0||!re(H,Q-1))?Ge=5:(re(H,Q-1)||K(H,Q-1))&&(Ge=5,Ye=!0),Ge>1&&Fe===W&&(qe[0]=!0),Ye||(Ye=B(Q,x,H)||re(H,Q-1)||K(H,Q-1)),Fe===W?Q>ve&&(Ge-=Ye?3:5):Le?Ge+=Ye?2:0:Ge+=Ye?0:1,Q+1===oe&&(Ge-=Ye?3:5),Ge}function X(pe,Ae,Fe,W,x,H,Q){return be(pe,Ae,Fe,W,x,H,!0,Q)}e.$ek=X;function he(pe,Ae,Fe,W,x,H,Q){return be(pe,Ae,Fe,W,x,H,!1,Q)}e.$fk=he;function be(pe,Ae,Fe,W,x,H,Q,oe){let ve=ue(pe,Ae,Fe,W,x,H,oe);if(ve&&!Q)return ve;if(pe.length>=3){const Le=Math.min(7,pe.length-1);for(let qe=Fe+1;qe<Le;qe++){const Ge=Pe(pe,qe);if(Ge){const Ye=ue(Ge,Ge.toLowerCase(),Fe,W,x,H,oe);Ye&&(Ye[0]-=3,(!ve||Ye[0]>ve[0])&&(ve=Ye))}}}return ve}function Pe(pe,Ae){if(Ae+1>=pe.length)return;const Fe=pe[Ae],W=pe[Ae+1];if(Fe!==W)return pe.slice(0,Ae)+W+Fe+pe.slice(Ae+2)}}),define(Ce[54],Ie([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=void 0;function O(o){return $(o,0)}e.$3i=O;function $(o,i){switch(typeof o){case"object":return o===null?A(349,i):Array.isArray(o)?p(o,i):S(o,i);case"string":return v(o,i);case"boolean":return R(o,i);case"number":return A(o,i);case"undefined":return A(937,i);default:return A(617,i)}}e.$4i=$;function A(o,i){return(i<<5)-i+o|0}e.$5i=A;function R(o,i){return A(o?433:863,i)}function v(o,i){i=A(149417,i);for(let n=0,r=o.length;n<r;n++)i=A(o.charCodeAt(n),i);return i}e.$6i=v;function p(o,i){return i=A(104579,i),o.reduce((n,r)=>$(r,n),i)}function S(o,i){return i=A(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=v(r,n),$(o[r],n)),i)}class L{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=$(i,this.g),this.g}}e.$7i=L;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function w(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function E(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function k(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function u(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):k((o>>>0).toString(16),i/4)}e.$8i=u;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,d,c;for(t!==0?(d=t,c=-1,t=0):(d=i.charCodeAt(0),c=0);;){let s=d;if(I.$lf(d))if(c+1<n){const l=i.charCodeAt(c+1);I.$mf(l)?(c++,s=I.$nf(d,l)):s=65533}else{t=d;break}else I.$mf(d)&&(s=65533);if(a=this.w(r,a,s),c++,c<n)d=i.charCodeAt(c);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let b=0;b<64;b+=4)i.setUint32(b,n.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)i.setUint32(b,w(i.getUint32(b-12,!1)^i.getUint32(b-32,!1)^i.getUint32(b-56,!1)^i.getUint32(b-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,d=this.n,c=this.o,s,l,h;for(let b=0;b<80;b++)b<20?(s=a&t|~a&d,l=1518500249):b<40?(s=a^t^d,l=1859775393):b<60?(s=a&t|a&d|t&d,l=2400959708):(s=a^t^d,l=3395469782),h=w(r,5)+s+c+l+i.getUint32(b*4,!1)&4294967295,c=d,d=t,t=w(a,30),a=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+d&4294967295,this.o=this.o+c&4294967295}}e.$9i=m}),define(Ce[39],Ie([1,0,12]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function($){$[$.Ignore=0]="Ignore",$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(O||(O={})),function($){const A="error",R="warning",v="warn",p="info",S="ignore";function L(w){return w?I.$hf(A,w)?$.Error:I.$hf(R,w)||I.$hf(v,w)?$.Warning:I.$hf(p,w)?$.Info:$.Ignore:$.Ignore}$.fromValue=L;function C(w){switch(w){case $.Error:return A;case $.Warning:return R;case $.Info:return p;default:return S}}$.toString=C}(O||(O={})),e.default=O}),define(Ce[164],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=void 0,e.$Zd=Symbol("MicrotaskDelay")}),define(Ce[78],Ie([1,0,19,12]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class ${constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const k=E.charCodeAt(0),u=this.b.charCodeAt(this.c);return k-u}value(){return this.b[this.c]}}e.$ei=$;class A{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,O.$bf)(E,this.b,0,E.length,this.c,this.d):(0,O.$df)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$fi=A;class R{constructor(E=!0,k=!0){this.f=E,this.g=k}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let k=E.length-1;k>=0;k--,this.c--){const u=this.b.charCodeAt(k);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const k=this.b.charCodeAt(this.e);if(k===47||this.f&&k===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,O.$bf)(E,this.b,0,E.length,this.d,this.e):(0,O.$df)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$gi=R;var v;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(v||(v={}));class p{constructor(E,k){this.f=E,this.g=k,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,O.$cf)(E,this.c.scheme);if(this.d[this.e]===2)return(0,O.$cf)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,O.$af)(E,this.c.query);if(this.d[this.e]===5)return(0,O.$af)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$hi=p;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var L;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(L||(L={}));class C{static forUris(E=()=>!1,k=()=>!1){return new C(new p(E,k))}static forPaths(E=!1){return new C(new R(void 0,!E))}static forStrings(){return new C(new $)}static forConfigKeys(){return new C(new A)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,k){if(k){const u=k.slice(0);(0,I.$Xb)(u);for(const m of u)this.set(m,E)}else{const u=E.slice(0);(0,I.$Xb)(u);for(const m of u)this.set(m[0],m[1])}}set(E,k){const u=this.b.reset(E);let m;this.c||(this.c=new S,this.c.segment=u.value());const o=[];for(m=this.c;;){const n=u.cmp(m.segment);if(n>0)m.left||(m.left=new S,m.left.segment=u.value()),o.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new S,m.right.segment=u.value()),o.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new S,m.mid.segment=u.value()),o.push([0,m]),m=m.mid;else break}const i=m.value;m.value=k,m.key=E;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],d=o[n+1][0];if(t===1&&d===1)o[n][1]=r.rotateLeft();else if(t===-1&&d===-1)o[n][1]=r.rotateRight();else if(t===1&&d===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&d===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const k=this.b.reset(E);let u=this.c;for(;u;){const m=k.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(k.hasNext())k.next(),u=u.mid;else break}return u}has(E){const k=this.d(E);return!(k?.value===void 0&&k?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,k){const u=this.b.reset(E),m=[];let o=this.c;for(;o;){const i=u.cmp(o.segment);if(i>0)m.push([-1,o]),o=o.left;else if(i<0)m.push([1,o]),o=o.right;else if(u.hasNext())u.next(),m.push([0,o]),o=o.mid;else break}if(o){if(k?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(m.length>0){const[n,r]=m[m.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const k=this.b.reset(E);let u=this.c,m;for(;u;){const o=k.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(k.hasNext())k.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(E){return this.g(E,!1)}g(E,k){const u=this.b.reset(E);let m=this.c;for(;m;){const o=u.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(u.hasNext())u.next(),m=m.mid;else return m.mid?this.h(m.mid):k?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[k,u]of this)E(u,k)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const k=[];return this.j(E,k),k[Symbol.iterator]()}j(E,k){E&&(E.left&&this.j(E.left,k),E.value&&k.push([E.key,E.value]),E.mid&&this.j(E.mid,k),E.right&&this.j(E.right,k))}_isBalanced(){const E=k=>{if(!k)return!0;const u=k.balanceFactor();return u<-1||u>1?!1:E(k.left)&&E(k.right)};return E(this.c)}}e.$ii=C}),define(Ce[18],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=void 0;function I(a){return typeof a=="string"}e.$Qf=I;function O(a){return Array.isArray(a)&&a.every(t=>I(t))}e.$Rf=O;function $(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Sf=$;function A(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Tf=A;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Uf=R;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Vf=v;function p(a){return a===!0||a===!1}e.$Wf=p;function S(a){return typeof a>"u"}e.$Xf=S;function L(a){return!C(a)}e.$Yf=L;function C(a){return S(a)||a===null}e.$Zf=C;function w(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$1f=w;function E(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$2f=E;function k(...a){const t=[];for(let d=0;d<a.length;d++){const c=a[d];if(C(c))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);t.push(c)}return t}e.$3f=k;const u=Object.prototype.hasOwnProperty;function m(a){if(!$(a))return!1;for(const t in a)if(u.call(a,t))return!1;return!0}e.$4f=m;function o(a){return typeof a=="function"}e.$5f=o;function i(...a){return a.length>0&&a.every(o)}e.$6f=i;function n(a,t){const d=Math.min(a.length,t.length);for(let c=0;c<d;c++)r(a[c],t[c])}e.$7f=n;function r(a,t){if(I(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$8f=r}),define(Ce[79],Ie([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=void 0;const O=Object.create(null);function $(v,p){if((0,I.$Qf)(p)){const S=O[p];if(S===void 0)throw new Error(`${v} references an unknown codicon: ${p}`);p=S}return O[v]=p,{id:v}}function A(){return O}e.$gk=A;function R(){return Object.values(e.$ik)}e.$hk=R,e.$ik={add:$("add",6e4),plus:$("plus",6e4),gistNew:$("gist-new",6e4),repoCreate:$("repo-create",6e4),lightbulb:$("lightbulb",60001),lightBulb:$("light-bulb",60001),repo:$("repo",60002),repoDelete:$("repo-delete",60002),gistFork:$("gist-fork",60003),repoForked:$("repo-forked",60003),gitPullRequest:$("git-pull-request",60004),gitPullRequestAbandoned:$("git-pull-request-abandoned",60004),recordKeys:$("record-keys",60005),keyboard:$("keyboard",60005),tag:$("tag",60006),tagAdd:$("tag-add",60006),tagRemove:$("tag-remove",60006),gitPullRequestLabel:$("git-pull-request-label",60006),person:$("person",60007),personFollow:$("person-follow",60007),personOutline:$("person-outline",60007),personFilled:$("person-filled",60007),gitBranch:$("git-branch",60008),gitBranchCreate:$("git-branch-create",60008),gitBranchDelete:$("git-branch-delete",60008),sourceControl:$("source-control",60008),mirror:$("mirror",60009),mirrorPublic:$("mirror-public",60009),star:$("star",60010),starAdd:$("star-add",60010),starDelete:$("star-delete",60010),starEmpty:$("star-empty",60010),comment:$("comment",60011),commentAdd:$("comment-add",60011),alert:$("alert",60012),warning:$("warning",60012),search:$("search",60013),searchSave:$("search-save",60013),logOut:$("log-out",60014),signOut:$("sign-out",60014),logIn:$("log-in",60015),signIn:$("sign-in",60015),eye:$("eye",60016),eyeUnwatch:$("eye-unwatch",60016),eyeWatch:$("eye-watch",60016),circleFilled:$("circle-filled",60017),primitiveDot:$("primitive-dot",60017),closeDirty:$("close-dirty",60017),debugBreakpoint:$("debug-breakpoint",60017),debugBreakpointDisabled:$("debug-breakpoint-disabled",60017),debugBreakpointPending:$("debug-breakpoint-pending",60377),debugHint:$("debug-hint",60017),primitiveSquare:$("primitive-square",60018),edit:$("edit",60019),pencil:$("pencil",60019),info:$("info",60020),issueOpened:$("issue-opened",60020),gistPrivate:$("gist-private",60021),gitForkPrivate:$("git-fork-private",60021),lock:$("lock",60021),mirrorPrivate:$("mirror-private",60021),close:$("close",60022),removeClose:$("remove-close",60022),x:$("x",60022),repoSync:$("repo-sync",60023),sync:$("sync",60023),clone:$("clone",60024),desktopDownload:$("desktop-download",60024),beaker:$("beaker",60025),microscope:$("microscope",60025),vm:$("vm",60026),deviceDesktop:$("device-desktop",60026),file:$("file",60027),fileText:$("file-text",60027),more:$("more",60028),ellipsis:$("ellipsis",60028),kebabHorizontal:$("kebab-horizontal",60028),mailReply:$("mail-reply",60029),reply:$("reply",60029),organization:$("organization",60030),organizationFilled:$("organization-filled",60030),organizationOutline:$("organization-outline",60030),newFile:$("new-file",60031),fileAdd:$("file-add",60031),newFolder:$("new-folder",60032),fileDirectoryCreate:$("file-directory-create",60032),trash:$("trash",60033),trashcan:$("trashcan",60033),history:$("history",60034),clock:$("clock",60034),folder:$("folder",60035),fileDirectory:$("file-directory",60035),symbolFolder:$("symbol-folder",60035),logoGithub:$("logo-github",60036),markGithub:$("mark-github",60036),github:$("github",60036),terminal:$("terminal",60037),console:$("console",60037),repl:$("repl",60037),zap:$("zap",60038),symbolEvent:$("symbol-event",60038),error:$("error",60039),stop:$("stop",60039),variable:$("variable",60040),symbolVariable:$("symbol-variable",60040),array:$("array",60042),symbolArray:$("symbol-array",60042),symbolModule:$("symbol-module",60043),symbolPackage:$("symbol-package",60043),symbolNamespace:$("symbol-namespace",60043),symbolObject:$("symbol-object",60043),symbolMethod:$("symbol-method",60044),symbolFunction:$("symbol-function",60044),symbolConstructor:$("symbol-constructor",60044),symbolBoolean:$("symbol-boolean",60047),symbolNull:$("symbol-null",60047),symbolNumeric:$("symbol-numeric",60048),symbolNumber:$("symbol-number",60048),symbolStructure:$("symbol-structure",60049),symbolStruct:$("symbol-struct",60049),symbolParameter:$("symbol-parameter",60050),symbolTypeParameter:$("symbol-type-parameter",60050),symbolKey:$("symbol-key",60051),symbolText:$("symbol-text",60051),symbolReference:$("symbol-reference",60052),goToFile:$("go-to-file",60052),symbolEnum:$("symbol-enum",60053),symbolValue:$("symbol-value",60053),symbolRuler:$("symbol-ruler",60054),symbolUnit:$("symbol-unit",60054),activateBreakpoints:$("activate-breakpoints",60055),archive:$("archive",60056),arrowBoth:$("arrow-both",60057),arrowDown:$("arrow-down",60058),arrowLeft:$("arrow-left",60059),arrowRight:$("arrow-right",60060),arrowSmallDown:$("arrow-small-down",60061),arrowSmallLeft:$("arrow-small-left",60062),arrowSmallRight:$("arrow-small-right",60063),arrowSmallUp:$("arrow-small-up",60064),arrowUp:$("arrow-up",60065),bell:$("bell",60066),bold:$("bold",60067),book:$("book",60068),bookmark:$("bookmark",60069),debugBreakpointConditionalUnverified:$("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:$("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:$("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:$("debug-breakpoint-data-unverified",60072),debugBreakpointData:$("debug-breakpoint-data",60073),debugBreakpointDataDisabled:$("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:$("debug-breakpoint-log-unverified",60074),debugBreakpointLog:$("debug-breakpoint-log",60075),debugBreakpointLogDisabled:$("debug-breakpoint-log-disabled",60075),briefcase:$("briefcase",60076),broadcast:$("broadcast",60077),browser:$("browser",60078),bug:$("bug",60079),calendar:$("calendar",60080),caseSensitive:$("case-sensitive",60081),check:$("check",60082),checklist:$("checklist",60083),chevronDown:$("chevron-down",60084),dropDownButton:$("drop-down-button",60084),chevronLeft:$("chevron-left",60085),chevronRight:$("chevron-right",60086),chevronUp:$("chevron-up",60087),chromeClose:$("chrome-close",60088),chromeMaximize:$("chrome-maximize",60089),chromeMinimize:$("chrome-minimize",60090),chromeRestore:$("chrome-restore",60091),circle:$("circle",60092),circleOutline:$("circle-outline",60092),debugBreakpointUnverified:$("debug-breakpoint-unverified",60092),circleSlash:$("circle-slash",60093),circuitBoard:$("circuit-board",60094),clearAll:$("clear-all",60095),clippy:$("clippy",60096),closeAll:$("close-all",60097),cloudDownload:$("cloud-download",60098),cloudUpload:$("cloud-upload",60099),code:$("code",60100),collapseAll:$("collapse-all",60101),colorMode:$("color-mode",60102),commentDiscussion:$("comment-discussion",60103),compareChanges:$("compare-changes",60157),creditCard:$("credit-card",60105),dash:$("dash",60108),dashboard:$("dashboard",60109),database:$("database",60110),debugContinue:$("debug-continue",60111),debugDisconnect:$("debug-disconnect",60112),debugPause:$("debug-pause",60113),debugRestart:$("debug-restart",60114),debugStart:$("debug-start",60115),debugStepInto:$("debug-step-into",60116),debugStepOut:$("debug-step-out",60117),debugStepOver:$("debug-step-over",60118),debugStop:$("debug-stop",60119),debug:$("debug",60120),deviceCameraVideo:$("device-camera-video",60121),deviceCamera:$("device-camera",60122),deviceMobile:$("device-mobile",60123),diffAdded:$("diff-added",60124),diffIgnored:$("diff-ignored",60125),diffModified:$("diff-modified",60126),diffRemoved:$("diff-removed",60127),diffRenamed:$("diff-renamed",60128),diff:$("diff",60129),discard:$("discard",60130),editorLayout:$("editor-layout",60131),emptyWindow:$("empty-window",60132),exclude:$("exclude",60133),extensions:$("extensions",60134),eyeClosed:$("eye-closed",60135),fileBinary:$("file-binary",60136),fileCode:$("file-code",60137),fileMedia:$("file-media",60138),filePdf:$("file-pdf",60139),fileSubmodule:$("file-submodule",60140),fileSymlinkDirectory:$("file-symlink-directory",60141),fileSymlinkFile:$("file-symlink-file",60142),fileZip:$("file-zip",60143),files:$("files",60144),filter:$("filter",60145),flame:$("flame",60146),foldDown:$("fold-down",60147),foldUp:$("fold-up",60148),fold:$("fold",60149),folderActive:$("folder-active",60150),folderOpened:$("folder-opened",60151),gear:$("gear",60152),gift:$("gift",60153),gistSecret:$("gist-secret",60154),gist:$("gist",60155),gitCommit:$("git-commit",60156),gitCompare:$("git-compare",60157),gitMerge:$("git-merge",60158),githubAction:$("github-action",60159),githubAlt:$("github-alt",60160),globe:$("globe",60161),grabber:$("grabber",60162),graph:$("graph",60163),gripper:$("gripper",60164),heart:$("heart",60165),home:$("home",60166),horizontalRule:$("horizontal-rule",60167),hubot:$("hubot",60168),inbox:$("inbox",60169),issueClosed:$("issue-closed",60324),issueReopened:$("issue-reopened",60171),issues:$("issues",60172),italic:$("italic",60173),jersey:$("jersey",60174),json:$("json",60175),bracket:$("bracket",60175),kebabVertical:$("kebab-vertical",60176),key:$("key",60177),law:$("law",60178),lightbulbAutofix:$("lightbulb-autofix",60179),linkExternal:$("link-external",60180),link:$("link",60181),listOrdered:$("list-ordered",60182),listUnordered:$("list-unordered",60183),liveShare:$("live-share",60184),loading:$("loading",60185),location:$("location",60186),mailRead:$("mail-read",60187),mail:$("mail",60188),markdown:$("markdown",60189),megaphone:$("megaphone",60190),mention:$("mention",60191),milestone:$("milestone",60192),gitPullRequestMilestone:$("git-pull-request-milestone",60192),mortarBoard:$("mortar-board",60193),move:$("move",60194),multipleWindows:$("multiple-windows",60195),mute:$("mute",60196),noNewline:$("no-newline",60197),note:$("note",60198),octoface:$("octoface",60199),openPreview:$("open-preview",60200),package:$("package",60201),paintcan:$("paintcan",60202),pin:$("pin",60203),play:$("play",60204),run:$("run",60204),plug:$("plug",60205),preserveCase:$("preserve-case",60206),preview:$("preview",60207),project:$("project",60208),pulse:$("pulse",60209),question:$("question",60210),quote:$("quote",60211),radioTower:$("radio-tower",60212),reactions:$("reactions",60213),references:$("references",60214),refresh:$("refresh",60215),regex:$("regex",60216),remoteExplorer:$("remote-explorer",60217),remote:$("remote",60218),remove:$("remove",60219),replaceAll:$("replace-all",60220),replace:$("replace",60221),repoClone:$("repo-clone",60222),repoForcePush:$("repo-force-push",60223),repoPull:$("repo-pull",60224),repoPush:$("repo-push",60225),report:$("report",60226),requestChanges:$("request-changes",60227),rocket:$("rocket",60228),rootFolderOpened:$("root-folder-opened",60229),rootFolder:$("root-folder",60230),rss:$("rss",60231),ruby:$("ruby",60232),saveAll:$("save-all",60233),saveAs:$("save-as",60234),save:$("save",60235),screenFull:$("screen-full",60236),screenNormal:$("screen-normal",60237),searchStop:$("search-stop",60238),server:$("server",60240),settingsGear:$("settings-gear",60241),settings:$("settings",60242),shield:$("shield",60243),smiley:$("smiley",60244),sortPrecedence:$("sort-precedence",60245),splitHorizontal:$("split-horizontal",60246),splitVertical:$("split-vertical",60247),squirrel:$("squirrel",60248),starFull:$("star-full",60249),starHalf:$("star-half",60250),symbolClass:$("symbol-class",60251),symbolColor:$("symbol-color",60252),symbolCustomColor:$("symbol-customcolor",60252),symbolConstant:$("symbol-constant",60253),symbolEnumMember:$("symbol-enum-member",60254),symbolField:$("symbol-field",60255),symbolFile:$("symbol-file",60256),symbolInterface:$("symbol-interface",60257),symbolKeyword:$("symbol-keyword",60258),symbolMisc:$("symbol-misc",60259),symbolOperator:$("symbol-operator",60260),symbolProperty:$("symbol-property",60261),wrench:$("wrench",60261),wrenchSubaction:$("wrench-subaction",60261),symbolSnippet:$("symbol-snippet",60262),tasklist:$("tasklist",60263),telescope:$("telescope",60264),textSize:$("text-size",60265),threeBars:$("three-bars",60266),thumbsdown:$("thumbsdown",60267),thumbsup:$("thumbsup",60268),tools:$("tools",60269),triangleDown:$("triangle-down",60270),triangleLeft:$("triangle-left",60271),triangleRight:$("triangle-right",60272),triangleUp:$("triangle-up",60273),twitter:$("twitter",60274),unfold:$("unfold",60275),unlock:$("unlock",60276),unmute:$("unmute",60277),unverified:$("unverified",60278),verified:$("verified",60279),versions:$("versions",60280),vmActive:$("vm-active",60281),vmOutline:$("vm-outline",60282),vmRunning:$("vm-running",60283),watch:$("watch",60284),whitespace:$("whitespace",60285),wholeWord:$("whole-word",60286),window:$("window",60287),wordWrap:$("word-wrap",60288),zoomIn:$("zoom-in",60289),zoomOut:$("zoom-out",60290),listFilter:$("list-filter",60291),listFlat:$("list-flat",60292),listSelection:$("list-selection",60293),selection:$("selection",60293),listTree:$("list-tree",60294),debugBreakpointFunctionUnverified:$("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:$("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:$("debug-breakpoint-function-disabled",60296),debugStackframeActive:$("debug-stackframe-active",60297),circleSmallFilled:$("circle-small-filled",60298),debugStackframeDot:$("debug-stackframe-dot",60298),debugStackframe:$("debug-stackframe",60299),debugStackframeFocused:$("debug-stackframe-focused",60299),debugBreakpointUnsupported:$("debug-breakpoint-unsupported",60300),symbolString:$("symbol-string",60301),debugReverseContinue:$("debug-reverse-continue",60302),debugStepBack:$("debug-step-back",60303),debugRestartFrame:$("debug-restart-frame",60304),callIncoming:$("call-incoming",60306),callOutgoing:$("call-outgoing",60307),menu:$("menu",60308),expandAll:$("expand-all",60309),feedback:$("feedback",60310),gitPullRequestReviewer:$("git-pull-request-reviewer",60310),groupByRefType:$("group-by-ref-type",60311),ungroupByRefType:$("ungroup-by-ref-type",60312),account:$("account",60313),gitPullRequestAssignee:$("git-pull-request-assignee",60313),bellDot:$("bell-dot",60314),debugConsole:$("debug-console",60315),library:$("library",60316),output:$("output",60317),runAll:$("run-all",60318),syncIgnored:$("sync-ignored",60319),pinned:$("pinned",60320),githubInverted:$("github-inverted",60321),debugAlt:$("debug-alt",60305),serverProcess:$("server-process",60322),serverEnvironment:$("server-environment",60323),pass:$("pass",60324),stopCircle:$("stop-circle",60325),playCircle:$("play-circle",60326),record:$("record",60327),debugAltSmall:$("debug-alt-small",60328),vmConnect:$("vm-connect",60329),cloud:$("cloud",60330),merge:$("merge",60331),exportIcon:$("export",60332),graphLeft:$("graph-left",60333),magnet:$("magnet",60334),notebook:$("notebook",60335),redo:$("redo",60336),checkAll:$("check-all",60337),pinnedDirty:$("pinned-dirty",60338),passFilled:$("pass-filled",60339),circleLargeFilled:$("circle-large-filled",60340),circleLarge:$("circle-large",60341),circleLargeOutline:$("circle-large-outline",60341),combine:$("combine",60342),gather:$("gather",60342),table:$("table",60343),variableGroup:$("variable-group",60344),typeHierarchy:$("type-hierarchy",60345),typeHierarchySub:$("type-hierarchy-sub",60346),typeHierarchySuper:$("type-hierarchy-super",60347),gitPullRequestCreate:$("git-pull-request-create",60348),runAbove:$("run-above",60349),runBelow:$("run-below",60350),notebookTemplate:$("notebook-template",60351),debugRerun:$("debug-rerun",60352),workspaceTrusted:$("workspace-trusted",60353),workspaceUntrusted:$("workspace-untrusted",60354),workspaceUnspecified:$("workspace-unspecified",60355),terminalCmd:$("terminal-cmd",60356),terminalDebian:$("terminal-debian",60357),terminalLinux:$("terminal-linux",60358),terminalPowershell:$("terminal-powershell",60359),terminalTmux:$("terminal-tmux",60360),terminalUbuntu:$("terminal-ubuntu",60361),terminalBash:$("terminal-bash",60362),arrowSwap:$("arrow-swap",60363),copy:$("copy",60364),personAdd:$("person-add",60365),filterFilled:$("filter-filled",60366),wand:$("wand",60367),debugLineByLine:$("debug-line-by-line",60368),inspect:$("inspect",60369),layers:$("layers",60370),layersDot:$("layers-dot",60371),layersActive:$("layers-active",60372),compass:$("compass",60373),compassDot:$("compass-dot",60374),compassActive:$("compass-active",60375),azure:$("azure",60376),issueDraft:$("issue-draft",60377),gitPullRequestClosed:$("git-pull-request-closed",60378),gitPullRequestDraft:$("git-pull-request-draft",60379),debugAll:$("debug-all",60380),debugCoverage:$("debug-coverage",60381),runErrors:$("run-errors",60382),folderLibrary:$("folder-library",60383),debugContinueSmall:$("debug-continue-small",60384),beakerStop:$("beaker-stop",60385),graphLine:$("graph-line",60386),graphScatter:$("graph-scatter",60387),pieChart:$("pie-chart",60388),bracketDot:$("bracket-dot",60389),bracketError:$("bracket-error",60390),lockSmall:$("lock-small",60391),azureDevops:$("azure-devops",60392),verifiedFilled:$("verified-filled",60393),newLine:$("newline",60394),layout:$("layout",60395),layoutActivitybarLeft:$("layout-activitybar-left",60396),layoutActivitybarRight:$("layout-activitybar-right",60397),layoutPanelLeft:$("layout-panel-left",60398),layoutPanelCenter:$("layout-panel-center",60399),layoutPanelJustify:$("layout-panel-justify",60400),layoutPanelRight:$("layout-panel-right",60401),layoutPanel:$("layout-panel",60402),layoutSidebarLeft:$("layout-sidebar-left",60403),layoutSidebarRight:$("layout-sidebar-right",60404),layoutStatusbar:$("layout-statusbar",60405),layoutMenubar:$("layout-menubar",60406),layoutCentered:$("layout-centered",60407),layoutSidebarRightOff:$("layout-sidebar-right-off",60416),layoutPanelOff:$("layout-panel-off",60417),layoutSidebarLeftOff:$("layout-sidebar-left-off",60418),target:$("target",60408),indent:$("indent",60409),recordSmall:$("record-small",60410),errorSmall:$("error-small",60411),arrowCircleDown:$("arrow-circle-down",60412),arrowCircleLeft:$("arrow-circle-left",60413),arrowCircleRight:$("arrow-circle-right",60414),arrowCircleUp:$("arrow-circle-up",60415),heartFilled:$("heart-filled",60420),map:$("map",60421),mapFilled:$("map-filled",60422),circleSmall:$("circle-small",60423),bellSlash:$("bell-slash",60424),bellSlashDot:$("bell-slash-dot",60425),commentUnresolved:$("comment-unresolved",60426),gitPullRequestGoToChanges:$("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:$("git-pull-request-new-changes",60428),searchFuzzy:$("search-fuzzy",60429),commentDraft:$("comment-draft",60430),send:$("send",60431),sparkle:$("sparkle",60432),insert:$("insert",60433),mic:$("mic",60434),thumbsDownFilled:$("thumbsdown-filled",60435),thumbsUpFilled:$("thumbsup-filled",60436),coffee:$("coffee",60437),snake:$("snake",60438),game:$("game",60439),vr:$("vr",60440),chip:$("chip",60441),piano:$("piano",60442),music:$("music",60443),micFilled:$("mic-filled",60444),gitFetch:$("git-fetch",60445),copilot:$("copilot",60446),lightbulbSparkle:$("lightbulb-sparkle",60447),lightbulbSparkleAutofix:$("lightbulb-sparkle-autofix",60447),robot:$("robot",60448),sparkleFilled:$("sparkle-filled",60449),diffSingle:$("diff-single",60450),diffMultiple:$("diff-multiple",60451),surroundWith:$("surround-with",60452),gitStash:$("git-stash",60454),gitStashApply:$("git-stash-apply",60455),gitStashPop:$("git-stash-pop",60456),coverage:$("coverage",60462),runAllCoverage:$("run-all-coverage",60461),runCoverage:$("run-all-coverage",60460),dialogError:$("dialog-error","error"),dialogWarning:$("dialog-warning","warning"),dialogInfo:$("dialog-info","info"),dialogClose:$("dialog-close","close"),treeItemExpanded:$("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:$("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:$("tree-filter-on-type-off","list-selection"),treeFilterClear:$("tree-filter-clear","close"),treeItemLoading:$("tree-item-loading","loading"),menuSelection:$("menu-selection","check"),menuSubmenu:$("menu-submenu","chevron-right"),menuBarMore:$("menubar-more","more"),scrollbarButtonLeft:$("scrollbar-button-left","triangle-left"),scrollbarButtonRight:$("scrollbar-button-right","triangle-right"),scrollbarButtonUp:$("scrollbar-button-up","triangle-up"),scrollbarButtonDown:$("scrollbar-button-down","triangle-down"),toolBarMore:$("toolbar-more","more"),quickInputBack:$("quick-input-back","arrow-left")}}),define(Ce[24],Ie([1,0,18]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=void 0;function O(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?O(r):r}),i}e.$Fn=O;function $(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(A.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,I.$Tf)(a)&&i.push(a)}}return o}e.$Gn=$;const A=Object.prototype.hasOwnProperty;function R(o,i){return v(o,i,new Set)}e.$Hn=R;function v(o,i,n){if((0,I.$Zf)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(v(t,i,n));return a}if((0,I.$Sf)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)A.call(o,t)&&(a[t]=v(o[t],i,n));return n.delete(o),a}return o}function p(o,i,n=!0){return(0,I.$Sf)(o)?((0,I.$Sf)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,I.$Sf)(o[r])&&(0,I.$Sf)(i[r])?p(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$In=p;function S(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!S(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!S(a,t))return!1;for(n=0;n<a.length;n++)if(!S(o[a[n]],i[a[n]]))return!1}return!0}e.$Jn=S;function L(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,I.$Sf)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$Kn=L;function C(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],d=i[a];S(t,d)||(n[a]=d)}),n}e.$Ln=C;function w(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.$Mn=w;function E(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.$Nn=E;function k(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$On=k;function u(o){const i=[];for(const n of k(o))typeof o[n]=="function"&&i.push(n);return i}e.$Pn=u;function m(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.$Qn=m}),define(Ce[55],Ie([1,0,79]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$jk=e.ThemeColor=void 0;var O;(function(R){function v(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=v})(O||(e.ThemeColor=O={}));function $(R){return{id:R}}e.$jk=$;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(i){const n=v.exec(i.id);if(!n)return p(I.$ik.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=p;function S(i){return p(i).join(" ")}R.asClassName=S;function L(i){return"."+p(i).join(".")}R.asCSSSelector=L;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||O.isThemeColor(i.color))}R.isThemeIcon=C;const w=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(i){const n=w.exec(i);if(!n)return;const[,r]=n;return{id:r}}R.fromString=E;function k(i){return{id:i}}R.fromId=k;function u(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}R.modify=u;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=m;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(Ce[165],Ie([1,0,123,12,55]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=void 0;const A="$(",R=new RegExp(`\\$\\(${$.ThemeIcon.iconNameExpression}(?:${$.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${R.source}`,"g");function p(o){return o.replace(v,(i,n)=>n?i:`\\${i}`)}e.$kk=p;const S=new RegExp(`\\\\${R.source}`,"g");function L(o){return o.replace(S,i=>`\\${i}`)}e.$lk=L;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function w(o){return o.indexOf(A)===-1?o:o.replace(C,(i,n,r,a)=>r?i:n||a||"")}e.$mk=w;function E(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$nk=E;const k=new RegExp(`\\$\\(${$.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){k.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=k.lastIndex,t=k.exec(o),d=o.substring(a,t?.index);if(d.length>0){i+=d;for(let c=0;c<d.length;c++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$ok=u;function m(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,I.$0j)(o,r,n);const t=(0,O.$1e)(r," "),d=r.length-t.length,c=(0,I.$0j)(o,t,n);if(c)for(const s of c){const l=a[s.start+d]+d;s.start+=l,s.end+=l}return c}e.$pk=m}),define(Ce[124],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.Constants=void 0;var I;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(I||(e.Constants=I={}));function O(A){return A<0?0:A>255?255:A|0}e.$Oe=O;function $(A){return A<0?0:A>4294967295?4294967295:A|0}e.$Pe=$}),define(Ce[30],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=e.$xg=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O($){return I.test($)}e.$xg=O,e.$yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let $;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?$=crypto.getRandomValues.bind(crypto):$=function(v){for(let p=0;p<v.length;p++)v[p]=Math.floor(Math.random()*256);return v};const A=new Uint8Array(16),R=[];for(let v=0;v<256;v++)R.push(v.toString(16).padStart(2,"0"));return function(){$(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,S="";return S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S+="-",S+=R[A[p++]],S+=R[A[p++]],S+="-",S+=R[A[p++]],S+=R[A[p++]],S+="-",S+=R[A[p++]],S+=R[A[p++]],S+="-",S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S+=R[A[p++]],S}}()}),define(Ce[166],Ie([1,0,19,53,30]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.$yt=e.$xt=e.$wt=void 0;function A(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$wt=A;function R(C,w,E){const k={id:(0,$.$yg)(),name:C,uri:w,data:E};return{asString:async()=>"",asFile:()=>k,value:void 0}}e.$xt=R;class v{constructor(){this.a=new Map}get size(){let w=0;for(const E of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const E=[...this.a.keys()];return O.Iterable.some(this,([k,u])=>u.asFile())&&E.push("files"),L(p(w),E)}get(w){return this.a.get(this.b(w))?.[0]}append(w,E){const k=this.a.get(w);k?k.push(E):this.a.set(this.b(w),[E])}replace(w,E){this.a.set(this.b(w),[E])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,E]of this.a)for(const k of E)yield[w,k]}b(w){return p(w)}}e.$yt=v;function p(C){return C.toLowerCase()}function S(C,w){return L(p(C),w.map(p))}e.$zt=S;function L(C,w){if(C==="*/*")return w.length>0;if(w.includes(C))return!0;const E=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[k,u,m]=E;return m==="*"?w.some(o=>o.startsWith(u+"/")):!1}e.$At=Object.freeze({create:C=>(0,I.$Mb)(C.map(w=>w.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$At.split(C).filter(w=>!w.startsWith("#"))})}),define(Ce[167],Ie([1,0,62]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=e.$Ag=void 0;function O(v,p,S,L=1){let C=!1;return new Promise(w=>{const E=setTimeout(()=>{if(!C)return C=!0,w(0)},S);$(v,p,L,k=>{if(!C)return C=!0,clearTimeout(E),w(k)})})}e.$Ag=O;function $(v,p,S,L){if(p===0)return L(0);const C=new I.Socket;C.once("connect",()=>(R(C),$(v+S,p-1,S,L))),C.once("data",()=>{}),C.once("error",w=>(R(C),w.code!=="ECONNREFUSED"?$(v+S,p-1,S,L):L(v))),C.connect(v,"127.0.0.1")}e.$Bg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(v,p,S,L="127.0.0.1"){let C=!1,w,E=1;const k=I.createServer({pauseOnConnect:!0});function u(m,o){C||(C=!0,k.removeAllListeners(),k.close(),w&&clearTimeout(w),o(m))}return new Promise(m=>{w=setTimeout(()=>{u(0,m)},S),k.on("listening",()=>{u(v,m)}),k.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<p?(v++,E++,k.listen(v,L)):u(0,m)}),k.on("close",()=>{u(0,m)}),k.listen(v,L)})}e.$Cg=A;function R(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch(p){console.error(p)}}}),define(Ce[125],Ie([1,0,124]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.$ot=void 0;class O{constructor(v){const p=(0,I.$Oe)(v);this.c=p,this.a=O.d(p),this.b=new Map}static d(v){const p=new Uint8Array(256);return p.fill(v),p}set(v,p){const S=(0,I.$Oe)(p);v>=0&&v<256?this.a[v]=S:this.b.set(v,S)}get(v){return v>=0&&v<256?this.a[v]:this.b.get(v)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ot=O;var $;(function(R){R[R.False=0]="False",R[R.True=1]="True"})($||($={}));class A{constructor(){this.a=new O(0)}add(v){this.a.set(v,1)}has(v){return this.a.get(v)===1}clear(){return this.a.clear()}}e.$pt=A}),define(Ce[168],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.StringEOL=void 0;var I;(function($){$[$.Unknown=0]="Unknown",$[$.Invalid=3]="Invalid",$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(I||(e.StringEOL=I={}));function O($){let A=0,R=0,v=0,p=0;for(let S=0,L=$.length;S<L;S++){const C=$.charCodeAt(S);C===13?(A===0&&(R=S),A++,S+1<L&&$.charCodeAt(S+1)===10?(p|=2,S++):p|=3,v=S+1):C===10&&(p|=1,A===0&&(R=S),A++,v=S+1)}return A===0&&(R=$.length),[A,R,$.length-v,p]}e.$Dt=O}),define(Ce[48],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0;class I{constructor($,A){this.lineNumber=$,this.column=A}with($=this.lineNumber,A=this.column){return $===this.lineNumber&&A===this.column?this:new I($,A)}delta($=0,A=0){return this.with(this.lineNumber+$,this.column+A)}equals($){return I.equals(this,$)}static equals($,A){return!$&&!A?!0:!!$&&!!A&&$.lineNumber===A.lineNumber&&$.column===A.column}isBefore($){return I.isBefore(this,$)}static isBefore($,A){return $.lineNumber<A.lineNumber?!0:A.lineNumber<$.lineNumber?!1:$.column<A.column}isBeforeOrEqual($){return I.isBeforeOrEqual(this,$)}static isBeforeOrEqual($,A){return $.lineNumber<A.lineNumber?!0:A.lineNumber<$.lineNumber?!1:$.column<=A.column}static compare($,A){const R=$.lineNumber|0,v=A.lineNumber|0;if(R===v){const p=$.column|0,S=A.column|0;return p-S}return R-v}clone(){return new I(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift($){return new I($.lineNumber,$.column)}static isIPosition($){return $&&typeof $.lineNumber=="number"&&typeof $.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$3s=I}),define(Ce[29],Ie([1,0,48]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=void 0;class O{constructor(A,R,v,p){A>v||A===v&&R>p?(this.startLineNumber=v,this.startColumn=p,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=v,this.endColumn=p)}isEmpty(){return O.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return O.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return O.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return O.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return O.plusRange(this,A)}static plusRange(A,R){let v,p,S,L;return R.startLineNumber<A.startLineNumber?(v=R.startLineNumber,p=R.startColumn):R.startLineNumber===A.startLineNumber?(v=R.startLineNumber,p=Math.min(R.startColumn,A.startColumn)):(v=A.startLineNumber,p=A.startColumn),R.endLineNumber>A.endLineNumber?(S=R.endLineNumber,L=R.endColumn):R.endLineNumber===A.endLineNumber?(S=R.endLineNumber,L=Math.max(R.endColumn,A.endColumn)):(S=A.endLineNumber,L=A.endColumn),new O(v,p,S,L)}intersectRanges(A){return O.intersectRanges(this,A)}static intersectRanges(A,R){let v=A.startLineNumber,p=A.startColumn,S=A.endLineNumber,L=A.endColumn;const C=R.startLineNumber,w=R.startColumn,E=R.endLineNumber,k=R.endColumn;return v<C?(v=C,p=w):v===C&&(p=Math.max(p,w)),S>E?(S=E,L=k):S===E&&(L=Math.min(L,k)),v>S||v===S&&p>L?null:new O(v,p,S,L)}equalsRange(A){return O.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(A){return new I.$3s(A.endLineNumber,A.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(A){return new I.$3s(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new O(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new O(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(A){return new O(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(A){return new O(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new O(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new O(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new O(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const S=A.startLineNumber|0,L=R.startLineNumber|0;if(S===L){const C=A.startColumn|0,w=R.startColumn|0;if(C===w){const E=A.endLineNumber|0,k=R.endLineNumber|0;if(E===k){const u=A.endColumn|0,m=R.endColumn|0;return u-m}return E-k}return C-w}return S-L}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$4s=O}),define(Ce[169],Ie([1,0,29]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0;class O{static insert(A,R){return{range:new I.$4s(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$5s=O}),define(Ce[170],Ie([1,0,48,29]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6s=e.SelectionDirection=void 0;var $;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})($||(e.SelectionDirection=$={}));class A extends O.$4s{constructor(v,p,S,L){super(v,p,S,L),this.selectionStartLineNumber=v,this.selectionStartColumn=p,this.positionLineNumber=S,this.positionColumn=L}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return A.selectionsEqual(this,v)}static selectionsEqual(v,p){return v.selectionStartLineNumber===p.selectionStartLineNumber&&v.selectionStartColumn===p.selectionStartColumn&&v.positionLineNumber===p.positionLineNumber&&v.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,p){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,v,p):new A(v,p,this.startLineNumber,this.startColumn)}getPosition(){return new I.$3s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new I.$3s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,p){return this.getDirection()===0?new A(v,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,v,p)}static fromPositions(v,p=v){return new A(v.lineNumber,v.column,p.lineNumber,p.column)}static fromRange(v,p){return p===0?new A(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new A(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new A(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,p){if(v&&!p||!v&&p)return!1;if(!v&&!p)return!0;if(v.length!==p.length)return!1;for(let S=0,L=v.length;S<L;S++)if(!this.selectionsEqual(v[S],p[S]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,p,S,L,C){return C===0?new A(v,p,S,L):new A(S,L,v,p)}}e.$6s=A}),define(Ce[171],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0,e.$Bs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[172],Ie([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.WordCharacterClass=void 0;var O;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(O||(e.WordCharacterClass=O={}));class $ extends I.$ot{constructor(v){super(0);for(let p=0,S=v.length;p<S;p++)this.set(v.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.$qt=$;function A(R){const v={};return p=>(v.hasOwnProperty(p)||(v[p]=R(p)),v[p])}e.$rt=A(R=>new $(R))}),define(Ce[126],Ie([1,0,53,3,76]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=e.$Fs=e.$Es=e.$Ds=e.$Cs=void 0,e.$Cs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(C=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Cs)C.indexOf(E)>=0||(w+="\\"+E);return w+="\\s]+)",new RegExp(w,"g")}e.$Ds=A();function R(C){let w=e.$Ds;if(C&&C instanceof RegExp)if(C.global)w=C;else{let E="g";C.ignoreCase&&(E+="i"),C.multiline&&(E+="m"),C.unicode&&(E+="u"),w=new RegExp(C.source,E)}return w.lastIndex=0,w}e.$Es=R;const v=new $.$4c;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(C){const w=v.unshift(C);return(0,O.$Rc)(w)}e.$Fs=p;function S(C,w,E,k,u){if(w=R(w),u||(u=I.Iterable.first(v)),E.length>u.maxLen){let r=C-u.maxLen/2;return r<0?r=0:k+=r,E=E.substring(r,C+u.maxLen/2),S(C,w,E,k,u)}const m=Date.now(),o=C-1-k;let i=-1,n=null;for(let r=1;!(Date.now()-m>=u.timeBudget);r++){const a=o-u.windowSize*r;w.lastIndex=Math.max(0,a);const t=L(w,E,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:k+1+n.index,endColumn:k+1+n.index+n[0].length};return w.lastIndex=0,r}return null}e.$Gs=S;function L(C,w,E,k){let u;for(;u=C.exec(w);){const m=u.index||0;if(m<=E&&C.lastIndex>=E)return u;if(k>0&&m>k)return null}return null}}),define(Ce[173],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=e.$1t=e.IndentAction=void 0;var I;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class O{constructor(v){if(this.e=null,this.f=!1,this.open=v.open,this.close=v.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(v.notIn))for(let p=0,S=v.notIn.length;p<S;p++)switch(v.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(v,p){if(v.getTokenCount()===0)return!0;const S=v.findTokenIndexAtOffset(p-2),L=v.getStandardTokenType(S);return this.isOK(L)}g(v,p){for(let S=v;S<=p;S++){const L=String.fromCharCode(S);if(!this.open.includes(L)&&!this.close.includes(L))return L}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$1t=O;class ${constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of v)A(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),A(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),A(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),A(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&A(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$2t=$;function A(R,v,p){R.has(v)?R.get(v).push(p):R.set(v,[p])}}),define(Ce[174],Ie([1,0,125]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D1=e.$C1=e.$B1=e.State=void 0;var O;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(O||(e.State=O={}));class ${constructor(k,u,m){const o=new Uint8Array(k*u);for(let i=0,n=k*u;i<n;i++)o[i]=m;this.a=o,this.rows=k,this.cols=u}get(k,u){return this.a[k*this.cols+u]}set(k,u,m){this.a[k*this.cols+u]=m}}class A{constructor(k){let u=0,m=0;for(let i=0,n=k.length;i<n;i++){const[r,a,t]=k[i];a>u&&(u=a),r>m&&(m=r),t>m&&(m=t)}u++,m++;const o=new $(m,u,0);for(let i=0,n=k.length;i<n;i++){const[r,a,t]=k[i];o.set(r,a,t)}this.a=o,this.b=u}nextState(k,u){return u<0||u>=this.b?0:this.a.get(k,u)}}e.$B1=A;let R=null;function v(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var p;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let S=null;function L(){if(S===null){S=new I.$ot(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<E.length;u++)S.set(E.charCodeAt(u),1);const k=".,;:";for(let u=0;u<k.length;u++)S.set(k.charCodeAt(u),2)}return S}class C{static a(k,u,m,o,i){let n=i-1;do{const r=u.charCodeAt(n);if(k.get(r)!==2)break;n--}while(n>o);if(o>0){const r=u.charCodeAt(o-1),a=u.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:n+2},url:u.substring(o,n+1)}}static computeLinks(k,u=v()){const m=L(),o=[];for(let i=1,n=k.getLineCount();i<=n;i++){const r=k.getLineContent(i),a=r.length;let t=0,d=0,c=0,s=1,l=!1,h=!1,b=!1,D=!1;for(;t<a;){let g=!1;const f=r.charCodeAt(t);if(s===13){let y;switch(f){case 40:l=!0,y=0;break;case 41:y=l?0:1;break;case 91:b=!0,h=!0,y=0;break;case 93:b=!1,y=h?0:1;break;case 123:D=!0,y=0;break;case 125:y=D?0:1;break;case 39:case 34:case 96:c===f?y=1:c===39||c===34||c===96?y=0:y=1;break;case 42:y=c===42?1:0;break;case 124:y=c===124?1:0;break;case 32:y=b?0:1;break;default:y=m.get(f)}y===1&&(o.push(C.a(m,r,i,d,t)),g=!0)}else if(s===12){let y;f===91?(h=!0,y=0):y=m.get(f),y===1?g=!0:s=13}else s=u.nextState(s,f),s===0&&(g=!0);g&&(s=1,l=!1,h=!1,D=!1,d=t+1,c=f),t++}s===13&&o.push(C.a(m,r,i,d,a))}return o}}e.$C1=C;function w(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:C.computeLinks(E)}e.$D1=w}),define(Ce[80],Ie([1,0,24]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ov=e.$nv=e.$mv=e.$lv=e.ModelConstants=e.PositionAffinity=e.$kv=e.TrackedRangeStickiness=e.$jv=e.$iv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var O;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(O||(e.OverviewRulerLane=O={}));var $;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})($||(e.GlyphMarginLane=$={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var p;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var S;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(S||(e.EndOfLineSequence=S={}));class L{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,I.$Jn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$iv=L;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$jv=C;var w;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function E(r){return r&&typeof r.read=="function"}e.$kv=E;var k;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(k||(e.PositionAffinity=k={}));var u;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class m{constructor(a,t,d,c,s,l){this.identifier=a,this.range=t,this.text=d,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=s,this._isTracked=l}}e.$lv=m;class o{constructor(a,t,d){this.regex=a,this.wordSeparators=t,this.simpleSearch=d}}e.$mv=o;class i{constructor(a,t,d){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=d}}e.$nv=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$ov=n}),define(Ce[175],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=e.NodeColor=e.$2B=void 0;class I{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$3B)return $(this.right);let m=this;for(;m.parent!==e.$3B&&m.parent.left!==m;)m=m.parent;return m.parent===e.$3B?e.$3B:m.parent}prev(){if(this.left!==e.$3B)return A(this.left);let m=this;for(;m.parent!==e.$3B&&m.parent.right!==m;)m=m.parent;return m.parent===e.$3B?e.$3B:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$2B=I;var O;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(O||(e.NodeColor=O={})),e.$3B=new I(null,0),e.$3B.parent=e.$3B,e.$3B.left=e.$3B,e.$3B.right=e.$3B,e.$3B.color=0;function $(u){for(;u.left!==e.$3B;)u=u.left;return u}e.$4B=$;function A(u){for(;u.right!==e.$3B;)u=u.right;return u}e.$5B=A;function R(u){return u===e.$3B?0:u.size_left+u.piece.length+R(u.right)}function v(u){return u===e.$3B?0:u.lf_left+u.piece.lineFeedCnt+v(u.right)}function p(){e.$3B.parent=e.$3B}function S(u,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$3B&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$3B?u.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}e.$6B=S;function L(u,m){const o=m.left;m.left=o.right,o.right!==e.$3B&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$3B?u.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}e.$7B=L;function C(u,m){let o,i;if(m.left===e.$3B?(i=m,o=i.right):m.right===e.$3B?(i=m,o=i.left):(i=$(m.right),o=i.right),i===u.root){u.root=o,o.color=0,m.detach(),p(),u.root.parent=e.$3B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===m?(o.parent=i.parent,k(u,o)):(i.parent===m?o.parent=i:o.parent=i.parent,k(u,o),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===u.root?u.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$3B&&(i.left.parent=i),i.right!==e.$3B&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,k(u,i)),m.detach(),o.parent.left===o){const a=R(o),t=v(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const d=a-o.parent.size_left,c=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,E(u,o.parent,d,c)}}if(k(u,o.parent),n){p();return}let r;for(;o!==u.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,S(u,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,L(u,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,S(u,o.parent),o=u.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,L(u,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,S(u,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,L(u,o.parent),o=u.root));o.color=0,p()}e.$8B=C;function w(u,m){for(k(u,m);m!==u.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,S(u,m)),m.parent.color=0,m.parent.parent.color=1,L(u,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,L(u,m)),m.parent.color=0,m.parent.parent.color=1,S(u,m.parent.parent))}u.root.color=0}e.$9B=w;function E(u,m,o,i){for(;m!==u.root&&m!==e.$3B;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}e.$0B=E;function k(u,m){let o=0,i=0;if(m!==u.root){for(;m!==u.root&&m===m.parent.right;)m=m.parent;if(m!==u.root)for(m=m.parent,o=R(m.left)-m.size_left,i=v(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=i;m!==u.root&&(o!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}}e.$$B=k}),define(Ce[176],Ie([1,0,19,124]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tv=e.$sv=e.$rv=void 0;class ${constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,S){p=(0,O.$Pe)(p);const L=this.a,C=this.b,w=S.length;return w===0?!1:(this.a=new Uint32Array(L.length+w),this.a.set(L.subarray(0,p),0),this.a.set(L.subarray(p),p+w),this.a.set(S,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(p,S){return p=(0,O.$Pe)(p),S=(0,O.$Pe)(S),this.a[p]===S?!1:(this.a[p]=S,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,S){p=(0,O.$Pe)(p),S=(0,O.$Pe)(S);const L=this.a,C=this.b;if(p>=L.length)return!1;const w=L.length-p;return S>=w&&(S=w),S===0?!1:(this.a=new Uint32Array(L.length-S),this.a.set(L.subarray(0,p),0),this.a.set(L.subarray(p+S),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,O.$Pe)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let S=this.c[0]+1;S===0&&(this.b[0]=this.a[0],S++),p>=this.a.length&&(p=this.a.length-1);for(let L=S;L<=p;L++)this.b[L]=this.b[L-1]+this.a[L];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let S=0,L=this.a.length-1,C=0,w=0,E=0;for(;S<=L;)if(C=S+(L-S)/2|0,w=this.b[C],E=w-this.a[C],p<E)L=C-1;else if(p>=w)S=C+1;else break;return new R(C,p-E)}}e.$rv=$;class A{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const S=this.e[p],L=S>0?this.d[S-1]:0;return new R(S,p-L)}removeValues(p,S){this.a.splice(p,S),this.f(p)}insertValues(p,S){this.a=(0,I.$Wb)(this.a,p,S),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,S=this.a.length;p<S;p++){const L=this.a[p],C=p>0?this.d[p-1]:0;this.d[p]=C+L;for(let w=0;w<L;w++)this.e[C+w]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,S){this.a[p]!==S&&(this.a[p]=S,this.f(p))}}e.$sv=A;class R{constructor(p,S){this.index=p,this.remainder=S,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=S}}e.$tv=R}),define(Ce[177],Ie([1,0,12,48,176]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=void 0;class A{constructor(v,p,S,L){this.d=v,this.f=p,this.g=S,this.h=L,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(v){v.eol&&v.eol!==this.g&&(this.g=v.eol,this.j=null);const p=v.changes;for(const S of p)this.o(S.range),this.p(new O.$3s(S.range.startLineNumber,S.range.startColumn),S.text);this.h=v.versionId,this.k=null}l(){if(!this.j){const v=this.g.length,p=this.f.length,S=new Uint32Array(p);for(let L=0;L<p;L++)S[L]=this.f[L].length+v;this.j=new $.$rv(S)}}n(v,p){this.f[v]=p,this.j&&this.j.setValue(v,this.f[v].length+this.g.length)}o(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.startLineNumber-1].substring(v.endColumn-1));return}this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.endLineNumber-1].substring(v.endColumn-1)),this.f.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.j&&this.j.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}p(v,p){if(p.length===0)return;const S=(0,I.$7e)(p);if(S.length===1){this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+S[0]+this.f[v.lineNumber-1].substring(v.column-1));return}S[S.length-1]+=this.f[v.lineNumber-1].substring(v.column-1),this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+S[0]);const L=new Uint32Array(S.length-1);for(let C=1;C<S.length;C++)this.f.splice(v.lineNumber+C-1,0,S[C]),L[C-1]=S[C].length+this.g.length;this.j&&this.j.insertValues(v.lineNumber,L)}}e.$uv=A}),define(Ce[99],Ie([1,0,12,172,48,29,80]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=void 0;const v=999;class p{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=S(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=I.$5e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new R.$mv(n,this.wordSeparators?(0,O.$rt)(this.wordSeparators):null,r?this.searchString:null)}}e.$_B=p;function S(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$aC=S;function L(o,i,n){if(!n)return new R.$jv(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new R.$jv(o,r)}e.$bC=L;class C{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class w{static findMatches(i,n,r,a,t){const d=n.parseSearchRequest();return d?d.regex.multiline?this.b(i,r,new m(d.wordSeparators,d.regex),a,t):this.c(i,r,d,a,t):[]}static a(i,n,r,a,t,d){let c,s=0;a?(s=a.findLineFeedCountBeforeOffset(t),c=n+t+s):c=n+t;let l;if(a){const g=a.findLineFeedCountBeforeOffset(t+d.length)-s;l=c+d.length+g}else l=c+d.length;const h=i.getPositionAt(c),b=i.getPositionAt(l);return new A.$4s(h.lineNumber,h.column,b.lineNumber,b.column)}static b(i,n,r,a,t){const d=i.getOffsetAt(n.getStartPosition()),c=i.getValueInRange(n,1),s=i.getEOL()===`\r
`?new C(c):null,l=[];let h=0,b;for(r.reset(0);b=r.next(c);)if(l[h++]=L(this.a(i,d,c,s,b.index,b[0]),b,a),h>=t)return l;return l}static c(i,n,r,a,t){const d=[];let c=0;if(n.startLineNumber===n.endLineNumber){const l=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return c=this.d(r,l,n.startLineNumber,n.startColumn-1,c,d,a,t),d}const s=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);c=this.d(r,s,n.startLineNumber,n.startColumn-1,c,d,a,t);for(let l=n.startLineNumber+1;l<n.endLineNumber&&c<t;l++)c=this.d(r,i.getLineContent(l),l,0,c,d,a,t);if(c<t){const l=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);c=this.d(r,l,n.endLineNumber,0,c,d,a,t)}return d}static d(i,n,r,a,t,d,c,s){const l=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=n.length;let y=-g;for(;(y=n.indexOf(D,y+g))!==-1;)if((!l||u(l,n,f,y,g))&&(d[t++]=new R.$jv(new A.$4s(r,y+1+a,r,y+1+g+a),null),t>=s))return t;return t}const h=new m(i.wordSeparators,i.regex);let b;h.reset(0);do if(b=h.next(n),b&&(d[t++]=L(new A.$4s(r,b.index+1+a,r,b.index+1+b[0].length+a),b,c),t>=s))return t;while(b);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,d,a):this.f(i,r,d,a)}static e(i,n,r,a){const t=new $.$3s(n.lineNumber,1),d=i.getOffsetAt(t),c=i.getLineCount(),s=i.getValueInRange(new A.$4s(t.lineNumber,t.column,c,i.getLineMaxColumn(c)),1),l=i.getEOL()===`\r
`?new C(s):null;r.reset(n.column-1);const h=r.next(s);return h?L(this.a(i,d,s,l,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new $.$3s(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),d=n.lineNumber,c=i.getLineContent(d),s=this.g(r,c,d,n.column,a);if(s)return s;for(let l=1;l<=t;l++){const h=(d+l-1)%t,b=i.getLineContent(h+1),D=this.g(r,b,h+1,1,a);if(D)return D}return null}static g(i,n,r,a,t){i.reset(a-1);const d=i.next(n);return d?L(new A.$4s(r,d.index+1,r,d.index+1+d[0].length),d,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const d=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,d,a):this.j(i,r,d,a)}static h(i,n,r,a){const t=this.b(i,new A.$4s(1,1,n.lineNumber,n.column),r,a,10*v);if(t.length>0)return t[t.length-1];const d=i.getLineCount();return n.lineNumber!==d||n.column!==i.getLineMaxColumn(d)?this.h(i,new $.$3s(d,i.getLineMaxColumn(d)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),d=n.lineNumber,c=i.getLineContent(d).substring(0,n.column-1),s=this.k(r,c,d,a);if(s)return s;for(let l=1;l<=t;l++){const h=(t+d-l-1)%t,b=i.getLineContent(h+1),D=this.k(r,b,h+1,a);if(D)return D}return null}static k(i,n,r,a){let t=null,d;for(i.reset(0);d=i.next(n);)t=L(new A.$4s(r,d.index+1,r,d.index+1+d[0].length),d,a);return t}}e.$cC=w;function E(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(r);if(o.get(d)!==0)return!0}return!1}function k(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const d=i.charCodeAt(r+a-1);if(o.get(d)!==0)return!0}return!1}function u(o,i,n,r,a){return E(o,i,n,r,a)&&k(o,i,n,r,a)}e.$dC=u;class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){I.$of(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$eC=m}),define(Ce[127],Ie([1,0,48,29,80,175,99]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=void 0;const v=65535;function p(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class S{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function L(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const d=o.charCodeAt(a);d===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:d===10&&(n[r++]=a+1)}return i?p(n):n}e.$fC=L;function C(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,d=!0;for(let s=0,l=i.length;s<l;s++){const h=i.charCodeAt(s);h===13?s+1<l&&i.charCodeAt(s+1)===10?(t++,o[n++]=s+2,s++):(r++,o[n++]=s+1):h===10?(a++,o[n++]=s+1):d&&h!==9&&(h<32||h>126)&&(d=!1)}const c=new S(p(o),r,a,t,d);return o.length=0,c}e.$gC=C;class w{constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$hC=w;class E{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$iC=E;class k{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$3B&&i.iterate(i.root,r=>(r!==A.$3B&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class m{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=A.$3B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,d=i.length;t<d;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=L(i[t].buffer));const c=new w(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,c)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=v,r=n-Math.floor(n/3),a=r*2;let t="",d=0;const c=[];if(this.iterate(this.root,s=>{const l=this.R(s),h=l.length;if(d<=r||d+h<a)return t+=l,d+=h,!0;const b=t.replace(/\r\n|\r|\n/g,i);return c.push(new E(b,L(b))),t=l,d=h,!0}),d>0){const s=t.replace(/\r\n|\r|\n/g,i);c.push(new E(s,L(s)))}this.create(c,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new k(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===A.$3B)return!0;const t=this.R(a),d=t.length,c=i.G(n),s=i.G(n+d),l=i.getValueInRange2(c,s);return n+=d,t===l})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==A.$3B;)if(a.left!==A.$3B&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==A.$3B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const d=this.getOffsetAt(r+1,1),c=a-d;return new I.$3s(r+1,c+1)}return new I.$3s(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$3B){const t=this.getOffsetAt(r+1,1),d=a-i-t;return new I.$3s(r+1,d+1)}else n=n.right;return new I.$3s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const c=i.node,s=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);return s.substring(l+i.remainder,l+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let d=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==A.$3B;){const c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){d+=c.substring(s,s+n.remainder);break}else d+=c.substr(s,r.piece.length);r=r.next()}return d}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===A.$3B)return!0;const d=t.piece;let c=d.length;if(c===0)return!0;const s=this.a[d.bufferIndex].buffer,l=this.a[d.bufferIndex].lineStarts,h=d.start.line,b=d.end.line;let D=l[h]+d.start.column;if(a&&(s.charCodeAt(D)===10&&(D++,c--),i[n++]=r,r="",a=!1,c===0))return!0;if(h===b)return!this.f&&s.charCodeAt(D+c-1)===13?(a=!0,r+=s.substr(D,c-1)):r+=s.substr(D,c),!0;r+=this.f?s.substring(D,Math.max(D,l[h+1]-this.e)):s.substring(D,l[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let g=h+1;g<b;g++)r=this.f?s.substring(l[g],l[g+1]-this.e):s.substring(l[g],l[g+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&s.charCodeAt(l[b]+d.end.column-1)===13?(a=!0,d.end.column===0?n--:r=s.substr(l[b],d.end.column-1)):r=s.substr(l[b],d.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,d,c,s,l,h,b){const D=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,d);let P;const N={line:0,column:0};let U,z;n._wordSeparators?(U=D.buffer.substring(f,y),z=F=>F+f,n.reset(0)):(U=D.buffer,z=F=>F,n.reset(f));do if(P=n.next(U),P){if(z(P.index)>=y)return h;this.s(i,z(P.index)-g,N);const F=this.t(i.piece.bufferIndex,t,N),M=N.line===t.line?N.column-t.column+a:N.column+1,T=M+P[0].length;if(b[h++]=(0,R.$bC)(new O.$4s(r+F,M,r+F,T),P,s),z(P.index)+P[0].length>=y||h>=l)return h}while(P);return h}findMatchesLineByLine(i,n,r,a){const t=[];let d=0;const c=new R.$eC(n.wordSeparators,n.regex);let s=this.H(i.startLineNumber,i.startColumn);if(s===null)return[];const l=this.H(i.endLineNumber,i.endColumn);if(l===null)return[];let h=this.s(s.node,s.remainder);const b=this.s(l.node,l.remainder);if(s.node===l.node)return this.findMatchesInNode(s.node,c,i.startLineNumber,i.startColumn,h,b,n,r,a,d,t),t;let D=i.startLineNumber,g=s.node;for(;g!==l.node;){const y=this.t(g.piece.bufferIndex,h,g.piece.end);if(y>=1){const N=this.a[g.piece.bufferIndex].lineStarts,U=this.u(g.piece.bufferIndex,g.piece.start),z=N[h.line+y],F=D===i.startLineNumber?i.startColumn:1;if(d=this.findMatchesInNode(g,c,D,F,h,this.s(g,z-U),n,r,a,d,t),d>=a)return t;D+=y}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const N=this.getLineContent(D).substring(P,i.endColumn-1);return d=this.n(n,c,N,i.endLineNumber,P,d,t,r,a),t}if(d=this.n(n,c,this.getLineContent(D).substr(P),D,P,d,t,r,a),d>=a)return t;D++,s=this.H(D,1),g=s.node,h=this.s(s.node,s.remainder)}if(D===i.endLineNumber){const y=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(y,i.endColumn-1);return d=this.n(n,c,P,i.endLineNumber,y,d,t,r,a),t}const f=D===i.startLineNumber?i.startColumn:1;return d=this.findMatchesInNode(l.node,c,D,f,h,b,n,r,a,d,t),t}n(i,n,r,a,t,d,c,s,l){const h=i.wordSeparators;if(!s&&i.simpleSearch){const D=i.simpleSearch,g=D.length,f=r.length;let y=-g;for(;(y=r.indexOf(D,y+g))!==-1;)if((!h||(0,R.$dC)(h,r,f,y,g))&&(c[d++]=new $.$jv(new O.$4s(a,y+1+t,a,y+1+g+t),null),d>=l))return d;return d}let b;n.reset(0);do if(b=n.next(r),b&&(c[d++]=(0,R.$bC)(new O.$4s(a,b.index+1+t,a,b.index+1+b[0].length+t),b,s),d>=l))return d;while(b);return d}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==A.$3B){const{node:a,remainder:t,nodeStartOffset:d}=this.G(i),c=a.piece,s=c.bufferIndex,l=this.s(a,t);if(a.piece.bufferIndex===0&&c.end.line===this.g.line&&c.end.column===this.g.column&&d+c.length===i&&n.length<v){this.F(a,n),this.y();return}if(d===i)this.o(n,a),this.h.validate(i);else if(d+a.piece.length>i){const h=[];let b=new w(c.bufferIndex,l,c.end,this.t(c.bufferIndex,l,c.end),this.u(s,c.end)-this.u(s,l));if(this.K()&&this.M(n)&&this.I(a,t)===10){const y={line:b.start.line+1,column:0};b=new w(b.bufferIndex,y,b.end,this.t(b.bufferIndex,y,b.end),b.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const y=this.s(a,t-1);this.C(a,y),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,l);else this.C(a,l);const D=this.w(n);b.length>0&&this.S(a,b);let g=a;for(let f=0;f<D.length;f++)g=this.S(g,D[f]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let d=1;d<a.length;d++)t=this.S(t,a[d])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$3B)return;const r=this.G(i),a=this.G(i+n),t=r.node,d=a.node;if(t===d){const D=this.s(t,r.remainder),g=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const f=t.next();(0,A.$8B)(this,t),this.N(f),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,g),this.y();return}const c=[],s=this.s(t,r.remainder);this.C(t,s),this.h.validate(i),t.piece.length===0&&c.push(t);const l=this.s(d,a.remainder);this.D(d,l),d.piece.length===0&&c.push(d);const h=t.next();for(let D=h;D!==A.$3B&&D!==d;D=D.next())c.push(D);const b=t.piece.length===0?t.prev():t;this.v(c),this.O(b),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const d=n.piece,c={line:d.start.line+1,column:0},s=new w(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),d.length-1);n.piece=s,i+=`
`,(0,A.$0B)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let d=a.length-2;d>=0;d--)t=this.T(t,a[d]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let d=1;d<r.length;d++)t=this.S(t,r[d]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,d=this.a[t].lineStarts,s=d[a.start.line]+a.start.column+n;let l=a.start.line,h=a.end.line,b=0,D=0,g=0;for(;l<=h&&(b=l+(h-l)/2|0,g=d[b],b!==h);)if(D=d[b+1],s<g)h=b-1;else if(s>=D)l=b+1;else break;return r?(r.line=b,r.column=s-g,null):{line:b,column:s-g}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],d=a[r.line]+r.column;if(t>d+1)return r.line-n.line;const c=d-1;return this.a[i].buffer.charCodeAt(c)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$8B)(this,i[n])}w(i){if(i.length>v){const h=[];for(;i.length>v;){const D=i.charCodeAt(v-1);let g;D===13||D>=55296&&D<=56319?(g=i.substring(0,v-1),i=i.substring(v-1)):(g=i.substring(0,v),i=i.substring(v));const f=L(g);h.push(new w(this.a.length,{line:0,column:0},{line:f.length-1,column:g.length-f[f.length-1]},f.length-1,g.length)),this.a.push(new E(g,f))}const b=L(i);return h.push(new w(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new E(i,b)),h}let n=this.a[0].buffer.length;const r=L(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<r.length;h++)r[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<r.length;h++)r[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,c=t-this.a[0].lineStarts[d],s={line:d,column:c},l=new w(0,a,s,this.t(0,a,s),t-n);return this.g=s,[l]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const d=this.B(r,i-t.nodeStartLineNumber-1),c=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=c.substring(s+d,s+r.piece.length);else{const l=this.B(r,i-t.nodeStartLineNumber);return c.substring(s+d,s+l-n)}}else{let d=0;const c=i;for(;r!==A.$3B;)if(r.left!==A.$3B&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const s=this.B(r,i-r.lf_left-2),l=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,b=this.u(r.piece.bufferIndex,r.piece.start);return d+=r.size_left,this.h.set({node:r,nodeStartOffset:d,nodeStartLineNumber:c-(i-1-r.lf_left)}),h.substring(b+s,b+l-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const s=this.B(r,i-r.lf_left-2),l=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);a=l.substring(h+s,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,d+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==A.$3B;){const d=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const c=this.B(r,0),s=this.u(r.piece.bufferIndex,r.piece.start);return a+=d.substring(s,s+c-n),a}else{const c=this.u(r.piece.bufferIndex,r.piece.start);a+=d.substr(c,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==A.$3B;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const d=this.t(i.piece.bufferIndex,r.start,a);if(d!==t)return{index:d,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),d=n,c=this.u(r.bufferIndex,d),s=this.t(r.bufferIndex,r.start,d),l=s-a,h=c-t,b=r.length+h;i.piece=new w(r.bufferIndex,r.start,d,s,b),(0,A.$0B)(this,i,h,l)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),d=n,c=this.t(r.bufferIndex,d,r.end),s=this.u(r.bufferIndex,d),l=c-a,h=t-s,b=r.length+h;i.piece=new w(r.bufferIndex,d,r.end,c,b),(0,A.$0B)(this,i,h,l)}E(i,n,r){const a=i.piece,t=a.start,d=a.end,c=a.length,s=a.lineFeedCnt,l=n,h=this.t(a.bufferIndex,a.start,l),b=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new w(a.bufferIndex,a.start,l,h,b),(0,A.$0B)(this,i,b-c,h-s);const D=new w(a.bufferIndex,r,d,this.t(a.bufferIndex,r,d),this.u(a.bufferIndex,d)-this.u(a.bufferIndex,r)),g=this.S(i,D);this.N(g)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=L(n,!1);for(let g=0;g<t.length;g++)t[g]+=a;if(r){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const d=this.a[0].lineStarts.length-1,c=this.a[0].buffer.length-this.a[0].lineStarts[d],s={line:d,column:c},l=i.piece.length+n.length,h=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,s),D=b-h;i.piece=new w(i.piece.bufferIndex,i.piece.start,s,b,l),this.g=s,(0,A.$0B)(this,i,n.length,D)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==A.$3B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==A.$3B;)if(r.left!==A.$3B&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),d=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,d),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==A.$3B;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),d=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:d}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$3B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$3B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const d=i.piece.length-1,c=i.piece.lineFeedCnt-1;i.piece=new w(i.piece.bufferIndex,i.piece.start,t,c,d),(0,A.$0B)(this,i,-1,-1),i.piece.length===0&&r.push(i);const s={line:n.piece.start.line+1,column:0},l=n.piece.length-1,h=this.t(n.piece.bufferIndex,s,n.piece.end);n.piece=new w(n.piece.bufferIndex,s,n.piece.end,h,l),(0,A.$0B)(this,n,-1,-1),n.piece.length===0&&r.push(n);const b=this.w(`\r
`);this.S(i,b[0]);for(let D=0;D<r.length;D++)(0,A.$8B)(this,r[D])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,A.$8B)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},d=a.length-1,c=this.t(a.bufferIndex,t,a.end);r.piece=new w(a.bufferIndex,t,a.end,c,d),(0,A.$0B)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$3B)return n(A.$3B);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$3B)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new A.$2B(n,1);if(r.left=A.$3B,r.right=A.$3B,r.parent=A.$3B,r.size_left=0,r.lf_left=0,this.root===A.$3B)this.root=r,r.color=0;else if(i.right===A.$3B)i.right=r,r.parent=i;else{const t=(0,A.$4B)(i.right);t.left=r,r.parent=t}return(0,A.$9B)(this,r),r}T(i,n){const r=new A.$2B(n,1);if(r.left=A.$3B,r.right=A.$3B,r.parent=A.$3B,r.size_left=0,r.lf_left=0,this.root===A.$3B)this.root=r,r.color=0;else if(i.left===A.$3B)i.left=r,r.parent=i;else{const a=(0,A.$5B)(i.left);a.right=r,r.parent=a}return(0,A.$9B)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$jC=m}),define(Ce[178],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9=e.$w9=void 0;class I{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$w9=I;class O{constructor(A){this.identifier=A}}e.$x9=O}),define(Ce[179],Ie([1,0,4,3]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=void 0;class ${constructor(){this.a=new Map,this.b=new Map,this.c=new I.$3d,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,p){return this.a.set(v,p),this.handleChange([v]),(0,O.$Rc)(()=>{this.a.get(v)===p&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,p){this.b.get(v)?.dispose();const S=new A(this,v,p);return this.b.set(v,S),(0,O.$Rc)(()=>{const L=this.b.get(v);!L||L!==S||(this.b.delete(v),L.dispose())})}async getOrCreate(v){const p=this.get(v);if(p)return p;const S=this.b.get(v);return!S||S.isResolved?null:(await S.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const S=this.b.get(v);return!!(!S||S.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ct=$;class A extends O.$Tc{get isResolved(){return this.c}constructor(v,p,S){super(),this.f=v,this.g=p,this.h=S,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Ce[180],Ie([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Ce[181],Ie([1,0,4,3,180]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;class A extends O.$Tc{constructor(w,E="",k="",u=!0,m){super(),this.h=this.B(new I.$3d),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=E,this.u=k,this.w=u,this.C=m}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,E){this.C&&await this.C(w)}}e.$Ti=A;class R extends O.$Tc{constructor(){super(...arguments),this.f=this.B(new I.$3d),this.onWillRun=this.f.event,this.m=this.B(new I.$3d),this.onDidRun=this.m.event}async run(w,E){if(!w.enabled)return;this.f.fire({action:w});let k;try{await this.u(w,E)}catch(u){k=u}this.m.fire({action:w,error:k})}async u(w,E){await w.run(E)}}e.$Ui=R;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let E=[];for(const k of w)k.length&&(E.length?E=[...E,new v,...k]:E=k);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Vi=v;class p{get actions(){return this.a}constructor(w,E,k,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=E,this.class=u,this.a=k}async run(){}}e.$Wi=p;class S extends A{static{this.ID="vs.actions.empty"}constructor(){super(S.ID,$.localize(0,null),void 0,!1)}}e.$Xi=S;function L(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...w)=>C.run(...w),tooltip:C.label}}e.$Yi=L}),define(Ce[182],Ie([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Ce[183],Ie([1,0,182]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;const O=60,$=O*60,A=$*24,R=A*7,v=A*30,p=A*365;function S(w,E,k,u){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,I.localize)(0,null,S(new Date().getTime()+m*1e3,!1));if(!u&&m<30)return(0,I.localize)(1,null);let o;return m<O?(o=m,E?o===1?k?(0,I.localize)(2,null,o):(0,I.localize)(3,null,o):k?(0,I.localize)(4,null,o):(0,I.localize)(5,null,o):o===1?k?(0,I.localize)(6,null,o):(0,I.localize)(7,null,o):k?(0,I.localize)(8,null,o):(0,I.localize)(9,null,o)):m<$?(o=Math.floor(m/O),E?o===1?k?(0,I.localize)(10,null,o):(0,I.localize)(11,null,o):k?(0,I.localize)(12,null,o):(0,I.localize)(13,null,o):o===1?k?(0,I.localize)(14,null,o):(0,I.localize)(15,null,o):k?(0,I.localize)(16,null,o):(0,I.localize)(17,null,o)):m<A?(o=Math.floor(m/$),E?o===1?k?(0,I.localize)(18,null,o):(0,I.localize)(19,null,o):k?(0,I.localize)(20,null,o):(0,I.localize)(21,null,o):o===1?k?(0,I.localize)(22,null,o):(0,I.localize)(23,null,o):k?(0,I.localize)(24,null,o):(0,I.localize)(25,null,o)):m<R?(o=Math.floor(m/A),E?o===1?(0,I.localize)(26,null,o):(0,I.localize)(27,null,o):o===1?(0,I.localize)(28,null,o):(0,I.localize)(29,null,o)):m<v?(o=Math.floor(m/R),E?o===1?k?(0,I.localize)(30,null,o):(0,I.localize)(31,null,o):k?(0,I.localize)(32,null,o):(0,I.localize)(33,null,o):o===1?k?(0,I.localize)(34,null,o):(0,I.localize)(35,null,o):k?(0,I.localize)(36,null,o):(0,I.localize)(37,null,o)):m<p?(o=Math.floor(m/v),E?o===1?k?(0,I.localize)(38,null,o):(0,I.localize)(39,null,o):k?(0,I.localize)(40,null,o):(0,I.localize)(41,null,o):o===1?k?(0,I.localize)(42,null,o):(0,I.localize)(43,null,o):k?(0,I.localize)(44,null,o):(0,I.localize)(45,null,o)):(o=Math.floor(m/p),E?o===1?k?(0,I.localize)(46,null,o):(0,I.localize)(47,null,o):k?(0,I.localize)(48,null,o):(0,I.localize)(49,null,o):o===1?k?(0,I.localize)(50,null,o):(0,I.localize)(51,null,o):k?(0,I.localize)(52,null,o):(0,I.localize)(53,null,o))}e.$Em=S;function L(w,E){const k=Math.abs(w/1e3);return k<1?E?(0,I.localize)(54,null,w):(0,I.localize)(55,null,w):k<O?E?(0,I.localize)(56,null,Math.round(w)/1e3):(0,I.localize)(57,null,Math.round(w)/1e3):k<$?E?(0,I.localize)(58,null,Math.round(w/(1e3*O))):(0,I.localize)(59,null,Math.round(w/(1e3*O))):k<A?E?(0,I.localize)(60,null,Math.round(w/(1e3*$))):(0,I.localize)(61,null,Math.round(w/(1e3*$))):(0,I.localize)(62,null,Math.round(w/(1e3*A)))}e.$Fm=L;function C(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Gm=C}),define(Ce[184],Ie([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Ce[44],Ie([1,0,19,18,184]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=void 0;function A(C,w){return w&&(C.stack||C.stacktrace)?$.localize(0,null,v(C),R(C.stack)||R(C.stacktrace)):v(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function v(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?$.localize(1,null,C.message):C.message||$.localize(2,null)}function p(C=null,w=!1){if(!C)return $.localize(3,null);if(Array.isArray(C)){const E=I.$Hb(C),k=p(E[0],w);return E.length>1?$.localize(4,null,k,E.length):k}if(O.$Qf(C))return C;if(C.detail){const E=C.detail;if(E.error)return A(E.error,w);if(E.exception)return A(E.exception,w)}return C.stack?A(C,w):C.message?C.message:$.localize(5,null)}e.$Zi=p;function S(C){const w=C;return w instanceof Error&&Array.isArray(w.actions)}e.$1i=S;function L(C,w){let E;return typeof C=="string"?E=new Error(C):E=C,E.actions=w,E}e.$2i=L}),define(Ce[185],Ie([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(Ce[11],Ie([1,0,185]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let O=!1,$=!1,A=!1,R=!1,v=!1,p=!1,S=!1,L=!1,C=!1,w=!1,E,k=e.$g,u=e.$g,m,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof n=="object"){O=n.platform==="win32",$=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,S=r,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,k=e.$g;const f=n.env.VSCODE_NLS_CONFIG;if(f)try{const y=JSON.parse(f),P=y.availableLanguages["*"];E=y.locale,u=y.osLocale,k=P||e.$g,m=y._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!a?(o=navigator.userAgent,O=o.indexOf("Windows")>=0,$=o.indexOf("Macintosh")>=0,L=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,w=o?.indexOf("Mobi")>=0,p=!0,E=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$g,k=E,u=navigator.language):console.error("Unable to resolve platform.");var t;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})(t||(e.Platform=t={}));function d(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=d;let c=0;$?c=1:O?c=3:A&&(c=2),e.$i=O,e.$j=$,e.$k=A,e.$l=R,e.$m=v,e.$n=S,e.$o=p,e.$p=p&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=L,e.$s=w,e.$t=C,e.$u=c,e.$v=o,e.$w=k;var s;(function(f){function y(){return e.$w}f.value=y;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}f.isDefaultVariant=P;function N(){return e.$w==="en"}f.isDefault=N})(s||(e.Language=s={})),e.$x=E,e.$y=u,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const f=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let N=0,U=f.length;N<U;N++){const z=f[N];if(z.id===P.data.vscodeScheduleAsyncWork){f.splice(N,1),z.callback();return}}});let y=0;return P=>{const N=++y;f.push({id:N,callback:P}),i.postMessage({vscodeScheduleAsyncWork:N},"*")}}return f=>setTimeout(f)})();var l;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=$||L?2:O?1:3;let h=!0,b=!1;function D(){if(!b){b=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,h=new Uint16Array(f.buffer)[0]===513}return h}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function g(f){return parseFloat(f)>=20}e.$J=g}),define(Ce[49],Ie([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let O;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.process<"u"){const A=$.process;O={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$dc=O.platform,e.$ec=O.arch}),define(Ce[17],Ie([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const O=65,$=97,A=90,R=122,v=46,p=47,S=92,L=58,C=63;class w extends Error{constructor(d,c,s){let l;typeof c=="string"&&c.indexOf("not ")===0?(l="must not be",c=c.replace(/^not /,"")):l="must be";const h=d.indexOf(".")!==-1?"property":"argument";let b=`The "${d}" ${h} ${l} of type ${c}`;b+=`. Received type ${typeof s}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,d){if(t===null||typeof t!="object")throw new w(d,"Object",t)}function k(t,d){if(typeof t!="string")throw new w(d,"string",t)}const u=I.$dc==="win32";function m(t){return t===p||t===S}function o(t){return t===p}function i(t){return t>=O&&t<=A||t>=$&&t<=R}function n(t,d,c,s){let l="",h=0,b=-1,D=0,g=0;for(let f=0;f<=t.length;++f){if(f<t.length)g=t.charCodeAt(f);else{if(s(g))break;g=p}if(s(g)){if(!(b===f-1||D===1))if(D===2){if(l.length<2||h!==2||l.charCodeAt(l.length-1)!==v||l.charCodeAt(l.length-2)!==v){if(l.length>2){const y=l.lastIndexOf(c);y===-1?(l="",h=0):(l=l.slice(0,y),h=l.length-1-l.lastIndexOf(c)),b=f,D=0;continue}else if(l.length!==0){l="",h=0,b=f,D=0;continue}}d&&(l+=l.length>0?`${c}..`:"..",h=2)}else l.length>0?l+=`${c}${t.slice(b+1,f)}`:l=t.slice(b+1,f),h=f-b-1;b=f,D=0}else g===v&&D!==-1?++D:D=-1}return l}function r(t,d){E(d,"pathObject");const c=d.dir||d.root,s=d.base||`${d.name||""}${d.ext||""}`;return c?c===d.root?`${c}${s}`:`${c}${t}${s}`:s}e.$fc={resolve(...t){let d="",c="",s=!1;for(let l=t.length-1;l>=-1;l--){let h;if(l>=0){if(h=t[l],k(h,"path"),h.length===0)continue}else d.length===0?h=I.cwd():(h=I.env[`=${d}`]||I.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==d.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${d}\\`));const b=h.length;let D=0,g="",f=!1;const y=h.charCodeAt(0);if(b===1)m(y)&&(D=1,f=!0);else if(m(y))if(f=!0,m(h.charCodeAt(1))){let P=2,N=P;for(;P<b&&!m(h.charCodeAt(P));)P++;if(P<b&&P!==N){const U=h.slice(N,P);for(N=P;P<b&&m(h.charCodeAt(P));)P++;if(P<b&&P!==N){for(N=P;P<b&&!m(h.charCodeAt(P));)P++;(P===b||P!==N)&&(g=`\\\\${U}\\${h.slice(N,P)}`,D=P)}}}else D=1;else i(y)&&h.charCodeAt(1)===L&&(g=h.slice(0,2),D=2,b>2&&m(h.charCodeAt(2))&&(f=!0,D=3));if(g.length>0)if(d.length>0){if(g.toLowerCase()!==d.toLowerCase())continue}else d=g;if(s){if(d.length>0)break}else if(c=`${h.slice(D)}\\${c}`,s=f,f&&d.length>0)break}return c=n(c,!s,"\\",m),s?`${d}\\${c}`:`${d}${c}`||"."},normalize(t){k(t,"path");const d=t.length;if(d===0)return".";let c=0,s,l=!1;const h=t.charCodeAt(0);if(d===1)return o(h)?"\\":t;if(m(h))if(l=!0,m(t.charCodeAt(1))){let D=2,g=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==g){const f=t.slice(g,D);for(g=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==g){for(g=D;D<d&&!m(t.charCodeAt(D));)D++;if(D===d)return`\\\\${f}\\${t.slice(g)}\\`;D!==g&&(s=`\\\\${f}\\${t.slice(g,D)}`,c=D)}}}else c=1;else i(h)&&t.charCodeAt(1)===L&&(s=t.slice(0,2),c=2,d>2&&m(t.charCodeAt(2))&&(l=!0,c=3));let b=c<d?n(t.slice(c),!l,"\\",m):"";return b.length===0&&!l&&(b="."),b.length>0&&m(t.charCodeAt(d-1))&&(b+="\\"),s===void 0?l?`\\${b}`:b:l?`${s}\\${b}`:`${s}${b}`},isAbsolute(t){k(t,"path");const d=t.length;if(d===0)return!1;const c=t.charCodeAt(0);return m(c)||d>2&&i(c)&&t.charCodeAt(1)===L&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let d,c;for(let h=0;h<t.length;++h){const b=t[h];k(b,"path"),b.length>0&&(d===void 0?d=c=b:d+=`\\${b}`)}if(d===void 0)return".";let s=!0,l=0;if(typeof c=="string"&&m(c.charCodeAt(0))){++l;const h=c.length;h>1&&m(c.charCodeAt(1))&&(++l,h>2&&(m(c.charCodeAt(2))?++l:s=!1))}if(s){for(;l<d.length&&m(d.charCodeAt(l));)l++;l>=2&&(d=`\\${d.slice(l)}`)}return e.$fc.normalize(d)},relative(t,d){if(k(t,"from"),k(d,"to"),t===d)return"";const c=e.$fc.resolve(t),s=e.$fc.resolve(d);if(c===s||(t=c.toLowerCase(),d=s.toLowerCase(),t===d))return"";let l=0;for(;l<t.length&&t.charCodeAt(l)===S;)l++;let h=t.length;for(;h-1>l&&t.charCodeAt(h-1)===S;)h--;const b=h-l;let D=0;for(;D<d.length&&d.charCodeAt(D)===S;)D++;let g=d.length;for(;g-1>D&&d.charCodeAt(g-1)===S;)g--;const f=g-D,y=b<f?b:f;let P=-1,N=0;for(;N<y;N++){const z=t.charCodeAt(l+N);if(z!==d.charCodeAt(D+N))break;z===S&&(P=N)}if(N!==y){if(P===-1)return s}else{if(f>y){if(d.charCodeAt(D+N)===S)return s.slice(D+N+1);if(N===2)return s.slice(D+N)}b>y&&(t.charCodeAt(l+N)===S?P=N:N===2&&(P=3)),P===-1&&(P=0)}let U="";for(N=l+P+1;N<=h;++N)(N===h||t.charCodeAt(N)===S)&&(U+=U.length===0?"..":"\\..");return D+=P,U.length>0?`${U}${s.slice(D,g)}`:(s.charCodeAt(D)===S&&++D,s.slice(D,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const d=e.$fc.resolve(t);if(d.length<=2)return t;if(d.charCodeAt(0)===S){if(d.charCodeAt(1)===S){const c=d.charCodeAt(2);if(c!==C&&c!==v)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(i(d.charCodeAt(0))&&d.charCodeAt(1)===L&&d.charCodeAt(2)===S)return`\\\\?\\${d}`;return t},dirname(t){k(t,"path");const d=t.length;if(d===0)return".";let c=-1,s=0;const l=t.charCodeAt(0);if(d===1)return m(l)?t:".";if(m(l)){if(c=s=1,m(t.charCodeAt(1))){let D=2,g=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==g){for(g=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==g){for(g=D;D<d&&!m(t.charCodeAt(D));)D++;if(D===d)return t;D!==g&&(c=s=D+1)}}}}else i(l)&&t.charCodeAt(1)===L&&(c=d>2&&m(t.charCodeAt(2))?3:2,s=c);let h=-1,b=!0;for(let D=d-1;D>=s;--D)if(m(t.charCodeAt(D))){if(!b){h=D;break}}else b=!1;if(h===-1){if(c===-1)return".";h=c}return t.slice(0,h)},basename(t,d){d!==void 0&&k(d,"ext"),k(t,"path");let c=0,s=-1,l=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===L&&(c=2),d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let b=d.length-1,D=-1;for(h=t.length-1;h>=c;--h){const g=t.charCodeAt(h);if(m(g)){if(!l){c=h+1;break}}else D===-1&&(l=!1,D=h+1),b>=0&&(g===d.charCodeAt(b)?--b===-1&&(s=h):(b=-1,s=D))}return c===s?s=D:s===-1&&(s=t.length),t.slice(c,s)}for(h=t.length-1;h>=c;--h)if(m(t.charCodeAt(h))){if(!l){c=h+1;break}}else s===-1&&(l=!1,s=h+1);return s===-1?"":t.slice(c,s)},extname(t){k(t,"path");let d=0,c=-1,s=0,l=-1,h=!0,b=0;t.length>=2&&t.charCodeAt(1)===L&&i(t.charCodeAt(0))&&(d=s=2);for(let D=t.length-1;D>=d;--D){const g=t.charCodeAt(D);if(m(g)){if(!h){s=D+1;break}continue}l===-1&&(h=!1,l=D+1),g===v?c===-1?c=D:b!==1&&(b=1):c!==-1&&(b=-1)}return c===-1||l===-1||b===0||b===1&&c===l-1&&c===s+1?"":t.slice(c,l)},format:r.bind(null,"\\"),parse(t){k(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const c=t.length;let s=0,l=t.charCodeAt(0);if(c===1)return m(l)?(d.root=d.dir=t,d):(d.base=d.name=t,d);if(m(l)){if(s=1,m(t.charCodeAt(1))){let P=2,N=P;for(;P<c&&!m(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&m(t.charCodeAt(P));)P++;if(P<c&&P!==N){for(N=P;P<c&&!m(t.charCodeAt(P));)P++;P===c?s=P:P!==N&&(s=P+1)}}}}else if(i(l)&&t.charCodeAt(1)===L){if(c<=2)return d.root=d.dir=t,d;if(s=2,m(t.charCodeAt(2))){if(c===3)return d.root=d.dir=t,d;s=3}}s>0&&(d.root=t.slice(0,s));let h=-1,b=s,D=-1,g=!0,f=t.length-1,y=0;for(;f>=s;--f){if(l=t.charCodeAt(f),m(l)){if(!g){b=f+1;break}continue}D===-1&&(g=!1,D=f+1),l===v?h===-1?h=f:y!==1&&(y=1):h!==-1&&(y=-1)}return D!==-1&&(h===-1||y===0||y===1&&h===D-1&&h===b+1?d.base=d.name=t.slice(b,D):(d.name=t.slice(b,h),d.base=t.slice(b,D),d.ext=t.slice(h,D))),b>0&&b!==s?d.dir=t.slice(0,b-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(u){const t=/\\/g;return()=>{const d=I.cwd().replace(t,"/");return d.slice(d.indexOf("/"))}}return()=>I.cwd()})();e.$gc={resolve(...t){let d="",c=!1;for(let s=t.length-1;s>=-1&&!c;s--){const l=s>=0?t[s]:a();k(l,"path"),l.length!==0&&(d=`${l}/${d}`,c=l.charCodeAt(0)===p)}return d=n(d,!c,"/",o),c?`/${d}`:d.length>0?d:"."},normalize(t){if(k(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===p,c=t.charCodeAt(t.length-1)===p;return t=n(t,!d,"/",o),t.length===0?d?"/":c?"./":".":(c&&(t+="/"),d?`/${t}`:t)},isAbsolute(t){return k(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let d;for(let c=0;c<t.length;++c){const s=t[c];k(s,"path"),s.length>0&&(d===void 0?d=s:d+=`/${s}`)}return d===void 0?".":e.$gc.normalize(d)},relative(t,d){if(k(t,"from"),k(d,"to"),t===d||(t=e.$gc.resolve(t),d=e.$gc.resolve(d),t===d))return"";const c=1,s=t.length,l=s-c,h=1,b=d.length-h,D=l<b?l:b;let g=-1,f=0;for(;f<D;f++){const P=t.charCodeAt(c+f);if(P!==d.charCodeAt(h+f))break;P===p&&(g=f)}if(f===D)if(b>D){if(d.charCodeAt(h+f)===p)return d.slice(h+f+1);if(f===0)return d.slice(h+f)}else l>D&&(t.charCodeAt(c+f)===p?g=f:f===0&&(g=0));let y="";for(f=c+g+1;f<=s;++f)(f===s||t.charCodeAt(f)===p)&&(y+=y.length===0?"..":"/..");return`${y}${d.slice(h+g)}`},toNamespacedPath(t){return t},dirname(t){if(k(t,"path"),t.length===0)return".";const d=t.charCodeAt(0)===p;let c=-1,s=!0;for(let l=t.length-1;l>=1;--l)if(t.charCodeAt(l)===p){if(!s){c=l;break}}else s=!1;return c===-1?d?"/":".":d&&c===1?"//":t.slice(0,c)},basename(t,d){d!==void 0&&k(d,"ext"),k(t,"path");let c=0,s=-1,l=!0,h;if(d!==void 0&&d.length>0&&d.length<=t.length){if(d===t)return"";let b=d.length-1,D=-1;for(h=t.length-1;h>=0;--h){const g=t.charCodeAt(h);if(g===p){if(!l){c=h+1;break}}else D===-1&&(l=!1,D=h+1),b>=0&&(g===d.charCodeAt(b)?--b===-1&&(s=h):(b=-1,s=D))}return c===s?s=D:s===-1&&(s=t.length),t.slice(c,s)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===p){if(!l){c=h+1;break}}else s===-1&&(l=!1,s=h+1);return s===-1?"":t.slice(c,s)},extname(t){k(t,"path");let d=-1,c=0,s=-1,l=!0,h=0;for(let b=t.length-1;b>=0;--b){const D=t.charCodeAt(b);if(D===p){if(!l){c=b+1;break}continue}s===-1&&(l=!1,s=b+1),D===v?d===-1?d=b:h!==1&&(h=1):d!==-1&&(h=-1)}return d===-1||s===-1||h===0||h===1&&d===s-1&&d===c+1?"":t.slice(d,s)},format:r.bind(null,"/"),parse(t){k(t,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return d;const c=t.charCodeAt(0)===p;let s;c?(d.root="/",s=1):s=0;let l=-1,h=0,b=-1,D=!0,g=t.length-1,f=0;for(;g>=s;--g){const y=t.charCodeAt(g);if(y===p){if(!D){h=g+1;break}continue}b===-1&&(D=!1,b=g+1),y===v?l===-1?l=g:f!==1&&(f=1):l!==-1&&(f=-1)}if(b!==-1){const y=h===0&&c?1:h;l===-1||f===0||f===1&&l===b-1&&l===h+1?d.base=d.name=t.slice(y,b):(d.name=t.slice(y,l),d.base=t.slice(y,b),d.ext=t.slice(l,b))}return h>0?d.dir=t.slice(0,h-1):c&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Ce[128],Ie([1,0,43,17]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=void 0;const $=new I.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new I.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(D,g,f=!1){const y=D||"",P=g||"",N=$.value.collator.compare(y,P);return $.value.collatorIsNumeric&&N===0&&y!==P?y<P?-1:1:N}e.$Rq=v;function p(D,g){const f=A.value.collator;return D=D||"",g=g||"",r(f,D,g)}e.$Sq=p;function S(D,g){const f=A.value.collator;return D=D||"",g=g||"",c(D,g)||r(f,D,g)}e.$Tq=S;function L(D,g){const f=A.value.collator;return D=D||"",g=g||"",d(D,g)||r(f,D,g)}e.$Uq=L;function C(D,g){return D=D||"",g=g||"",D===g?0:D<g?-1:1}e.$Vq=C;function w(D,g){const[f,y]=i(D),[P,N]=i(g);let U=$.value.collator.compare(y,N);if(U===0){if($.value.collatorIsNumeric&&y!==N)return y<N?-1:1;if(U=$.value.collator.compare(f,P),$.value.collatorIsNumeric&&U===0&&f!==P)return f<P?-1:1}return U}e.$Wq=w;function E(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=A.value.collator,N=R.value.collator;return r(N,f,y)||r(P,D,g)}e.$Xq=E;function k(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=A.value.collator,N=R.value.collator;return r(N,f,y)||c(D,g)||r(P,D,g)}e.$Yq=k;function u(D,g){D=D||"",g=g||"";const f=n(D),y=n(g),P=A.value.collator,N=R.value.collator;return r(N,f,y)||d(D,g)||r(P,D,g)}e.$Zq=u;function m(D,g){D=D||"",g=g||"";const f=n(D).toLowerCase(),y=n(g).toLowerCase();return f!==y?f<y?-1:1:D!==g?D<g?-1:1:0}e.$1q=m;const o=/^(.*?)(\.([^.]*))?$/;function i(D,g=!1){const f=D?o.exec(D):[];let y=[f&&f[1]||"",f&&f[3]||""];return g&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function n(D){const g=D?o.exec(D):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function r(D,g,f){const y=D.compare(g,f);return y!==0?y:g.length!==f.length?g.length<f.length?-1:1:0}function a(D){const g=D.charAt(0);return g.toLocaleUpperCase()!==g}function t(D){const g=D.charAt(0);return g.toLocaleLowerCase()!==g}function d(D,g){return a(D)&&t(g)?-1:t(D)&&a(g)?1:0}function c(D,g){return t(D)&&a(g)?-1:a(D)&&t(g)?1:0}function s(D,g,f=!1){return f||(D=D&&D.toLowerCase(),g=g&&g.toLowerCase()),D===g?0:D<g?-1:1}function l(D,g,f=!1){const y=D.split(O.sep),P=g.split(O.sep),N=y.length-1,U=P.length-1;let z,F;for(let M=0;;M++){if(z=N===M,F=U===M,z&&F)return v(y[M],P[M],f);if(z)return-1;if(F)return 1;const T=s(y[M],P[M],f);if(T!==0)return T}}e.$2q=l;function h(D,g,f){const y=D.toLowerCase(),P=g.toLowerCase(),N=b(D,g,f);if(N)return N;const U=y.endsWith(f),z=P.endsWith(f);if(U!==z)return U?-1:1;const F=v(y,P);return F!==0?F:y.localeCompare(P)}e.$3q=h;function b(D,g,f){const y=D.toLowerCase(),P=g.toLowerCase(),N=y.startsWith(f),U=P.startsWith(f);if(N!==U)return N?-1:1;if(N&&U){if(y.length<P.length)return-1;if(y.length>P.length)return 1}return 0}e.$4q=b}),define(Ce[34],Ie([1,0,17,11,12,18]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function R(h){return h===47||h===92}e.$9f=R;function v(h){return h.replace(/[\\/]/g,I.$gc.sep)}e.$0f=v;function p(h){return h.indexOf("/")===-1&&(h=v(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$$f=p;function S(h,b=I.$gc.sep){if(!h)return"";const D=h.length,g=h.charCodeAt(0);if(R(g)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let y=3;const P=y;for(;y<D&&!R(h.charCodeAt(y));y++);if(P!==y&&!R(h.charCodeAt(y+1))){for(y+=1;y<D;y++)if(R(h.charCodeAt(y)))return h.slice(0,y+1).replace(/[\\/]/g,b)}}return b}else if(o(g)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+b:h.slice(0,2);let f=h.indexOf("://");if(f!==-1){for(f+=3;f<D;f++)if(R(h.charCodeAt(f)))return h.slice(0,f+1)}return""}e.$_f=S;function L(h){if(!O.$i||!h||h.length<5)return!1;let b=h.charCodeAt(0);if(b!==92||(b=h.charCodeAt(1),b!==92))return!1;let D=2;const g=D;for(;D<h.length&&(b=h.charCodeAt(D),b!==92);D++);return!(g===D||(b=h.charCodeAt(D+1),isNaN(b)||b===92))}e.$ag=L;const C=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function k(h,b=O.$i){const D=b?C:w;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||b&&E.test(h)||h==="."||h===".."||b&&h[h.length-1]==="."||b&&h.length!==h.trim().length||h.length>255)}e.$bg=k;function u(h,b,D){const g=h===b;return!D||g?g:!h||!b?!1:(0,$.$hf)(h,b)}e.$cg=u;function m(h,b,D,g=I.sep){if(h===b)return!0;if(!h||!b||b.length>h.length)return!1;if(D){if(!(0,$.$if)(h,b))return!1;if(b.length===h.length)return!0;let y=b.length;return b.charAt(b.length-1)===g&&y--,h.charAt(y)===g}return b.charAt(b.length-1)!==g&&(b+=g),h.indexOf(b)===0}e.$dg=m;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$eg=o;function i(h,b){return O.$i&&h.endsWith(":")&&(h+=I.sep),(0,I.$ic)(h)||(h=(0,I.$jc)(b,h)),h=(0,I.$hc)(h),O.$i?(h=(0,$.$2e)(h,I.sep),h.endsWith(":")&&(h+=I.sep)):(h=(0,$.$2e)(h,I.sep),h||(h=I.sep)),h}e.$fg=i;function n(h){const b=(0,I.$hc)(h);return O.$i?h.length>3?!1:r(b)&&(h.length===2||b.charCodeAt(2)===92):b===I.$gc.sep}e.$gg=n;function r(h,b=O.$i){return b?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$hg=r;function a(h,b=O.$i){return r(h,b)?h[0]:void 0}e.$ig=a;function t(h,b,D){return b.length>h.length?-1:h===b?0:(D&&(h=h.toLowerCase(),b=b.toLowerCase()),h.indexOf(b))}e.$jg=t;function d(h){const b=h.split(":");let D,g,f;for(const y of b){const P=Number(y);(0,A.$Uf)(P)?g===void 0?g=P:f===void 0&&(f=P):D=D?[D,y].join(":"):y}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.$kg=d;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(h,b,D=8){let g="";for(let y=0;y<D;y++){let P;y===0&&O.$i&&!b&&(D===3||D===4)?P=s:P=c,g+=P.charAt(Math.floor(Math.random()*P.length))}let f;return b?f=`${b}-${g}`:f=g,h?(0,I.$jc)(h,f):f}e.$lg=l}),define(Ce[129],Ie([1,0,128,123,54,17,11,12]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=void 0;const p=0,S=[p,[]];function L(j,J,ne,_){if(!j||!J)return S;const Z=j.length,Y=J.length;if(Z<Y)return S;const ce=j.toLowerCase();return C(J,ne,Y,j,ce,Z,_)}e.$5q=L;function C(j,J,ne,_,Z,Y,ce){const ie=[],fe=[];for(let ae=0;ae<ne;ae++){const ye=ae*Y,le=ye-Y,de=ae>0,ue=j[ae],ge=J[ae];for(let V=0;V<Y;V++){const X=V>0,he=ye+V,be=he-1,Pe=le+V-1,pe=X?ie[be]:0,Ae=de&&X?ie[Pe]:0,Fe=de&&X?fe[Pe]:0;let W;!Ae&&de?W=0:W=w(ue,ge,_,Z,V,Fe),W&&Ae+W>=pe&&(ce||de||Z.startsWith(J,V))?(fe[he]=Fe+1,ie[he]=Ae+W):(fe[he]=p,ie[he]=pe)}}const re=[];let K=ne-1,B=Y-1;for(;K>=0&&B>=0;){const ae=K*Y+B;fe[ae]===p||(re.push(B),K--),B--}return[ie[ne*Y-1],re.reverse()]}function w(j,J,ne,_,Z,Y){let ce=0;if(!E(J,_[Z]))return ce;if(ce+=1,Y>0&&(ce+=Y*5),j===ne[Z]&&(ce+=1),Z===0)ce+=8;else{const ie=k(ne.charCodeAt(Z-1));ie?ce+=ie:(0,O.$7j)(ne.charCodeAt(Z))&&Y===0&&(ce+=2)}return ce}function E(j,J){return j===J?!0:j==="/"||j==="\\"?J==="/"||J==="\\":!1}function k(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function m(j,J,ne=0,_=0){const Z=J;return Z.values&&Z.values.length>1?o(j,Z.values,ne,_):i(j,J,ne,_)}e.$6q=m;function o(j,J,ne,_){let Z=0;const Y=[];for(const ce of J){const[ie,fe]=i(j,ce,ne,_);if(typeof ie!="number")return u;Z+=ie,Y.push(...fe)}return[Z,D(Y)]}function i(j,J,ne,_){const Z=(0,O.$dk)(J.original,J.originalLowercase,ne,j,j.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,O.$ak)(Z)]:u}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=65536;function d(j,J,ne,_){const Z=_.values?_.values:[_];return(0,$.$3i)({[_.normalized]:{values:Z.map(ce=>({value:ce.normalized,expectContiguousMatch:ce.expectContiguousMatch})),label:j,description:J,allowNonContiguousMatches:ne}})}function c(j,J,ne,_,Z){if(!j||!J.normalized)return n;const Y=_.getItemLabel(j);if(!Y)return n;const ce=_.getItemDescription(j),ie=d(Y,ce,ne,J),fe=Z[ie];if(fe)return fe;const re=s(Y,ce,_.getItemPath(j),J,ne);return Z[ie]=re,re}e.$7q=c;function s(j,J,ne,_,Z){const Y=!ne||!_.containsPathSeparator;return ne&&(R.$k?_.pathNormalized===ne:(0,v.$hf)(_.pathNormalized,ne))?{score:r,labelMatch:[{start:0,end:j.length}],descriptionMatch:J?[{start:0,end:J.length}]:void 0}:_.values&&_.values.length>1?l(j,J,ne,_.values,Y,Z):h(j,J,ne,_,Y,Z)}function l(j,J,ne,_,Z,Y){let ce=0;const ie=[],fe=[];for(const re of _){const{score:K,labelMatch:B,descriptionMatch:ae}=h(j,J,ne,re,Z,Y);if(K===p)return n;ce+=K,B&&ie.push(...B),ae&&fe.push(...ae)}return{score:ce,labelMatch:D(ie),descriptionMatch:D(fe)}}function h(j,J,ne,_,Z,Y){if(Z||!J){const[ce,ie]=L(j,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(ce){const fe=(0,O.$4j)(_.normalized,j);let re;if(fe){re=a;const K=Math.round(_.normalized.length/j.length*100);re+=K}else re=t;return{score:re+ce,labelMatch:fe||b(ie)}}}if(J){let ce=J;ne&&(ce=`${J}${A.sep}`);const ie=ce.length,fe=`${ce}${j}`,[re,K]=L(fe,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(re){const B=b(K),ae=[],ye=[];return B.forEach(le=>{le.start<ie&&le.end>ie?(ae.push({start:0,end:le.end-ie}),ye.push({start:le.start,end:ie})):le.start>=ie?ae.push({start:le.start-ie,end:le.end-ie}):ye.push(le)}),{score:re,labelMatch:ae,descriptionMatch:ye}}}return n}function b(j){const J=[];if(!j)return J;let ne;for(const _ of j)ne&&ne.end===_?ne.end+=1:(ne={start:_,end:_+1},J.push(ne));return J}function D(j){const J=j.sort((Z,Y)=>Z.start-Y.start),ne=[];let _;for(const Z of J)!_||!g(_,Z)?(_=Z,ne.push(Z)):(_.start=Math.min(_.start,Z.start),_.end=Math.max(_.end,Z.end));return ne}function g(j,J){return!(j.end<J.start||J.end<j.start)}function f(j,J,ne,_,Z,Y){const ce=c(j,ne,_,Z,Y),ie=c(J,ne,_,Z,Y),fe=ce.score,re=ie.score;if((fe===r||re===r)&&fe!==re)return fe===r?-1:1;if(fe>t||re>t){if(fe!==re)return fe>re?-1:1;if(fe<a&&re<a){const ue=P(ce.labelMatch,ie.labelMatch);if(ue!==0)return ue}const le=Z.getItemLabel(j)||"",de=Z.getItemLabel(J)||"";if(le.length!==de.length)return le.length-de.length}if(fe!==re)return fe>re?-1:1;const K=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0,B=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0;if(K&&!B)return-1;if(B&&!K)return 1;const ae=y(j,ce,Z),ye=y(J,ie,Z);return ae&&ye&&ae!==ye?ye>ae?-1:1:N(j,J,ne,Z)}e.$8q=f;function y(j,J,ne){let _=-1,Z=-1;if(J.descriptionMatch&&J.descriptionMatch.length?_=J.descriptionMatch[0].start:J.labelMatch&&J.labelMatch.length&&(_=J.labelMatch[0].start),J.labelMatch&&J.labelMatch.length){if(Z=J.labelMatch[J.labelMatch.length-1].end,J.descriptionMatch&&J.descriptionMatch.length){const Y=ne.getItemDescription(j);Y&&(Z+=Y.length)}}else J.descriptionMatch&&J.descriptionMatch.length&&(Z=J.descriptionMatch[J.descriptionMatch.length-1].end);return Z-_}function P(j,J){if(!j&&!J||(!j||!j.length)&&(!J||!J.length))return 0;if(!J||!J.length)return-1;if(!j||!j.length)return 1;const ne=j[0].start,Z=j[j.length-1].end-ne,Y=J[0].start,ie=J[J.length-1].end-Y;return Z===ie?0:ie<Z?1:-1}function N(j,J,ne,_){const Z=_.getItemLabel(j)||"",Y=_.getItemLabel(J)||"",ce=_.getItemDescription(j),ie=_.getItemDescription(J),fe=Z.length+(ce?ce.length:0),re=Y.length+(ie?ie.length:0);if(fe!==re)return fe-re;const K=_.getItemPath(j),B=_.getItemPath(J);return K&&B&&K.length!==B.length?K.length-B.length:Z!==Y?(0,I.$3q)(Z,Y,ne.normalized):ce&&ie&&ce!==ie?(0,I.$3q)(ce,ie,ne.normalized):K&&B&&K!==B?(0,I.$3q)(K,B,ne.normalized):0}function U(j){return j.startsWith('"')&&j.endsWith('"')}const z=" ";function F(j){typeof j!="string"&&(j="");const J=j.toLowerCase(),{pathNormalized:ne,normalized:_,normalizedLowercase:Z}=M(j),Y=ne.indexOf(A.sep)>=0,ce=U(j);let ie;const fe=j.split(z);if(fe.length>1)for(const re of fe){const K=U(re),{pathNormalized:B,normalized:ae,normalizedLowercase:ye}=M(re);ae&&(ie||(ie=[]),ie.push({original:re,originalLowercase:re.toLowerCase(),pathNormalized:B,normalized:ae,normalizedLowercase:ye,expectContiguousMatch:K}))}return{original:j,originalLowercase:J,pathNormalized:ne,normalized:_,normalizedLowercase:Z,values:ie,containsPathSeparator:Y,expectContiguousMatch:ce}}e.$9q=F;function M(j){let J;R.$i?J=j.replace(/\//g,A.sep):J=j.replace(/\\/g,A.sep);const ne=(0,v.$4e)(J).replace(/\s|"/g,"");return{pathNormalized:J,normalized:ne,normalizedLowercase:ne.toLowerCase()}}function T(j){return Array.isArray(j)?F(j.map(J=>J.original).join(z)):F(j.original)}e.$0q=T}),define(Ce[100],Ie([1,0,17]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.$ps=e.$os=void 0,e.$os=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},$={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(L){const C=(0,I.$oc)(L),w=O[C.toLowerCase()];return w!==void 0?w:R(L)}e.$ps=A;function R(L){const C=(0,I.$oc)(L);return $[C.toLowerCase()]}e.$qs=R;function v(L){for(const C in $)if($[C]===L)return C}e.$rs=v;const p=/^(.+)\/(.+?)(;.+)?$/;function S(L,C){const w=p.exec(L);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:C?void 0:L}e.$ss=S}),define(Ce[101],Ie([1,0,11]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.TerminateResponseCode=e.Source=void 0;var O;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(O||(e.Source=O={}));var $;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})($||(e.TerminateResponseCode=$={}));function A(v,...p){const S=p.reduce((w,E)=>(w[E]=!0,w),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(w=>!S[w]).forEach(w=>{for(let E=0;E<L.length;E++)if(w.search(L[E])!==-1){delete v[w];break}})}e.$1l=A;function R(v){v&&(delete v.DEBUG,I.$j&&delete v.DYLD_LIBRARY_PATH,I.$k&&delete v.LD_PRELOAD)}e.$2l=R}),define(Ce[2],Ie([1,0,17,11]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const $=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function v(s,l){if(!s.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!$.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(s,l){return!s&&!l?"file":s}function S(s,l){switch(s){case"https":case"http":case"file":l?l[0]!==C&&(l=C+l):l=C;break}return l}const L="",C="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(l){return l instanceof E?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,h,b,D,g,f=!1){typeof l=="object"?(this.scheme=l.scheme||L,this.authority=l.authority||L,this.path=l.path||L,this.query=l.query||L,this.fragment=l.fragment||L):(this.scheme=p(l,f),this.authority=h||L,this.path=S(this.scheme,b||L),this.query=D||L,this.fragment=g||L,v(this,f))}get fsPath(){return r(this,!1)}with(l){if(!l)return this;let{scheme:h,authority:b,path:D,query:g,fragment:f}=l;return h===void 0?h=this.scheme:h===null&&(h=L),b===void 0?b=this.authority:b===null&&(b=L),D===void 0?D=this.path:D===null&&(D=L),g===void 0?g=this.query:g===null&&(g=L),f===void 0?f=this.fragment:f===null&&(f=L),h===this.scheme&&b===this.authority&&D===this.path&&g===this.query&&f===this.fragment?this:new m(h,b,D,g,f)}static parse(l,h=!1){const b=w.exec(l);return b?new m(b[2]||L,c(b[4]||L),c(b[5]||L),c(b[7]||L),c(b[9]||L),h):new m(L,L,L,L,L)}static file(l){let h=L;if(O.$i&&(l=l.replace(/\\/g,C)),l[0]===C&&l[1]===C){const b=l.indexOf(C,2);b===-1?(h=l.substring(2),l=C):(h=l.substring(2,b),l=l.substring(b)||C)}return new m("file",h,l,L,L)}static from(l,h){return new m(l.scheme,l.authority,l.path,l.query,l.fragment,h)}static joinPath(l,...h){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return O.$i&&l.scheme==="file"?b=E.file(I.$fc.join(r(l,!0),...h)).path:b=I.$gc.join(l.path,...h),l.with({path:b})}toString(l=!1){return a(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof E)return l;{const h=new m(l);return h._formatted=l.external??null,h._fsPath=l._sep===u?l.fsPath??null:null,h}}else return l}}e.URI=E;function k(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=k;const u=O.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(l=!1){return l?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const l={$mid:1};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=u),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(s,l,h){let b,D=-1;for(let g=0;g<s.length;g++){const f=s.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||l&&f===47||h&&f===91||h&&f===93||h&&f===58)D!==-1&&(b+=encodeURIComponent(s.substring(D,g)),D=-1),b!==void 0&&(b+=s.charAt(g));else{b===void 0&&(b=s.substr(0,g));const y=o[f];y!==void 0?(D!==-1&&(b+=encodeURIComponent(s.substring(D,g)),D=-1),b+=y):D===-1&&(D=g)}}return D!==-1&&(b+=encodeURIComponent(s.substring(D))),b!==void 0?b:s}function n(s){let l;for(let h=0;h<s.length;h++){const b=s.charCodeAt(h);b===35||b===63?(l===void 0&&(l=s.substr(0,h)),l+=o[b]):l!==void 0&&(l+=s[h])}return l!==void 0?l:s}function r(s,l){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?l?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,O.$i&&(h=h.replace(/\//g,"\\")),h}e.$wc=r;function a(s,l){const h=l?n:i;let b="",{scheme:D,authority:g,path:f,query:y,fragment:P}=s;if(D&&(b+=D,b+=":"),(g||D==="file")&&(b+=C,b+=C),g){let N=g.indexOf("@");if(N!==-1){const U=g.substr(0,N);g=g.substr(N+1),N=U.lastIndexOf(":"),N===-1?b+=h(U,!1,!1):(b+=h(U.substr(0,N),!1,!1),b+=":",b+=h(U.substr(N+1),!1,!0)),b+="@"}g=g.toLowerCase(),N=g.lastIndexOf(":"),N===-1?b+=h(g,!1,!0):(b+=h(g.substr(0,N),!1,!0),b+=g.substr(N))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const N=f.charCodeAt(1);N>=65&&N<=90&&(f=`/${String.fromCharCode(N+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const N=f.charCodeAt(0);N>=65&&N<=90&&(f=`${String.fromCharCode(N+32)}:${f.substr(2)}`)}b+=h(f,!0,!1)}return y&&(b+="?",b+=h(y,!1,!1)),P&&(b+="#",b+=l?P:i(P,!1,!1)),b}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const d=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(s){return s.match(d)?s.replace(d,l=>t(l)):s}}),define(Ce[186],Ie([1,0,2]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$xq=e.$wq=e.$vq=void 0;function O(S){const L=S;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.$vq=O;function $(S){const L=[];let C;try{const w=JSON.parse(S.arguments),E=w[w.length-1];E&&E.__$stack&&(w.pop(),C=E.__$stack),L.push(...w)}catch{L.push("Unable to log remote console arguments",S.arguments)}return{args:L,stack:C}}e.$wq=$;function A(S){if(typeof S!="string")return A($(S).stack);const L=S;if(L){const C=R(L),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(w&&w.length===4)return{uri:I.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$xq=A;function R(S){if(!S)return S;const L=S.indexOf(`
`);return L===-1?S:S.substring(0,L)}function v(S,L){const{args:C,stack:w}=$(S),E=typeof C[0]=="string"&&C.length===1;let k=R(w);k&&(k=`(${k.trim()})`);let u=[];if(typeof C[0]=="string"?k&&E?u=[`%c[${L}] %c${C[0]} %c${k}`,p("blue"),p(""),p("grey")]:u=[`%c[${L}] %c${C[0]}`,p("blue"),p(""),...C.slice(1)]:u=[`%c[${L}]%`,p("blue"),...C],k&&!E&&u.push(k),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,u)}e.log=v;function p(S){return`color: ${S}`}}),define(Ce[56],Ie([1,0,21,2]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function $(p){return JSON.stringify(p,R)}e.$Jh=$;function A(p){let S=JSON.parse(p);return S=v(S),S}e.$Kh=A;function R(p,S){return S instanceof RegExp?{$mid:2,source:S.source,flags:S.flags}:S}function v(p,S=0){if(!p||S>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return O.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof I.$qe||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let L=0;L<p.length;++L)p[L]=v(p[L],S+1);else for(const L in p)Object.hasOwnProperty.call(p,L)&&(p[L]=v(p[L],S+1))}return p}e.$Lh=v}),define(Ce[16],Ie([1,0,14,11,12,2]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.codeSetting="code-setting",w.codeFeature="code-feature"})(R||(e.Schemas=R={}));function v(w,E){return A.URI.isUri(w)?(0,$.$hf)(w.scheme,E):(0,$.$if)(w,E+":")}e.$mg=v;function p(w,...E){return E.some(k=>v(w,k))}e.$ng=p,e.$og="vscode-tkn",e.$pg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${R.vscodeRemoteResource}`}set(E,k,u){this.a[E]=k,this.b[E]=u}setConnectionToken(E,k){this.c[E]=k}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(n){return I.$1(n),E}const k=E.authority;let u=this.a[k];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const m=this.b[k],o=this.c[k];let i=`path=${encodeURIComponent(E.path)}`;return typeof o=="string"&&(i+=`&${e.$pg}=${encodeURIComponent(o)}`),A.URI.from({scheme:O.$o?this.d:R.vscodeRemoteResource,authority:`${u}:${m}`,path:this.f,query:i})}}e.$qg=new S,e.$rg="vs/../../extensions",e.$sg="vs/../../node_modules",e.$tg="vs/../../node_modules.asar",e.$ug="vs/../../node_modules.asar.unpacked",e.$vg="vscode-app";class L{static{this.a=e.$vg}asBrowserUri(E){const k=this.b(E,me);return this.uriToBrowserUri(k)}uriToBrowserUri(E){return E.scheme===R.vscodeRemote?e.$qg.rewrite(E):E.scheme===R.file&&(O.$m||O.$q===`${R.vscodeFileResource}://${L.a}`)?E.with({scheme:R.vscodeFileResource,authority:E.authority||L.a,query:null,fragment:null}):E}asFileUri(E){const k=this.b(E,me);return this.uriToFileUri(k)}uriToFileUri(E){return E.scheme===R.vscodeFileResource?E.with({scheme:R.file,authority:E.authority!==L.a?E.authority:null,query:null,fragment:null}):E}b(E,k){return A.URI.isUri(E)?E:A.URI.parse(k.toUrl(E))}}e.$wg=new L;var C;(function(w){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(E.get("3"));const k="vscode-coi";function u(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:A.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const n=i?.get(k);if(n)return E.get(n)}w.getHeadersFromQuery=u;function m(o,i,n){if(!globalThis.crossOriginIsolated)return;const r=i&&n?"3":n?"2":"1";o instanceof URLSearchParams?o.set(k,r):o[k]=r}w.addSearchParam=m})(C||(e.COI=C={}))}),define(Ce[187],Ie([1,0,158,16,11,2]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=void 0;class R{constructor(w,E,k){this.id=w,this.dependencies=E,this.callback=k}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,E,k)=>{typeof w!="string"&&(k=E,E=w,w=null),(typeof E!="object"||!Array.isArray(E))&&(k=E,E=null),this.c.push(new R(w,E,k))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const E=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!E)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(w){return new Promise((E,k)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const m=()=>{u.removeEventListener("load",o),u.removeEventListener("error",i)},o=n=>{m(),E(this.c.pop())},i=n=>{m(),k(n)};u.addEventListener("load",o),u.addEventListener("error",i),this.f&&(w=this.f.createScriptURL(w)),u.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(w){return new Promise((E,k)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),E(this.c.pop())}catch(u){k(u)}})}async j(w){try{const E=globalThis._VSCODE_NODE_MODULES.fs,k=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(w).fsPath,o=E.readFileSync(m).toString(),i=u.wrap(o.replace(/^#!.*/,""));return new k.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const p=new Map;let S={};typeof globalThis.require=="object"&&(S=globalThis.require.paths??{});async function L(C,w,E){if(I.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),S[C]&&(C=S[C]);const k=`${C}/${w}`;if(p.has(k))return p.get(k);let u;if(/^\w[\w\d+.-]*:\/\//.test(k))u=k;else{const n=`${E&&!$.$o?O.$tg:O.$sg}/${k}`;u=O.$wg.asBrowserUri(n).toString(!0)}const m=v.INSTANCE.load(u);return p.set(k,m),m}else return await new Promise((k,u)=>{me([C],k,u)})}e.$qD=L}),define(Ce[23],Ie([1,0,34,16,17,11,12,2]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=e.DataUri=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function p(E){return(0,v.$wc)(E,!0)}e.$Dg=p;class S{constructor(k){this.a=k}compare(k,u,m=!1){return k===u?0:(0,R.$af)(this.getComparisonKey(k,m),this.getComparisonKey(u,m))}isEqual(k,u,m=!1){return k===u?!0:!k||!u?!1:this.getComparisonKey(k,m)===this.getComparisonKey(u,m)}getComparisonKey(k,u=!1){return k.with({path:this.a(k)?k.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(k){return this.a(k)}isEqualOrParent(k,u,m=!1){if(k.scheme===u.scheme){if(k.scheme===O.Schemas.file)return I.$dg(p(k),p(u),this.a(k))&&k.query===u.query&&(m||k.fragment===u.fragment);if((0,e.$Ug)(k.authority,u.authority))return I.$dg(k.path,u.path,this.a(k),"/")&&k.query===u.query&&(m||k.fragment===u.fragment)}return!1}joinPath(k,...u){return v.URI.joinPath(k,...u)}basenameOrAuthority(k){return(0,e.$Mg)(k)||k.authority}basename(k){return $.$gc.basename(k.path)}extname(k){return $.$gc.extname(k.path)}dirname(k){if(k.path.length===0)return k;let u;return k.scheme===O.Schemas.file?u=v.URI.file($.$mc(p(k))).path:(u=$.$gc.dirname(k.path),k.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${k.toString})) resulted in a relative path`),u="/")),k.with({path:u})}normalizePath(k){if(!k.path.length)return k;let u;return k.scheme===O.Schemas.file?u=v.URI.file($.$hc(p(k))).path:u=$.$gc.normalize(k.path),k.with({path:u})}relativePath(k,u){if(k.scheme!==u.scheme||!(0,e.$Ug)(k.authority,u.authority))return;if(k.scheme===O.Schemas.file){const i=$.$lc(p(k),p(u));return A.$i?I.$0f(i):i}let m=k.path||"/";const o=u.path||"/";if(this.a(k)){let i=0;for(const n=Math.min(m.length,o.length);i<n&&!(m.charCodeAt(i)!==o.charCodeAt(i)&&m.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);m=o.substr(0,i)+m.substr(i)}return $.$gc.relative(m,o)}resolvePath(k,u){if(k.scheme===O.Schemas.file){const m=v.URI.file($.$kc(p(k),u));return k.with({authority:m.authority,path:m.path})}return u=I.$$f(u),k.with({path:$.$gc.resolve(k.path,u)})}isAbsolutePath(k){return!!k.path&&k.path[0]==="/"}isEqualAuthority(k,u){return k===u||k!==void 0&&u!==void 0&&(0,R.$hf)(k,u)}hasTrailingPathSeparator(k,u=$.sep){if(k.scheme===O.Schemas.file){const m=p(k);return m.length>I.$_f(m).length&&m[m.length-1]===u}else{const m=k.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(k.fsPath)}}removeTrailingPathSeparator(k,u=$.sep){return(0,e.$Vg)(k,u)?k.with({path:k.path.substr(0,k.path.length-1)}):k}addTrailingPathSeparator(k,u=$.sep){let m=!1;if(k.scheme===O.Schemas.file){const o=p(k);m=o!==void 0&&o.length===I.$_f(o).length&&o[o.length-1]===u}else{u="/";const o=k.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$Vg)(k,u)?k.with({path:k.path+"/"}):k}}e.$Eg=S,e.$Fg=new S(()=>!1),e.$Gg=new S(E=>E.scheme===O.Schemas.file?!A.$k:!0),e.$Hg=new S(E=>!0),e.$Ig=e.$Fg.isEqual.bind(e.$Fg),e.$Jg=e.$Fg.isEqualOrParent.bind(e.$Fg),e.$Kg=e.$Fg.getComparisonKey.bind(e.$Fg),e.$Lg=e.$Fg.basenameOrAuthority.bind(e.$Fg),e.$Mg=e.$Fg.basename.bind(e.$Fg),e.$Ng=e.$Fg.extname.bind(e.$Fg),e.$Og=e.$Fg.dirname.bind(e.$Fg),e.$Pg=e.$Fg.joinPath.bind(e.$Fg),e.$Qg=e.$Fg.normalizePath.bind(e.$Fg),e.$Rg=e.$Fg.relativePath.bind(e.$Fg),e.$Sg=e.$Fg.resolvePath.bind(e.$Fg),e.$Tg=e.$Fg.isAbsolutePath.bind(e.$Fg),e.$Ug=e.$Fg.isEqualAuthority.bind(e.$Fg),e.$Vg=e.$Fg.hasTrailingPathSeparator.bind(e.$Fg),e.$Wg=e.$Fg.removeTrailingPathSeparator.bind(e.$Fg),e.$Xg=e.$Fg.addTrailingPathSeparator.bind(e.$Fg);function L(E,k){const u=[];for(let m=0;m<E.length;m++){const o=k(E[m]);E.some((i,n)=>n===m?!1:(0,e.$Jg)(o,k(i)))||u.push(E[m])}return u}e.$Yg=L;var C;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function k(u){const m=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&m.set(r,a)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&m.set(E.META_DATA_MIME,i),m}E.parseMetaData=k})(C||(e.DataUri=C={}));function w(E,k,u){if(k){let m=E.path;return m&&m[0]!==$.$gc.sep&&(m=$.$gc.sep+m),E.with({scheme:u,authority:k,path:m})}return E.with({scheme:u})}e.$Zg=w}),define(Ce[8],Ie([1,0,22,14,4,3,23,11,164,43]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.Promises=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0;function L(ge){return!!ge&&typeof ge.then=="function"}e.$1g=L;function C(ge){const V=new I.$ae,X=ge(V.token),he=new Promise((be,Pe)=>{const pe=V.token.onCancellationRequested(()=>{pe.dispose(),Pe(new O.$5)});Promise.resolve(X).then(Ae=>{pe.dispose(),V.dispose(),be(Ae)},Ae=>{pe.dispose(),V.dispose(),Pe(Ae)})});return new class{cancel(){V.cancel(),V.dispose()}then(be,Pe){return he.then(be,Pe)}catch(be){return this.then(void 0,be)}finally(be){return he.finally(be)}}}e.$2g=C;function w(ge,V,X){return new Promise((he,be)=>{const Pe=V.onCancellationRequested(()=>{Pe.dispose(),he(X)});ge.then(he,be).finally(()=>Pe.dispose())})}e.$3g=w;function E(ge,V){return new Promise((X,he)=>{const be=V.onCancellationRequested(()=>{be.dispose(),he(new O.$5)});ge.then(X,he).finally(()=>be.dispose())})}e.$4g=E;async function k(ge){let V=-1;const X=ge.map((he,be)=>he.then(Pe=>(V=be,Pe)));try{return await Promise.race(X)}finally{ge.forEach((he,be)=>{be!==V&&he.cancel()})}}e.$5g=k;function u(ge,V,X){let he;const be=setTimeout(()=>{he?.(void 0),X?.()},V);return Promise.race([ge.finally(()=>clearTimeout(be)),new Promise(Pe=>he=Pe)])}e.$6g=u;function m(ge){return new Promise((V,X)=>{const he=ge();L(he)?he.then(V,X):V(he)})}e.$7g=m;function o(){let ge,V;return{promise:new Promise((he,be)=>{ge=he,V=be}),resolve:ge,reject:V}}e.$8g=o;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const X=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(X,X).then(he)})}return new Promise((X,he)=>{this.b.then(X,he)})}return this.a=V(),new Promise((X,he)=>{this.a.then(be=>{this.a=null,X(be)},be=>{this.a=null,he(be)})})}dispose(){this.f=!0}}e.$9g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$0g=n;class r{constructor(){this.a=new Map}queue(V,X){const be=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(V)===be&&this.a.delete(V)});return this.a.set(V,be),be}}e.$$g=r;const a=(ge,V)=>{let X=!0;const he=setTimeout(()=>{X=!1,V()},ge);return{isTriggered:()=>X,dispose:()=>{clearTimeout(he),X=!1}}},t=ge=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,ge())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class d{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,X=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((be,Pe)=>{this.d=be,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=X===p.$Zd?t(he):a(X,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$_g=d;class c{constructor(V){this.a=new d(V),this.b=new i}trigger(V,X){return this.a.trigger(()=>this.b.queue(V),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ah=c;class s{constructor(){this.a=!1,this.b=new Promise((V,X)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$bh=s;class l extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$ch=l;function h(ge,V){return V?new Promise((X,he)=>{const be=setTimeout(()=>{Pe.dispose(),X()},ge),Pe=V.onCancellationRequested(()=>{clearTimeout(be),Pe.dispose(),he(new O.$5)})}):C(X=>h(ge,X))}e.$dh=h;function b(ge,V=0,X){const he=setTimeout(()=>{ge(),X&&be.dispose()},V),be=(0,A.$Rc)(()=>{clearTimeout(he),X?.deleteAndLeak(be)});return X?.add(be),be}e.$eh=b;function D(ge){const V=[];let X=0;const he=ge.length;function be(){return X<he?ge[X++]():null}function Pe(pe){pe!=null&&V.push(pe);const Ae=be();return Ae?Ae.then(Pe):Promise.resolve(V)}return Promise.resolve(null).then(Pe)}e.$fh=D;function g(ge,V=he=>!!he,X=null){let he=0;const be=ge.length,Pe=()=>{if(he>=be)return Promise.resolve(X);const pe=ge[he++];return Promise.resolve(pe()).then(Fe=>V(Fe)?Promise.resolve(Fe):Pe())};return Pe()}e.$gh=g;function f(ge,V=he=>!!he,X=null){if(ge.length===0)return Promise.resolve(X);let he=ge.length;const be=()=>{he=-1;for(const Pe of ge)Pe.cancel?.()};return new Promise((Pe,pe)=>{for(const Ae of ge)Ae.then(Fe=>{--he>=0&&V(Fe)?(be(),Pe(Fe)):he===0&&Pe(X)}).catch(Fe=>{--he>=0&&(be(),pe(Fe))})})}e.$hh=f;class y{constructor(V){this.a=0,this.b=!1,this.f=V,this.g=[],this.d=0,this.h=new $.$3d}whenIdle(){return this.size>0?$.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(V){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,he)=>{this.g.push({factory:V,c:X,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const V=this.g.shift();this.d++;const X=V.factory();X.then(V.c,V.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ih=y;class P extends y{constructor(){super(1)}}e.$jh=P;class N{constructor(){this.a=new Y,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$kh=N;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new fe;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueSize(V,X=R.$Fg){const he=X.getComparisonKey(V);return this.a.get(he)?.size??0}queueFor(V,X,he=R.$Fg){const be=he.getComparisonKey(V);let Pe=this.a.get(be);if(!Pe){Pe=new P;const pe=this.f++,Ae=$.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(pe,Ae),this.a.set(be,Pe)}return Pe.queue(X)}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$lh=U;class z{constructor(V,X){this.a=-1,typeof V=="function"&&typeof X=="number"&&this.setIfNotSet(V,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},X)}setIfNotSet(V,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},X))}}e.$mh=z;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(V,X,he=globalThis){this.cancel();const be=he.setInterval(()=>{V()},X);this.d=(0,A.$Rc)(()=>{he.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$nh=F;class M{constructor(V,X){this.b=-1,this.a=V,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$oh=M;class T{constructor(V,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=V,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ph=T;class j extends M{constructor(V,X){super(V,X),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$qh=j;class J extends A.$Tc{constructor(V,X){super(),this.g=V,this.h=X,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of V)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$rh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$th=(ge,V)=>{(0,v.$B)(()=>{if(X)return;const he=Date.now()+15;V(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$th=(ge,V,X)=>{const he=ge.requestIdleCallback(V,typeof X=="number"?{timeout:X}:void 0);let be=!1;return{dispose(){be||(be=!0,ge.cancelIdleCallback(he))}}},e.$sh=ge=>(0,e.$th)(globalThis,ge)}();class ne{constructor(V,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$th)(V,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$uh=ne;class _ extends ne{constructor(V){super(globalThis,V)}}e.$vh=_;async function Z(ge,V,X){let he;for(let be=0;be<X;be++)try{return await ge()}catch(Pe){he=Pe,await h(V)}throw he}e.$wh=Z;class Y{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,X,he){return this.a={taskId:V,cancel:()=>he?.(),promise:X},X.then(()=>this.d(V),()=>this.d(V)),X}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{const{promise:X,resolve:he,reject:be}=o();this.b={run:V,promise:X,promiseResolve:he,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$xh=Y;class ce{constructor(V,X=()=>Date.now()){this.d=V,this.f=X,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$yh=ce;var ie;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(ie||(ie={}));class fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,X)=>{this.a=V,this.b=X})}complete(V){return new Promise(X=>{this.a(V),this.d={outcome:0,value:V},X()})}error(V){return new Promise(X=>{this.b(V),this.d={outcome:1,value:V},X()})}cancel(){return this.error(new O.$5)}}e.$zh=fe;var re;(function(ge){async function V(he){let be;const Pe=await Promise.all(he.map(pe=>pe.then(Ae=>Ae,Ae=>{be||(be=Ae)})));if(typeof be<"u")throw be;return Pe}ge.settled=V;function X(he){return new Promise(async(be,Pe)=>{try{await he(be,Pe)}catch(pe){Pe(pe)}})}ge.withAsyncBody=X})(re||(e.Promises=re={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(V){this.a=void 0,this.b=void 0,this.d=!1,this.promise=V.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new O.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ah=K;class B{constructor(V){this.b=V,this.a=new S.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Bh=B;var ae;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ae||(ae={}));class ye{static fromArray(V){return new ye(X=>{X.emitMany(V)})}static fromPromise(V){return new ye(async X=>{X.emitMany(await V)})}static fromPromises(V){return new ye(async X=>{await Promise.all(V.map(async he=>X.emitOne(await he)))})}static merge(V){return new ye(async X=>{await Promise.all(V.map(async he=>{for await(const be of he)X.emitOne(be)}))})}static{this.EMPTY=ye.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new $.$3d,queueMicrotask(async()=>{const X={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(V(X)),this.j()}catch(he){this.k(he)}finally{X.emitOne=void 0,X.emitMany=void 0,X.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await $.Event.toPromise(this.f.event)}while(!0)}}}static map(V,X){return new ye(async he=>{for await(const be of V)he.emitOne(X(be))})}map(V){return ye.map(this,V)}static filter(V,X){return new ye(async he=>{for await(const be of V)X(be)&&he.emitOne(be)})}filter(V){return ye.filter(this,V)}static coalesce(V){return ye.filter(V,X=>!!X)}coalesce(){return ye.coalesce(this)}static async toPromise(V){const X=[];for await(const he of V)X.push(he);return X}toPromise(){return ye.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$Ch=ye;class le extends ye{constructor(V,X){super(X),this.l=V}cancel(){this.l.cancel()}}e.$Dh=le;function de(ge){const V=new I.$ae,X=ge(V.token);return new le(V,async he=>{const be=V.token.onCancellationRequested(()=>{be.dispose(),V.dispose(),he.reject(new O.$5)});try{for await(const Pe of X){if(V.token.isCancellationRequested)return;he.emitOne(Pe)}be.dispose(),V.dispose()}catch(Pe){be.dispose(),V.dispose(),he.reject(Pe)}})}e.$Eh=de;class ue{constructor(){this.a=new fe,this.b=new ye(he=>{if(V){he.reject(V);return}return X&&he.emitMany(X),this.d=be=>he.reject(be),this.f=be=>he.emitOne(be),this.a.p});let V,X;this.f=he=>{X||(X=[]),X.push(he)},this.d=he=>{V||(V=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(V){this.d(V),this.a.complete()}emitOne(V){this.f(V)}}e.$Fh=ue}),define(Ce[35],Ie([1,0,19,8,34,28,17,11,12]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;function S(){return Object.create(null)}e.$Qj=S,e.$Rj="**",e.$Sj="/";const L="[/\\\\]",C="[^/\\\\]",w=/\//g;function E(ne,_){switch(ne){case 0:return"";case 1:return`${C}*?`;default:return`(?:${L}|${C}+${L}${_?`|${L}${C}+`:""})*?`}}function k(ne,_){if(!ne)return[];const Z=[];let Y=!1,ce=!1,ie="";for(const fe of ne){switch(fe){case _:if(!Y&&!ce){Z.push(ie),ie="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}ie+=fe}return ie&&Z.push(ie),Z}e.$Tj=k;function u(ne){if(!ne)return"";let _="";const Z=k(ne,e.$Sj);if(Z.every(Y=>Y===e.$Rj))_=".*";else{let Y=!1;Z.forEach((ce,ie)=>{if(ce===e.$Rj){if(Y)return;_+=E(2,ie===Z.length-1)}else{let fe=!1,re="",K=!1,B="";for(const ae of ce){if(ae!=="}"&&fe){re+=ae;continue}if(K&&(ae!=="]"||!B)){let ye;ae==="-"?ye=ae:(ae==="^"||ae==="!")&&!B?ye="^":ae===e.$Sj?ye="":ye=(0,p.$Ve)(ae),B+=ye;continue}switch(ae){case"{":fe=!0;continue;case"[":K=!0;continue;case"}":{const le=`(?:${k(re,",").map(de=>u(de)).join("|")})`;_+=le,fe=!1,re="";break}case"]":{_+="["+B+"]",K=!1,B="";break}case"?":_+=C;continue;case"*":_+=E(1);continue;default:_+=(0,p.$Ve)(ae)}}ie<Z.length-1&&(Z[ie+1]!==e.$Rj||ie+2<Z.length)&&(_+=L)}Y=ce===e.$Rj})}return _}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),d=function(){return!1},c=function(){return null};function s(ne,_){if(!ne)return c;let Z;typeof ne!="string"?Z=ne.pattern:Z=ne,Z=Z.trim();const Y=`${Z}_${!!_.trimForExclusions}`;let ce=t.get(Y);if(ce)return l(ce,ne);let ie;return m.test(Z)?ce=b(Z.substr(4),Z):(ie=o.exec(h(Z,_)))?ce=D(ie[1],Z):(_.trimForExclusions?n:i).test(Z)?ce=g(Z,_):(ie=r.exec(h(Z,_)))?ce=f(ie[1].substr(1),Z,!0):(ie=a.exec(h(Z,_)))?ce=f(ie[1],Z,!1):ce=y(Z),t.set(Y,ce),l(ce,ne)}function l(ne,_){if(typeof _=="string")return ne;const Z=function(Y,ce){return(0,$.$dg)(Y,_.base,!v.$k)?ne((0,p.$1e)(Y.substr(_.base.length),R.sep),ce):null};return Z.allBasenames=ne.allBasenames,Z.allPaths=ne.allPaths,Z.basenames=ne.basenames,Z.patterns=ne.patterns,Z}function h(ne,_){return _.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function b(ne,_){return function(Z,Y){return typeof Z=="string"&&Z.endsWith(ne)?_:null}}function D(ne,_){const Z=`/${ne}`,Y=`\\${ne}`,ce=function(fe,re){return typeof fe!="string"?null:re?re===ne?_:null:fe===ne||fe.endsWith(Z)||fe.endsWith(Y)?_:null},ie=[ne];return ce.basenames=ie,ce.patterns=[_],ce.allBasenames=ie,ce}function g(ne,_){const Z=j(ne.slice(1,-1).split(",").map(re=>s(re,_)).filter(re=>re!==c),ne),Y=Z.length;if(!Y)return c;if(Y===1)return Z[0];const ce=function(re,K){for(let B=0,ae=Z.length;B<ae;B++)if(Z[B](re,K))return ne;return null},ie=Z.find(re=>!!re.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Z.reduce((re,K)=>K.allPaths?re.concat(K.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function f(ne,_,Z){const Y=R.sep===R.$gc.sep,ce=Y?ne:ne.replace(w,R.sep),ie=R.sep+ce,fe=R.$gc.sep+ne;let re;return Z?re=function(K,B){return typeof K=="string"&&(K===ce||K.endsWith(ie)||!Y&&(K===ne||K.endsWith(fe)))?_:null}:re=function(K,B){return typeof K=="string"&&(K===ce||!Y&&K===ne)?_:null},re.allPaths=[(Z?"*/":"./")+ne],re}function y(ne){try{const _=new RegExp(`^${u(ne)}$`);return function(Z){return _.lastIndex=0,typeof Z=="string"&&_.test(Z)?ne:null}}catch{return c}}function P(ne,_,Z){return!ne||typeof _!="string"?!1:N(ne)(_,void 0,Z)}e.$Uj=P;function N(ne,_={}){if(!ne)return d;if(typeof ne=="string"||U(ne)){const Z=s(ne,_);if(Z===c)return d;const Y=function(ce,ie){return!!Z(ce,ie)};return Z.allBasenames&&(Y.allBasenames=Z.allBasenames),Z.allPaths&&(Y.allPaths=Z.allPaths),Y}return M(ne,_)}e.$Vj=N;function U(ne){const _=ne;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.$Wj=U;function z(ne){return ne.allBasenames||[]}e.$Xj=z;function F(ne){return ne.allPaths||[]}e.$Yj=F;function M(ne,_){const Z=j(Object.getOwnPropertyNames(ne).map(re=>T(re,ne[re],_)).filter(re=>re!==c)),Y=Z.length;if(!Y)return c;if(!Z.some(re=>!!re.requiresSiblings)){if(Y===1)return Z[0];const re=function(ae,ye){let le;for(let de=0,ue=Z.length;de<ue;de++){const ge=Z[de](ae,ye);if(typeof ge=="string")return ge;(0,O.$1g)(ge)&&(le||(le=[]),le.push(ge))}return le?(async()=>{for(const de of le){const ue=await de;if(typeof ue=="string")return ue}return null})():null},K=Z.find(ae=>!!ae.allBasenames);K&&(re.allBasenames=K.allBasenames);const B=Z.reduce((ae,ye)=>ye.allPaths?ae.concat(ye.allPaths):ae,[]);return B.length&&(re.allPaths=B),re}const ce=function(re,K,B){let ae,ye;for(let le=0,de=Z.length;le<de;le++){const ue=Z[le];ue.requiresSiblings&&B&&(K||(K=(0,R.$nc)(re)),ae||(ae=K.substr(0,K.length-(0,R.$oc)(re).length)));const ge=ue(re,K,ae,B);if(typeof ge=="string")return ge;(0,O.$1g)(ge)&&(ye||(ye=[]),ye.push(ge))}return ye?(async()=>{for(const le of ye){const de=await le;if(typeof de=="string")return de}return null})():null},ie=Z.find(re=>!!re.allBasenames);ie&&(ce.allBasenames=ie.allBasenames);const fe=Z.reduce((re,K)=>K.allPaths?re.concat(K.allPaths):re,[]);return fe.length&&(ce.allPaths=fe),ce}function T(ne,_,Z){if(_===!1)return c;const Y=s(ne,Z);if(Y===c)return c;if(typeof _=="boolean")return Y;if(_){const ce=_.when;if(typeof ce=="string"){const ie=(fe,re,K,B)=>{if(!B||!Y(fe,re))return null;const ae=ce.replace("$(basename)",()=>K),ye=B(ae);return(0,O.$1g)(ye)?ye.then(le=>le?ne:null):ye?ne:null};return ie.requiresSiblings=!0,ie}}return Y}function j(ne,_){const Z=ne.filter(re=>!!re.basenames);if(Z.length<2)return ne;const Y=Z.reduce((re,K)=>{const B=K.basenames;return B?re.concat(B):re},[]);let ce;if(_){ce=[];for(let re=0,K=Y.length;re<K;re++)ce.push(_)}else ce=Z.reduce((re,K)=>{const B=K.patterns;return B?re.concat(B):re},[]);const ie=function(re,K){if(typeof re!="string")return null;if(!K){let ae;for(ae=re.length;ae>0;ae--){const ye=re.charCodeAt(ae-1);if(ye===47||ye===92)break}K=re.substr(ae)}const B=Y.indexOf(K);return B!==-1?ce[B]:null};ie.basenames=Y,ie.patterns=ce,ie.allBasenames=Y;const fe=ne.filter(re=>!re.basenames);return fe.push(ie),fe}function J(ne,_){return(0,I.$ub)(ne,_,(Z,Y)=>typeof Z=="string"&&typeof Y=="string"?Z===Y:typeof Z!="string"&&typeof Y!="string"?Z.base===Y.base&&Z.pattern===Y.pattern:!1)}e.$Zj=J}),define(Ce[63],Ie([1,0,14,165,23,12,2]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class p{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,I.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=w(this.supportThemeIcons?(0,O.$kk)(i):i).replace(/([ \t]+)/g,(r,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${E(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,A.$Ve)(n),"g");return i.replace(r,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$qk=p;function S(o){return L(o)?!o.value:Array.isArray(o)?o.every(S):!0}e.$rk=S;function L(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$sk=L;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,$.$Ig)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$tk=C;function w(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$uk=w;function E(o,i){const n=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,o,`${"`".repeat(r)}`].join(`
`)}e.$vk=E;function k(o){return o.replace(/"/g,"&quot;")}e.$wk=k;function u(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$xk=u;function m(o){const i=[],n=o.split("|").map(a=>a.trim());o=n[0];const r=n[1];if(r){const a=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),d=a?a[1]:"",c=t?t[1]:"",s=isFinite(parseInt(c)),l=isFinite(parseInt(d));s&&i.push(`width="${c}"`),l&&i.push(`height="${d}"`)}return{href:o,dimensions:i}}e.$yk=m}),define(Ce[102],Ie([1,0,19,34,17,11,23,12]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=void 0;function p(s,l){const{os:h,tildify:b,relative:D}=l;if(D){const y=S(s,D,h);if(typeof y=="string")return y}let g=s.fsPath;if(h===1&&!A.$i?g=g.replace(/\//g,"\\"):h!==1&&A.$i&&(g=g.replace(/\\/g,"/")),h!==1&&b?.userHome){const y=b.userHome.fsPath;let P;s.scheme!==b.userHome.scheme&&s.path[0]===$.$gc.sep&&s.path[1]!==$.$gc.sep?P=b.userHome.with({path:s.path}).fsPath:P=g,g=w(P,y,h)}return(h===1?$.$fc:$.$gc).normalize(L(g,h===1))}e.$5v=p;function S(s,l,h){const b=h===1?$.$fc:$.$gc,D=h===3?R.$Fg:R.$Hg,g=l.getWorkspace(),f=(0,I.$Ob)(g.folders);if(!f)return;s.scheme!==f.uri.scheme&&s.path[0]===$.$gc.sep&&s.path[1]!==$.$gc.sep&&(s=f.uri.with({path:s.path}));const y=l.getWorkspaceFolder(s);if(!y)return;let P;if(D.isEqual(y.uri,s)?P="":P=D.relativePath(y.uri,s)??"",P&&(P=b.normalize(P)),g.folders.length>1&&!l.noPrefix){const N=y.name?y.name:D.basenameOrAuthority(y.uri);P=P?`${N} \u2022 ${P}`:N}return P}function L(s,l=A.$i){return(0,O.$hg)(s,l)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$6v=L;let C=Object.create(null);function w(s,l,h=A.OS){if(h===1||!s||!l)return s;let b=C.original===l?C.normalized:void 0;b||(b=l,A.$i&&(b=(0,O.$0f)(b)),b=`${(0,v.$2e)(b,$.$gc.sep)}${$.$gc.sep}`,C={original:l,normalized:b});let D=s;return A.$i&&(D=(0,O.$0f)(D)),(h===3?D.startsWith(b):(0,v.$if)(D,b))?`~/${D.substr(b.length)}`:s}e.$7v=w;function E(s,l){return s.replace(/^~($|\/|\\)/,`${l}$1`)}e.$8v=E;const k="\u2026",u="\\\\",m="~";function o(s,l=$.sep){const h=new Array(s.length);let b=!1;for(let D=0;D<s.length;D++){const g=s[D];if(g===""){h[D]=`.${l}`;continue}if(!g){h[D]=g;continue}b=!0;let f="",y=g;y.indexOf(u)===0?(f=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(l)===0?(f=y.substr(0,y.indexOf(l)+l.length),y=y.substr(y.indexOf(l)+l.length)):y.indexOf(m)===0&&(f=y.substr(0,y.indexOf(m)+m.length),y=y.substr(y.indexOf(m)+m.length));const P=y.split(l);for(let N=1;b&&N<=P.length;N++)for(let U=P.length-N;b&&U>=0;U--){b=!1;let z=P.slice(U,U+N).join(l);for(let F=0;!b&&F<s.length;F++)if(F!==D&&s[F]&&s[F].indexOf(z)>-1){const M=U+N===P.length,T=U>0&&s[F].indexOf(l)>-1?l+z:z,j=s[F].endsWith(T);b=!M||j}if(!b){let F="";(P[0].endsWith(":")||f!=="")&&(U===1&&(U=0,N++,z=P[0]+l+z),U>0&&(F=P[0]+l),F=f+F),U>0&&(F=F+k+l),F=F+z,U+N<P.length&&(F=F+l+k),h[D]=F}}b&&(h[D]=g)}return h}e.$9v=o;var i;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(s,l=Object.create(null)){const h=[];let b=!1,D="";for(const g of s)if(g==="$"||b&&g==="{")D&&h.push({value:D,type:i.TEXT}),D="",b=!0;else if(g==="}"&&b){const f=l[D];if(typeof f=="string")f.length&&h.push({value:f,type:i.VARIABLE});else if(f){const y=h[h.length-1];(!y||y.type!==i.SEPARATOR)&&h.push({value:f.label,type:i.SEPARATOR})}D="",b=!1}else D+=g;return D&&!b&&h.push({value:D,type:i.TEXT}),h.filter((g,f)=>{if(g.type===i.SEPARATOR){const y=h[f-1],P=h[f+1];return[y,P].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(g=>g.value).join("")}e.$0v=n;function r(s,l){return A.$j||l?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):s.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$$v=r;function a(s,l){return A.$j||l?s.replace(/\(&&\w\)|&&/g,""):A.$i?s.replace(/&&|&/g,h=>h==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$_v=a;function t(s){return s.replace(/&/g,"&&")}e.$aw=t;function d(s){if(s.endsWith("]")){const l=s.lastIndexOf(" [",s.length-2);if(l!==-1){const h=c(s.substring(0,l)),b=s.substring(l);return{name:h.name+b,parentPath:h.parentPath}}}return c(s)}e.$bw=d;function c(s){const l=s.indexOf("/")!==-1?$.$gc:$.$fc,h=l.basename(s),b=l.dirname(s);return h.length?{name:h,parentPath:b}:{name:b,parentPath:""}}}),define(Ce[130],Ie([1,0,21,2]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=void 0;function $(C){return C.toJSON()}class A{constructor(w){this.a=w}transformIncoming(w){const E=this.a.transformIncoming(w);return E===w?w:$(O.URI.from(E))}transformOutgoing(w){const E=this.a.transformOutgoing(w);return E===w?w:$(O.URI.from(E))}transformOutgoingURI(w){const E=this.a.transformOutgoing(w);return E===w?w:O.URI.from(E)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$bn=A,e.$cn=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,w,E){if(!C||E>200)return null;if(typeof C=="object"){if(C instanceof O.URI)return w.transformOutgoing(C);for(const k in C)if(Object.hasOwnProperty.call(C,k)){const u=R(C[k],w,E+1);u!==null&&(C[k]=u)}}return null}function v(C,w){const E=R(C,w,0);return E===null?C:E}e.$dn=v;function p(C,w,E,k){if(!C||k>200)return null;if(typeof C=="object"){if(C.$mid===1)return E?O.URI.revive(w.transformIncoming(C)):w.transformIncoming(C);if(C instanceof I.$qe)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const m=p(C[u],w,E,k+1);m!==null&&(C[u]=m)}}return null}function S(C,w){const E=p(C,w,!1,0);return E===null?C:E}e.$en=S;function L(C,w){const E=p(C,w,!0,0);return E===null?C:E}e.$fn=L}),define(Ce[31],Ie([1,0,57,64,388,8,34,77,17,11,23,2]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(T){T[T.UNLINK=0]="UNLINK",T[T.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function E(T,j=w.UNLINK,J){if((0,R.$gg)(T))throw new Error("rimraf - will refuse to recursively delete root");return j===w.UNLINK?u(T):k(T,J)}async function k(T,j=(0,R.$lg)((0,O.tmpdir)())){try{try{await I.promises.rename(T,j)}catch(J){return J.code==="ENOENT"?void 0:u(T)}u(j).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function u(T){return(0,$.promisify)(I.rm)(T,{recursive:!0,force:!0,maxRetries:3})}function m(T){if((0,R.$gg)(T))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(T,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function o(T,j){return r(await(j?i(T):(0,$.promisify)(I.readdir)(T)))}async function i(T){try{return await(0,$.promisify)(I.readdir)(T,{withFileTypes:!0})}catch(ne){console.warn("[node.js fs] readdir with filetypes failed with error: ",ne)}const j=[],J=await o(T);for(const ne of J){let _=!1,Z=!1,Y=!1;try{const ce=await e.Promises.lstat((0,p.$jc)(T,ne));_=ce.isFile(),Z=ce.isDirectory(),Y=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}j.push({name:ne,isFile:()=>_,isDirectory:()=>Z,isSymbolicLink:()=>Y})}return j}function n(T){return r(I.readdirSync(T))}e.readdirSync=n;function r(T){return T.map(j=>typeof j=="string"?S.$j?(0,v.$Pl)(j):j:(j.name=S.$j?(0,v.$Pl)(j.name):j.name,j))}async function a(T){const j=await o(T),J=[];for(const ne of j)await d.existsDirectory((0,p.$jc)(T,ne))&&J.push(ne);return J}function t(T,j=1e3){return new Promise(J=>{let ne=!1;const _=setInterval(()=>{ne||(ne=!0,I.access(T,Z=>{ne=!1,Z&&(clearInterval(_),J(void 0))}))},j)})}e.whenDeleted=t;var d;(function(T){async function j(_){let Z;try{if(Z=await e.Promises.lstat(_),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(S.$i&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw ce}throw Y}}T.stat=j;async function J(_){try{const{stat:Z,symbolicLink:Y}=await T.stat(_);return Z.isFile()&&Y?.dangling!==!0}catch{}return!1}T.existsFile=J;async function ne(_){try{const{stat:Z,symbolicLink:Y}=await T.stat(_);return Z.isDirectory()&&Y?.dangling!==!0}catch{}return!1}T.existsDirectory=ne})(d||(e.SymlinkSupport=d={}));const c=new A.$lh;function s(T,j,J){return c.queueFor(C.URI.file(T),()=>{const ne=g(J);return new Promise((_,Z)=>b(T,j,ne,Y=>Y?Z(Y):_()))},L.$Gg)}let l=!0;function h(T){l=T}e.configureFlushOnWrite=h;function b(T,j,J,ne){if(!l)return I.writeFile(T,j,{mode:J.mode,flag:J.flag},ne);I.open(T,J.flag,J.mode,(_,Z)=>{if(_)return ne(_);I.writeFile(Z,j,Y=>{if(Y)return I.close(Z,()=>ne(Y));I.fdatasync(Z,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),h(!1)),I.close(Z,ie=>ne(ie))))})})}function D(T,j,J){const ne=g(J);if(!l)return I.writeFileSync(T,j,{mode:ne.mode,flag:ne.flag});const _=I.openSync(T,ne.flag,ne.mode);try{I.writeFileSync(_,j);try{I.fdatasyncSync(_)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),h(!1)}}finally{I.closeSync(_)}}e.writeFileSync=D;function g(T){return T?{mode:typeof T.mode=="number"?T.mode:438,flag:typeof T.flag=="string"?T.flag:"w"}:{mode:438,flag:"w"}}async function f(T,j,J=6e4){if(T!==j)try{S.$i&&typeof J=="number"?await y(T,j,Date.now(),J):await(0,$.promisify)(I.rename)(T,j)}catch(ne){if(T.toLowerCase()!==j.toLowerCase()&&ne.code==="EXDEV"||T.endsWith("."))await P(T,j,{preserveSymlinks:!1}),await E(T,w.MOVE);else throw ne}}async function y(T,j,J,ne,_=0){try{return await(0,$.promisify)(I.rename)(T,j)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-J>=ne)throw console.error(`[node.js fs] rename failed after ${_} retries with error: ${Z}`),Z;if(_===0){let Y=!1;try{const{stat:ce}=await d.stat(j);ce.isFile()||(Y=!0)}catch{}if(Y)throw Z}return await(0,A.$dh)(Math.min(100,_*10)),y(T,j,J,ne,_+1)}}async function P(T,j,J){return U(T,j,{root:{source:T,target:j},options:J,handledSourcePaths:new Set})}const N=511;async function U(T,j,J){if(J.handledSourcePaths.has(T))return;J.handledSourcePaths.add(T);const{stat:ne,symbolicLink:_}=await d.stat(T);if(_){if(J.options.preserveSymlinks)try{return await M(T,j,J)}catch{}if(_.dangling)return}return ne.isDirectory()?z(T,j,ne.mode&N,J):F(T,j,ne.mode&N)}async function z(T,j,J,ne){await e.Promises.mkdir(j,{recursive:!0,mode:J});const _=await o(T);for(const Z of _)await U((0,p.$jc)(T,Z),(0,p.$jc)(j,Z),ne)}async function F(T,j,J){await e.Promises.copyFile(T,j),await e.Promises.chmod(j,J)}async function M(T,j,J){let ne=await e.Promises.readlink(T);(0,R.$dg)(ne,J.root.source,!S.$k)&&(ne=(0,p.$jc)(J.root.target,ne.substr(J.root.source.length+1))),await e.Promises.symlink(ne,j)}e.Promises=new class{get access(){return(0,$.promisify)(I.access)}get stat(){return(0,$.promisify)(I.stat)}get lstat(){return(0,$.promisify)(I.lstat)}get utimes(){return(0,$.promisify)(I.utimes)}get read(){return(T,j,J,ne,_)=>new Promise((Z,Y)=>{I.read(T,j,J,ne,_,(ce,ie,fe)=>ce?Y(ce):Z({bytesRead:ie,buffer:fe}))})}get readFile(){return(0,$.promisify)(I.readFile)}get write(){return(T,j,J,ne,_)=>new Promise((Z,Y)=>{I.write(T,j,J,ne,_,(ce,ie,fe)=>ce?Y(ce):Z({bytesWritten:ie,buffer:fe}))})}get appendFile(){return(0,$.promisify)(I.appendFile)}get fdatasync(){return(0,$.promisify)(I.fdatasync)}get truncate(){return(0,$.promisify)(I.truncate)}get copyFile(){return(0,$.promisify)(I.copyFile)}get open(){return(0,$.promisify)(I.open)}get close(){return(0,$.promisify)(I.close)}get symlink(){return(0,$.promisify)(I.symlink)}get readlink(){return(0,$.promisify)(I.readlink)}get chmod(){return(0,$.promisify)(I.chmod)}get mkdir(){return(0,$.promisify)(I.mkdir)}get unlink(){return(0,$.promisify)(I.unlink)}get rmdir(){return(0,$.promisify)(I.rmdir)}get realpath(){return(0,$.promisify)(I.realpath)}async exists(T){try{return await e.Promises.access(T),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return s}get rm(){return E}get rename(){return f}get copy(){return P}}}),define(Ce[103],Ie([1,0,57,17,11,12,31]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=void 0;function v(w){if($.$k)return w;const E=(0,O.$mc)(w);if(w===E)return w;const k=((0,O.$nc)(w)||w).toLowerCase();try{const m=(0,R.readdirSync)(E).filter(o=>o.toLowerCase()===k);if(m.length===1){const o=v(E);if(o)return(0,O.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(k);if(o>=0){const i=v(E);if(i)return(0,O.$jc)(i,m[o])}}}catch{}return null}e.$Cq=v;async function p(w){if($.$k)return w;const E=(0,O.$mc)(w);if(w===E)return w;const k=((0,O.$nc)(w)||w).toLowerCase();try{const m=(await R.Promises.readdir(E)).filter(o=>o.toLowerCase()===k);if(m.length===1){const o=await p(E);if(o)return(0,O.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(k);if(o>=0){const i=await p(E);if(i)return(0,O.$jc)(i,m[o])}}}catch{}return null}e.$Dq=p;async function S(w){try{return await R.Promises.realpath(w)}catch{const k=C(w);return await R.Promises.access(k,I.constants.R_OK),k}}e.$Eq=S;function L(w){try{return I.realpathSync(w)}catch{const k=C(w);return I.accessSync(k,I.constants.R_OK),k}}e.$Fq=L;function C(w){return(0,A.$2e)((0,O.$hc)(w),O.sep)}}),define(Ce[104],Ie([1,0,17,11,49,101,18,31]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function p(C=$.env){return C.comspec||"cmd.exe"}e.$3l=p;function S(C){let w=[],E=!1;const k=function(u){if(E){w.push(u);return}(!C.send(u,o=>{if(o&&console.error(o),E=!1,w.length>0){const i=w.slice(0);w=[],i.forEach(n=>k(n))}})||O.$i)&&(E=!0)};return{send:k}}e.$4l=S;var L;(function(C){async function w(E,k,u){if(I.$ic(E))return E;if(k===void 0&&(k=$.cwd()),I.$mc(E)!=="."||(u===void 0&&R.$Qf($.env.PATH)&&(u=$.env.PATH.split(I.$tc)),u===void 0||u.length===0))return I.$jc(k,E);async function o(i){if(await v.Promises.exists(i)){let n;try{n=await v.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await v.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of u){let n;if(I.$ic(i)?n=I.$jc(i,E):n=I.$jc(k,i,E),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return I.$jc(k,E)}C.findExecutable=w})(L||(e.win32=L={}))});var Ke=this&&this.__decorate||function(me,e,I,O){var $=arguments.length,A=$<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,I):O,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(me,e,I,O);else for(var v=me.length-1;v>=0;v--)(R=me[v])&&(A=($<3?R(A):$>3?R(e,I,A):R(e,I))||A);return $>3&&A&&Object.defineProperty(e,I,A),A};define(Ce[81],Ie([1,0,19,8,21,22,52,14,4,3,56,12,18]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=e.ProxyChannel=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.RequestInitiator=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=void 0;var E;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(E||(E={}));function k(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(u||(u={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(o||(o={}));function i(_){let Z=0;for(let Y=0;;Y+=7){const ce=_.read(1);if(Z|=(ce.buffer[0]&127)<<Y,!(ce.buffer[0]&128))return Z}}const n=c(0);function r(_,Z){if(Z===0){_.write(n);return}let Y=0;for(let ie=Z;ie!==0;ie=ie>>>7)Y++;const ce=$.$qe.alloc(Y);for(let ie=0;Z!==0;ie++)ce.buffer[ie]=Z&127,Z=Z>>>7,Z>0&&(ce.buffer[ie]|=128);_.write(ce)}class a{constructor(Z){this.b=Z,this.a=0}read(Z){const Y=this.b.slice(this.a,this.a+Z);return this.a+=Y.byteLength,Y}}e.$Mh=a;class t{constructor(){this.a=[]}get buffer(){return $.$qe.concat(this.a)}write(Z){this.a.push(Z)}}e.$Nh=t;var d;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(d||(d={}));function c(_){const Z=$.$qe.alloc(1);return Z.writeUInt8(_,0),Z}const s={Undefined:c(d.Undefined),String:c(d.String),Buffer:c(d.Buffer),VSBuffer:c(d.VSBuffer),Array:c(d.Array),Object:c(d.Object),Uint:c(d.Int)},l=typeof Buffer<"u";function h(_,Z){if(typeof Z>"u")_.write(s.Undefined);else if(typeof Z=="string"){const Y=$.$qe.fromString(Z);_.write(s.String),r(_,Y.byteLength),_.write(Y)}else if(l&&Buffer.isBuffer(Z)){const Y=$.$qe.wrap(Z);_.write(s.Buffer),r(_,Y.byteLength),_.write(Y)}else if(Z instanceof $.$qe)_.write(s.VSBuffer),r(_,Z.byteLength),_.write(Z);else if(Array.isArray(Z)){_.write(s.Array),r(_,Z.length);for(const Y of Z)h(_,Y)}else if(typeof Z=="number"&&(Z|0)===Z)_.write(s.Uint),r(_,Z);else{const Y=$.$qe.fromString(JSON.stringify(Z));_.write(s.Object),r(_,Y.byteLength),_.write(Y)}}e.$Oh=h;function b(_){switch(_.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return _.read(i(_)).toString();case d.Buffer:return _.read(i(_)).buffer;case d.VSBuffer:return _.read(i(_));case d.Array:{const Y=i(_),ce=[];for(let ie=0;ie<Y;ie++)ce.push(b(_));return ce}case d.Object:return JSON.parse(_.read(i(_)).toString());case d.Int:return i(_)}}e.$Ph=b;class D{constructor(Z,Y,ce=null,ie=1e3){this.h=Z,this.j=Y,this.k=ce,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(fe=>this.q(fe)),this.m({type:200})}registerChannel(Z,Y){this.b.set(Z,Y),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const Y=this.o([Z.type]);this.k?.logOutgoing(Y,0,1,m(Z.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(Y,Z.id,1,m(Z.type),Z.data);return}}}o(Z,Y=void 0){const ce=new t;return h(ce,Z),h(ce,Y),this.p(ce.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const Y=new a(Z),ce=b(Y),ie=b(Y),fe=ce[0];switch(fe){case 100:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${k(fe)}: ${ce[2]}.${ce[3]}`,ie),this.s({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 102:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${k(fe)}: ${ce[2]}.${ce[3]}`,ie),this.t({type:fe,id:ce[1],channelName:ce[2],name:ce[3],arg:ie});case 101:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${k(fe)}`),this.u({type:fe,id:ce[1]});case 103:return this.k?.logIncoming(Z.byteLength,ce[1],1,`${k(fe)}`),this.u({type:fe,id:ce[1]})}}s(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ce=new A.$ae;let ie;try{ie=Y.call(this.j,Z.name,Z.arg,ce.token)}catch(K){ie=Promise.reject(K)}const fe=Z.id;ie.then(K=>{this.m({id:fe,data:K,type:201})},K=>{K instanceof Error?this.m({id:fe,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:fe,data:K,type:203})}).finally(()=>{re.dispose(),this.d.delete(Z.id)});const re=(0,S.$Rc)(()=>ce.cancel());this.d.set(Z.id,re)}t(Z){const Y=this.b.get(Z.channelName);if(!Y){this.v(Z);return}const ce=Z.id,fe=Y.listen(this.j,Z.name,Z.arg)(re=>this.m({id:ce,data:re,type:204}));this.d.set(Z.id,fe)}u(Z){const Y=this.d.get(Z.id);Y&&(Y.dispose(),this.d.delete(Z.id))}v(Z){let Y=this.g.get(Z.channelName);Y||(Y=[],this.g.set(Z.channelName,Y));const ce=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:Z,timeoutTimer:ce})}w(Z){const Y=this.g.get(Z);if(Y){for(const ce of Y)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Oc)(this.d.values()),this.d.clear()}}e.$Qh=D;var g;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class f{constructor(Z,Y=null){this.l=Z,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$3d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=Y}getChannel(Z){const Y=this;return{call(ce,ie,fe){return Y.a?Promise.reject(new v.$5):Y.m(Z,ce,ie,fe)},listen(ce,ie){return Y.a?p.Event.None:Y.o(Z,ce,ie)}}}m(Z,Y,ce,ie=A.CancellationToken.None){const fe=this.g++,K={id:fe,type:100,channelName:Z,name:Y,arg:ce};if(ie.isCancellationRequested)return Promise.reject(new v.$5);let B;return new Promise((ye,le)=>{if(ie.isCancellationRequested)return le(new v.$5);const de=()=>{const X=he=>{switch(he.type){case 201:this.f.delete(fe),ye(he.data);break;case 202:{this.f.delete(fe);const be=new Error(he.data.message);be.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,be.name=he.data.name,le(be);break}case 203:this.f.delete(fe),le(he.data);break}};this.f.set(fe,X),this.p(K)};let ue=null;this.b===o.Idle?de():(ue=(0,O.$2g)(X=>this.u()),ue.then(()=>{ue=null,de()}));const ge=()=>{ue?(ue.cancel(),ue=null):this.p({id:fe,type:101}),le(new v.$5)},V=ie.onCancellationRequested(ge);B=(0,S.$Qc)((0,S.$Rc)(ge),V),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Z,Y,ce){const ie=this.g++,re={id:ie,type:102,channelName:Z,name:Y,arg:ce};let K=null;const B=new p.$3d({onWillAddFirstListener:()=>{K=(0,O.$2g)(ye=>this.u()),K.then(()=>{K=null,this.d.add(B),this.p(re)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(B),this.p({id:ie,type:103}))}}),ae=ye=>B.fire(ye.data);return this.f.set(ie,ae),B.event}p(Z){switch(Z.type){case 100:case 102:{const Y=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(Y,Z.id,0,`${k(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const Y=this.q([Z.type,Z.id]);this.j?.logOutgoing(Y,Z.id,0,k(Z.type));return}}}q(Z,Y=void 0){const ce=new t;return h(ce,Z),h(ce,Y),this.r(ce.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const Y=new a(Z),ce=b(Y),ie=b(Y),fe=ce[0];switch(fe){case 200:return this.j?.logIncoming(Z.byteLength,0,0,m(fe)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,ce[1],0,m(fe),ie),this.t({type:ce[0],id:ce[1],data:ie})}}t(Z){if(Z.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Oc)(this.d.values()),this.d.clear()}}e.$Rh=f,Ke([R.$Gh],f.prototype,"onDidInitializePromise",null);class y{get connections(){const Z=[];return this.f.forEach(Y=>Z.push(Y)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new p.$3d,this.onDidAddConnection=this.g.event,this.h=new p.$3d,this.onDidRemoveConnection=this.h.event,this.j=new S.$Sc,this.j.add(Z(({protocol:Y,onDidClientDisconnect:ce})=>{const ie=p.Event.once(Y.onMessage);this.j.add(ie(fe=>{const re=new a(fe),K=b(re),B=new D(Y,K),ae=new f(Y);this.a.forEach((le,de)=>B.registerChannel(de,le));const ye={channelServer:B,channelClient:ae,ctx:K};this.f.add(ye),this.g.fire(ye),this.j.add(ce(()=>{B.dispose(),ae.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Z,Y){const ce=this;return{call(ie,fe,re){let K;if((0,w.$5f)(Y)){const ae=(0,I.$4b)(ce.connections.filter(Y));K=ae?Promise.resolve(ae):p.Event.toPromise(p.Event.filter(ce.onDidAddConnection,Y))}else K=Y.routeCall(ce,ie,fe);const B=K.then(ae=>ae.channelClient.getChannel(Z));return N(B).call(ie,fe,re)},listen(ie,fe){if((0,w.$5f)(Y))return ce.k(Z,Y,ie,fe);const re=Y.routeEvent(ce,ie,fe).then(K=>K.channelClient.getChannel(Z));return N(re).listen(ie,fe)}}}k(Z,Y,ce,ie){const fe=this;let re;const K=new p.$3d({onWillAddFirstListener:()=>{re=new S.$Sc;const B=new p.$9d,ae=new Map,ye=de=>{const ge=de.channelClient.getChannel(Z).listen(ce,ie),V=B.add(ge);ae.set(de,V)},le=de=>{const ue=ae.get(de);ue&&(ue.dispose(),ae.delete(de))};fe.connections.filter(Y).forEach(ye),p.Event.filter(fe.onDidAddConnection,Y)(ye,void 0,re),fe.onDidRemoveConnection(le,void 0,re),B.event(K.fire,K,re),re.add(B)},onDidRemoveLastListener:()=>{re?.dispose(),re=void 0}});return K.event}registerChannel(Z,Y){this.a.set(Z,Y);for(const ce of this.f)ce.channelServer.registerChannel(Z,Y)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Sh=y;class P{constructor(Z,Y,ce=null){const ie=new t;h(ie,Y),Z.send(ie.buffer),this.a=new f(Z,ce),this.d=new D(Z,Y,ce)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,Y){this.d.registerChannel(Z,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Th=P;function N(_){return{call(Z,Y,ce){return _.then(ie=>ie.call(Z,Y,ce))},listen(Z,Y){const ce=new p.$_d;return _.then(ie=>ce.input=ie.listen(Z,Y)),ce.event}}}e.$Uh=N;function U(_){let Z=!1;return{call(Y,ce,ie){return Z?_.call(Y,ce,ie):(0,O.$dh)(0).then(()=>Z=!0).then(()=>_.call(Y,ce,ie))},listen(Y,ce){if(Z)return _.listen(Y,ce);const ie=new p.$_d;return(0,O.$dh)(0).then(()=>Z=!0).then(()=>ie.input=_.listen(Y,ce)),ie.event}}}e.$Vh=U;class z{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const Y of Z.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await p.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$Wh=z;var F;(function(_){function Z(fe,re,K){const B=fe,ae=K&&K.disableMarshalling,ye=new Map;for(const le in B)ce(le)&&ye.set(le,p.Event.buffer(B[le],!0,void 0,re));return new class{listen(le,de,ue){const ge=ye.get(de);if(ge)return ge;if(ie(de)){const V=B[de];if(typeof V=="function")return V.call(B,ue)}throw new v.$bb(`Event not found: ${de}`)}call(le,de,ue){const ge=B[de];if(typeof ge=="function"){if(!ae&&Array.isArray(ue))for(let X=0;X<ue.length;X++)ue[X]=(0,L.$Lh)(ue[X]);let V=ge.apply(B,ue);return V instanceof Promise||(V=Promise.resolve(V)),V}throw new v.$bb(`Method not found: ${de}`)}}}_.fromService=Z;function Y(fe,re){const K=re&&re.disableMarshalling;return new Proxy({},{get(B,ae){if(typeof ae=="string")return re?.properties?.has(ae)?re.properties.get(ae):ie(ae)?function(ye){return fe.listen(ae,ye)}:ce(ae)?fe.listen(ae):async function(...ye){let le;re&&!(0,w.$Zf)(re.context)?le=[re.context,...ye]:le=ye;const de=await fe.call(ae,le);return K?de:(0,L.$Lh)(de)};throw new v.$bb(`Property not found: ${String(ae)}`)}})}_.toService=Y;function ce(fe){return fe[0]==="o"&&fe[1]==="n"&&C.$gf(fe.charCodeAt(2))}function ie(fe){return/^onDynamic/.test(fe)&&C.$gf(fe.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Z=_.toString();if(Z!=="[object Object]")return Z}return _}function j(_){return Array.isArray(_)?_.map(T):T(_)}function J(_,Z,Y,ce,ie,fe,re){re=j(re);const K=M[ie],B=K[ce%K.length];let ae=[`%c[${_}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${fe}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(fe)?(ae=ae.concat(re),ae.push(")")):ae.push(re),console.log.apply(console,ae)}class ne{constructor(Z,Y){this.d=Z,this.f=Y,this.a=0,this.b=0}logOutgoing(Z,Y,ce,ie,fe){this.b+=Z,J(this.d,this.b,Z,Y,ce,ie,fe)}logIncoming(Z,Y,ce,ie,fe){this.a+=Z,J(this.f,this.a,Z,Y,ce,ie,fe)}}e.$Xh=ne}),define(Ce[82],Ie([1,0,21,4,3,81]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e.$Zh=e.ProtocolConstants=e.$Yh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var v;(function(s){s.enableDiagnostics=!1,s.records=[];const l=new WeakMap;let h=0;function b(g,f){if(!l.has(g)){const y=String(++h);l.set(g,y)}return l.get(g)}function D(g,f,y,P){if(!s.enableDiagnostics)return;const N=b(g,f);if(P instanceof I.$qe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=I.$qe.alloc(P.byteLength);U.set(P),s.records.push({timestamp:Date.now(),id:N,label:f,type:y,buff:U})}else s.records.push({timestamp:Date.now(),id:N,label:f,type:y,data:P})}s.traceSocketEvent=D})(v||(e.SocketDiagnostics=v={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let S=null;function L(){return S||(S=I.$qe.alloc(0)),S}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(l){this.a.push(l),this.b+=l.byteLength}read(l){return this.c(l,!0)}peek(l){return this.c(l,!1)}c(l,h){if(l===0)return L();if(l>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===l){const f=this.a[0];return h&&(this.a.shift(),this.b-=l),f}if(this.a[0].byteLength>l){const f=this.a[0].slice(0,l);return h&&(this.a[0]=this.a[0].slice(l),this.b-=l),f}const b=I.$qe.alloc(l);let D=0,g=0;for(;l>0;){const f=this.a[g];if(f.byteLength>l){const y=f.slice(0,l);b.set(y,D),D+=l,h&&(this.a[g]=f.slice(l),this.b-=l),l-=l}else b.set(f,D),D+=f.byteLength,h?(this.a.shift(),this.b-=f.byteLength):g++,l-=f.byteLength}return b}}e.$Yh=C;var w;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(w||(w={}));function E(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var k;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(k||(e.ProtocolConstants=k={}));class u{constructor(l,h,b,D){this.type=l,this.id=h,this.ack=b,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends $.$Tc{constructor(l){super(),this.f=this.B(new O.$3d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=l,this.b=!1,this.c=new C,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(l){if(!(!l||l.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(l);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,D=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new u(b,D,g,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(l){this.k=null,this.a=!1,this.b=!1,this.c=l,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(l){if(this.a)return;l.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=I.$qe.alloc(13);h.writeUInt8(l.type,0),h.writeUInt32BE(l.id,1),h.writeUInt32BE(l.ack,5),h.writeUInt32BE(l.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(l.type),id:l.id,ack:l.ack,messageSize:l.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",l.data),this.j(h,l.data)}g(l,h){const b=this.f===0;return this.d.push(l,h),this.f+=l.byteLength+h.byteLength,b}h(){const l=I.$qe.concat(this.d,this.f);return this.d.length=0,this.f=0,l}j(l,h){this.g(l,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const l=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:l.byteLength}),this.c.write(l)}}class i extends $.$Tc{constructor(l){super(),this.f=new O.$3d,this.onMessage=this.f.event,this.g=new O.$3d,this.onDidDispose=this.g.event,this.a=l,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(l){this.b.write(new u(1,0,0,l))}}e.$Zh=i;class n extends A.$Th{static fromSocket(l,h){return new n(new i(l),h)}get onDidDispose(){return this.b.onDidDispose}constructor(l,h,b=null){super(l,h,b),this.b=l}dispose(){super.dispose();const l=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),l.end()}}e.$1h=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$3d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(l){this.b?this.d.length>0?this.d.push(l):this.a.fire(l):this.d.push(l)}flushBuffer(){this.d=[]}}e.$2h=r;class a{constructor(l){this.data=l,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let l=0,h=this.a;for(;h;)h=h.next,l++;return l}peek(){return this.a?this.a.data:null}toArray(){const l=[];let h=0,b=this.a;for(;b;)l[h++]=b.data,b=b.next;return l}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(l){const h=new a(l);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class d{static{this.a=10}static{this.b=null}static getInstance(){return d.b||(d.b=new d),d.b}constructor(){this.c=[];const l=Date.now();for(let h=0;h<d.a;h++)this.c[h]=l-1e3*h;setInterval(()=>{for(let h=d.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const l=Date.now(),h=(1+d.a)*1e3;let b=0;for(let D=0;D<d.a;D++)l-this.c[D]<=h&&b++;return 1-b/d.a}hasHighLoad(){return this.d()>=.5}}class c{get unacknowledgedCount(){return this.c-this.d}constructor(l){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=l.loadEstimator??d.getInstance(),this.t=l.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new $.$Sc,this.o=l.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),l.initialChunk&&this.q.acceptChunk(l.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const l=new u(5,0,0,L());this.p.write(l),this.p.flush()}sendPause(){const l=new u(7,0,0,L());this.p.write(l)}sendResume(){const l=new u(8,0,0,L());this.p.write(l)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(l,h){this.a=!0,this.r.dispose(),this.r=new $.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=l,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const l=new u(3,0,this.h,L());this.p.write(l);const h=this.b.toArray();for(let b=0,D=h.length;b<D;b++)this.p.write(h[b]);this.B()}acceptDisconnect(){this.w.fire()}z(l){if(l.ack>this.d){this.d=l.ack;do{const h=this.b.peek();if(h&&h.id<=l.ack)this.b.pop();else break}while(!0)}switch(l.type){case 0:break;case 1:{if(l.id>this.g)if(l.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new u(6,0,0,L())))}else this.g=l.id,this.j=Date.now(),this.A(),this.v.fire(l.data);break}case 2:{this.u.fire(l.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let b=0,D=h.length;b<D;b++)this.p.write(h[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(l){const h=++this.c;this.h=this.g;const b=new u(1,h,this.h,l);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(l){const h=new u(2,0,0,l);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const l=Date.now()-this.j;if(l>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-l+5)}B(){if(this.c<=this.d||this.f||this.a)return;const l=this.b.peek(),h=Date.now()-l.writtenTime,b=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&b>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:b});return}const g=Math.max(2e4-h,2e4-b,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const l=new u(3,0,this.h,L());this.p.write(l)}D(){this.h=this.g;const l=new u(9,0,this.h,L());this.p.write(l)}}e.$3h=c}),define(Ce[188],Ie([1,0,50,8,21,22,186,14,4,3,24,104,101,81]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0;class k extends E.$Qh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",i=>$.$qe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$zq=k;class u{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new p.$3d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new O.$_g(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,a){return i.k(o,n,r,a)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(v.$6());this.b.cancel();const a=this.n(o),t=(0,O.$2g)(s=>a.call(i,n,s)),d=r.onCancellationRequested(()=>t.cancel()),c=(0,S.$Rc)(()=>t.cancel());return this.c.add(c),t.finally(()=>{d.dispose(),this.c.delete(c),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return p.Event.None;this.b.cancel();let r;const a=new p.$3d({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,L.$Fn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,w.$2l)(i.env),this.d=(0,I.fork)(this.i,o,i);const n=new p.$3d;p.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,R.$vq)(l)){(0,R.log)(l,`IPC Library: ${this.j.serverName}`);return}n.fire($.$qe.wrap(Buffer.from(l,"base64")))});const a=this.j.useQueue?(0,C.$4l)(this.d):this.d,t=l=>this.d&&this.d.connected&&a.send(l.buffer.toString("base64")),d=n.event,c={send:t,onMessage:d};this.f=new E.$Rh(c);const s=()=>this.o();process.once("exit",s),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,h)=>{process.removeListener("exit",s),this.c.forEach(b=>(0,S.$Oc)(b)),this.c.clear(),l!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Aq=u}),define(Ce[189],Ie([1,0,8,4,3,56,18]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.StorageState=e.$yp=e.StorageHint=void 0;var v;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function p(w){const E=w;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$yp=p;var S;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(S||(e.StorageState=S={}));class L extends $.$Tc{static{this.a=100}constructor(E,k=Object.create(null)){super(),this.r=E,this.s=k,this.b=this.B(new O.$6d),this.onDidChangeStorage=this.b.event,this.c=S.None,this.f=new Map,this.g=this.B(new I.$ah(L.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((k,u)=>this.w(u,k)),E.deleted?.forEach(k=>this.w(k,void 0))}finally{this.b.resume()}}w(E,k){if(this.c===S.Closed)return;let u=!1;(0,R.$Zf)(k)?u=this.f.delete(E):this.f.get(E)!==k&&(this.f.set(E,k),u=!0),u&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===S.None&&(this.c=S.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,k){const u=this.f.get(E);return(0,R.$Zf)(u)?k:u}getBoolean(E,k){const u=this.get(E);return(0,R.$Zf)(u)?k:u==="true"}getNumber(E,k){const u=this.get(E);return(0,R.$Zf)(u)?k:parseInt(u,10)}getObject(E,k){const u=this.get(E);return(0,R.$Zf)(u)?k:(0,A.$Kh)(u)}async set(E,k,u=!1){if(this.c===S.Closed)return;if((0,R.$Zf)(k))return this.delete(E,u);const m=(0,R.$Sf)(k)||Array.isArray(k)?(0,A.$Jh)(k):String(k);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:u}),this.D()}async delete(E,k=!1){if(!(this.c===S.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:k}),this.D()}async optimize(){if(this.c!==S.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=S.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$zp=L;class C{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((k,u)=>this.a.set(u,k)),E.delete?.forEach(k=>this.a.delete(k))}async optimize(){}async close(){}}e.$Ap=C}),define(Ce[190],Ie([1,0,12,11,21]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.$jt=void 0;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let v;function p(){return v||(v=new TextDecoder("UTF-16BE")),v}let S;function L(){return S||(S=O.$D()?R():p()),S}e.$jt=L;function C(k,u,m){const o=new Uint16Array(k.buffer,u,m);return m>0&&(o[0]===65279||o[0]===65534)?w(k,u,m):R().decode(o)}e.$kt=C;function w(k,u,m){const o=[];let i=0;for(let n=0;n<m;n++){const r=$.$se(k,u);u+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class E{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return L().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const m=this.a-this.d;m<=1&&(m===0||I.$lf(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const m=u.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=u;return}for(let o=0;o<m;o++)this.b[this.d++]=u.charCodeAt(o)}}e.$lt=E}),define(Ce[191],Ie([1,0,21,190]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=void 0;function $(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(S,L,C,w){this.oldPosition=S,this.oldText=L,this.newPosition=C,this.newText=w}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${$(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${$(this.oldText)}")`:`(replace@${this.oldPosition} "${$(this.oldText)}" with "${$(this.newText)}")`}static a(S){return 4+2*S.length}static c(S,L,C){const w=L.length;I.$ve(S,w,C),C+=4;for(let E=0;E<w;E++)I.$te(S,L.charCodeAt(E),C),C+=2;return C}static d(S,L){const C=I.$ue(S,L);return L+=4,(0,O.$kt)(S,L,C)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(S,L){return I.$ve(S,this.oldPosition,L),L+=4,I.$ve(S,this.newPosition,L),L+=4,L=A.c(S,this.oldText,L),L=A.c(S,this.newText,L),L}static read(S,L,C){const w=I.$ue(S,L);L+=4;const E=I.$ue(S,L);L+=4;const k=A.d(S,L);L+=A.a(k);const u=A.d(S,L);return L+=A.a(u),C.push(new A(w,k,E,u)),L}}e.$mt=A;function R(p,S){return p===null||p.length===0?S:new v(p,S).compress()}e.$nt=R;class v{constructor(S,L){this.a=S,this.c=L,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let S=0,L=0,C=this.n(S),w=this.l(L);for(;S<this.f||L<this.h;){if(C===null){this.k(w),w=this.l(++L);continue}if(w===null){this.m(C),C=this.n(++S);continue}if(w.oldEnd<=C.newPosition){this.k(w),w=this.l(++L);continue}if(C.newEnd<=w.oldPosition){this.m(C),C=this.n(++S);continue}if(w.oldPosition<C.newPosition){const[o,i]=v.r(w,C.newPosition-w.oldPosition);this.k(o),w=i;continue}if(C.newPosition<w.oldPosition){const[o,i]=v.q(C,w.oldPosition-C.newPosition);this.m(o),C=i;continue}let u,m;if(w.oldEnd===C.newEnd)u=C,m=w,C=this.n(++S),w=this.l(++L);else if(w.oldEnd<C.newEnd){const[o,i]=v.q(C,w.oldLength);u=o,m=w,C=i,w=this.l(++L)}else{const[o,i]=v.r(w,C.newLength);u=C,m=o,C=this.n(++S),w=i}this.d[this.e++]=new A(u.oldPosition,u.oldText,m.newPosition,m.newText),this.g+=u.newLength-u.oldLength,this.j+=m.newLength-m.oldLength}const E=v.s(this.d);return v.t(E)}k(S){this.d[this.e++]=v.o(this.g,S),this.j+=S.newLength-S.oldLength}l(S){return S<this.h?this.c[S]:null}m(S){this.d[this.e++]=v.p(this.j,S),this.g+=S.newLength-S.oldLength}n(S){return S<this.f?this.a[S]:null}static o(S,L){return new A(L.oldPosition-S,L.oldText,L.newPosition,L.newText)}static p(S,L){return new A(L.oldPosition,L.oldText,L.newPosition+S,L.newText)}static q(S,L){const C=S.newText.substr(0,L),w=S.newText.substr(L);return[new A(S.oldPosition,S.oldText,S.newPosition,C),new A(S.oldEnd,"",S.newPosition+L,w)]}static r(S,L){const C=S.oldText.substr(0,L),w=S.oldText.substr(L);return[new A(S.oldPosition,C,S.newPosition,S.newText),new A(S.oldPosition+L,w,S.newEnd,"")]}static s(S){if(S.length===0)return S;const L=[];let C=0,w=S[0];for(let E=1;E<S.length;E++){const k=S[E];w.oldEnd===k.oldPosition?w=new A(w.oldPosition,w.oldText+k.oldText,w.newPosition,w.newText+k.newText):(L[C++]=w,w=k)}return L[C++]=w,L}static t(S){if(S.length===0)return S;const L=[];let C=0;for(let w=0;w<S.length;w++){const E=S[w];E.oldText!==E.newText&&(L[C++]=E)}return L}}}),define(Ce[192],Ie([1,0,35,17]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;function $(A,R,v,p,S,L){if(Array.isArray(A)){let C=0;for(const w of A){const E=$(w,R,v,p,S,L);if(E===10)return E;E>C&&(C=E)}return C}else{if(typeof A=="string")return p?A==="*"?5:A===v?10:0:0;if(A){const{language:C,pattern:w,scheme:E,hasAccessToAllModels:k,notebookType:u}=A;if(!p&&!k)return 0;u&&S&&(R=S);let m=0;if(E)if(E===R.scheme)m=10;else if(E==="*")m=5;else return 0;if(C)if(C===v)m=10;else if(C==="*")m=Math.max(m,5);else return 0;if(u)if(u===L)m=10;else if(u==="*"&&L!==void 0)m=Math.max(m,5);else return 0;if(w){let o;if(typeof w=="string"?o=w:o={...w,base:(0,O.$hc)(w.base)},o===R.fsPath||(0,I.$Uj)(o,R.fsPath))m=10;else return 0}return m}else return 0}}e.$Kt=$}),define(Ce[193],Ie([1,0,4,12,29,80,127,168,191,3]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=void 0;class L extends S.$Tc{constructor(w,E,k,u,m,o,i){super(),this.m=this.B(new I.$3d),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=u,this.h=m,this.c=new R.$jC(w,k,i)}equals(w){return!(w instanceof L)||this.f!==w.f||this.getEOL()!==w.getEOL()?!1:this.c.equal(w.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(w){return this.c.createSnapshot(w?this.f:"")}getOffsetAt(w,E){return this.c.getOffsetAt(w,E)}getPositionAt(w){return this.c.getPositionAt(w)}getRangeAt(w,E){const k=w+E,u=this.getPositionAt(w),m=this.getPositionAt(k);return new $.$4s(u.lineNumber,u.column,m.lineNumber,m.column)}getValueInRange(w,E=0){if(w.isEmpty())return"";const k=this.n(E);return this.c.getValueInRange(w,k)}getValueLengthInRange(w,E=0){if(w.isEmpty())return 0;if(w.startLineNumber===w.endLineNumber)return w.endColumn-w.startColumn;const k=this.getOffsetAt(w.startLineNumber,w.startColumn),u=this.getOffsetAt(w.endLineNumber,w.endColumn);let m=0;const o=this.n(E),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=w.endLineNumber-w.startLineNumber;m=n*r}return u-k+m}getCharacterCountInRange(w,E=0){if(this.j){let k=0;const u=w.startLineNumber,m=w.endLineNumber;for(let o=u;o<=m;o++){const i=this.getLineContent(o),n=o===u?w.startColumn-1:0,r=o===m?w.endColumn-1:i.length;for(let a=n;a<r;a++)O.$lf(i.charCodeAt(a))?(k=k+1,a=a+1):k=k+1}return k+=this.n(E).length*(m-u),k}return this.getValueLengthInRange(w,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(w){return this.c.getLineContent(w)}getLineCharCode(w,E){return this.c.getLineCharCode(w,E)}getCharCode(w){return this.c.getCharCode(w)}getLineLength(w){return this.c.getLineLength(w)}getLineMinColumn(w){return 1}getLineMaxColumn(w){return this.getLineLength(w)+1}getLineFirstNonWhitespaceColumn(w){const E=O.$9e(this.getLineContent(w));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(w){const E=O.$$e(this.getLineContent(w));return E===-1?0:E+2}n(w){switch(w){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(w){this.c.setEOL(w)}applyEdits(w,E,k){let u=this.g,m=this.h,o=this.j,i=!0,n=[];for(let l=0;l<w.length;l++){const h=w[l];i&&h._isTracked&&(i=!1);const b=h.range;if(h.text){let P=!0;o||(P=!O.$wf(h.text),o=P),!u&&P&&(u=O.$vf(h.text)),!m&&P&&(m=O.$yf(h.text))}let D="",g=0,f=0,y=0;if(h.text){let P;[g,f,y,P]=(0,v.$Dt)(h.text);const N=this.getEOL();P===0||P===(N===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,N)}n[l]={sortIndex:l,identifier:h.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:D,eolCount:g,firstLineLength:f,lastLineLength:y,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(L.u);let r=!1;for(let l=0,h=n.length-1;l<h;l++){const b=n[l].range.getEndPosition(),D=n[l+1].range.getStartPosition();if(D.isBeforeOrEqual(b)){if(D.isBefore(b))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=k||E?L._getInverseEditRanges(n):[],t=[];if(E)for(let l=0;l<n.length;l++){const h=n[l],b=a[l];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=b.startLineNumber;D<=b.endLineNumber;D++){let g="";D===b.startLineNumber&&(g=this.getLineContent(h.range.startLineNumber),O.$9e(g)!==-1)||t.push({lineNumber:D,oldContent:g})}}let d=null;if(k){let l=0;d=[];for(let h=0;h<n.length;h++){const b=n[h],D=a[h],g=this.getValueInRange(b.range),f=b.rangeOffset+l;l+=b.text.length-g.length,d[h]={sortIndex:b.sortIndex,identifier:b.identifier,range:D,text:g,textChange:new p.$mt(b.rangeOffset,g,f,b.text)}}r||d.sort((h,b)=>h.sortIndex-b.sortIndex)}this.g=u,this.h=m,this.j=o;const c=this.t(n);let s=null;if(E&&t.length>0){t.sort((l,h)=>h.lineNumber-l.lineNumber),s=[];for(let l=0,h=t.length;l<h;l++){const b=t[l].lineNumber;if(l>0&&t[l-1].lineNumber===b)continue;const D=t[l].oldContent,g=this.getLineContent(b);g.length===0||g===D||O.$9e(g)!==-1||s.push(b)}}return this.m.fire(),new A.$nv(d,c,s)}s(w){return w.length<1e3?w:[this._toSingleEditOperation(w)]}_toSingleEditOperation(w){let E=!1;const k=w[0].range,u=w[w.length-1].range,m=new $.$4s(k.startLineNumber,k.startColumn,u.endLineNumber,u.endColumn);let o=k.startLineNumber,i=k.startColumn;const n=[];for(let c=0,s=w.length;c<s;c++){const l=w[c],h=l.range;E=E||l.forceMoveMarkers,n.push(this.getValueInRange(new $.$4s(o,i,h.startLineNumber,h.startColumn))),l.text.length>0&&n.push(l.text),o=h.endLineNumber,i=h.endColumn}const r=n.join(""),[a,t,d]=(0,v.$Dt)(r);return{sortIndex:0,identifier:w[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:d,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(w){w.sort(L.w);const E=[];for(let k=0;k<w.length;k++){const u=w[k],m=u.range.startLineNumber,o=u.range.startColumn,i=u.range.endLineNumber,n=u.range.endColumn;if(m===i&&o===n&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const r=new $.$4s(m,o,i,n);E.push({range:r,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return E}findMatchesLineByLine(w,E,k,u){return this.c.findMatchesLineByLine(w,E,k,u)}getPieceTree(){return this.c}static _getInverseEditRange(w,E){const k=w.startLineNumber,u=w.startColumn,[m,o,i]=(0,v.$Dt)(E);let n;if(E.length>0){const r=m+1;r===1?n=new $.$4s(k,u,k,u+o):n=new $.$4s(k,u,k+r-1,i+1)}else n=new $.$4s(k,u,k,u);return n}static _getInverseEditRanges(w){const E=[];let k=0,u=0,m=null;for(let o=0,i=w.length;o<i;o++){const n=w[o];let r,a;m?m.range.endLineNumber===n.range.startLineNumber?(r=k,a=u+(n.range.startColumn-m.range.endColumn)):(r=k+(n.range.startLineNumber-m.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const d=n.eolCount+1;d===1?t=new $.$4s(r,a,r,a+n.firstLineLength):t=new $.$4s(r,a,r+d-1,n.lastLineLength+1)}else t=new $.$4s(r,a,r,a);k=t.endLineNumber,u=t.endColumn,E.push(t),m=n}return E}static u(w,E){const k=$.$4s.compareRangesUsingEnds(w.range,E.range);return k===0?w.sortIndex-E.sortIndex:k}static w(w,E){const k=$.$4s.compareRangesUsingEnds(w.range,E.range);return k===0?E.sortIndex-w.sortIndex:-k}}e.$kC=L}),define(Ce[194],Ie([1,0,12,127,193]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=void 0;class A{constructor(p,S,L,C,w,E,k,u,m){this.a=p,this.b=S,this.c=L,this.d=C,this.e=w,this.f=E,this.g=k,this.h=u,this.j=m}k(p){const S=this.c+this.d+this.e,L=this.c+this.e;return S===0?p===1?`
`:`\r
`:L>S/2?`\r
`:`
`}create(p){const S=this.k(p),L=this.a;if(this.j&&(S===`\r
`&&(this.c>0||this.d>0)||S===`
`&&(this.c>0||this.e>0)))for(let w=0,E=L.length;w<E;w++){const k=L[w].buffer.replace(/\r\n|\r|\n/g,S),u=(0,O.$fC)(k);L[w]=new O.$iC(k,u)}const C=new $.$kC(L,this.b,S,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&I.$Ef(p)&&(this.b=I.$Df,p=p.substr(1));const S=p.charCodeAt(p.length-1);S===13||S>=55296&&S<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=S):(this.m(p,!1),this.c=!1,this.d=S)}m(p,S){!S&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const S=(0,O.$gC)(this.e,p);this.a.push(new O.$iC(p,S.lineStarts)),this.f+=S.cr,this.g+=S.lf,this.h+=S.crlf,S.isBasicASCII||(this.l=!1,this.j||(this.j=I.$vf(p)),this.k||(this.k=I.$yf(p)))}finish(p=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const S=(0,O.$fC)(p.buffer);p.lineStarts=S,this.d===13&&this.f++}}}e.$lC=R}),define(Ce[131],Ie([1,0,21,11]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_=e.$I_=void 0;var $;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})($||($={}));function A(C){for(let w=0,E=C.length;w<E;w+=4){const k=C[w+0],u=C[w+1],m=C[w+2],o=C[w+3];C[w+0]=o,C[w+1]=m,C[w+2]=u,C[w+3]=k}}function R(C){const w=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return O.$D()||A(w),I.$qe.wrap(w)}function v(C){const w=C.buffer;if(O.$D()||A(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const E=new Uint8Array(w.byteLength);return E.set(w),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(C){const w=new Uint32Array(S(C));let E=0;if(w[E++]=C.id,C.type==="full")w[E++]=1,w[E++]=C.data.length,w.set(C.data,E),E+=C.data.length;else{w[E++]=2,w[E++]=C.deltas.length;for(const k of C.deltas)w[E++]=k.start,w[E++]=k.deleteCount,k.data?(w[E++]=k.data.length,w.set(k.data,E),E+=k.data.length):w[E++]=0}return R(w)}e.$I_=p;function S(C){let w=0;if(w+=2,C.type==="full")w+=1+C.data.length;else{w+=1,w+=3*C.deltas.length;for(const E of C.deltas)E.data&&(w+=E.data.length)}return w}function L(C){const w=v(C);let E=0;const k=w[E++];if(w[E++]===1){const i=w[E++],n=w.subarray(E,E+i);return E+=i,{id:k,type:"full",data:n}}const m=w[E++],o=[];for(let i=0;i<m;i++){const n=w[E++],r=w[E++],a=w[E++];let t;a>0&&(t=w.subarray(E,E+a),E+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:k,type:"delta",deltas:o}}e.$J_=L}),define(Ce[195],Ie([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Ce[132],Ie([1,0,19,24,11,171,126,195]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var p;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=S;class L{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=L;class C{constructor(se,Se,Ve,Ze){this.id=se,this.name=Se,this.defaultValue=Ve,this.schema=Ze}applyUpdate(se,Se){return E(se,Se)}compute(se,Se,Ve){return Ve}}class w{constructor(se,Se){this.newValue=se,this.didChange=Se}}e.ApplyUpdateResult=w;function E(ee,se){if(typeof ee!="object"||typeof se!="object"||!ee||!se)return new w(se,ee!==se);if(Array.isArray(ee)||Array.isArray(se)){const Ve=Array.isArray(ee)&&Array.isArray(se)&&I.$ub(ee,se);return new w(se,!Ve)}let Se=!1;for(const Ve in se)if(se.hasOwnProperty(Ve)){const Ze=E(ee[Ve],se[Ve]);Ze.didChange&&(ee[Ve]=Ze.newValue,Se=!0)}return new w(ee,Se)}class k{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Se){return E(se,Se)}validate(se){return this.defaultValue}}class u{constructor(se,Se,Ve,Ze){this.id=se,this.name=Se,this.defaultValue=Ve,this.schema=Ze}applyUpdate(se,Se){return E(se,Se)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Se,Ve){return Ve}}function m(ee,se){return typeof ee>"u"?se:ee==="false"?!1:!!ee}e.boolean=m;class o extends u{constructor(se,Se,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Ve),super(se,Se,Ve,Ze)}validate(se){return m(se,this.defaultValue)}}function i(ee,se,Se,Ve){if(typeof ee>"u")return se;let Ze=parseInt(ee,10);return isNaN(Ze)?se:(Ze=Math.max(Se,Ze),Ze=Math.min(Ve,Ze),Ze|0)}e.clampedInt=i;class n extends u{static clampedInt(se,Se,Ve,Ze){return i(se,Se,Ve,Ze)}constructor(se,Se,Ve,Ze,nt,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ve,rt.minimum=Ze,rt.maximum=nt),super(se,Se,Ve,rt),this.minimum=Ze,this.maximum=nt}validate(se){return n.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function r(ee,se,Se,Ve){if(typeof ee>"u")return se;const Ze=a.float(ee,se);return a.clamp(Ze,Se,Ve)}e.clampedFloat=r;class a extends u{static clamp(se,Se,Ve){return se<Se?Se:se>Ve?Ve:se}static float(se,Se){if(typeof se=="number")return se;if(typeof se>"u")return Se;const Ve=parseFloat(se);return isNaN(Ve)?Se:Ve}constructor(se,Se,Ve,Ze,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(se,Se,Ve,nt),this.validationFn=Ze}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class t extends u{static string(se,Se){return typeof se!="string"?Se:se}constructor(se,Se,Ve,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Ve),super(se,Se,Ve,Ze)}validate(se){return t.string(se,this.defaultValue)}}function d(ee,se,Se,Ve){return typeof ee!="string"?se:Ve&&ee in Ve?Ve[ee]:Se.indexOf(ee)===-1?se:ee}e.stringSet=d;class c extends u{constructor(se,Se,Ve,Ze,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Ze,nt.default=Ve),super(se,Se,Ve,nt),this.c=Ze}validate(se){return d(se,this.defaultValue,this.c)}}class s extends C{constructor(se,Se,Ve,Ze,nt,rt,je=void 0){typeof je<"u"&&(je.type="string",je.enum=nt,je.default=Ze),super(se,Se,Ve,je),this.c=nt,this.d=rt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function l(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Se,Ve){return Ve===0?se.accessibilitySupport:Ve}}class b extends C{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:v.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertSpace:m(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function g(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function y(ee){switch(ee){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function P(ee){switch(ee){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class N extends k{constructor(){super(140)}compute(se,Se,Ve){const Ze=["monaco-editor"];return Se.get(39)&&Ze.push(Se.get(39)),se.extraEditorClassName&&Ze.push(se.extraEditorClassName),Se.get(73)==="default"?Ze.push("mouse-default"):Se.get(73)==="copy"&&Ze.push("mouse-copy"),Se.get(110)&&Ze.push("showUnused"),Se.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(se,Se,Ve){return Ve&&se.emptySelectionClipboard}}class z extends C{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:v.localize(16,null),included:$.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:v.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{cursorMoveOnType:m(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":d(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":d(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Se.loop,this.defaultValue.loop)}}}class F extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?F.OFF:se==="true"?F.ON:se:se?F.ON:F.OFF}}e.EditorFontLigatures=F;class M extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,Se,Ve){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class T extends k{constructor(){super(50)}compute(se,Se,Ve){return se.fontInfo}}class j extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(se){const Se=a.float(se,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Se,6,100)}compute(se,Se,Ve){return se.fontInfo.fontSize}}class J extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:J.d,maximum:J.e,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:J.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(n.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,J.d,J.e))}}class ne extends C{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Ve,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Ve,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Ve,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Ve,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Ve,description:v.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{multiple:d(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??d(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??d(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??d(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??d(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??d(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends C{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:v.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),delay:n.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:m(Se.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Se.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Se.above,this.defaultValue.above)}}}var Z;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class Y extends k{constructor(){super(143)}compute(se,Se,Ve){return Y.computeLayout(Se,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Se=se.height/se.lineHeight,Ve=Math.floor(se.paddingTop/se.lineHeight);let Ze=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ze=Math.max(Ze,Se-1));const nt=(Ve+se.viewLineCount+Ze)/(se.pixelRatio*se.height),rt=Math.floor(se.viewLineCount/nt);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ze,desiredRatio:nt,minimapLineCount:rt}}static c(se,Se){const Ve=se.outerWidth,Ze=se.outerHeight,nt=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const rt=Se.stableMinimapLayoutInput,je=rt&&se.outerHeight===rt.outerHeight&&se.lineHeight===rt.lineHeight&&se.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&se.pixelRatio===rt.pixelRatio&&se.scrollBeyondLastLine===rt.scrollBeyondLastLine&&se.paddingTop===rt.paddingTop&&se.paddingBottom===rt.paddingBottom&&se.minimap.enabled===rt.minimap.enabled&&se.minimap.side===rt.minimap.side&&se.minimap.size===rt.minimap.size&&se.minimap.showSlider===rt.minimap.showSlider&&se.minimap.renderCharacters===rt.minimap.renderCharacters&&se.minimap.maxColumn===rt.minimap.maxColumn&&se.minimap.scale===rt.minimap.scale&&se.verticalScrollbarWidth===rt.verticalScrollbarWidth&&se.isViewportWrapping===rt.isViewportWrapping,Et=se.lineHeight,St=se.typicalHalfwidthCharacterWidth,jt=se.scrollBeyondLastLine,Lt=se.minimap.renderCharacters;let Dt=nt>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const ei=se.minimap.maxColumn,Wt=se.minimap.size,si=se.minimap.side,xt=se.verticalScrollbarWidth,_t=se.viewLineCount,_e=se.remainingWidth,qt=se.isViewportWrapping,ti=Lt?2:3;let dt=Math.floor(nt*Ze);const $t=dt/nt;let Qt=!1,ii=!1,Rt=ti*Dt,ft=Dt/nt,Ft=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Nt,extraLinesBeyondLastLine:At,desiredRatio:Bt,minimapLineCount:Ht}=Y.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:jt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ze,lineHeight:Et,pixelRatio:nt});if(_t/Ht>1)Qt=!0,ii=!0,Dt=1,Rt=1,ft=Dt/nt;else{let It=!1,Zt=Dt+1;if(Wt==="fit"){const kt=Math.ceil((Nt+_t+At)*Rt);qt&&je&&_e<=Se.stableFitRemainingWidth?(It=!0,Zt=Se.stableFitMaxMinimapScale):It=kt>dt}if(Wt==="fill"||It){Qt=!0;const kt=Dt;Rt=Math.min(Et*nt,Math.max(1,Math.floor(1/Bt))),qt&&je&&_e<=Se.stableFitRemainingWidth&&(Zt=Se.stableFitMaxMinimapScale),Dt=Math.min(Zt,Math.max(1,Math.floor(Rt/ti))),Dt>kt&&(Ft=Math.min(2,Dt/kt)),ft=Dt/nt/Ft,dt=Math.ceil(Math.max(gt,Nt+_t+At)*Rt),qt?(Se.stableMinimapLayoutInput=se,Se.stableFitRemainingWidth=_e,Se.stableFitMaxMinimapScale=Dt):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const oi=Math.floor(ei*ft),Ot=Math.min(oi,Math.max(0,Math.floor((_e-xt-2)*ft/(St+ft)))+e.MINIMAP_GUTTER_WIDTH);let Je=Math.floor(nt*Ot);const Ut=Je/nt;Je=Math.floor(Je*Ft);const Vt=Lt?1:2,ni=si==="left"?0:Ve-Ot-xt;return{renderMinimap:Vt,minimapLeft:ni,minimapWidth:Ot,minimapHeightIsEditorHeight:Qt,minimapIsSampling:ii,minimapScale:Dt,minimapLineHeight:Rt,minimapCanvasInnerWidth:Je,minimapCanvasInnerHeight:dt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:$t}}static computeLayout(se,Se){const Ve=Se.outerWidth|0,Ze=Se.outerHeight|0,nt=Se.lineHeight|0,rt=Se.lineNumbersDigitCount|0,je=Se.typicalHalfwidthCharacterWidth,Et=Se.maxDigitWidth,St=Se.pixelRatio,jt=Se.viewLineCount,Lt=se.get(135),Dt=Lt==="inherit"?se.get(134):Lt,ei=Dt==="inherit"?se.get(130):Dt,Wt=se.get(133),si=Se.isDominatedByLongLines,xt=se.get(57),_t=se.get(67).renderType!==0,_e=se.get(68),qt=se.get(104),ti=se.get(83),dt=se.get(72),$t=se.get(102),Qt=$t.verticalScrollbarSize,ii=$t.verticalHasArrows,Rt=$t.arrowSize,ft=$t.horizontalScrollbarSize,Ft=se.get(43),oi=se.get(109)!=="never";let Ot=se.get(65);Ft&&oi&&(Ot+=16);let Je=0;if(_t){const Pt=Math.max(rt,_e);Je=Math.round(Pt*Et)}let Ut=0;xt&&(Ut=nt*Se.glyphMarginDecorationLaneCount);let Vt=0,ni=Vt+Ut,gt=ni+Je,Nt=gt+Ot;const At=Ve-Ut-Je-Ot;let Bt=!1,Ht=!1,Gt=-1;Dt==="inherit"&&si?(Bt=!0,Ht=!0):ei==="on"||ei==="bounded"?Ht=!0:ei==="wordWrapColumn"&&(Gt=Wt);const It=Y.c({outerWidth:Ve,outerHeight:Ze,lineHeight:nt,typicalHalfwidthCharacterWidth:je,pixelRatio:St,scrollBeyondLastLine:qt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:dt,verticalScrollbarWidth:Qt,viewLineCount:jt,remainingWidth:At,isViewportWrapping:Ht},Se.memory||new L);It.renderMinimap!==0&&It.minimapLeft===0&&(Vt+=It.minimapWidth,ni+=It.minimapWidth,gt+=It.minimapWidth,Nt+=It.minimapWidth);const Zt=At-It.minimapWidth,kt=Math.max(1,Math.floor((Zt-Qt-2)/je)),pt=ii?Rt:0;return Ht&&(Gt=Math.max(1,kt),ei==="bounded"&&(Gt=Math.min(Gt,Wt))),{width:Ve,height:Ze,glyphMarginLeft:Vt,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:Je,decorationsLeft:gt,decorationsWidth:Ot,contentLeft:Nt,contentWidth:Zt,minimap:It,viewportColumn:kt,isWordWrapMinified:Bt,isViewportWrapping:Ht,wrappingColumn:Gt,verticalScrollbarWidth:Qt,horizontalScrollbarHeight:ft,overviewRuler:{top:pt,width:Qt,height:Ze-2*pt,right:0}}}}e.EditorLayoutInfoComputer=Y;class ce extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(se){return d(se,"simple",["simple","advanced"])}compute(se,Se,Ve){return Se.get(2)===2?"advanced":Ve}}var ie;(function(ee){ee.Off="off",ee.OnCode="onCode",ee.On="on"})(ie||(e.ShowLightbulbIconMode=ie={}));class fe extends C{constructor(){const se={enabled:ie.OnCode};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ie.Off,ie.OnCode,ie.On],default:se.enabled,enumDescriptions:[v.localize(50,null),v.localize(51,null),v.localize(52,null)],description:v.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:d(se.enabled,this.defaultValue.enabled,[ie.Off,ie.OnCode,ie.On])}}}class re extends C{constructor(){const se={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:v.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:v.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:v.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:v.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:d(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Se.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class K extends C{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:v.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(59,null),v.localize(60,null,$.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(61,null,$.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:v.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:v.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:v.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:d(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Se.fontFamily,this.defaultValue.fontFamily),padding:m(Se.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):n.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Se,Ve){return Ve<0?n.clampedInt(-Ve*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ae extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:v.localize(66,null)})}compute(se,Se,Ve){return se.fontInfo.lineHeight}}class ye extends C{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:v.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:v.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)],default:se.size,description:v.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:v.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:v.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:v.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:v.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),autohide:m(Se.autohide,this.defaultValue.autohide),size:d(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:d(Se.side,this.defaultValue.side,["right","left"]),showSlider:d(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Se.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Se.scale,1,1,3),maxColumn:n.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ee){return ee==="ctrlCmd"?$.$j?"metaKey":"ctrlKey":"altKey"}class de extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{top:n.clampedInt(Se.top,0,0,1e3),bottom:n.clampedInt(Se.bottom,0,0,1e3)}}}class ue extends C{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:v.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:v.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),cycle:m(Se.cycle,this.defaultValue.cycle)}}}class ge extends k{constructor(){super(141)}compute(se,Se,Ve){return se.pixelRatio}}class V extends C{constructor(){const se={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(82,null),v.localize(83,null),v.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:se.strings,description:v.localize(85,null)},comments:{anyOf:Se,default:se.comments,description:v.localize(86,null)},other:{anyOf:Se,default:se.other,description:v.localize(87,null)}},default:se,markdownDescription:v.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const St=se?"on":"off";return{comments:St,strings:St,other:St}}if(!se||typeof se!="object")return this.defaultValue;const{other:Se,comments:Ve,strings:Ze}=se,nt=["on","inline","off"];let rt,je,Et;return typeof Se=="boolean"?rt=Se?"on":"off":rt=d(Se,this.defaultValue.other,nt),typeof Ve=="boolean"?je=Ve?"on":"off":je=d(Ve,this.defaultValue.comments,nt),typeof Ze=="boolean"?Et=Ze?"on":"off":Et=d(Ze,this.defaultValue.strings,nt),{other:rt,comments:je,strings:Et}}}var X;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class he extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(89,null),v.localize(90,null),v.localize(91,null),v.localize(92,null)],default:"on",description:v.localize(93,null)})}validate(se){let Se=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Se=4,Ve=se):se==="interval"?Se=3:se==="relative"?Se=2:se==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ve}}}function be(ee){const se=ee.get(97);return se==="editable"?ee.get(90):se!=="on"}e.filterValidationDecorations=be;class Pe extends C{constructor(){const se=[],Se={type:"number",description:v.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:v.localize(95,null),format:"color-hex"}}}]},default:se,description:v.localize(96,null)})}validate(se){if(Array.isArray(se)){const Se=[];for(const Ve of se)if(typeof Ve=="number")Se.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ze=Ve;Se.push({column:n.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Se.sort((Ve,Ze)=>Ve.column-Ze.column),Se}return this.defaultValue}}class pe extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ae(ee,se){if(typeof ee!="string")return se;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class Fe extends C{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(97,null),v.localize(98,null),v.localize(99,null)],default:"auto",description:v.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(101,null),v.localize(102,null),v.localize(103,null)],default:"auto",description:v.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:v.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:v.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:v.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se,Ve=n.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=n.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Se.vertical,this.defaultValue.vertical),horizontal:Ae(Se.horizontal,this.defaultValue.horizontal),useShadows:m(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(Se.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:n.clampedInt(Se.verticalSliderSize,Ze,0,1e3),scrollByPage:m(Se.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Se.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends C{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:v.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:v.localize(115,null)}})}applyUpdate(se,Se){let Ve=!1;Se.allowedCharacters&&se&&(O.$Jn(se.allowedCharacters,Se.allowedCharacters)||(se={...se,allowedCharacters:Se.allowedCharacters},Ve=!0)),Se.allowedLocales&&se&&(O.$Jn(se.allowedLocales,Se.allowedLocales)||(se={...se,allowedLocales:Se.allowedLocales},Ve=!0));const Ze=super.applyUpdate(se,Se);return Ve?new w(Ze.newValue,!0):Ze}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{nonBasicASCII:oe(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:oe(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:oe(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Se){if(typeof se!="object"||!se)return Se;const Ve={};for(const[Ze,nt]of Object.entries(se))nt===!0&&(Ve[Ze]=!0);return Ve}}class x extends C{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:v.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(117,null),v.localize(118,null),v.localize(119,null)],description:v.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:v.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:v.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),mode:d(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:d(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Se.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Se.fontFamily,this.defaultValue.fontFamily)}}}class H extends C{constructor(){const se={enabled:A.$Bs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Bs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Q extends C{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:se.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:se.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:se.highlightActiveIndentation,description:v.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{bracketPairs:oe(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:oe(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:oe(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function oe(ee,se,Se){const Ve=Se.indexOf(ee);return Ve===-1?se:Se[Ve]}class ve extends C{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:se.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:se.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{insertMode:d(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:d(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Se.showIcons,this.defaultValue.showIcons),showStatusBar:m(Se.showStatusBar,this.defaultValue.showStatusBar),preview:m(Se.preview,this.defaultValue.preview),previewMode:d(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Se.showMethods,this.defaultValue.showMethods),showFunctions:m(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Se.showFields,this.defaultValue.showFields),showVariables:m(Se.showVariables,this.defaultValue.showVariables),showClasses:m(Se.showClasses,this.defaultValue.showClasses),showStructs:m(Se.showStructs,this.defaultValue.showStructs),showInterfaces:m(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Se.showModules,this.defaultValue.showModules),showProperties:m(Se.showProperties,this.defaultValue.showProperties),showEvents:m(Se.showEvents,this.defaultValue.showEvents),showOperators:m(Se.showOperators,this.defaultValue.showOperators),showUnits:m(Se.showUnits,this.defaultValue.showUnits),showValues:m(Se.showValues,this.defaultValue.showValues),showConstants:m(Se.showConstants,this.defaultValue.showConstants),showEnums:m(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Se.showKeywords,this.defaultValue.showKeywords),showWords:m(Se.showWords,this.defaultValue.showWords),showColors:m(Se.showColors,this.defaultValue.showColors),showFiles:m(Se.showFiles,this.defaultValue.showFiles),showReferences:m(Se.showReferences,this.defaultValue.showReferences),showFolders:m(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Se.showSnippets,this.defaultValue.showSnippets),showUsers:m(Se.showUsers,this.defaultValue.showUsers),showIssues:m(Se.showIssues,this.defaultValue.showIssues)}}}class Le extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(se.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class Ge extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Se,Ve){return Se.get(2)===2?0:Ve}}class Ye extends k{constructor(){super(144)}compute(se,Se,Ve){const Ze=Se.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class it extends C{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),showDropSelector:d(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends C{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Se=se;return{enabled:m(Se.enabled,this.defaultValue.enabled),showPasteSelector:d(Se.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ot="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:$.$j?et:$.$k?Re:ot,fontWeight:"normal",fontSize:$.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var He;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.letterSpacing=63]="letterSpacing",ee[ee.lightbulb=64]="lightbulb",ee[ee.lineDecorationsWidth=65]="lineDecorationsWidth",ee[ee.lineHeight=66]="lineHeight",ee[ee.lineNumbers=67]="lineNumbers",ee[ee.lineNumbersMinChars=68]="lineNumbersMinChars",ee[ee.linkedEditing=69]="linkedEditing",ee[ee.links=70]="links",ee[ee.matchBrackets=71]="matchBrackets",ee[ee.minimap=72]="minimap",ee[ee.mouseStyle=73]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=75]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=77]="multiCursorModifier",ee[ee.multiCursorPaste=78]="multiCursorPaste",ee[ee.multiCursorLimit=79]="multiCursorLimit",ee[ee.occurrencesHighlight=80]="occurrencesHighlight",ee[ee.overviewRulerBorder=81]="overviewRulerBorder",ee[ee.overviewRulerLanes=82]="overviewRulerLanes",ee[ee.padding=83]="padding",ee[ee.pasteAs=84]="pasteAs",ee[ee.parameterHints=85]="parameterHints",ee[ee.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=88]="quickSuggestions",ee[ee.quickSuggestionsDelay=89]="quickSuggestionsDelay",ee[ee.readOnly=90]="readOnly",ee[ee.readOnlyMessage=91]="readOnlyMessage",ee[ee.renameOnType=92]="renameOnType",ee[ee.renderControlCharacters=93]="renderControlCharacters",ee[ee.renderFinalNewline=94]="renderFinalNewline",ee[ee.renderLineHighlight=95]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=97]="renderValidationDecorations",ee[ee.renderWhitespace=98]="renderWhitespace",ee[ee.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ee[ee.roundedSelection=100]="roundedSelection",ee[ee.rulers=101]="rulers",ee[ee.scrollbar=102]="scrollbar",ee[ee.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=104]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=105]="scrollPredominantAxis",ee[ee.selectionClipboard=106]="selectionClipboard",ee[ee.selectionHighlight=107]="selectionHighlight",ee[ee.selectOnLineNumbers=108]="selectOnLineNumbers",ee[ee.showFoldingControls=109]="showFoldingControls",ee[ee.showUnused=110]="showUnused",ee[ee.snippetSuggestions=111]="snippetSuggestions",ee[ee.smartSelect=112]="smartSelect",ee[ee.smoothScrolling=113]="smoothScrolling",ee[ee.stickyScroll=114]="stickyScroll",ee[ee.stickyTabStops=115]="stickyTabStops",ee[ee.stopRenderingLineAfter=116]="stopRenderingLineAfter",ee[ee.suggest=117]="suggest",ee[ee.suggestFontSize=118]="suggestFontSize",ee[ee.suggestLineHeight=119]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ee[ee.suggestSelection=121]="suggestSelection",ee[ee.tabCompletion=122]="tabCompletion",ee[ee.tabIndex=123]="tabIndex",ee[ee.unicodeHighlighting=124]="unicodeHighlighting",ee[ee.unusualLineTerminators=125]="unusualLineTerminators",ee[ee.useShadowDOM=126]="useShadowDOM",ee[ee.useTabStops=127]="useTabStops",ee[ee.wordBreak=128]="wordBreak",ee[ee.wordSeparators=129]="wordSeparators",ee[ee.wordWrap=130]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=133]="wordWrapColumn",ee[ee.wordWrapOverride1=134]="wordWrapOverride1",ee[ee.wordWrapOverride2=135]="wordWrapOverride2",ee[ee.wrappingIndent=136]="wrappingIndent",ee[ee.wrappingStrategy=137]="wrappingStrategy",ee[ee.showDeprecated=138]="showDeprecated",ee[ee.inlayHints=139]="inlayHints",ee[ee.editorClassName=140]="editorClassName",ee[ee.pixelRatio=141]="pixelRatio",ee[ee.tabFocusMode=142]="tabFocusMode",ee[ee.layoutInfo=143]="layoutInfo",ee[ee.wrappingInfo=144]="wrappingInfo",ee[ee.defaultColorDecorators=145]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(He||(e.EditorOption=He={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:ke(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:ke(new h),accessibilityPageSize:ke(new n(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:ke(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:ke(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:ke(new c(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:ke(new c(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:ke(new c(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:ke(new c(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:ke(new c(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:ke(new s(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:ke(new o(13,"automaticLayout",!1)),autoSurround:ke(new c(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:ke(new H),bracketPairGuides:ke(new Q),stickyTabStops:ke(new o(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:ke(new o(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:ke(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:ke(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:ke(new o(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:ke(new c(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:ke(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:ke(new o(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:ke(new b),contextmenu:ke(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new o(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:ke(new s(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:ke(new c(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:ke(new s(28,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:v.localize(248,null)})),cursorSurroundingLines:ke(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:ke(new c(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:ke(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:ke(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new o(34,"domReadOnly",!1)),dragAndDrop:ke(new o(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:ke(new U),dropIntoEditor:ke(new it),stickyScroll:ke(new re),experimentalWhitespaceRendering:ke(new c(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:ke(new t(39,"extraEditorClassName","")),fastScrollSensitivity:ke(new a(40,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:v.localize(259,null)})),find:ke(new z),fixedOverflowWidgets:ke(new o(42,"fixedOverflowWidgets",!1)),folding:ke(new o(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:ke(new c(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:ke(new o(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:ke(new o(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:ke(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:ke(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:ke(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:ke(new T),fontLigatures2:ke(new F),fontSize:ke(new j),fontWeight:ke(new J),fontVariations:ke(new M),formatOnPaste:ke(new o(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:ke(new o(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:ke(new o(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:ke(new ne),hideCursorInOverviewRuler:ke(new o(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:ke(new _),inDiffEditor:ke(new o(61,"inDiffEditor",!1)),letterSpacing:ke(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>a.clamp(ee,-5,20),{description:v.localize(273,null)})),lightbulb:ke(new fe),lineDecorationsWidth:ke(new B),lineHeight:ke(new ae),lineNumbers:ke(new he),lineNumbersMinChars:ke(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new o(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:ke(new o(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:ke(new c(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:ke(new ye),mouseStyle:ke(new c(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new a(74,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:ke(new o(75,"mouseWheelZoom",!1,{markdownDescription:$.$j?v.localize(278,null):v.localize(279,null)})),multiCursorMergeOverlapping:ke(new o(76,"multiCursorMergeOverlapping",!0,{description:v.localize(280,null)})),multiCursorModifier:ke(new s(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[v.localize(281,null),v.localize(282,null)],markdownDescription:v.localize(283,null)})),multiCursorPaste:ke(new c(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(284,null),v.localize(285,null)],markdownDescription:v.localize(286,null)})),multiCursorLimit:ke(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(287,null)})),occurrencesHighlight:ke(new c(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(288,null),v.localize(289,null),v.localize(290,null)],markdownDescription:v.localize(291,null)})),overviewRulerBorder:ke(new o(81,"overviewRulerBorder",!0,{description:v.localize(292,null)})),overviewRulerLanes:ke(new n(82,"overviewRulerLanes",3,0,3)),padding:ke(new de),pasteAs:ke(new ut),parameterHints:ke(new ue),peekWidgetDefaultFocus:ke(new c(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(293,null),v.localize(294,null)],description:v.localize(295,null)})),definitionLinkOpensInPeek:ke(new o(87,"definitionLinkOpensInPeek",!1,{description:v.localize(296,null)})),quickSuggestions:ke(new V),quickSuggestionsDelay:ke(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(297,null)})),readOnly:ke(new o(90,"readOnly",!1)),readOnlyMessage:ke(new pe),renameOnType:ke(new o(92,"renameOnType",!1,{description:v.localize(298,null),markdownDeprecationMessage:v.localize(299,null)})),renderControlCharacters:ke(new o(93,"renderControlCharacters",!0,{description:v.localize(300,null),restricted:!0})),renderFinalNewline:ke(new c(94,"renderFinalNewline",$.$k?"dimmed":"on",["off","on","dimmed"],{description:v.localize(301,null)})),renderLineHighlight:ke(new c(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(302,null)],description:v.localize(303,null)})),renderLineHighlightOnlyWhenFocus:ke(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(304,null)})),renderValidationDecorations:ke(new c(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new c(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(305,null),v.localize(306,null),v.localize(307,null),""],description:v.localize(308,null)})),revealHorizontalRightPadding:ke(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new o(100,"roundedSelection",!0,{description:v.localize(309,null)})),rulers:ke(new Pe),scrollbar:ke(new Fe),scrollBeyondLastColumn:ke(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(310,null)})),scrollBeyondLastLine:ke(new o(104,"scrollBeyondLastLine",!0,{description:v.localize(311,null)})),scrollPredominantAxis:ke(new o(105,"scrollPredominantAxis",!0,{description:v.localize(312,null)})),selectionClipboard:ke(new o(106,"selectionClipboard",!0,{description:v.localize(313,null),included:$.$k})),selectionHighlight:ke(new o(107,"selectionHighlight",!0,{description:v.localize(314,null)})),selectOnLineNumbers:ke(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:ke(new c(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(315,null),v.localize(316,null),v.localize(317,null)],description:v.localize(318,null)})),showUnused:ke(new o(110,"showUnused",!0,{description:v.localize(319,null)})),showDeprecated:ke(new o(138,"showDeprecated",!0,{description:v.localize(320,null)})),inlayHints:ke(new K),snippetSuggestions:ke(new c(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null),v.localize(324,null)],description:v.localize(325,null)})),smartSelect:ke(new Le),smoothScrolling:ke(new o(113,"smoothScrolling",!1,{description:v.localize(326,null)})),stopRenderingLineAfter:ke(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new ve),inlineSuggest:ke(new x),inlineCompletionsAccessibilityVerbose:ke(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(327,null)})),suggestFontSize:ke(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new o(120,"suggestOnTriggerCharacters",!0,{description:v.localize(330,null)})),suggestSelection:ke(new c(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(331,null),v.localize(332,null),v.localize(333,null)],description:v.localize(334,null)})),tabCompletion:ke(new c(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(335,null),v.localize(336,null),v.localize(337,null)],description:v.localize(338,null)})),tabIndex:ke(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new W),unusualLineTerminators:ke(new c(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),useShadowDOM:ke(new o(126,"useShadowDOM",!0)),useTabStops:ke(new o(127,"useTabStops",!0,{description:v.localize(343,null)})),wordBreak:ke(new c(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(344,null),v.localize(345,null)],description:v.localize(346,null)})),wordSeparators:ke(new t(129,"wordSeparators",R.$Cs,{description:v.localize(347,null)})),wordWrap:ke(new c(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(348,null),v.localize(349,null),v.localize(350,null),v.localize(351,null)],description:v.localize(352,null)})),wordWrapBreakAfterCharacters:ke(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(353,null)})),wordWrapOverride1:ke(new c(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new c(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new N),defaultColorDecorators:ke(new o(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(354,null)})),pixelRatio:ke(new ge),tabFocusMode:ke(new o(142,"tabFocusMode",!1,{markdownDescription:v.localize(355,null)})),layoutInfo:ke(new Y),wrappingInfo:ke(new Ye),wrappingIndent:ke(new Ge),wrappingStrategy:ke(new ce)}}),define(Ce[196],Ie([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(Ce[83],Ie([1,0,79,2,169,29,179,196]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Vt=e.$Ut=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$Tt=e.$St=e.SymbolKinds=e.SymbolTag=e.$Rt=e.$Qt=e.SymbolKind=e.$Pt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ot=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Nt=e.$Mt=e.$Lt=void 0;class p{constructor(M,T,j){this.offset=M,this.type=T,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Lt=p;class S{constructor(M,T){this.tokens=M,this.endState=T,this._tokenizationResultBrand=void 0}}e.$Mt=S;class L{constructor(M,T){this.tokens=M,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$Nt=L;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var w;(function(F){const M=new Map;M.set(0,I.$ik.symbolMethod),M.set(1,I.$ik.symbolFunction),M.set(2,I.$ik.symbolConstructor),M.set(3,I.$ik.symbolField),M.set(4,I.$ik.symbolVariable),M.set(5,I.$ik.symbolClass),M.set(6,I.$ik.symbolStruct),M.set(7,I.$ik.symbolInterface),M.set(8,I.$ik.symbolModule),M.set(9,I.$ik.symbolProperty),M.set(10,I.$ik.symbolEvent),M.set(11,I.$ik.symbolOperator),M.set(12,I.$ik.symbolUnit),M.set(13,I.$ik.symbolValue),M.set(15,I.$ik.symbolEnum),M.set(14,I.$ik.symbolConstant),M.set(15,I.$ik.symbolEnum),M.set(16,I.$ik.symbolEnumMember),M.set(17,I.$ik.symbolKeyword),M.set(27,I.$ik.symbolSnippet),M.set(18,I.$ik.symbolText),M.set(19,I.$ik.symbolColor),M.set(20,I.$ik.symbolFile),M.set(21,I.$ik.symbolReference),M.set(22,I.$ik.symbolCustomColor),M.set(23,I.$ik.symbolFolder),M.set(24,I.$ik.symbolTypeParameter),M.set(25,I.$ik.account),M.set(26,I.$ik.issues);function T(ne){let _=M.get(ne);return _||(console.info("No codicon found for CompletionItemKind "+ne),_=I.$ik.symbolProperty),_}F.toIcon=T;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function J(ne,_){let Z=j.get(ne);return typeof Z>"u"&&!_&&(Z=9),Z}F.fromString=J})(w||(e.CompletionItemKinds=w={}));var E;(function(F){F[F.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var k;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(k||(e.CompletionItemInsertTextRule=k={}));var u;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var m;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class o{constructor(M,T,j,J){this.range=M,this.text=T,this.completionKind=j,this.isSnippetText=J}equals(M){return A.$4s.lift(this.range).equalsRange(M.range)&&this.text===M.text&&this.completionKind===M.completionKind&&this.isSnippetText===M.isSnippetText}}e.$Ot=o;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(F){return F&&O.URI.isUri(F.uri)&&A.$4s.isIRange(F.range)&&(A.$4s.isIRange(F.originSelectionRange)||A.$4s.isIRange(F.targetSelectionRange))}e.$Pt=a;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Qt={17:(0,v.localize)(0,null),16:(0,v.localize)(1,null),4:(0,v.localize)(2,null),13:(0,v.localize)(3,null),8:(0,v.localize)(4,null),9:(0,v.localize)(5,null),21:(0,v.localize)(6,null),23:(0,v.localize)(7,null),7:(0,v.localize)(8,null),0:(0,v.localize)(9,null),11:(0,v.localize)(10,null),10:(0,v.localize)(11,null),19:(0,v.localize)(12,null),5:(0,v.localize)(13,null),1:(0,v.localize)(14,null),2:(0,v.localize)(15,null),20:(0,v.localize)(16,null),15:(0,v.localize)(17,null),18:(0,v.localize)(18,null),24:(0,v.localize)(19,null),3:(0,v.localize)(20,null),6:(0,v.localize)(21,null),14:(0,v.localize)(22,null),22:(0,v.localize)(23,null),25:(0,v.localize)(24,null),12:(0,v.localize)(25,null)};function d(F,M){return(0,v.localize)(26,null,F,e.$Qt[M])}e.$Rt=d;var c;(function(F){F[F.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var s;(function(F){const M=new Map;M.set(0,I.$ik.symbolFile),M.set(1,I.$ik.symbolModule),M.set(2,I.$ik.symbolNamespace),M.set(3,I.$ik.symbolPackage),M.set(4,I.$ik.symbolClass),M.set(5,I.$ik.symbolMethod),M.set(6,I.$ik.symbolProperty),M.set(7,I.$ik.symbolField),M.set(8,I.$ik.symbolConstructor),M.set(9,I.$ik.symbolEnum),M.set(10,I.$ik.symbolInterface),M.set(11,I.$ik.symbolFunction),M.set(12,I.$ik.symbolVariable),M.set(13,I.$ik.symbolConstant),M.set(14,I.$ik.symbolString),M.set(15,I.$ik.symbolNumber),M.set(16,I.$ik.symbolBoolean),M.set(17,I.$ik.symbolArray),M.set(18,I.$ik.symbolObject),M.set(19,I.$ik.symbolKey),M.set(20,I.$ik.symbolNull),M.set(21,I.$ik.symbolEnumMember),M.set(22,I.$ik.symbolStruct),M.set(23,I.$ik.symbolEvent),M.set(24,I.$ik.symbolOperator),M.set(25,I.$ik.symbolTypeParameter);function T(j){let J=M.get(j);return J||(console.info("No codicon found for SymbolKind "+j),J=I.$ik.symbolProperty),J}F.toIcon=T})(s||(e.SymbolKinds=s={}));class l{static asEditOperation(M){return $.$5s.replace(A.$4s.lift(M.range),M.text)}}e.$St=l;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(M){switch(M){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(M)}constructor(M){this.value=M}}e.$Tt=h;var b;(function(F){F[F.AIGenerated=1]="AIGenerated"})(b||(e.NewSymbolNameTag=b={}));var D;(function(F){function M(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}F.is=M})(D||(e.Command=D={}));var g;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(g||(e.CommentThreadCollapsibleState=g={}));var f;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(f||(e.CommentThreadState=f={}));var y;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(y||(e.CommentMode=y={}));var P;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(P||(e.CommentState=P={}));var N;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(N||(e.InlayHintKind=N={}));class U{constructor(M){this.b=M,this.a=null}dispose(){this.a&&this.a.then(M=>{M&&M.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ut=U,e.$Vt=new R.$Ct;var z;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(Ce[197],Ie([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[198],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[199],Ie([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[200],Ie([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(Ce[201],Ie([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[202],Ie([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[203],Ie([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[204],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Ce[205],Ie([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(Ce[206],Ie([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ce[207],Ie([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Ce[208],Ie([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[209],Ie([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[210],Ie([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Ce[211],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[212],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Ce[213],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[214],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[215],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[216],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[217],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[218],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[219],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[220],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[221],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[222],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[223],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[224],Ie([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[225],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Ce[226],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Ce[227],Ie([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Ce[228],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[229],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[230],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[231],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[232],Ie([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[233],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[234],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[235],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[236],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ce[237],Ie([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[238],Ie([1,0,14,199]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.TokenType=void 0;var $;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})($||(e.TokenType=$={}));function A(...S){switch(S.length){case 1:return(0,O.localize)(0,null,S[0]);case 2:return(0,O.localize)(1,null,S[0],S[1]);case 3:return(0,O.localize)(2,null,S[0],S[1],S[2]);default:return}}const R=(0,O.localize)(3,null),v=(0,O.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(L){switch(L.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return L.isTripleEq?"===":"==";case 4:return L.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return L.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return L.lexeme;case 18:return L.lexeme;case 19:return L.lexeme;case 20:return"EOF";default:throw(0,I.$8)(`unhandled token type: ${JSON.stringify(L)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(L=>L.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(L){return this.c=L,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(L){return this.r()||this.c.charCodeAt(this.e)!==L?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(L){this.f.push({type:L,offset:this.d})}l(L){const C=this.d,w=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:w};this.g.push({offset:C,lexeme:w,additionalInfo:L}),this.f.push(E)}n(){this.m.lastIndex=this.d;const L=this.m.exec(this.c);if(L){this.e=this.d+L[0].length;const C=this.c.substring(this.d,this.e),w=p.b.get(C);w?this.k(w):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let L=this.e,C=!1,w=!1;for(;;){if(L>=this.c.length){this.e=L,this.l(v);return}const k=this.c.charCodeAt(L);if(C)C=!1;else if(k===47&&!w){L++;break}else k===91?w=!0:k===92?C=!0:k===93&&(w=!1);L++}for(;L<this.c.length&&p.a.has(this.c.charCodeAt(L));)L++;this.e=L;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$0i=p}),define(Ce[239],Ie([1,0,23,39,202,389]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||R.test(o)}e.$jp=p;function S(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$kp=S;function L(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let d=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),d=!1);let c=0;if(o.preRelease){const s=v.exec(o.preRelease);if(s){const[,l,h,b]=s;c=Date.UTC(Number(l),Number(h)-1,Number(b))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:d,isMinimum:o.hasGreaterEquals,notBefore:c}}e.$lp=L;function C(o,i,n){let r;typeof o=="string"?r=L(S(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=L(S(n)):t=n,!r||!t)return!1;const d=r.majorBase,c=r.minorBase,s=r.patchBase;let l=t.majorBase,h=t.minorBase,b=t.patchBase;const D=t.notBefore;let g=t.majorMustEqual,f=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?d>l?!0:d<l?!1:c>h?!0:c<h||a&&a<D?!1:s>=b:(d===1&&l===0&&(!g||!f||!y)&&(l=1,h=0,b=0,g=!0,f=!1,y=!1),d<l?!1:d>l?!g:c<h?!1:c>h?!f:s<b?!1:s>b?!y:!(a&&a<D))}e.$mp=C;function w(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([O.default.Error,$.localize(0,null)]),t;if(typeof r.name!="string")return t.push([O.default.Error,$.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([O.default.Error,$.localize(2,null,"version")]),t;if(!r.engines)return t.push([O.default.Error,$.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([O.default.Error,$.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([O.default.Error,$.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([O.default.Error,$.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([O.default.Error,$.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([O.default.Warning,$.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([O.default.Error,$.localize(9,null,"main")]),t;{const s=(0,I.$Pg)(n,r.main);(0,I.$Jg)(s,n)||t.push([O.default.Warning,$.localize(10,null,s.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([O.default.Error,$.localize(11,null,"browser")]),t;{const s=(0,I.$Pg)(n,r.browser);(0,I.$Jg)(s,n)||t.push([O.default.Warning,$.localize(12,null,s.path,n.path)])}}if(!A.valid(r.version))return t.push([O.default.Error,$.localize(13,null)]),t;const d=[];if(!E(o,i,r,a,d))for(const s of d)t.push([O.default.Error,s]);return t}e.$np=w;function E(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(o,i,n.engines.vscode,a)}e.$op=E;function k(o,i,n){return o==="*"||u(i,n,o)}e.$pp=k;function u(o,i,n,r=[]){const a=L(S(n));if(!a)return r.push($.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push($.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push($.localize(16,null,n)),!1;return C(o,i,a)?!0:(r.push($.localize(17,null,o,n)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Ce[105],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=void 0;class I{constructor($,A=[],R=!1){this.ctor=$,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$_h=I}),define(Ce[84],Ie([1,0,105]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.InstantiationType=void 0;const O=[];var $;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})($||(e.InstantiationType=$={}));function A(v,p,S){p instanceof I.$_h||(p=new I.$_h(p,[],!!S)),O.push([v,p])}e.$8r=A;function R(){return O}e.$9r=R}),define(Ce[240],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class I{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Lq=I;class O{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const v=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(R);v.outgoing.set(p.key,p),p.incoming.set(v.key,v)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const v of this.a.values())v.outgoing.delete(R),v.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let v=this.a.get(R);return v||(v=new I(R,A),this.a.set(R,v)),v}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,v]of this.a)A.push(`${R}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const v=new Set([A]),p=this.c(R,v);if(p)return p}}c(A,R){for(const[v,p]of A.outgoing){if(R.has(v))return[...R,v].join(" -> ");R.add(v);const S=this.c(p,R);if(S)return S;R.delete(v)}}}e.$Mq=O}),define(Ce[5],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e._util=void 0;var I;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function v(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=v})(I||(e._util=I={})),e.$bi=$("instantiationService");function O(R,v,p){v[I.DI_TARGET]===v?v[I.DI_DEPENDENCIES].push({id:R,index:p}):(v[I.DI_DEPENDENCIES]=[{id:R,index:p}],v[I.DI_TARGET]=v)}function $(R){if(I.serviceIds.has(R))return I.serviceIds.get(R);const v=function(p,S,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(v,p,L)};return v.toString=()=>R,I.serviceIds.set(R,v),v}e.$ci=$;function A(R){return R}e.$di=A}),define(Ce[51],Ie([1,0,18,2,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ConfigurationTarget=e.$Ki=e.$Ji=e.$Ii=void 0,e.$Ii=(0,$.$ci)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof O.URI)}e.$Ji=A;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof O.URI)}e.$Ki=R;var v;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Li=p;function S(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Mi=S;function L(o,i){const n=Object.create(null);for(const r in o)C(n,r,o[r],i);return n}e.$Ni=L;function C(o,i,n,r){const a=i.split("."),t=a.pop();let d=o;for(let c=0;c<a.length;c++){const s=a[c];let l=d[s];switch(typeof l){case"undefined":l=d[s]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,c+1).join(".")} is ${JSON.stringify(l)}`);return}d=l}if(typeof d=="object"&&d!==null)try{d[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(d)}`)}e.$Oi=C;function w(o,i){const n=i.split(".");E(o,n)}e.$Pi=w;function E(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(E(r,i),Object.keys(r).length===0&&delete o[n])}}function k(o,i,n){function r(d,c){let s=d;for(const l of c){if(typeof s!="object"||s===null)return;s=s[l]}return s}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.$Qi=k;function u(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?I.$Sf(o[r])&&I.$Sf(i[r])?u(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$Ri=u;function m(o){return o.replace(/[\[\]]/g,"")}e.$Si=m}),define(Ce[45],Ie([1,0,11,12,238,5,198,14]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.ContextKeyExprType=e.$$i=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",I.$j),p.set("isLinux",I.$k),p.set("isWindows",I.$i),p.set("isWeb",I.$o),p.set("isMacNative",I.$j&&!I.$o),p.set("isEdge",I.$H),p.set("isFirefox",I.$F),p.set("isChrome",I.$E),p.set("isSafari",I.$G);function S(K,B){if(p.get(K)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(K,B)}e.$$i=S;const L=Object.prototype.hasOwnProperty;var C;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const w={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),k=(0,R.localize)(1,null),u=(0,R.localize)(2,null),m=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),r=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=w){this.k=B,this.d=new $.$0i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:k});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ae=this.l();if(!this.E()){const ye=this.D(),le=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:$.$0i.getLexeme(ye),additionalInfo:le}),a.c}return ae}catch(ae){if(ae!==a.c)throw ae;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ae=this.o();B.push(ae)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ae=this.s();B.push(ae)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),l.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ae=this.l();return this.A(1,m),ae?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ae=this.l();return this.A(1,m),ae}case 17:{const ae=B.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const de=le.lexeme,ue=de.lastIndexOf("/"),ge=ue===de.length-1?void 0:this.w(de.substring(ue+1));let V;try{V=new RegExp(de.substring(1,ue),ge)}catch{throw this.B("REGEX",le)}return T.create(ae,V)}switch(le.type){case 10:case 19:{const de=[le.lexeme];this.z();let ue=this.D(),ge=0;for(let Pe=0;Pe<le.lexeme.length;Pe++)le.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--;for(;!this.E()&&ue.type!==15&&ue.type!==16;){switch(ue.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Pe=0;Pe<ue.lexeme.length;Pe++)ue.lexeme.charCodeAt(Pe)===40?ge++:le.lexeme.charCodeAt(Pe)===41&&ge--}if(ge<0)break;de.push($.$0i.getLexeme(ue)),this.z(),ue=this.D()}const V=de.join(""),X=V.lastIndexOf("/"),he=X===V.length-1?void 0:this.w(V.substring(X+1));let be;try{be=new RegExp(V.substring(1,X),he)}catch{throw this.B("REGEX",le)}return t.regex(ae,be)}case 18:{const de=le.lexeme;this.z();let ue=null;if(!(0,O.$Qe)(de)){const ge=de.indexOf("/"),V=de.lastIndexOf("/");if(ge!==V&&ge>=0){const X=de.slice(ge+1,V),he=de[V+1]==="i"?"i":"";try{ue=new RegExp(X,he)}catch{throw this.B("REGEX",le)}}}if(ue===null)throw this.B("REGEX",le);return T.create(ae,ue)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const le=this.u();return t.notIn(ae,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ae,le);switch(le){case"true":return t.has(ae);case"false":return t.not(ae);default:return t.equals(ae,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ae,le);switch(le){case"true":return t.not(ae);case"false":return t.has(ae);default:return t.notEquals(ae,le)}}case 5:return this.z(),F.create(ae,this.u());case 6:return this.z(),M.create(ae,this.u());case 7:return this.z(),U.create(ae,this.u());case 8:return this.z(),z.create(ae,this.u());case 13:return this.z(),t.in(ae,this.u());default:return t.has(ae)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ae){if(this.C(B))return this.z();throw this.B(ae,this.D())}B(B,ae,ye){const le=(0,R.localize)(8,null,B,$.$0i.getLexeme(ae)),de=ae.offset,ue=$.$0i.getLexeme(ae);return this.h.push({message:le,offset:de,lexeme:ue,additionalInfo:ye}),a.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$_i=a;class t{static false(){return l.INSTANCE}static true(){return h.INSTANCE}static has(B){return b.create(B)}static equals(B,ae){return D.create(B,ae)}static notEquals(B,ae){return y.create(B,ae)}static regex(B,ae){return T.create(B,ae)}static in(B,ae){return g.create(B,ae)}static notIn(B,ae){return f.create(B,ae)}static not(B){return P.create(B)}static and(...B){return ne.create(B,null,!0)}static or(...B){return _.create(B,null,!0)}static greater(B,ae){return U.create(B,ae)}static greaterEquals(B,ae){return z.create(B,ae)}static smaller(B,ae){return F.create(B,ae)}static smallerEquals(B,ae){return M.create(B,ae)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$aj=t;function d(K){const B=new a({regexParsingWithErrorRecovery:!1});return K.map(ae=>(B.parse(ae),B.lexingErrors.length>0?B.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$bj=d;function c(K,B){const ae=K?K.substituteConstants():void 0,ye=B?B.substituteConstants():void 0;return!ae&&!ye?!0:!ae||!ye?!1:ae.equals(ye)}e.$cj=c;function s(K,B){return K.cmp(B)}class l{static{this.INSTANCE=new l}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return h.INSTANCE}}e.$dj=l;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return l.INSTANCE}}e.$ej=h;class b{static create(B,ae=null){const ye=p.get(B);return typeof ye=="boolean"?ye?h.INSTANCE:l.INSTANCE:new b(B,ae)}constructor(B,ae){this.key=B,this.c=ae,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=p.get(this.key);return typeof B=="boolean"?B?h.INSTANCE:l.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$fj=b;class D{static create(B,ae,ye=null){if(typeof ae=="boolean")return ae?b.create(B,ye):P.create(B,ye);const le=p.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?h.INSTANCE:l.INSTANCE:new D(B,ae,ye)}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?h.INSTANCE:l.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$gj=D;class g{static create(B,ae){return new g(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.f),ye=B.getValue(this.d);return Array.isArray(ae)?ae.includes(ye):typeof ye=="string"&&typeof ae=="object"&&ae!==null?L.call(ae,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$hj=g;class f{static create(B,ae){return new f(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=11,this.c=g.create(B,ae)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$ij=f;class y{static create(B,ae,ye=null){if(typeof ae=="boolean")return ae?P.create(B,ye):b.create(B,ye);const le=p.get(B);return typeof le=="boolean"?ae===(le?"true":"false")?l.INSTANCE:h.INSTANCE:new y(B,ae,ye)}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ae=B?"true":"false";return this.d===ae?l.INSTANCE:h.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$jj=y;class P{static create(B,ae=null){const ye=p.get(B);return typeof ye=="boolean"?ye?l.INSTANCE:h.INSTANCE:new P(B,ae)}constructor(B,ae){this.c=B,this.d=ae,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:Y(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=p.get(this.c);return typeof B=="boolean"?B?l.INSTANCE:h.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$kj=P;function N(K,B){if(typeof K=="string"){const ae=parseFloat(K);isNaN(ae)||(K=ae)}return typeof K=="string"||typeof K=="number"?B(K):l.INSTANCE}class U{static create(B,ae,ye=null){return N(ae,le=>new U(B,le,ye))}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$lj=U;class z{static create(B,ae,ye=null){return N(ae,le=>new z(B,le,ye))}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$mj=z;class F{static create(B,ae,ye=null){return N(ae,le=>new F(B,le,ye))}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$nj=F;class M{static create(B,ae,ye=null){return N(ae,le=>new M(B,le,ye))}constructor(B,ae,ye){this.c=B,this.d=ae,this.f=ye,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$oj=M;class T{static create(B,ae){return new T(B,ae)}constructor(B,ae){this.d=B,this.f=ae,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ae=this.f?this.f.source:"",ye=B.f?B.f.source:"";return ae<ye?-1:ae>ye?1:0}equals(B){if(B.type===this.type){const ae=this.f?this.f.source:"",ye=B.f?B.f.source:"";return this.d===B.d&&ae===ye}return!1}substituteConstants(){return this}evaluate(B){const ae=B.getValue(this.d);return this.f?this.f.test(ae):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=j.create(this)),this.c}}e.$pj=T;class j{static create(B){return new j(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new j(this.c.map(B))}negate(){return this.c}}e.$qj=j;function J(K){let B=null;for(let ae=0,ye=K.length;ae<ye;ae++){const le=K[ae].substituteConstants();if(K[ae]!==le&&B===null){B=[];for(let de=0;de<ae;de++)B[de]=K[de]}B!==null&&(B[ae]=le)}return B===null?K:B}class ne{static create(B,ae,ye){return ne.d(B,ae,ye)}constructor(B,ae){this.expr=B,this.c=ae,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,ye=this.expr.length;ae<ye;ae++){const le=s(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,ye=this.expr.length;ae<ye;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=J(this.expr);return B===this.expr?this:ne.create(B,this.c,!1)}evaluate(B){for(let ae=0,ye=this.expr.length;ae<ye;ae++)if(!this.expr[ae].evaluate(B))return!1;return!0}static d(B,ae,ye){const le=[];let de=!1;for(const ue of B)if(ue){if(ue.type===1){de=!0;continue}if(ue.type===0)return l.INSTANCE;if(ue.type===6){le.push(...ue.expr);continue}le.push(ue)}if(le.length===0&&de)return h.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(s);for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];for(;le.length>1;){const ue=le[le.length-1];if(ue.type!==9)break;le.pop();const ge=le.pop(),V=le.length===0,X=_.create(ue.expr.map(he=>ne.create([he,ge],null,ye)),null,V);X&&(le.push(X),le.sort(s))}if(le.length===1)return le[0];if(ye){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return l.INSTANCE;if(le.length===1)return le[0]}return new ne(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new ne(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());this.c=_.create(B,this,!0)}return this.c}}e.$rj=ne;class _{static create(B,ae,ye){return _.d(B,ae,ye)}constructor(B,ae){this.expr=B,this.c=ae,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ae=0,ye=this.expr.length;ae<ye;ae++){const le=s(this.expr[ae],B.expr[ae]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ae=0,ye=this.expr.length;ae<ye;ae++)if(!this.expr[ae].equals(B.expr[ae]))return!1;return!0}return!1}substituteConstants(){const B=J(this.expr);return B===this.expr?this:_.create(B,this.c,!1)}evaluate(B){for(let ae=0,ye=this.expr.length;ae<ye;ae++)if(this.expr[ae].evaluate(B))return!0;return!1}static d(B,ae,ye){let le=[],de=!1;if(B){for(let ue=0,ge=B.length;ue<ge;ue++){const V=B[ue];if(V){if(V.type===0){de=!0;continue}if(V.type===1)return h.INSTANCE;if(V.type===9){le=le.concat(V.expr);continue}le.push(V)}}if(le.length===0&&de)return l.INSTANCE;le.sort(s)}if(le.length!==0){if(le.length===1)return le[0];for(let ue=1;ue<le.length;ue++)le[ue-1].equals(le[ue])&&(le.splice(ue,1),ue--);if(le.length===1)return le[0];if(ye){for(let ue=0;ue<le.length;ue++)for(let ge=ue+1;ge<le.length;ge++)if(le[ue].negate().equals(le[ge]))return h.INSTANCE;if(le.length===1)return le[0]}return new _(le,ae)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ae of this.expr)B.push(...ae.keys());return B}map(B){return new _(this.expr.map(ae=>ae.map(B)),null)}negate(){if(!this.c){const B=[];for(const ae of this.expr)B.push(ae.negate());for(;B.length>1;){const ae=B.shift(),ye=B.shift(),le=[];for(const de of re(ae))for(const ue of re(ye))le.push(ne.create([de,ue],null,!1));B.unshift(_.create(le,null,!1))}this.c=_.create(B,this,!0)}return this.c}}e.$sj=_;class Z extends b{static{this.d=[]}static all(){return Z.d.values()}constructor(B,ae,ye){super(B,null),this.f=ae,typeof ye=="object"?Z.d.push({...ye,key:B}):ye!==!0&&Z.d.push({key:B,description:ye,type:ae!=null?typeof ae:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return y.create(this.key,B)}}e.$tj=Z,e.$uj=(0,A.$ci)("contextKeyService");function Y(K,B){return K<B?-1:K>B?1:0}function ce(K,B,ae,ye){return K<ae?-1:K>ae?1:B<ye?-1:B>ye?1:0}function ie(K,B){if(K.type===0||B.type===1)return!0;if(K.type===9)return B.type===9?fe(K.expr,B.expr):!1;if(B.type===9){for(const ae of B.expr)if(ie(K,ae))return!0;return!1}if(K.type===6){if(B.type===6)return fe(B.expr,K.expr);for(const ae of K.expr)if(ie(ae,B))return!0;return!1}return K.equals(B)}e.$vj=ie;function fe(K,B){let ae=0,ye=0;for(;ae<K.length&&ye<B.length;){const le=K[ae].cmp(B[ye]);if(le<0)return!1;le===0&&ae++,ye++}return ae===K.length}function re(K){return K.type===9?K.expr:[K]}}),define(Ce[241],Ie([1,0,23,39,200,5,102,11,24]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=e.$fw=e.ConfirmResult=e.$ew=e.$dw=e.$cw=void 0,e.$cw=(0,A.$ci)("dialogService");var S;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(S||(S={}));class L{a(m){return this.d(m,S.Confirmation)}b(m){return this.d(m,S.Prompt)}c(m){return this.d(m,S.Input)}d(m,o){const i=[];switch(o){case S.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,$.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,$.localize)(1,null));break}case S.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,$.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,$.localize)(3,null))),i.length===0&&i.push((0,$.localize)(4,null));break}case S.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,$.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,$.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===O.default.Info?"info":m===O.default.Error?"error":m===O.default.Warning?"warning":"none"}f(m,o,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$dw=L,e.$ew=(0,A.$ci)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const w=10;function E(u){const m=[];return m.push(...u.slice(0,w).map(o=>typeof o=="string"?o:(0,I.$Mg)(o))),u.length>w&&(u.length-w===1?m.push((0,$.localize)(7,null)):m.push((0,$.localize)(8,null,u.length-w))),m.push(""),m.join(`
`)}e.$fw=E;function k(u,m){const o=(0,p.$Fn)(u);let i=(o.buttons??[]).map(t=>(0,R.$_v)(t)),n=(u.buttons||[]).map((t,d)=>d),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(v.$k||v.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const d=n[a];n.splice(a,1),n.splice(1,0,d),a=1}v.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(v.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const d=n[a];n.splice(a,1),n.push(d),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:n}}e.$gw=k}),define(Ce[133],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=void 0,e.$ji=(0,I.$ci)("environmentService"),e.$ki=(0,I.$di)(e.$ji)}),define(Ce[134],Ie([1,0,201,5]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.ExtensionGalleryErrorCode=e.$Jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$xo=new RegExp(e.$wo),e.$yo="__web_extension",e.$zo="skipWalkthrough",e.$Ao="extensionsSync",e.$Bo="dependecyOrPackExtensionInstall";function $(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Co=$;function A(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Do=A;function R(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Eo=R;function v(n,r){return r==="web"&&!n.includes("web")}e.$Fo=v;function p(n,r,a){return v(r,a)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===a}e.$Go=p;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Ho=S;var L;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(L||(e.SortBy=L={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var w;(function(n){n.Install="install",n.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var E;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Io=(0,O.$ci)("extensionGalleryService");var k;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(k||(e.ExtensionManagementErrorCode=k={}));var u;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class m extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Jo=m;var o;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(r,a){super(r),this.code=a,this.name=a}}e.$Ko=i,e.$Lo=(0,O.$ci)("extensionManagementService"),e.$Mo="extensionsIdentifiers/disabled",e.$No="extensionsIdentifiers/enabled",e.$Oo=(0,O.$ci)("IGlobalExtensionEnablementService"),e.$Po=(0,O.$ci)("IExtensionTipsService"),e.$Qo=(0,I.localize2)(0,"Extensions"),e.$Ro=(0,I.localize2)(1,"Preferences")}),define(Ce[242],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=e.$K3b=void 0,e.$K3b=(0,I.$ci)("externalTerminal"),e.$L3b="Terminal.app"}),define(Ce[243],Ie([1,0,50,52,16,17,11,101,31,104,203,242]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L$b=e.$K$b=e.$J$b=void 0;const w=L.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends E{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(I,a,S.$3l(),t)}spawnTerminal(a,t,d,c){const s=t.windowsExec||k.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const l=A.$nc(s,".exe").toLowerCase();if(l==="cmder")return a.spawn(s,c?[c]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return s.indexOf(" ")>=0&&h.push('""'),h.push(s),l==="wt"&&h.push("-d ."),new Promise((b,D)=>{const g=o(process),f=a.spawn(d,h,{cwd:c,env:g,detached:!0});f.on("error",D),f.on("exit",()=>b())})}async runInTerminal(a,t,d,c,s){const l="windowsExec"in s&&s.windowsExec?s.windowsExec:k.getDefaultTerminalWindows(),h=await k.f();return new Promise((b,D)=>{const g=`"${t} - ${w}"`,f=`""${d.join('" "')}" & pause"`,y=Object.assign({},o(process),c);Object.keys(y).filter(F=>y[F]===null).forEach(F=>delete y[F]);const P={cwd:t,env:y,windowsVerbatimArguments:!0};let N,U;A.$nc(l,".exe")==="wt"?(N=l,U=["-d",".",k.b,"/c",f]):h?(N=h,U=["-d",t||".",l,"/c",f]):(N=k.b,U=["/c","start",g,"/wait",l,"/c",f]),I.spawn(N,U,P).on("error",F=>{D(i(F))}),b(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return k.d}static async f(){try{const a=await S.win32.findExecutable("wt");return await p.Promises.exists(a)?a:void 0}catch{return}}}e.$J$b=k,Ke([O.$Gh],k,"f",null);class u extends E{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,d,c,s){const l=s.osxExec||C.$L3b;return new Promise((h,b)=>{if(l===C.$L3b||l==="iTerm.app"){const D=l===C.$L3b?"TerminalHelper":"iTermHelper",f=[$.$wg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",a||w,"-w",t];for(const N of d)f.push("-a"),f.push(N);if(c){const N=Object.assign({},o(process),c);for(const U in N){const z=N[U];z===null?(f.push("-u"),f.push(U)):(f.push("-e"),f.push(`${U}=${z}`))}}let y="";const P=I.spawn(u.b,f);P.on("error",N=>{b(i(N))}),P.stderr.on("data",N=>{y+=N.toString()}),P.on("exit",N=>{if(N===0)h(void 0);else if(y){const U=y.split(`
`,1);b(new Error(U[0]))}else b(new Error(L.localize(1,null,D,N)))})}else b(new Error(L.localize(2,null,l)))})}spawnTerminal(a,t,d){const c=t.osxExec||C.$L3b;return new Promise((s,l)=>{const h=["-a",c];d&&h.push(d);const b=o(process),D=a.spawn("/usr/bin/open",h,{cwd:d,env:b});D.on("error",l),D.on("exit",()=>s())})}}e.$K$b=u;class m extends E{static{this.b=L.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(I,a,t)}runInTerminal(a,t,d,c,s){const l=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,b)=>{const D=[];l.then(g=>{g.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const f=`${n(d)}; echo; read -p "${m.b}" -n1;`;D.push(`''${f}''`);const y=Object.assign({},o(process),c);Object.keys(y).filter(z=>y[z]===null).forEach(z=>delete y[z]);const P={cwd:t,env:y};let N="";const U=I.spawn(g,D,P);U.on("error",z=>{b(i(z))}),U.stderr.on("data",z=>{N+=z.toString()}),U.on("exit",z=>{if(z===0)h(void 0);else if(N){const F=N.split(`
`,1);b(new Error(F[0]))}else b(new Error(L.localize(4,null,g,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$k)m.d=Promise.resolve("xterm");else{const a=await p.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(a,t,d){const c=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,l)=>{c.then(h=>{const b=o(process),D=a.spawn(h,[],{cwd:d,env:b});D.on("error",l),D.on("exit",()=>s())})})}}e.$L$b=m;function o(r){const a={...r.env};return(0,v.$1l)(a),a}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(L.localize(5,null,r.path)):r}function n(r){let a="";for(const t of r)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(Ce[32],Ie([1,0,78,17,12,18,2,204,5,11,16,43]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileKind=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileOperationResult=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileChangeType=e.$Rk=e.FileOperation=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileSystemProviderErrorCode=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderCapabilities=e.$Bk=e.FilePermission=e.FileType=e.$Ak=e.$zk=void 0,e.$zk=(0,p.$ci)("fileService");function w(ie){return ie.create===!0}e.$Ak=w;var E;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var k;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(k||(e.FilePermission=k={}));function u(ie){const fe=ie;return!!fe&&typeof fe.onDidChange=="function"}e.$Bk=u;var m;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(ie){return!!(ie.capabilities&2)}e.$Ck=o;function i(ie){return!!(ie.capabilities&8)}e.$Dk=i;function n(ie){return!!(ie.capabilities&131072)}e.$Ek=n;function r(ie){return!!(ie.capabilities&4)}e.$Fk=r;function a(ie){return!!(ie.capabilities&16)}e.$Gk=a;function t(ie){return o(ie)?!!(ie.capabilities&16384):!1}e.$Hk=t;function d(ie){return o(ie)?!!(ie.capabilities&32768):!1}e.$Ik=d;function c(ie){return!!(ie.capabilities&65536)}e.$Jk=c;function s(ie){return!!(ie.capabilities&2048)}e.$Kk=s;var l;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class h extends Error{static create(fe,re){const K=new h(fe.toString(),re);return g(K,re),K}constructor(fe,re){super(fe),this.code=re}}e.$Lk=h;function b(ie,fe){return h.create(ie,fe)}e.$Mk=b;function D(ie){return ie||b((0,v.localize)(0,null),l.Unknown)}e.$Nk=D;function g(ie,fe){return ie.name=fe?`${fe} (FileSystemError)`:"FileSystemError",ie}e.$Ok=g;function f(ie){if(!ie)return l.Unknown;if(ie instanceof h)return ie.code;const fe=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!fe)return l.Unknown;switch(fe[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}e.$Pk=f;function y(ie){if(ie instanceof M)return ie.fileOperationResult;switch(f(ie)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}e.$Qk=y;var P;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class N{constructor(fe,re,K){this.resource=fe,this.operation=re,this.target=K}isOperation(fe){return this.operation===fe}}e.$Rk=N;var U;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.a=null}constructor(fe,re){this.c=re,this.b=void 0,this.d=new C.$V(()=>{const K=I.$ii.forUris(()=>this.c);return K.fill(this.rawAdded.map(B=>[B,!0])),K}),this.f=new C.$V(()=>{const K=I.$ii.forUris(()=>this.c);return K.fill(this.rawUpdated.map(B=>[B,!0])),K}),this.g=new C.$V(()=>{const K=I.$ii.forUris(()=>this.c);return K.fill(this.rawDeleted.map(B=>[B,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of fe){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==z.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(fe,...re){return this.h(fe,{includeChildren:!1},...re)}affects(fe,...re){return this.h(fe,{includeChildren:!0},...re)}h(fe,re,...K){if(!fe)return!1;const B=K.length>0;return!!((!B||K.includes(1))&&(this.d.value.get(fe)||re.includeChildren&&this.d.value.findSuperstr(fe))||(!B||K.includes(0))&&(this.f.value.get(fe)||re.includeChildren&&this.f.value.findSuperstr(fe))||(!B||K.includes(2))&&(this.g.value.findSubstr(fe)||re.includeChildren&&this.g.value.findSuperstr(fe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(fe){return this.b===fe}hasCorrelation(){return typeof this.b=="number"}}e.$Sk=z;function F(ie,fe,re){return!ie||!fe||ie===fe||fe.length>ie.length?!1:(fe.charAt(fe.length-1)!==O.sep&&(fe+=O.sep),re?(0,$.$if)(ie,fe):ie.indexOf(fe)===0)}e.$Tk=F;class M extends Error{constructor(fe,re,K){super(fe),this.fileOperationResult=re,this.options=K}}e.$Uk=M;class T extends M{constructor(fe,re,K,B){super(fe,re,B),this.fileOperationResult=re,this.size=K}}e.$Vk=T;class j extends M{constructor(fe,re,K){super(fe,2,K),this.stat=re}}e.$Wk=j;var J;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$Xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Zk="files.associations",e.$1k="files.exclude",e.$2k="files.readonlyInclude",e.$3k="files.readonlyExclude",e.$4k="files.readonlyFromPermissions";var ne;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$5k="";function _(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$6k=_;async function Z(ie,fe){if(!fe.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(re=>{const K=fe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===ie.scheme&&B.added&&(K.dispose(),re())})})}e.$7k=Z;class Y{static{this.KB=1024}static{this.MB=Y.KB*Y.KB}static{this.GB=Y.MB*Y.KB}static{this.TB=Y.GB*Y.KB}static formatSize(fe){return(0,A.$Uf)(fe)||(fe=0),fe<Y.KB?(0,v.localize)(1,null,fe.toFixed(0)):fe<Y.MB?(0,v.localize)(2,null,(fe/Y.KB).toFixed(2)):fe<Y.GB?(0,v.localize)(3,null,(fe/Y.MB).toFixed(2)):fe<Y.TB?(0,v.localize)(4,null,(fe/Y.GB).toFixed(2)):(0,v.localize)(5,null,(fe/Y.TB).toFixed(2))}}e.$8k=Y;function ce(ie){const fe=typeof ie=="string"||ie?.scheme===L.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===L.Schemas.file?1024*Y.MB:fe?10*Y.MB:S.$o?50*Y.MB:1024*Y.MB}e.$9k=ce}),define(Ce[244],Ie([1,0,21,14,205,32]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;async function R(L,C,w,E,k,u){let m;try{await v(L,C,w,E,k,u)}catch(o){m=o}finally{m&&k.errorTransformer&&(m=k.errorTransformer(m)),typeof m<"u"&&w.error(m),w.end()}}e.$kq=R;async function v(L,C,w,E,k,u){p(u);const m=await L.open(C,{create:!1});try{p(u);let o=0,i=0,n=k&&typeof k.length=="number"?k.length:void 0,r=I.$qe.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),a=k&&typeof k.position=="number"?k.position:0,t=0;do i=await L.read(m,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await w.write(E(r)),r=I.$qe.alloc(Math.min(k.bufferSize,typeof n=="number"?n:k.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&p(u)&&S(o,k));if(t>0){let d=t;typeof n=="number"&&(d=Math.min(t,n)),w.write(E(r.slice(0,d)))}}catch(o){throw(0,A.$Nk)(o)}finally{await L.close(m)}}function p(L){if(L.isCancellationRequested)throw(0,O.$6)();return!0}function S(L,C){if(typeof C?.limits?.size=="number"&&L>C.limits.size)throw(0,A.$Mk)((0,$.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ce[85],Ie([1,0,35,3,17,11,2,32]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;function p(o){return o.recursive===!0}e.$mq=p;class S extends O.$Tc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new O.$Uc),this.f=void 0,this.g=0}s(){const i=new O.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<S.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$nq=S;class L extends S{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$oq=L;class C extends S{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$pq=C;function w(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$qq=w;function E(o){const i=new m;for(const n of o)i.processEvent(n);return i.coalesce()}e.$rq=E;function k(o,i){return typeof i=="string"&&!i.startsWith(I.$Rj)&&!(0,$.$ic)(i)?{base:o,pattern:i}:i}e.$sq=k;function u(o,i){const n=[];for(const r of i)n.push((0,I.$Vj)(k(o,r)));return n}e.$tq=u;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,v.$Tk)(r.resource.fsPath,a,!A.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(Ce[245],Ie([1,0,57,8,22,34,3,77,17,11,23,2,103,31,85]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;class u extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new O.$rh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new O.$qh(t=>this.z(t),u.b)),this.g=(0,k.$tq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,k.$tq)(this.m.path,this.m.includes):void 0,this.j=new $.$ae,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await E.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await E.Promises.realpath(i.path),i.path===n&&(n=await(0,w.$Dq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(S.$j&&(0,A.$dg)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const r=new $.$ae(this.j.token),a=new R.$Sc;try{const t=C.URI.file(this.m.path),d=(0,p.$nc)(i),c=(0,I.watch)(i);a.add((0,R.$Rc)(()=>{c.removeAllListeners(),c.close()})),this.G(`Started watching: '${i}'`);const s=new Set;if(n)try{for(const h of await E.Promises.readdir(i))s.add(h)}catch(h){this.D(h)}const l=new Map;a.add((0,R.$Rc)(()=>{for(const[,h]of l)h.dispose();l.clear()})),c.on("error",(h,b)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${b})`),this.dispose()}),c.on("change",(h,b)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${b}`);let D="";if(b&&(D=b.toString(),S.$j&&(D=(0,v.$Pl)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){l.get(D)?.dispose();const g=setTimeout(async()=>{if(l.delete(D),D===d&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const f=await this.C((0,p.$jc)(i,D));if(r.token.isCancellationRequested)return;let y;f?s.has(D)?y=0:(y=1,s.add(D)):(s.delete(D),y=2),this.y({resource:(0,L.$Pg)(t,D),type:y,cId:this.m.correlationId})},u.a);l.set(D,(0,R.$Rc)(()=>clearTimeout(g)))}else{let g;s.has(D)?g=0:(g=1,s.add(D)),this.y({resource:(0,L.$Pg)(t,D),type:g,cId:this.m.correlationId})}else if(h==="rename"||D!==d){const g=setTimeout(async()=>{const f=await E.Promises.exists(i);r.token.isCancellationRequested||(f?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);a.clear(),a.add((0,R.$Rc)(()=>clearTimeout(g)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,k.$rq)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(S.$k)return E.Promises.exists(i);try{const n=(0,p.$nc)(i);return(await E.Promises.readdir((0,p.$mc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Gq=u;async function m(o,i,n,r,a=512){const t=await E.Promises.open(o,"r"),d=Buffer.allocUnsafe(a),c=new $.$ae(r);let s,l=!1;const h={path:o,excludes:[],recursive:!1},b=new u(h,D=>{(async()=>{for(const{type:g}of D)if(g===0){if(l)return;l=!0;try{for(;!c.token.isCancellationRequested;){const{bytesRead:f}=await E.Promises.read(t,d,0,a,null);if(!f||c.token.isCancellationRequested)break;i(d.slice(0,f))}}catch(f){s=new Error(f),c.dispose(!0)}finally{l=!1}}})()});return await b.ready,n(),new Promise((D,g)=>{c.token.onCancellationRequested(async()=>{b.dispose();try{await E.Promises.close(t)}catch(f){s=new Error(f)}s?g(s):D()})})}e.$Hq=m}),define(Ce[246],Ie([1,0,4,35,3,11,245]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;class v extends $.$Tc{constructor(){super(...arguments),this.a=this.B(new I.$3d),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$3d),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(S){const L=this.j(S),C=L.filter(E=>{const k=this.c.get(E.path);return k?!(0,O.$Zj)(k.request.excludes,E.excludes)||!(0,O.$Zj)(k.request.includes,E.includes):!0}),w=Array.from(this.c.values()).filter(({request:E})=>!L.find(k=>k.path===E.path&&(0,O.$Zj)(k.excludes,E.excludes)&&(0,O.$Zj)(k.includes,E.includes))).map(({request:E})=>E.path);C.length&&this.m(`Request to start watching: ${C.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const E of w)this.h(E);for(const E of C)this.g(E)}g(S){const L=new R.$Gq(S,w=>this.a.fire(w),w=>this.b.fire(w),this.f),C={request:S,instance:L};this.c.set(S.path,C)}async stop(){for(const[S]of this.c)this.h(S);this.c.clear()}h(S){const L=this.c.get(S);L&&(this.c.delete(S),L.instance.dispose())}j(S){const L=new Map;for(const C of S){const w=A.$k?C.path:C.path.toLowerCase();let E=L.get(C.correlationId);E||(E=new Map,L.set(C.correlationId,E)),E.set(w,C)}return Array.from(L.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(S){this.f=S;for(const[,L]of this.c)L.instance.setVerboseLogging(S)}m(S){this.f&&this.b.fire({type:"trace",message:this.n(S)})}n(S,L){return L?`[File Watcher (node.js)] ${S} (path: ${L.request.path})`:`[File Watcher (node.js)] ${S}`}}e.$Iq=v}),define(Ce[247],Ie([1,0,85,246]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;class $ extends I.$oq{constructor(R,v,p){super(R,v,p),this.s()}r(R){return R.add(new O.$Iq)}}e.$Jq=$}),define(Ce[248],Ie([1,0,16,81,188,85]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class R extends A.$pq{constructor(p,S,L){super(p,S,L),this.s()}r(p){const S=p.add(new $.$Aq(I.$wg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(S.onDidProcessExit(({code:L,signal:C})=>this.t(`terminated by itself with code ${L}, signal: ${C}`))),O.ProxyChannel.toService((0,O.$Vh)(S.getChannel("watcher")))}}e.$Bq=R}),define(Ce[106],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=void 0;class I{constructor(...$){this.a=new Map;for(const[A,R]of $)this.set(A,R)}set($,A){const R=this.a.get($);return this.a.set($,A),R}has($){return this.a.has($)}get($){return this.a.get($)}}e.$ai=I}),define(Ce[249],Ie([1,0,8,14,3,105,240,5,106,76]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;const L=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class w{constructor(m=new p.$ai,o=!1,i,n=L){this.f=m,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(v.$bi,this),this._globalGraph=n?i?._globalGraph??new R.$Mq(r=>r):void 0}createChild(m){return new w(m,this.g,this,this.i)}invokeFunction(m,...o){const i=k.traceInvocation(this.i,m);let n=!1;try{return m({get:a=>{if(n)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(m,...o){let i,n;return m instanceof A.$_h?(i=k.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(o),i)):(i=k.traceCreation(this.i,m),n=this.j(m,o,i)),i.stop(),n}j(m,o=[],i){const n=v._util.getServiceDependencies(m).sort((t,d)=>t.index-d.index),r=[];for(const t of n){const d=this.m(t.id,i);d||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(d)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${m.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(m,o.concat(r))}k(m,o){if(this.f.get(m)instanceof A.$_h)this.f.set(m,o);else if(this.h)this.h.k(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const o=this.f.get(m);return!o&&this.h?this.h.l(m):o}m(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof A.$_h?this.q(m,i,o.branch(m,!0)):(o.branch(m,!1),i)}q(m,o,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,o,i)}finally{this.o.delete(m)}}r(m,o,i){const n=new R.$Mq(t=>t.id.toString());let r=0;const a=[{id:m,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new C(n);for(const d of v._util.getServiceDependencies(t.desc.ctor)){const c=this.l(d.id);if(c||this.u(`[createInstance] ${m} depends on ${d.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(d.id)),c instanceof A.$_h){const s={id:d.id,desc:c,_trace:t._trace.branch(d.id,!0)};n.insertEdge(t,s),a.push(s)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:d}of t){if(this.l(d.id)instanceof A.$_h){const s=this.s(d.id,d.desc.ctor,d.desc.staticArguments,d.desc.supportsDelayedInstantiation,d._trace);this.k(d.id,s)}n.removeNode(d)}}return this.l(m)}s(m,o,i=[],n,r){if(this.f.get(m)instanceof A.$_h)return this.t(m,o,i,n,r);if(this.h)return this.h.s(m,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(m,o,i=[],n,r){if(n){const a=new w(void 0,this.g,this,this.i);a.c=String(m);const t=new Map,d=new I.$vh(()=>{const c=a.j(o,i,r);for(const[s,l]of t){const h=c[s];if(typeof h=="function")for(const b of l)b.disposable=h.apply(c,b.listener)}return t.clear(),c});return new Proxy(Object.create(null),{get(c,s){if(!d.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let b=t.get(s);return b||(b=new S.$4c,t.set(s,b)),(g,f,y)=>{if(d.isInitialized)return d.value[s](g,f,y);{const P={listener:[g,f,y],disposable:void 0},N=b.push(P);return(0,$.$Rc)(()=>{N(),P.disposable?.dispose()})}}}if(s in c)return c[s];const l=d.value;let h=l[s];return typeof h!="function"||(h=h.bind(l),c[s]=h),h},set(c,s,l){return d.value[s]=l,!0},getPrototypeOf(c){return o.prototype}})}else return this.j(o,i,r)}u(m,o){if(o&&console.warn(m),this.g)throw new Error(m)}}e.$Nq=w;var E;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(E||(E={}));class k{static{this.all=new Set}static{this.c=new class extends k{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new k(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):k.c}static traceCreation(m,o){return m?new k(1,o.name):k.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const i=new k(3,m.toString());return this.h.push([m,o,i]),i}stop(){const m=Date.now()-this.g;k.f+=m;let o=!1;function i(r,a){const t=[],d=new Array(r+1).join("	");for(const[c,s,l]of a.h)if(s&&l){o=!0,t.push(`${d}CREATES -> ${c}`);const h=i(r+1,l);h&&t.push(h)}else t.push(`${d}uses -> ${c}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${k.f.toFixed(2)}ms)`];(m>2||o)&&k.all.add(n.join(`
`))}}e.$Oq=k}),define(Ce[13],Ie([1,0,44,4,54,3,28,11,23,18,2,45,5]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.log=e.$zj=e.LogLevel=e.$yj=e.$xj=e.$wj=void 0,e.$wj=(0,w.$ci)("logService"),e.$xj=(0,w.$ci)("loggerService");function E(){return new Date().toISOString()}function k(g){return(0,S.$Uf)(g)}e.$yj=k;var u;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$zj=u.Info;function m(g,f,y){switch(f){case u.Trace:g.trace(y);break;case u.Debug:g.debug(y);break;case u.Info:g.info(y);break;case u.Warning:g.warn(y);break;case u.Error:g.error(y);break;case u.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=m;function o(g,f=!1){let y="";for(let P=0;P<g.length;P++){let N=g[P];if(N instanceof Error&&(N=(0,I.$Zi)(N,f)),typeof N=="object")try{N=JSON.stringify(N)}catch{}y+=(P>0?" ":"")+N}return y}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$zj,this.c=this.B(new O.$3d),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==u.Off&&this.b<=f}}e.$Bj=i;class n extends i{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...y){this.f(u.Trace)&&this.g(u.Trace,o([f,...y],!0))}debug(f,...y){this.f(u.Debug)&&this.g(u.Debug,o([f,...y]))}info(f,...y){this.f(u.Info)&&this.g(u.Info,o([f,...y]))}warn(f,...y){this.f(u.Warning)&&this.g(u.Warning,o([f,...y]))}error(f,...y){if(this.f(u.Error))if(f instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=f.stack,this.g(u.Error,o(P))}else this.g(u.Error,o([f,...y]))}flush(){}}e.$Cj=n;class r extends i{constructor(f=e.$zj){super(),this.setLevel(f),this.g=!v.$i}trace(f,...y){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}debug(f,...y){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}info(f,...y){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,f,...y):console.log(`[main ${E()}]`,f,...y))}warn(f,...y){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,f,...y):console.warn(`[main ${E()}]`,f,...y))}error(f,...y){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,f,...y):console.error(`[main ${E()}]`,f,...y))}flush(){}}e.$Dj=r;class a extends i{constructor(f=e.$zj,y=!0){super(),this.g=y,this.setLevel(f)}trace(f,...y){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...y):console.log(f,...y))}debug(f,...y){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...y):console.log(f,...y))}info(f,...y){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...y):console.log(f,...y))}warn(f,...y){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...y):console.log(f,...y))}error(f,...y){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...y):console.error(f,...y))}flush(){}}e.$Ej=a;class t extends i{constructor(f,y=e.$zj){super(),this.g=f,this.setLevel(y)}trace(f,...y){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(f),...y])}debug(f,...y){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(f),...y])}info(f,...y){this.f(u.Info)&&this.g.log(u.Info,[this.h(f),...y])}warn(f,...y){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(f),...y])}error(f,...y){this.f(u.Error)&&this.g.log(u.Error,[this.h(f),...y])}h(f){return typeof f=="string"?f:(0,I.$Zi)(f,this.f(u.Trace))}flush(){}}e.$Fj=t;class d extends i{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const y of this.g)y.setLevel(f);super.setLevel(f)}trace(f,...y){for(const P of this.g)P.trace(f,...y)}debug(f,...y){for(const P of this.g)P.debug(f,...y)}info(f,...y){for(const P of this.g)P.info(f,...y)}warn(f,...y){for(const P of this.g)P.warn(f,...y)}error(f,...y){for(const P of this.g)P.error(f,...y)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose();super.dispose()}}e.$Gj=d;class c extends A.$Tc{constructor(f,y,P){if(super(),this.h=f,this.j=y,this.b=new R.$Ac,this.c=this.B(new O.$3d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$3d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$3d),this.onDidChangeVisibility=this.g.event,P)for(const N of P)this.b.set(N.resource,{logger:void 0,info:N})}m(f){return(0,S.$Qf)(f)?[...this.b.values()].find(y=>y.info.id===f):this.b.get(f)}getLogger(f){return this.m(f)?.logger}createLogger(f,y){const P=this.n(f),N=(0,S.$Qf)(f)?f:y?.id??(0,$.$3i)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const z=y?.logLevel==="always"?u.Trace:y?.logLevel;U||(U=this.s(P,z??this.getLogLevel(P)??this.h,{...y,id:N}));const F={logger:U,info:{resource:P,id:N,logLevel:z,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(F.info),this.b.set(P,F),U}n(f){return(0,S.$Qf)(f)?(0,p.$Pg)(this.j,`${f}.log`):f}setLogLevel(f,y){if(L.URI.isUri(f)){const P=f,N=y,U=this.b.get(P);U&&N!==U.info.logLevel&&(U.info.logLevel=N===this.h?void 0:N,U.logger?.setLevel(N),this.b.set(U.info.resource,U),this.f.fire([P,N]))}else{this.h=f;for(const[P,N]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,y){const P=this.m(f);P&&y!==!P.info.hidden&&(P.info.hidden=!y,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,y]))}getLogLevel(f){let y;return f&&(y=this.b.get(f)?.info.logLevel),y??this.h}registerLogger(f){const y=this.b.get(f.resource);y?y.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const y=this.b.get(f);y&&(y.logger&&y.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Hj=c;class s{constructor(){this.onDidChangeLogLevel=new O.$3d().event}setLevel(f){}getLevel(){return u.Info}trace(f,...y){}debug(f,...y){}info(f,...y){}warn(f,...y){}error(f,...y){}critical(f,...y){}dispose(){}flush(){}}e.$Ij=s;class l extends s{}e.$Jj=l;function h(g){if(g.verbose)return u.Trace;if(typeof g.logLevel=="string"){const f=D(g.logLevel.toLowerCase());if(f!==void 0)return f}return e.$zj}e.$Kj=h;function b(g){switch(g){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$Lj=b;function D(g){switch(g){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$Mj=D,e.$Nj=new C.$tj("logLevel",b(u.Info))}),define(Ce[250],Ie([1,0,19,8,14,4,3,17,85,13]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;class L extends R.$Tc{constructor(w,E){super(),this.a=w,this.b=E,this.c=this.B(new A.$3d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$3d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$ah(0)),this.w=[],this.y=this.B(new O.$ah(0))}watch(w,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(w,E):this.z(w,E)}n(w,E){const k={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},u=(0,I.$Ub)(this.j,k);return this.r(),(0,R.$Rc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,$.$1)(w))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,p.$qq)(E)),E=>this.G(E),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const E of this.j)(0,p.$mq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const E of this.j)(0,p.$mq)(E)&&w.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,E){const k={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},u=(0,I.$Ub)(this.w,k);return this.C(),(0,R.$Rc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,$.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,p.$qq)(w)),w=>this.G(w),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,v.$hc)(w.fsPath)}}e.$uq=L}),define(Ce[251],Ie([1,0,57,390,8,28,21,4,34,3,17,11,23,98,31,206,32,244,250,44,248,247]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0,(()=>{try{(0,O.gracefulify)(I)}catch(d){console.error(`Error enabling graceful-fs: ${(0,n.$Zi)(d)}`)}})();class t extends i.$uq{static{this.I=!1}constructor(c,s){super(c,s),this.onDidChangeCapabilities=v.Event.None,this.N=new A.$Ac(l=>w.$Gg.getComparisonKey(l)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(c){try{const{stat:s,symbolicLink:l}=await k.SymlinkSupport.stat(this.H(c));return{type:this.M(s,l),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(c){try{return await this.stat(c)}catch{return}}async readdir(c){try{const s=await k.Promises.readdir(this.H(c),{withFileTypes:!0}),l=[];return await Promise.all(s.map(async h=>{try{let b;h.isSymbolicLink()?b=(await this.stat((0,w.$Pg)(c,h.name))).type:b=this.M(h),l.push([h.name,b])}catch(b){this.a.trace(b)}})),l}catch(s){throw this.fb(s)}}M(c,s){let l;return s?.dangling?l=m.FileType.Unknown:c.isFile()?l=m.FileType.File:c.isDirectory()?l=m.FileType.Directory:l=m.FileType.Unknown,s&&(l|=m.FileType.SymbolicLink),l}async O(c){const s=this.H(c);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let l;for(;l=this.N.get(c);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await l.wait();const h=new $.$bh;return this.N.set(c,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,S.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(c)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(c)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),h.open()})}async readFile(c,s){let l;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(c)})`),l=await this.O(c));const h=this.H(c);return await k.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{l?.dispose()}}P(c){t.I&&this.a.trace(c)}readFileStream(c,s,l){const h=(0,E.$ee)(b=>R.$qe.concat(b.map(D=>R.$qe.wrap(D))).buffer);return(0,o.$kq)(this,c,h,b=>b.buffer,{...s,bufferSize:256*1024},l),h}async writeFile(c,s,l){return l?.atomic!==!1&&l?.atomic?.postfix&&await this.Q(c)?this.R(c,(0,w.$Pg)((0,w.$Og)(c),`${(0,w.$Mg)(c)}${l.atomic.postfix}`),s,l):this.S(c,s,l)}async Q(c){try{const s=this.H(c),{symbolicLink:l}=await k.SymlinkSupport.stat(s);if(l)return!1}catch{}return!0}async R(c,s,l,h){const b=new S.$Sc;try{b.add(await this.O(c)),b.add(await this.O(s)),await this.S(s,l,h,!0);try{await this.rename(s,c,{overwrite:!0})}catch(D){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{b.dispose()}}async S(c,s,l,h){let b;try{const D=this.H(c);if(!l.create||!l.overwrite){if(await k.Promises.exists(D)){if(!l.overwrite)throw(0,m.$Mk)((0,u.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,m.$Mk)((0,u.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(c,{create:!0,unlock:l.unlock},h),await this.write(b,0,s,0,s.byteLength)}catch(D){throw await this.gb(c,D)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(c){t.Y=c}async open(c,s,l){const h=this.H(c);let b;(0,m.$Ak)(s)&&!l&&(b=await this.O(c));let D;try{if((0,m.$Ak)(s)&&s.unlock)try{const{stat:f}=await k.SymlinkSupport.stat(h);f.mode&128||await k.Promises.chmod(h,f.mode|128)}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}let g;if((0,m.$Ak)(s)){if(C.$i)try{await k.Promises.truncate(h,0),g="r+"}catch(f){f.code!=="ENOENT"&&this.a.trace(f)}g||(g="w")}else g="r";D=await k.Promises.open(h,g)}catch(g){throw b?.dispose(),(0,m.$Ak)(s)?await this.gb(c,g):this.fb(g)}if(this.U.set(D,0),(0,m.$Ak)(s)&&this.X.set(D,c),b){const g=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,b),g&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),g.dispose())}return D}async close(c){const s=this.W.get(c);try{if(this.U.delete(c),this.X.delete(c)&&t.Y)try{await k.Promises.fdatasync(c)}catch(l){t.configureFlushOnWrite(!1),this.a.error(l)}return await k.Promises.close(c)}catch(l){throw this.fb(l)}finally{s&&(this.W.get(c)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${c}`),this.W.delete(c)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${c}`),s.dispose())}}async read(c,s,l,h,b){const D=this.Z(c,s);let g=null;try{g=(await k.Promises.read(c,l,h,b,D)).bytesRead}catch(f){throw this.fb(f)}finally{this.$(c,D,g)}return g}Z(c,s){return s===this.U.get(c)?null:s}$(c,s,l){const h=this.U.get(c);typeof h=="number"&&(typeof s=="number"||(typeof l=="number"?this.U.set(c,h+l):this.U.delete(c)))}async write(c,s,l,h,b){return(0,$.$wh)(()=>this.ab(c,s,l,h,b),100,3)}async ab(c,s,l,h,b){const D=this.Z(c,s);let g=null;try{g=(await k.Promises.write(c,l,h,b,D)).bytesWritten}catch(f){throw await this.gb(this.X.get(c),f)}finally{this.$(c,D,g)}return g}async mkdir(c){try{await k.Promises.mkdir(this.H(c))}catch(s){throw this.fb(s)}}async delete(c,s){try{const l=this.H(c);if(s.recursive){let h;s?.atomic!==!1&&s.atomic.postfix&&(h=(0,L.$jc)((0,L.$mc)(l),`${(0,L.$nc)(l)}${s.atomic.postfix}`)),await k.Promises.rm(l,k.RimRafMode.MOVE,h)}else try{await k.Promises.unlink(l)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let b=!1;try{const{stat:D,symbolicLink:g}=await k.SymlinkSupport.stat(l);b=D.isDirectory()&&!g}catch{}if(b)await k.Promises.rmdir(l);else throw h}else throw h}}catch(l){throw this.fb(l)}}async rename(c,s,l){const h=this.H(c),b=this.H(s);if(h!==b)try{await this.bb(c,s,"move",l.overwrite),await k.Promises.rename(h,b)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(2,null,(0,L.$nc)(h),(0,L.$nc)((0,L.$mc)(b)),D.toString()))),this.fb(D)}}async copy(c,s,l){const h=this.H(c),b=this.H(s);if(h!==b)try{await this.bb(c,s,"copy",l.overwrite),await k.Promises.copy(h,b,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(3,null,(0,L.$nc)(h),(0,L.$nc)((0,L.$mc)(b)),D.toString()))),this.fb(D)}}async bb(c,s,l,h){const b=this.H(c),D=this.H(s);let g=!1;if(!!(this.capabilities&1024)||(g=(0,p.$cg)(b,D,!0)),g){if(l==="copy")throw(0,m.$Mk)((0,u.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(l==="move")return}const y=await this.L(c);if(!y)throw(0,m.$Mk)((0,u.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(s);if(P){if(!h)throw(0,m.$Mk)((0,u.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);y.type&m.FileType.File&&P.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(c,s){return this.cb(c,s,!1)}async cb(c,s,l){const h=this.H(c),b=this.H(s),D=!!(this.capabilities&1024);if((0,p.$cg)(h,b,!D))return;const g=new S.$Sc;try{g.add(await this.O(c)),g.add(await this.O(s)),l&&await k.Promises.mkdir((0,L.$mc)(b),{recursive:!0}),await k.Promises.copyFile(h,b)}catch(f){if(f.code==="ENOENT"&&!l)return this.cb(c,s,!0);throw this.fb(f)}finally{g.dispose()}}t(c,s,l){return new r.$Bq(h=>c(h),h=>s(h),l)}F(c,s,l){return new a.$Jq(h=>c(h),h=>s(h),l)}fb(c){if(c instanceof m.$Lk)return c;let s=c,l;switch(c.code){case"ENOENT":l=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,l=m.FileSystemProviderErrorCode.Unknown;break;default:l=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Mk)(s,l)}async gb(c,s){let l=this.fb(s);if(c&&l.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await k.SymlinkSupport.stat(this.H(c));h.mode&128||(l=(0,m.$Mk)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return l}}e.$Kq=t}),define(Ce[252],Ie([1,0,3,13]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;class $ extends I.$Tc{constructor(R,v=[]){super(),this.a=new O.$Gj([R,...v]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...v){this.a.trace(R,...v)}debug(R,...v){this.a.debug(R,...v)}info(R,...v){this.a.info(R,...v)}warn(R,...v){this.a.warn(R,...v)}error(R,...v){this.a.error(R,...v)}flush(){this.a.flush()}}e.$xP=$}),define(Ce[253],Ie([1,0,32,13]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=void 0;var $;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})($||($={}));async function A(S,L,C,w,E){try{const k=await new Promise((m,o)=>{me(["@vscode/spdlog"],m,o)});k.setFlushOn($.Trace);const u=await k.createAsyncRotatingLogger(S,L,C,w);return E?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(k){console.error(k)}return null}function R(S,L,C){switch(L){case O.LogLevel.Trace:S.trace(C);break;case O.LogLevel.Debug:S.debug(C);break;case O.LogLevel.Info:S.info(C);break;case O.LogLevel.Warning:S.warn(C);break;case O.LogLevel.Error:S.error(C);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function v(S,L){switch(L){case O.LogLevel.Trace:S.setLevel($.Trace);break;case O.LogLevel.Debug:S.setLevel($.Debug);break;case O.LogLevel.Info:S.setLevel($.Info);break;case O.LogLevel.Warning:S.setLevel($.Warning);break;case O.LogLevel.Error:S.setLevel($.Error);break;case O.LogLevel.Off:S.setLevel($.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class p extends O.$Cj{constructor(L,C,w,E,k){super(),this.m=[],this.setLevel(k),this.n=this.s(L,C,w,E),this.B(this.onDidChangeLogLevel(u=>{this.r&&v(this.r,u)}))}async s(L,C,w,E){const k=w?6:1,u=30/k*I.$8k.MB,m=await A(L,C,u,k,E);if(m){this.r=m,v(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(L,C){this.r?R(this.r,L,C):this.getLevel()<=L&&this.m.push({level:L,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$mP=p}),define(Ce[135],Ie([1,0,39,207,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function S(k,u){return u-k}p.compare=S;const L=Object.create(null);L[p.Error]=(0,O.localize)(0,null),L[p.Warning]=(0,O.localize)(1,null),L[p.Info]=(0,O.localize)(2,null);function C(k){return L[k]||""}p.toString=C;function w(k){switch(k){case I.default.Error:return p.Error;case I.default.Warning:return p.Warning;case I.default.Info:return p.Info;case I.default.Ignore:return p.Hint}}p.fromSeverity=w;function E(k){switch(k){case p.Error:return I.default.Error;case p.Warning:return I.default.Warning;case p.Info:return I.default.Info;case p.Hint:return I.default.Ignore}}p.toSeverity=E}(R||(e.MarkerSeverity=R={}));var v;(function(p){const S="";function L(w){return C(w,!0)}p.makeKey=L;function C(w,E){const k=[S];return w.source?k.push(w.source.replace("\xA6","\\\xA6")):k.push(S),w.code?typeof w.code=="string"?k.push(w.code.replace("\xA6","\\\xA6")):k.push(w.code.value.replace("\xA6","\\\xA6")):k.push(S),w.severity!==void 0&&w.severity!==null?k.push(R.toString(w.severity)):k.push(S),w.message&&E?k.push(w.message.replace("\xA6","\\\xA6")):k.push(S),w.startLineNumber!==void 0&&w.startLineNumber!==null?k.push(w.startLineNumber.toString()):k.push(S),w.startColumn!==void 0&&w.startColumn!==null?k.push(w.startColumn.toString()):k.push(S),w.endLineNumber!==void 0&&w.endLineNumber!==null?k.push(w.endLineNumber.toString()):k.push(S),w.endColumn!==void 0&&w.endColumn!==null?k.push(w.endColumn.toString()):k.push(S),k.push(S),k.join("\xA6")}p.makeKeyOptionalMessage=C})(v||(e.IMarkerData=v={})),e.$Jt=(0,$.$ci)("markerService")}),define(Ce[254],Ie([1,0,4,39,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.NotificationsFilter=e.$zv=e.NeverShowAgainScope=e.NotificationPriority=e.$yv=e.Severity=void 0,e.Severity=O.default,e.$yv=(0,$.$ci)("notificationService");var A;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function v(C){if(C){const w=C;return typeof w.id=="string"&&typeof w.label=="string"}return!1}e.$zv=v;var p;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class S{constructor(){this.progress=new L,this.onDidClose=I.Event.None,this.onDidChangeVisibility=I.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.$Av=S;class L{infinite(){}done(){}total(w){}worked(w){}}e.$Bv=L}),define(Ce[255],Ie([1,0,49]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;const $=globalThis.vscode;if(typeof $<"u"&&typeof $.context<"u"){const A=$.context.configuration();if(A)O=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,I.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:A.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(Ce[136],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Oj=(0,I.$ci)("productService"),e.$Pj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(me,e){return function(I,O){e(I,O,me)}};define(Ce[107],Ie([1,0,8,22,3,5]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProgressLocation=e.$Cv=void 0,e.$Cv=(0,A.$ci)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Dv=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.$Ev=v;class p{get value(){return this.a}constructor(w){this.e=w}report(w){this.b?this.b.push(w):this.b=[w],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const w=this.b.shift();this.a=w,await this.e(this.a)}}finally{this.c=!1;const w=this.d;this.d=void 0,w?.()}}drain(){return this.c?new Promise(w=>{const E=this.d;this.d=()=>{E?.(),w()}}):Promise.resolve()}}e.$Fv=p;let S=class extends $.$Tc{constructor(w,E){super(),this.a=new I.$zh,E.withProgress(w,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,$.$Rc)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.$Gv=S,e.$Gv=S=Ke([We(1,e.$Cv)],S);class L extends $.$Tc{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new $.$Sc)}start(w){this.stop();const E=++this.a,k=new O.$ae;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,$.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,$.$Rc)(()=>k.cancel())),this.b.add((0,$.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:k.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.$Hv=L,e.$Iv=(0,A.$ci)("editorProgressService")}),define(Ce[37],Ie([1,0,61,18]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0;class ${constructor(){this.a=new Map}add(R,v){I.ok(O.$Qf(R)),I.ok(O.$Sf(v)),I.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,v)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Rn=new $}),define(Ce[108],Ie([1,0,4,37]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn={JSONContribution:"base.contributions.json"};function $(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class A{constructor(){this.b=new I.$3d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,S){this.a[$(p)]=S,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;O.$Rn.add(e.$Sn.JSONContribution,R)}),define(Ce[86],Ie([1,0,19,4,18,197,51,108,37]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.ConfigurationScope=e.$Wn=e.EditPresentationTypes=void 0;var S;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(S||(e.EditPresentationTypes=S={})),e.$Wn={Configuration:"base.contributions.configuration"};var L;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(L||(e.ConfigurationScope=L={})),e.$Xn={properties:{},patternProperties:{}},e.$Yn={properties:{},patternProperties:{}},e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n="vscode://schemas/settings/resourceLanguage",e.$5n="vscode://schemas/settings/configurationDefaults";const C=p.$Rn.as(v.$Sn.JSONContribution);class w{constructor(){this.h=new Set,this.i=new O.$3d,this.onDidSchemaChange=this.i.event,this.j=new O.$3d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$4n,this.g),this.v()}registerConfiguration(t,d=!0){this.registerConfigurations([t],d)}registerConfigurations(t,d=!0){const c=new Set;this.n(t,d,c),C.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:c})}deregisterConfigurations(t){const d=new Set;this.o(t,d),C.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:d})}updateConfigurations({add:t,remove:d}){const c=new Set;this.o(d,c),this.n(t,!1,c),C.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:c})}registerDefaultConfigurations(t){const d=new Set;this.k(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}k(t,d){const c=[];for(const{overrides:s,source:l}of t)for(const h in s)if(d.add(h),e.$7n.test(h)){const b=this.a.get(h),D=b?.valuesSources??new Map;if(l)for(const P of Object.keys(s[h]))D.set(P,l);const g={...b?.value||{},...s[h]};this.a.set(h,{source:l,value:g,valuesSources:D});const f=(0,R.$Si)(h),y={type:"object",default:g,description:A.localize(1,null,f),$ref:e.$4n,defaultDefaultValue:g,source:$.$Qf(l)?void 0:l,defaultValueSource:l};c.push(...u(h)),this.d[h]=y,this.b.properties[h]=y}else{this.a.set(h,{value:s[h],source:l});const b=this.d[h];b&&(this.w(h,b),this.r(h,b))}this.m(c)}deregisterDefaultConfigurations(t){const d=new Set;this.l(t,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:!0})}l(t,d){for(const{overrides:c,source:s}of t)for(const l in c){const h=this.a.get(l),b=$.$Qf(s)?s:s?.id,D=$.$Qf(h?.source)?h?.source:h?.source?.id;if(b===D)if(d.add(l),this.a.delete(l),e.$7n.test(l))delete this.d[l],delete this.b.properties[l];else{const g=this.d[l];g&&(this.w(l,g),this.r(l,g))}}this.u()}deltaConfiguration(t){let d=!1;const c=new Set;t.removedDefaults&&(this.l(t.removedDefaults,c),d=!0),t.addedDefaults&&(this.k(t.addedDefaults,c),d=!0),t.removedConfigurations&&this.o(t.removedConfigurations,c),t.addedConfigurations&&this.n(t.addedConfigurations,!1,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:d})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const d of t)this.h.add(d);this.u()}n(t,d,c){t.forEach(s=>{this.p(s,d,s.extensionInfo,s.restrictedProperties,void 0,c),this.c.push(s),this.q(s)})}o(t,d){const c=s=>{if(s.properties)for(const l in s.properties){d.add(l);const h=this.d[l];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[l],this.s(l,s.properties[l])}s.allOf?.forEach(l=>c(l))};for(const s of t){c(s);const l=this.c.indexOf(s);l!==-1&&this.c.splice(l,1)}}p(t,d=!0,c,s,l=3,h){l=$.$Zf(t.scope)?l:t.scope;const b=t.properties;if(b)for(const g in b){const f=b[g];if(d&&n(g,f)){delete b[g];continue}if(f.source=c,f.defaultDefaultValue=b[g].default,this.w(g,f),e.$7n.test(g)?f.scope=void 0:(f.scope=$.$Zf(f.scope)?l:f.scope,f.restricted=$.$Zf(f.restricted)?!!s?.includes(g):f.restricted),b[g].hasOwnProperty("included")&&!b[g].included){this.f[g]=b[g],delete b[g];continue}else this.d[g]=b[g],b[g].policy?.name&&this.e.set(b[g].policy.name,g);!b[g].deprecationMessage&&b[g].markdownDeprecationMessage&&(b[g].deprecationMessage=b[g].markdownDeprecationMessage),h.add(g)}const D=t.allOf;if(D)for(const g of D)this.p(g,d,c,s,l,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const d=c=>{const s=c.properties;if(s)for(const h in s)this.r(h,s[h]);c.allOf?.forEach(d)};d(t)}r(t,d){switch(e.$Xn.properties[t]=d,d.scope){case 1:e.$Yn.properties[t]=d;break;case 2:e.$Zn.properties[t]=d;break;case 6:e.$1n.properties[t]=d;break;case 3:e.$2n.properties[t]=d;break;case 4:e.$3n.properties[t]=d;break;case 5:e.$3n.properties[t]=d,this.g.properties[t]=d;break}}s(t,d){switch(delete e.$Xn.properties[t],d.scope){case 1:delete e.$Yn.properties[t];break;case 2:delete e.$Zn.properties[t];break;case 6:delete e.$1n.properties[t];break;case 3:delete e.$2n.properties[t];break;case 4:case 5:delete e.$3n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const d=`[${t}]`,c={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$4n};this.w(d,c),e.$Xn.properties[d]=c,e.$Yn.properties[d]=c,e.$Zn.properties[d]=c,e.$1n.properties[d]=c,e.$2n.properties[d]=c,e.$3n.properties[d]=c}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$4n};e.$Xn.patternProperties[e.$6n]=t,e.$Yn.patternProperties[e.$6n]=t,e.$Zn.patternProperties[e.$6n]=t,e.$1n.patternProperties[e.$6n]=t,e.$2n.patternProperties[e.$6n]=t,e.$3n.patternProperties[e.$6n]=t,this.i.fire()}w(t,d){const c=this.a.get(t);let s=c?.value,l=c?.source;$.$Xf(s)&&(s=d.defaultDefaultValue,l=void 0),$.$Xf(s)&&(s=o(d.type)),d.default=s,d.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",k=new RegExp(E,"g");e.$6n=`^(${E})+$`,e.$7n=new RegExp(e.$6n);function u(a){const t=[];if(e.$7n.test(a)){let d=k.exec(a);for(;d?.length;){const c=d[1].trim();c&&t.push(c),d=k.exec(a)}}return(0,I.$Mb)(t)}e.$8n=u;function m(a){return a.reduce((t,d)=>`${t}[${d}]`,"")}e.$9n=m;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0n=o;const i=new w;p.$Rn.add(e.$Wn.Configuration,i);function n(a,t){return a.trim()?e.$7n.test(a)?A.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?A.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$$n=n;function r(){const a=[],t=i.getConfigurationProperties();for(const d of Object.keys(t))a.push([d,t[d].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$_n=r}),define(Ce[256],Ie([1,0,19,4,160,3,28,24,18,2,51,86,37]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;function E(d){return Object.isFrozen(d)?d:v.$Gn(d)}class k{constructor(c={},s=[],l=[],h){this.b=c,this.c=s,this.d=l,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const c=this.raw.map(s=>{if(s instanceof k)return s;const l=new u("");return l.parseRaw(s),l.configurationModel});this.f=c.reduce((s,l)=>l===s?l:s.merge(l),c[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(c){return c?(0,L.$Qi)(this.contents,c):this.contents}inspect(c,s){const l=this;return{get value(){return E(l.rawConfiguration.getValue(c))},get override(){return s?E(l.rawConfiguration.getOverrideValue(c,s)):void 0},get merged(){return E(s?l.rawConfiguration.override(s).getValue(c):l.rawConfiguration.getValue(c))},get overrides(){const h=[];for(const{contents:b,identifiers:D,keys:g}of l.rawConfiguration.overrides){const f=new k(b,g).getValue(c);f!==void 0&&h.push({identifiers:D,value:f})}return h.length?E(h):void 0}}}getOverrideValue(c,s){const l=this.i(s);return l?c?(0,L.$Qi)(l,c):l:void 0}getKeysForOverrideIdentifier(c){const s=[];for(const l of this.overrides)l.identifiers.includes(c)&&s.push(...l.keys);return I.$Mb(s)}getAllOverrideIdentifiers(){const c=[];for(const s of this.overrides)c.push(...s.identifiers);return I.$Mb(c)}override(c){let s=this.a.get(c);return s||(s=this.g(c),this.a.set(c,s)),s}merge(...c){const s=v.$Fn(this.contents),l=v.$Fn(this.overrides),h=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const D of c)if(b.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(s,D.contents);for(const g of D.overrides){const[f]=l.filter(y=>I.$ub(y.identifiers,g.identifiers));f?(this.h(f.contents,g.contents),f.keys.push(...g.keys),f.keys=I.$Mb(f.keys)):l.push(v.$Fn(g))}for(const g of D.keys)h.indexOf(g)===-1&&h.push(g)}return new k(s,h,l,b.every(D=>D instanceof k)?void 0:b)}g(c){const s=this.i(c);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const l={};for(const h of I.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let b=this.contents[h];const D=s[h];D&&(typeof b=="object"&&typeof D=="object"?(b=v.$Fn(b),this.h(b,D)):b=D),l[h]=b}return new k(l,this.keys,this.overrides)}h(c,s){for(const l of Object.keys(s)){if(l in c&&p.$Sf(c[l])&&p.$Sf(s[l])){this.h(c[l],s[l]);continue}c[l]=v.$Fn(s[l])}}i(c){let s=null,l=null;const h=b=>{b&&(l?this.h(l,b):l=v.$Fn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===c?s=b.contents:b.identifiers.includes(c)&&h(b.contents);return h(s),l}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(c,s){this.j(c,s,!0)}setValue(c,s){this.j(c,s,!1)}removeValue(c){const s=this.keys.indexOf(c);s!==-1&&(this.keys.splice(s,1),(0,L.$Pi)(this.contents,c),C.$7n.test(c)&&this.overrides.splice(this.overrides.findIndex(l=>I.$ub(l.identifiers,(0,C.$8n)(c))),1))}j(c,s,l){(0,L.$Oi)(this.contents,c,s,h=>console.error(h)),l=l||this.keys.indexOf(c)===-1,l&&this.keys.push(c),C.$7n.test(c)&&this.overrides.push({identifiers:(0,C.$8n)(c),keys:Object.keys(this.contents[c]),contents:(0,L.$Ni)(this.contents[c],h=>console.error(h))})}}e.$ao=k;class u{constructor(c){this.f=c,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new k}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(c,s){if(!p.$Zf(c)){const l=this.g(c);this.parseRaw(l,s)}}reparse(c){this.a&&this.parseRaw(this.a,c)}parseRaw(c,s){this.a=c;const{contents:l,keys:h,overrides:b,restricted:D,hasExcludedProperties:g}=this.h(c,s);this.b=new k(l,h,b,g?[c]:void 0),this.c=D||[]}g(c){let s={},l=null,h=[];const b=[],D=[];function g(y){Array.isArray(h)?h.push(y):l!==null&&(h[l]=y)}const f={onObjectBegin:()=>{const y={};g(y),b.push(h),h=y,l=null},onObjectProperty:y=>{l=y},onObjectEnd:()=>{h=b.pop()},onArrayBegin:()=>{const y=[];g(y),b.push(h),h=y,l=null},onArrayEnd:()=>{h=b.pop()},onLiteralValue:g,onError:(y,P,N)=>{D.push({error:y,offset:P,length:N})}};if(c)try{$.$tn(c,f),s=h[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return s}h(c,s){const l=w.$Rn.as(C.$Wn.Configuration).getConfigurationProperties(),h=this.i(c,l,!0,s);c=h.raw;const b=(0,L.$Ni)(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),D=Object.keys(c),g=this.j(c,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:b,keys:D,overrides:g,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(c,s,l,h){let b=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:c,restricted:[],hasExcludedProperties:b};const D={},g=[];for(const f in c)if(C.$7n.test(f)&&l){const y=this.i(c[f],s,!1,h);D[f]=y.raw,b=b||y.hasExcludedProperties,g.push(...y.restricted)}else{const y=s[f],P=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&g.push(f),!h.exclude?.includes(f)&&(h.include?.includes(f)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&y?.restricted))?D[f]=c[f]:b=!0}return{raw:D,restricted:g,hasExcludedProperties:b}}j(c,s){const l=[];for(const h of Object.keys(c))if(C.$7n.test(h)){const b={};for(const D in c[h])b[D]=c[h][D];l.push({identifiers:(0,C.$8n)(h),keys:Object.keys(b),contents:(0,L.$Ni)(b,s)})}return l}}e.$bo=u;class m extends A.$Tc{constructor(c,s,l,h){super(),this.c=c,this.f=s,this.g=h,this.b=this.B(new O.$3d),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(l.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&l.isEqual(b.resource,c)))(()=>this.b.fire()))}async loadConfiguration(){try{const c=await this.g.readFile(this.c);return this.a.parse(c.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new k}}reparse(c){return c&&(this.f=c),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$co=m;class o{constructor(c,s,l,h,b,D,g,f,y,P,N,U,z){this.a=c,this.b=s,this.c=l,this.overrideIdentifiers=h,this.d=b,this.f=D,this.g=g,this.h=f,this.i=y,this.j=P,this.k=N,this.l=U,this.m=z}get value(){return E(this.c)}n(c){return c?.value!==void 0||c?.override!==void 0||c?.overrides!==void 0?c:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(c,s,l,h,b=new k,D=new k,g=new R.$Ac,f=new k,y=new R.$Ac){this.c=c,this.d=s,this.f=l,this.g=h,this.h=b,this.i=D,this.j=g,this.l=f,this.m=y,this.a=null,this.b=new R.$Ac,this.n=null}getValue(c,s,l){return this.p(c,s,l).getValue(c)}updateValue(c,s,l={}){let h;l.resource?(h=this.m.get(l.resource),h||(h=new k,this.m.set(l.resource,h))):h=this.l,s===void 0?h.removeValue(c):h.setValue(c,s),l.resource||(this.a=null)}inspect(c,s,l){const h=this.p(c,s,l),b=this.t(s.resource,l),D=s.resource?this.m.get(s.resource)||this.l:this.l,g=new Set;for(const f of h.overrides)for(const y of f.identifiers)h.getOverrideValue(c,y)!==void 0&&g.add(y);return new o(c,s,h.getValue(c),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,l?this.i:void 0,b||void 0,D)}keys(c){const s=this.t(void 0,c);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(c){this.c=c,this.a=null,this.b.clear()}updatePolicyConfiguration(c){this.d=c}updateApplicationConfiguration(c){this.f=c,this.a=null,this.b.clear()}updateLocalUserConfiguration(c){this.g=c,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(c){this.h=c,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(c){this.i=c,this.a=null,this.b.clear()}updateFolderConfiguration(c,s){this.j.set(c,s),this.b.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this.b.delete(c)}compareAndUpdateDefaultConfiguration(c,s){const l=[];if(!s){const{added:h,updated:b,removed:D}=a(this.c,c);s=[...h,...b,...D]}for(const h of s)for(const b of(0,C.$8n)(h)){const D=this.c.getKeysForOverrideIdentifier(b),g=c.getKeysForOverrideIdentifier(b),f=[...g.filter(y=>D.indexOf(y)===-1),...D.filter(y=>g.indexOf(y)===-1),...D.filter(y=>!v.$Jn(this.c.override(b).getValue(y),c.override(b).getValue(y)))];l.push([b,f])}return this.updateDefaultConfiguration(c),{keys:s,overrides:l}}compareAndUpdatePolicyConfiguration(c){const{added:s,updated:l,removed:h}=a(this.d,c),b=[...s,...l,...h];return b.length&&this.updatePolicyConfiguration(c),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:s,updated:l,removed:h,overrides:b}=a(this.applicationConfiguration,c),D=[...s,...l,...h];return D.length&&this.updateApplicationConfiguration(c),{keys:D,overrides:b}}compareAndUpdateLocalUserConfiguration(c){const{added:s,updated:l,removed:h,overrides:b}=a(this.localUserConfiguration,c),D=[...s,...l,...h];return D.length&&this.updateLocalUserConfiguration(c),{keys:D,overrides:b}}compareAndUpdateRemoteUserConfiguration(c){const{added:s,updated:l,removed:h,overrides:b}=a(this.remoteUserConfiguration,c),D=[...s,...l,...h];return D.length&&this.updateRemoteUserConfiguration(c),{keys:D,overrides:b}}compareAndUpdateWorkspaceConfiguration(c){const{added:s,updated:l,removed:h,overrides:b}=a(this.workspaceConfiguration,c),D=[...s,...l,...h];return D.length&&this.updateWorkspaceConfiguration(c),{keys:D,overrides:b}}compareAndUpdateFolderConfiguration(c,s){const l=this.folderConfigurations.get(c),{added:h,updated:b,removed:D,overrides:g}=a(l,s),f=[...h,...b,...D];return(f.length||!l)&&this.updateFolderConfiguration(c,s),{keys:f,overrides:g}}compareAndDeleteFolderConfiguration(c){const s=this.folderConfigurations.get(c);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:l,updated:h,removed:b,overrides:D}=a(s,void 0);return{keys:[...l,...h,...b],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(c,s,l){let h=this.q(s,l);return s.overrideIdentifier&&(h=h.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(c)!==void 0&&(h=h.merge(this.d)),h}q({resource:c},s){let l=this.r();if(s&&c){const h=s.getFolder(c);h&&(l=this.s(h.uri)||l);const b=this.m.get(c);b&&(l=l.merge(b))}return l}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(c){let s=this.b.get(c);if(!s){const l=this.r(),h=this.j.get(c);h?(s=l.merge(h),this.b.set(c,s)):s=l}return s}t(c,s){if(s&&c){const l=s.getFolder(c);if(l)return this.j.get(l.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((c,s)=>{const{contents:l,overrides:h,keys:b}=this.j.get(s);return c.push([s,{contents:l,overrides:h,keys:b}]),c},[])}}allKeys(){const c=new Set;return this.c.keys.forEach(s=>c.add(s)),this.userConfiguration.keys.forEach(s=>c.add(s)),this.i.keys.forEach(s=>c.add(s)),this.j.forEach(s=>s.keys.forEach(l=>c.add(l))),[...c.values()]}u(){const c=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>c.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>c.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>c.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(l=>c.add(l))),[...c.values()]}v(c){const s=new Set;return this.c.getKeysForOverrideIdentifier(c).forEach(l=>s.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(l=>s.add(l)),this.i.getKeysForOverrideIdentifier(c).forEach(l=>s.add(l)),this.j.forEach(l=>l.getKeysForOverrideIdentifier(c).forEach(h=>s.add(h))),[...s.values()]}static parse(c){const s=this.w(c.defaults),l=this.w(c.policy),h=this.w(c.application),b=this.w(c.user),D=this.w(c.workspace),g=c.folders.reduce((f,y)=>(f.set(S.URI.revive(y[0]),this.w(y[1])),f),new R.$Ac);return new i(s,l,h,b,new k,D,g,new k,new R.$Ac)}static w(c){return new k(c.contents,c.keys,c.overrides)}}e.$do=i;function n(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const c=new Set,s=new Map;for(const h of d)h.keys.forEach(b=>c.add(b)),h.overrides.forEach(([b,D])=>{const g=(0,R.$xc)(s,b,new Set);D.forEach(f=>g.add(f))});const l=[];return s.forEach((h,b)=>l.push([b,[...h.values()]])),{keys:[...c.values()],overrides:l}}e.$eo=n;class r{constructor(c,s,l,h){this.change=c,this.f=s,this.g=l,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of c.keys)this.affectedKeys.add(b);for(const[,b]of c.overrides)for(const D of b)this.affectedKeys.add(D);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(c,s){const l=this.a+c,h=this.d.indexOf(l);if(h<0)return!1;const b=h+l.length;if(b>=this.d.length)return!1;const D=this.d.charCodeAt(b);if(D!==this.b&&D!==this.c)return!1;if(s){const g=this.previousConfiguration?this.previousConfiguration.getValue(c,s,this.f?.workspace):void 0,f=this.g.getValue(c,s,this.h);return!v.$Jn(g,f)}return!0}}e.$fo=r;function a(d,c){const{added:s,removed:l,updated:h}=t(c?.rawConfiguration,d?.rawConfiguration),b=[],D=d?.getAllOverrideIdentifiers()||[],g=c?.getAllOverrideIdentifiers()||[];if(c){const f=g.filter(y=>!D.includes(y));for(const y of f)b.push([y,c.getKeysForOverrideIdentifier(y)])}if(d){const f=D.filter(y=>!g.includes(y));for(const y of f)b.push([y,d.getKeysForOverrideIdentifier(y)])}if(c&&d){for(const f of D)if(g.includes(f)){const y=t({contents:d.getOverrideValue(void 0,f)||{},keys:d.getKeysForOverrideIdentifier(f)},{contents:c.getOverrideValue(void 0,f)||{},keys:c.getKeysForOverrideIdentifier(f)});b.push([f,[...y.added,...y.removed,...y.updated]])}}return{added:s,removed:l,updated:h,overrides:b}}function t(d,c){const s=d?c?d.keys.filter(b=>c.keys.indexOf(b)===-1):[...d.keys]:[],l=c?d?c.keys.filter(b=>d.keys.indexOf(b)===-1):[...c.keys]:[],h=[];if(d&&c){for(const b of c.keys)if(d.keys.indexOf(b)!==-1){const D=(0,L.$Qi)(c.contents,b),g=(0,L.$Qi)(d.contents,b);v.$Jn(D,g)||h.push(b)}}return{added:s,removed:l,updated:h}}}),define(Ce[257],Ie([1,0,21,4,3,82]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1sb=e.$Zsb=e.$Ysb=e.$Xsb=void 0;const R=(S,L,C)=>{const w=new Uint8Array(16);for(let u=0;u<16;u++)w[u]=Math.round(Math.random()*256);const E=(0,I.$Ke)(I.$qe.wrap(w));return[`GET ws://localhost${S}?${L}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$Xsb=R,e.$Ysb=I.$qe.fromString(`\r
\r
`);async function v(S,L,C,w,E){S.write(I.$qe.fromString((0,e.$Xsb)(L,C,w)));const k=new $.$Sc;try{return await new Promise((u,m)=>{let o;k.add(S.onData(i=>{o?o=I.$qe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$Ysb);if(n===-1)return;u(S),S.pauseData();const r=o.slice(n+e.$Ysb.byteLength);r.byteLength&&E.onData.fire(r)})),k.add(S.onClose(i=>m(i??new Error("socket closed")))),k.add(S.onEnd(()=>m(new Error("socket ended"))))})}catch(u){throw S.dispose(),u}finally{k.dispose()}}e.$Zsb=v;class p extends $.$Tc{constructor(L,C){super(),this.g=L,this.a=this.B(new O.$6d),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new O.$3d),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(w=>this.a.fire(w))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(L,C){A.SocketDiagnostics.traceSocketEvent(this,this.g,L,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$1sb=p}),define(Ce[65],Ie([1,0,14,5]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.RemoteAuthorityResolverErrorCode=e.$gl=e.$fl=e.RemoteConnectionType=e.$el=void 0,e.$el=(0,O.$ci)("remoteAuthorityResolverService");var $;(function(L){L[L.WebSocket=0]="WebSocket",L[L.Managed=1]="Managed"})($||(e.RemoteConnectionType=$={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$fl=A;class R{constructor(C,w){this.host=C,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$gl=R;var v;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound",L.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class p extends I.$bb{static isNotAvailable(C){return C instanceof p&&C._code===v.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof p&&C._code===v.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof p&&C._code===v.NoResolverFound}static isInvalidAuthority(C){return C instanceof p&&C._code===v.InvalidAuthority}static isHandled(C){return C instanceof p&&C.isHandled}constructor(C,w=v.Unknown,E){super(C),this._message=C,this._code=w,this._detail=E,this.isHandled=w===v.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$hl=p;function S(L){const C=L.indexOf("+");return C===-1?L:L.substring(0,C)}e.$il=S}),define(Ce[66],Ie([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=void 0;function O(S){return S.scheme===I.Schemas.vscodeRemote?S.authority:void 0}e.$jl=O;function $(S){if(!S)return;const L=S.indexOf("+");return L<0?S:S.substr(0,L)}e.$kl=$;function A(S){return`/${S.quality??"oss"}-${S.commit??"dev"}`}e.$ll=A;function R(S){const{host:L,port:C}=p(S);if(typeof C>"u")throw new Error(`Invalid remote authority: ${S}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:L,port:C}}e.$ml=R;function v(S,L){let{host:C,port:w}=p(S);return typeof w>"u"&&(w=L),{host:C,port:w}}e.$nl=v;function p(S){const L=S.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(L)return{host:L[1],port:parseInt(L[2],10)};const C=S.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const w=S.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:S,port:void 0}}}),define(Ce[26],Ie([1,0,12,5,66]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.TargetPlatform=e.ExtensionType=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0,e.$om="extensions.user.cache",e.$pm="extensions.builtin.cache",e.$qm="undefined_publisher",e.$rm=["ui","workspace","web"];function A(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$sm=A,e.$tm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(R||(e.ExtensionType=R={}));var v;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const i=typeof m=="string"?m:m.value,n=typeof o=="string"?o:o.value;return I.$hf(i,n)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$um=p;class S{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(p.toKey(m))}delete(m){return this.c.delete(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}}e.$vm=S;class L{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(p.toKey(m))}get(m){return this.c.get(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}set(m,o){this.c.set(p.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wm=L;function C(u){return w(u)}e.$xm=C;function w(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$ym=w;function E(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$zm=E;function k(u,m){if(m){const o=`onResolveRemoteAuthority:${(0,$.$kl)(m)}`;return!!u.activationEvents?.includes(o)}return!1}e.$Am=k,e.$Bm=(0,O.$ci)("IBuiltinExtensionsScannerService")}),define(Ce[137],Ie([1,0,14,26]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class ${constructor(){this.a=new Map,this.b=new WeakMap}register(R,v){this.a.set(R,v)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const v=Object.create(null);for(const p of R){const S=this.readActivationEvents(p);S.length>0&&(v[O.$um.toKey(p.identifier)]=S)}return v}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const v=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<v.length;p++)v[p]==="onUri"&&(v[p]=`onUri:${O.$um.toKey(R.identifier)}`);if(!R.contributes)return v;for(const p in R.contributes){const S=this.a.get(p);if(!S)continue;const L=R.contributes[p],C=Array.isArray(L)?L:[L];try{S(C,v)}catch(w){(0,I.$1)(w)}}return v}}e.$wF=$,e.$xF=new $}),define(Ce[258],Ie([1,0,8,21,22,14,4,3,58,38,30,82,65,66]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.PersistentConnectionEventType=e.$ul=e.$tl=e.$sl=e.ConnectionType=void 0;const k=30*1e3;var u;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function m(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(K){const B=new $.$ae;return setTimeout(()=>B.cancel(),K),B.token}function i(K,B){if(K.isCancellationRequested||B.isCancellationRequested)return $.CancellationToken.Cancelled;const ae=new $.$ae;return K.onCancellationRequested(()=>ae.cancel()),B.onCancellationRequested(()=>ae.cancel()),ae.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new v.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,I.$8g)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function r(K,B){const ae=new n(B);return ae.registerDisposable(K.onControlMessage(ye=>{const le=JSON.parse(ye.toString()),de=Z(le);de?ae.reject(de):ae.resolve(le)})),ae.promise}function a(K,B,ae,ye,le,de,ue,ge){const V=new n(ge),X=S.$Yd.create(!1);return K.info(`Creating a socket (${ue})...`),p.mark(`code/willCreateSocket/${de}`),B.connect(ae,ye,le,ue).then(he=>{V.didTimeout?(p.mark(`code/didCreateSocketError/${de}`),K.info(`Creating a socket (${ue}) finished after ${X.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(p.mark(`code/didCreateSocketOK/${de}`),K.info(`Creating a socket (${ue}) was successful after ${X.elapsed()} ms.`),V.resolve(he))},he=>{p.mark(`code/didCreateSocketError/${de}`),K.info(`Creating a socket (${ue}) returned an error after ${X.elapsed()} ms.`),K.error(he),V.reject(he)}),V.promise}function t(K,B){const ae=new n(B);return K.then(ye=>{ae.didTimeout||ae.resolve(ye)},ye=>{ae.didTimeout||ae.reject(ye)}),ae.promise}async function d(K,B,ae,ye){const le=fe(K,B);K.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let de;try{de=await a(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,E.$ll)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,m(B),`renderer-${m(B)}-${K.reconnectionToken}`,ye)}catch(he){throw K.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),K.logService.error(he),he}K.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ue,ge;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(de,null),ue=K.reconnectionProtocol,ge=!1):(ue=new C.$3h({socket:de}),ge=!0),K.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const V=await t(K.signService.createNewMessage((0,L.$yg)()),ye),X={type:"auth",auth:K.connectionToken||"00000000000000000000",data:V.data};ue.sendControl(O.$qe.fromString(JSON.stringify(X)));try{const he=await r(ue,i(ye,o(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(K.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(K.signService.validate(V,he.signedData),ye)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Pe=await t(K.signService.sign(he.data),ye),pe={type:"connectionType",commit:K.commit,signedData:Pe,desiredConnectionType:B};return ae&&(pe.args=ae),K.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ue.sendControl(O.$qe.fromString(JSON.stringify(pe))),{protocol:ue,ownsProtocol:ge}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(K.logService.error(`${le} the handshake timed out. Error:`),K.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${le} received error control message when negotiating connection. Error:`),K.logService.error(he)),ge&&_(ue),he}}async function c(K,B,ae,ye){const le=Date.now(),de=fe(K,B),{protocol:ue,ownsProtocol:ge}=await d(K,B,ae,ye),V=new n(ye);return V.registerDisposable(ue.onControlMessage(X=>{const he=JSON.parse(X.toString()),be=Z(he);be?(K.logService.error(`${de} received error control message when negotiating connection. Error:`),K.logService.error(be),ge&&_(ue),V.reject(be)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${re(le)}!`),V.resolve({protocol:ue,firstMessage:he}))})),V.promise}async function s(K,B){const{protocol:ae}=await c(K,1,void 0,B);return{protocol:ae}}async function l(K,B,ae){const{protocol:ye,firstMessage:le}=await c(K,2,B,ae),de=le&&le.debugPort;return{protocol:ye,debugPort:de}}async function h(K,B,ae){const ye=Date.now(),le=fe(K,3),{protocol:de}=await d(K,3,B,ae);return K.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${re(ye)}!`),de}async function b(K,B,ae){const{connectTo:ye,connectionToken:le}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:ye,connectionToken:le,reconnectionToken:B,reconnectionProtocol:ae,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function D(K,B,ae){return f(K,async ye=>{const{protocol:le}=await s(ye,$.CancellationToken.None);return new J(K,B,ae,ye.reconnectionToken,le)})}e.$sl=D;async function g(K,B){return f(K,async ae=>{const{protocol:ye,debugPort:le}=await l(ae,B,$.CancellationToken.None);return new ne(K,B,ae.reconnectionToken,ye,le)})}e.$tl=g;async function f(K,B){for(let ye=1;;ye++)try{const le=(0,L.$yg)(),de=await b(K,le,null);return await B(de)}catch(le){if(ye<5)K.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(le);else throw K.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(le),j.triggerPermanentFailure(0,0,w.$hl.isHandled(le)),le}}async function y(K,B,ae){const ye=await b(K,(0,L.$yg)(),null);return await h(ye,{host:B,port:ae},$.CancellationToken.None)}e.$ul=y;function P(K){return(0,I.$2g)(B=>new Promise((ae,ye)=>{const le=setTimeout(ae,K*1e3);B.onCancellationRequested(()=>{clearTimeout(le),ae()})}))}var N;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class U{constructor(B,ae){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.type=0}}e.$vl=U;class z{constructor(B,ae,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.durationSeconds=ye,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$wl=z;class F{constructor(B,ae,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=ye,this.type=2}}e.$xl=F;class M{constructor(B,ae,ye){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=ye,this.type=4}}e.$yl=M;class T{constructor(B,ae,ye,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ae,this.attempt=ye,this.handled=le,this.type=3}}e.$zl=T;class j extends v.$Tc{static triggerPermanentFailure(B,ae,ye){this._permanentFailure=!0,this.f=B,this.g=ae,this.h=ye,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||j._permanentFailure}constructor(B,ae,ye,le,de){super(),this.t=B,this.u=ae,this.reconnectionToken=ye,this.protocol=le,this.w=de,this.m=this.B(new R.$3d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ue=>{const ge=ie(this.t,this.reconnectionToken,!0);ue?ue.type===0?(this.u.logService.info(`${ge} received socket close event (hadError: ${ue.hadError}).`),ue.error&&this.u.logService.error(ue.error)):(this.u.logService.info(`${ge} received socket close event (wasClean: ${ue.wasClean}, code: ${ue.code}, reason: ${ue.reason}).`),ue.event&&this.u.logService.error(ue.event)):this.u.logService.info(`${ge} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ue=>{const ge=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ge} received socket timeout event (unacknowledgedMsgCount: ${ue.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ue.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ue.timeSinceLastReceivedSomeData}).`),this.y()})),j.j.push(this),this.B((0,v.$Rc)(()=>{const ue=j.j.indexOf(this);ue>=0&&j.j.splice(ue,1)})),this.n&&this.D(j.f,j.g,j.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=ie(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ae=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const le=ye<ae.length?ae[ye]:ae[ae.length-1];try{if(le>0){const ue=P(le);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ue)),this.u.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ue}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${B} resolving connection...`);const de=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${de.connectTo}...`),await this.G(de,o(k)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(de){if(de.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(w.$hl.isTemporarilyNotAvailable(de)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((de.code==="ETIMEDOUT"||de.code==="ENETUNREACH"||de.code==="ECONNREFUSED"||de.code==="ECONNRESET")&&de.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if((0,A.$4)(de)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(de);continue}if(de instanceof w.$hl){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,w.$hl.isHandled(de));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(de),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(B,ae,ye){this.w?j.triggerPermanentFailure(B,ae,ye):this.D(B,ae,ye)}D(B,ae,ye){this.m.fire(new T(this.reconnectionToken,B,ae,ye)),_(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Al=j;class J extends j{constructor(B,ae,ye,le,de){super(1,B,le,de,!0),this.client=this.B(new C.$1h(de,{remoteAuthority:ae,clientId:ye},B.ipcLogger))}async G(B,ae){await s(B,ae)}}e.$Bl=J;class ne extends j{constructor(B,ae,ye,le,de){super(2,B,ye,le,!1),this.H=ae,this.debugPort=de}async G(B,ae){await l(B,this.H,ae)}}e.$Cl=ne;function _(K){try{K.acceptDisconnect();const B=K.getSocket();K.dispose(),B.dispose()}catch(B){(0,A.$1)(B)}}function Z(K){if(K&&K.type==="error"){const B=new Error(`Connection error: ${K.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function Y(K,B){for(;K.length<B;)K+=" ";return K}function ce(K,B){return`[remote-connection][${Y(m(K),13)}][${B.substr(0,5)}\u2026]`}function ie(K,B,ae){return`${ce(K,B)}[${ae?"reconnect":"initial"}]`}function fe(K,B){return`${ie(B,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function re(K){return`${Date.now()-K} ms`}}),define(Ce[259],Ie([1,0,3,5]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=void 0,e.$ol=(0,O.$ci)("remoteSocketFactoryService");class ${constructor(){this.a={}}register(R,v){return this.a[R]??=[],this.a[R].push(v),(0,I.$Rc)(()=>{const p=this.a[R]?.indexOf(v);typeof p=="number"&&p>=0&&this.a[R]?.splice(p,1)})}b(R){return(this.a[R.type]||[]).find(p=>p.supports(R))}connect(R,v,p,S){const L=this.b(R);if(!L)throw new Error(`No socket factory found for ${R}`);return L.connect(R,v,p,S)}}e.$pl=$}),define(Ce[260],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage($){try{const A=await this.c();if(A){const R=String(I.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage($)}}}catch{}return{id:"",data:$}}async validate($,A){if(!$.id)return!0;const R=this.b.get($.id);if(!R)return!1;this.b.delete($.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign($){try{return await this.d($)}catch{}return $}}e.$67b=I}),define(Ce[109],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql="signService",e.$rl=(0,I.$ci)(e.$ql)}),define(Ce[138],Ie([1,0,260]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z_b=void 0;class O extends I.$67b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>me(["vsda"],A,R))}}e.$Z_b=O}),define(Ce[261],Ie([1,0,11,49,30]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=void 0;function A(p){if(I.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,S,L,C,w,E,k,u,m){const o=Object.create(null);o["common.machineId"]=E,o["common.sqmId"]=k,o.sessionID=(0,$.$yg)()+Date.now(),o.commitHash=C,o.version=w,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,I.$h)(I.$u),o["common.nodePlatform"]=O.$dc,o["common.nodeArch"]=L,o["common.product"]=m||"desktop",u&&(o["common.msftInternal"]=u);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),I.$l&&(o["common.snap"]="true");const r=A(S);return r&&(o["common.platformDetail"]=r),o}e.$So=R;function v(p){const S=O.env.USERDNSDOMAIN;if(!S)return!1;const L=S.toLowerCase();return p.some(C=>L===C)}e.$To=v}),define(Ce[262],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=void 0,e.$Dl=(0,I.$ci)("telemetryService"),e.$El=(0,I.$ci)("customEndpointTelemetryService"),e.$Fl="telemetry.currentSessionDate",e.$Gl="telemetry.firstSessionDate",e.$Hl="telemetry.lastSessionDate",e.$Il="telemetry.machineId",e.$Jl="telemetry.sqmId",e.$Kl="telemetry",e.$Ll="telemetry.telemetryLevel",e.$Ml="telemetry.enableCrashReporter",e.$Nl="telemetry.enableTelemetry";var O;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var $;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})($||(e.TelemetryConfiguration=$={}))}),define(Ce[87],Ie([1,0,24,18,66,261,262]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0;class v{constructor(d){this.value=d,this.isTrustedTelemetryValue=!0}}e.$Uo=v;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Vo=p,e.$Wo=new p;class S{async publicLog(d,c,s){}async publicLogError(d,c,s){}}e.$Xo=S,e.$Yo="telemetry",e.$Zo="extensionTelemetryLog",e.$1o={log:()=>null,flush:()=>Promise.resolve(null)};function L(t,d){return!d.isBuilt&&!d.disableTelemetry?!0:!(d.disableTelemetry||!t.enableTelemetry)}e.$2o=L;function C(t,d){return d.extensionTestsLocationURI?!0:!(d.isBuilt||d.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$3o=C;function w(t){const d=t.getValue(R.$Ll),c=t.getValue(R.$Ml);if(t.getValue(R.$Nl)===!1||c===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$4o=w;function E(t){const d={},c={},s={};m(t,s);for(let l in s){l=l.length>150?l.substr(l.length-149):l;const h=s[l];typeof h=="number"?c[l]=h:typeof h=="boolean"?c[l]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${h.length}`),d[l]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(d[l]=h)}return{properties:d,measurements:c}}e.$5o=E;const k=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const d=(0,$.$kl)(t);return k.has(d)?d:"other"}e.$6o=u;function m(t,d,c=0,s){if(t)for(const l of Object.getOwnPropertyNames(t)){const h=t[l],b=s?s+l:l;Array.isArray(h)?d[b]=(0,I.$Kn)(h):h instanceof Date?d[b]=h.toISOString():(0,O.$Sf)(h)?c<2?m(h,d,c+1,b+"."):d[b]=(0,I.$Kn)(h):d[b]=h}}function o(t,d){const c=t.msftInternalDomains||[],s=d.getValue("telemetry.internalTesting");return(0,A.$To)(c)||s}e.$7o=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$8o=i;function n(t,d){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let c=t;const s=[];for(const D of d)for(;;){const g=D.exec(t);if(!g)break;s.push([g.index,D.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(c="";;){const D=h.exec(t);if(!D)break;const g=s.some(([f,y])=>D.index<y&&f<h.lastIndex);!l.test(D[0])&&!g&&(c+=t.substring(b,D.index)+"<REDACTED: user-file-path>",b=h.lastIndex)}return b<t.length&&(c+=t.substr(b)),c}function r(t){if(!t)return t;const d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of d)if(c.regex.test(t))return`<REDACTED: ${c.label}>`;return t}function a(t,d){return(0,I.$Hn)(t,c=>{if(c instanceof v||Object.hasOwnProperty.call(c,"isTrustedTelemetryValue"))return c.value;if(typeof c=="string"){let s=c.replaceAll("%20"," ");s=n(s,d);for(const l of d)s=s.replace(l,"");return s=r(s),s}})}e.$9o=a}),define(Ce[263],Ie([1,0,12,134,26,11,2,14,49,87]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0;function L(c,s){return c.uuid&&s.uuid?c.uuid===s.uuid:c.id===s.id?!0:(0,I.$cf)(c.id,s.id)===0}e.$0o=L;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(s){const l=s.manifest?s.manifest.version:s.version,h=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new w(s.identifier,l,h)}static parse(s){const l=C.exec(s);return l&&l[1]&&l[2]?new w({id:l[1]},l[2],l[4]||void 0):null}constructor(s,l,h="undefined"){this.version=l,this.targetPlatform=h,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof w?L(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$$o=w;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(c){const s=E.exec(c);return s&&s[1]?[m(s[1]),s[2]]:[m(c),void 0]}e.$_o=k;function u(c,s){return`${c}.${s}`}e.$ap=u;function m(c){return c.toLowerCase()}e.$bp=m;function o(c,s){return m(u(c??$.$qm,s))}e.$cp=o;function i(c,s){const l=[],h=b=>{for(const D of l)if(D.some(g=>L(s(g),s(b))))return D;return null};for(const b of c){const D=h(b);D?D.push(b):l.push([b])}return l}e.$dp=i;function n(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.$ep=n;function r(c){return{id:new S.$Uo(c.identifier.id),name:new S.$Uo(c.name),galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.$fp=r,e.$gp=new $.$um("pprice.better-merge");function a(c,s){const l=[],h=s.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const b=h.shift();if(b&&l.every(D=>!L(D.identifier,{id:b}))){const D=c.filter(g=>L(g.identifier,{id:b}));D.length===1&&(l.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return l}e.$hp=a;async function t(c,s){if(!A.$k)return!1;let l;try{l=(await c.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{l=(await c.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){s.debug("Error while getting the os-release file.",(0,v.$0)(b))}}return!!l&&(l.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function d(c,s){const l=await t(c,s),h=(0,O.$Eo)(l?"alpine":A.$u,p.$ec);return s.debug("ComputeTargetPlatform:",h),h}e.$ip=d}),define(Ce[264],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0;function I(p){return[...p.entries()]}e.$Vr=I;function O(p){return p?[...p.entries()]:[]}e.$Wr=O;function $(p){return new Map(p)}e.$Xr=$;function A(p){return new Map(p??[])}e.$Yr=A;function R(p){return Array.from(p.entries()).map(S=>[S[0],I(S[1].map),O(S[1].descriptionMap)])}e.$Zr=R;function v(p){return new Map(p.map(S=>[S[0],{map:$(S[1]),descriptionMap:A(S[2])}]))}e.$1r=v}),define(Ce[265],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftb=void 0;class I{constructor($){this.b=$,this.a=new Map}dispose(){for(const $ of this.a.values())$.dispose()}startBuffering($,A,R=5){const v=A(p=>{const S=typeof p=="string"?p:p.data;let L=this.a.get($);if(L){L.data.push(S);return}const C=setTimeout(()=>this.flushBuffer($),R);L={data:[S],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer($),v.dispose()}},this.a.set($,L)});return v}stopBuffering($){this.a.get($)?.dispose()}flushBuffer($){const A=this.a.get($);A&&(this.a.delete($),this.b($,A.data.join("")))}}e.$ftb=I}),define(Ce[266],Ie([1,0,8,79,55,4,18,2,208,108,37]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.IconFontDefinition=e.IconContribution=e.$Fw=void 0,e.$Fw={IconContribution:"base.contributions.icons"};var C;(function(r){function a(t,d){let c=t.defaults;for(;$.ThemeIcon.isThemeIcon(c);){const s=k.getIcon(c.id);if(!s)return;c=s.defaults}return c}r.getDefinition=a})(C||(e.IconContribution=C={}));var w;(function(r){function a(d){return{weight:d.weight,style:d.style,src:d.src.map(c=>({format:c.format,location:c.location.toString()}))}}r.toJSONObject=a;function t(d){const c=s=>(0,R.$Qf)(s)?s:void 0;if(d&&Array.isArray(d.src)&&d.src.every(s=>(0,R.$Qf)(s.format)&&(0,R.$Qf)(s.location)))return{weight:c(d.weight),style:c(d.style),src:d.src.map(s=>({format:s.format,location:v.URI.parse(s.location)}))}}r.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class E{constructor(){this.a=new A.$3d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${$.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,d,c){const s=this.b[a];if(s){if(d&&!s.description){s.description=d,this.d.properties[a].markdownDescription=`${d} $(${a})`;const b=this.e.enum.indexOf(a);b!==-1&&(this.e.enumDescriptions[b]=d),this.a.fire()}return s}const l={id:a,description:d,defaults:t,deprecationMessage:c};this.b[a]=l;const h={$ref:"#/definitions/icons"};return c&&(h.deprecationMessage=c),d&&(h.markdownDescription=`${d}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const d=this.f[a];return d||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(s,l)=>s.id.localeCompare(l.id),t=s=>{for(;$.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const c=Object.keys(this.b).map(s=>this.b[s]);for(const s of c.filter(l=>!!l.description).sort(a))d.push(`|<i class="${t(s)}"></i>|${s.id}|${$.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const s of c.filter(l=>!$.ThemeIcon.isThemeIcon(l.defaults)).sort(a))d.push(`|<i class="${t(s)}"></i>|${s.id}|`);return d.join(`
`)}}const k=new E;L.$Rn.add(e.$Fw.IconContribution,k);function u(r,a,t,d){return k.registerIcon(r,a,t,d)}e.$Gw=u;function m(){return k}e.$Hw=m;function o(){const r=(0,O.$gk)();for(const a in r){const t="\\"+r[a].toString(16);k.registerIcon(a,{fontCharacter:t})}}o(),e.$Iw="vscode://schemas/icons";const i=L.$Rn.as(S.$Sn.JSONContribution);i.registerSchema(e.$Iw,k.getIconSchema());const n=new I.$oh(()=>i.notifySchemaChanged(e.$Iw),200);k.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Jw=u("widget-close",O.$ik.close,(0,p.localize)(2,null)),e.$Kw=u("goto-previous-location",O.$ik.arrowUp,(0,p.localize)(3,null)),e.$Lw=u("goto-next-location",O.$ik.arrowDown,(0,p.localize)(4,null)),e.$Mw=$.ThemeIcon.modify(O.$ik.sync,"spin"),e.$Nw=$.ThemeIcon.modify(O.$ik.loading,"spin")}),define(Ce[88],Ie([1,0,4,2,51,5,13]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.ProvidedOnAutoForward=e.$Lv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Kv=e.$Jv=void 0,e.$Jv=(0,A.$ci)("tunnelService"),e.$Kv=(0,A.$ci)("sharedTunnelsService");var v;(function(o){o.Http="http",o.Https="https"})(v||(e.TunnelProtocol=v={}));var p;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(p||(e.TunnelPrivacyId=p={}));function S(o){return!!o.forwardPort}e.$Lv=S;var L;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(L||(e.ProvidedOnAutoForward=L={}));function C(o,{checkQuery:i=!0}={}){if(o.scheme!=="http"&&o.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(n)return{address:n[1],port:+n[2]};if(!o.query||!i)return;const r=o.query.split("&");for(const a of r){const t=a.split("=")[1];if(/^https?:/.exec(t)){const d=C(O.URI.parse(t));if(d)return d}}}e.$Mv=C,e.$Nv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(o){return e.$Nv.indexOf(o)>=0}e.$Ov=w,e.$Pv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(o){return e.$Pv.indexOf(o)>=0}e.$Qv=E;function k(o,i,n,r){if(n===1)return!1;if(n===2&&E(i)){const a=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(a?.length===4&&parseInt(a[1])>=18)return!1}return o<1024}e.$Rv=k;class u{constructor(i,n,r){this.remoteAddress=i,this.localAddress=n,this.b=r,this.a=new I.$3d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sv=u;let m=class{constructor(i,n){this.k=i,this.l=n,this.a=new I.$3d,this.onTunnelOpened=this.a.event,this.b=new I.$3d,this.onTunnelClosed=this.b.event,this.c=new I.$3d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],n=Array.from(this.e.values());for(const r of n){const a=Array.from(r.values());for(const t of a){const d=await t.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(r=>typeof r!="string"?r?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,r,a,t){this.q(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:r,privacy:a,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(E(i)||w(i))&&(i=e.$Nv[0]);const r=this.s(i,n);if(r)return++r.refcount,r.value}openTunnel(i,n,r,a,t,d=!1,c,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${r} on local port ${t}.`);const l=this.f??i;if(!l)return;if(n||(n="localhost"),a||(a=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t(l,n,r,a,t,d,c,s);return h?h.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,r),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(b);return(b.tunnelRemoteHost!==n||b.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&b.privacy!==c&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const r=n.get(i.tunnelRemotePort);r&&(r.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,r))}}}}async p(i,n,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const a=r.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),a}}async closeTunnel(i,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const r=this.e.get(i);if(r&&r.has(n)){const a=r.get(n);a.refcount=0,await this.p(i,n,a)}}q(i,n,r){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:r})}async r(i,n){const r=this.e.get(i);if(r){const a=r.get(n),t=a?await a.value:void 0;(!t||typeof t=="string")&&r.delete(n),r.size===0&&this.e.delete(i)}}s(i,n){const r=[i];w(i)?(r.push(...e.$Nv),r.push(...e.$Pv)):E(i)&&r.push(...e.$Pv);const a=r.map(t=>this.e.get(t));for(const t of a){const d=t?.get(n);if(d)return d}}canTunnel(i){return!!C(i)}u(i,n,r,a,t,d,c){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${r} on local port ${a}.`);const s=r;this.j.add(s);const l=a===void 0?r:a,h={elevationRequired:t?this.isPortPrivileged(l):!1},b={remoteAddress:{host:n,port:r},localAddressPort:a,privacy:d,public:d?d!==p.Private:void 0,protocol:c},D=i.forwardPort(b,h);return D?(this.q(n,r,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),D}};e.$Tv=m,e.$Tv=m=Ke([We(0,R.$wj),We(1,$.$Ii)],m)}),define(Ce[267],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=void 0,e.$0k=(0,I.$ci)("IUriIdentityService")}),define(Ce[268],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Uv=void 0,e.$Uv=(0,I.$ci)("editSessionIdentityService");var O;(function($){$[$.Complete=100]="Complete",$[$.Partial=50]="Partial",$[$.None=0]="None"})(O||(e.EditSessionIdentityMatch=O={}))}),define(Ce[269],Ie([1,0,16]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=void 0;function O(p){return p.scheme!==I.Schemas.file&&p.scheme!==I.Schemas.vscodeRemote}e.$sL=O;function $(p){if(p.folders.length)return p.folders.every(S=>O(S.uri))?p.folders[0].uri:void 0;if(p.configuration&&O(p.configuration))return p.configuration}e.$tL=$;function A(p){return $(p)?.scheme}e.$uL=A;function R(p){return $(p)?.authority}e.$vL=R;function v(p){return $(p)!==void 0}e.$wL=v}),define(Ce[40],Ie([1,0,210,17,78,23,2,5,16]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.WorkbenchState=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=void 0,e.$li=(0,v.$ci)("contextService");function S(s){const l=s;return typeof l?.id=="string"&&R.URI.isUri(l.uri)}e.$mi=S;function L(s){return typeof s?.id=="string"&&!S(s)&&!w(s)}e.$ni=L,e.$oi={id:"ext-dev"},e.$pi={id:"empty-window"};function C(s,l){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,O.$nc)(s)}:l?e.$oi:e.$pi;const h=s;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$qi=C;function w(s){const l=s;return typeof l?.id=="string"&&R.URI.isUri(l.configPath)}e.$ri=w;function E(s){const l=s;if(l?.uri)return{id:l.id,uri:R.URI.revive(l.uri)};const h=s;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(s?.id)return{id:s.id}}e.$si=E;var k;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(k||(e.WorkbenchState=k={}));function u(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&Array.isArray(l.folders))}e.$ti=u;function m(s){const l=s;return!!(l&&typeof l=="object"&&R.URI.isUri(l.uri)&&typeof l.name=="string"&&typeof l.toResource=="function")}e.$ui=m;class o{constructor(l,h,b,D,g){this.h=l,this.j=b,this.k=D,this.l=g,this.c=$.$ii.forUris(this.l,()=>!0),this.folders=h}update(l){this.h=l.id,this.k=l.configuration,this.j=l.transient,this.l=l.l,this.folders=l.folders}get folders(){return this.g}set folders(l){this.g=l,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(l){this.k=l}getFolder(l){return l&&this.c.findSubstr(l)||null}n(){this.c=$.$ii.forUris(this.l,()=>!0);for(const l of this.folders)this.c.set(l.uri,l)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$vi=o;class i{constructor(l,h){this.raw=h,this.uri=l.uri,this.index=l.index,this.name=l.name}toResource(l){return(0,A.$Pg)(this.uri,l)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$wi=i;function n(s){return new i({uri:s,index:0,name:(0,A.$Lg)(s)},{uri:s.toString()})}e.$xi=n,e.$yi="code-workspace",e.$zi=`.${e.$yi}`,e.$Ai=[{name:(0,I.localize)(0,null),extensions:[e.$yi]}],e.$Bi="workspace.json";function r(s,l){return A.$Gg.isEqualOrParent(s,l.untitledWorkspacesHome)}e.$Ci=r;function a(s){let l;return R.URI.isUri(s)?l=s:l=s.configuration,l?.scheme===p.Schemas.tmp}e.$Di=a,e.$Ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Ei}e.$Fi=t;function d(s,l){return!r(s,l)&&!a(s)}e.$Gi=d;function c(s){return(typeof s=="string"?(0,O.$oc)(s):(0,A.$Ng)(s))===e.$zi}e.$Hi=c}),define(Ce[270],Ie([1,0,54,4,3,23,2,209,133,32,5,13,40,28,267,8,30,12,18]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.ProfileResourceType=void 0;var n;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(s){const l=s;return!!(l&&typeof l=="object"&&typeof l.id=="string"&&typeof l.isDefault=="boolean"&&typeof l.name=="string"&&R.URI.isUri(l.location)&&R.URI.isUri(l.globalStorageHome)&&R.URI.isUri(l.settingsResource)&&R.URI.isUri(l.keybindingsResource)&&R.URI.isUri(l.tasksResource)&&R.URI.isUri(l.snippetsHome)&&R.URI.isUri(l.extensionsResource))}e.$$k=r,e.$_k=(0,L.$ci)("IUserDataProfilesService");function a(s,l){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:l}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:l}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:l}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:l}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:l}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:l}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:l}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:l}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$al=a;function t(s,l,h,b,D,g){return{id:s,name:l,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:g&&D?.useDefaultFlags?.globalState?g.globalStorageHome:(0,A.$Pg)(h,"globalStorage"),settingsResource:g&&D?.useDefaultFlags?.settings?g.settingsResource:(0,A.$Pg)(h,"settings.json"),keybindingsResource:g&&D?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,A.$Pg)(h,"keybindings.json"),tasksResource:g&&D?.useDefaultFlags?.tasks?g.tasksResource:(0,A.$Pg)(h,"tasks.json"),snippetsHome:g&&D?.useDefaultFlags?.snippets?g.snippetsHome:(0,A.$Pg)(h,"snippets"),extensionsResource:g&&D?.useDefaultFlags?.extensions?g.extensionsResource:(0,A.$Pg)(h,"extensions.json"),cacheHome:(0,A.$Pg)(b,s),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$bl=t;let d=class extends $.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(l,h,b,D){super(),this.t=l,this.u=h,this.w=b,this.y=D,this.f=!0,this.h=this.B(new O.$3d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$3d),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$3d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$3d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Pg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Pg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(l){this.f!==l&&(this.z=void 0,this.f=l)}isEnabled(){return this.f}get C(){if(!this.z){const l=this.D(),h=[l];if(this.f)try{for(const g of this.O()){if(!g.name||!(0,i.$Qf)(g.name)||!g.location){this.y.warn("Skipping the invalid stored profile",g.location||g.name);continue}h.push(t((0,A.$Mg)(g.location),g.name,g.location,this.g,{shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags},l))}}catch(g){this.y.error(g)}const b=new E.$Ac,D=new Map;if(h.length)try{const g=this.Q();if(g.workspaces)for(const[f,y]of Object.entries(g.workspaces)){const P=R.URI.parse(f),N=h.find(U=>U.id===y);N&&b.set(P,N)}if(g.emptyWindows)for(const[f,y]of Object.entries(g.emptyWindows)){const P=h.find(N=>N.id===y);P&&D.set(f,P)}}catch(g){this.y.error(g)}this.z={profiles:h,workspaces:b,emptyWindows:D}}return this.z}D(){const l=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...l,extensionsResource:this.S()??l.extensionsResource,isDefault:!0}}async createTransientProfile(l){const h="Temp",b=new RegExp(`${(0,o.$Ve)(h)}\\s(\\d+)`);let D=0;for(const f of this.profiles){const y=b.exec(f.name),P=y?parseInt(y[1]):0;D=P>D?P:D}const g=`${h} ${D+1}`;return this.createProfile((0,I.$3i)((0,m.$yg)()).toString(16),g,{transient:!0},l)}async createNamedProfile(l,h,b){return this.createProfile((0,I.$3i)((0,m.$yg)()).toString(16),l,h,b)}async createProfile(l,h,b,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.F(l,h,b);return D&&await this.setProfileForWorkspace(D,g),g}async F(l,h,b){if(!(0,i.$Qf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const g=this.profiles.find(P=>P.name===h||P.id===l);if(g)return g;const f=t(l,h,(0,A.$Pg)(this.profilesHome,l),this.g,b,this.defaultProfile);await this.u.createFolder(f.location);const y=[];return this.j.fire({profile:f,join(P){y.push(P)}}),await u.Promises.settled(y),this.I([f],[],[]),f}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(D=>D.id===l.id);if(!b)throw new Error(`Profile '${l.name}' does not exist`);return b=t(b.id,h.name??b.name,b.location,this.g,{shortName:h.shortName??b.shortName,icon:h.icon===null?void 0:h.icon??b.icon,transient:h.transient??b.isTransient,useDefaultFlags:h.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(l.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===l.id);if(!h)throw new Error(`Profile '${l.name}' does not exist`);const b=[];this.m.fire({profile:h,join(D){b.push(D)}});try{await Promise.allSettled(b)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,S.$Qk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(D=>D.id===h.id);if(!b)throw new Error(`Profile '${h.name}' does not exist`);this.L(l,b)}unsetWorkspace(l,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(l,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const l=await this.u.resolve(this.profilesHome);await Promise.all((l.children||[]).filter(h=>h.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const l=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(l.map(h=>this.removeProfile(h)))}getProfileForWorkspace(l){const h=this.G(l);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(l){return(0,w.$mi)(l)?l.uri:(0,w.$ri)(l)?l.configPath:l.id}H(l){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,l.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,l.location)))}I(l,h,b){const D=[...this.profiles,...l],g=[];this.s.profiles=[];for(let f of D)f.isDefault||h.some(y=>f.id===y.id)||(f=b.find(y=>f.id===y.id)??f,f.isTransient?this.s.profiles.push(f):g.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags}));this.P(g),this.z=void 0,this.J(l,h,b)}J(l,h,b){this.h.fire({added:l,removed:h,updated:b,all:this.profiles})}L(l,h,b){b=h?.isTransient?!0:b,b||this.L(l,void 0,!0);const D=this.G(l),g=b?this.s:this.C;R.URI.isUri(D)?(g.workspaces.delete(D),h&&g.workspaces.set(D,h)):(g.emptyWindows.delete(D),h&&g.emptyWindows.set(D,h)),b||this.M()}M(){const l={};for(const[b,D]of this.C.workspaces.entries())l[b.toString()]=D.id;const h={};for(const[b,D]of this.C.emptyWindows.entries())h[b.toString()]=D.id;this.R({workspaces:l,emptyWindows:h}),this.z=void 0}N(l){const h={},b=this.D();if(l.workspaces)for(const[g,f]of Object.entries(l.workspaces)){const y=R.URI.parse(f);h[g]=this.w.extUri.isEqual(y,b.location)?b.id:this.w.extUri.basename(y)}const D={};if(l.emptyWindows)for(const[g,f]of Object.entries(l.emptyWindows)){const y=R.URI.parse(f);D[g]=this.w.extUri.isEqual(y,b.location)?b.id:this.w.extUri.basename(y)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(l){throw new Error("not implemented")}Q(){return{}}R(l){throw new Error("not implemented")}S(){}};e.$cl=d,e.$cl=d=Ke([We(0,p.$ji),We(1,S.$zk),We(2,k.$0k),We(3,C.$wj)],d);class c extends d{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(l){this.a=l}Q(){return this.X}R(l){this.X=l}}e.$dl=c}),define(Ce[271],Ie([1,0,8,4,3,58,18,189,5,270]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Dp=e.$Cp=e.$Bp=void 0,e.$Bp="__$__isNewStorageMarker",e.$Cp="__$__targetStorageMarker",e.$Dp=(0,p.$ci)("storageService");var L;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(L||(e.WillSaveStateReason=L={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var w;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function E(i){const n=i.get(e.$Cp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$Ep=E;class k extends $.$Tc{static{this.a=60*1e3}constructor(n={flushInterval:k.a}){super(),this.m=n,this.b=this.B(new O.$6d),this.c=this.B(new O.$6d),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$3d),this.onWillSaveState=this.f.event,this.h=this.B(new I.$oh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new $.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return O.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,I.$sh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,$.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$Cp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,d=!1){if((0,R.$Zf)(r)){this.remove(n,a,d);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,d)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const d of Object.keys(t))t[d]===r&&a.push(d);return a}z(n,r,a,t=!1){const d=this.J(r);typeof a=="number"?d[n]!==a&&(d[n]=a,this.P(r)?.set(e.$Cp,JSON.stringify(d),t)):typeof d[n]=="number"&&(delete d[n],this.P(r)?.set(e.$Cp,JSON.stringify(d),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?E(r):Object.create(null)}isNew(n){return this.getBoolean(e.$Bp,n)===!0}async flush(n=L.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case L.NONE:await I.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case L.SHUTDOWN:await I.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(L.NONE),(0,S.$$k)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||u(r)&&u(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[d,c]of n)t.add(d),r.get(d)!==c&&this.u(a,{key:d,external:!0});for(const[d]of r.items)t.has(d)||this.u(a,{key:d,external:!0})})}}e.$Fp=k;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Gp=u;class m extends k{constructor(){super(),this.U=this.B(new v.$zp(new v.$Ap,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$zp(new v.$Ap,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$zp(new v.$Ap,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Hp=m;async function o(i,n,r,a,t,d){const c=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,l=new Map;i.forEach((P,N)=>{s.set(N,P),l.set(N,c(P))});const h=new Map,b=new Map;n.forEach((P,N)=>{h.set(N,P),b.set(N,c(P))});const D=new Map,g=new Map;r.forEach((P,N)=>{D.set(N,P),g.set(N,c(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const f=[];if(s.forEach((P,N)=>{f.push({key:N,value:P})}),console.table(f),console.groupEnd(),console.log(l),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((N,U)=>{P.push({key:U,value:N})}),console.table(P),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${d})`);const y=[];D.forEach((P,N)=>{y.push({key:N,value:P})}),console.table(y),console.groupEnd(),console.log(g)}e.$Ip=o}),define(Ce[110],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class I{static{this.a=!1}constructor($){this.d=$,this.b=new Map,this.c=1}add($){const A=this.c++;return this.b.set(A,$),this.e(),A}get($,A){return this.b.has($)?this.b.get($)[A]:void 0}delete($){this.b.delete($),this.e()}e(){I.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$4gc=I}),define(Ce[59],Ie([1,0,16,23,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class A{constructor(){this.a=new Set(Object.keys(I.Schemas)),this.b=new Map,this.extUri=new O.$Eg(v=>{const p=this.b.get(v.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(v,p){p===null?this.b.delete(v.scheme):this.b.set(v.scheme,p)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$9gc=A,e.$0gc=(0,$.$ci)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0,e.$qO=(0,I.$ci)("IExtHostInitDataService")}),define(Ce[272],Ie([1,0,216,13,252,27]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;let R=class extends $.$xP{constructor(p,S,L){const C=L.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",w=L.remote.isRemote?(0,I.localize)(0,null):p?(0,I.localize)(1,null):(0,I.localize)(2,null);super(S.createLogger(C,{name:w}))}};e.$bjc=R,e.$bjc=R=Ke([We(1,O.$xj),We(2,A.$qO)],R)}),define(Ce[273],Ie([1,0,8]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;class O{constructor(R,v,p){this.h=new Map,this.a=R,this.b=v,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(S=>(this.f=S,this)),this.g=this.c.onDidChangeStorage(S=>{S.shared===this.b&&S.key===this.a&&(this.f=S.value)}),this.i=new I.$oh(()=>{const S=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const L of S.values())L.complete()}catch(L){for(const C of S.values())C.error(L)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,v){let p=this.f[R];return typeof p>"u"&&(p=v),p}update(R,v){this.f[R]=v;const p=this.h.get(R);if(p!==void 0)return p.p;const S=new I.$zh;return this.h.set(R,S),this.i.isScheduled()||this.i.schedule(),S.p}dispose(){this.g.dispose()}}e.$Phc=O;class $ extends O{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,v){super(R.identifier.value,!0,v),this.j=R}}e.$Qhc=$}),define(Ce[274],Ie([1,0,4,2]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class ${constructor(R){this.c=R,this.a=new I.$3d,this.onDidSaveNotebookDocument=this.a.event,this.b=new I.$3d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,v,p,S){const C=this.c.getNotebookDocument(O.URI.revive(R)).acceptModelChanged(v.value,p,S);this.b.fire(C)}$acceptDirtyStateChanged(R,v){this.c.getNotebookDocument(O.URI.revive(R)).acceptDirty(v)}$acceptModelSaved(R){const v=this.c.getNotebookDocument(O.URI.revive(R));this.a.fire(v.apiNotebook)}}e.$Dic=$}),define(Ce[20],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0,e.$aO=(0,I.$ci)("IExtHostRpcService");class O{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$bO=O}),define(Ce[275],Ie([1,0,26,4]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class ${#e;constructor(R,v){this.b=new O.$3d,this.onDidChange=this.b.event,this.a=I.$um.toKey(R.identifier),this.#e=v,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(R){return this.#e.get(this.a,R)}store(R,v){return this.#e.store(this.a,R,v)}delete(R){return this.#e.delete(this.a,R)}}e.$Xhc=$}),define(Ce[67],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0,e.$nhc=(0,I.$ci)("IURITransformerService");class O{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ohc=O}),define(Ce[276],Ie([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmb=e.$Kmb=void 0;class O{constructor(){this.buffers=[]}add(p){let S=this.buffers.indexOf(p);return S<0&&(S=this.buffers.length,this.buffers.push(p)),S}}function $(v,p){if(p.serializeBuffersForPostMessage){const S=new O,C=JSON.stringify(v,(E,k)=>{if(k instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:S.add(k)};if(ArrayBuffer.isView(k)){const u=A(k);if(u)return{$$vscode_array_buffer_reference$$:!0,index:S.add(k.buffer),view:{type:u,byteLength:k.byteLength,byteOffset:k.byteOffset}}}return k}),w=S.buffers.map(E=>{const k=new Uint8Array(E);return I.$qe.wrap(k)});return{message:C,buffers:w}}else return{message:JSON.stringify(v),buffers:[]}}e.$Kmb=$;function A(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(v,p){const S=p.map(w=>{const E=new ArrayBuffer(w.byteLength);return new Uint8Array(E).set(w.buffer),E}),L=p.length?(w,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const k=E,{index:u}=k,m=S[u];if(k.view)switch(k.view.type){case 1:return new Int8Array(m,k.view.byteOffset,k.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,k.view.byteOffset,k.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,k.view.byteOffset,k.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,k.view.byteOffset,k.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,k.view.byteOffset,k.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,k.view.byteOffset,k.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,k.view.byteOffset,k.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,k.view.byteOffset,k.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,k.view.byteOffset,k.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,k.view.byteOffset,k.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,k.view.byteOffset,k.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(v,L),arrayBuffers:S}}e.$Lmb=R}),define(Ce[277],Ie([1,0,278,391,392,62,2,13,393]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;const S=!1;function L(n,r,a,t,d,c){const s=c.environment.useHostProxy,l=typeof s=="boolean"?s:!c.remote.isRemote,h={resolveProxy:g=>n.resolveProxy(g),lookupProxyAuthorization:m.bind(void 0,t,d,r,{},c.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>w(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const g=t.getLevel();switch(g){case v.LogLevel.Trace:return p.LogLevel.Trace;case v.LogLevel.Debug:return p.LogLevel.Debug;case v.LogLevel.Info:return p.LogLevel.Info;case v.LogLevel.Warning:return p.LogLevel.Warning;case v.LogLevel.Error:return p.LogLevel.Error;case v.LogLevel.Off:return p.LogLevel.Off;default:return f(g)}function f(y){return t.error("Unknown log level",y),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:l,loadAdditionalCertificates:async()=>{const g=[];if(c.remote.isRemote&&g.push((0,p.loadSystemCertificates)({log:t})),l){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const f=n.loadCertificates();f.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),g.push(f)}return(await Promise.all(g)).flat()},env:process.env},b=(0,p.createProxyResolver)(h),D=C(h,b);return u(a,D)}e.$Jjc=L;function C(n,r){return{http:Object.assign(I,(0,p.createHttpPatch)(n,I,r)),https:Object.assign(O,(0,p.createHttpPatch)(n,O,r)),net:Object.assign(A,(0,p.createNetPatch)(n,A)),tls:Object.assign($,(0,p.createTlsPatch)(n,$))}}function w(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}function E(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",S)&&!!r.get("systemCertificates")}const k=new Map;function u(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,d=t._load;t._load=function(s,l,h){if(s==="net")return r.net;if(s==="tls")return r.tls;if(s!=="http"&&s!=="https")return d.apply(this,arguments);const b=a.findSubstr(R.URI.file(l.filename));let D=k.get(b);if(D||k.set(b,D={}),!D[s]){const g=r[s];D[s]={...g}}return D[s]}})}async function m(n,r,a,t,d,c,s,l){const h=t[c];s&&(t[c]=s),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${c}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${h}`);const b=s||h,D=Array.isArray(b)?b:typeof b=="string"?[b]:[];if(i(r,D,d),D.some(g=>/^(Negotiate|Kerberos)( |$)/i.test(g))&&!l.kerberosRequested)try{l.kerberosRequested=!0;const g=await new Promise((U,z)=>{me(["kerberos"],U,z)}),f=new URL(c),y=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${f.hostname}`:`HTTP@${f.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${c}`,`spn:${y}`),"Negotiate "+await(await g.initializeClient(y)).step("")}catch(g){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",g)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Ce[279],Ie([1,0,130]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0;function O(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function $(A){return new I.$bn(O(A))}e.$_r=$}),define(Ce[139],Ie([1,0,226,18,2,3,5,37,32,16,44,181,39]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.EditorsOrder=e.$aF=e.CloseDirection=e.$_E=e.$$E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.EditorInputCapabilities=e.$2E=e.SaveReason=e.Verbosity=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=void 0,e.$OE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PE={id:"default",displayName:(0,I.localize)(0,null),providerDisplayName:(0,I.localize)(1,null)},e.$QE="workbench.editor.sidebysideEditor",e.$RE="workbench.editors.textDiffEditor",e.$SE="workbench.editors.binaryResourceDiffEditor";var E;(function(re){re[re.PROGRAMMATIC=1]="PROGRAMMATIC",re[re.USER=2]="USER",re[re.EDIT=3]="EDIT",re[re.NAVIGATION=4]="NAVIGATION",re[re.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var k;(function(re){re[re.IDENTICAL=1]="IDENTICAL",re[re.SIMILAR=2]="SIMILAR",re[re.DIFFERENT=3]="DIFFERENT"})(k||(e.EditorPaneSelectionCompareResult=k={}));function u(re){const K=re;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}e.$TE=u;function m(re,K,B){for(const ae of B.visibleEditorPanes)if(ae.group.id===K&&re.matches(ae.input))return ae.getViewState()}e.$UE=m;function o(re){if(b(re))return!1;const K=re;return $.URI.isUri(K?.resource)}e.$VE=o;function i(re){if(b(re))return!1;const K=re;return K?.original!==void 0&&K.modified!==void 0}e.$WE=i;function n(re){if(b(re))return!1;const K=re;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}e.$XE=n;function r(re){if(b(re)||i(re))return!1;const K=re;return K?.primary!==void 0&&K.secondary!==void 0}e.$YE=r;function a(re){if(b(re))return!1;const K=re;return K?K.resource===void 0||K.resource.scheme===S.Schemas.untitled||K.forceUntitled===!0:!1}e.$ZE=a;function t(re){if(b(re))return!1;const K=re;return $.URI.isUri(K?.base?.resource)&&$.URI.isUri(K?.input1?.resource)&&$.URI.isUri(K?.input2?.resource)&&$.URI.isUri(K?.result?.resource)}e.$1E=t;var d;(function(re){re[re.SHORT=0]="SHORT",re[re.MEDIUM=1]="MEDIUM",re[re.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var c;(function(re){re[re.EXPLICIT=1]="EXPLICIT",re[re.AUTO=2]="AUTO",re[re.FOCUS_CHANGE=3]="FOCUS_CHANGE",re[re.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(c||(e.SaveReason=c={}));class s{constructor(){this.a=new Map}registerSource(K,B){let ae=this.a.get(K);return ae||(ae={source:K,label:B},this.a.set(K,ae)),ae.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$2E=new s;var l;(function(re){re[re.None=0]="None",re[re.Readonly=2]="Readonly",re[re.Untitled=4]="Untitled",re[re.Singleton=8]="Singleton",re[re.RequiresTrust=16]="RequiresTrust",re[re.CanSplitInGroup=32]="CanSplitInGroup",re[re.ForceDescription=64]="ForceDescription",re[re.CanDropIntoEditor=128]="CanDropIntoEditor",re[re.MultipleEditors=256]="MultipleEditors",re[re.Scratchpad=512]="Scratchpad",re[re.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(l||(e.EditorInputCapabilities=l={}));class h extends A.$Tc{}e.$3E=h;function b(re){return re instanceof h}e.$4E=b;function D(re){const K=re;return $.URI.isUri(K?.preferredResource)}function g(re){const K=re;return b(K?.primary)&&b(K?.secondary)}e.$5E=g;function f(re){const K=re;return b(K?.modified)&&b(K?.original)}e.$6E=f;function y(re,K,B,ae,ye){return fe(ae,[(0,C.$Yi)({id:"workbench.action.openLargeFile",label:(0,I.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};re.openEditor(K,le)}}),(0,C.$Yi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,I.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$7E=y;function P(re){return b(re?.editor)}e.$8E=P;function N(re){const K=re;return P(re)&&K?.group!==void 0}e.$9E=N;function U(re){const K=re;return typeof K?.groupId=="number"&&b(K.editor)}e.$0E=U;var z;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.REPLACE=1]="REPLACE",re[re.MOVE=2]="MOVE",re[re.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var F;(function(re){re[re.GROUP_ACTIVE=0]="GROUP_ACTIVE",re[re.GROUP_INDEX=1]="GROUP_INDEX",re[re.GROUP_LABEL=2]="GROUP_LABEL",re[re.GROUP_LOCKED=3]="GROUP_LOCKED",re[re.EDITOR_OPEN=4]="EDITOR_OPEN",re[re.EDITOR_CLOSE=5]="EDITOR_CLOSE",re[re.EDITOR_MOVE=6]="EDITOR_MOVE",re[re.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",re[re.EDITOR_LABEL=8]="EDITOR_LABEL",re[re.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",re[re.EDITOR_PIN=10]="EDITOR_PIN",re[re.EDITOR_STICKY=11]="EDITOR_STICKY",re[re.EDITOR_DIRTY=12]="EDITOR_DIRTY",re[re.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var M;(function(re){re[re.PRIMARY=1]="PRIMARY",re[re.SECONDARY=2]="SECONDARY",re[re.BOTH=3]="BOTH",re[re.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class T{getOriginalUri(K,B){if(!K)return;if(t(K))return e.$_E.getOriginalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.a(K);if(ye&&le){if(B?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===M.PRIMARY?ye:le}}if(i(K)||n(K)||r(K)||t(K))return;const ae=D(K)?K.preferredResource:K.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}a(K){return g(K)||r(K)?{primary:K.primary,secondary:K.secondary}:f(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,B){if(!K)return;if(t(K))return e.$_E.getCanonicalUri(K.result,B);if(B?.supportSideBySide){const{primary:ye,secondary:le}=this.a(K);if(ye&&le){if(B?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});K=B.supportSideBySide===M.PRIMARY?ye:le}}if(i(K)||n(K)||r(K)||t(K))return;const ae=K.resource;return!ae||!B||!B.filterByScheme?ae:this.b(ae,B.filterByScheme)}b(K,B){if(Array.isArray(B)){if(B.some(ae=>K.scheme===ae))return K}else if(B===K.scheme)return K}}var j;(function(re){re[re.UNKNOWN=0]="UNKNOWN",re[re.KEYBOARD=1]="KEYBOARD",re[re.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function J(re,K,B,ae){if(!re.isSticky(K))return!1;switch(ae.preventPinnedEditorClose){case"keyboardAndMouse":return B===j.MOUSE||B===j.KEYBOARD;case"mouse":return B===j.MOUSE;case"keyboard":return B===j.KEYBOARD}return!1}e.$$E=J,e.$_E=new T;var ne;(function(re){re[re.LEFT=0]="LEFT",re[re.RIGHT=1]="RIGHT"})(ne||(e.CloseDirection=ne={}));class _{constructor(){this.c=new Map,this.d=new Map}start(K){const B=this.a=K.get(R.$bi);for(const[ae,ye]of this.c)this.e(ae,ye,B);this.c.clear()}e(K,B,ae){const ye=ae.createInstance(B);this.d.set(K,ye)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,O.$2f)(this.b)}registerEditorSerializer(K,B){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,B,this.a):this.c.set(K,B),(0,A.$Rc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}v.$Rn.add(e.$OE.EditorFactory,new _);async function Z(re,K,B){return!re||!re.length?[]:await Promise.all(re.map(async ae=>{const ye=$.URI.revive(ae.fileUri);if(!ye){B.info("Cannot resolve the path because it is not valid.",ae);return}if(!await K.canHandleResource(ye)){B.info("Cannot resolve the path because it cannot be handled",ae);return}let de=ae.exists,ue=ae.type;if(typeof de!="boolean"||typeof ue!="number")try{ue=(await K.stat(ye)).isDirectory?p.FileType.Directory:p.FileType.Unknown,de=!0}catch(V){B.error(V),de=!1}if(!de&&ae.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ae);return}if(ue===p.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ae);return}const ge={...ae.options,pinned:!0};return de?{resource:ye,options:ge}:{resource:ye,options:ge,forceUntitled:!0}}))}e.$aF=Z;var Y;(function(re){re[re.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",re[re.SEQUENTIAL=1]="SEQUENTIAL"})(Y||(e.EditorsOrder=Y={}));function ce(re){const K=re;if(!K)return!1;const B=K;if(B.modified)return ce(B.modified);const ae=K;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.$bF=ce;function ie(re){return(0,L.$1i)(re)}e.$cF=ie;function fe(re,K,B){const ae=(0,L.$2i)(re,K);return ae.forceMessage=B?.forceMessage,ae.forceSeverity=B?.forceSeverity,ae.allowDialog=B?.allowDialog,ae}e.$dF=fe}),define(Ce[280],Ie([1,0,4,227,5,3,28,37,19,24,79,266]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$jF=e.ViewContentGroups=e.$iF=e.$hF=e.ViewContainerLocation=e.Extensions=e.$gF=e.$fF=e.$eF=void 0,e.$eF="views",e.$fF=(0,O.localize)(0,null),e.$gF=(0,C.$Gw)("default-view-icon",L.$ik.window,(0,O.localize)(1,null));var w;(function(d){d.ViewContainersRegistry="workbench.registry.view.containers",d.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var E;(function(d){d[d.Sidebar=0]="Sidebar",d[d.Panel=1]="Panel",d[d.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$hF=[0,1,2];function k(d){switch(d){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$iF=k;class u extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new I.$3d),this.onDidRegister=this.c.event,this.f=this.B(new I.$3d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(c,s,l){const h=this.get(c.id);if(h)return h;const b=c;return b.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:b.openCommandActionDescriptor??{id:b.id},(0,R.$xc)(this.g,s,[]).push(b),l?.isDefault&&this.h.push(b),this.c.fire({viewContainer:b,viewContainerLocation:s}),b}deregisterViewContainer(c){for(const s of this.g.keys()){const l=this.g.get(s),h=l?.indexOf(c);if(h!==-1){l?.splice(h,1),l.length===0&&this.g.delete(s),this.f.fire({viewContainer:c,viewContainerLocation:s});return}}}get(c){return this.all.filter(s=>s.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(l=>l?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(s=>this.getViewContainerLocation(s)===c)}}v.$Rn.add(w.ViewContainersRegistry,new u);var m;(function(d){d.Open="2_open",d.Debug="4_debug",d.SCM="5_scm",d.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(d,c){const s=d.group??m.More,l=c.group??m.More;return s!==l?s.localeCompare(l):(d.order??5)-(c.order??5)}class i extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new I.$3d),this.onViewsRegistered=this.c.event,this.f=this.B(new I.$3d),this.onViewsDeregistered=this.f.event,this.g=this.B(new I.$3d),this.onDidChangeContainer=this.g.event,this.h=this.B(new I.$3d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(c,s){this.registerViews2([{views:c,viewContainer:s}])}registerViews2(c){c.forEach(({views:s,viewContainer:l})=>this.r(s,l)),this.c.fire(c)}deregisterViews(c,s){const l=this.s(c,s);l.length&&this.f.fire({views:l,viewContainer:s})}moveViews(c,s){for(const l of this.m.keys())if(l!==s){const h=this.s(c,l);h.length&&(this.r(h,s),this.g.fire({views:h,from:l,to:s}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const s of this.j){const l=(this.m.get(s)||[]).filter(h=>h.id===c)[0];if(l)return l}return null}getViewContainer(c){for(const s of this.j)if((this.m.get(s)||[]).filter(h=>h.id===c)[0])return s;return null}registerViewWelcomeContent(c,s){return this.n.add(c,s),this.h.fire(c),(0,A.$Rc)(()=>{this.n.delete(c,s),this.h.fire(c)})}registerViewWelcomeContent2(c,s){const l=new Map;for(const[h,b]of s)this.n.add(c,b),l.set(h,(0,A.$Rc)(()=>{this.n.delete(c,b),this.h.fire(c)}));return this.h.fire(c),l}getViewWelcomeContent(c){const s=[];return this.n.forEach(c,l=>s.push(l)),s.sort(o)}r(c,s){let l=this.m.get(s);l||(l=[],this.m.set(s,l),this.j.push(s));for(const h of c){if(this.getView(h.id)!==null)throw new Error((0,O.localize)(2,null,h.id));l.push(h)}}s(c,s){const l=this.m.get(s);if(!l)return[];const h=[],b=[];for(const D of l)c.includes(D)?h.push(D):b.push(D);return h.length&&(b.length?this.m.set(s,b):(this.m.delete(s),this.j.splice(this.j.indexOf(s),1))),h}}v.$Rn.add(w.ViewsRegistry,new i),e.$jF=(0,$.$ci)("viewDescriptorService");var n;(function(d){d[d.Default=0]="Default",d[d.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(d){d[d.None=0]="None",d[d.Collapsed=1]="Collapsed",d[d.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(c,s){this.c=!1,this.d=!1,(0,S.$In)(this,c),this.d=!!s,this.resolve=async l=>{if(s&&!this.c){const h=await s(l);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$kF=a;class t extends Error{constructor(c){super((0,O.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$lF=t}),define(Ce[281],Ie([1,0,2,29,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$tF=e.$sF=void 0;function A(S){return!!S&&typeof S=="object"&&"uri"in S&&S.uri instanceof I.URI&&"version"in S&&typeof S.version=="number"&&"ranges"in S&&Array.isArray(S.ranges)&&S.ranges.every(O.$4s.isIRange)}e.$sF=A;function R(S){return!!S&&typeof S=="object"&&"documents"in S&&Array.isArray(S.documents)&&S.documents.every(A)}e.$tF=R;var v;(function(S){S[S.Down=0]="Down",S[S.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var p;(function(S){S[S.Action=1]="Action",S[S.Toolbar=2]="Toolbar"})(p||(e.ChatAgentCopyKind=p={})),e.$uF=(0,$.$ci)("IChatService"),e.$vF="accessibility.voice.keywordActivation"}),define(Ce[140],Ie([1,0,4,8,228]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new I.$3d,this.o=new I.$3d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(v){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=v}onEvent(v){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=v}onRequest(v){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=v}sendResponse(v){v.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.u("response",v)}sendRequest(v,p,S,L){const C={command:v};if(p&&Object.keys(p).length>0&&(C.arguments=p),this.u("request",C),typeof L=="number"){const w=setTimeout(()=>{clearTimeout(w);const E=this.f.get(C.seq);if(E){this.f.delete(C.seq);const k={type:"response",seq:0,request_seq:C.seq,success:!1,command:v,message:(0,$.localize)(0,null,L,v)};E(k)}},L)}return S&&this.f.set(C.seq,S),C.seq}acceptMessage(v){this.k?this.k(v):(this.m.push(v),this.m.length===1&&this.s())}q(v,p){return v.type!=="event"||p.type!=="event"}async s(){let v;for(;this.m.length;){if((!v||this.q(this.m[0],v))&&await(0,O.$dh)(0),v=this.m.shift(),!v)return;switch(v.type){case"event":this.j?.(v);break;case"request":this.g?.(v);break;case"response":{const p=v,S=this.f.get(p.request_seq);S&&(this.f.delete(p.request_seq),S(p));break}}}}u(v,p){p.type=v,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const v=new Map;this.f.forEach((p,S)=>v.set(S,p)),await(0,O.$dh)(500),v.forEach((p,S)=>{p({type:"response",seq:0,request_seq:S,success:!1,command:"canceled",message:"canceled"}),this.f.delete(S)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$enb=A}),define(Ce[282],Ie([1,0,2,229,45,5]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$tI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$sI=e.MemoryRangeType=e.$rI=e.State=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=void 0,e.$iH="workbench.view.debug",e.$jH="workbench.debug.variablesView",e.$kH="workbench.debug.watchExpressionsView",e.$lH="workbench.debug.callStackView",e.$mH="workbench.debug.loadedScriptsView",e.$nH="workbench.debug.breakPointsView",e.$oH="workbench.debug.disassemblyView",e.$pH="workbench.panel.repl",e.$qH="workbench.panel.repl.view",e.$rH=new $.$tj("debugType",void 0,{type:"string",description:O.localize(0,null)}),e.$sH=new $.$tj("debugConfigurationType",void 0,{type:"string",description:O.localize(1,null)}),e.$tH=new $.$tj("debugState","inactive",{type:"string",description:O.localize(2,null)}),e.$uH="debugUx",e.$vH=new $.$tj(e.$uH,"default",{type:"string",description:O.localize(3,null)}),e.$wH=new $.$tj("hasDebugged",!1,{type:"boolean",description:O.localize(4,null)}),e.$xH=new $.$tj("inDebugMode",!1,{type:"boolean",description:O.localize(5,null)}),e.$yH=new $.$tj("inDebugRepl",!1,{type:"boolean",description:O.localize(6,null)}),e.$zH=new $.$tj("breakpointWidgetVisible",!1,{type:"boolean",description:O.localize(7,null)}),e.$AH=new $.$tj("inBreakpointWidget",!1,{type:"boolean",description:O.localize(8,null)}),e.$BH=new $.$tj("breakpointsFocused",!0,{type:"boolean",description:O.localize(9,null)}),e.$CH=new $.$tj("watchExpressionsFocused",!0,{type:"boolean",description:O.localize(10,null)}),e.$DH=new $.$tj("watchExpressionsExist",!1,{type:"boolean",description:O.localize(11,null)}),e.$EH=new $.$tj("variablesFocused",!0,{type:"boolean",description:O.localize(12,null)}),e.$FH=new $.$tj("expressionSelected",!1,{type:"boolean",description:O.localize(13,null)}),e.$GH=new $.$tj("breakpointInputFocused",!1,{type:"boolean",description:O.localize(14,null)}),e.$HH=new $.$tj("callStackItemType",void 0,{type:"string",description:O.localize(15,null)}),e.$IH=new $.$tj("callStackSessionIsAttach",!1,{type:"boolean",description:O.localize(16,null)}),e.$JH=new $.$tj("callStackItemStopped",!1,{type:"boolean",description:O.localize(17,null)}),e.$KH=new $.$tj("callStackSessionHasOneThread",!1,{type:"boolean",description:O.localize(18,null)}),e.$LH=new $.$tj("watchItemType",void 0,{type:"string",description:O.localize(19,null)}),e.$MH=new $.$tj("canViewMemory",void 0,{type:"boolean",description:O.localize(20,null)}),e.$NH=new $.$tj("breakpointItemType",void 0,{type:"string",description:O.localize(21,null)}),e.$OH=new $.$tj("breakpointHasModes",!1,{type:"boolean",description:O.localize(22,null)}),e.$PH=new $.$tj("breakpointSupportsCondition",!1,{type:"boolean",description:O.localize(23,null)}),e.$QH=new $.$tj("loadedScriptsSupported",!1,{type:"boolean",description:O.localize(24,null)}),e.$RH=new $.$tj("loadedScriptsItemType",void 0,{type:"string",description:O.localize(25,null)}),e.$SH=new $.$tj("focusedSessionIsAttach",!1,{type:"boolean",description:O.localize(26,null)}),e.$TH=new $.$tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:O.localize(27,null)}),e.$UH=new $.$tj("stepBackSupported",!1,{type:"boolean",description:O.localize(28,null)}),e.$VH=new $.$tj("restartFrameSupported",!1,{type:"boolean",description:O.localize(29,null)}),e.$WH=new $.$tj("stackFrameSupportsRestart",!1,{type:"boolean",description:O.localize(30,null)}),e.$XH=new $.$tj("jumpToCursorSupported",!1,{type:"boolean",description:O.localize(31,null)}),e.$YH=new $.$tj("stepIntoTargetsSupported",!1,{type:"boolean",description:O.localize(32,null)}),e.$ZH=new $.$tj("breakpointsExist",!1,{type:"boolean",description:O.localize(33,null)}),e.$1H=new $.$tj("debuggersAvailable",!1,{type:"boolean",description:O.localize(34,null)}),e.$2H=new $.$tj("debugExtensionAvailable",!0,{type:"boolean",description:O.localize(35,null)}),e.$3H=new $.$tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:O.localize(36,null)}),e.$4H=new $.$tj("debugSetVariableSupported",!1,{type:"boolean",description:O.localize(37,null)}),e.$5H=new $.$tj("debugSetExpressionSupported",!1,{type:"boolean",description:O.localize(38,null)}),e.$6H=new $.$tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:O.localize(39,null)}),e.$7H=new $.$tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:O.localize(40,null)}),e.$8H=new $.$tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:O.localize(41,null)}),e.$9H=new $.$tj("terminateDebuggeeSupported",!1,{type:"boolean",description:O.localize(42,null)}),e.$0H=new $.$tj("suspendDebuggeeSupported",!1,{type:"boolean",description:O.localize(43,null)}),e.$$H=new $.$tj("variableEvaluateNamePresent",!1,{type:"boolean",description:O.localize(44,null)}),e.$_H=new $.$tj("variableIsReadonly",!1,{type:"boolean",description:O.localize(45,null)}),e.$aI=new $.$tj("variableValue",!1,{type:"string",description:O.localize(46,null)}),e.$bI=new $.$tj("variableType",!1,{type:"string",description:O.localize(47,null)}),e.$cI=new $.$tj("variableName",!1,{type:"string",description:O.localize(48,null)}),e.$dI=new $.$tj("variableLanguage",!1,{type:"string",description:O.localize(49,null)}),e.$eI=new $.$tj("variableExtensionId",!1,{type:"string",description:O.localize(50,null)}),e.$fI=new $.$tj("exceptionWidgetVisible",!1,{type:"boolean",description:O.localize(51,null)}),e.$gI=new $.$tj("multiSessionRepl",!1,{type:"boolean",description:O.localize(52,null)}),e.$hI=new $.$tj("multiSessionDebug",!1,{type:"boolean",description:O.localize(53,null)}),e.$iI=new $.$tj("disassembleRequestSupported",!1,{type:"boolean",description:O.localize(54,null)}),e.$jI=new $.$tj("disassemblyViewFocus",!1,{type:"boolean",description:O.localize(55,null)}),e.$kI=new $.$tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:O.localize(56,null)}),e.$lI=new $.$tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:O.localize(57,null)});const R=o=>O.localize(58,null,o);e.$mI=R,e.$nI="editor.contrib.debug",e.$oI="editor.contrib.breakpoint",e.$pI="debug",e.$qI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:O.localize(59,null)};var v;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(v||(e.State=v={}));function p(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$rI=p;var S;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$sI="vscode-debug-memory";var L;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(L||(e.DebugConfigurationProviderTriggerKind=L={}));var C;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$tI=(0,A.$ci)("debugService");var w;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE",o[o.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var E;(function(o){o[o.Command=0]="Command",o[o.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var k;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(k||(e.DebugTreeItemCollapsibleState=k={}));var u;(function(o){o.deserialize=i=>i,o.serialize=i=>i})(u||(e.IDebugVisualizationTreeItem=u={}));var m;(function(o){o.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:I.URI.revive(i.iconPath.light),dark:I.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),o.serialize=i=>i})(m||(e.IDebugVisualization=m={}))}),define(Ce[283],Ie([1,0,12,2,17,24,16,29,22,19]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0;const L=/{([^}]+)}/g;function C(D,g,f){return D.replace(L,function(y,P){return g&&P.length>0&&P[0]!=="_"?y:f&&f.hasOwnProperty(P)?f[P]:y})}e.$kG=C;function w(D){const g={};for(const f of Object.keys(D))f.startsWith("!")||(g[f]=D[f]);return g}e.$lG=w;function E(D){return D.configuration.request==="attach"&&!k(D)&&(!D.parentSession||E(D.parentSession))}e.$mG=E;function k(D){let g=D.configuration.type;if(g)return g==="vslsShare"&&(g=D.configuration.adapterProxy.configuration.type),(0,I.$hf)(g,"extensionhost")||(0,I.$hf)(g,"pwa-extensionhost")?D:D.parentSession?k(D.parentSession):void 0}e.$nG=k;function u(D){return D.type&&(D.label||D.program||D.runtime)}e.$oG=u;function m(D,g,f){let y,P=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=N.exec(D);){const z=U.index+1,F=z+U[0].length;if(z<=g&&F>=f){y=U[0],P=z;break}}if(y){const z=/\w+/g;let F=null;for(;(F=z.exec(y))&&!(F.index+1+P+F[0].length>=f););F&&(y=y.substring(0,z.lastIndex))}return y?{start:P,end:P+y.length-1}:{start:0,end:0}}e.$pG=m;async function o(D,g,f,y){if(D.evaluatableExpressionProvider.has(g)){const P=D.evaluatableExpressionProvider.ordered(g),N=(0,S.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(g,f,y??p.CancellationToken.None)}catch{return}})));if(N.length>0){let U=N[0].expression;const z=N[0].range;return U||(U=g.getLineContent(f.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const P=g.getLineContent(f.lineNumber),{start:N,end:U}=m(P,f.column,f.column),z=P.substring(N-1,U);return{matchingExpression:z,range:new v.$4s(f.lineNumber,N,f.lineNumber,N+z.length)}}return null}e.$qG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$rG=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return O.URI.parse(D.path);if((0,$.$ic)(D.path))return O.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const g=O.URI.revive(D.path);if(g)return g.scheme===R.Schemas.file?g.fsPath:g.toString()}return D.path}function t(D,g){const f=g?r:a,y=(0,A.$Fn)(D);return c(y,(P,N)=>{P&&N&&(N.path=f(N))}),y}e.$sG=t;function d(D,g){const f=g?r:a,y=(0,A.$Fn)(D);return c(y,(P,N)=>{!P&&N&&(N.path=f(N))}),y}e.$tG=d;function c(D,g){switch(D.type){case"event":{const f=D;switch(f.event){case"output":g(!1,f.body.source);break;case"loadedSource":g(!1,f.body.source);break;case"breakpoint":g(!1,f.body.breakpoint.source);break;default:break}break}case"request":{const f=D;switch(f.command){case"setBreakpoints":g(!0,f.arguments.source);break;case"breakpointLocations":g(!0,f.arguments.source);break;case"source":g(!0,f.arguments.source);break;case"gotoTargets":g(!0,f.arguments.source);break;case"launchVSCode":f.arguments.args.forEach(y=>g(!1,y));break;default:break}break}case"response":{const f=D;if(f.success&&f.body)switch(f.command){case"stackTrace":f.body.stackFrames.forEach(y=>g(!1,y.source));break;case"loadedSources":f.body.sources.forEach(y=>g(!1,y));break;case"scopes":f.body.scopes.forEach(y=>g(!1,y.source));break;case"setFunctionBreakpoints":f.body.breakpoints.forEach(y=>g(!1,y.source));break;case"setBreakpoints":f.body.breakpoints.forEach(y=>g(!1,y.source));break;case"disassemble":f.body?.instructions.forEach(P=>g(!1,P.location));break;default:break}break}}}function s(D){return D.filter(g=>!g.presentation?.hidden).sort((g,f)=>g.presentation?f.presentation?g.presentation.group?f.presentation.group?g.presentation.group!==f.presentation.group?g.presentation.group.localeCompare(f.presentation.group):l(g.presentation.order,f.presentation.order):-1:f.presentation.group?1:l(g.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.$uG=s;function l(D,g){return typeof D!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:D-g}async function h(D,g){const f=D.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(f!=="none"&&(await g.saveAll(),f==="allEditorsInActiveGroup")){const y=g.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await g.save({editor:y.input,groupId:y.group.id})}await D.reloadConfiguration()}e.$vG=h;const b=(D,g)=>!D||!g?D===g:D.name===g.name&&D.path===g.path&&D.sourceReference===g.sourceReference;e.$wG=b}),define(Ce[284],Ie([1,0,50,62,24,17,11,12,31,230,140]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=e.$jjc=e.$ijc=e.$hjc=void 0;class C extends L.$enb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",n=>this.v(n))}sendMessage(o){if(this.l){const i=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(C.a);if(i!==-1){const r=this.p.toString("utf8",0,i).split(C.b);for(const a of r){const t=a.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+C.a.length);continue}}break}}}e.$hjc=C;class w extends C{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.n.fire(r):i(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$ijc=w;class E extends w{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$jjc=E;class k extends w{constructor(o){super(),this.z=o}y(o){return O.createConnection(this.z.path,o)}}e.$kjc=k;class u extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(A.$ic(o)){if(!await p.Promises.exists(o))throw new Error(S.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(S.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=$.$In($.$Fn(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const d=I.fork(i[0],i.slice(1),t);if(!d.pid)throw new Error(S.localize(2,null,i[0]));this.x=d}else throw new Error(S.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=I.spawn(o,i,a)}this.x.on("error",a=>{this.n.fire(a)}),this.x.on("exit",(a,t)=>{this.o.fire(a)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.n.fire(a)}),this.x.stdin.on("error",a=>{this.n.fire(a)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((o,i)=>{const n=I.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=A.$jc(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(A.$ic(o.program)?n.program=o.program:n.program=A.$jc(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=u.A(r.win,i)),r.winx86&&(n.winx86=u.A(r.winx86,i)),r.windows&&(n.windows=u.A(r.windows,i)),r.osx&&(n.osx=u.A(r.osx,i)),r.linux&&(n.linux=u.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const s of o)if(s.contributes){const l=s.contributes.debuggers;l&&l.length>0&&l.filter(h=>typeof h.type=="string"&&v.$hf(h.type,i)).forEach(h=>{const b=u.A(h,s.extensionLocation.fsPath);n=$.$In(n,b,s.isBuiltin)})}let r;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:R.$i?r=n.win||n.windows:R.$j?r=n.osx:R.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,d=r.runtime||n.runtime,c=r.runtimeArgs||n.runtimeArgs;if(d)return{type:"executable",command:d,args:(c||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$ljc=u}),define(Ce[285],Ie([1,0,50,34,11]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=e.$mjc=void 0;function A(S,L){return new Promise((C,w)=>{let E="";const k=I.spawn(S,L);k.pid&&k.stdout.on("data",u=>{E+=u.toString()}),k.on("error",u=>{w(u)}),k.on("close",u=>{C(E)})})}async function R(S){if(S)if($.$i){const L=await new Promise((C,w)=>{me(["@vscode/windows-process-tree"],C,w)});return new Promise(C=>{L.getProcessTree(S,w=>{C(!!w&&w.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(S)]).then(L=>{const C=L.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},L=>!0);return Promise.resolve(!0)}e.$mjc=R;var v;(function(S){S[S.cmd=0]="cmd",S[S.powershell=1]="powershell",S[S.bash=2]="bash"})(v||(v={}));function p(S,L,C,w,E){S=S.trim().toLowerCase();let k;S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0?k=1:S.indexOf("cmd.exe")>=0?k=0:S.indexOf("bash")>=0?k=2:$.$i?k=0:k=2;let u,m=" ";switch(k){case 1:if(u=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),w){const o=(0,O.$ig)(w);o&&(m+=`${o}:; `),m+=`cd ${u(w)}; `}if(E)for(const o in E){const i=E[o];i===null?m+=`Remove-Item env:${o}; `:m+=`\${env:${o}}='${i}'; `}if(L.length>0){const o=L.shift(),i=C?o:u(o);m+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of L)m+=n==="<"||n===">"||C?n:u(n),m+=" "}break;case 0:if(u=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),w){const o=(0,O.$ig)(w);o&&(m+=`${o}: && `),m+=`cd ${u(w)} && `}if(E){m+='cmd /C "';for(const o in E){let i=E[o];i===null?m+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),m+=`set "${o}=${i}" && `)}}for(const o of L)m+=o==="<"||o===">"||C?o:u(o),m+=" ";E&&(m+='"');break;case 2:{u=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(w&&(m+=`cd ${u(w)} ; `),E){m+="/usr/bin/env";for(const i in E){const n=E[i];n===null?m+=` -u ${o(i)}`:m+=` ${o(`${i}=${n}`)}`}m+=" "}for(const i of L)m+=i==="<"||i===">"||C?i:u(i),m+=" ";break}}return m}e.$njc=p}),define(Ce[286],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.CellExecutionUpdateType=void 0;var O;(function($){$[$.Output=1]="Output",$[$.OutputItems=2]="OutputItems",$[$.ExecutionState=3]="ExecutionState"})(O||(e.CellExecutionUpdateType=O={})),e.$2J=(0,I.$ci)("INotebookExecutionService")}),define(Ce[287],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agb=e.$zgb=e.ProxyKernelState=e.$ygb=void 0,e.$ygb=100;var O;(function($){$[$.Disconnected=1]="Disconnected",$[$.Connected=2]="Connected",$[$.Initializing=3]="Initializing"})(O||(e.ProxyKernelState=O={})),e.$zgb=(0,I.$ci)("INotebookKernelService"),e.$Agb=(0,I.$ci)("INotebookKernelHistoryService")}),define(Ce[288],Ie([1,0,3,29,194,99]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ASb=void 0;class R extends I.$Tc{constructor(p,S,L){super(),this._source=p,this.b=S,this.c=L,this.a=void 0}f(p){const S=p.getLineCount();return new O.$4s(1,1,S,this.g(p,S))}g(p,S){if(S<1||S>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(S)+1}get inputTextBuffer(){if(!this.b){const p=new $.$lC;p.acceptChunk(this._source);const S=p.finish(!0),{textBuffer:L,disposable:C}=S.create(1);this.b=L,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const S=new $.$lC;S.acceptChunk(p);const L=S.finish(!0),{textBuffer:C,disposable:w}=L.create(1);return this.B(w),C})),this.a}findInInputs(p){const L=new A.$_B(p,!1,!1,null).parseSearchRequest();if(!L)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,L,!0,5e3)}findInOutputs(p){const L=new A.$_B(p,!1,!1,null).parseSearchRequest();return L?this.outputTextBuffers.map(C=>{const w=C.findMatchesLineByLine(this.f(C),L,!0,5e3);if(w.length!==0)return{textBuffer:C,matches:w}}).filter(C=>!!C):[]}}e.$ASb=R}),define(Ce[68],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.TestPosition=e.TestIdPathParts=void 0;var I;(function(A){A.Delimiter="\0"})(I||(e.TestIdPathParts=I={}));var O;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class ${static fromExtHostTestItem(R,v,p=R.parent){if(R._isRoot)return new $([v]);const S=[R.id];for(let L=p;L&&L.id!==v;L=L.parent)S.push(L.id);return S.push(v),new $(S.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const v=R.indexOf("\0");return v===-1?R:R.slice(0,v)}static fromString(R){return new $(R.split("\0"))}static join(R,v){return new $([...R.path,v])}static joinToString(R,v){return R.toString()+"\0"+v}static parentId(R){const v=R.lastIndexOf("\0");return v===-1?void 0:R.slice(0,v)}static localId(R){const v=R.lastIndexOf("\0");return v===-1?R:R.slice(v+1)}static isChild(R,v){return v.startsWith(R)&&v[R.length]==="\0"}static compare(R,v){return R===v?0:$.isChild(R,v)?2:$.isChild(v,R)?3:1}constructor(R,v=R.length){if(this.path=R,this.d=v,R.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new $(this.path,1)}get parentId(){return this.d>1?new $(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new $(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new $(this.path,R)}compare(R){if(typeof R=="string")return $.compare(this.toString(),R);for(let v=0;v<R.d&&v<this.d;v++)if(R.path[v]!==this.path[v])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$MK=$}),define(Ce[89],Ie([1,0,2,48,29,68]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$TK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$SK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$RK=e.$QK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$PK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$OK=e.$NK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var v;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var p;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$NK=[2,4,8,16,32,64];const S=M=>"runId"in M;e.$OK=S;var L;(function(M){M.serialize=T=>({range:T.range.toJSON(),uri:T.uri.toJSON()}),M.deserialize=(T,j)=>({range:$.$4s.lift(j.range),uri:T.asCanonicalUri(I.URI.revive(j.uri))})})(L||(e.IRichLocation=L={}));var C;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(C||(e.TestMessageType=C={}));var w;(function(M){M.serialize=T=>({message:T.message,type:0,expected:T.expected,actual:T.actual,contextValue:T.contextValue,location:T.location&&L.serialize(T.location)}),M.deserialize=(T,j)=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&L.deserialize(T,j.location)})})(w||(e.ITestErrorMessage=w={}));const E=(M,T)=>`${T?"s":"e"}${M}`;e.$PK=E;var k;(function(M){M.serialize=T=>({message:T.message,type:1,offset:T.offset,length:T.length,location:T.location&&L.serialize(T.location)}),M.deserialize=(T,j)=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&L.deserialize(T,j.location)})})(k||(e.ITestOutputMessage=k={}));var u;(function(M){M.serialize=T=>T.type===0?w.serialize(T):k.serialize(T),M.deserialize=(T,j)=>j.type===0?w.deserialize(T,j):k.deserialize(T,j)})(u||(e.ITestMessage=u={}));var m;(function(M){M.serializeWithoutMessages=T=>({state:T.state,duration:T.duration,messages:[]}),M.serialize=T=>({state:T.state,duration:T.duration,messages:T.messages.map(u.serialize)}),M.deserialize=(T,j)=>({state:j.state,duration:j.duration,messages:j.messages.map(J=>u.deserialize(T,J))})})(m||(e.ITestTaskState=m={}));const o="\0",i=(M,T)=>M+o+T;e.$QK=i;const n=M=>{const T=M.indexOf(o);return{ctrlId:M.slice(0,T),tagId:M.slice(T+1)}};e.$RK=n;var r;(function(M){M.serialize=T=>({extId:T.extId,label:T.label,tags:T.tags,busy:T.busy,children:void 0,uri:T.uri?.toJSON(),range:T.range?.toJSON()||null,description:T.description,error:T.error,sortText:T.sortText}),M.deserialize=(T,j)=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?T.asCanonicalUri(I.URI.revive(j.uri)):void 0,range:j.range?$.$4s.lift(j.range):null,description:j.description,error:j.error,sortText:j.sortText})})(r||(e.ITestItem=r={}));var a;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(M){M.serialize=T=>({expand:T.expand,item:r.serialize(T.item)}),M.deserialize=(T,j)=>({controllerId:A.$MK.root(j.item.extId),expand:j.expand,item:r.deserialize(T,j.item)})})(t||(e.InternalTestItem=t={}));var d;(function(M){M.serialize=T=>{let j;return T.item&&(j={},T.item.label!==void 0&&(j.label=T.item.label),T.item.tags!==void 0&&(j.tags=T.item.tags),T.item.busy!==void 0&&(j.busy=T.item.busy),T.item.uri!==void 0&&(j.uri=T.item.uri?.toJSON()),T.item.range!==void 0&&(j.range=T.item.range?.toJSON()),T.item.description!==void 0&&(j.description=T.item.description),T.item.error!==void 0&&(j.error=T.item.error),T.item.sortText!==void 0&&(j.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:j}},M.deserialize=T=>{let j;return T.item&&(j={},T.item.label!==void 0&&(j.label=T.item.label),T.item.tags!==void 0&&(j.tags=T.item.tags),T.item.busy!==void 0&&(j.busy=T.item.busy),T.item.range!==void 0&&(j.range=T.item.range?$.$4s.lift(T.item.range):null),T.item.description!==void 0&&(j.description=T.item.description),T.item.error!==void 0&&(j.error=T.item.error),T.item.sortText!==void 0&&(j.sortText=T.item.sortText)),{extId:T.extId,expand:T.expand,item:j}}})(d||(e.ITestItemUpdate=d={}));const c=(M,T)=>{T.expand!==void 0&&(M.expand=T.expand),T.item!==void 0&&(M.item=M.item?Object.assign(M.item,T.item):T.item)};e.$SK=c;var s;(function(M){M.serializeWithoutMessages=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serializeWithoutMessages)}),M.serialize=T=>({...t.serialize(T),ownComputedState:T.ownComputedState,computedState:T.computedState,tasks:T.tasks.map(m.serialize)}),M.deserialize=(T,j)=>({...t.deserialize(T,j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(J=>m.deserialize(T,J)),retired:!0})})(s||(e.TestResultItem=s={}));var l;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(T,j)=>{T.covered+=j.covered,T.total+=j.total}})(l||(e.ICoveredCount=l={}));var h;(function(M){M.serialize=T=>({statement:T.statement,branch:T.branch,declaration:T.declaration,details:T.details?.map(f.serialize),uri:T.uri.toJSON()}),M.deserialize=(T,j)=>({statement:j.statement,branch:j.branch,declaration:j.declaration,details:j.details?.map(f.deserialize),uri:T.asCanonicalUri(I.URI.revive(j.uri))})})(h||(e.IFileCoverage=h={}));function b(M){return{...M,location:M.location?.toJSON()}}function D(M){return M.location=M.location?O.$3s.isIPosition(M.location)?O.$3s.lift(M.location):$.$4s.lift(M.location):void 0,M}e.$TK=3;var g;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(g||(e.DetailType=g={}));var f;(function(M){M.serialize=T=>T.type===0?P.serialize(T):N.serialize(T),M.deserialize=T=>T.type===0?P.deserialize(T):N.deserialize(T)})(f||(e.CoverageDetails=f={}));var y;(function(M){M.serialize=b,M.deserialize=D})(y||(e.IBranchCoverage=y={}));var P;(function(M){M.serialize=b,M.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var N;(function(M){M.serialize=T=>({...b(T),branches:T.branches?.map(y.serialize)}),M.deserialize=T=>({...D(T),branches:T.branches?.map(y.deserialize)})})(N||(e.IStatementCoverage=N={}));var U;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(M){M.deserialize=(T,j)=>j.op===0?{op:j.op,item:t.deserialize(T,j.item)}:j.op===1?{op:j.op,item:d.deserialize(j.item)}:j.op===2?{op:j.op,uri:T.asCanonicalUri(I.URI.revive(j.uri)),docv:j.docv}:j,M.serialize=T=>T.op===0?{op:T.op,item:t.serialize(T.item)}:T.op===1?{op:T.op,item:d.serialize(T.item)}:T})(z||(e.TestsDiffOp=z={}));class F{constructor(T){this.k=T,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(T){const j=this.v();for(const J of T)switch(J.op){case 0:this.l(t.deserialize(this.k,J.item),j);break;case 1:this.o(d.deserialize(J.item),j);break;case 3:this.p(J.itemId,j);break;case 5:this.q(J.itemId);break;case 4:this.updatePendingRoots(J.amount);break;case 6:this.c.set(J.tag.id,J.tag);break;case 7:this.c.delete(J.id);break}j.complete?.()}l(T,j){const J=A.$MK.parentId(T.item.extId)?.toString();let ne;if(!J)ne=this.w(T),this.g.add(ne),this.f.set(T.item.extId,ne);else if(this.f.has(J)){const _=this.f.get(J);_.children.add(T.item.extId),ne=this.w(T,_),this.f.set(T.item.extId,ne)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(T)}`);return}return j.add?.(ne),T.expand===2&&this.h++,ne}o(T,j){const J=this.f.get(T.extId);if(J)return T.expand!==void 0&&(J.expand===2&&this.h--,T.expand===2&&this.h++),(0,e.$SK)(J,T),j.update?.(J),J}p(T,j){const J=this.f.get(T);if(!J)return;const ne=A.$MK.parentId(J.item.extId)?.toString();ne?this.f.get(ne).children.delete(J.item.extId):this.g.delete(J);const _=[[T]];for(;_.length;)for(const Z of _.pop()){const Y=this.f.get(Z);Y&&(_.push(Y.children),this.f.delete(Z),j.remove?.(Y,Y!==J),Y.expand===2&&this.h--)}}q(T){}updatePendingRoots(T){this.j+=T}v(){return{}}}e.$UK=F}),define(Ce[111],Ie([1,0,8,4,3,61,89,68]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const S=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:S,label:S,description:S,error:S,sortText:S,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),w=(i,n)=>{let r;for(const[a,t]of C)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class E extends $.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new I.$oh(()=>this.flushDiff(),200)),this.g=this.B(new O.$3d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,R.$SK)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,R.$SK)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,r-1):t.wait().then(()=>this.L(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,r-1)):this.L(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(v.$MK.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const a of r.ops)this.w(n,a);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,A.$9c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const a=v.$MK.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let d=this.tree.get(a.toString());if(!d){d={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(d.fullId.toString(),d),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:d.expand,item:this.s.toITestItem(n)}}),this.I(n,d,r);return}if(d.actual===n){this.H(n,d,r);return}if(d.actual.uri?.toString()!==n.uri?.toString())return this.O(a.toString()),this.z(n,r);const c=this.s.getChildren(d.actual),s=d.actual,l=w(this.s.toITestItem(s),this.s.toITestItem(n));this.s.getApiFor(s).listener=void 0,d.actual=n,d.expand=0,l&&(l.hasOwnProperty("tags")&&(this.C(n.tags,s.tags,a.toString()),delete l.tags),this.w(d,{op:4,update:l})),this.I(n,d,r);for(const[h,b]of c)this.s.getChildren(n).get(b.id)||this.O(v.$MK.joinToString(a,b.id));this.y(d.actual.uri)}C(n,r,a){const t=new Set(r.map(d=>d.id));for(const d of n)t.delete(d.id)||this.D(d);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(d=>(0,R.$QK)(this.s.controllerId,d.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$QK)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$QK)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,a){this.G(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=d=>this.w(r,d),this.J(r)}I(n,r,a){this.H(n,r,a);for(const[t,d]of this.s.getChildren(n))this.z(d,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const a=[];for(const[t,d]of this.s.getChildren(n.actual)){const c=this.expand(v.$MK.joinToString(n.fullId,d.id),r);(0,I.$1g)(c)&&a.push(c)}if(a.length)return Promise.all(a).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const d=new I.$bh;return d.open(),d}n.expand=2,this.N(n);const r=n.resolveBarrier=new I.$bh,a=d=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,d)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(d){a(d)}return(0,I.$1g)(t)?t.catch(a).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const d of t.actual.tags)this.F(d.id);this.tree.delete(t.fullId.toString());for(const[d,c]of this.s.getChildren(t.actual))a.push(this.tree.get(v.$MK.joinToString(t.fullId,c.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$3N=E;class k extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$4N=k;class u extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5N=u;class m extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$6N=m;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,d){for(const c of a.values())t.call(d,c,this)},[Symbol.iterator](){return a.entries()},replace(t){const d=new Map,c=new Set(a.keys()),s={op:5,ops:[]};for(const l of t){if(!(l instanceof r))throw new u(l.id);const h=n(l).controllerId;if(h!==i.controllerId)throw new m(l.id,h,i.controllerId);if(d.has(l.id))throw new k(l.id);d.set(l.id,l),c.delete(l.id),s.ops.push({op:0,item:l})}for(const l of c.keys())s.ops.push({op:3,id:l});i.listener?.(s),a=d},add(t){if(!(t instanceof r))throw new u(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$7N=o}),define(Ce[141],Ie([1,0,111]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=e.$8N=void 0;const O=new WeakMap,$=(R,v)=>{const p={controllerId:v};return O.set(R,p),p};e.$8N=$;const A=R=>{const v=O.get(R);if(!v)throw new I.$5N(R?.id||"<unknown>");return v};e.$9N=A}),define(Ce[112],Ie([1,0,16,2]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9wb=e.$8wb=e.$7wb=e.$6wb=e.$5wb=void 0,e.$5wb="vscode-cdn.net",e.$6wb=`vscode-resource.${e.$5wb}`,e.$7wb=`'self' https://*.${e.$5wb}`;function $(v,p){return v.scheme===I.Schemas.http||v.scheme===I.Schemas.https?v:(p&&p.authority&&p.isRemote&&v.scheme===I.Schemas.file&&(v=O.URI.from({scheme:I.Schemas.vscodeRemote,authority:p.authority,path:v.path})),O.URI.from({scheme:I.Schemas.https,authority:`${v.scheme}+${A(v.authority)}.${e.$6wb}`,path:v.path,fragment:v.fragment,query:v.query}))}e.$8wb=$;function A(v){return v.replace(/./g,p=>{const S=p.charCodeAt(0);return S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57?p:"-"+S.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,(p,S)=>String.fromCharCode(parseInt(S,16)))}e.$9wb=R}),define(Ce[289],Ie([1,0,4,3,112]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class A{constructor(v,p,S){this.d=v,this.e=p,this.f=S,this.a=0,this.b=new O.$Sc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const L=p.getVisibleTextEditors();for(const C of this.c.values())L.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(v=>v.inset.dispose()),this.b.dispose()}createWebviewEditorInset(v,p,S,L,C){let w;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===v){w=n;break}if(!w)throw new Error("not a visible editor");const E=this,k=this.a++,u=new I.$3d,m=new I.$3d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,$.$8wb)(n,E.f)}get cspSource(){return $.$7wb}set options(n){this.b=n,E.d.$setOptions(k,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(k,n)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(n){return E.d.$postMessage(k,n)}},i=new class{constructor(){this.editor=v,this.line=p,this.height=S,this.webview=o,this.onDidDispose=m.event}dispose(){E.c.has(k)&&(E.c.delete(k),E.d.$disposeEditorInset(k),m.fire(),m.dispose(),u.dispose())}};return this.d.$createEditorInset(k,w.id,w.value.document.uri,p+1,S,L||{},C.identifier,C.extensionLocation),this.c.set(k,{editor:v,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(v){const p=this.c.get(v);p&&p.inset.dispose()}$onDidReceiveMessage(v,p){this.c.get(v)?.onDidReceiveMessage.fire(p)}}e.$lhc=A}),define(Ce[142],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.$2K=void 0,e.$2K="__",e.$3K=(0,I.$ci)("IAuthenticationService")}),define(Ce[290],Ie([1,0,5]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.VariableKind=e.$YO=void 0,e.$YO=(0,I.$ci)("configurationResolverService");var O;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(O||(e.VariableKind=O={}));class $ extends Error{constructor(R,v){super(v),this.variable=R}}e.$ZO=$}),define(Ce[291],Ie([1,0,17,49,18,24,11,102,233,290,12]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,k,u,m){this.h=new Map,this.a=E,this.b=k,this.g=u,m&&(this.c=m.then(o=>this.i(o)))}i(E){if(R.$i){const k=Object.create(null);return Object.keys(E).forEach(u=>{k[u.toLowerCase()]=E[u]}),k}return E}resolveWithEnvironment(E,k,u){return this.l({env:this.i(E),userHome:void 0},k?k.uri:void 0,u)}async resolveAsync(E,k){const u={env:await this.c,userHome:await this.g};return this.l(u,E?E.uri:void 0,k)}async j(E,k,u,m){const o=A.$Fn(k);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,o,u,m)}async resolveAnyAsync(E,k,u){return this.j(E,k,u)}async resolveAnyMap(E,k,u){const m=new Map;return{newConfig:await this.j(E,k,u,m),resolvedVariables:m}}resolveWithInteractionReplace(E,k,u,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,k,u,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,k){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,k)}async l(E,k,u,m,o){if($.$Qf(u))return this.m(E,k,u,m,o);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(E,k,i,m,o)));if($.$Sf(u)){const i=Object.create(null),n=await Promise.all(Object.keys(u).map(async r=>[await this.m(E,k,r,m,o),await this.l(E,k,u[r],m,o)]));for(const[r,a]of n)i[r]=a;return i}return u}m(E,k,u,m,o){return(0,L.$_e)(u,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let r=await this.o(E,i,n,k,m);return o?.set(n,r),r!==i&&$.$Qf(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(E,k,r,m,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,k,u,m,o){let i;const n=u.split(":");n.length>1&&(u=n[0],i=n[1]);const r=d=>{const c=this.a.getFilePath();if(c)return(0,v.$6v)(c);throw new S.$ZO(d,(0,p.localize)(0,null,k))},a=d=>{const c=r(d);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,v.$6v)(s)}throw new S.$ZO(d,(0,p.localize)(1,null,k,I.$nc(c)))},t=d=>{if(i){const c=this.a.getFolderUri(i);if(c)return c;throw new S.$ZO(d,(0,p.localize)(2,null,k,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new S.$ZO(d,(0,p.localize)(3,null,k)):new S.$ZO(d,(0,p.localize)(4,null,k))};switch(u){case"env":if(i){if(E.env){const d=E.env[R.$i?i.toLowerCase():i];if($.$Qf(d))return d}return""}throw new S.$ZO(S.VariableKind.Env,(0,p.localize)(5,null,k));case"config":if(i){const d=this.a.getConfigurationValue(m,i);if($.$Zf(d))throw new S.$ZO(S.VariableKind.Config,(0,p.localize)(6,null,k,i));if($.$Sf(d))throw new S.$ZO(S.VariableKind.Config,(0,p.localize)(7,null,k,i));return d}throw new S.$ZO(S.VariableKind.Config,(0,p.localize)(8,null,k));case"command":return this.p(S.VariableKind.Command,k,i,o,"command");case"input":return this.p(S.VariableKind.Input,k,i,o,"input");case"extensionInstallFolder":if(i){const d=await this.a.getExtension(i);if(!d)throw new S.$ZO(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,k,i));return this.n(d.extensionLocation)}throw new S.$ZO(S.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,k));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,v.$6v)(this.n(t(S.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,v.$6v)(this.n(t(S.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.$6v)(I.$nc(this.n(t(S.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new S.$ZO(S.VariableKind.UserHome,(0,p.localize)(11,null,k))}case"lineNumber":{const d=this.a.getLineNumber();if(d)return d;throw new S.$ZO(S.VariableKind.LineNumber,(0,p.localize)(12,null,k))}case"selectedText":{const d=this.a.getSelectedText();if(d)return d;throw new S.$ZO(S.VariableKind.SelectedText,(0,p.localize)(13,null,k))}case"file":return r(S.VariableKind.File);case"fileWorkspaceFolder":return a(S.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return I.$nc(a(S.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?I.$lc(this.n(t(S.VariableKind.RelativeFile)),r(S.VariableKind.RelativeFile)):r(S.VariableKind.RelativeFile);case"relativeFileDirname":{const d=I.$mc(r(S.VariableKind.RelativeFileDirname));if(m||i){const c=I.$lc(this.n(t(S.VariableKind.RelativeFileDirname)),d);return c.length===0?".":c}return d}case"fileDirname":return I.$mc(r(S.VariableKind.FileDirname));case"fileExtname":return I.$oc(r(S.VariableKind.FileExtname));case"fileBasename":return I.$nc(r(S.VariableKind.FileBasename));case"fileBasenameNoExtension":{const d=I.$nc(r(S.VariableKind.FileBasenameNoExtension));return d.slice(0,d.length-I.$oc(d).length)}case"fileDirnameBasename":return I.$nc(I.$mc(r(S.VariableKind.FileDirnameBasename)));case"execPath":{const d=this.a.getExecPath();return d||k}case"execInstallFolder":{const d=this.a.getAppRoot();return d||k}case"pathSeparator":case"/":return I.sep;default:try{const d=i?`${u}:${i}`:u;return this.p(S.VariableKind.Unknown,k,d,o,void 0)}catch{return k}}}}p(E,k,u,m,o){if(u&&m){const i=o===void 0?m[u]:m[o+":"+u];if(typeof i=="string")return i;throw new S.$ZO(E,(0,p.localize)(14,null,k))}return k}}e.$bP=C}),define(Ce[143],Ie([1,0,5,139]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.OpenEditorContext=e.GroupsOrder=e.$iD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$hD=void 0,e.$hD=(0,I.$ci)("editorGroupsService");var $;(function(k){k[k.UP=0]="UP",k[k.DOWN=1]="DOWN",k[k.LEFT=2]="LEFT",k[k.RIGHT=3]="RIGHT"})($||(e.GroupDirection=$={}));var A;(function(k){k[k.HORIZONTAL=0]="HORIZONTAL",k[k.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(k){k[k.FIRST=0]="FIRST",k[k.LAST=1]="LAST",k[k.NEXT=2]="NEXT",k[k.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var v;(function(k){k[k.MAXIMIZE=0]="MAXIMIZE",k[k.EXPAND=1]="EXPAND",k[k.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var p;(function(k){k[k.COPY_EDITORS=0]="COPY_EDITORS",k[k.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function S(k){const u=k;return(0,O.$4E)(u?.editor)&&(0,O.$4E)(u?.replacement)}e.$iD=S;var L;(function(k){k[k.CREATION_TIME=0]="CREATION_TIME",k[k.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",k[k.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(L||(e.GroupsOrder=L={}));var C;(function(k){k[k.NEW_EDITOR=1]="NEW_EDITOR",k[k.MOVE_EDITOR=2]="MOVE_EDITOR",k[k.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function w(k){const u=k;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$jD=w;function E(k){return k.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$kD=E}),define(Ce[292],Ie([1,0,5,143]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=void 0,e.$lD=(0,I.$ci)("editorService"),e.$mD=-1,e.$nD=-2,e.$oD=-3;function $(A){const R=A;return typeof A=="number"||(0,O.$jD)(R)}e.$pD=$}),define(Ce[144],Ie([1,0,5,133]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=void 0,e.$gL=(0,I.$di)(O.$ji)}),define(Ce[145],Ie([1,0,26,4,17,3,8]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=e.$88b=e.$78b=e.$68b=e.$58b=void 0;class v{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$58b=v;class p{static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const a=r.getExtensionDescription(i);return a?!!((a.main||a.browser)&&a.api==="none"):!1}constructor(i,n){this.j=i,this.c=new O.$3d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(u),this.f=new I.$wm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const r=p.l(this.e);return this.e=m(this.e,r.map(a=>a.identifier)),this.k(),this.d++,this.c.fire(void 0),new v(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(c){this.d.has(c)||(this.d.add(c),this.e.push(c))}addArc(c,s){this.addNode(c),this.addNode(s),this.c.has(c)?this.c.get(c).push(s):this.c.set(c,[s])}getArcs(c){return this.c.has(c)?this.c.get(c):[]}hasOnlyGoodArcs(c,s){const l=n.getArcs(c);for(let h=0;h<l.length;h++)if(!s.has(l[h]))return!1;return!0}getNodes(){return this.e}},r=new I.$wm;for(const c of i)if(r.set(c.identifier,c),c.extensionDependencies)for(const s of c.extensionDependencies)n.addArc(I.$um.toKey(c.identifier),I.$um.toKey(s));const a=new Set;n.getNodes().filter(c=>n.getArcs(c).length===0).forEach(c=>a.add(c));const t=n.getNodes().filter(c=>!a.has(c));let d;do{d=!1;for(let c=0;c<t.length;c++){const s=t[c];n.hasOnlyGoodArcs(s,a)&&(t.splice(c,1),c--,a.add(s),d=!0)}}while(d);return t.map(c=>r.get(c))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$68b=p;class S{constructor(i,n){this.versionId=i,this.extensions=n}}e.$78b=S;class L{constructor(i){this.d=new E,this.c=new p(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$88b=L;class C extends A.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$98b=C;class w{constructor(i){this.name=i;const n=(0,R.$8g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class E{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new w(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),a=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,A.$Rc)(a))}}var k;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(k||(k={}));function u(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const a=$.$gc.basename(o.extensionLocation.path),t=$.$gc.basename(i.extensionLocation.path);return a<t?-1:a>t?1:0}function m(o,i){const n=new I.$vm(i);return o.filter(r=>!n.has(r.identifier))}}),define(Ce[293],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.ExtHostConnectionType=void 0;var I;(function(L){L[L.IPC=1]="IPC",L[L.Socket=2]="Socket",L[L.MessagePort=3]="MessagePort"})(I||(e.ExtHostConnectionType=I={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[O.ENV_KEY]=this.pipeName}}e.$Zm=O;class ${constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[$.ENV_KEY]="1"}}e.$1m=$;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[A.ENV_KEY]="1"}}e.$2m=A;function R(L){delete L[O.ENV_KEY],delete L[$.ENV_KEY],delete L[A.ENV_KEY]}function v(L,C){R(C),L.serialize(C)}e.$3m=v;function p(L){if(L[O.ENV_KEY])return S(L,new O(L[O.ENV_KEY]));if(L[$.ENV_KEY])return S(L,new $);if(L[A.ENV_KEY])return S(L,new A);throw new Error("No connection information defined in environment!")}e.$4m=p;function S(L,C){return R(L),C}}),define(Ce[113],Ie([1,0,21]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Dm=e.$Cm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function(S){S[S.Desktop=1]="Desktop",S[S.Web=2]="Web"})(O||(e.UIKind=O={}));var $;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})($||(e.ExtensionHostExitCode=$={}));var A;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(S){const L=I.$qe.alloc(1);switch(S){case 0:L.writeUInt8(1,0);break;case 1:L.writeUInt8(2,0);break;case 2:L.writeUInt8(3,0);break}return L}e.$Cm=R;function v(S,L){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return L===0;case 2:return L===1;case 3:return L===2;default:return!1}}e.$Dm=v;var p;(function(S){S.Start="START_NATIVE_LOG",S.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[90],Ie([1,0,5,4,13,27,113,66,87,24,2,3,219]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=void 0;let E=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new O.$3d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$3d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=L.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:p.$Zo,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,$.$yj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===$.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new k(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$kl)((0,p.$6o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$rO=E,e.$rO=E=Ke([We(0,A.$qO),We(1,$.$xj)],E);class k{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,d){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new O.$3d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,p.$9o)(i,[]),this.c&&(i=(0,S.$In)(i,this.c)),this.b||(i=(0,S.$In)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,p.$9o)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$sO=k;function u(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$tO=u,e.$uO=(0,I.$ci)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,263,137,26,5]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.ActivationKind=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.ExtensionHostStartup=e.$PF=e.$OF=e.$NF=e.$MF=void 0,e.$MF=Object.freeze({identifier:new R.$um("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:O.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NF="extensions.webWorker",e.$OF=(0,v.$ci)("extensionService");class p{constructor(a){this.dependency=a}}e.$PF=p;var S;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(S||(e.ExtensionHostStartup=S={}));class L{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,d){this.c=a,this.d=t.slice(0),this.e=d.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$xF.createActivationEventsMap(this.d)}}set(a,t,d){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const c=[],s=[],l=[],h=[],b=C(this.d),D=C(t),g=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=D.get(U.identifier);if(!z){c.push(U.identifier),b.delete(U.identifier);continue}if(!g(U,z)){c.push(U.identifier),b.delete(U.identifier);continue}}for(const U of t){const z=b.get(U.identifier);if(!z){s.push(U);continue}if(!g(z,U)){c.push(z.identifier),b.delete(z.identifier);continue}}const f=new R.$vm(this.e),y=new R.$vm(d);for(const U of this.e)y.has(U)||l.push(U);for(const U of d)f.has(U)||h.push(U);const P=A.$xF.createActivationEventsMap(s),N={versionId:a,toRemove:c,toAdd:s,addActivationEvents:P,myToRemove:l,myToAdd:h};return this.delta(N),N}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:d,myToRemove:c,myToAdd:s}=a,l=new R.$vm(t),h=new R.$vm(c);for(let b=0;b<this.d.length;b++)l.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)h.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of d)this.d.push(b);for(const b of s)this.e.push(b);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$um.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const d=A.$xF.readActivationEvents(t);for(const c of d)a.add(c)}return a}}e.$QF=L;function C(r){const a=new R.$wm;for(const t of r)a.set(t.identifier,t);return a}function w(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$RF=w;function E(r,a){if(!w(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$SF=E;class k{constructor(a,t,d,c){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=d,this.activationReason=c}}e.$TF=k;class u{constructor(a,t){this.description=a,this.value=t}}e.$UF=u;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,$.$cp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$VF=o;function i(r,a){return{identifier:new R.$um((0,$.$ap)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$WF=i;class n{constructor(){this.onDidRegisterExtensions=I.Event.None,this.onDidChangeExtensionsStatus=I.Event.None,this.onDidChangeExtensions=I.Event.None,this.onWillActivateByEvent=I.Event.None,this.onDidChangeResponsiveChange=I.Event.None,this.onWillStop=I.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XF=n}),define(Ce[294],Ie([1,0,14,145,26,25,13,8]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=e.$Hhc=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$Hhc=p;class S{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ihc=S;class L{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$Jhc=L;class C extends L{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Khc=C;class w extends L{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lhc=w;class E extends L{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let k=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new $.$wm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(a));return this.c.onExtensionActivationError(o.id,a,new A.$PF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const d=this.a.getExtensionDescription(a);if(d){if(!d.main&&!d.browser)continue;n.push(this.j({id:d.identifier,reason:o.reason}));continue}const c=i.displayName||i.identifier.value,s=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${a}'`),l=this.k(o,i.displayName,[],new E(s));return this.c.onExtensionActivationError(i.identifier,s,new A.$PF(a)),l}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const a=new u(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,a),a}l(o){return O.$68b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Mhc=k,e.$Mhc=k=Ke([We(3,R.$wj)],k);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,a,t,d){this.c=o,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=d,this.a=new v.$bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new E(i),this.b&&I.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};u=Ke([We(6,R.$wj)],u)}),define(Ce[295],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[296],Ie([1,0,235,14,39,134,108,37,26,295,136,137]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=void 0;const w=v.$Rn.as(R.$Sn.JSONContribution);class E{constructor(a,t,d){this.a=a,this.b=t,this.c=d}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d($.default.Error,a)}warn(a){this.d($.default.Warning,a)}info(a){this.d($.default.Info,a)}}e.$GF=E;class k{static a(a){const t=new p.$vm;for(let d=0,c=a.length;d<c;d++)t.add(a[d].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new k(t,[]);if(!t||!t.length)return new k([],a);const d=this.a(a),c=this.a(t),s=t.filter(h=>!d.has(h.description.identifier)),l=a.filter(h=>!c.has(h.description.identifier));return new k(s,l)}constructor(a,t){this.added=a,this.removed=t}}e.$HF=k;class u{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=k.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,O.$1)(a)}}}e.$IF=u;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[I.localize(0,null),I.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$JF={properties:{engines:{type:"object",description:I.localize(2,null),properties:{vscode:{type:"string",description:I.localize(3,null),default:"^1.22.0"}}},publisher:{description:I.localize(4,null),type:"string"},displayName:{description:I.localize(5,null),type:"string"},categories:{description:I.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$tm},{type:"string",const:"Languages",deprecationMessage:I.localize(7,null)}]}},galleryBanner:{type:"object",description:I.localize(8,null),properties:{color:{description:I.localize(9,null),type:"string"},theme:{description:I.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:I.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:I.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:I.localize(13,null)},enabledApiProposals:{markdownDescription:I.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}},api:{markdownDescription:I.localize(15,null),type:"string",enum:["none"],enumDescriptions:[I.localize(16,null)]},activationEvents:{description:I.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:I.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:I.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:I.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:I.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:I.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:I.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:I.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:I.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:I.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:I.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:I.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:I.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:I.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:I.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:I.localize(32,null)},{label:"onUri",body:"onUri",description:I.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:I.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:I.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:I.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:I.localize(37,null)},{label:"onRenderer",description:I.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:I.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:I.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:I.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:I.localize(42,null)},{label:"*",description:I.localize(43,null),body:"*"}]}},badges:{type:"array",description:I.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:I.localize(45,null)},href:{type:"string",description:I.localize(46,null)},description:{type:"string",description:I.localize(47,null)}}}},markdown:{type:"string",description:I.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:I.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:I.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$wo}},extensionPack:{description:I.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$wo}},extensionKind:{description:I.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:I.localize(53,null)},{body:["workspace"],description:I.localize(54,null)},{body:["ui","workspace"],description:I.localize(55,null)},{body:["workspace","ui"],description:I.localize(56,null)},{body:[],description:I.localize(57,null)}]},capabilities:{description:I.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:I.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:I.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(61,null),I.localize(62,null),I.localize(63,null)]},description:{type:"string",markdownDescription:I.localize(64,null)}}},untrustedWorkspaces:{description:I.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:I.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[I.localize(67,null),I.localize(68,null),I.localize(69,null)]},restrictedConfigurations:{description:I.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:I.localize(71,null)}}}}},sponsor:{description:I.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:I.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:I.localize(74,null),type:"string"},"vscode:uninstall":{description:I.localize(75,null),type:"string"}}},icon:{type:"string",description:I.localize(76,null)},l10n:{type:"string",description:I.localize(77,null)},pricing:{type:"string",markdownDescription:I.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new u(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$xF.register(a.extensionPoint,a.activationEventsGenerator),e.$JF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,w.registerSchema(o,e.$JF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$KF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};v.$Rn.add(n.ExtensionsRegistry,new i),e.$LF=v.$Rn.as(n.ExtensionsRegistry),w.registerSchema(o,e.$JF),w.registerSchema(L.$Pj,{properties:{extensionEnabledApiProposals:{description:I.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(S.allApiProposals),markdownEnumDescriptions:Object.values(S.allApiProposals)}}]}}}})}),define(Ce[297],Ie([1,0,231,18,24,296,45,4]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:I.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:I.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:I.localize(2,null),default:""}}};var S;(function(w){function E(k,u,m){if(!k)return;const o=O.$Qf(k.type)?k.type:void 0;if(!o||o.length===0){m.error(I.localize(3,null));return}const i=[];if(Array.isArray(k.required))for(const n of k.required)O.$Qf(n)&&i.push(n);return{extensionId:u.value,taskType:o,required:i,properties:k.properties?$.$Fn(k.properties):{},when:k.when?R.$aj.deserialize(k.when):void 0}}w.from=E})(S||(S={}));const L=A.$LF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,E)=>{for(const k of w)k.type&&E.push(`onTaskType:${k.type}`)},jsonSchema:{description:I.localize(4,null),type:"array",items:p}});class C{constructor(){this.d=new v.$3d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,k)=>{L.setHandler((u,m)=>{this.c=void 0;try{for(const o of m.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of m.added){const i=o.value;for(const n of i){const r=S.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const k of this.all()){const u={type:"object",additionalProperties:!1};k.required.length>0&&(u.required=k.required.slice(0)),k.properties!==void 0?u.properties=$.$Fn(k.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[k.taskType]},E.push(u)}this.c={oneOf:E}}return this.c}}e.$0G=new C}),define(Ce[298],Ie([1,0,232,18,23,24,45,297]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$hH=e.JsonSchemaVersion=e.ExecutionEngine=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$bH=e.ShellQuoting=e.$aH=e.$_G=e.$$G=void 0,e.$$G="settings",e.$_G=new R.$tj("taskRunning",!1,I.localize(0,null)),e.$aH=I.localize2(2,"Tasks");var p;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$bH="$customized",function(M){function T(j){if(!j)return M.Strong;switch(j.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=T}(p||(e.ShellQuoting=p={}));var S;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(S||(e.CommandOptions=S={}));var L;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(L||(e.RevealKind=L={})),function(M){function T(j){switch(j.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=T}(L||(e.RevealKind=L={}));var C;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(M){function T(j){switch(j.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=T}(C||(e.RevealProblemKind=C={}));var w;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(w||(e.PanelKind=w={})),function(M){function T(j){switch(j.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=T}(w||(e.PanelKind=w={}));var E;(function(M){M.defaults={echo:!0,reveal:L.Always,revealProblems:C.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var k;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(k||(e.RuntimeType=k={})),function(M){function T(J){switch(J.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=T;function j(J){switch(J){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=j}(k||(e.RuntimeType=k={}));var u;(function(M){function T(j){return O.$Qf(j)?j:j.value}M.value=T})(u||(e.CommandString=u={}));var m;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function T(J){return J===M.Clean._id||J===M.Build._id||J===M.Rebuild._id||J===M.Test._id}M.is=T;function j(J){if(J!==void 0)return O.$Qf(J)?T(J)?{_id:J,isDefault:!1}:void 0:J}M.from=j})(m||(e.TaskGroup=m={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function T(j){switch(j){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=T})(i||(e.TaskSourceKind=i={}));var n;(function(M){M.parallel="parallel",M.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(T,j,J,ne,_,Z){this._label="",this._id=T,j&&(this._label=j),J&&(this.type=J),this.runOptions=ne,this.configurationProperties=_,this._source=Z}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,j=!1){if(T===void 0)return!1;if(O.$Qf(T))return T===this._label||T===this.configurationProperties.identifier||j&&T===this._id;const J=this.getDefinition(!0);return J!==void 0&&J._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$cH=t;class d extends t{constructor(T,j,J,ne,_,Z,Y,ce){super(T,J,void 0,Y,ce,j),this.command={},this._source=j,this.hasDefinedMatchers=Z,_&&(this.command=_)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case k.Shell:j="shell";break;case k.Process:j="process";break;case k.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(T){return T instanceof d}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$$G:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const J={type:e.$bH,folder:T,id:j};return JSON.stringify(J)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?$.$Mg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new d(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$dH=d;class c extends t{constructor(T,j,J,ne,_,Z,Y){super(T,J,ne,Z,Y,j),this._source=j,this.configures=_}static is(T){return T instanceof c}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?$.$Mg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$$G:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const J={type:e.$bH,folder:T,id:j};return JSON.stringify(J)}}e.$eH=c;class s extends t{constructor(T,j,J,ne,_,Z,Y,ce,ie){super(T,J,ne,ce,ie,j),this.defines=_,this.hasDefinedMatchers=Y,this.command=Z,this.icon=ie.icon,this.hide=ie.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof s}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new s(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$fH=s;class l extends t{constructor(T,j,J,ne,_,Z){super(T,J,ne,_,Z,j),this._source=j}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new l(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$gH=l;var h;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(M){M._default=M.Terminal}(h||(e.ExecutionEngine=h={}));var b;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class D{constructor(T){this.c=new Map;for(let j=0;j<T.length;j++)this.c.set(T[j].uri.toString(),j)}compare(T,j){const J=T.getWorkspaceFolder(),ne=j.getWorkspaceFolder();if(J&&ne){let _=this.c.get(J.uri.toString());_=_===void 0?0:_+1;let Z=this.c.get(ne.uri.toString());return Z=Z===void 0?0:Z+1,_===Z?T._label.localeCompare(j._label):_-Z}else return!J&&ne?-1:J&&!ne?1:0}}e.$hH=D;var g;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(g||(e.TaskEventKind=g={}));var f;(function(M){M.SingleRun="singleRun",M.Background="background"})(f||(e.TaskRunType=f={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var P;(function(M){function T(ce){return{taskId:ce._id,taskName:ce.configurationProperties.name,runType:ce.configurationProperties.isBackground?"background":"singleRun",group:ce.configurationProperties.group,__task:ce}}function j(ce,ie,fe){return{...T(ce),kind:"start",terminalId:ie,resolvedVariables:fe}}M.start=j;function J(ce,ie,fe){return{...T(ce),kind:"processStarted",terminalId:ie,processId:fe}}M.processStarted=J;function ne(ce,ie,fe){return{...T(ce),kind:"processEnded",terminalId:ie,exitCode:fe}}M.processEnded=ne;function _(ce,ie,fe){return{...T(ce),kind:"terminated",exitReason:fe,terminalId:ie}}M.terminated=_;function Z(ce,ie,fe){return{...T(ie),kind:ce,terminalId:fe}}M.general=Z;function Y(){return{kind:"changed"}}M.changed=Y})(P||(e.TaskEvent=P={}));var N;(function(M){function T(J){const ne=Object.keys(J).sort();let _="";for(const Z of ne){let Y=J[Z];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),_+=Z+","+Y+","}return _}function j(J){const _={_key:T(J),type:J.taskType};return Object.assign(_,J),_}M.create=j})(N||(e.KeyedTaskIdentifier=N={}));var U;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var z;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var F;(function(M){function T(j,J){const ne=v.$0G.get(j.type);if(ne===void 0){const ce=A.$Fn(j);return delete ce._key,N.create(ce)}const _=Object.create(null);_.type=ne.taskType;const Z=new Set;ne.required.forEach(ce=>Z.add(ce));const Y=ne.properties;for(const ce of Object.keys(Y)){const ie=j[ce];if(ie!=null)_[ce]=ie;else if(Z.has(ce)){const fe=Y[ce];if(fe.default!==void 0)_[ce]=A.$Fn(fe.default);else switch(fe.type){case"boolean":_[ce]=!1;break;case"number":case"integer":_[ce]=0;break;case"string":_[ce]="";break;default:J.error(I.localize(1,null,JSON.stringify(j,void 0,0),ce));return}}}return N.create(_)}M.createTaskIdentifier=T})(F||(e.TaskDefinition=F={}))}),define(Ce[299],Ie([1,0,14]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=e.$08b=void 0;class O{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,v)=>{this.b=R,this.d=v,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,I.$1)(R))}then(R,v){return this.j().then(R,v)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$08b=O;class $ extends O{constructor(){super(),this.h=!0,this.i=new I.$5}}e.$$8b=$}),define(Ce[69],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3v=e.$2v=e.$1v=e.$Zv=void 0;class I{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++I.count}}e.$Zv=I;const O=[];function $(v){const p=new I(v);return O[p.nid]=p,p}e.$1v=$;function A(v){return O[v].sid}e.$2v=A;class R{constructor(p){this.value=p}}e.$3v=R}),define(Ce[6],Ie([1,0,69]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$UL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var $;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})($||(e.TabInputKind=$={}));var A;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var v;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var p;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var S;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(S||(e.NotebookEditorRevealType=S={}));var L;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(L||(e.CandidatePortSource=L={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$UL=C;var w;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var E;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var k;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(k||(e.ExtHostTestingResource=k={})),e.$VL={MainThreadAuthentication:(0,I.$1v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.$1v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,I.$1v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,I.$1v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,I.$1v)("MainThreadChatVariables"),MainThreadClipboard:(0,I.$1v)("MainThreadClipboard"),MainThreadCommands:(0,I.$1v)("MainThreadCommands"),MainThreadComments:(0,I.$1v)("MainThreadComments"),MainThreadConfiguration:(0,I.$1v)("MainThreadConfiguration"),MainThreadConsole:(0,I.$1v)("MainThreadConsole"),MainThreadDebugService:(0,I.$1v)("MainThreadDebugService"),MainThreadDecorations:(0,I.$1v)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.$1v)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.$1v)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.$1v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.$1v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.$1v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.$1v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.$1v)("MainThreadEditorTabs"),MainThreadErrors:(0,I.$1v)("MainThreadErrors"),MainThreadTreeViews:(0,I.$1v)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.$1v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,I.$1v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.$1v)("MainThreadLanguages"),MainThreadLogger:(0,I.$1v)("MainThreadLogger"),MainThreadMessageService:(0,I.$1v)("MainThreadMessageService"),MainThreadOutputService:(0,I.$1v)("MainThreadOutputService"),MainThreadProgress:(0,I.$1v)("MainThreadProgress"),MainThreadQuickDiff:(0,I.$1v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,I.$1v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.$1v)("MainThreadStatusBar"),MainThreadSecretState:(0,I.$1v)("MainThreadSecretState"),MainThreadStorage:(0,I.$1v)("MainThreadStorage"),MainThreadSpeech:(0,I.$1v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,I.$1v)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.$1v)("MainThreadTerminalService"),MainThreadWebviews:(0,I.$1v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.$1v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.$1v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.$1v)("MainThreadCustomEditors"),MainThreadUrls:(0,I.$1v)("MainThreadUrls"),MainThreadUriOpeners:(0,I.$1v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,I.$1v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,I.$1v)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.$1v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,I.$1v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,I.$1v)("MainThreadExtensionService"),MainThreadSCM:(0,I.$1v)("MainThreadSCM"),MainThreadSearch:(0,I.$1v)("MainThreadSearch"),MainThreadShare:(0,I.$1v)("MainThreadShare"),MainThreadTask:(0,I.$1v)("MainThreadTask"),MainThreadWindow:(0,I.$1v)("MainThreadWindow"),MainThreadLabelService:(0,I.$1v)("MainThreadLabelService"),MainThreadNotebook:(0,I.$1v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.$1v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.$1v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.$1v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,I.$1v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,I.$1v)("MainThreadInteractive"),MainThreadChat:(0,I.$1v)("MainThreadChat"),MainThreadInlineChat:(0,I.$1v)("MainThreadInlineChatShape"),MainThreadTheming:(0,I.$1v)("MainThreadTheming"),MainThreadTunnelService:(0,I.$1v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,I.$1v)("MainThreadManagedSockets"),MainThreadTimeline:(0,I.$1v)("MainThreadTimeline"),MainThreadTesting:(0,I.$1v)("MainThreadTesting"),MainThreadLocalization:(0,I.$1v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,I.$1v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,I.$1v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,I.$1v)("MainThreadIssueReporter")},e.$WL={ExtHostCommands:(0,I.$1v)("ExtHostCommands"),ExtHostConfiguration:(0,I.$1v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.$1v)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.$1v)("ExtHostDebugService"),ExtHostDecorations:(0,I.$1v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.$1v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.$1v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.$1v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.$1v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.$1v)("ExtHostEditors"),ExtHostTreeViews:(0,I.$1v)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.$1v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.$1v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.$1v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,I.$1v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,I.$1v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.$1v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,I.$1v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,I.$1v)("ExtHostStatusBar"),ExtHostShare:(0,I.$1v)("ExtHostShare"),ExtHostExtensionService:(0,I.$1v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,I.$1v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,I.$1v)("ExtHostTerminalService"),ExtHostSCM:(0,I.$1v)("ExtHostSCM"),ExtHostSearch:(0,I.$1v)("ExtHostSearch"),ExtHostTask:(0,I.$1v)("ExtHostTask"),ExtHostWorkspace:(0,I.$1v)("ExtHostWorkspace"),ExtHostWindow:(0,I.$1v)("ExtHostWindow"),ExtHostWebviews:(0,I.$1v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.$1v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.$1v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.$1v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.$1v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.$1v)("ExtHostEditorTabs"),ExtHostProgress:(0,I.$1v)("ExtHostProgress"),ExtHostComments:(0,I.$1v)("ExtHostComments"),ExtHostSecretState:(0,I.$1v)("ExtHostSecretState"),ExtHostStorage:(0,I.$1v)("ExtHostStorage"),ExtHostUrls:(0,I.$1v)("ExtHostUrls"),ExtHostUriOpeners:(0,I.$1v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,I.$1v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,I.$1v)("ExtHostOutputService"),ExtHostLabelService:(0,I.$1v)("ExtHostLabelService"),ExtHostNotebook:(0,I.$1v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,I.$1v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,I.$1v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,I.$1v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,I.$1v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,I.$1v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,I.$1v)("ExtHostInteractive"),ExtHostInlineChat:(0,I.$1v)("ExtHostInlineChatShape"),ExtHostChat:(0,I.$1v)("ExtHostChat"),ExtHostChatAgents2:(0,I.$1v)("ExtHostChatAgents"),ExtHostChatVariables:(0,I.$1v)("ExtHostChatVariables"),ExtHostChatProvider:(0,I.$1v)("ExtHostChatProvider"),ExtHostSpeech:(0,I.$1v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,I.$1v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,I.$1v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,I.$1v)("ExtHostTheming"),ExtHostTunnelService:(0,I.$1v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,I.$1v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,I.$1v)("ExtHostAuthentication"),ExtHostTimeline:(0,I.$1v)("ExtHostTimeline"),ExtHostTesting:(0,I.$1v)("ExtHostTesting"),ExtHostTelemetry:(0,I.$1v)("ExtHostTelemetry"),ExtHostLocalization:(0,I.$1v)("ExtHostLocalization"),ExtHostIssueReporter:(0,I.$1v)("ExtHostIssueReporter")}}),define(Ce[91],Ie([1,0,5,13,6,20]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=void 0,e.$6gc=(0,I.$ci)("IExtHostApiDeprecationService");let R=class{constructor(p,S){this.c=S,this.a=new Set,this.b=p.getProxy($.$VL.MainThreadTelemetry)}report(p,S,L){const C=this.d(p,S);this.a.has(C)||(this.a.add(C),S.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${L}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:S.identifier.value,apiId:p}))}d(p,S){return`${p}-${S.identifier.value}`}};e.$7gc=R,e.$7gc=R=Ke([We(0,A.$aO),We(1,O.$wj)],R),e.$8gc=Object.freeze(new class{report(v,p,S){}})}),define(Ce[300],Ie([1,0,53,3,6]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class A{static{this.a=0}constructor(p,S){this.extension=p,this.provider=S,this.handle=A.a++}}class R{static{this.a=0}constructor(p){this.b=new Map,this.c=new Map,this.d=p.getProxy($.$VL.MainThreadChat)}registerChatProvider(p,S,L){const C=new A(p,L);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,S),(0,O.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession(p,S){const L=I.Iterable.find(this.c.keys(),C=>this.c.get(C)===p)??0;typeof L=="number"&&this.d.$transferChatSession(L,S)}sendInteractiveRequestToProvider(p,S){this.d.$sendRequestToProvider(p,S)}async $prepareChat(p,S){const L=this.b.get(p);if(!L)return;const C=await L.provider.prepareSession(S);if(!C)return;const w=R.a++;return this.c.set(w,C),{id:w,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession(p){this.c.delete(p)}}e.$fhc=R}),define(Ce[301],Ie([1,0,6]),function(me,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class O{constructor(A){const R=A.getProxy(I.$VL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(v){return R.$writeText(v)}})}}e.$jhc=O}),define(Ce[302],Ie([1,0,24,6,27,20]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;let R=class{constructor(L,C){this.a=L.getProxy(O.$VL.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(L,C){const w=this,E=console[L];Object.defineProperty(console,L,{set:()=>{},get:()=>function(){w.e(L,C,E,arguments)}})}e(L,C,w,E){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:p(E,this.b)}),this.c&&this.f(L,w,E)}};e.$ajc=R,e.$ajc=R=Ke([We(0,A.$aO),We(1,$.$qO)],R);const v=1e5;function p(S,L){const C=[];if(S.length)for(let w=0;w<S.length;w++){let E=S[w];if(typeof E>"u")E="undefined";else if(E instanceof Error){const k=E;k.stack?E=k.stack:E=k.toString()}C.push(E)}if(L){const w=new Error().stack;w&&C.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,I.$Kn)(C);return w.length>v?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(Ce[303],Ie([1,0,2,6,25]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class A{constructor(v){this.a=v.getProxy(O.$VL.MainThreadDialogs)}showOpenDialog(v,p){return p?.allowUIResources&&(0,$.$SF)(v,"showLocal"),this.a.$showOpenDialog(p).then(S=>S?S.map(L=>I.URI.revive(L)):void 0)}showSaveDialog(v){return this.a.$showSaveDialog(v).then(p=>p?I.URI.revive(p):void 0)}}e.$eic=A}),define(Ce[304],Ie([1,0,3,6]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class ${constructor(R){this.b=0,this.a=R.getProxy(O.$VL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const v=this.b++;return this.a.$registerResourceLabelFormatter(v,R),(0,I.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(v)})}}e.$zic=$}),define(Ce[114],Ie([1,0,11,12,2,5,13,6,27,20]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0;let L=class{constructor(w,E,k){this.f=k,this.d=new Map,this.a=E.getProxy(v.$VL.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===I.$g}getMessage(w,E){const{message:k,args:u,comment:m}=E;if(this.c)return(0,O.$Se)(k,u??{});let o=k;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(w)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,O.$Se)(i??k,u??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let E;const k=await this.g(w);if(!k){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(k),m=JSON.parse(u);E=w.isBuiltin?m.contents?.bundle:m}catch(u){this.f.error(`Failed to load translations for ${w.identifier.value} from ${k}: ${u.message}`);return}E&&this.d.set(w.identifier.value,{contents:E,uri:k})}async g(w){if(w.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return $.URI.revive(E)}return w.l10n?$.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Yhc=L,e.$Yhc=L=Ke([We(0,p.$qO),We(1,S.$aO),We(2,R.$wj)],L),e.$Zhc=(0,A.$ci)("IExtHostLocalizationService")}),define(Ce[146],Ie([1,0,13,6,27,20,2,56]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;let p=class extends I.$Hj{constructor(C,w){super(w.logLevel,w.logsLocation,w.loggers.map(E=>(0,v.$Lh)(E))),this.r=C.getProxy(O.$VL.MainThreadLogger)}$setLogLevel(C,w){w?this.setLogLevel(R.URI.revive(w),C):this.setLogLevel(C)}setVisibility(C,w){super.setVisibility(C,w),this.r.$setVisibility(C,w)}s(C,w,E){return new S(this.r,C,w,E)}};e.$_ic=p,e.$_ic=p=Ke([We(0,A.$aO),We(1,$.$qO)],p);class S extends I.$Cj{constructor(C,w,E,k){super(k?.logLevel==="always"),this.r=C,this.s=w,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(w,k).then(()=>{this.u(this.n),this.m=!0})}g(C,w){const E=[[C,w]];this.m?this.u(E):this.n.push(...E)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Ce[115],Ie([1,0,6,5,3,20,21]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=void 0,e.$1hc=(0,O.$ci)("IExtHostManagedSockets");let v=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(I.$VL.MainThreadManagedSockets)}setFactory(C,w){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(C,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const w=++this.b,E=await this.c.makeConnection(),k=new $.$Sc;return this.d.set(w,new S(w,E,k)),k.add((0,$.$Rc)(()=>this.d.delete(w))),k.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),k.dispose()})),k.add(E.onDidClose(u=>{this.a.$onDidManagedSocketClose(w,u?.stack??u?.message),k.dispose()})),k.add(E.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(w,R.$qe.wrap(u)))),w}$remoteSocketWrite(C,w){this.d.get(C)?.actual.send(w.buffer)}$remoteSocketEnd(C){const w=this.d.get(C);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$2hc=v,e.$2hc=v=Ke([We(0,A.$aO)],v);class p{constructor(C,w){this.socketFactoryId=C,this.makeConnection=w}}class S extends $.$Tc{constructor(C,w,E){super(),this.socketId=C,this.actual=w,this.B(E)}}}),define(Ce[305],Ie([1,0,6,13,25]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;function A(v){return v&&v.title}let R=class{constructor(p,S){this.b=S,this.a=p.getProxy(I.$VL.MainThreadMessageService)}showMessage(p,S,L,C,w){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let k;typeof C=="string"||A(C)?k=[C,...w]:(E.modal=C?.modal,E.useCustom=C?.useCustom,E.detail=C?.detail,k=w),E.useCustom&&(0,$.$SF)(p,"resolvers");const u=[];let m=!1;for(let o=0;o<k.length;o++){const i=k[o];if(typeof i=="string")u.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;u.push({title:n,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,i)}return this.a.$showMessage(S,L,E,u).then(o=>{if(typeof o=="number")return k[o]})}};e.$Bic=R,e.$Bic=R=Ke([We(1,O.$wj)],R)}),define(Ce[306],Ie([1,0,3,18,2,25,6]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class v{constructor(S){this.b=new Map,this.a=S.getProxy(R.$VL.MainThreadProfileContentHandlers)}registerProfileContentHandler(S,L,C){if((0,A.$SF)(S,"profileContentHandlers"),this.b.has(L))throw new Error(`Handler with id '${L}' already registered`);return this.b.set(L,C),this.a.$registerProfileContentHandler(L,C.name,C.description,S.identifier.value),(0,I.$Rc)(()=>{this.b.delete(L),this.a.$unregisterProfileContentHandler(L)})}async $saveProfile(S,L,C,w){const E=this.b.get(S);if(!E)throw new Error(`Unknown handler with id: ${S}`);return E.saveProfile(L,C,w)}async $readProfile(S,L,C){const w=this.b.get(S);if(!w)throw new Error(`Unknown handler with id: ${S}`);return w.readProfile((0,O.$Qf)(L)?L:$.URI.revive(L),C)}}e.$Kic=v}),define(Ce[116],Ie([1,0,6,4,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=void 0;class A{constructor(v){this.b=new O.$3d,this.onDidChangePassword=this.b.event,this.a=v.getProxy(I.$VL.MainThreadSecretState)}async $onDidChangePassword(v){this.b.fire(v)}get(v,p){return this.a.$getPassword(v,p)}store(v,p,S){return this.a.$setPassword(v,p,S)}delete(v,p){return this.a.$deletePassword(v,p)}}e.$Vhc=A,e.$Whc=(0,$.$ci)("IExtHostSecretState")}),define(Ce[307],Ie([1,0,22,3,6]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;class A{static{this.a=1}constructor(v){this.c=new Map,this.d=new Map,this.b=v.getProxy($.$VL.MainThreadSpeech)}async $createSpeechToTextSession(v,p){const S=this.c.get(v);if(!S)return;const L=new O.$Sc,C=new I.$ae;this.d.set(p,C);const w=L.add(S.provideSpeechToTextSession(C.token));L.add(w.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,E)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelSpeechToTextSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}async $createKeywordRecognitionSession(v,p){const S=this.c.get(v);if(!S)return;const L=new O.$Sc,C=new I.$ae;this.d.set(p,C);const w=L.add(S.provideKeywordRecognitionSession(C.token));L.add(w.onDidChange(E=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),L.add(C.token.onCancellationRequested(()=>L.dispose()))}async $cancelKeywordRecognitionSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}registerProvider(v,p,S){const L=A.a++;return this.c.set(L,S),this.b.$registerProvider(L,p,{extension:v,displayName:v.value}),(0,O.$Rc)(()=>{this.b.$unregisterProvider(L),this.c.delete(L)})}}e.$Ric=A}),define(Ce[117],Ie([1,0,6,4,5]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0;class A{constructor(v,p){this.c=p,this.b=new O.$3d,this.onDidChangeStorage=this.b.event,this.a=v.getProxy(I.$VL.MainThreadStorage)}registerExtensionStorageKeysToSync(v,p){this.a.$registerExtensionStorageKeysToSync(v,p)}async initializeExtensionStorage(v,p,S){const L=await this.a.$initializeExtensionStorage(v,p);let C;return L&&(C=this.d(v,p,L)),C||S}setValue(v,p,S){return this.a.$setValue(v,p,S)}$acceptValue(v,p,S){const L=this.d(v,p,S);L&&this.b.fire({shared:v,key:p,value:L})}d(v,p,S){try{return JSON.parse(S)}catch(L){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${v}): ${L}`)}}}e.$Nhc=A,e.$Ohc=(0,$.$ci)("IExtHostStorage")}),define(Ce[308],Ie([1,0,3,16,2,6]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class R{static{this.a=new Set([O.Schemas.http,O.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(A.$VL.MainThreadUriOpeners)}registerExternalUriOpener(p,S,L,C){if(this.c.has(S))throw new Error(`Opener with id '${S}' already registered`);const w=C.schemes.find(E=>!R.a.has(E));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(S,L),this.b.$registerUriOpener(S,C.schemes,p,C.label),(0,I.$Rc)(()=>{this.c.delete(S),this.b.$unregisterUriOpener(S)})}async $canOpenUri(p,S,L){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener with id: ${p}`);const w=$.URI.revive(S);return C.canOpenExternalUri(w,L)}async $openUri(p,S,L){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener id: '${p}'`);return C.openExternalUri($.URI.revive(S.resolvedUri),{sourceUri:$.URI.revive(S.sourceUri)},L)}}e.$6ic=R}),define(Ce[309],Ie([1,0,6,2,3,14,26]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class v{static{this.a=0}constructor(S){this.c=new R.$vm,this.d=new Map,this.b=S.getProxy(I.$VL.MainThreadUrls)}registerUriHandler(S,L){const C=S.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const w=v.a++;return this.c.add(C),this.d.set(w,L),this.b.$registerUriHandler(w,C,S.displayName||S.name),(0,$.$Rc)(()=>{this.c.delete(C),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(S,L){const C=this.d.get(S);if(!C)return Promise.resolve(void 0);try{C.handleUri(O.URI.revive(L))}catch(w){(0,A.$1)(w)}return Promise.resolve(void 0)}async createAppUri(S){return O.URI.revive(await this.b.$createAppUri(S))}}e.$7ic=v}),define(Ce[92],Ie([1,0,4,3,16,24,2,239,276,112,6]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,a,t,d,c,s,l){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new I.$3d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new I.$3d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#o=t,this.#n=d,this.#s=c,this.#r=s,this.#l=w(s),this.#d=E(s),this.#i=l}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,S.$8wb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===$.Schemas.https||r.scheme===$.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+S.$7wb}return S.$7wb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),A.$Jn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const a=(0,p.$Kmb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#r.extensionLocation?.scheme===$.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===$.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,c,s,l,h,b)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),g=(0,S.$8wb)(D,{isRemote:a,authority:t}).toString();return`${c}${g}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(d,c,s,l,h,b)=>{const D=R.URI.from({scheme:l||"file",path:decodeURIComponent(h)}),g=(0,S.$8wb)(D,{isRemote:a,authority:t}).toString();return`${c}${g}${b}`})}}e.$yhc=C;function w(n){try{const r=(0,v.$lp)((0,v.$kp)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$zhc=w;function E(n){try{const r=(0,v.$lp)((0,v.$kp)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class k extends O.$Tc{constructor(r,a,t,d,c){super(),this.c=a,this.f=t,this.g=d,this.h=c,this.b=new Map,this.a=r.getProxy(L.$VL.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const d=this.j(r);if(d){const{message:c}=(0,p.$Lmb)(a,t.value);d._onMessageEmitter.fire(c)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const d=new C(r,this.a,o(a),this.c,this.f,t,this.h);this.b.set(r,d);const c=d._onDidDispose(()=>{c.dispose(),this.deleteWebview(r)});return d}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$Ahc=k;function u(n){return{id:n.identifier,location:n.extensionLocation}}e.$Bhc=u;function m(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$Chc=m;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>R.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Ce[147],Ie([1,0,4,6,2,16,12,5,20,25]),function(me,e,I,O,$,A,R,v,p,S){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=e.$9ic=void 0;let C=class{static{L=this}static{this.a={focused:!0,active:!0}}getState(E){const k=this.d;return{get focused(){return k.focused},get active(){return(0,S.$SF)(E,"windowActivity"),k.active}}}constructor(E){this.c=new I.$3d,this.onDidChangeWindowState=this.c.event,this.d=L.a,this.b=E.getProxy(O.$VL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:u})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,k){k!==this.d[E]&&(this.d={...this.d,[E]:k},this.c.fire(this.d))}openUri(E,k){let u;if(typeof E=="string"){u=E;try{E=$.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,R.$Qe)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,u,k)}async asExternalUri(E,k){if((0,R.$Qe)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(E,k);return $.URI.from(u)}};e.$9ic=C,e.$9ic=C=L=Ke([We(0,p.$aO)],C),e.$0ic=(0,v.$ci)("IExtHostWindow")}),define(Ce[310],Ie([1,0,302,27,20]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;const A=1024*1024;let R=class extends I.$ajc{constructor(p,S){super(p,S),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,S,L){const C=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),S.apply(console,L),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,S){const L=process[p],C=L.write;let w="";Object.defineProperty(L,"write",{set:()=>{},get:()=>(E,k,u)=>{if(!this.g){w+=E.toString(k);const m=w.length>A?w.length:w.lastIndexOf(`
`);m!==-1&&(console[S](w.slice(0,m)),w=w.slice(m+1))}C.call(L,E,k,u)}})}};e.$Ljc=R,e.$Ljc=R=Ke([We(0,$.$aO),We(1,O.$qO)],R)}),define(Ce[311],Ie([1,0,146,16,253,30]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class R extends I.$_ic{s(p,S,L){return p.scheme===O.Schemas.file?new $.$mP(L?.name||(0,A.$yg)(),p.fsPath,!L?.donotRotate,!!L?.donotUseFormatters,S):super.s(p,S,L)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Xjc=R}),define(Ce[312],Ie([1,0,8,21,22,14,4,3,130,299,69]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=e.ResponsiveState=e.RequestInitiator=e.$a9b=e.$_8b=void 0;function w(y,P){try{return JSON.stringify(y,P)}catch{return"null"}}const E="$$ref$$",k={[E]:-1};class u{constructor(P,N){this.jsonString=P,this.referencedBuffers=N}}function m(y,P=null,N=!1){const U=[];return{jsonString:(N?w:JSON.stringify)(y,(F,M)=>{if(typeof M>"u")return k;if(typeof M=="object"){if(M instanceof O.$qe){const T=U.push(M)-1;return{[E]:T}}if(P)return P(F,M)}return M}),referencedBuffers:U}}e.$_8b=m;function o(y,P,N){return JSON.parse(y,(U,z)=>{if(z){const F=z[E];if(typeof F=="number")return P[F];if(N&&z.$mid===1)return N.transformIncoming(z)}return z})}e.$a9b=o;function i(y,P){return JSON.stringify(y,P)}function n(y){return y?(P,N)=>N&&N.$mid===1?y.transformOutgoing(N):N:null}var r;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},d=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class s extends v.$Tc{static{C=d}static{this.a=3*1e3}constructor(P,N=null,U=null){super(),this[C]=!0,this.b=this.B(new R.$3d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=N,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,F=L.$Zv.count;z<F;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new I.$oh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const N=this.w[P];delete this.w[P],N.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+s.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+s.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,p.$en)(P,this.g):P}getProxy(P){const{nid:N,sid:U}=P;return this.s[N]||(this.s[N]=this.J(N,U)),this.s[N]}J(P,N){const U={get:(z,F)=>(typeof F=="string"&&!z[F]&&F.charCodeAt(0)===36&&(z[F]=(...M)=>this.U(P,F,M)),F===c?N:z[F])};return new Proxy(Object.create(null),U)}set(P,N){return this.m[P.nid]=N,N}assertRegistered(P){for(let N=0,U=P.length;N<U;N++){const z=P[N];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const N=P.byteLength,U=h.read(P,0),z=U.readUInt8(),F=U.readUInt32();switch(z){case 1:case 2:{let{rpcId:M,method:T,args:j}=D.deserializeRequestJSONArgs(U);this.g&&(j=(0,p.$en)(j,this.g)),this.M(N,F,M,T,j,z===2);break}case 3:case 4:{let{rpcId:M,method:T,args:j}=D.deserializeRequestMixedArgs(U);this.g&&(j=(0,p.$en)(j,this.g)),this.M(N,F,M,T,j,z===4);break}case 5:{this.f?.logIncoming(N,F,0,"ack"),this.G(F);break}case 6:{this.N(N,F);break}case 7:{this.O(N,F,void 0);break}case 9:{let M=D.deserializeReplyOKJSON(U);this.g&&(M=(0,p.$en)(M,this.g)),this.O(N,F,M);break}case 10:{const M=D.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(N,F,M);break}case 8:{const M=D.deserializeReplyOKVSBuffer(U);this.O(N,F,M);break}case 11:{let M=D.deserializeReplyErrError(U);this.g&&(M=(0,p.$en)(M,this.g)),this.P(N,F,M);break}case 12:{this.P(N,F,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,N,U,z,F,M){this.f?.logIncoming(P,N,1,`receiveRequest ${(0,L.$2v)(U)}.${z}(`,F);const T=String(N);let j,J;if(M){const _=new $.$ae;F.push(_.token),j=this.Q(U,z,F),J=()=>_.cancel()}else j=this.Q(U,z,F),J=t;this.u[T]=J;const ne=D.serializeAcknowledged(N);this.f?.logOutgoing(ne.byteLength,N,1,"ack"),this.c.send(ne),j.then(_=>{delete this.u[T];const Z=D.serializeReplyOK(N,_,this.h);this.f?.logOutgoing(Z.byteLength,N,1,"reply:",_),this.c.send(Z)},_=>{delete this.u[T];const Z=D.serializeReplyErr(N,_);this.f?.logOutgoing(Z.byteLength,N,1,"replyErr:",_),this.c.send(Z)})}N(P,N){this.f?.logIncoming(P,N,1,"receiveCancel");const U=String(N);this.u[U]?.()}O(P,N,U){this.f?.logIncoming(P,N,0,"receiveReply:",U);const z=String(N);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z],F.resolveOk(U)}P(P,N,U){this.f?.logIncoming(P,N,0,"receiveReplyErr:",U);const z=String(N);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z];let M;U&&(U.$isError?(M=new Error,M.name=U.name,M.message=U.message,M.stack=U.stack):M=U),F.resolveErr(M)}Q(P,N,U){try{return Promise.resolve(this.S(P,N,U))}catch(z){return Promise.reject(z)}}S(P,N,U){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,L.$2v)(P));const F=z[N];if(typeof F!="function")throw new Error("Unknown method "+N+" on actor "+(0,L.$2v)(P));return F.apply(z,U)}U(P,N,U){if(this.j)return new S.$$8b;let z=null;if(U.length>0&&$.CancellationToken.isCancellationToken(U[U.length-1])&&(z=U.pop()),z&&z.isCancellationRequested)return Promise.reject(A.$6());const F=D.serializeRequestArguments(U,this.h),M=++this.t,T=String(M),j=new S.$08b,J=new v.$Sc;z&&J.add(z.onCancellationRequested(()=>{const _=D.serializeCancel(M);this.f?.logOutgoing(_.byteLength,M,0,"cancel"),this.c.send(D.serializeCancel(M))})),this.w[T]=new l(j,J),this.F(M);const ne=D.serializeRequest(M,P,N,F,!!z);return this.f?.logOutgoing(ne.byteLength,M,0,`request: ${(0,L.$2v)(P)}.${N}(`,U),this.c.send(ne),j}}e.$b9b=s;class l{constructor(P,N){this.a=P,this.b=N}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,N,U){const z=new h(O.$qe.alloc(U+1+4),0);return z.writeUInt8(P),z.writeUInt32(N),z}static read(P,N){return new h(P,N)}get buffer(){return this.a}constructor(P,N){this.a=P,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+P);return this.b+=P,N}static sizeMixedArray(P){let N=0;N+=1;for(let U=0,z=P.length;U<z;U++){const F=P[U];switch(N+=1,F.type){case 1:N+=this.sizeLongString(F.value);break;case 2:N+=this.sizeVSBuffer(F.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(F.value);for(let M=0;M<F.buffers.length;++M)N+=this.sizeVSBuffer(F.buffers[M]);break;case 4:break}}return N}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let N=0,U=P.length;N<U;N++){const z=P[N];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let F=0;F<z.buffers.length;++F)this.writeBuffer(z.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const N=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:N[U]=this.readLongString();break;case 2:N[U]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),M=this.readLongString(),T=[];for(let j=0;j<F;++j)T.push(this.readVSBuffer());N[U]=new L.$3v(o(M,T,null));break}case 4:N[U]=void 0;break}return N}}var b;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(b||(b={}));class D{static a(P){for(let N=0,U=P.length;N<U;N++)if(P[N]instanceof O.$qe||P[N]instanceof L.$3v||typeof P[N]>"u")return!0;return!1}static serializeRequestArguments(P,N){if(this.a(P)){const U=[];for(let z=0,F=P.length;z<F;z++){const M=P[z];if(M instanceof O.$qe)U[z]={type:2,value:M};else if(typeof M>"u")U[z]={type:4};else if(M instanceof L.$3v){const{jsonString:T,referencedBuffers:j}=m(M.value,N);U[z]={type:3,value:O.$qe.fromString(T),buffers:j}}else U[z]={type:1,value:O.$qe.fromString(i(M,N))}}return{type:1,args:U}}return{type:0,args:i(P,N)}}static serializeRequest(P,N,U,z,F){switch(z.type){case 0:return this.b(P,N,U,z.args,F);case 1:return this.c(P,N,U,z.args,F)}}static b(P,N,U,z,F){const M=O.$qe.fromString(U),T=O.$qe.fromString(z);let j=0;j+=h.sizeUInt8(),j+=h.sizeShortString(M),j+=h.sizeLongString(T);const J=h.alloc(F?2:1,P,j);return J.writeUInt8(N),J.writeShortString(M),J.writeLongString(T),J.buffer}static deserializeRequestJSONArgs(P){const N=P.readUInt8(),U=P.readShortString(),z=P.readLongString();return{rpcId:N,method:U,args:JSON.parse(z)}}static c(P,N,U,z,F){const M=O.$qe.fromString(U);let T=0;T+=h.sizeUInt8(),T+=h.sizeShortString(M),T+=h.sizeMixedArray(z);const j=h.alloc(F?4:3,P,T);return j.writeUInt8(N),j.writeShortString(M),j.writeMixedArray(z),j.buffer}static deserializeRequestMixedArgs(P){const N=P.readUInt8(),U=P.readShortString(),z=P.readMixedArray(),F=new Array(z.length);for(let M=0,T=z.length;M<T;M++){const j=z[M];typeof j=="string"?F[M]=JSON.parse(j):F[M]=j}return{rpcId:N,method:U,args:F}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,N,U){if(typeof N>"u")return this.d(P);if(N instanceof O.$qe)return this.e(P,N);if(N instanceof L.$3v){const{jsonString:z,referencedBuffers:F}=m(N.value,U,!0);return this.g(P,z,F)}else return this.f(P,w(N,U))}static d(P){return h.alloc(7,P,0).buffer}static e(P,N){let U=0;U+=h.sizeVSBuffer(N);const z=h.alloc(8,P,U);return z.writeVSBuffer(N),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,N){const U=O.$qe.fromString(N);let z=0;z+=h.sizeLongString(U);const F=h.alloc(9,P,z);return F.writeLongString(U),F.buffer}static g(P,N,U){const z=O.$qe.fromString(N);let F=0;F+=h.sizeUInt32,F+=h.sizeLongString(z);for(const T of U)F+=h.sizeVSBuffer(T);const M=h.alloc(10,P,F);M.writeUInt32(U.length),M.writeLongString(z);for(const T of U)M.writeBuffer(T);return M.buffer}static deserializeReplyOKJSON(P){const N=P.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(P,N){const U=P.readUInt32(),z=P.readLongString(),F=[];for(let M=0;M<U;++M)F.push(P.readVSBuffer());return new L.$3v(o(z,F,N))}static serializeReplyErr(P,N){const U=N?w(A.$3(N),null):void 0;if(typeof U!="string")return this.h(P);const z=O.$qe.fromString(U);let F=0;F+=h.sizeLongString(z);const M=h.alloc(11,P,F);return M.writeLongString(z),M.buffer}static deserializeReplyErrError(P){const N=P.readLongString();return JSON.parse(N)}static h(P){return h.alloc(12,P,0).buffer}}var g;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var f;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(f||(f={}))}),define(Ce[313],Ie([1,0,21,28,16,84,5]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0,e.$EJ=(0,R.$ci)("notebookDocumentService");const v=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${v.join("")}]+`),S=7;function L(E){if(E.scheme!==$.Schemas.vscodeNotebookCell)return;const k=E.fragment.indexOf("s");if(k<0)return;const u=parseInt(E.fragment.substring(0,k).replace(p,""),S),m=(0,I.$Je)(E.fragment.substring(k+1)).toString();if(!isNaN(u))return{handle:u,notebook:E.with({scheme:m,fragment:null})}}e.$FJ=L;function C(E,k){const u=k.toString(S),o=`${u.length<v.length?v[u.length-1]:"z"}${u}s${(0,I.$Ke)(I.$qe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:$.Schemas.vscodeNotebookCell,fragment:o})}e.$GJ=C;class w{constructor(){this.a=new O.$Ac}getNotebook(k){if(k.scheme===$.Schemas.vscodeNotebookCell){const u=L(k);if(u){const m=this.a.get(u.notebook);if(m)return m}}return this.a.get(k)}addNotebookDocument(k){this.a.set(k.uri,k)}removeNotebookDocument(k){this.a.delete(k.uri)}}e.$HJ=w,(0,A.$8r)(e.$EJ,w,1)}),define(Ce[118],Ie([1,0,21,35,53,100,16,17,11,45,313]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CellStatusbarAlignment=e.$VJ=e.$UJ=e.$TJ=e.NotebookEditorPriority=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.CellKind=e.$KJ=e.$JJ=e.$IJ=void 0,e.$IJ="workbench.editor.notebook",e.$JJ="workbench.editor.notebookTextDiffEditor",e.$KJ="workbench.editor.interactive";var C;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(C||(e.CellKind=C={})),e.$LJ=["application/json","application/javascript","text/html","image/svg+xml",A.$os.latex,A.$os.markdown,"image/png","image/jpeg",A.$os.text],e.$MJ=[A.$os.latex,A.$os.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$os.text],e.$NJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$OJ="_notAvailable";var w;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var E;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var k;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(k||(e.NotebookExecutionState=k={}));var u;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var m;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(j){j.scheme=R.Schemas.vscodeNotebookCell;function J(ie,fe){return(0,L.$GJ)(ie,fe)}j.generate=J;function ne(ie){return(0,L.$FJ)(ie)}j.parse=ne;function _(ie,fe){return ie.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${ie.scheme!==R.Schemas.file?ie.scheme:""}`})}j.generateCellOutputUri=_;function Z(ie){if(ie.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ie.fragment);if(!fe)return;const re=fe[1]&&fe[1]!==""?fe[1]:void 0,K=fe[2];return{outputId:re,notebook:ie.with({scheme:K||R.Schemas.file,fragment:null})}}j.parseCellOutputUri=Z;function Y(ie,fe,re){return j.generate(ie,fe).with({scheme:re})}j.generateCellPropertyUri=Y;function ce(ie,fe){if(ie.scheme===fe)return j.parse(ie.with({scheme:j.scheme}))}j.parseCellPropertyUri=ce})(r||(e.CellUri=r={}));const a=j=>p.$i?j.replace(/\//g,"\\"):j;class t{constructor(J=[],ne=e.$LJ){this.e=ne,this.d=[...new Set(J)].map(_=>({pattern:_,matches:O.$Vj(a(_))}))}sort(J){const ne=new Map($.Iterable.map(J,Z=>[Z,a(Z)]));let _=[];for(const{matches:Z}of this.d)for(const[Y,ce]of ne)if(Z(ce)){_.push(Y),ne.delete(Y);break}return ne.size&&(_=_.concat([...ne.keys()].sort((Z,Y)=>this.e.indexOf(Z)-this.e.indexOf(Y)))),_}prioritize(J,ne){const _=this.f(J);if(_===-1){this.d.unshift({pattern:J,matches:O.$Vj(a(J))});return}const Z=new Set(ne.map(ce=>this.f(ce,_)));Z.delete(-1);const Y=Array.from(Z).sort();this.d.splice(_+1,0,...Y.map(ce=>this.d[ce]));for(let ce=Y.length-1;ce>=0;ce--)this.d.splice(Y[ce],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ne=this.d.length){const _=a(J);for(let Z=0;Z<ne;Z++)if(this.d[Z].matches(_))return Z;return-1}}e.$PJ=t;function d(j,J,ne,_=(Z,Y)=>Z===Y){const Z=[];function Y(fe,re,K){if(re===0&&K.length===0)return;const B=Z[Z.length-1];B&&B.start+B.deleteCount===fe?(B.deleteCount+=re,B.toInsert.push(...K)):Z.push({start:fe,deleteCount:re,toInsert:K})}let ce=0,ie=0;for(;;){if(ce===j.length){Y(ce,0,J.slice(ie));break}if(ie===J.length){Y(ce,j.length-ce,[]);break}const fe=j[ce],re=J[ie];if(_(fe,re)){ce+=1,ie+=1;continue}ne(re)?(Y(ce,1,[]),ce+=1):(Y(ce,0,[re]),ie+=1)}return Z}e.$QJ=d,e.$RJ=new S.$tj("notebookEditorCursorAtBoundary","none"),e.$SJ=new S.$tj("notebookEditorCursorAtLineBoundary","none");var c;(function(j){j.default="default",j.option="option"})(c||(e.NotebookEditorPriority=c={}));function s(j){const J=j;return!!((typeof J.include=="string"||O.$Wj(J.include))&&(typeof J.exclude=="string"||O.$Wj(J.exclude)))}e.$TJ=s;function l(j,J,ne){if(Array.isArray(j.viewType)&&j.viewType.indexOf(J)>=0||j.viewType===J)return!0;if(j.filenamePattern){const _=s(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,Z=s(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(O.$Uj(_,(0,v.$nc)(ne.fsPath).toLowerCase()))return!(Z&&O.$Uj(Z,(0,v.$nc)(ne.fsPath).toLowerCase()))}return!1}e.$UJ=l,e.$VJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var h;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class b{static{this.d="notebook/"}static create(J){return`${b.d}${J}`}static parse(J){if(J.startsWith(b.d))return J.substring(b.d.length)}}e.$WJ=b;function D(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$XJ=D;const g=new TextDecoder;function f(j){const J=[];let ne=!1;for(const ce of j)(J.length===0||ne)&&(J.push(ce),ne=!0);let _=N(J);const Z=I.$qe.concat(J.map(ce=>I.$qe.wrap(ce))),Y=T(Z);return _=_||Y.byteLength!==Z.byteLength,{data:Y,didCompression:_}}e.$YJ=f,e.$ZJ="\x1B[A";const y=e.$ZJ.split("").map(j=>j.charCodeAt(0)),P=10;function N(j){let J=!1;return j.forEach((ne,_)=>{if(_===0||ne.length<e.$ZJ.length)return;const Z=j[_-1],Y=ne.subarray(0,e.$ZJ.length);if(Y[0]===y[0]&&Y[1]===y[1]&&Y[2]===y[2]){const ce=Z.lastIndexOf(P);if(ce===-1)return;J=!0,j[_-1]=Z.subarray(0,ce),j[_]=ne.subarray(e.$ZJ.length)}}),J}function U(j){let J=j;do j=J,J=j.replace(/[^\n]\x08/gm,"");while(J.length<j.length);return j}function z(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const J=j.match(/^(.*)\r+/m)[1];let ne=j.match(/\r+(.*)$/m)[1];ne=ne+J.slice(ne.length,J.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ne)}return j}const F=8,M=13;function T(j){return!j.buffer.includes(F)&&!j.buffer.includes(M)?j:I.$qe.fromString(z(U(g.decode(j.buffer))))}}),define(Ce[7],Ie([1,0,19,14,63,28,100,12,18,2,30,26,32,65,118]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";var u,m,o,i,n,r,a,t,d,c,s,l,h,b,D,g,f;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.ChatAgentResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TestRunProfileKind=e.TestResultState=e.$vN=e.$uN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$tN=e.NotebookVariablesRequestKind=e.$sN=e.$rN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$qN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.ColorThemeKind=e.$kN=e.$jN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$iN=e.$hN=e.DebugConsoleMode=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$bN=e.$aN=e.FileChangeType=e.$_M=e.NewSymbolNameTag=e.$$M=e.$0M=e.$9M=e.$8M=e.InlineCompletionTriggerKind=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.ConfigurationTarget=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$KM=e.ViewBadge=e.ProgressLocation=e.$JM=e.$IM=e.TaskScope=e.ShellQuoting=e.$HM=e.$GM=e.$FM=e.TaskPanelKind=e.TaskRevealKind=e.$EM=e.TerminalLocation=e.$DM=e.$CM=e.$BM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$AM=e.$zM=e.$yM=e.$xM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$wM=e.StatusBarAlignment=e.ViewColumn=e.$vM=e.$uM=e.$tM=e.$sM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$rM=e.$qM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.LanguageStatusSeverity=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.CodeActionTriggerKind=e.$eM=e.$dM=e.SymbolTag=e.SymbolKind=e.$cM=e.$bM=e.DocumentHighlightKind=e.$aM=e.$_L=e.$$L=e.$0L=e.DiagnosticSeverity=e.DiagnosticTag=e.$9L=e.$8L=e.FileEditType=e.$7L=e.$6L=e.$5L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(G){return Object.assign(G,{apply:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const Ne=we.length===1?[]:we[1];return Reflect.construct(G,Ne,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(G,[]);{const[Ne,...Xe]=we;return Reflect.construct(G,Xe,Ne.constructor)}}})}var P;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var N;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let U=u=class{static from(...q){let we=q;return new u(function(){if(we){for(const Ne of we)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$XL=U,e.$XL=U=u=Ke([y],U);let z=m=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Ne=1;Ne<q.length;Ne++){const Xe=q[Ne];Xe.isBefore(we)&&(we=Xe)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Ne=1;Ne<q.length;Ne++){const Xe=q[Ne];Xe.isAfter(we)&&(we=Xe)}return we}static isPosition(q){if(!q)return!1;if(q instanceof m)return!0;const{line:we,character:Ne}=q;return typeof we=="number"&&typeof Ne=="number"}static of(q){if(q instanceof m)return q;if(this.isPosition(q))return new m(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,O.$7)("line must be non-negative");if(we<0)throw(0,O.$7)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,O.$7)();let Ne;return typeof q>"u"?Ne=0:typeof q=="number"?Ne=q:(Ne=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Ne===0&&we===0?this:new m(this.line+Ne,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,O.$7)();let Ne;return typeof q>"u"?Ne=this.line:typeof q=="number"?Ne=q:(Ne=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Ne===this.line&&we===this.character?this:new m(Ne,we)}toJSON(){return{line:this.line,character:this.character}}};e.$YL=z,e.$YL=z=m=Ke([y],z);let F=o=class{static isRange(q){return q instanceof o?!0:q?z.isPosition(q.start)&&z.isPosition(q.end):!1}static of(q){if(q instanceof o)return q;if(this.isRange(q))return new o(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Ne,Xe){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(tt=new z(q,we),lt=new z(Ne,Xe)):z.isPosition(q)&&z.isPosition(we)&&(tt=z.of(q),lt=z.of(we)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(q){return o.isRange(q)?this.contains(q.start)&&this.contains(q.end):z.isPosition(q)?!(z.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=z.Max(q.start,this.c),Ne=z.Min(q.end,this.e);if(!we.isAfter(Ne))return new o(we,Ne)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=z.Min(q.start,this.c),Ne=z.Max(q.end,this.end);return new o(we,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,O.$7)();let Ne;return q?z.isPosition(q)?Ne=q:(Ne=q.start||this.start,we=q.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&we.isEqual(this.end)?this:new o(Ne,we)}toJSON(){return[this.start,this.end]}};e.$ZL=F,e.$ZL=F=o=Ke([y],F);let M=i=class extends F{static isSelection(q){return q instanceof i?!0:q?F.isRange(q)&&z.isPosition(q.anchor)&&z.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Ne,Xe){let tt,lt;if(typeof q=="number"&&typeof we=="number"&&typeof Ne=="number"&&typeof Xe=="number"?(tt=new z(q,we),lt=new z(Ne,Xe)):z.isPosition(q)&&z.isPosition(we)&&(tt=z.of(q),lt=z.of(we)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$1L=M,e.$1L=M=i=Ke([y],M);const T=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,O.$7)("connectionToken")};class j{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Ne){if(typeof q!="string"||q.length===0)throw(0,O.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,O.$7)("port");typeof Ne<"u"&&T(Ne),this.host=q,this.port=Math.round(we),this.connectionToken=Ne}}e.$2L=j;class J{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&T(we)}}e.$3L=J;class ne extends Error{static NotAvailable(q,we){return new ne(q,E.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new ne(q,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=E.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(q),this._message=q,this._code=we,this._detail=Ne,Object.setPrototypeOf(this,ne.prototype)}}e.$4L=ne;var _;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var Z;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let Y=n=class{static isTextEdit(q){return q instanceof n?!0:q?F.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new n(q,we)}static insert(q,we){return n.replace(new F(q,q),we)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const we=new n(new F(new z(0,0),new z(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!F.isRange(q))throw(0,O.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,O.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,O.$7)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$5L=Y,e.$5L=Y=n=Ke([y],Y);let ce=r=class{static isNotebookCellEdit(q){return q instanceof r?!0:q?di.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new r(q,we)}static insertCells(q,we){return new r(new di(q,q),we)}static deleteCells(q){return new r(q,[])}static updateCellMetadata(q,we){const Ne=new r(new di(q,q),[]);return Ne.newCellMetadata=we,Ne}static updateNotebookMetadata(q){const we=new r(new di(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$6L=ce,e.$6L=ce=r=Ke([y],ce);class ie{static isSnippetTextEdit(q){return q instanceof ie?!0:q?F.isRange(q.range)&&K.isSnippetString(q.snippet):!1}static replace(q,we){return new ie(q,we)}static insert(q,we){return ie.replace(new F(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$7L=ie;var fe;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Ne,Xe){this.c.push({_type:1,from:q,to:we,options:Ne,metadata:Xe})}createFile(q,we,Ne){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Ne})}deleteFile(q,we,Ne){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Ne})}e(q,we,Ne){this.c.push({_type:3,metadata:Ne,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Ne,Xe){const tt=we.start,lt=we.end;(tt!==lt||Ne.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:lt-tt,cells:Ne,metadata:Xe})}g(q,we,Ne,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:we,metadata:Ne}})}replace(q,we,Ne,Xe){this.c.push({_type:2,uri:q,edit:new Y(we,Ne),metadata:Xe})}insert(q,we,Ne,Xe){this.replace(q,new F(we,we),Ne,Xe)}delete(q,we,Ne){this.replace(q,we,"",Ne)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Ne of we){if(!Ne)continue;let Xe,tt;Array.isArray(Ne)?(Xe=Ne[0],tt=Ne[1]):Xe=Ne,ce.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,tt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,tt):this.f(q,Xe.range,Xe.newCells,tt):ie.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:tt})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Xe=this.c[Ne];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Ne]=void 0);break}}(0,I.$Ib)(this.c)}}get(q){const we=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===q.toString()&&we.push(Ne.edit);return we}entries(){const q=new A.$Ac;for(const we of this.c)if(we._type===2){let Ne=q.get(we.uri);Ne||(Ne=[we.uri,[]],q.set(we.uri,Ne)),Ne[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$8L=re,e.$8L=re=Ke([y],re);let K=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Ne=new a;Ne.e=this.e,q(Ne),this.e=Ne.e,q=Ne.value}else q=a.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Ne=q.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Ne=new a;Ne.e=this.e,we(Ne),this.e=Ne.e,we=Ne.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$9L=K,e.$9L=K=a=Ke([y],K);var B;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ae;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ae||(e.DiagnosticSeverity=ae={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?F.isRange(q.range)&&S.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(F.isRange(we))this.range=F.of(we);else if(z.isPosition(we))this.range=new F(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$0L=ye,e.$0L=ye=t=Ke([y],ye);let le=class{static is(q){return q?typeof q.message=="string"&&q.location&&F.isRange(q.location.range)&&S.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$$L=le,e.$$L=le=Ke([y],le);let de=class{constructor(q,we,Ne=ae.Error){if(!F.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Ne}toJSON(){return{severity:ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,I.$ub)(q.tags,we.tags)&&(0,I.$ub)(q.relatedInformation,we.relatedInformation,le.isEqual)}};e.$_L=de,e.$_L=de=Ke([y],de);let ue=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$aM=ue,e.$aM=ue=Ke([y],ue);var ge;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let V=class{constructor(q,we=ge.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$bM=V,e.$bM=V=Ke([y],V);let X=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$cM=X,e.$cM=X=Ke([y],X);var he;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var be;(function(G){G[G.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Pe=d=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Ne,Xe,tt){this.name=q,this.kind=we,this.containerName=tt,typeof Ne=="string"&&(this.containerName=Ne),Xe instanceof ye?this.location=Xe:Ne instanceof F&&(this.location=new ye(Xe,Ne)),d.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$dM=Pe,e.$dM=Pe=d=Ke([y],Pe);let pe=c=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(c.validate)}constructor(q,we,Ne,Xe,tt){this.name=q,this.detail=we,this.kind=Ne,this.range=Xe,this.selectionRange=tt,this.children=[],c.validate(this)}};e.$eM=pe,e.$eM=pe=c=Ke([y],pe);var Ae;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ae||(e.CodeActionTriggerKind=Ae={}));let Fe=class{constructor(q,we){this.title=q,this.kind=we}};e.$fM=Fe,e.$fM=Fe=Ke([y],Fe);let W=class{static{s=this}static{this.c="."}constructor(q){this.value=q}append(q){return new s(this.value?this.value+s.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+s.c)}};e.$gM=W,e.$gM=W=s=Ke([y],W),W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorMove=W.Refactor.append("move"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll"),W.Notebook=W.Empty.append("notebook");let x=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$hM=x,e.$hM=x=Ke([y],x);class H{constructor(q,we,Ne,Xe,tt,lt){this.kind=q,this.name=we,this.detail=Ne,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$iM=H;class Q{constructor(q,we){this.fromRanges=we,this.from=q}}e.$jM=Q;class oe{constructor(q,we){this.fromRanges=we,this.to=q}}e.$kM=oe;var ve;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(ve||(e.LanguageStatusSeverity=ve={}));let Le=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$lM=Le,e.$lM=Le=Ke([y],Le);let qe=l=class{#e;static isMarkdownString(q){return q instanceof l?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new $.$qk(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$mM=qe,e.$mM=qe=l=Ke([y],qe);let Ge=class{constructor(q,we){this.label=q,this.documentation=we}};e.$nM=Ge,e.$nM=Ge=Ke([y],Ge);let Ye=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$oM=Ye,e.$oM=Ye=Ke([y],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$pM=it,e.$pM=it=Ke([y],it);var ut;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(ut||(e.SignatureHelpTriggerKind=ut={}));var ot;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(ot||(e.InlayHintKind=ot={}));let et=class{constructor(q){this.value=q}};e.$qM=et,e.$qM=et=Ke([y],et);let Re=class{constructor(q,we,Ne){this.position=q,this.label=we,this.kind=Ne}};e.$rM=Re,e.$rM=Re=Ke([y],Re);var ke;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ke||(e.CompletionTriggerKind=ke={}));var He;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(He||(e.CompletionItemKind=He={}));var ee;(function(G){G[G.Deprecated=1]="Deprecated"})(ee||(e.CompletionItemTag=ee={}));let se=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&He[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$sM=se,e.$sM=se=Ke([y],se);let Se=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$tM=Se,e.$tM=Se=Ke([y],Se);let Ve=class{constructor(q,we,Ne){this.insertText=q,this.range=we,this.command=Ne}};e.$uM=Ve,e.$uM=Ve=Ke([y],Ve);let Ze=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$vM=Ze,e.$vM=Ze=Ke([y],Ze);var nt;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var rt;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function je(G,q){return`${C.$um.toKey(G)}.${q}`}e.$wM=je;var Et;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(Et||(e.TextEditorLineNumbersStyle=Et={}));var St;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(St||(e.TextDocumentSaveReason=St={}));var jt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var Lt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var Dt;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(Dt||(e.TextDocumentChangeReason=Dt={}));var ei;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(ei||(e.DecorationRangeBehavior=ei={})),function(G){function q(we){switch(we){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=q}(Lt||(e.TextEditorSelectionChangeKind=Lt={}));var Wt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(G){function q(we){switch(we){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=q}(Wt||(e.SyntaxTokenType=Wt={}));let si=class{constructor(q,we){if(we&&!S.URI.isUri(we))throw(0,O.$7)("target");if(!F.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.target=we}};e.$xM=si,e.$xM=si=Ke([y],si);let xt=class{constructor(q,we,Ne,Xe){this.red=q,this.green=we,this.blue=Ne,this.alpha=Xe}};e.$yM=xt,e.$yM=xt=Ke([y],xt);let _t=class{constructor(q,we){if(we&&!(we instanceof xt))throw(0,O.$7)("color");if(!F.isRange(q)||q.isEmpty)throw(0,O.$7)("range");this.range=q,this.color=we}};e.$zM=_t,e.$zM=_t=Ke([y],_t);let _e=class{constructor(q){if(!q||typeof q!="string")throw(0,O.$7)("label");this.label=q}};e.$AM=_e,e.$AM=_e=Ke([y],_e);var qt;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var ti;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var dt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class $t{constructor(q,we,Ne){if(this.startIndex=q,this.length=we,this.tooltip=Ne,typeof q!="number"||q<0)throw(0,O.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,O.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,O.$7)("tooltip")}}e.$BM=$t;class Qt{constructor(q){this.uri=q}}e.$CM=Qt;class ii{constructor(q){this.terminalCommand=q}}e.$DM=ii;var Rt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(Rt||(e.TerminalLocation=Rt={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,O.$7)("options")}}e.$EM=ft;var Ft;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(Ft||(e.TaskRevealKind=Ft={}));var oi;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Ot=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(q){switch(q){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,O.$7)("name");this.c=q}get id(){return this.c}};e.$FM=Ot,e.$FM=Ot=h=Ke([y],Ot);function Je(G){let q="";for(let we=0;we<G.length;we++)q+=G[we].replace(/,/g,",,")+",";return q}let Ut=class{constructor(q,we,Ne){if(typeof q!="string")throw(0,O.$7)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Ne):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,O.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Je(q)}};e.$GM=Ut,e.$GM=Ut=Ke([y],Ut);let Vt=class{constructor(q,we,Ne){if(this.f=[],Array.isArray(we)){if(!q)throw(0,O.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q,this.f=we,this.g=Ne}else{if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,O.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,O.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Je(q)}};e.$HM=Vt,e.$HM=Vt=Ke([y],Vt);var ni;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var gt;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Nt{constructor(q){this.c=q}computeId(){return"customExecution"+(0,L.$yg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$IM=Nt;let At=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Ne,Xe,tt,lt){this.k=!1,this.l=this.definition=q;let mt;typeof we=="string"?(this.o=this.name=we,this.w=this.source=Ne,this.execution=Xe,mt=tt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=tt,mt=lt):(this.target=we,this.o=this.name=Ne,this.w=this.source=Xe,this.execution=tt,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ut?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Vt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof Nt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,L.$yg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,O.$7)("Kind can't be undefined or null");this.B(),this.l=q}get scope(){return this.m}set target(q){this.B(),this.m=q}get name(){return this.o}set name(q){if(typeof q!="string")throw(0,O.$7)("name");this.B(),this.o=q}get execution(){return this.q}set execution(q){q===null&&(q=void 0),this.B(),this.q=q;const we=this.l.type;(b.g===we||b.e===we||b.f===we||b.c===we)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(q){if(Array.isArray(q))this.B(),this.r=q,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.B(),this.u=q}get source(){return this.w}set source(q){if(typeof q!="string"||q.length===0)throw(0,O.$7)("source must be a string of length > 0");this.B(),this.w=q}get group(){return this.x}set group(q){q===null&&(q=void 0),this.B(),this.x=q}get detail(){return this.A}set detail(q){q===null&&(q=void 0),this.A=q}get presentationOptions(){return this.y}set presentationOptions(q){q==null&&(q=Object.create(null)),this.B(),this.y=q}get runOptions(){return this.z}set runOptions(q){q==null&&(q=Object.create(null)),this.B(),this.z=q}};e.$JM=At,e.$JM=At=b=Ke([y],At);var Bt;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(Bt||(e.ProgressLocation=Bt={}));var Ht;(function(G){function q(we){const Ne=we;return(0,p.$Uf)(Ne.value)?Ne.tooltip&&!(0,p.$Qf)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}G.isViewBadge=q})(Ht||(e.ViewBadge=Ht={}));let Gt=D=class{static isTreeItem(q,we){const Ne=q;if(Ne.checkboxState!==void 0){const Xe=(0,p.$Uf)(Ne.checkboxState)?Ne.checkboxState:(0,p.$Sf)(Ne.checkboxState)&&(0,p.$Uf)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,tt=!(0,p.$Uf)(Ne.checkboxState)&&(0,p.$Sf)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Zt.Checked&&Xe!==Zt.Unchecked||tt!==void 0&&!(0,p.$Qf)(tt))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(q instanceof D)return!0;if(Ne.label!==void 0&&!(0,p.$Qf)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,p.$Qf)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,p.$Qf)(Ne.iconPath)&&!S.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,p.$Qf)(Ne.iconPath.id))){const Xe=Ne.iconPath;if(!Xe||!(0,p.$Qf)(Xe.light)&&!S.URI.isUri(Xe.light)&&!(0,p.$Qf)(Xe.dark)&&!S.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,p.$Qf)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!S.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,p.$Qf)(Ne.tooltip)&&!(Ne.tooltip instanceof qe)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<It.None&&Ne.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,p.$Qf)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(q,we=It.None){this.collapsibleState=we,S.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$KM=Gt,e.$KM=Gt=D=Ke([y],Gt);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var Zt;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(Zt||(e.TreeItemCheckboxState=Zt={}));let kt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$LM=kt,e.$LM=kt=Ke([y],kt);class pt extends kt{}e.$MM=pt;class Pt extends pt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$NM=Pt;class Ct{constructor(q,we,Ne,Xe){this.name=q,this.uri=we,this._itemId=Ne,this.c=Xe}data(){return this.c()}}e.$OM=Ct;let ci=class{#e=new Map;constructor(q){for(const[we,Ne]of q??[]){const Xe=this.#e.get(this.#t(we));Xe?Xe.push(Ne):this.#e.set(this.#t(we),[Ne])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Ne,Xe]of this.#e)for(const tt of Xe)q.call(we,tt,Ne,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Ne of we)yield[q,Ne]}#t(q){return q.toLowerCase()}};e.$PM=ci,e.$PM=ci=Ke([y],ci);let Xt=class{constructor(q){this.insertText=q}};e.$QM=Xt,e.$QM=Xt=Ke([y],Xt);let bi=class{constructor(q,we){this.label=we,this.insertText=q}};e.$RM=bi,e.$RM=bi=Ke([y],bi);let Kt=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$SM=Kt,e.$SM=Kt=Ke([y],Kt),Kt.File=new Kt("file"),Kt.Folder=new Kt("folder");let Me=class{constructor(q){this.id=q}};e.$TM=Me,e.$TM=Me=Ke([y],Me);var Te;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Te||(e.ConfigurationTarget=Te={}));let De=class{get base(){return this.c}set base(q){this.c=q,this.e=S.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!S.URI.isUri(q)&&!S.URI.isUri(q.uri)))throw(0,O.$7)("base");if(typeof we!="string")throw(0,O.$7)("pattern");typeof q=="string"?this.baseUri=S.URI.file(q):S.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$UM=De,e.$UM=De=Ke([y],De);const te=new WeakMap;function Oe(G,q){te.set(G,q)}e.$VM=Oe;let Be=class{constructor(q,we,Ne,Xe,tt){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Xe=="string"&&(this.logMessage=Xe),typeof tt=="string"&&(this.mode=tt)}get id(){return this.c||(this.c=te.get(this)??(0,L.$yg)()),this.c}};e.$WM=Be,e.$WM=Be=Ke([y],Be);let xe=class extends Be{constructor(q,we,Ne,Xe,tt,lt){if(super(we,Ne,Xe,tt,lt),q===null)throw(0,O.$7)("location");this.location=q}};e.$XM=xe,e.$XM=xe=Ke([y],xe);let Qe=class extends Be{constructor(q,we,Ne,Xe,tt,lt){super(we,Ne,Xe,tt,lt),this.functionName=q}};e.$YM=Qe,e.$YM=Qe=Ke([y],Qe);let at=class extends Be{constructor(q,we,Ne,Xe,tt,lt,mt,Jt){if(super(Xe,tt,lt,mt,Jt),!we)throw(0,O.$7)("dataId");this.label=q,this.dataId=we,this.canPersist=Ne}};e.$ZM=at,e.$ZM=at=Ke([y],at);let vt=class{constructor(q,we,Ne){this.command=q,this.args=we||[],this.options=Ne}};e.$1M=vt,e.$1M=vt=Ke([y],vt);let yt=class{constructor(q,we){this.port=q,this.host=we}};e.$2M=yt,e.$2M=yt=Ke([y],yt);let Yt=class{constructor(q){this.path=q}};e.$3M=Yt,e.$3M=Yt=Ke([y],Yt);let Mt=class{constructor(q){this.implementation=q}};e.$4M=Mt,e.$4M=Mt=Ke([y],Mt);let zt=class{constructor(q,we,Ne){this.session=q,this.threadId=we,this.frameId=Ne}};e.$5M=zt,e.$5M=zt=Ke([y],zt);let wi=class{constructor(q,we){this.session=q,this.threadId=we}};e.$6M=wi,e.$6M=wi=Ke([y],wi);let ht=class{constructor(q,we){this.range=q,this.expression=we}};e.$7M=ht,e.$7M=ht=Ke([y],ht);var Xi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Xi||(e.InlineCompletionTriggerKind=Xi={}));let ui=class{constructor(q,we){this.range=q,this.text=we}};e.$8M=ui,e.$8M=ui=Ke([y],ui);let gi=class{constructor(q,we,Ne=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Ne}};e.$9M=gi,e.$9M=gi=Ke([y],gi);let yi=class{constructor(q,we){this.range=q,this.expression=we}};e.$0M=yi,e.$0M=yi=Ke([y],yi);let Ai=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$$M=Ai,e.$$M=Ai=Ke([y],Ai);var Yi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));class hn{constructor(q,we){this.newSymbolName=q,this.tags=we}}e.$_M=hn;var Ri;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(Ri||(e.FileChangeType=Ri={}));let Li=g=class extends Error{static FileExists(q){return new g(q,w.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(q){return new g(q,w.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(q){return new g(q,w.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(q){return new g(q,w.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(q){return new g(q,w.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(q){return new g(q,w.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(q,we=w.FileSystemProviderErrorCode.Unknown,Ne){super(S.URI.isUri(q)?q.toString(!0):q),this.code=Ne?.name??"Unknown",(0,w.$Ok)(this,we),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$aN=Li,e.$aN=Li=g=Ke([y],Li);let Ei=class{constructor(q,we,Ne){this.start=q,this.end=we,this.kind=Ne}};e.$bN=Ei,e.$bN=Ei=Ke([y],Ei);var mi;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(mi||(e.FoldingRangeKind=mi={}));var xi;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var ki;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(ki||(e.CommentMode=ki={}));var Si;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Si||(e.CommentState=Si={}));var _i;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class dn{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$cN=dn;function pi(G){return typeof G>"u"||(0,p.$Rf)(G)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Ne=q.tokenTypes.length;we<Ne;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Ne=q.tokenModifiers.length;we<Ne;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Ne,Xe,tt){if(typeof q=="number"&&typeof we=="number"&&typeof Ne=="number"&&typeof Xe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.q(q,we,Ne,Xe,tt);if(F.isRange(q)&&typeof we=="string"&&pi(Ne))return this.o(q,we,Ne);throw(0,O.$7)()}o(q,we,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,tt=q.start.character,lt=q.end.character-q.start.character,mt=this.k.get(we);let Jt=0;if(Ne)for(const ai of Ne){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Jt|=1<<hi>>>0}this.q(Xe,tt,lt,mt,Jt)}q(q,we,Ne,Xe,tt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Jt;fi++){let $i=this.g[5*fi],Qi=this.g[5*fi+1];$i===0?($i=ai,Qi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Qi,ai=$i,hi=Qi}}let lt=q,mt=we;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Ne,this.g[this.j++]=Xe,this.g[this.j++]=tt,this.c=q,this.e=we}static r(q){const we=[],Ne=q.length/5|0;for(let mt=0;mt<Ne;mt++)we[mt]=mt;we.sort((mt,Jt)=>{const ai=q[5*mt],hi=q[5*Jt];if(ai===hi){const fi=q[5*mt+1],$i=q[5*Jt+1];return fi-$i}return ai-hi});const Xe=new Uint32Array(q.length);let tt=0,lt=0;for(let mt=0;mt<Ne;mt++){const Jt=5*we[mt],ai=q[Jt+0],hi=q[Jt+1],fi=q[Jt+2],$i=q[Jt+3],Qi=q[Jt+4],In=ai-tt,Yn=In===0?hi-lt:hi,Zi=5*mt;Xe[Zi+0]=In,Xe[Zi+1]=Yn,Xe[Zi+2]=fi,Xe[Zi+3]=$i,Xe[Zi+4]=Qi,tt=ai,lt=hi}return Xe}build(q){return this.f?new Fi(new Uint32Array(this.g),q):new Fi(Mi.r(this.g),q)}}e.$dN=Mi;class Fi{constructor(q,we){this.resultId=we,this.data=q}}e.$eN=Fi;class fn{constructor(q,we,Ne){this.start=q,this.deleteCount=we,this.data=Ne}}e.$fN=fn;class Di{constructor(q,we){this.resultId=we,this.edits=q}}e.$gN=Di;var en;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class gn{constructor(q){this.name=q}}e.$hN=gn;let vi=class{static{this.Back={iconPath:new Kt("arrow-left")}}constructor(){}};e.$iN=vi,e.$iN=vi=Ke([y],vi);var Oi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var tn;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Ni;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(Ni||(e.ExtensionKind=Ni={}));class nn{static validate(q){if(typeof q.badge=="string"){let we=(0,v.$rf)(q.badge,0);if(we<q.badge.length&&(we+=(0,v.$rf)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Kt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Ne){this.badge=q,this.tooltip=we,this.color=Ne}}e.$jN=nn;let Ti=class{constructor(q){this.kind=q}};e.$kN=Ti,e.$kN=Ti=Ke([y],Ti);var rn;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class di{static isNotebookRange(q){return q instanceof di?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,O.$7)("start must be positive");if(we<0)throw(0,O.$7)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Ne=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Ne=q.end),we===this.c&&Ne===this.e?this:new di(we,Ne)}}e.$lN=di;class Ci{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>Ci.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Ne,Xe,tt,lt,mt){this.kind=q,this.value=we,this.languageId=Ne,this.mime=Xe,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,Ci.validate(this)}}e.$mN=Ci;class ji{constructor(q){this.cells=q}}e.$nN=ji;class ri{static isNotebookCellOutputItem(q){return q instanceof ri?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return ri.json(we,"application/vnd.code.notebook.error")}static stdout(q){return ri.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return ri.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new ri(q,we)}static#e=new TextEncoder;static text(q,we=R.$os.text){const Ne=ri.#e.encode(String(q));return new ri(Ne,we)}static json(q,we="text/x-json"){const Ne=JSON.stringify(q,void 0,"	");return ri.text(Ne,we)}constructor(q,we){this.data=q,this.mime=we;const Ne=(0,R.$ss)(we,!0);if(!Ne)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$oN=ri;class ze{static isNotebookCellOutput(q){return q instanceof ze?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Ne=new Set,Xe=new Set;for(let tt=0;tt<q.length;tt++){const lt=q[tt],mt=(0,R.$ss)(lt.mime);if(!Ne.has(mt)||(0,k.$XJ)(mt)){Ne.add(mt);continue}Xe.add(tt),we&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?q:q.filter((tt,lt)=>!Xe.has(lt))}constructor(q,we,Ne){this.items=ze.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Ne):(this.id=(0,L.$yg)(),this.metadata=we??Ne)}}e.$pN=ze;var li;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var zi;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var st;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(st||(e.NotebookCellStatusBarAlignment=st={}));var bt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(bt||(e.NotebookEditorRevealType=bt={}));class mn{constructor(q,we){this.text=q,this.alignment=we}}e.$qN=mn;var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var Ui;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(Ui||(e.NotebookControllerAffinity2=Ui={}));class $n{constructor(q,we=[]){this.uri=q,this.provides=(0,I.$3b)(we)}}e.$rN=$n;class Ii{constructor(q){this.label=q}}e.$sN=Ii;var on;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$tN=Bi,e.$tN=Bi=Ke([y],Bi);var an;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Wi;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(Wi||(e.ExtensionRuntime=Wi={}));var cn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class bn{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$uN=bn;class wn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$vN=wn;var un;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let qi=class{constructor(q=void 0,we=void 0,Ne=void 0,Xe=!1){this.include=q,this.exclude=we,this.profile=Ne,this.continuous=Xe}};e.$wN=qi,e.$wN=qi=Ke([y],qi);let Vi=f=class{static diff(q,we,Ne){const Xe=new f(q);return Xe.expectedOutput=we,Xe.actualOutput=Ne,Xe}constructor(q){this.message=q}};e.$xN=Vi,e.$xN=Vi=f=Ke([y],Vi);let Hi=class{constructor(q){this.id=q}};e.$yN=Hi,e.$yN=Hi=Ke([y],Hi);class Pi{constructor(q,we){this.covered=q,this.total=we}}e.$zN=Pi;const Gi=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class Ki{static fromDetails(q,we){const Ne=new Pi(0,0),Xe=new Pi(0,0),tt=new Pi(0,0);for(const mt of we)if("branches"in mt){Ne.total+=1,Ne.covered+=mt.executed?1:0;for(const Jt of mt.branches)Xe.total+=1,Xe.covered+=Jt.executed?1:0}else tt.total+=1,tt.covered+=mt.executed?1:0;const lt=new Ki(q,Ne,Xe.total>0?Xe:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=we,lt}constructor(q,we,Ne,Xe){this.uri=q,this.statementCoverage=we,this.branchCoverage=Ne,this.declarationCoverage=Xe,Gi(we),Gi(Ne),Gi(Xe)}}e.$AN=Ki;class $e{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Ne=[]){this.executed=q,this.location=we,this.branches=Ne}}e.$BN=$e;class Ee{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Ne){this.executed=q,this.location=we,this.label=Ne}}e.$CN=Ee;class Ue{get executionCount(){return+this.executed}set executionCount(q){this.executed=q}constructor(q,we,Ne){this.name=q,this.executed=we,this.location=Ne}}e.$DN=Ue;var ct;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(ct||(e.ExternalUriOpenerPriority=ct={}));var wt;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(wt||(e.WorkspaceTrustState=wt={}));var Tt;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tt||(e.PortAutoForwardAction=Tt={}));class Ji{constructor(q,we,Ne,Xe,tt,lt){this.kind=q,this.name=we,this.detail=Ne,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$EN=Ji;class Pn{constructor(q){this.uri=q}}e.$FN=Pn;class An{constructor(q,we){this.original=q,this.modified=we}}e.$GN=An;class Rn{constructor(q,we,Ne,Xe){this.base=q,this.input1=we,this.input2=Ne,this.result=Xe}}e.$HN=Rn;class Ln{constructor(q,we){this.uri=q,this.viewType=we}}e.$IN=Ln;class Mn{constructor(q){this.viewType=q}}e.$JN=Mn;class Fn{constructor(q,we){this.uri=q,this.notebookType=we}}e.$KN=Fn;class On{constructor(q,we,Ne){this.original=q,this.modified=we,this.notebookType=Ne}}e.$LN=On;class Nn{constructor(){}}e.$MN=Nn;class Tn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$NN=Tn;class jn{constructor(q){this.providerId=q}}e.$ON=jn;var pn;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(vn||(e.ChatAgentCopyKind=vn={}));var yn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class zn{constructor(q,we){this.label=q,this.values=we}}e.$PN=zn;var En;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var kn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));class Un{constructor(q){this.value=q}}e.$QN=Un;class Bn{constructor(q){this.value=typeof q=="string"?new qe(q):q}}e.$RN=Bn;class Wn{constructor(q,we){this.value=q,this.baseUri=we}}e.$SN=Wn;class qn{constructor(q,we){this.value=q,this.title=we}}e.$TN=qn;class Vn{constructor(q){this.value=q}}e.$UN=Vn;class Hn{constructor(q){this.value=q}}e.$VN=Hn;class Gn{constructor(q){this.value=q}}e.$WN=Gn;class Kn{constructor(q,we,Ne,Xe){this.prompt=q,this.command=we,this.variables=Ne,this.agent=Xe}}e.$XN=Kn;class Jn{constructor(q,we,Ne){this.response=q,this.result=we,this.agent=Ne}}e.$YN=Jn;class Qn{constructor(q){this.content=q}}e.$ZN=Qn;class Zn{constructor(q,we){this.content=q,this.name=we}}e.$1N=Zn;class Xn{constructor(q){this.content=q}}e.$2N=Xn;var Sn;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(Ce[314],Ie([1,0,6,7]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class ${constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$VL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,v,p){if(this.a.size===0)throw new Error("No related information providers registered");const S=this.a.get(R);if(!S)throw new Error("related information provider not found");return await S.provideRelatedInformation(v,p)??[]}getRelatedInformation(R,v,p){return this.c.$getAiRelatedInformation(v,p)}registerRelatedInformationProvider(R,v,p){const S=this.b;return this.b++,this.a.set(S,p),this.c.$registerAiRelatedInformationProvider(S,v),new O.$XL(()=>{this.c.$unregisterAiRelatedInformationProvider(S),this.a.delete(S)})}}e.$5gc=$}),define(Ce[315],Ie([1,0,4,6,7,26,142]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class v{constructor(L){this.b=new Map,this.c=new I.$3d,this.onDidChangeSessions=this.c.event,this.d=new p,this.f=new p,this.a=L.getProxy(O.$VL.MainThreadAuthentication)}async getSession(L,C,w,E={}){const k=A.$um.toKey(L.identifier),u=[...w].sort().join(" ");return await this.d.getOrCreate(`${k} ${C} ${u}`,async()=>{await this.a.$ensureProvider(C);const m=L.displayName||L.name;return this.a.$getSession(C,w,k,m,E)})}async getSessions(L,C,w){const E=A.$um.toKey(L.identifier),k=[...w].sort().join(" ");return await this.f.getOrCreate(`${E} ${k}`,async()=>{await this.a.$ensureProvider(C);const u=L.displayName||L.name;return this.a.$getSessions(C,w,E,u)})}async removeSession(L,C){const w=this.b.get(L);return w?w.provider.removeSession(C):this.a.$removeSession(L,C)}registerAuthenticationProvider(L,C,w,E){if(this.b.get(L))throw new Error(`An authentication provider with id '${L}' is already registered.`);this.b.set(L,{label:C,provider:w,options:E??{supportsMultipleAccounts:!1}});const k=w.onDidChangeSessions(u=>this.a.$sendDidChangeSessions(L,u));return this.a.$registerAuthenticationProvider(L,C,E?.supportsMultipleAccounts??!1),new $.$XL(()=>{k.dispose(),this.b.delete(L),this.a.$unregisterAuthenticationProvider(L)})}$createSession(L,C,w){const E=this.b.get(L);if(E)return Promise.resolve(E.provider.createSession(C,w));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$removeSession(L,C){const w=this.b.get(L);if(w)return Promise.resolve(w.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$getSessions(L,C){const w=this.b.get(L);if(w)return Promise.resolve(w.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${L}`)}$onDidChangeAuthenticationSessions(L,C){return L.startsWith(R.$2K)||this.c.fire({provider:{id:L,label:C}}),Promise.resolve()}}e.$dhc=v;class p{constructor(){this.a=new Map}getOrCreate(L,C){const w=this.a.get(L);if(w)return w;const E=C().finally(()=>this.a.delete(L));return this.a.set(L,E),E}}}),define(Ce[148],Ie([1,0,2,6,7,5,20,13,19,12,17,25]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;let E=class{static{w=this}static{this.c=0}static{this.d=250}constructor(u,m){this.h=m,this.f=new Map,this.g=u.getProxy(O.$VL.MainThreadDecorations)}registerFileDecorationProvider(u,m){const o=w.c++;this.f.set(o,{provider:u,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,p.$3b)(n);if(r.length<=w.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const a=r.map(c=>({uri:c,rank:(0,S.$We)(c.path,"/")})),t=(0,p.$zb)(a,(c,s)=>c.rank-s.rank||(0,S.$af)(c.uri.path,s.uri.path)),d=[];e:for(const c of t){let s;for(const l of c){const h=(0,L.$mc)(l.uri.path);if(s!==h&&(s=h,d.push(l.uri)>=w.d))break e}}this.g.$onDidChange(o,d)});return new $.$XL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(u,m,o){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(u);return await Promise.all(m.map(async a=>{try{const{uri:t,id:d}=a,c=await Promise.resolve(n.provideFileDecoration(I.URI.revive(t),o));if(!c)return;try{$.$jN.validate(c),c.badge&&typeof c.badge!="string"&&(0,C.$SF)(r,"codiconDecoration"),i[d]=[c.propagate,c.tooltip,c.badge,c.color]}catch(s){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${s}`)}}catch(t){this.h.error(t)}})),i}};e.$cic=E,e.$cic=E=w=Ke([We(0,R.$aO),We(1,v.$wj)],E),e.$dic=(0,A.$ci)("IExtHostDecorations")}),define(Ce[316],Ie([1,0,14,2,7,6,16,22,12]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class S{static{this.a=0}constructor(C,w,E){this.d=w,this.e=E,this.b=new Map,this.c=C.getProxy(A.$VL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,w){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const E=S.a++;this.b.set(E,w),this.c.$registerTextContentProvider(E,C);let k;if(typeof w.onDidChange=="function"){let u;k=w.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;u&&await u;const o=this.$provideTextDocumentContent(E,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const r=(0,p.$7e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(m,i)}).catch(I.$1).finally(()=>{u===o&&(u=void 0)});u=o})}return new $.$XL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),k&&(k.dispose(),k=void 0)})}$provideTextDocumentContent(C,w){const E=this.b.get(C);return E?Promise.resolve(E.provideTextDocumentContent(O.URI.revive(w),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$fic=S}),define(Ce[149],Ie([1,0,61,16,12,177,126,7,19]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=e.$dO=e.$cO=void 0;const S=new Map;function L(k,u){u?S.set(k,u):S.delete(k)}e.$cO=L;function C(k){return S.get(k)}class w extends A.$uv{constructor(u,m,o,i,n,r,a,t){super(m,o,i,n),this.c=u,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,I.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,p.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===O.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(m){return m?u.s(m):u.getText()},get eol(){return u.g===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(m){return u.t(m)},offsetAt(m){return u.u(m)},positionAt(m){return u.v(m)},validateRange(m){return u.w(m)},validatePosition(m){return u.x(m)},getWordRangeAtPosition(m,o){return u.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,I.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,I.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const m=this.w(u);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,i=m.start.line,n=m.end.line,r=[];r.push(this.f[i].substring(m.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,m.end.character)),r.join(o)}t(u){let m;if(u instanceof v.$YL?m=u.line:typeof u=="number"&&(m=u),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const m=this.j.getIndexOf(u),o=this.f[m.index].length;return new v.$YL(m.index,Math.min(m.remainder,o))}w(u){if(!(u instanceof v.$ZL))throw new Error("Invalid argument");const m=this.x(u.start),o=this.x(u.end);return m===u.start&&o===u.end?u:new v.$ZL(m.line,m.character,o.line,o.character)}x(u){if(!(u instanceof v.$YL))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:m,character:o}=u,i=!1;if(m<0)m=0,o=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,i=!0;else{const n=this.f[m].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new v.$YL(m,o):u}y(u,m){const o=this.x(u);if(!m)m=C(this.m);else if((0,$.$6e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,R.$Gs)(o.character+1,(0,R.$Es)(m),this.f[o.line],0);if(i)return new v.$ZL(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$dO=w;class E{constructor(u,m,o){this.a=u,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new v.$ZL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new v.$ZL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eO=E}),define(Ce[317],Ie([1,0,6,7]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;class ${constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(I.$VL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,v,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const S=this.a.get(R);if(!S)throw new Error("Embedding vector provider not found");const L=await S.provideEmbeddingVector(v,p);if(!L)throw new Error("Embedding vector provider returned undefined");return L}registerEmbeddingVectorProvider(R,v,p){const S=this.b;return this.b++,this.a.set(S,p),this.c.$registerAiEmbeddingVectorProvider(v,S),new O.$XL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(S),this.a.delete(S)})}}e.$hic=$}),define(Ce[70],Ie([1,0,6,32,7,21,5,20,59,3,8,23,16]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;let k=E=class{constructor(m,o){this.b=new Map,this.c=new L.$lh,this.a=m.getProxy(I.$VL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===O.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return E.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return E.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return E.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$qe.wrap(r))}catch(a){return E.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return E.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return E.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return E.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(m,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await m.stat(i)).type&O.FileType.Directory))throw $.$aN.FileExists(`Unable to create folder '${i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(O.$Pk(r)!==O.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await m.createDirectory(i)}catch(a){if(O.$Pk(a)!==O.FileSystemProviderErrorCode.FileExists)throw a}}}static e(m){if(m instanceof $.$aN)throw m;if(m instanceof O.$Lk)switch(m.code){case O.FileSystemProviderErrorCode.FileExists:throw $.$aN.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw $.$aN.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw $.$aN.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw $.$aN.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw $.$aN.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw $.$aN.Unavailable(m.message);default:throw new $.$aN(m.message,m.name)}if(!(m instanceof Error))throw new $.$aN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw $.$aN.Unavailable(m.message);switch(m.name){case O.FileSystemProviderErrorCode.FileExists:throw $.$aN.FileExists(m.message);case O.FileSystemProviderErrorCode.FileNotFound:throw $.$aN.FileNotFound(m.message);case O.FileSystemProviderErrorCode.FileNotADirectory:throw $.$aN.FileNotADirectory(m.message);case O.FileSystemProviderErrorCode.FileIsADirectory:throw $.$aN.FileIsADirectory(m.message);case O.FileSystemProviderErrorCode.NoPermissions:throw $.$aN.NoPermissions(m.message);case O.FileSystemProviderErrorCode.Unavailable:throw $.$aN.Unavailable(m.message);default:throw new $.$aN(m.message,m.name)}}addFileSystemProvider(m,o,i){return this.b.set(m,{impl:o,extUri:i?.isCaseSensitive?C.$Fg:C.$Hg,isReadonly:!!i?.isReadonly}),(0,S.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$Fg}};e.$uhc=k,e.$uhc=k=E=Ke([We(0,v.$aO),We(1,p.$0gc)],k),e.$vhc=(0,R.$ci)("IExtHostConsumerFileSystem")}),define(Ce[318],Ie([1,0,6,7]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class ${constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(I.$VL.MainThreadIssueReporter)}async $getIssueReporterUri(R,v){if(this.a.size===0)throw new Error("No issue request handlers registered");const p=this.a.get(R);if(!p)throw new Error("Issue request handler not found");const S=await p.handleIssueUrlRequest();if(!S)throw new Error("Issue request handler returned no result");return S}async $getIssueReporterData(R,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(R);if(!p)throw new Error("Issue data provider not found");const S=await p.provideIssueData(v);if(!S)throw new Error("Issue data provider returned no result");return S}async $getIssueReporterTemplate(R,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(R);if(!p)throw new Error("Issue data provider not found");const S=await p.provideIssueTemplate(v);if(!S)throw new Error("Issue template provider returned no result");return S}registerIssueUriRequestHandler(R,v){const p=R.identifier.value;return this.a.set(p,v),this.c.$registerIssueUriRequestHandler(p),new O.$XL(()=>{this.c.$unregisterIssueUriRequestHandler(p),this.a.delete(p)})}registerIssueDataProvider(R,v){const p=R.identifier.value;return this.b.set(p,v),this.c.$registerIssueDataProvider(p),new O.$XL(()=>{this.c.$unregisterIssueDataProvider(p),this.b.delete(p)})}}e.$yic=$}),define(Ce[93],Ie([1,0,5,27,13,70,2]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,I.$ci)("IExtensionStoragePaths");let v=class{constructor(S,L,C){this.d=L,this.f=C,this.a=S.workspace??void 0,this.b=S.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(S){return R.URI.joinPath(this.b.workspaceStorageHome,S)}async h(){if(!this.a)return Promise.resolve(void 0);const S=this.a.id,L=await this.g(S);try{return await this.f.value.stat(L),this.d.trace("[ExtHostStorage] storage dir already exists",L),L}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",L),await this.f.value.createDirectory(L),await this.f.value.writeFile(R.URI.joinPath(L,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),L}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(S){if(this.c)return R.URI.joinPath(this.c,S.identifier.value)}globalValue(S){return R.URI.joinPath(this.b.globalStorageHome,S.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xhc=v,e.$xhc=v=Ke([We(0,O.$qO),We(1,$.$wj),We(2,A.$vhc)],v)}),define(Ce[319],Ie([1,0,7,20,4]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let A=class{constructor(v){this.a=new I.$kN(I.ColorThemeKind.Dark),this.b=new $.$3d}get activeColorTheme(){return this.a}$onColorThemeChange(v){let p;switch(v){case"light":p=I.ColorThemeKind.Light;break;case"hcDark":p=I.ColorThemeKind.HighContrast;break;case"hcLight":p=I.ColorThemeKind.HighContrastLight;break;default:p=I.ColorThemeKind.Dark}this.a=new I.$kN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2ic=A,e.$2ic=A=Ke([We(0,O.$aO)],A)}),define(Ce[71],Ie([1,0,22,4,3,222,5,13,88,6,27,20,7]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Szb=e.$Rzb=e.TunnelDtoConverter=void 0;class E extends p.$Sv{}var k;(function(m){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(k||(e.TunnelDtoConverter=k={})),e.$Rzb=(0,R.$ci)("IExtHostTunnelService");let u=class extends $.$Tc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new O.$3d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(S.$VL.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new w.$XL(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const c of o){const s=this.r.get(c);if(!s)return[];t.push(...await Promise.all(i.map(async l=>{let h;try{h=await s.provider.providePortAttributes({port:l,pid:n,commandLine:r},a)}catch{h=await s.provider.providePortAttributes(l,n,r,a)}return{providedAttributes:h,port:l}})))}const d=t.filter(c=>!!c.providedAttributes);return d.length>0?d.map(c=>({autoForwardAction:c.providedAttributes.autoForwardAction,port:c.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await o.provideTunnel(r,a,new I.$ae().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,$.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,$.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),k.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$Szb=u,e.$Szb=u=Ke([We(0,C.$aO),We(1,L.$qO),We(2,v.$wj)],u)}),define(Ce[15],Ie([1,0,19,21,166,75,63,28,161,56,100,24,23,18,2,29,83,135,141,139,118,68,89,292,25,7]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$_N=e.$$N=e.MarkdownString=e.$0N=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var l;(function(Me){function Te(te){const{selectionStartLineNumber:Oe,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Qe}=te,at=new s.$YL(Oe-1,Be-1),vt=new s.$YL(xe-1,Qe-1);return new s.$1L(at,vt)}Me.to=Te;function De(te){const{anchor:Oe,active:Be}=te;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Me.from=De})(l||(e.Selection=l={}));var h;(function(Me){function Te(te){if(!te)return;const{start:Oe,end:Be}=te;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Me.from=Te;function De(te){if(!te)return;const{startLineNumber:Oe,startColumn:Be,endLineNumber:xe,endColumn:Qe}=te;return new s.$ZL(Oe-1,Be-1,xe-1,Qe-1)}Me.to=De})(h||(e.Range=h={}));var b;(function(Me){function Te(te){return{uri:te.uri,range:h.from(te.range)}}Me.from=Te;function De(te){return new s.$0L(k.URI.revive(te.uri),h.to(te.range))}Me.to=De})(b||(e.Location=b={}));var D;(function(Me){function Te(De){switch(De){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Te})(D||(e.TokenType=D={}));var g;(function(Me){function Te(te){return new s.$YL(te.lineNumber-1,te.column-1)}Me.to=Te;function De(te){return{lineNumber:te.line+1,column:te.character+1}}Me.from=De})(g||(e.Position=g={}));var f;(function(Me){function Te(Oe,Be,xe){return(0,I.$Hb)((0,I.$3b)(Oe).map(Qe=>De(Qe,Be,xe)))}Me.from=Te;function De(Oe,Be,xe){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:xe?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:te(Oe.scheme,Be),pattern:Se.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:xe?.isBuiltin}}function te(Oe,Be){return Be&&typeof Oe=="string"?Be.transformOutgoingScheme(Oe):Oe}})(f||(e.DocumentSelector=f={}));var y;(function(Me){function Te(te){switch(te){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function De(te){switch(te){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=De})(y||(e.DiagnosticTag=y={}));var P;(function(Me){function Te(te){let Oe;return te.code&&((0,E.$Qf)(te.code)||(0,E.$Uf)(te.code)?Oe=String(te.code):Oe={value:String(te.code.value),target:te.code.target}),{...h.from(te.range),message:te.message,source:te.source,code:Oe,severity:U.from(te.severity),relatedInformation:te.relatedInformation&&te.relatedInformation.map(N.from),tags:Array.isArray(te.tags)?(0,I.$Hb)(te.tags.map(y.from)):void 0}}Me.from=Te;function De(te){const Oe=new s.$_L(h.to(te),te.message,U.to(te.severity));return Oe.source=te.source,Oe.code=(0,E.$Qf)(te.code)?te.code:te.code?.value,Oe.relatedInformation=te.relatedInformation&&te.relatedInformation.map(N.to),Oe.tags=te.tags&&(0,I.$Hb)(te.tags.map(y.to)),Oe}Me.to=De})(P||(e.Diagnostic=P={}));var N;(function(Me){function Te(te){return{...h.from(te.location.range),message:te.message,resource:te.location.uri}}Me.from=Te;function De(te){return new s.$$L(new s.$0L(te.resource,h.to(te)),te.message)}Me.to=De})(N||(e.DiagnosticRelatedInformation=N={}));var U;(function(Me){function Te(te){switch(te){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Me.from=Te;function De(te){switch(te){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=De})(U||(e.DiagnosticSeverity=U={}));var z;(function(Me){function Te(te){return typeof te=="number"&&te>=s.ViewColumn.One?te-1:te===s.ViewColumn.Beside?d.$nD:d.$mD}Me.from=Te;function De(te){if(typeof te=="number"&&te>=0)return te+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(z||(e.ViewColumn=z={}));function F(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!F(Me[0])}e.$0N=M;var T;(function(Me){function Te(Qe){return Qe.map(Me.from)}Me.fromMany=Te;function De(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function te(Qe){let at;if(De(Qe)){const{language:Mt,value:zt}=Qe;at={value:"```"+Mt+`
`+zt+"\n```\n"}}else s.$mM.isMarkdownString(Qe)?at={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?at={value:Qe}:at={value:""};const vt=Object.create(null);at.uris=vt;const yt=Mt=>{try{let zt=k.URI.parse(Mt,!0);zt=zt.with({query:Oe(zt.query,vt)}),vt[Mt]=zt}catch{}return""},Yt=new p.marked.Renderer;return Yt.link=yt,Yt.image=Mt=>typeof Mt=="string"?yt(R.$yk(Mt).href):"",(0,p.marked)(at.value,{renderer:Yt}),at}Me.from=te;function Oe(Qe,at){if(!Qe)return Qe;let vt;try{vt=(0,S.$Kh)(Qe)}catch{}if(!vt)return Qe;let yt=!1;return vt=(0,C.$Hn)(vt,Yt=>{if(k.URI.isUri(Yt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return at[Mt]=Yt,yt=!0,Mt}else return}),yt?JSON.stringify(vt):Qe}function Be(Qe){const at=new s.$mM(Qe.value,Qe.supportThemeIcons);return at.isTrusted=Qe.isTrusted,at.supportHtml=Qe.supportHtml,at.baseUri=Qe.baseUri?k.URI.from(Qe.baseUri):void 0,at}Me.to=Be;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(T||(e.MarkdownString=T={}));function j(Me){return M(Me)?Me.map(Te=>({range:h.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?T.fromMany(Te.hoverMessage):Te.hoverMessage?T.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:h.from(Te)}))}e.$$N=j;function J(Me){return typeof Me>"u"?Me:typeof Me=="string"?k.URI.file(Me):Me}e.$_N=J;var ne;(function(Me){function Te(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?J(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Te})(ne||(e.ThemableDecorationAttachmentRenderOptions=ne={}));var _;(function(Me){function Te(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?J(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?ne.from(De.before):void 0,after:De.after?ne.from(De.after):void 0}}Me.from=Te})(_||(e.ThemableDecorationRenderOptions=_={}));var Z;(function(Me){function Te(De){if(typeof De>"u")return De;switch(De){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(Z||(e.DecorationRangeBehavior=Z={}));var Y;(function(Me){function Te(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?Z.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?_.from(De.light):void 0,dark:De.dark?_.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?J(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?ne.from(De.before):void 0,after:De.after?ne.from(De.after):void 0}}Me.from=Te})(Y||(e.DecorationRenderOptions=Y={}));var ce;(function(Me){function Te(te){return{text:te.newText,eol:te.newEol&&Re.from(te.newEol),range:h.from(te.range)}}Me.from=Te;function De(te){const Oe=new s.$5L(h.to(te.range),te.text);return Oe.newEol=typeof te.eol>"u"?void 0:Re.to(te.eol),Oe}Me.to=De})(ce||(e.TextEdit=ce={}));var ie;(function(Me){function Te(te,Oe){const Be={edits:[]};if(te instanceof s.$8L){const xe=new v.$Bc;for(const Qe of te._allEntries())Qe._type===1&&k.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of te._allEntries())if(Qe._type===1){let at;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?at={type:"base64",value:(0,O.$Ke)(O.$qe.wrap(Qe.options.contents))}:at={type:"dataTransferItem",id:Qe.options.contents._itemId}),Be.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:at},metadata:Qe.metadata})}else Qe._type===2?Be.edits.push({resource:Qe.uri,textEdit:ce.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?Be.edits.push({resource:Qe.uri,textEdit:{range:h.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Oe?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&Be.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(jt.from)}})}return Be}Me.from=Te;function De(te){const Oe=new s.$8L,Be=new v.$Ac;for(const xe of te.edits)if(xe.textEdit){const Qe=xe,at=k.URI.revive(Qe.resource),vt=h.to(Qe.textEdit.range),yt=Qe.textEdit.text,Yt=Qe.textEdit.insertAsSnippet;let Mt;Yt?Mt=s.$7L.replace(vt,new s.$9L(yt)):Mt=s.$5L.replace(vt,yt);const zt=Be.get(at);zt?zt.push(Mt):Be.set(at,[Mt])}else Oe.renameFile(k.URI.revive(xe.oldResource),k.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of Be)Oe.set(xe,Qe);return Oe}Me.to=De})(ie||(e.WorkspaceEdit=ie={}));var fe;(function(Me){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function De(Oe){return typeof Te[Oe]=="number"?Te[Oe]:6}Me.from=De;function te(Oe){for(const Be in Te)if(Te[Be]===Oe)return Number(Be);return s.SymbolKind.Property}Me.to=te})(fe||(e.SymbolKind=fe={}));var re;(function(Me){function Te(te){switch(te){case s.SymbolTag.Deprecated:return 1}}Me.from=Te;function De(te){switch(te){case 1:return s.SymbolTag.Deprecated}}Me.to=De})(re||(e.SymbolTag=re={}));var K;(function(Me){function Te(te){return{name:te.name,kind:fe.from(te.kind),tags:te.tags&&te.tags.map(re.from),containerName:te.containerName,location:de.from(te.location)}}Me.from=Te;function De(te){const Oe=new s.$dM(te.name,fe.to(te.kind),te.containerName,de.to(te.location));return Oe.tags=te.tags&&te.tags.map(re.to),Oe}Me.to=De})(K||(e.WorkspaceSymbol=K={}));var B;(function(Me){function Te(te){const Oe={name:te.name||"!!MISSING: name!!",detail:te.detail,range:h.from(te.range),selectionRange:h.from(te.selectionRange),kind:fe.from(te.kind),tags:te.tags?.map(re.from)??[]};return te.children&&(Oe.children=te.children.map(Te)),Oe}Me.from=Te;function De(te){const Oe=new s.$eM(te.name,te.detail,fe.to(te.kind),h.to(te.range),h.to(te.selectionRange));return(0,I.$Lb)(te.tags)&&(Oe.tags=te.tags.map(re.to)),te.children&&(Oe.children=te.children.map(De)),Oe}Me.to=De})(B||(e.DocumentSymbol=B={}));var ae;(function(Me){function Te(te){const Oe=new s.$iM(fe.to(te.kind),te.name,te.detail||"",k.URI.revive(te.uri),h.to(te.range),h.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Me.to=Te;function De(te,Oe,Be){if(Oe=Oe??te._sessionId,Be=Be??te._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,name:te.name,detail:te.detail,kind:fe.from(te.kind),uri:te.uri,range:h.from(te.range),selectionRange:h.from(te.selectionRange),tags:te.tags?.map(re.from)}}Me.from=De})(ae||(e.CallHierarchyItem=ae={}));var ye;(function(Me){function Te(De){return new s.$jM(ae.to(De.from),De.fromRanges.map(te=>h.to(te)))}Me.to=Te})(ye||(e.CallHierarchyIncomingCall=ye={}));var le;(function(Me){function Te(De){return new s.$kM(ae.to(De.to),De.fromRanges.map(te=>h.to(te)))}Me.to=Te})(le||(e.CallHierarchyOutgoingCall=le={}));var de;(function(Me){function Te(te){return{range:te.range&&h.from(te.range),uri:te.uri}}Me.from=Te;function De(te){return new s.$0L(k.URI.revive(te.uri),h.to(te.range))}Me.to=De})(de||(e.location=de={}));var ue;(function(Me){function Te(te){const Oe=te,Be=te;return{originSelectionRange:Oe.originSelectionRange?h.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:Be.uri,range:h.from(Oe.targetRange?Oe.targetRange:Be.range),targetSelectionRange:Oe.targetSelectionRange?h.from(Oe.targetSelectionRange):void 0}}Me.from=Te;function De(te){return{targetUri:k.URI.revive(te.uri),targetRange:h.to(te.range),targetSelectionRange:te.targetSelectionRange?h.to(te.targetSelectionRange):void 0,originSelectionRange:te.originSelectionRange?h.to(te.originSelectionRange):void 0}}Me.to=De})(ue||(e.DefinitionLink=ue={}));var ge;(function(Me){function Te(te){return{range:h.from(te.range),contents:T.fromMany(te.contents)}}Me.from=Te;function De(te){return new s.$aM(te.contents.map(T.to),h.to(te.range))}Me.to=De})(ge||(e.Hover=ge={}));var V;(function(Me){function Te(te){return{range:h.from(te.range),expression:te.expression}}Me.from=Te;function De(te){return new s.$7M(h.to(te.range),te.expression)}Me.to=De})(V||(e.EvaluatableExpression=V={}));var X;(function(Me){function Te(te){if(te instanceof s.$8M)return{type:"text",range:h.from(te.range),text:te.text};if(te instanceof s.$9M)return{type:"variable",range:h.from(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};if(te instanceof s.$0M)return{type:"expression",range:h.from(te.range),expression:te.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function De(te){switch(te.type){case"text":return{range:h.to(te.range),text:te.text};case"variable":return{range:h.to(te.range),variableName:te.variableName,caseSensitiveLookup:te.caseSensitiveLookup};case"expression":return{range:h.to(te.range),expression:te.expression}}}Me.to=De})(X||(e.InlineValue=X={}));var he;(function(Me){function Te(te){return{frameId:te.frameId,stoppedLocation:h.from(te.stoppedLocation)}}Me.from=Te;function De(te){return new s.$$M(te.frameId,h.to(te.stoppedLocation))}Me.to=De})(he||(e.InlineValueContext=he={}));var be;(function(Me){function Te(te){return{range:h.from(te.range),kind:te.kind}}Me.from=Te;function De(te){return new s.$bM(h.to(te.range),te.kind)}Me.to=De})(be||(e.DocumentHighlight=be={}));var Pe;(function(Me){function Te(te){return{uri:te.uri,highlights:te.highlights.map(be.from)}}Me.from=Te;function De(te){return new s.$cM(k.URI.revive(te.uri),te.highlights.map(be.to))}Me.to=De})(Pe||(e.MultiDocumentHighlight=Pe={}));var pe;(function(Me){function Te(De){switch(De){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Te})(pe||(e.CompletionTriggerKind=pe={}));var Ae;(function(Me){function Te(De){return{triggerKind:pe.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Te})(Ae||(e.CompletionContext=Ae={}));var Fe;(function(Me){function Te(te){switch(te){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function De(te){switch(te){case 1:return s.CompletionItemTag.Deprecated}}Me.to=De})(Fe||(e.CompletionItemTag=Fe={}));var W;(function(Me){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function De(Be){return Te.get(Be)??9}Me.from=De;const te=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Oe(Be){return te.get(Be)??s.CompletionItemKind.Property}Me.to=Oe})(W||(e.CompletionItemKind=W={}));var x;(function(Me){function Te(De,te){const Oe=new s.$sM(De.label);return Oe.insertText=De.insertText,Oe.kind=W.to(De.kind),Oe.tags=De.tags?.map(Fe.to),Oe.detail=De.detail,Oe.documentation=R.$sk(De.documentation)?T.to(De.documentation):De.documentation,Oe.sortText=De.sortText,Oe.filterText=De.filterText,Oe.preselect=De.preselect,Oe.commitCharacters=De.commitCharacters,u.$4s.isIRange(De.range)?Oe.range=h.to(De.range):typeof De.range=="object"&&(Oe.range={inserting:h.to(De.range.insert),replacing:h.to(De.range.replace)}),Oe.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Oe.insertText=new s.$9L(De.insertText):(Oe.insertText=De.insertText,Oe.textEdit=Oe.range instanceof s.$ZL?new s.$5L(Oe.range,Oe.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Oe.additionalTextEdits=De.additionalTextEdits.map(Be=>ce.to(Be))),Oe.command=te&&De.command?te.fromInternal(De.command):void 0,Oe}Me.to=Te})(x||(e.CompletionItem=x={}));var H;(function(Me){function Te(te){if(typeof te.label!="string"&&!Array.isArray(te.label))throw new TypeError("Invalid label");return{label:te.label,documentation:T.fromStrict(te.documentation)}}Me.from=Te;function De(te){return{label:te.label,documentation:R.$sk(te.documentation)?T.to(te.documentation):te.documentation}}Me.to=De})(H||(e.ParameterInformation=H={}));var Q;(function(Me){function Te(te){return{label:te.label,documentation:T.fromStrict(te.documentation),parameters:Array.isArray(te.parameters)?te.parameters.map(H.from):[],activeParameter:te.activeParameter}}Me.from=Te;function De(te){return{label:te.label,documentation:R.$sk(te.documentation)?T.to(te.documentation):te.documentation,parameters:Array.isArray(te.parameters)?te.parameters.map(H.to):[],activeParameter:te.activeParameter}}Me.to=De})(Q||(e.SignatureInformation=Q={}));var oe;(function(Me){function Te(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.from):[]}}Me.from=Te;function De(te){return{activeSignature:te.activeSignature,activeParameter:te.activeParameter,signatures:Array.isArray(te.signatures)?te.signatures.map(Q.to):[]}}Me.to=De})(oe||(e.SignatureHelp=oe={}));var ve;(function(Me){function Te(De,te){const Oe=new s.$rM(g.to(te.position),typeof te.label=="string"?te.label:te.label.map(Le.to.bind(void 0,De)),te.kind&&qe.to(te.kind));return Oe.textEdits=te.textEdits&&te.textEdits.map(ce.to),Oe.tooltip=R.$sk(te.tooltip)?T.to(te.tooltip):te.tooltip,Oe.paddingLeft=te.paddingLeft,Oe.paddingRight=te.paddingRight,Oe}Me.to=Te})(ve||(e.InlayHint=ve={}));var Le;(function(Me){function Te(De,te){const Oe=new s.$qM(te.label);return Oe.tooltip=R.$sk(te.tooltip)?T.to(te.tooltip):te.tooltip,m.Command.is(te.command)&&(Oe.command=De.fromInternal(te.command)),te.location&&(Oe.location=de.to(te.location)),Oe}Me.to=Te})(Le||(e.InlayHintLabelPart=Le={}));var qe;(function(Me){function Te(te){return te}Me.from=Te;function De(te){return te}Me.to=De})(qe||(e.InlayHintKind=qe={}));var Ge;(function(Me){function Te(te){return{range:h.from(te.range),url:te.target,tooltip:te.tooltip}}Me.from=Te;function De(te){let Oe;if(te.url)try{Oe=typeof te.url=="string"?k.URI.parse(te.url,!0):k.URI.revive(te.url)}catch{}return new s.$xM(h.to(te.range),Oe)}Me.to=De})(Ge||(e.DocumentLink=Ge={}));var Ye;(function(Me){function Te(te){const Oe=new s.$AM(te.label);return te.textEdit&&(Oe.textEdit=ce.to(te.textEdit)),te.additionalTextEdits&&(Oe.additionalTextEdits=te.additionalTextEdits.map(Be=>ce.to(Be))),Oe}Me.to=Te;function De(te){return{label:te.label,textEdit:te.textEdit?ce.from(te.textEdit):void 0,additionalTextEdits:te.additionalTextEdits?te.additionalTextEdits.map(Oe=>ce.from(Oe)):void 0}}Me.from=De})(Ye||(e.ColorPresentation=Ye={}));var it;(function(Me){function Te(te){return new s.$yM(te[0],te[1],te[2],te[3])}Me.to=Te;function De(te){return[te.red,te.green,te.blue,te.alpha]}Me.from=De})(it||(e.Color=it={}));var ut;(function(Me){function Te(te){return{range:h.from(te.range)}}Me.from=Te;function De(te){return new s.$hM(h.to(te.range))}Me.to=De})(ut||(e.SelectionRange=ut={}));var ot;(function(Me){function Te(De){switch(De){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Te})(ot||(e.TextDocumentSaveReason=ot={}));var et;(function(Me){function Te(te){switch(te){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function De(te){switch(te){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=De})(et||(e.TextEditorLineNumbersStyle=et={}));var Re;(function(Me){function Te(te){if(te===s.EndOfLine.CRLF)return 1;if(te===s.EndOfLine.LF)return 0}Me.from=Te;function De(te){if(te===1)return s.EndOfLine.CRLF;if(te===0)return s.EndOfLine.LF}Me.to=De})(Re||(e.EndOfLine=Re={}));var ke;(function(Me){function Te(De){if(typeof De=="object")return De.viewId;switch(De){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(ke||(e.ProgressLocation=ke={}));var He;(function(Me){function Te(te){const Oe={start:te.start+1,end:te.end+1};return te.kind&&(Oe.kind=ee.from(te.kind)),Oe}Me.from=Te;function De(te){const Oe={start:te.start-1,end:te.end-1};return te.kind&&(Oe.kind=ee.to(te.kind)),Oe}Me.to=De})(He||(e.FoldingRange=He={}));var ee;(function(Me){function Te(te){if(te)switch(te){case s.FoldingRangeKind.Comment:return m.$Tt.Comment;case s.FoldingRangeKind.Imports:return m.$Tt.Imports;case s.FoldingRangeKind.Region:return m.$Tt.Region}}Me.from=Te;function De(te){if(te)switch(te.value){case m.$Tt.Comment.value:return s.FoldingRangeKind.Comment;case m.$Tt.Imports.value:return s.FoldingRangeKind.Imports;case m.$Tt.Region.value:return s.FoldingRangeKind.Region}}Me.to=De})(ee||(e.FoldingRangeKind=ee={}));var se;(function(Me){function Te(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?h.from(De.selection):void 0,override:typeof De.override=="boolean"?n.$PE.id:void 0}}Me.from=Te})(se||(e.TextEditorOpenOptions=se={}));var Se;(function(Me){function Te(Be){return Be instanceof s.$UM?Be.toJSON():typeof Be=="string"?Be:De(Be)||te(Be)?new s.$UM(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Me.from=Te;function De(Be){const xe=Be;return xe?k.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function te(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Oe(Be){return typeof Be=="string"?Be:new s.$UM(k.URI.revive(Be.baseUri),Be.pattern)}Me.to=Oe})(Se||(e.GlobPattern=Se={}));var Ve;(function(Me){function Te(De){if(De){if(Array.isArray(De))return De.map(Te);if(typeof De=="string")return De;{const te=De;return{language:te.language,scheme:te.scheme,pattern:Se.from(te.pattern),exclusive:te.exclusive,notebookType:te.notebookType}}}else return}Me.from=Te})(Ve||(e.LanguageSelector=Ve={}));var Ze;(function(Me){function Te(te){return!!te&&typeof te=="object"&&"documents"in te&&Array.isArray(te.documents)&&te.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&k.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof s.$ZL)))}Me.is=Te;function De(te){return{documents:te.documents.map(Oe=>Oe.map(Be=>({uri:k.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>h.from(xe))})))}}Me.from=De})(Ze||(e.MappedEditsContext=Ze={}));var nt;(function(Me){function Te(te){return{start:te.start,end:te.end}}Me.from=Te;function De(te){return new s.$lN(te.start,te.end)}Me.to=De})(nt||(e.NotebookRange=nt={}));var rt;(function(Me){function Te(te){return{timing:typeof te.runStartTime=="number"&&typeof te.runEndTime=="number"?{startTime:te.runStartTime,endTime:te.runEndTime}:void 0,executionOrder:te.executionOrder,success:te.lastRunSuccess}}Me.to=Te;function De(te){return{lastRunSuccess:te.success,runStartTime:te.timing?.startTime,runEndTime:te.timing?.endTime,executionOrder:te.executionOrder}}Me.from=De})(rt||(e.NotebookCellExecutionSummary=rt={}));var je;(function(Me){function Te(De){if(De===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(De===r.NotebookCellExecutionState.Pending)return;if(De===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Te})(je||(e.NotebookCellExecutionState=je={}));var Et;(function(Me){function Te(te){switch(te){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Me.from=Te;function De(te){switch(te){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=De})(Et||(e.NotebookCellKind=Et={}));var St;(function(Me){function Te(te){const Oe={metadata:te.metadata??Object.create(null),cells:[]};for(const Be of te.cells)s.$mN.validate(Be),Oe.cells.push(jt.from(Be));return Oe}Me.from=Te;function De(te){const Oe=new s.$nN(te.cells.map(jt.to));return(0,E.$4f)(te.metadata)||(Oe.metadata=te.metadata),Oe}Me.to=De})(St||(e.NotebookData=St={}));var jt;(function(Me){function Te(te){return{cellKind:Et.from(te.kind),language:te.languageId,mime:te.mime,source:te.value,metadata:te.metadata,internalMetadata:rt.from(te.executionSummary??{}),outputs:te.outputs?te.outputs.map(Dt.from):[]}}Me.from=Te;function De(te){return new s.$mN(Et.to(te.cellKind),te.source,te.language,te.mime,te.outputs?te.outputs.map(Dt.to):void 0,te.metadata,te.internalMetadata?rt.to(te.internalMetadata):void 0)}Me.to=De})(jt||(e.NotebookCellData=jt={}));var Lt;(function(Me){function Te(te){return{mime:te.mime,valueBytes:O.$qe.wrap(te.data)}}Me.from=Te;function De(te){return new s.$oN(te.valueBytes.buffer,te.mime)}Me.to=De})(Lt||(e.NotebookCellOutputItem=Lt={}));var Dt;(function(Me){function Te(te){return{outputId:te.id,items:te.items.map(Lt.from),metadata:te.metadata}}Me.from=Te;function De(te){const Oe=te.items.map(Lt.to);return new s.$pN(Oe,te.outputId,te.metadata)}Me.to=De})(Dt||(e.NotebookCellOutput=Dt={}));var ei;(function(Me){function Te(Oe){return te(Oe)?{include:Se.from(Oe.include)??void 0,exclude:Se.from(Oe.exclude)??void 0}:Se.from(Oe)??void 0}Me.from=Te;function De(Oe){return te(Oe)?{include:Se.to(Oe.include),exclude:Se.to(Oe.exclude)}:Se.to(Oe)}Me.to=De;function te(Oe){const Be=Oe;return Be?!(0,E.$Zf)(Be.include)&&!(0,E.$Zf)(Be.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var Wt;(function(Me){function Te(De,te,Oe){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:te.toInternal(Be,Oe),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Te})(Wt||(e.NotebookStatusBarItem=Wt={}));var si;(function(Me){function Te(De,te,Oe){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:te.toInternal(Be,Oe),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Te})(si||(e.NotebookKernelSourceAction=si={}));var xt;(function(Me){function Te(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Te})(xt||(e.NotebookDocumentContentOptions=xt={}));var _t;(function(Me){function Te(te){return{uri:te.uri,provides:te.provides}}Me.from=Te;function De(te){return new s.$rN(k.URI.revive(te.uri),te.provides)}Me.to=De})(_t||(e.NotebookRendererScript=_t={}));var _e;(function(Me){function Te(te){return{message:T.fromStrict(te.message)||"",type:0,expected:te.expectedOutput,actual:te.actualOutput,contextValue:te.contextValue,location:te.location&&{range:h.from(te.location.range),uri:te.location.uri}}}Me.from=Te;function De(te){const Oe=new s.$xN(typeof te.message=="string"?te.message:T.to(te.message));return Oe.actualOutput=te.actual,Oe.expectedOutput=te.expected,Oe.contextValue=te.contextValue,Oe.location=te.location?de.to(te.location):void 0,Oe}Me.to=De})(_e||(e.TestMessage=_e={}));var qt;(function(Me){Me.namespace=t.$QK,Me.denamespace=t.$RK})(qt||(e.TestTag=qt={}));var ti;(function(Me){function Te(te){const Oe=(0,i.$9N)(te).controllerId;return{extId:a.$MK.fromExtHostTestItem(te,Oe).toString(),label:te.label,uri:k.URI.revive(te.uri),busy:te.busy,tags:te.tags.map(Be=>qt.namespace(Oe,Be.id)),range:u.$4s.lift(h.from(te.range)),description:te.description||null,sortText:te.sortText||null,error:te.error&&T.fromStrict(te.error)||null}}Me.from=Te;function De(te){return{parent:void 0,error:void 0,id:a.$MK.fromString(te.extId).localId,label:te.label,uri:k.URI.revive(te.uri),tags:(te.tags||[]).map(Oe=>{const{tagId:Be}=qt.denamespace(Oe);return new s.$yN(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(te.range||void 0),canResolveChildren:!1,busy:te.busy,description:te.description||void 0,sortText:te.sortText||void 0}}Me.toPlain=De})(ti||(e.TestItem=ti={})),function(Me){function Te(te){return{id:te.id}}Me.from=Te;function De(te){return new s.$yN(te.id)}Me.to=De}(qt||(e.TestTag=qt={}));var dt;(function(Me){const Te=(te,Oe)=>{const Be=[];for(const[Qe,at]of Oe)a.$MK.compare(at.item.extId,Qe)===2&&(Oe.delete(Qe),Be.push(at));const xe={...ti.toPlain(te.item),parent:void 0,taskStates:te.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(at=>at.type===0).map(_e.to)})),children:Be.map(Qe=>Te(Qe,Oe))};for(const Qe of xe.children)Qe.parent=xe;return xe};function De(te){const Oe=[],Be=new Map;for(const xe of te.items){Be.set(xe.item.extId,xe);const Qe=a.$MK.root(xe.item.extId);te.request.targets.some(at=>at.controllerId===Qe&&at.testIds.includes(xe.item.extId))&&Oe.push(xe)}return{completedAt:te.completedAt,results:Oe.map(xe=>Te(xe,Be))}}Me.to=De})(dt||(e.TestResults=dt={}));var $t;(function(Me){function Te(Be){return{covered:Be.covered,total:Be.total}}function De(Be){return"line"in Be?g.from(Be):h.from(Be)}function te(Be){return"branches"in Be?{count:Be.executed,location:De(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executed,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executed,location:De(Be.location)}}Me.fromDetailed=te;function Oe(Be){return{uri:Be.uri,statement:Te(Be.statementCoverage),branch:Be.branchCoverage&&Te(Be.branchCoverage),declaration:Be.declarationCoverage&&Te(Be.declarationCoverage),details:Be.detailedCoverage?.map(te)}}Me.fromFile=Oe})($t||(e.TestCoverage=$t={}));var Qt;(function(Me){function Te(De){switch(De){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Te})(Qt||(e.CodeActionTriggerKind=Qt={}));var ii;(function(Me){function Te(te){const Oe=new s.$EN(fe.to(te.kind),te.name,te.detail||"",k.URI.revive(te.uri),h.to(te.range),h.to(te.selectionRange));return Oe._sessionId=te._sessionId,Oe._itemId=te._itemId,Oe}Me.to=Te;function De(te,Oe,Be){if(Oe=Oe??te._sessionId,Be=Be??te._itemId,Oe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:Be,kind:fe.from(te.kind),name:te.name,detail:te.detail??"",uri:te.uri,range:h.from(te.range),selectionRange:h.from(te.selectionRange),tags:te.tags?.map(re.from)}}Me.from=De})(ii||(e.TypeHierarchyItem=ii={}));var Rt;(function(Me){function Te(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Te})(Rt||(e.ViewBadge=Rt={}));var ft;(function(Me){function Te(Be,xe,Qe){const at=xe.fileData;return at?new s.$NM(new s.$OM(at.name,k.URI.revive(at.uri),at.id,(0,A.$db)(()=>Qe(at.id)))):Be===L.$os.uriList&&xe.uriListData?new s.$MM(Oe(xe.uriListData)):new s.$MM(xe.asString)}Me.to=Te;async function De(Be,xe){const Qe=await xe.asString();if(Be===L.$os.uriList)return{asString:Qe,fileData:void 0,uriListData:te(Qe)};const at=xe.asFile();return{asString:Qe,fileData:at?{name:at.name,uri:at.uri,id:at._itemId??at.id}:void 0}}Me.from=De;function te(Be){return $.$At.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return k.URI.parse(xe)}catch{}return xe})}function Oe(Be){return $.$At.create(Be.map(xe=>typeof xe=="string"?xe:k.URI.revive(xe)))}})(ft||(e.DataTransferItem=ft={}));var Ft;(function(Me){function Te(te,Oe){const Be=te.items.map(([xe,Qe])=>[xe,ft.to(xe,Qe,Oe)]);return new s.$PM(Be)}Me.toDataTransfer=Te;async function De(te){const Oe={items:[]},Be=[];for(const[xe,Qe]of te)Be.push((async()=>{Oe.items.push([xe,await ft.from(xe,Qe)])})());return await Promise.all(Be),Oe}Me.from=De})(Ft||(e.DataTransfer=Ft={}));var oi;(function(Me){function Te(te,Oe){return{kind:"reply",agentId:te.agentId??Oe?.agentId??"",subCommand:te.command??Oe?.command,message:te.prompt,title:te.title,tooltip:te.tooltip}}Me.from=Te;function De(te){return{prompt:te.message,title:te.title,agentId:te.agentId,command:te.subCommand,tooltip:te.tooltip}}Me.to=De})(oi||(e.ChatFollowup=oi={}));var Ot;(function(Me){function Te(De){return"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Te})(Ot||(e.ChatInlineFollowup=Ot={}));var Je;(function(Me){function Te(te){switch(te.role){case 0:return new s.$ZN(te.content);case 1:return new s.$1N(te.content);case 2:return new s.$2N(te.content)}}Me.to=Te;function De(te){if(te instanceof s.$ZN)return{role:0,content:te.content};if(te instanceof s.$1N)return{role:1,content:te.content};if(te instanceof s.$2N)return{role:2,content:te.content};throw new Error("Invalid LanguageModelMessage")}Me.from=De})(Je||(e.LanguageModelMessage=Je={}));var Ut;(function(Me){function Te(Oe){const Be={};for(const xe of Object.keys(Oe))Be[xe]=Oe[xe].map(Me.to);return Be}Me.objectTo=Te;function De(Oe){return{level:Vt.to(Oe.level),kind:Oe.kind,value:(0,k.$vc)(Oe.value)?k.URI.revive(Oe.value):Oe.value,description:Oe.description}}Me.to=De;function te(Oe){return{level:Vt.from(Oe.level),kind:Oe.kind,value:Oe.value,description:Oe.description}}Me.from=te})(Ut||(e.ChatVariable=Ut={}));var Vt;(function(Me){function Te(te){switch(te){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Te;function De(te){switch(te){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(Vt||(e.ChatVariableLevel=Vt={}));var ni;(function(Me){function Te(De){switch(De){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Te})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var gt;(function(Me){function Te(te){return{kind:"markdownContent",content:T.from(new s.$mM().appendText(te.value))}}Me.to=Te;function De(te){return new s.$QN(te.content.value)}Me.from=De})(gt||(e.ChatResponseTextPart=gt={}));var Nt;(function(Me){function Te(te){return{kind:"markdownContent",content:T.from(te.value)}}Me.to=Te;function De(te){return new s.$RN(T.to(te.content))}Me.from=De})(Nt||(e.ChatResponseMarkdownPart=Nt={}));var At;(function(Me){function Te(te){const{value:Oe,baseUri:Be}=te;function xe(Qe,at){return Qe.map(vt=>{const yt=k.URI.joinPath(at,vt.name);return{label:vt.name,uri:yt,children:vt.children&&xe(vt.children,yt)}})}return{kind:"treeData",treeData:{label:(0,w.$Mg)(Be),uri:Be,children:xe(Oe,Be)}}}Me.to=Te;function De(te){const Oe=(0,S.$Lh)(te.treeData);function Be(at){return at.map(vt=>({name:vt.label,children:vt.children&&Be(vt.children)}))}const xe=Oe.uri,Qe=Oe.children?Be(Oe.children):[];return new s.$SN(Qe,xe)}Me.from=De})(At||(e.ChatResponseFilesPart=At={}));var Bt;(function(Me){function Te(te){return{kind:"inlineReference",name:te.title,inlineReference:k.URI.isUri(te.value)?te.value:b.from(te.value)}}Me.to=Te;function De(te){const Oe=(0,S.$Lh)(te);return new s.$TN(k.URI.isUri(Oe.inlineReference)?Oe.inlineReference:b.to(Oe.inlineReference),te.name)}Me.from=De})(Bt||(e.ChatResponseAnchorPart=Bt={}));var Ht;(function(Me){function Te(te){return{kind:"progressMessage",content:T.from(te.value)}}Me.to=Te;function De(te){return new s.$UN(te.content.value)}Me.from=De})(Ht||(e.ChatResponseProgressPart=Ht={}));var Gt;(function(Me){function Te(te,Oe,Be){return{kind:"command",command:Oe.toInternal(te.value,Be)??{command:te.value.command,title:te.value.title}}}Me.to=Te;function De(te,Oe){return new s.$VN(Oe.fromInternal(te.command)??{command:te.command.id,title:te.command.title})}Me.from=De})(Gt||(e.ChatResponseCommandButtonPart=Gt={}));var It;(function(Me){function Te(te){return{kind:"reference",reference:k.URI.isUri(te.value)?te.value:b.from(te.value)}}Me.to=Te;function De(te){const Oe=(0,S.$Lh)(te);return new s.$WN(k.URI.isUri(Oe.reference)?Oe.reference:b.to(Oe.reference))}Me.from=De})(It||(e.ChatResponseReferencePart=It={}));var Zt;(function(Me){function Te(te){return te instanceof s.$RN?Nt.to(te):te instanceof s.$TN?Bt.to(te):te instanceof s.$WN?It.to(te):te instanceof s.$UN?Ht.to(te):te instanceof s.$SN?At.to(te):{kind:"content",content:""}}Me.to=Te;function De(te,Oe){switch(te.kind){case"markdownContent":return Nt.from(te);case"inlineReference":return Bt.from(te);case"reference":return It.from(te);case"progressMessage":return Ht.from(te);case"treeData":return At.from(te);case"command":return Gt.from(te,Oe)}}Me.from=De})(Zt||(e.ChatResponsePart=Zt={}));var kt;(function(Me){function Te(Oe,Be){return"markdownContent"in Be?((0,c.$SF)(Oe,"chatAgents2Additions"),{content:T.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,c.$SF)(Oe,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,c.$SF)(Oe,"chatAgents2Additions"),{content:T.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Qe=>h.from(Qe))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:h.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:h.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,c.$SF)(Oe,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"message"in Be?{content:T.from(Be.message),kind:"progressMessage"}:void 0}Me.from=Te;function De(Oe){switch(Oe.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Oe);case"content":return{content:Oe.content};case"usedContext":return{documents:Oe.documents.map(Be=>({uri:k.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>h.to(xe))}))};case"reference":return{reference:(0,k.$vc)(Oe.reference)?k.URI.revive(Oe.reference):b.to(Oe.reference)};case"agentDetection":return;case"progressMessage":return{message:Oe.content.value};case"vulnerability":return{content:Oe.content,vulnerabilities:Oe.vulnerabilities};default:return}}Me.to=De;function te(Oe,Be){switch(Oe.kind){case"markdownContent":return{content:Oe.content.value};case"inlineReference":return{inlineReference:(0,k.$vc)(Oe.inlineReference)?k.URI.revive(Oe.inlineReference):b.to(Oe.inlineReference),title:Oe.name};case"command":return{command:Be.fromInternal(Oe.command)??{command:Oe.command.id,title:Oe.command.title}};default:return}}Me.toProgressContent=te})(kt||(e.ChatResponseProgress=kt={}));var pt;(function(Me){function Te(De){return{prompt:De.message,command:De.command,variables:De.variables.variables.map(Pt.to)}}Me.to=Te})(pt||(e.ChatAgentRequest=pt={}));var Pt;(function(Me){function Te(De){return{name:De.name,range:[De.range.start,De.range.endExclusive],values:De.values.map(Ut.to)}}Me.to=Te})(Pt||(e.ChatAgentResolvedVariable=Pt={}));var Ct;(function(Me){function Te(De){return{label:De.label,values:De.values.map(Ut.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Te})(Ct||(e.ChatAgentCompletionItem=Ct={}));var ci;(function(Me){function Te(De){return{errorDetails:De.errorDetails,metadata:De.metadata}}Me.to=Te})(ci||(e.ChatAgentResult=ci={}));var Xt;(function(Me){function Te(De,te,Oe){if(te.action.kind==="vote")return;const Be=ci.to(De);return te.action.kind==="command"?{action:{kind:"command",commandButton:kt.toProgressContent(te.action.commandButton,Oe)},result:Be}:te.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(te.action.followup)},result:Be}:{action:te.action,result:Be}}Me.to=Te})(Xt||(e.ChatAgentUserActionEvent=Xt={}));var bi;(function(Me){function Te(De,te,Oe){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:te.toInternal(De,Oe)}Me.from=Te})(bi||(e.TerminalQuickFix=bi={}));var Kt;(function(Me){function Te(De,te){return{id:te,label:De.label,description:De.description,canEdit:De.canEdit,collapsibleState:De.collapsibleState||0,contextValue:De.contextValue}}Me.from=Te})(Kt||(e.DebugTreeItem=Kt={}))}),define(Ce[320],Ie([1,0,6,20,15]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;let A=class{constructor(v,p){this.a=v.getProxy(I.$VL.MainThreadBulkEdits),this.b={getTextDocumentVersion:S=>p.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,p,S){const L=$.WorkspaceEdit.from(v,this.b);return this.a.$tryApplyWorkspaceEdit(L,void 0,S?.isRefactoring??!1)}};e.$ehc=A,e.$ehc=A=Ke([We(0,O.$aO)],A)}),define(Ce[321],Ie([1,0,19,8,44,4,63,3,38,18,2,211,6,15,7,281,25]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class o{constructor(a,t,d,c,s,l){this.i=a,this.j=t,this.k=d,this.l=c,this.m=s,this.n=l,this.a=p.$Yd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let t=function(c){if(a.b){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,c),s}};const a=this;this.a.reset();const d=c=>{typeof this.d>"u"&&"content"in c&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,c)};this.g={text(c){return t(this.text),this.markdown(new R.$qk().appendText(c)),this},markdown(c){t(this.markdown);const s=new k.$RN(c),l=E.ChatResponseMarkdownPart.to(s);return d(l),this},filetree(c,s){t(this.filetree);const l=new k.$SN(c,s),h=E.ChatResponseFilesPart.to(l);return d(h),this},anchor(c,s){t(this.anchor);const l=new k.$TN(c,s),h=E.ChatResponseAnchorPart.to(l);return d(h),this},button(c){t(this.anchor);const s=new k.$VN(c),l=E.ChatResponseCommandButtonPart.to(s,a.m,a.n);return d(l),this},progress(c){t(this.progress);const s=new k.$UN(c),l=E.ChatResponseProgressPart.to(s);return d(l),this},reference(c){t(this.reference);const s=new k.$WN(c),l=E.ChatResponseReferencePart.to(s);return d(l),this},push(c){t(this.push);const s=E.ChatResponsePart.to(c);return d(s),this},report(c){if(t(this.report),"placeholder"in c&&"resolvedContent"in c)return;const s=E.ChatResponseProgress.from(a.i,c);if(!s){a.l.error("Unknown progress type: "+JSON.stringify(c));return}return d(s),this}}}return this.g}}class i{static{this.a=0}constructor(a,t,d){this.i=t,this.j=d,this.b=new Map,this.g=new v.$3c,this.d=a.getProxy(w.$VL.MainThreadChatAgents2)}createChatAgent(a,t,d){const c=i.a++,s=new n(a,t,this.d,c,d);return this.b.set(c,s),this.d.$registerAgent(c,a.identifier,t,{}),s.apiAgent}async $invokeAgent(a,t,d,c){const s=this.b.get(a);if(!s)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let l=this.g.get(t.sessionId);l||(l=new v.$Sc,this.g.set(t.sessionId,l));const h=new o(s.extension,t,this.d,this.i,this.j.converter,l);try{const b=await this.k(t,d),D=s.invoke(E.ChatAgentRequest.to(t),{history:b},h.apiObject,c);return await(0,O.$3g)(Promise.resolve(D).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(f){const y=`result.metadata MUST be JSON.stringify-able. Got error: ${f.message}`;return this.i.error(`[${s.extension.identifier.value}] [@${s.id}] ${y}`,s.extension),{errorDetails:{message:y},timings:h.timings}}return{errorDetails:g?.errorDetails,timings:h.timings,metadata:g?.metadata}}),c)}catch(b){return this.i.error(b,s.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,$.$Zi)(b)),responseIsIncomplete:!0}}}finally{h.close()}}async k(a,t){const d=[];for(const c of t.history){const s=E.ChatAgentResult.to(c.result),l=a.agentId===c.request.agentId?s:{...s,metadata:void 0};d.push(new k.$XN(c.request.message,c.request.command,c.request.variables.variables.map(E.ChatAgentResolvedVariable.to),{extensionId:"",agent:c.request.agentId}));const h=(0,I.$Hb)(c.response.map(b=>E.ChatResponsePart.from(b,this.j.converter)));d.push(new k.$YN(h,l,{extensionId:"",agent:c.request.agentId}))}return d}$releaseSession(a){this.g.deleteAndDispose(a)}async $provideSlashCommands(a,t){const d=this.b.get(a);return d?d.provideSlashCommands(t):[]}async $provideFollowups(a,t,d,c){const s=this.b.get(t);if(!s)return Promise.resolve([]);const l=E.ChatAgentResult.to(d);return(await s.provideFollowups(l,c)).map(h=>E.ChatFollowup.from(h,a))}$acceptFeedback(a,t,d,c){const s=this.b.get(a);if(!s)return;const l=E.ChatAgentResult.to(t);let h;switch(d){case u.InteractiveSessionVoteDirection.Down:h=k.ChatAgentResultFeedbackKind.Unhelpful;break;case u.InteractiveSessionVoteDirection.Up:h=k.ChatAgentResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(c?{result:l,kind:h,reportIssue:c}:{result:l,kind:h}))}$acceptAction(a,t,d){const c=this.b.get(a);if(!c||d.action.kind==="vote")return;const s=E.ChatAgentUserActionEvent.to(t,d,this.j.converter);s&&c.acceptAction(Object.freeze(s))}async $invokeCompletionProvider(a,t,d){const c=this.b.get(a);return c?(await c.invokeCompletionProvider(t,d)).map(E.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(a,t){const d=this.b.get(a);if(d)return await d.provideWelcomeMessage(t)}async $provideSampleQuestions(a,t){const d=this.b.get(a);if(d)return(await d.provideSampleQuestions(t)).map(c=>E.ChatFollowup.from(c,void 0))}}e.$ghc=i;class n{constructor(a,t,d,c,s){this.extension=a,this.id=t,this.w=d,this.x=c,this.y=s,this.o=new A.$3d,this.p=new A.$3d}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.p.fire(a)}async invokeCompletionProvider(a,t){return this.s?await this.s.provider.provideCompletionItems(a,t)??[]:[]}async provideSlashCommands(a){if(!this.a)return[];const t=await this.a.provideCommands(a);return t?t.map(d=>("repopulate2"in d&&(0,m.$SF)(this.extension,"chatAgents2Additions"),{name:d.name,description:d.description,followupPlaceholder:d.isSticky2?.placeholder,shouldRepopulate:d.isSticky2?.isSticky??d.isSticky,sampleRequest:d.sampleRequest})):[]}async provideFollowups(a,t){if(!this.b)return[];const d=await this.b.provideFollowups(a,t);return d?d.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(a){if(!this.t)return[];const t=await this.t.provideWelcomeMessage(a);return t?t.map(d=>typeof d=="string"?d:E.MarkdownString.from(d)):[]}async provideSampleQuestions(a){if(!this.t||!this.t.provideSampleQuestions)return[];const t=await this.t.provideSampleQuestions(a);return t||[]}get apiAgent(){let a=!1,t=!1;const d=()=>{a||t||(t=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof L.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof k.$SM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:E.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u}),t=!1}))},c=this;return{get name(){return c.id},get description(){return c.d??""},set description(s){c.d=s,d()},get fullName(){return c.g??c.extension.displayName??c.extension.name},set fullName(s){c.g=s,d()},get iconPath(){return c.i},set iconPath(s){c.i=s,d()},get requestHandler(){return c.y},set requestHandler(s){(0,S.$1f)(typeof s=="function","Invalid request handler"),c.y=s},get commandProvider(){return c.a},set commandProvider(s){c.a=s,d()},get followupProvider(){return c.b},set followupProvider(s){c.b=s,d()},get isDefault(){return(0,m.$SF)(c.extension,"defaultChatAgent"),c.j},set isDefault(s){(0,m.$SF)(c.extension,"defaultChatAgent"),c.j=s,d()},get helpTextPrefix(){return(0,m.$SF)(c.extension,"defaultChatAgent"),c.k},set helpTextPrefix(s){if((0,m.$SF)(c.extension,"defaultChatAgent"),!c.j)throw new Error("helpTextPrefix is only available on the default chat agent");c.k=s,d()},get helpTextPostfix(){return(0,m.$SF)(c.extension,"defaultChatAgent"),c.l},set helpTextPostfix(s){if((0,m.$SF)(c.extension,"defaultChatAgent"),!c.j)throw new Error("helpTextPostfix is only available on the default chat agent");c.l=s,d()},get isSecondary(){return(0,m.$SF)(c.extension,"defaultChatAgent"),c.n},set isSecondary(s){(0,m.$SF)(c.extension,"defaultChatAgent"),c.n=s,d()},get sampleRequest(){return c.m},set sampleRequest(s){c.m=s,d()},get supportIssueReporting(){return(0,m.$SF)(c.extension,"chatAgents2Additions"),c.q},set supportIssueReporting(s){(0,m.$SF)(c.extension,"chatAgents2Additions"),c.q=s,d()},get onDidReceiveFeedback(){return c.o.event},set agentVariableProvider(s){if((0,m.$SF)(c.extension,"chatAgents2Additions"),c.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");c.w.$registerAgentCompletionsProvider(c.x,s.triggerCharacters)}else c.w.$unregisterAgentCompletionsProvider(c.x)},get agentVariableProvider(){return(0,m.$SF)(c.extension,"chatAgents2Additions"),c.s},set welcomeMessageProvider(s){(0,m.$SF)(c.extension,"defaultChatAgent"),c.t=s,d()},get welcomeMessageProvider(){return(0,m.$SF)(c.extension,"defaultChatAgent"),c.t},onDidPerformAction:(0,m.$RF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,get isSticky(){return c.u},set isSticky(s){c.u=s,d()},dispose(){a=!0,c.a=void 0,c.b=void 0,c.o.dispose(),c.w.$unregisterAgent(c.x)}}}invoke(a,t,d,c){return this.y(a,t,d,c)}}}),define(Ce[322],Ie([1,0,22,3,6,15,107,26,8,4,212,142]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class w{constructor(m,o){this.option=m,this.stream=new p.$Fh,this.stream=o??new p.$Fh}}class E{constructor(m,o){this.cts=o,this.a=new Map,this.b=new p.$Fh,this.c=!1;const i=this;this.apiObject={result:m,stream:i.b.asyncIterable},m.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,n]of this.a)n.stream.resolve();else this.b.resolve()})}handleFragment(m){if(this.c)return;let o=this.a.get(m.index);o||(this.a.size===0?o=new w(m.index,this.b):o=new w(m.index),this.a.set(m.index,o)),o.stream.emitOne(m.part)}}class k{static{this.a=1}constructor(m,o,i){this.j=o,this.k=i,this.c=new S.$3d,this.d=new S.$3d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new v.$wm,this.i=new Map,this.b=m.getProxy($.$VL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(m,o,i,n){const r=k.a++;this.f.set(r,{extension:m.identifier,provider:i});let a;return n.auth&&(a={providerLabel:m.displayName||m.name,accountLabel:typeof n.auth=="object"?n.auth.label:void 0}),this.b.$registerProvider(r,o,{extension:m.identifier,model:n.name??"",auth:a}),(0,O.$Rc)(()=>{this.f.delete(r),this.b.$unregisterProvider(r)})}async $provideLanguageModelResponse(m,o,i,n,r,a){const t=this.f.get(m);if(!t)return;const d=new R.$Ev(async c=>{if(a.isCancellationRequested){this.j.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(o,{index:c.index,part:c.part})});return t.provider.provideLanguageModelResponse2(n.map(A.LanguageModelMessage.to),r,v.$um.toKey(i),d,a)}$updateLanguageModels(m){const o=[],i=[];if(m.added)for(const n of m.added)this.g.add(n),o.push(n);if(m.removed)for(const n of m.removed){this.g.delete(n),i.push(n);for(const[r,a]of this.i)a.languageModelId===n&&(a.res.cts.cancel(),this.i.delete(r))}this.d.fire(Object.freeze({added:Object.freeze(o),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(m){const o=new Array;for(const{from:i,to:n,enabled:r}of m){const a=this.h.get(i)??new v.$vm;if(a.has(n)!==r){r?a.add(n):a.delete(n),this.h.set(i,a);const d={from:i,to:n};o.push(d),this.c.fire(d)}}}async requestLanguageModelAccess(m,o,i){const n=m.identifier,r=i?.justification,a=await this.b.$prepareChatAccess(n,o,r);if(!a)throw new Error(`Language model '${o}' NOT found`);this.m(n,a)&&await this.l(m,{identifier:a.extension,displayName:a.auth.providerLabel},r);const t=this;return{get model(){return a.model},get isRevoked(){return t.m(n,a)&&!t.h.get(n)?.has(a.extension)||!t.g.has(o)},get onDidChangeAccess(){const d=S.Event.filter(t.d.event,s=>s.removed.includes(o)),c=S.Event.filter(t.c.event,s=>v.$um.equals(s.from,n)&&v.$um.equals(s.to,a.extension));return S.Event.signal(S.Event.any(d,c))},makeChatRequest(d,c,s){if(t.m(n,a)&&!t.h.get(n)?.has(a.extension))throw new Error("Access to chat has been revoked");if(!t.g.has(o))throw new Error("Language Model has been removed");const l=new I.$ae(s),h=Math.random()*1e6|0,b=t.b.$fetchResponse(n,o,h,d.map(A.LanguageModelMessage.from),c??{},l.token),D=new E(b,l);return t.i.set(h,{languageModelId:o,res:D}),b.finally(()=>{t.i.delete(h),l.dispose()}),D.apiObject}}}async $handleResponseFragment(m,o){const i=this.i.get(m);i&&i.res.handleFragment(o)}async l(m,o,i){const n=C.$2K+o.identifier.value;if(!await this.k.getSession(m,n,[],{silent:!0}))try{const a=i?(0,L.localize)(0,null,o.displayName,i):(0,L.localize)(1,null,o.displayName);await this.k.getSession(m,n,[],{forceNewSession:{detail:a}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:m.identifier,to:o.identifier,enabled:!0}])}m(m,o){return!!o.auth&&!v.$um.equals(o.extension,m)}}e.$hhc=k}),define(Ce[323],Ie([1,0,14,3,6,15,7,25]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class p{static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy($.$VL.MainThreadChatVariables)}async $resolveVariable(C,w,E,k){const u=this.b.get(C);if(u)try{if(u.resolver.resolve2){(0,v.$SF)(u.extension,"chatAgents2Additions");const m=new S(w,this.c),o=await u.resolver.resolve2(u.data.name,{prompt:E},m.apiObject,k);if(o)return o.map(A.ChatVariable.from)}else{const m=await u.resolver.resolve(u.data.name,{prompt:E},k);if(m)return m.map(A.ChatVariable.from)}}catch(m){(0,I.$2)(m)}}registerVariableResolver(C,w,E,k){const u=p.a++;return this.b.set(u,{extension:C,data:{name:w,description:E},resolver:k}),this.c.$registerVariable(u,{name:w,description:E}),(0,O.$Rc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$ihc=p;class S{constructor(C,w){this.c=C,this.d=w,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let w=function(k){if(C.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,k),u}};const C=this,E=k=>{this.d.$handleProgressChunk(this.c,k)};this.b={progress(k){w(this.progress);const u=new R.$UN(k),m=A.ChatResponseProgressPart.to(u);return E(m),this},reference(k){w(this.reference);const u=new R.$WN(k),m=A.ChatResponseReferencePart.to(u);return E(m),this},push(k){w(this.push);const u=A.ChatResponsePart.to(k);return E(u),this}}}return this.b}}}),define(Ce[324],Ie([1,0,8,52,4,3,2,83,26,15,7,6,25]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;function E(k,u,m){const o=k.getProxy(C.$VL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$wm,u.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const b=this.b.get(h.handle);return b?b.value:h}else if(h&&h.$mid===7){const b=this.b.get(h.commentControlHandle);if(!b)return h;const D=b.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const D=b.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const D=b.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const g=h.commentUniqueId,f=D.getCommentByUniqueId(g);return f||h}else if(h&&h.$mid===11){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const D=b.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const g=h.text,f=h.commentUniqueId,y=D.getCommentByUniqueId(f);return y?(typeof y.body=="string"?y.body=g:y.body=new L.$mM(g),y):h}return h}})}createCommentController(h,b,D){const g=i.a++,f=new r(h,g,b,D);this.b.set(f.handle,f);const y=this.c.get(h.identifier)||[];return y.push(f),this.c.set(h.identifier,y),f.value}async $createCommentThreadTemplate(h,b,D){const g=this.b.get(h);g&&g.$createCommentThreadTemplate(b,D)}async $setActiveComment(h,b){const D=this.b.get(h);D&&D.$setActiveComment(b??void 0)}async $updateCommentThreadTemplate(h,b,D){const g=this.b.get(h);g&&g.$updateCommentThreadTemplate(b,D)}$deleteCommentThread(h,b){this.b.get(h)?.$deleteCommentThread(b)}$provideCommentingRanges(h,b,D){const g=this.b.get(h);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const f=m.getDocument(R.URI.revive(b));return(0,I.$7g)(async()=>{const y=await g.commentingRangeProvider.provideCommentingRanges(f,D);let P;return Array.isArray(y)?P={ranges:y,fileComments:!1}:y?P={ranges:y.ranges||[],fileComments:y.fileComments||!1}:P=y??void 0,P}).then(y=>{let P;return y&&(P={ranges:y.ranges.map(N=>S.Range.from(N)),fileComments:y.fileComments}),P})}$toggleReaction(h,b,D,g,f){const y=this.b.get(h);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,I.$7g)(()=>{const P=y.getCommentThread(b);if(P){const N=P.getCommentByUniqueId(g.uniqueIdInThread);if(y!==void 0&&N&&y.reactionHandler)return y.reactionHandler(N,d(f))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,b,D,g,f,y,P,N){this.m=b,this.n=D,this.o=g,this.p=f,this.q=y,this.extensionDescription=P,this.r=N,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new $.$3d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(b,this.handle,this.n,this.o,S.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{o.$deleteCommentThread(b,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(z){U.range=z},get comments(){return U.comments},set comments(z){U.comments=z},get collapsibleState(){return U.collapsibleState},set collapsibleState(z){U.collapsibleState=z},get canReply(){return U.canReply},set canReply(z){U.canReply=z},get contextValue(){return U.contextValue},set contextValue(z){U.contextValue=z},get label(){return U.label},set label(z){U.label=z},get state(){return U.state},set state(z){U.state=z},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),b={};h("range")&&(b.range=S.Range.from(this.p)),h("label")&&(b.label=this.label),h("contextValue")&&(b.contextValue=this.contextValue??null),h("comments")&&(b.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(b.collapseState=c(this.g)),h("canReply")&&(b.canReply=this.canReply),h("state")&&(b.state=s(this.h)),h("isTemplate")&&(b.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(h){for(const b of this.k){const D=b[0],g=b[1];if(h===g)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Ke([(0,O.$Hh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,w.$SF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,w.$SF)(this.h,"activeComment"),this.f}constructor(h,b,D,g){this.h=h,this.i=b,this.j=D,this.k=g,this.a=new Map,o.$registerCommentController(this.handle,D,g,this.h.identifier.value);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(y){f.options=y},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(y){f.commentingRangeProvider=y},get reactionHandler(){return f.reactionHandler},set reactionHandler(y){f.reactionHandler=y},get activeCommentThread(){return f.activeCommentThread},createCommentThread(y,P,N){return f.createCommentThread(y,P,N).value},dispose:()=>{f.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,b,D){b===void 0&&(0,w.$SF)(this.h,"fileComments");const g=new n(this.id,this.handle,void 0,h,b,D,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const b=this.a.get(h.commentThreadHandle);b&&(this.e=h.uniqueIdInThread?b.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=b)}$createCommentThreadTemplate(h,b){const D=new n(this.id,this.handle,void 0,R.URI.revive(h),S.Range.to(b),[],this.h,!0);return D.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,b){const D=this.a.get(h);D&&(D.range=S.Range.to(b))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function a(l,h,b,D){let g=b.get(h);return g||(g=++l.commentHandle,b.set(h,g)),h.state!==void 0&&(0,w.$SF)(D,"commentsDraftState"),h.reactions?.some(f=>f.reactors!==void 0)&&(0,w.$SF)(D,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:g,body:typeof h.body=="string"?h.body:S.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(f=>t(f)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(l){return{label:l.label,iconPath:l.iconPath?S.$_N(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted,reactors:l.reactors&&l.reactors.length>0&&typeof l.reactors[0]!="string"?l.reactors.map(h=>h.name):l.reactors}}function d(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?R.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1,reactors:l.reactors?.map(h=>({name:h}))}}function c(l){if(l!==void 0)switch(l){case L.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case L.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function s(l){if(l!==void 0)switch(l){case L.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case L.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.$mhc=E}),define(Ce[325],Ie([1,0,22,54,3,16,23,2,15,92,110,6,7]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;class E{constructor(d,c){this.document=d,this.b=c,this.a=1,this.c=new L.$4gc("custom documents")}addEdit(d){return this.c.add([d])}async undo(d,c){await this.f(d).undo(),c||this.disposeBackup()}async redo(d,c){await this.f(d).redo(),c||this.disposeBackup()}disposeEdits(d){for(const c of d)this.c.delete(c)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const d=a(this.document.uri)+this.a++;return(0,R.$Pg)(this.b,d)}updateBackup(d){this.d?.delete(),this.d=d}disposeBackup(){this.d?.delete(),this.d=void 0}f(d){const c=this.c.get(d,0);if(!c)throw new Error("No edit found");return c}}class k{constructor(){this.a=new Map}get(d,c){return this.a.get(this.b(d,c))}add(d,c,s){const l=this.b(d,c.uri);if(this.a.has(l))throw new Error(`Document already exists for viewType:${d} resource:${c.uri}`);const h=new E(c,s);return this.a.set(l,h),h}delete(d,c){const s=this.b(d,c.uri);this.a.delete(s)}b(d,c){return`${d}@@@${c}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class m{constructor(){this.a=new Map}addTextProvider(d,c,s){return this.b(0,d,c,s)}addCustomProvider(d,c,s){return this.b(1,d,c,s)}get(d){return this.a.get(d)}b(d,c,s,l){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,{type:d,extension:s,provider:l}),new w.$XL(()=>this.a.delete(c))}}class o{constructor(d,c,s,l,h){this.d=c,this.f=s,this.g=l,this.h=h,this.b=new m,this.c=new k,this.a=d.getProxy(C.$VL.MainThreadCustomEditors)}registerCustomEditorProvider(d,c,s,l){const h=new $.$Sc;return n(s)?(h.add(this.b.addTextProvider(c,d,s)),this.a.$registerTextEditorProvider((0,S.$Bhc)(d),c,l.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,S.$zhc)(d))):(h.add(this.b.addCustomProvider(c,d,s)),i(s)&&h.add(s.onDidChangeCustomDocument(b=>{const D=this.i(c,b.document.uri);if(r(b)){const g=D.addEdit(b);this.a.$onDidEdit(b.document.uri,c,g,b.label)}else this.a.$onContentChange(b.document.uri,c)})),this.a.$registerCustomEditorProvider((0,S.$Bhc)(d),c,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,S.$zhc)(d))),w.$XL.from(h,new w.$XL(()=>{this.a.$unregisterEditorProvider(c)}))}async $createCustomDocument(d,c,s,l,h){const b=this.b.get(c);if(!b)throw new Error(`No provider found for '${c}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${c}'`);const D=v.URI.revive(d),g=await b.provider.openCustomDocument(D,{backupId:s,untitledDocumentData:l?.buffer},h);let f;return i(b.provider)&&this.f&&(f=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(c,g,f),{editable:i(b.provider)}}async $disposeCustomDocument(d,c){const s=this.b.get(c);if(!s)throw new Error(`No provider found for '${c}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${c}'`);const l=v.URI.revive(d),{document:h}=this.i(c,l);this.c.delete(c,h),h.dispose()}async $resolveCustomEditor(d,c,s,l,h,b){const D=this.b.get(s);if(!D)throw new Error(`No provider found for '${s}'`);const g=p.ViewColumn.to(h),f=this.g.createNewWebview(c,l.contentOptions,D.extension),y=this.h.createNewWebviewPanel(c,s,l.title,g,l.options,f,l.active),P=v.URI.revive(d);switch(D.type){case 1:{const{document:N}=this.i(s,P);return D.provider.resolveCustomEditor(N,y,b)}case 0:{const N=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(N,y,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(d,c,s){this.i(c,d).disposeEdits(s)}async $onMoveCustomEditor(d,c,s){const l=this.b.get(s);if(!l)throw new Error(`No provider found for '${s}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const h=this.h.getWebviewPanel(d);if(!h)throw new Error("No webview found");const b=v.URI.revive(c),D=this.d.getDocument(b);await l.provider.moveCustomTextEditor(D,h,I.CancellationToken.None)}async $undo(d,c,s,l){return this.i(c,d).undo(s,l)}async $redo(d,c,s,l){return this.i(c,d).redo(s,l)}async $revert(d,c,s){const l=this.i(c,d);await this.j(c).revertCustomDocument(l.document,s),l.disposeBackup()}async $onSave(d,c,s){const l=this.i(c,d);await this.j(c).saveCustomDocument(l.document,s),l.disposeBackup()}async $onSaveAs(d,c,s,l){const h=this.i(c,d);return this.j(c).saveCustomDocumentAs(h.document,v.URI.revive(s),l)}async $backup(d,c,s){const l=this.i(c,d),b=await this.j(c).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},s);return l.updateBackup(b),b.id}i(d,c){const s=this.c.get(d,v.URI.revive(c));if(!s)throw new Error("No custom document found");return s}j(d){const s=this.b.get(d)?.provider;if(!s||!i(s))throw new Error("Custom document is not editable");return s}}e.$Ehc=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const d=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,O.$3i)(d)+""}}),define(Ce[326],Ie([1,0,213,135,2,6,7,15,4,13,28,59]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;class E{#e;#t;#i;constructor(m,o,i,n,r,a,t,d){this.d=m,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new L.$Ac(c=>a.getComparisonKey(c)),this.#e=t,this.#t=d}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let i=[];if($.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),i=[m]}else if(Array.isArray(m)){i=[];let a;m=[...m].sort(E.k);for(const t of m){const[d,c]=t;if((!a||d.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=d,i.push(d),this.#i.set(d,[])),c)this.#i.get(d)?.push(...c);else{const s=this.#i.get(d);s&&(s.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const d=this.#i.get(a);if(d)if(d.length>this.g){t=[];const c=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const l of d)if(l.severity===c[s]&&t.push({...v.Diagnostic.from(l),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:O.MarkerSeverity.Info,message:(0,I.localize)(0,null,d.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=d.map(c=>({...v.Diagnostic.from(c),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[i,n]of this)m.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$$gc=E;let k=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(m){const o=new L.$Ac;for(const i of m)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new p.$7d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,w._mapper),this.f=m.getProxy(A.$VL.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:i,f:n,h:r,j:a,k:t,l:d}=this,c=new class{$changeMany(h,b){n.$changeMany(h,b),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,b.length===0?"CLEARING":b)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){n.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+w.c++,s=o;else if(!i.has(o))s=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+w.c++;while(i.has(s))}return new class extends E{constructor(){super(o,s,w.e,w.d,h=>d.getDocument(h)?.version,t.extUri,c,r),i.set(s,this)}dispose(){super.dispose(),i.delete(s)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(m){let o=[];for(const i of this.g.values())i.has(m)&&(o=o.concat(i.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",i=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of m)this.n.set($.URI.revive(o),i.map(v.Diagnostic.to))}};e.$_gc=k,e.$_gc=k=w=Ke([We(1,S.$wj),We(2,C.$0gc)],k)}),define(Ce[327],Ie([1,0,2,14,7,15,76]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;class v{constructor(S,L,C,w={timeout:1500,errors:3}){this.c=S,this.d=L,this.f=C,this.g=w,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(S){return(L,C,w)=>{const k={dispose:this.a.push([L,C,S])};return Array.isArray(w)&&w.push(k),k}}async $participateInSave(S,L){const C=I.URI.revive(S);let w=!1;const E=setTimeout(()=>w=!0,this.g.timeout),k=[];try{for(const u of[...this.a]){if(w)break;const m=this.d.getDocument(C),o=await this.h(u,{document:m,reason:A.TextDocumentSaveReason.to(L)});k.push(o)}}finally{clearTimeout(E)}return k}h([S,L,C],w){const E=this.b.get(S);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(C,S,L,w).then(()=>!0,k=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(k),!(k instanceof Error)||k.message!=="concurrent_edits"){const u=this.b.get(S);this.b.set(S,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(S,L,C,w){const E=[],k=Date.now(),{document:u,reason:m}=w,{version:o}=u,i=Object.freeze({document:u,reason:m,waitUntil(n){if(Object.isFrozen(E))throw(0,O.$8)("waitUntil can not be called async");E.push(Promise.resolve(n))}});try{L.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(E),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' finished after ${Date.now()-k}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof $.$5L))for(const{newText:t,newEol:d,range:c}of a)r.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:c&&A.Range.from(c),text:t,eol:d&&A.EndOfLine.from(d)}});if(r.edits.length!==0)return o===u.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$gic=v}),define(Ce[328],Ie([1,0,4,3,2,6,149,15,18,24,7]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class C{constructor(E,k){this.a=new I.$3d,this.b=new I.$3d,this.c=new I.$3d,this.d=new I.$3d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new O.$Sc,this.h=new Map,this.f=E.getProxy(A.$VL.MainThreadDocuments),this.g=k,this.g.onDidRemoveDocuments(u=>{for(const m of u)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const m of u)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const k=this.g.getDocument(E);if(k)return k}getDocument(E){const k=this.getDocumentData(E);if(!k?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return k.document}ensureDocumentData(E){const k=this.g.getDocument(E);if(k)return Promise.resolve(k);let u=this.h.get(E.toString());return u||(u=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const o=$.URI.revive(m);return(0,p.$2f)(this.g.getDocument(o))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),u)),u}createDocumentData(E){return this.f.$tryCreateDocument(E).then(k=>$.URI.revive(k))}$acceptModelLanguageChanged(E,k){const u=$.URI.revive(E),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(k),this.a.fire(m.document)}$acceptModelSaved(E){const k=$.URI.revive(E),u=this.g.getDocument(k);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(E,k){const u=$.URI.revive(E),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");m._acceptIsDirty(k),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,k,u){const m=$.URI.revive(E),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(k);let i;k.isUndoing?i=L.TextDocumentChangeReason.Undo:k.isRedoing&&(i=L.TextDocumentChangeReason.Redo),this.c.fire((0,S.$Gn)({document:o.document,contentChanges:k.changes.map(n=>({range:v.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(E,k){(0,R.$cO)(E,k)}}e.$ahc=C}),define(Ce[72],Ie([1,0,74,4,18,2,5,6,20,15,7]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0,e.$Fhc=(0,R.$ci)("IExtHostEditorTabs");class C{constructor(m,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new L.$FN(A.URI.revive(this.b.input.uri));case 2:return new L.$GN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new L.$HN(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new L.$IN(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new L.$JN(this.b.input.viewType);case 4:return new L.$KN(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new L.$LN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new L.$MN;case 9:return new L.$NN(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new L.$ON(this.b.input.providerId);default:return}}}class w{constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return S.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const o=this.c.find(i=>i.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new O.$3d,this.c=new O.$3d,this.e=[],this.a=m.getProxy(v.$VL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,$.$2f)(m.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?k(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(c=>c.groupId)),i=new Set(m.map(c=>c.groupId)),n=(0,I.$L)(o,i),r=this.e.filter(c=>n.removed.includes(c.groupId)).map(c=>c.apiObject),a=[],t=[];this.e=m.map(c=>{const s=new w(c,()=>this.d);return n.added.includes(s.groupId)?a.push(s.apiObject):t.push(s.apiObject),s});const d=(0,$.$2f)(m.find(c=>c.isActive===!0)?.groupId);d!==void 0&&this.d!==d&&(this.d=d),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const i=[];for(const n of m){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(m,o){const i=[];for(const n of m){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$Ghc=E,e.$Ghc=E=Ke([We(0,p.$aO)],E);function k(u){return u.tabs!==void 0}}),define(Ce[329],Ie([1,0,2,6,3,7,15,174,12,21,25,63]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;class w{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const m=this.a.indexOf(u);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),m=[];let o,i,n=14,r=14;for(const a of u){let t=o?(0,p.$jf)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,m.push([i,a.toUpperCase().charCodeAt(t),r]),m.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new v.$B1(m)}}provideDocumentLinks(u){this.c();const m=[],o=v.$C1.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&m.push(n)}return m}}class E{constructor(u,m){this.i=m,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(O.$VL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,m,o,i={}){if(E.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,L.$SF)(u,"fsChunks"),r+=4);let a;i.isReadonly&&(0,C.$sk)(i.isReadonly)&&i.isReadonly.value!==""&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,r,a).catch(d=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${m}`),console.error(d)});const t=o.onDidChangeFile(d=>{const c=[];for(const s of d){const{uri:l,type:h}=s;if(l.scheme!==m)continue;let b;switch(h){case A.FileChangeType.Changed:b=0;break;case A.FileChangeType.Created:b=1;break;case A.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:l,type:b})}this.a.$onFileSystemChange(n,c)});return(0,$.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:m,ctime:o,mtime:i,size:n,permissions:r}=u;return{type:m,ctime:o,mtime:i,size:n,permissions:r}}$stat(u,m){return Promise.resolve(this.l(u).stat(I.URI.revive(m))).then(o=>E.k(o))}$readdir(u,m){return Promise.resolve(this.l(u).readDirectory(I.URI.revive(m)))}$readFile(u,m){return Promise.resolve(this.l(u).readFile(I.URI.revive(m))).then(o=>S.$qe.wrap(o))}$writeFile(u,m,o,i){return Promise.resolve(this.l(u).writeFile(I.URI.revive(m),o.buffer,i))}$delete(u,m,o){return Promise.resolve(this.l(u).delete(I.URI.revive(m),o))}$rename(u,m,o,i){return Promise.resolve(this.l(u).rename(I.URI.revive(m),I.URI.revive(o),i))}$copy(u,m,o,i){const n=this.l(u);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(I.URI.revive(m),I.URI.revive(o),i))}$mkdir(u,m){return Promise.resolve(this.l(u).createDirectory(I.URI.revive(m)))}$watch(u,m,o,i){const n=this.l(u).watch(I.URI.revive(o),i);this.f.set(m,n)}$unwatch(u,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(u,m,o){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(I.URI.revive(m),o))}$close(u,m){const o=this.l(u);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(u,m,o,i){const n=this.l(u);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=S.$qe.alloc(i);return Promise.resolve(n.read(m,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(u,m,o,i){const n=this.l(u);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,o,i.buffer,0,i.byteLength))}l(u){const m=this.c.get(u);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$iic=E}),define(Ce[330],Ie([1,0,4,35,2,6,15,7,43]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;class S{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,k,u,m,o,i){this.a=Math.random(),this.b=new I.$3d,this.c=new I.$3d,this.d=new I.$3d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,O.$Vj)(o),r=typeof o=="string",a=i?.correlate,t=m(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(a&&typeof d.session>"u")){if(!i?.ignoreCreateEvents)for(const c of d.created){const s=$.URI.revive(c);n(s.fsPath)&&(!r||k.getWorkspaceFolder(s))&&this.b.fire(s)}if(!i?.ignoreChangeEvents)for(const c of d.changed){const s=$.URI.revive(c);n(s.fsPath)&&(!r||k.getWorkspaceFolder(s))&&this.c.fire(s)}if(!i?.ignoreDeleteEvents)for(const c of d.deleted){const s=$.URI.revive(c);n(s.fsPath)&&(!r||k.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=v.$XL.from(this.i(E,u,o,i,i?.correlate),this.b,this.c,this.d,t)}i(E,k,u,m,o){const i=v.$XL.from();if(typeof u=="string")return i;const n=E.getProxy(A.$VL.MainThreadFileSystemEventService);let r=!1;return(u.pattern.includes(O.$Rj)||u.pattern.includes(O.$Sj))&&(r=!0),n.$watch(k.identifier.value,this.a,u.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),v.$XL.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class L{constructor(E){this.a=E,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map($.URI.revive)),this.c=new p.$V(()=>this.a.changed.map($.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map($.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(E,k,u){this.j=E,this.k=k,this.l=u,this.a=new I.$3d,this.b=new I.$3d,this.c=new I.$3d,this.d=new I.$3d,this.g=new I.$5d,this.h=new I.$5d,this.i=new I.$5d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,k,u,m){return new S(this.j,E,k,this.a.event,R.GlobPattern.from(u),m)}$onFileEvent(E){this.a.fire(new L(E))}$onDidRunFileOperation(E,k){switch(E){case 2:this.b.fire(Object.freeze({files:k.map(u=>({oldUri:$.URI.revive(u.source),newUri:$.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:k.map(u=>$.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:k.map(u=>$.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,k){return(u,m,o)=>{const i=function(r){u.call(m,r)};return i.extension=E,k.event(i,void 0,o)}}async $onWillRunFileOperation(E,k,u,m){switch(E){case 2:return await this.n(this.g,{files:k.map(o=>({oldUri:$.URI.revive(o.source),newUri:$.URI.revive(o.target)}))},u,m);case 1:return await this.n(this.i,{files:k.map(o=>$.URI.revive(o.target))},u,m);case 0:case 3:return await this.n(this.h,{files:k.map(o=>$.URI.revive(o.target))},u,m)}}async n(E,k,u,m){const o=new Set,i=[];if(await E.fireAsync(k,m,async(r,a)=>{const t=Date.now(),d=await Promise.resolve(r);d instanceof v.$8L&&(i.push([a.extension,d]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",a.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=R.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$jic=C}),define(Ce[331],Ie([1,0,19,8,22,14,121,3,24,38,12,18,2,29,170,83,131,215,26,15,7,25,110,6]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class c{constructor(W,x){this.d=W,this.e=x}async provideDocumentSymbols(W,x){const H=this.d.getDocument(W),Q=await this.e.provideDocumentSymbols(H,x);if(!(0,I.$Kb)(Q))return Q[0]instanceof r.$eM?Q.map(n.DocumentSymbol.from):c.f(Q)}static f(W){W=W.slice(0).sort((Q,oe)=>{let ve=Q.location.range.start.compareTo(oe.location.range.start);return ve===0&&(ve=oe.location.range.end.compareTo(Q.location.range.end)),ve});const x=[],H=[];for(const Q of W){const oe={name:Q.name||"!!MISSING: name!!",kind:n.SymbolKind.from(Q.kind),tags:Q.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:n.Range.from(Q.location.range),selectionRange:n.Range.from(Q.location.range),children:[]};for(;;){if(H.length===0){H.push(oe),x.push(oe);break}const ve=H[H.length-1];if(E.$4s.containsRange(ve.range,oe.range)&&!E.$4s.equalsRange(ve.range,oe.range)){ve.children?.push(oe),H.push(oe);break}H.pop()}}return x}}class s{constructor(W,x,H,Q,oe,ve){this.f=W,this.g=x,this.h=H,this.j=Q,this.k=oe,this.l=ve,this.d=new t.$4gc("CodeLens"),this.e=new Map}async provideCodeLenses(W,x){const H=this.f.getDocument(W),Q=await this.h.provideCodeLenses(H,x);if(!Q||x.isCancellationRequested)return;const oe=this.d.add(Q),ve=new v.$Sc;this.e.set(oe,ve);const Le={cacheId:oe,lenses:[]};for(let qe=0;qe<Q.length;qe++)Le.lenses.push({cacheId:[oe,qe],range:n.Range.from(Q[qe].range),command:this.g.toInternal(Q[qe].command,ve)});return Le}async resolveCodeLens(W,x){const H=W.cacheId&&this.d.get(...W.cacheId);if(!H)return;let Q;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?Q=H:Q=await this.h.resolveCodeLens(H,x),Q||(Q=H),x.isCancellationRequested)return;const oe=W.cacheId&&this.e.get(W.cacheId[0]);if(oe){if(!Q.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return W.command=this.g.toInternal(Q.command,oe),W}}releaseCodeLenses(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}}function l(Fe){return Array.isArray(Fe)?Fe.map(n.DefinitionLink.from):Fe?[n.DefinitionLink.from(Fe)]:[]}class h{constructor(W,x){this.d=W,this.e=x}async provideDefinition(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideDefinition(Q,oe,H);return l(ve)}}class b{constructor(W,x){this.d=W,this.e=x}async provideDeclaration(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideDeclaration(Q,oe,H);return l(ve)}}class D{constructor(W,x){this.d=W,this.e=x}async provideImplementation(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideImplementation(Q,oe,H);return l(ve)}}class g{constructor(W,x){this.d=W,this.e=x}async provideTypeDefinition(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideTypeDefinition(Q,oe,H);return l(ve)}}class f{constructor(W,x){this.d=W,this.e=x}async provideHover(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideHover(Q,oe,H);if(!(!ve||(0,I.$Kb)(ve.contents)))return ve.range||(ve.range=Q.getWordRangeAtPosition(oe)),ve.range||(ve.range=new r.$ZL(oe,oe)),n.Hover.from(ve)}}class y{constructor(W,x){this.d=W,this.e=x}async provideEvaluatableExpression(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideEvaluatableExpression(Q,oe,H);if(ve)return n.EvaluatableExpression.from(ve)}}class P{constructor(W,x){this.d=W,this.e=x}async provideInlineValues(W,x,H,Q){const oe=this.d.getDocument(W),ve=await this.e.provideInlineValues(oe,n.Range.to(x),n.InlineValueContext.to(H),Q);if(Array.isArray(ve))return ve.map(Le=>n.InlineValue.from(Le))}}class N{constructor(W,x){this.d=W,this.e=x}async provideDocumentHighlights(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideDocumentHighlights(Q,oe,H);if(Array.isArray(ve))return ve.map(n.DocumentHighlight.from)}}class U{constructor(W,x){this.d=W,this.e=x}async provideMultiDocumentHighlights(W,x,H,Q){const oe=this.d.getDocument(W),ve=H.map(Ge=>this.d.getDocument(Ge)),Le=n.Position.to(x),qe=await this.e.provideMultiDocumentHighlights(oe,Le,ve,Q);if(Array.isArray(qe))return qe.map(n.MultiDocumentHighlight.from)}}class z{constructor(W,x){this.d=W,this.e=x}async provideLinkedEditingRanges(W,x,H){const Q=this.d.getDocument(W),oe=n.Position.to(x),ve=await this.e.provideLinkedEditingRanges(Q,oe,H);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,I.$Hb)(ve.ranges.map(n.Range.from)),wordPattern:ve.wordPattern}}}class F{constructor(W,x){this.d=W,this.e=x}async provideReferences(W,x,H,Q){const oe=this.d.getDocument(W),ve=n.Position.to(x),Le=await this.e.provideReferences(oe,ve,H,Q);if(Array.isArray(Le))return Le.map(n.location.from)}}class M{static{this.d=1e3}constructor(W,x,H,Q,oe,ve,Le){this.g=W,this.h=x,this.j=H,this.k=Q,this.l=oe,this.m=ve,this.n=Le,this.e=new t.$4gc("CodeAction"),this.f=new Map}async provideCodeActions(W,x,H,Q){const oe=this.g.getDocument(W),ve=k.$6s.isISelection(x)?n.Selection.to(x):n.Range.to(x),Le=[];for(const ot of this.j.getDiagnostics(W))if(ve.intersection(ot.range)&&Le.push(ot)>M.d)break;const qe={diagnostics:Le,only:H.only?new r.$gM(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},Ge=await this.k.provideCodeActions(oe,ve,qe,Q);if(!(0,I.$Lb)(Ge)||Q.isCancellationRequested)return;const Ye=this.e.add(Ge),it=new v.$Sc;this.f.set(Ye,it);const ut=[];for(let ot=0;ot<Ge.length;ot++){const et=Ge[ot];if(et)if(M.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,it)});else{qe.only&&(et.kind?qe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${qe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Re=et.ranges??[];ut.push({cacheId:[Ye,ot],title:et.title,command:et.command&&this.h.toInternal(et.command,it),diagnostics:et.diagnostics&&et.diagnostics.map(n.Diagnostic.from),edit:et.edit&&n.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,a.$RF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,a.$RF)(this.m,"codeActionRanges")?(0,I.$Hb)(Re.map(n.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ye,actions:ut}}async resolveCodeAction(W,x){const[H,Q]=W,oe=this.e.get(H,Q);if(!oe||M.o(oe))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(oe,x)??oe;let Le;ve.edit&&(Le=n.WorkspaceEdit.from(ve.edit,void 0));let qe;if(ve.command){const Ge=this.f.get(H);Ge&&(qe=this.h.toInternal(ve.command,Ge))}return{edit:Le,command:qe}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}class T{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,Q,oe){this.d=W,this.e=x,this.f=H,this.g=Q,this.h=oe}async prepareDocumentPaste(W,x,H,Q){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(W),ve=x.map(Ge=>n.Range.to(Ge)),Le=n.DataTransfer.toDataTransfer(H,()=>{throw new A.$$});if(await this.f.prepareDocumentPaste(oe,ve,Le,Q),Q.isCancellationRequested)return;const qe=Array.from(Le).filter(([,Ge])=>!(Ge instanceof r.$MM));return n.DataTransfer.from(qe)}async providePasteEdits(W,x,H,Q,oe){if(!this.f.provideDocumentPasteEdits)return;const ve=this.e.getDocument(x),Le=H.map(Ye=>n.Range.to(Ye)),qe=n.DataTransfer.toDataTransfer(Q,async Ye=>(await this.d.$resolvePasteFileData(this.g,W,Ye)).buffer),Ge=await this.f.provideDocumentPasteEdits(ve,Le,qe,oe);if(Ge)return{label:Ge.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ge.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:T.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?n.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class j{constructor(W,x){this.d=W,this.e=x}async provideDocumentFormattingEdits(W,x,H){const Q=this.d.getDocument(W),oe=await this.e.provideDocumentFormattingEdits(Q,x,H);if(Array.isArray(oe))return oe.map(n.TextEdit.from)}}class J{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeFormattingEdits(W,x,H,Q){const oe=this.d.getDocument(W),ve=n.Range.to(x),Le=await this.e.provideDocumentRangeFormattingEdits(oe,ve,H,Q);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,x,H,Q){(0,C.$1f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(W),ve=x.map(n.Range.to),Le=await this.e.provideDocumentRangesFormattingEdits(oe,ve,H,Q);if(Array.isArray(Le))return Le.map(n.TextEdit.from)}}class ne{constructor(W,x){this.d=W,this.e=x,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,x,H,Q,oe){const ve=this.d.getDocument(W),Le=n.Position.to(x),qe=await this.e.provideOnTypeFormattingEdits(ve,Le,H,Q,oe);if(Array.isArray(qe))return qe.map(n.TextEdit.from)}}class _{constructor(W,x){this.e=W,this.f=x,this.d=new t.$4gc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,x){const H=await this.e.provideWorkspaceSymbols(W,x);if(!(0,I.$Lb)(H))return{symbols:[]};const Q=this.d.add(H),oe={cacheId:Q,symbols:[]};for(let ve=0;ve<H.length;ve++){const Le=H[ve];if(!Le||!Le.name){this.f.warn("INVALID SymbolInformation",Le);continue}oe.symbols.push({...n.WorkspaceSymbol.from(Le),cacheId:[Q,ve]})}return oe}async resolveWorkspaceSymbol(W,x){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const H=this.d.get(...W.cacheId);if(H){const Q=await this.e.resolveWorkspaceSymbol(H,x);return Q&&(0,p.$In)(W,n.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class Z{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideRenameEdits(W,x,H,Q){const oe=this.d.getDocument(W),ve=n.Position.to(x);try{const Le=await this.e.provideRenameEdits(oe,ve,H,Q);return Le?n.WorkspaceEdit.from(Le):void 0}catch(Le){const qe=Z.g(Le);return qe?{rejectReason:qe,edits:void 0}:Promise.reject(Le)}}async resolveRenameLocation(W,x,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(W),oe=n.Position.to(x);try{const ve=await this.e.prepareRename(Q,oe,H);let Le,qe;if(r.$ZL.isRange(ve)?(Le=ve,qe=Q.getText(ve)):(0,C.$Sf)(ve)&&(Le=ve.range,qe=ve.placeholder),!Le||!qe)return;if(Le.start.line>oe.line||Le.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Le),text:qe}}catch(ve){const Le=Z.g(ve);return Le?{rejectReason:Le,range:void 0,text:void 0}:Promise.reject(ve)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideNewSymbolNames(W,x,H){const Q=this.d.getDocument(W),oe=n.Range.to(x);try{const ve=await this.e.provideNewSymbolNames(Q,oe,H);return ve?ve.map(Le=>typeof Le=="string"?{newSymbolName:Le}:{newSymbolName:Le.newSymbolName,tags:Le.tags}):void 0}catch(ve){this.f.error(Y.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class ce{constructor(W,x){this.resultId=W,this.tokens=x}}class ie{constructor(W,x){this.f=W,this.g=x,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,x,H){const Q=this.f.getDocument(W),oe=x!==0?this.d.get(x):null;let ve=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,oe.resultId,H):await this.g.provideDocumentSemanticTokens(Q,H);return oe&&this.d.delete(x),ve?(ve=ie.h(ve),this.o(ie.n(oe,ve),ve)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return ie.j(W)?ie.k(W)?W:new r.$eN(new Uint32Array(W.data),W.resultId):ie.l(W)?ie.m(W)?W:new r.$gN(W.edits.map(x=>new r.$fN(x.start,x.deleteCount,x.data?new Uint32Array(x.data):x.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const x of W.edits)if(!(x.data instanceof Uint32Array))return!1;return!0}static n(W,x){if(!ie.j(x)||!W||!W.tokens)return x;const H=W.tokens,Q=H.length,oe=x.data,ve=oe.length;let Le=0;const qe=Math.min(Q,ve);for(;Le<qe&&H[Le]===oe[Le];)Le++;if(Le===Q&&Le===ve)return new r.$gN([],x.resultId);let Ge=0;const Ye=qe-Le;for(;Ge<Ye&&H[Q-Ge-1]===oe[ve-Ge-1];)Ge++;return new r.$gN([{start:Le,deleteCount:Q-Le-Ge,data:oe.subarray(Le,ve-Ge)}],x.resultId)}o(W,x){if(ie.j(W)){const H=this.e++;return this.d.set(H,new ce(W.resultId,W.data)),(0,m.$I_)({id:H,type:"full",data:W.data})}if(ie.l(W)){const H=this.e++;return ie.j(x)?this.d.set(H,new ce(x.resultId,x.data)):this.d.set(H,new ce(W.resultId)),(0,m.$I_)({id:H,type:"delta",deltas:(W.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class fe{constructor(W,x){this.d=W,this.e=x}async provideDocumentRangeSemanticTokens(W,x,H){const Q=this.d.getDocument(W),oe=await this.e.provideDocumentRangeSemanticTokens(Q,n.Range.to(x),H);return oe?this.f(oe):null}f(W){return(0,m.$I_)({id:0,type:"full",data:W.data})}}class re{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,x,H,Q,oe){this.f=W,this.g=x,this.h=H,this.j=Q,this.k=oe,this.d=new t.$4gc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,x,H,Q){const oe=this.f.getDocument(W),ve=n.Position.to(x),Le=oe.getWordRangeAtPosition(ve)||new r.$ZL(ve,ve),qe=Le.with({end:ve}),Ge=new S.$Yd,Ye=await this.h.provideCompletionItems(oe,ve,Q,n.CompletionContext.to(H));if(!Ye||Q.isCancellationRequested)return;const it=Array.isArray(Ye)?new r.$tM(Ye):Ye,ut=re.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),ot=new v.$Sc;this.e.set(ut,ot);const et=[],Re={x:ut,b:et,a:{replace:n.Range.from(Le),insert:n.Range.from(qe)},c:it.isIncomplete||void 0,d:Ge.elapsed()};for(let ke=0;ke<it.items.length;ke++){const He=it.items[ke],ee=this.l(He,[ut,ke],qe,Le);et.push(ee)}return Re}async resolveCompletionItem(W,x){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...W);if(!H)return;const Q=this.l(H,W),oe=await this.h.resolveCompletionItem(H,x);if(!oe)return;const ve=this.l(oe,W);return(Q.h!==ve.h||Q.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==ve.n||Q.o!==ve.o||!(0,p.$Jn)(Q.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x,H,Q){const oe=this.e.get(x[0]);if(!oe)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(W.command,oe),Le={x,a:W.label,b:W.kind!==void 0?n.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(n.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:n.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(n.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Le.h=W.textEdit.newText):typeof W.insertText=="string"?Le.h=W.insertText:W.insertText instanceof r.$9L&&(Le.h=W.insertText.value,Le.i|=4);let qe;return W.textEdit?qe=W.textEdit.range:W.range&&(qe=W.range),r.$ZL.isRange(qe)?Le.j=n.Range.from(qe):qe&&(!H?.isEqual(qe.inserting)||!Q?.isEqual(qe.replacing))&&(Le.j={insert:n.Range.from(qe.inserting),replace:n.Range.from(qe.replacing)}),Le}}class K{async provideInlineCompletions(W,x,H,Q){}disposeCompletions(W){}handleDidShowCompletionItem(W,x,H){}handlePartialAccept(W,x,H){}}class B extends K{constructor(W,x,H,Q){super(),this.f=W,this.g=x,this.h=H,this.j=Q,this.d=new ae,this.e=(0,a.$RF)(this.f,"inlineCompletionsAdditions"),this.k={[u.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[u.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,a.$RF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,x,H,Q){const oe=this.g.getDocument(W),ve=n.Position.to(x),Le=await this.h.provideInlineCompletionItems(oe,ve,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},Q);if(!Le||Q.isCancellationRequested)return;const qe=Array.isArray(Le)?Le:Le.items,Ge=this.e?Array.isArray(Le)?[]:Le.commands||[]:[],Ye=this.e&&!Array.isArray(Le)?Le.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:qe}),items:qe.map((ot,et)=>{let Re;ot.command&&(it||(it=new v.$Sc),Re=this.j.toInternal(ot.command,it));const ke=ot.insertText;return{insertText:typeof ke=="string"?ke:{snippet:ke.value},filterText:ot.filterText,range:ot.range?n.Range.from(ot.range):void 0,command:Re,idx:et,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Ge.map(ot=>(it||(it=new v.$Sc),this.j.toInternal(ot,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,x,H){const Q=this.d.get(W)?.items[x];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,H)}handlePartialAccept(W,x,H){const Q=this.d.get(W)?.items[x];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,H)}}class ae{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const x=this.e++;return this.d.set(x,W),x}disposeReferenceId(W){const x=this.d.get(W);return this.d.delete(W),x}get(W){return this.d.get(W)}}class ye{constructor(W,x){this.e=W,this.f=x,this.d=new t.$4gc("SignatureHelp")}async provideSignatureHelp(W,x,H,Q){const oe=this.e.getDocument(W),ve=n.Position.to(x),Le=this.g(H),qe=await this.f.provideSignatureHelp(oe,ve,Q,Le);if(qe){const Ge=this.d.add([qe]);return{...n.SignatureHelp.from(qe),id:Ge}}}g(W){let x;if(W.activeSignatureHelp){const H=n.SignatureHelp.to(W.activeSignatureHelp),Q=this.d.get(W.activeSignatureHelp.id,0);Q?(x=Q,x.activeSignature=H.activeSignature,x.activeParameter=H.activeParameter):x=H}return{...W,activeSignatureHelp:x}}releaseSignatureHelp(W){this.d.delete(W)}}class le{constructor(W,x,H,Q,oe){this.f=W,this.g=x,this.h=H,this.j=Q,this.k=oe,this.d=new t.$4gc("InlayHints"),this.e=new Map}async provideInlayHints(W,x,H){const Q=this.f.getDocument(W),oe=n.Range.to(x),ve=await this.h.provideInlayHints(Q,oe,H);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`);return}if(H.isCancellationRequested)return;const Le=this.d.add(ve);this.e.set(Le,new v.$Sc);const qe={hints:[],cacheId:Le};for(let Ge=0;Ge<ve.length;Ge++)this.l(ve[Ge],oe)&&qe.hints.push(this.m(ve[Ge],[Le,Ge]));return this.j.trace(`[InlayHints] ${qe.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(x)}`),qe}async resolveInlayHint(W,x){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...W);if(!H)return;const Q=await this.h.resolveInlayHint(H,x);if(Q&&this.l(Q))return this.m(Q,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,x){return W.label.length===0||Array.isArray(W.label)&&W.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(x&&!x.contains(W.position))}m(W,x){const H=this.e.get(x[0]);if(!H)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:x,tooltip:n.MarkdownString.fromStrict(W.tooltip),position:n.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(n.TextEdit.from),kind:W.kind&&n.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};if(typeof W.label=="string")Q.label=W.label;else{const oe=[];Q.label=oe;for(const ve of W.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Le={label:ve.value,tooltip:n.MarkdownString.fromStrict(ve.tooltip)};r.$0L.isLocation(ve.location)&&(Le.location=n.location.from(ve.location)),ve.command&&(Le.command=this.g.toInternal(ve.command,H)),oe.push(Le)}}return Q}}class de{constructor(W,x){this.e=W,this.f=x,this.d=new t.$4gc("DocumentLink")}async provideLinks(W,x){const H=this.e.getDocument(W),Q=await this.f.provideDocumentLinks(H,x);if(!(!Array.isArray(Q)||Q.length===0)&&!x.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(de.g).map(n.DocumentLink.from)};{const oe=this.d.add(Q),ve={links:[],cacheId:oe};for(let Le=0;Le<Q.length;Le++){if(!de.g(Q[Le]))continue;const qe=n.DocumentLink.from(Q[Le]);qe.cacheId=[oe,Le],ve.links.push(qe)}return ve}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,x){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...W);if(!H)return;const Q=await this.f.resolveDocumentLink(H,x);if(!(!Q||!de.g(Q)))return n.DocumentLink.from(Q)}releaseLinks(W){this.d.delete(W)}}class ue{constructor(W,x){this.d=W,this.e=x}async provideColors(W,x){const H=this.d.getDocument(W),Q=await this.e.provideDocumentColors(H,x);return Array.isArray(Q)?Q.map(ve=>({color:n.Color.from(ve.color),range:n.Range.from(ve.range)})):[]}async provideColorPresentations(W,x,H){const Q=this.d.getDocument(W),oe=n.Range.to(x.range),ve=n.Color.to(x.color),Le=await this.e.provideColorPresentations(ve,{document:Q,range:oe},H);if(Array.isArray(Le))return Le.map(n.ColorPresentation.from)}}class ge{constructor(W,x){this.d=W,this.e=x}async provideFoldingRanges(W,x,H){const Q=this.d.getDocument(W),oe=await this.e.provideFoldingRanges(Q,x,H);if(Array.isArray(oe))return oe.map(n.FoldingRange.from)}}class V{constructor(W,x,H){this.d=W,this.e=x,this.f=H}async provideSelectionRanges(W,x,H){const Q=this.d.getDocument(W),oe=x.map(n.Position.to),ve=await this.e.provideSelectionRanges(Q,oe,H);if(!(0,I.$Lb)(ve))return[];if(ve.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Le=[];for(let qe=0;qe<oe.length;qe++){const Ge=[];Le.push(Ge);let Ye=oe[qe],it=ve[qe];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(n.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Le}}class X{constructor(W,x){this.f=W,this.g=x,this.d=new R.$fO(""),this.e=new Map}async prepareSession(W,x,H){const Q=this.f.getDocument(W),oe=n.Position.to(x),ve=await this.g.prepareCallHierarchy(Q,oe,H);if(!ve)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ve)?ve.map(qe=>this.h(Le,qe)):[this.h(Le,ve)]}async provideCallsTo(W,x,H){const Q=this.j(W,x);if(!Q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(Q,H);if(oe)return oe.map(ve=>({from:this.h(W,ve.from),fromRanges:ve.fromRanges.map(Le=>n.Range.from(Le))}))}async provideCallsFrom(W,x,H){const Q=this.j(W,x);if(!Q)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(Q,H);if(oe)return oe.map(ve=>({to:this.h(W,ve.to),fromRanges:ve.fromRanges.map(Le=>n.Range.from(Le))}))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),Q=n.CallHierarchyItem.from(x,W,H.size.toString(36));return H.set(Q._itemId,x),Q}j(W,x){return this.e.get(W)?.get(x)}}class he{constructor(W,x){this.f=W,this.g=x,this.d=new R.$fO(""),this.e=new Map}async prepareSession(W,x,H){const Q=this.f.getDocument(W),oe=n.Position.to(x),ve=await this.g.prepareTypeHierarchy(Q,oe,H);if(!ve)return;const Le=this.d.nextId();return this.e.set(Le,new Map),Array.isArray(ve)?ve.map(qe=>this.h(Le,qe)):[this.h(Le,ve)]}async provideSupertypes(W,x,H){const Q=this.j(W,x);if(!Q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(Q,H);if(oe)return oe.map(ve=>this.h(W,ve))}async provideSubtypes(W,x,H){const Q=this.j(W,x);if(!Q)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(Q,H);if(oe)return oe.map(ve=>this.h(W,ve))}releaseSession(W){this.e.delete(W)}h(W,x){const H=this.e.get(W),Q=n.TypeHierarchyItem.from(x,W,H.size.toString(36));return H.set(Q._itemId,x),Q}j(W,x){return this.e.get(W)?.get(x)}}class be{static toInternalProviderId(W,x){return W+"."+x}constructor(W,x,H,Q,oe){this.d=W,this.e=x,this.f=H,this.g=Q,this.h=oe}async provideDocumentOnDropEdits(W,x,H,Q,oe){const ve=this.e.getDocument(x),Le=n.Position.to(H),qe=n.DataTransfer.toDataTransfer(Q,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,W,Ye)).buffer),Ge=await this.f.provideDocumentDropEdits(ve,Le,qe,oe);if(Ge)return{label:Ge.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ge.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:be.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Ge.insertText=="string"?Ge.insertText:{snippet:Ge.insertText.value},additionalEdit:Ge.additionalEdit?n.WorkspaceEdit.from(Ge.additionalEdit,void 0):void 0}}}class Pe{constructor(W,x){this.d=W,this.e=x}async provideMappedEdits(W,x,H,Q){const oe=w.URI.revive(W),ve=this.d.getDocument(oe),Le=H.documents.map(Ye=>Ye.map(it=>({uri:w.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(ut=>n.Range.to(ut))}))),qe={documents:Le,selections:Le[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(ve,x,qe,Q);return Ge?n.WorkspaceEdit.from(Ge):null}}class pe{constructor(W,x){this.adapter=W,this.extension=x}}class Ae{static{this.d=0}constructor(W,x,H,Q,oe,ve,Le,qe){this.g=x,this.h=H,this.j=Q,this.k=oe,this.l=ve,this.m=Le,this.n=qe,this.f=new Map,this.e=W.getProxy(d.$VL.MainThreadLanguageFeatures)}o(W,x){return n.DocumentSelector.from(W,this.g,x)}p(W){return new r.$XL(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return Ae.d++}async s(W,x,H,Q,oe,ve=!1){const Le=this.f.get(W);if(!Le||!(Le.adapter instanceof x))return Q;const qe=Date.now();ve||this.l.trace(`[${Le.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ge=H(Le.adapter,Le.extension);return Promise.resolve(Ge).catch(Ye=>{(0,A.$4)(Ye)||(this.l.error(`[${Le.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Le.extension.identifier,Ye))}).finally(()=>{ve||this.l.trace(`[${Le.extension.identifier.value}] provider DONE after ${Date.now()-qe}ms`)}),$.CancellationToken.isCancellationToken(oe)?(0,O.$4g)(Ge,oe):Ge}t(W,x){const H=this.q();return this.f.set(H,new pe(W,x)),H}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,x,H,Q){const oe=this.t(new c(this.h,H),W),ve=Q&&Q.label||Ae.u(W);return this.e.$registerDocumentSymbolProvider(oe,this.o(x,W),ve),this.p(oe)}$provideDocumentSymbols(W,x,H){return this.s(W,c,Q=>Q.provideDocumentSymbols(w.URI.revive(x),H),void 0,H)}registerCodeLensProvider(W,x,H){const Q=this.q(),oe=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new pe(new s(this.h,this.j.converter,H,W,this.n,this.l),W)),this.e.$registerCodeLensSupport(Q,this.o(x,W),oe);let ve=this.p(Q);if(oe!==void 0){const Le=H.onDidChangeCodeLenses(qe=>this.e.$emitCodeLensEvent(oe));ve=r.$XL.from(ve,Le)}return ve}$provideCodeLenses(W,x,H){return this.s(W,s,Q=>Q.provideCodeLenses(w.URI.revive(x),H),void 0,H)}$resolveCodeLens(W,x,H){return this.s(W,s,Q=>Q.resolveCodeLens(x,H),void 0,void 0)}$releaseCodeLenses(W,x){this.s(W,s,H=>Promise.resolve(H.releaseCodeLenses(x)),void 0,void 0)}registerDefinitionProvider(W,x,H){const Q=this.t(new h(this.h,H),W);return this.e.$registerDefinitionSupport(Q,this.o(x,W)),this.p(Q)}$provideDefinition(W,x,H,Q){return this.s(W,h,oe=>oe.provideDefinition(w.URI.revive(x),H,Q),[],Q)}registerDeclarationProvider(W,x,H){const Q=this.t(new b(this.h,H),W);return this.e.$registerDeclarationSupport(Q,this.o(x,W)),this.p(Q)}$provideDeclaration(W,x,H,Q){return this.s(W,b,oe=>oe.provideDeclaration(w.URI.revive(x),H,Q),[],Q)}registerImplementationProvider(W,x,H){const Q=this.t(new D(this.h,H),W);return this.e.$registerImplementationSupport(Q,this.o(x,W)),this.p(Q)}$provideImplementation(W,x,H,Q){return this.s(W,D,oe=>oe.provideImplementation(w.URI.revive(x),H,Q),[],Q)}registerTypeDefinitionProvider(W,x,H){const Q=this.t(new g(this.h,H),W);return this.e.$registerTypeDefinitionSupport(Q,this.o(x,W)),this.p(Q)}$provideTypeDefinition(W,x,H,Q){return this.s(W,g,oe=>oe.provideTypeDefinition(w.URI.revive(x),H,Q),[],Q)}registerHoverProvider(W,x,H,Q){const oe=this.t(new f(this.h,H),W);return this.e.$registerHoverProvider(oe,this.o(x,W)),this.p(oe)}$provideHover(W,x,H,Q){return this.s(W,f,oe=>oe.provideHover(w.URI.revive(x),H,Q),void 0,Q)}registerEvaluatableExpressionProvider(W,x,H,Q){const oe=this.t(new y(this.h,H),W);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(x,W)),this.p(oe)}$provideEvaluatableExpression(W,x,H,Q){return this.s(W,y,oe=>oe.provideEvaluatableExpression(w.URI.revive(x),H,Q),void 0,Q)}registerInlineValuesProvider(W,x,H,Q){const oe=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new P(this.h,H),W);this.e.$registerInlineValuesProvider(ve,this.o(x,W),oe);let Le=this.p(ve);if(oe!==void 0){const qe=H.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(oe));Le=r.$XL.from(Le,qe)}return Le}$provideInlineValues(W,x,H,Q,oe){return this.s(W,P,ve=>ve.provideInlineValues(w.URI.revive(x),H,Q,oe),void 0,oe)}registerDocumentHighlightProvider(W,x,H){const Q=this.t(new N(this.h,H),W);return this.e.$registerDocumentHighlightProvider(Q,this.o(x,W)),this.p(Q)}registerMultiDocumentHighlightProvider(W,x,H){const Q=this.t(new U(this.h,H),W);return this.e.$registerMultiDocumentHighlightProvider(Q,this.o(x,W)),this.p(Q)}$provideDocumentHighlights(W,x,H,Q){return this.s(W,N,oe=>oe.provideDocumentHighlights(w.URI.revive(x),H,Q),void 0,Q)}$provideMultiDocumentHighlights(W,x,H,Q,oe){return this.s(W,U,ve=>ve.provideMultiDocumentHighlights(w.URI.revive(x),H,Q.map(Le=>w.URI.revive(Le)),oe),void 0,oe)}registerLinkedEditingRangeProvider(W,x,H){const Q=this.t(new z(this.h,H),W);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(x,W)),this.p(Q)}$provideLinkedEditingRanges(W,x,H,Q){return this.s(W,z,async oe=>{const ve=await oe.provideLinkedEditingRanges(w.URI.revive(x),H,Q);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Ae.w(ve.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(W,x,H){const Q=this.t(new F(this.h,H),W);return this.e.$registerReferenceSupport(Q,this.o(x,W)),this.p(Q)}$provideReferences(W,x,H,Q,oe){return this.s(W,F,ve=>ve.provideReferences(w.URI.revive(x),H,Q,oe),void 0,oe)}registerCodeActionProvider(W,x,H,Q){const oe=new v.$Sc,ve=this.t(new M(this.h,this.j.converter,this.k,H,this.l,W,this.m),W);return this.e.$registerQuickFixSupport(ve,this.o(x,W),{providedKinds:Q?.providedCodeActionKinds?.map(Le=>Le.value),documentation:Q?.documentation?.map(Le=>({kind:Le.kind.value,command:this.j.converter.toInternal(Le.command,oe)}))},Ae.u(W),!!H.resolveCodeAction),oe.add(this.p(ve)),oe}$provideCodeActions(W,x,H,Q,oe){return this.s(W,M,ve=>ve.provideCodeActions(w.URI.revive(x),H,Q,oe),void 0,oe)}$resolveCodeAction(W,x,H){return this.s(W,M,Q=>Q.resolveCodeAction(x,H),{},void 0)}$releaseCodeActions(W,x){this.s(W,M,H=>Promise.resolve(H.releaseCodeActions(x)),void 0,void 0)}registerDocumentFormattingEditProvider(W,x,H){const Q=this.t(new j(this.h,H),W);return this.e.$registerDocumentFormattingSupport(Q,this.o(x,W),W.identifier,W.displayName||W.name),this.p(Q)}$provideDocumentFormattingEdits(W,x,H,Q){return this.s(W,j,oe=>oe.provideDocumentFormattingEdits(w.URI.revive(x),H,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(W,x,H){const Q=typeof H.provideDocumentRangesFormattingEdits=="function",oe=this.t(new J(this.h,H),W);return this.e.$registerRangeFormattingSupport(oe,this.o(x,W),W.identifier,W.displayName||W.name,Q),this.p(oe)}$provideDocumentRangeFormattingEdits(W,x,H,Q,oe){return this.s(W,J,ve=>ve.provideDocumentRangeFormattingEdits(w.URI.revive(x),H,Q,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(W,x,H,Q,oe){return this.s(W,J,ve=>ve.provideDocumentRangesFormattingEdits(w.URI.revive(x),H,Q,oe),void 0,oe)}registerOnTypeFormattingEditProvider(W,x,H,Q){const oe=this.t(new ne(this.h,H),W);return this.e.$registerOnTypeFormattingSupport(oe,this.o(x,W),Q,W.identifier),this.p(oe)}$provideOnTypeFormattingEdits(W,x,H,Q,oe,ve){return this.s(W,ne,Le=>Le.provideOnTypeFormattingEdits(w.URI.revive(x),H,Q,oe,ve),void 0,ve)}registerWorkspaceSymbolProvider(W,x){const H=this.t(new _(x,this.l),W);return this.e.$registerNavigateTypeSupport(H,typeof x.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(W,x,H){return this.s(W,_,Q=>Q.provideWorkspaceSymbols(x,H),{symbols:[]},H)}$resolveWorkspaceSymbol(W,x,H){return this.s(W,_,Q=>Q.resolveWorkspaceSymbol(x,H),void 0,void 0)}$releaseWorkspaceSymbols(W,x){this.s(W,_,H=>H.releaseWorkspaceSymbols(x),void 0,void 0)}registerRenameProvider(W,x,H){const Q=this.t(new Z(this.h,H,this.l),W);return this.e.$registerRenameSupport(Q,this.o(x,W),Z.supportsResolving(H)),this.p(Q)}$provideRenameEdits(W,x,H,Q,oe){return this.s(W,Z,ve=>ve.provideRenameEdits(w.URI.revive(x),H,Q,oe),void 0,oe)}$resolveRenameLocation(W,x,H,Q){return this.s(W,Z,oe=>oe.resolveRenameLocation(w.URI.revive(x),H,Q),void 0,Q)}registerNewSymbolNamesProvider(W,x,H){const Q=this.t(new Y(this.h,H,this.l),W);return this.e.$registerNewSymbolNamesProvider(Q,this.o(x,W)),this.p(Q)}$provideNewSymbolNames(W,x,H,Q){return this.s(W,Y,oe=>oe.provideNewSymbolNames(w.URI.revive(x),H,Q),void 0,Q)}registerDocumentSemanticTokensProvider(W,x,H,Q){const oe=this.t(new ie(this.h,H),W),ve=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(x,W),Q,ve);let Le=this.p(oe);if(ve){const qe=H.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(ve));Le=r.$XL.from(Le,qe)}return Le}$provideDocumentSemanticTokens(W,x,H,Q){return this.s(W,ie,oe=>oe.provideDocumentSemanticTokens(w.URI.revive(x),H,Q),null,Q)}$releaseDocumentSemanticTokens(W,x){this.s(W,ie,H=>H.releaseDocumentSemanticColoring(x),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,x,H,Q){const oe=this.t(new fe(this.h,H),W);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(x,W),Q),this.p(oe)}$provideDocumentRangeSemanticTokens(W,x,H,Q){return this.s(W,fe,oe=>oe.provideDocumentRangeSemanticTokens(w.URI.revive(x),H,Q),null,Q)}registerCompletionItemProvider(W,x,H,Q){const oe=this.t(new re(this.h,this.j.converter,H,this.m,W),W);return this.e.$registerCompletionsProvider(oe,this.o(x,W),Q,re.supportsResolving(H),W.identifier),this.p(oe)}$provideCompletionItems(W,x,H,Q,oe){return this.s(W,re,ve=>ve.provideCompletionItems(w.URI.revive(x),H,Q,oe),void 0,oe)}$resolveCompletionItem(W,x,H){return this.s(W,re,Q=>Q.resolveCompletionItem(x,H),void 0,H)}$releaseCompletionItems(W,x){this.s(W,re,H=>H.releaseCompletionItems(x),void 0,void 0)}registerInlineCompletionsProvider(W,x,H,Q){const oe=new B(W,this.h,H,this.j.converter),ve=this.t(oe,W);return this.e.$registerInlineCompletionsSupport(ve,this.o(x,W),oe.supportsHandleEvents,i.$um.toKey(W.identifier.value),Q?.yieldTo?.map(Le=>i.$um.toKey(Le))||[]),this.p(ve)}$provideInlineCompletions(W,x,H,Q,oe){return this.s(W,K,ve=>ve.provideInlineCompletions(w.URI.revive(x),H,Q,oe),void 0,oe)}$handleInlineCompletionDidShow(W,x,H,Q){this.s(W,K,async oe=>{oe.handleDidShowCompletionItem(x,H,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,x,H,Q){this.s(W,K,async oe=>{oe.handlePartialAccept(x,H,Q)},void 0,void 0)}$freeInlineCompletionsList(W,x){this.s(W,K,async H=>{H.disposeCompletions(x)},void 0,void 0)}registerSignatureHelpProvider(W,x,H,Q){const oe=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,ve=this.t(new ye(this.h,H),W);return this.e.$registerSignatureHelpProvider(ve,this.o(x,W),oe),this.p(ve)}$provideSignatureHelp(W,x,H,Q,oe){return this.s(W,ye,ve=>ve.provideSignatureHelp(w.URI.revive(x),H,Q,oe),void 0,oe)}$releaseSignatureHelp(W,x){this.s(W,ye,H=>H.releaseSignatureHelp(x),void 0,void 0)}registerInlayHintsProvider(W,x,H){const Q=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new le(this.h,this.j.converter,H,this.l,W),W);this.e.$registerInlayHintsProvider(oe,this.o(x,W),typeof H.resolveInlayHint=="function",Q,Ae.u(W));let ve=this.p(oe);if(Q!==void 0){const Le=H.onDidChangeInlayHints(qe=>this.e.$emitInlayHintsEvent(Q));ve=r.$XL.from(ve,Le)}return ve}$provideInlayHints(W,x,H,Q){return this.s(W,le,oe=>oe.provideInlayHints(w.URI.revive(x),H,Q),void 0,Q)}$resolveInlayHint(W,x,H){return this.s(W,le,Q=>Q.resolveInlayHint(x,H),void 0,H)}$releaseInlayHints(W,x){this.s(W,le,H=>H.releaseHints(x),void 0,void 0)}registerDocumentLinkProvider(W,x,H){const Q=this.t(new de(this.h,H),W);return this.e.$registerDocumentLinkProvider(Q,this.o(x,W),typeof H.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(W,x,H){return this.s(W,de,Q=>Q.provideLinks(w.URI.revive(x),H),void 0,H,x.scheme==="output")}$resolveDocumentLink(W,x,H){return this.s(W,de,Q=>Q.resolveLink(x,H),void 0,void 0,!0)}$releaseDocumentLinks(W,x){this.s(W,de,H=>H.releaseLinks(x),void 0,void 0,!0)}registerColorProvider(W,x,H){const Q=this.t(new ue(this.h,H),W);return this.e.$registerDocumentColorProvider(Q,this.o(x,W)),this.p(Q)}$provideDocumentColors(W,x,H){return this.s(W,ue,Q=>Q.provideColors(w.URI.revive(x),H),[],H)}$provideColorPresentations(W,x,H,Q){return this.s(W,ue,oe=>oe.provideColorPresentations(w.URI.revive(x),H,Q),void 0,Q)}registerFoldingRangeProvider(W,x,H){const Q=this.q(),oe=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new pe(new ge(this.h,H),W)),this.e.$registerFoldingRangeProvider(Q,this.o(x,W),W.identifier,oe);let ve=this.p(Q);if(oe!==void 0){const Le=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));ve=r.$XL.from(ve,Le)}return ve}$provideFoldingRanges(W,x,H,Q){return this.s(W,ge,oe=>oe.provideFoldingRanges(w.URI.revive(x),H,Q),void 0,Q)}registerSelectionRangeProvider(W,x,H){const Q=this.t(new V(this.h,H,this.l),W);return this.e.$registerSelectionRangeProvider(Q,this.o(x,W)),this.p(Q)}$provideSelectionRanges(W,x,H,Q){return this.s(W,V,oe=>oe.provideSelectionRanges(w.URI.revive(x),H,Q),[],Q)}registerCallHierarchyProvider(W,x,H){const Q=this.t(new X(this.h,H),W);return this.e.$registerCallHierarchyProvider(Q,this.o(x,W)),this.p(Q)}$prepareCallHierarchy(W,x,H,Q){return this.s(W,X,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(x),H,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(W,x,H,Q){return this.s(W,X,oe=>oe.provideCallsTo(x,H,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(W,x,H,Q){return this.s(W,X,oe=>oe.provideCallsFrom(x,H,Q),void 0,Q)}$releaseCallHierarchy(W,x){this.s(W,X,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerTypeHierarchyProvider(W,x,H){const Q=this.t(new he(this.h,H),W);return this.e.$registerTypeHierarchyProvider(Q,this.o(x,W)),this.p(Q)}$prepareTypeHierarchy(W,x,H,Q){return this.s(W,he,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(x),H,Q)),void 0,Q)}$provideTypeHierarchySupertypes(W,x,H,Q){return this.s(W,he,oe=>oe.provideSupertypes(x,H,Q),void 0,Q)}$provideTypeHierarchySubtypes(W,x,H,Q){return this.s(W,he,oe=>oe.provideSubtypes(x,H,Q),void 0,Q)}$releaseTypeHierarchy(W,x){this.s(W,he,H=>Promise.resolve(H.releaseSession(x)),void 0,void 0)}registerDocumentOnDropEditProvider(W,x,H,Q){const oe=this.q();this.f.set(oe,new pe(new be(this.e,this.h,H,oe,W),W));const ve=(0,a.$RF)(W,"dropMetadata")&&Q?be.toInternalProviderId(W.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(oe,this.o(x,W),ve,(0,a.$RF)(W,"dropMetadata")?Q:void 0),this.p(oe)}$provideDocumentOnDropEdits(W,x,H,Q,oe,ve){return this.s(W,be,Le=>Promise.resolve(Le.provideDocumentOnDropEdits(x,w.URI.revive(H),Q,oe,ve)),void 0,void 0)}registerMappedEditsProvider(W,x,H){const Q=this.t(new Pe(this.h,H),W);return this.e.$registerMappedEditsProvider(Q,this.o(x,W)),this.p(Q)}$provideMappedEdits(W,x,H,Q,oe){return this.s(W,Pe,ve=>Promise.resolve(ve.provideMappedEdits(x,H,Q,oe)),null,oe)}registerDocumentPasteEditProvider(W,x,H,Q){const oe=this.q();this.f.set(oe,new pe(new T(this.e,this.h,H,oe,W),W));const ve=T.toInternalProviderId(W.identifier.value,Q.id);return this.e.$registerPasteEditProvider(oe,this.o(x,W),ve,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(W,x,H,Q,oe){return this.s(W,T,ve=>ve.prepareDocumentPaste(w.URI.revive(x),H,Q,oe),void 0,oe)}$providePasteEdits(W,x,H,Q,oe,ve){return this.s(W,T,Le=>Le.providePasteEdits(x,w.URI.revive(H),Q,oe,ve),void 0,ve)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:Ae.w(W.decreaseIndentPattern),increaseIndentPattern:Ae.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Ae.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Ae.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:Ae.w(W.beforeText),afterText:W.afterText?Ae.w(W.afterText):void 0,previousLineText:W.previousLineText?Ae.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(Ae.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(x=>r.SyntaxTokenType.toString(x)):void 0}}static D(W){return W.map(Ae.C)}setLanguageConfiguration(W,x,H){const{wordPattern:Q}=H;if(Q&&(0,L.$6e)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(x,Q):this.h.setWordDefinitionFor(x,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const oe=this.q(),ve={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ae.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Ae.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ae.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ae.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(oe,x,ve),this.p(oe)}$setWordDefinitions(W){for(const x of W)this.h.setWordDefinitionFor(x.languageId,new RegExp(x.regexSource,x.regexFlags))}}e.$bhc=Ae}),define(Ce[332],Ie([1,0,6,15,7,39,8,3,25]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class S{constructor(C,w,E,k){this.c=w,this.d=E,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(I.$VL.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,w){await this.a.$changeLanguage(C,w);const E=this.c.getDocumentData(C);if(!E)throw new Error(`document '${C.toString()}' NOT found`);return E.document}async tokenAtPosition(C,w){const E=C.version,k=O.Position.from(w),u=await this.a.$tokensAtPosition(C.uri,k),m={type:$.StandardTokenType.Other,range:C.getWordRangeAtPosition(w)??new $.$ZL(w.line,w.character,w.line,w.character)};if(!u)return m;const o={range:O.Range.to(u.range),type:O.TokenType.to(u.type)};return!o.range.contains(w)||E!==C.version?m:o}createLanguageStatusItem(C,w,E){const k=this.f++,u=this.a,m=this.g,o=`${C.identifier.value}/${w}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);m.add(o);const i={selector:E,id:w,name:C.displayName??C.name,severity:$.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new v.$Sc,a=()=>{if(n?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${w}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$eh)(()=>{r.clear(),this.a.$setLanguageStatus(k,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:O.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===$.LanguageStatusSeverity.Error?A.default.Error:i.severity===$.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),u.$removeLanguageStatus(k),m.delete(o)},get id(){return i.id},get name(){return i.name},set name(d){i.name=d,a()},get selector(){return i.selector},set selector(d){i.selector=d,a()},get text(){return i.text},set text(d){i.text=d,a()},set text2(d){(0,p.$SF)(C,"languageStatusText"),i.text=d,a()},get text2(){return(0,p.$SF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(d){i.detail=d,a()},get severity(){return i.severity},set severity(d){i.severity=d,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(d){i.accessibilityInformation=d,a()},get command(){return i.command},set command(d){i.command=d,a()},get busy(){return i.busy},set busy(d){i.busy=d,a()}};return a(),t}}e.$Aic=S}),define(Ce[333],Ie([1,0,16,2,15,7,118]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=void 0;class v{constructor(C,w,E,k){this.start=C,this.deletedCount=w,this.deletedItems=E,this.items=k}asApiEvent(){return{range:new A.$lN(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(C,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,w,E){this.notebook=C,this.h=w,this.j=E,this.handle=E.handle,this.uri=O.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map($.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze($.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:$.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return C.g},set mime(k){C.g=k},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(E)}return this.f}setOutputs(C){this.a=C.map($.NotebookCellOutput.to)}setOutputItems(C,w,E){const k=E.map($.NotebookCellOutputItem.to),u=this.a.find(m=>m.id===C);if(u&&(w||(u.items.length=0),u.items.push(...k),u.items.length>1&&u.items.every(m=>R.$XJ(m.mime)))){const m=new Map,o=[];u.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),u.items.length=0,o.forEach(i=>{const n=R.$YJ(m.get(i));u.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze($.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$lic=p;class S{static{this.a=0}constructor(C,w,E,k,u){this.k=C,this.l=w,this.m=E,this.uri=k,this.handle=S.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,w={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===I.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(E){return E=C.n(E),C.b[E].apiCell},getCells(E){return(E?C.p(E):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,w,E){this.g=C.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:E});const k={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},u=[];for(const o of C.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,k.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,k.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),u.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),u.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<u.length;o++){const i=u[o],n=m.get(i.cell);if(n===void 0){const r=k.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,r-1)}else k.cellChanges[n]={...k.cellChanges[n],...i}}return Object.freeze(k),Object.freeze(k.cellChanges),Object.freeze(k.contentChanges),k}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let w=C.start|0,E=C.end|0;return w<0&&(w=0),E>this.b.length&&(E=this.b.length),C.with({start:w,end:E})}p(C){C=this.o(C);const w=[];for(let E=C.start;E<C.end;E++)w.push(this.b[E]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,w,E){if(this.j)return;const k=[],u=[],m=[];if(C.reverse().forEach(o=>{const n=o[2].map(t=>{const d=new p(this,this.l,t);return w||u.push(p.asModelAddData(this.apiNotebook,t)),d}),r=new v(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)m.push(t.uri),r.deletedItems.push(t.apiCell);k.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:m}),E)for(const o of k)E.push(o.asApiEvent())}s(C,w,E,k){const u=this.b.splice(C,w);this.b.splice(E,0,...u);const m=[new v(C,w,u.map(o=>o.apiCell),[]),new v(E,0,[],u)];for(const o of m)k.push(o.asApiEvent())}t(C,w){this.b[C].setOutputs(w)}u(C,w,E,k){this.b[C].setOutputItems(w,E,k)}v(C,w){const E=this.b[C];E.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(E.uri,w)}w(C,w){const E=this.b[C];E.apiCell.mime=w}x(C,w){this.b[C].setMetadata(w)}y(C,w){this.b[C].setInternalMetadata(w)}getCellFromApiCell(C){return this.b.find(w=>w.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(w=>w.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$mic=S}),define(Ce[334],Ie([1,0,4,2,15,7]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class R{constructor(p,S,L,C={timeout:1500,errors:3}){this.b=p,this.c=S,this.d=L,this.f=C,this.a=new I.$5d}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(S,L,C)=>{const w=function(k){S.call(L,k)};return w.extension=p,this.a.event(w,void 0,C)}}async $participateInSave(p,S,L){const C=O.URI.revive(p),w=this.c.getNotebookDocument(C);if(!w)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:$.TextDocumentSaveReason.to(S)},L,async(u,m)=>{const o=Date.now(),i=await await Promise.resolve(u);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!L.isCancellationRequested&&i&&(i instanceof A.$8L?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),L.isCancellationRequested)return!1;if(E.length===0)return!0;const k={edits:[]};for(const u of E){const{edits:m}=$.WorkspaceEdit.from(u);k.edits=k.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(k)}}e.$Cic=R}),define(Ce[150],Ie([1,0,14,15,7]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,p,S,L,C,w){this.id=v,this.f=p,this.notebookData=S,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=L,this.c=w}get apiEditor(){if(!this.e){const v=this;this.e={get notebook(){return v.notebookData.apiNotebook},get selection(){return v.a[0]},set selection(p){this.selections=[p]},get selections(){return v.a},set selections(p){if(!Array.isArray(p)||!p.every($.$lN.isNotebookRange))throw(0,I.$7)("selections");v.a=p,v.g(p)},get visibleRanges(){return v.b},revealRange(p,S){v.f.$tryRevealRange(v.id,O.NotebookRange.from(p),S??$.NotebookEditorRevealType.Default)},get viewColumn(){return v.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(v){this.d=v}_acceptVisibleRanges(v){this.b=v}_acceptSelections(v){this.a=v}g(v){this.f.$trySetSelections(this.id,v.map(O.NotebookRange.from))}_acceptViewColumn(v){this.c=v}}e.$nic=A}),define(Ce[335],Ie([1,0,4,13,15]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;let A=class{constructor(v,p){this.c=v,this.d=p,this.a=new I.$3d,this.b=new I.$3d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,p);const S=this.d.getEditorById(v);p.visibleRanges&&S._acceptVisibleRanges(p.visibleRanges.ranges.map($.NotebookRange.to)),p.selections&&S._acceptSelections(p.selections.selections.map($.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:S.apiEditor,visibleRanges:S.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:S.apiEditor,selections:S.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const p in v)this.d.getEditorById(p)._acceptViewColumn($.ViewColumn.to(v[p]))}};e.$Eic=A,e.$Eic=A=Ke([We(0,O.$wj)],A)}),define(Ce[336],Ie([1,0,4,6,150]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class A{constructor(v,p){this.c=p,this.a=new Map,this.b=v.getProxy(O.$VL.MainThreadNotebookRenderers)}$postRendererMessage(v,p,S){const L=this.c.getEditorById(v);this.a.get(p)?.fire({editor:L.apiEditor,message:S})}createRendererMessaging(v,p){if(!v.contributes?.notebookRenderer?.some(L=>L.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(L,C,w)=>this.d(p).event(L,C,w),postMessage:(L,C)=>{$.$nic.apiEditorsToExtHost.has(L)&&([L,C]=[C,L]);const w=C&&$.$nic.apiEditorsToExtHost.get(C);return this.b.$postMessage(w?.id,p,L)}}}d(v){let p=this.a.get(v);return p||(p=new I.$3d({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(v)}}),this.a.set(v,p),p)}}e.$Hic=A}),define(Ce[337],Ie([1,0,15,107,22,52,14]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class v{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,w,E){const k=this.b++,{title:u,location:m,cancellable:o}=w,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(k,{location:I.ProgressLocation.from(m),title:u,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(k,E,!!o)}d(C,w,E){let k;E&&(k=new $.$ae,this.c.set(C,k));const u=o=>{this.a.$progressEnd(o),this.c.delete(o),k?.dispose()};let m;try{m=w(new S(this.a,C),E&&k?k.token:$.CancellationToken.None)}catch(o){throw u(C),o}return m.then(o=>u(C),o=>u(C)),m}$acceptProgressCanceled(C){const w=this.c.get(C);w&&(w.cancel(),this.c.delete(C))}}e.$Lic=v;function p(L,C){return L.message=C.message,typeof C.increment=="number"&&(typeof L.increment=="number"?L.increment+=C.increment:L.increment=C.increment),L}class S extends O.$Ev{constructor(C,w){super(E=>this.throttledReport(E)),this.c=C,this.d=w}throttledReport(C){this.c.$progressReport(this.d,C)}}Ke([(0,A.$Ih)(100,(L,C)=>p(L,C),()=>Object.create(null))],S.prototype,"throttledReport",null)}),define(Ce[338],Ie([1,0,2,6,8,15]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class R{static{this.a=0}constructor(p,S){this.d=S,this.c=new Map,this.b=p.getProxy(O.$VL.MainThreadQuickDiff)}$provideOriginalResource(p,S,L){const C=I.URI.revive(S),w=this.c.get(p);return w?(0,$.$7g)(()=>w.provideOriginalResource(C,L)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,S,L,C){const w=R.a++;return this.c.set(w,S),this.b.$registerQuickDiffProvider(w,A.DocumentSelector.from(p,this.d),L,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$Mic=R}),define(Ce[339],Ie([1,0,22,4,3,6,2,7,14,19,39,55,25,15]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;function k(u,m,o){const i=u.getProxy(A.$VL.MainThreadQuickOpen);class n{constructor(b,D){this.e=new Map,this.f=0,this.a=b,this.b=D}showQuickPick(b,D,g,f=I.CancellationToken.None){this.c=void 0;const y=Promise.resolve(D),P=++this.f,N=i.$show(P,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},f),U={},z=N.then(()=>U);return Promise.race([z,y]).then(F=>{if(F===U)return;const M=(0,w.$RF)(b,"quickPickItemTooltip");return y.then(T=>{const j=[];for(let J=0;J<T.length;J++){const ne=T[J];if(typeof ne=="string")j.push({label:ne,handle:J});else if(ne.kind===v.QuickPickItemKind.Separator)j.push({type:"separator",label:ne.label});else{ne.tooltip&&!M&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const _=ne.iconPath?c(ne.iconPath):void 0;j.push({label:ne.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:ne.description,detail:ne.detail,picked:ne.picked,alwaysShow:ne.alwaysShow,tooltip:M?E.MarkdownString.fromStrict(ne.tooltip):void 0,handle:J})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=J=>{g.onDidSelectItem(T[J])}),i.$setItems(P,j),N.then(J=>{if(typeof J=="number")return T[J];if(Array.isArray(J))return J.map(ne=>T[ne])})})}).then(void 0,F=>{if(!(0,p.$4)(F))return i.$setError(P,F),Promise.reject(F)})}$onItemSelected(b){this.c?.(b)}showInput(b,D=I.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",D).then(void 0,g=>{if(!(0,p.$4)(g))return Promise.reject(g)})}async $validateInput(b){if(!this.d)return;const D=await this.d(b);if(!D||typeof D=="string")return D;let g;switch(D.severity){case v.InputBoxValidationSeverity.Info:g=L.default.Info;break;case v.InputBoxValidationSeverity.Warning:g=L.default.Warning;break;case v.InputBoxValidationSeverity.Error:g=L.default.Error;break;default:g=D.message?L.default.Error:L.default.Ignore;break}return{content:D.message,severity:g}}async showWorkspaceFolderPick(b,D=I.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!g)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(y=>y.uri.toString()===g.uri.toString())}createQuickPick(b){const D=new s(b,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(b){const D=new l(b,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(b,D){this.e.get(b)?._fireDidChangeValue(D)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,D){const g=this.e.get(b);g instanceof s&&g._fireDidChangeActive(D)}$onDidChangeSelection(b,D){const g=this.e.get(b);g instanceof s&&g._fireDidChangeSelection(D)}$onDidTriggerButton(b,D){this.e.get(b)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(b,D,g){const f=this.e.get(b);f instanceof s&&f._fireDidTriggerItemButton(D,g)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class r{static{this.a=1}constructor(b,D){this.x=b,this.y=D,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new O.$3d,this.q=new O.$3d,this.r=new O.$3d,this.s=new O.$3d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((D,g)=>{const f=D===v.$iN.Back?-1:g;this.o.set(f,D)}),this.z({buttons:b.map((D,g)=>({...c(D.iconPath),tooltip:D.tooltip,handle:D===v.$iN.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const D=this.o.get(b);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,$.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const D of Object.keys(b)){const g=b[D];this.u[D]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof v.$SM)return{id:h.id};const b=d(h),D=t(h);return{dark:typeof b=="string"?R.URI.file(b):b,light:typeof D=="string"?R.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function d(h){return typeof h=="object"&&"dark"in h?h.dark:h}function c(h){const b=a(h);let D,g;return"id"in b?g=C.ThemeIcon.asClassName(b):D=b,{iconPath:D,iconClass:g}}class s extends r{constructor(b,D){super(b.identifier,D),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new O.$3d,this.L=[],this.M=new O.$3d,this.N=new O.$3d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((f,y)=>{this.C.set(y,f),this.D.set(f,y)});const D=(0,w.$RF)(this.O,"quickPickItemTooltip"),g=[];for(let f=0;f<b.length;f++){const y=b[f];if(y.kind===v.QuickPickItemKind.Separator)g.push({type:"separator",label:y.label});else{y.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=y.iconPath?c(y.iconPath):void 0;g.push({handle:f,label:y.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:D?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((N,U)=>({...c(N.iconPath),tooltip:N.tooltip,handle:U}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(b){const D=(0,S.$Hb)(b.map(g=>this.C.get(g)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(b){const D=(0,S.$Hb)(b.map(g=>this.C.get(g)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(b,D){const g=this.C.get(b);if(!g||!g.buttons||!g.buttons.length)return;const f=g.buttons[D];f&&this.N.fire({button:f,item:g})}}class l extends r{constructor(b,D){super(b.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:L.default.Error}):this.z({validationMessage:b.message,severity:b.severity??L.default.Error}):this.z({validationMessage:void 0,severity:L.default.Ignore})}}return new n(m,o)}e.$Nic=k}),define(Ce[340],Ie([1,0,2,4,52,3,8,6,19,128,13,26,55,15,25,16,11]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;function i(P){return P instanceof I.URI}function n(P,N){return P.scheme===u.Schemas.file&&N.scheme===u.Schemas.file&&m.$k?P.toString()===N.toString():P.toString().toLowerCase()===N.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?I.URI.file(P.iconPath):I.URI.isUri(P.iconPath)||w.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function a(P){if(P.icon){if(I.URI.isUri(P.icon))return P.icon;if(w.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const N=P.icon;return{light:N.light,dark:N.dark}}}else return}function t(P,N){if(!P.iconPath&&!N.iconPath)return 0;if(P.iconPath){if(!N.iconPath)return 1}else return-1;const U=typeof P.iconPath=="string"?P.iconPath:I.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,z=typeof N.iconPath=="string"?N.iconPath:I.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,S.$2q)(U,z)}function d(P,N){let U=0;if(P.strikeThrough!==N.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==N.faded)return P.faded?1:-1;if(P.tooltip!==N.tooltip)return(P.tooltip||"").localeCompare(N.tooltip||"");if(U=t(P,N),U!==0)return U;if(P.light&&N.light)U=t(P.light,N.light);else{if(P.light)return 1;if(N.light)return-1}if(U!==0)return U;if(P.dark&&N.dark)U=t(P.dark,N.dark);else{if(P.dark)return 1;if(N.dark)return-1}return U}function c(P,N){if(P.command!==N.command)return P.command<N.command?-1:1;if(P.title!==N.title)return P.title<N.title?-1:1;if(P.tooltip!==N.tooltip){if(P.tooltip!==void 0&&N.tooltip!==void 0)return P.tooltip<N.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(P.arguments===N.arguments)return 0;if(P.arguments)if(N.arguments){if(P.arguments.length!==N.arguments.length)return P.arguments.length-N.arguments.length}else return 1;else return-1;for(let U=0;U<P.arguments.length;U++){const z=P.arguments[U],F=N.arguments[U];if(z!==F&&!(i(z)&&i(F)&&n(z,F)))return z<F?-1:1}return 0}function s(P,N){let U=(0,S.$2q)(P.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(U!==0)return U;if(P.command&&N.command)U=c(P.command,N.command);else{if(P.command)return 1;if(N.command)return-1}if(U!==0)return U;if(P.decorations&&N.decorations)U=d(P.decorations,N.decorations);else{if(P.decorations)return 1;if(N.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)U=(0,S.$2q)(P.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)U=(0,S.$2q)(P.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return U}function l(P,N){for(let U=0;U<P.length;U++)if(P[U]!==N[U])return!1;return!0}function h(P,N){return P.command===N.command&&P.title===N.title&&P.tooltip===N.tooltip&&(P.arguments&&N.arguments?l(P.arguments,N.arguments):P.arguments===N.arguments)}function b(P,N){return(0,p.$ub)(P,N,h)}class D{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,k.$SF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,k.$SF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,k.$SF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,U,z,F,M){this.k=N,this.l=F,this.m=M,this.d="",this.e=new O.$3d,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=z}showValidationMessage(N,U){(0,k.$SF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,U)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$Oic=D;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,U,z,F,M,T,j){this.q=N,this.s=U,this.t=z,this.u=F,this.v=M,this.multiDiffEditorEnableViewChanges=T,this.w=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new O.$3d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new O.$3d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,U){const z=this.h.get(N);return z?(0,R.$7g)(()=>this.s.executeCommand(z.command,...z.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(s),z=(0,p.$Db)(this.o,N,s).map(T=>{const j=T.toInsert.map(J=>{const ne=this.e++;this.g.set(ne,J);const _=J.resourceUri;let Z;if(J.command)if(J.command.command==="vscode.open"||J.command.command==="vscode.diff"||J.command.command==="vscode.changes"){const ge=new A.$Sc;Z=this.s.converter.toInternal(J.command,ge),this.j.set(ne,ge)}else this.h.set(ne,J.command);const Y=(0,k.$RF)(this.w,"scmMultiDiffEditor"),ce=Y?J.multiDiffEditorOriginalUri:void 0,ie=Y?J.multiFileDiffEditorModifiedUri:void 0,fe=r(J.decorations),re=J.decorations&&r(J.decorations.light)||fe,K=J.decorations&&r(J.decorations.dark)||fe,B=[re,K],ae=J.decorations&&J.decorations.tooltip||"",ye=J.decorations&&!!J.decorations.strikeThrough,le=J.decorations&&!!J.decorations.faded,de=J.contextValue||"";return{rawResource:[ne,_,B,ae,ye,le,de,Z,ce,ie],handle:ne}});return{start:T.start,deleteCount:T.deleteCount,toInsert:j}}),F=z.map(({start:T,deleteCount:j,toInsert:J})=>[T,j,J.map(ne=>ne.rawResource)]),M=z.reverse();for(const{start:T,deleteCount:j,toInsert:J}of M){const ne=J.map(Z=>Z.handle),_=this.n.splice(T,j,...ne);for(const Z of _)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=N,F}dispose(){this.l=!0,this.m.fire()}}class f{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let U;(0,k.$RF)(this.x,"quickDiffProvider")&&(U=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:U})}get historyProvider(){return(0,k.$SF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,k.$SF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new A.$Sc,this.o=N;const U=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,k.$SF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,k.$SF)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=N;const U=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(z=>z.map(F=>this.y.converter.toInternal(F,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&b(this.t,N))return;this.s.value=new A.$Sc,this.t=N;const U=(N||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(N,U,z,F,M,T,j){this.x=N,this.y=F,this.z=M,this.A=T,this.B=j,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new O.$3d,this.onDidChangeSelection=this.v.event,this.w=f.d++,this.C=new Map,this.D=new Set,this.#e=z;const J=I.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new D(N,U,this.#e,this.w,J),this.#e.$registerSourceControl(this.w,M,T,j,J)}createResourceGroup(N,U,z){const F=(0,k.$RF)(this.x,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,M=new g(this.#e,this.y,this.w,N,U,F,this.x),T=O.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,T),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const N=[],U=[];for(const[z,F]of this.C){F.dispose();const M=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});O.Event.once(z.onDidDispose)(()=>{this.D.delete(z),M.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),N.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const T=z._takeResourceStateSnapshot();T.length>0&&U.push([z.handle,T]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,N,U),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(U=>{const z=U._takeResourceStateSnapshot();z.length!==0&&N.push([U.handle,z])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ke([(0,$.$Hh)(100)],f.prototype,"eventuallyAddResourceGroups",null),Ke([(0,$.$Hh)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,U,z,F){this.l=U,this.m=z,this.n=F,this.g=new Map,this.h=new C.$wm,this.j=new O.$3d,this.e=N.getProxy(v.$VL.MainThreadSCM),this.f=N.getProxy(v.$VL.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const T=this.g.get(M.sourceControlHandle);if(!T)return M;const j=T.getResourceGroup(M.groupHandle);return j?j.getResourceState(M.handle):M}else if(M&&M.$mid===4){const T=this.g.get(M.sourceControlHandle);return T?T.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const T=this.g.get(M.handle);return T||M}return M}})}createSourceControl(N,U,z,F){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,U,z,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const M=o.d++,T=new f(N,this.m,this.e,this.l,U,z,F);this.g.set(M,T);const j=this.h.get(N.identifier)||[];return j.push(T),this.h.set(N.identifier,j),T}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const U=this.h.get(N.identifier),z=U&&U[U.length-1];return z&&z.inputBox}$provideOriginalResource(N,U,z){const F=I.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",N,F.toString());const M=this.g.get(N);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$7g)(()=>M.quickDiffProvider.provideOriginalResource(F,z)).then(T=>T||null)}$onInputBoxValueChange(N,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const z=this.g.get(N);return z&&z.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(N,U,z,F){this.n.trace("ExtHostSCM#$executeResourceCommand",N,U,z);const M=this.g.get(N);if(!M)return Promise.resolve(void 0);const T=M.getResourceGroup(U);return T?T.$executeResourceCommand(z,F):Promise.resolve(void 0)}$validateInput(N,U,z){this.n.trace("ExtHostSCM#$validateInput",N);const F=this.g.get(N);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,R.$7g)(()=>F.inputBox.validateInput(U,z)).then(M=>{if(!M)return Promise.resolve(void 0);const T=E.MarkdownString.fromStrict(M.message);return T?Promise.resolve([T,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,U,z,F){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,z,F)??void 0}async $provideHistoryItems(N,U,z,F){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(U,z,F))?.map(j=>({...j,icon:a(j)}))??void 0}async $provideHistoryItemSummary(N,U,z,F){const M=this.g.get(N)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const T=await M.provideHistoryItemSummary(U,z,F);return T?{...T,icon:a(T)}:void 0}async $provideHistoryItemChanges(N,U,z,F){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(U,z,F)??void 0}};e.$Pic=y,e.$Pic=y=o=Ke([We(3,L.$wj)],y)}),define(Ce[341],Ie([1,0,6,15,2]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class A{static{this.a=0}constructor(v,p){this.d=p,this.c=new Map,this.b=v.getProxy(I.$VL.MainThreadShare)}async $provideShare(v,p,S){return await this.c.get(v)?.provideShare({selection:O.Range.to(p.selection),resourceUri:$.URI.revive(p.resourceUri)},S)??void 0}registerShareProvider(v,p){const S=A.a++;return this.c.set(S,p),this.b.$registerShareProvider(S,O.DocumentSelector.from(v,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(S),this.c.delete(S)}}}}e.$Qic=A}),define(Ce[342],Ie([1,0,7,6,218,3,15,18]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new I.$TM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new I.$TM("statusBarItem.warningForeground")]])}#e;#t;constructor(w,E,k,u,m,o=I.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=w,this.#t=E,m&&u){this.c=(0,I.$wM)(u.identifier,m);const n=k.get(this.c);n&&(o=n.alignLeft?I.StatusBarAlignment.Left:I.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=u,this.f=m,this.g=o,this.h=this.u(i)}u(w){if((0,v.$Uf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!p.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let E;this.m?E=this.m:E=(0,$.localize)(0,null,this.e.displayName||this.e.name);let k=this.n;this.o&&(k=p.b.get(this.o.id));const u=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,E,this.k,u,this.r?.internal,k,this.o,this.g===I.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Sic=p;class S{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",I.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,$.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const E={message:w};return this.b.unshift(E),this.c(),new I.$XL(()=>{const k=this.b.indexOf(E);k>=0&&(this.b.splice(k,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class L{constructor(w,E){this.e=new Map,this.a=w.getProxy(O.$VL.MainThreadStatusBar),this.b=E,this.c=new S(this)}$acceptStaticEntries(w){for(const E of w)this.e.set(E.entryId,E)}createStatusBarEntry(w,E,k,u){return new p(this.a,this.b,this.e,w,E,k,u)}setStatusBarMessage(w,E){const k=this.c.setMessage(w);let u;return typeof E=="number"?u=setTimeout(()=>k.dispose(),E):typeof E<"u"&&E.then(()=>k.dispose(),()=>k.dispose()),new I.$XL(()=>{k.dispose(),clearTimeout(u)})}}e.$Tic=L}),define(Ce[151],Ie([1,0,29,141,68,111,89,15,2]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=e.$nO=e.$mO=void 0;const S=(n,r,a,t)=>{let d=r;return{enumerable:!0,configurable:!1,get(){return d},set(c){if(!a(d,c)){const s=d;d=c,n.listener?.(t(c,s))}}}},L=(n,r)=>n===r,C={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:L,description:L,sortText:L,busy:L,error:L,canResolveChildren:L,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},w=n=>r=>({op:4,update:n(r)}),E=(n,r)=>({range:(()=>{let a;const t=w(d=>({range:I.$4s.lift(v.Range.from(d))}));return{enumerable:!0,configurable:!1,get(){return a},set(d){n.listener?.({op:6}),C.range(a,d)||(a=d,n.listener?.(t(d)))}}})(),label:S(n,r,C.label,w(a=>({label:a}))),description:S(n,void 0,C.description,w(a=>({description:a}))),sortText:S(n,void 0,C.sortText,w(a=>({sortText:a}))),canResolveChildren:S(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:S(n,!1,C.busy,w(a=>({busy:a}))),error:S(n,void 0,C.error,w(a=>({error:v.MarkdownString.fromStrict(a)||null}))),tags:S(n,[],C.tags,(a,t)=>({op:1,new:a.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),k=n=>{const r=$.$MK.fromString(n.extId),a=new m(r.controllerId,r.localId,n.label,p.URI.revive(n.uri)||void 0);return a.range=v.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>v.TestTag.to({id:(0,R.$RK)(t).tagId})),a},u=n=>{let r;for(const a of n.tests){const t=k(a.item);(0,O.$9N)(t).parent=r,r=t}return r};e.$mO=u;class m{constructor(r,a,t,d){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const c=(0,O.$8N)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:d,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return c.parent instanceof o?void 0:c.parent}},children:{value:(0,A.$7N)(c,O.$9N,m),enumerable:!0,writable:!1},...E(c,t)})}}e.$nO=m;class o extends m{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$oO=o;class i extends A.$3N{constructor(r,a,t){super({controllerId:r,getDocumentVersion:d=>d&&t.getDocument(d)?.version,getApiFor:O.$9N,getChildren:d=>d.children,root:new o(r,a),toITestItem:v.TestItem.from})}}e.$pO=i}),define(Ce[33],Ie([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,151,21,69,44,38,87,90,30]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=void 0;let c=class{#e;#t;#i;constructor(g,f,y){this.b=new Map,this.c=new Map,this.#e=g.getProxy(R.$VL.MainThreadCommands),this.d=f,this.#i=y,this.#t=g.getProxy(R.$VL.MainThreadTelemetry),this.converter=new s(this,P=>{const N=this.c.get(P);return N?.result===h.Void?N:void 0},f),this.f=[{processArgument(P){return(0,S.$Lh)(P)}},{processArgument(P){return(0,A.$Hn)(P,function(N){if(L.$4s.isIRange(N))return $.Range.to(N);if(C.$3s.isIPosition(N))return $.Position.to(N);if(L.$4s.isIRange(N.range)&&w.URI.isUri(N.uri))return $.location.to(N);if(N instanceof o.$qe)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const f=this.registerCommand(!1,g.id,async(...y)=>{const P=g.args.map((U,z)=>{if(!U.validate(y[z]))throw new Error(`Invalid argument '${U.name}' when running '${g.id}', received: ${typeof y[z]=="object"?JSON.stringify(y[z],null,"	"):y[z]} `);return U.convert(y[z])}),N=await this.executeCommand(g.internalId,...P);return g.result.convert(N,y,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new O.$XL(()=>{f.dispose(),this.c.delete(g.id)})}registerCommand(g,f,y,P,N,U){if(this.d.trace("ExtHostCommands#registerCommand",f),!f.trim().length)throw new Error("invalid id");if(this.b.has(f))throw new Error(`command '${f}' already exists`);return this.b.set(f,{callback:y,thisArg:P,metadata:N,extension:U}),g&&this.#e.$registerCommand(f),new O.$XL(()=>{this.b.delete(f)&&g&&this.#e.$unregisterCommand(f)})}executeCommand(g,...f){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,f,!0)}async g(g,f,y){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,f,!1);{let P=!1;const N=(0,A.$Hn)(f,function(U){if(U instanceof O.$YL)return $.Position.from(U);if(U instanceof O.$ZL)return $.Range.from(U);if(U instanceof O.$0L)return $.location.from(U);if(O.$lN.isNotebookRange(U))return $.NotebookRange.from(U);if(U instanceof ArrayBuffer)return P=!0,o.$qe.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return P=!0,o.$qe.wrap(U);if(U instanceof o.$qe)return P=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(g,P?new i.$3v(N):N,y);return(0,S.$Lh)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(g,f,!1);throw U}}}async h(g,f,y){const P=this.b.get(g);if(!P)throw new Error("Unknown command");const{callback:N,thisArg:U,metadata:z}=P;if(z?.args)for(let M=0;M<z.args.length;M++)try{(0,I.$8f)(f[M],z.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${z.args[M].name}' - ${z.args[M].description}`)}const F=r.$Yd.create();try{return await N.apply(U,f)}catch(M){if(g===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...f);T&&(g=T.command)}if(this.d.error(M,g,P.extension?.identifier),!y)throw M;if(P.extension?.identifier){const T=this.#i.onExtensionError(P.extension.identifier,M);this.d.trace("forwarded error to extension?",T,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Zi)(M)),this.id=g,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,g,F.elapsed())}}j(g,f,y){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new a.$Uo(f),duration:y})}$executeContributedCommand(g,...f){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const y=this.b.get(g);return y?(f=f.map(P=>this.f.reduce((N,U)=>U.processArgument(N,y.extension?.identifier),P)),this.h(g,f,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(f=>(g&&(f=f.filter(y=>y[0]!=="_")),f))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[f,y]of this.b){const{metadata:P}=y;P&&(g[f]=P)}return Promise.resolve(g)}};e.$vO=c,e.$vO=c=Ke([We(0,u.$aO),We(1,p.$wj),We(2,t.$uO)],c),e.$wO=(0,k.$ci)("IExtHostCommands");class s{constructor(g,f,y){this.d=g,this.f=f,this.g=y,this.delegatingCommandId=`__vsc${(0,d.$yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,f){if(!g)return;const y={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return y;const P=this.f(g.command);if(P)y.id=P.internalId,y.arguments=P.args.map((N,U)=>N.convert(g.arguments&&g.arguments[U]));else if((0,v.$Lb)(g.arguments)){const N=`${g.command} /${++this.c}`;this.b.set(N,g),f.add((0,E.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),y.$ident=N,y.id=this.delegatingCommandId,y.arguments=[N],this.g.trace("CommandsConverter#CREATE",g.command,N)}return y}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const f=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],f?f.command:"MISSING"),f?this.d.executeCommand(f.command,...f.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$xO=s;class l{static{this.Uri=new l("uri","Uri of a text document",g=>w.URI.isUri(g),g=>g)}static{this.Position=new l("position","A position in a text document",g=>O.$YL.isPosition(g),$.Position.from)}static{this.Range=new l("range","A range in a text document",g=>O.$ZL.isRange(g),$.Range.from)}static{this.Selection=new l("selection","A selection in a text document",g=>O.$1L.isSelection(g),$.Selection.from)}static{this.Number=new l("number","",g=>typeof g=="number",g=>g)}static{this.String=new l("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=l.Arr(l.String)}static Arr(g){return new l(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,f=>Array.isArray(f)&&f.every(y=>g.validate(y)),f=>f.map(y=>g.convert(y)))}static{this.CallHierarchyItem=new l("item","A call hierarchy item",g=>g instanceof O.$iM,$.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new l("item","A type hierarchy item",g=>g instanceof O.$EN,$.TypeHierarchyItem.from)}static{this.TestItem=new l("testItem","A VS Code TestItem",g=>g instanceof m.$nO,$.TestItem.from)}constructor(g,f,y,P){this.name=g,this.description=f,this.validate=y,this.convert=P}optional(){return new l(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,f){return new l(g??this.name,f??this.description,this.validate,this.convert)}}e.$yO=l;class h{static{this.Void=new h("no result",g=>g)}constructor(g,f){this.description=g,this.convert=f}}e.$zO=h;class b{constructor(g,f,y,P,N){this.id=g,this.internalId=f,this.description=y,this.args=P,this.result=N}}e.$AO=b}),define(Ce[343],Ie([1,0,19,16,2,83,131,45,33,15,7]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;const C=[new p.$AO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of DocumentHighlight-instances.",E(S.DocumentHighlight.to))),new p.$AO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$yO.Uri],new p.$zO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,I.$Kb)(u))return;class o extends L.$dM{static to(n){const r=new o(n.name,S.SymbolKind.to(n.kind),n.containerName||"",new L.$0L(m[0],S.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=S.Range.to(n.selectionRange),r.children=n.children?n.children.map(o.to):[],r}}return u.map(o.to)})),new p.$AO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$yO.Uri,new p.$yO("options","Formatting options",u=>!0,u=>u)],new p.$zO("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$AO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$yO.Uri,p.$yO.Range,new p.$yO("options","Formatting options",u=>!0,u=>u)],new p.$zO("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$AO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$yO.Uri,p.$yO.Position,new p.$yO("ch","Trigger character",u=>typeof u=="string",u=>u),new p.$yO("options","Formatting options",u=>!0,u=>u)],new p.$zO("A promise that resolves to an array of TextEdits.",E(S.TextEdit.to))),new p.$AO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Location or LocationLink instances.",k)),new p.$AO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Location or LocationLink instances.",k)),new p.$AO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Location or LocationLink instances.",k)),new p.$AO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Location or LocationLink instances.",k)),new p.$AO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Location-instances.",E(S.location.to))),new p.$AO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of Hover-instances.",E(S.Hover.to))),new p.$AO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$yO.Uri,new p.$yO("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>L.$YL.isPosition(m)),u=>u.map(S.Position.from))],new p.$zO("A promise that resolves to an array of ranges.",u=>u.map(m=>{let o;for(const i of m.reverse())o=new L.$hM(S.Range.to(i),o);return o}))),new p.$AO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$yO.String.with("query","Search string")],new p.$zO("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(S.WorkspaceSymbol.to))),new p.$AO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(S.CallHierarchyItem.to))),new p.$AO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$yO.CallHierarchyItem],new p.$zO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(S.CallHierarchyIncomingCall.to))),new p.$AO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$yO.CallHierarchyItem],new p.$zO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(S.CallHierarchyOutgoingCall.to))),new p.$AO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:S.Range.to(u.range),placeholder:u.text}})),new p.$AO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$yO.Uri,p.$yO.Position,p.$yO.String.with("newName","The new symbol name")],new p.$zO("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return S.WorkspaceEdit.to(u)}})),new p.$AO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$yO.Uri,p.$yO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$zO("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(S.DocumentLink.to))),new p.$AO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$yO.Uri],new p.$zO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new L.$cN(u.tokenTypes,u.tokenModifiers)})),new p.$AO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$yO.Uri],new p.$zO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$J_)(u);if(m.type==="full")return new L.$eN(m.data,void 0)})),new p.$AO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$yO.Uri,p.$yO.Range.optional()],new p.$zO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new L.$cN(u.tokenTypes,u.tokenModifiers)})),new p.$AO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$yO.Uri,p.$yO.Range],new p.$zO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$J_)(u);if(m.type==="full")return new L.$eN(m.data,void 0)})),new p.$AO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$yO.Uri,p.$yO.Position,p.$yO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$yO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$zO("A promise that resolves to a CompletionList-instance.",(u,m,o)=>{if(!u)return new L.$tM([]);const i=u.suggestions.map(n=>S.CompletionItem.to(n,o));return new L.$tM(i,u.incomplete)})),new p.$AO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$yO.Uri,p.$yO.Position,p.$yO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$zO("A promise that resolves to SignatureHelp.",u=>{if(u)return S.SignatureHelp.to(u)})),new p.$AO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$yO.Uri,p.$yO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$zO("A promise that resolves to an array of CodeLens-instances.",(u,m,o)=>E(i=>new L.$lM(S.Range.to(i.range),i.command&&o.fromInternal(i.command)))(u))),new p.$AO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$yO.Uri,new p.$yO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>L.$ZL.isRange(u),u=>L.$1L.isSelection(u)?S.Selection.from(u):S.Range.from(u)),p.$yO.String.with("kind","Code action kind to return code actions for").optional(),p.$yO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$zO("A promise that resolves to an array of Command-instances.",(u,m,o)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new L.$fM(i.title,i.kind?new L.$gM(i.kind):void 0);return i.edit&&(n.edit=S.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(u))),new p.$AO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$yO.Uri],new p.$zO("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new L.$zM(S.Range.to(m.range),S.Color.to(m.color))):[])),new p.$AO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$yO("color","The color to show and insert",u=>u instanceof L.$yM,S.Color.from),new p.$yO("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:S.Range.from(u.range)}))],new p.$zO("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(S.ColorPresentation.to):[])),new p.$AO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$yO.Uri,p.$yO.Range],new p.$zO("A promise that resolves to an array of Inlay objects",(u,m,o)=>u.map(S.InlayHint.to.bind(void 0,o)))),new p.$AO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$yO.Uri],new p.$zO("A promise that resolves to an array of FoldingRange objects",(u,m)=>{if(u)return u.map(S.FoldingRange.to)})),new p.$AO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$zO("A promise that resolves to an array of NotebookContentProvider static info objects.",E(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>S.NotebookExclusiveDocumentPattern.to(m))})))),new p.$AO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$yO.Uri,p.$yO.Range,new p.$yO("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof L.$ZL,u=>S.InlineValueContext.from(u))],new p.$zO("A promise that resolves to an array of InlineValue objects",u=>u.map(S.InlineValue.to))),new p.$AO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$yO("uriOrString","Uri-instance or string (only http/https)",u=>$.URI.isUri(u)||typeof u=="string"&&(0,O.$ng)(u,O.Schemas.http,O.Schemas.https),u=>u),new p.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[S.ViewColumn.from(u),void 0]:[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)])).optional(),p.$yO.String.with("label","").optional()],p.$zO.Void),new p.$AO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$yO.Uri.with("resource","Resource to open"),p.$yO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[S.ViewColumn.from(u),void 0]:[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)])).optional()],p.$zO.Void),new p.$AO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$yO.Uri.with("left","Left-hand side resource of the diff editor"),p.$yO.Uri.with("right","Right-hand side resource of the diff editor"),p.$yO.String.with("title","Human readable title for the diff editor").optional(),new p.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[S.ViewColumn.from(u.viewColumn),S.TextEditorOpenOptions.from(u)]).optional()],p.$zO.Void),new p.$AO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$yO.String.with("title","Human readable title for the changes editor"),new p.$yO("resourceList","List of resources to compare",u=>{for(const m of u){if(m.length!==3)return!1;const[o,i,n]=m;if(!$.URI.isUri(o)||!$.URI.isUri(i)&&i!==void 0&&i!==null||!$.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},u=>u)],p.$zO.Void),new p.$AO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$yO.Uri,p.$yO.Position],new p.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new p.$AO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$yO.TypeHierarchyItem],new p.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new p.$AO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$yO.TypeHierarchyItem],new p.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(S.TypeHierarchyItem.to))),new p.$AO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$yO.TestItem],p.$zO.Void),new p.$AO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$yO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$zO.Void),new p.$AO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$yO.String.with("name","The context key name"),new p.$yO("value","The context key value",()=>!0,u=>u)],p.$zO.Void),new p.$AO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$yO.Uri,p.$yO.StringArray,new p.$yO("MappedEditsContext","Mapped Edits Context",u=>S.MappedEditsContext.is(u),u=>S.MappedEditsContext.from(u))],new p.$zO("A promise that resolves to a workspace edit or null",u=>u?S.WorkspaceEdit.to(u):null))];class w{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",v.$bj)}}e.$chc=w;function E(u){return m=>{if(Array.isArray(m))return m.map(u)}}function k(u){if(!Array.isArray(u))return;const m=[];for(const o of u)A.$Pt(o)?m.push(S.DefinitionLink.to(o)):m.push(S.location.to(o));return m}}),define(Ce[344],Ie([1,0,8,3,2,6,33,15,7]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class S{static{this.a=0}constructor(E,k){this.extension=E,this.provider=k,this.handle=S.a++}}class L{constructor(E){this.session=E,this.responses=[]}}class C{static{this.a=0}constructor(E,k,u,m){this.f=u,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(A.$VL.MainThreadInlineChat),k.registerApiCommand(new R.$AO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$yO("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?v.Range.from(o.initialRange):void 0,initialSelection:p.$1L.isSelection(o.initialSelection)?v.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?v.Position.from(o.position):void 0}})],R.$zO.Void))}registerProvider(E,k,u){const m=new S(E,k);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,u?.label??E.displayName??E.name,E.identifier.value,typeof k.handleInteractiveEditorResponseFeedback=="function",typeof k.provideFollowups=="function",u?.supportReportIssue??!1),(0,O.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,k,u,m){const o=this.b.get(E);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument($.URI.revive(k)),n=v.Selection.to(u),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new L(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:v.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,k,u,m){const o=this.b.get(E);if(!o)return;const i=this.d.get(k.id);if(!i)return;const n={prompt:u.prompt,selection:v.Selection.to(u.selection),wholeRange:v.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument($.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let r=!1;const a={report:async D=>{if(!u.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:D.message,edits:D.edits?.map(v.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$mM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,m));let d;try{d=await(0,I.$3g)(t,m)}finally{r=!0}if(!d)return;const c=i.responses.push(d)-1,s={wholeRange:v.Range.from(d.wholeRange),placeholder:d.placeholder};if(!C.h(d))return{...s,id:c,type:"editorEdit",message:v.MarkdownString.from(d.contents),edits:[]};const{edits:l,contents:h}=d,b=h!==void 0?v.MarkdownString.from(h):void 0;return l instanceof p.$8L?{...s,id:c,type:"bulkEdit",edits:v.WorkspaceEdit.from(l),message:b}:{...s,id:c,type:"editorEdit",edits:l.map(v.TextEdit.from),message:b}}async $provideFollowups(E,k,u,m){const o=this.b.get(E),i=this.d.get(k),n=i?.responses[u];if(o&&n&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(i.session,n,m));return(await(0,I.$3g)(r,m))?.map(v.ChatInlineFollowup.from)}}$handleFeedback(E,k,u,m){const o=this.b.get(E),i=this.d.get(k),n=i?.responses[u];if(o&&n){const r=v.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(E,k){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$kic=C}),define(Ce[345],Ie([1,0,2,33]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class ${constructor(R,v,p,S,L){this.a=v,this.b=p,this.c=S;const C=new O.$AO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new O.$yO("showOptions","Show Options",w=>!0,w=>w),new O.$yO("resource","Interactive resource Uri",w=>!0,w=>w),new O.$yO("controllerId","Notebook controller Id",w=>!0,w=>w),new O.$yO("title","Interactive editor title",w=>!0,w=>w)],new O.$zO("Notebook and input URI",w=>{if(L.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const E=this.a.getEditorById(w.notebookEditorId);return L.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:I.URI.revive(w.notebookUri),inputUri:I.URI.revive(w.inputUri),notebookEditor:E.apiEditor}}return L.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:I.URI.revive(w.notebookUri),inputUri:I.URI.revive(w.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,v,p,S){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(I.URI.revive(S))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,v){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$xic=$}),define(Ce[346],Ie([1,0,19,8,22,4,3,28,2,26,13,6,33,15,7,112,286,25,69,287]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;let r=class{constructor(b,D,g,f,y){this.m=D,this.n=g,this.o=f,this.q=y,this.b=new v.$Ac,this.c=new v.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$3d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(C.$VL.MainThreadNotebookKernels);const P=new w.$AO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$yO("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const z=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:z}}else if(U&&"notebookEditor"in U){const z=this.n.getIdByEditor(U.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return U})],w.$zO.Void),N=new w.$AO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[w.$yO.Uri],new w.$zO("A promise that resolves to an array of variables",(U,z)=>U.map(F=>({name:F.name,value:F.value,type:F.type,editable:!1}))));this.o.registerApiCommand(P),this.o.registerApiCommand(N)}createNotebookController(b,D,g,f,y,P){for(const fe of this.j.values())if(fe.controller.id===D&&S.$um.equals(b.identifier,fe.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this.k++,U=this;this.q.trace(`NotebookController[${N}], CREATED by ${b.identifier.value}, ${D}`);const z=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${b.identifier}'`);let F=!1;const M=new A.$3d,T=new A.$3d,j={id:l(b.identifier,D),notebookType:g,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:f||b.identifier.value,preloads:P?P.map(E.NotebookRendererScript.from):[]};let J=y??z,ne,_;this.a.$addKernel(N,j).catch(fe=>{console.log(fe),F=!0});let Z=0;const Y=()=>{if(F)return;const fe=++Z;Promise.resolve().then(()=>{fe===Z&&this.a.$updateKernel(N,j)})},ce=new v.$Ac,ie={get id(){return D},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return j.label},set label(fe){j.label=fe??b.displayName??b.name,Y()},get detail(){return j.detail??""},set detail(fe){j.detail=fe,Y()},get description(){return j.description??""},set description(fe){j.description=fe,Y()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(fe){j.supportedLanguages=fe,Y()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){j.supportsExecutionOrder=fe,Y()},get rendererScripts(){return j.preloads?j.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(fe){J=fe??z},get interruptHandler(){return ne},set interruptHandler(fe){ne=fe,j.supportsInterrupt=!!fe,Y()},set variableProvider(fe){(0,o.$SF)(b,"notebookVariableProvider"),_=fe,j.hasVariableProvider=!!fe,fe?.onDidChangeVariables(re=>U.a.$variablesUpdated(re.uri)),Y()},get variableProvider(){return _},createNotebookCellExecution(fe){if(F)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.notebook.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return U._createNotebookCellExecution(fe,l(b.identifier,this.id))},createNotebookExecution(fe){if((0,o.$SF)(b,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.uri))throw U.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.uri.toString()}`);return U._createNotebookExecution(fe,l(b.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${N}], DISPOSED`),F=!0,this.j.delete(N),M.dispose(),T.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(fe,re){re===k.NotebookControllerAffinity2.Hidden&&(0,o.$SF)(b,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(N,fe.uri,re)},onDidReceiveMessage:T.event,postMessage(fe,re){return(0,o.$SF)(b,"notebookMessaging"),U.a.$postMessage(N,re&&U.n.getIdByEditor(re),fe)},asWebviewUri(fe){return(0,o.$SF)(b,"notebookMessaging"),(0,u.$8wb)(fe,U.m.remote)}};return this.j.set(N,{extensionId:b.identifier,controller:ie,onDidReceiveMessage:T,onDidChangeSelection:M,associatedNotebooks:ce}),ie}getIdByController(b){for(const[D,g]of this.j)if(g.controller===b)return l(g.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,D){const g=this.g++,f=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(g,D);const y={dispose:()=>{this.f.delete(g),f.a.$removeKernelDetectionTask(g)}};return this.f.set(g,y),y}registerKernelSourceActionProvider(b,D,g){const f=this.i++,y=typeof g.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,P=this;this.h.set(f,g),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,D);let N;return y!==void 0&&(N=g.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(f),P.a.$removeKernelSourceActionProvider(f,f),N?.dispose()}}}async $provideKernelSourceActions(b,D){const g=this.h.get(b);if(g){const f=new R.$Sc;return(await g.provideNotebookKernelSourceActions(D)??[]).map(P=>E.NotebookKernelSourceAction.from(P,this.o.converter,f))}return[]}$acceptNotebookAssociation(b,D,g){const f=this.j.get(b);if(f){const y=this.n.getNotebookDocument(p.URI.revive(D));g?f.associatedNotebooks.set(y.uri,!0):f.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,y.uri.toString(),g),f.onDidChangeSelection.fire({selected:g,notebook:y.apiNotebook})}}async $executeCells(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getNotebookDocument(p.URI.revive(D)),P=[];for(const N of g){const U=y.getCell(N);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,y.uri.toString(),P.length),await f.controller.executeHandler.call(f.controller,P,y.apiNotebook,f.controller)}catch(N){this.q.error(`NotebookController[${b}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getNotebookDocument(p.URI.revive(D));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,y.apiNotebook);else for(const P of g){const N=y.getCell(P);N&&this.b.get(N.uri)?.cancel()}if(f.controller.interruptHandler){const P=this.c.get(y.uri);g.length&&Array.isArray(P)&&P.length&&P.forEach(N=>N.dispose())}}async $provideVariables(b,D,g,f,y,P,N){const U=this.j.get(b);if(!U)return;const z=this.n.getNotebookDocument(p.URI.revive(g)),F=U.controller.variableProvider;if(!F)return;let M;if(f!==void 0){if(M=this.s[f],!M)return}else this.s={};const T=y==="named"?k.NotebookVariablesRequestKind.Named:k.NotebookVariablesRequestKind.Indexed,j=F.provideVariables(z.apiNotebook,M,T,P,N);let J=0;for await(const ne of j){if(N.isCancellationRequested)return;const _={id:this.r++,name:ne.variable.name,value:ne.variable.value,type:ne.variable.type,hasNamedChildren:ne.hasNamedChildren,indexedChildrenCount:ne.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[_.id]=ne.variable,this.a.$receiveVariable(D,_),J++>=n.$ygb)return}}$acceptKernelMessageFromRenderer(b,D,g){const f=this.j.get(b);if(!f)return;const y=this.n.getEditorById(D);f.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:g}))}$cellExecutionChanged(b,D,g){const y=this.n.getNotebookDocument(p.URI.revive(b)).getCell(D);if(y){const P=g?E.NotebookCellExecutionState.to(g):k.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:y.apiCell,state:P})}}_createNotebookCellExecution(b,D){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const y=new t(D,f,this.a);this.b.set(f.uri,y);const P=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),P.dispose(),this.b.delete(f.uri))});return y.asApiObject()}_createNotebookExecution(b,D){const g=this.n.getNotebookDocument(b.uri),f=b.getCells().find(N=>{const U=g.getCellFromApiCell(N);return U&&this.b.has(U.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const y=new c(D,g,this.a),P=y.onDidChangeState(()=>{y.state===d.Resolved&&(y.dispose(),P.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[y,P]),y.asApiObject()}};e.$Fic=r,e.$Fic=r=Ke([We(4,L.$wj)],r);var a;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(a||(a={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(b,D,g){super(),this.m=D,this.n=g,this.b=t.a++,this.c=new A.$3d,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new $.$ae),this.h=new s(10,f=>this.s(f)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const D=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$3v(D))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let D=this.m;if(b&&(D=this.m.notebook.getCellFromApiCell(b)),!D)throw new Error("INVALID cell");return D.handle}y(b){return b.map(D=>{const g=k.$pN.ensureUniqueMimeTypes(D.items,!0);return g===D.items?E.NotebookCellOutput.from(D):E.NotebookCellOutput.from({items:g,id:D.id,metadata:D.metadata})})}async z(b,D,g){const f=this.w(D),y=this.y((0,I.$3b)(b));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:f,append:g,outputs:y})}async C(b,D,g){return b=k.$pN.ensureUniqueMimeTypes((0,I.$3b)(b),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:b.map(E.NotebookCellOutputItem.from),outputId:D.id,append:g})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(g){b.j=g,b.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(g){if(b.f===a.Resolved||b.f===a.Started)throw new Error("Cannot call start again");b.f=a.Started,b.c.fire(),b.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,f){if(b.f===a.Resolved)throw new Error("Cannot call resolve twice");b.f=a.Resolved,b.c.fire(),b.h.flush(),b.n.$completeExecution(b.b,new i.$3v({runEndTime:f,lastRunSuccess:g}))},clearOutput(g){return b.t(),b.z([],g,!1)},appendOutput(g,f){return b.t(),b.z(g,f,!0)},replaceOutput(g,f){return b.t(),b.z(g,f,!1)},appendOutputItems(g,f){return b.t(),b.C(g,f,!0)},replaceOutputItems(g,f){return b.t(),b.C(g,f,!1)}})}}var d;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(d||(d={}));class c extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(b,D,g){super(),this.h=D,this.j=g,this.b=c.a++,this.c=new A.$3d,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new $.$ae),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===d.Resolved||this.f===d.Started)throw new Error("Cannot call start again");this.f=d.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===d.Resolved)throw new Error("Cannot call resolve twice");this.f=d.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor(b,D){this.f=b,this.g=D,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new O.$zh,this.b=Date.now(),(0,O.$dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>b.complete())}}function l(h,b){return`${h.value}/${b}`}e.$Gic=l}),define(Ce[46],Ie([1,0,4,6,5,2,20,3,7,220,14,264,22,30,265,55,8,15,33]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,$.$ci)("IExtHostTerminalService");class n{constructor(g,f,y,P){this.l=g,this._id=f,this.m=y,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(U,z=!0){N.q(),N.l.$sendText(N._id,U,z)},show(U){N.q(),N.l.$show(N._id,U)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(g,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??f?.cwd??void 0,env:g.env??void 0,icon:l(g.iconPath)??void 0,color:u.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:f?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:f?.useShellEnvironment??void 0,location:f?.location||this.o(g.location,f?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,f,y,P,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:u.ThemeColor.isThemeColor(N)?N.id:void 0,location:f?.location||this.o(g,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,f){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in g?{viewColumn:o.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,f){this.h=Object.freeze({code:g,reason:f})}setDimensions(g,f){return g===this.d&&f===this.g||g===0||f===0?!1:(this.d=g,this.g=f,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(f=>{f!==g&&(this.b=Promise.resolve(g))})}}e.$Shc=n;class r{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new I.$3d,this.onProcessData=this.a.event,this.b=new I.$3d,this.d=new I.$3d,this.onDidChangeProperty=this.d.event,this.f=new I.$3d,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,f){this.g.setDimensions?.({columns:g,rows:f})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends v.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,f,y){super(),this.Q=f,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new v.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new I.$3d,this.onDidCloseTerminal=this.H.event,this.I=new I.$3d,this.onDidOpenTerminal=this.I.event,this.J=new I.$3d,this.onDidChangeActiveTerminal=this.J.event,this.L=new I.$3d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new I.$3d,this.onDidChangeTerminalState=this.M.event,this.N=new I.$3d,this.onDidChangeShell=this.N.event,this.O=new I.$3d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new I.$3d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(O.$VL.MainThreadTerminalService),this.y=new k.$ftb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:P=>{const N=U=>{const z=U;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return N(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=N(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,N]of this.g)N.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,f){const y=new n(this.a,(0,E.$yg)(),g,g.name),P=new r(g.pty);return y.createExtensionTerminal(g.location,f,this.R(g,f).resolvedExtHostIdentifier,l(g.iconPath),h(g.color)).then(N=>{const U=this.S(N,P);this.h[N]=U}),this.f.push(y),y.value}R(g,f){if(f=f||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const y=g.location.parentTerminal;if(y){const P=this.f.find(N=>N.value===y);P&&(f.resolvedExtHostIdentifier=P._id)}}else g.location&&typeof g.location!="object"?f.location=g.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(g,f){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const P=new r(f),N=this.S(g,P);this.h[g]=N}async $acceptActiveTerminalChanged(g){const f=this.b;if(g===null){this.b=void 0,f!==this.b&&this.J.fire(this.b);return}const y=this.W(g);y&&(this.b=y,f!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,f){const y=this.W(g);y&&this.O.fire({terminal:y.value,data:f})}async $acceptTerminalDimensions(g,f,y){const P=this.W(g);P&&P.setDimensions(f,y)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(g,f){const y=this.W(g);y&&this.P.fire({terminal:y.value,...f})}async $acceptTerminalMaximumDimensions(g,f,y){this.g.get(g)?.resize(f,y)}async $acceptTerminalTitleChange(g,f){const y=this.W(g);y&&(y.name=f)}async $acceptTerminalClosed(g,f,y){const P=this.Y(this.f,g);if(P!==null){const N=this.f.splice(P,1)[0];N.setExitStatus(f,y),this.H.fire(N.value)}}$acceptTerminalOpened(g,f,y,P){if(f){const z=this.Y(this.f,f);if(z!==null){this.f[z]._id=g,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const N={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new n(this.a,g,N,y);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(g,f){this.W(g)?._setProcessId(f)}async $startExtensionTerminal(g,f){const y=this.W(g);if(!y)return{message:(0,S.localize)(0,null,g)};y.isOpen||await new Promise(N=>{const U=this.onDidOpenTerminal(async z=>{z===y.value&&(U.dispose(),N())})});const P=this.g.get(g);P?P.startSendingEvents(f):this.j[g]={initialDimensions:f}}S(g,f){const y=new v.$Sc;y.add(f.onProcessReady(N=>this.a.$sendProcessReady(g,N.pid,N.cwd,N.windowsPty))),y.add(f.onDidChangeProperty(N=>this.a.$sendProcessProperty(g,N))),this.y.startBuffering(g,f.onProcessData),y.add(f.onProcessExit(N=>this.U(g,N))),this.g.set(g,f);const P=this.j[g];return P&&f instanceof r&&(f.startSendingEvents(P.initialDimensions),delete this.j[g]),y}$acceptProcessAckDataEvent(g,f){this.g.get(g)?.acknowledgeDataEvent(f)}$acceptProcessInput(g,f){this.g.get(g)?.input(f)}$acceptTerminalInteraction(g){const f=this.W(g);f?.setInteractedWith()&&this.M.fire(f.value)}$acceptTerminalSelection(g,f){this.W(g)?.setSelection(f)}$acceptProcessResize(g,f,y){try{this.g.get(g)?.resize(f,y)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(g,f){this.g.get(g)?.shutdown(f)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(f=>this.a.$sendProcessProperty(g,{type:"cwd",value:f}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$XL(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,f,y){if(this.C.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.C.set(f,y),this.a.$registerProfileProvider(f,g.identifier.value),new p.$XL(()=>{this.C.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(g,f,y){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,y),this.a.$registerQuickFixProvider(g,f),new p.$XL(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,f){const y=new w.$ae().token;if(y.isCancellationRequested)return;const P=this.D.get(g);if(!P)return;const N=await P.provideTerminalQuickFixes(f,y);if(N===null||Array.isArray(N)&&N.length===0)return;const U=new v.$Sc;if(this.w.value=U,!Array.isArray(N))return N?o.TerminalQuickFix.from(N,this.Q.converter,U):void 0;const z=[];for(const F of N){const M=o.TerminalQuickFix.from(F,this.Q.converter,U);M&&z.push(M)}return z}async $createContributedProfileTerminal(g,f){const y=new w.$ae().token;let P=await this.C.get(g)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,f);return}this.createTerminalFromOptions(P.options,f)}}async $provideLinks(g,f){const y=this.W(g);if(!y)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const N=new w.$ae;this.G.set(g,N);const U=[],z={terminal:y.value,line:f},F=[];for(const j of this.z)F.push(m.Promises.withAsyncBody(async J=>{N.token.onCancellationRequested(()=>J({provider:j,links:[]}));const ne=await j.provideTerminalLinks(z,N.token)||[];N.token.isCancellationRequested||J({provider:j,links:ne})}));const M=await Promise.all(F);if(N.token.isCancellationRequested)return[];const T=new Map;for(const j of M)j&&j.links.length>0&&U.push(...j.links.map(J=>{const ne={id:a++,startIndex:J.startIndex,length:J.length,label:J.tooltip};return T.set(ne.id,{provider:j.provider,link:J}),ne}));return this.F.set(g,T),U}$activateLink(g,f){const y=this.F.get(g)?.get(f);y&&y.provider.handleTerminalLink(y.link)}U(g,f){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const y=this.h[g];y&&(y.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,f)}W(g){return this.X(this.f,g)}X(g,f){const y=this.Y(g,f);return y!==null?g[y]:null}Y(g,f){const y=g.findIndex(P=>P._id===f);return y===-1?null:y}getEnvironmentVariableCollection(g){let f=this.n.get(g.identifier.value);return f||(f=new d,this.$(g.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Z(g,f){const y=(0,C.$Vr)(f.map),P=(0,C.$Wr)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(g,f.persistent,y.length===0?void 0:y,P)}$initEnvironmentVariableCollections(g){g.forEach(f=>{const y=f[0],P=new d(f[1]);this.$(y,P)})}$acceptDefaultProfile(g,f){const y=this.s;this.s=g,this.u=f,y?.path!==g.path&&this.N.fire(g.path)}$(g,f){this.n.set(g,f),f.onDidChangeCollection(()=>{this.Z(g,f)})}};e.$Thc=t,e.$Thc=t=Ke([We(1,i.$wO),We(2,R.$aO)],t);class d{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new I.$3d,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const f=this.h(g);let y=this.a.get(f);return y||(y=new c(this,g),this.a.set(f,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:P})}append(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:P})}prepend(g,f,y,P){this.f(g,{value:f,type:p.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:P})}f(g,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(g,f.scope),P=this.map.get(y),N=f.options?{applyAtProcessCreation:f.options.applyAtProcessCreation??!1,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==f.value||P.type!==f.type||P.options?.applyAtProcessCreation!==N.applyAtProcessCreation||P.options?.applyAtShellIntegration!==N.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const U=this.g(g,f.scope),z={variable:g,...f,options:N};this.map.set(U,z),this.d.fire()}}get(g,f){const y=this.g(g,f),P=this.map.get(y);return P?b(P):void 0}g(g,f){const y=this.h(f);return y.length?`${g}:::${y}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const f=new Map;for(const[y,P]of this.map)this.h(P.scope)===this.h(g)&&f.set(P.variable,b(P));return f}delete(g,f){const y=this.g(g,f);this.map.delete(y),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[f,y]of this.map)y.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(f);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,f){const y=this.h(f),P=this.descriptionMap.get(y);if(!P||P.description!==g){let N;typeof g=="string"?N=g:N=g?.value.split(`

`)[0];const U={description:N,scope:f};this.descriptionMap.set(y,U),this.d.fire()}}getDescription(g){const f=this.h(g);return this.descriptionMap.get(f)?.description}k(g){const f=this.h(g);this.descriptionMap.delete(f)}}class c{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,f){this.b=g,this.d=f,this.a=new I.$3d}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,f,y){this.b.replace(g,f,y,this.d)}append(g,f,y){this.b.append(g,f,y,this.d)}prepend(g,f,y){this.b.prepend(g,f,y,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,f){this.b.getVariableMap(this.d).forEach((y,P)=>g.call(f,P,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let s=class extends t{constructor(g,f){super(!1,g,f)}createTerminal(g,f,y){throw new L.$_}createTerminalFromOptions(g,f){throw new L.$_}};e.$Uhc=s,e.$Uhc=s=Ke([We(0,i.$wO),We(1,R.$aO)],s);function l(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return u.ThemeColor.isThemeColor(D)?D:void 0}function b(D){const g={...D};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[347],Ie([1,0,8,21,22,4,75,54,3,24,18,30,13,6,20,151,15,7,68,111,89,25]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=e.$Yic=e.$Xic=void 0;let t=class extends p.$Tc{constructor(F,M,T,j){super(),this.w=j,this.f=this.B(new A.$3d),this.g=new Map,this.s=this.B(new A.$3d),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(E.$VL.MainThreadTesting),this.m=new y(this.h),this.j=new l(this.h,M),T.registerArgumentProcessor({processArgument:J=>{switch(J?.$mid){case 16:{const ne=J,_=ne.tests[ne.tests.length-1].item.extId;return this.g.get(i.$MK.root(_))?.collection.tree.get(_)?.actual??(0,u.$mO)(J)}case 18:{const{extId:ne,message:_}=J;return{test:this.g.get(i.$MK.root(ne))?.collection.tree.get(ne)?.actual,message:m.TestMessage.to(_)}}default:return J}}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const J=await T.executeCommand("_testing.getExplorerSelection"),ne=_=>{const Z=this.g.get(i.$MK.root(_));if(Z)return i.$MK.isRoot(_)?Z.controller:Z.collection.tree.get(_)?.actual};return{include:J?.include.map(ne).filter(L.$Yf)||[],exclude:J?.exclude.map(ne).filter(L.$Yf)||[]}})}createTestController(F,M,T,j){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const J=new p.$Sc,ne=J.add(new u.$pO(M,T,this.w));ne.root.label=T;const _=new Map,Z=new Set,Y=this.h,ce={items:ne.root.children,get label(){return T},set label(fe){T=fe,ne.root.label=fe,Y.$updateController(M,{label:T})},get refreshHandler(){return j},set refreshHandler(fe){j=fe,Y.$updateController(M,{canRefresh:!!fe})},get id(){return M},createRunProfile:(fe,re,K,B,ae,ye)=>{let le=(0,v.$3i)(fe);for(;_.has(le);)le++;return new N(this.h,_,Z,this.s.event,M,le,fe,re,K,B,ae,ye)},createTestItem(fe,re,K){return new u.$nO(M,fe,re,K)},createTestRun:(fe,re,K=!0)=>this.j.createTestRun(F,M,ne,fe,re,K),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const re=fe instanceof Array?fe:[fe];this.h.$markTestRetired(re.map(K=>i.$MK.fromExtHostTestItem(K,M).toString()))}},set resolveHandler(fe){ne.resolveHandler=fe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{J.dispose()}};Y.$registerTestController(M,T,!!j),J.add((0,p.$Rc)(()=>Y.$unregisterTestController(M)));const ie={controller:ce,collection:ne,profiles:_,extension:F,activeProfiles:Z};return this.g.set(M,ie),J.add((0,p.$Rc)(()=>this.g.delete(M))),J.add(ne.onDidGenerateDiff(fe=>Y.$publishDiff(M,fe.map(r.TestsDiffOp.serialize)))),ce}createTestObserver(){return this.m.checkout()}async runTests(F,M=$.CancellationToken.None){const T=h(F);if(!T)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.g.get(T.controllerId);if(!j)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(J=>i.$MK.fromExtHostTestItem(J,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:U[T.kind],profileId:T.profileId,controllerId:T.controllerId}],exclude:F.exclude?.map(J=>J.id)},M)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $provideFileCoverage(F,M,T){return await this.j.getCoverageReport(F,M)?.provideFileCoverage(T)??[]}async $resolveFileCoverage(F,M,T,j){return await this.j.getCoverageReport(F,M)?.resolveFileCoverage(T,j)??[]}$configureRunProfile(F,M){this.g.get(F)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(F){const M=new Map;for(const[T,j]of Object.entries(F)){const J=this.g.get(T);if(!J)continue;const ne=new Map,_=j.filter(Y=>!J.activeProfiles.has(Y)),Z=[...J.activeProfiles].filter(Y=>!j.includes(Y));for(const Y of _)ne.set(Y,!0),J.activeProfiles.add(Y);for(const Y of Z)ne.set(Y,!1),J.activeProfiles.delete(Y);ne.size&&M.set(T,ne)}this.s.fire(M)}async $refreshTests(F,M){await this.g.get(F)?.controller.refreshHandler?.(M)}$publishTestResults(F){this.results=Object.freeze(F.map(M=>(0,S.$Gn)(m.TestResults.to(M))).concat(this.results).sort((M,T)=>T.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,M){const T=this.g.get(i.$MK.fromString(F).controllerId)?.collection;T&&(await T.expand(F,M<0?1/0:M),T.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(M=>r.TestsDiffOp.deserialize({asCanonicalUri:T=>T},M)))}async $runControllerTests(F,M){return Promise.all(F.map(T=>this.y(T,!1,M)))}async $startContinuousRun(F,M){const T=new $.$ae(M),j=await Promise.all(F.map(J=>this.y(J,!0,T.token)));return!M.isCancellationRequested&&!j.some(J=>J.error)&&await new Promise(J=>M.onCancellationRequested(J)),T.dispose(!0),j}async y(F,M,T){const j=this.g.get(F.controllerId);if(!j)return{};const{collection:J,profiles:ne,extension:_}=j,Z=ne.get(F.profileId);if(!Z)return{};const Y=F.testIds.map(re=>J.tree.get(re)).filter(L.$Yf),ce=F.excludeExtIds.map(re=>j.collection.tree.get(re)).filter(L.$Yf).filter(re=>Y.some(K=>K.fullId.compare(re.fullId)===2));if(!Y.length)return{};const ie=new o.$wN(Y.some(re=>re.actual instanceof u.$oO)?void 0:Y.map(re=>re.actual),ce.map(re=>re.actual),Z,M),fe=(0,r.$OK)(F)&&this.j.prepareForMainThreadTestRun(ie,b.fromInternal(F,j.collection),_,T);try{return await Z.runHandler(ie,T),{}}catch(re){return{error:String(re)}}finally{fe&&(fe.hasRunningTasks&&!T.isCancellationRequested&&await A.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Xic=t,e.$Xic=t=Ke([We(0,k.$aO),We(1,w.$wj)],t);const d=1e4;var c;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(c||(c={}));class s extends p.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(F,M,T,j,J){super(),this.s=F,this.w=M,this.y=T,this.z=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$3d),this.m=this.B(new A.$3d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new $.$ae(J));const ne=this.B(new I.$oh(()=>this.C(),d));this.B(this.h.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(F){const M=this.s.id,T=this.s.controllerId,j=(0,C.$yg)(),J=this.y,ne=this.m;let _;const Z=fe=>(re,...K)=>{if(ce){this.z.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.s.isIncluded(re)&&(this.F(re),fe(re,...K))},Y=(fe,re)=>{const K=re instanceof Array?re.map(m.TestMessage.from):[m.TestMessage.from(re)];if(fe.uri&&fe.range){const B={range:m.Range.from(fe.range),uri:fe.uri};for(const ae of K)ae.location=ae.location||B}this.w.$appendTestMessagesInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),K)};let ce=!1;const ie={isPersisted:this.s.isPersisted,token:this.h.token,name:F,get coverageProvider(){return _?.provider},set coverageProvider(fe){(0,a.$SF)(J,"testCoverage"),_=fe&&new D(fe),ne.fire({taskId:j,runId:M,coverage:_})},enqueued:Z(fe=>{this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),1)}),skipped:Z(fe=>{this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),5)}),started:Z(fe=>{this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),2)}),errored:Z((fe,re,K)=>{Y(fe,re),this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),6,K)}),failed:Z((fe,re,K)=>{Y(fe,re),this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,T).toString(),4,K)}),passed:Z((fe,re)=>{this.w.$updateTestStateInRun(M,j,i.$MK.fromExtHostTestItem(fe,this.s.controllerId).toString(),3,re)}),appendOutput:(fe,re,K)=>{ce||(K&&(this.s.isIncluded(K)?this.F(K):K=void 0),this.w.$appendOutputToRun(M,j,O.$qe.fromString(fe),re&&m.location.from(re),K&&i.$MK.fromExtHostTestItem(K,T).toString()))},end:()=>{ce||(ce=!0,this.w.$finishedTestRunTask(M,j),this.f.delete(j),this.f.size||this.D())}};return this.f.set(j,{run:ie}),this.w.$startedTestRunTask(M,{id:j,name:F,running:!0}),ie}C(){for(const{run:F}of this.f.values())F.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(F){if(!(F instanceof u.$nO))throw new n.$5N(F.id);if(this.g.has(i.$MK.fromExtHostTestItem(F,this.s.controllerId).toString()))return;const M=[],T=this.s.colllection.root;for(;;){const j=m.TestItem.from(F);if(M.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),F===T))break;F=F.parent||T}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(F,M){this.g=F,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(F,M){return this.f.find(T=>T.runId===F)?.coverage.get(M)}prepareForMainThreadTestRun(F,M,T,j){return this.j(F,M,T,j)}cancelRunById(F){for(const M of this.c.values())if(M.id===F){M.cancel();return}}cancelAllRuns(){for(const F of this.c.values())F.cancel()}createTestRun(F,M,T,j,J,ne){const _=this.c.get(j);if(_)return _.createRun(J);const Z=b.fromPublic(M,T,j,ne),Y=h(j);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!j.continuous,profile:Y&&{group:U[Y.kind],id:Y.profileId},exclude:j.exclude?.map(ie=>i.$MK.fromExtHostTestItem(ie,T.root.id).toString())??[],id:Z.id,include:j.include?.map(ie=>i.$MK.fromExtHostTestItem(ie,T.root.id).toString())??[T.root.id],persist:ne});const ce=this.j(j,Z,F);return A.Event.once(ce.onEnd)(()=>{this.g.$finishedExtensionTestRun(Z.id),ce.dispose()}),ce.createRun(J)}j(F,M,T,j){const J=new s(M,this.g,T,this.h,j);this.c.set(F,J);let ne;const _=J.onDidCoverage(({runId:Z,taskId:Y,coverage:ce})=>{ne||(ne={runId:Z,coverage:new Map},this.f.unshift(ne),this.f.length>r.$TK&&this.f.pop()),ne.coverage.set(Y,ce),this.g.$signalCoverageAvailable(Z,Y,!!ce)});return A.Event.once(J.onEnd)(()=>{this.c.delete(F),_.dispose()}),J}}e.$Yic=l;const h=z=>{if(z.profile){if(!(z.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class b{static fromPublic(F,M,T,j){return new b(F,(0,C.$yg)(),T.include?.map(J=>i.$MK.fromExtHostTestItem(J,F).toString())??[F],T.exclude?.map(J=>i.$MK.fromExtHostTestItem(J,F).toString())??[],j,M)}static fromInternal(F,M){return new b(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,M)}constructor(F,M,T,j,J,ne){this.controllerId=F,this.id=M,this.isPersisted=J,this.colllection=ne,this.c=T.map(_=>_+"\0"),this.f=j.map(_=>_+"\0")}isIncluded(F){const M=i.$MK.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const T of this.f)if(M===T||M.startsWith(T))return!1;for(const T of this.c)if(M===T||M.startsWith(T))return!0;return!1}}e.$Zic=b;class D{constructor(F){this.provider=F}async provideFileCoverage(F){this.c||(this.c=(async()=>this.provider.provideFileCoverage(F))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(F,M){const T=await this.c;let j=T?.[F];return!this.provider||!T||!j?[]:(j.detailedCoverage||(j=T[F]=await this.provider.resolveFileCoverage?.(j,M)??j),j.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(F){this.j=F,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(F){this.c.add(F)}update(F){Object.assign(F.revived,m.TestItem.toPlain(F.item)),this.c.has(F)||this.f.add(F)}remove(F){if(this.c.has(F)){this.c.delete(F);return}this.f.delete(F);const M=i.$MK.parentId(F.item.extId);if(M&&this.h.has(M.toString())){this.h.add(F.item.extId);return}this.g.add(F)}getChangeEvent(){const{c:F,f:M,g:T}=this;return{get added(){return[...F].map(j=>j.revived)},get updated(){return[...M].map(j=>j.revived)},get removed(){return[...T].map(j=>j.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class f extends r.$UK{constructor(){super(...arguments),this.s=new A.$3d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(F){return this.f.get(F)}getMirroredTestDataByReference(F){return this.f.get(F.id)}w(F,M){return{...F,revived:m.TestItem.toPlain(F.item),depth:M?M.depth+1:0,children:new Set}}v(){return new g(this.s)}}class y{constructor(F){this.f=F}checkout(){this.c||(this.c=this.g());const F=this.c;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(M=>M.revived)},dispose:(0,R.$db)(()=>{--F.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(F){return this.c?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.c?.tests.apply(F)}g(){const F=new f({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:F}}}const P=(z,F,M,T)=>{M?Object.assign(M,T):F.$updateTestRunConfig(z.controllerId,z.profileId,T)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(F){F!==this.f&&(this.f=F,P(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(F){F!==this.g&&(this.g=F,P(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,P(this,this.#e,this.#n,{tag:F?m.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.c}set configureHandler(F){F!==this.c&&(this.c=F,P(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return A.Event.chain(this.#i,F=>F.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(L.$Yf))}constructor(F,M,T,j,J,ne,_,Z,Y,ce=!1,ie=void 0,fe=!1){this.controllerId=J,this.profileId=ne,this.f=_,this.kind=Z,this.runHandler=Y,this._tag=ie,this.g=fe,this.#e=F,this.#s=M,this.#t=T,this.#i=j,M.set(ne,this);const re=U[Z];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);ce&&T.add(ne),this.#n={profileId:ne,controllerId:J,tag:ie?m.TestTag.namespace(this.controllerId,ie.id):null,label:_,group:re,isDefault:ce,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$1ic=N;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[152],Ie([1,0,61,14,121,15,7]),function(me,e,I,O,$,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=void 0;class v{static{this.c=new $.$fO("TextEditorDecorationType")}constructor(w,E,k){const u=v.c.nextId();w.$registerTextEditorDecorationType(E.identifier,u,A.DecorationRenderOptions.from(k)),this.value=Object.freeze({key:u,dispose(){w.$removeTextEditorDecorationType(u)}})}}e.$hO=v;class p{constructor(w,E){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,E){this.k();let k=null;if(w instanceof R.$YL)k=new R.$ZL(w,w);else if(w instanceof R.$ZL)k=w;else throw new Error("Unrecognized location");this.l(k,E,!1)}insert(w,E){this.k(),this.l(new R.$ZL(w,w),E,!0)}delete(w){this.k();let E=null;if(w instanceof R.$ZL)E=w;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(w,E,k){const u=this.c.validateRange(w);this.g.push({range:u,text:E,forceMoveMarkers:k})}setEndOfLine(w){if(this.k(),w!==R.EndOfLine.LF&&w!==R.EndOfLine.CRLF)throw(0,O.$7)("endOfLine");this.h=w}}class S{constructor(w,E,k,u){this.c=w,this.d=E,this._accept(k),this.e=u;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.originalIndentSize,this.j=w.insertSpaces,this.k=w.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(w.lineNumbers)}m(w){if(w==="auto")return"auto";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}n(w){const E=this.m(w);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}p(w){const E=this.o(w);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(w){return w==="auto"?"auto":w==="false"?!1:!!w}s(w){const E=this.q(w);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(w){this.k!==w&&(this.k=w,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}u(w){this.l!==w&&(this.l=w,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(w)})))}assign(w){const E={};let k=!1;if(typeof w.tabSize<"u"){const u=this.m(w.tabSize);u==="auto"?(k=!0,E.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,k=!0,E.tabSize=u)}if(typeof w.indentSize<"u"){const u=this.o(w.indentSize);u==="tabSize"?(k=!0,E.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,k=!0,E.indentSize=u)}if(typeof w.insertSpaces<"u"){const u=this.q(w.insertSpaces);u==="auto"?(k=!0,E.insertSpaces=u):this.j!==u&&(this.j=u,k=!0,E.insertSpaces=u)}typeof w.cursorStyle<"u"&&this.k!==w.cursorStyle&&(this.k=w.cursorStyle,k=!0,E.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.l!==w.lineNumbers&&(this.l=w.lineNumbers,k=!0,E.lineNumbers=A.TextEditorLineNumbersStyle.from(w.lineNumbers)),k&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(w,E){E.catch(k=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(k)})}}e.$iO=S;class L{constructor(w,E,k,u,m,o,i,n){this.id=w,this.j=E,this.k=k,this.g=!1,this.h=new Set,this.c=m,this.d=new S(this.j,this.id,o,k),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return u.value},set document(a){throw new O.$9("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof R.$1L))throw(0,O.$7)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$1L)))throw(0,O.$7)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new O.$9("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new O.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const d=new p(u.value,t);return a(d),r.m(d)},insertSnippet(a,t,d={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let c;if(!t||Array.isArray(t)&&t.length===0)c=r.c.map(s=>A.Range.from(s));else if(t instanceof R.$YL){const{lineNumber:s,column:l}=A.Position.from(t);c=[{startLineNumber:s,startColumn:l,endLineNumber:s,endColumn:l}]}else if(t instanceof R.$ZL)c=[A.Range.from(t)];else{c=[];for(const s of t)if(s instanceof R.$ZL)c.push(A.Range.from(s));else{const{lineNumber:l,column:h}=A.Position.from(s);c.push({startLineNumber:l,startColumn:h,endLineNumber:l,endColumn:h})}}return E.$tryInsertSnippet(w,u.value.version,a.value,c,d)},setDecorations(a,t){const d=t.length===0;d&&!r.h.has(a.key)||(d?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(A.$0N(t))return E.$trySetDecorations(w,a.key,A.$$N(t));{const c=new Array(4*t.length);for(let s=0,l=t.length;s<l;s++){const h=t[s];c[4*s]=h.start.line+1,c[4*s+1]=h.start.character+1,c[4*s+2]=h.end.line+1,c[4*s+3]=h.end.character+1}return E.$trySetDecorationsFast(w,a.key,c)}}))},revealRange(a,t){r.n(()=>E.$tryRevealRange(w,A.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){E.$tryShowEditor(w,A.ViewColumn.from(a))},hide(){E.$tryHideEditor(w)}})}dispose(){(0,I.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,I.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,I.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,I.ok)(!this.g),this.f=w}_acceptSelections(w){(0,I.ok)(!this.g),this.c=w}async l(){const w=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const E=w.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const k=E.edits.map(m=>m.range);k.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=k.length-1;m<o;m++){const i=k[m].end;if(k[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=E.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,u,{setEndOfLine:typeof E.setEndOfLine=="number"?A.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$jO=L}),define(Ce[73],Ie([1,0,61,4,3,2,5,6,149,20,152,15,13,28,16,53,43]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new O.$3d,this.e=new O.$3d,this.f=new O.$3d,this.g=new O.$3d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],d=[];if(r.removedDocuments)for(const c of r.removedDocuments){const s=A.URI.revive(c),l=this.c.get(s);l?.unref()&&(this.c.delete(s),a.push(l.value))}if(r.addedDocuments)for(const c of r.addedDocuments){const s=A.URI.revive(c.uri);let l=this.c.get(s);if(l&&s.scheme!==k.Schemas.vscodeNotebookCell&&s.scheme!==k.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);l||(l=new o(new p.$dO(this.h.getProxy(v.$VL.MainThreadDocuments),s,c.lines,c.EOL,c.versionId,c.languageId,c.isDirty,c.notebook)),this.c.set(s,l),t.push(l.value)),l.ref()}if(r.removedEditors)for(const c of r.removedEditors){const s=this.b.get(c);this.b.delete(c),s&&d.push(s)}if(r.addedEditors)for(const c of r.addedEditors){const s=A.URI.revive(c.documentUri);I.ok(this.c.has(s),`document '${s}' does not exist`),I.ok(!this.b.has(c.id),`editor '${c.id}' already exists!`);const l=this.c.get(s).value,h=new L.$jO(c.id,this.h.getProxy(v.$VL.MainThreadTextEditors),this.i,new m.$V(()=>l.document),c.selections.map(C.Selection.to),c.options,c.visibleRanges.map(b=>C.Range.to(b)),typeof c.editorPosition=="number"?C.ViewColumn.to(c.editorPosition):void 0);this.b.set(c.id,h)}r.newActiveEditor!==void 0&&(I.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,$.$Oc)(a),(0,$.$Oc)(d),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(c=>c.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return u.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$kO=i,e.$kO=i=Ke([We(0,S.$aO),We(1,w.$wj)],i),e.$lO=(0,R.$ci)("IExtHostDocumentsAndEditors")}),define(Ce[348],Ie([1,0,19,4,6,152,15,7]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class p{constructor(L,C){this.i=C,this.a=new O.$3d,this.b=new O.$3d,this.c=new O.$3d,this.d=new O.$3d,this.f=new O.$3d,this.g=new O.$3d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=L.getProxy($.$VL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(L){const C=this.i.allEditors();return L?C:C.map(w=>w.value)}async showTextDocument(L,C,w){let E;typeof C=="number"?E={position:R.ViewColumn.from(C),preserveFocus:w}:typeof C=="object"?E={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:E={preserveFocus:!1};const k=await this.h.$tryShowTextDocument(L.uri,E),u=k&&this.i.getEditor(k);if(u)return u.value;throw k?new Error(`Could NOT open editor for "${L.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${L.uri.toString()}".`)}createTextEditorDecorationType(L,C){return new A.$hO(this.h,L,C).value}$acceptEditorPropertiesChanged(L,C){const w=this.i.getEditor(L);if(!w)throw new Error("unknown text editor");if(C.options&&w._acceptOptions(C.options),C.selections){const E=C.selections.selections.map(R.Selection.to);w._acceptSelections(E)}if(C.visibleRanges){const E=I.$Hb(C.visibleRanges.map(R.Range.to));w._acceptVisibleRanges(E)}if(C.options&&this.b.fire({textEditor:w.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const E=v.TextEditorSelectionChangeKind.fromValue(C.selections.source),k=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:w.value,selections:k,kind:E})}if(C.visibleRanges){const E=I.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:w.value,visibleRanges:E})}}$acceptEditorPositionData(L){for(const C in L){const w=this.i.getEditor(C);if(!w)throw new Error("Unknown text editor");const E=R.ViewColumn.to(L[C]);w.value.viewColumn!==E&&(w._acceptViewColumn(E),this.d.fire({textEditor:w.value,viewColumn:E}))}}getDiffInformation(L){return Promise.resolve(this.h.$getDiffInformation(L))}}e.$khc=p}),define(Ce[349],Ie([1,0,2,5,6,3,7,15,26,18]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=e.$3ic=void 0,e.$3ic=(0,O.$ci)("IExtHostTimeline");class L{constructor(E,k){this.b=new Map,this.c=new Map,this.a=E.getProxy($.$VL.MainThreadTimeline),k.registerArgumentProcessor({processArgument:(u,m)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&p.$um.equals(m,this.b.get(u.source)?.extension)){const o=u.uri===void 0?void 0:I.URI.revive(u.uri);return this.c.get(u.source)?.get(C(o))?.get(u.handle)}else return;return u}})}async $getTimeline(E,k,u,m){return this.b.get(E)?.provider.provideTimeline(I.URI.revive(k),u,m)}registerTimelineProvider(E,k,u,m){const o=new A.$Sc,i=this.d(k.id,m,o).bind(this);let n;k.onDidChange&&(n=k.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:k.id}),this));const r=this.c;return this.f({...k,scheme:E,onDidChange:void 0,async provideTimeline(a,t,d){t?.resetCache&&(o.clear(),r.get(k.id)?.clear());const c=await k.provideTimeline(a,t,d);if(c==null)return;const s=i(a,t);return{...c,source:k.id,items:c.items.map(s)}},dispose(){for(const a of r.values())a.get(k.id)?.clear();n?.dispose(),o.dispose()}},u)}d(E,k,u){return(m,o)=>{let i;if(o?.cacheResults){let n=this.c.get(E);n===void 0&&(n=new Map,this.c.set(E,n));const r=C(m);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${E}|${n.id??n.timestamp}`;i?.set(t,n);let d,c,s;n.iconPath&&(r instanceof R.$SM?s={id:r.id,color:r.color}:I.URI.isUri(r)?(d=r,c=r):{light:d,dark:c}=r);let l;return R.$mM.isMarkdownString(a.tooltip)?l=v.MarkdownString.from(a.tooltip):(0,S.$Qf)(a.tooltip)?l=a.tooltip:R.$mM.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=v.MarkdownString.from(a.detail)):(0,S.$Qf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),l=a.detail),{...a,id:a.id??void 0,handle:t,source:E,command:n.command?k.toInternal(n.command,u):void 0,icon:d,iconDark:c,themeIcon:s,tooltip:l,accessibilityInformation:n.accessibilityInformation}}}}f(E,k){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:k}),(0,A.$Rc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$4ic=L;function C(w){return w?.toString()}}),define(Ce[350],Ie([1,0,221,23,2,4,3,280,8,7,18,19,15,63,22,178,25]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;function o(r,a){if((0,L.$Qf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends R.$Tc{constructor(a,t,d){super(),this.f=a,this.g=t,this.h=d,this.a=new Map,this.b=new u.$w9;function c(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>c(s)?this.r(s):Array.isArray(s)&&s.length>0?s.map(l=>c(l)?this.r(l):l):s})}registerTreeDataProvider(a,t,d){const c=this.createTreeView(a,{treeDataProvider:t},d);return{dispose:()=>c.dispose()}}createTreeView(a,t,d){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],l=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,b=this.m(a,t,d),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:c,dragMimeTypes:s,hasHandleDrag:l,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(a,D),f={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,m.$SF)(d,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,m.$SF)(d,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(y){(0,E.$sk)(y)&&(0,m.$SF)(d,"treeViewMarkdownMessage"),b.message=y},get title(){return b.title},set title(y){b.title=y},get description(){return b.description},set description(y){b.description=y},get badge(){return b.badge},set badge(y){y!==void 0&&S.ViewBadge.isViewBadge(y)?b.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(b.badge=void 0)},reveal:(y,P)=>b.reveal(y,P),dispose:async()=>{await g,this.a.delete(a),b.dispose()}};return this.B(f),f}$getChildren(a,t){const d=this.a.get(a);return d?d.getChildren(t):Promise.reject(new v.$lF(a))}async $handleDrop(a,t,d,c,s,l,h,b){const D=this.a.get(a);if(!D)return Promise.reject(new v.$lF(a));const g=w.DataTransfer.toDataTransfer(d,async f=>(await this.f.$resolveDropFileData(a,t,f)).buffer);return h===a&&b&&await this.j(g,D,b,s,l),D.onDrop(g,c,s)}async j(a,t,d,c,s){const l=this.b.removeDragOperationTransfer(s);if(l)(await l)?.forEach((h,b)=>{h&&a.set(b,h)});else if(s&&t.handleDrag){const h=t.handleDrag(d,a,c);this.b.addDragOperationTransfer(s,h),await h}return a}async $handleDrag(a,t,d,c){const s=this.a.get(a);if(!s)return Promise.reject(new v.$lF(a));const l=await this.j(new S.$PM,s,t,c,d);if(!(!l||c.isCancellationRequested))return w.DataTransfer.from(l)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new v.$lF(a);return t.hasResolve}$resolve(a,t,d){const c=this.a.get(a);if(!c)throw new v.$lF(a);return c.resolveTreeItem(t,d)}$setExpanded(a,t,d){const c=this.a.get(a);if(!c)throw new v.$lF(a);c.setExpanded(t,d)}$setSelectionAndFocus(a,t,d){const c=this.a.get(a);if(!c)throw new v.$lF(a);c.setSelectionAndFocus(t,d)}$setVisible(a,t){const d=this.a.get(a);if(!d){if(!t)return;throw new v.$lF(a)}d.setVisible(t)}$changeCheckboxState(a,t){const d=this.a.get(a);if(!d)throw new v.$lF(a);d.setCheckboxState(t)}m(a,t,d){const c=this.B(new n(a,t,this.f,this.g.converter,this.h,d));return this.a.set(a,c),c}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$5ic=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,L.$Zf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,d,c,s,l){if(super(),this.I=a,this.J=d,this.L=c,this.M=s,this.N=l,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$3d),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$3d),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$3d),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$3d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$3d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$3d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$3d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new k.$ae,l.contributes&&l.contributes.views)for(const g in l.contributes.views)for(const f of l.contributes.views[g])f.id===a&&(this.P=f.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let h,b;const D=A.Event.debounce(this.F.event,(g,f)=>(g||(g={message:!1,elements:[]}),f.element!==!1&&(h||(h=new Promise(y=>b=y),this.G=this.G.then(()=>h)),Array.isArray(f.element)?g.elements.push(...f.element):g.elements.push(f.element)),f.message&&(g.message=!0),g),200,!0);this.B(D(({message:g,elements:f})=>{f.length&&(this.H=this.H.then(()=>{const y=b;return h=null,this.$(f).then(()=>y())})),g&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let d=this.X(a);return d||(d=await this.Y(t)),d?d.map(c=>c.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const d=(0,L.$Zf)(t.select)?!0:t.select,c=(0,L.$Zf)(t.focus)?!1:t.focus,s=(0,L.$Zf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(l=>this.W(a,l[l.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:l.map(b=>b.item)},{select:d,focus:c,expand:s})),l=>this.M.error(l)):this.J.$reveal(this.I,void 0,{select:d,focus:c,expand:s})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=w.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const d=this.getExtensionElement(a);d&&(t?this.u.fire(Object.freeze({element:d})):this.w.fire(Object.freeze({element:d})))}setSelectionAndFocus(a,t){const d=!(0,C.$ub)(this.s,a);this.s=a;const c=this.t!==t;this.t=t,d&&this.y.fire(Object.freeze({selection:this.selectedElements})),c&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async d=>{const c=this.getExtensionElement(d.treeItemHandle);return c?{extensionItem:c,treeItem:await this.f.getTreeItem(c),newState:d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(d=>d!==void 0);t.forEach(d=>{d.treeItem.checkboxState=d.newState?S.TreeItemCheckboxState.Checked:S.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(d=>[d.extensionItem,d.newState])})}async handleDrag(a,t,d){const c=[];for(const s of a){const l=this.getExtensionElement(s);l&&c.push(l)}if(!(!this.g?.handleDrag||c.length===0))return await this.g.handleDrag(c,t,d),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,d){const c=t?this.getExtensionElement(t):void 0;if(!(!c&&t||!this.g?.handleDrop))return(0,p.$7g)(()=>this.g?.handleDrop?this.g.handleDrop(c,a,d):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const d=this.j.get(a);if(d){const c=this.m.get(d);if(c){const s=await this.f.resolveTreeItem(c.extensionItem,d,t)??c.extensionItem;return this.hb(s),c.item.tooltip=this.eb(s.tooltip),c.item.command=this.fb(c.disposableStore,s.command),c.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(d=>this.W(t,d[d.length-1]).then(c=>(d.push(c),d))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$7g)(()=>this.f.getParent(a))}W(a,t){const d=this.m.get(a);return d?Promise.resolve(d):(0,p.$7g)(()=>this.f.getTreeItem(a)).then(c=>this.kb(a,c,t,!0)).then(c=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(c);if(s){const l=this.m.get(s);if(l)return Promise.resolve(l)}throw new Error(`Cannot resolve tree item for element ${c} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const d=this.getExtensionElement(a);t=d?this.m.get(d):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new k.$ae(this.Z.token);try{const d=a?this.m.get(a):void 0,c=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const s=(0,C.$Hb)(c||[]),l=await Promise.all((0,C.$Hb)(s).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const h=l.map((b,D)=>b?this.db(s[D],b,d):null);return(0,C.$Hb)(h)}finally{t.dispose()}}$(a){if(a.some(d=>!d))return this.Z.dispose(!0),this.Z=new k.$ae,this.tb(),this.J.$refresh(this.I);{const d=this.ab(a);if(d.length)return this.bb(d)}return Promise.resolve(void 0)}ab(a){const t=new Set,d=a.map(s=>this.m.get(s));for(const s of d)if(s&&!t.has(s.item.handle)){let l=s;for(;l&&l.parent&&d.findIndex(h=>l&&l.parent&&h&&h.item.handle===l.parent.item.handle)===-1;){const h=this.j.get(l.parent.item.handle);l=h?this.m.get(h):void 0}l&&!l.parent&&t.add(s.item.handle)}const c=[];return t.forEach(s=>{const l=this.j.get(s);if(l){const h=this.m.get(l);h&&(!h.parent||!t.has(h.parent.item.handle))&&c.push(s)}}),c}bb(a){const t={};return Promise.all(a.map(d=>this.cb(d).then(c=>{c&&(t[d]=c.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const d=this.m.get(t);if(d)return this.rb(t),(0,p.$7g)(()=>this.f.getTreeItem(t)).then(c=>{if(c){const s=this.ib(t,c,d.parent);return this.pb(t,s,d,d.parent),d.dispose(),s}return null})}return Promise.resolve(null)}db(a,t,d){const c=this.ib(a,t,d);if(t.id&&this.j.has(c.item.handle))throw new Error((0,I.localize)(0,null,t.id));return this.ob(a,c),this.qb(c,d),c}eb(a){return S.$mM.isMarkdownString(a)?w.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,d,c;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,d=a.checkboxState.tooltip,c=a.checkboxState.accessibilityInformation),{isChecked:t===S.TreeItemCheckboxState.Checked,tooltip:d,accessibilityInformation:c}}hb(a){if(!S.$KM.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,d){this.hb(t);const c=this.B(new R.$Sc),s=this.kb(a,t,d),l=this.lb(t);return{item:{handle:s,parentHandle:d?d.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(c,t.command),contextValue:t.contextValue,icon:l,iconDark:this.mb(t)||l,themeIcon:this.jb(t),collapsibleState:(0,L.$Zf)(t.collapsibleState)?S.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:d,children:void 0,disposableStore:c,dispose(){c.dispose()}}}jb(a){return a.iconPath instanceof S.$SM?a.iconPath:void 0}kb(a,{id:t,label:d,resourceUri:c},s,l){if(t)return`${n.b}/${t}`;const h=o(d,this.N),b=s?s.item.handle:n.a;let D=h?h.label:c?(0,O.$Mg)(c):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const g=this.m.has(a)?this.m.get(a).item.handle:void 0,f=this.X(s)||[];let y,P=0;do{if(y=`${b}/${P}:${D}`,l||!this.j.has(y)||g===y)break;P++}while(P<=f.length);return y}lb(a){if(a.iconPath&&!(a.iconPath instanceof S.$SM))return typeof a.iconPath=="string"||$.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof S.$SM)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return $.URI.isUri(a)?a:$.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,d,c){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==d.item.handle&&this.j.delete(d.item.handle),this.ob(a,t);const s=this.X(c)||[],l=s.filter(h=>h.item.handle===d.item.handle)[0];l&&s.splice(s.indexOf(l),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const d of t.children){const c=this.j.get(d.item.handle);c&&this.sb(c)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const d of t.children){const c=this.j.get(d.item.handle);c&&this.sb(c)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[351],Ie([1,0,4,3,2,30,15,92,6,7]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class L extends O.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(k,u,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new I.$3d),this.onDidDispose=this.#d.event,this.#h=this.B(new I.$3d),this.onDidChangeViewState=this.#h.event,this.#e=k,this.#t=u,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(k){this.c(),this.#r!==k&&(this.#r=k,this.#t.$setTitle(this.#e,k))}get iconPath(){return this.c(),this.#a}set iconPath(k){this.c(),this.#a!==k&&(this.#a=k,this.#t.$setIconPath(this.#e,$.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(k){this.#l||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(this.#u=k.active,this.#c=k.visible,this.#o=k.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(k,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof k>"u"?void 0:R.ViewColumn.from(k),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends O.$Tc{static c(){return(0,A.$yg)()}constructor(k,u,m){super(),this.j=u,this.m=m,this.g=new Map,this.h=new Map,this.f=k.getProxy(p.$VL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(k=>k.dispose()),this.g.clear()}createWebviewPanel(k,u,m,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,v.$zhc)(k),t=C.c();this.f.$createWebviewPanel((0,v.$Bhc)(k),t,u,{title:m,panelOptions:w(i),webviewOptions:(0,v.$Chc)(k,this.m,i),serializeBuffersForPostMessage:a},r);const d=this.j.createNewWebview(t,i,k);return this.createNewWebviewPanel(t,u,m,n,i,d,!0)}$onDidChangeWebviewPanelViewStates(k){const u=Object.keys(k);u.sort((m,o)=>{const i=k[m],n=k[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const m of u){const o=this.getWebviewPanel(m);if(!o)continue;const i=k[m];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.g.delete(k),this.j.deleteWebview(k)}registerWebviewPanelSerializer(k,u,m){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:m,extension:k}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,v.$zhc)(k)}),new S.$XL(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(k,u,m,o){const i=this.h.get(u);if(!i)throw new Error(`No serializer found for '${u}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(k,m.webviewOptions,r),t=this.createNewWebviewPanel(k,u,m.title,o,m.panelOptions,a,m.active);await n.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(k,u,m,o,i,n,r){const a=new L(k,this.f,n,{viewType:u,title:m,viewColumn:o,panelOptions:i,active:r});return this.g.set(k,a),a}getWebviewPanel(k){return this.g.get(k)}}e.$Dhc=C;function w(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[352],Ie([1,0,4,3,92,15,6,7]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class p extends O.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,w,E,k,u,m){super(),this.#s=!1,this.#u=this.B(new I.$3d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new I.$3d),this.onDidDispose=this.#l.event,this.#i=E,this.#a=k,this.#e=C,this.#t=w,this.#n=u,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class S{constructor(C,w){this.d=w,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$VL.MainThreadWebviewViews)}registerWebviewViewProvider(C,w,E,k){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:E,extension:C}),this.a.$registerWebviewViewProvider((0,$.$Bhc)(C),w,{retainContextWhenHidden:k?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,$.$zhc)(C)}),new v.$XL(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(C,w,E,k,u){const m=this.b.get(w);if(!m)throw new Error(`No view provider found for '${w}'`);const{provider:o,extension:i}=m,n=this.d.createNewWebview(C,{},i),r=new p(C,this.a,w,E,n,!0);this.c.set(C,r),await o.resolveWebviewView(r,{state:k},u)}async $onDidChangeWebviewViewVisibility(C,w){this.e(C)._setVisible(w)}async $disposeWebviewView(C){const w=this.e(C);this.c.delete(C),w.dispose(),this.d.deleteWebview(C)}e(C){const w=this.c.get(C);if(!w)throw new Error("No webview found");return w}}e.$8ic=S}),define(Ce[353],Ie([1,0,70,16,13,251,32,11]),function(me,e,I,O,$,A,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;let p=class{constructor(C,w){C.addFileSystemProvider(O.Schemas.file,new S(w),{isCaseSensitive:v.$k})}};e.$Mjc=p,e.$Mjc=p=Ke([We(0,I.$vhc),We(1,$.$wj)],p);class S{constructor(C){this.b=C,this.a=new A.$Kq(this.b)}async stat(C){const w=await this.a.stat(C);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,w,E){return this.a.writeFile(C,w,{...E,unlock:!1,atomic:!1})}delete(C,w){return this.a.delete(C,{...w,useTrash:!1,atomic:!1})}rename(C,w,E){return this.a.rename(C,w,E)}copy(C,w,E){return this.a.copy(C,w,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,w){throw new Error("Method not implemented.")}}}),define(Ce[354],Ie([1,0,17,64,30,33,3,6,2,20]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=void 0;let L=class extends R.$Tc{constructor(w,E){super();const k=w.getProxy(v.$VL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async u=>{const m=p.URI.file((0,I.$jc)((0,O.tmpdir)(),(0,$.$yg)()));return await k.$download(u,m),m})}};e.$Kjc=L,e.$Kjc=L=Ke([We(0,S.$aO),We(1,A.$wO)],L)}),define(Ce[355],Ie([1,0,57,17,2,93,3,16,8,31]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class L extends A.$xhc{constructor(){super(...arguments),this.i=null}async g(t){const d=await super.g(t);if(d.scheme!==v.Schemas.file)return d;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${d.fsPath}.`),d;const c=d.fsPath;let s=0;do{let l;s===0?l=c:l=/[/\\]$/.test(c)?`${c.substr(0,c.length-1)}-${s}`:`${c}-${s}`,await C(l);const h=O.$jc(l,"vscode.lock"),b=await u(this.d,h,!1);if(b)return this.i=b,process.on("exit",()=>{b.dispose()}),$.URI.file(l);s++}while(s<10);return d}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Wjc=L;async function C(a){try{await S.Promises.stat(a);return}catch{}try{await S.Promises.mkdir(a,{recursive:!0})}catch{}}const w=1e3,E=10*60*1e3;class k extends R.$Tc{constructor(t,d){super(),this.b=t,this.c=d,this.a=this.B(new p.$nh),this.a.cancelAndSet(async()=>{const c=await m(t,d);(!c||c.pid!==process.pid)&&(t.info(`Lock '${d}': The lock was lost unexpectedly.`),this.a.cancel());try{await S.Promises.utimes(d,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${d}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{I.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const d={pid:process.pid,willReleaseAt:Date.now()+t};await S.Promises.writeFile(this.c,JSON.stringify(d),{flag:"w"})}catch(d){this.b.error(d)}}}async function u(a,t,d){try{const s={pid:process.pid,willReleaseAt:0};await S.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){a.error(s)}const c=await m(a,t);return!c||c.pid!==process.pid?d?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new k(a,t))}async function m(a,t){let d;try{d=await S.Promises.readFile(t)}catch(c){return a.error(c),null}try{return JSON.parse(String(d))}catch(c){return a.error(c),null}}async function o(a,t){let d;try{d=await S.Promises.stat(t)}catch(c){return a.error(c),0}return d.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const d=await m(a,t);if(!d)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(d.willReleaseAt){let b=d.willReleaseAt-Date.now();if(b<5e3){for(b>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${b} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);b>0;){if(await(0,p.$dh)(Math.min(100,b)),await o(a,t)===0)return r(a,t);b=d.willReleaseAt-Date.now()}return r(a,t)}}if(!i(d.pid))return a.info(`Lock '${t}': The pid ${d.pid} appears to be gone.`),r(a,t);const c=await o(a,t),s=Date.now()-c;if(s<=E)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$dh)(2e3);const l=await o(a,t),h=Date.now()-l;return h<=E?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await S.Promises.unlink(t)}catch{}return u(a,t,!0)}}),define(Ce[356],Ie([1,0,30,20,46,33]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;let R=class extends $.$Thc{constructor(p,S){super(!0,p,S)}createTerminal(p,S,L){return this.createTerminalFromOptions({name:p,shellPath:S,shellArgs:L})}createTerminalFromOptions(p,S){const L=new $.$Shc(this.a,(0,I.$yg)(),p,p.name);return this.f.push(L),L.create(p,this.R(p,S)),L.value}};e.$fjc=R,e.$fjc=R=Ke([We(0,A.$wO),We(1,O.$aO)],R)}),define(Ce[357],Ie([1,0,4,37,45,5]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.$eL=e.OutputChannelUpdateMode=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=void 0,e.$7K="text/x-code-output",e.$8K="output",e.$9K="Log",e.$0K="text/x-code-log-output",e.$$K="log",e.$_K="workbench.panel.output",e.$aL=new $.$tj("inOutput",!1),e.$bL=new $.$tj("activeLogOutput",!1),e.$cL=new $.$tj("outputView.scrollLock",!1),e.$dL=(0,A.$ci)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$eL={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.a=new Map,this.b=new I.$3d,this.onDidRegisterChannel=this.b.event,this.c=new I.$3d,this.onDidRemoveChannel=this.c.event}registerChannel(S){this.a.has(S.id)||(this.a.set(S.id,S),this.b.fire(S.id))}getChannels(){const S=[];return this.a.forEach(L=>S.push(L)),S}getChannel(S){return this.a.get(S)}removeChannel(S){this.a.delete(S),this.c.fire(S)}}O.$Rn.add(e.$eL.OutputChannels,new v),e.$fL=new $.$tj("activeOutputChannel","")}),define(Ce[153],Ie([1,0,6,5,20,26,13,357,70,27,59,183,21,18,32,4,3]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=void 0;class o extends R.$Cj{get disposed(){return this.n}constructor(a,t,d,c,s){super(),this.id=a,this.name=t,this.r=d,this.s=c,this.extension=s,this.m=0,this.n=!1,this.visible=!1,this.setLevel(d.getLevel()),this.B(d.onDidChangeLogLevel(l=>this.setLevel(l)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=w.$qe.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,d,c,s,l){this.i=t,this.j=d,this.k=c,this.l=s,this.m=l,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(I.$VL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Gm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,d]of this.g)d.visible=t===this.h}createOutputChannel(a,t,d){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const c=typeof t=="object"&&t.log,s=(0,E.$Qf)(t)?t:void 0;if((0,E.$Qf)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let l;const h=this.i.environment.extensionLogLevel?.find(([D])=>A.$um.equals(d.identifier,D))?.[1];h&&(l=(0,R.$Mj)(h));const b=c?this.o(a,l,d):this.n(a,s,d);return b.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),c?this.r(a,l??this.m.getLevel(),b):this.q(a,b)}async n(a,t,d){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const c=await this.c,s=this.k.extUri.joinPath(c,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),l=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,s,t,d.identifier.value);return new o(h,a,l,this.a,d)}async o(a,t,d){const c=await this.p(d),s=a.replace(/[\\/:\*\?"<>\|]/g,""),l=this.k.extUri.joinPath(c,`${s}.log`),h=`${d.identifier.value}.${s}`,b=this.l.createLogger(l,{id:h,name:a,logLevel:t,extensionId:d.identifier.value});return new i(h,a,b,this.a,d)}p(a){let t=this.d.get(a.identifier.value);if(!t){const d=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(d)}catch(c){if((0,k.$Pk)(c)!==k.FileSystemProviderErrorCode.FileExists)throw c}return d})())}return t}q(a,t){let d=!1;const c=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return a},append(s){c(),t.then(l=>l.append(s))},appendLine(s){c(),t.then(l=>l.appendLine(s))},clear(){c(),t.then(s=>s.clear())},replace(s){c(),t.then(l=>l.replace(s))},show(s,l){c(),t.then(h=>h.show(s,l))},hide(){c(),t.then(s=>s.hide())},dispose(){d=!0,t.then(s=>s.dispose())}}}r(a,t,d){const c=new m.$Sc,s=()=>{if(c.isDisposed)throw new Error("Channel has been closed")},l=c.add(new u.$3d);function h(b){t=b,l.fire(b)}return d.then(b=>{c.add(b),b.logLevel!==t&&h(b.logLevel),c.add(b.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,d),get logLevel(){return t},onDidChangeLogLevel:l.event,trace(b,...D){s(),d.then(g=>g.trace(b,...D))},debug(b,...D){s(),d.then(g=>g.debug(b,...D))},info(b,...D){s(),d.then(g=>g.info(b,...D))},warn(b,...D){s(),d.then(g=>g.warn(b,...D))},error(b,...D){s(),d.then(g=>g.error(b,...D))},dispose(){c.dispose()}}}};e.$Iic=n,e.$Iic=n=Ke([We(0,$.$aO),We(1,S.$qO),We(2,p.$vhc),We(3,L.$0gc),We(4,R.$xj),We(5,R.$wj)],n),e.$Jic=(0,O.$ci)("IExtHostOutputService")}),define(Ce[154],Ie([1,0,5,8]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,I.$ci)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure($){let A=1/0;for(let v=0;v<this.maxSampleCount;v++){const p=await $.getRoundTripTime();if(p===void 0)return;A=Math.min(A,p/2),await(0,O.$dh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((v,p)=>v+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((v,p)=>v+p,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[358],Ie([1,0,225,86,37,40,51,3,4,154,11,24,8]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=void 0,e.$BI=Object.freeze({id:"application",order:100,title:(0,I.localize)(0,null),type:"object"}),e.$CI=Object.freeze({id:"workbench",order:7,title:(0,I.localize)(1,null),type:"object"}),e.$DI=Object.freeze({id:"security",scope:1,title:(0,I.localize)(2,null),type:"object",order:7}),e.$EI=Object.freeze({id:"problems",title:(0,I.localize)(3,null),type:"object",order:101}),e.$FI={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new p.$3d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const k=new E;$.$Rn.add(e.$FI.ConfigurationMigration,k);let u=class extends v.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const a of r.added)await this.f(a,k.migrations)})),this.c(k.migrations),this.B(k.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(r=>this.g(r,i?.uri))])}async g(i,n){const r=this.a.inspect(i.key,{resource:n}),a=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,d]of a){const c=r[t];if(!c)continue;const s=[];if(c.value!==void 0){const l=await this.h(i,t,c.value,n,void 0);for(const h of l??[])s.push([h,[]])}for(const{identifiers:l,value:h}of c.overrides??[])if(h!==void 0){const b=await this.h(i,t,h,n,l);for(const D of b??[])s.push([D,l])}s.length&&await Promise.allSettled(s.map(async([[l,h],b])=>this.a.updateValue(l,h.value,{resource:n,overrideIdentifiers:b},d)))}}async h(i,n,r,a,t){const d=s=>{const h=this.a.inspect(s,{resource:a})[n];if(h)return t?h.overrides?.find(({identifiers:b})=>(0,C.$Jn)(b,t))?.value:h.value},c=await i.migrateFn(r,d);return Array.isArray(c)?c:[[i.key,c]]}};e.$GI=u,e.$GI=u=Ke([We(0,R.$Ii),We(1,A.$li)],u);let m=class extends v.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new w.$zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!L.$i&&(await this.b.getEnvironment())?.os!==1)return;$.$Rn.as(O.$Wn.Configuration).registerConfiguration({...e.$DI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,I.localize)(4,null)},default:[],markdownDescription:(0,I.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,I.localize)(6,null),scope:2}}})}};e.$HI=m,e.$HI=m=Ke([We(0,S.$Vm)],m)}),define(Ce[359],Ie([1,0,35,16,17,23,234,358,86,5,37]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Beb=e.$Aeb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$zeb=e.$yeb=void 0,e.$yeb=(0,S.$ci)("editorResolverService"),e.$zeb="workbench.editorAssociations";const C=L.$Rn.as(p.$Wn.Configuration),w={...v.$CI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(w);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var k;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(k||(e.ResolvedStatus=k={}));function u(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$Aeb=u;function m(o,i){if(new Set([O.Schemas.extension,O.Schemas.webviewPanel,O.Schemas.vscodeWorkspaceTrust,O.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf($.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$Mg)(i);return I.$Uj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$Beb=m}),define(Ce[360],Ie([1,0,34,16,17,11,23,2,5,269,40,144,154]),function(me,e,I,O,$,A,R,v,p,S,L,C,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$xL=void 0,e.$xL=(0,p.$ci)("pathService");let k=E=class{constructor(m,o,i,n){this.d=m,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(m,n,o)):this.h(m,o,i)}h(m,o,i){return m.scheme===O.Schemas.file||m.scheme===O.Schemas.vscodeRemote?(0,I.$bg)(i??(0,R.$Mg)(m),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return O.Schemas.vscodeRemote;const i=(0,S.$uL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:O.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?$.$fc:$.$gc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(o=m.substring(2),m="/"):(o=m.substring(2,n),m=m.substring(n)||"/")}return v.URI.from({scheme:O.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$yL=k,e.$yL=k=E=Ke([We(1,w.$Vm),We(2,C.$gL),We(3,L.$li)],k)}),define(Ce[361],Ie([1,0,236,19,52,4,54,3,2,51,241,13,65,271,88,40,144,25,22,18,24,45]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rL=e.$qL=e.$pL=e.OnPortForward=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.TunnelSource=e.TunnelCloseReason=e.$jL=e.$iL=e.$hL=void 0;const t=10*1e3,d="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",s=1e3*60*60*24*14;e.$hL="onTunnel",e.$iL=new a.$tj("forwardedPortsViewEnabled",!1,I.localize(0,null));function l(z){const F=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(F)return{host:F[1]?.substring(0,F[1].length-1)||"localhost",port:Number(F[2])}}e.$jL=l;var h;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var b;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(b||(e.TunnelSource=b={})),e.$kL={source:b.User,description:I.localize(1,null)},e.$lL={source:b.Auto,description:I.localize(2,null)};function D(z,F,M){const T=z.get(f(F,M));if(T)return T;if((0,k.$Ov)(F))for(const j of k.$Nv){const J=f(j,M);if(z.has(J))return z.get(J)}else if((0,k.$Qv)(F))for(const j of k.$Pv){const J=f(j,M);if(z.has(J))return z.get(J)}}e.$mL=D;function g(z,F,M){const T=D(z,F,M);if(T)return T;const j=(0,k.$Qv)(F)?"localhost":(0,k.$Ov)(F)?"0.0.0.0":void 0;if(j)return D(z,j,M)}e.$nL=g;function f(z,F){return z+":"+F}e.$oL=f;var y;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(y||(e.OnPortForward=y={}));function P(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$pL=P;class N extends v.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(F){super(),this.r=F,this.j=[],this.n=new A.$3d,this.onDidChangeAttributes=this.n.event,this.B(F.onDidChangeConfiguration(M=>{(M.affectsConfiguration(N.c)||M.affectsConfiguration(N.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(F,M,T){let j=this.w(F,M,T,this.j,0);const J={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const ne=this.j[j];ne.key===F?(J.onAutoForward=ne.onAutoForward??J.onAutoForward,J.elevateIfNeeded=ne.elevateIfNeeded!==void 0?ne.elevateIfNeeded:J.elevateIfNeeded,J.label=ne.label??J.label,J.requireLocalPort=ne.requireLocalPort,J.protocol=ne.protocol):(J.onAutoForward=J.onAutoForward??ne.onAutoForward,J.elevateIfNeeded=J.elevateIfNeeded!==void 0?J.elevateIfNeeded:ne.elevateIfNeeded,J.label=J.label??ne.label,J.requireLocalPort=J.requireLocalPort!==void 0?J.requireLocalPort:void 0,J.protocol=J.protocol??ne.protocol),j=this.w(F,M,T,this.j,j+1)}return J.onAutoForward!==void 0||J.elevateIfNeeded!==void 0||J.label!==void 0||J.requireLocalPort!==void 0||J.protocol!==void 0?J:this.C()}t(F){return F.start!==void 0&&F.end!==void 0}u(F){return F.host!==void 0&&F.port!==void 0&&(0,n.$Qf)(F.host)&&(0,n.$Uf)(F.port)}w(F,M,T,j,J){if(J>=j.length)return-1;const ne=!(0,k.$Ov)(M)&&!(0,k.$Qv)(M),Z=j.slice(J).findIndex(Y=>(0,n.$Uf)(Y.key)?ne?!1:Y.key===F:this.t(Y.key)?ne?!1:F>=Y.key.start&&F<=Y.key.end:this.u(Y.key)?F===Y.key.port&&M===Y.key.host:T?Y.key.test(T):!1);return Z>=0?Z+J:-1}y(){const F=this.r.getValue(N.c);if(!F||!(0,n.$Sf)(F))return[];const M=[];for(const j in F){if(j===void 0)continue;const J=F[j];let ne;if(Number(j))ne=Number(j);else if((0,n.$Qf)(j))if(N.g.test(j)){const _=j.match(N.g);ne={start:Number(_[1]),end:Number(_[2])}}else if(N.h.test(j)){const _=j.match(N.h);ne={host:_[1],port:Number(_[2])}}else{let _;try{_=RegExp(j)}catch{}_&&(ne=_)}ne&&M.push({key:ne,elevateIfNeeded:J.elevateIfNeeded,onAutoForward:J.onAutoForward,label:J.label,requireLocalPort:J.requireLocalPort,protocol:J.protocol})}const T=this.r.getValue(N.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(M)}z(F){function M(T,j){return(0,n.$Uf)(T.key)?T.key:j.t(T.key)?T.key.start:j.u(T.key)?T.key.port:Number.MAX_VALUE}return F.sort((T,j)=>M(T,this)-M(j,this))}C(){return this.m}static providedActionToAction(F){switch(F){case k.ProvidedOnAutoForward.Notify:return y.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return y.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return y.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return y.OpenPreview;case k.ProvidedOnAutoForward.Silent:return y.Silent;case k.ProvidedOnAutoForward.Ignore:return y.Ignore;default:return}}async addAttributes(F,M,T){const J=this.r.inspect(N.c).userRemoteValue;let ne;!J||!(0,n.$Sf)(J)?ne={}:ne=(0,r.$Fn)(J),ne[`${F}`]||(ne[`${F}`]={});for(const _ in M)ne[`${F}`][_]=M[_];return this.r.updateValue(N.c,ne,T)}}e.$qL=N;let U=class extends v.$Tc{constructor(F,M,T,j,J,ne,_,Z,Y,ce){super(),this.H=F,this.I=M,this.J=T,this.L=j,this.M=J,this.N=ne,this.O=_,this.P=Z,this.Q=Y,this.R=ce,this.c=new Map,this.g=new A.$3d,this.onForwardPort=this.g.event,this.h=new A.$3d,this.onClosePort=this.h.event,this.j=new A.$3d,this.onPortName=this.j.event,this.n=new A.$3d,this.onCandidatesChanged=this.n.event,this.t=new A.$3d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$3d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new N(T),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ie=>{const fe=await this.getAttributes(ie.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of ie)if(re.localAddress){const K=f(re.tunnelRemoteHost,re.tunnelRemotePort),B=g(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set(K,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:fe?.get(re.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(re.localAddress,fe?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:re.privacy,source:e.$kL}),this.f.set(K,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ie=>{const fe=f(ie.tunnelRemoteHost,ie.tunnelRemotePort);if(!g(this.forwarded,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!g(this.detected,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&!g(this.c,ie.tunnelRemoteHost,ie.tunnelRemotePort)&&ie.localAddress){const re=g(this.m??new Map,ie.tunnelRemoteHost,ie.tunnelRemotePort),K=(await this.getAttributes([{port:ie.tunnelRemotePort,host:ie.tunnelRemoteHost}]))?.get(ie.tunnelRemotePort);this.forwarded.set(fe,{remoteHost:ie.tunnelRemoteHost,remotePort:ie.tunnelRemotePort,localAddress:ie.localAddress,protocol:K?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ie.localAddress,K),localPort:ie.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:ie.privacy,source:e.$kL})}await this.cb(),this.f.set(fe,ie),this.g.fire(this.forwarded.get(fe))})),this.B(this.H.onTunnelClosed(ie=>this.W(ie,h.Other))),this.U()}S(){return this.Q.extensions.find(F=>F.activationEvents?.includes(e.$hL))?(this.R.createKey(e.$iL.key,!0),!0):!1}U(){if(this.S())return;const F=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&F.dispose()}))}async W(F,M){const T=f(F.host,F.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.cb(),this.h.fire(F))}X(F,M){if(F.startsWith("http"))return p.URI.parse(F);const T=M?.protocol??"http";return p.URI.parse(`${T}://${F}`)}async Y(F){const M=this.N.getWorkspace(),T=M.configuration?(0,R.$3i)(M.configuration.path):M.folders.length>0?(0,R.$3i)(M.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${F}.${this.L.remoteAuthority}.${T}`}async Z(){return this.Y(d)}async $(){return this.Y(c)}async ab(){const F=this.I.get(d,1);if(F)return this.I.remove(d,1),await this.cb(),F;const M=await this.Z();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const F=await this.s;if(F&&F!==this.y){const M=JSON.parse(F)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(T=>T.remotePort).join(", ")}`);for(const T of M){const j=g(this.detected,T.remoteHost,T.remotePort);T.source.source!==b.Extension&&!j||T.source.source===b.Extension&&j?await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,elevateIfNeeded:!0,source:T.source}):T.source.source===b.Extension&&!j&&this.D.set(f(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const F=await this.Z();this.w=this.B(new v.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===F&&(this.s=Promise.resolve(this.I.get(F,0)),await this.restoreForwarded())}))}}bb(){const F=this.I.keys(0,0).filter(M=>M.startsWith(c));for(const M of F){const T=this.I.getNumber(M,0);if(T&&T<Date.now()){this.s=Promise.resolve(void 0);const j=M.replace(c,d);this.I.remove(M,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const F=Array.from(this.forwarded.values()),M=F.map(ne=>({remoteHost:ne.remoteHost,remotePort:ne.remotePort,localPort:ne.localPort,name:ne.name,localAddress:ne.localAddress,localUri:ne.localUri,protocol:ne.protocol,source:ne.source}));let T;F.length>0&&(T=JSON.stringify(M));const j=await this.Z(),J=await this.$();!T&&j&&J?(this.I.remove(j,0),this.I.remove(J,0)):T!==this.y&&j&&J&&(this.I.store(j,T,0,0),this.I.store(J,Date.now()+s,0,0)),this.y=T}}async eb(F,M,T){if(!F.tunnelLocalPort||!T?.requireLocalPort||F.tunnelLocalPort===M)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const J=I.localize(3,null,M,F.tunnelRemotePort,F.tunnelLocalPort);return this.P.info(J)}async forward(F,M){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(F,M)}async fb(F,M){await this.Q.activateByEvent(e.$hL);const T=g(this.forwarded,F.remote.host,F.remote.port);M=M??(M!==null?(await this.getAttributes([F.remote]))?.get(F.remote.port):void 0);const j=F.local!==void 0?F.local:F.remote.port;let J;if(T)return this.hb(T,F,M);{const ne=this.L.remoteAuthority,_=ne?{getAddress:async()=>(await this.M.resolveAuthority(ne)).authority}:void 0,Z=f(F.remote.host,F.remote.port);this.c.set(Z,!0),F=this.gb(Z,F);const Y=await this.H.openTunnel(_,F.remote.host,F.remote.port,void 0,j,F.elevateIfNeeded?F.elevateIfNeeded:M?.elevateIfNeeded,F.privacy,M?.protocol);if(typeof Y=="string")J=Y;else if(Y&&Y.localAddress){const ce=g(this.m??new Map,F.remote.host,F.remote.port),ie=Y.protocol?Y.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:M?.protocol??k.TunnelProtocol.Http,fe={remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localPort:Y.tunnelLocalPort,name:M?.label??F.name,closeable:!0,localAddress:Y.localAddress,protocol:ie,localUri:await this.X(Y.localAddress,M),runningProcess:ce?.detail,hasRunningProcess:!!ce,pid:ce?.pid,source:F.source??e.$kL,privacy:Y.privacy};return this.forwarded.set(Z,fe),this.f.set(Z,Y),this.c.delete(Z),await this.cb(),await this.eb(Y,j,M),this.g.fire(fe),Y}this.c.delete(Z)}return J}gb(F,M){const T=this.D.has(F)?this.D:this.F.has(F)?this.F:void 0;if(T){const j=T.get(F);T.delete(F),j&&(M.name=j.name??M.name,M.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??M.local,M.privacy=M.privacy)}return M}async hb(F,M,T){const j=T?.label??M.name;let J;(function(_){_[_.None=0]="None",_[_.Fire=1]="Fire",_[_.Reopen=2]="Reopen"})(J||(J={}));let ne=J.None;switch(j!==F.name&&(F.name=j,ne=J.Fire),(T?.protocol||F.protocol!==k.TunnelProtocol.Http)&&T?.protocol!==F.protocol&&(M.source=F.source,ne=J.Reopen),M.privacy&&F.privacy!==M.privacy&&(ne=J.Reopen),ne){case J.Fire:{this.g.fire();break}case J.Reopen:await this.close(F.remoteHost,F.remotePort,h.User),await this.fb(M,T)}return g(this.f,M.remote.host,M.remote.port)}async name(F,M,T){const j=g(this.forwarded,F,M),J=f(F,M);if(j){j.name=T,await this.cb(),this.j.fire({host:F,port:M});return}else this.detected.has(J)&&(this.detected.get(J).name=T,this.j.fire({host:F,port:M}))}async close(F,M,T){const j=f(F,M),J=this.forwarded.get(j);return T===h.AutoForwardEnd&&J&&J.source.source===b.Auto&&this.F.set(j,{local:J.localPort,name:J.name,privacy:J.privacy}),await this.H.closeTunnel(F,M),this.W({host:F,port:M},T)}address(F,M){const T=f(F,M);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(F){if(F)for(const M of F){const T=g(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),j=typeof M.localAddress=="string"?M.localAddress:f(M.localAddress.host,M.localAddress.port);this.detected.set(f(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:j,protocol:k.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:b.Extension,description:I.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,j,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(F){this.r=F}async setCandidates(F){let M=F;this.r&&(M=await this.r(F));const T=this.ib(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(j=>j.port).join(", ")}`),this.n.fire(T)}ib(F){const M=this.m??new Map,T=new Map;return this.m=T,F.forEach(j=>{const J=f(j.host,j.port);T.set(J,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),M.has(J)&&M.delete(J);const ne=g(this.forwarded,j.host,j.port);ne&&(ne.runningProcess=j.detail,ne.hasRunningProcess=!0,ne.pid=j.pid)}),M.forEach((j,J)=>{const ne=l(J);if(!ne)return;const _=g(this.forwarded,ne.host,ne.port);_&&(_.runningProcess=void 0,_.hasRunningProcess=!1,_.pid=void 0);const Z=g(this.detected,ne.host,ne.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const F=Array.from(this.forwarded.values()),M=await this.getAttributes(F.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(M)for(const T of F){const j=M.get(T.remotePort);(j?.protocol||T.protocol!==k.TunnelProtocol.Http)&&j?.protocol!==T.protocol&&await this.fb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},j),j&&j.label&&j.label!==T.name&&await this.name(T.remoteHost,T.remotePort,j.label)}}async getAttributes(F,M=!0){const T=new Map,j=new Map;F.forEach(Y=>{const ce=g(this.m??new Map,k.$Nv[0],Y.port)??Y;if(ce){T.set(Y.port,ce);const ie=P(ce)?ce.pid:void 0;j.has(ie)||j.set(ie,[]),j.get(ie)?.push(Y.port)}});const J=new Map;if(F.forEach(Y=>{const ce=this.configPortsAttributes.getAttributes(Y.port,Y.host,T.get(Y.port)?.detail);ce&&J.set(Y.port,ce)}),this.G.length===0||!M)return J.size>0?J:void 0;const ne=await Promise.all((0,O.$Rb)(this.G.map(Y=>Array.from(j.entries()).map(ce=>{const ie=ce[1],fe=T.get(ie[0]);return Y.providePortAttributes(ie,fe?.pid,fe?.detail,new i.$ae().token)})))),_=new Map;if(ne.forEach(Y=>Y.forEach(ce=>{ce&&_.set(ce.port,ce)})),!J&&!_)return;const Z=new Map;return F.forEach(Y=>{const ce=J.get(Y.port),ie=_.get(Y.port);Z.set(Y.port,{elevateIfNeeded:ce?.elevateIfNeeded,label:ce?.label,onAutoForward:ce?.onAutoForward??N.providedActionToAction(ie?.autoForwardAction),requireLocalPort:ce?.requireLocalPort,protocol:ce?.protocol})}),Z}addAttributesProvider(F){this.G.push(F)}};e.$rL=U,Ke([(0,$.$Hh)(1e3)],U.prototype,"cb",null),e.$rL=U=Ke([We(0,k.$Jv),We(1,E.$Dp),We(2,S.$Ii),We(3,m.$gL),We(4,w.$el),We(5,u.$li),We(6,C.$wj),We(7,L.$cw),We(8,o.$OF),We(9,a.$uj)],U)}),define(Ce[94],Ie([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$J=e.$0J=void 0;class I{constructor(R,v){this.line=R,this.character=v}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,v){return new I(0,0)}with(R){return new I(0,0)}}e.$0J=I;class O{constructor(R,v,p,S){this.isEmpty=!1,this.isSingleLine=!1,this.start=new I(R,v),this.end=new I(p,S)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new O(0,0,0,0)}with(R){return new O(0,0,0,0)}}e.$$J=O;var $;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})($||(e.TextSearchCompleteMessageType=$={}))}),define(Ce[36],Ie([1,0,19,35,24,34,12,5,17,14,94,8]),function(me,e,I,O,$,A,R,v,p,S,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.SearchErrorCode=e.$nK=e.$mK=e.SearchSortOrder=e.ViewMode=e.$lK=e.$kK=e.$jK=e.$iK=e.SearchCompletionExitCode=e.$hK=e.$gK=e.$fK=e.QueryType=e.SearchProviderType=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return L.TextSearchCompleteMessageType}}),e.$_J="workbench.view.search",e.$aK="workbench.panel.search",e.$bK="workbench.view.search",e.$cK="search-result",e.$dK="search.exclude";const w="\u27EA ",E=" characters skipped \u27EB",k=(w.length+E.length+5)*2;e.$eK=(0,v.$ci)("searchService");var u;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(u||(e.SearchProviderType=u={}));var m;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(m||(e.QueryType=m={}));function o(Y){return!!Y.preview}e.$fK=o;function i(Y){return!!Y.resource}e.$gK=i;function n(Y){return!!Y.message}e.$hK=n;var r;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(ce){this.resource=ce,this.results=[]}}e.$iK=a;class t{constructor(ce,ie,fe,re){this.ranges=ie,this.webviewIndex=re;const K=Array.isArray(ie)?ie:[ie];if(fe&&fe.matchLines===1&&d(K)){ce=(0,R.$Jf)(ce,fe.matchLines);let B="",ae=0,ye=0;const le=Math.floor(fe.charsPerLine/5),de=[];for(const ue of K){const ge=Math.max(ue.startColumn-le,0),V=ue.startColumn+fe.charsPerLine;if(ge>ye+le+k){const X=w+(ge-ye)+E;B+=X+ce.slice(ge,V),ae+=ge-(ye+X.length)}else B+=ce.slice(ye,V);de.push(new s(0,ue.startColumn-ae,ue.endColumn-ae)),ye=V}this.preview={text:B,matches:Array.isArray(this.ranges)?de:de[0]}}else{const B=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:ce,matches:(0,I.$2b)(ie,ae=>new c(ae.startLineNumber-B,ae.startColumn,ae.endLineNumber-B,ae.endColumn))}}}}e.$jK=t;function d(Y){const ce=Y[0].startLineNumber;for(const ie of Y)if(ie.startLineNumber!==ce||ie.endLineNumber!==ce)return!1;return!0}class c{constructor(ce,ie,fe,re){this.startLineNumber=ce,this.startColumn=ie,this.endLineNumber=fe,this.endColumn=re}}e.$kK=c;class s extends c{constructor(ce,ie,fe){super(ce,ie,ce,fe)}}e.$lK=s;var l;(function(Y){Y.List="list",Y.Tree="tree"})(l||(e.ViewMode=l={}));var h;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function b(Y,ce=!0){const ie=Y&&Y.files&&Y.files.exclude,fe=ce&&Y&&Y.search&&Y.search.exclude;if(!ie&&!fe)return;if(!ie||!fe)return ie||fe;let re=Object.create(null);return re=$.$In(re,$.$Fn(ie)),re=$.$In(re,$.$Fn(fe),!0),re}e.$mK=b;function D(Y,ce){return Y.excludePattern&&O.$Uj(Y.excludePattern,ce)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&O.$Uj(Y.includePattern,ce)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ie=>{const fe=ie.folder.fsPath;if(A.$dg(ce,fe)){const re=p.$lc(fe,ce);return!ie.includePattern||!!O.$Uj(ie.includePattern,re)}else return!1}):!1:!0}e.$nK=D;var g;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class f extends Error{constructor(ce,ie){super(ce),this.code=ie}}e.$oK=f;function y(Y){const ce=Y.message;if((0,S.$4)(Y))return new f(ce,g.canceled);try{const ie=JSON.parse(ce);return new f(ie.message,ie.code)}catch{return new f(ce,g.other)}}e.$pK=y;function P(Y){const ce={message:Y.message,code:Y.code};return new Error(JSON.stringify(ce))}e.$qK=P;function N(Y){return Y.type==="error"?!0:Y.type==="success"}e.$rK=N;function U(Y){return Y.type==="success"}e.$sK=U;function z(Y){return!!Y.path}e.$tK=z;function F(Y,ce,ie=!0){const fe=Y.searchPath?Y.searchPath:Y.relativePath;return ie?(0,R.$Gf)(fe,ce):O.$Uj(ce,fe)}e.$uK=F;class M{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vK=M;function T(Y,ce){const ie={...Y||{},...ce||{}};return Object.keys(ie).filter(fe=>{const re=ie[fe];return typeof re=="boolean"&&re})}e.$wK=T;class j{constructor(ce,ie){this.c=null,this.a={...ce.excludePattern||{},...ie.excludePattern||{}},this.b=O.$Vj(this.a);let fe=ce.includePattern;ie.includePattern&&(fe?fe={...fe,...ie.includePattern}:fe=ie.includePattern),fe&&(this.c=O.$Vj(fe))}matchesExcludesSync(ce,ie,fe){return!!(this.b&&this.b(ce,ie,fe))}includedInQuerySync(ce,ie,fe){return!(this.b&&this.b(ce,ie,fe)||this.c&&!this.c(ce,ie,fe))}includedInQuery(ce,ie,fe){const re=this.b(ce,ie,fe),K=()=>this.c?!!this.c(ce,ie,fe):!0;return(0,C.$1g)(re)?re.then(B=>B?!1:K()):K()}hasSiblingExcludeClauses(){return J(this.a)}}e.$xK=j;function J(Y){for(const ce in Y)if(typeof Y[ce]!="boolean")return!0;return!1}function ne(Y){if(!Y)return;let ce;return ie=>(ce||(ce=(Y()||Promise.resolve([])).then(fe=>fe?Z(fe):{})),ce.then(fe=>!!fe[ie]))}e.$yK=ne;function _(Y){if(!Y)return;let ce;return ie=>{if(!ce){const fe=Y();ce=fe?Z(fe):{}}return!!ce[ie]}}e.$zK=_;function Z(Y){const ce={};for(const ie of Y)ce[ie]=!0;return ce}}),define(Ce[41],Ie([1,0,19,8,22,4,3,78,16,122,23,12,2,223,5,13,254,40,59,27,20,15,7,67,36,6,56]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;function h(U,z,F){return new L.$Eg(M=>f(M,F)).isEqual(U,z)}function b(U,z,F){return h(U.uri,z.uri,F)?0:(0,C.$af)(U.uri.toString(),z.uri.toString())}function D(U,z,F){return U.index!==z.index?U.index<z.index?-1:1:h(U.uri,z.uri,F)?(0,C.$af)(U.name,z.name):(0,C.$af)(U.uri.toString(),z.uri.toString())}function g(U,z,F,M){const T=U.slice(0).sort((J,ne)=>F(J,ne,M)),j=z.slice(0).sort((J,ne)=>F(J,ne,M));return(0,I.$Eb)(T,j,(J,ne)=>F(J,ne,M))}function f(U,z){const F=z.getCapabilities(U.scheme);return!(F&&F&1024)}class y extends o.$vi{static toExtHostWorkspace(z,F,M,T){if(!z)return{workspace:null,added:[],removed:[]};const{id:j,name:J,folders:ne,configuration:_,transient:Z,isUntitled:Y}=z,ce=[],ie=F;F?ne.forEach((B,ae)=>{const ye=w.URI.revive(B.uri),le=y.o(M||F,ye,T);le?(le.name=B.name,le.index=B.index,ce.push(le)):ce.push({uri:ye,name:B.name,index:ae})}):ce.push(...ne.map(({uri:B,name:ae,index:ye})=>({uri:w.URI.revive(B),name:ae,index:ye}))),ce.sort((B,ae)=>B.index<ae.index?-1:1);const fe=new y(j,J,ce,!!Z,_?w.URI.revive(_):null,!!Y,B=>f(B,T)),{added:re,removed:K}=g(ie?ie.workspaceFolders:[],fe.workspaceFolders,b,T);return{workspace:fe,added:re,removed:K}}static o(z,F,M){for(let T=0;T<z.folders.length;T++){const j=z.workspaceFolders[T];if(h(j.uri,F,M))return j}}constructor(z,F,M,T,j,J,ne){super(z,M.map(_=>new o.$wi(_)),T,j,ne),this.t=F,this.u=J,this.q=[],this.s=v.$ii.forUris(ne),M.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,F){return F&&this.s.get(z)&&(z=(0,L.$Og)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let P=class{constructor(z,F,M,T,j){this.c=new A.$3d,this.onDidChangeWorkspace=this.c.event,this.g=new A.$3d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$5d,this.C=new Map,this.h=T,this.s=M,this.t=j,this.j=new S.$fm,this.k=new O.$bh,this.o=z.getProxy(s.$VL.MainThreadWorkspace),this.q=z.getProxy(s.$VL.MainThreadMessageService);const J=F.workspace;this.l=J?new y(J.id,J.name,[],!!J.transient,J.configuration?w.URI.revive(J.configuration):null,!!J.isUntitled,ne=>f(ne,M)):void 0}$initializeWorkspace(z,F){this.v=F,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:p.Schemas.untitled,path:(0,L.$Mg)((0,L.$Og)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,F,M,...T){const j=[];if(Array.isArray(T)&&T.forEach(Y=>{w.URI.isUri(Y.uri)&&!j.some(ce=>h(ce.uri,Y.uri,this.s))&&j.push({uri:Y.uri,name:Y.name||(0,L.$Lg)(Y.uri)})}),this.n||[F,M].some(Y=>typeof Y!="number"||Y<0)||M===0&&j.length===0)return!1;const J=this.x?this.x.workspaceFolders:[];if(F+M>J.length)return!1;const ne=J.slice(0);ne.splice(F,M,...j.map(Y=>({uri:Y.uri,name:Y.name||(0,L.$Lg)(Y.uri),index:void 0})));for(let Y=0;Y<ne.length;Y++){const ce=ne[Y];if(ne.some((ie,fe)=>fe!==Y&&h(ce.uri,ie.uri,this.s)))return!1}ne.forEach((Y,ce)=>Y.index=ce);const{added:_,removed:Z}=g(J,ne,D,this.s);if(_.length===0&&Z.length===0)return!1;if(this.o){const Y=z.displayName||z.name;this.o.$updateWorkspaceFolders(Y,F,M,j).then(void 0,ce=>{this.n=void 0;const ie={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,Y,ce.toString()),ie,[])})}return this.y(ne),!0}getWorkspaceFolder(z,F){if(this.x)return this.x.getWorkspaceFolder(z,F)}async getWorkspaceFolder2(z,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,F)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,F){let M,T="";if(typeof z=="string"?(M=w.URI.file(z),T=z):typeof z<"u"&&(M=z,T=z.fsPath),!M)return T;const j=this.getWorkspaceFolder(M,!0);if(!j)return T;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let J=(0,L.$Rg)(j.uri,M);return F&&j.name&&(J=`${j.name}/${J}`),J}y(z){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:F,added:M,removed:T}=y.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:T}))}findFiles(z,F,M,T,j=$.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let J="",ne=!0;return F===null?ne=!1:F!==void 0&&(typeof F=="string"?J=F:J=F.pattern),this.z(z,void 0,{exclude:J,maxResults:M,useDefaultExcludes:ne,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},j)}findFiles2(z,F={},M,T=$.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${M.value}, entryPoint: findFiles2`),this.z(void 0,z,F,T)}async z(z,F,M,T=$.CancellationToken.None){if(T&&T.isCancellationRequested)return Promise.resolve([]);const j=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,J={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof M.useDefaultSearchExcludes=="boolean"?!M.useDefaultSearchExcludes:!1,maxResults:M.maxResults,excludePattern:j,shouldGlobSearch:typeof M.fuzzy=="boolean"?!M.fuzzy:!0,_reason:"startFileSearch"};let ne;if(z){const{includePattern:_,folder:Z}=N(a.GlobPattern.from(z));ne=Z,J.includePattern=_}else{const{includePattern:_,folder:Z}=N(a.GlobPattern.from(F));ne=Z,J.filePattern=_}return this.o.$startFileSearch(ne??null,J,T).then(_=>Array.isArray(_)?_.map(Z=>w.URI.revive(Z)):[])}async findTextInFiles(z,F,M,T,j=$.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const J=this.j.getNext(),ne=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:_,folder:Z}=N(a.GlobPattern.from(F.include)),Y=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ce={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:ne,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:_,excludePattern:Y},ie=!1;if(this.u[J]=fe=>{if(ie)return;const re=w.URI.revive(fe.resource);fe.results.forEach(K=>{const B=(0,l.$Lh)(K);(0,c.$fK)(B)?M({uri:re,preview:{text:B.preview.text,matches:(0,I.$2b)(B.preview.matches,ae=>new t.$ZL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))},ranges:(0,I.$2b)(B.ranges,ae=>new t.$ZL(ae.startLineNumber,ae.startColumn,ae.endLineNumber,ae.endColumn))}):M({uri:re,text:B.text,lineNumber:B.lineNumber})})},j.isCancellationRequested)return{};try{const fe=await this.o.$startTextSearch(z,Z??null,ce,J,j);return delete this.u[J],fe||{}}catch(fe){throw delete this.u[J],fe}}$handleTextSearchResult(z,F){this.u[F]?.(z)}async save(z){const F=await this.o.$save(z,{saveAs:!1});return w.URI.revive(F)}async saveAs(z){const F=await this.o.$save(z,{saveAs:!0});return w.URI.revive(F)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,F){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,F);const M=this.t.transformOutgoingScheme(z),T=this.A++;return this.o.$registerEditSessionIdentityProvider(T,M),(0,R.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(z,F){this.h.info("Getting edit session identifier for workspaceFolder",z);const M=await this.resolveWorkspaceFolder(w.URI.revive(z));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const T=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!T),!T)return;const j=await T.provideEditSessionIdentity(M,F);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(z,F,M,T){this.h.info("Getting edit session identifier for workspaceFolder",z);const j=await this.resolveWorkspaceFolder(w.URI.revive(z));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const J=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!J),!J)return;const ne=await J.provideEditSessionIdentityMatch?.(F,M,T);if(this.h.info("Provider returned edit session identifier match result: ",ne),!!ne)return ne}getOnWillCreateEditSessionIdentityEvent(z){return(F,M,T)=>{const j=function(ne){F.call(M,ne)};return j.extension=z,this.B.event(j,void 0,T)}}async $onWillCreateEditSessionIdentity(z,F,M){const T=await this.resolveWorkspaceFolder(w.URI.revive(z));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:T},F,async(j,J)=>{const ne=Date.now();await Promise.resolve(j),Date.now()-ne>M&&this.h.warn("SLOW edit session create-participant",J.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(z,F){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,F);const M=this.t.transformOutgoingScheme(z),T=this.A++;return this.o.$registerCanonicalUriProvider(T,M),(0,R.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(z,F,M){const T=this.C.get(z.scheme);if(!T)return;const j=await T.provideCanonicalUri?.(w.URI.revive(z),F,M);if(j)return j}async $provideCanonicalUri(z,F,M){return this.provideCanonicalUri(w.URI.revive(z),{targetScheme:F},M)}};e.$phc=P,e.$phc=P=Ke([We(0,r.$aO),We(1,n.$qO),We(2,i.$0gc),We(3,u.$wj),We(4,d.$nhc)],P),e.$qhc=(0,k.$ci)("IExtHostWorkspace");function N(U){let z,F;return U&&(typeof U=="string"?z=U:(z=U.pattern,F=w.URI.revive(U.baseUri))),{includePattern:z,folder:F}}}),define(Ce[42],Ie([1,0,24,4,41,6,7,256,86,18,8,5,20,13,2]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=void 0;function u(d,c){if(c){const s=c.split(".");let l=d;for(let h=0;l&&h<s.length;h++)l=l[s[h]];return l}}function m(d){return d instanceof k.URI}function o(d){return d&&d.uri instanceof k.URI&&d.languageId&&typeof d.languageId=="string"}function i(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function n(d){return d&&d.uri instanceof k.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function r(d){if(m(d))return{resource:d};if(o(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(i(d))return{overrideIdentifier:d.languageId};if(n(d))return{resource:d.uri};if(d===null)return{resource:null}}let a=class{constructor(c,s,l){this.a=c.getProxy(A.$VL.MainThreadConfiguration),this.c=s,this.b=l,this.d=new L.$bh,this.e=null}getConfigProvider(){return this.d.wait().then(c=>this.e)}$initializeConfiguration(c){this.e=new t(this.a,this.c,c,this.b),this.d.open()}$acceptConfigurationChanged(c,s){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(c,s))}};e.$rhc=a,e.$rhc=a=Ke([We(0,w.$aO),We(1,$.$qhc),We(2,E.$wj)],a);class t{constructor(c,s,l,h){this.a=new O.$3d,this.b=c,this.f=h,this.c=s,this.e=v.$do.parse(l),this.d=this.k(l.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(c,s){const l={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$do.parse(c),this.d=this.k(c.configurationScopes),this.a.fire(this.j(s,l))}getConfiguration(c,s,l){const h=r(s)||{},b=this.g(c?u(this.e.getValue(void 0,h,this.c.workspace),c):this.e.getValue(void 0,h,this.c.workspace));c&&this.h(c,h,l?.identifier);function D(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(f){return typeof u(b,f)<"u"},get:(f,y)=>{this.h(c?`${c}.${f}`:f,h,l?.identifier);let P=u(b,f);if(typeof P>"u")P=y;else{let N;const U=(z,F)=>{if((0,S.$Sf)(z)){let M;const T=()=>{N=N||(0,I.$Fn)(b),M=M||u(N,F)};return new Proxy(z,{get:(j,J)=>{if(typeof J=="string"&&J.toLowerCase()==="tojson")return T(),()=>M;if(N)return M=M||u(N,F),M[J];const ne=j[J];return typeof J=="string"?U(ne,`${F}.${J}`):ne},set:(j,J,ne)=>(T(),M&&(M[J]=ne),!0),deleteProperty:(j,J)=>(T(),M&&delete M[J],!0),defineProperty:(j,J,ne)=>(T(),M&&Object.defineProperty(M,J,ne),!0)})}return Array.isArray(z)?(0,I.$Fn)(z):z};P=U(P,f)}return P},update:(f,y,P,N)=>{f=c?`${c}.${f}`:f;const U=D(P);return y!==void 0?this.b.$updateConfigurationOption(U,f,y,h,N):this.b.$removeConfigurationOption(U,f,h,N)},inspect:f=>{f=c?`${c}.${f}`:f;const y=this.e.inspect(f,h,this.c.workspace);if(y)return{key:f,defaultValue:(0,I.$Fn)(y.policy?.value??y.default?.value),globalValue:(0,I.$Fn)(y.user?.value??y.application?.value),workspaceValue:(0,I.$Fn)(y.workspace?.value),workspaceFolderValue:(0,I.$Fn)(y.workspaceFolder?.value),defaultLanguageValue:(0,I.$Fn)(y.default?.override),globalLanguageValue:(0,I.$Fn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,I.$Fn)(y.workspace?.override),workspaceFolderLanguageValue:(0,I.$Fn)(y.workspaceFolder?.override),languageIds:(0,I.$Fn)(y.overrideIdentifiers)}}};return typeof b=="object"&&(0,I.$In)(g,b,!1),Object.freeze(g)}g(c){const s=l=>(0,S.$Sf)(l)?new Proxy(l,{get:(h,b)=>s(h[b]),set:(h,b,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(h,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(h,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return s(c)}h(c,s,l){const h=p.$7n.test(c)?4:this.d.get(c),b=l?`[${l.value}] `:"";if(h===4){typeof s?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${c}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){s?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${c}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(c,s){const l=new v.$fo(c,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,b)=>l.affectsConfiguration(h,r(b))})}k(c){return c.reduce((s,l)=>(s.set(l[0],l[1]),s),new Map)}}e.$shc=t,e.$thc=(0,C.$ci)("IExtHostConfiguration")}),define(Ce[95],Ie([1,0,2,8,4,6,7,41,73,42,22,46,20,27,5,16,11,13,91,298,14]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=e.$Uic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(U){function z(M){if(M!=null)return M}U.from=z;function F(M){if(M!=null)return M}U.to=F})(a||(a={}));var t;(function(U){function z(M){if(M!=null)return M}U.from=z;function F(M){if(M!=null)return M}U.to=F})(t||(t={}));var d;(function(U){function z(M){if(M!=null)return M}U.from=z;function F(M){if(M!=null)return M}U.to=F})(d||(d={}));var c;(function(U){function z(T){if(T){const j=T;return j&&!!j.process}else return!1}U.is=z;function F(T){if(T==null)return;const j={process:T.process,args:T.args};return T.options&&(j.options=d.from(T.options)),j}U.from=F;function M(T){if(T!=null)return new R.$GM(T.process,T.args,T.options)}U.to=M})(c||(c={}));var s;(function(U){function z(M){if(M!=null)return M}U.from=z;function F(M){if(M!=null)return M}U.to=F})(s||(s={}));var l;(function(U){function z(T){if(T){const j=T;return j&&(!!j.commandLine||!!j.command)}else return!1}U.is=z;function F(T){if(T==null)return;const j={};return T.commandLine!==void 0?j.commandLine=T.commandLine:(j.command=T.command,j.args=T.args),T.options&&(j.options=s.from(T.options)),j}U.from=F;function M(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$HM(T.commandLine,T.options):new R.$HM(T.command,T.args?T.args:[],T.options)}U.to=M})(l||(l={}));var h;(function(U){function z(T){if(T){const j=T;return j&&j.customExecution==="customExecution"}else return!1}U.is=z;function F(T){return{customExecution:"customExecution"}}U.from=F;function M(T,j){return j.get(T)}U.to=M})(h||(e.CustomExecutionDTO=h={}));var b;(function(U){function z(F,M){let T;return F.scope!==void 0&&typeof F.scope!="number"?T=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?T=M.workspaceFile:T=n.$$G),{id:F._id,workspaceFolder:T}}U.from=z})(b||(e.TaskHandleDTO=b={}));var D;(function(U){function z(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}U.from=z})(D||(D={}));var g;(function(U){function z(T,j){if(T==null)return[];const J=[];for(const ne of T){const _=F(ne,j);_&&J.push(_)}return J}U.fromMany=z;function F(T,j){if(T==null)return;let J;T.execution instanceof R.$GM?J=c.from(T.execution):T.execution instanceof R.$HM?J=l.from(T.execution):T.execution&&T.execution instanceof R.$IM&&(J=h.from(T.execution));const ne=a.from(T.definition);let _;return T.scope?typeof T.scope=="number"?_=T.scope:_=T.scope.uri:_=R.TaskScope.Workspace,!ne||!_?void 0:{_id:T._id,definition:ne,name:T.name,source:{extensionId:j.identifier.value,label:T.source,scope:_},execution:J,isBackground:T.isBackground,group:D.from(T.group),presentationOptions:t.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}U.from=F;async function M(T,j,J){if(T==null)return;let ne;c.is(T.execution)?ne=c.to(T.execution):l.is(T.execution)?ne=l.to(T.execution):h.is(T.execution)&&(ne=h.to(T._id,J));const _=a.to(T.definition);let Z;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?Z=T.source.scope:Z=await j.resolveWorkspaceFolder(I.URI.revive(T.source.scope)):Z=R.TaskScope.Workspace),!_||!Z)return;const Y=new R.$JM(_,Z,T.name,T.source.label,ne,T.problemMatchers);return T.isBackground!==void 0&&(Y.isBackground=T.isBackground),T.group!==void 0&&(Y.group=R.$FM.from(T.group._id),Y.group&&T.group.isDefault&&(Y.group=new R.$FM(Y.group.id,Y.group.label),T.group.isDefault===!0&&(Y.group.isDefault=T.group.isDefault))),T.presentationOptions&&(Y.presentationOptions=t.to(T.presentationOptions)),T._id&&(Y._id=T._id),T.detail&&(Y.detail=T.detail),Y}U.to=M})(g||(e.TaskDTO=g={}));var f;(function(U){function z(M){return M}U.from=z;function F(M){if(M)return Object.assign(Object.create(null),M)}U.to=F})(f||(f={}));class y{#e;constructor(z,F,M){this._id=F,this.a=M,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,F,M,T,j,J,ne,_){this.q=new $.$3d,this.r=new $.$3d,this.s=new $.$3d,this.u=new $.$3d,this.a=z.getProxy(A.$VL.MainThreadTask),this.b=M,this.c=T,this.d=j,this.e=J,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ne,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,F,M){if(!M)return new R.$XL(()=>{});const T=this.x();return this.j.set(T,{type:F,provider:M,extension:z}),this.a.$registerTaskProvider(T,F),new R.$XL(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(z,F){this.a.$registerTaskSystem(z,F)}fetchTasks(z){return this.a.$fetchTasks(f.from(z)).then(async F=>{const M=[];for(const T of F){const j=await g.to(T,this.b,this.m);j&&M.push(j)}return M})}get taskExecutions(){const z=[];return this.k.forEach(F=>z.push(F)),z}terminateTask(z){if(!(z instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,F,M){const T=this.m.get(z.id);T&&(this.o.set(z.id,T),this.e.attachPtyToTerminal(F,await T.callback(M))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const F=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const F=await this.z(z.id);this.s.fire({execution:F,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const F=await this.z(z.id);this.u.fire({execution:F,exitCode:z.exitCode})}$provideTasks(z,F){const M=this.j.get(z);if(!M)return Promise.reject(new Error("no handler found"));const T=[],j=(0,O.$7g)(()=>M.provider.provideTasks(L.CancellationToken.None)).then(J=>this.v(F,T,M,J));return new Promise(J=>{j.then(ne=>{Promise.all(T).then(()=>{J(ne)})})})}async $resolveTask(z,F){const M=this.j.get(z);if(!M)return Promise.reject(new Error("no handler found"));if(F.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${M.type}].`);const T=await g.to(F,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const j=await M.provider.resolveTask(T,L.CancellationToken.None);if(!j)return;this.A(j,M);const J=g.from(j,M.extension);if(!J)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(J.execution)&&await this.y(J,j,!0),await this.w(J)}x(){return this.h++}async y(z,F,M){const T=await this.a.$createTaskId(z);!M&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,F.execution)),this.m.set(T,F.execution)}async z(z,F){if(typeof z=="string"){const j=this.l.get(z);if(!j)throw new r.$bb("Unexpected: The specified task is missing an execution");return j}const M=this.l.get(z.id);if(M)return M;let T;return F?T=Promise.resolve(new y(this,z.id,F)):T=g.to(z.task,this.b,this.m).then(j=>{if(!j)throw new r.$bb("Unexpected: Task does not exist.");return new y(this,z.id,j)}),this.l.set(z.id,T),T.then(j=>(this.k.set(z.id,j),j))}A(z,F){z._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const M=this.n.values();let T=M.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=M.next()}};e.$Uic=P,e.$Uic=P=Ke([We(0,w.$aO),We(1,E.$qO),We(2,v.$qhc),We(3,p.$lO),We(4,S.$thc),We(5,C.$Rhc),We(6,o.$wj),We(7,i.$6gc)],P);let N=class extends P{constructor(z,F,M,T,j,J,ne,_){super(z,F,M,T,j,J,ne,_),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(z,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const M=g.from(F,z);if(M===void 0)throw new Error("Task is not valid");if(h.is(M.execution))await this.y(M,F,!1);else throw new r.$_;const T=await this.z(await this.a.$getTaskExecution(M),F);return this.a.$executeTask(M).catch(j=>{throw new Error(j)}),T}v(z,F,M,T){const j=[];if(T)for(const J of T){if(this.A(J,M),!J.definition||!z[J.definition.type]){const _=J.source?J.source:"No task source";this.f.warn(`The task [${_}, ${J.name}] uses an undefined task type. The task will be ignored in the future.`)}const ne=g.from(J,M.extension);ne&&h.is(ne.execution)?(j.push(ne),F.push(this.y(ne,J,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:M.extension}}async w(z){if(h.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,F,M){}};e.$Vic=N,e.$Vic=N=Ke([We(0,w.$aO),We(1,E.$qO),We(2,v.$qhc),We(3,p.$lO),We(4,S.$thc),We(5,C.$Rhc),We(6,o.$wj),We(7,i.$6gc)],N),e.$Wic=(0,k.$ci)("IExtHostTask")}),define(Ce[362],Ie([1,0,36,29]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=e.$FK=void 0;function $(R){return"cellResults"in R}e.$FK=$,e.$GK="rawCell#";function A(R,v){let p=-1;const S=[];let L=[];return R.forEach(w=>{w.range.startLineNumber!==p&&L.length>0&&(S.push([...L]),L=[]),L.push(w),p=w.range.endLineNumber}),L.length>0&&S.push([...L]),S.map(w=>{const E=[],k=w[0].range.startLineNumber,u=w[w.length-1].range.endLineNumber;for(let m=k;m<=u;m++)E.push(v.getLineContent(m));return new I.$jK(E.join(`
`)+`
`,w.map(m=>new O.$4s(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$HK=A}),define(Ce[363],Ie([1,0,217,21,4,3,28,12,18,2,32,110,6,33,15,7,69,333,150,24,16,288,362,359]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,h,b,D,g,f){this.q=b,this.r=D,this.s=g,this.t=f,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new $.$3d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new $.$3d,this.onDidOpenNotebookDocument=this.m.event,this.n=new $.$3d,this.onDidCloseNotebookDocument=this.n.event,this.o=new $.$3d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$4gc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(w.$VL.MainThreadNotebook),this.c=l.getProxy(w.$VL.MainThreadNotebookDocuments),this.d=l.getProxy(w.$VL.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const P=y.notebookEditor?.notebookUri,N=y.cell.handle,z=this.g.get(P)?.getCell(N);if(z)return z.apiCell}if(y&&y.$mid===14){const P=y.uri,N=this.g.get(P);if(N)return N.apiNotebook}return y}}),c.B(h)}getEditorById(l){const h=this.h.get(l);if(!h)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(l){for(const[h,b]of this.h)if(b.apiEditor===l)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,h){const b=this.g.get(l);if(!b&&!h)throw new Error(`NO notebook document for '${l}'`);return b}static u(l,h){if(!h)return;const b=h.filenamePattern.map(D=>k.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(h.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:h.displayName,filenamePattern:b,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,h,b){const D=c.a++,g=typeof b.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(D,b),this.b.$registerNotebookCellStatusBarItemProvider(D,g,h);let f;return g!==void 0&&(f=b.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(g))),new u.$XL(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,g),f?.dispose()})}async createNotebookDocument(l){const h=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&k.NotebookData.from(l.content)});return S.URI.revive(h)}async openNotebookDocument(l){const h=this.g.get(l);if(h)return h.apiNotebook;const b=await this.c.$tryOpenNotebook(l),D=this.g.get(S.URI.revive(b));return(0,p.$2f)(D?.apiNotebook)}async showNotebookDocument(l,h){S.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let b;typeof h=="object"?b={position:k.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(k.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:b={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,b),g=D&&this.h.get(D)?.apiEditor;if(g)return g;throw D?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,h,b,D){const g=this.f.get(l),f=S.URI.revive(h),y=this.g.get(f);if(!y||!g)return;const P=y.getCellFromIndex(b);if(!P)return;const N=await g.provideCellStatusBarItems(P.apiCell,D);if(!N)return;const U=new A.$Sc,z=this.p.add([U]),M=(Array.isArray(N)?N:[N]).map(T=>k.NotebookStatusBarItem.from(T,this.i,U));return{cacheId:z,items:M}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,h,b,D,g){if((0,v.$Qe)(h))throw new Error("viewType cannot be empty or just whitespace");const f=this.w++;return this.x.set(f,{viewType:h,serializer:b,options:D}),this.b.$registerNotebookSerializer(f,{id:l.identifier,location:l.extensionLocation},h,k.NotebookDocumentContentOptions.from(D),c.u(l,g)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(f)})}async $dataToNotebook(l,h,b){const D=this.x.get(l);if(!D)throw new Error("NO serializer found");const g=await D.serializer.deserializeNotebook(h.buffer,b);return new m.$3v(k.NotebookData.from(g))}async $notebookToData(l,h,b){const D=this.x.get(l);if(!D)throw new Error("NO serializer found");const g=await D.serializer.serializeNotebook(k.NotebookData.to(h.value),b);return O.$qe.wrap(g)}async $saveNotebook(l,h,b,D,g){const f=S.URI.revive(h),y=this.x.get(l);if(!y)throw new Error("NO serializer found");const P=this.g.get(f);if(!P)throw new Error("Document NOT found");if(P.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(f.scheme))throw new L.$Uk((0,I.localize)(0,null,this.z(f)),6);await this.y(f,D);const N={metadata:(0,n.$Nn)(P.apiNotebook.metadata,T=>!(y.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of P.apiNotebook.getCells()){const j=new u.$mN(T.kind,T.document.getText(),T.document.languageId,T.mime,y.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);j.metadata=(0,n.$Nn)(T.metadata,J=>!(y.options?.transientCellMetadata??{})[J]),N.cells.push(j)}const U=await y.serializer.serializeNotebook(N,g);await this.s.value.writeFile(f,U);const z=this.s.getFileSystemProviderExtUri(f.scheme),F=await this.s.value.stat(f);return{name:z.basename(f),isFile:(F.type&L.FileType.File)!==0,isDirectory:(F.type&L.FileType.Directory)!==0,isSymbolicLink:(F.type&L.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&L.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(f.scheme),locked:!!((F.permissions??0)&L.FilePermission.Locked),etag:L.$6k({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(l,h,b,D,g){const f=this.x.get(l)?.serializer;if(!f)return{limitHit:!1,results:[]};const y=new R.$Bc;await(async(F,M,T)=>{await Promise.all(F.map(async j=>await Promise.all(j.filenamePatterns.map(J=>{const ne={_reason:T._reason,folderQueries:T.folderQueries,includePattern:T.includePattern,excludePattern:T.excludePattern,maxResults:T.maxResults,type:1,filePattern:J};return this.t.doInternalFileSearchWithCustomCallback(ne,M,_=>{_.forEach(Z=>{y.has(Z)||D.some(ce=>j.isFromSettings&&!ce.isFromSettings?!1:ce.filenamePatterns.some(ie=>(0,d.$Beb)(ie,Z)))||y.add(Z)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(b,g,h);const N=new R.$Ac;let U=!1;const z=Array.from(y).map(async F=>{const M=[];try{if(g.isCancellationRequested)return;if(h.maxResults&&[...N.values()].reduce((ne,_)=>ne+_.cellResults.length,0)>h.maxResults){U=!0;return}const T=[],j=this.g.get(F);if(j)j.apiNotebook.getCells().forEach(_=>T.push({input:_.document.getText(),outputs:_.outputs.flatMap(Z=>Z.items.map(Y=>Y.data.toString()))}));else{const ne=await this.s.value.readFile(F),_=O.$qe.fromString(ne.toString()),Z=await f.deserializeNotebook(_.buffer,g);if(g.isCancellationRequested)return;k.NotebookData.from(Z).cells.forEach(ce=>T.push({input:ce.source,outputs:ce.outputs.flatMap(ie=>ie.items.map(fe=>fe.valueBytes.toString()))}))}if(g.isCancellationRequested)return;T.forEach((ne,_)=>{const Z=h.contentPattern.pattern,Y=new a.$ASb(ne.input,void 0,ne.outputs),ce=Y.findInInputs(Z),ie=Y.findInOutputs(Z),fe=ie.flatMap(re=>(0,t.$HK)(re.matches,re.textBuffer)).map((re,K)=>(re.webviewIndex=K,re));if(ce.length>0||ie.length>0){const re={index:_,contentResults:(0,t.$HK)(ce,Y.inputTextBuffer),webviewResults:fe};M.push(re)}});const J={resource:F,cellResults:M};N.set(F,J);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...N.values()]}}async y(l,h){const b=await this.s.value.stat(l);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==L.$5k&&typeof b.mtime=="number"&&typeof b.size=="number"&&h.mtime<b.mtime&&h.etag!==L.$6k({mtime:h.mtime,size:b.size}))throw new L.$Uk((0,I.localize)(1,null),3,h)}z(l){return l.scheme===r.Schemas.file?l.fsPath:l.toString()}A(l,h,b){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const D=new i.$nic(h,this.d,l,b.visibleRanges.map(k.NotebookRange.to),b.selections.map(k.NotebookRange.to),typeof b.viewColumn=="number"?k.ViewColumn.to(b.viewColumn):void 0);this.h.set(h,D)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const b of l.value.removedDocuments){const D=S.URI.revive(b),g=this.g.get(D);g&&(g.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(f=>f.document.uri)}),this.n.fire(g.apiNotebook));for(const f of this.h.values())f.notebookData.uri.toString()===D.toString()&&this.h.delete(f.id)}if(l.value.addedDocuments){const b=[];for(const D of l.value.addedDocuments){const g=S.URI.revive(D.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const f=new o.$mic(this.c,this.q,this.r,g,D);b.push(...D.cells.map(y=>o.$lic.asModelAddData(f.apiNotebook,y))),this.g.get(g)?.dispose(),this.g.set(g,f),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(f.apiNotebook)}}if(l.value.addedEditors)for(const b of l.value.addedEditors){if(this.h.has(b.id))return;const D=S.URI.revive(b.documentUri),g=this.g.get(D);g&&this.A(g,b.id,b)}const h=[];if(l.value.removedEditors)for(const b of l.value.removedEditors){const D=this.h.get(b);D&&(this.h.delete(b),this.k?.id===D.id&&(this.k=void 0),h.push(D))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const b=new Set;this.l.forEach(D=>b.add(D.id));for(const D of this.h.values()){const g=b.has(D.id);D._acceptVisibility(g)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const h=E.$yO.String.with("notebookType","A notebook type"),b=new E.$AO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.$yO("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>O.$qe.wrap(g))],new E.$zO("Notebook Data",g=>k.NotebookData.to(g.value))),D=new E.$AO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.$yO("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new m.$3v(k.NotebookData.from(g)))],new E.$zO("Bytes",g=>g.buffer));l.registerApiCommand(b),l.registerApiCommand(D)}}e.$wic=c}),define(Ce[364],Ie([1,0,17,22,44,35,23,38,36]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class S{constructor(w,E,k){this.k=w,this.l=E,this.o=k,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&A.$Vj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&A.$Vj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const E=this.k.folderQueries||[];return new Promise((k,u)=>{const m=o=>{this.f++,w(o)};if(this.g)return k({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=I.$nc(i);this.j&&this.j(i,n)||this.v(m,{base:o,basename:n})}),Promise.all(E.map(o=>this.p(o,m))).then(o=>{k({limitHit:this.e,stats:o[0]||void 0})},o=>{u(new Error((0,$.$Zi)(o)))})})}async p(w,E){const k=new O.$ae,u=this.q(w),m=this.r(),o=new p.$xK(this.k,w),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(k),n=v.$Yd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,k.token),a=n.elapsed(),t=v.$Yd.create();return this.g&&!this.e||(r&&r.forEach(d=>{const c=I.$gc.relative(w.folder.path,d.path);if(i){const s=I.$nc(d.path);this.v(E,{base:w.folder,relativePath:c,basename:s});return}this.s(m,w.folder,c,E)}),this.g&&!this.e)?null:(this.u(m,o,E),{providerTime:a,postProcessTime:t.elapsed()})}finally{k.dispose(),this.h.delete(k)}}q(w){const E=(0,p.$wK)(this.k.includePattern,w.includePattern),k=(0,p.$wK)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:k,includes:E,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},E,k,u){if(k===this.a){const o=I.$nc(this.a);this.v(u,{base:E,relativePath:this.a,basename:o})}function m(o){const i=I.$nc(o),n=I.$mc(o);let r=w[n];r||(r=w[n]=[],m(n)),r.push({base:E,relativePath:o,basename:i})}m(k)}u({rootEntries:w,pathToEntries:E},k,u){const m=this,o=this.a;function i(n){const r=(0,p.$zK)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const d=n[a],{relativePath:c,basename:s}=d;if(k.matchesExcludesSync(c,s,o!==s?r:void 0))continue;const l=E[c];if(l)i(l);else{if(c===o)continue;m.v(u,d)}if(m.e)break}}i(w)}v(w,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(E))}}class L{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,E,k,u){const m=this.c(w.cacheKey),o=new S(w,E,m&&m.token);let i=0;const n=r=>{i+=r.length,k(r.map(a=>this.d(a)))};return this.e(o,L.a,n,u).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new O.$ae),this.b.get(w)}d(w){return w.relativePath?{resource:R.$Pg(w.base,w.relativePath)}:{resource:w.base}}e(w,E,k,u){const m=u.onCancellationRequested(()=>{w.cancel()}),o=n=>{n&&(i.push(n),E>0&&i.length>=E&&(k(i),i=[]))};let i=[];return w.search(o).then(n=>(i.length&&k(i),m.dispose(),n),n=>(i.length&&k(i),m.dispose(),Promise.reject(n)))}}e.$oic=L}),define(Ce[365],Ie([1,0,19,74,35,102,28,16,17,23,12,18,2,99,237,51,13,40,143,360,36]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=void 0;let a=class{constructor(f,y,P,N,U){this.a=f,this.b=y,this.c=P,this.d=N,this.e=U}text(f,y,P={}){f=this.f(f,P);const N=this.a.getValue(),U=y&&y.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(y?.map(o.$xi),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:N.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(f,y){const P=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const N={...f,wordSeparators:P.editor.wordSeparators};return this.j(f,y)&&(N.isCaseSensitive=!0),this.k(f)&&(N.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),N}file(f,y={}){return{...this.h(f,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey,shouldGlobMatchFilePattern:y.shouldGlobSearch}}g(f,y){return f?(f=Array.isArray(f)?f.map(l):l(f),y?this.parseSearchPaths(f):{pattern:d(...Array.isArray(f)?f:[f])}):{}}h(f=[],y={}){const P=this.g(y.includePattern,y.expandPatterns),N=this.g(y.excludePattern,y.expandPatterns),U=f.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(T=>this.q(T,y,N)):f.map(T=>this.r(T,y,N,U))).filter(T=>!!T),F={_reason:y._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:N.pattern,includePattern:P.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const T=I.$Hb(I.$Rb(this.c.groups.map(ne=>ne.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const j=T.filter(ne=>(0,r.$nK)(F,ne.fsPath)),J=this.i(j);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(J)),{...F,...J}}const M=y.extraFileResources&&y.extraFileResources.filter(T=>(0,r.$nK)(F,T.fsPath));return F.extraFileResources=M&&M.length?M:void 0,F}i(f){const y=[],P=new R.$Ac,N={};let U=!1;return f.forEach(z=>{if(z.scheme===v.Schemas.walkThrough)return;if((0,S.$Tg)(z)){const M=this.b.getWorkspaceFolder(z)?.uri??z.with({path:p.$mc(z.fsPath)});let T=P.get(M);T||(U=!0,T={folder:M,includePattern:{}},y.push(T),P.set(M,T));const j=p.$lc(M.fsPath,z.fsPath);(0,C.$2f)(T.includePattern)[j.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,N[z.fsPath]=!0)}),{folderQueries:y,includePattern:N,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(f,y){if(y.isSmartCase){if(f.isRegExp){if(L.$Hf(f.pattern,!0))return!0}else if(L.$Hf(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,E.$aC)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const y=J=>p.$ic(J)||/^\.\.?([\/\\]|$)/.test(J),N=(Array.isArray(f)?f:c(f)).map(J=>{const ne=this.e.resolvedUserHome;return ne?(0,A.$8v)(J,ne.scheme===v.Schemas.file?ne.fsPath:ne.path):J}),U=O.$K(N,J=>y(J)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(J=>L.$2e(J,"/")).map(J=>L.$2e(J,"\\")).map(J=>(J[0]==="."&&(J="*"+J),s(J))),F={},M=this.m(U.searchPaths||[]);M&&M.length&&(F.searchPaths=M);const T=I.$Rb(z),j=d(...T);return j&&(F.pattern=j),F}l(f,y){return y.disregardExcludeSettings?void 0:(0,r.$mK)(f,!y.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const y=f.flatMap(N=>{let{pathPortion:U,globPortion:z}=t(N);return z&&(z=h(z)),this.n(U).flatMap(M=>this.o(M,z))}),P=new Map;return y.forEach(N=>{const U=N.searchPath.toString(),z=P.get(U);z?N.pattern&&(z.pattern=z.pattern||{},z.pattern[N.pattern]=!0):P.set(U,{searchPath:N.searchPath,pattern:N.pattern?d(N.pattern):void 0})}),Array.from(P.values())}n(f){if(p.$ic(f)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==v.Schemas.file?[{searchPath:y[0].uri.with({path:f})}]:[{searchPath:w.URI.file(p.$hc(f))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(f=l(f),f.startsWith("../")||f===".."){const N=p.$gc.resolve(y.path,f);return[{searchPath:y.with({path:N})}]}const P=h(f);return[{searchPath:y,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const y=f.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(U=>{const z=y.match(new RegExp(`^${L.$Ve(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(C.$Yf);if(N.length)return N.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&h(z)}});{const U=f.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:f,F=k.localize(0,null,z);throw new Error(F)}}}}o(f,y){const P=f.pattern&&y?`${f.pattern}/${y}`:f.pattern||y,N=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&N.push({searchPath:f.searchPath,pattern:P+"/**"}),N}q(f,y,P){const N=this.r((0,o.$xi)(f.searchPath),y,P,!1);return N?{...N,includePattern:f.pattern}:null}r(f,y,P,N){let U;const z=w.URI.isUri(f)?f:f.uri;if(P.searchPaths){const J=P.searchPaths.filter(ne=>(0,S.$Ig)(ne.searchPath,z))[0];if(J&&!J.pattern)return null;J&&(U=J.pattern)}const F=this.a.getValue({resource:z}),T={...this.l(F,y)||{},...U||{}},j=w.URI.isUri(f)?(0,S.$Mg)(f):f.name;return{folder:z,folderName:N?j:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!F.search.followSymlinks}}};e.$zL=a,e.$zL=a=Ke([We(0,u.$Ii),We(1,o.$li),We(2,i.$hD),We(3,m.$wj),We(4,n.$xL)],a);function t(g){const f=g.match(/[\*\{\}\(\)\[\]\?]/);if(f){const y=f.index,P=g.substr(0,y).match(/[/|\\][^/\\]*$/);if(P){let N=g.substr(0,P.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:g.substr((P.index||0)+1)}}}return{pathPortion:g}}function d(...g){return g.length?g.reduce((f,y)=>(f[y]=!0,f),Object.create(null)):void 0}function c(g){return $.$Tj(g,",").map(f=>f.trim()).filter(f=>!!f.length)}function s(g){return[`**/${g}/**`,`**/${g}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function l(g){return g.replace(/\\/g,"/")}function h(g){return l(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(g){return g.replace(/([?*[\]])/g,"[$1]")}function D(g,f){g=I.$Mb(g,N=>N.toString());const y=[],P=f.getWorkspace();return g&&g.forEach(N=>{let U;if(f.getWorkbenchState()===2)U=(0,S.$Rg)(P.folders[0].uri,N),U&&U!=="."&&(U="./"+U);else{const z=f.getWorkspaceFolder(N);if(z){const F=z.name;if(P.folders.filter(T=>T.name===F).length===1){const T=(0,S.$Rg)(z.uri,N);T===""?U=`./${z.name}`:U=`./${z.name}/${T}`}else U=N.fsPath}}U&&y.push(b(U))}),y}e.$AL=D}),define(Ce[366],Ie([1,0,23,2,22,14,5,365,36,40,8]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ytb=e.$Xtb=void 0;const C=7e3;function w(m,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const l of i)if(/^workspaceContains:/.test(l)){const h=l.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):n.push(h)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:a,resolve:t}=(0,L.$8g)(),d=l=>t({activationEvent:l}),c=Promise.all(n.map(l=>E(m,l,d))).then(()=>{}),s=k(m,o.identifier,r,d);return Promise.all([c,s]).then(()=>{t(void 0)}),a}e.$Xtb=w;async function E(m,o,i){for(const n of m.folders)if(await m.exists(I.$Pg(O.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function k(m,o,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new $.$ae,a=m.checkExists(m.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let d=!1;try{d=await a}catch(c){A.$4(c)||A.$1(c)}r.dispose(),clearTimeout(t),d&&n(`workspaceContains:${i.join(",")}`)}function u(m,o,i,n){const r=m.get(R.$bi),a=m.get(p.$eK),d=r.createInstance(v.$zL).file(o.map(c=>(0,S.$xi)(O.URI.revive(c))),{_reason:"checkExists",includePattern:i,exists:!0});return a.fileSearch(d,n).then(c=>!!c.limitHit,c=>A.$4(c)?!1:Promise.reject(c))}e.$Ytb=u}),define(Ce[47],Ie([1,0,214,17,58,23,8,3,78,2,13,6,42,294,117,41,25,145,14,26,21,273,7,65,5,27,93,20,106,71,46,4,366,116,275,16,114,38,11,115]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c,s,l,h,b,D,g,f,y,P,N,U,z,F,M,T){"use strict";var j;Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=e.$5hc=e.$4hc=e.$3hc=void 0,e.$3hc=(0,c.$ci)("IHostUtils");let J=j=class extends v.$Tc{constructor(K,B,ae,ye,le,de,ue,ge,V,X,he,be){super(),this.X=be,this.a=this.B(new f.$3d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ae,this.f=ue,this.j=ye,this.m=le,this.s=de,this.t=V,this.u=X,this.w=he,this.y=this.g.getProxy(C.$VL.MainThreadWorkspace),this.z=this.g.getProxy(C.$VL.MainThreadTelemetry),this.C=this.g.getProxy(C.$VL.MainThreadExtensionService),this.D=new R.$bh,this.F=new R.$bh,this.G=new R.$bh,this.H=new R.$bh,this.I=new fe(this.f.extensions.activationEvents),this.L=new o.$68b(this.I,this.f.extensions.allExtensions);const Pe=new n.$vm(this.f.extensions.myExtensions);this.J=new o.$68b(this.I,ce(this.L,Pe)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Z(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Z(this.J)}`)),this.M=new k.$Nhc(this.g,this.s),this.N=new P.$Vhc(this.g),this.O=ge,this.h=K.createChild(new b.$ai([k.$Ohc,this.M],[P.$Whc,this.N])),this.P=this.B(new E.$Mhc(this.J,this.L,{onExtensionActivationError:(pe,Ae,Fe)=>{this.C.$onExtensionActivationError(pe,i.$3(Ae),Fe)},actualActivateExtension:async(pe,Ae)=>{if(o.$68b.isHostExtension(pe,this.J,this.L))return await this.C.$activateExtension(pe,Ae),new E.$Lhc;const Fe=this.J.getExtensionDescription(pe);return this.db(Fe,Ae)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),$.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(K){i.$1(K)}}async Y(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.cb(le))}catch{}await Promise.all(K)}terminate(K,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ae=this.Y();Promise.race([(0,R.$dh)(5e3),ae]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const B=await this.C.$getExtension(K);return B&&{...B,identifier:new n.$um(B.identifier.value),extensionLocation:S.URI.revive(B.extensionLocation)}}Z(K,B){return this.P.activateByEvent(K,B)}$(K,B){return this.P.activateById(K,B)}activateByIdWithErrors(K,B){return this.$(K,B).then(()=>{const ae=this.P.getActivatedExtension(K);if(ae.activationFailed)return Promise.reject(ae.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async ab(K){if(K.scheme===U.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(K.fsPath);return S.URI.file(B)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(K=>new ie(K))),this.Q}async bb(K){const B=p.$ii.forUris(ae=>A.$Gg.ignorePathCasing(ae));return await Promise.all(K.map(async ae=>{if(this.ub(ae)){const ye=await this.ab(ae.extensionLocation);B.set(ye,ae)}})),B}cb(K){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return B;const ae=this.P.getActivatedExtension(K);if(!ae)return B;try{typeof ae.module.deactivate=="function"&&(B=Promise.resolve(ae.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(ye)}try{(0,v.$Oc)(ae.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(ye)}return B}async db(K,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.fb(K,B).then(ae=>{const ye=ae.activationTimes;return this.C.$onDidActivateExtension(K.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,B),this.eb(K,B,"success",ye),ae},ae=>{throw this.eb(K,B,"failure"),ae})}eb(K,B,ae,ye){const le=_(K,B);this.z.$publicLog2("extensionActivationTimes",{...le,...ye||{},outcome:ae})}fb(K,B){const ae=_(K,B);this.z.$publicLog2("activatePlugin",ae);const ye=this.ub(K);if(!ye)return Promise.resolve(new E.$Khc(E.$Hhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${K.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const le=new E.$Ihc(B.startup);return Promise.all([this.vb(K,(0,A.$Pg)(K.extensionLocation,ye),le),this.gb(K)]).then(de=>($.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),j.hb(this.s,K.identifier,de[0],de[1],le))).then(de=>($.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),de))}gb(K){const B=new a.$Qhc(K,this.M),ae=new a.$Phc(K.identifier.value,!1,this.M),ye=new N.$Xhc(K,this.N),le=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([B.whenReady,ae.whenReady,this.O.whenReady]).then(()=>{const ue=this;let ge,V;const X=(0,m.$RF)(K,"ipc")?this.f.messagePorts?.get(n.$um.toKey(K.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ae,secrets:ye,subscriptions:[],get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(he){return O.$jc(K.extensionLocation.fsPath,he)},get storagePath(){return ue.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return ue.O.globalValue(K).fsPath},get logPath(){return O.$jc(ue.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return S.URI.joinPath(ue.f.logsLocation,K.identifier.value)},get storageUri(){return ue.O.workspaceValue(K)},get globalStorageUri(){return ue.O.globalValue(K)},get extensionMode(){return le},get extension(){return ge===void 0&&(ge=new Y(ue,K.identifier,K,de,!1)),ge},get extensionRuntime(){return(0,m.$SF)(K,"extensionRuntime"),ue.extensionRuntime},get environmentVariableCollection(){return ue.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!V){if(!X)return;const he=f.Event.buffer(f.Event.fromDOMEventEmitter(X,"message",be=>be.data));X.start(),V={onDidReceiveMessage:he,postMessage:X.postMessage.bind(X)}}return V}})})}static hb(K,B,ae,ye,le){return ae=ae||{activate:void 0,deactivate:void 0},this.ib(K,B,ae,ye,le).then(de=>new E.$Jhc(!1,null,le.build(),ae,de,ye.subscriptions))}static ib(K,B,ae,ye,le){if(typeof ae.activate=="function")try{le.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${B.value}`);const de=typeof global=="object"?global:self,ue=ae.activate.apply(de,[ye]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ue).then(ge=>(le.activateResolveStop(),ge))}catch(de){return Promise.reject(de)}else return Promise.resolve(ae)}jb(K,B){this.$(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:B}).then(void 0,ae=>{this.s.error(ae)})}kb(K,B=0){const ye=Date.now();(0,M.$B)(()=>{for(let le=B;le<K.length;le+=1){const de=K[le];for(const ue of de.activationEvents??[])if(ue==="onStartupFinished")if(Date.now()-ye>50){this.kb(K,le);break}else this.jb(de,ue)}})}lb(){this.C.$setPerformanceMarks($.getMarks()),this.m.getConfigProvider().then(K=>{const B=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ae=this.J.getAllExtensionDescriptions();if(B)this.kb(ae);else for(const ye of ae)if(ye.activationEvents)for(const le of ye.activationEvents)le==="onStartupFinished"&&this.jb(ye,le)})}mb(){const K=this.Z("*",!0).then(void 0,de=>{this.s.error(de)});this.B(this.j.onDidChangeWorkspace(de=>this.nb(de.added)));const B=this.j.workspace?this.j.workspace.folders:[],ae=this.nb(B),ye=this.pb(),le=Promise.all([ye,K,ae]).then(()=>{});return Promise.race([le,(0,R.$dh)(1e4)]).then(()=>{this.lb()}),le}nb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(K,B))).then(()=>{})}async ob(K,B){if(this.isActivated(B.identifier))return;const ae=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:K.map(de=>de.uri),forceUsingSearch:ae||!this.c.fsExists,exists:de=>this.c.fsExists(de.fsPath),checkExists:(de,ue,ge)=>this.y.$checkExists(de,ue,ge)},le=await(0,y.$Xtb)(ye,B);if(le)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:le.activationEvent}).then(void 0,de=>this.s.error(de))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(K){throw console.error(K),K}}async qb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:B}=this.f.environment;if(!K||!B)throw new Error(I.localize(0,null));const ae=await this.vb(null,B,new E.$Ihc(!1));if(!ae||typeof ae.run!="function")throw new Error(I.localize(1,null,B.toString()));return new Promise((ye,le)=>{const de=(V,X)=>{V?(M.$t&&this.s.error("Test runner called back with error",V),le(V)):(M.$t&&(X?this.s.info(`Test runner called back with ${X} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof X=="number"&&X>0?1:0))},ue=(0,A.$Dg)(B),ge=ae.run(ue,de);ge&&ge.then&&ge.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(V=>{M.$t&&this.s.error("Test runner finished with error",V),le(V instanceof Error&&V.stack?V.stack:String(V))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$dh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,B){return this.R[K]=B,(0,v.$Rc)(()=>{delete this.R[K]})}async getRemoteExecServer(K){const{resolver:B}=await this.sb(K);return B?.resolveExecServer?.(K,{resolveAttempt:0})}async sb(K){const B=K.indexOf("+");if(B===-1)throw new t.$4L("Not an authority that can be resolved!",d.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ae=K.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ae}`,!1),{authorityPrefix:ae,resolver:this.R[ae]}}async $resolveAuthority(K,B){const ae=F.$Yd.create(!1),ye=()=>`[resolveAuthority(${(0,d.$il)(K)},${B})][${ae.elapsed()}ms] `,le=x=>this.s.info(`${ye()}${x}`),de=x=>this.s.warn(`${ye()}${x}`),ue=(x,H=void 0)=>this.s.error(`${ye()}${x}`,H),ge=x=>{if(x instanceof t.$4L)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},V=async x=>{le(`activating resolver for ${x}...`);const{resolver:H,authorityPrefix:Q}=await this.sb(x);if(!H)throw ue(`no resolver for ${Q}`),new t.$4L(`No remote extension installed to resolve ${Q}.`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:Q,remoteAuthority:x}},X=K.split(/@|%40/g).reverse();le(`activating remote resolvers ${X.join(" -> ")}`);let he;try{he=await Promise.all(X.map(V)).catch(async x=>{if(!(x instanceof t.$4L)||x._code!==d.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return de(`resolving nested authorities failed: ${x.message}`),[await V(K)]})}catch(x){return ge(x)}const be=new R.$nh;be.cancelAndSet(()=>le("waiting..."),1e3);let Pe,pe;for(const[x,{authorityPrefix:H,resolver:Q,remoteAuthority:oe}]of he.entries())try{if(x===he.length-1)le("invoking final resolve()..."),$.mark(`code/extHost/willResolveAuthority/${H}`),Pe=await Q.resolve(oe,{resolveAttempt:B,execServer:pe}),$.mark(`code/extHost/didResolveAuthorityOK/${H}`),le("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,t.$3L.isManagedResolvedAuthority(Pe)?Pe:void 0));else{if(le(`invoking resolveExecServer() for ${oe}`),$.mark(`code/extHost/willResolveExecServer/${H}`),pe=await Q.resolveExecServer?.(oe,{resolveAttempt:B,execServer:pe}),!pe)throw new t.$4L(`Exec server was not available for ${oe}`,d.RemoteAuthorityResolverErrorCode.NoResolverFound);$.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ve){return $.mark(`code/extHost/didResolveAuthorityError/${H}`),ue("returned an error",ve),be.dispose(),ge(ve)}be.dispose();const Ae={environmentTunnels:Pe.environmentTunnels,features:Pe.tunnelFeatures?{elevation:Pe.tunnelFeatures.elevation,privacyOptions:Pe.tunnelFeatures.privacyOptions,protocol:Pe.tunnelFeatures.protocol===void 0?!0:Pe.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:Pe.extensionHostEnv,isTrusted:Pe.isTrusted,authenticationSession:Pe.authenticationSessionForInitializingExtensions?{id:Pe.authenticationSessionForInitializingExtensions.id,providerId:Pe.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${t.$3L.isManagedResolvedAuthority(Pe)?"managed authority":`${Pe.host}:${Pe.port}`}`);let W;if(t.$3L.isManagedResolvedAuthority(Pe)){const x=B;this.X.setFactory(x,Pe.makeConnection),W={authority:K,connectTo:new d.$fl(x),connectionToken:Pe.connectionToken}}else W={authority:K,connectTo:new d.$gl(Pe.host,Pe.port),connectionToken:Pe.connectionToken};return{type:"ok",value:{authority:W,options:Fe,tunnelInformation:Ae}}}async $getCanonicalURI(K,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,d.$il)(K)})`);const{resolver:ae}=await this.sb(K);if(!ae)return null;const ye=S.URI.revive(B);if(typeof ae.getCanonicalURI>"u")return ye;const le=await(0,R.$7g)(()=>ae.getCanonicalURI(ye));return le||ye}$startExtensionHost(K){K.toAdd.forEach(ye=>ye.extensionLocation=S.URI.revive(ye.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,K);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Z(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Z(this.J)}`)),this.rb()}$activateByEvent(K,B){return B===1?this.D.wait().then(ae=>this.Z(K,!1)):this.G.wait().then(ae=>this.Z(K,!1))}async $activate(K,B){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.$(K,B),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(de=>de.extensionLocation=S.URI.revive(de.extensionLocation));const{globalRegistry:B,myExtensions:ae}=ne(this.I,this.L,this.J,K),ye=await this.bb(ae);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ae),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Z(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Z(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const B=r.$qe.alloc(K),ae=Math.random()%256;for(let ye=0;ye<K;ye++)B.writeUInt8(ae,ye);return B}async $updateRemoteConnectionData(K){this.W=K,this.a.fire()}};e.$4hc=J,e.$4hc=J=j=Ke([We(0,c.$bi),We(1,e.$3hc),We(2,h.$aO),We(3,u.$qhc),We(4,w.$thc),We(5,L.$wj),We(6,s.$qO),We(7,l.$whc),We(8,D.$Rzb),We(9,g.$Rhc),We(10,z.$Zhc),We(11,T.$1hc)],J);function ne(re,K,B,ae){re.addActivationEvents(ae.addActivationEvents);const ye=new o.$68b(re,K.getAllExtensionDescriptions());ye.deltaExtensions(ae.toAdd,ae.toRemove);const le=new n.$vm(B.getAllExtensionDescriptions().map(ue=>ue.identifier));for(const ue of ae.myToRemove)le.delete(ue);for(const ue of ae.myToAdd)le.add(ue);const de=ce(ye,le);return{globalRegistry:ye,myExtensions:de}}function _(re,K){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Z(re){return re.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$5hc=(0,c.$ci)("IExtHostExtensionService");class Y{#e;#t;#i;constructor(K,B,ae,ye,le){this.#e=K,this.#t=B,this.#i=ae.identifier,this.id=ae.identifier.value,this.extensionUri=ae.extensionLocation,this.extensionPath=O.$hc((0,A.$Dg)(ae.extensionLocation)),this.packageJSON=ae,this.extensionKind=ye,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$6hc=Y;function ce(re,K){return re.getAllExtensionDescriptions().filter(B=>K.has(B.identifier))}class ie{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$7hc=ie;class fe{constructor(K){this.a=new n.$wm,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const B of Object.keys(K))this.a.set(B,K[B])}}}),define(Ce[367],Ie([1,0,58,2,6,42,25,26,20,27,5,47,13,12]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let u=class{constructor(r,a,t,d,c,s,l){this.c=r,this.d=a,this.e=t,this.f=d,this.g=c,this.h=s,this.i=l,this.a=new Map,this.b=[]}async install(){this.j(),I.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();I.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$cjc=u,e.$cjc=u=Ke([We(2,L.$bi),We(3,A.$thc),We(4,C.$5hc),We(5,S.$qO),We(6,w.$wj)],u);let m=class{static{k=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&k.a.size){const a=(0,E.$Ve)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",d=`@${t}+\\/${t}+|${t}+`,c="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${c}\\/)(${d})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,d,c]=a,s=k.a.get(d);if(s!==void 0)return console.warn(`${d} as been renamed to ${s}, please update your imports`),t+s+c}c(r){return r.replace(/\\/g,"/")}};m=k=Ke([We(0,S.$qO)],m);class o{constructor(r,a,t,d,c){this.c=r,this.d=a,this.e=t,this.f=d,this.g=c,this.nodeModuleName="vscode",this.a=new v.$wm}load(r,a){const t=this.d.findSubstr(a);if(t){let d=this.a.get(t.identifier);return d||(d=this.c(t,this.e,this.f),this.a.set(t.identifier,d)),d}if(!this.b){let d="";this.d.forEach((c,s)=>d+=`	${s} -> ${c.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${d}`),this.b=this.c(R.$MF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy($.$VL.MainThreadTelemetry);const d=t.getProxy($.$VL.MainThreadWindow);this.c=(c,s)=>{const l=O.URI.parse(c);return s?this.g(c,s):l.scheme==="http"||l.scheme==="https"?d.$openUri(l,c,{allowTunneling:!0}):l.scheme==="mailto"||l.scheme===this.f?d.$openUri(l,c,{}):this.g(c,s)}}load(r,a,t){const d=this.e.findSubstr(a);return d&&(this.a=d.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ke([We(2,p.$aO)],i)}),define(Ce[60],Ie([1,0,43,3,17,49,5,73,72,47,7,41,291,42]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0,e.$8hc=(0,R.$ci)("IExtHostVariableResolverProvider");class k extends w.$bP{constructor(o,i,n,r,a,t,d){function c(){if(n){const s=n.activeEditor();if(s)return s.document.uri;const l=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof L.$GN||l.input instanceof L.$LN)return l.input.modified;if(l.input instanceof L.$FN||l.input instanceof L.$KN||l.input instanceof L.$IN)return l.input.uri}}}super({getFolderUri:s=>{const l=t.folders.filter(h=>h.name===s);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,l)=>a.getConfiguration(void 0,s).get(l),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=c();if(s)return $.$hc(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const s=c();if(s){const l=i.getWorkspaceFolder(s);if(l)return $.$hc(l.uri.fsPath)}}},getSelectedText:()=>{if(n){const s=n.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(n){const s=n.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>o.getExtension(s)},void 0,d?Promise.resolve(d):void 0,Promise.resolve(A.env))}}let u=class extends O.$Tc{constructor(o,i,n,r,a){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new I.$V(async()=>{const t=await this.h.getConfigProvider(),c={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{c.folders=await this.c.getWorkspaceFolders2()||[]})),new k(this.b,this.c,this.g,this.j,t,c,this.m())})}getResolver(){return this.a.value}m(){}};e.$9hc=u,e.$9hc=u=Ke([We(0,S.$5hc),We(1,C.$qhc),We(2,v.$lO),We(3,E.$thc),We(4,p.$Fhc)],u)}),define(Ce[96],Ie([1,0,8,4,2,26,5,6,72,47,20,7,41,140,283,42,60,3,55,33,15]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=e.$$hc=e.$0hc=void 0,e.$0hc=(0,R.$ci)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(b,D,g,f,y,P,N){this.N=D,this.O=g,this.P=f,this.Q=y,this.R=P,this.S=N,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new O.$3d,this.o=new O.$3d,this.q=new O.$3d,this.w=new O.$3d,this.l=b.getProxy(v.$VL.MainThreadDebugService),this.A=new O.$3d,this.C=new O.$3d,this.y=new d(this.l),this.z=new Map,this.O.getExtensionRegistry().then(U=>{U.onDidChange(z=>{this.V(U)}),this.V(U)})}async $getVisualizerTreeItem(b,D){const g=this.W(D);if(!g)return;const f=await this.H.get(b)?.getTreeItem?.(g);return f?this.U(b,f):void 0}registerDebugVisualizationTree(b,D,g){const f=A.$um.toKey(b.identifier),y=this.jb(f,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(y,g),this.l.$registerDebugVisualizerTree(y,!!g.editItem),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(y),this.H.delete(D)})}async $getVisualizerTreeItemChildren(b,D){const g=this.J.get(D)?.item;return g?(await this.H.get(b)?.getChildren?.(g))?.map(y=>this.U(b,y))||[]:[]}async $editVisualizerTreeItem(b,D){const g=this.J.get(b);if(!g)return;const f=await this.H.get(g.provider)?.editItem?.(g.item,D);return this.U(g.provider,f||g.item)}$disposeVisualizedTree(b){const D=this.J.get(b);if(!D)return;const g=[D.children];for(const f of g)if(f)for(const y of f)g.push(this.J.get(y)?.children),this.J.delete(y)}U(b,D){let g=this.I.get(D);return g||(g=this.F++,this.I.set(D,g),this.J.set(g,{provider:b,item:D})),r.DebugTreeItem.from(D,g)}asDebugSourceUri(b,D){const g=b;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let f=`debug:${encodeURIComponent(g.path||"")}`,y="?";return D&&(f+=`${y}session=${encodeURIComponent(D.id)}`,y="&"),f+=`${y}ref=${g.sourceReference}`,$.URI.parse(f)}else{if(g.path)return $.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(b){const D=[];for(const g of b.getAllExtensionDescriptions())if(g.contributes){const f=g.contributes.debuggers;if(f&&f.length>0)for(const y of f)(0,k.$oG)(y)&&D.push(y.type)}this.l.$registerDebugTypes(D)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const b=[];return this.z.forEach(D=>b.push(D)),b}async $resolveDebugVisualizer(b,D){const g=this.L.get(b);if(!g)throw new Error(`No debug visualizer found with id '${b}'`);let{v:f,provider:y,extensionId:P}=g;if(f.visualization||(f=await y.resolveDebugVisualization?.(f,D)||f,g.v=f),!f.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${y}'`);return this.kb(P,f.visualization)}async $executeDebugVisualizerCommand(b){const D=this.L.get(b);if(!D)throw new Error(`No debug visualizer found with id '${b}'`);const g=D.v.visualization;g&&"command"in g&&this.S.executeCommand(g.command,...g.arguments||[])}W(b){const D=this.m.get(b.sessionId);return D&&{session:D.api,variable:b.variable,containerId:b.containerId,frameId:b.frameId,threadId:b.threadId}}async $provideDebugVisualizers(b,D,g,f){const y=this.W(g),P=this.jb(b,D),N=this.G.get(P);if(!y||!N)return[];const U=await N.provideDebugVisualization(y,f);return U?U.map(z=>{const F=++this.M;this.L.set(F,{v:z,provider:N,extensionId:b});const M=z.iconPath?this.lb(z.iconPath):void 0;return{id:F,name:z.name,iconClass:M?.iconClass,iconPath:M?.iconPath,visualization:this.kb(b,z.visualization)}}):[]}$disposeDebugVisualizers(b){for(const D of b)this.L.delete(D)}registerDebugVisualizationProvider(b,D,g){if(!b.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const f=A.$um.toKey(b.identifier),y=this.jb(f,D);if(this.G.has(y))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(y,g),this.l.$registerDebugVisualizer(f,D),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizer(f,D),this.G.delete(D)})}addBreakpoints(b){const D=b.filter(y=>{const P=y.id;return this.z.has(P)?!1:(this.z.set(P,y),!0)});this.gb(D,[],[]);const g=[],f=new Map;for(const y of D)if(y instanceof C.$XM){let P=f.get(y.location.uri.toString());P||(P={type:"sourceMulti",uri:y.location.uri,lines:[]},f.set(y.location.uri.toString(),P),g.push(P)),P.lines.push({id:y.id,enabled:y.enabled,condition:y.condition,hitCondition:y.hitCondition,logMessage:y.logMessage,line:y.location.range.start.line,character:y.location.range.start.character,mode:y.mode})}else y instanceof C.$YM&&g.push({type:"function",id:y.id,enabled:y.enabled,hitCondition:y.hitCondition,logMessage:y.logMessage,condition:y.condition,functionName:y.functionName,mode:y.mode});return this.l.$registerBreakpoints(g)}removeBreakpoints(b){const D=b.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const g=D.filter(P=>P instanceof C.$XM).map(P=>P.id),f=D.filter(P=>P instanceof C.$YM).map(P=>P.id),y=D.filter(P=>P instanceof C.$ZM).map(P=>P.id);return this.l.$unregisterBreakpoints(g,f,y)}startDebugging(b,D,g){return this.l.$startDebugging(b?b.uri:void 0,D,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(b){return this.l.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,D,g){if(!D)return new C.$XL(()=>{});const f=this.d++;return this.f.push({type:b,handle:f,provider:D}),this.l.$registerDebugConfigurationProvider(b,g,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,f),new C.$XL(()=>{this.f=this.f.filter(y=>y.provider!==D),this.l.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(b,D,g){if(!g)return new C.$XL(()=>{});if(!this.cb(b,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this.g++;return this.h.push({type:D,handle:f,factory:g}),this.l.$registerDebugAdapterDescriptorFactory(D,f),new C.$XL(()=>{this.h=this.h.filter(y=>y.factory!==g),this.l.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(b,D){if(!D)return new C.$XL(()=>{});const g=this.j++;return this.k.push({type:b,handle:g,factory:D}),new C.$XL(()=>{this.k=this.k.filter(f=>f.factory!==D)})}async $runInTerminal(b,D){return Promise.resolve(void 0)}async $substituteVariables(b,D){let g;const f=await this.ib(b);return f&&(g={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(g,D)}X(b,D){if(b.type==="implementation")return new s(b.implementation)}Y(){}async $startDASession(b,D){const g=this,f=await this.hb(D);return this.eb(this.$(f.type),f).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const P=this.Z(y),N=this.X(P,f);if(!N)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const U=N;return this.D.set(b,U),this.db(f).then(z=>(z&&this.E.set(b,z),U.onMessage(async F=>{if(F.type==="request"&&F.command==="handshake"){const M=F,T={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const j=await this.K.sign(M.arguments.value);T.body={signature:j},U.sendResponse(T)}else throw new Error("no signer")}catch(j){T.success=!1,T.message=j.message,U.sendResponse(T)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(F),F=(0,k.$tG)(F,!0),g.l.$acceptDAMessage(b,F)}),U.onError(F=>{z&&z.onError&&z.onError(F),this.l.$acceptDAError(b,F.name,F.message,F.stack)}),U.onExit(F=>{z&&z.onExit&&z.onExit(F??void 0,void 0),this.l.$acceptDAExit(b,F??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),U.startSession()))})}$sendDAMessage(b,D){D=(0,k.$sG)(D,!1);const g=this.E.get(b);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(D),this.D.get(b)?.sendMessage(D)}$stopDASession(b){const D=this.E.get(b);this.E.delete(b),D&&D.onWillStopSession&&D.onWillStopSession();const g=this.D.get(b);return this.D.delete(b),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const D=[],g=[],f=[];if(b.added)for(const y of b.added){const P=y.id;if(P&&!this.z.has(P)){let N;if(y.type==="function")N=new C.$YM(y.functionName,y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode);else if(y.type==="data")N=new C.$ZM(y.label,y.dataId,y.canPersist,y.enabled,y.hitCondition,y.condition,y.logMessage,y.mode);else{const U=$.URI.revive(y.uri);N=new C.$XM(new C.$0L(U,new C.$YL(y.line,y.character)),y.enabled,y.condition,y.hitCondition,y.logMessage,y.mode)}(0,C.$VM)(N,P),this.z.set(P,N),D.push(N)}}if(b.removed)for(const y of b.removed){const P=this.z.get(y);P&&(this.z.delete(y),g.push(P))}if(b.changed){for(const y of b.changed)if(y.id){const P=this.z.get(y.id);if(P){if(P instanceof C.$YM&&y.type==="function"){const N=P;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.functionName=y.functionName}else if(P instanceof C.$XM&&y.type==="source"){const N=P;N.enabled=y.enabled,N.condition=y.condition,N.hitCondition=y.hitCondition,N.logMessage=y.logMessage,N.location=new C.$0L($.URI.revive(y.uri),new C.$YL(y.line,y.character))}f.push(P)}}}this.gb(D,g,f)}async $acceptStackFrameFocus(b){let D;const g=b.sessionId?await this.hb(b.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");b.kind==="thread"?D=new C.$6M(g.api,b.threadId):D=new C.$5M(g.api,b.threadId,b.frameId),this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(b,D,g){return(0,I.$7g)(async()=>{const f=this.bb(b);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const y=await this.ib(D);return f.provideDebugConfigurations(y,g)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(b,D,g,f){return(0,I.$7g)(async()=>{const y=this.bb(b);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return y.resolveDebugConfiguration(P,g,f)})}$resolveDebugConfigurationWithSubstitutedVariables(b,D,g,f){return(0,I.$7g)(async()=>{const y=this.bb(b);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return y.resolveDebugConfigurationWithSubstitutedVariables(P,g,f)})}async $provideDebugAdapter(b,D){const g=this.ab(b);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.hb(D);return this.eb(g,f).then(y=>{if(!y)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.Z(y)})}async $acceptDebugSessionStarted(b){const D=await this.hb(b);this.n.fire(D.api)}async $acceptDebugSessionTerminated(b){const D=await this.hb(b);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(b){this.u=b?await this.hb(b):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(b,D){(await this.hb(b))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(b,D){const f={session:(await this.hb(b)).api,event:D.event,body:D.body};this.w.fire(f)}Z(b){if(b instanceof C.$1M)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof C.$2M)return{type:"server",port:b.port,host:b.host};if(b instanceof C.$3M)return{type:"pipeServer",path:b.path};if(b instanceof C.$4M)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}$(b){const D=this.h.filter(g=>g.type===b);if(D.length>0)return D[0].factory}ab(b){const D=this.h.filter(g=>g.handle===b);if(D.length>0)return D[0].factory}bb(b){const D=this.f.filter(g=>g.handle===b);if(D.length>0)return D[0].provider}cb(b,D){if(b.contributes){const g=b.contributes.debuggers;if(g&&g.length>0){for(const f of g)if(f.label&&f.type&&f.type===D)return!0}}return!1}db(b){const g=b.configuration.type,f=this.k.filter(y=>y.type===g||y.type==="*").map(y=>(0,I.$7g)(()=>y.factory.createDebugAdapterTracker(b.api)).then(P=>P,P=>null));return Promise.race([Promise.all(f).then(y=>{const P=y.filter(N=>!!N);if(P.length>0)return new c(P)}),new Promise(y=>setTimeout(()=>y(void 0),1e3))]).catch(y=>{})}async eb(b,D){const g=D.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new C.$2M(g));if(b){const y=await this.O.getExtensionRegistry();return(0,I.$7g)(()=>b.createDebugAdapterDescriptor(D.api,this.fb(D,y))).then(P=>{if(P)return P})}const f=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,f))}fb(b,D){}gb(b,D,g){(b.length>0||D.length>0||g.length>0)&&this.A.fire(Object.freeze({added:b,removed:D,changed:g}))}async hb(b){if(b)if(typeof b=="string"){const D=this.m.get(b);if(D)return D}else{let D=this.m.get(b.id);if(!D){const g=await this.ib(b.folderUri),f=b.parent?this.m.get(b.parent):void 0;D=new t(this.l,b.id,b.type,b.name,g,b.configuration,f?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(b){if(b){const D=$.URI.revive(b);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(b,D){return`${b}\0${D}`}kb(b,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${b}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(b){const D=this.mb(b);let g,f;return"id"in D?f=i.ThemeIcon.asClassName(D):g=D,{iconPath:g,iconClass:f}}mb(b){if(b instanceof C.$SM)return{id:b.id};const D=typeof b=="object"&&"dark"in b?b.dark:b,g=typeof b=="object"&&"light"in b?b.light:b;return{dark:typeof D=="string"?$.URI.file(D):D,light:typeof g=="string"?$.URI.file(g):g}}};e.$$hc=a,e.$$hc=a=Ke([We(0,L.$aO),We(1,w.$qhc),We(2,S.$5hc),We(3,u.$thc),We(4,p.$Fhc),We(5,m.$8hc),We(6,n.$wO)],a);class t{constructor(b,D,g,f,y,P,N){this.f=b,this.g=D,this.h=g,this.j=f,this.k=y,this.l=P,this.m=N}get api(){const b=this;return this.d??=Object.freeze({id:b.g,type:b.h,get name(){return b.j},set name(D){b.j=D,b.f.$setDebugSessionName(b.g,D)},parentSession:b.m,workspaceFolder:b.k,configuration:b.l,customRequest(D,g){return b.f.$customDebugAdapterRequest(b.g,D,g)},getDebugProtocolBreakpoint(D){return b.f.$getDebugProtocolBreakpoint(b.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(b){this.j=b}get configuration(){return this.l}}e.$_hc=t;class d{constructor(b){this.value=Object.freeze({append(D){b.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$aic=d;class c{constructor(b){this.d=b}onWillStartSession(){this.d.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(b):void 0)}onWillStopSession(){this.d.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.d.forEach(D=>D.onError?D.onError(b):void 0)}onExit(b,D){this.d.forEach(g=>g.onExit?g.onExit(b,D):void 0)}}class s extends E.$enb{constructor(b){super(),this.h=b,b.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.h.handleMessage(b)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends a{constructor(b,D,g,f,y,P,N){super(b,D,g,f,y,P,N)}};e.$bic=l,e.$bic=l=Ke([We(0,L.$aO),We(1,w.$qhc),We(2,S.$5hc),We(3,u.$thc),We(4,p.$Fhc),We(5,m.$8hc),We(6,n.$wO)],l)}),define(Ce[368],Ie([1,0,14,58,2,6,312,13,84,106,27,249,20,67,47,90]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(v.$wj),t=n.get(w.$aO).getProxy(A.$VL.MainThreadErrors);I.setUnexpectedErrorHandler(d=>{r.error(d);const c=I.$3(d);t.$onUnexpectedError(c)})}static async installFullHandler(n){const r=n.get(v.$wj),a=n.get(w.$aO),t=n.get(k.$5hc),d=n.get(u.$uO),c=a.getProxy(A.$VL.MainThreadExtensionService),s=a.getProxy(A.$VL.MainThreadErrors),l=await t.getExtensionPathIndex(),h=new WeakMap;function b(f,y){if(h.has(f))return h.get(f).stack;let P="",N,U;for(const F of y)P+=`
	at ${F.toString()}`,U=F.getFileName(),!N&&U&&(N=l.findSubstr($.URI.file(U)));const z=`${f.name||"Error"}: ${f.message||""}${P}`;return h.set(f,{extensionIdentifier:N?.identifier,stack:z}),z}const D=Symbol("prepareStackTrace wrapped");let g=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(f){if(f===b||!f||f[D]){g=f||b;return}g=function(y,P){return b(y,P),f.call(Error,y,P)},Object.assign(g,{[D]:!0})}}),I.setUnexpectedErrorHandler(f=>{r.error(f);const y=I.$3(f),P=h.get(f);if(!P?.extensionIdentifier){s.$onUnexpectedError(y);return}c.$onExtensionRuntimeError(P.extensionIdentifier,y);const N=d.onExtensionError(P.extensionIdentifier,f);r.trace("forwarded error to extension?",N,P)})}}e.$djc=m;class o{constructor(n,r,a,t,d){this.a=a,this.b=new R.$b9b(n,null,t),r=o.e(r,this.b);const c=new S.$ai(...(0,p.$9r)());c.set(L.$qO,{_serviceBrand:void 0,...r,messagePorts:d}),c.set(w.$aO,new w.$bO(this.b)),c.set(E.$nhc,new E.$ohc(t)),c.set(k.$3hc,a);const s=new C.$Nq(c,!0);s.invokeFunction(m.installEarlyHandler),this.d=s.invokeFunction(l=>l.get(v.$wj)),O.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=s.invokeFunction(l=>l.get(k.$5hc)),this.c.initialize(),s.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(A.$VL.MainThreadExtensionService);return $.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=$.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=$.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>$.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=$.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=$.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=$.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=$.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=$.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=$.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$ejc=o}),define(Ce[369],Ie([1,0,8,11,224,243,138,96,72,47,20,46,7,60,41,284,285,42,33]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;let n=class extends v.$$hc{constructor(c,s,l,h,b,D,g,f){super(c,s,l,h,D,g,f),this.pb=b,this.nb=new t}X(c,s){switch(c.type){case"server":return new u.$jjc(c);case"pipeServer":return new u.$kjc(c);case"executable":return new u.$ljc(c,s.type)}return super.X(c,s)}fb(c,s){const l=u.$ljc.platformAdapterExecutable(s.getAllExtensionDescriptions(),c.type);if(l)return new w.$1M(l.command,l.args,l.options)}Y(){return new R.$Z_b}async $runInTerminal(c,s){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(F=>{this.nb.onTerminalClosed(F)}));const l=await this.P.getConfigProvider(),h=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),D=c.title||$.localize(0,null),g=JSON.stringify({shell:h,shellArgs:b});let f=await this.nb.checkout(g,D),y,P=!1;if(f)y=c.cwd;else{const F={shellPath:h,shellArgs:b,cwd:c.cwd,name:D,iconPath:new w.$SM("debug")};P=!0,f=this.pb.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.nb.insert(f,g)}f.show(!0);const N=await f.processId;P?await new Promise(F=>setTimeout(F,1e3)):l.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(h.indexOf("powershell")>=0||h.indexOf("pwsh")>=0||h.indexOf("cmd.exe")>=0?f.sendText("cls"):h.indexOf("bash")>=0?f.sendText("clear"):O.$i?f.sendText("cls"):f.sendText("clear"));const U=(0,m.$njc)(h,c.args,!!c.argsCanBeInterpretedByShell,y,c.env);f.sendText(U);const z=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.nb.free(f),z.dispose())});return N}else if(c.kind==="external")return a(c,await this.P.getConfigProvider());return super.$runInTerminal(c,s)}};e.$ojc=n,e.$ojc=n=Ke([We(0,L.$aO),We(1,k.$qhc),We(2,S.$5hc),We(3,o.$thc),We(4,C.$Rhc),We(5,p.$Fhc),We(6,E.$8hc),We(7,i.$wO)],n);let r;function a(d,c){if(!r)if(O.$i)r=new A.$J$b;else if(O.$j)r=new A.$K$b;else if(O.$k)r=new A.$L$b;else throw new Error("external terminals not supported on this platform");const s=c.getConfiguration("terminal");return r.runInTerminal(d.title,d.cwd,d.args,d.env||{},s.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,s){const h=[...this.b.entries()].map(([b,D])=>(0,I.$2g)(async g=>{if(b.name!==s||D.lastUsedAt!==-1&&await(0,m.$mjc)(await b.processId))return null;const f=Date.now();return D.lastUsedAt+t.a>f||g.isCancellationRequested||D.config!==c?null:(D.lastUsedAt=f,b)}));return await(0,I.$hh)(h,b=>!!b)}insert(c,s){this.b.set(c,{lastUsedAt:Date.now(),config:s})}free(c){const s=this.b.get(c);s&&(s.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(Ce[370],Ie([1,0,17,2,104,41,73,42,40,46,20,27,95,16,13,91,23,64,60]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;let n=class extends w.$Uic{constructor(a,t,d,c,s,l,h,b,D){super(a,t,d,c,s,l,h,b),this.C=d,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const d=t;if(!t.execution&&d._id===void 0)throw new Error("Tasks to execute must include an execution");if(d._id!==void 0){const c=w.TaskHandleDTO.from(d,this.C),s=await this.a.$getTaskExecution(c);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const l=await this.z(s,t);return this.a.$executeTask(c).catch(()=>{}),l}else{const c=w.TaskDTO.from(t,a);if(c===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(c.execution)&&await this.y(c,t,!1);const s=await this.z(await this.a.$getTaskExecution(c),t);return this.a.$executeTask(c).catch(()=>{}),s}}v(a,t,d,c){const s=[];if(c)for(const l of c){this.A(l,d),(!l.definition||!a[l.definition.type])&&this.f.warn(`The task [${l.source}, ${l.name}] uses an undefined task type. The task will be ignored in the future.`);const h=w.TaskDTO.from(l,d.extension);h&&(s.push(h),w.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,l,!0)))}return{tasks:s,extension:d.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const d=O.URI.file((0,o.homedir)());t=new p.$wi({uri:d,name:m.$Mg(d),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const d=O.URI.revive(a),c={process:void 0,variables:Object.create(null)},s=await this.b.resolveWorkspaceFolder(d),l=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),b=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(l);for(const D of t.variables)c.variables[D]=await h.resolveAsync(b,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(I.$tc);for(let g=0;g<D.length;g++)D[g]=await h.resolveAsync(b,D[g])}c.process=await $.win32.findExecutable(await h.resolveAsync(b,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(b,t.process.cwd):void 0,D)}return c}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,d){return $.win32.findExecutable(a,t,d)}};e.$gjc=n,e.$gjc=n=Ke([We(0,L.$aO),We(1,C.$qO),We(2,A.$qhc),We(3,R.$lO),We(4,v.$thc),We(5,S.$Rhc),We(6,k.$wj),We(7,u.$6gc),We(8,i.$8hc)],n)}),define(Ce[371],Ie([1,0,64,60]),function(me,e,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;class $ extends O.$9hc{m(){return(0,I.homedir)()}}e.$Yjc=$}),define(Ce[155],Ie([1,0,19,8,22,44,16,17,23,2,36]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=e.$pic=void 0;class C{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new $.$ae(n);return new Promise((t,d)=>{this.a=new E(i);let c=!1;const s=(l,h)=>{if(!c&&!this.b){const b=this.h(l);u(l)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,c=!0,a.cancel(),l=this.j(l,this.d.maxResults-this.c));const D=this.h(l);this.c+=D,(D>0||!u(l))&&this.a.add(l,h)}};Promise.all(r.map((l,h)=>this.k(l,b=>s(b,h),a.token))).then(l=>{a.dispose(),this.a.flush();const h=l.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||h,messages:(0,I.$Rb)(l.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},l=>{a.dispose();const h=(0,A.$Zi)(l);d(new Error(h))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new L.$xK(this.d,i),t=[],d={report:l=>{if(!this.l(l))return;const h=i.folder.scheme===R.Schemas.file?(0,L.$yK)(()=>this.f.readdir(p.$Og(l.uri))):void 0,b=p.$Rg(i.folder,l.uri);if(b){const D=a.includedInQuery(b,v.$nc(b),h);(0,O.$1g)(D)?t.push(D.then(g=>{g&&n(l)})):D&&n(l)}}},c=this.n(i),s=await this.e.provideTextSearchResults(w(this.d.contentPattern),c,d,r);return t.length&&await Promise.all(t),s}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,L.$wK)(this.d.includePattern,i.includePattern),r=(0,L.$wK)(this.d.excludePattern,i.excludePattern),a={folder:S.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$pic=C;function w(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!p.$Ig(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(k(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$qic=E;function k(o){return u(o)?{preview:{matches:(0,I.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,I.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.$ric=u;class m{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$sic=m}),define(Ce[97],Ie([1,0,3,6,5,364,20,67,13,2,155]),function(me,e,I,O,$,A,R,v,p,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=e.$tic=void 0,e.$tic=(0,$.$ci)("IExtHostSearch");let C=class{constructor(u,m,o){this.k=u,this.l=m,this.n=o,this.c=this.k.getProxy(O.$VL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new A.$oic}o(u){return this.l.transformOutgoingScheme(u)}registerTextSearchProvider(u,m){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.o(u)),(0,I.$Rc)(()=>{this.g.delete(u),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(u,m){if(this.i.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.i.add(u);const o=this.d++;return this.h.set(o,m),this.c.$registerFileSearchProvider(o,this.o(u)),(0,I.$Rc)(()=>{this.i.delete(u),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(u,m,o,i){const n=w(o),r=this.h.get(u);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(u,m,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,m,o){return{messages:[]}}$clearCache(u){return this.j.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,m,o,i){const n=this.e.get(u);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${u}`);const r=w(o);return this.q(r,n).search(t=>this.c.$handleTextMatch(u,m,t),i)}$enableExtensionHostSearch(){}q(u,m){return new L.$pic(u,m,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$uic=C,e.$uic=C=Ke([We(0,R.$aO),We(1,v.$nhc),We(2,p.$wj)],C);function w(k){return{...k,folderQueries:k.folderQueries&&k.folderQueries.map(E),extraFileResources:k.extraFileResources&&k.extraFileResources.map(u=>S.URI.revive(u))}}e.$vic=w;function E(k){return{...k,folder:S.URI.revive(k.folder)}}}),define(Ce[372],Ie([1,0,22,14,4,3,16,39,2,132,192,173,80,26,32,13,66,87,268,6,314,343,91,315,320,300,321,322,323,301,289,33,324,42,325,96,148,326,303,316,327,328,73,72,317,47,329,70,330,59,27,344,345,318,304,331,332,114,115,305,363,334,274,335,346,336,153,306,337,338,339,20,340,97,116,341,307,342,117,93,95,90,46,347,348,319,349,350,71,15,7,308,67,309,92,351,352,147,41,282,113,25,94]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c,s,l,h,b,D,g,f,y,P,N,U,z,F,M,T,j,J,ne,_,Z,Y,ce,ie,fe,re,K,B,ae,ye,le,de,ue,ge,V,X,he,be,Pe,pe,Ae,Fe,W,x,H,Q,oe,ve,Le,qe,Ge,Ye,it,ut,ot,et,Re,ke,He,ee,se,Se,Ve,Ze,nt,rt,je,Et,St,jt,Lt,Dt,ei,Wt,si,xt,_t,_e,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;function ti(dt){const $t=dt.get(K.$qO),Qt=dt.get(re.$0gc),ii=dt.get(ie.$vhc),Rt=dt.get(Y.$5hc),ft=dt.get(si.$qhc),Ft=dt.get(ke.$uO),oi=dt.get(P.$thc),Ot=dt.get(St.$nhc),Je=dt.get(ve.$aO),Ut=dt.get(ot.$Ohc),Vt=dt.get(et.$whc),ni=dt.get(u.$xj),gt=dt.get(u.$wj),Nt=dt.get(nt.$Rzb),At=dt.get(t.$6gc),Bt=dt.get(Wt.$0ic),Ht=dt.get(Ge.$Whc),Gt=dt.get(_.$Fhc),It=dt.get(V.$1hc);Je.set(n.$WL.ExtHostFileSystemInfo,Qt),Je.set(n.$WL.ExtHostLogLevelServiceShape,ni),Je.set(n.$WL.ExtHostWorkspace,ft),Je.set(n.$WL.ExtHostConfiguration,oi),Je.set(n.$WL.ExtHostExtensionService,Rt),Je.set(n.$WL.ExtHostStorage,Ut),Je.set(n.$WL.ExtHostTunnelService,Nt),Je.set(n.$WL.ExtHostWindow,Bt),Je.set(n.$WL.ExtHostSecretState,Ht),Je.set(n.$WL.ExtHostTelemetry,Ft),Je.set(n.$WL.ExtHostEditorTabs,Gt),Je.set(n.$WL.ExtHostManagedSockets,It);const Zt=Je.set(n.$WL.ExtHostDecorations,dt.get(z.$dic)),kt=Je.set(n.$WL.ExtHostDocumentsAndEditors,dt.get(ne.$lO)),pt=Je.set(n.$WL.ExtHostCommands,dt.get(f.$wO)),Pt=Je.set(n.$WL.ExtHostTerminalService,dt.get(He.$Rhc)),Ct=Je.set(n.$WL.ExtHostDebugService,dt.get(U.$0hc)),ci=Je.set(n.$WL.ExtHostSearch,dt.get(qe.$tic)),Xt=Je.set(n.$WL.ExtHostTask,dt.get(Re.$Wic)),bi=Je.set(n.$WL.ExtHostOutputService,dt.get(W.$Jic)),Kt=Je.set(n.$WL.ExtHostLocalization,dt.get(ge.$Zhc)),Me=Je.set(n.$WL.ExtHostUrls,new jt.$7ic(Je)),Te=Je.set(n.$WL.ExtHostDocuments,new J.$ahc(Je,kt)),De=Je.set(n.$WL.ExtHostDocumentContentProviders,new T.$fic(Je,kt,gt)),te=Je.set(n.$WL.ExtHostDocumentSaveParticipant,new j.$gic(gt,Te,Je.getProxy(n.$VL.MainThreadBulkEdits))),Oe=Je.set(n.$WL.ExtHostNotebook,new he.$wic(Je,pt,kt,Te,ii,ci)),Be=Je.set(n.$WL.ExtHostNotebookDocuments,new Pe.$Dic(Oe)),xe=Je.set(n.$WL.ExtHostNotebookEditors,new pe.$Eic(gt,Oe)),Qe=Je.set(n.$WL.ExtHostNotebookKernels,new Ae.$Fic(Je,$t,Oe,pt,gt)),at=Je.set(n.$WL.ExtHostNotebookRenderers,new Fe.$Hic(Je,Oe)),vt=Je.set(n.$WL.ExtHostNotebookDocumentSaveParticipant,new be.$Cic(gt,Oe,Je.getProxy(n.$VL.MainThreadBulkEdits))),yt=Je.set(n.$WL.ExtHostEditors,new se.$khc(Je,kt)),Yt=Je.set(n.$WL.ExtHostTreeViews,new Ze.$5ic(Je.getProxy(n.$VL.MainThreadTreeViews),pt,gt)),Mt=Je.set(n.$WL.ExtHostEditorInsets,new g.$lhc(Je.getProxy(n.$VL.MainThreadEditorInsets),yt,$t.remote)),zt=Je.set(n.$WL.ExtHostDiagnostics,new F.$_gc(Je,gt,Qt,kt)),wi=Je.set(n.$WL.ExtHostLanguages,new ue.$Aic(Je,Te,pt.converter,Ot)),ht=Je.set(n.$WL.ExtHostLanguageFeatures,new de.$bhc(Je,Ot,Te,pt,zt,gt,At,Ft)),Xi=Je.set(n.$WL.ExtHostFileSystem,new ce.$iic(Je,ht)),ui=Je.set(n.$WL.ExtHostFileSystemEventService,new fe.$jic(Je,gt,kt)),gi=Je.set(n.$WL.ExtHostQuickOpen,(0,oe.$Nic)(Je,ft,pt)),yi=Je.set(n.$WL.ExtHostSCM,new Le.$Pic(Je,pt,Te,gt)),Ai=Je.set(n.$WL.ExtHostQuickDiff,new Q.$Mic(Je,Ot)),Yi=Je.set(n.$WL.ExtHostShare,new Ye.$Qic(Je,Ot)),hn=Je.set(n.$WL.ExtHostComments,(0,y.$mhc)(Je,pt,Te)),Ri=Je.set(n.$WL.ExtHostProgress,new H.$Lic(Je.getProxy(n.$VL.MainThreadProgress))),Li=Je.set(n.$WL.ExtHostLabelService,new le.$zic(Je)),Ei=Je.set(n.$WL.ExtHostTheming,new Se.$2ic(Je)),mi=Je.set(n.$WL.ExtHostAuthentication,new d.$dhc(Je)),xi=Je.set(n.$WL.ExtHostTimeline,new Ve.$4ic(Je,pt)),ki=Je.set(n.$WL.ExtHostWebviews,new Lt.$Ahc(Je,$t.remote,ft,gt,At)),Si=Je.set(n.$WL.ExtHostWebviewPanels,new Dt.$Dhc(Je,ki,ft)),_i=Je.set(n.$WL.ExtHostCustomEditors,new N.$Ehc(Je,Te,Vt,ki,Si)),dn=Je.set(n.$WL.ExtHostWebviewViews,new ei.$8ic(Je,ki)),pi=Je.set(n.$WL.ExtHostTesting,new ee.$Xic(Je,gt,pt,kt)),Mi=Je.set(n.$WL.ExtHostUriOpeners,new Et.$6ic(Je)),Fi=Je.set(n.$WL.ExtHostProfileContentHandlers,new x.$Kic(Je));Je.set(n.$WL.ExtHostInteractive,new ae.$xic(Je,Oe,kt,pt,gt));const fn=Je.set(n.$WL.ExtHostInlineChat,new B.$kic(Je,pt,Te,gt)),Di=Je.set(n.$WL.ExtHostChatProvider,new h.$hhc(Je,gt,mi)),en=Je.set(n.$WL.ExtHostChatAgents2,new l.$ghc(Je,gt,pt)),gn=Je.set(n.$WL.ExtHostChatVariables,new b.$ihc(Je)),vi=Je.set(n.$WL.ExtHostChat,new s.$fhc(Je)),Oi=Je.set(n.$WL.ExtHostAiRelatedInformation,new r.$5gc(Je)),tn=Je.set(n.$WL.ExtHostAiEmbeddingVector,new Z.$hic(Je)),Ni=Je.set(n.$WL.ExtHostIssueReporter,new ye.$yic(Je)),nn=Je.set(n.$WL.ExtHostStatusBar,new ut.$Tic(Je,pt.converter)),Ti=Je.set(n.$WL.ExtHostSpeech,new it.$Ric(Je)),rn=Object.values(n.$WL);Je.assertRegistered(rn);const di=new c.$ehc(Je,kt),Ci=new D.$jhc(Je),ji=new X.$Bic(Je,gt),ri=new M.$eic(Je);return a.$chc.register(pt),function(ze,li,zi){function st($e){return(Ee,Ue,ct)=>{const wt=$e(Tt=>{try{Ee.call(Ue,Tt)}catch(Ji){O.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),Ft.onExtensionError(ze.identifier,Ji)}});return ct?.push(wt),wt}}const bt=function(){let $e=!ze.isUnderDevelopment;function Ee(){$e||(gt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ue(ct){if(Array.isArray(ct))ct.forEach(Ue);else if(typeof ct=="string")Ee();else{const wt=ct;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,_e.$SF)(ze,"documentFiltersExclusive")}return ct}}(),mn={getSession($e,Ee,Ue){return mi.getSession(ze,$e,Ee,Ue)},getSessions($e,Ee){return(0,_e.$SF)(ze,"authGetSessions"),mi.getSessions(ze,$e,Ee)},async hasSession($e,Ee){return(0,_e.$SF)(ze,"authSession"),!!await mi.getSession(ze,$e,Ee,{silent:!0})},get onDidChangeSessions(){return st(mi.onDidChangeSessions)},registerAuthenticationProvider($e,Ee,Ue,ct){return mi.registerAuthenticationProvider($e,Ee,Ue,ct)}},sn={registerCommand($e,Ee,Ue){return pt.registerCommand(!0,$e,Ee,Ue,void 0,ze)},registerTextEditorCommand($e,Ee,Ue){return pt.registerCommand(!0,$e,(...ct)=>{const wt=yt.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}return wt.edit(Tt=>{Ee.apply(Ue,[wt,Tt,...ct])}).then(Tt=>{Tt||gt.warn("Edits from command "+$e+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+$e,Tt)})},void 0,void 0,ze)},registerDiffInformationCommand:($e,Ee,Ue)=>((0,_e.$SF)(ze,"diffCommand"),pt.registerCommand(!0,$e,async(...ct)=>{const wt=kt.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Tt=await yt.getDiffInformation(wt.id);Ee.apply(Ue,[Tt,...ct])},void 0,void 0,ze)),executeCommand($e,...Ee){return pt.executeCommand($e,...Ee)},getCommands($e=!1){return pt.getCommands($e)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Ci.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return st(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Ft.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Ft.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,_e.$SF)(ze,"telemetry"),Ft.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,_e.$SF)(ze,"telemetry"),st(Ft.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ke.$tO)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Ee){return ke.$sO.validateSender($e),Ft.instantiateLogger(ze,$e,Ee)},openExternal($e,Ee){return Bt.openUri($e,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===$t.environment.appUriScheme)return Me.createAppUri($e);try{return await Bt.asExternalUri($e,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$mg)($e,R.Schemas.http)||(0,R.$mg)($e,R.Schemas.https))return $e;throw Ee}},get remoteName(){return(0,m.$kl)($t.remote.authority)},get remoteAuthority(){return(0,_e.$SF)(ze,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return st(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler($e){return(0,_e.$SF)(ze,"handleIssueUri"),Ni.registerIssueUriRequestHandler(ze,$e)},registerIssueDataProvider($e){return(0,_e.$SF)(ze,"handleIssueUri"),Ni.registerIssueDataProvider(ze,$e)},get appQuality(){return(0,_e.$SF)(ze,"resolvers"),$t.quality},get appCommit(){return(0,_e.$SF)(ze,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const $n={createTestController($e,Ee,Ue){return pi.createTestController(ze,$e,Ee,Ue)},createTestObserver(){return(0,_e.$SF)(ze,"testObserver"),pi.createTestObserver()},runTests($e){return(0,_e.$SF)(ze,"testObserver"),pi.runTests($e)},get onDidChangeTestResults(){return(0,_e.$SF)(ze,"testObserver"),st(pi.onResultsChanged)},get testResults(){return(0,_e.$SF)(ze,"testObserver"),pi.results}},Ii=$t.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,on={getExtension($e,Ee){(0,_e.$RF)(ze,"extensionsAny")||(Ee=!1);const Ue=li.mine.getExtensionDescription($e);if(Ue)return new Y.$6hc(Rt,ze.identifier,Ue,Ii,!1);if(Ee){const ct=li.all.getExtensionDescription($e);if(ct)return new Y.$6hc(Rt,ze.identifier,ct,Ii,!0)}},get all(){const $e=[];for(const Ee of li.mine.getAllExtensionDescriptions())$e.push(new Y.$6hc(Rt,ze.identifier,Ee,Ii,!1));return $e},get allAcrossExtensionHosts(){(0,_e.$SF)(ze,"extensionsAny");const $e=new E.$vm(li.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of li.all.getAllExtensionDescriptions()){const ct=!$e.has(Ue.identifier);Ee.push(new Y.$6hc(Rt,ze.identifier,Ue,Ii,ct))}return Ee},get onDidChange(){return(0,_e.$RF)(ze,"extensionsAny")?st($.Event.any(li.mine.onDidChange,li.all.onDidChange)):st(li.mine.onDidChange)}},Bi={createDiagnosticCollection($e){return zt.createDiagnosticCollection(ze.identifier,$e)},get onDidChangeDiagnostics(){return st(zt.onDidChangeDiagnostics)},getDiagnostics:$e=>zt.getDiagnostics($e),getLanguages(){return wi.getLanguages()},setTextDocumentLanguage($e,Ee){return wi.changeLanguage($e.uri,Ee)},match($e,Ee){const Ue=Te.getDocumentData(Ee.uri)?.notebook;return(0,L.$Kt)(rt.LanguageSelector.from($e),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider($e,Ee,Ue){return ht.registerCodeActionProvider(ze,bt($e),Ee,Ue)},registerDocumentPasteEditProvider($e,Ee,Ue){return(0,_e.$SF)(ze,"documentPaste"),ht.registerDocumentPasteEditProvider(ze,bt($e),Ee,Ue)},registerCodeLensProvider($e,Ee){return ht.registerCodeLensProvider(ze,bt($e),Ee)},registerDefinitionProvider($e,Ee){return ht.registerDefinitionProvider(ze,bt($e),Ee)},registerDeclarationProvider($e,Ee){return ht.registerDeclarationProvider(ze,bt($e),Ee)},registerImplementationProvider($e,Ee){return ht.registerImplementationProvider(ze,bt($e),Ee)},registerTypeDefinitionProvider($e,Ee){return ht.registerTypeDefinitionProvider(ze,bt($e),Ee)},registerHoverProvider($e,Ee){return ht.registerHoverProvider(ze,bt($e),Ee,ze.identifier)},registerEvaluatableExpressionProvider($e,Ee){return ht.registerEvaluatableExpressionProvider(ze,bt($e),Ee,ze.identifier)},registerInlineValuesProvider($e,Ee){return ht.registerInlineValuesProvider(ze,bt($e),Ee,ze.identifier)},registerDocumentHighlightProvider($e,Ee){return ht.registerDocumentHighlightProvider(ze,bt($e),Ee)},registerMultiDocumentHighlightProvider($e,Ee){return ht.registerMultiDocumentHighlightProvider(ze,bt($e),Ee)},registerLinkedEditingRangeProvider($e,Ee){return ht.registerLinkedEditingRangeProvider(ze,bt($e),Ee)},registerReferenceProvider($e,Ee){return ht.registerReferenceProvider(ze,bt($e),Ee)},registerRenameProvider($e,Ee){return ht.registerRenameProvider(ze,bt($e),Ee)},registerNewSymbolNamesProvider($e,Ee){return(0,_e.$SF)(ze,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(ze,bt($e),Ee)},registerDocumentSymbolProvider($e,Ee,Ue){return ht.registerDocumentSymbolProvider(ze,bt($e),Ee,Ue)},registerWorkspaceSymbolProvider($e){return ht.registerWorkspaceSymbolProvider(ze,$e)},registerDocumentFormattingEditProvider($e,Ee){return ht.registerDocumentFormattingEditProvider(ze,bt($e),Ee)},registerDocumentRangeFormattingEditProvider($e,Ee){return ht.registerDocumentRangeFormattingEditProvider(ze,bt($e),Ee)},registerOnTypeFormattingEditProvider($e,Ee,Ue,...ct){return ht.registerOnTypeFormattingEditProvider(ze,bt($e),Ee,[Ue].concat(ct))},registerDocumentSemanticTokensProvider($e,Ee,Ue){return ht.registerDocumentSemanticTokensProvider(ze,bt($e),Ee,Ue)},registerDocumentRangeSemanticTokensProvider($e,Ee,Ue){return ht.registerDocumentRangeSemanticTokensProvider(ze,bt($e),Ee,Ue)},registerSignatureHelpProvider($e,Ee,Ue,...ct){return typeof Ue=="object"?ht.registerSignatureHelpProvider(ze,bt($e),Ee,Ue):ht.registerSignatureHelpProvider(ze,bt($e),Ee,typeof Ue>"u"?[]:[Ue,...ct])},registerCompletionItemProvider($e,Ee,...Ue){return ht.registerCompletionItemProvider(ze,bt($e),Ee,Ue)},registerInlineCompletionItemProvider($e,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,_e.$SF)(ze,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,_e.$SF)(ze,"inlineCompletionsAdditions"),Ue&&(0,_e.$SF)(ze,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(ze,bt($e),Ee,Ue)},registerDocumentLinkProvider($e,Ee){return ht.registerDocumentLinkProvider(ze,bt($e),Ee)},registerColorProvider($e,Ee){return ht.registerColorProvider(ze,bt($e),Ee)},registerFoldingRangeProvider($e,Ee){return ht.registerFoldingRangeProvider(ze,bt($e),Ee)},registerSelectionRangeProvider($e,Ee){return ht.registerSelectionRangeProvider(ze,$e,Ee)},registerCallHierarchyProvider($e,Ee){return ht.registerCallHierarchyProvider(ze,$e,Ee)},registerTypeHierarchyProvider($e,Ee){return ht.registerTypeHierarchyProvider(ze,$e,Ee)},setLanguageConfiguration:($e,Ee)=>ht.setLanguageConfiguration(ze,$e,Ee),getTokenInformationAtPosition($e,Ee){return(0,_e.$SF)(ze,"tokenInformation"),wi.tokenAtPosition($e,Ee)},registerInlayHintsProvider($e,Ee){return ht.registerInlayHintsProvider(ze,$e,Ee)},createLanguageStatusItem($e,Ee){return wi.createLanguageStatusItem(ze,$e,Ee)},registerDocumentDropEditProvider($e,Ee,Ue){return ht.registerDocumentOnDropEditProvider(ze,$e,Ee,(0,_e.$RF)(ze,"dropMetadata")?Ue:void 0)}},an={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument($e,Ee,Ue){p.URI.isUri($e)&&$e.scheme===R.Schemas.vscodeRemote&&!$e.authority&&At.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await(p.URI.isUri($e)?Promise.resolve(Wi.openTextDocument($e)):Promise.resolve($e));return yt.showTextDocument(ct,Ee,Ue)},createTextEditorDecorationType($e){return yt.createTextEditorDecorationType(ze,$e)},onDidChangeActiveTextEditor($e,Ee,Ue){return st(yt.onDidChangeActiveTextEditor)($e,Ee,Ue)},onDidChangeVisibleTextEditors($e,Ee,Ue){return st(yt.onDidChangeVisibleTextEditors)($e,Ee,Ue)},onDidChangeTextEditorSelection($e,Ee,Ue){return st(yt.onDidChangeTextEditorSelection)($e,Ee,Ue)},onDidChangeTextEditorOptions($e,Ee,Ue){return st(yt.onDidChangeTextEditorOptions)($e,Ee,Ue)},onDidChangeTextEditorVisibleRanges($e,Ee,Ue){return st(yt.onDidChangeTextEditorVisibleRanges)($e,Ee,Ue)},onDidChangeTextEditorViewColumn($e,Ee,Ue){return st(yt.onDidChangeTextEditorViewColumn)($e,Ee,Ue)},onDidCloseTerminal($e,Ee,Ue){return st(Pt.onDidCloseTerminal)($e,Ee,Ue)},onDidOpenTerminal($e,Ee,Ue){return st(Pt.onDidOpenTerminal)($e,Ee,Ue)},onDidChangeActiveTerminal($e,Ee,Ue){return st(Pt.onDidChangeActiveTerminal)($e,Ee,Ue)},onDidChangeTerminalDimensions($e,Ee,Ue){return(0,_e.$SF)(ze,"terminalDimensions"),st(Pt.onDidChangeTerminalDimensions)($e,Ee,Ue)},onDidChangeTerminalState($e,Ee,Ue){return st(Pt.onDidChangeTerminalState)($e,Ee,Ue)},onDidWriteTerminalData($e,Ee,Ue){return(0,_e.$SF)(ze,"terminalDataWriteEvent"),st(Pt.onDidWriteTerminalData)($e,Ee,Ue)},onDidExecuteTerminalCommand($e,Ee,Ue){return(0,_e.$SF)(ze,"terminalExecuteCommandEvent"),st(Pt.onDidExecuteTerminalCommand)($e,Ee,Ue)},get state(){return Bt.getState(ze)},onDidChangeWindowState($e,Ee,Ue){return st(Bt.onDidChangeWindowState)($e,Ee,Ue)},showInformationMessage($e,...Ee){return ji.showMessage(ze,v.default.Info,$e,Ee[0],Ee.slice(1))},showWarningMessage($e,...Ee){return ji.showMessage(ze,v.default.Warning,$e,Ee[0],Ee.slice(1))},showErrorMessage($e,...Ee){return ji.showMessage(ze,v.default.Error,$e,Ee[0],Ee.slice(1))},showQuickPick($e,Ee,Ue){return gi.showQuickPick(ze,$e,Ee,Ue)},showWorkspaceFolderPick($e){return gi.showWorkspaceFolderPick($e)},showInputBox($e,Ee){return gi.showInput($e,Ee)},showOpenDialog($e){return ri.showOpenDialog(ze,$e)},showSaveDialog($e){return ri.showSaveDialog($e)},createStatusBarItem($e,Ee,Ue){let ct,wt,Tt;return typeof $e=="string"?(ct=$e,wt=Ee,Tt=Ue):(wt=$e,Tt=Ee),nn.createStatusBarEntry(ze,ct,wt,Tt)},setStatusBarMessage($e,Ee){return nn.setStatusBarMessage($e,Ee)},withScmProgress($e){return At.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ri.withProgress(ze,{location:je.ProgressLocation.SourceControl},(Ee,Ue)=>$e({report(ct){}}))},withProgress($e,Ee){return Ri.withProgress(ze,$e,Ee)},createOutputChannel($e,Ee){return bi.createOutputChannel($e,Ee,ze)},createWebviewPanel($e,Ee,Ue,ct){return Si.createWebviewPanel(ze,$e,Ee,Ue,ct)},createWebviewTextEditorInset($e,Ee,Ue,ct){return(0,_e.$SF)(ze,"editorInsets"),Mt.createWebviewEditorInset($e,Ee,Ue,ct,ze)},createTerminal($e,Ee,Ue){return typeof $e=="object"?"pty"in $e?Pt.createExtensionTerminal($e):Pt.createTerminalFromOptions($e):Pt.createTerminal($e,Ee,Ue)},registerTerminalLinkProvider($e){return Pt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Ee){return Pt.registerProfileProvider(ze,$e,Ee)},registerTerminalQuickFixProvider($e,Ee){return(0,_e.$SF)(ze,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider($e,ze.identifier.value,Ee)},registerTreeDataProvider($e,Ee){return Yt.registerTreeDataProvider($e,Ee,ze)},createTreeView($e,Ee){return Yt.createTreeView($e,Ee,ze)},registerWebviewPanelSerializer:($e,Ee)=>Si.registerWebviewPanelSerializer(ze,$e,Ee),registerCustomEditorProvider:($e,Ee,Ue={})=>_i.registerCustomEditorProvider(ze,$e,Ee,Ue),registerFileDecorationProvider($e){return Zt.registerFileDecorationProvider($e,ze)},registerUriHandler($e){return Me.registerUriHandler(ze,$e)},createQuickPick(){return gi.createQuickPick(ze)},createInputBox(){return gi.createInputBox(ze)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme($e,Ee,Ue){return st(Ei.onDidChangeActiveColorTheme)($e,Ee,Ue)},registerWebviewViewProvider($e,Ee,Ue){return dn.registerWebviewViewProvider(ze,$e,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Oe.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Ee,Ue){return st(Oe.onDidChangeActiveNotebookEditor)($e,Ee,Ue)},get visibleNotebookEditors(){return Oe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(Oe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection($e,Ee,Ue){return st(xe.onDidChangeNotebookEditorSelection)($e,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges($e,Ee,Ue){return st(xe.onDidChangeNotebookEditorVisibleRanges)($e,Ee,Ue)},showNotebookDocument($e,Ee){return Oe.showNotebookDocument($e,Ee)},registerExternalUriOpener($e,Ee,Ue){return(0,_e.$SF)(ze,"externalUriOpener"),Mi.registerExternalUriOpener(ze.identifier,$e,Ee,Ue)},registerProfileContentHandler($e,Ee){return(0,_e.$SF)(ze,"profileContentHandlers"),Fi.registerProfileContentHandler(ze,$e,Ee)},registerQuickDiffProvider($e,Ee,Ue,ct){return(0,_e.$SF)(ze,"quickDiffProvider"),Ai.registerQuickDiffProvider(bt($e),Ee,Ue,ct)},get tabGroups(){return Gt.tabGroups},registerShareProvider($e,Ee){return(0,_e.$SF)(ze,"shareProvider"),Yi.registerShareProvider(bt($e),Ee)}},Wi={get rootPath(){return At.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath($e){throw new O.$9("rootPath")},getWorkspaceFolder($e){return ft.getWorkspaceFolder($e)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name($e){throw new O.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile($e){throw new O.$9("workspaceFile")},updateWorkspaceFolders:($e,Ee,...Ue)=>ft.updateWorkspaceFolders(ze,$e,Ee||0,...Ue),onDidChangeWorkspaceFolders:function($e,Ee,Ue){return st(ft.onDidChangeWorkspace)($e,Ee,Ue)},asRelativePath:($e,Ee)=>ft.getRelativePath($e,Ee),findFiles:($e,Ee,Ue,ct)=>ft.findFiles($e,Ee,Ue,ze.identifier,ct),findFiles2:($e,Ee,Ue)=>((0,_e.$SF)(ze,"findFiles2"),ft.findFiles2($e,Ee,ze.identifier,Ue)),findTextInFiles:($e,Ee,Ue,ct)=>{(0,_e.$SF)(ze,"findTextInFiles");let wt,Tt;return typeof Ee=="object"?(wt=Ee,Tt=Ue):(wt={},Tt=Ee,ct=Ue),ft.findTextInFiles($e,wt||{},Tt,ze.identifier,ct)},save:$e=>ft.save($e),saveAs:$e=>ft.saveAs($e),saveAll:$e=>ft.saveAll($e),applyEdit($e,Ee){return di.applyWorkspaceEdit($e,ze,Ee)},createFileSystemWatcher:($e,Ee,Ue,ct)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ct,correlate:!1}:Ee&&((0,_e.$SF)(ze,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),ui.createFileSystemWatcher(ft,ze,$e,wt)},get textDocuments(){return Te.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw new O.$9("textDocuments")},openTextDocument($e){let Ee;const Ue=$e;if(typeof $e=="string")Ee=Promise.resolve(p.URI.file($e));else if(p.URI.isUri($e))Ee=Promise.resolve($e);else if(!Ue||typeof Ue=="object")Ee=Te.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ct=>(ct.scheme===R.Schemas.vscodeRemote&&!ct.authority&&At.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Te.ensureDocumentData(ct).then(wt=>wt.document)))},onDidOpenTextDocument:($e,Ee,Ue)=>st(Te.onDidAddDocument)($e,Ee,Ue),onDidCloseTextDocument:($e,Ee,Ue)=>st(Te.onDidRemoveDocument)($e,Ee,Ue),onDidChangeTextDocument:($e,Ee,Ue)=>st(Te.onDidChangeDocument)($e,Ee,Ue),onDidSaveTextDocument:($e,Ee,Ue)=>st(Te.onDidSaveDocument)($e,Ee,Ue),onWillSaveTextDocument:($e,Ee,Ue)=>st(te.getOnWillSaveTextDocumentEvent(ze))($e,Ee,Ue),get notebookDocuments(){return Oe.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Ee){let Ue;if(p.URI.isUri($e))Ue=$e,await Oe.openNotebookDocument($e);else if(typeof $e=="string")Ue=p.URI.revive(await Oe.createNotebookDocument({viewType:$e,content:Ee}));else throw new Error("Invalid arguments");return Oe.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument($e,Ee,Ue){return st(Be.onDidSaveNotebookDocument)($e,Ee,Ue)},onDidChangeNotebookDocument($e,Ee,Ue){return st(Be.onDidChangeNotebookDocument)($e,Ee,Ue)},onWillSaveNotebookDocument($e,Ee,Ue){return st(vt.getOnWillSaveNotebookDocumentEvent(ze))($e,Ee,Ue)},get onDidOpenNotebookDocument(){return st(Oe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(Oe.onDidCloseNotebookDocument)},registerNotebookSerializer($e,Ee,Ue,ct){return Oe.registerNotebookSerializer(ze,$e,Ee,Ue,(0,_e.$RF)(ze,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:($e,Ee,Ue)=>st(zi.onDidChangeConfiguration)($e,Ee,Ue),getConfiguration($e,Ee){return Ee=arguments.length===1?void 0:Ee,zi.getConfiguration($e,Ee,ze)},registerTextDocumentContentProvider($e,Ee){return De.registerTextDocumentContentProvider($e,Ee)},registerTaskProvider:($e,Ee)=>(At.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Xt.registerTaskProvider(ze,$e,Ee)),registerFileSystemProvider($e,Ee,Ue){return(0,A.$Qc)(Xi.registerFileSystemProvider(ze,$e,Ee,Ue),ii.addFileSystemProvider($e,Ee,Ue))},get fs(){return ii.value},registerFileSearchProvider:($e,Ee)=>((0,_e.$SF)(ze,"fileSearchProvider"),ci.registerFileSearchProvider($e,Ee)),registerTextSearchProvider:($e,Ee)=>((0,_e.$SF)(ze,"textSearchProvider"),ci.registerTextSearchProvider($e,Ee)),registerRemoteAuthorityResolver:($e,Ee)=>((0,_e.$SF)(ze,"resolvers"),Rt.registerRemoteAuthorityResolver($e,Ee)),registerResourceLabelFormatter:$e=>((0,_e.$SF)(ze,"resolvers"),Li.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,_e.$SF)(ze,"resolvers"),Rt.getRemoteExecServer($e)),onDidCreateFiles:($e,Ee,Ue)=>st(ui.onDidCreateFile)($e,Ee,Ue),onDidDeleteFiles:($e,Ee,Ue)=>st(ui.onDidDeleteFile)($e,Ee,Ue),onDidRenameFiles:($e,Ee,Ue)=>st(ui.onDidRenameFile)($e,Ee,Ue),onWillCreateFiles:($e,Ee,Ue)=>st(ui.getOnWillCreateFileEvent(ze))($e,Ee,Ue),onWillDeleteFiles:($e,Ee,Ue)=>st(ui.getOnWillDeleteFileEvent(ze))($e,Ee,Ue),onWillRenameFiles:($e,Ee,Ue)=>st(ui.getOnWillRenameFileEvent(ze))($e,Ee,Ue),openTunnel:$e=>((0,_e.$SF)(ze,"tunnels"),Nt.openTunnel(ze,$e).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,_e.$SF)(ze,"tunnels"),Nt.getTunnels()},onDidChangeTunnels:($e,Ee,Ue)=>((0,_e.$SF)(ze,"tunnels"),st(Nt.onDidChangeTunnels)($e,Ee,Ue)),registerPortAttributesProvider:($e,Ee)=>((0,_e.$SF)(ze,"portsAttributes"),Nt.registerPortsAttributesProvider($e,Ee)),registerTunnelProvider:($e,Ee)=>((0,_e.$SF)(ze,"tunnelFactory"),Nt.registerTunnelProvider($e,Ee)),registerTimelineProvider:($e,Ee)=>((0,_e.$SF)(ze,"timeline"),xi.registerTimelineProvider($e,Ee,ze.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:$e=>((0,_e.$SF)(ze,"workspaceTrust"),ft.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Ee,Ue)=>st(ft.onDidGrantWorkspaceTrust)($e,Ee,Ue),registerEditSessionIdentityProvider:($e,Ee)=>((0,_e.$SF)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider($e,Ee)),onWillCreateEditSessionIdentity:($e,Ee,Ue)=>((0,_e.$SF)(ze,"editSessionIdentityProvider"),st(ft.getOnWillCreateEditSessionIdentityEvent(ze))($e,Ee,Ue)),registerCanonicalUriProvider:($e,Ee)=>((0,_e.$SF)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider($e,Ee)),getCanonicalUri:($e,Ee,Ue)=>((0,_e.$SF)(ze,"canonicalUriProvider"),ft.provideCanonicalUri($e,Ee,Ue))},cn={get inputBox(){return At.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(ze)},createSourceControl($e,Ee,Ue){return yi.createSourceControl(ze,$e,Ee,Ue)}},bn={createCommentController($e,Ee){return hn.createCommentController(ze,$e,Ee)}},wn={get activeDebugSession(){return Ct.activeDebugSession},get activeDebugConsole(){return Ct.activeDebugConsole},get breakpoints(){return Ct.breakpoints},get stackFrameFocus(){return Ct.stackFrameFocus},registerDebugVisualizationProvider($e,Ee){return(0,_e.$SF)(ze,"debugVisualization"),Ct.registerDebugVisualizationProvider(ze,$e,Ee)},registerDebugVisualizationTreeProvider($e,Ee){return(0,_e.$SF)(ze,"debugVisualization"),Ct.registerDebugVisualizationTree(ze,$e,Ee)},onDidStartDebugSession($e,Ee,Ue){return st(Ct.onDidStartDebugSession)($e,Ee,Ue)},onDidTerminateDebugSession($e,Ee,Ue){return st(Ct.onDidTerminateDebugSession)($e,Ee,Ue)},onDidChangeActiveDebugSession($e,Ee,Ue){return st(Ct.onDidChangeActiveDebugSession)($e,Ee,Ue)},onDidReceiveDebugSessionCustomEvent($e,Ee,Ue){return st(Ct.onDidReceiveDebugSessionCustomEvent)($e,Ee,Ue)},onDidChangeBreakpoints($e,Ee,Ue){return st(Ct.onDidChangeBreakpoints)($e,Ee,Ue)},onDidChangeStackFrameFocus($e,Ee,Ue){return(0,_e.$SF)(ze,"debugFocus"),st(Ct.onDidChangeStackFrameFocus)($e,Ee,Ue)},registerDebugConfigurationProvider($e,Ee,Ue){return Ct.registerDebugConfigurationProvider($e,Ee,Ue||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Ee){return Ct.registerDebugAdapterDescriptorFactory(ze,$e,Ee)},registerDebugAdapterTrackerFactory($e,Ee){return Ct.registerDebugAdapterTrackerFactory($e,Ee)},startDebugging($e,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Ct.startDebugging($e,Ee,{parentSession:Ue}):Ct.startDebugging($e,Ee,Ue||{})},stopDebugging($e){return Ct.stopDebugging($e)},addBreakpoints($e){return Ct.addBreakpoints($e)},removeBreakpoints($e){return Ct.removeBreakpoints($e)},asDebugSourceUri($e,Ee){return Ct.asDebugSourceUri($e,Ee)}},un={registerTaskProvider:($e,Ee)=>Xt.registerTaskProvider(ze,$e,Ee),fetchTasks:$e=>Xt.fetchTasks($e),executeTask:$e=>Xt.executeTask(ze,$e),get taskExecutions(){return Xt.taskExecutions},onDidStartTask:($e,Ee,Ue)=>st(Xt.onDidStartTask)($e,Ee,Ue),onDidEndTask:($e,Ee,Ue)=>st(Xt.onDidEndTask)($e,Ee,Ue),onDidStartTaskProcess:($e,Ee,Ue)=>st(Xt.onDidStartTaskProcess)($e,Ee,Ue),onDidEndTaskProcess:($e,Ee,Ue)=>st(Xt.onDidEndTaskProcess)($e,Ee,Ue)},ln={createNotebookController($e,Ee,Ue,ct,wt){return Qe.createNotebookController(ze,$e,Ee,Ue,ct,(0,_e.$RF)(ze,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Ee)=>Oe.registerNotebookCellStatusBarItemProvider(ze,$e,Ee),createRendererMessaging($e){return at.createRendererMessaging(ze,$e)},createNotebookControllerDetectionTask($e){return(0,_e.$SF)(ze,"notebookKernelSource"),Qe.createNotebookControllerDetectionTask(ze,$e)},registerKernelSourceActionProvider($e,Ee){return(0,_e.$SF)(ze,"notebookKernelSource"),Qe.registerKernelSourceActionProvider(ze,$e,Ee)},onDidChangeNotebookCellExecutionState($e,Ee,Ue){return(0,_e.$SF)(ze,"notebookCellExecutionState"),st(Qe.onDidChangeNotebookCellExecutionState)($e,Ee,Ue)}},qi={t(...$e){if(typeof $e[0]=="string"){const Ee=$e.shift(),Ue=!$e||typeof $e[0]!="object"?$e:$e[0];return Kt.getMessage(ze.identifier.value,{message:Ee,args:Ue})}return Kt.getMessage(ze.identifier.value,$e[0])},get bundle(){return Kt.getBundle(ze.identifier.value)},get uri(){return Kt.getBundleUri(ze.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider($e,Ee){return(0,_e.$SF)(ze,"interactive"),fn.registerProvider(ze,$e,Ee)},registerInteractiveSessionProvider($e,Ee){return(0,_e.$SF)(ze,"interactive"),vi.registerChatProvider(ze,$e,Ee)},sendInteractiveRequestToProvider($e,Ee){return(0,_e.$SF)(ze,"interactive"),vi.sendInteractiveRequestToProvider($e,Ee)},transferChatSession($e,Ee){return(0,_e.$SF)(ze,"interactive"),vi.transferChatSession($e,Ee)}},Hi={getRelatedInformation($e,Ee){return(0,_e.$SF)(ze,"aiRelatedInformation"),Oi.getRelatedInformation(ze,$e,Ee)},registerRelatedInformationProvider($e,Ee){return(0,_e.$SF)(ze,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(ze,$e,Ee)},registerEmbeddingVectorProvider($e,Ee){return(0,_e.$SF)(ze,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(ze,$e,Ee)}},Pi={registerChatResponseProvider($e,Ee,Ue){return(0,_e.$SF)(ze,"chatProvider"),Di.registerLanguageModel(ze,$e,Ee,Ue)},registerVariable($e,Ee,Ue){return(0,_e.$SF)(ze,"chatAgents2"),gn.registerVariableResolver(ze,$e,Ee,Ue)},registerMappedEditsProvider($e,Ee){return(0,_e.$SF)(ze,"mappedEditsProvider"),ht.registerMappedEditsProvider(ze,$e,Ee)},createChatAgent($e,Ee){return(0,_e.$SF)(ze,"chatAgents2"),en.createChatAgent(ze,$e,Ee)}},Gi={requestLanguageModelAccess($e,Ee){return(0,_e.$SF)(ze,"languageModels"),Di.requestLanguageModelAccess(ze,$e,Ee)},get languageModels(){return(0,_e.$SF)(ze,"languageModels"),Di.getLanguageModelIds()},onDidChangeLanguageModels:($e,Ee,Ue)=>((0,_e.$SF)(ze,"languageModels"),Di.onDidChangeProviders($e,Ee,Ue))},Ki={registerSpeechProvider($e,Ee){return(0,_e.$SF)(ze,"speech"),Ti.registerProvider(ze.identifier,$e,Ee)}};return{version:$t.version,ai:Hi,authentication:mn,commands:sn,comments:bn,chat:Pi,debug:wn,env:Ui,extensions:on,interactive:Vi,l10n:qi,languages:Bi,lm:Gi,notebooks:ln,scm:cn,speech:Ki,tasks:un,tests:$n,window:an,workspace:Wi,Breakpoint:je.$WM,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatVariableLevel:je.ChatVariableLevel,ChatAgentCompletionItem:je.$PN,CallHierarchyIncomingCall:je.$jM,CallHierarchyItem:je.$iM,CallHierarchyOutgoingCall:je.$kM,CancellationError:O.$5,CancellationTokenSource:I.$ae,CandidatePortSource:n.CandidatePortSource,CodeAction:je.$fM,CodeActionKind:je.$gM,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$lM,Color:je.$yM,ColorInformation:je.$zM,ColorPresentation:je.$AM,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$sM,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$tM,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$IM,DebugAdapterExecutable:je.$1M,DebugAdapterInlineImplementation:je.$4M,DebugAdapterNamedPipeServer:je.$3M,DebugAdapterServer:je.$2M,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DebugVisualization:je.$hN,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$_L,DiagnosticRelatedInformation:je.$$L,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$XL,DocumentHighlight:je.$bM,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$cM,DocumentLink:je.$xM,DocumentSymbol:je.$eM,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$7M,InlineValueText:je.$8M,InlineValueVariableLookup:je.$9M,InlineValueEvaluatableExpression:je.$0M,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:$.$3d,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$jN,FileDecoration2:je.$jN,FileSystemError:je.$aN,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:je.$bN,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$YM,InlineCompletionItem:je.$uM,InlineCompletionList:je.$vM,Hover:je.$aM,IndentAction:C.IndentAction,Location:je.$0L,MarkdownString:je.$mM,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:je.$nM,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$YL,ProcessExecution:je.$GM,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$iN,Range:je.$ZL,RelativePattern:je.$UM,Selection:je.$1L,SelectionRange:je.$hM,SemanticTokens:je.$eN,SemanticTokensBuilder:je.$dN,SemanticTokensEdit:je.$fN,SemanticTokensEdits:je.$gN,SemanticTokensLegend:je.$cN,ShellExecution:je.$HM,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$pM,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$oM,SnippetString:je.$9L,SourceBreakpoint:je.$XM,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$dM,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$JM,TaskGroup:je.$FM,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$BM,TerminalQuickFixTerminalCommand:je.$DM,TerminalQuickFixOpener:je.$CM,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$EM,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$5L,SnippetTextEdit:je.$7L,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$TM,ThemeIcon:je.$SM,TreeItem:je.$KM,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$EN,UIKind:_t.UIKind,Uri:p.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$8L,DocumentDropEdit:je.$QM,DocumentPasteEdit:je.$RM,InlayHint:je.$rM,InlayHintLabelPart:je.$qM,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$4L,ResolvedAuthority:je.$2L,ManagedResolvedAuthority:je.$3L,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$tN,NotebookRange:je.$lN,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$mN,NotebookData:je.$nN,NotebookRendererScript:je.$rN,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$pN,NotebookCellOutputItem:je.$oN,NotebookCellStatusBarItem:je.$qN,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$6L,NotebookKernelSourceAction:je.$sN,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$vN,LinkedEditingRanges:je.$uN,TestResultState:je.TestResultState,TestRunRequest:je.$wN,TestMessage:je.$xN,TestTag:je.$yN,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:qt.TextSearchCompleteMessageType,DataTransfer:je.$PM,DataTransferItem:je.$LM,CoveredCount:je.$zN,FileCoverage:je.$AN,StatementCoverage:je.$BN,BranchCoverage:je.$CN,DeclarationCoverage:je.$DN,FunctionCoverage:je.$DN,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$FN,TabInputTextDiff:je.$GN,TabInputTextMerge:je.$HN,TabInputCustom:je.$IN,TabInputNotebook:je.$KN,TabInputNotebookDiff:je.$LN,TabInputWebview:je.$JN,TabInputTerminal:je.$MN,TabInputInteractiveWindow:je.$NN,TabInputChat:je.$ON,TelemetryTrustedValue:o.$Uo,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,ChatAgentCopyKind:je.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$5M,ThreadFocus:je.$6M,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus,KeywordRecognitionStatus:je.KeywordRecognitionStatus,ChatResponseTextPart:je.$QN,ChatResponseMarkdownPart:je.$RN,ChatResponseFileTreePart:je.$SN,ChatResponseAnchorPart:je.$TN,ChatResponseProgressPart:je.$UN,ChatResponseReferencePart:je.$WN,ChatResponseCommandButtonPart:je.$VN,ChatAgentRequestTurn:je.$XN,ChatAgentResponseTurn:je.$YN,LanguageModelSystemMessage:je.$ZN,LanguageModelUserMessage:je.$1N,LanguageModelAssistantMessage:je.$2N,NewSymbolName:je.$_M,NewSymbolNameTag:je.NewSymbolNameTag}}}e.$$ic=ti}),define(Ce[373],Ie([1,0,84,153,41,148,42,33,73,46,95,96,97,117,71,91,147,70,59,116,90,72,146,13,60,114,115]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$8r)(s.$Zhc,s.$Yhc,1),(0,I.$8r)(d.$xj,t.$_ic,1),(0,I.$8r)(u.$6gc,u.$7gc,1),(0,I.$8r)(v.$wO,v.$vO,0),(0,I.$8r)(R.$thc,R.$rhc,0),(0,I.$8r)(o.$vhc,o.$uhc,0),(0,I.$8r)(C.$0hc,C.$bic,0),(0,I.$8r)(A.$dic,A.$cic,0),(0,I.$8r)(p.$lO,p.$kO,0),(0,I.$8r)(l.$1hc,l.$2hc,0),(0,I.$8r)(i.$0gc,i.$9gc,0),(0,I.$8r)(O.$Jic,O.$Iic,1),(0,I.$8r)(w.$tic,w.$uic,0),(0,I.$8r)(E.$Ohc,E.$Nhc,0),(0,I.$8r)(L.$Wic,L.$Vic,0),(0,I.$8r)(S.$Rhc,S.$Uhc,0),(0,I.$8r)(k.$Rzb,k.$Szb,0),(0,I.$8r)(m.$0ic,m.$9ic,0),(0,I.$8r)($.$qhc,$.$phc,0),(0,I.$8r)(n.$Whc,n.$Vhc,0),(0,I.$8r)(r.$uO,r.$rO,0),(0,I.$8r)(a.$Fhc,a.$Ghc,0),(0,I.$8r)(c.$8hc,c.$9hc,0)}),define(Ce[119],Ie([1,0,19,13,36,94]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=e.$pjc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$pjc=R;function v(C,w,E,k){const u=(0,I.$2b)(E,p),m=new $.$jK(w,u,k),o=m.preview.matches;return{ranges:(0,I.$2b)(u,S),uri:C,preview:{text:m.preview.text,matches:(0,I.$2b)(o,S)}}}e.$qjc=v;function p(C){return new $.$kK(C.start.line,C.start.character,C.end.line,C.end.character)}function S(C){return new A.$$J(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let L=class{constructor(w,E){this.a=w,this.b=E}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$rjc=L,e.$rjc=L=Ke([We(1,O.$wj)],L)}),define(Ce[374],Ie([1,0,50,17,77,34,11,12,119,375]),function(me,e,I,O,$,A,R,v,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=e.$sjc=void 0;const L=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,r,a,t){const d=w(n,r,a,t),c=r.folder.fsPath;return{cmd:I.spawn(L,d.args,{cwd:c}),rgDiskPath:L,siblingClauses:d.siblingClauses,rgArgs:d,cwd:c}}e.$sjc=C;function w(n,r,a,t){const d=["--files","--hidden","--case-sensitive","--no-require-git"];k([r],a,!1).forEach(s=>{const l=(0,p.$pjc)(s);if(d.push("-g",l),R.$j){const h=(0,$.$Ql)(l);h!==l&&d.push("-g",h)}});const c=E([r],t,void 0,!1);return c.globArgs.forEach(s=>{const l=`!${(0,p.$pjc)(s)}`;if(d.push("-g",l),R.$j){const h=(0,$.$Ql)(l);h!==l&&d.push("-g",h)}}),r.disregardIgnoreFiles!==!1?d.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&d.push("--no-ignore-parent"),r.ignoreSymlinks||d.push("--follow"),n.exists&&d.push("--quiet"),d.push("--no-config"),r.disregardGlobalIgnoreFiles&&d.push("--no-ignore-global"),{args:d,siblingClauses:c.siblingClauses}}function E(n,r,a,t=!0){const d=[];let c={};return n.forEach(s=>{const l=Object.assign({},s.excludePattern||{},r||{}),h=u(l,t?s.folder.fsPath:void 0,a);d.push(...h.globArgs),h.siblingClauses&&(c=Object.assign(c,h.siblingClauses))}),{globArgs:d,siblingClauses:c}}function k(n,r,a=!0){const t=[];return n.forEach(d=>{const c=Object.assign({},r||{},d.includePattern||{}),s=u(c,a?d.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function u(n,r,a){const t=[],d={};return Object.keys(n).forEach(c=>{if(a&&a.has(c)||!c)return;const s=n[c];c=o(r?m(r,c):c),c.startsWith("\\\\")?c="\\\\"+c.substr(2).replace(/\\/g,"/"):c=c.replace(/\\/g,"/"),typeof s=="boolean"&&s?(c.startsWith("\\\\")&&(c+="**"),t.push(i(c))):s&&s.when&&(d[c]=s)}),{globArgs:t,siblingClauses:d}}function m(n,r){return O.$ic(r)?r:O.$jc(n,r)}e.$tjc=m;function o(n){return n=v.$2e(n,"\\"),v.$2e(n,"/")}function i(n){return A.$_f(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$ujc=i}),define(Ce[376],Ie([1,0,50,57,17,377,19,44,35,77,34,11,38,12,18,31,36,374,129]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(c=>c())});class r{constructor(s){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=s,this.b=s.filePattern||"",this.d=s.includePattern&&p.$Vj(s.includePattern),this.f=s.maxResults||null,this.g=!!s.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=s.shouldGlobMatchFilePattern?null:(0,i.$9q)(this.b).normalizedLowercase),this.u=s.excludePattern&&p.$Vj(s.excludePattern),this.t=new Map,s.folderQueries.forEach(l=>{const h=Object.assign({},l.excludePattern||{},this.a.excludePattern||{}),b=l.folder.fsPath;s.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==b).forEach(D=>{(0,L.$dg)(D,b)&&(h[$.$lc(b,D)]=!0)}),this.t.set(b,new t(h,b))})}cancel(){this.l=!0,n.forEach(s=>s())}walk(s,l,h,b,D){if(this.m=w.$Yd.create(!1),this.l)return D(null,this.j);l.forEach(g=>{const f=$.$nc(g.fsPath);this.u&&this.u(g.fsPath,f)||this.J(h,{relativePath:g.fsPath,searchPath:void 0})}),this.r=w.$Yd.create(!1),this.w(s,(g,f)=>{this.x(this.y,this,g,h,b,y=>{if(y){const P=(0,v.$Zi)(y);console.error(P),this.q.push(P),f(y,void 0)}else f(null,void 0)})},(g,f)=>{this.m.stop();const y=g?R.$Hb(g)[0]:null;D(y,this.j)})}w(s,l,h){const b=new Array(s.length),D=new Array(s.length);let g=!1,f=0;if(s.length===0)return h(null,[]);s.forEach((y,P)=>{l(y,(N,U)=>{if(N?(g=!0,b[P]=null,D[P]=N):(b[P]=U,D[P]=null),++f===s.length)return h(g?D:null,b)})})}x(s,l,...h){try{s.apply(l,h)}catch(b){h[h.length-1](b)}}y(s,l,h,b){const D=s.folder.fsPath,g=C.$j,f=()=>z&&z.kill();n.add(f);let y=j=>{n.delete(f),y=()=>{},b(j)},P="";const N=this.D(),U=(0,o.$sjc)(this.a,s,this.a.includePattern,this.t.get(s.folder.fsPath).expression),z=U.cmd,F=!Object.keys(U.siblingClauses).length,M=U.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let T=`${U.rgDiskPath} ${M}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),h({message:T}),this.s=0,this.z(z,"utf8",h,(j,J,ne)=>{if(j){y(j);return}if(this.j){y();return}const Z=(P+(g?S.$Pl(J||""):J)).split(`
`);if(ne){const Y=Z.length;Z[Y-1]=Z[Y-1].trim(),Z[Y-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Z.length,F){for(const Y of Z)if(this.J(l,{base:D,relativePath:Y,searchPath:this.N(s,Y)}),this.j){f();break}(ne||this.j)&&y();return}this.G(s,N,D,Z,l),ne&&(this.H(N,D,l),y())})}spawnFindCmd(s){const l=this.t.get(s.folder.fsPath),h=l.getBasenameTerms(),b=l.getPathTerms(),D=["-L","."];if(h.length||b.length){D.push("-not","(","(");for(const g of h)D.push("-name",g),D.push("-o");for(const g of b)D.push("-path",g),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),I.spawn("find",D,{cwd:s.folder.fsPath})}readStdout(s,l,h){let b="";this.z(s,l,()=>{},(D,g,f)=>{if(D){h(D);return}b+=g,f&&h(null,b)})}z(s,l,h,b){let D=(y,P,N)=>{(y||N)&&(D=()=>{},this.r?.stop()),b(y,P,N)},g=!1;s.stdout?(this.A(s.stdout,l,D),s.stdout.once("data",()=>g=!0)):h({message:"stdout is null"});let f;s.stderr?f=this.B(s.stderr):h({message:"stderr is null"}),s.on("error",y=>{D(y)}),s.on("close",y=>{let P;!g&&(P=this.C(f,l))&&d(P)?D(new Error(`command failed with error code ${y}: ${this.C(f,l)}`)):(this.g&&y===0&&(this.j=!0),D(null,"",!0))})}A(s,l,h){const b=new A.StringDecoder(l);return s.on("data",D=>{h(null,b.write(D))}),b}B(s){const l=[];return s.on("data",h=>{l.push(h)}),l}C(s,l){const h=new A.StringDecoder(l);return s.map(b=>h.write(b)).join("")}D(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}G(s,{pathToEntries:l},h,b,D){b.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(s,this.b)});const g=f=>{const y=$.$nc(f),P=$.$mc(f);let N=l[P];N||(N=l[P]=[],g(P)),N.push({base:h,relativePath:f,basename:y,searchPath:this.N(s,f)})};b.forEach(g)}H({rootEntries:s,pathToEntries:l},h,b){const D=this,g=this.t.get(h),f=this.b;function y(P){D.o++;const N=(0,m.$zK)(()=>P.map(U=>U.basename));for(let U=0,z=P.length;U<z;U++){const F=P[U],{relativePath:M,basename:T}=F;if(g.test(M,T,f!==T?N:void 0))continue;const j=l[M];if(j)y(j);else{if(D.p++,M===f)continue;D.J(b,F)}if(D.j)break}}y(s)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(s,l,h,b,D){const g=s.folder,f=(0,m.$zK)(()=>h);this.w(h,(y,P)=>{if(this.l||this.j)return P(null);const N=l?[l,y].join($.sep):y;if(this.t.get(s.folder.fsPath).test(N,y,this.a.filePattern!==y?f:void 0))return P(null);const U=[g.fsPath,N].join($.sep);O.lstat(U,(z,F)=>{if(z||this.l||this.j)return P(null);this.L(U,F,(M,T)=>M||this.l||this.j?P(null):T.isDirectory()?(this.o++,this.M(U,F,(j,J)=>j||this.l||this.j||(J=J||"",this.v[J])?P(null):(this.v[J]=!0,u.Promises.readdir(U).then(ne=>{if(this.l||this.j)return P(null);this.I(s,N,ne,b,_=>P(_||null))},ne=>{P(null)})))):(this.p++,N===this.b||this.h&&k.$Uf(T.size)&&T.size>this.h||this.J(b,{base:g.fsPath,relativePath:N,searchPath:this.N(s,N)}),P(null,void 0)))})},y=>{const P=y&&R.$Hb(y);return D(P&&P.length>0?P[0]:void 0)})}J(s,l){this.K(l)&&(!this.d||this.d(l.relativePath,$.$nc(l.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||s(l))}K(s){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$uK)(s,this.c);if(this.b)return(0,m.$uK)(s,this.b,!1)}return!0}L(s,l,h){return l.isSymbolicLink()?O.stat(s,h):h(null,l)}M(s,l,h){return l.isSymbolicLink()?O.realpath(s,(b,D)=>b?h(b):h(null,D)):h(null,s)}N(s,l){return s.folderName?$.$jc(s.folderName,l):l}}e.$vjc=r;class a{constructor(s){this.a=s.folderQueries,this.b=s.extraFileResources||[],this.c=new r(s)}search(s,l,h){this.c.walk(this.a,this.b,s,l,(b,D)=>{h(b,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$wjc=a;class t{constructor(s,l){this.expression=s,this.c=l,this.d(s)}d(s){let l,h;Object.keys(s).filter(b=>s[b]).forEach(b=>{$.$ic(b)?(l=l||p.$Qj(),l[b]=s[b]):(h=h||p.$Qj(),h[b]=s[b])}),this.a=l&&p.$Vj(l,{trimForExclusions:!0}),this.b=h&&p.$Vj(h,{trimForExclusions:!0})}test(s,l,h){return this.b&&this.b(s,l,h)||this.a&&this.a($.$jc(this.c,s),l,h)}getBasenameTerms(){const s=[];return this.a&&s.push(...p.$Xj(this.a)),this.b&&s.push(...p.$Xj(this.b)),s}getPathTerms(){const s=[];return this.a&&s.push(...p.$Yj(this.a)),this.b&&s.push(...p.$Yj(this.b)),s}}function d(c){const s=c.trim().split(`
`),l=s[0].trim();if(l.startsWith("Error parsing regex"))return l;if(l.startsWith("regex parse error"))return E.$If(s[s.length-1].trim());if(l.startsWith("error parsing glob")||l.startsWith("unsupported encoding"))return l.charAt(0).toUpperCase()+l.substr(1);if(l==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(l.startsWith("Literal "))return l}}),define(Ce[378],Ie([1,0,98,21,187,22]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HD=e.$GD=e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.DecodeStreamErrorKind=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=void 0,e.$rD="utf8",e.$sD="utf8bom",e.$tD="utf16be",e.$uD="utf16le";function R(l){return[e.$rD,e.$sD,e.$tD,e.$uD].some(h=>h===l)}e.$vD=R,e.$wD=[254,255],e.$xD=[255,254],e.$yD=[239,187,191];const v=512,p=512,S=512*8,L=512*128;var C;(function(l){l[l.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class w extends Error{constructor(h,b){super(h),this.decodeStreamErrorKind=b}}e.$zD=w;class E{static async create(h){let b;if(h!==e.$rD)b=(await(0,$.$qD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;b={write(g){return D.decode(g,{stream:!0})},end(){return D.decode()}}}return new E(b)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function k(l,h){const b=h.minBytesRequiredForDetection??h.guessEncoding?S:p;return new Promise((D,g)=>{const f=(0,I.$ee)(F=>F.join("")),y=[];let P=0,N;const U=new A.$ae,z=async()=>{try{const F=await s({buffer:O.$qe.concat(y),bytesRead:P},h.guessEncoding);if(F.seemsBinary&&h.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);F.encoding=await h.overwriteEncoding(F.encoding),N=await E.create(F.encoding);const M=N.write(O.$qe.concat(y).buffer);f.write(M),y.length=0,P=0,D({stream:f,detected:F})}catch(F){U.cancel(),f.destroy(),g(F)}};(0,I.$ie)(l,{onData:async F=>{N?f.write(N.write(F.buffer)):(y.push(F),P+=F.byteLength,P>=b&&(l.pause(),await z(),setTimeout(()=>l.resume())))},onError:F=>f.error(F),onEnd:async()=>{N||await z(),f.end(N?.end())}},U.token)})}e.$AD=k;async function u(l,h,b){const g=(await(0,$.$qD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),b);let f=!1,y=!1;return{read(){if(y)return null;const P=l.read();if(typeof P!="string"){if(y=!0,!f&&b?.addBOM)switch(h){case e.$rD:case e.$sD:return O.$qe.wrap(Uint8Array.from(e.$yD));case e.$tD:return O.$qe.wrap(Uint8Array.from(e.$wD));case e.$uD:return O.$qe.wrap(Uint8Array.from(e.$xD))}const N=g.end();return N&&N.length>0?(f=!0,O.$qe.wrap(N)):null}return f=!0,O.$qe.wrap(g.write(P))}}}e.$BD=u;async function m(l){return(await(0,$.$qD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(l))}e.$CD=m;function o(l){return l===e.$sD||l===null?e.$rD:l}e.$DD=o;function i(l,h){if(!l||h<e.$wD.length)return null;const b=l.readUInt8(0),D=l.readUInt8(1);if(b===e.$wD[0]&&D===e.$wD[1])return e.$tD;if(b===e.$xD[0]&&D===e.$xD[1])return e.$uD;if(h<e.$yD.length)return null;const g=l.readUInt8(2);return b===e.$yD[0]&&D===e.$yD[1]&&g===e.$yD[2]?e.$sD:null}e.$ED=i;const n=["ascii","utf-16","utf-32"];async function r(l){const h=await(0,$.$qD)("jschardet","dist/jschardet.min.js"),b=l.slice(0,L),D=d(b.buffer),g=h.detect(D);if(!g||!g.encoding)return null;const f=g.encoding.toLowerCase();return 0<=n.indexOf(f)?null:t(g.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(l){const h=l.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function d(l){let h="";for(let b=0;b<l.length;b++)h+=String.fromCharCode(l[b]);return h}function c(l){switch(l){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=l.match(/windows(\d+)/);return h?"windows-"+h[1]:l}}}e.$FD=c;function s({buffer:l,bytesRead:h},b){let D=i(l,h),g=!1;if(D!==e.$tD&&D!==e.$uD&&l){let f=!0,y=!0,P=!1;for(let N=0;N<h&&N<v;N++){const U=N%2===1,z=l.readUInt8(N)===0;if(z&&(P=!0),f&&(U&&!z||!U&&z)&&(f=!1),y&&(U&&z||!U&&!z)&&(y=!1),z&&!f&&!y)break}P&&(f?D=e.$uD:y?D=e.$tD:g=!0)}return b&&!g&&!D&&l?r(l.slice(0,h)).then(f=>({seemsBinary:!1,encoding:f})):{seemsBinary:g,encoding:D}}e.$GD=s,e.$HD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[156],Ie([1,0,378,31,155]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ejc=void 0;class A extends $.$pic{constructor(v,p,S=O,L="searchProcess"){super(v,p,{readdir:C=>S.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,I.$FD)(C)},L)}}e.$Ejc=A}),define(Ce[157],Ie([1,0,50,394,377,19,74,35,12,2,36,94,395,375,119]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=e.$Bjc=e.$Ajc=e.$zjc=e.$yjc=e.$xjc=void 0;const u=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(f){this.a=f}provideTextSearchResults(f,y,P,N){return this.a.appendLine(`provideTextSearchResults ${f.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((U,z)=>{N.onCancellationRequested(()=>Z());const F=t(f,y),M=y.folder.fsPath,T=F.map(re=>re.match(/^-/)?re:`'${re}'`).join(" ");this.a.appendLine(`${u} ${T}
 - cwd: ${M}`);let j=I.spawn(u,F,{cwd:M});j.on("error",re=>{console.error(re),this.a.appendLine("Error: "+(re&&re.message)),z((0,L.$qK)(new L.$oK(re&&re.message,L.SearchErrorCode.rgProcessError)))});let J=!1;const ne=new n(y.maxResults,y.folder,y.previewOptions);ne.on("result",re=>{J=!0,ce="",P.report(re)});let _=!1;const Z=()=>{_=!0,j?.kill(),ne?.cancel()};let Y=!1;ne.on("hitLimit",()=>{Y=!0,Z()});let ce="";j.stdout.on("data",re=>{ne.handleData(re),J||(ce+=re)});let ie=!1;j.stdout.once("data",()=>ie=!0);let fe="";j.stderr.on("data",re=>{const K=re.toString();this.a.appendLine(K),fe.length+K.length<1e6&&(fe+=K)}),j.on("close",()=>{if(this.a.appendLine(ie?"Got data from stdout":"No data from stdout"),this.a.appendLine(J?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),_)U({limitHit:Y});else{ne.flush(),j=null;let re;fe&&!ie&&(re=o(fe))?z((0,L.$qK)(new L.$oK(re.message,re.code))):U({limitHit:Y})}})})}}e.$xjc=m;function o(g){const f=g.split(`
`),y=f[0].trim();if(f.some(N=>N.startsWith("regex parse error")))return new L.$oK(i(f),L.SearchErrorCode.regexParseError);const P=y.match(/grep config error: unknown encoding: (.*)/);if(P)return new L.$oK(`Unknown encoding: ${P[1]}`,L.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new L.$oK(y.charAt(0).toUpperCase()+y.substr(1),L.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new L.$oK(y.charAt(0).toUpperCase()+y.substr(1),L.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new L.$oK(y,L.SearchErrorCode.regexParseError)}function i(g){const f=["Regex parse error"],y=g.filter(P=>P.startsWith("PCRE2:"));if(y.length>=1){const P=y[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const N=P.split(":")[1];f.push(":"+N)}}return f.join("")}class n extends O.EventEmitter{constructor(f,y,P){super(),this.g=f,this.h=y,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new $.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(f,y){return super.on(f,y),this}handleData(f){if(this.b)return;const y=typeof f=="string"?f:this.d.write(f);this.k(y)}k(f){let y=f.indexOf(`
`);const P=this.a+f;if(y>=0)y+=this.a.length;else{this.a=P;return}let N=0;for(;y>=0;)this.m(P.substring(N,y).trim()),N=y+1,y=P.indexOf(`
`,N);this.a=P.substring(N)}m(f){if(this.b||!f)return;let y;try{y=JSON.parse(f)}catch{throw new Error(`malformed line from rg: ${f}`)}if(y.type==="match"){const P=r(y.data.path),N=S.URI.joinPath(this.h,P),U=this.n(y.data,N);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const P=r(y.data.path),N=S.URI.joinPath(this.h,P);this.o(y.data,N).forEach(z=>this.p(z))}}n(f,y){const P=f.line_number-1,N=r(f.lines),U=Buffer.from(N);let z=0,F=0,M=P;f.submatches.length===0&&f.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const T=(0,A.$Hb)(f.submatches.map((j,J)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ne=r(j.match),_=U.slice(z,j.start).toString(),Z=a(_),Y=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+F,ce=a(ne),ie=Z.numLines+M,fe=ce.numLines+ie,re=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+Y;return z=j.end,F=re,M=fe,new C.$$J(ie,Y,fe,re)}));return(0,k.$qjc)(y,N,T,this.j)}o(f,y){const P=r(f.lines),N=f.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:y,lineNumber:N+z}))}p(f){this.emit("result",f)}}e.$yjc=n;function r(g){return g.bytes?Buffer.from(g.bytes,"base64").toString():g.text}function a(g){const f=/\n/g;let y=0,P=-1,N;for(;N=f.exec(g);)y++,P=N.index;const U=P>=0?g.length-P-1:g.length;return{numLines:y,lastLineLength:U}}function t(g,f){const y=["--hidden","--no-require-git"];y.push(g.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:N}=(0,R.$K)(f.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const z=new Set;N.forEach(F=>{z.add(F)}),y.push("-g","!*"),z.forEach(F=>{d(F).map(k.$pjc).forEach(M=>{y.push("-g",M)})})}P&&P.length&&P.forEach(z=>{y.push("-g",z)}),f.excludes.map(k.$pjc).forEach(z=>y.push("-g",`!${z}`)),f.maxFileSize&&y.push("--max-filesize",f.maxFileSize+""),f.useIgnoreFiles?f.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),f.followSymlinks&&y.push("--follow"),f.encoding&&f.encoding!=="utf8"&&y.push("--encoding",f.encoding),g.pattern==="--"&&(g.isRegExp=!0,g.pattern="\\-\\-"),g.isMultiline&&!g.isRegExp&&(g.pattern=(0,p.$Ve)(g.pattern),g.isRegExp=!0),f.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),g.isRegExp&&(g.pattern=c(g.pattern),y.push("--engine","auto"));let U;if(g.isWordMatch){const F=(0,p.$5e)(g.pattern,!!g.isRegExp,{wholeWord:g.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",F)}else if(g.isRegExp){let z=l(g.pattern);z=h(z),y.push("--regexp",z)}else U=g.pattern,y.push("--fixed-strings");return y.push("--no-config"),f.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),g.isMultiline&&y.push("--multiline"),f.beforeContext&&y.push("--before-context",f.beforeContext+""),f.afterContext&&y.push("--after-context",f.afterContext+""),y.push("--"),U&&y.push(U),y.push("."),y}e.$zjc=t;function d(g){return D(g).flatMap(y=>{const P=(0,v.$Tj)(y,"/");return P.map((N,U)=>P.slice(0,U+1).join("/"))})}function c(g){const f=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;g.match(f);)g=g.replace(f,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;g.match(y);)g=g.replace(y,"$1\\x{$2}");return g}e.$Ajc=c;const s=g=>g.type==="Assertion"&&g.kind==="lookbehind";function l(g){let f;try{f=new w.RegExpParser().parsePattern(g)}catch{return g}let y="",P=0;const N=(F,M,T)=>{y+=g.slice(P,F)+T,P=M},U=[];return new w.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const M=U[0];if(!M)N(F.start,F.end,"\\r?\\n");else if(!U.some(s))if(M.type==="CharacterClass")if(M.negate){const T=g.slice(M.start+2,F.start)+g.slice(F.end,M.end-1);M.parent?.type==="Quantifier"?N(M.start,M.end,T?`[^${T}]`:"."):N(M.start,M.end,"(?!\\r?\\n"+(T?`|[${T}]`:"")+")")}else{const T=g.slice(M.start+1,F.start)+g.slice(F.end,M.end-1);N(M.start,M.end,T===""?"\\r?\\n":`(?:[${T}]|\\r?\\n)`)}else M.type==="Quantifier"&&N(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){U.unshift(F)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(F){U.unshift(F)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(F){U.unshift(F)},onCharacterClassLeave(){U.shift()},onAssertionEnter(F){s(F)&&U.push(F)},onAssertionLeave(F){U[0]===F&&U.shift()}}).visit(f),y+=g.slice(P),y}e.$Bjc=l;function h(g){return g.replace(/\n/g,"\\r?\\n")}e.$Cjc=h;function b(g){let f=!1,y=!1,P="",N="";for(let U=0;U<g.length;U++){const z=g[U];switch(z){case"\\":y?(f?N+="\\"+z:P+="\\"+z,y=!1):y=!0;break;case"{":if(y)f?N+=z:P+=z,y=!1;else{if(f)return{strInBraces:P+"{"+N+"{"+g.substring(U+1)};f=!0}break;case"}":if(y)f?N+=z:P+=z,y=!1;else{if(f)return{fixedStart:P,strInBraces:N,fixedEnd:g.substring(U+1)};P+=z}break;default:f?N+=(y?"\\":"")+z:P+=(y?"\\":"")+z,y=!1;break}}return{strInBraces:P+(f?"{"+N:"")}}function D(g){const{fixedStart:f,strInBraces:y,fixedEnd:P}=b(g);if(f===void 0||P===void 0)return[y];let N=(0,v.$Tj)(y,",");N.length||(N=[""]);const U=D(P);return N.flatMap(z=>{const F=f+z;return U.map(M=>F+M)})}e.$Djc=D}),define(Ce[379],Ie([1,0,22,157,107,16]),function(me,e,I,O,$,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class R{constructor(S){this.b=S,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(S,L,C,w){const E=new O.$xjc(this.b);if(L.folder.scheme===A.Schemas.vscodeUserData){const k={...L,folder:L.folder.with({scheme:A.Schemas.file})},u=new $.$Ev(m=>C.report({...m,uri:m.uri.with({scheme:L.folder.scheme})}));return this.c(w,m=>E.provideTextSearchResults(S,k,u,m))}else return this.c(w,k=>E.provideTextSearchResults(S,L,C,k))}async c(S,L){const C=v(S);this.a.add(C);const w=await L(C.token);return this.a.delete(C),w}d(){this.a.forEach(S=>S.cancel())}}e.$Hjc=R;function v(p){const S=new I.$ae;return p.onCancellationRequested(()=>S.cancel()),S}}),define(Ce[380],Ie([1,0,31,157,156]),function(me,e,I,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=void 0;class A{constructor(p){this.a=p}search(p,S,L){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(E){L({message:E})}},w=new $.$Ejc(this.a,new O.$xjc(C),I);return new Promise((E,k)=>w.search(u=>{S(u.map(R))},p).then(u=>E({limitHit:u.limitHit,type:"success",stats:u.stats}),k))}}e.$Fjc=A;function R(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce((p,S)=>{if(S.ranges){const L=S;return p+(Array.isArray(L.ranges)?L.ranges.length:1)}else return p+1},0)}}}),define(Ce[381],Ie([1,0,19,8,14,4,129,17,38,2,32,36,376,380]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class k{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=o(r),d=new A.$3d({onDidAddFirstListener:()=>{a=(0,O.$2g)(c=>this.doFileSearchWithEngine(w.$wjc,t,s=>d.fire(s),c)),a.then(c=>d.fire(c),c=>d.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}textSearch(r){let a;const t=o(r),d=new A.$3d({onDidAddFirstListener:()=>{a=(0,O.$2g)(c=>this.f(t,s=>d.fire(s),c)),a.then(c=>d.fire(c),c=>d.fire({type:"error",error:{message:c.message,stack:c.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return d.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new E.$Fjc(r).search(t,a,a)}g(){return{maxFileSize:16*L.$8k.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine(w.$wjc,r,a,t)}doFileSearchWithEngine(r,a,t,d,c=k.a){let s=0;const l=b=>{Array.isArray(b)?(s+=b.length,t(b.map(D=>this.h(D)))):b.relativePath?(s++,t(this.h(b))):t(b)};if(a.sortByScore){let b=this.l(a,l,d);if(!b){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,g=new r(D);b=this.j(g,a,t,l,d)}return new Promise((D,g)=>{b.then(([f,y])=>{const P=y.map(N=>this.h(N));this.o(P,t,c),D(f)},g)})}const h=new r(a);return this.r(h,l,c,d).then(b=>({limitHit:b.limitHit,type:"success",stats:{detailStats:b.stats,type:this.d,fromCache:!1,resultCount:s,sortingTime:void 0}}))}h(r){return{path:r.base?(0,v.$jc)(r.base,r.relativePath):r.relativePath}}j(r,a,t,d,c){const s=new A.$3d;let l=(0,O.$2g)(b=>{let D=[];const g=f=>{Array.isArray(f)?D=f:(d(f),s.fire(f))};return this.r(r,g,-1,b).then(f=>[f,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const b={promise:l,event:s.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=b,l.then(()=>{b.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),l=this.s(l)}return l.then(([b,D])=>{const g=h?h.scorerCache:Object.create(null),f=(typeof a.maxResults!="number"||a.maxResults>0)&&p.$Yd.create(!1);return this.n(a,D,g,c).then(y=>{const P=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:b.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:y.length},messages:b.messages,limitHit:b.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},y]})})}k(r){const a=this.b[r];return a||(this.b[r]=new u)}l(r,a,t){const d=r.cacheKey&&this.b[r.cacheKey];if(!d)return;const c=this.q(d,r.filePattern||"",a,t);if(c)return c.then(([s,l,h])=>{const b=p.$Yd.create(!1);return this.n(r,l,d.scorerCache,t).then(D=>{const g=b.elapsed(),f={fromCache:!0,detailStats:h,type:this.d,resultCount:l.length,sortingTime:g};return[{type:"success",limitHit:s.limitHit||typeof r.maxResults=="number"&&l.length>r.maxResults,stats:f},D]})})}n(r,a,t,d){const c=(0,R.$9q)(r.filePattern||""),s=(h,b)=>(0,R.$8q)(h,b,c,!0,m,t),l=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return I.$Gb(a,s,l,1e4,d)}o(r,a,t){if(t&&t>0)for(let d=0;d<r.length;d+=t)a(r.slice(d,d+t));else a(r)}q(r,a,t,d){const c=p.$Yd.create(!1),s=a.indexOf(v.sep)>=0;let l;for(const g in r.resultsToSearchCache)if(a.startsWith(g)){if(s&&g.indexOf(v.sep)<0&&g!=="")continue;const f=r.resultsToSearchCache[g];l={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!l)return null;const h=c.elapsed(),b=p.$Yd.create(!1),D=l.event(t);return d&&d.onCancellationRequested(()=>{D.dispose()}),l.promise.then(([g,f])=>{if(d&&d.isCancellationRequested)throw(0,$.$6)();const y=[],P=(0,R.$9q)(a).normalizedLowercase;for(const N of f)(0,C.$uK)(N,P)&&y.push(N);return[g,y,{cacheWasResolved:l.resolved,cacheLookupTime:h,cacheFilterTime:b.elapsed(),cacheEntryCount:f.length}]})}r(r,a,t,d){return new Promise((c,s)=>{let l=[];d?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(l.push(h),t>0&&l.length>=t&&(a(l),l=[])):a(h))},h=>{a(h)},(h,b)=>{l.length&&a(l),h?(a({message:"Search finished. Error: "+h.message}),s(h)):(a({message:"Search finished. Stats: "+JSON.stringify(b.stats)}),c(b))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$Gjc=k;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,v.$nc)(n.relativePath)}getItemDescription(n){return(0,v.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>S.URI.revive(r))}}function i(n){return{...n,folder:S.URI.revive(n.folder)}}}),define(Ce[382],Ie([1,0,3,16,2,31,13,27,20,97,67,36,381,379,119,156]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;let m=class extends S.$uic{constructor(i,n,r,a){super(i,r,a),this.s=A,this.t=-1,this.v=null,this.w=!1,this.x=new I.$Sc;const t=new k.$rjc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.vscodeUserData,new E.$Hjc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new k.$rjc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(O.Schemas.file,new E.$Hjc(i))),this.x.add(this.z(O.Schemas.file,new w.$Gjc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,I.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,S.$vic)(r);if(i===this.t){const d=Date.now();return this.A(i,n,t,a).then(c=>{const s=Date.now()-d;return this.n.debug(`Ext host file search time: ${s}ms`),c})}return super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,C.$tK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(d=>$.URI.file(d.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new u.$Ejc(i,n,void 0,"textSearchProvider")}};e.$Ijc=m,e.$Ijc=m=Ke([We(0,p.$aO),We(1,v.$qO),We(2,L.$nhc),We(3,R.$wj)],m)}),define(Ce[120],Ie([1,0,396,62,64,397,21,14,4,3,17,11,30,81,82]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class u{traceSocketEvent(f,y){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,y)}constructor(f,y=""){this.f=!0,this.debugLabel=y,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,v.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const y=P=>{this.traceSocketEvent("read",P),f(R.$qe.wrap(P))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(f){const y=P=>{f({type:0,hadError:P,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(f){const y=()=>{f()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$4h=u;var m;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(o||(o={}));class i extends S.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,y){this.socket.traceSocketEvent(f,y)}constructor(f,y,P,N){super(),this.f=this.B(new p.$3d),this.g=this.B(new p.$3d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:P?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new n(this,y,P,N,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,v.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new k.$Yh,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let y=0;for(;y<f.byteLength;)this.a.writeMessage(f.slice(y,Math.min(y+262144,f.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(f,{compressed:y,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const U=R.$qe.alloc(N),z=y?64:0,F=P&15;if(U.writeUInt8(128|z|F,0),f.byteLength<126)U.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){U.writeUInt8(126,1);let M=1;U.writeUInt8(f.byteLength>>>8&255,++M),U.writeUInt8(f.byteLength>>>0&255,++M)}else{U.writeUInt8(127,1);let M=1;U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(f.byteLength>>>24&255,++M),U.writeUInt8(f.byteLength>>>16&255,++M),U.writeUInt8(f.byteLength>>>8&255,++M),U.writeUInt8(f.byteLength>>>0&255,++M)}this.socket.write(R.$qe.concat([U,f]))}end(){this.h=!0,this.socket.end()}n(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),P=y.readUInt8(0),N=(P&128)>>>7,U=(P&64)>>>6,z=P&15,F=y.readUInt8(1),M=(F&128)>>>7,T=F&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(T===126?2:0)+(T===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),P=y.readUInt8(1),N=(P&128)>>>7;let U=P&127,z=1;U===126?U=y.readUInt8(++z)*2**8+y.readUInt8(++z):U===127&&(U=y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*0+y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z));let F=0;N&&(F=y.readUInt8(++z)*2**24+y.readUInt8(++z)*2**16+y.readUInt8(++z)*2**8+y.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$5h=i;class n extends S.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$qe.alloc(0)}constructor(f,y,P,N,U,z){super(),this.n=f,this.r=U,this.s=z,this.a=this.B(new p.$3d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$3d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$3d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new r(this.n,N,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(F=>this.a.fire(F))),this.B(this.f.onError(F=>this.a.fire(F)))):(this.b=null,this.f=null)}writeMessage(f,y){this.g.push({data:f,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:f,options:y}=this.g.shift();if(this.f&&y.compressed){const P=await this.w(this.f,f);this.s(P,y)}else this.s(f,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(f,y){return new Promise((P,N)=>{f.write(y),f.flush(U=>P(U))})}acceptFrame(f,y,P){this.h.push({data:f,isCompressed:y,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const y=await this.C(this.b,f.data,f.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(f.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(f,y,P){return new Promise((N,U)=>{f.write(y),P&&f.write(R.$qe.fromByteArray([0,0,255,255])),f.flush(z=>N(z))})}}class r extends S.$Tc{get recordedInflateBytes(){return this.j?R.$qe.concat(this.f):R.$qe.alloc(0)}constructor(f,y,P,N){super(),this.h=f,this.j=y,this.a=this.B(new p.$3d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(N),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(R.$qe.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=R.$qe.concat(this.g);this.g.length=0,f(y)})}}class a extends S.$Tc{constructor(f,y){super(),this.g=f,this.a=this.B(new p.$3d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$qe.wrap(P))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=R.$qe.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),f(y)})}}function t(g,f){if(f===0)return;const y=g.byteLength>>>2;for(let M=0;M<y;M++){const T=g.readUInt32BE(M*4);g.writeUInt32BE(T^f,M*4)}const P=y*4,N=g.byteLength-P,U=f>>>24&255,z=f>>>16&255,F=f>>>8&255;N>=1&&g.writeUInt8(g.readUInt8(P)^U,P),N>=2&&g.writeUInt8(g.readUInt8(P+1)^z,P+1),N>=3&&g.writeUInt8(g.readUInt8(P+2)^F,P+2)}e.$6h=process.env.XDG_RUNTIME_DIR;const d={2:107,1:103};function c(){const g=(0,w.$yg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const f=process.platform!=="darwin"&&e.$6h?e.$6h:(0,$.tmpdir)(),y=(0,L.$jc)(f,`vscode-ipc-${g}.sock`);return l(y),y}e.$7h=c;function s(g,f,y){const N=(0,I.createHash)("sha256").update(g).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${y}-${f}-sock`;const U=y.substr(0,4),z=f.substr(0,6);let F;return process.platform!=="darwin"&&e.$6h&&!process.env.VSCODE_PORTABLE?F=(0,L.$jc)(e.$6h,`vscode-${N}-${U}-${z}.sock`):F=(0,L.$jc)(g,`${U}-${z}.sock`),l(F),F}e.$8h=s;function l(g){const f=d[C.$u];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class h extends E.$Sh{static b(f){const y=p.Event.fromNodeEventEmitter(f,"connection");return p.Event.map(y,P=>({protocol:new k.$Zh(new u(P,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(P,"close"))}))}constructor(f){super(h.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$9h=h;function b(g){return new Promise((f,y)=>{const P=(0,O.createServer)();P.on("error",y),P.listen(g,()=>{P.removeListener("error",y),f(new h(P))})})}e.$0h=b;function D(g,f){return new Promise((y,P)=>{const N=(0,O.createConnection)(g,()=>{N.removeListener("error",P),y(k.$1h.fromSocket(new u(N,`ipc-client${f}`),f))});N.once("error",P)})}e.$$h=D}),define(Ce[383],Ie([1,0,62,64,167,120,8,3,11,51,13,136,258,259,109,88,21]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=e.$V_b=e.$U_b=void 0;async function o(t,d,c,s,l){let h;for(let b=3;b&&(h?.dispose(),h=await new i(t,d,c,s,l).waitForReady(),!(l&&$.$Bg[l]||!$.$Bg[h.tunnelLocalPort]));b--);return h}class i extends v.$Tc{constructor(d,c,s,l,h){super(),this.m=c,this.n=h,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=d,this.b=I.createServer(),this.c=new R.$bh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=l,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(c=>{c()})}async waitForReady(){const d=this.n??this.tunnelRemotePort,c=(0,u.$Qv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,$.$Cg)(d,2,1e3,c),l=null;return this.b.listen(s,this.m),await this.c.wait(),l=this.b.address(),l||(s=0,this.b.listen(s,this.m),await this.c.wait(),l=this.b.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async r(d){d.pause();const c=(0,u.$Ov)(this.tunnelRemoteHost)||(0,u.$Qv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,w.$ul)(this.a,c,this.tunnelRemotePort),l=s.getSocket(),h=s.readEntireBuffer();s.dispose(),h.byteLength>0&&d.write(h.buffer),d.on("end",()=>{d.localAddress&&this.j.delete(d.localAddress),l.end()}),d.on("close",()=>l.end()),d.on("error",()=>{d.localAddress&&this.j.delete(d.localAddress),l instanceof A.$4h?l.socket.destroy():l.end()}),l instanceof A.$4h?this.t(d,l):this.s(d,l),d.localAddress&&this.j.set(d.localAddress,()=>{d.end(),l.end()})}s(d,c){c.onClose(()=>d.destroy()),c.onEnd(()=>d.end()),c.onData(s=>d.write(s.buffer)),d.on("data",s=>c.write(m.$qe.wrap(s))),d.resume()}t(d,c){const s=c.socket;s.on("end",()=>d.end()),s.on("close",()=>d.end()),s.on("error",()=>{d.destroy()}),s.pipe(d),d.pipe(s)}}e.$U_b=i;let n=class extends u.$Tv{constructor(d,c,s,l,h){super(c,h),this.v=d,this.w=s,this.y=l}isPortPrivileged(d){return(0,u.$Rv)(d,this.m,p.OS,O.release())}t(d,c,s,l,h,b,D,g){const f=this.s(c,s);if(f)return++f.refcount,f.value;if((0,u.$Lv)(d))return this.u(d,c,s,h,b,D,g);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${s} on local port ${h}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:d,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(y,l,c,s,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(c,s,P),P}}};e.$V_b=n,e.$V_b=n=Ke([We(0,E.$ol),We(1,L.$wj),We(2,k.$rl),We(3,C.$Oj),We(4,S.$Ii)],n);let r=class extends n{constructor(d,c,s,l,h){super(d,c,s,l,h)}};e.$W_b=r,e.$W_b=r=Ke([We(0,E.$ol),We(1,L.$wj),We(2,k.$rl),We(3,C.$Oj),We(4,S.$Ii)],r);let a=class extends v.$Tc{constructor(d,c,s,l,h){super(),this.b=d,this.c=c,this.f=s,this.g=l,this.h=h,this.a=new Map}async openTunnel(d,c,s,l,h,b,D,g,f){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${l} on local port ${b}.`),!this.a.has(d)){const y=new r(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(d,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(d))})}return this.a.get(d).openTunnel(c,s,l,h,b,D,g,f)}};e.$X_b=a,e.$X_b=a=Ke([We(0,E.$ol),We(1,L.$wj),We(2,C.$Oj),We(3,k.$rl),We(4,S.$Ii)],a)}),define(Ce[384],Ie([1,0,120,278,57,33,2,13,40]),function(me,e,I,O,$,A,R,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=e.$BO=void 0;class S{constructor(w,E,k){this.b=w,this.c=E,this.f=k,this.a=O.createServer((u,m)=>this.h(u,m)),this.g().catch(u=>(E.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,E){const k=(m,o)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},u=[];w.setEncoding("utf8"),w.on("data",m=>u.push(m)),w.on("end",async()=>{try{const m=JSON.parse(u.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:k(404,`Unknown message type: ${m.type}`);break}k(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);k(500,o),this.c.error("Error while processing pipe request",m)}})}async i(w){const{fileURIs:E,folderURIs:k,forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=w,d=[];if(Array.isArray(k))for(const h of k)try{d.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(E))for(const h of E)try{(0,p.$Hi)(h)?d.push({workspaceUri:R.URI.parse(h)}):d.push({fileUri:R.URI.parse(h)})}catch{}const c=a?R.URI.file(a):void 0,l={forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!c&&!i,waitMarkerFileURI:c,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",d,l)}async j(w){for(const E of w.uris){const k=R.URI.parse(E),u=k.scheme==="file"?k:E;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(w){const E=u=>u?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),k={list:w.list,install:E(w.install),uninstall:E(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",k)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&$.existsSync(this.f)&&$.unlinkSync(this.f)}}e.$BO=S;let L=class extends S{constructor(w,E){super(w,E,(0,I.$7h)())}};e.$CO=L,e.$CO=L=Ke([We(0,A.$wO),We(1,v.$wj)],L)}),define(Ce[385],Ie([1,0,58,372,367,277,47,354,2,16,7,384,103,310,353]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class u extends $.$cjc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(c,s,l){return c=t(c),i.a.has(c)?i.a.get(c).load(c,p.URI.file((0,w.$Fq)(s.filename)),h=>r.apply(this,[h,s,l])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(d,c)=>a.call(this,t(d),c);const t=d=>{for(const c of i.b){const s=c(d);if(s){d=s;break}}return d}}}class m extends R.$4hc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$Ljc);const i=this.h.invokeFunction(O.$$ic);if(this.h.createInstance(v.$Kjc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$CO);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(k.$Mjc),await this.h.createInstance(u,i,{mine:this.J,all:this.L}).install(),I.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,A.$Jjc)(this.j,r,this,this.s,this.z,this.f),I.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==S.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&I.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&I.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$Njc=m}),define(Ce[386],Ie([1,0,50,21,4,3,122,11,23,2,31,13,257,65,109,88,383,27,20,71,361]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=e.$Tjc=e.$Sjc=e.$Rjc=e.$Qjc=e.$Pjc=e.$Ojc=void 0;function a(f){const y=f.trim().split(`
`),P=[];return y.forEach(U=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);z&&z.length>=3&&P.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),P.reduce((U,z)=>(U[z.socket]=z,U),{})}e.$Ojc=a;function t(...f){const y=[].concat(...f.map(c));return[...new Map(y.filter(P=>P.st==="0A").map(P=>{const N=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:d(N[0]),port:parseInt(N[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Pjc=t;function d(f){let y="";if(f.length===8)for(let P=f.length-2;P>=0;P-=2)y+=parseInt(f.substr(P,2),16),P!==0&&(y+=".");else for(let P=0;P<f.length;P+=8){const N=f.substring(P,P+8);let U="";for(let z=8;z>=2;z-=2)U+=N.substring(z-2,z),(z===6||z===2)&&(U=parseInt(U,16).toString(16),y+=`${U}`,U="",P+z!==f.length-6&&(y+=":"))}return y}e.$Qjc=d;function c(f){const y=f.trim().split(`
`),P=y.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return y.map(U=>U.trim().split(/\s+/).reduce((z,F,M)=>(z[P[M]||M]=F,z),{}))}e.$Rjc=c;function s(f){return!!f.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||f.indexOf("out/server-main.js")!==-1||f.indexOf("_productName=VSCode")!==-1}function l(f){const y=f.trim().split(`
`),P=[];return y.forEach(N=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(N);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Sjc=l;async function h(f,y,P){const N=P.reduce((z,F)=>(z[F.pid]=F,z),{}),U=[];return f.forEach(({socket:z,ip:F,port:M})=>{const T=y[z]?y[z].pid:void 0,j=T?N[T]?.cmd:void 0;T&&j&&!s(j)&&U.push({host:F,port:M,detail:j,pid:T})}),U}e.$Tjc=h;function b(f,y,P){const N=new Map,U=l(y);for(const z of f){const F=P.get(z.port);if(F){N.set(z.port,F);continue}const M=U.find(T=>T.cmd.includes(`${z.port}`));if(M){let T=M,j;do j=U.find(J=>J.ppid===T.pid),j&&(T=j);while(j);N.set(z.port,{host:z.ip,port:z.port,pid:T.pid,detail:T.cmd,ppid:T.ppid})}else N.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return N}e.$Ujc=b;let D=class extends n.$Szb{constructor(y,P,N,U){super(y,P,N),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,v.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const N=new R.$gm;let U=0;for(;this.C;){const z=new Date().getTime(),F=(await this.I()).filter(j=>(0,u.$Ov)(j.host)||(0,u.$Qv)(j.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${F.map(j=>j.port).join(", ")}`);const M=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),U++>3&&N.update(M),(!P||JSON.stringify(P)!==JSON.stringify(F))&&(P=F,await this.a.$onFoundNewCandidates(P));const T=this.G(N.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${T} ms.`),await new Promise(j=>setTimeout(()=>j(),T))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",P="";try{y=await L.Promises.readFile("/proc/net/tcp","utf8"),P=await L.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const N=t(y,P),U=await new Promise(_=>{(0,I.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,Y,ce)=>{_(Y)})}),z=a(U),F=await L.Promises.readdir("/proc"),M=[];for(const _ of F)try{const Z=Number(_),Y=p.$Pg(S.URI.file("/proc"),_);if((await L.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN(Z)){const ie=await L.Promises.readlink(p.$Pg(Y,"cwd").fsPath),fe=await L.Promises.readFile(p.$Pg(Y,"cmdline").fsPath,"utf8");M.push({pid:Z,cwd:ie,cmd:fe})}}catch{}const T=[],j=N.filter(_=>{const Z=z[_.socket];return Z||T.push(_),Z}),J=h(j,z,M);let ne;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${T.length}`),T.length>0){const _=await new Promise(Z=>{(0,I.exec)("ps -F -A -l | grep root",(Y,ce,ie)=>{Z(ce)})});this.z=b(T,_,this.z),ne=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ne.map(Z=>Z.port).join(", ")}`)}return J.then(_=>ne?_.concat(ne):_)}w(y){return async P=>{const N=new m.$U_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,F,M,T){const j=await y.makeConnection();return g.connect(j,F,M,T)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$fl(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await N.waitForReady();const U=new $.$3d;return{localAddress:(0,r.$jL)(N.localAddress)??N.localAddress,remoteAddress:{port:N.tunnelRemotePort,host:N.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{N.dispose(),U.fire(),U.dispose()}}}}};e.$Vjc=D,e.$Vjc=D=Ke([We(0,i.$aO),We(1,o.$qO),We(2,C.$wj),We(3,k.$rl)],D);class g extends w.$1sb{static connect(y,P,N,U){const z=new A.$Sc,F={onClose:z.add(new $.$3d),onData:z.add(new $.$3d),onEnd:z.add(new $.$3d)};z.add(y.onDidReceiveMessage(T=>F.onData.fire(O.$qe.wrap(T)))),z.add(y.onDidEnd(()=>F.onEnd.fire())),z.add(y.onDidClose(T=>F.onClose.fire({type:0,error:T,hadError:!!T})));const M=new g(y,U,F);return M.B(z),(0,w.$Zsb)(M,P,N,U,F)}constructor(y,P,N){super(P,N),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ce[387],Ie([1,0,84,356,370,369,382,385,386,96,47,97,95,46,71,93,355,311,13,371,60,272,105,109,138]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o,i,n,r,a,t,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,I.$8r)(L.$5hc,v.$Njc,0),(0,I.$8r)(i.$xj,o.$Xjc,1),(0,I.$8r)(i.$wj,new t.$_h(a.$bjc,[!1],!0)),(0,I.$8r)(d.$rl,c.$Z_b,1),(0,I.$8r)(u.$whc,m.$Wjc,0),(0,I.$8r)(S.$0hc,A.$ojc,0),(0,I.$8r)(C.$tic,R.$Ijc,0),(0,I.$8r)(w.$Wic,$.$gjc,0),(0,I.$8r)(E.$Rhc,O.$fjc,0),(0,I.$8r)(k.$Rzb,p.$Vjc,0),(0,I.$8r)(r.$8hc,n.$Yjc,0)}),define(Ce[398],Ie([1,0,62,399,58,14,82,120,255,113,368,21,31,103,8,132,279,293,373,387]),function(me,e,I,O,$,A,R,v,p,S,L,C,w,E,k,u,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let b=0;b<process.execArgv.length;b++)process.execArgv[b]==="--inspect-port=0"&&(process.execArgv.splice(b,1),b--)}();const i=O(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,b=h._load;h._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return b.apply(this,arguments)}})();const n=process.exit.bind(process),r=process.on.bind(process);function a(h){process.exit=function(b){if(h)n(b);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const b=new Error("An extension called process.crash() and this was prevented.");console.warn(b.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(b,D){b==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r(b,D)}}let t=function(h){n()};function d(){const h=(0,o.$4m)(process.env);if(h.type===3)return new Promise((b,D)=>{const g=f=>{const y=f[0],P=new R.$2h;y.on("message",N=>P.fire(C.$qe.wrap(N.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),b({onMessage:P.event,send:N=>y.postMessage(N.buffer)})};process.parentPort.on("message",f=>g(f.ports))});if(h.type===2)return new Promise((b,D)=>{let g=null;const f=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,P=3e5,N=new k.$ph(()=>t("renderer disconnected for too long (1)"),y),U=new k.$ph(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(F,M)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const T=C.$qe.wrap(Buffer.from(F.initialDataChunk,"base64"));let j;if(F.skipWebSocketFrames)j=new v.$4h(M,"extHost-socket");else{const J=C.$qe.wrap(Buffer.from(F.inflateBytes,"base64"));j=new v.$5h(new v.$4h(M,"extHost-socket"),F.permessageDeflate,J,!1)}g?(N.cancel(),U.cancel(),g.beginAcceptReconnection(j,T),g.endAcceptReconnection(),g.sendResume()):(clearTimeout(f),g=new R.$3h({socket:j,initialChunk:T}),g.sendResume(),g.onDidDispose(()=>t("renderer disconnected")),b(g),g.onSocketClose(()=>{N.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;N.isScheduled()&&U.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const b=h.pipeName;return new Promise((D,g)=>{const f=I.createConnection(b,()=>{f.removeListener("error",g);const y=new R.$3h({socket:new v.$4h(f,"extHost-renderer")});y.sendResume(),D(y)});f.once("error",g),f.on("close",()=>{t("renderer closed the socket")})})}}async function c(){const h=await d();return new class{constructor(){this.a=new R.$2h,this.onMessage=this.a.event,this.b=!1,h.onMessage(b=>{(0,S.$Dm)(b,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(b)})}send(b){this.b||h.send(b)}async drain(){if(h.drain)return h.drain()}}}function s(h){return new Promise(b=>{const D=h.onMessage(g=>{D.dispose();const f=JSON.parse(g.toString()),y=f.commit,P=p.default.commit;if(y&&P&&y!==P&&n(55),f.parentPid){let N=0;setInterval(function(){try{process.kill(f.parentPid,0),N=0}catch(z){z&&z.code==="EPERM"?(N++,N>=3&&t(`parent process ${f.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):t(`parent process ${f.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(f.parentPid)}catch(z){(0,A.$1)(z)}}h.send((0,S.$Cm)(0)),b({protocol:h,initData:f})});h.send((0,S.$Cm)(1))})}async function l(){const h=[];process.on("unhandledRejection",(N,U)=>{h.push(U),setTimeout(()=>{const z=h.indexOf(U);z>=0&&U.catch(F=>{h.splice(z,1),(0,A.$4)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),N&&(0,A.$1)(N))})},1e3)}),process.on("rejectionHandled",N=>{const U=h.indexOf(N);U>=0&&h.splice(U,1)}),process.on("uncaughtException",function(N){(0,A.$Z)(N)||(0,A.$1)(N)}),$.mark("code/extHost/willConnectToRenderer");const b=await c();$.mark("code/extHost/didConnectToRenderer");const D=await s(b);$.mark("code/extHost/didWaitForInitData");const{initData:g}=D;a(!!g.environment.extensionTestsLocationURI),g.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,g.environment.skipWorkspaceStorageLock=(0,u.boolean)(i.skipWorkspaceStorageLock,!1);const f=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return w.Promises.exists(U)}fsRealpath(U){return(0,E.$Eq)(U)}};let y=null;g.remote.authority&&i.transformURIs&&(y=(0,m.$_r)(g.remote.authority));const P=new L.$ejc(D.protocol,g,f,y);t=N=>P.terminate(N)}l().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d84c946d27b649d614319c796911871320befd42/core/vs/workbench/api/node/extensionHostProcess.js.map
