/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Fe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostChatProvider","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Le=function(fe){for(var e=[],S=0,F=fe.length;S<F;S++)e[S]=Fe[fe[S]];return e};define(Fe[67],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=e.$Gh=void 0;function S(R){return(g,f,D)=>{let A=null,k=null;if(typeof D.value=="function"?(A="value",k=D.value):typeof D.get=="function"&&(A="get",k=D.get),!k)throw new Error("not supported");D[A]=R(k,f)}}function F(R,g,f){let D=null,A=null;if(typeof f.value=="function"?(D="value",A=f.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(D="get",A=f.get),!A)throw new Error("not supported");const k=`$memoize$${g}`;f[D]=function(...h){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,h)}),this[k]}}e.$Gh=F;function P(R,g,f){return S((D,A)=>{const k=`$debounce$${A}`,h=`$debounce$result$${A}`;return function(...v){this[h]||(this[h]=f?f():void 0),clearTimeout(this[k]),g&&(this[h]=g(this[h],...v),v=[this[h]]),this[k]=setTimeout(()=>{D.apply(this,v),this[h]=f?f():void 0},R)}})}e.$Hh=P;function L(R,g,f){return S((D,A)=>{const k=`$throttle$timer$${A}`,h=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...s){if(this[h]||(this[h]=f?f():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),g&&(this[h]=g(this[h],...s)),this[p])return;const u=this[v]+R;u<=Date.now()?(this[v]=Date.now(),D.apply(this,[this[h]]),this[h]=f?f():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),D.apply(this,[this[h]]),this[h]=f?f():void 0},u-Date.now()))}})}e.$Ih=L}),define(Fe[88],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=e.$fO=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$fO=S,e.$gO=new S("id#")}),define(Fe[120],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var F;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,m=!1){let a=0;const c=t.length;let E="",y=0,$=16,I=0;function d(U){let C=0,O=0;for(;C<U;){const V=t.charCodeAt(a);if(V>=48&&V<=57)O=O*16+V-48;else if(V>=65&&V<=70)O=O*16+V-65+10;else if(V>=97&&V<=102)O=O*16+V-97+10;else break;a++,C++}return C<U&&(O=-1),O}function w(U){a=U,E="",y=0,$=16,I=0}function b(){const U=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&D(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&D(t.charCodeAt(a)))for(a++;a<t.length&&D(t.charCodeAt(a));)a++;else return I=3,t.substring(U,a);let C=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&D(t.charCodeAt(a))){for(a++;a<t.length&&D(t.charCodeAt(a));)a++;C=a}else I=3;return t.substring(U,C)}function M(){let U="",C=a;for(;;){if(a>=c){U+=t.substring(C,a),I=2;break}const O=t.charCodeAt(a);if(O===34){U+=t.substring(C,a),a++;break}if(O===92){if(U+=t.substring(C,a),a++,a>=c){I=2;break}switch(t.charCodeAt(a++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=d(4);re>=0?U+=String.fromCharCode(re):I=4;break}default:I=5}C=a;continue}if(O>=0&&O<=31)if(f(O)){U+=t.substring(C,a),I=2;break}else I=6;a++}return U}function T(){if(E="",I=0,y=a,a>=c)return y=c,$=17;let U=t.charCodeAt(a);if(g(U)){do a++,E+=String.fromCharCode(U),U=t.charCodeAt(a);while(g(U));return $=15}if(f(U))return a++,E+=String.fromCharCode(U),U===13&&t.charCodeAt(a)===10&&(a++,E+=`
`),$=14;switch(U){case 123:return a++,$=1;case 125:return a++,$=2;case 91:return a++,$=3;case 93:return a++,$=4;case 58:return a++,$=6;case 44:return a++,$=5;case 34:return a++,E=M(),$=10;case 47:{const C=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<c&&!f(t.charCodeAt(a));)a++;return E=t.substring(C,a),$=12}if(t.charCodeAt(a+1)===42){a+=2;const O=c-1;let V=!1;for(;a<O;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,V=!0;break}a++}return V||(a++,I=1),E=t.substring(C,a),$=13}return E+=String.fromCharCode(U),a++,$=16}case 45:if(E+=String.fromCharCode(U),a++,a===c||!D(t.charCodeAt(a)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=b(),$=11;default:for(;a<c&&G(U);)a++,U=t.charCodeAt(a);if(y!==a){switch(E=t.substring(y,a),E){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return E+=String.fromCharCode(U),a++,$=16}}function G(U){if(g(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=T();while(U>=12&&U<=15);return U}return{setPosition:w,getPosition:()=>a,scan:m?W:T,getToken:()=>$,getTokenValue:()=>E,getTokenOffset:()=>y,getTokenLength:()=>a-y,getTokenError:()=>I}}e.$kn=R;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,m){const a=[],c=new Object;let E;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function I(d,w,b,M){y.value=d,y.offset=w,y.length=b,y.type=M,y.colonOffset=void 0,E=y}try{n(t,{onObjectBegin:(d,w)=>{if(m<=d)throw c;E=void 0,$=m>d,a.push("")},onObjectProperty:(d,w,b)=>{if(m<w||(I(d,w,b,"property"),a[a.length-1]=d,m<=w+b))throw c},onObjectEnd:(d,w)=>{if(m<=d)throw c;E=void 0,a.pop()},onArrayBegin:(d,w)=>{if(m<=d)throw c;E=void 0,a.push(0)},onArrayEnd:(d,w)=>{if(m<=d)throw c;E=void 0,a.pop()},onLiteralValue:(d,w,b)=>{if(m<w||(I(d,w,b,l(d)),m<=w+b))throw c},onSeparator:(d,w,b)=>{if(m<=w)throw c;if(d===":"&&E&&E.type==="property")E.colonOffset=w,$=!1,E=void 0;else if(d===","){const M=a[a.length-1];typeof M=="number"?a[a.length-1]=M+1:($=!0,a[a.length-1]=""),E=void 0}}})}catch(d){if(d!==c)throw d}return{path:a,previousNode:E,isAtPropertyKey:$,matches:d=>{let w=0;for(let b=0;w<d.length&&b<a.length;b++)if(d[w]===a[b]||d[w]==="*")w++;else if(d[w]!=="**")return!1;return w===d.length}}}e.$ln=k;function h(t,m=[],a=L.DEFAULT){let c=null,E=[];const y=[];function $(d){Array.isArray(E)?E.push(d):c!==null&&(E[c]=d)}return n(t,{onObjectBegin:()=>{const d={};$(d),y.push(E),E=d,c=null},onObjectProperty:d=>{c=d},onObjectEnd:()=>{E=y.pop()},onArrayBegin:()=>{const d=[];$(d),y.push(E),E=d,c=null},onArrayEnd:()=>{E=y.pop()},onLiteralValue:$,onError:(d,w,b)=>{m.push({error:d,offset:w,length:b})}},a),E[0]}e.$mn=h;function v(t,m=[],a=L.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(d){c.type==="property"&&(c.length=d-c.offset,c=c.parent)}function y(d){return c.children.push(d),d}n(t,{onObjectBegin:d=>{c=y({type:"object",offset:d,length:-1,parent:c,children:[]})},onObjectProperty:(d,w,b)=>{c=y({type:"property",offset:w,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:d,offset:w,length:b,parent:c})},onObjectEnd:(d,w)=>{c.length=d+w-c.offset,c=c.parent,E(d+w)},onArrayBegin:(d,w)=>{c=y({type:"array",offset:d,length:-1,parent:c,children:[]})},onArrayEnd:(d,w)=>{c.length=d+w-c.offset,c=c.parent,E(d+w)},onLiteralValue:(d,w,b)=>{y({type:l(d),offset:w,length:b,parent:c,value:d}),E(w+b)},onSeparator:(d,w,b)=>{c.type==="property"&&(d===":"?c.colonOffset=w:d===","&&E(w))},onError:(d,w,b)=>{m.push({error:d,offset:w,length:b})}},a);const I=c.children[0];return I&&delete I.parent,I}e.$nn=v;function p(t,m){if(!t)return;let a=t;for(const c of m)if(typeof c=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let E=!1;for(const y of a.children)if(Array.isArray(y.children)&&y.children[0].value===c){a=y.children[1],E=!0;break}if(!E)return}else{const E=c;if(a.type!=="array"||E<0||!Array.isArray(a.children)||E>=a.children.length)return;a=a.children[E]}return a}e.$on=p;function s(t){if(!t.parent||!t.parent.children)return[];const m=s(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;m.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&m.push(a)}return m}e.$pn=s;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const m=Object.create(null);for(const a of t.children){const c=a.children[1];c&&(m[a.children[0].value]=u(c))}return m}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$qn=u;function r(t,m,a=!1){return m>=t.offset&&m<t.offset+t.length||a&&m===t.offset+t.length}e.$rn=r;function i(t,m,a=!1){if(r(t,m,a)){const c=t.children;if(Array.isArray(c))for(let E=0;E<c.length&&c[E].offset<=m;E++){const y=i(c[E],m,a);if(y)return y}return t}}e.$sn=i;function n(t,m,a=L.DEFAULT){const c=R(t,!1);function E(se){return se?()=>se(c.getTokenOffset(),c.getTokenLength()):()=>!0}function y(se){return se?$e=>se($e,c.getTokenOffset(),c.getTokenLength()):()=>!0}const $=E(m.onObjectBegin),I=y(m.onObjectProperty),d=E(m.onObjectEnd),w=E(m.onArrayBegin),b=E(m.onArrayEnd),M=y(m.onLiteralValue),T=y(m.onSeparator),G=E(m.onComment),W=y(m.onError),U=a&&a.disallowComments,C=a&&a.allowTrailingComma;function O(){for(;;){const se=c.scan();switch(c.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:U||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(se){case 12:case 13:U?V(10):G();break;case 16:V(1);break;case 15:case 14:break;default:return se}}}function V(se,$e=[],te=[]){if(W(se),$e.length+te.length>0){let Y=c.getToken();for(;Y!==17;){if($e.indexOf(Y)!==-1){O();break}else if(te.indexOf(Y)!==-1)break;Y=O()}}}function re(se){const $e=c.getTokenValue();return se?M($e):I($e),O(),!0}function ce(){switch(c.getToken()){case 11:{let se=0;try{se=JSON.parse(c.getTokenValue()),typeof se!="number"&&(V(2),se=0)}catch{V(2)}M(se);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return O(),!0}function ye(){return c.getToken()!==10?(V(3,[],[2,5]),!1):(re(!1),c.getToken()===6?(T(":"),O(),ve()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function ke(){$(),O();let se=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(se||V(4,[],[]),T(","),O(),c.getToken()===2&&C)break}else se&&V(6,[],[]);ye()||V(4,[],[2,5]),se=!0}return d(),c.getToken()!==2?V(7,[2],[]):O(),!0}function he(){w(),O();let se=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(se||V(4,[],[]),T(","),O(),c.getToken()===4&&C)break}else se&&V(6,[],[]);ve()||V(4,[],[4,5]),se=!0}return b(),c.getToken()!==4?V(8,[4],[]):O(),!0}function ve(){switch(c.getToken()){case 3:return he();case 1:return ke();case 10:return re(!0);default:return ce()}}return O(),c.getToken()===17?a.allowEmptyContent?!0:(V(4,[],[]),!1):ve()?(c.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.$tn=n;function o(t,m){const a=R(t),c=[];let E,y=0,$;do switch($=a.getPosition(),E=a.scan(),E){case 12:case 13:case 17:y!==$&&c.push(t.substring(y,$)),m!==void 0&&c.push(a.getTokenValue().replace(/[^\r\n]/g,m)),y=a.getPosition();break}while(E!==17);return c.join("")}e.$un=o;function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$vn=l}),function(fe,e){typeof define=="function"&&define.amd?define(Fe[121],Le([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(Re,be){for(var me=0;me<be.length;me++){var Q=be[me];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Re,Q.key,Q)}}function S(Re,be,me){return be&&e(Re.prototype,be),me&&e(Re,me),Object.defineProperty(Re,"prototype",{writable:!1}),Re}function F(Re,be){if(Re){if(typeof Re=="string")return P(Re,be);var me=Object.prototype.toString.call(Re).slice(8,-1);if(me==="Object"&&Re.constructor&&(me=Re.constructor.name),me==="Map"||me==="Set")return Array.from(Re);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return P(Re,be)}}function P(Re,be){(be==null||be>Re.length)&&(be=Re.length);for(var me=0,Q=new Array(be);me<be;me++)Q[me]=Re[me];return Q}function L(Re,be){var me=typeof Symbol<"u"&&Re[Symbol.iterator]||Re["@@iterator"];if(me)return(me=me.call(Re)).next.bind(me);if(Array.isArray(Re)||(me=F(Re))||be&&Re&&typeof Re.length=="number"){me&&(Re=me);var Q=0;return function(){return Q>=Re.length?{done:!0}:{done:!1,value:Re[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function g(Re){fe.defaults=Re}var f=/[&<>"']/,D=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,h={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(be){return h[be]};function p(Re,be){if(be){if(f.test(Re))return Re.replace(D,v)}else if(A.test(Re))return Re.replace(k,v);return Re}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(Re){return Re.replace(s,function(be,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var r=/(^|[^\[])\^/g;function i(Re,be){Re=typeof Re=="string"?Re:Re.source,be=be||"";var me={replace:function(x,le){return le=le.source||le,le=le.replace(r,"$1"),Re=Re.replace(x,le),me},getRegex:function(){return new RegExp(Re,be)}};return me}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(Re,be,me){if(Re){var Q;try{Q=decodeURIComponent(u(me)).replace(n,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}be&&!o.test(me)&&(me=E(be,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var t={},m=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(Re,be){t[" "+Re]||(m.test(Re)?t[" "+Re]=Re+"/":t[" "+Re]=d(Re,"/",!0)),Re=t[" "+Re];var me=Re.indexOf(":")===-1;return be.substring(0,2)==="//"?me?be:Re.replace(a,"$1")+be:be.charAt(0)==="/"?me?be:Re.replace(c,"$1")+be:Re+be}var y={exec:function(){}};function $(Re){for(var be=1,me,Q;be<arguments.length;be++){me=arguments[be];for(Q in me)Object.prototype.hasOwnProperty.call(me,Q)&&(Re[Q]=me[Q])}return Re}function I(Re,be){var me=Re.replace(/\|/g,function(le,de,Me){for(var ge=!1,Se=de;--Se>=0&&Me[Se]==="\\";)ge=!ge;return ge?"|":" |"}),Q=me.split(/ \|/),x=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>be)Q.splice(be);else for(;Q.length<be;)Q.push("");for(;x<Q.length;x++)Q[x]=Q[x].trim().replace(/\\\|/g,"|");return Q}function d(Re,be,me){var Q=Re.length;if(Q===0)return"";for(var x=0;x<Q;){var le=Re.charAt(Q-x-1);if(le===be&&!me)x++;else if(le!==be&&me)x++;else break}return Re.slice(0,Q-x)}function w(Re,be){if(Re.indexOf(be[1])===-1)return-1;for(var me=Re.length,Q=0,x=0;x<me;x++)if(Re[x]==="\\")x++;else if(Re[x]===be[0])Q++;else if(Re[x]===be[1]&&(Q--,Q<0))return x;return-1}function b(Re){Re&&Re.sanitize&&!Re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(Re,be){if(be<1)return"";for(var me="";be>1;)be&1&&(me+=Re),be>>=1,Re+=Re;return me+Re}function T(Re,be,me,Q){var x=be.href,le=be.title?p(be.title):null,de=Re[1].replace(/\\([\[\]])/g,"$1");if(Re[0].charAt(0)!=="!"){Q.state.inLink=!0;var Me={type:"link",raw:me,href:x,title:le,text:de,tokens:Q.inlineTokens(de)};return Q.state.inLink=!1,Me}return{type:"image",raw:me,href:x,title:le,text:p(de)}}function G(Re,be){var me=Re.match(/^(\s+)(?:```)/);if(me===null)return be;var Q=me[1];return be.split(`
`).map(function(x){var le=x.match(/^\s+/);if(le===null)return x;var de=le[0];return de.length>=Q.length?x.slice(Q.length):x}).join(`
`)}var W=function(){function Re(me){this.options=me||fe.defaults}var be=Re.prototype;return be.space=function(Q){var x=this.rules.block.newline.exec(Q);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(Q){var x=this.rules.block.code.exec(Q);if(x){var le=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?le:d(le,`
`)}}},be.fences=function(Q){var x=this.rules.block.fences.exec(Q);if(x){var le=x[0],de=G(le,x[3]||"");return{type:"code",raw:le,lang:x[2]?x[2].trim():x[2],text:de}}},be.heading=function(Q){var x=this.rules.block.heading.exec(Q);if(x){var le=x[2].trim();if(/#$/.test(le)){var de=d(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:le,tokens:this.lexer.inline(le)}}},be.hr=function(Q){var x=this.rules.block.hr.exec(Q);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(Q){var x=this.rules.block.blockquote.exec(Q);if(x){var le=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},be.list=function(Q){var x=this.rules.block.list.exec(Q);if(x){var le,de,Me,ge,Se,Ce,N,K,j,H,Z,oe,Ee=x[1].trim(),Be=Ee.length>1,Ve={type:"list",raw:"",ordered:Be,start:Be?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Be?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Be?Ee:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(oe=!1,!(!(x=Ze.exec(Q))||this.rules.block.hr.test(Q)));){if(le=x[0],Q=Q.substring(le.length),K=x[2].split(`
`,1)[0],j=Q.split(`
`,1)[0],this.options.pedantic?(ge=2,Z=K.trimLeft()):(ge=x[2].search(/[^ ]/),ge=ge>4?1:ge,Z=K.slice(ge),ge+=x[1].length),Ce=!1,!K&&/^ *$/.test(j)&&(le+=j+`
`,Q=Q.substring(j.length+1),oe=!0),!oe)for(var xe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");Q&&(H=Q.split(`
`,1)[0],K=H,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(K)||et.test(K)||xe.test(K)||at.test(Q)));){if(K.search(/[^ ]/)>=ge||!K.trim())Z+=`
`+K.slice(ge);else if(!Ce)Z+=`
`+K;else break;!Ce&&!K.trim()&&(Ce=!0),le+=H+`
`,Q=Q.substring(H.length+1)}Ve.loose||(N?Ve.loose=!0:/\n *\n *$/.test(le)&&(N=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Z),de&&(Me=de[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:le,task:!!de,checked:Me,loose:!1,text:Z}),Ve.raw+=le}Ve.items[Ve.items.length-1].raw=le.trimRight(),Ve.items[Ve.items.length-1].text=Z.trimRight(),Ve.raw=Ve.raw.trimRight();var ut=Ve.items.length;for(Se=0;Se<ut;Se++){this.lexer.state.top=!1,Ve.items[Se].tokens=this.lexer.blockTokens(Ve.items[Se].text,[]);var je=Ve.items[Se].tokens.filter(function(X){return X.type==="space"}),pt=je.every(function(X){for(var _=X.raw.split(""),pe=0,We=L(_),Qe;!(Qe=We()).done;){var it=Qe.value;if(it===`
`&&(pe+=1),pe>1)return!0}return!1});!Ve.loose&&je.length&&pt&&(Ve.loose=!0,Ve.items[Se].loose=!0)}return Ve}},be.html=function(Q){var x=this.rules.block.html.exec(Q);if(x){var le={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},be.def=function(Q){var x=this.rules.block.def.exec(Q);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var le=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:x[0],href:x[2],title:x[3]}}},be.table=function(Q){var x=this.rules.block.table.exec(Q);if(x){var le={type:"table",header:I(x[1]).map(function(N){return{text:N}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=x[0];var de=le.align.length,Me,ge,Se,Ce;for(Me=0;Me<de;Me++)/^ *-+: *$/.test(le.align[Me])?le.align[Me]="right":/^ *:-+: *$/.test(le.align[Me])?le.align[Me]="center":/^ *:-+ *$/.test(le.align[Me])?le.align[Me]="left":le.align[Me]=null;for(de=le.rows.length,Me=0;Me<de;Me++)le.rows[Me]=I(le.rows[Me],le.header.length).map(function(N){return{text:N}});for(de=le.header.length,ge=0;ge<de;ge++)le.header[ge].tokens=this.lexer.inline(le.header[ge].text);for(de=le.rows.length,ge=0;ge<de;ge++)for(Ce=le.rows[ge],Se=0;Se<Ce.length;Se++)Ce[Se].tokens=this.lexer.inline(Ce[Se].text);return le}}},be.lheading=function(Q){var x=this.rules.block.lheading.exec(Q);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(Q){var x=this.rules.block.paragraph.exec(Q);if(x){var le=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:le,tokens:this.lexer.inline(le)}}},be.text=function(Q){var x=this.rules.block.text.exec(Q);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(Q){var x=this.rules.inline.escape.exec(Q);if(x)return{type:"escape",raw:x[0],text:p(x[1])}},be.tag=function(Q){var x=this.rules.inline.tag.exec(Q);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):p(x[0]):x[0]}},be.link=function(Q){var x=this.rules.inline.link.exec(Q);if(x){var le=x[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=d(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Me=w(x[2],"()");if(Me>-1){var ge=x[0].indexOf("!")===0?5:4,Se=ge+x[1].length+Me;x[2]=x[2].substring(0,Me),x[0]=x[0].substring(0,Se).trim(),x[3]=""}}var Ce=x[2],N="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);K&&(Ce=K[1],N=K[3])}else N=x[3]?x[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(le)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),T(x,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:N&&N.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(Q,x){var le;if((le=this.rules.inline.reflink.exec(Q))||(le=this.rules.inline.nolink.exec(Q))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=x[de.toLowerCase()],!de||!de.href){var Me=le[0].charAt(0);return{type:"text",raw:Me,text:Me}}return T(le,de,le[0],this.lexer)}},be.emStrong=function(Q,x,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(Q);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=de[1]||de[2]||"";if(!Me||Me&&(le===""||this.rules.inline.punctuation.exec(le))){var ge=de[0].length-1,Se,Ce,N=ge,K=0,j=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*Q.length+ge);(de=j.exec(x))!=null;)if(Se=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Se){if(Ce=Se.length,de[3]||de[4]){N+=Ce;continue}else if((de[5]||de[6])&&ge%3&&!((ge+Ce)%3)){K+=Ce;continue}if(N-=Ce,!(N>0)){if(Ce=Math.min(Ce,Ce+N+K),Math.min(ge,Ce)%2){var H=Q.slice(1,ge+de.index+Ce);return{type:"em",raw:Q.slice(0,ge+de.index+Ce+1),text:H,tokens:this.lexer.inlineTokens(H)}}var Z=Q.slice(2,ge+de.index+Ce-1);return{type:"strong",raw:Q.slice(0,ge+de.index+Ce+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},be.codespan=function(Q){var x=this.rules.inline.code.exec(Q);if(x){var le=x[2].replace(/\n/g," "),de=/[^ ]/.test(le),Me=/^ /.test(le)&&/ $/.test(le);return de&&Me&&(le=le.substring(1,le.length-1)),le=p(le,!0),{type:"codespan",raw:x[0],text:le}}},be.br=function(Q){var x=this.rules.inline.br.exec(Q);if(x)return{type:"br",raw:x[0]}},be.del=function(Q){var x=this.rules.inline.del.exec(Q);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(Q,x){var le=this.rules.inline.autolink.exec(Q);if(le){var de,Me;return le[2]==="@"?(de=p(this.options.mangle?x(le[1]):le[1]),Me="mailto:"+de):(de=p(le[1]),Me=de),{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},be.url=function(Q,x){var le;if(le=this.rules.inline.url.exec(Q)){var de,Me;if(le[2]==="@")de=p(this.options.mangle?x(le[0]):le[0]),Me="mailto:"+de;else{var ge;do ge=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(ge!==le[0]);de=p(le[0]),le[1]==="www."?Me="http://"+de:Me=de}return{type:"link",raw:le[0],text:de,href:Me,tokens:[{type:"text",raw:de,text:de}]}}},be.inlineText=function(Q,x){var le=this.rules.inline.text.exec(Q);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):p(le[0]):le[0]:de=p(this.options.smartypants?x(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},Re}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=$({},U),U.gfm=$({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=$({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=$({},C),C.pedantic=$({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=$({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=$({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Re){return Re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Re){var be="",me,Q,x=Re.length;for(me=0;me<x;me++)Q=Re.charCodeAt(me),Math.random()>.5&&(Q="x"+Q.toString(16)),be+="&#"+Q+";";return be}var re=function(){function Re(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||fe.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:U.normal,inline:C.normal};this.options.pedantic?(Q.block=U.pedantic,Q.inline=C.pedantic):this.options.gfm&&(Q.block=U.gfm,this.options.breaks?Q.inline=C.breaks:Q.inline=C.gfm),this.tokenizer.rules=Q}Re.lex=function(Q,x){var le=new Re(x);return le.lex(Q)},Re.lexInline=function(Q,x){var le=new Re(x);return le.inlineTokens(Q)};var be=Re.prototype;return be.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(Q,x){var le=this;x===void 0&&(x=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(N,K,j){return K+"    ".repeat(j.length)});for(var de,Me,ge,Se;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(N){return(de=N.call({lexer:le},Q,x))?(Q=Q.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.space(Q)){Q=Q.substring(de.raw.length),de.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(de);continue}if(de=this.tokenizer.code(Q)){Q=Q.substring(de.raw.length),Me=x[x.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(de);continue}if(de=this.tokenizer.fences(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.heading(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.hr(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.blockquote(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.list(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.html(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.def(Q)){Q=Q.substring(de.raw.length),Me=x[x.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.lheading(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(ge=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var N=1/0,K=Q.slice(1),j=void 0;le.options.extensions.startBlock.forEach(function(H){j=H.call({lexer:this},K),typeof j=="number"&&j>=0&&(N=Math.min(N,j))}),N<1/0&&N>=0&&(ge=Q.substring(0,N+1))}(),this.state.top&&(de=this.tokenizer.paragraph(ge))){Me=x[x.length-1],Se&&Me.type==="paragraph"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(de),Se=ge.length!==Q.length,Q=Q.substring(de.raw.length);continue}if(de=this.tokenizer.text(Q)){Q=Q.substring(de.raw.length),Me=x[x.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+de.raw,Me.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):x.push(de);continue}if(Q){var Ce="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,x},be.inline=function(Q,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:Q,tokens:x}),x},be.inlineTokens=function(Q,x){var le=this;x===void 0&&(x=[]);var de,Me,ge,Se=Q,Ce,N,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)j.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Ce.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(N||(K=""),N=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(de=Z.call({lexer:le},Q,x))?(Q=Q.substring(de.raw.length),x.push(de),!0):!1}))){if(de=this.tokenizer.escape(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.tag(Q)){Q=Q.substring(de.raw.length),Me=x[x.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):x.push(de);continue}if(de=this.tokenizer.link(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(de.raw.length),Me=x[x.length-1],Me&&de.type==="text"&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):x.push(de);continue}if(de=this.tokenizer.emStrong(Q,Se,K)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.codespan(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.br(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.del(Q)){Q=Q.substring(de.raw.length),x.push(de);continue}if(de=this.tokenizer.autolink(Q,V)){Q=Q.substring(de.raw.length),x.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(Q,V))){Q=Q.substring(de.raw.length),x.push(de);continue}if(ge=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,oe=Q.slice(1),Ee=void 0;le.options.extensions.startInline.forEach(function(Be){Ee=Be.call({lexer:this},oe),typeof Ee=="number"&&Ee>=0&&(Z=Math.min(Z,Ee))}),Z<1/0&&Z>=0&&(ge=Q.substring(0,Z+1))}(),de=this.tokenizer.inlineText(ge,O)){Q=Q.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(K=de.raw.slice(-1)),N=!0,Me=x[x.length-1],Me&&Me.type==="text"?(Me.raw+=de.raw,Me.text+=de.text):x.push(de);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},S(Re,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Re}(),ce=function(){function Re(me){this.options=me||fe.defaults}var be=Re.prototype;return be.code=function(Q,x,le){var de=(x||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Q,de);Me!=null&&Me!==Q&&(le=!0,Q=Me)}return Q=Q.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+p(de,!0)+'">'+(le?Q:p(Q,!0))+`</code></pre>
`:"<pre><code>"+(le?Q:p(Q,!0))+`</code></pre>
`},be.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},be.html=function(Q){return Q},be.heading=function(Q,x,le,de){if(this.options.headerIds){var Me=this.options.headerPrefix+de.slug(le);return"<h"+x+' id="'+Me+'">'+Q+"</h"+x+`>
`}return"<h"+x+">"+Q+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(Q,x,le){var de=x?"ol":"ul",Me=x&&le!==1?' start="'+le+'"':"";return"<"+de+Me+`>
`+Q+"</"+de+`>
`},be.listitem=function(Q){return"<li>"+Q+`</li>
`},be.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(Q){return"<p>"+Q+`</p>
`},be.table=function(Q,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+x+`</table>
`},be.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},be.tablecell=function(Q,x){var le=x.header?"th":"td",de=x.align?"<"+le+' align="'+x.align+'">':"<"+le+">";return de+Q+("</"+le+`>
`)},be.strong=function(Q){return"<strong>"+Q+"</strong>"},be.em=function(Q){return"<em>"+Q+"</em>"},be.codespan=function(Q){return"<code>"+Q+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(Q){return"<del>"+Q+"</del>"},be.link=function(Q,x,le){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<a href="'+p(Q)+'"';return x&&(de+=' title="'+x+'"'),de+=">"+le+"</a>",de},be.image=function(Q,x,le){if(Q=l(this.options.sanitize,this.options.baseUrl,Q),Q===null)return le;var de='<img src="'+Q+'" alt="'+le+'"';return x&&(de+=' title="'+x+'"'),de+=this.options.xhtml?"/>":">",de},be.text=function(Q){return Q},Re}(),ye=function(){function Re(){}var be=Re.prototype;return be.strong=function(Q){return Q},be.em=function(Q){return Q},be.codespan=function(Q){return Q},be.del=function(Q){return Q},be.html=function(Q){return Q},be.text=function(Q){return Q},be.link=function(Q,x,le){return""+le},be.image=function(Q,x,le){return""+le},be.br=function(){return""},Re}(),ke=function(){function Re(){this.seen={}}var be=Re.prototype;return be.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(Q,x){var le=Q,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[Q];do de++,le=Q+"-"+de;while(this.seen.hasOwnProperty(le))}return x||(this.seen[Q]=de,this.seen[le]=0),le},be.slug=function(Q,x){x===void 0&&(x={});var le=this.serialize(Q);return this.getNextSafeSlug(le,x.dryrun)},Re}(),he=function(){function Re(me){this.options=me||fe.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new ke}Re.parse=function(Q,x){var le=new Re(x);return le.parse(Q)},Re.parseInline=function(Q,x){var le=new Re(x);return le.parseInline(Q)};var be=Re.prototype;return be.parse=function(Q,x){x===void 0&&(x=!0);var le="",de,Me,ge,Se,Ce,N,K,j,H,Z,oe,Ee,Be,Ve,Ze,xe,at,nt,et,ut=Q.length;for(de=0;de<ut;de++){if(Z=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(et=this.options.extensions.renderers[Z.type].call({parser:this},Z),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){le+=et||"";continue}switch(Z.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,u(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(j="",K="",Se=Z.header.length,Me=0;Me<Se;Me++)K+=this.renderer.tablecell(this.parseInline(Z.header[Me].tokens),{header:!0,align:Z.align[Me]});for(j+=this.renderer.tablerow(K),H="",Se=Z.rows.length,Me=0;Me<Se;Me++){for(N=Z.rows[Me],K="",Ce=N.length,ge=0;ge<Ce;ge++)K+=this.renderer.tablecell(this.parseInline(N[ge].tokens),{header:!1,align:Z.align[ge]});H+=this.renderer.tablerow(K)}le+=this.renderer.table(j,H);continue}case"blockquote":{H=this.parse(Z.tokens),le+=this.renderer.blockquote(H);continue}case"list":{for(oe=Z.ordered,Ee=Z.start,Be=Z.loose,Se=Z.items.length,H="",Me=0;Me<Se;Me++)Ze=Z.items[Me],xe=Ze.checked,at=Ze.task,Ve="",Ze.task&&(nt=this.renderer.checkbox(xe),Be?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=nt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=nt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:nt}):Ve+=nt),Ve+=this.parse(Ze.tokens,Be),H+=this.renderer.listitem(Ve,at,xe);le+=this.renderer.list(H,oe,Ee);continue}case"html":{le+=this.renderer.html(Z.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(H=Z.tokens?this.parseInline(Z.tokens):Z.text;de+1<ut&&Q[de+1].type==="text";)Z=Q[++de],H+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);le+=x?this.renderer.paragraph(H):H;continue}default:{var je='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return le},be.parseInline=function(Q,x){x=x||this.renderer;var le="",de,Me,ge,Se=Q.length;for(de=0;de<Se;de++){if(Me=Q[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(ge=this.options.extensions.renderers[Me.type].call({parser:this},Me),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){le+=ge||"";continue}switch(Me.type){case"escape":{le+=x.text(Me.text);break}case"html":{le+=x.html(Me.text);break}case"link":{le+=x.link(Me.href,Me.title,this.parseInline(Me.tokens,x));break}case"image":{le+=x.image(Me.href,Me.title,Me.text);break}case"strong":{le+=x.strong(this.parseInline(Me.tokens,x));break}case"em":{le+=x.em(this.parseInline(Me.tokens,x));break}case"codespan":{le+=x.codespan(Me.text);break}case"br":{le+=x.br();break}case"del":{le+=x.del(this.parseInline(Me.tokens,x));break}case"text":{le+=x.text(Me.text);break}default:{var Ce='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return le},Re}();function ve(Re,be,me){if(typeof Re>"u"||Re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");if(typeof be=="function"&&(me=be,be=null),be=$({},ve.defaults,be||{}),b(be),me){var Q=be.highlight,x;try{x=re.lex(Re,be)}catch(Se){return me(Se)}var le=function(Ce){var N;if(!Ce)try{be.walkTokens&&ve.walkTokens(x,be.walkTokens),N=he.parse(x,be)}catch(K){Ce=K}return be.highlight=Q,Ce?me(Ce):me(null,N)};if(!Q||Q.length<3||(delete be.highlight,!x.length))return le();var de=0;ve.walkTokens(x,function(Se){Se.type==="code"&&(de++,setTimeout(function(){Q(Se.text,Se.lang,function(Ce,N){if(Ce)return le(Ce);N!=null&&N!==Se.text&&(Se.text=N,Se.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Me(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(Se.message+"",!0)+"</pre>";throw Se}try{var ge=re.lex(Re,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(ge,be.walkTokens)).then(function(){return he.parse(ge,be)}).catch(Me);ve.walkTokens(ge,be.walkTokens)}return he.parse(ge,be)}catch(Se){Me(Se)}}ve.options=ve.setOptions=function(Re){return $(ve.defaults,Re),g(ve.defaults),ve},ve.getDefaults=R,ve.defaults=fe.defaults,ve.use=function(){for(var Re=arguments.length,be=new Array(Re),me=0;me<Re;me++)be[me]=arguments[me];var Q=$.apply(void 0,[{}].concat(be)),x=ve.defaults.extensions||{renderers:{},childTokens:{}},le;be.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Se=x.renderers?x.renderers[ge.name]:null;Se?x.renderers[ge.name]=function(){for(var Ce=arguments.length,N=new Array(Ce),K=0;K<Ce;K++)N[K]=arguments[K];var j=ge.renderer.apply(this,N);return j===!1&&(j=Se.apply(this,N)),j}:x.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ge.level]?x[ge.level].unshift(ge.tokenizer):x[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?x.startBlock?x.startBlock.push(ge.start):x.startBlock=[ge.start]:ge.level==="inline"&&(x.startInline?x.startInline.push(ge.start):x.startInline=[ge.start]))}ge.childTokens&&(x.childTokens[ge.name]=ge.childTokens)})),de.renderer&&function(){var ge=ve.defaults.renderer||new ce,Se=function(K){var j=ge[K];ge[K]=function(){for(var H=arguments.length,Z=new Array(H),oe=0;oe<H;oe++)Z[oe]=arguments[oe];var Ee=de.renderer[K].apply(ge,Z);return Ee===!1&&(Ee=j.apply(ge,Z)),Ee}};for(var Ce in de.renderer)Se(Ce);Q.renderer=ge}(),de.tokenizer&&function(){var ge=ve.defaults.tokenizer||new W,Se=function(K){var j=ge[K];ge[K]=function(){for(var H=arguments.length,Z=new Array(H),oe=0;oe<H;oe++)Z[oe]=arguments[oe];var Ee=de.tokenizer[K].apply(ge,Z);return Ee===!1&&(Ee=j.apply(ge,Z)),Ee}};for(var Ce in de.tokenizer)Se(Ce);Q.tokenizer=ge}(),de.walkTokens){var Me=ve.defaults.walkTokens;Q.walkTokens=function(ge){var Se=[];return Se.push(de.walkTokens.call(this,ge)),Me&&(Se=Se.concat(Me.call(this,ge))),Se}}le&&(Q.extensions=x),ve.setOptions(Q)})},ve.walkTokens=function(Re,be){for(var me=[],Q=function(){var Me=le.value;switch(me=me.concat(be.call(ve,Me)),Me.type){case"table":{for(var ge=L(Me.header),Se;!(Se=ge()).done;){var Ce=Se.value;me=me.concat(ve.walkTokens(Ce.tokens,be))}for(var N=L(Me.rows),K;!(K=N()).done;)for(var j=K.value,H=L(j),Z;!(Z=H()).done;){var oe=Z.value;me=me.concat(ve.walkTokens(oe.tokens,be))}break}case"list":{me=me.concat(ve.walkTokens(Me.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Me.type]?ve.defaults.extensions.childTokens[Me.type].forEach(function(Ee){me=me.concat(ve.walkTokens(Me[Ee],be))}):Me.tokens&&(me=me.concat(ve.walkTokens(Me.tokens,be)))}},x=L(Re),le;!(le=x()).done;)Q();return me},ve.parseInline=function(Re,be){if(typeof Re>"u"||Re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Re)+", string expected");be=$({},ve.defaults,be||{}),b(be);try{var me=re.lexInline(Re,be);return be.walkTokens&&ve.walkTokens(me,be.walkTokens),he.parseInline(me,be)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(Q.message+"",!0)+"</pre>";throw Q}},ve.Parser=he,ve.parser=he.parse,ve.Renderer=ce,ve.TextRenderer=ye,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=W,ve.Slugger=ke,ve.parse=ve;var se=ve.options,$e=ve.setOptions,te=ve.use,Y=ve.walkTokens,q=ve.parseInline,ne=ve,Pe=he.parse,Oe=re.lex;fe.Lexer=re,fe.Parser=he,fe.Renderer=ce,fe.Slugger=ke,fe.TextRenderer=ye,fe.Tokenizer=W,fe.getDefaults=R,fe.lexer=Oe,fe.marked=ve,fe.options=se,fe.parse=ne,fe.parseInline=q,fe.parser=Pe,fe.setOptions=$e,fe.use=te,fe.walkTokens=Y,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Fe[122],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=void 0;function S(s){const u=L(s);if(u&&u.length>0)return new Uint32Array(u)}e.$1j=S;let F=0;const P=new Uint32Array(10);function L(s){if(F=0,R(s,k,4352),F>0||(R(s,h,4449),F>0)||(R(s,v,4520),F>0)||(R(s,p,12593),F))return P.subarray(0,F);if(s>=44032&&s<=55203){const u=s-44032,r=u%588,i=Math.floor(u/588),n=Math.floor(r/28),o=r%28-1;if(i<k.length?R(i,k,0):4352+i-12593<p.length&&R(4352+i,p,12593),n<h.length?R(n,h,0):4449+n-12593<p.length&&R(4449+n-12593,p,12593),o>=0&&(o<v.length?R(o,v,0):4520+o-12593<p.length&&R(4520+o-12593,p,12593)),F>0)return P.subarray(0,F)}}function R(s,u,r){s>=r&&s<r+u.length&&g(u[s-r])}function g(s){s!==0&&(P[F++]=s&255,s>>8&&(P[F++]=s>>8&255),s>>16&&(P[F++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var D;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(D||(D={}));var A;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),h=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),v=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Fe[123],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.rot=e.$dm=void 0;function S(g,f,D){return Math.min(Math.max(g,f),D)}e.$dm=S;function F(g,f){return(f+g%f)%f}e.rot=F;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$fm=P;class L{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$gm=L;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const D=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$hm=R}),function(){function fe(P){const L=[];typeof P=="number"&&L.push("code/timeOrigin",P);function R(f){L.push(f,Date.now())}function g(){const f=[];for(let D=0;D<L.length;D+=2)f.push({name:L[D],startTime:L[D+1]});return f}return{mark:R,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(P+R.startTime)});return L}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=S(F))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var F in S)(typeof exports=="object"?exports:fe)[F]=S[F]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function S(F){if(e[F])return e[F].exports;var P=e[F]={i:F,l:!1,exports:{}};return fe[F].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=fe,S.c=e,S.d=function(F,P,L){S.o(F,P)||Object.defineProperty(F,P,{enumerable:!0,get:L})},S.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},S.t=function(F,P){if(1&P&&(F=S(F)),8&P||4&P&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(S.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&P&&typeof F!="string")for(var R in F)S.d(L,R,function(g){return F[g]}.bind(null,R));return L},S.n=function(F){var P=F&&F.__esModule?function(){return F.default}:function(){return F};return S.d(P,"a",P),P},S.o=function(F,P){return Object.prototype.hasOwnProperty.call(F,P)},S.p="",S(S.s=0)}([function(fe,e,S){(function(F){var P;e=fe.exports=te,P=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],f=e.src=[],D=0,A=D++;f[A]="0|[1-9]\\d*";var k=D++;f[k]="[0-9]+";var h=D++;f[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=D++;f[v]="("+f[A]+")\\.("+f[A]+")\\.("+f[A]+")";var p=D++;f[p]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var s=D++;f[s]="(?:"+f[A]+"|"+f[h]+")";var u=D++;f[u]="(?:"+f[k]+"|"+f[h]+")";var r=D++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var i=D++;f[i]="(?:-?("+f[u]+"(?:\\."+f[u]+")*))";var n=D++;f[n]="[0-9A-Za-z-]+";var o=D++;f[o]="(?:\\+("+f[n]+"(?:\\."+f[n]+")*))";var l=D++,t="v?"+f[v]+f[r]+"?"+f[o]+"?";f[l]="^"+t+"$";var m="[v=\\s]*"+f[p]+f[i]+"?"+f[o]+"?",a=D++;f[a]="^"+m+"$";var c=D++;f[c]="((?:<|>)?=?)";var E=D++;f[E]=f[k]+"|x|X|\\*";var y=D++;f[y]=f[A]+"|x|X|\\*";var $=D++;f[$]="[v=\\s]*("+f[y]+")(?:\\.("+f[y]+")(?:\\.("+f[y]+")(?:"+f[r]+")?"+f[o]+"?)?)?";var I=D++;f[I]="[v=\\s]*("+f[E]+")(?:\\.("+f[E]+")(?:\\.("+f[E]+")(?:"+f[i]+")?"+f[o]+"?)?)?";var d=D++;f[d]="^"+f[c]+"\\s*"+f[$]+"$";var w=D++;f[w]="^"+f[c]+"\\s*"+f[I]+"$";var b=D++;f[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=D++;f[M]="(?:~>?)";var T=D++;f[T]="(\\s*)"+f[M]+"\\s+",g[T]=new RegExp(f[T],"g");var G=D++;f[G]="^"+f[M]+f[$]+"$";var W=D++;f[W]="^"+f[M]+f[I]+"$";var U=D++;f[U]="(?:\\^)";var C=D++;f[C]="(\\s*)"+f[U]+"\\s+",g[C]=new RegExp(f[C],"g");var O=D++;f[O]="^"+f[U]+f[$]+"$";var V=D++;f[V]="^"+f[U]+f[I]+"$";var re=D++;f[re]="^"+f[c]+"\\s*("+m+")$|^$";var ce=D++;f[ce]="^"+f[c]+"\\s*("+t+")$|^$";var ye=D++;f[ye]="(\\s*)"+f[c]+"\\s*("+m+"|"+f[$]+")",g[ye]=new RegExp(f[ye],"g");var ke=D++;f[ke]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var he=D++;f[he]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=D++;f[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)P(se,f[se]),g[se]||(g[se]=new RegExp(f[se]));function $e(j,H){if(j instanceof te)return j;if(typeof j!="string"||j.length>L||!(H?g[a]:g[l]).test(j))return null;try{return new te(j,H)}catch{return null}}function te(j,H){if(j instanceof te){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof te))return new te(j,H);P("SemVer",j,H),this.loose=H;var Z=j.trim().match(H?g[a]:g[l]);if(!Z)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var Ee=+oe;if(Ee>=0&&Ee<R)return Ee}return oe}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,H){var Z=$e(j,H);return Z?Z.version:null},e.clean=function(j,H){var Z=$e(j.trim().replace(/^[=v]+/,""),H);return Z?Z.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof te||(j=new te(j,this.loose)),this.compareMain(j)||this.comparePre(j)},te.prototype.compareMain=function(j){return j instanceof te||(j=new te(j,this.loose)),q(this.major,j.major)||q(this.minor,j.minor)||q(this.patch,j.patch)},te.prototype.comparePre=function(j){if(j instanceof te||(j=new te(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var Z=this.prerelease[H],oe=j.prerelease[H];if(P("prerelease compare",H,Z,oe),Z===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(Z===void 0)return-1;if(Z!==oe)return q(Z,oe)}while(++H)},te.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,Z,oe){typeof Z=="string"&&(oe=Z,Z=void 0);try{return new te(j,Z).inc(H,oe).version}catch{return null}},e.diff=function(j,H){if(Re(j,H))return null;var Z=$e(j),oe=$e(H);if(Z.prerelease.length||oe.prerelease.length){for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==oe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==oe[Ee])return Ee},e.compareIdentifiers=q;var Y=/^[0-9]+$/;function q(j,H){var Z=Y.test(j),oe=Y.test(H);return Z&&oe&&(j=+j,H=+H),Z&&!oe?-1:oe&&!Z?1:j<H?-1:j>H?1:0}function ne(j,H,Z){return new te(j,Z).compare(new te(H,Z))}function Pe(j,H,Z){return ne(j,H,Z)>0}function Oe(j,H,Z){return ne(j,H,Z)<0}function Re(j,H,Z){return ne(j,H,Z)===0}function be(j,H,Z){return ne(j,H,Z)!==0}function me(j,H,Z){return ne(j,H,Z)>=0}function Q(j,H,Z){return ne(j,H,Z)<=0}function x(j,H,Z,oe){var Ee;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Ee=j===Z;break;case"!==":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Ee=j!==Z;break;case"":case"=":case"==":Ee=Re(j,Z,oe);break;case"!=":Ee=be(j,Z,oe);break;case">":Ee=Pe(j,Z,oe);break;case">=":Ee=me(j,Z,oe);break;case"<":Ee=Oe(j,Z,oe);break;case"<=":Ee=Q(j,Z,oe);break;default:throw new TypeError("Invalid operator: "+H)}return Ee}function le(j,H){if(j instanceof le){if(j.loose===H)return j;j=j.value}if(!(this instanceof le))return new le(j,H);P("comparator",j,H),this.loose=H,this.parse(j),this.semver===de?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,H){return q(H,j)},e.major=function(j,H){return new te(j,H).major},e.minor=function(j,H){return new te(j,H).minor},e.patch=function(j,H){return new te(j,H).patch},e.compare=ne,e.compareLoose=function(j,H){return ne(j,H,!0)},e.rcompare=function(j,H,Z){return ne(H,j,Z)},e.sort=function(j,H){return j.sort(function(Z,oe){return e.compare(Z,oe,H)})},e.rsort=function(j,H){return j.sort(function(Z,oe){return e.rcompare(Z,oe,H)})},e.gt=Pe,e.lt=Oe,e.eq=Re,e.neq=be,e.gte=me,e.lte=Q,e.cmp=x,e.Comparator=le;var de={};function Me(j,H){if(j instanceof Me)return j.loose===H?j:new Me(j.raw,H);if(j instanceof le)return new Me(j.value,H);if(!(this instanceof Me))return new Me(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function ge(j){return!j||j.toLowerCase()==="x"||j==="*"}function Se(j,H,Z,oe,Ee,Be,Ve,Ze,xe,at,nt,et,ut){return((H=ge(Z)?"":ge(oe)?">="+Z+".0.0":ge(Ee)?">="+Z+"."+oe+".0":">="+H)+" "+(Ze=ge(xe)?"":ge(at)?"<"+(+xe+1)+".0.0":ge(nt)?"<"+xe+"."+(+at+1)+".0":et?"<="+xe+"."+at+"."+nt+"-"+et:"<="+Ze)).trim()}function Ce(j,H){for(var Z=0;Z<j.length;Z++)if(!j[Z].test(H))return!1;if(H.prerelease.length){for(Z=0;Z<j.length;Z++)if(P(j[Z].semver),j[Z].semver!==de&&j[Z].semver.prerelease.length>0){var oe=j[Z].semver;if(oe.major===H.major&&oe.minor===H.minor&&oe.patch===H.patch)return!0}return!1}return!0}function N(j,H,Z){try{H=new Me(H,Z)}catch{return!1}return H.test(j)}function K(j,H,Z,oe){var Ee,Be,Ve,Ze,xe;switch(j=new te(j,oe),H=new Me(H,oe),Z){case">":Ee=Pe,Be=Q,Ve=Oe,Ze=">",xe=">=";break;case"<":Ee=Oe,Be=me,Ve=Pe,Ze="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(N(j,H,oe))return!1;for(var at=0;at<H.set.length;++at){var nt=H.set[at],et=null,ut=null;if(nt.forEach(function(je){je.semver===de&&(je=new le(">=0.0.0")),et=et||je,ut=ut||je,Ee(je.semver,et.semver,oe)?et=je:Ve(je.semver,ut.semver,oe)&&(ut=je)}),et.operator===Ze||et.operator===xe||(!ut.operator||ut.operator===Ze)&&Be(j,ut.semver)||ut.operator===xe&&Ve(j,ut.semver))return!1}return!0}le.prototype.parse=function(j){var H=this.loose?g[re]:g[ce],Z=j.match(H);if(!Z)throw new TypeError("Invalid comparator: "+j);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new te(Z[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===de||(typeof j=="string"&&(j=new te(j,this.loose)),x(j,this.operator,this.semver,this.loose))},le.prototype.intersects=function(j,H){if(!(j instanceof le))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Me(j.value,H),N(this.value,Z,H);if(j.operator==="")return Z=new Me(this.value,H),N(j.semver,Z,H);var oe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Be=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ze=x(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=x(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return oe||Ee||Be&&Ve||Ze||xe},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),P("range",j,H);var Z=H?g[he]:g[ke];j=j.replace(Z,Se),P("hyphen replace",j),j=j.replace(g[ye],"$1$2$3"),P("comparator trim",j,g[ye]),j=(j=(j=j.replace(g[T],"$1~")).replace(g[C],"$1^")).split(/\s+/).join(" ");var oe=H?g[re]:g[ce],Ee=j.split(" ").map(function(Be){return function(Ve,Ze){return P("comp",Ve),Ve=function(xe,at){return xe.trim().split(/\s+/).map(function(nt){return function(et,ut){P("caret",et,ut);var je=ut?g[V]:g[O];return et.replace(je,function(pt,X,_,pe,We){var Qe;return P("caret",et,pt,X,_,pe,We),ge(X)?Qe="":ge(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":ge(pe)?Qe=X==="0"?">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":">="+X+"."+_+".0 <"+(+X+1)+".0.0":We?(P("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+We+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+We+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+We+" <"+(+X+1)+".0.0"):(P("no pr"),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+" <"+(+X+1)+".0.0"),P("caret return",Qe),Qe})}(nt,at)}).join(" ")}(Ve,Ze),P("caret",Ve),Ve=function(xe,at){return xe.trim().split(/\s+/).map(function(nt){return function(et,ut){var je=ut?g[W]:g[G];return et.replace(je,function(pt,X,_,pe,We){var Qe;return P("tilde",et,pt,X,_,pe,We),ge(X)?Qe="":ge(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":ge(pe)?Qe=">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":We?(P("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Qe=">="+X+"."+_+"."+pe+We+" <"+X+"."+(+_+1)+".0"):Qe=">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0",P("tilde return",Qe),Qe})}(nt,at)}).join(" ")}(Ve,Ze),P("tildes",Ve),Ve=function(xe,at){return P("replaceXRanges",xe,at),xe.split(/\s+/).map(function(nt){return function(et,ut){et=et.trim();var je=ut?g[w]:g[d];return et.replace(je,function(pt,X,_,pe,We,Qe){P("xRange",et,pt,X,_,pe,We,Qe);var it=ge(_),rt=it||ge(pe),Te=rt||ge(We);return X==="="&&Te&&(X=""),it?pt=X===">"||X==="<"?"<0.0.0":"*":X&&Te?(rt&&(pe=0),Te&&(We=0),X===">"?(X=">=",rt?(_=+_+1,pe=0,We=0):Te&&(pe=+pe+1,We=0)):X==="<="&&(X="<",rt?_=+_+1:pe=+pe+1),pt=X+_+"."+pe+"."+We):rt?pt=">="+_+".0.0 <"+(+_+1)+".0.0":Te&&(pt=">="+_+"."+pe+".0 <"+_+"."+(+pe+1)+".0"),P("xRange return",pt),pt})}(nt,at)}).join(" ")}(Ve,Ze),P("xrange",Ve),Ve=function(xe,at){return P("replaceStars",xe,at),xe.trim().replace(g[ve],"")}(Ve,Ze),P("stars",Ve),Ve}(Be,H)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Be){return!!Be.match(oe)})),Ee=Ee.map(function(Be){return new le(Be,H)})},Me.prototype.intersects=function(j,H){if(!(j instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(oe){return j.set.some(function(Ee){return Ee.every(function(Be){return oe.intersects(Be,H)})})})})},e.toComparators=function(j,H){return new Me(j,H).set.map(function(Z){return Z.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new te(j,this.loose));for(var H=0;H<this.set.length;H++)if(Ce(this.set[H],j))return!0;return!1},e.satisfies=N,e.maxSatisfying=function(j,H,Z){var oe=null,Ee=null;try{var Be=new Me(H,Z)}catch{return null}return j.forEach(function(Ve){Be.test(Ve)&&(oe&&Ee.compare(Ve)!==-1||(Ee=new te(oe=Ve,Z)))}),oe},e.minSatisfying=function(j,H,Z){var oe=null,Ee=null;try{var Be=new Me(H,Z)}catch{return null}return j.forEach(function(Ve){Be.test(Ve)&&(oe&&Ee.compare(Ve)!==1||(Ee=new te(oe=Ve,Z)))}),oe},e.validRange=function(j,H){try{return new Me(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,Z){return K(j,H,"<",Z)},e.gtr=function(j,H,Z){return K(j,H,">",Z)},e.outside=K,e.prerelease=function(j,H){var Z=$e(j,H);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(j,H,Z){return j=new Me(j,Z),H=new Me(H,Z),j.intersects(H)},e.coerce=function(j){if(j instanceof te)return j;if(typeof j!="string")return null;var H=j.match(g[b]);return H==null?null:$e((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(fe,e){var S,F,P=fe.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function g(u){if(S===setTimeout)return setTimeout(u,0);if((S===L||!S)&&setTimeout)return S=setTimeout,setTimeout(u,0);try{return S(u,0)}catch{try{return S.call(null,u,0)}catch{return S.call(this,u,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:L}catch{S=L}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var f,D=[],A=!1,k=-1;function h(){A&&f&&(A=!1,f.length?D=f.concat(D):k=-1,D.length&&v())}function v(){if(!A){var u=g(h);A=!0;for(var r=D.length;r;){for(f=D,D=[];++k<r;)f&&f[k].run();k=-1,r=D.length}f=null,A=!1,function(i){if(F===clearTimeout)return clearTimeout(i);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(i);try{F(i)}catch{try{return F.call(null,i)}catch{return F.call(this,i)}}}(u)}}function p(u,r){this.fun=u,this.array=r}function s(){}P.nextTick=function(u){var r=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)r[i-1]=arguments[i];D.push(new p(u,r)),D.length!==1||A||g(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(u){return[]},P.binding=function(u){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(u){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Fe[124],Le([1,0,15,6]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;function P(o){const l=o;return l?typeof l.read=="function":!1}e.$be=P;function L(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}e.$ce=L;function R(o){const l=o;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$de=R;function g(o,l){return new f(o,l)}e.$ee=g;class f{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,S.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let m;switch(l){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const a=m.indexOf(t);a>=0&&m.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(o,l){const t=[];let m;for(;(m=o.read())!==null;)t.push(m);return l(t)}e.$fe=D;function A(o,l,t){const m=[];let a;for(;(a=o.read())!==null&&m.length<t;)m.push(a);return a===null&&m.length>0?l(m):{read:()=>{if(m.length>0)return m.shift();if(typeof a<"u"){const c=a;return a=void 0,c}return o.read()}}}e.$ge=A;function k(o,l){return new Promise((t,m)=>{const a=[];h(o,{onData:c=>{l&&a.push(c)},onError:c=>{l?m(c):t(void 0)},onEnd:()=>{t(l?l(a):void 0)}})})}e.$he=k;function h(o,l,t){o.on("error",m=>{t?.isCancellationRequested||l.onError(m)}),o.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),o.on("data",m=>{t?.isCancellationRequested||l.onData(m)})}e.$ie=h;function v(o,l){return new Promise((t,m)=>{const a=new F.$Sc,c=[],E=I=>{if(c.push(I),c.length>l)return a.dispose(),o.pause(),t({stream:o,buffer:c,ended:!1})},y=I=>(a.dispose(),m(I)),$=()=>(a.dispose(),t({stream:o,buffer:c,ended:!0}));a.add((0,F.$Rc)(()=>o.removeListener("error",y))),o.on("error",y),a.add((0,F.$Rc)(()=>o.removeListener("end",$))),o.on("end",$),a.add((0,F.$Rc)(()=>o.removeListener("data",E))),o.on("data",E)})}e.$je=v;function p(o,l){const t=g(l);return t.end(o),t}e.$ke=p;function s(){const o=g(()=>{throw new Error("not supported")});return o.end(),o}e.$le=s;function u(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$me=u;function r(o,l,t){const m=g(t);return h(o,{onData:a=>m.write(l.data(a)),onError:a=>m.error(l.error?l.error(a):a),onEnd:()=>m.end()}),m}e.$ne=r;function i(o,l,t){let m=!1;return{read:()=>{const a=l.read();return m?a:(m=!0,a!==null?t([o,a]):o)}}}e.$oe=i;function n(o,l,t){let m=!1;const a=g(t);return h(l,{onData:c=>m?a.write(c):(m=!0,a.write(t([o,c]))),onError:c=>a.error(c),onEnd:()=>{m||(m=!0,a.write(o)),a.end()}}),a}e.$pe=n}),define(Fe[24],Le([1,0,39,124]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=void 0;const P=typeof Buffer<"u",L=new S.$V(()=>new Uint8Array(256));let R,g;class f{static alloc(b){return P?new f(Buffer.allocUnsafe(b)):new f(new Uint8Array(b))}static wrap(b){return P&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new f(b)}static fromString(b,M){return!(M?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(b)):(R||(R=new TextEncoder),new f(R.encode(b)))}static fromByteArray(b){const M=f.alloc(b.length);for(let T=0,G=b.length;T<G;T++)M.buffer[T]=b[T];return M}static concat(b,M){if(typeof M>"u"){M=0;for(let W=0,U=b.length;W<U;W++)M+=b[W].byteLength}const T=f.alloc(M);let G=0;for(let W=0,U=b.length;W<U;W++){const C=b[W];T.set(C,G),G+=C.byteLength}return T}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=f.alloc(this.byteLength);return b.set(this),b}toString(){return P?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(b,M){return new f(this.buffer.subarray(b,M))}set(b,M){if(b instanceof f)this.buffer.set(b.buffer,M);else if(b instanceof Uint8Array)this.buffer.set(b,M);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),M);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return h(this.buffer,b)}writeUInt32BE(b,M){v(this.buffer,b,M)}readUInt32LE(b){return p(this.buffer,b)}writeUInt32LE(b,M){s(this.buffer,b,M)}readUInt8(b){return u(this.buffer,b)}writeUInt8(b,M){r(this.buffer,b,M)}indexOf(b,M=0){return D(this.buffer,b instanceof f?b.buffer:b,M)}}e.$qe=f;function D(w,b,M=0){const T=b.byteLength,G=w.byteLength;if(T===0)return 0;if(T===1)return w.indexOf(b[0]);if(T>G-M)return-1;const W=L.value;W.fill(b.length);for(let V=0;V<b.length;V++)W[b[V]]=b.length-V-1;let U=M+b.length-1,C=U,O=-1;for(;U<G;)if(w[U]===b[C]){if(C===0){O=U;break}U--,C--}else U+=Math.max(b.length-C,W[w[U]]),C=b.length-1;return O}e.$re=D;function A(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0}e.$se=A;function k(w,b,M){w[M+0]=b&255,b=b>>>8,w[M+1]=b&255}e.$te=k;function h(w,b){return w[b]*2**24+w[b+1]*2**16+w[b+2]*2**8+w[b+3]}e.$ue=h;function v(w,b,M){w[M+3]=b,b=b>>>8,w[M+2]=b,b=b>>>8,w[M+1]=b,b=b>>>8,w[M]=b}e.$ve=v;function p(w,b){return w[b+0]<<0>>>0|w[b+1]<<8>>>0|w[b+2]<<16>>>0|w[b+3]<<24>>>0}e.$we=p;function s(w,b,M){w[M+0]=b&255,b=b>>>8,w[M+1]=b&255,b=b>>>8,w[M+2]=b&255,b=b>>>8,w[M+3]=b&255}e.$xe=s;function u(w,b){return w[b]}e.$ye=u;function r(w,b,M){w[M]=b}e.$ze=r;function i(w){return F.$fe(w,b=>f.concat(b))}e.$Ae=i;function n(w){return F.$me(w)}e.$Be=n;function o(w){return F.$he(w,b=>f.concat(b))}e.$Ce=o;async function l(w){return w.ended?f.concat(w.buffer):f.concat([...w.buffer,await o(w.stream)])}e.$De=l;function t(w){return F.$ke(w,b=>f.concat(b))}e.$Ee=t;function m(w){return F.$ne(w,{data:b=>typeof b=="string"?f.fromString(b):f.wrap(b)},b=>f.concat(b))}e.$Fe=m;function a(w){return F.$ee(b=>f.concat(b),w)}e.$Ge=a;function c(w,b){return F.$oe(w,b,M=>f.concat(M))}e.$He=c;function E(w,b){return F.$pe(w,b,M=>f.concat(M))}e.$Ie=E;function y(w){let b=0,M=0,T=0;const G=new Uint8Array(Math.floor(w.length/4*3)),W=C=>{switch(M){case 3:G[T++]=b|C,M=0;break;case 2:G[T++]=b|C>>>2,b=C<<6,M=3;break;case 1:G[T++]=b|C>>>4,b=C<<4,M=2;break;default:b=C<<2,M=1}};for(let C=0;C<w.length;C++){const O=w.charCodeAt(C);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[C]}`)}}const U=T;for(;M>0;)W(0);return f.wrap(G).slice(0,U)}e.$Je=y;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:w},b=!0,M=!1){const T=M?I:$;let G="";const W=w.byteLength%3;let U=0;for(;U<w.byteLength-W;U+=3){const C=w[U+0],O=w[U+1],V=w[U+2];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[(O<<2|V>>>6)&63],G+=T[V&63]}if(W===1){const C=w[U+0];G+=T[C>>>2],G+=T[C<<4&63],b&&(G+="==")}else if(W===2){const C=w[U+0],O=w[U+1];G+=T[C>>>2],G+=T[(C<<4|O>>>4)&63],G+=T[O<<2&63],b&&(G+="=")}return G}e.$Ke=d}),define(Fe[125],Le([1,0,28,122,13]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fk=e.$ek=e.$dk=e.$ck=e.FuzzyScore=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.or=void 0;function L(...ge){return function(Se,Ce){for(let N=0,K=ge.length;N<K;N++){const j=ge[N](Se,Ce);if(j)return j}return null}}e.or=L,e.$3j=R.bind(void 0,!1),e.$4j=R.bind(void 0,!0);function R(ge,Se,Ce){if(!Ce||Ce.length<Se.length)return null;let N;return ge?N=P.$if(Ce,Se):N=Ce.indexOf(Se)===0,N?Se.length>0?[{start:0,end:Se.length}]:[]:null}function g(ge,Se){const Ce=Se.toLowerCase().indexOf(ge.toLowerCase());return Ce===-1?null:[{start:Ce,end:Ce+ge.length}]}e.$5j=g;function f(ge,Se){return D(ge.toLowerCase(),Se.toLowerCase(),0,0)}e.$6j=f;function D(ge,Se,Ce,N){if(Ce===ge.length)return[];if(N===Se.length)return null;if(ge[Ce]===Se[N]){let K=null;return(K=D(ge,Se,Ce+1,N+1))?o({start:N,end:N+1},K):null}return D(ge,Se,Ce,N+1)}function A(ge){return 97<=ge&&ge<=122}function k(ge){return 65<=ge&&ge<=90}e.$7j=k;function h(ge){return 48<=ge&&ge<=57}function v(ge){return ge===32||ge===9||ge===10||ge===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ge=>p.add(ge.charCodeAt(0)));function s(ge){return v(ge)||p.has(ge)}function u(ge,Se){return ge===Se||s(ge)&&s(Se)}const r=new Map;function i(ge){if(r.has(ge))return r.get(ge);let Se;const Ce=(0,F.$1j)(ge);return Ce&&(Se=Ce),r.set(ge,Se),Se}function n(ge){return A(ge)||k(ge)||h(ge)}function o(ge,Se){return Se.length===0?Se=[ge]:ge.end===Se[0].start?Se[0].start=ge.start:Se.unshift(ge),Se}function l(ge,Se){for(let Ce=Se;Ce<ge.length;Ce++){const N=ge.charCodeAt(Ce);if(k(N)||h(N)||Ce>0&&!n(ge.charCodeAt(Ce-1)))return Ce}return ge.length}function t(ge,Se,Ce,N){if(Ce===ge.length)return[];if(N===Se.length)return null;if(ge[Ce]!==Se[N].toLowerCase())return null;{let K=null,j=N+1;for(K=t(ge,Se,Ce+1,N+1);!K&&(j=l(Se,j))<Se.length;)K=t(ge,Se,Ce+1,j),j++;return K===null?null:o({start:N,end:N+1},K)}}function m(ge){let Se=0,Ce=0,N=0,K=0,j=0;for(let Be=0;Be<ge.length;Be++)j=ge.charCodeAt(Be),k(j)&&Se++,A(j)&&Ce++,n(j)&&N++,h(j)&&K++;const H=Se/ge.length,Z=Ce/ge.length,oe=N/ge.length,Ee=K/ge.length;return{upperPercent:H,lowerPercent:Z,alphaPercent:oe,numericPercent:Ee}}function a(ge){const{upperPercent:Se,lowerPercent:Ce}=ge;return Ce===0&&Se>.6}function c(ge){const{upperPercent:Se,lowerPercent:Ce,alphaPercent:N,numericPercent:K}=ge;return Ce>.2&&Se<.8&&N>.6&&K<.2}function E(ge){let Se=0,Ce=0,N=0,K=0;for(let j=0;j<ge.length;j++)N=ge.charCodeAt(j),k(N)&&Se++,A(N)&&Ce++,v(N)&&K++;return(Se===0||Ce===0)&&K===0?ge.length<=30:Se<=5}function y(ge,Se){if(!Se||(Se=Se.trim(),Se.length===0)||!E(ge))return null;Se.length>60&&(Se=Se.substring(0,60));const Ce=m(Se);if(!c(Ce)){if(!a(Ce))return null;Se=Se.toLowerCase()}let N=null,K=0;for(ge=ge.toLowerCase();K<Se.length&&(N=t(ge,Se,0,K))===null;)K=l(Se,K+1);return N}e.$8j=y;function $(ge,Se,Ce=!1){if(!Se||Se.length===0)return null;let N=null,K=0;for(ge=ge.toLowerCase(),Se=Se.toLowerCase();K<Se.length&&(N=I(ge,Se,0,K,Ce),N===null);)K=d(Se,K+1);return N}e.$9j=$;function I(ge,Se,Ce,N,K){let j=0;if(Ce===ge.length)return[];if(N===Se.length)return null;if(!u(ge.charCodeAt(Ce),Se.charCodeAt(N))){const oe=i(ge.charCodeAt(Ce));if(!oe)return null;for(let Ee=0;Ee<oe.length;Ee++)if(!u(oe[Ee],Se.charCodeAt(N+Ee)))return null;j+=oe.length-1}let H=null,Z=N+j+1;if(H=I(ge,Se,Ce+1,Z,K),!K)for(;!H&&(Z=d(Se,Z))<Se.length;)H=I(ge,Se,Ce+1,Z,K),Z++;if(!H)return null;if(ge.charCodeAt(Ce)!==Se.charCodeAt(N)){const oe=i(ge.charCodeAt(Ce));if(!oe)return H;for(let Ee=0;Ee<oe.length;Ee++)if(oe[Ee]!==Se.charCodeAt(N+Ee))return H}return o({start:N,end:N+j+1},H)}function d(ge,Se){for(let Ce=Se;Ce<ge.length;Ce++)if(s(ge.charCodeAt(Ce))||Ce>0&&s(ge.charCodeAt(Ce-1)))return Ce;return ge.length}const w=L(e.$4j,y,g),b=L(e.$4j,y,f),M=new S.$Dc(1e4);function T(ge,Se,Ce=!1){if(typeof ge!="string"||typeof Se!="string")return null;let N=M.get(ge);N||(N=new RegExp(P.$3e(ge),"i"),M.set(ge,N));const K=N.exec(Se);return K?[{start:K.index,end:K.index+K[0].length}]:Ce?b(ge,Se):w(ge,Se)}e.$0j=T;function G(ge,Se){const Ce=be(ge,ge.toLowerCase(),0,Se,Se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ce?U(Ce):null}e.$$j=G;function W(ge,Se,Ce,N,K,j){const H=Math.min(13,ge.length);for(;Ce<H;Ce++){const Z=be(ge,Se,Ce,N,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,j]}e.$_j=W;function U(ge){if(typeof ge>"u")return[];const Se=[],Ce=ge[1];for(let N=ge.length-1;N>1;N--){const K=ge[N]+Ce,j=Se[Se.length-1];j&&j.end===K?j.end=K+1:Se.push({start:K,end:K+1})}return Se}e.$ak=U;const C=128;function O(){const ge=[],Se=[];for(let Ce=0;Ce<=C;Ce++)Se[Ce]=0;for(let Ce=0;Ce<=C;Ce++)ge.push(Se.slice(0));return ge}function V(ge){const Se=[];for(let Ce=0;Ce<=ge;Ce++)Se[Ce]=0;return Se}const re=V(2*C),ce=V(2*C),ye=O(),ke=O(),he=O(),ve=!1;function se(ge,Se,Ce,N,K){function j(Z,oe,Ee=" "){for(;Z.length<oe;)Z=Ee+Z;return Z}let H=` |   |${N.split("").map(Z=>j(Z,3)).join("|")}
`;for(let Z=0;Z<=Ce;Z++)Z===0?H+=" |":H+=`${Se[Z-1]}|`,H+=ge[Z].slice(0,K+1).map(oe=>j(oe.toString(),3)).join("|")+`
`;return H}function $e(ge,Se,Ce,N){ge=ge.substr(Se),Ce=Ce.substr(N),console.log(se(ke,ge,ge.length,Ce,Ce.length)),console.log(se(he,ge,ge.length,Ce,Ce.length)),console.log(se(ye,ge,ge.length,Ce,Ce.length))}function te(ge,Se){if(Se<0||Se>=ge.length)return!1;const Ce=ge.codePointAt(Se);switch(Ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Af(Ce)}}function Y(ge,Se){if(Se<0||Se>=ge.length)return!1;switch(ge.charCodeAt(Se)){case 32:case 9:return!0;default:return!1}}function q(ge,Se,Ce){return Se[ge]!==Ce[ge]}function ne(ge,Se,Ce,N,K,j,H=!1){for(;Se<Ce&&K<j;)ge[Se]===N[K]&&(H&&(re[Se]=K),Se+=1),K+=1;return Se===Ce}e.$bk=ne;var Pe;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Pe||(Pe={}));var Oe;(function(ge){ge.Default=[-100,0];function Se(Ce){return!Ce||Ce.length===2&&Ce[0]===-100&&Ce[1]===0}ge.isDefault=Se})(Oe||(e.FuzzyScore=Oe={}));class Re{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Se,Ce){this.firstMatchCanBeWeak=Se,this.boostFullMatch=Ce}}e.$ck=Re;function be(ge,Se,Ce,N,K,j,H=Re.default){const Z=ge.length>C?C:ge.length,oe=N.length>C?C:N.length;if(Ce>=Z||j>=oe||Z-Ce>oe-j||!ne(Se,Ce,Z,K,j,oe,!0))return;me(Z,oe,Ce,j,Se,K);let Ee=1,Be=1,Ve=Ce,Ze=j;const xe=[!1];for(Ee=1,Ve=Ce;Ve<Z;Ee++,Ve++){const je=re[Ve],pt=ce[Ve],X=Ve+1<Z?ce[Ve+1]:oe;for(Be=je-j+1,Ze=je;Ze<X;Be++,Ze++){let _=Number.MIN_SAFE_INTEGER,pe=!1;Ze<=pt&&(_=Q(ge,Se,Ve,Ce,N,K,Ze,oe,j,ye[Ee-1][Be-1]===0,xe));let We=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,We=_+ke[Ee-1][Be-1]);const Qe=Ze>je,it=Qe?ke[Ee][Be-1]+(ye[Ee][Be-1]>0?-5:0):0,rt=Ze>je+1&&ye[Ee][Be-1]>0,Te=rt?ke[Ee][Be-2]+(ye[Ee][Be-2]>0?-5:0):0;if(rt&&(!Qe||Te>=it)&&(!pe||Te>=We))ke[Ee][Be]=Te,he[Ee][Be]=3,ye[Ee][Be]=0;else if(Qe&&(!pe||it>=We))ke[Ee][Be]=it,he[Ee][Be]=2,ye[Ee][Be]=0;else if(pe)ke[Ee][Be]=We,he[Ee][Be]=1,ye[Ee][Be]=ye[Ee-1][Be-1]+1;else throw new Error("not possible")}}if(ve&&$e(ge,Ce,N,j),!xe[0]&&!H.firstMatchCanBeWeak)return;Ee--,Be--;const at=[ke[Ee][Be],j];let nt=0,et=0;for(;Ee>=1;){let je=Be;do{const pt=he[Ee][je];if(pt===3)je=je-2;else if(pt===2)je=je-1;else break}while(je>=1);nt>1&&Se[Ce+Ee-1]===K[j+Be-1]&&!q(je+j-1,N,K)&&nt+1>ye[Ee][je]&&(je=Be),je===Be?nt++:nt=1,et||(et=je),Ee--,Be=je-1,at.push(Be)}oe===Z&&H.boostFullMatch&&(at[0]+=2);const ut=et-Z;return at[0]-=ut,at}e.$dk=be;function me(ge,Se,Ce,N,K,j){let H=ge-1,Z=Se-1;for(;H>=Ce&&Z>=N;)K[H]===j[Z]&&(ce[H]=Z,H--),Z--}function Q(ge,Se,Ce,N,K,j,H,Z,oe,Ee,Be){if(Se[Ce]!==j[H])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return H===Ce-N?Ve=ge[Ce]===K[H]?7:5:q(H,K,j)&&(H===0||!q(H-1,K,j))?(Ve=ge[Ce]===K[H]?7:5,Ze=!0):te(j,H)&&(H===0||!te(j,H-1))?Ve=5:(te(j,H-1)||Y(j,H-1))&&(Ve=5,Ze=!0),Ve>1&&Ce===N&&(Be[0]=!0),Ze||(Ze=q(H,K,j)||te(j,H-1)||Y(j,H-1)),Ce===N?H>oe&&(Ve-=Ze?3:5):Ee?Ve+=Ze?2:0:Ve+=Ze?0:1,H+1===Z&&(Ve-=Ze?3:5),Ve}function x(ge,Se,Ce,N,K,j,H){return de(ge,Se,Ce,N,K,j,!0,H)}e.$ek=x;function le(ge,Se,Ce,N,K,j,H){return de(ge,Se,Ce,N,K,j,!1,H)}e.$fk=le;function de(ge,Se,Ce,N,K,j,H,Z){let oe=be(ge,Se,Ce,N,K,j,Z);if(oe&&!H)return oe;if(ge.length>=3){const Ee=Math.min(7,ge.length-1);for(let Be=Ce+1;Be<Ee;Be++){const Ve=Me(ge,Be);if(Ve){const Ze=be(Ve,Ve.toLowerCase(),Ce,N,K,j,Z);Ze&&(Ze[0]-=3,(!oe||Ze[0]>oe[0])&&(oe=Ze))}}}return oe}function Me(ge,Se){if(Se+1>=ge.length)return;const Ce=ge[Se],N=ge[Se+1];if(Ce!==N)return ge.slice(0,Se)+N+Ce+ge.slice(Se+2)}}),define(Fe[32],Le([1,0,13]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(F||(F={})),function(P){const L="error",R="warning",g="warn",f="info",D="ignore";function A(h){return h?S.$hf(L,h)?P.Error:S.$hf(R,h)||S.$hf(g,h)?P.Warning:S.$hf(f,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=A;function k(h){switch(h){case P.Error:return L;case P.Warning:return R;case P.Info:return f;default:return D}}P.toString=k}(F||(F={})),e.default=F}),define(Fe[126],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=void 0,e.$Zd=Symbol("MicrotaskDelay")}),define(Fe[51],Le([1,0,18,13]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0;class P{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const p=v.charCodeAt(0),s=this.b.charCodeAt(this.c);return p-s}value(){return this.b[this.c]}}e.$ei=P;class L{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,F.$bf)(v,this.b,0,v.length,this.c,this.d):(0,F.$df)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$fi=L;class R{constructor(v=!0,p=!0){this.f=v,this.g=p}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let p=v.length-1;p>=0;p--,this.c--){const s=this.b.charCodeAt(p);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,F.$bf)(v,this.b,0,v.length,this.d,this.e):(0,F.$df)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$gi=R;var g;(function(h){h[h.Scheme=1]="Scheme",h[h.Authority=2]="Authority",h[h.Path=3]="Path",h[h.Query=4]="Query",h[h.Fragment=5]="Fragment"})(g||(g={}));class f{constructor(v,p){this.f=v,this.g=p,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,F.$cf)(v,this.c.scheme);if(this.d[this.e]===2)return(0,F.$cf)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,F.$af)(v,this.c.query);if(this.d[this.e]===5)return(0,F.$af)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$hi=f;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(h){h[h.Left=-1]="Left",h[h.Mid=0]="Mid",h[h.Right=1]="Right"})(A||(A={}));class k{static forUris(v=()=>!1,p=()=>!1){return new k(new f(v,p))}static forPaths(v=!1){return new k(new R(void 0,!v))}static forStrings(){return new k(new P)}static forConfigKeys(){return new k(new L)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,p){if(p){const s=p.slice(0);(0,S.$Xb)(s);for(const u of s)this.set(u,v)}else{const s=v.slice(0);(0,S.$Xb)(s);for(const u of s)this.set(u[0],u[1])}}set(v,p){const s=this.b.reset(v);let u;this.c||(this.c=new D,this.c.segment=s.value());const r=[];for(u=this.c;;){const n=s.cmp(u.segment);if(n>0)u.left||(u.left=new D,u.left.segment=s.value()),r.push([-1,u]),u=u.left;else if(n<0)u.right||(u.right=new D,u.right.segment=s.value()),r.push([1,u]),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new D,u.mid.segment=s.value()),r.push([0,u]),u=u.mid;else break}const i=u.value;u.value=p,u.key=v;for(let n=r.length-1;n>=0;n--){const o=r[n][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const t=r[n][0],m=r[n+1][0];if(t===1&&m===1)r[n][1]=o.rotateLeft();else if(t===-1&&m===-1)r[n][1]=o.rotateRight();else if(t===1&&m===-1)o.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=o.rotateLeft();else if(t===-1&&m===1)o.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const p=this.b.reset(v);let s=this.c;for(;s;){const u=p.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(p.hasNext())p.next(),s=s.mid;else break}return s}has(v){const p=this.d(v);return!(p?.value===void 0&&p?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,p){const s=this.b.reset(v),u=[];let r=this.c;for(;r;){const i=s.cmp(r.segment);if(i>0)u.push([-1,r]),r=r.left;else if(i<0)u.push([1,r]),r=r.right;else if(s.hasNext())s.next(),u.push([0,r]),r=r.mid;else break}if(r){if(p?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const i=this.f(r.right);if(i.key){const{key:n,value:o,segment:l}=i;this.e(i.key,!1),r.key=n,r.value=o,r.segment=l}}else{const i=r.left??r.right;if(u.length>0){const[n,o]=u[u.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=u.length-1;i>=0;i--){const n=u[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),u[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),u[i][1]=n.rotateRight()),i>0)switch(u[i-1][0]){case-1:u[i-1][1].left=u[i][1];break;case 1:u[i-1][1].right=u[i][1];break;case 0:u[i-1][1].mid=u[i][1];break}else this.c=u[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const p=this.b.reset(v);let s=this.c,u;for(;s;){const r=p.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(p.hasNext())p.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(v){return this.g(v,!1)}g(v,p){const s=this.b.reset(v);let u=this.c;for(;u;){const r=s.cmp(u.segment);if(r>0)u=u.left;else if(r<0)u=u.right;else if(s.hasNext())s.next(),u=u.mid;else return u.mid?this.h(u.mid):p?u.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[p,s]of this)v(s,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const p=[];return this.j(v,p),p[Symbol.iterator]()}j(v,p){v&&(v.left&&this.j(v.left,p),v.value&&p.push([v.key,v.value]),v.mid&&this.j(v.mid,p),v.right&&this.j(v.right,p))}_isBalanced(){const v=p=>{if(!p)return!0;const s=p.balanceFactor();return s<-1||s>1?!1:v(p.left)&&v(p.right)};return v(this.c)}}e.$ii=k}),define(Fe[40],Le([1,0,89]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$jk=e.ThemeColor=void 0;var F;(function(R){function g(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=g})(F||(e.ThemeColor=F={}));function P(R){return{id:R}}e.$jk=P;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(i){const n=g.exec(i.id);if(!n)return f(S.$ik.error);const[,o,l]=n,t=["codicon","codicon-"+o];return l&&t.push("codicon-modifier-"+l.substring(1)),t}R.asClassNameArray=f;function D(i){return f(i).join(" ")}R.asClassName=D;function A(i){return"."+f(i).join(".")}R.asCSSSelector=A;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||F.isThemeColor(i.color))}R.isThemeIcon=k;const h=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function v(i){const n=h.exec(i);if(!n)return;const[,o]=n;return{id:o}}R.fromString=v;function p(i){return{id:i}}R.fromId=p;function s(i,n){let o=i.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),n&&(o=`${o}~${n}`),{id:o}}R.modify=s;function u(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=u;function r(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=r})(L||(e.ThemeIcon=L={}))}),define(Fe[127],Le([1,0,125,13,40]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=void 0;const L="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${R.source}`,"g");function f(r){return r.replace(g,(i,n)=>n?i:`\\${i}`)}e.$kk=f;const D=new RegExp(`\\\\${R.source}`,"g");function A(r){return r.replace(D,i=>`\\${i}`)}e.$lk=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function h(r){return r.indexOf(L)===-1?r:r.replace(k,(i,n,o,l)=>o?i:n||l||"")}e.$mk=h;function v(r){return r?r.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$nk=v;const p=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){p.lastIndex=0;let i="";const n=[];let o=0;for(;;){const l=p.lastIndex,t=p.exec(r),m=r.substring(l,t?.index);if(m.length>0){i+=m;for(let a=0;a<m.length;a++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$ok=s;function u(r,i,n=!1){const{text:o,iconOffsets:l}=i;if(!l||l.length===0)return(0,S.$0j)(r,o,n);const t=(0,F.$1e)(o," "),m=o.length-t.length,a=(0,S.$0j)(r,t,n);if(a)for(const c of a){const E=l[c.start+m]+m;c.start+=E,c.end+=E}return a}e.$pk=u}),define(Fe[33],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yg=e.$xg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(P){return S.test(P)}e.$xg=F,e.$yg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(g){for(let f=0;f<g.length;f++)g[f]=Math.floor(Math.random()*256);return g};const L=new Uint8Array(16),R=[];for(let g=0;g<256;g++)R.push(g.toString(16).padStart(2,"0"));return function(){P(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let f=0,D="";return D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+="-",D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D+=R[L[f++]],D}}()}),define(Fe[128],Le([1,0,18,68,33]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=e.$yt=e.$xt=e.$wt=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$wt=L;function R(k,h,v){const p={id:(0,P.$yg)(),name:k,uri:h,data:v};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$xt=R;class g{constructor(){this.a=new Map}get size(){let h=0;for(const v of this.a)h++;return h}has(h){return this.a.has(this.b(h))}matches(h){const v=[...this.a.keys()];return F.Iterable.some(this,([p,s])=>s.asFile())&&v.push("files"),A(f(h),v)}get(h){return this.a.get(this.b(h))?.[0]}append(h,v){const p=this.a.get(h);p?p.push(v):this.a.set(this.b(h),[v])}replace(h,v){this.a.set(this.b(h),[v])}delete(h){this.a.delete(this.b(h))}*[Symbol.iterator](){for(const[h,v]of this.a)for(const p of v)yield[h,p]}b(h){return f(h)}}e.$yt=g;function f(k){return k.toLowerCase()}function D(k,h){return A(f(k),h.map(f))}e.$zt=D;function A(k,h){if(k==="*/*")return h.length>0;if(h.includes(k))return!0;const v=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[p,s,u]=v;return u==="*"?h.some(r=>r.startsWith(s+"/")):!1}e.$At=Object.freeze({create:k=>(0,S.$Mb)(k.map(h=>h.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$At.split(k).filter(h=>!h.startsWith("#"))})}),define(Fe[129],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function F(P){let L=0,R=0,g=0,f=0;for(let D=0,A=P.length;D<A;D++){const k=P.charCodeAt(D);k===13?(L===0&&(R=D),L++,D+1<A&&P.charCodeAt(D+1)===10?(f|=2,D++):f|=3,g=D+1):k===10&&(f|=1,L===0&&(R=D),L++,g=D+1)}return L===0&&(R=P.length),[L,R,P.length-g,f]}e.$Dt=F}),define(Fe[130],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=void 0,e.$Bs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Fe[131],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=e.$1t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class F{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let f=0,D=g.notIn.length;f<D;f++)switch(g.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,f){if(g.getTokenCount()===0)return!0;const D=g.findTokenIndexAtOffset(f-2),A=g.getStandardTokenType(D);return this.isOK(A)}g(g,f){for(let D=g;D<=f;D++){const A=String.fromCharCode(D);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$1t=F;class P{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of g)L(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),L(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),L(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),L(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&L(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$2t=P;function L(R,g,f){R.has(g)?R.get(g).push(f):R.set(g,[f])}}),define(Fe[132],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.$9B=e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=e.NodeColor=e.$2B=void 0;class S{constructor(u,r){this.piece=u,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$3B)return P(this.right);let u=this;for(;u.parent!==e.$3B&&u.parent.left!==u;)u=u.parent;return u.parent===e.$3B?e.$3B:u.parent}prev(){if(this.left!==e.$3B)return L(this.left);let u=this;for(;u.parent!==e.$3B&&u.parent.right!==u;)u=u.parent;return u.parent===e.$3B?e.$3B:u.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$2B=S;var F;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$3B=new S(null,0),e.$3B.parent=e.$3B,e.$3B.left=e.$3B,e.$3B.right=e.$3B,e.$3B.color=0;function P(s){for(;s.left!==e.$3B;)s=s.left;return s}e.$4B=P;function L(s){for(;s.right!==e.$3B;)s=s.right;return s}e.$5B=L;function R(s){return s===e.$3B?0:s.size_left+s.piece.length+R(s.right)}function g(s){return s===e.$3B?0:s.lf_left+s.piece.lineFeedCnt+g(s.right)}function f(){e.$3B.parent=e.$3B}function D(s,u){const r=u.right;r.size_left+=u.size_left+(u.piece?u.piece.length:0),r.lf_left+=u.lf_left+(u.piece?u.piece.lineFeedCnt:0),u.right=r.left,r.left!==e.$3B&&(r.left.parent=u),r.parent=u.parent,u.parent===e.$3B?s.root=r:u.parent.left===u?u.parent.left=r:u.parent.right=r,r.left=u,u.parent=r}e.$6B=D;function A(s,u){const r=u.left;u.left=r.right,r.right!==e.$3B&&(r.right.parent=u),r.parent=u.parent,u.size_left-=r.size_left+(r.piece?r.piece.length:0),u.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),u.parent===e.$3B?s.root=r:u===u.parent.right?u.parent.right=r:u.parent.left=r,r.right=u,u.parent=r}e.$7B=A;function k(s,u){let r,i;if(u.left===e.$3B?(i=u,r=i.right):u.right===e.$3B?(i=u,r=i.left):(i=P(u.right),r=i.right),i===s.root){s.root=r,r.color=0,u.detach(),f(),s.root.parent=e.$3B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=r:i.parent.right=r,i===u?(r.parent=i.parent,p(s,r)):(i.parent===u?r.parent=i:r.parent=i.parent,p(s,r),i.left=u.left,i.right=u.right,i.parent=u.parent,i.color=u.color,u===s.root?s.root=i:u===u.parent.left?u.parent.left=i:u.parent.right=i,i.left!==e.$3B&&(i.left.parent=i),i.right!==e.$3B&&(i.right.parent=i),i.size_left=u.size_left,i.lf_left=u.lf_left,p(s,i)),u.detach(),r.parent.left===r){const l=R(r),t=g(r);if(l!==r.parent.size_left||t!==r.parent.lf_left){const m=l-r.parent.size_left,a=t-r.parent.lf_left;r.parent.size_left=l,r.parent.lf_left=t,v(s,r.parent,m,a)}}if(p(s,r.parent),n){f();return}let o;for(;r!==s.root&&r.color===0;)r===r.parent.left?(o=r.parent.right,o.color===1&&(o.color=0,r.parent.color=1,D(s,r.parent),o=r.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,r=r.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(s,o),o=r.parent.right),o.color=r.parent.color,r.parent.color=0,o.right.color=0,D(s,r.parent),r=s.root)):(o=r.parent.left,o.color===1&&(o.color=0,r.parent.color=1,A(s,r.parent),o=r.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,r=r.parent):(o.left.color===0&&(o.right.color=0,o.color=1,D(s,o),o=r.parent.left),o.color=r.parent.color,r.parent.color=0,o.left.color=0,A(s,r.parent),r=s.root));r.color=0,f()}e.$8B=k;function h(s,u){for(p(s,u);u!==s.root&&u.parent.color===1;)if(u.parent===u.parent.parent.left){const r=u.parent.parent.right;r.color===1?(u.parent.color=0,r.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.right&&(u=u.parent,D(s,u)),u.parent.color=0,u.parent.parent.color=1,A(s,u.parent.parent))}else{const r=u.parent.parent.left;r.color===1?(u.parent.color=0,r.color=0,u.parent.parent.color=1,u=u.parent.parent):(u===u.parent.left&&(u=u.parent,A(s,u)),u.parent.color=0,u.parent.parent.color=1,D(s,u.parent.parent))}s.root.color=0}e.$9B=h;function v(s,u,r,i){for(;u!==s.root&&u!==e.$3B;)u.parent.left===u&&(u.parent.size_left+=r,u.parent.lf_left+=i),u=u.parent}e.$0B=v;function p(s,u){let r=0,i=0;if(u!==s.root){for(;u!==s.root&&u===u.parent.right;)u=u.parent;if(u!==s.root)for(u=u.parent,r=R(u.left)-u.size_left,i=g(u.left)-u.lf_left,u.size_left+=r,u.lf_left+=i;u!==s.root&&(r!==0||i!==0);)u.parent.left===u&&(u.parent.size_left+=r,u.parent.lf_left+=i),u=u.parent}}e.$$B=p}),define(Fe[90],Le([1,0,91,29,92,132,93]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jC=e.$iC=e.$hC=e.$gC=e.$fC=void 0;const g=65535;function f(r){let i;return r[r.length-1]<65536?i=new Uint16Array(r.length):i=new Uint32Array(r.length),i.set(r,0),i}class D{constructor(i,n,o,l,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=l,this.isBasicASCII=t}}function A(r,i=!0){const n=[0];let o=1;for(let l=0,t=r.length;l<t;l++){const m=r.charCodeAt(l);m===13?l+1<t&&r.charCodeAt(l+1)===10?(n[o++]=l+2,l++):n[o++]=l+1:m===10&&(n[o++]=l+1)}return i?f(n):n}e.$fC=A;function k(r,i){r.length=0,r[0]=0;let n=1,o=0,l=0,t=0,m=!0;for(let c=0,E=i.length;c<E;c++){const y=i.charCodeAt(c);y===13?c+1<E&&i.charCodeAt(c+1)===10?(t++,r[n++]=c+2,c++):(o++,r[n++]=c+1):y===10?(l++,r[n++]=c+1):m&&y!==9&&(y<32||y>126)&&(m=!1)}const a=new D(f(r),o,l,t,m);return r.length=0,a}e.$gC=k;class h{constructor(i,n,o,l,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=l,this.length=t}}e.$hC=h;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$iC=v;class p{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==L.$3B&&i.iterate(i.root,o=>(o!==L.$3B&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let l=0;l<o.length;l++){const t=o[l];if(t.node.parent===null||t.nodeStartOffset>=i){o[l]=null,n=!0;continue}}if(n){const l=[];for(const t of o)t!==null&&l.push(t);this.b=l}}}class u{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=L.$3B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let l=null;for(let t=0,m=i.length;t<m;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const a=new h(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),l=this.S(l,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=g,o=n-Math.floor(n/3),l=o*2;let t="",m=0;const a=[];if(this.iterate(this.root,c=>{const E=this.R(c),y=E.length;if(m<=o||m+y<l)return t+=E,m+=y,!0;const $=t.replace(/\r\n|\r|\n/g,i);return a.push(new v($,A($))),t=E,m=y,!0}),m>0){const c=t.replace(/\r\n|\r|\n/g,i);a.push(new v(c,A(c)))}this.create(a,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new p(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,l=>{if(l===L.$3B)return!0;const t=this.R(l),m=t.length,a=i.G(n),c=i.G(n+m),E=i.getValueInRange2(a,c);return n+=m,t===E})}getOffsetAt(i,n){let o=0,l=this.root;for(;l!==L.$3B;)if(l.left!==L.$3B&&l.lf_left+1>=i)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=i){o+=l.size_left;const t=this.B(l,i-l.lf_left-2);return o+=t+n-1}else i-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const l=i;for(;n!==L.$3B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const m=this.getOffsetAt(o+1,1),a=l-m;return new S.$3s(o+1,a+1)}return new S.$3s(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===L.$3B){const t=this.getOffsetAt(o+1,1),m=l-i-t;return new S.$3s(o+1,m+1)}else n=n.right;return new S.$3s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),l=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,l);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const a=i.node,c=this.a[a.piece.bufferIndex].buffer,E=this.u(a.piece.bufferIndex,a.piece.start);return c.substring(E+i.remainder,E+n.remainder)}let o=i.node;const l=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let m=l.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==L.$3B;){const a=this.a[o.piece.bufferIndex].buffer,c=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){m+=a.substring(c,c+n.remainder);break}else m+=a.substr(c,o.piece.length);o=o.next()}return m}getLinesContent(){const i=[];let n=0,o="",l=!1;return this.iterate(this.root,t=>{if(t===L.$3B)return!0;const m=t.piece;let a=m.length;if(a===0)return!0;const c=this.a[m.bufferIndex].buffer,E=this.a[m.bufferIndex].lineStarts,y=m.start.line,$=m.end.line;let I=E[y]+m.start.column;if(l&&(c.charCodeAt(I)===10&&(I++,a--),i[n++]=o,o="",l=!1,a===0))return!0;if(y===$)return!this.f&&c.charCodeAt(I+a-1)===13?(l=!0,o+=c.substr(I,a-1)):o+=c.substr(I,a),!0;o+=this.f?c.substring(I,Math.max(I,E[y+1]-this.e)):c.substring(I,E[y+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let d=y+1;d<$;d++)o=this.f?c.substring(E[d],E[d+1]-this.e):c.substring(E[d],E[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&c.charCodeAt(E[$]+m.end.column-1)===13?(l=!0,m.end.column===0?n--:o=c.substr(E[$],m.end.column-1)):o=c.substr(E[$],m.end.column),!0}),l&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],l=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(l)}else{const n=this.a[i.node.piece.bufferIndex],l=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(l)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,l,t,m,a,c,E,y,$){const I=this.a[i.piece.bufferIndex],d=this.u(i.piece.bufferIndex,i.piece.start),w=this.u(i.piece.bufferIndex,t),b=this.u(i.piece.bufferIndex,m);let M;const T={line:0,column:0};let G,W;n._wordSeparators?(G=I.buffer.substring(w,b),W=U=>U+w,n.reset(0)):(G=I.buffer,W=U=>U,n.reset(w));do if(M=n.next(G),M){if(W(M.index)>=b)return y;this.s(i,W(M.index)-d,T);const U=this.t(i.piece.bufferIndex,t,T),C=T.line===t.line?T.column-t.column+l:T.column+1,O=C+M[0].length;if($[y++]=(0,R.$bC)(new F.$4s(o+U,C,o+U,O),M,c),W(M.index)+M[0].length>=b||y>=E)return y}while(M);return y}findMatchesLineByLine(i,n,o,l){const t=[];let m=0;const a=new R.$eC(n.wordSeparators,n.regex);let c=this.H(i.startLineNumber,i.startColumn);if(c===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let y=this.s(c.node,c.remainder);const $=this.s(E.node,E.remainder);if(c.node===E.node)return this.findMatchesInNode(c.node,a,i.startLineNumber,i.startColumn,y,$,n,o,l,m,t),t;let I=i.startLineNumber,d=c.node;for(;d!==E.node;){const b=this.t(d.piece.bufferIndex,y,d.piece.end);if(b>=1){const T=this.a[d.piece.bufferIndex].lineStarts,G=this.u(d.piece.bufferIndex,d.piece.start),W=T[y.line+b],U=I===i.startLineNumber?i.startColumn:1;if(m=this.findMatchesInNode(d,a,I,U,y,this.s(d,W-G),n,o,l,m,t),m>=l)return t;I+=b}const M=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const T=this.getLineContent(I).substring(M,i.endColumn-1);return m=this.n(n,a,T,i.endLineNumber,M,m,t,o,l),t}if(m=this.n(n,a,this.getLineContent(I).substr(M),I,M,m,t,o,l),m>=l)return t;I++,c=this.H(I,1),d=c.node,y=this.s(c.node,c.remainder)}if(I===i.endLineNumber){const b=I===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(I).substring(b,i.endColumn-1);return m=this.n(n,a,M,i.endLineNumber,b,m,t,o,l),t}const w=I===i.startLineNumber?i.startColumn:1;return m=this.findMatchesInNode(E.node,a,I,w,y,$,n,o,l,m,t),t}n(i,n,o,l,t,m,a,c,E){const y=i.wordSeparators;if(!c&&i.simpleSearch){const I=i.simpleSearch,d=I.length,w=o.length;let b=-d;for(;(b=o.indexOf(I,b+d))!==-1;)if((!y||(0,R.$dC)(y,o,w,b,d))&&(a[m++]=new P.$jv(new F.$4s(l,b+1+t,l,b+1+d+t),null),m>=E))return m;return m}let $;n.reset(0);do if($=n.next(o),$&&(a[m++]=(0,R.$bC)(new F.$4s(l,$.index+1+t,l,$.index+1+$[0].length+t),$,c),m>=E))return m;while($);return m}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==L.$3B){const{node:l,remainder:t,nodeStartOffset:m}=this.G(i),a=l.piece,c=a.bufferIndex,E=this.s(l,t);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&m+a.length===i&&n.length<g){this.F(l,n),this.y();return}if(m===i)this.o(n,l),this.h.validate(i);else if(m+l.piece.length>i){const y=[];let $=new h(a.bufferIndex,E,a.end,this.t(a.bufferIndex,E,a.end),this.u(c,a.end)-this.u(c,E));if(this.K()&&this.M(n)&&this.I(l,t)===10){const b={line:$.start.line+1,column:0};$=new h($.bufferIndex,b,$.end,this.t($.bufferIndex,b,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(l,t-1)===13){const b=this.s(l,t-1);this.C(l,b),n="\r"+n,l.piece.length===0&&y.push(l)}else this.C(l,E);else this.C(l,E);const I=this.w(n);$.length>0&&this.S(l,$);let d=l;for(let w=0;w<I.length;w++)d=this.S(d,I[w]);this.v(y)}else this.q(n,l)}else{const l=this.w(n);let t=this.T(null,l[0]);for(let m=1;m<l.length;m++)t=this.S(t,l[m])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===L.$3B)return;const o=this.G(i),l=this.G(i+n),t=o.node,m=l.node;if(t===m){const I=this.s(t,o.remainder),d=this.s(t,l.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const w=t.next();(0,L.$8B)(this,t),this.N(w),this.y();return}this.D(t,d),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,d),this.y();return}const a=[],c=this.s(t,o.remainder);this.C(t,c),this.h.validate(i),t.piece.length===0&&a.push(t);const E=this.s(m,l.remainder);this.D(m,E),m.piece.length===0&&a.push(m);const y=t.next();for(let I=y;I!==L.$3B&&I!==m;I=I.next())a.push(I);const $=t.piece.length===0?t.prev():t;this.v(a),this.O($),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const m=n.piece,a={line:m.start.line+1,column:0},c=new h(m.bufferIndex,a,m.end,this.t(m.bufferIndex,a,m.end),m.length-1);n.piece=c,i+=`
`,(0,L.$0B)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const l=this.w(i);let t=this.T(n,l[l.length-1]);for(let m=l.length-2;m>=0;m--)t=this.T(t,l[m]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),l=this.S(n,o[0]);let t=l;for(let m=1;m<o.length;m++)t=this.S(t,o[m]);this.N(l)}s(i,n,o){const l=i.piece,t=i.piece.bufferIndex,m=this.a[t].lineStarts,c=m[l.start.line]+l.start.column+n;let E=l.start.line,y=l.end.line,$=0,I=0,d=0;for(;E<=y&&($=E+(y-E)/2|0,d=m[$],$!==y);)if(I=m[$+1],c<d)y=$-1;else if(c>=I)E=$+1;else break;return o?(o.line=$,o.column=c-d,null):{line:$,column:c-d}}t(i,n,o){if(o.column===0)return o.line-n.line;const l=this.a[i].lineStarts;if(o.line===l.length-1)return o.line-n.line;const t=l[o.line+1],m=l[o.line]+o.column;if(t>m+1)return o.line-n.line;const a=m-1;return this.a[i].buffer.charCodeAt(a)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,L.$8B)(this,i[n])}w(i){if(i.length>g){const y=[];for(;i.length>g;){const I=i.charCodeAt(g-1);let d;I===13||I>=55296&&I<=56319?(d=i.substring(0,g-1),i=i.substring(g-1)):(d=i.substring(0,g),i=i.substring(g));const w=A(d);y.push(new h(this.a.length,{line:0,column:0},{line:w.length-1,column:d.length-w[w.length-1]},w.length-1,d.length)),this.a.push(new v(d,w))}const $=A(i);return y.push(new h(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new v(i,$)),y}let n=this.a[0].buffer.length;const o=A(i,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let y=0;y<o.length;y++)o[y]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let y=0;y<o.length;y++)o[y]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,m=this.a[0].lineStarts.length-1,a=t-this.a[0].lineStarts[m],c={line:m,column:a},E=new h(0,l,c,this.t(0,l,c),t-n);return this.g=c,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,l="";const t=this.h.get2(i);if(t){o=t.node;const m=this.B(o,i-t.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,c=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)l=a.substring(c+m,c+o.piece.length);else{const E=this.B(o,i-t.nodeStartLineNumber);return a.substring(c+m,c+E-n)}}else{let m=0;const a=i;for(;o!==L.$3B;)if(o.left!==L.$3B&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const c=this.B(o,i-o.lf_left-2),E=this.B(o,i-o.lf_left-1),y=this.a[o.piece.bufferIndex].buffer,$=this.u(o.piece.bufferIndex,o.piece.start);return m+=o.size_left,this.h.set({node:o,nodeStartOffset:m,nodeStartLineNumber:a-(i-1-o.lf_left)}),y.substring($+c,$+E-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const c=this.B(o,i-o.lf_left-2),E=this.a[o.piece.bufferIndex].buffer,y=this.u(o.piece.bufferIndex,o.piece.start);l=E.substring(y+c,y+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,m+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==L.$3B;){const m=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),c=this.u(o.piece.bufferIndex,o.piece.start);return l+=m.substring(c,c+a-n),l}else{const a=this.u(o.piece.bufferIndex,o.piece.start);l+=m.substr(a,o.piece.length)}o=o.next()}return l}y(){let i=this.root,n=1,o=0;for(;i!==L.$3B;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,l=this.s(i,n),t=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const m=this.t(i.piece.bufferIndex,o.start,l);if(m!==t)return{index:m,remainder:0}}return{index:t,remainder:l.column}}B(i,n){if(n<0)return 0;const o=i.piece,l=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[t]-l[o.start.line]-o.start.column}C(i,n){const o=i.piece,l=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),m=n,a=this.u(o.bufferIndex,m),c=this.t(o.bufferIndex,o.start,m),E=c-l,y=a-t,$=o.length+y;i.piece=new h(o.bufferIndex,o.start,m,c,$),(0,L.$0B)(this,i,y,E)}D(i,n){const o=i.piece,l=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),m=n,a=this.t(o.bufferIndex,m,o.end),c=this.u(o.bufferIndex,m),E=a-l,y=t-c,$=o.length+y;i.piece=new h(o.bufferIndex,m,o.end,a,$),(0,L.$0B)(this,i,y,E)}E(i,n,o){const l=i.piece,t=l.start,m=l.end,a=l.length,c=l.lineFeedCnt,E=n,y=this.t(l.bufferIndex,l.start,E),$=this.u(l.bufferIndex,n)-this.u(l.bufferIndex,t);i.piece=new h(l.bufferIndex,l.start,E,y,$),(0,L.$0B)(this,i,$-a,y-c);const I=new h(l.bufferIndex,o,m,this.t(l.bufferIndex,o,m),this.u(l.bufferIndex,m)-this.u(l.bufferIndex,o)),d=this.S(i,I);this.N(d)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),l=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let d=0;d<t.length;d++)t[d]+=l;if(o){const d=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-d}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const m=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[m],c={line:m,column:a},E=i.piece.length+n.length,y=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,c),I=$-y;i.piece=new h(i.piece.bufferIndex,i.piece.start,c,$,E),this.g=c,(0,L.$0B)(this,i,n.length,I)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let l=0;for(;n!==L.$3B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){l+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:l};return this.h.set(t),t}else i-=n.size_left+n.piece.length,l+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,l=0;for(;o!==L.$3B;)if(o.left!==L.$3B&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),m=this.B(o,i-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(t+n-1,m),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:l};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==L.$3B;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),m=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:m}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],l=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(l)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$3B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,l=n.start.line,t=o[l]+n.start.column;return l===o.length-1||o[l+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$3B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],l=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:l[i.piece.end.line]-l[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const m=i.piece.length-1,a=i.piece.lineFeedCnt-1;i.piece=new h(i.piece.bufferIndex,i.piece.start,t,a,m),(0,L.$0B)(this,i,-1,-1),i.piece.length===0&&o.push(i);const c={line:n.piece.start.line+1,column:0},E=n.piece.length-1,y=this.t(n.piece.bufferIndex,c,n.piece.end);n.piece=new h(n.piece.bufferIndex,c,n.piece.end,y,E),(0,L.$0B)(this,n,-1,-1),n.piece.length===0&&o.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let I=0;I<o.length;I++)(0,L.$8B)(this,o[I])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,L.$8B)(this,o);else{const l=o.piece,t={line:l.start.line+1,column:0},m=l.length-1,a=this.t(l.bufferIndex,t,l.end);o.piece=new h(l.bufferIndex,t,l.end,a,m),(0,L.$0B)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===L.$3B)return n(L.$3B);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===L.$3B)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,l=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(l,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),l=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,l)}S(i,n){const o=new L.$2B(n,1);if(o.left=L.$3B,o.right=L.$3B,o.parent=L.$3B,o.size_left=0,o.lf_left=0,this.root===L.$3B)this.root=o,o.color=0;else if(i.right===L.$3B)i.right=o,o.parent=i;else{const t=(0,L.$4B)(i.right);t.left=o,o.parent=t}return(0,L.$9B)(this,o),o}T(i,n){const o=new L.$2B(n,1);if(o.left=L.$3B,o.right=L.$3B,o.parent=L.$3B,o.size_left=0,o.lf_left=0,this.root===L.$3B)this.root=o,o.color=0;else if(i.left===L.$3B)i.left=o,o.parent=i;else{const l=(0,L.$5B)(i.left);l.right=o,o.parent=l}return(0,L.$9B)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$jC=u}),define(Fe[133],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x9=e.$w9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$w9=S;class F{constructor(L){this.identifier=L}}e.$x9=F}),define(Fe[134],Le([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Fe[135],Le([1,0,5,6,134]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;class L extends F.$Tc{constructor(h,v="",p="",s=!0,u){super(),this.h=this.B(new S.$3d),this.onDidChange=this.h.event,this.w=!0,this.j=h,this.m=v,this.u=p,this.w=s,this.C=u}get id(){return this.j}get label(){return this.m}set label(h){this.D(h)}D(h){this.m!==h&&(this.m=h,this.h.fire({label:h}))}get tooltip(){return this.n||""}set tooltip(h){this.F(h)}F(h){this.n!==h&&(this.n=h,this.h.fire({tooltip:h}))}get class(){return this.u}set class(h){this.G(h)}G(h){this.u!==h&&(this.u=h,this.h.fire({class:h}))}get enabled(){return this.w}set enabled(h){this.H(h)}H(h){this.w!==h&&(this.w=h,this.h.fire({enabled:h}))}get checked(){return this.z}set checked(h){this.I(h)}I(h){this.z!==h&&(this.z=h,this.h.fire({checked:h}))}async run(h,v){this.C&&await this.C(h)}}e.$Ti=L;class R extends F.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$3d),this.onWillRun=this.f.event,this.m=this.B(new S.$3d),this.onDidRun=this.m.event}async run(h,v){if(!h.enabled)return;this.f.fire({action:h});let p;try{await this.u(h,v)}catch(s){p=s}this.m.fire({action:h,error:p})}async u(h,v){await h.run(v)}}e.$Ui=R;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...h){let v=[];for(const p of h)p.length&&(v.length?v=[...v,new g,...p]:v=p);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Vi=g;class f{get actions(){return this.a}constructor(h,v,p,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=h,this.label=v,this.class=s,this.a=p}async run(){}}e.$Wi=f;class D extends L{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,P.localize(0,null),void 0,!1)}}e.$Xi=D;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...h)=>k.run(...h),tooltip:k.label}}e.$Yi=A}),define(Fe[136],Le([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Fe[137],Le([1,0,136]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=void 0;const F=60,P=F*60,L=P*24,R=L*7,g=L*30,f=L*365;function D(h,v,p,s){typeof h!="number"&&(h=h.getTime());const u=Math.round((new Date().getTime()-h)/1e3);if(u<-30)return(0,S.localize)(0,null,D(new Date().getTime()+u*1e3,!1));if(!s&&u<30)return(0,S.localize)(1,null);let r;return u<F?(r=u,v?r===1?p?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):p?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?p?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):p?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):u<P?(r=Math.floor(u/F),v?r===1?p?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):p?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?p?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):p?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):u<L?(r=Math.floor(u/P),v?r===1?p?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):p?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?p?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):p?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):u<R?(r=Math.floor(u/L),v?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):u<g?(r=Math.floor(u/R),v?r===1?p?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):p?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?p?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):p?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):u<f?(r=Math.floor(u/g),v?r===1?p?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):p?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?p?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):p?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(u/f),v?r===1?p?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):p?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?p?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):p?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}e.$Em=D;function A(h,v){const p=Math.abs(h/1e3);return p<1?v?(0,S.localize)(54,null,h):(0,S.localize)(55,null,h):p<F?v?(0,S.localize)(56,null,Math.round(h)/1e3):(0,S.localize)(57,null,Math.round(h)/1e3):p<P?v?(0,S.localize)(58,null,Math.round(h/(1e3*F))):(0,S.localize)(59,null,Math.round(h/(1e3*F))):p<L?v?(0,S.localize)(60,null,Math.round(h/(1e3*P))):(0,S.localize)(61,null,Math.round(h/(1e3*P))):(0,S.localize)(62,null,Math.round(h/(1e3*L)))}e.$Fm=A;function k(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Gm=k}),define(Fe[138],Le([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Fe[41],Le([1,0,18,16,138]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2i=e.$1i=e.$Zi=void 0;function L(k,h){return h&&(k.stack||k.stacktrace)?P.localize(0,null,g(k),R(k.stack)||R(k.stacktrace)):g(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function g(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?P.localize(1,null,k.message):k.message||P.localize(2,null)}function f(k=null,h=!1){if(!k)return P.localize(3,null);if(Array.isArray(k)){const v=S.$Hb(k),p=f(v[0],h);return v.length>1?P.localize(4,null,p,v.length):p}if(F.$Qf(k))return k;if(k.detail){const v=k.detail;if(v.error)return L(v.error,h);if(v.exception)return L(v.exception,h)}return k.stack?L(k,h):k.message?k.message:P.localize(5,null)}e.$Zi=f;function D(k){const h=k;return h instanceof Error&&Array.isArray(h.actions)}e.$1i=D;function A(k,h){let v;return typeof k=="string"?v=new Error(k):v=k,v.actions=h,v}e.$2i=A}),define(Fe[139],Le([1,0,39,19]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),L=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(I,d,w=!1){const b=I||"",M=d||"",T=P.value.collator.compare(b,M);return P.value.collatorIsNumeric&&T===0&&b!==M?b<M?-1:1:T}e.$Rq=g;function f(I,d){const w=L.value.collator;return I=I||"",d=d||"",o(w,I,d)}e.$Sq=f;function D(I,d){const w=L.value.collator;return I=I||"",d=d||"",a(I,d)||o(w,I,d)}e.$Tq=D;function A(I,d){const w=L.value.collator;return I=I||"",d=d||"",m(I,d)||o(w,I,d)}e.$Uq=A;function k(I,d){return I=I||"",d=d||"",I===d?0:I<d?-1:1}e.$Vq=k;function h(I,d){const[w,b]=i(I),[M,T]=i(d);let G=P.value.collator.compare(b,T);if(G===0){if(P.value.collatorIsNumeric&&b!==T)return b<T?-1:1;if(G=P.value.collator.compare(w,M),P.value.collatorIsNumeric&&G===0&&w!==M)return w<M?-1:1}return G}e.$Wq=h;function v(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),M=L.value.collator,T=R.value.collator;return o(T,w,b)||o(M,I,d)}e.$Xq=v;function p(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),M=L.value.collator,T=R.value.collator;return o(T,w,b)||a(I,d)||o(M,I,d)}e.$Yq=p;function s(I,d){I=I||"",d=d||"";const w=n(I),b=n(d),M=L.value.collator,T=R.value.collator;return o(T,w,b)||m(I,d)||o(M,I,d)}e.$Zq=s;function u(I,d){I=I||"",d=d||"";const w=n(I).toLowerCase(),b=n(d).toLowerCase();return w!==b?w<b?-1:1:I!==d?I<d?-1:1:0}e.$1q=u;const r=/^(.*?)(\.([^.]*))?$/;function i(I,d=!1){const w=I?r.exec(I):[];let b=[w&&w[1]||"",w&&w[3]||""];return d&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(I){const d=I?r.exec(I):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function o(I,d,w){const b=I.compare(d,w);return b!==0?b:d.length!==w.length?d.length<w.length?-1:1:0}function l(I){const d=I.charAt(0);return d.toLocaleUpperCase()!==d}function t(I){const d=I.charAt(0);return d.toLocaleLowerCase()!==d}function m(I,d){return l(I)&&t(d)?-1:t(I)&&l(d)?1:0}function a(I,d){return t(I)&&l(d)?-1:l(I)&&t(d)?1:0}function c(I,d,w=!1){return w||(I=I&&I.toLowerCase(),d=d&&d.toLowerCase()),I===d?0:I<d?-1:1}function E(I,d,w=!1){const b=I.split(F.sep),M=d.split(F.sep),T=b.length-1,G=M.length-1;let W,U;for(let C=0;;C++){if(W=T===C,U=G===C,W&&U)return g(b[C],M[C],w);if(W)return-1;if(U)return 1;const O=c(b[C],M[C],w);if(O!==0)return O}}e.$2q=E;function y(I,d,w){const b=I.toLowerCase(),M=d.toLowerCase(),T=$(I,d,w);if(T)return T;const G=b.endsWith(w),W=M.endsWith(w);if(G!==W)return G?-1:1;const U=g(b,M);return U!==0?U:b.localeCompare(M)}e.$3q=y;function $(I,d,w){const b=I.toLowerCase(),M=d.toLowerCase(),T=b.startsWith(w),G=M.startsWith(w);if(T!==G)return T?-1:1;if(T&&G){if(b.length<M.length)return-1;if(b.length>M.length)return 1}return 0}e.$4q=$}),define(Fe[45],Le([1,0,19,20,13,16]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function R(y){return y===47||y===92}e.$9f=R;function g(y){return y.replace(/[\\/]/g,S.$gc.sep)}e.$0f=g;function f(y){return y.indexOf("/")===-1&&(y=g(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}e.$$f=f;function D(y,$=S.$gc.sep){if(!y)return"";const I=y.length,d=y.charCodeAt(0);if(R(d)){if(R(y.charCodeAt(1))&&!R(y.charCodeAt(2))){let b=3;const M=b;for(;b<I&&!R(y.charCodeAt(b));b++);if(M!==b&&!R(y.charCodeAt(b+1))){for(b+=1;b<I;b++)if(R(y.charCodeAt(b)))return y.slice(0,b+1).replace(/[\\/]/g,$)}}return $}else if(r(d)&&y.charCodeAt(1)===58)return R(y.charCodeAt(2))?y.slice(0,2)+$:y.slice(0,2);let w=y.indexOf("://");if(w!==-1){for(w+=3;w<I;w++)if(R(y.charCodeAt(w)))return y.slice(0,w+1)}return""}e.$_f=D;function A(y){if(!F.$i||!y||y.length<5)return!1;let $=y.charCodeAt(0);if($!==92||($=y.charCodeAt(1),$!==92))return!1;let I=2;const d=I;for(;I<y.length&&($=y.charCodeAt(I),$!==92);I++);return!(d===I||($=y.charCodeAt(I+1),isNaN($)||$===92))}e.$ag=A;const k=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(y,$=F.$i){const I=$?k:h;return!(!y||y.length===0||/^\s+$/.test(y)||(I.lastIndex=0,I.test(y))||$&&v.test(y)||y==="."||y===".."||$&&y[y.length-1]==="."||$&&y.length!==y.trim().length||y.length>255)}e.$bg=p;function s(y,$,I){const d=y===$;return!I||d?d:!y||!$?!1:(0,P.$hf)(y,$)}e.$cg=s;function u(y,$,I,d=S.sep){if(y===$)return!0;if(!y||!$||$.length>y.length)return!1;if(I){if(!(0,P.$if)(y,$))return!1;if($.length===y.length)return!0;let b=$.length;return $.charAt($.length-1)===d&&b--,y.charAt(b)===d}return $.charAt($.length-1)!==d&&($+=d),y.indexOf($)===0}e.$dg=u;function r(y){return y>=65&&y<=90||y>=97&&y<=122}e.$eg=r;function i(y,$){return F.$i&&y.endsWith(":")&&(y+=S.sep),(0,S.$ic)(y)||(y=(0,S.$jc)($,y)),y=(0,S.$hc)(y),F.$i?(y=(0,P.$2e)(y,S.sep),y.endsWith(":")&&(y+=S.sep)):(y=(0,P.$2e)(y,S.sep),y||(y=S.sep)),y}e.$fg=i;function n(y){const $=(0,S.$hc)(y);return F.$i?y.length>3?!1:o($)&&(y.length===2||$.charCodeAt(2)===92):$===S.$gc.sep}e.$gg=n;function o(y,$=F.$i){return $?r(y.charCodeAt(0))&&y.charCodeAt(1)===58:!1}e.$hg=o;function l(y,$=F.$i){return o(y,$)?y[0]:void 0}e.$ig=l;function t(y,$,I){return $.length>y.length?-1:y===$?0:(I&&(y=y.toLowerCase(),$=$.toLowerCase()),y.indexOf($))}e.$jg=t;function m(y){const $=y.split(":");let I,d,w;for(const b of $){const M=Number(b);(0,L.$Uf)(M)?d===void 0?d=M:w===void 0&&(w=M):I=I?[I,b].join(":"):b}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:d!==void 0?d:void 0,column:w!==void 0?w:d!==void 0?1:void 0}}e.$kg=m;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(y,$,I=8){let d="";for(let b=0;b<I;b++){let M;b===0&&F.$i&&!$&&(I===3||I===4)?M=c:M=a,d+=M.charAt(Math.floor(Math.random()*M.length))}let w;return $?w=`${$}-${d}`:w=d,y?(0,S.$jc)(y,w):w}e.$lg=E}),define(Fe[69],Le([1,0,19]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=e.$rs=e.$qs=e.$ps=e.$os=void 0,e.$os=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const k=(0,S.$oc)(A),h=F[k.toLowerCase()];return h!==void 0?h:R(A)}e.$ps=L;function R(A){const k=(0,S.$oc)(A);return P[k.toLowerCase()]}e.$qs=R;function g(A){for(const k in P)if(P[k]===A)return k}e.$rs=g;const f=/^(.+)\/(.+?)(;.+)?$/;function D(A,k){const h=f.exec(A);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:k?void 0:A}e.$ss=D}),define(Fe[52],Le([1,0,24,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Kh=e.$Jh=void 0;function P(f){return JSON.stringify(f,R)}e.$Jh=P;function L(f){let D=JSON.parse(f);return D=g(D),D}e.$Kh=L;function R(f,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function g(f,D=0){if(!f||D>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return F.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$qe||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let A=0;A<f.length;++A)f[A]=g(f[A],D+1);else for(const A in f)Object.hasOwnProperty.call(f,A)&&(f[A]=g(f[A],D+1))}return f}e.$Lh=g}),define(Fe[12],Le([1,0,15,20,13,2]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.Schemas=void 0;var R;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting",h.codeFeature="code-feature"})(R||(e.Schemas=R={}));function g(h,v){return L.URI.isUri(h)?(0,P.$hf)(h.scheme,v):(0,P.$if)(h,v+":")}e.$mg=g;function f(h,...v){return v.some(p=>g(h,p))}e.$ng=f,e.$og="vscode-tkn",e.$pg="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${R.vscodeRemoteResource}`}set(v,p,s){this.a[v]=p,this.b[v]=s}setConnectionToken(v,p){this.c[v]=p}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return S.$1(n),v}const p=v.authority;let s=this.a[p];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const u=this.b[p],r=this.c[p];let i=`path=${encodeURIComponent(v.path)}`;return typeof r=="string"&&(i+=`&${e.$pg}=${encodeURIComponent(r)}`),L.URI.from({scheme:F.$o?this.d:R.vscodeRemoteResource,authority:`${s}:${u}`,path:this.f,query:i})}}e.$qg=new D,e.$rg="vs/../../extensions",e.$sg="vs/../../node_modules",e.$tg="vs/../../node_modules.asar",e.$ug="vs/../../node_modules.asar.unpacked",e.$vg="vscode-app";class A{static{this.a=e.$vg}asBrowserUri(v){const p=this.b(v,fe);return this.uriToBrowserUri(p)}uriToBrowserUri(v){return v.scheme===R.vscodeRemote?e.$qg.rewrite(v):v.scheme===R.file&&(F.$m||F.$q===`${R.vscodeFileResource}://${A.a}`)?v.with({scheme:R.vscodeFileResource,authority:v.authority||A.a,query:null,fragment:null}):v}asFileUri(v){const p=this.b(v,fe);return this.uriToFileUri(p)}uriToFileUri(v){return v.scheme===R.vscodeFileResource?v.with({scheme:R.file,authority:v.authority!==A.a?v.authority:null,query:null,fragment:null}):v}b(v,p){return L.URI.isUri(v)?v:L.URI.parse(p.toUrl(v))}}e.$wg=new A;var k;(function(h){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(v.get("3"));const p="vscode-coi";function s(r){let i;typeof r=="string"?i=new URL(r).searchParams:r instanceof URL?i=r.searchParams:L.URI.isUri(r)&&(i=new URL(r.toString(!0)).searchParams);const n=i?.get(p);if(n)return v.get(n)}h.getHeadersFromQuery=s;function u(r,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";r instanceof URLSearchParams?r.set(p,o):r[p]=o}h.addSearchParam=u})(k||(e.COI=k={}))}),define(Fe[25],Le([1,0,45,12,19,20,13,2]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=e.DataUri=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function f(v){return(0,g.$wc)(v,!0)}e.$Dg=f;class D{constructor(p){this.a=p}compare(p,s,u=!1){return p===s?0:(0,R.$af)(this.getComparisonKey(p,u),this.getComparisonKey(s,u))}isEqual(p,s,u=!1){return p===s?!0:!p||!s?!1:this.getComparisonKey(p,u)===this.getComparisonKey(s,u)}getComparisonKey(p,s=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,s,u=!1){if(p.scheme===s.scheme){if(p.scheme===F.Schemas.file)return S.$dg(f(p),f(s),this.a(p))&&p.query===s.query&&(u||p.fragment===s.fragment);if((0,e.$Ug)(p.authority,s.authority))return S.$dg(p.path,s.path,this.a(p),"/")&&p.query===s.query&&(u||p.fragment===s.fragment)}return!1}joinPath(p,...s){return g.URI.joinPath(p,...s)}basenameOrAuthority(p){return(0,e.$Mg)(p)||p.authority}basename(p){return P.$gc.basename(p.path)}extname(p){return P.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let s;return p.scheme===F.Schemas.file?s=g.URI.file(P.$mc(f(p))).path:(s=P.$gc.dirname(p.path),p.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),s="/")),p.with({path:s})}normalizePath(p){if(!p.path.length)return p;let s;return p.scheme===F.Schemas.file?s=g.URI.file(P.$hc(f(p))).path:s=P.$gc.normalize(p.path),p.with({path:s})}relativePath(p,s){if(p.scheme!==s.scheme||!(0,e.$Ug)(p.authority,s.authority))return;if(p.scheme===F.Schemas.file){const i=P.$lc(f(p),f(s));return L.$i?S.$0f(i):i}let u=p.path||"/";const r=s.path||"/";if(this.a(p)){let i=0;for(const n=Math.min(u.length,r.length);i<n&&!(u.charCodeAt(i)!==r.charCodeAt(i)&&u.charAt(i).toLowerCase()!==r.charAt(i).toLowerCase());i++);u=r.substr(0,i)+u.substr(i)}return P.$gc.relative(u,r)}resolvePath(p,s){if(p.scheme===F.Schemas.file){const u=g.URI.file(P.$kc(f(p),s));return p.with({authority:u.authority,path:u.path})}return s=S.$$f(s),p.with({path:P.$gc.resolve(p.path,s)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,s){return p===s||p!==void 0&&s!==void 0&&(0,R.$hf)(p,s)}hasTrailingPathSeparator(p,s=P.sep){if(p.scheme===F.Schemas.file){const u=f(p);return u.length>S.$_f(u).length&&u[u.length-1]===s}else{const u=p.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,s=P.sep){return(0,e.$Vg)(p,s)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,s=P.sep){let u=!1;if(p.scheme===F.Schemas.file){const r=f(p);u=r!==void 0&&r.length===S.$_f(r).length&&r[r.length-1]===s}else{s="/";const r=p.path;u=r.length===1&&r.charCodeAt(r.length-1)===47}return!u&&!(0,e.$Vg)(p,s)?p.with({path:p.path+"/"}):p}}e.$Eg=D,e.$Fg=new D(()=>!1),e.$Gg=new D(v=>v.scheme===F.Schemas.file?!L.$k:!0),e.$Hg=new D(v=>!0),e.$Ig=e.$Fg.isEqual.bind(e.$Fg),e.$Jg=e.$Fg.isEqualOrParent.bind(e.$Fg),e.$Kg=e.$Fg.getComparisonKey.bind(e.$Fg),e.$Lg=e.$Fg.basenameOrAuthority.bind(e.$Fg),e.$Mg=e.$Fg.basename.bind(e.$Fg),e.$Ng=e.$Fg.extname.bind(e.$Fg),e.$Og=e.$Fg.dirname.bind(e.$Fg),e.$Pg=e.$Fg.joinPath.bind(e.$Fg),e.$Qg=e.$Fg.normalizePath.bind(e.$Fg),e.$Rg=e.$Fg.relativePath.bind(e.$Fg),e.$Sg=e.$Fg.resolvePath.bind(e.$Fg),e.$Tg=e.$Fg.isAbsolutePath.bind(e.$Fg),e.$Ug=e.$Fg.isEqualAuthority.bind(e.$Fg),e.$Vg=e.$Fg.hasTrailingPathSeparator.bind(e.$Fg),e.$Wg=e.$Fg.removeTrailingPathSeparator.bind(e.$Fg),e.$Xg=e.$Fg.addTrailingPathSeparator.bind(e.$Fg);function A(v,p){const s=[];for(let u=0;u<v.length;u++){const r=p(v[u]);v.some((i,n)=>n===u?!1:(0,e.$Jg)(r,p(i)))||s.push(v[u])}return s}e.$Yg=A;var k;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function p(s){const u=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,l]=n.split(":");o&&l&&u.set(o,l)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&u.set(v.META_DATA_MIME,i),u}v.parseMetaData=p})(k||(e.DataUri=k={}));function h(v,p,s){if(p){let u=v.path;return u&&u[0]!==P.$gc.sep&&(u=P.$gc.sep+u),v.with({scheme:s,authority:p,path:u})}return v.with({scheme:s})}e.$Zg=h}),define(Fe[11],Le([1,0,21,15,5,6,25,20,126,39]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.Promises=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0;function A(me){return!!me&&typeof me.then=="function"}e.$1g=A;function k(me){const Q=new S.$ae,x=me(Q.token),le=new Promise((de,Me)=>{const ge=Q.token.onCancellationRequested(()=>{ge.dispose(),Me(new F.$5)});Promise.resolve(x).then(Se=>{ge.dispose(),Q.dispose(),de(Se)},Se=>{ge.dispose(),Q.dispose(),Me(Se)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(de,Me){return le.then(de,Me)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}e.$2g=k;function h(me,Q,x){return new Promise((le,de)=>{const Me=Q.onCancellationRequested(()=>{Me.dispose(),le(x)});me.then(le,de).finally(()=>Me.dispose())})}e.$3g=h;function v(me,Q){return new Promise((x,le)=>{const de=Q.onCancellationRequested(()=>{de.dispose(),le(new F.$5)});me.then(x,le).finally(()=>de.dispose())})}e.$4g=v;async function p(me){let Q=-1;const x=me.map((le,de)=>le.then(Me=>(Q=de,Me)));try{return await Promise.race(x)}finally{me.forEach((le,de)=>{de!==Q&&le.cancel()})}}e.$5g=p;function s(me,Q,x){let le;const de=setTimeout(()=>{le?.(void 0),x?.()},Q);return Promise.race([me.finally(()=>clearTimeout(de)),new Promise(Me=>le=Me)])}e.$6g=s;function u(me){return new Promise((Q,x)=>{const le=me();A(le)?le.then(Q,x):Q(le)})}e.$7g=u;function r(){let me,Q;return{promise:new Promise((le,de)=>{me=le,Q=de}),resolve:me,reject:Q}}e.$8g=r;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const x=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(x,x).then(le)})}return new Promise((x,le)=>{this.b.then(x,le)})}return this.a=Q(),new Promise((x,le)=>{this.a.then(de=>{this.a=null,x(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$9g=i;class n{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$0g=n;class o{constructor(){this.a=new Map}queue(Q,x){const de=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(Q)===de&&this.a.delete(Q)});return this.a.set(Q,de),de}}e.$$g=o;const l=(me,Q)=>{let x=!0;const le=setTimeout(()=>{x=!1,Q()},me);return{isTriggered:()=>x,dispose:()=>{clearTimeout(le),x=!1}}},t=me=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,me())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class m{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,x=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((de,Me)=>{this.d=de,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=x===f.$Zd?t(le):l(x,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$_g=m;class a{constructor(Q){this.a=new m(Q),this.b=new i}trigger(Q,x){return this.a.trigger(()=>this.b.queue(Q),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ah=a;class c{constructor(){this.a=!1,this.b=new Promise((Q,x)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$bh=c;class E extends c{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$ch=E;function y(me,Q){return Q?new Promise((x,le)=>{const de=setTimeout(()=>{Me.dispose(),x()},me),Me=Q.onCancellationRequested(()=>{clearTimeout(de),Me.dispose(),le(new F.$5)})}):k(x=>y(me,x))}e.$dh=y;function $(me,Q=0,x){const le=setTimeout(()=>{me(),x&&de.dispose()},Q),de=(0,L.$Rc)(()=>{clearTimeout(le),x?.deleteAndLeak(de)});return x?.add(de),de}e.$eh=$;function I(me){const Q=[];let x=0;const le=me.length;function de(){return x<le?me[x++]():null}function Me(ge){ge!=null&&Q.push(ge);const Se=de();return Se?Se.then(Me):Promise.resolve(Q)}return Promise.resolve(null).then(Me)}e.$fh=I;function d(me,Q=le=>!!le,x=null){let le=0;const de=me.length,Me=()=>{if(le>=de)return Promise.resolve(x);const ge=me[le++];return Promise.resolve(ge()).then(Ce=>Q(Ce)?Promise.resolve(Ce):Me())};return Me()}e.$gh=d;function w(me,Q=le=>!!le,x=null){if(me.length===0)return Promise.resolve(x);let le=me.length;const de=()=>{le=-1;for(const Me of me)Me.cancel?.()};return new Promise((Me,ge)=>{for(const Se of me)Se.then(Ce=>{--le>=0&&Q(Ce)?(de(),Me(Ce)):le===0&&Me(x)}).catch(Ce=>{--le>=0&&(de(),ge(Ce))})})}e.$hh=w;class b{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new P.$3d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,le)=>{this.g.push({factory:Q,c:x,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const x=Q.factory();x.then(Q.c,Q.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ih=b;class M extends b{constructor(){super(1)}}e.$jh=M;class T{constructor(){this.a=new he,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$kh=T;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new $e;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,x=R.$Fg){const le=x.getComparisonKey(Q);return this.a.get(le)?.size??0}queueFor(Q,x,le=R.$Fg){const de=le.getComparisonKey(Q);let Me=this.a.get(de);if(!Me){Me=new M;const ge=this.f++,Se=P.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$3c),this.d.set(ge,Se),this.a.set(de,Me)}return Me.queue(x)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$lh=G;class W{constructor(Q,x){this.a=-1,typeof Q=="function"&&typeof x=="number"&&this.setIfNotSet(Q,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},x)}setIfNotSet(Q,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},x))}}e.$mh=W;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,x,le=globalThis){this.cancel();const de=le.setInterval(()=>{Q()},x);this.d=(0,L.$Rc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$nh=U;class C{constructor(Q,x){this.b=-1,this.a=Q,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$oh=C;class O{constructor(Q,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=Q,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ph=O;class V extends C{constructor(Q,x){super(Q,x),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$qh=V;class re extends L.$Tc{constructor(Q,x){super(),this.g=Q,this.h=x,this.a=[],this.b=this.B(new L.$Uc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of Q)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$rh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$th=(me,Q)=>{(0,g.$B)(()=>{if(x)return;const le=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$th=(me,Q,x)=>{const le=me.requestIdleCallback(Q,typeof x=="number"?{timeout:x}:void 0);let de=!1;return{dispose(){de||(de=!0,me.cancelIdleCallback(le))}}},e.$sh=me=>(0,e.$th)(globalThis,me)}();class ce{constructor(Q,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$th)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$uh=ce;class ye extends ce{constructor(Q){super(globalThis,Q)}}e.$vh=ye;async function ke(me,Q,x){let le;for(let de=0;de<x;de++)try{return await me()}catch(Me){le=Me,await y(Q)}throw le}e.$wh=ke;class he{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,x,le){return this.a={taskId:Q,cancel:()=>le?.(),promise:x},x.then(()=>this.d(Q),()=>this.d(Q)),x}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:x,resolve:le,reject:de}=r();this.b={run:Q,promise:x,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$xh=he;class ve{constructor(Q,x=()=>Date.now()){this.d=Q,this.f=x,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$yh=ve;var se;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,x)=>{this.a=Q,this.b=x})}complete(Q){return new Promise(x=>{this.a(Q),this.d={outcome:0,value:Q},x()})}error(Q){return new Promise(x=>{this.b(Q),this.d={outcome:1,value:Q},x()})}cancel(){return this.error(new F.$5)}}e.$zh=$e;var te;(function(me){async function Q(le){let de;const Me=await Promise.all(le.map(ge=>ge.then(Se=>Se,Se=>{de||(de=Se)})));if(typeof de<"u")throw de;return Me}me.settled=Q;function x(le){return new Promise(async(de,Me)=>{try{await le(de,Me)}catch(ge){Me(ge)}})}me.withAsyncBody=x})(te||(e.Promises=te={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new F.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ah=Y;class q{constructor(Q){this.b=Q,this.a=new D.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Bh=q;var ne;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(ne||(ne={}));class Pe{static fromArray(Q){return new Pe(x=>{x.emitMany(Q)})}static fromPromise(Q){return new Pe(async x=>{x.emitMany(await Q)})}static fromPromises(Q){return new Pe(async x=>{await Promise.all(Q.map(async le=>x.emitOne(await le)))})}static merge(Q){return new Pe(async x=>{await Promise.all(Q.map(async le=>{for await(const de of le)x.emitOne(de)}))})}static{this.EMPTY=Pe.fromArray([])}constructor(Q){this.a=0,this.b=[],this.d=null,this.f=new P.$3d,queueMicrotask(async()=>{const x={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(Q(x)),this.j()}catch(le){this.k(le)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(Q,x){return new Pe(async le=>{for await(const de of Q)le.emitOne(x(de))})}map(Q){return Pe.map(this,Q)}static filter(Q,x){return new Pe(async le=>{for await(const de of Q)x(de)&&le.emitOne(de)})}filter(Q){return Pe.filter(this,Q)}static coalesce(Q){return Pe.filter(Q,x=>!!x)}coalesce(){return Pe.coalesce(this)}static async toPromise(Q){const x=[];for await(const le of Q)x.push(le);return x}toPromise(){return Pe.toPromise(this)}g(Q){this.a===0&&(this.b.push(Q),this.f.fire())}h(Q){this.a===0&&(this.b=this.b.concat(Q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Q){this.a===0&&(this.a=2,this.d=Q,this.f.fire())}}e.$Ch=Pe;class Oe extends Pe{constructor(Q,x){super(x),this.l=Q}cancel(){this.l.cancel()}}e.$Dh=Oe;function Re(me){const Q=new S.$ae,x=me(Q.token);return new Oe(Q,async le=>{const de=Q.token.onCancellationRequested(()=>{de.dispose(),Q.dispose(),le.reject(new F.$5)});try{for await(const Me of x){if(Q.token.isCancellationRequested)return;le.emitOne(Me)}de.dispose(),Q.dispose()}catch(Me){de.dispose(),Q.dispose(),le.reject(Me)}})}e.$Eh=Re;class be{constructor(){this.a=new $e,this.b=new Pe(le=>{if(Q){le.reject(Q);return}return x&&le.emitMany(x),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let Q,x;this.f=le=>{x||(x=[]),x.push(le)},this.d=le=>{Q||(Q=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$Fh=be}),define(Fe[34],Le([1,0,18,11,45,28,19,20,13]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;function D(){return Object.create(null)}e.$Qj=D,e.$Rj="**",e.$Sj="/";const A="[/\\\\]",k="[^/\\\\]",h=/\//g;function v(ce,ye){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${ye?`|${A}${k}+`:""})*?`}}function p(ce,ye){if(!ce)return[];const ke=[];let he=!1,ve=!1,se="";for(const $e of ce){switch($e){case ye:if(!he&&!ve){ke.push(se),se="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&ke.push(se),ke}e.$Tj=p;function s(ce){if(!ce)return"";let ye="";const ke=p(ce,e.$Sj);if(ke.every(he=>he===e.$Rj))ye=".*";else{let he=!1;ke.forEach((ve,se)=>{if(ve===e.$Rj){if(he)return;ye+=v(2,se===ke.length-1)}else{let $e=!1,te="",Y=!1,q="";for(const ne of ve){if(ne!=="}"&&$e){te+=ne;continue}if(Y&&(ne!=="]"||!q)){let Pe;ne==="-"?Pe=ne:(ne==="^"||ne==="!")&&!q?Pe="^":ne===e.$Sj?Pe="":Pe=(0,f.$Ve)(ne),q+=Pe;continue}switch(ne){case"{":$e=!0;continue;case"[":Y=!0;continue;case"}":{const Oe=`(?:${p(te,",").map(Re=>s(Re)).join("|")})`;ye+=Oe,$e=!1,te="";break}case"]":{ye+="["+q+"]",Y=!1,q="";break}case"?":ye+=k;continue;case"*":ye+=v(1);continue;default:ye+=(0,f.$Ve)(ne)}}se<ke.length-1&&(ke[se+1]!==e.$Rj||se+2<ke.length)&&(ye+=A)}he=ve===e.$Rj})}return ye}const u=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),m=function(){return!1},a=function(){return null};function c(ce,ye){if(!ce)return a;let ke;typeof ce!="string"?ke=ce.pattern:ke=ce,ke=ke.trim();const he=`${ke}_${!!ye.trimForExclusions}`;let ve=t.get(he);if(ve)return E(ve,ce);let se;return u.test(ke)?ve=$(ke.substr(4),ke):(se=r.exec(y(ke,ye)))?ve=I(se[1],ke):(ye.trimForExclusions?n:i).test(ke)?ve=d(ke,ye):(se=o.exec(y(ke,ye)))?ve=w(se[1].substr(1),ke,!0):(se=l.exec(y(ke,ye)))?ve=w(se[1],ke,!1):ve=b(ke),t.set(he,ve),E(ve,ce)}function E(ce,ye){if(typeof ye=="string")return ce;const ke=function(he,ve){return(0,P.$dg)(he,ye.base,!g.$k)?ce((0,f.$1e)(he.substr(ye.base.length),R.sep),ve):null};return ke.allBasenames=ce.allBasenames,ke.allPaths=ce.allPaths,ke.basenames=ce.basenames,ke.patterns=ce.patterns,ke}function y(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function $(ce,ye){return function(ke,he){return typeof ke=="string"&&ke.endsWith(ce)?ye:null}}function I(ce,ye){const ke=`/${ce}`,he=`\\${ce}`,ve=function($e,te){return typeof $e!="string"?null:te?te===ce?ye:null:$e===ce||$e.endsWith(ke)||$e.endsWith(he)?ye:null},se=[ce];return ve.basenames=se,ve.patterns=[ye],ve.allBasenames=se,ve}function d(ce,ye){const ke=V(ce.slice(1,-1).split(",").map(te=>c(te,ye)).filter(te=>te!==a),ce),he=ke.length;if(!he)return a;if(he===1)return ke[0];const ve=function(te,Y){for(let q=0,ne=ke.length;q<ne;q++)if(ke[q](te,Y))return ce;return null},se=ke.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=ke.reduce((te,Y)=>Y.allPaths?te.concat(Y.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function w(ce,ye,ke){const he=R.sep===R.$gc.sep,ve=he?ce:ce.replace(h,R.sep),se=R.sep+ve,$e=R.$gc.sep+ce;let te;return ke?te=function(Y,q){return typeof Y=="string"&&(Y===ve||Y.endsWith(se)||!he&&(Y===ce||Y.endsWith($e)))?ye:null}:te=function(Y,q){return typeof Y=="string"&&(Y===ve||!he&&Y===ce)?ye:null},te.allPaths=[(ke?"*/":"./")+ce],te}function b(ce){try{const ye=new RegExp(`^${s(ce)}$`);return function(ke){return ye.lastIndex=0,typeof ke=="string"&&ye.test(ke)?ce:null}}catch{return a}}function M(ce,ye,ke){return!ce||typeof ye!="string"?!1:T(ce)(ye,void 0,ke)}e.$Uj=M;function T(ce,ye={}){if(!ce)return m;if(typeof ce=="string"||G(ce)){const ke=c(ce,ye);if(ke===a)return m;const he=function(ve,se){return!!ke(ve,se)};return ke.allBasenames&&(he.allBasenames=ke.allBasenames),ke.allPaths&&(he.allPaths=ke.allPaths),he}return C(ce,ye)}e.$Vj=T;function G(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$Wj=G;function W(ce){return ce.allBasenames||[]}e.$Xj=W;function U(ce){return ce.allPaths||[]}e.$Yj=U;function C(ce,ye){const ke=V(Object.getOwnPropertyNames(ce).map(te=>O(te,ce[te],ye)).filter(te=>te!==a)),he=ke.length;if(!he)return a;if(!ke.some(te=>!!te.requiresSiblings)){if(he===1)return ke[0];const te=function(ne,Pe){let Oe;for(let Re=0,be=ke.length;Re<be;Re++){const me=ke[Re](ne,Pe);if(typeof me=="string")return me;(0,F.$1g)(me)&&(Oe||(Oe=[]),Oe.push(me))}return Oe?(async()=>{for(const Re of Oe){const be=await Re;if(typeof be=="string")return be}return null})():null},Y=ke.find(ne=>!!ne.allBasenames);Y&&(te.allBasenames=Y.allBasenames);const q=ke.reduce((ne,Pe)=>Pe.allPaths?ne.concat(Pe.allPaths):ne,[]);return q.length&&(te.allPaths=q),te}const ve=function(te,Y,q){let ne,Pe;for(let Oe=0,Re=ke.length;Oe<Re;Oe++){const be=ke[Oe];be.requiresSiblings&&q&&(Y||(Y=(0,R.$nc)(te)),ne||(ne=Y.substr(0,Y.length-(0,R.$oc)(te).length)));const me=be(te,Y,ne,q);if(typeof me=="string")return me;(0,F.$1g)(me)&&(Pe||(Pe=[]),Pe.push(me))}return Pe?(async()=>{for(const Oe of Pe){const Re=await Oe;if(typeof Re=="string")return Re}return null})():null},se=ke.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=ke.reduce((te,Y)=>Y.allPaths?te.concat(Y.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function O(ce,ye,ke){if(ye===!1)return a;const he=c(ce,ke);if(he===a)return a;if(typeof ye=="boolean")return he;if(ye){const ve=ye.when;if(typeof ve=="string"){const se=($e,te,Y,q)=>{if(!q||!he($e,te))return null;const ne=ve.replace("$(basename)",()=>Y),Pe=q(ne);return(0,F.$1g)(Pe)?Pe.then(Oe=>Oe?ce:null):Pe?ce:null};return se.requiresSiblings=!0,se}}return he}function V(ce,ye){const ke=ce.filter(te=>!!te.basenames);if(ke.length<2)return ce;const he=ke.reduce((te,Y)=>{const q=Y.basenames;return q?te.concat(q):te},[]);let ve;if(ye){ve=[];for(let te=0,Y=he.length;te<Y;te++)ve.push(ye)}else ve=ke.reduce((te,Y)=>{const q=Y.patterns;return q?te.concat(q):te},[]);const se=function(te,Y){if(typeof te!="string")return null;if(!Y){let ne;for(ne=te.length;ne>0;ne--){const Pe=te.charCodeAt(ne-1);if(Pe===47||Pe===92)break}Y=te.substr(ne)}const q=he.indexOf(Y);return q!==-1?ve[q]:null};se.basenames=he,se.patterns=ve,se.allBasenames=he;const $e=ce.filter(te=>!te.basenames);return $e.push(se),$e}function re(ce,ye){return(0,S.$ub)(ce,ye,(ke,he)=>typeof ke=="string"&&typeof he=="string"?ke===he:typeof ke!="string"&&typeof he!="string"?ke.base===he.base&&ke.pattern===he.pattern:!1)}e.$Zj=re}),define(Fe[46],Le([1,0,15,127,25,13,2]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class f{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=h(this.supportThemeIcons?(0,F.$kk)(i):i).replace(/([ \t]+)/g,(o,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${v(n,i)}
`,this}appendLink(i,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(i,n){const o=new RegExp((0,L.$Ve)(n),"g");return i.replace(o,(l,t)=>i.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$qk=f;function D(r){return A(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.$rk=D;function A(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$sk=A;function k(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,P.$Ig)(R.URI.from(r.baseUri),R.URI.from(i.baseUri)))}e.$tk=k;function h(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$uk=h;function v(r,i){const n=r.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${i}`,r,`${"`".repeat(o)}`].join(`
`)}e.$vk=v;function p(r){return r.replace(/"/g,"&quot;")}e.$wk=p;function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$xk=s;function u(r){const i=[],n=r.split("|").map(l=>l.trim());r=n[0];const o=n[1];if(o){const l=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),m=l?l[1]:"",a=t?t[1]:"",c=isFinite(parseInt(a)),E=isFinite(parseInt(m));c&&i.push(`width="${a}"`),E&&i.push(`height="${m}"`)}return{href:r,dimensions:i}}e.$yk=u}),define(Fe[94],Le([1,0,18,45,19,20,25,13]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.$7v=e.$6v=e.$5v=void 0;function f(c,E){const{os:y,tildify:$,relative:I}=E;if(I){const b=D(c,I,y);if(typeof b=="string")return b}let d=c.fsPath;if(y===1&&!L.$i?d=d.replace(/\//g,"\\"):y!==1&&L.$i&&(d=d.replace(/\\/g,"/")),y!==1&&$?.userHome){const b=$.userHome.fsPath;let M;c.scheme!==$.userHome.scheme&&c.path[0]===P.$gc.sep&&c.path[1]!==P.$gc.sep?M=$.userHome.with({path:c.path}).fsPath:M=d,d=h(M,b,y)}return(y===1?P.$fc:P.$gc).normalize(A(d,y===1))}e.$5v=f;function D(c,E,y){const $=y===1?P.$fc:P.$gc,I=y===3?R.$Fg:R.$Hg,d=E.getWorkspace(),w=(0,S.$Ob)(d.folders);if(!w)return;c.scheme!==w.uri.scheme&&c.path[0]===P.$gc.sep&&c.path[1]!==P.$gc.sep&&(c=w.uri.with({path:c.path}));const b=E.getWorkspaceFolder(c);if(!b)return;let M;if(I.isEqual(b.uri,c)?M="":M=I.relativePath(b.uri,c)??"",M&&(M=$.normalize(M)),d.folders.length>1&&!E.noPrefix){const T=b.name?b.name:I.basenameOrAuthority(b.uri);M=M?`${T} \u2022 ${M}`:T}return M}function A(c,E=L.$i){return(0,F.$hg)(c,E)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$6v=A;let k=Object.create(null);function h(c,E,y=L.OS){if(y===1||!c||!E)return c;let $=k.original===E?k.normalized:void 0;$||($=E,L.$i&&($=(0,F.$0f)($)),$=`${(0,g.$2e)($,P.$gc.sep)}${P.$gc.sep}`,k={original:E,normalized:$});let I=c;return L.$i&&(I=(0,F.$0f)(I)),(y===3?I.startsWith($):(0,g.$if)(I,$))?`~/${I.substr($.length)}`:c}e.$7v=h;function v(c,E){return c.replace(/^~($|\/|\\)/,`${E}$1`)}e.$8v=v;const p="\u2026",s="\\\\",u="~";function r(c,E=P.sep){const y=new Array(c.length);let $=!1;for(let I=0;I<c.length;I++){const d=c[I];if(d===""){y[I]=`.${E}`;continue}if(!d){y[I]=d;continue}$=!0;let w="",b=d;b.indexOf(s)===0?(w=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(E)===0?(w=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(u)===0&&(w=b.substr(0,b.indexOf(u)+u.length),b=b.substr(b.indexOf(u)+u.length));const M=b.split(E);for(let T=1;$&&T<=M.length;T++)for(let G=M.length-T;$&&G>=0;G--){$=!1;let W=M.slice(G,G+T).join(E);for(let U=0;!$&&U<c.length;U++)if(U!==I&&c[U]&&c[U].indexOf(W)>-1){const C=G+T===M.length,O=G>0&&c[U].indexOf(E)>-1?E+W:W,V=c[U].endsWith(O);$=!C||V}if(!$){let U="";(M[0].endsWith(":")||w!=="")&&(G===1&&(G=0,T++,W=M[0]+E+W),G>0&&(U=M[0]+E),U=w+U),G>0&&(U=U+p+E),U=U+W,G+T<M.length&&(U=U+E+p),y[I]=U}}$&&(y[I]=d)}return y}e.$9v=r;var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,E=Object.create(null)){const y=[];let $=!1,I="";for(const d of c)if(d==="$"||$&&d==="{")I&&y.push({value:I,type:i.TEXT}),I="",$=!0;else if(d==="}"&&$){const w=E[I];if(typeof w=="string")w.length&&y.push({value:w,type:i.VARIABLE});else if(w){const b=y[y.length-1];(!b||b.type!==i.SEPARATOR)&&y.push({value:w.label,type:i.SEPARATOR})}I="",$=!1}else I+=d;return I&&!$&&y.push({value:I,type:i.TEXT}),y.filter((d,w)=>{if(d.type===i.SEPARATOR){const b=y[w-1],M=y[w+1];return[b,M].every(T=>T&&(T.type===i.VARIABLE||T.type===i.TEXT)&&T.value.length>0)}return!0}).map(d=>d.value).join("")}e.$0v=n;function o(c,E){return L.$j||E?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):c.replace(/&&|&/g,y=>y==="&"?"&&":"&")}e.$$v=o;function l(c,E){return L.$j||E?c.replace(/\(&&\w\)|&&/g,""):L.$i?c.replace(/&&|&/g,y=>y==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$_v=l;function t(c){return c.replace(/&/g,"&&")}e.$aw=t;function m(c){if(c.endsWith("]")){const E=c.lastIndexOf(" [",c.length-2);if(E!==-1){const y=a(c.substring(0,E)),$=c.substring(E);return{name:y.name+$,parentPath:y.parentPath}}}return a(c)}e.$bw=m;function a(c){const E=c.indexOf("/")!==-1?P.$gc:P.$fc,y=E.basename(c),$=E.dirname(c);return y.length?{name:y,parentPath:$}:{name:$,parentPath:""}}}),define(Fe[140],Le([1,0,24,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=void 0;function P(k){return k.toJSON()}class L{constructor(h){this.a=h}transformIncoming(h){const v=this.a.transformIncoming(h);return v===h?h:P(F.URI.from(v))}transformOutgoing(h){const v=this.a.transformOutgoing(h);return v===h?h:P(F.URI.from(v))}transformOutgoingURI(h){const v=this.a.transformOutgoing(h);return v===h?h:F.URI.from(v)}transformOutgoingScheme(h){return this.a.transformOutgoingScheme(h)}}e.$bn=L,e.$cn=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,h,v){if(!k||v>200)return null;if(typeof k=="object"){if(k instanceof F.URI)return h.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const s=R(k[p],h,v+1);s!==null&&(k[p]=s)}}return null}function g(k,h){const v=R(k,h,0);return v===null?k:v}e.$dn=g;function f(k,h,v,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return v?F.URI.revive(h.transformIncoming(k)):h.transformIncoming(k);if(k instanceof S.$qe)return null;for(const s in k)if(Object.hasOwnProperty.call(k,s)){const u=f(k[s],h,v,p+1);u!==null&&(k[s]=u)}}return null}function D(k,h){const v=f(k,h,!1,0);return v===null?k:v}e.$en=D;function A(k,h){const v=f(k,h,!0,0);return v===null?k:v}e.$fn=A}),define(Fe[141],Le([1,0,13,20,24]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=e.$kt=e.$jt=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let g;function f(){return g||(g=new TextDecoder("UTF-16BE")),g}let D;function A(){return D||(D=F.$D()?R():f()),D}e.$jt=A;function k(p,s,u){const r=new Uint16Array(p.buffer,s,u);return u>0&&(r[0]===65279||r[0]===65534)?h(p,s,u):R().decode(r)}e.$kt=k;function h(p,s,u){const r=[];let i=0;for(let n=0;n<u;n++){const o=P.$se(p,s);s+=2,r[i++]=String.fromCharCode(o)}return r.join("")}class v{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return A().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const u=this.a-this.d;u<=1&&(u===0||S.$lf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const u=s.length;if(this.d+u>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<u;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$lt=v}),define(Fe[142],Le([1,0,24,141]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.$mt=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,A,k,h){this.oldPosition=D,this.oldText=A,this.newPosition=k,this.newText=h}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,A,k){const h=A.length;S.$ve(D,h,k),k+=4;for(let v=0;v<h;v++)S.$te(D,A.charCodeAt(v),k),k+=2;return k}static d(D,A){const k=S.$ue(D,A);return A+=4,(0,F.$kt)(D,A,k)}writeSize(){return 8+L.a(this.oldText)+L.a(this.newText)}write(D,A){return S.$ve(D,this.oldPosition,A),A+=4,S.$ve(D,this.newPosition,A),A+=4,A=L.c(D,this.oldText,A),A=L.c(D,this.newText,A),A}static read(D,A,k){const h=S.$ue(D,A);A+=4;const v=S.$ue(D,A);A+=4;const p=L.d(D,A);A+=L.a(p);const s=L.d(D,A);return A+=L.a(s),k.push(new L(h,p,v,s)),A}}e.$mt=L;function R(f,D){return f===null||f.length===0?D:new g(f,D).compress()}e.$nt=R;class g{constructor(D,A){this.a=D,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,A=0,k=this.n(D),h=this.l(A);for(;D<this.f||A<this.h;){if(k===null){this.k(h),h=this.l(++A);continue}if(h===null){this.m(k),k=this.n(++D);continue}if(h.oldEnd<=k.newPosition){this.k(h),h=this.l(++A);continue}if(k.newEnd<=h.oldPosition){this.m(k),k=this.n(++D);continue}if(h.oldPosition<k.newPosition){const[r,i]=g.r(h,k.newPosition-h.oldPosition);this.k(r),h=i;continue}if(k.newPosition<h.oldPosition){const[r,i]=g.q(k,h.oldPosition-k.newPosition);this.m(r),k=i;continue}let s,u;if(h.oldEnd===k.newEnd)s=k,u=h,k=this.n(++D),h=this.l(++A);else if(h.oldEnd<k.newEnd){const[r,i]=g.q(k,h.oldLength);s=r,u=h,k=i,h=this.l(++A)}else{const[r,i]=g.r(h,k.newLength);s=k,u=r,k=this.n(++D),h=i}this.d[this.e++]=new L(s.oldPosition,s.oldText,u.newPosition,u.newText),this.g+=s.newLength-s.oldLength,this.j+=u.newLength-u.oldLength}const v=g.s(this.d);return g.t(v)}k(D){this.d[this.e++]=g.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=g.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,A){return new L(A.oldPosition-D,A.oldText,A.newPosition,A.newText)}static p(D,A){return new L(A.oldPosition,A.oldText,A.newPosition+D,A.newText)}static q(D,A){const k=D.newText.substr(0,A),h=D.newText.substr(A);return[new L(D.oldPosition,D.oldText,D.newPosition,k),new L(D.oldEnd,"",D.newPosition+A,h)]}static r(D,A){const k=D.oldText.substr(0,A),h=D.oldText.substr(A);return[new L(D.oldPosition,k,D.newPosition,D.newText),new L(D.oldPosition+A,h,D.newEnd,"")]}static s(D){if(D.length===0)return D;const A=[];let k=0,h=D[0];for(let v=1;v<D.length;v++){const p=D[v];h.oldEnd===p.oldPosition?h=new L(h.oldPosition,h.oldText+p.oldText,h.newPosition,h.newText+p.newText):(A[k++]=h,h=p)}return A[k++]=h,A}static t(D){if(D.length===0)return D;const A=[];let k=0;for(let h=0;h<D.length;h++){const v=D[h];v.oldText!==v.newText&&(A[k++]=v)}return A}}}),define(Fe[143],Le([1,0,34,19]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=void 0;function P(L,R,g,f,D,A){if(Array.isArray(L)){let k=0;for(const h of L){const v=P(h,R,g,f,D,A);if(v===10)return v;v>k&&(k=v)}return k}else{if(typeof L=="string")return f?L==="*"?5:L===g?10:0:0;if(L){const{language:k,pattern:h,scheme:v,hasAccessToAllModels:p,notebookType:s}=L;if(!f&&!p)return 0;s&&D&&(R=D);let u=0;if(v)if(v===R.scheme)u=10;else if(v==="*")u=5;else return 0;if(k)if(k===g)u=10;else if(k==="*")u=Math.max(u,5);else return 0;if(s)if(s===A)u=10;else if(s==="*"&&A!==void 0)u=Math.max(u,5);else return 0;if(h){let r;if(typeof h=="string"?r=h:r={...h,base:(0,F.$hc)(h.base)},r===R.fsPath||(0,S.$Uj)(r,R.fsPath))u=10;else return 0}return u}else return 0}}e.$Kt=P}),define(Fe[144],Le([1,0,5,13,29,92,90,129,142,6]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kC=void 0;class A extends D.$Tc{constructor(h,v,p,s,u,r,i){super(),this.m=this.B(new S.$3d),this.onDidChangeContent=this.m.event,this.f=v,this.j=!r,this.g=s,this.h=u,this.c=new R.$jC(h,p,i)}equals(h){return!(h instanceof A)||this.f!==h.f||this.getEOL()!==h.getEOL()?!1:this.c.equal(h.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(h){return this.c.createSnapshot(h?this.f:"")}getOffsetAt(h,v){return this.c.getOffsetAt(h,v)}getPositionAt(h){return this.c.getPositionAt(h)}getRangeAt(h,v){const p=h+v,s=this.getPositionAt(h),u=this.getPositionAt(p);return new P.$4s(s.lineNumber,s.column,u.lineNumber,u.column)}getValueInRange(h,v=0){if(h.isEmpty())return"";const p=this.n(v);return this.c.getValueInRange(h,p)}getValueLengthInRange(h,v=0){if(h.isEmpty())return 0;if(h.startLineNumber===h.endLineNumber)return h.endColumn-h.startColumn;const p=this.getOffsetAt(h.startLineNumber,h.startColumn),s=this.getOffsetAt(h.endLineNumber,h.endColumn);let u=0;const r=this.n(v),i=this.getEOL();if(r.length!==i.length){const n=r.length-i.length,o=h.endLineNumber-h.startLineNumber;u=n*o}return s-p+u}getCharacterCountInRange(h,v=0){if(this.j){let p=0;const s=h.startLineNumber,u=h.endLineNumber;for(let r=s;r<=u;r++){const i=this.getLineContent(r),n=r===s?h.startColumn-1:0,o=r===u?h.endColumn-1:i.length;for(let l=n;l<o;l++)F.$lf(i.charCodeAt(l))?(p=p+1,l=l+1):p=p+1}return p+=this.n(v).length*(u-s),p}return this.getValueLengthInRange(h,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(h){return this.c.getLineContent(h)}getLineCharCode(h,v){return this.c.getLineCharCode(h,v)}getCharCode(h){return this.c.getCharCode(h)}getLineLength(h){return this.c.getLineLength(h)}getLineMinColumn(h){return 1}getLineMaxColumn(h){return this.getLineLength(h)+1}getLineFirstNonWhitespaceColumn(h){const v=F.$9e(this.getLineContent(h));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(h){const v=F.$$e(this.getLineContent(h));return v===-1?0:v+2}n(h){switch(h){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(h){this.c.setEOL(h)}applyEdits(h,v,p){let s=this.g,u=this.h,r=this.j,i=!0,n=[];for(let E=0;E<h.length;E++){const y=h[E];i&&y._isTracked&&(i=!1);const $=y.range;if(y.text){let M=!0;r||(M=!F.$wf(y.text),r=M),!s&&M&&(s=F.$vf(y.text)),!u&&M&&(u=F.$yf(y.text))}let I="",d=0,w=0,b=0;if(y.text){let M;[d,w,b,M]=(0,g.$Dt)(y.text);const T=this.getEOL();M===0||M===(T===`\r
`?2:1)?I=y.text:I=y.text.replace(/\r\n|\r|\n/g,T)}n[E]={sortIndex:E,identifier:y.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:I,eolCount:d,firstLineLength:w,lastLineLength:b,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let E=0,y=n.length-1;E<y;E++){const $=n[E].range.getEndPosition(),I=n[E+1].range.getStartPosition();if(I.isBeforeOrEqual($)){if(I.isBefore($))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const l=p||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let E=0;E<n.length;E++){const y=n[E],$=l[E];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let I=$.startLineNumber;I<=$.endLineNumber;I++){let d="";I===$.startLineNumber&&(d=this.getLineContent(y.range.startLineNumber),F.$9e(d)!==-1)||t.push({lineNumber:I,oldContent:d})}}let m=null;if(p){let E=0;m=[];for(let y=0;y<n.length;y++){const $=n[y],I=l[y],d=this.getValueInRange($.range),w=$.rangeOffset+E;E+=$.text.length-d.length,m[y]={sortIndex:$.sortIndex,identifier:$.identifier,range:I,text:d,textChange:new f.$mt($.rangeOffset,d,w,$.text)}}o||m.sort((y,$)=>y.sortIndex-$.sortIndex)}this.g=s,this.h=u,this.j=r;const a=this.t(n);let c=null;if(v&&t.length>0){t.sort((E,y)=>y.lineNumber-E.lineNumber),c=[];for(let E=0,y=t.length;E<y;E++){const $=t[E].lineNumber;if(E>0&&t[E-1].lineNumber===$)continue;const I=t[E].oldContent,d=this.getLineContent($);d.length===0||d===I||F.$9e(d)!==-1||c.push($)}}return this.m.fire(),new L.$nv(m,a,c)}s(h){return h.length<1e3?h:[this._toSingleEditOperation(h)]}_toSingleEditOperation(h){let v=!1;const p=h[0].range,s=h[h.length-1].range,u=new P.$4s(p.startLineNumber,p.startColumn,s.endLineNumber,s.endColumn);let r=p.startLineNumber,i=p.startColumn;const n=[];for(let a=0,c=h.length;a<c;a++){const E=h[a],y=E.range;v=v||E.forceMoveMarkers,n.push(this.getValueInRange(new P.$4s(r,i,y.startLineNumber,y.startColumn))),E.text.length>0&&n.push(E.text),r=y.endLineNumber,i=y.endColumn}const o=n.join(""),[l,t,m]=(0,g.$Dt)(o);return{sortIndex:0,identifier:h[0].identifier,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u,0),text:o,eolCount:l,firstLineLength:t,lastLineLength:m,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(h){h.sort(A.w);const v=[];for(let p=0;p<h.length;p++){const s=h[p],u=s.range.startLineNumber,r=s.range.startColumn,i=s.range.endLineNumber,n=s.range.endColumn;if(u===i&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const o=new P.$4s(u,r,i,n);v.push({range:o,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return v}findMatchesLineByLine(h,v,p,s){return this.c.findMatchesLineByLine(h,v,p,s)}getPieceTree(){return this.c}static _getInverseEditRange(h,v){const p=h.startLineNumber,s=h.startColumn,[u,r,i]=(0,g.$Dt)(v);let n;if(v.length>0){const o=u+1;o===1?n=new P.$4s(p,s,p,s+r):n=new P.$4s(p,s,p+o-1,i+1)}else n=new P.$4s(p,s,p,s);return n}static _getInverseEditRanges(h){const v=[];let p=0,s=0,u=null;for(let r=0,i=h.length;r<i;r++){const n=h[r];let o,l;u?u.range.endLineNumber===n.range.startLineNumber?(o=p,l=s+(n.range.startColumn-u.range.endColumn)):(o=p+(n.range.startLineNumber-u.range.endLineNumber),l=n.range.startColumn):(o=n.range.startLineNumber,l=n.range.startColumn);let t;if(n.text.length>0){const m=n.eolCount+1;m===1?t=new P.$4s(o,l,o,l+n.firstLineLength):t=new P.$4s(o,l,o+m-1,n.lastLineLength+1)}else t=new P.$4s(o,l,o,l);p=t.endLineNumber,s=t.endColumn,v.push(t),u=n}return v}static u(h,v){const p=P.$4s.compareRangesUsingEnds(h.range,v.range);return p===0?h.sortIndex-v.sortIndex:p}static w(h,v){const p=P.$4s.compareRangesUsingEnds(h.range,v.range);return p===0?v.sortIndex-h.sortIndex:-p}}e.$kC=A}),define(Fe[145],Le([1,0,13,90,144]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=void 0;class L{constructor(f,D,A,k,h,v,p,s,u){this.a=f,this.b=D,this.c=A,this.d=k,this.e=h,this.f=v,this.g=p,this.h=s,this.j=u}k(f){const D=this.c+this.d+this.e,A=this.c+this.e;return D===0?f===1?`
`:`\r
`:A>D/2?`\r
`:`
`}create(f){const D=this.k(f),A=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let h=0,v=A.length;h<v;h++){const p=A[h].buffer.replace(/\r\n|\r|\n/g,D),s=(0,F.$fC)(p);A[h]=new F.$iC(p,s)}const k=new P.$kC(A,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Ef(f)&&(this.b=S.$Df,f=f.substr(1));const D=f.charCodeAt(f.length-1);D===13||D>=55296&&D<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=D):(this.m(f,!1),this.c=!1,this.d=D)}m(f,D){!D&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const D=(0,F.$gC)(this.e,f);this.a.push(new F.$iC(f,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=S.$vf(f)),this.k||(this.k=S.$yf(f)))}finish(f=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const D=(0,F.$fC)(f.buffer);f.lineStarts=D,this.d===13&&this.f++}}}e.$lC=R}),define(Fe[95],Le([1,0,24,20]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_=e.$I_=void 0;var P;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(P||(P={}));function L(k){for(let h=0,v=k.length;h<v;h+=4){const p=k[h+0],s=k[h+1],u=k[h+2],r=k[h+3];k[h+0]=r,k[h+1]=u,k[h+2]=s,k[h+3]=p}}function R(k){const h=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return F.$D()||L(h),S.$qe.wrap(h)}function g(k){const h=k.buffer;if(F.$D()||L(h),h.byteOffset%4===0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const v=new Uint8Array(h.byteLength);return v.set(h),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function f(k){const h=new Uint32Array(D(k));let v=0;if(h[v++]=k.id,k.type==="full")h[v++]=1,h[v++]=k.data.length,h.set(k.data,v),v+=k.data.length;else{h[v++]=2,h[v++]=k.deltas.length;for(const p of k.deltas)h[v++]=p.start,h[v++]=p.deleteCount,p.data?(h[v++]=p.data.length,h.set(p.data,v),v+=p.data.length):h[v++]=0}return R(h)}e.$I_=f;function D(k){let h=0;if(h+=2,k.type==="full")h+=1+k.data.length;else{h+=1,h+=3*k.deltas.length;for(const v of k.deltas)v.data&&(h+=v.data.length)}return h}function A(k){const h=g(k);let v=0;const p=h[v++];if(h[v++]===1){const i=h[v++],n=h.subarray(v,v+i);return v+=i,{id:p,type:"full",data:n}}const u=h[v++],r=[];for(let i=0;i<u;i++){const n=h[v++],o=h[v++],l=h[v++];let t;l>0&&(t=h.subarray(v,v+l),v+=l),r[i]={start:n,deleteCount:o,data:t}}return{id:p,type:"delta",deltas:r}}e.$J_=A}),define(Fe[146],Le([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Fe[147],Le([1,0,18,26,20,130,148,146]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=D;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,pe,We,Qe){this.id=_,this.name=pe,this.defaultValue=We,this.schema=Qe}applyUpdate(_,pe){return v(_,pe)}compute(_,pe,We){return We}}class h{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=h;function v(X,_){if(typeof X!="object"||typeof _!="object"||!X||!_)return new h(_,X!==_);if(Array.isArray(X)||Array.isArray(_)){const We=Array.isArray(X)&&Array.isArray(_)&&S.$ub(X,_);return new h(_,!We)}let pe=!1;for(const We in _)if(_.hasOwnProperty(We)){const Qe=v(X[We],_[We]);Qe.didChange&&(X[We]=Qe.newValue,pe=!0)}return new h(X,pe)}class p{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return v(_,pe)}validate(_){return this.defaultValue}}class s{constructor(_,pe,We,Qe){this.id=_,this.name=pe,this.defaultValue=We,this.schema=Qe}applyUpdate(_,pe){return v(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,We){return We}}function u(X,_){return typeof X>"u"?_:X==="false"?!1:!!X}e.boolean=u;class r extends s{constructor(_,pe,We,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=We),super(_,pe,We,Qe)}validate(_){return u(_,this.defaultValue)}}function i(X,_,pe,We){if(typeof X>"u")return _;let Qe=parseInt(X,10);return isNaN(Qe)?_:(Qe=Math.max(pe,Qe),Qe=Math.min(We,Qe),Qe|0)}e.clampedInt=i;class n extends s{static clampedInt(_,pe,We,Qe){return i(_,pe,We,Qe)}constructor(_,pe,We,Qe,it,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=We,rt.minimum=Qe,rt.maximum=it),super(_,pe,We,rt),this.minimum=Qe,this.maximum=it}validate(_){return n.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function o(X,_,pe,We){if(typeof X>"u")return _;const Qe=l.float(X,_);return l.clamp(Qe,pe,We)}e.clampedFloat=o;class l extends s{static clamp(_,pe,We){return _<pe?pe:_>We?We:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const We=parseFloat(_);return isNaN(We)?pe:We}constructor(_,pe,We,Qe,it){typeof it<"u"&&(it.type="number",it.default=We),super(_,pe,We,it),this.validationFn=Qe}validate(_){return this.validationFn(l.float(_,this.defaultValue))}}class t extends s{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,We,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=We),super(_,pe,We,Qe)}validate(_){return t.string(_,this.defaultValue)}}function m(X,_,pe,We){return typeof X!="string"?_:We&&X in We?We[X]:pe.indexOf(X)===-1?_:X}e.stringSet=m;class a extends s{constructor(_,pe,We,Qe,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=We),super(_,pe,We,it),this.c=Qe}validate(_){return m(_,this.defaultValue,this.c)}}class c extends k{constructor(_,pe,We,Qe,it,rt,Te=void 0){typeof Te<"u"&&(Te.type="string",Te.enum=it,Te.default=Qe),super(_,pe,We,Te),this.c=it,this.d=rt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function E(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class y extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,We){return We===0?_.accessibilitySupport:We}}class $ extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:g.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:u(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function d(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function b(X){switch(X){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function M(X){switch(X){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class T extends p{constructor(){super(140)}compute(_,pe,We){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class G extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(_,pe,We){return We&&_.emptySelectionClipboard}}class W extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:g.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:g.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:u(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":m(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":m(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(pe.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?U.OFF:_==="true"?U.ON:_:_?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?C.OFF:_==="true"?C.TRANSLATE:_:_?C.TRANSLATE:C.OFF}compute(_,pe,We){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class O extends p{constructor(){super(50)}compute(_,pe,We){return _.fontInfo}}class V extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(_){const pe=l.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(pe,6,100)}compute(_,pe,We){return _.fontInfo.fontSize}}class re extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(n.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ce extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:We,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:We,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:We,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:We,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:We,description:g.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:m(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??m(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??m(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??m(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??m(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??m(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:g.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:u(pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:u(pe.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class he extends p{constructor(){super(143)}compute(_,pe,We){return he.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,We=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const it=(We+_.viewLineCount+Qe)/(_.pixelRatio*_.height),rt=Math.floor(_.viewLineCount/it);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Qe,desiredRatio:it,minimapLineCount:rt}}static c(_,pe){const We=_.outerWidth,Qe=_.outerHeight,it=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const rt=pe.stableMinimapLayoutInput,Te=rt&&_.outerHeight===rt.outerHeight&&_.lineHeight===rt.lineHeight&&_.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&_.pixelRatio===rt.pixelRatio&&_.scrollBeyondLastLine===rt.scrollBeyondLastLine&&_.paddingTop===rt.paddingTop&&_.paddingBottom===rt.paddingBottom&&_.minimap.enabled===rt.minimap.enabled&&_.minimap.side===rt.minimap.side&&_.minimap.size===rt.minimap.size&&_.minimap.showSlider===rt.minimap.showSlider&&_.minimap.renderCharacters===rt.minimap.renderCharacters&&_.minimap.maxColumn===rt.minimap.maxColumn&&_.minimap.scale===rt.minimap.scale&&_.verticalScrollbarWidth===rt.verticalScrollbarWidth&&_.isViewportWrapping===rt.isViewportWrapping,Tt=_.lineHeight,Xt=_.typicalHalfwidthCharacterWidth,xt=_.scrollBeyondLastLine,Ut=_.minimap.renderCharacters;let Dt=it>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const ei=_.minimap.maxColumn,jt=_.minimap.size,si=_.minimap.side,Yt=_.verticalScrollbarWidth,_t=_.viewLineCount,Ye=_.remainingWidth,Bt=_.isViewportWrapping,ti=Ut?2:3;let ht=Math.floor(it*Qe);const mt=ht/it;let Gt=!1,ii=!1,Pt=ti*Dt,dt=Dt/it,At=1;if(jt==="fill"||jt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Ct,desiredRatio:zt,minimapLineCount:Wt}=he.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:xt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:Tt,pixelRatio:it});if(_t/Wt>1)Gt=!0,ii=!0,Dt=1,Pt=1,dt=Dt/it;else{let St=!1,Jt=Dt+1;if(jt==="fit"){const Et=Math.ceil((Ft+_t+Ct)*Pt);Bt&&Te&&Ye<=pe.stableFitRemainingWidth?(St=!0,Jt=pe.stableFitMaxMinimapScale):St=Et>ht}if(jt==="fill"||St){Gt=!0;const Et=Dt;Pt=Math.min(Tt*it,Math.max(1,Math.floor(1/zt))),Bt&&Te&&Ye<=pe.stableFitRemainingWidth&&(Jt=pe.stableFitMaxMinimapScale),Dt=Math.min(Jt,Math.max(1,Math.floor(Pt/ti))),Dt>Et&&(At=Math.min(2,Dt/Et)),dt=Dt/it/At,ht=Math.ceil(Math.max(ft,Ft+_t+Ct)*Pt),Bt?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Ye,pe.stableFitMaxMinimapScale=Dt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const oi=Math.floor(ei*dt),Mt=Math.min(oi,Math.max(0,Math.floor((Ye-Yt-2)*dt/(Xt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(it*Mt);const Nt=He/it;He=Math.floor(He*At);const Vt=Ut?1:2,ni=si==="left"?0:We-Mt-Yt;return{renderMinimap:Vt,minimapLeft:ni,minimapWidth:Mt,minimapHeightIsEditorHeight:Gt,minimapIsSampling:ii,minimapScale:Dt,minimapLineHeight:Pt,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:mt}}static computeLayout(_,pe){const We=pe.outerWidth|0,Qe=pe.outerHeight|0,it=pe.lineHeight|0,rt=pe.lineNumbersDigitCount|0,Te=pe.typicalHalfwidthCharacterWidth,Tt=pe.maxDigitWidth,Xt=pe.pixelRatio,xt=pe.viewLineCount,Ut=_.get(135),Dt=Ut==="inherit"?_.get(134):Ut,ei=Dt==="inherit"?_.get(130):Dt,jt=_.get(133),si=pe.isDominatedByLongLines,Yt=_.get(57),_t=_.get(67).renderType!==0,Ye=_.get(68),Bt=_.get(104),ti=_.get(83),ht=_.get(72),mt=_.get(102),Gt=mt.verticalScrollbarSize,ii=mt.verticalHasArrows,Pt=mt.arrowSize,dt=mt.horizontalScrollbarSize,At=_.get(43),oi=_.get(109)!=="never";let Mt=_.get(65);At&&oi&&(Mt+=16);let He=0;if(_t){const It=Math.max(rt,Ye);He=Math.round(It*Tt)}let Nt=0;Yt&&(Nt=it*pe.glyphMarginDecorationLaneCount);let Vt=0,ni=Vt+Nt,ft=ni+He,Ft=ft+Mt;const Ct=We-Nt-He-Mt;let zt=!1,Wt=!1,qt=-1;Dt==="inherit"&&si?(zt=!0,Wt=!0):ei==="on"||ei==="bounded"?Wt=!0:ei==="wordWrapColumn"&&(qt=jt);const St=he.c({outerWidth:We,outerHeight:Qe,lineHeight:it,typicalHalfwidthCharacterWidth:Te,pixelRatio:Xt,scrollBeyondLastLine:Bt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:ht,verticalScrollbarWidth:Gt,viewLineCount:xt,remainingWidth:Ct,isViewportWrapping:Wt},pe.memory||new A);St.renderMinimap!==0&&St.minimapLeft===0&&(Vt+=St.minimapWidth,ni+=St.minimapWidth,ft+=St.minimapWidth,Ft+=St.minimapWidth);const Jt=Ct-St.minimapWidth,Et=Math.max(1,Math.floor((Jt-Gt-2)/Te)),bt=ii?Pt:0;return Wt&&(qt=Math.max(1,Et),ei==="bounded"&&(qt=Math.min(qt,jt))),{width:We,height:Qe,glyphMarginLeft:Vt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:ni,lineNumbersWidth:He,decorationsLeft:ft,decorationsWidth:Mt,contentLeft:Ft,contentWidth:Jt,minimap:St,viewportColumn:Et,isWordWrapMinified:zt,isViewportWrapping:Wt,wrappingColumn:qt,verticalScrollbarWidth:Gt,horizontalScrollbarHeight:dt,overviewRuler:{top:bt,width:Gt,height:Qe-2*bt,right:0}}}}e.EditorLayoutInfoComputer=he;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(_){return m(_,"simple",["simple","advanced"])}compute(_,pe,We){return pe.get(2)===2?"advanced":We}}var se;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends k{constructor(){const _={enabled:se.OnCode};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:_.enabled,enumDescriptions:[g.localize(50,null),g.localize(51,null),g.localize(52,null)],description:g.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:m(_.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class te extends k{constructor(){const _={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:g.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:g.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:g.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:g.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:m(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:u(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:g.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(59,null),g.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),g.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:g.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:g.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:g.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:m(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:u(pe.padding,this.defaultValue.padding)}}}class q extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):n.clampedInt(_,this.defaultValue,0,1e3)}compute(_,pe,We){return We<0?n.clampedInt(-We*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class ne extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>l.clamp(_,0,150),{markdownDescription:g.localize(66,null)})}compute(_,pe,We){return _.fontInfo.lineHeight}}class Pe extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:g.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:g.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(69,null),g.localize(70,null),g.localize(71,null)],default:_.size,description:g.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:g.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:g.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:g.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:g.localize(77,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),autohide:u(pe.autohide,this.defaultValue.autohide),size:m(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(pe.side,this.defaultValue.side,["right","left"]),showSlider:m(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(pe.scale,1,1,3),maxColumn:n.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Oe(X){return X==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Re extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(79,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:n.clampedInt(pe.top,0,0,1e3),bottom:n.clampedInt(pe.bottom,0,0,1e3)}}}class be extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:g.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:g.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),cycle:u(pe.cycle,this.defaultValue.cycle)}}}class me extends p{constructor(){super(141)}compute(_,pe,We){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(82,null),g.localize(83,null),g.localize(84,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:g.localize(85,null)},comments:{anyOf:pe,default:_.comments,description:g.localize(86,null)},other:{anyOf:pe,default:_.other,description:g.localize(87,null)}},default:_,markdownDescription:g.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Xt=_?"on":"off";return{comments:Xt,strings:Xt,other:Xt}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:We,strings:Qe}=_,it=["on","inline","off"];let rt,Te,Tt;return typeof pe=="boolean"?rt=pe?"on":"off":rt=m(pe,this.defaultValue.other,it),typeof We=="boolean"?Te=We?"on":"off":Te=m(We,this.defaultValue.comments,it),typeof Qe=="boolean"?Tt=Qe?"on":"off":Tt=m(Qe,this.defaultValue.strings,it),{other:rt,comments:Te,strings:Tt}}}var x;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class le extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(89,null),g.localize(90,null),g.localize(91,null),g.localize(92,null)],default:"on",description:g.localize(93,null)})}validate(_){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,We=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function de(X){const _=X.get(97);return _==="editable"?X.get(90):_!=="on"}e.filterValidationDecorations=de;class Me extends k{constructor(){const _=[],pe={type:"number",description:g.localize(94,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:g.localize(95,null),format:"color-hex"}}}]},default:_,description:g.localize(96,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const We of _)if(typeof We=="number")pe.push({column:n.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Qe=We;pe.push({column:n.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((We,Qe)=>We.column-Qe.column),pe}return this.defaultValue}}class ge extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function Se(X,_){if(typeof X!="string")return _;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ce extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(97,null),g.localize(98,null),g.localize(99,null)],default:"auto",description:g.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(101,null),g.localize(102,null),g.localize(103,null)],default:"auto",description:g.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:g.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:g.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:g.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:g.localize(108,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,We=n.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=n.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(pe.vertical,this.defaultValue.vertical),horizontal:Se(pe.horizontal,this.defaultValue.horizontal),useShadows:u(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:n.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:n.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:u(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:u(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class N extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:g.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:g.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:g.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:g.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:g.localize(115,null)}})}applyUpdate(_,pe){let We=!1;pe.allowedCharacters&&_&&(F.$Jn(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&_&&(F.$Jn(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},We=!0));const Qe=super.applyUpdate(_,pe);return We?new h(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:Z(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const We={};for(const[Qe,it]of Object.entries(_))it===!0&&(We[Qe]=!0);return We}}class K extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:g.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[g.localize(117,null),g.localize(118,null),g.localize(119,null)],description:g.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:g.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:g.localize(122,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),mode:m(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:m(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:u(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:u(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends k{constructor(){const _={enabled:L.$Bs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Bs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:g.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:g.localize(124,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(125,null),g.localize(126,null),g.localize(127,null)],default:_.bracketPairs,description:g.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null)],default:_.bracketPairsHorizontal,description:g.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:g.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:g.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null)],default:_.highlightActiveIndentation,description:g.localize(138,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(X,_,pe){const We=pe.indexOf(X);return We===-1?_:pe[We]}class oe extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(139,null),g.localize(140,null)],default:_.insertMode,description:g.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:g.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:g.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:g.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(145,null),g.localize(146,null),g.localize(147,null),g.localize(148,null)],default:_.selectionMode,markdownDescription:g.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:g.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:g.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:g.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:g.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:g.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(186,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:m(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:m(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(pe.showIcons,this.defaultValue.showIcons),showStatusBar:u(pe.showStatusBar,this.defaultValue.showStatusBar),preview:u(pe.preview,this.defaultValue.preview),previewMode:m(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(pe.showMethods,this.defaultValue.showMethods),showFunctions:u(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:u(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(pe.showFields,this.defaultValue.showFields),showVariables:u(pe.showVariables,this.defaultValue.showVariables),showClasses:u(pe.showClasses,this.defaultValue.showClasses),showStructs:u(pe.showStructs,this.defaultValue.showStructs),showInterfaces:u(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:u(pe.showModules,this.defaultValue.showModules),showProperties:u(pe.showProperties,this.defaultValue.showProperties),showEvents:u(pe.showEvents,this.defaultValue.showEvents),showOperators:u(pe.showOperators,this.defaultValue.showOperators),showUnits:u(pe.showUnits,this.defaultValue.showUnits),showValues:u(pe.showValues,this.defaultValue.showValues),showConstants:u(pe.showConstants,this.defaultValue.showConstants),showEnums:u(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:u(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(pe.showKeywords,this.defaultValue.showKeywords),showWords:u(pe.showWords,this.defaultValue.showWords),showColors:u(pe.showColors,this.defaultValue.showColors),showFiles:u(pe.showFiles,this.defaultValue.showFiles),showReferences:u(pe.showReferences,this.defaultValue.showReferences),showFolders:u(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:u(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(pe.showSnippets,this.defaultValue.showSnippets),showUsers:u(pe.showUsers,this.defaultValue.showUsers),showIssues:u(pe.showIssues,this.defaultValue.showIssues)}}}class Ee extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(188,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:u(_.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Ve extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(189,null),g.localize(190,null),g.localize(191,null),g.localize(192,null)],description:g.localize(193,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,We){return pe.get(2)===2?0:We}}class Ze extends p{constructor(){super(144)}compute(_,pe,We){const Qe=pe.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class xe extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:g.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(196,null),g.localize(197,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),showDropSelector:m(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:g.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(200,null),g.localize(201,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:u(pe.enabled,this.defaultValue.enabled),showPasteSelector:m(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ut="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?et:P.$k?ut:nt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(X){return e.editorOptionsRegistry[X.id]=X,X}var pt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(pt||(e.EditorOption=pt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(202,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(203,null),""],markdownDescription:g.localize(204,null)})),accessibilitySupport:je(new y),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(205,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",g.localize(206,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(208,null),g.localize(209,null),""],description:g.localize(210,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(211,null),g.localize(212,null),""],description:g.localize(213,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(214,null),""],description:g.localize(215,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(216,null),""],description:g.localize(217,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(218,null),g.localize(219,null),""],description:g.localize(220,null)})),autoIndent:je(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[g.localize(221,null),g.localize(222,null),g.localize(223,null),g.localize(224,null),g.localize(225,null)],description:g.localize(226,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(227,null),g.localize(228,null),g.localize(229,null),""],description:g.localize(230,null)})),bracketPairColorization:je(new j),bracketPairGuides:je(new H),stickyTabStops:je(new r(115,"stickyTabStops",!1,{description:g.localize(231,null)})),codeLens:je(new r(17,"codeLens",!0,{description:g.localize(232,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:g.localize(233,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(234,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:g.localize(235,null)})),colorDecoratorActivatedOn:je(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(236,null),g.localize(237,null),g.localize(238,null)],description:g.localize(239,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(240,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:g.localize(241,null)})),comments:je(new $),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(242,null)})),cursorBlinking:je(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],d,{description:g.localize(243,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(244,null),g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),cursorStyle:je(new c(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:g.localize(248,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(249,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(250,null),g.localize(251,null)],markdownDescription:g.localize(252,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(253,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:g.localize(254,null)})),emptySelectionClipboard:je(new G),dropIntoEditor:je(new xe),stickyScroll:je(new te),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(255,null),g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:g.localize(259,null)})),find:je(new W),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:g.localize(260,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(261,null),g.localize(262,null)],description:g.localize(263,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:g.localize(264,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:g.localize(265,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(266,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(267,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(268,null)})),fontInfo:je(new O),fontLigatures2:je(new U),fontSize:je(new V),fontWeight:je(new re),fontVariations:je(new C),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:g.localize(269,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:g.localize(270,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:g.localize(271,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:g.localize(272,null)})),hover:je(new ye),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:g.localize(273,null)})),lightbulb:je(new $e),lineDecorationsWidth:je(new q),lineHeight:je(new ne),lineNumbers:je(new le),lineNumbersMinChars:je(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(69,"linkedEditing",!1,{description:g.localize(274,null)})),links:je(new r(70,"links",!0,{description:g.localize(275,null)})),matchBrackets:je(new a(71,"matchBrackets","always",["always","near","never"],{description:g.localize(276,null)})),minimap:je(new Pe),mouseStyle:je(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new l(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:g.localize(277,null)})),mouseWheelZoom:je(new r(75,"mouseWheelZoom",!1,{markdownDescription:P.$j?g.localize(278,null):g.localize(279,null)})),multiCursorMergeOverlapping:je(new r(76,"multiCursorMergeOverlapping",!0,{description:g.localize(280,null)})),multiCursorModifier:je(new c(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Oe,{markdownEnumDescriptions:[g.localize(281,null),g.localize(282,null)],markdownDescription:g.localize(283,null)})),multiCursorPaste:je(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(284,null),g.localize(285,null)],markdownDescription:g.localize(286,null)})),multiCursorLimit:je(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(287,null)})),occurrencesHighlight:je(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[g.localize(288,null),g.localize(289,null),g.localize(290,null)],markdownDescription:g.localize(291,null)})),overviewRulerBorder:je(new r(81,"overviewRulerBorder",!0,{description:g.localize(292,null)})),overviewRulerLanes:je(new n(82,"overviewRulerLanes",3,0,3)),padding:je(new Re),pasteAs:je(new at),parameterHints:je(new be),peekWidgetDefaultFocus:je(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(293,null),g.localize(294,null)],description:g.localize(295,null)})),definitionLinkOpensInPeek:je(new r(87,"definitionLinkOpensInPeek",!1,{description:g.localize(296,null)})),quickSuggestions:je(new Q),quickSuggestionsDelay:je(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(297,null)})),readOnly:je(new r(90,"readOnly",!1)),readOnlyMessage:je(new ge),renameOnType:je(new r(92,"renameOnType",!1,{description:g.localize(298,null),markdownDeprecationMessage:g.localize(299,null)})),renderControlCharacters:je(new r(93,"renderControlCharacters",!0,{description:g.localize(300,null),restricted:!0})),renderFinalNewline:je(new a(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:g.localize(301,null)})),renderLineHighlight:je(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(302,null)],description:g.localize(303,null)})),renderLineHighlightOnlyWhenFocus:je(new r(96,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(304,null)})),renderValidationDecorations:je(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(305,null),g.localize(306,null),g.localize(307,null),""],description:g.localize(308,null)})),revealHorizontalRightPadding:je(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(100,"roundedSelection",!0,{description:g.localize(309,null)})),rulers:je(new Me),scrollbar:je(new Ce),scrollBeyondLastColumn:je(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(310,null)})),scrollBeyondLastLine:je(new r(104,"scrollBeyondLastLine",!0,{description:g.localize(311,null)})),scrollPredominantAxis:je(new r(105,"scrollPredominantAxis",!0,{description:g.localize(312,null)})),selectionClipboard:je(new r(106,"selectionClipboard",!0,{description:g.localize(313,null),included:P.$k})),selectionHighlight:je(new r(107,"selectionHighlight",!0,{description:g.localize(314,null)})),selectOnLineNumbers:je(new r(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(315,null),g.localize(316,null),g.localize(317,null)],description:g.localize(318,null)})),showUnused:je(new r(110,"showUnused",!0,{description:g.localize(319,null)})),showDeprecated:je(new r(138,"showDeprecated",!0,{description:g.localize(320,null)})),inlayHints:je(new Y),snippetSuggestions:je(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(321,null),g.localize(322,null),g.localize(323,null),g.localize(324,null)],description:g.localize(325,null)})),smartSelect:je(new Ee),smoothScrolling:je(new r(113,"smoothScrolling",!1,{description:g.localize(326,null)})),stopRenderingLineAfter:je(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new oe),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new r(147,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(327,null)})),suggestFontSize:je(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(120,"suggestOnTriggerCharacters",!0,{description:g.localize(330,null)})),suggestSelection:je(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),tabCompletion:je(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(335,null),g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),tabIndex:je(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new N),unusualLineTerminators:je(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(339,null),g.localize(340,null),g.localize(341,null)],description:g.localize(342,null)})),useShadowDOM:je(new r(126,"useShadowDOM",!0)),useTabStops:je(new r(127,"useTabStops",!0,{description:g.localize(343,null)})),wordBreak:je(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(344,null),g.localize(345,null)],description:g.localize(346,null)})),wordSeparators:je(new t(129,"wordSeparators",R.$Cs,{description:g.localize(347,null)})),wordWrap:je(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(348,null),g.localize(349,null),g.localize(350,null),g.localize(351,null)],description:g.localize(352,null)})),wordWrapBreakAfterCharacters:je(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(353,null)})),wordWrapOverride1:je(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new T),defaultColorDecorators:je(new r(145,"defaultColorDecorators",!1,{markdownDescription:g.localize(354,null)})),pixelRatio:je(new me),tabFocusMode:je(new r(142,"tabFocusMode",!1,{markdownDescription:g.localize(355,null)})),layoutInfo:je(new he),wrappingInfo:je(new Ze),wrappingIndent:je(new Ve),wrappingStrategy:je(new ve)}}),define(Fe[149],Le([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Fe[150],Le([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Fe[151],Le([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Fe[152],Le([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Fe[153],Le([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Fe[154],Le([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Fe[155],Le([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Fe[156],Le([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Fe[157],Le([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Fe[158],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Fe[159],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatProvider",e)}),define(Fe[160],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Fe[161],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Fe[162],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Fe[163],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Fe[164],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Fe[165],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Fe[166],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Fe[167],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Fe[168],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Fe[169],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Fe[170],Le([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Fe[171],Le([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Fe[172],Le([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Fe[173],Le([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Fe[174],Le([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Fe[175],Le([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Fe[176],Le([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Fe[177],Le([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Fe[178],Le([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Fe[179],Le([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Fe[180],Le([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Fe[181],Le([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Fe[182],Le([1,0,15,151]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.TokenType=void 0;var P;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(P||(e.TokenType=P={}));function L(...D){switch(D.length){case 1:return(0,F.localize)(0,null,D[0]);case 2:return(0,F.localize)(1,null,D[0],D[1]);case 3:return(0,F.localize)(2,null,D[0],D[1],D[2]);default:return}}const R=(0,F.localize)(3,null),g=(0,F.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,h=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:h};this.g.push({offset:k,lexeme:h,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),h=f.b.get(k);h?this.k(h):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,h=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(g);return}const p=this.c.charCodeAt(A);if(k)k=!1;else if(p===47&&!h){A++;break}else p===91?h=!0:p===92?k=!0:p===93&&(h=!1);A++}for(;A<this.c.length&&f.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$0i=f}),define(Fe[183],Le([1,0,25,32,153,297]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||R.test(r)}e.$jp=f;function D(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=r.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$kp=D;function A(r){if(!r)return null;const i=r.majorBase,n=r.majorMustEqual,o=r.minorBase;let l=r.minorMustEqual;const t=r.patchBase;let m=r.patchMustEqual;r.hasCaret&&(i===0||(l=!1),m=!1);let a=0;if(r.preRelease){const c=g.exec(r.preRelease);if(c){const[,E,y,$]=c;a=Date.UTC(Number(E),Number(y)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:l,patchBase:t,patchMustEqual:m,isMinimum:r.hasGreaterEquals,notBefore:a}}e.$lp=A;function k(r,i,n){let o;typeof r=="string"?o=A(D(r)):o=r;let l;i instanceof Date?l=i.getTime():typeof i=="string"&&(l=new Date(i).getTime());let t;if(typeof n=="string"?t=A(D(n)):t=n,!o||!t)return!1;const m=o.majorBase,a=o.minorBase,c=o.patchBase;let E=t.majorBase,y=t.minorBase,$=t.patchBase;const I=t.notBefore;let d=t.majorMustEqual,w=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?m>E?!0:m<E?!1:a>y?!0:a<y||l&&l<I?!1:c>=$:(m===1&&E===0&&(!d||!w||!b)&&(E=1,y=0,$=0,d=!0,w=!1,b=!1),m<E?!1:m>E?!d:a<y?!1:a>y?!w:c<$?!1:c>$?!b:!(l&&l<I))}e.$mp=k;function h(r,i,n,o,l){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([F.default.Error,P.localize(0,null)]),t;if(typeof o.name!="string")return t.push([F.default.Error,P.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([F.default.Error,P.localize(2,null,"version")]),t;if(!o.engines)return t.push([F.default.Error,P.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([F.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!u(o.extensionDependencies))return t.push([F.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!u(o.activationEvents))return t.push([F.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([F.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([F.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([F.default.Error,P.localize(9,null,"main")]),t;{const c=(0,S.$Pg)(n,o.main);(0,S.$Jg)(c,n)||t.push([F.default.Warning,P.localize(10,null,c.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([F.default.Error,P.localize(11,null,"browser")]),t;{const c=(0,S.$Pg)(n,o.browser);(0,S.$Jg)(c,n)||t.push([F.default.Warning,P.localize(12,null,c.path,n.path)])}}if(!L.valid(o.version))return t.push([F.default.Error,P.localize(13,null)]),t;const m=[];if(!v(r,i,o,l,m))for(const c of m)t.push([F.default.Error,c]);return t}e.$np=h;function v(r,i,n,o,l){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,i,n.engines.vscode,l)}e.$op=v;function p(r,i,n){return r==="*"||s(i,n,r)}e.$pp=p;function s(r,i,n,o=[]){const l=A(D(n));if(!l)return o.push(P.localize(14,null,n)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(P.localize(15,null,n)),!1}else if(!l.majorMustEqual)return o.push(P.localize(16,null,n)),!1;return k(r,i,l)?!0:(o.push(P.localize(17,null,r,n)),!1)}function u(r){if(!Array.isArray(r))return!1;for(let i=0,n=r.length;i<n;i++)if(typeof r[i]!="string")return!1;return!0}}),define(Fe[70],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=void 0;class S{constructor(P,L=[],R=!1){this.ctor=P,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$_h=S}),define(Fe[53],Le([1,0,70]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.InstantiationType=void 0;const F=[];var P;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function L(g,f,D){f instanceof S.$_h||(f=new S.$_h(f,[],!!D)),F.push([g,f])}e.$8r=L;function R(){return F}e.$9r=R}),define(Fe[184],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class S{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Lq=S;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const g=this.lookupOrInsertNode(L),f=this.lookupOrInsertNode(R);g.outgoing.set(f.key,f),f.incoming.set(g.key,g)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const g of this.a.values())g.outgoing.delete(R),g.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let g=this.a.get(R);return g||(g=new S(R,L),this.a.set(R,g)),g}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,g]of this.a)L.push(`${R}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const g=new Set([L]),f=this.c(R,g);if(f)return f}}c(L,R){for(const[g,f]of L.outgoing){if(R.has(g))return[...R,g].join(" -> ");R.add(g);const D=this.c(f,R);if(D)return D;R.delete(g)}}}e.$Mq=F}),define(Fe[4],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=e.$bi=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function g(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=g})(S||(e._util=S={})),e.$bi=P("instantiationService");function F(R,g,f){g[S.DI_TARGET]===g?g[S.DI_DEPENDENCIES].push({id:R,index:f}):(g[S.DI_DEPENDENCIES]=[{id:R,index:f}],g[S.DI_TARGET]=g)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const g=function(f,D,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(g,f,A)};return g.toString=()=>R,S.serviceIds.set(R,g),g}e.$ci=P;function L(R){return R}e.$di=L}),define(Fe[47],Le([1,0,16,2,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.ConfigurationTarget=e.$Ki=e.$Ji=e.$Ii=void 0,e.$Ii=(0,P.$ci)("configurationService");function L(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof F.URI)}e.$Ji=L;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof F.URI)}e.$Ki=R;var g;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Li=f;function D(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Mi=D;function A(r,i){const n=Object.create(null);for(const o in r)k(n,o,r[o],i);return n}e.$Ni=A;function k(r,i,n,o){const l=i.split("."),t=l.pop();let m=r;for(let a=0;a<l.length;a++){const c=l[a];let E=m[c];switch(typeof E){case"undefined":E=m[c]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(E)}`);return}m=E}if(typeof m=="object"&&m!==null)try{m[t]=n}catch{o(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(m)}`)}else o(`Ignoring ${i} as ${l.join(".")} is ${JSON.stringify(m)}`)}e.$Oi=k;function h(r,i){const n=i.split(".");v(r,n)}e.$Pi=h;function v(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const o=r[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete r[n])}}function p(r,i,n){function o(m,a){let c=m;for(const E of a){if(typeof c!="object"||c===null)return;c=c[E]}return c}const l=i.split("."),t=o(r,l);return typeof t>"u"?n:t}e.$Qi=p;function s(r,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in r?S.$Sf(r[o])&&S.$Sf(i[o])?s(r[o],i[o],n):n&&(r[o]=i[o]):r[o]=i[o])})}e.$Ri=s;function u(r){return r.replace(/[\[\]]/g,"")}e.$Si=u}),define(Fe[35],Le([1,0,20,13,182,4,150,15]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.ContextKeyExprType=e.$$i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function D(Y,q){if(f.get(Y)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(Y,q)}e.$$i=D;const A=Object.prototype.hasOwnProperty;var k;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const h={regexParsingWithErrorRecovery:!0},v=(0,R.localize)(0,null),p=(0,R.localize)(1,null),s=(0,R.localize)(2,null),u=(0,R.localize)(3,null),r=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(q=h){this.k=q,this.d=new P.$0i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(q){if(q===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(q).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Pe=this.D(),Oe=Pe.type===17?i:void 0;throw this.h.push({message:r,offset:Pe.offset,lexeme:P.$0i.getLexeme(Pe),additionalInfo:Oe}),l.c}return ne}catch(ne){if(ne!==l.c)throw ne;return}}l(){return this.m()}m(){const q=[this.o()];for(;this.y(16);){const ne=this.o();q.push(ne)}return q.length===1?q[0]:t.or(...q)}o(){const q=[this.s()];for(;this.y(15);){const ne=this.s();q.push(ne)}return q.length===1?q[0]:t.and(...q)}s(){if(this.y(2)){const q=this.D();switch(q.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),y.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,u),ne?.negate()}case 17:return this.z(),M.create(q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",q)}}return this.t()}t(){const q=this.D();switch(q.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,u),ne}case 17:{const ne=q.lexeme;if(this.z(),this.y(9)){const Oe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Oe.type!==10)throw this.B("REGEX",Oe);const Re=Oe.lexeme,be=Re.lastIndexOf("/"),me=be===Re.length-1?void 0:this.w(Re.substring(be+1));let Q;try{Q=new RegExp(Re.substring(1,be),me)}catch{throw this.B("REGEX",Oe)}return O.create(ne,Q)}switch(Oe.type){case 10:case 19:{const Re=[Oe.lexeme];this.z();let be=this.D(),me=0;for(let Me=0;Me<Oe.lexeme.length;Me++)Oe.lexeme.charCodeAt(Me)===40?me++:Oe.lexeme.charCodeAt(Me)===41&&me--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Me=0;Me<be.lexeme.length;Me++)be.lexeme.charCodeAt(Me)===40?me++:Oe.lexeme.charCodeAt(Me)===41&&me--}if(me<0)break;Re.push(P.$0i.getLexeme(be)),this.z(),be=this.D()}const Q=Re.join(""),x=Q.lastIndexOf("/"),le=x===Q.length-1?void 0:this.w(Q.substring(x+1));let de;try{de=new RegExp(Q.substring(1,x),le)}catch{throw this.B("REGEX",Oe)}return t.regex(ne,de)}case 18:{const Re=Oe.lexeme;this.z();let be=null;if(!(0,F.$Qe)(Re)){const me=Re.indexOf("/"),Q=Re.lastIndexOf("/");if(me!==Q&&me>=0){const x=Re.slice(me+1,Q),le=Re[Q+1]==="i"?"i":"";try{be=new RegExp(x,le)}catch{throw this.B("REGEX",Oe)}}}if(be===null)throw this.B("REGEX",Oe);return O.create(ne,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Oe=this.u();return t.notIn(ne,Oe)}switch(this.D().type){case 3:{this.z();const Oe=this.u();if(this.x().type===18)return t.equals(ne,Oe);switch(Oe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,Oe)}}case 4:{this.z();const Oe=this.u();if(this.x().type===18)return t.notEquals(ne,Oe);switch(Oe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,Oe)}}case 5:return this.z(),U.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),G.create(ne,this.u());case 8:return this.z(),W.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:q.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const q=this.D();switch(q.type){case 17:case 18:return this.z(),q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(q){return q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(q){return this.C(q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(q,ne){if(this.C(q))return this.z();throw this.B(ne,this.D())}B(q,ne,Pe){const Oe=(0,R.localize)(8,null,q,P.$0i.getLexeme(ne)),Re=ne.offset,be=P.$0i.getLexeme(ne);return this.h.push({message:Oe,offset:Re,lexeme:be,additionalInfo:Pe}),l.c}C(q){return this.D().type===q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$_i=l;class t{static false(){return E.INSTANCE}static true(){return y.INSTANCE}static has(q){return $.create(q)}static equals(q,ne){return I.create(q,ne)}static notEquals(q,ne){return b.create(q,ne)}static regex(q,ne){return O.create(q,ne)}static in(q,ne){return d.create(q,ne)}static notIn(q,ne){return w.create(q,ne)}static not(q){return M.create(q)}static and(...q){return ce.create(q,null,!0)}static or(...q){return ye.create(q,null,!0)}static greater(q,ne){return G.create(q,ne)}static greaterEquals(q,ne){return W.create(q,ne)}static smaller(q,ne){return U.create(q,ne)}static smallerEquals(q,ne){return C.create(q,ne)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(q){return q==null?void 0:this.c.parse(q)}}e.$aj=t;function m(Y){const q=new l({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(q.parse(ne),q.lexingErrors.length>0?q.lexingErrors.map(Pe=>({errorMessage:Pe.additionalInfo?(0,R.localize)(9,null,Pe.additionalInfo):(0,R.localize)(10,null),offset:Pe.offset,length:Pe.lexeme.length})):q.parsingErrors.length>0?q.parsingErrors.map(Pe=>({errorMessage:Pe.additionalInfo?`${Pe.message}. ${Pe.additionalInfo}`:Pe.message,offset:Pe.offset,length:Pe.lexeme.length})):[]))}e.$bj=m;function a(Y,q){const ne=Y?Y.substituteConstants():void 0,Pe=q?q.substituteConstants():void 0;return!ne&&!Pe?!0:!ne||!Pe?!1:ne.equals(Pe)}e.$cj=a;function c(Y,q){return Y.cmp(q)}class E{static{this.INSTANCE=new E}constructor(){this.type=0}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!1}serialize(){return"false"}keys(){return[]}map(q){return this}negate(){return y.INSTANCE}}e.$dj=E;class y{static{this.INSTANCE=new y}constructor(){this.type=1}cmp(q){return this.type-q.type}equals(q){return q.type===this.type}substituteConstants(){return this}evaluate(q){return!0}serialize(){return"true"}keys(){return[]}map(q){return this}negate(){return E.INSTANCE}}e.$ej=y;class ${static create(q,ne=null){const Pe=f.get(q);return typeof Pe=="boolean"?Pe?y.INSTANCE:E.INSTANCE:new $(q,ne)}constructor(q,ne){this.key=q,this.c=ne,this.type=2}cmp(q){return q.type!==this.type?this.type-q.type:he(this.key,q.key)}equals(q){return q.type===this.type?this.key===q.key:!1}substituteConstants(){const q=f.get(this.key);return typeof q=="boolean"?q?y.INSTANCE:E.INSTANCE:this}evaluate(q){return!!q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(q){return q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$fj=$;class I{static create(q,ne,Pe=null){if(typeof ne=="boolean")return ne?$.create(q,Pe):M.create(q,Pe);const Oe=f.get(q);return typeof Oe=="boolean"?ne===(Oe?"true":"false")?y.INSTANCE:E.INSTANCE:new I(q,ne,Pe)}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=4}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?y.INSTANCE:E.INSTANCE}return this}evaluate(q){return q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(q){return q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$gj=I;class d{static create(q,ne){return new d(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=10,this.c=null}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.d,this.f,q.d,q.f)}equals(q){return q.type===this.type?this.d===q.d&&this.f===q.f:!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.f),Pe=q.getValue(this.d);return Array.isArray(ne)?ne.includes(Pe):typeof Pe=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(q){return q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$hj=d;class w{static create(q,ne){return new w(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=11,this.c=d.create(q,ne)}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(q){return q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$ij=w;class b{static create(q,ne,Pe=null){if(typeof ne=="boolean")return ne?M.create(q,Pe):$.create(q,Pe);const Oe=f.get(q);return typeof Oe=="boolean"?ne===(Oe?"true":"false")?E.INSTANCE:y.INSTANCE:new b(q,ne,Pe)}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=5}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){const q=f.get(this.c);if(typeof q=="boolean"){const ne=q?"true":"false";return this.d===ne?E.INSTANCE:y.INSTANCE}return this}evaluate(q){return q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(q){return q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$jj=b;class M{static create(q,ne=null){const Pe=f.get(q);return typeof Pe=="boolean"?Pe?E.INSTANCE:y.INSTANCE:new M(q,ne)}constructor(q,ne){this.c=q,this.d=ne,this.type=3}cmp(q){return q.type!==this.type?this.type-q.type:he(this.c,q.c)}equals(q){return q.type===this.type?this.c===q.c:!1}substituteConstants(){const q=f.get(this.c);return typeof q=="boolean"?q?E.INSTANCE:y.INSTANCE:this}evaluate(q){return!q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(q){return q.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$kj=M;function T(Y,q){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?q(Y):E.INSTANCE}class G{static create(q,ne,Pe=null){return T(ne,Oe=>new G(q,Oe,Pe))}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=12}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$lj=G;class W{static create(q,ne,Pe=null){return T(ne,Oe=>new W(q,Oe,Pe))}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=13}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(q){return q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$mj=W;class U{static create(q,ne,Pe=null){return T(ne,Oe=>new U(q,Oe,Pe))}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=14}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$nj=U;class C{static create(q,ne,Pe=null){return T(ne,Oe=>new C(q,Oe,Pe))}constructor(q,ne,Pe){this.c=q,this.d=ne,this.f=Pe,this.type=15}cmp(q){return q.type!==this.type?this.type-q.type:ve(this.c,this.d,q.c,q.d)}equals(q){return q.type===this.type?this.c===q.c&&this.d===q.d:!1}substituteConstants(){return this}evaluate(q){return typeof this.d=="string"?!1:parseFloat(q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(q){return q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$oj=C;class O{static create(q,ne){return new O(q,ne)}constructor(q,ne){this.d=q,this.f=ne,this.type=7,this.c=null}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.d<q.d)return-1;if(this.d>q.d)return 1;const ne=this.f?this.f.source:"",Pe=q.f?q.f.source:"";return ne<Pe?-1:ne>Pe?1:0}equals(q){if(q.type===this.type){const ne=this.f?this.f.source:"",Pe=q.f?q.f.source:"";return this.d===q.d&&ne===Pe}return!1}substituteConstants(){return this}evaluate(q){const ne=q.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${q}`}keys(){return[this.d]}map(q){return q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=V.create(this)),this.c}}e.$pj=O;class V{static create(q){return new V(q)}constructor(q){this.c=q,this.type=8}cmp(q){return q.type!==this.type?this.type-q.type:this.c.cmp(q.c)}equals(q){return q.type===this.type?this.c.equals(q.c):!1}substituteConstants(){return this}evaluate(q){return!this.c.evaluate(q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(q){return new V(this.c.map(q))}negate(){return this.c}}e.$qj=V;function re(Y){let q=null;for(let ne=0,Pe=Y.length;ne<Pe;ne++){const Oe=Y[ne].substituteConstants();if(Y[ne]!==Oe&&q===null){q=[];for(let Re=0;Re<ne;Re++)q[Re]=Y[Re]}q!==null&&(q[ne]=Oe)}return q===null?Y:q}class ce{static create(q,ne,Pe){return ce.d(q,ne,Pe)}constructor(q,ne){this.expr=q,this.c=ne,this.type=6}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Pe=this.expr.length;ne<Pe;ne++){const Oe=c(this.expr[ne],q.expr[ne]);if(Oe!==0)return Oe}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Pe=this.expr.length;ne<Pe;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ce.create(q,this.c,!1)}evaluate(q){for(let ne=0,Pe=this.expr.length;ne<Pe;ne++)if(!this.expr[ne].evaluate(q))return!1;return!0}static d(q,ne,Pe){const Oe=[];let Re=!1;for(const be of q)if(be){if(be.type===1){Re=!0;continue}if(be.type===0)return E.INSTANCE;if(be.type===6){Oe.push(...be.expr);continue}Oe.push(be)}if(Oe.length===0&&Re)return y.INSTANCE;if(Oe.length!==0){if(Oe.length===1)return Oe[0];Oe.sort(c);for(let be=1;be<Oe.length;be++)Oe[be-1].equals(Oe[be])&&(Oe.splice(be,1),be--);if(Oe.length===1)return Oe[0];for(;Oe.length>1;){const be=Oe[Oe.length-1];if(be.type!==9)break;Oe.pop();const me=Oe.pop(),Q=Oe.length===0,x=ye.create(be.expr.map(le=>ce.create([le,me],null,Pe)),null,Q);x&&(Oe.push(x),Oe.sort(c))}if(Oe.length===1)return Oe[0];if(Pe){for(let be=0;be<Oe.length;be++)for(let me=be+1;me<Oe.length;me++)if(Oe[be].negate().equals(Oe[me]))return E.INSTANCE;if(Oe.length===1)return Oe[0]}return new ce(Oe,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" && ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ce(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());this.c=ye.create(q,this,!0)}return this.c}}e.$rj=ce;class ye{static create(q,ne,Pe){return ye.d(q,ne,Pe)}constructor(q,ne){this.expr=q,this.c=ne,this.type=9}cmp(q){if(q.type!==this.type)return this.type-q.type;if(this.expr.length<q.expr.length)return-1;if(this.expr.length>q.expr.length)return 1;for(let ne=0,Pe=this.expr.length;ne<Pe;ne++){const Oe=c(this.expr[ne],q.expr[ne]);if(Oe!==0)return Oe}return 0}equals(q){if(q.type===this.type){if(this.expr.length!==q.expr.length)return!1;for(let ne=0,Pe=this.expr.length;ne<Pe;ne++)if(!this.expr[ne].equals(q.expr[ne]))return!1;return!0}return!1}substituteConstants(){const q=re(this.expr);return q===this.expr?this:ye.create(q,this.c,!1)}evaluate(q){for(let ne=0,Pe=this.expr.length;ne<Pe;ne++)if(this.expr[ne].evaluate(q))return!0;return!1}static d(q,ne,Pe){let Oe=[],Re=!1;if(q){for(let be=0,me=q.length;be<me;be++){const Q=q[be];if(Q){if(Q.type===0){Re=!0;continue}if(Q.type===1)return y.INSTANCE;if(Q.type===9){Oe=Oe.concat(Q.expr);continue}Oe.push(Q)}}if(Oe.length===0&&Re)return E.INSTANCE;Oe.sort(c)}if(Oe.length!==0){if(Oe.length===1)return Oe[0];for(let be=1;be<Oe.length;be++)Oe[be-1].equals(Oe[be])&&(Oe.splice(be,1),be--);if(Oe.length===1)return Oe[0];if(Pe){for(let be=0;be<Oe.length;be++)for(let me=be+1;me<Oe.length;me++)if(Oe[be].negate().equals(Oe[me]))return y.INSTANCE;if(Oe.length===1)return Oe[0]}return new ye(Oe,ne)}}serialize(){return this.expr.map(q=>q.serialize()).join(" || ")}keys(){const q=[];for(const ne of this.expr)q.push(...ne.keys());return q}map(q){return new ye(this.expr.map(ne=>ne.map(q)),null)}negate(){if(!this.c){const q=[];for(const ne of this.expr)q.push(ne.negate());for(;q.length>1;){const ne=q.shift(),Pe=q.shift(),Oe=[];for(const Re of te(ne))for(const be of te(Pe))Oe.push(ce.create([Re,be],null,!1));q.unshift(ye.create(Oe,null,!1))}this.c=ye.create(q,this,!0)}return this.c}}e.$sj=ye;class ke extends ${static{this.d=[]}static all(){return ke.d.values()}constructor(q,ne,Pe){super(q,null),this.f=ne,typeof Pe=="object"?ke.d.push({...Pe,key:q}):Pe!==!0&&ke.d.push({key:q,description:Pe,type:ne!=null?typeof ne:void 0})}bindTo(q){return q.createKey(this.key,this.f)}getValue(q){return q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(q){return I.create(this.key,q)}notEqualsTo(q){return b.create(this.key,q)}}e.$tj=ke,e.$uj=(0,L.$ci)("contextKeyService");function he(Y,q){return Y<q?-1:Y>q?1:0}function ve(Y,q,ne,Pe){return Y<ne?-1:Y>ne?1:q<Pe?-1:q>Pe?1:0}function se(Y,q){if(Y.type===0||q.type===1)return!0;if(Y.type===9)return q.type===9?$e(Y.expr,q.expr):!1;if(q.type===9){for(const ne of q.expr)if(se(Y,ne))return!0;return!1}if(Y.type===6){if(q.type===6)return $e(q.expr,Y.expr);for(const ne of Y.expr)if(se(ne,q))return!0;return!1}return Y.equals(q)}e.$vj=se;function $e(Y,q){let ne=0,Pe=0;for(;ne<Y.length&&Pe<q.length;){const Oe=Y[ne].cmp(q[Pe]);if(Oe<0)return!1;Oe===0&&ne++,Pe++}return ne===Y.length}function te(Y){return Y.type===9?Y.expr:[Y]}}),define(Fe[185],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=void 0,e.$ji=(0,S.$ci)("environmentService"),e.$ki=(0,S.$di)(e.$ji)}),define(Fe[96],Le([1,0,152,4]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.ExtensionGalleryErrorCode=e.$Jo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Io=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$xo=new RegExp(e.$wo),e.$yo="__web_extension",e.$zo="skipWalkthrough",e.$Ao="extensionsSync",e.$Bo="dependecyOrPackExtensionInstall";function P(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Co=P;function L(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Do=L;function R(n,o){switch(n){case 3:return o==="x64"?"win32-x64":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Eo=R;function g(n,o){return o==="web"&&!n.includes("web")}e.$Fo=g;function f(n,o,l){return g(o,l)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===l}e.$Go=f;function D(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$Ho=D;var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var h;(function(n){n.Install="install",n.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var v;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Io=(0,F.$ci)("extensionGalleryService");var p;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var s;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class u extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$Jo=u;var r;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class i extends Error{constructor(o,l){super(o),this.code=l,this.name=l}}e.$Ko=i,e.$Lo=(0,F.$ci)("extensionManagementService"),e.$Mo="extensionsIdentifiers/disabled",e.$No="extensionsIdentifiers/enabled",e.$Oo=(0,F.$ci)("IGlobalExtensionEnablementService"),e.$Po=(0,F.$ci)("IExtensionTipsService"),e.$Qo=(0,S.localize2)(0,"Extensions"),e.$Ro=(0,S.localize2)(1,"Preferences")}),define(Fe[42],Le([1,0,51,19,13,16,2,154,4,20,12,39]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileKind=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileOperationResult=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileChangeType=e.$Rk=e.FileOperation=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileSystemProviderErrorCode=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderCapabilities=e.$Bk=e.FilePermission=e.FileType=e.$Ak=e.$zk=void 0,e.$zk=(0,f.$ci)("fileService");function h(se){return se.create===!0}e.$Ak=h;var v;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function s(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$Bk=s;var u;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(u||(e.FileSystemProviderCapabilities=u={}));function r(se){return!!(se.capabilities&2)}e.$Ck=r;function i(se){return!!(se.capabilities&8)}e.$Dk=i;function n(se){return!!(se.capabilities&131072)}e.$Ek=n;function o(se){return!!(se.capabilities&4)}e.$Fk=o;function l(se){return!!(se.capabilities&16)}e.$Gk=l;function t(se){return r(se)?!!(se.capabilities&16384):!1}e.$Hk=t;function m(se){return r(se)?!!(se.capabilities&32768):!1}e.$Ik=m;function a(se){return!!(se.capabilities&65536)}e.$Jk=a;function c(se){return!!(se.capabilities&2048)}e.$Kk=c;var E;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class y extends Error{static create($e,te){const Y=new y($e.toString(),te);return d(Y,te),Y}constructor($e,te){super($e),this.code=te}}e.$Lk=y;function $(se,$e){return y.create(se,$e)}e.$Mk=$;function I(se){return se||$((0,g.localize)(0,null),E.Unknown)}e.$Nk=I;function d(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Ok=d;function w(se){if(!se)return E.Unknown;if(se instanceof y)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return E.Unknown;switch($e[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.$Pk=w;function b(se){if(se instanceof C)return se.fileOperationResult;switch(w(se)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 9;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileTooLarge:return 7;default:return 10}}e.$Qk=b;var M;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class T{constructor($e,te,Y){this.resource=$e,this.operation=te,this.target=Y}isOperation($e){return this.operation===$e}}e.$Rk=T;var G;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(G||(e.FileChangeType=G={}));class W{static{this.a=null}constructor($e,te){this.c=te,this.b=void 0,this.d=new k.$V(()=>{const Y=S.$ii.forUris(()=>this.c);return Y.fill(this.rawAdded.map(q=>[q,!0])),Y}),this.f=new k.$V(()=>{const Y=S.$ii.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(q=>[q,!0])),Y}),this.g=new k.$V(()=>{const Y=S.$ii.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(q=>[q,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of $e){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==W.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains($e,...te){return this.h($e,{includeChildren:!1},...te)}affects($e,...te){return this.h($e,{includeChildren:!0},...te)}h($e,te,...Y){if(!$e)return!1;const q=Y.length>0;return!!((!q||Y.includes(1))&&(this.d.value.get($e)||te.includeChildren&&this.d.value.findSuperstr($e))||(!q||Y.includes(0))&&(this.f.value.get($e)||te.includeChildren&&this.f.value.findSuperstr($e))||(!q||Y.includes(2))&&(this.g.value.findSubstr($e)||te.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Sk=W;function U(se,$e,te){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==F.sep&&($e+=F.sep),te?(0,P.$if)(se,$e):se.indexOf($e)===0)}e.$Tk=U;class C extends Error{constructor($e,te,Y){super($e),this.fileOperationResult=te,this.options=Y}}e.$Uk=C;class O extends C{constructor($e,te,Y,q){super($e,te,q),this.fileOperationResult=te,this.size=Y}}e.$Vk=O;class V extends C{constructor($e,te,Y){super($e,2,Y),this.stat=te}}e.$Wk=V;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Zk="files.associations",e.$1k="files.exclude",e.$2k="files.readonlyInclude",e.$3k="files.readonlyExclude",e.$4k="files.readonlyFromPermissions";var ce;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$5k="";function ye(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$6k=ye;async function ke(se,$e){if(!$e.hasProvider(R.URI.from({scheme:se.scheme})))return new Promise(te=>{const Y=$e.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===se.scheme&&q.added&&(Y.dispose(),te())})})}e.$7k=ke;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize($e){return(0,L.$Uf)($e)||($e=0),$e<he.KB?(0,g.localize)(1,null,$e.toFixed(0)):$e<he.MB?(0,g.localize)(2,null,($e/he.KB).toFixed(2)):$e<he.GB?(0,g.localize)(3,null,($e/he.MB).toFixed(2)):$e<he.TB?(0,g.localize)(4,null,($e/he.GB).toFixed(2)):(0,g.localize)(5,null,($e/he.TB).toFixed(2))}}e.$8k=he;function ve(se){const $e=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*he.MB:$e?10*he.MB:D.$o?50*he.MB:1024*he.MB}e.$9k=ve}),define(Fe[71],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=void 0;class S{constructor(...P){this.a=new Map;for(const[L,R]of P)this.set(L,R)}set(P,L){const R=this.a.get(P);return this.a.set(P,L),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$ai=S}),define(Fe[186],Le([1,0,11,15,6,70,184,4,71,187]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;const A=!1;class k extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class h{constructor(u=new f.$ai,r=!1,i,n=A){this.f=u,this.g=r,this.h=i,this.i=n,this.o=new Set,this.f.set(g.$bi,this),this._globalGraph=n?i?._globalGraph??new R.$Mq(o=>o):void 0}createChild(u){return new h(u,this.g,this,this.i)}invokeFunction(u,...r){const i=p.traceInvocation(this.i,u);let n=!1;try{return u({get:l=>{if(n)throw(0,F.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(l,i);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...r)}finally{n=!0,i.stop()}}createInstance(u,...r){let i,n;return u instanceof L.$_h?(i=p.traceCreation(this.i,u.ctor),n=this.j(u.ctor,u.staticArguments.concat(r),i)):(i=p.traceCreation(this.i,u),n=this.j(u,r,i)),i.stop(),n}j(u,r=[],i){const n=g._util.getServiceDependencies(u).sort((t,m)=>t.index-m.index),o=[];for(const t of n){const m=this.m(t.id,i);m||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(m)}const l=n.length>0?n[0].index:r.length;if(r.length!==l){console.trace(`[createInstance] First service dependency of ${u.name} at position ${l+1} conflicts with ${r.length} static arguments`);const t=l-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,l)}return Reflect.construct(u,r.concat(o))}k(u,r){if(this.f.get(u)instanceof L.$_h)this.f.set(u,r);else if(this.h)this.h.k(u,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const r=this.f.get(u);return!r&&this.h?this.h.l(u):r}m(u,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const i=this.l(u);return i instanceof L.$_h?this.q(u,i,r.branch(u,!0)):(r.branch(u,!1),i)}q(u,r,i){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,r,i)}finally{this.o.delete(u)}}r(u,r,i){const n=new R.$Mq(t=>t.id.toString());let o=0;const l=[{id:u,desc:r,_trace:i}];for(;l.length;){const t=l.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new k(n);for(const m of g._util.getServiceDependencies(t.desc.ctor)){const a=this.l(m.id);if(a||this.u(`[createInstance] ${u} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(m.id)),a instanceof L.$_h){const c={id:m.id,desc:a,_trace:t._trace.branch(m.id,!0)};n.insertEdge(t,c),l.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new k(n);break}for(const{data:m}of t){if(this.l(m.id)instanceof L.$_h){const c=this.s(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.k(m.id,c)}n.removeNode(m)}}return this.l(u)}s(u,r,i=[],n,o){if(this.f.get(u)instanceof L.$_h)return this.t(u,r,i,n,o);if(this.h)return this.h.s(u,r,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(u,r,i=[],n,o){if(n){const l=new h(void 0,this.g,this,this.i);l.c=String(u);const t=new Map,m=new S.$vh(()=>{const a=l.j(r,i,o);for(const[c,E]of t){const y=a[c];if(typeof y=="function")for(const $ of E)$.disposable=y.apply(a,$.listener)}return t.clear(),a});return new Proxy(Object.create(null),{get(a,c){if(!m.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let $=t.get(c);return $||($=new D.$4c,t.set(c,$)),(d,w,b)=>{if(m.isInitialized)return m.value[c](d,w,b);{const M={listener:[d,w,b],disposable:void 0},T=$.push(M);return(0,P.$Rc)(()=>{T(),M.disposable?.dispose()})}}}if(c in a)return a[c];const E=m.value;let y=E[c];return typeof y!="function"||(y=y.bind(E),a[c]=y),y},set(a,c,E){return m.value[c]=E,!0},getPrototypeOf(a){return r.prototype}})}else return this.j(r,i,o)}u(u,r){if(r&&console.warn(u),this.g)throw new Error(u)}}e.$Nq=h;var v;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(v||(v={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(u,r){return u?new p(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(u,r){return u?new p(1,r.name):p.c}static{this.f=0}constructor(u,r){this.type=u,this.name=r,this.g=Date.now(),this.h=[]}branch(u,r){const i=new p(3,u.toString());return this.h.push([u,r,i]),i}stop(){const u=Date.now()-this.g;p.f+=u;let r=!1;function i(o,l){const t=[],m=new Array(o+1).join("	");for(const[a,c,E]of l.h)if(c&&E){r=!0,t.push(`${m}CREATES -> ${a}`);const y=i(o+1,E);y&&t.push(y)}else t.push(`${m}uses -> ${a}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(u>2||r)&&p.all.add(n.join(`
`))}}e.$Oq=p}),define(Fe[14],Le([1,0,41,5,97,6,28,20,25,16,2,35,4]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.log=e.$zj=e.LogLevel=e.$yj=e.$xj=e.$wj=void 0,e.$wj=(0,h.$ci)("logService"),e.$xj=(0,h.$ci)("loggerService");function v(){return new Date().toISOString()}function p(d){return(0,D.$Uf)(d)}e.$yj=p;var s;(function(d){d[d.Off=0]="Off",d[d.Trace=1]="Trace",d[d.Debug=2]="Debug",d[d.Info=3]="Info",d[d.Warning=4]="Warning",d[d.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$zj=s.Info;function u(d,w,b){switch(w){case s.Trace:d.trace(b);break;case s.Debug:d.debug(b);break;case s.Info:d.info(b);break;case s.Warning:d.warn(b);break;case s.Error:d.error(b);break;case s.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=u;function r(d,w=!1){let b="";for(let M=0;M<d.length;M++){let T=d[M];if(T instanceof Error&&(T=(0,S.$Zi)(T,w)),typeof T=="object")try{T=JSON.stringify(T)}catch{}b+=(M>0?" ":"")+T}return b}class i extends L.$Tc{constructor(){super(...arguments),this.b=e.$zj,this.c=this.B(new F.$3d),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==s.Off&&this.b<=w}}e.$Bj=i;class n extends i{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...b){this.f(s.Trace)&&this.g(s.Trace,r([w,...b],!0))}debug(w,...b){this.f(s.Debug)&&this.g(s.Debug,r([w,...b]))}info(w,...b){this.f(s.Info)&&this.g(s.Info,r([w,...b]))}warn(w,...b){this.f(s.Warning)&&this.g(s.Warning,r([w,...b]))}error(w,...b){if(this.f(s.Error))if(w instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=w.stack,this.g(s.Error,r(M))}else this.g(s.Error,r([w,...b]))}flush(){}}e.$Cj=n;class o extends i{constructor(w=e.$zj){super(),this.setLevel(w),this.g=!g.$i}trace(w,...b){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,w,...b):console.log(`[main ${v()}]`,w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,w,...b):console.warn(`[main ${v()}]`,w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,w,...b):console.error(`[main ${v()}]`,w,...b))}flush(){}}e.$Dj=o;class l extends i{constructor(w=e.$zj,b=!0){super(),this.g=b,this.setLevel(w)}trace(w,...b){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...b):console.log(w,...b))}debug(w,...b){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...b):console.log(w,...b))}info(w,...b){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...b):console.log(w,...b))}warn(w,...b){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...b):console.log(w,...b))}error(w,...b){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...b):console.error(w,...b))}flush(){}}e.$Ej=l;class t extends i{constructor(w,b=e.$zj){super(),this.g=w,this.setLevel(b)}trace(w,...b){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(w),...b])}debug(w,...b){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(w),...b])}info(w,...b){this.f(s.Info)&&this.g.log(s.Info,[this.h(w),...b])}warn(w,...b){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(w),...b])}error(w,...b){this.f(s.Error)&&this.g.log(s.Error,[this.h(w),...b])}h(w){return typeof w=="string"?w:(0,S.$Zi)(w,this.f(s.Trace))}flush(){}}e.$Fj=t;class m extends i{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const b of this.g)b.setLevel(w);super.setLevel(w)}trace(w,...b){for(const M of this.g)M.trace(w,...b)}debug(w,...b){for(const M of this.g)M.debug(w,...b)}info(w,...b){for(const M of this.g)M.info(w,...b)}warn(w,...b){for(const M of this.g)M.warn(w,...b)}error(w,...b){for(const M of this.g)M.error(w,...b)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$Gj=m;class a extends L.$Tc{constructor(w,b,M){if(super(),this.h=w,this.j=b,this.b=new R.$Ac,this.c=this.B(new F.$3d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$3d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$3d),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(w){return(0,D.$Qf)(w)?[...this.b.values()].find(b=>b.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,b){const M=this.n(w),T=(0,D.$Qf)(w)?w:b?.id??(0,P.$3i)(M.toString()).toString(16);let G=this.b.get(M)?.logger;const W=b?.logLevel==="always"?s.Trace:b?.logLevel;G||(G=this.s(M,W??this.getLogLevel(M)??this.h,{...b,id:T}));const U={logger:G,info:{resource:M,id:T,logLevel:W,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(U.info),this.b.set(M,U),G}n(w){return(0,D.$Qf)(w)?(0,f.$Pg)(this.j,`${w}.log`):w}setLogLevel(w,b){if(A.URI.isUri(w)){const M=w,T=b,G=this.b.get(M);G&&T!==G.info.logLevel&&(G.info.logLevel=T===this.h?void 0:T,G.logger?.setLevel(T),this.b.set(G.info.resource,G),this.f.fire([M,T]))}else{this.h=w;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,b){const M=this.m(w);M&&b!==!M.info.hidden&&(M.info.hidden=!b,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,b]))}getLogLevel(w){let b;return w&&(b=this.b.get(w)?.info.logLevel),b??this.h}registerLogger(w){const b=this.b.get(w.resource);b?b.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const b=this.b.get(w);b&&(b.logger&&b.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Hj=a;class c{constructor(){this.onDidChangeLogLevel=new F.$3d().event}setLevel(w){}getLevel(){return s.Info}trace(w,...b){}debug(w,...b){}info(w,...b){}warn(w,...b){}error(w,...b){}critical(w,...b){}dispose(){}flush(){}}e.$Ij=c;class E extends c{}e.$Jj=E;function y(d){if(d.verbose)return s.Trace;if(typeof d.logLevel=="string"){const w=I(d.logLevel.toLowerCase());if(w!==void 0)return w}return e.$zj}e.$Kj=y;function $(d){switch(d){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Lj=$;function I(d){switch(d){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Mj=I,e.$Nj=new k.$tj("logLevel",$(s.Info))}),define(Fe[188],Le([1,0,6,14]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=void 0;class P extends S.$Tc{constructor(R,g=[]){super(),this.a=new F.$Gj([R,...g]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...g){this.a.trace(R,...g)}debug(R,...g){this.a.debug(R,...g)}info(R,...g){this.a.info(R,...g)}warn(R,...g){this.a.warn(R,...g)}error(R,...g){this.a.error(R,...g)}flush(){this.a.flush()}}e.$xP=P}),define(Fe[98],Le([1,0,32,155,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function D(p,s){return s-p}f.compare=D;const A=Object.create(null);A[f.Error]=(0,F.localize)(0,null),A[f.Warning]=(0,F.localize)(1,null),A[f.Info]=(0,F.localize)(2,null);function k(p){return A[p]||""}f.toString=k;function h(p){switch(p){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=h;function v(p){switch(p){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=v}(R||(e.MarkerSeverity=R={}));var g;(function(f){const D="";function A(h){return k(h,!0)}f.makeKey=A;function k(h,v){const p=[D];return h.source?p.push(h.source.replace("\xA6","\\\xA6")):p.push(D),h.code?typeof h.code=="string"?p.push(h.code.replace("\xA6","\\\xA6")):p.push(h.code.value.replace("\xA6","\\\xA6")):p.push(D),h.severity!==void 0&&h.severity!==null?p.push(R.toString(h.severity)):p.push(D),h.message&&v?p.push(h.message.replace("\xA6","\\\xA6")):p.push(D),h.startLineNumber!==void 0&&h.startLineNumber!==null?p.push(h.startLineNumber.toString()):p.push(D),h.startColumn!==void 0&&h.startColumn!==null?p.push(h.startColumn.toString()):p.push(D),h.endLineNumber!==void 0&&h.endLineNumber!==null?p.push(h.endLineNumber.toString()):p.push(D),h.endColumn!==void 0&&h.endColumn!==null?p.push(h.endColumn.toString()):p.push(D),p.push(D),p.join("\xA6")}f.makeKeyOptionalMessage=k})(g||(e.IMarkerData=g={})),e.$Jt=(0,P.$ci)("markerService")}),define(Fe[189],Le([1,0,5,32,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.NotificationsFilter=e.$zv=e.NeverShowAgainScope=e.NotificationPriority=e.$yv=e.Severity=void 0,e.Severity=F.default,e.$yv=(0,P.$ci)("notificationService");var L;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function g(k){if(k){const h=k;return typeof h.id=="string"&&typeof h.label=="string"}return!1}e.$zv=g;var f;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class D{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(h){}updateMessage(h){}updateActions(h){}close(){}}e.$Av=D;class A{infinite(){}done(){}total(h){}worked(h){}}e.$Bv=A}),define(Fe[190],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=void 0,e.$Oj=(0,S.$ci)("productService"),e.$Pj="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(fe,e,S,F){var P=arguments.length,L=P<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,S):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(fe,e,S,F);else for(var g=fe.length-1;g>=0;g--)(R=fe[g])&&(L=(P<3?R(L):P>3?R(e,S,L):R(e,S))||L);return P>3&&L&&Object.defineProperty(e,S,L),L},qe=this&&this.__param||function(fe,e){return function(S,F){e(S,F,fe)}};define(Fe[99],Le([1,0,11,21,6,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProgressLocation=e.$Cv=void 0,e.$Cv=(0,L.$ci)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Dv=Object.freeze({total(){},worked(){},done(){}});class g{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(h){this.b=h}report(h){this.a=h,this.b(this.a)}}e.$Ev=g;class f{get value(){return this.a}constructor(h){this.e=h}report(h){this.b?this.b.push(h):this.b=[h],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const h=this.b.shift();this.a=h,await this.e(this.a)}}finally{this.c=!1;const h=this.d;this.d=void 0,h?.()}}drain(){return this.c?new Promise(h=>{const v=this.d;this.d=()=>{v?.(),h()}}):Promise.resolve()}}e.$Fv=f;let D=class extends P.$Tc{constructor(h,v){super(),this.a=new S.$zh,v.withProgress(h,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(h){this.b?this.b.report(h):this.c=h}};e.$Gv=D,e.$Gv=D=Je([qe(1,e.$Cv)],D);class A extends P.$Tc{constructor(h){super(),this.g=h,this.a=0,this.b=this.B(new P.$Sc)}start(h){this.stop();const v=++this.a,p=new F.$ae;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},h),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>p.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:v,token:p.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(h){this.a===h&&this.b.clear()}}e.$Hv=A,e.$Iv=(0,L.$ci)("editorProgressService")}),define(Fe[30],Le([1,0,54,16]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0;class P{constructor(){this.a=new Map}add(R,g){S.ok(F.$Qf(R)),S.ok(F.$Sf(g)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,g)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Rn=new P}),define(Fe[72],Le([1,0,5,30]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=void 0,e.$Sn={JSONContribution:"base.contributions.json"};function P(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this.b=new S.$3d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,D){this.a[P(f)]=D,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;F.$Rn.add(e.$Sn.JSONContribution,R)}),define(Fe[55],Le([1,0,18,5,16,149,47,72,30]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.ConfigurationScope=e.$Wn=e.EditPresentationTypes=void 0;var D;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$Wn={Configuration:"base.contributions.configuration"};var A;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Xn={properties:{},patternProperties:{}},e.$Yn={properties:{},patternProperties:{}},e.$Zn={properties:{},patternProperties:{}},e.$1n={properties:{},patternProperties:{}},e.$2n={properties:{},patternProperties:{}},e.$3n={properties:{},patternProperties:{}},e.$4n="vscode://schemas/settings/resourceLanguage",e.$5n="vscode://schemas/settings/configurationDefaults";const k=f.$Rn.as(g.$Sn.JSONContribution);class h{constructor(){this.h=new Set,this.i=new F.$3d,this.onDidSchemaChange=this.i.event,this.j=new F.$3d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$4n,this.g),this.v()}registerConfiguration(t,m=!0){this.registerConfigurations([t],m)}registerConfigurations(t,m=!0){const a=new Set;this.n(t,m,a),k.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(t){const m=new Set;this.o(t,m),k.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:m})}updateConfigurations({add:t,remove:m}){const a=new Set;this.o(m,a),this.n(t,!1,a),k.registerSchema(e.$4n,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(t){const m=new Set;this.k(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}k(t,m){const a=[];for(const{overrides:c,source:E}of t)for(const y in c)if(m.add(y),e.$7n.test(y)){const $=this.a.get(y),I=$?.valuesSources??new Map;if(E)for(const M of Object.keys(c[y]))I.set(M,E);const d={...$?.value||{},...c[y]};this.a.set(y,{source:E,value:d,valuesSources:I});const w=(0,R.$Si)(y),b={type:"object",default:d,description:L.localize(1,null,w),$ref:e.$4n,defaultDefaultValue:d,source:P.$Qf(E)?void 0:E,defaultValueSource:E};a.push(...s(y)),this.d[y]=b,this.b.properties[y]=b}else{this.a.set(y,{value:c[y],source:E});const $=this.d[y];$&&(this.w(y,$),this.r(y,$))}this.m(a)}deregisterDefaultConfigurations(t){const m=new Set;this.l(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}l(t,m){for(const{overrides:a,source:c}of t)for(const E in a){const y=this.a.get(E),$=P.$Qf(c)?c:c?.id,I=P.$Qf(y?.source)?y?.source:y?.source?.id;if($===I)if(m.add(E),this.a.delete(E),e.$7n.test(E))delete this.d[E],delete this.b.properties[E];else{const d=this.d[E];d&&(this.w(E,d),this.r(E,d))}}this.u()}deltaConfiguration(t){let m=!1;const a=new Set;t.removedDefaults&&(this.l(t.removedDefaults,a),m=!0),t.addedDefaults&&(this.k(t.addedDefaults,a),m=!0),t.removedConfigurations&&this.o(t.removedConfigurations,a),t.addedConfigurations&&this.n(t.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const m of t)this.h.add(m);this.u()}n(t,m,a){t.forEach(c=>{this.p(c,m,c.extensionInfo,c.restrictedProperties,void 0,a),this.c.push(c),this.q(c)})}o(t,m){const a=c=>{if(c.properties)for(const E in c.properties){m.add(E);const y=this.d[E];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[E],this.s(E,c.properties[E])}c.allOf?.forEach(E=>a(E))};for(const c of t){a(c);const E=this.c.indexOf(c);E!==-1&&this.c.splice(E,1)}}p(t,m=!0,a,c,E=3,y){E=P.$Zf(t.scope)?E:t.scope;const $=t.properties;if($)for(const d in $){const w=$[d];if(m&&n(d,w)){delete $[d];continue}if(w.source=a,w.defaultDefaultValue=$[d].default,this.w(d,w),e.$7n.test(d)?w.scope=void 0:(w.scope=P.$Zf(w.scope)?E:w.scope,w.restricted=P.$Zf(w.restricted)?!!c?.includes(d):w.restricted),$[d].hasOwnProperty("included")&&!$[d].included){this.f[d]=$[d],delete $[d];continue}else this.d[d]=$[d],$[d].policy?.name&&this.e.set($[d].policy.name,d);!$[d].deprecationMessage&&$[d].markdownDeprecationMessage&&($[d].deprecationMessage=$[d].markdownDeprecationMessage),y.add(d)}const I=t.allOf;if(I)for(const d of I)this.p(d,m,a,c,E,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const m=a=>{const c=a.properties;if(c)for(const y in c)this.r(y,c[y]);a.allOf?.forEach(m)};m(t)}r(t,m){switch(e.$Xn.properties[t]=m,m.scope){case 1:e.$Yn.properties[t]=m;break;case 2:e.$Zn.properties[t]=m;break;case 6:e.$1n.properties[t]=m;break;case 3:e.$2n.properties[t]=m;break;case 4:e.$3n.properties[t]=m;break;case 5:e.$3n.properties[t]=m,this.g.properties[t]=m;break}}s(t,m){switch(delete e.$Xn.properties[t],m.scope){case 1:delete e.$Yn.properties[t];break;case 2:delete e.$Zn.properties[t];break;case 6:delete e.$1n.properties[t];break;case 3:delete e.$2n.properties[t];break;case 4:case 5:delete e.$3n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const m=`[${t}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$4n};this.w(m,a),e.$Xn.properties[m]=a,e.$Yn.properties[m]=a,e.$Zn.properties[m]=a,e.$1n.properties[m]=a,e.$2n.properties[m]=a,e.$3n.properties[m]=a}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$4n};e.$Xn.patternProperties[e.$6n]=t,e.$Yn.patternProperties[e.$6n]=t,e.$Zn.patternProperties[e.$6n]=t,e.$1n.patternProperties[e.$6n]=t,e.$2n.patternProperties[e.$6n]=t,e.$3n.patternProperties[e.$6n]=t,this.i.fire()}w(t,m){const a=this.a.get(t);let c=a?.value,E=a?.source;P.$Xf(c)&&(c=m.defaultDefaultValue,E=void 0),P.$Xf(c)&&(c=r(m.type)),m.default=c,m.defaultValueSource=E}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.$6n=`^(${v})+$`,e.$7n=new RegExp(e.$6n);function s(l){const t=[];if(e.$7n.test(l)){let m=p.exec(l);for(;m?.length;){const a=m[1].trim();a&&t.push(a),m=p.exec(l)}}return(0,S.$Mb)(t)}e.$8n=s;function u(l){return l.reduce((t,m)=>`${t}[${m}]`,"")}e.$9n=u;function r(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0n=r;const i=new h;f.$Rn.add(e.$Wn.Configuration,i);function n(l,t){return l.trim()?e.$7n.test(l)?L.localize(7,null,l):i.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,l,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$$n=n;function o(){const l=[],t=i.getConfigurationProperties();for(const m of Object.keys(t))l.push([m,t[m].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$_n=o}),define(Fe[191],Le([1,0,18,5,120,6,28,26,16,2,47,55,30]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;function v(m){return Object.isFrozen(m)?m:g.$Gn(m)}class p{constructor(a={},c=[],E=[],y){this.b=a,this.c=c,this.d=E,this.raw=y,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(c=>{if(c instanceof p)return c;const E=new s("");return E.parseRaw(c),E.configurationModel});this.f=a.reduce((c,E)=>E===c?E:c.merge(E),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,A.$Qi)(this.contents,a):this.contents}inspect(a,c){const E=this;return{get value(){return v(E.rawConfiguration.getValue(a))},get override(){return c?v(E.rawConfiguration.getOverrideValue(a,c)):void 0},get merged(){return v(c?E.rawConfiguration.override(c).getValue(a):E.rawConfiguration.getValue(a))},get overrides(){const y=[];for(const{contents:$,identifiers:I,keys:d}of E.rawConfiguration.overrides){const w=new p($,d).getValue(a);w!==void 0&&y.push({identifiers:I,value:w})}return y.length?v(y):void 0}}}getOverrideValue(a,c){const E=this.i(c);return E?a?(0,A.$Qi)(E,a):E:void 0}getKeysForOverrideIdentifier(a){const c=[];for(const E of this.overrides)E.identifiers.includes(a)&&c.push(...E.keys);return S.$Mb(c)}getAllOverrideIdentifiers(){const a=[];for(const c of this.overrides)a.push(...c.identifiers);return S.$Mb(a)}override(a){let c=this.a.get(a);return c||(c=this.g(a),this.a.set(a,c)),c}merge(...a){const c=g.$Fn(this.contents),E=g.$Fn(this.overrides),y=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const I of a)if($.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(c,I.contents);for(const d of I.overrides){const[w]=E.filter(b=>S.$ub(b.identifiers,d.identifiers));w?(this.h(w.contents,d.contents),w.keys.push(...d.keys),w.keys=S.$Mb(w.keys)):E.push(g.$Fn(d))}for(const d of I.keys)y.indexOf(d)===-1&&y.push(d)}return new p(c,y,E,$.every(I=>I instanceof p)?void 0:$)}g(a){const c=this.i(a);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const E={};for(const y of S.$Mb([...Object.keys(this.contents),...Object.keys(c)])){let $=this.contents[y];const I=c[y];I&&(typeof $=="object"&&typeof I=="object"?($=g.$Fn($),this.h($,I)):$=I),E[y]=$}return new p(E,this.keys,this.overrides)}h(a,c){for(const E of Object.keys(c)){if(E in a&&f.$Sf(a[E])&&f.$Sf(c[E])){this.h(a[E],c[E]);continue}a[E]=g.$Fn(c[E])}}i(a){let c=null,E=null;const y=$=>{$&&(E?this.h(E,$):E=g.$Fn($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===a?c=$.contents:$.identifiers.includes(a)&&y($.contents);return y(c),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,c){this.j(a,c,!0)}setValue(a,c){this.j(a,c,!1)}removeValue(a){const c=this.keys.indexOf(a);c!==-1&&(this.keys.splice(c,1),(0,A.$Pi)(this.contents,a),k.$7n.test(a)&&this.overrides.splice(this.overrides.findIndex(E=>S.$ub(E.identifiers,(0,k.$8n)(a))),1))}j(a,c,E){(0,A.$Oi)(this.contents,a,c,y=>console.error(y)),E=E||this.keys.indexOf(a)===-1,E&&this.keys.push(a),k.$7n.test(a)&&this.overrides.push({identifiers:(0,k.$8n)(a),keys:Object.keys(this.contents[a]),contents:(0,A.$Ni)(this.contents[a],y=>console.error(y))})}}e.$ao=p;class s{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,c){if(!f.$Zf(a)){const E=this.g(a);this.parseRaw(E,c)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,c){this.a=a;const{contents:E,keys:y,overrides:$,restricted:I,hasExcludedProperties:d}=this.h(a,c);this.b=new p(E,y,$,d?[a]:void 0),this.c=I||[]}g(a){let c={},E=null,y=[];const $=[],I=[];function d(b){Array.isArray(y)?y.push(b):E!==null&&(y[E]=b)}const w={onObjectBegin:()=>{const b={};d(b),$.push(y),y=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{y=$.pop()},onArrayBegin:()=>{const b=[];d(b),$.push(y),y=b,E=null},onArrayEnd:()=>{y=$.pop()},onLiteralValue:d,onError:(b,M,T)=>{I.push({error:b,offset:M,length:T})}};if(a)try{P.$tn(a,w),c=y[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return c}h(a,c){const E=h.$Rn.as(k.$Wn.Configuration).getConfigurationProperties(),y=this.i(a,E,!0,c);a=y.raw;const $=(0,A.$Ni)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),I=Object.keys(a),d=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:$,keys:I,overrides:d,restricted:y.restricted,hasExcludedProperties:y.hasExcludedProperties}}i(a,c,E,y){let $=!1;if(!y?.scopes&&!y?.skipRestricted&&!y?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:$};const I={},d=[];for(const w in a)if(k.$7n.test(w)&&E){const b=this.i(a[w],c,!1,y);I[w]=b.raw,$=$||b.hasExcludedProperties,d.push(...b.restricted)}else{const b=c[w],M=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&d.push(w),!y.exclude?.includes(w)&&(y.include?.includes(w)||(M===void 0||y.scopes===void 0||y.scopes.includes(M))&&!(y.skipRestricted&&b?.restricted))?I[w]=a[w]:$=!0}return{raw:I,restricted:d,hasExcludedProperties:$}}j(a,c){const E=[];for(const y of Object.keys(a))if(k.$7n.test(y)){const $={};for(const I in a[y])$[I]=a[y][I];E.push({identifiers:(0,k.$8n)(y),keys:Object.keys($),contents:(0,A.$Ni)($,c)})}return E}}e.$bo=s;class u extends L.$Tc{constructor(a,c,E,y){super(),this.c=a,this.f=c,this.g=y,this.b=this.B(new F.$3d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&E.isEqual($.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$co=u;class r{constructor(a,c,E,y,$,I,d,w,b,M,T,G,W){this.a=a,this.b=c,this.c=E,this.overrideIdentifiers=y,this.d=$,this.f=I,this.g=d,this.h=w,this.i=b,this.j=M,this.k=T,this.l=G,this.m=W}get value(){return v(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(a,c,E,y,$=new p,I=new p,d=new R.$Ac,w=new p,b=new R.$Ac){this.c=a,this.d=c,this.f=E,this.g=y,this.h=$,this.i=I,this.j=d,this.l=w,this.m=b,this.a=null,this.b=new R.$Ac,this.n=null}getValue(a,c,E){return this.p(a,c,E).getValue(a)}updateValue(a,c,E={}){let y;E.resource?(y=this.m.get(E.resource),y||(y=new p,this.m.set(E.resource,y))):y=this.l,c===void 0?y.removeValue(a):y.setValue(a,c),E.resource||(this.a=null)}inspect(a,c,E){const y=this.p(a,c,E),$=this.t(c.resource,E),I=c.resource?this.m.get(c.resource)||this.l:this.l,d=new Set;for(const w of y.overrides)for(const b of w.identifiers)y.getOverrideValue(a,b)!==void 0&&d.add(b);return new r(a,c,y.getValue(a),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,$||void 0,I)}keys(a){const c=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,c){this.j.set(a,c),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,c){const E=[];if(!c){const{added:y,updated:$,removed:I}=l(this.c,a);c=[...y,...$,...I]}for(const y of c)for(const $ of(0,k.$8n)(y)){const I=this.c.getKeysForOverrideIdentifier($),d=a.getKeysForOverrideIdentifier($),w=[...d.filter(b=>I.indexOf(b)===-1),...I.filter(b=>d.indexOf(b)===-1),...I.filter(b=>!g.$Jn(this.c.override($).getValue(b),a.override($).getValue(b)))];E.push([$,w])}return this.updateDefaultConfiguration(a),{keys:c,overrides:E}}compareAndUpdatePolicyConfiguration(a){const{added:c,updated:E,removed:y}=l(this.d,a),$=[...c,...E,...y];return $.length&&this.updatePolicyConfiguration(a),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:c,updated:E,removed:y,overrides:$}=l(this.applicationConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateApplicationConfiguration(a),{keys:I,overrides:$}}compareAndUpdateLocalUserConfiguration(a){const{added:c,updated:E,removed:y,overrides:$}=l(this.localUserConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateLocalUserConfiguration(a),{keys:I,overrides:$}}compareAndUpdateRemoteUserConfiguration(a){const{added:c,updated:E,removed:y,overrides:$}=l(this.remoteUserConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateRemoteUserConfiguration(a),{keys:I,overrides:$}}compareAndUpdateWorkspaceConfiguration(a){const{added:c,updated:E,removed:y,overrides:$}=l(this.workspaceConfiguration,a),I=[...c,...E,...y];return I.length&&this.updateWorkspaceConfiguration(a),{keys:I,overrides:$}}compareAndUpdateFolderConfiguration(a,c){const E=this.folderConfigurations.get(a),{added:y,updated:$,removed:I,overrides:d}=l(E,c),w=[...y,...$,...I];return(w.length||!E)&&this.updateFolderConfiguration(a,c),{keys:w,overrides:d}}compareAndDeleteFolderConfiguration(a){const c=this.folderConfigurations.get(a);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:E,updated:y,removed:$,overrides:I}=l(c,void 0);return{keys:[...E,...y,...$],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,c,E){let y=this.q(c,E);return c.overrideIdentifier&&(y=y.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(y=y.merge(this.d)),y}q({resource:a},c){let E=this.r();if(c&&a){const y=c.getFolder(a);y&&(E=this.s(y.uri)||E);const $=this.m.get(a);$&&(E=E.merge($))}return E}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let c=this.b.get(a);if(!c){const E=this.r(),y=this.j.get(a);y?(c=E.merge(y),this.b.set(a,c)):c=E}return c}t(a,c){if(c&&a){const E=c.getFolder(a);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,c)=>{const{contents:E,overrides:y,keys:$}=this.j.get(c);return a.push([c,{contents:E,overrides:y,keys:$}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(c=>a.add(c)),this.userConfiguration.keys.forEach(c=>a.add(c)),this.i.keys.forEach(c=>a.add(c)),this.j.forEach(c=>c.keys.forEach(E=>a.add(E))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>a.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(E=>a.add(E))),[...a.values()]}v(a){const c=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.i.getKeysForOverrideIdentifier(a).forEach(E=>c.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(a).forEach(y=>c.add(y))),[...c.values()]}static parse(a){const c=this.w(a.defaults),E=this.w(a.policy),y=this.w(a.application),$=this.w(a.user),I=this.w(a.workspace),d=a.folders.reduce((w,b)=>(w.set(D.URI.revive(b[0]),this.w(b[1])),w),new R.$Ac);return new i(c,E,y,$,new p,I,d,new p,new R.$Ac)}static w(a){return new p(a.contents,a.keys,a.overrides)}}e.$do=i;function n(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const a=new Set,c=new Map;for(const y of m)y.keys.forEach($=>a.add($)),y.overrides.forEach(([$,I])=>{const d=(0,R.$xc)(c,$,new Set);I.forEach(w=>d.add(w))});const E=[];return c.forEach((y,$)=>E.push([$,[...y.values()]])),{keys:[...a.values()],overrides:E}}e.$eo=n;class o{constructor(a,c,E,y){this.change=a,this.f=c,this.g=E,this.h=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of a.keys)this.affectedKeys.add($);for(const[,$]of a.overrides)for(const I of $)this.affectedKeys.add(I);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(a,c){const E=this.a+a,y=this.d.indexOf(E);if(y<0)return!1;const $=y+E.length;if($>=this.d.length)return!1;const I=this.d.charCodeAt($);if(I!==this.b&&I!==this.c)return!1;if(c){const d=this.previousConfiguration?this.previousConfiguration.getValue(a,c,this.f?.workspace):void 0,w=this.g.getValue(a,c,this.h);return!g.$Jn(d,w)}return!0}}e.$fo=o;function l(m,a){const{added:c,removed:E,updated:y}=t(a?.rawConfiguration,m?.rawConfiguration),$=[],I=m?.getAllOverrideIdentifiers()||[],d=a?.getAllOverrideIdentifiers()||[];if(a){const w=d.filter(b=>!I.includes(b));for(const b of w)$.push([b,a.getKeysForOverrideIdentifier(b)])}if(m){const w=I.filter(b=>!d.includes(b));for(const b of w)$.push([b,m.getKeysForOverrideIdentifier(b)])}if(a&&m){for(const w of I)if(d.includes(w)){const b=t({contents:m.getOverrideValue(void 0,w)||{},keys:m.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});$.push([w,[...b.added,...b.removed,...b.updated]])}}return{added:c,removed:E,updated:y,overrides:$}}function t(m,a){const c=m?a?m.keys.filter($=>a.keys.indexOf($)===-1):[...m.keys]:[],E=a?m?a.keys.filter($=>m.keys.indexOf($)===-1):[...a.keys]:[],y=[];if(m&&a){for(const $ of a.keys)if(m.keys.indexOf($)!==-1){const I=(0,A.$Qi)(a.contents,$),d=(0,A.$Qi)(m.contents,$);g.$Jn(I,d)||y.push($)}}return{added:c,removed:E,updated:y}}}),define(Fe[100],Le([1,0,15,4]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.RemoteAuthorityResolverErrorCode=e.$gl=e.$fl=e.RemoteConnectionType=e.$el=void 0,e.$el=(0,F.$ci)("remoteAuthorityResolverService");var P;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$fl=L;class R{constructor(k,h){this.host=k,this.port=h,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$gl=R;var g;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class f extends S.$bb{static isNotAvailable(k){return k instanceof f&&k._code===g.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===g.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===g.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===g.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,h=g.Unknown,v){super(k),this._message=k,this._code=h,this._detail=v,this.isHandled=h===g.NotAvailable&&v===!0,Object.setPrototypeOf(this,f.prototype)}}e.$hl=f;function D(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$il=D}),define(Fe[56],Le([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=void 0;function F(D){return D.scheme===S.Schemas.vscodeRemote?D.authority:void 0}e.$jl=F;function P(D){if(!D)return;const A=D.indexOf("+");return A<0?D:D.substr(0,A)}e.$kl=P;function L(D){return`/${D.quality??"oss"}-${D.commit??"dev"}`}e.$ll=L;function R(D){const{host:A,port:k}=f(D);if(typeof k>"u")throw new Error(`Invalid remote authority: ${D}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$ml=R;function g(D,A){let{host:k,port:h}=f(D);return typeof h>"u"&&(h=A),{host:k,port:h}}e.$nl=g;function f(D){const A=D.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=D.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const h=D.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:D,port:void 0}}}),define(Fe[22],Le([1,0,13,4,56]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.TargetPlatform=e.ExtensionType=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0,e.$om="extensions.user.cache",e.$pm="extensions.builtin.cache",e.$qm="undefined_publisher",e.$rm=["ui","workspace","web"];function L(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$sm=L,e.$tm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var g;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class f{constructor(u){this.value=u,this._lower=u.toLowerCase()}static equals(u,r){if(typeof u>"u"||u===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof u=="string"||typeof r=="string"){const i=typeof u=="string"?u:u.value,n=typeof r=="string"?r:r.value;return S.$hf(i,n)}return u._lower===r._lower}static toKey(u){return typeof u=="string"?u.toLowerCase():u._lower}}e.$um=f;class D{get size(){return this.c.size}constructor(u){if(this.c=new Set,u)for(const r of u)this.add(r)}add(u){this.c.add(f.toKey(u))}delete(u){return this.c.delete(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}}e.$vm=D;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(u){this.c.delete(f.toKey(u))}get(u){return this.c.get(f.toKey(u))}has(u){return this.c.has(f.toKey(u))}set(u,r){this.c.set(f.toKey(u),r)}values(){return this.c.values()}forEach(u){this.c.forEach(u)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$wm=A;function k(s){return h(s)}e.$xm=k;function h(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$ym=h;function v(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$zm=v;function p(s,u){if(u){const r=`onResolveRemoteAuthority:${(0,P.$kl)(u)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Am=p,e.$Bm=(0,F.$ci)("IBuiltinExtensionsScannerService")}),define(Fe[101],Le([1,0,15,22]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,g){this.a.set(R,g)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const g=Object.create(null);for(const f of R){const D=this.readActivationEvents(f);D.length>0&&(g[F.$um.toKey(f.identifier)]=D)}return g}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const g=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<g.length;f++)g[f]==="onUri"&&(g[f]=`onUri:${F.$um.toKey(R.identifier)}`);if(!R.contributes)return g;for(const f in R.contributes){const D=this.a.get(f);if(!D)continue;const A=R.contributes[f],k=Array.isArray(A)?A:[A];try{D(k,g)}catch(h){(0,S.$1)(h)}}return g}}e.$wF=P,e.$xF=new P}),define(Fe[192],Le([1,0,20,73,33]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=void 0;function L(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,D,A,k,h,v,p,s,u){const r=Object.create(null);r["common.machineId"]=v,r["common.sqmId"]=p,r.sessionID=(0,P.$yg)()+Date.now(),r.commitHash=k,r.version=h,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=F.$dc,r["common.nodeArch"]=A,r["common.product"]=u||"desktop",s&&(r["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const o=L(D);return o&&(r["common.platformDetail"]=o),r}e.$So=R;function g(f){const D=F.env.USERDNSDOMAIN;if(!D)return!1;const A=D.toLowerCase();return f.some(k=>A===k)}e.$To=g}),define(Fe[193],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=void 0,e.$Dl=(0,S.$ci)("telemetryService"),e.$El=(0,S.$ci)("customEndpointTelemetryService"),e.$Fl="telemetry.currentSessionDate",e.$Gl="telemetry.firstSessionDate",e.$Hl="telemetry.lastSessionDate",e.$Il="telemetry.machineId",e.$Jl="telemetry.sqmId",e.$Kl="telemetry",e.$Ll="telemetry.telemetryLevel",e.$Ml="telemetry.enableCrashReporter",e.$Nl="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var P;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Fe[57],Le([1,0,26,16,56,192,193]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=void 0;class g{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$Uo=g;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Vo=f,e.$Wo=new f;class D{async publicLog(m,a,c){}async publicLogError(m,a,c){}}e.$Xo=D,e.$Yo="telemetry",e.$Zo="extensionTelemetryLog",e.$1o={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!t.enableTelemetry)}e.$2o=A;function k(t,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$3o=k;function h(t){const m=t.getValue(R.$Ll),a=t.getValue(R.$Ml);if(t.getValue(R.$Nl)===!1||a===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$4o=h;function v(t){const m={},a={},c={};u(t,c);for(let E in c){E=E.length>150?E.substr(E.length-149):E;const y=c[E];typeof y=="number"?a[E]=y:typeof y=="boolean"?a[E]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${y.length}`),m[E]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(m[E]=y)}return{properties:m,measurements:a}}e.$5o=v;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const m=(0,P.$kl)(t);return p.has(m)?m:"other"}e.$6o=s;function u(t,m,a=0,c){if(t)for(const E of Object.getOwnPropertyNames(t)){const y=t[E],$=c?c+E:E;Array.isArray(y)?m[$]=(0,S.$Kn)(y):y instanceof Date?m[$]=y.toISOString():(0,F.$Sf)(y)?a<2?u(y,m,a+1,$+"."):m[$]=(0,S.$Kn)(y):m[$]=y}}function r(t,m){const a=t.msftInternalDomains||[],c=m.getValue("telemetry.internalTesting");return(0,L.$To)(a)||c}e.$7o=r;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$8o=i;function n(t,m){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let a=t;const c=[];for(const I of m)for(;;){const d=I.exec(t);if(!d)break;c.push([d.index,I.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(a="";;){const I=y.exec(t);if(!I)break;const d=c.some(([w,b])=>I.index<b&&w<y.lastIndex);!E.test(I[0])&&!d&&(a+=t.substring($,I.index)+"<REDACTED: user-file-path>",$=y.lastIndex)}return $<t.length&&(a+=t.substr($)),a}function o(t){if(!t)return t;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of m)if(a.regex.test(t))return`<REDACTED: ${a.label}>`;return t}function l(t,m){return(0,S.$Hn)(t,a=>{if(a instanceof g||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let c=a.replaceAll("%20"," ");c=n(c,m);for(const E of m)c=c.replace(E,"");return c=o(c),c}})}e.$9o=l}),define(Fe[194],Le([1,0,13,96,22,20,2,15,73,57]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0;function A(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,S.$cf)(a.id,c.id)===0}e.$0o=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(c){const E=c.manifest?c.manifest.version:c.version,y=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new h(c.identifier,E,y)}static parse(c){const E=k.exec(c);return E&&E[1]&&E[2]?new h({id:E[1]},E[2],E[4]||void 0):null}constructor(c,E,y="undefined"){this.version=E,this.targetPlatform=y,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof h?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$$o=h;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(a){const c=v.exec(a);return c&&c[1]?[u(c[1]),c[2]]:[u(a),void 0]}e.$_o=p;function s(a,c){return`${a}.${c}`}e.$ap=s;function u(a){return a.toLowerCase()}e.$bp=u;function r(a,c){return u(s(a??P.$qm,c))}e.$cp=r;function i(a,c){const E=[],y=$=>{for(const I of E)if(I.some(d=>A(c(d),c($))))return I;return null};for(const $ of a){const I=y($);I?I.push($):E.push([$])}return E}e.$dp=i;function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$ep=n;function o(a){return{id:new D.$Uo(a.identifier.id),name:new D.$Uo(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$fp=o,e.$gp=new P.$um("pprice.better-merge");function l(a,c){const E=[],y=c.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const $=y.shift();if($&&E.every(I=>!A(I.identifier,{id:$}))){const I=a.filter(d=>A(d.identifier,{id:$}));I.length===1&&(E.push(I[0]),y.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.$hp=l;async function t(a,c){if(!L.$k)return!1;let E;try{E=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){c.debug("Error while getting the os-release file.",(0,g.$0)($))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function m(a,c){const E=await t(a,c),y=(0,F.$Eo)(E?"alpine":L.$u,f.$ec);return c.debug("ComputeTargetPlatform:",y),y}e.$ip=m}),define(Fe[195],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0;function S(f){return[...f.entries()]}e.$Vr=S;function F(f){return f?[...f.entries()]:[]}e.$Wr=F;function P(f){return new Map(f)}e.$Xr=P;function L(f){return new Map(f??[])}e.$Yr=L;function R(f){return Array.from(f.entries()).map(D=>[D[0],S(D[1].map),F(D[1].descriptionMap)])}e.$Zr=R;function g(f){return new Map(f.map(D=>[D[0],{map:P(D[1]),descriptionMap:L(D[2])}]))}e.$1r=g}),define(Fe[196],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ftb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,L,R=5){const g=L(f=>{const D=typeof f=="string"?f:f.data;let A=this.a.get(P);if(A){A.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(P),R);A={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(P),g.dispose()}},this.a.set(P,A)});return g}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const L=this.a.get(P);L&&(this.a.delete(P),this.b(P,L.data.join("")))}}e.$ftb=S}),define(Fe[197],Le([1,0,11,89,40,5,16,2,156,72,30]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=e.$Mw=e.$Lw=e.$Kw=e.$Jw=e.$Iw=e.$Hw=e.$Gw=e.IconFontDefinition=e.IconContribution=e.$Fw=void 0,e.$Fw={IconContribution:"base.contributions.icons"};var k;(function(o){function l(t,m){let a=t.defaults;for(;P.ThemeIcon.isThemeIcon(a);){const c=p.getIcon(a.id);if(!c)return;a=c.defaults}return a}o.getDefinition=l})(k||(e.IconContribution=k={}));var h;(function(o){function l(m){return{weight:m.weight,style:m.style,src:m.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=l;function t(m){const a=c=>(0,R.$Qf)(c)?c:void 0;if(m&&Array.isArray(m.src)&&m.src.every(c=>(0,R.$Qf)(c.format)&&(0,R.$Qf)(c.location)))return{weight:a(m.weight),style:a(m.style),src:m.src.map(c=>({format:c.format,location:g.URI.parse(c.location)}))}}o.fromJSONObject=t})(h||(e.IconFontDefinition=h={}));class v{constructor(){this.a=new L.$3d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,t,m,a){const c=this.b[l];if(c){if(m&&!c.description){c.description=m,this.d.properties[l].markdownDescription=`${m} $(${l})`;const $=this.e.enum.indexOf(l);$!==-1&&(this.e.enumDescriptions[$]=m),this.a.fire()}return c}const E={id:l,description:m,defaults:t,deprecationMessage:a};this.b[l]=E;const y={$ref:"#/definitions/icons"};return a&&(y.deprecationMessage=a),m&&(y.markdownDescription=`${m}: $(${l})`),this.d.properties[l]=y,this.e.enum.push(l),this.e.enumDescriptions.push(m||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const t=this.e.enum.indexOf(l);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,t){const m=this.f[l];return m||(this.f[l]=t,this.a.fire(),t)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(c,E)=>c.id.localeCompare(E.id),t=c=>{for(;P.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},m=[];m.push("| preview     | identifier                        | default codicon ID                | description"),m.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(c=>this.b[c]);for(const c of a.filter(E=>!!E.description).sort(l))m.push(`|<i class="${t(c)}"></i>|${c.id}|${P.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);m.push("| preview     | identifier                        "),m.push("| ----------- | --------------------------------- |");for(const c of a.filter(E=>!P.ThemeIcon.isThemeIcon(E.defaults)).sort(l))m.push(`|<i class="${t(c)}"></i>|${c.id}|`);return m.join(`
`)}}const p=new v;A.$Rn.add(e.$Fw.IconContribution,p);function s(o,l,t,m){return p.registerIcon(o,l,t,m)}e.$Gw=s;function u(){return p}e.$Hw=u;function r(){const o=(0,F.$gk)();for(const l in o){const t="\\"+o[l].toString(16);p.registerIcon(l,{fontCharacter:t})}}r(),e.$Iw="vscode://schemas/icons";const i=A.$Rn.as(D.$Sn.JSONContribution);i.registerSchema(e.$Iw,p.getIconSchema());const n=new S.$oh(()=>i.notifySchemaChanged(e.$Iw),200);p.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Jw=s("widget-close",F.$ik.close,(0,f.localize)(2,null)),e.$Kw=s("goto-previous-location",F.$ik.arrowUp,(0,f.localize)(3,null)),e.$Lw=s("goto-next-location",F.$ik.arrowDown,(0,f.localize)(4,null)),e.$Mw=P.ThemeIcon.modify(F.$ik.sync,"spin"),e.$Nw=P.ThemeIcon.modify(F.$ik.loading,"spin")}),define(Fe[198],Le([1,0,5,2,47,4,14]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.ProvidedOnAutoForward=e.$Lv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Kv=e.$Jv=void 0,e.$Jv=(0,L.$ci)("tunnelService"),e.$Kv=(0,L.$ci)("sharedTunnelsService");var g;(function(r){r.Http="http",r.Https="https"})(g||(e.TunnelProtocol=g={}));var f;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(f||(e.TunnelPrivacyId=f={}));function D(r){return!!r.forwardPort}e.$Lv=D;var A;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function k(r,{checkQuery:i=!0}={}){if(r.scheme!=="http"&&r.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(n)return{address:n[1],port:+n[2]};if(!r.query||!i)return;const o=r.query.split("&");for(const l of o){const t=l.split("=")[1];if(/^https?:/.exec(t)){const m=k(F.URI.parse(t));if(m)return m}}}e.$Mv=k,e.$Nv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(r){return e.$Nv.indexOf(r)>=0}e.$Ov=h,e.$Pv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(r){return e.$Pv.indexOf(r)>=0}e.$Qv=v;function p(r,i,n,o){if(n===1)return!1;if(n===2&&v(i)){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(l?.length===4&&parseInt(l[1])>=18)return!1}return r<1024}e.$Rv=p;class s{constructor(i,n,o){this.remoteAddress=i,this.localAddress=n,this.b=o,this.a=new S.$3d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Sv=s;let u=class{constructor(i,n){this.k=i,this.l=n,this.a=new S.$3d,this.onTunnelOpened=this.a.event,this.b=new S.$3d,this.onTunnelClosed=this.b.event,this.c=new S.$3d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],n=Array.from(this.e.values());for(const o of n){const l=Array.from(o.values());for(const t of l){const m=await t.value;m&&typeof m!="string"&&i.push(m)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:n}of i.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,n,o,l,t){this.q(i,n,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:n,localAddress:o,privacy:l,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,n){(v(i)||h(i))&&(i=e.$Nv[0]);const o=this.s(i,n);if(o)return++o.refcount,o.value}openTunnel(i,n,o,l,t,m=!1,a,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${t}.`);const E=this.f??i;if(!E)return;if(n||(n="localhost"),l||(l=this.m),this.f&&this.j.has(o)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.t(E,n,o,l,t,m,a,c);return y?y.then($=>{if($){if(typeof $=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,o),$}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,o);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o($);return($.tunnelRemoteHost!==n||$.tunnelRemotePort!==o)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&$.privacy!==a&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const n=this.e.get(i.tunnelRemoteHost);if(n){const o=n.get(i.tunnelRemotePort);o&&(o.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,o))}}}}async p(i,n,o){if(o.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${n}.`);const l=o.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(n),l}}async closeTunnel(i,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${n} `);const o=this.e.get(i);if(o&&o.has(n)){const l=o.get(n);l.refcount=0,await this.p(i,n,l)}}q(i,n,o){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(n,{refcount:1,value:o})}async r(i,n){const o=this.e.get(i);if(o){const l=o.get(n),t=l?await l.value:void 0;(!t||typeof t=="string")&&o.delete(n),o.size===0&&this.e.delete(i)}}s(i,n){const o=[i];h(i)?(o.push(...e.$Nv),o.push(...e.$Pv)):v(i)&&o.push(...e.$Pv);const l=o.map(t=>this.e.get(t));for(const t of l){const m=t?.get(n);if(m)return m}}canTunnel(i){return!!k(i)}u(i,n,o,l,t,m,a){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${l}.`);const c=o;this.j.add(c);const E=l===void 0?o:l,y={elevationRequired:t?this.isPortPrivileged(E):!1},$={remoteAddress:{host:n,port:o},localAddressPort:l,privacy:m,public:m?m!==f.Private:void 0,protocol:a},I=i.forwardPort($,y);return I?(this.q(n,o,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),I}};e.$Tv=u,e.$Tv=u=Je([qe(0,R.$wj),qe(1,P.$Ii)],u)}),define(Fe[199],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Uv=void 0,e.$Uv=(0,S.$ci)("editSessionIdentityService");var F;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Fe[200],Le([1,0,12]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=void 0;function F(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$sL=F;function P(f){if(f.folders.length)return f.folders.every(D=>F(D.uri))?f.folders[0].uri:void 0;if(f.configuration&&F(f.configuration))return f.configuration}e.$tL=P;function L(f){return P(f)?.scheme}e.$uL=L;function R(f){return P(f)?.authority}e.$vL=R;function g(f){return P(f)!==void 0}e.$wL=g}),define(Fe[48],Le([1,0,157,19,51,25,2,4,12]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.WorkbenchState=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=void 0,e.$li=(0,g.$ci)("contextService");function D(c){const E=c;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.$mi=D;function A(c){return typeof c?.id=="string"&&!D(c)&&!h(c)}e.$ni=A,e.$oi={id:"ext-dev"},e.$pi={id:"empty-window"};function k(c,E){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,F.$nc)(c)}:E?e.$oi:e.$pi;const y=c;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}e.$qi=k;function h(c){const E=c;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.$ri=h;function v(c){const E=c;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const y=c;if(y?.configPath)return{id:y.id,configPath:R.URI.revive(y.configPath)};if(c?.id)return{id:c.id}}e.$si=v;var p;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function s(c){const E=c;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.$ti=s;function u(c){const E=c;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.$ui=u;class r{constructor(E,y,$,I,d){this.h=E,this.j=$,this.k=I,this.l=d,this.c=P.$ii.forUris(this.l,()=>!0),this.folders=y}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=P.$ii.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$vi=r;class i{constructor(E,y){this.raw=y,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,L.$Pg)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$wi=i;function n(c){return new i({uri:c,index:0,name:(0,L.$Lg)(c)},{uri:c.toString()})}e.$xi=n,e.$yi="code-workspace",e.$zi=`.${e.$yi}`,e.$Ai=[{name:(0,S.localize)(0,null),extensions:[e.$yi]}],e.$Bi="workspace.json";function o(c,E){return L.$Gg.isEqualOrParent(c,E.untitledWorkspacesHome)}e.$Ci=o;function l(c){let E;return R.URI.isUri(c)?E=c:E=c.configuration,E?.scheme===f.Schemas.tmp}e.$Di=l,e.$Ei="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$Ei}e.$Fi=t;function m(c,E){return!o(c,E)&&!l(c)}e.$Gi=m;function a(c){return(typeof c=="string"?(0,F.$oc)(c):(0,L.$Ng)(c))===e.$zi}e.$Hi=a}),define(Fe[74],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const L=this.c++;return this.b.set(L,P),this.e(),L}get(P,L){return this.b.has(P)?this.b.get(P)[L]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$4gc=S}),define(Fe[43],Le([1,0,12,25,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class L{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new F.$Eg(g=>{const f=this.b.get(g.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(g,f){f===null?this.b.delete(g.scheme):this.b.set(g.scheme,f)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$9gc=L,e.$0gc=(0,P.$ci)("IExtHostFileSystemInfo")}),define(Fe[27],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0,e.$qO=(0,S.$ci)("IExtHostInitDataService")}),define(Fe[201],Le([1,0,163,14,188,27]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=void 0;let R=class extends P.$xP{constructor(f,D,A){const k=A.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",h=A.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(D.createLogger(k,{name:h}))}};e.$bjc=R,e.$bjc=R=Je([qe(1,F.$xj),qe(2,L.$qO)],R)}),define(Fe[202],Le([1,0,11]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;class F{constructor(R,g,f){this.h=new Map,this.a=R,this.b=g,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new S.$oh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of D.values())A.complete()}catch(A){for(const k of D.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,g){let f=this.f[R];return typeof f>"u"&&(f=g),f}update(R,g){this.f[R]=g;const f=this.h.get(R);if(f!==void 0)return f.p;const D=new S.$zh;return this.h.set(R,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$Phc=F;class P extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,g){super(R.identifier.value,!0,g),this.j=R}}e.$Qhc=P}),define(Fe[203],Le([1,0,5,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class P{constructor(R){this.c=R,this.a=new S.$3d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$3d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,g,f,D){const k=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged(g.value,f,D);this.b.fire(k)}$acceptDirtyStateChanged(R,g){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty(g)}$acceptModelSaved(R){const g=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire(g.apiNotebook)}}e.$Dic=P}),define(Fe[17],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bO=e.$aO=void 0,e.$aO=(0,S.$ci)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$bO=F}),define(Fe[204],Le([1,0,22,5]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class P{#e;constructor(R,g){this.b=new F.$3d,this.onDidChange=this.b.event,this.a=S.$um.toKey(R.identifier),this.#e=g,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,g){return this.#e.store(this.a,R,g)}delete(R){return this.#e.delete(this.a,R)}}e.$Xhc=P}),define(Fe[58],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=e.$nhc=void 0,e.$nhc=(0,S.$ci)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$ohc=F}),define(Fe[205],Le([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmb=e.$Kmb=void 0;class F{constructor(){this.buffers=[]}add(f){let D=this.buffers.indexOf(f);return D<0&&(D=this.buffers.length,this.buffers.push(f)),D}}function P(g,f){if(f.serializeBuffersForPostMessage){const D=new F,k=JSON.stringify(g,(v,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(p)};if(ArrayBuffer.isView(p)){const s=L(p);if(s)return{$$vscode_array_buffer_reference$$:!0,index:D.add(p.buffer),view:{type:s,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),h=D.buffers.map(v=>{const p=new Uint8Array(v);return S.$qe.wrap(p)});return{message:k,buffers:h}}else return{message:JSON.stringify(g),buffers:[]}}e.$Kmb=P;function L(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(g,f){const D=f.map(h=>{const v=new ArrayBuffer(h.byteLength);return new Uint8Array(v).set(h.buffer),v}),A=f.length?(h,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const p=v,{index:s}=p,u=D[s];if(p.view)switch(p.view.type){case 1:return new Int8Array(u,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return v}:void 0;return{message:JSON.parse(g,A),arrayBuffers:D}}e.$Lmb=R}),define(Fe[102],Le([1,0,172,16,2,6,4,30,42,12,41,135,32]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dF=e.$cF=e.$bF=e.EditorsOrder=e.$aF=e.CloseDirection=e.$_E=e.$$E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.EditorInputCapabilities=e.$2E=e.SaveReason=e.Verbosity=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=void 0,e.$OE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$QE="workbench.editor.sidebysideEditor",e.$RE="workbench.editors.textDiffEditor",e.$SE="workbench.editors.binaryResourceDiffEditor";var v;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var p;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function s(te){const Y=te;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$TE=s;function u(te,Y,q){for(const ne of q.visibleEditorPanes)if(ne.group.id===Y&&te.matches(ne.input))return ne.getViewState()}e.$UE=u;function r(te){if($(te))return!1;const Y=te;return P.URI.isUri(Y?.resource)}e.$VE=r;function i(te){if($(te))return!1;const Y=te;return Y?.original!==void 0&&Y.modified!==void 0}e.$WE=i;function n(te){if($(te))return!1;const Y=te;return!Y||Y.resources&&!Array.isArray(Y.resources)?!1:!!Y.resources||!!Y.multiDiffSource}e.$XE=n;function o(te){if($(te)||i(te))return!1;const Y=te;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$YE=o;function l(te){if($(te))return!1;const Y=te;return Y?Y.resource===void 0||Y.resource.scheme===D.Schemas.untitled||Y.forceUntitled===!0:!1}e.$ZE=l;function t(te){if($(te))return!1;const Y=te;return P.URI.isUri(Y?.base?.resource)&&P.URI.isUri(Y?.input1?.resource)&&P.URI.isUri(Y?.input2?.resource)&&P.URI.isUri(Y?.result?.resource)}e.$1E=t;var m;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(m||(e.Verbosity=m={}));var a;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class c{constructor(){this.a=new Map}registerSource(Y,q){let ne=this.a.get(Y);return ne||(ne={source:Y,label:q},this.a.set(Y,ne)),ne.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$2E=new c;var E;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad",te[te.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(E||(e.EditorInputCapabilities=E={}));class y extends L.$Tc{}e.$3E=y;function $(te){return te instanceof y}e.$4E=$;function I(te){const Y=te;return P.URI.isUri(Y?.preferredResource)}function d(te){const Y=te;return $(Y?.primary)&&$(Y?.secondary)}e.$5E=d;function w(te){const Y=te;return $(Y?.modified)&&$(Y?.original)}e.$6E=w;function b(te,Y,q,ne,Pe){return $e(ne,[(0,k.$Yi)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Oe={...q,limits:{size:Number.MAX_VALUE}};te.openEditor(Y,Oe)}}),(0,k.$Yi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:h.default.Warning})}e.$7E=b;function M(te){return $(te?.editor)}e.$8E=M;function T(te){const Y=te;return M(te)&&Y?.group!==void 0}e.$9E=T;function G(te){const Y=te;return typeof Y?.groupId=="number"&&$(Y.editor)}e.$0E=G;var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_STICKY=11]="EDITOR_STICKY",te[te.EDITOR_DIRTY=12]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class O{getOriginalUri(Y,q){if(!Y)return;if(t(Y))return e.$_E.getOriginalUri(Y.result,q);if(q?.supportSideBySide){const{primary:Pe,secondary:Oe}=this.a(Y);if(Pe&&Oe){if(q?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Pe,{filterByScheme:q.filterByScheme}),secondary:this.getOriginalUri(Oe,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getOriginalUri(Pe,{filterByScheme:q.filterByScheme})??this.getOriginalUri(Oe,{filterByScheme:q.filterByScheme});Y=q.supportSideBySide===C.PRIMARY?Pe:Oe}}if(i(Y)||n(Y)||o(Y)||t(Y))return;const ne=I(Y)?Y.preferredResource:Y.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}a(Y){return d(Y)||o(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||i(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,q){if(!Y)return;if(t(Y))return e.$_E.getCanonicalUri(Y.result,q);if(q?.supportSideBySide){const{primary:Pe,secondary:Oe}=this.a(Y);if(Pe&&Oe){if(q?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Pe,{filterByScheme:q.filterByScheme}),secondary:this.getCanonicalUri(Oe,{filterByScheme:q.filterByScheme})};if(q?.supportSideBySide===C.ANY)return this.getCanonicalUri(Pe,{filterByScheme:q.filterByScheme})??this.getCanonicalUri(Oe,{filterByScheme:q.filterByScheme});Y=q.supportSideBySide===C.PRIMARY?Pe:Oe}}if(i(Y)||n(Y)||o(Y)||t(Y))return;const ne=Y.resource;return!ne||!q||!q.filterByScheme?ne:this.b(ne,q.filterByScheme)}b(Y,q){if(Array.isArray(q)){if(q.some(ne=>Y.scheme===ne))return Y}else if(q===Y.scheme)return Y}}var V;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(V||(e.EditorCloseMethod=V={}));function re(te,Y,q,ne){if(!te.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return q===V.MOUSE||q===V.KEYBOARD;case"mouse":return q===V.MOUSE;case"keyboard":return q===V.KEYBOARD}return!1}e.$$E=re,e.$_E=new O;var ce;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(Y){const q=this.a=Y.get(R.$bi);for(const[ne,Pe]of this.c)this.e(ne,Pe,q);this.c.clear()}e(Y,q,ne){const Pe=ne.createInstance(q);this.d.set(Y,Pe)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,F.$2f)(this.b)}registerEditorSerializer(Y,q){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,q,this.a):this.c.set(Y,q),(0,L.$Rc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}g.$Rn.add(e.$OE.EditorFactory,new ye);async function ke(te,Y,q){return!te||!te.length?[]:await Promise.all(te.map(async ne=>{const Pe=P.URI.revive(ne.fileUri);if(!Pe){q.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(Pe)){q.info("Cannot resolve the path because it cannot be handled",ne);return}let Re=ne.exists,be=ne.type;if(typeof Re!="boolean"||typeof be!="number")try{be=(await Y.stat(Pe)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Re=!0}catch(Q){q.error(Q),Re=!1}if(!Re&&ne.openOnlyIfExists){q.info("Cannot resolve the path because it does not exist",ne);return}if(be===f.FileType.Directory){q.info("Cannot resolve the path because it is a directory",ne);return}const me={...ne.options,pinned:!0};return Re?{resource:Pe,options:me}:{resource:Pe,options:me,forceUntitled:!0}}))}e.$aF=ke;var he;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ve(te){const Y=te;if(!Y)return!1;const q=Y;if(q.modified)return ve(q.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$bF=ve;function se(te){return(0,A.$1i)(te)}e.$cF=se;function $e(te,Y,q){const ne=(0,A.$2i)(te,Y);return ne.forceMessage=q?.forceMessage,ne.forceSeverity=q?.forceSeverity,ne.allowDialog=q?.allowDialog,ne}e.$dF=$e}),define(Fe[206],Le([1,0,5,173,4,6,28,30,18,26,89,197]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$jF=e.ViewContentGroups=e.$iF=e.$hF=e.ViewContainerLocation=e.Extensions=e.$gF=e.$fF=e.$eF=void 0,e.$eF="views",e.$fF=(0,F.localize)(0,null),e.$gF=(0,k.$Gw)("default-view-icon",A.$ik.window,(0,F.localize)(1,null));var h;(function(m){m.ViewContainersRegistry="workbench.registry.view.containers",m.ViewsRegistry="workbench.registry.view"})(h||(e.Extensions=h={}));var v;(function(m){m[m.Sidebar=0]="Sidebar",m[m.Panel=1]="Panel",m[m.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$hF=[0,1,2];function p(m){switch(m){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$iF=p;class s extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$3d),this.onDidRegister=this.c.event,this.f=this.B(new S.$3d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(a,c,E){const y=this.get(a.id);if(y)return y;const $=a;return $.openCommandActionDescriptor=E?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,c,[]).push($),E?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:c}),$}deregisterViewContainer(a){for(const c of this.g.keys()){const E=this.g.get(c),y=E?.indexOf(a);if(y!==-1){E?.splice(y,1),E.length===0&&this.g.delete(c),this.f.fire({viewContainer:a,viewContainerLocation:c});return}}}get(a){return this.all.filter(c=>c.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(E=>E?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(c=>this.getViewContainerLocation(c)===a)}}g.$Rn.add(h.ViewContainersRegistry,new s);var u;(function(m){m.Open="2_open",m.Debug="4_debug",m.SCM="5_scm",m.More="9_more"})(u||(e.ViewContentGroups=u={}));function r(m,a){const c=m.group??u.More,E=a.group??u.More;return c!==E?c.localeCompare(E):(m.order??5)-(a.order??5)}class i extends L.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$3d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$3d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$3d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$3d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(a,c){this.registerViews2([{views:a,viewContainer:c}])}registerViews2(a){a.forEach(({views:c,viewContainer:E})=>this.r(c,E)),this.c.fire(a)}deregisterViews(a,c){const E=this.s(a,c);E.length&&this.f.fire({views:E,viewContainer:c})}moveViews(a,c){for(const E of this.m.keys())if(E!==c){const y=this.s(a,E);y.length&&(this.r(y,c),this.g.fire({views:y,from:E,to:c}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const c of this.j){const E=(this.m.get(c)||[]).filter(y=>y.id===a)[0];if(E)return E}return null}getViewContainer(a){for(const c of this.j)if((this.m.get(c)||[]).filter(y=>y.id===a)[0])return c;return null}registerViewWelcomeContent(a,c){return this.n.add(a,c),this.h.fire(a),(0,L.$Rc)(()=>{this.n.delete(a,c),this.h.fire(a)})}registerViewWelcomeContent2(a,c){const E=new Map;for(const[y,$]of c)this.n.add(a,$),E.set(y,(0,L.$Rc)(()=>{this.n.delete(a,$),this.h.fire(a)}));return this.h.fire(a),E}getViewWelcomeContent(a){const c=[];return this.n.forEach(a,E=>c.push(E)),c.sort(r)}r(a,c){let E=this.m.get(c);E||(E=[],this.m.set(c,E),this.j.push(c));for(const y of a){if(this.getView(y.id)!==null)throw new Error((0,F.localize)(2,null,y.id));E.push(y)}}s(a,c){const E=this.m.get(c);if(!E)return[];const y=[],$=[];for(const I of E)a.includes(I)?y.push(I):$.push(I);return y.length&&($.length?this.m.set(c,$):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),y}}g.$Rn.add(h.ViewsRegistry,new i),e.$jF=(0,P.$ci)("viewDescriptorService");var n;(function(m){m[m.Default=0]="Default",m[m.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(m){m[m.None=0]="None",m[m.Collapsed=1]="Collapsed",m[m.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(a,c){this.c=!1,this.d=!1,(0,D.$In)(this,a),this.d=!!c,this.resolve=async E=>{if(c&&!this.c){const y=await c(E);y&&(this.tooltip=this.tooltip??y.tooltip,this.command=this.command??y.command)}E.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$kF=l;class t extends Error{constructor(a){super((0,F.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$lF=t}),define(Fe[207],Le([1,0,2,29,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$tF=e.$sF=void 0;function L(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof S.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(F.$4s.isIRange)}e.$sF=L;function R(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(L)}e.$tF=R;var g;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var f;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(f||(e.ChatAgentCopyKind=f={})),e.$uF=(0,P.$ci)("IChatService"),e.$vF="accessibility.voice.keywordActivation"}),define(Fe[208],Le([1,0,5,11,174]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enb=void 0;class L{constructor(){this.f=new Map,this.m=[],this.n=new S.$3d,this.o=new S.$3d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(g){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=g}onEvent(g){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=g}onRequest(g){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.u("response",g)}sendRequest(g,f,D,A){const k={command:g};if(f&&Object.keys(f).length>0&&(k.arguments=f),this.u("request",k),typeof A=="number"){const h=setTimeout(()=>{clearTimeout(h);const v=this.f.get(k.seq);if(v){this.f.delete(k.seq);const p={type:"response",seq:0,request_seq:k.seq,success:!1,command:g,message:(0,P.localize)(0,null,A,g)};v(p)}},A)}return D&&this.f.set(k.seq,D),k.seq}acceptMessage(g){this.k?this.k(g):(this.m.push(g),this.m.length===1&&this.s())}q(g,f){return g.type!=="event"||f.type!=="event"}async s(){let g;for(;this.m.length;){if((!g||this.q(this.m[0],g))&&await(0,F.$dh)(0),g=this.m.shift(),!g)return;switch(g.type){case"event":this.j?.(g);break;case"request":this.g?.(g);break;case"response":{const f=g,D=this.f.get(f.request_seq);D&&(this.f.delete(f.request_seq),D(f));break}}}}u(g,f){f.type=g,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((f,D)=>g.set(D,f)),await(0,F.$dh)(500),g.forEach((f,D)=>{f({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$enb=L}),define(Fe[209],Le([1,0,2,175,35,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$tI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$sI=e.MemoryRangeType=e.$rI=e.State=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=void 0,e.$iH="workbench.view.debug",e.$jH="workbench.debug.variablesView",e.$kH="workbench.debug.watchExpressionsView",e.$lH="workbench.debug.callStackView",e.$mH="workbench.debug.loadedScriptsView",e.$nH="workbench.debug.breakPointsView",e.$oH="workbench.debug.disassemblyView",e.$pH="workbench.panel.repl",e.$qH="workbench.panel.repl.view",e.$rH=new P.$tj("debugType",void 0,{type:"string",description:F.localize(0,null)}),e.$sH=new P.$tj("debugConfigurationType",void 0,{type:"string",description:F.localize(1,null)}),e.$tH=new P.$tj("debugState","inactive",{type:"string",description:F.localize(2,null)}),e.$uH="debugUx",e.$vH=new P.$tj(e.$uH,"default",{type:"string",description:F.localize(3,null)}),e.$wH=new P.$tj("hasDebugged",!1,{type:"boolean",description:F.localize(4,null)}),e.$xH=new P.$tj("inDebugMode",!1,{type:"boolean",description:F.localize(5,null)}),e.$yH=new P.$tj("inDebugRepl",!1,{type:"boolean",description:F.localize(6,null)}),e.$zH=new P.$tj("breakpointWidgetVisible",!1,{type:"boolean",description:F.localize(7,null)}),e.$AH=new P.$tj("inBreakpointWidget",!1,{type:"boolean",description:F.localize(8,null)}),e.$BH=new P.$tj("breakpointsFocused",!0,{type:"boolean",description:F.localize(9,null)}),e.$CH=new P.$tj("watchExpressionsFocused",!0,{type:"boolean",description:F.localize(10,null)}),e.$DH=new P.$tj("watchExpressionsExist",!1,{type:"boolean",description:F.localize(11,null)}),e.$EH=new P.$tj("variablesFocused",!0,{type:"boolean",description:F.localize(12,null)}),e.$FH=new P.$tj("expressionSelected",!1,{type:"boolean",description:F.localize(13,null)}),e.$GH=new P.$tj("breakpointInputFocused",!1,{type:"boolean",description:F.localize(14,null)}),e.$HH=new P.$tj("callStackItemType",void 0,{type:"string",description:F.localize(15,null)}),e.$IH=new P.$tj("callStackSessionIsAttach",!1,{type:"boolean",description:F.localize(16,null)}),e.$JH=new P.$tj("callStackItemStopped",!1,{type:"boolean",description:F.localize(17,null)}),e.$KH=new P.$tj("callStackSessionHasOneThread",!1,{type:"boolean",description:F.localize(18,null)}),e.$LH=new P.$tj("watchItemType",void 0,{type:"string",description:F.localize(19,null)}),e.$MH=new P.$tj("canViewMemory",void 0,{type:"boolean",description:F.localize(20,null)}),e.$NH=new P.$tj("breakpointItemType",void 0,{type:"string",description:F.localize(21,null)}),e.$OH=new P.$tj("breakpointHasModes",!1,{type:"boolean",description:F.localize(22,null)}),e.$PH=new P.$tj("breakpointSupportsCondition",!1,{type:"boolean",description:F.localize(23,null)}),e.$QH=new P.$tj("loadedScriptsSupported",!1,{type:"boolean",description:F.localize(24,null)}),e.$RH=new P.$tj("loadedScriptsItemType",void 0,{type:"string",description:F.localize(25,null)}),e.$SH=new P.$tj("focusedSessionIsAttach",!1,{type:"boolean",description:F.localize(26,null)}),e.$TH=new P.$tj("focusedSessionIsNoDebug",!1,{type:"boolean",description:F.localize(27,null)}),e.$UH=new P.$tj("stepBackSupported",!1,{type:"boolean",description:F.localize(28,null)}),e.$VH=new P.$tj("restartFrameSupported",!1,{type:"boolean",description:F.localize(29,null)}),e.$WH=new P.$tj("stackFrameSupportsRestart",!1,{type:"boolean",description:F.localize(30,null)}),e.$XH=new P.$tj("jumpToCursorSupported",!1,{type:"boolean",description:F.localize(31,null)}),e.$YH=new P.$tj("stepIntoTargetsSupported",!1,{type:"boolean",description:F.localize(32,null)}),e.$ZH=new P.$tj("breakpointsExist",!1,{type:"boolean",description:F.localize(33,null)}),e.$1H=new P.$tj("debuggersAvailable",!1,{type:"boolean",description:F.localize(34,null)}),e.$2H=new P.$tj("debugExtensionAvailable",!0,{type:"boolean",description:F.localize(35,null)}),e.$3H=new P.$tj("debugProtocolVariableMenuContext",void 0,{type:"string",description:F.localize(36,null)}),e.$4H=new P.$tj("debugSetVariableSupported",!1,{type:"boolean",description:F.localize(37,null)}),e.$5H=new P.$tj("debugSetExpressionSupported",!1,{type:"boolean",description:F.localize(38,null)}),e.$6H=new P.$tj("breakWhenValueChangesSupported",!1,{type:"boolean",description:F.localize(39,null)}),e.$7H=new P.$tj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:F.localize(40,null)}),e.$8H=new P.$tj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:F.localize(41,null)}),e.$9H=new P.$tj("terminateDebuggeeSupported",!1,{type:"boolean",description:F.localize(42,null)}),e.$0H=new P.$tj("suspendDebuggeeSupported",!1,{type:"boolean",description:F.localize(43,null)}),e.$$H=new P.$tj("variableEvaluateNamePresent",!1,{type:"boolean",description:F.localize(44,null)}),e.$_H=new P.$tj("variableIsReadonly",!1,{type:"boolean",description:F.localize(45,null)}),e.$aI=new P.$tj("variableValue",!1,{type:"string",description:F.localize(46,null)}),e.$bI=new P.$tj("variableType",!1,{type:"string",description:F.localize(47,null)}),e.$cI=new P.$tj("variableName",!1,{type:"string",description:F.localize(48,null)}),e.$dI=new P.$tj("variableLanguage",!1,{type:"string",description:F.localize(49,null)}),e.$eI=new P.$tj("variableExtensionId",!1,{type:"string",description:F.localize(50,null)}),e.$fI=new P.$tj("exceptionWidgetVisible",!1,{type:"boolean",description:F.localize(51,null)}),e.$gI=new P.$tj("multiSessionRepl",!1,{type:"boolean",description:F.localize(52,null)}),e.$hI=new P.$tj("multiSessionDebug",!1,{type:"boolean",description:F.localize(53,null)}),e.$iI=new P.$tj("disassembleRequestSupported",!1,{type:"boolean",description:F.localize(54,null)}),e.$jI=new P.$tj("disassemblyViewFocus",!1,{type:"boolean",description:F.localize(55,null)}),e.$kI=new P.$tj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:F.localize(56,null)}),e.$lI=new P.$tj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:F.localize(57,null)});const R=r=>F.localize(58,null,r);e.$mI=R,e.$nI="editor.contrib.debug",e.$oI="editor.contrib.breakpoint",e.$pI="debug",e.$qI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:F.localize(59,null)};var g;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(g||(e.State=g={}));function f(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$rI=f;var D;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$sI="vscode-debug-memory";var A;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var k;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$tI=(0,L.$ci)("debugService");var h;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var v;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var p;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(p||(e.DebugTreeItemCollapsibleState=p={}));var s;(function(r){r.deserialize=i=>i,r.serialize=i=>i})(s||(e.IDebugVisualizationTreeItem=s={}));var u;(function(r){r.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:S.URI.revive(i.iconPath.light),dark:S.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),r.serialize=i=>i})(u||(e.IDebugVisualization=u={}))}),define(Fe[210],Le([1,0,13,2,19,26,12,29,21,18]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0;const A=/{([^}]+)}/g;function k(I,d,w){return I.replace(A,function(b,M){return d&&M.length>0&&M[0]!=="_"?b:w&&w.hasOwnProperty(M)?w[M]:b})}e.$kG=k;function h(I){const d={};for(const w of Object.keys(I))w.startsWith("!")||(d[w]=I[w]);return d}e.$lG=h;function v(I){return I.configuration.request==="attach"&&!p(I)&&(!I.parentSession||v(I.parentSession))}e.$mG=v;function p(I){let d=I.configuration.type;if(d)return d==="vslsShare"&&(d=I.configuration.adapterProxy.configuration.type),(0,S.$hf)(d,"extensionhost")||(0,S.$hf)(d,"pwa-extensionhost")?I:I.parentSession?p(I.parentSession):void 0}e.$nG=p;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$oG=s;function u(I,d,w){let b,M=0;const T=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let G=null;for(;G=T.exec(I);){const W=G.index+1,U=W+G[0].length;if(W<=d&&U>=w){b=G[0],M=W;break}}if(b){const W=/\w+/g;let U=null;for(;(U=W.exec(b))&&!(U.index+1+M+U[0].length>=w););U&&(b=b.substring(0,W.lastIndex))}return b?{start:M,end:M+b.length-1}:{start:0,end:0}}e.$pG=u;async function r(I,d,w,b){if(I.evaluatableExpressionProvider.has(d)){const M=I.evaluatableExpressionProvider.ordered(d),T=(0,D.$Hb)(await Promise.all(M.map(async G=>{try{return await G.provideEvaluatableExpression(d,w,b??f.CancellationToken.None)}catch{return}})));if(T.length>0){let G=T[0].expression;const W=T[0].range;return G||(G=d.getLineContent(w.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:G}}}else{const M=d.getLineContent(w.lineNumber),{start:T,end:G}=u(M,w.column,w.column),W=M.substring(T-1,G);return{matchingExpression:W,range:new g.$4s(w.lineNumber,T,w.lineNumber,T+W.length)}}return null}e.$qG=r;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}e.$rG=n;function o(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return F.URI.parse(I.path);if((0,P.$ic)(I.path))return F.URI.file(I.path)}return I.path}function l(I){if(typeof I.path=="object"){const d=F.URI.revive(I.path);if(d)return d.scheme===R.Schemas.file?d.fsPath:d.toString()}return I.path}function t(I,d){const w=d?o:l,b=(0,L.$Fn)(I);return a(b,(M,T)=>{M&&T&&(T.path=w(T))}),b}e.$sG=t;function m(I,d){const w=d?o:l,b=(0,L.$Fn)(I);return a(b,(M,T)=>{!M&&T&&(T.path=w(T))}),b}e.$tG=m;function a(I,d){switch(I.type){case"event":{const w=I;switch(w.event){case"output":d(!1,w.body.source);break;case"loadedSource":d(!1,w.body.source);break;case"breakpoint":d(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=I;switch(w.command){case"setBreakpoints":d(!0,w.arguments.source);break;case"breakpointLocations":d(!0,w.arguments.source);break;case"source":d(!0,w.arguments.source);break;case"gotoTargets":d(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(b=>d(!1,b));break;default:break}break}case"response":{const w=I;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(b=>d(!1,b.source));break;case"loadedSources":w.body.sources.forEach(b=>d(!1,b));break;case"scopes":w.body.scopes.forEach(b=>d(!1,b.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"setBreakpoints":w.body.breakpoints.forEach(b=>d(!1,b.source));break;case"disassemble":w.body?.instructions.forEach(M=>d(!1,M.location));break;default:break}break}}}function c(I){return I.filter(d=>!d.presentation?.hidden).sort((d,w)=>d.presentation?w.presentation?d.presentation.group?w.presentation.group?d.presentation.group!==w.presentation.group?d.presentation.group.localeCompare(w.presentation.group):E(d.presentation.order,w.presentation.order):-1:w.presentation.group?1:E(d.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$uG=c;function E(I,d){return typeof I!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:I-d}async function y(I,d){const w=I.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(w!=="none"&&(await d.saveAll(),w==="allEditorsInActiveGroup")){const b=d.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await d.save({editor:b.input,groupId:b.group.id})}await I.reloadConfiguration()}e.$vG=y;const $=(I,d)=>!I||!d?I===d:I.name===d.name&&I.path===d.path&&I.sourceReference===d.sourceReference;e.$wG=$}),define(Fe[211],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.CellExecutionUpdateType=void 0;var F;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$2J=(0,S.$ci)("INotebookExecutionService")}),define(Fe[212],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agb=e.$zgb=e.ProxyKernelState=e.$ygb=void 0,e.$ygb=100;var F;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(F||(e.ProxyKernelState=F={})),e.$zgb=(0,S.$ci)("INotebookKernelService"),e.$Agb=(0,S.$ci)("INotebookKernelHistoryService")}),define(Fe[213],Le([1,0,6,29,145,93]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ASb=void 0;class R extends S.$Tc{constructor(f,D,A){super(),this._source=f,this.b=D,this.c=A,this.a=void 0}f(f){const D=f.getLineCount();return new F.$4s(1,1,D,this.g(f,D))}g(f,D){if(D<1||D>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const f=new P.$lC;f.acceptChunk(this._source);const D=f.finish(!0),{textBuffer:A,disposable:k}=D.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const D=new P.$lC;D.acceptChunk(f);const A=D.finish(!0),{textBuffer:k,disposable:h}=A.create(1);return this.B(h),k})),this.a}findInInputs(f){const A=new L.$_B(f,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(f){const A=new L.$_B(f,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const h=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(h.length!==0)return{textBuffer:k,matches:h}}).filter(k=>!!k):[]}}e.$ASb=R}),define(Fe[49],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(L){L.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class P{static fromExtHostTestItem(R,g,f=R.parent){if(R._isRoot)return new P([g]);const D=[R.id];for(let A=f;A&&A.id!==g;A=A.parent)D.push(A.id);return D.push(g),new P(D.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const g=R.indexOf("\0");return g===-1?R:R.slice(0,g)}static fromString(R){return new P(R.split("\0"))}static join(R,g){return new P([...R.path,g])}static joinToString(R,g){return R.toString()+"\0"+g}static parentId(R){const g=R.lastIndexOf("\0");return g===-1?void 0:R.slice(0,g)}static localId(R){const g=R.lastIndexOf("\0");return g===-1?R:R.slice(g+1)}static isChild(R,g){return g.startsWith(R)&&g[R.length]==="\0"}static compare(R,g){return R===g?0:P.isChild(R,g)?2:P.isChild(g,R)?3:1}constructor(R,g=R.length){if(this.path=R,this.d=g,R.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let g=0;g<R.d&&g<this.d;g++)if(R.path[g]!==this.path[g])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$MK=P}),define(Fe[59],Le([1,0,2,91,29,49]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$TK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$SK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$RK=e.$QK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$PK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$OK=e.$NK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var g;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(g||(e.ExtTestRunProfileKind=g={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$NK=[2,4,8,16,32,64];const D=C=>"runId"in C;e.$OK=D;var A;(function(C){C.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({range:P.$4s.lift(V.range),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(A||(e.IRichLocation=A={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var h;(function(C){C.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&A.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:0,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&A.deserialize(O,V.location)})})(h||(e.ITestErrorMessage=h={}));const v=(C,O)=>`${O?"s":"e"}${C}`;e.$PK=v;var p;(function(C){C.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&A.serialize(O.location)}),C.deserialize=(O,V)=>({message:V.message,type:1,offset:V.offset,length:V.length,location:V.location&&A.deserialize(O,V.location)})})(p||(e.ITestOutputMessage=p={}));var s;(function(C){C.serialize=O=>O.type===0?h.serialize(O):p.serialize(O),C.deserialize=(O,V)=>V.type===0?h.deserialize(O,V):p.deserialize(O,V)})(s||(e.ITestMessage=s={}));var u;(function(C){C.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),C.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(s.serialize)}),C.deserialize=(O,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(re=>s.deserialize(O,re))})})(u||(e.ITestTaskState=u={}));const r="\0",i=(C,O)=>C+r+O;e.$QK=i;const n=C=>{const O=C.indexOf(r);return{ctrlId:C.slice(0,O),tagId:C.slice(O+1)}};e.$RK=n;var o;(function(C){C.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),C.deserialize=(O,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?O.asCanonicalUri(S.URI.revive(V.uri)):void 0,range:V.range?P.$4s.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(o||(e.ITestItem=o={}));var l;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(C){C.serialize=O=>({expand:O.expand,item:o.serialize(O.item)}),C.deserialize=(O,V)=>({controllerId:L.$MK.root(V.item.extId),expand:V.expand,item:o.deserialize(O,V.item)})})(t||(e.InternalTestItem=t={}));var m;(function(C){C.serialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.uri!==void 0&&(V.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(V.range=O.item.range?.toJSON()),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}},C.deserialize=O=>{let V;return O.item&&(V={},O.item.label!==void 0&&(V.label=O.item.label),O.item.tags!==void 0&&(V.tags=O.item.tags),O.item.busy!==void 0&&(V.busy=O.item.busy),O.item.range!==void 0&&(V.range=O.item.range?P.$4s.lift(O.item.range):null),O.item.description!==void 0&&(V.description=O.item.description),O.item.error!==void 0&&(V.error=O.item.error),O.item.sortText!==void 0&&(V.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:V}}})(m||(e.ITestItemUpdate=m={}));const a=(C,O)=>{O.expand!==void 0&&(C.expand=O.expand),O.item!==void 0&&(C.item=C.item?Object.assign(C.item,O.item):O.item)};e.$SK=a;var c;(function(C){C.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(u.serializeWithoutMessages)}),C.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(u.serialize)}),C.deserialize=(O,V)=>({...t.deserialize(O,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(re=>u.deserialize(O,re)),retired:!0})})(c||(e.TestResultItem=c={}));var E;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(O,V)=>{O.covered+=V.covered,O.total+=V.total}})(E||(e.ICoveredCount=E={}));var y;(function(C){C.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(w.serialize),uri:O.uri.toJSON()}),C.deserialize=(O,V)=>({statement:V.statement,branch:V.branch,declaration:V.declaration,details:V.details?.map(w.deserialize),uri:O.asCanonicalUri(S.URI.revive(V.uri))})})(y||(e.IFileCoverage=y={}));function $(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?F.$3s.isIPosition(C.location)?F.$3s.lift(C.location):P.$4s.lift(C.location):void 0,C}e.$TK=3;var d;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(d||(e.DetailType=d={}));var w;(function(C){C.serialize=O=>O.type===0?M.serialize(O):T.serialize(O),C.deserialize=O=>O.type===0?M.deserialize(O):T.deserialize(O)})(w||(e.CoverageDetails=w={}));var b;(function(C){C.serialize=$,C.deserialize=I})(b||(e.IBranchCoverage=b={}));var M;(function(C){C.serialize=$,C.deserialize=I})(M||(e.IDeclarationCoverage=M={}));var T;(function(C){C.serialize=O=>({...$(O),branches:O.branches?.map(b.serialize)}),C.deserialize=O=>({...I(O),branches:O.branches?.map(b.deserialize)})})(T||(e.IStatementCoverage=T={}));var G;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(G||(e.TestDiffOpType=G={}));var W;(function(C){C.deserialize=(O,V)=>V.op===0?{op:V.op,item:t.deserialize(O,V.item)}:V.op===1?{op:V.op,item:m.deserialize(V.item)}:V.op===2?{op:V.op,uri:O.asCanonicalUri(S.URI.revive(V.uri)),docv:V.docv}:V,C.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:m.serialize(O.item)}:O})(W||(e.TestsDiffOp=W={}));class U{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const V=this.v();for(const re of O)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),V);break;case 1:this.o(m.deserialize(re.item),V);break;case 3:this.p(re.itemId,V);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}V.complete?.()}l(O,V){const re=L.$MK.parentId(O.item.extId)?.toString();let ce;if(!re)ce=this.w(O),this.g.add(ce),this.f.set(O.item.extId,ce);else if(this.f.has(re)){const ye=this.f.get(re);ye.children.add(O.item.extId),ce=this.w(O,ye),this.f.set(O.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return V.add?.(ce),O.expand===2&&this.h++,ce}o(O,V){const re=this.f.get(O.extId);if(re)return O.expand!==void 0&&(re.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$SK)(re,O),V.update?.(re),re}p(O,V){const re=this.f.get(O);if(!re)return;const ce=L.$MK.parentId(re.item.extId)?.toString();ce?this.f.get(ce).children.delete(re.item.extId):this.g.delete(re);const ye=[[O]];for(;ye.length;)for(const ke of ye.pop()){const he=this.f.get(ke);he&&(ye.push(he.children),this.f.delete(ke),V.remove?.(he,he!==re),he.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$UK=U}),define(Fe[75],Le([1,0,11,5,6,54,59,49]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.TestItemEventOp=void 0;var f;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const D=(i,n)=>i===n,k=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:D,label:D,description:D,error:D,sortText:D,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),h=(i,n)=>{let o;for(const[l,t]of k)t(i[l],n[l])||(o?o[l]=n[l]:o={[l]:n[l]});return o};class v extends P.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$oh(()=>this.flushDiff(),200)),this.g=this.B(new F.$3d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,R.$SK)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,R.$SK)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const l=this.tree.get(n);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const t=this.M(l);return t.isOpen()?this.L(l,o-1):t.wait().then(()=>this.L(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,o-1)):this.L(l,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case 3:this.O(g.$MK.joinToString(n.fullId,o.id));break;case 0:this.z(o.item,n);break;case 5:for(const l of o.ops)this.w(n,l);break;case 1:this.C(o.new,o.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.y(n.actual.uri);break;default:(0,L.$9c)(o)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const l=g.$MK.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let m=this.tree.get(l.toString());if(!m){m={fullId:l,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(m.fullId.toString(),m),this.G(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:m.expand,item:this.s.toITestItem(n)}}),this.I(n,m,o);return}if(m.actual===n){this.H(n,m,o);return}if(m.actual.uri?.toString()!==n.uri?.toString())return this.O(l.toString()),this.z(n,o);const a=this.s.getChildren(m.actual),c=m.actual,E=h(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,m.actual=n,m.expand=0,E&&(E.hasOwnProperty("tags")&&(this.C(n.tags,c.tags,l.toString()),delete E.tags),this.w(m,{op:4,update:E})),this.I(n,m,o);for(const[y,$]of a)this.s.getChildren(n).get($.id)||this.O(g.$MK.joinToString(l,$.id));this.y(m.actual.uri)}C(n,o,l){const t=new Set(o.map(m=>m.id));for(const m of n)t.delete(m.id)||this.D(m);this.pushDiff({op:1,item:{extId:l,item:{tags:n.map(m=>(0,R.$QK)(this.s.controllerId,m.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$QK)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$QK)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,l){this.G(n,l);const t=this.s.getApiFor(n);t.parent=l?.actual,t.listener=m=>this.w(o,m),this.J(o)}I(n,o,l){this.H(n,o,l);for(const[t,m]of this.s.getChildren(n))this.z(m,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const l=[];for(const[t,m]of this.s.getChildren(n.actual)){const a=this.expand(g.$MK.joinToString(n.fullId,m.id),o);(0,S.$1g)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const m=new S.$bh;return m.open(),m}n.expand=2,this.N(n);const o=n.resolveBarrier=new S.$bh,l=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,m)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(m){l(m)}return(0,S.$1g)(t)?t.catch(l).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const l=[o];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const m of t.actual.tags)this.F(m.id);this.tree.delete(t.fullId.toString());for(const[m,a]of this.s.getChildren(t.actual))l.push(this.tree.get(g.$MK.joinToString(t.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$3N=v;class p extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$4N=p;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$5N=s;class u extends Error{constructor(n,o,l){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$6N=u;const r=(i,n,o)=>{let l=new Map;return{get size(){return l.size},forEach(t,m){for(const a of l.values())t.call(m,a,this)},[Symbol.iterator](){return l.entries()},replace(t){const m=new Map,a=new Set(l.keys()),c={op:5,ops:[]};for(const E of t){if(!(E instanceof o))throw new s(E.id);const y=n(E).controllerId;if(y!==i.controllerId)throw new u(E.id,y,i.controllerId);if(m.has(E.id))throw new p(E.id);m.set(E.id,E),a.delete(E.id),c.ops.push({op:0,item:E})}for(const E of a.keys())c.ops.push({op:3,id:E});i.listener?.(c),l=m},add(t){if(!(t instanceof o))throw new s(t.id);l.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){l.delete(t)&&i.listener?.({op:3,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$7N=r}),define(Fe[103],Le([1,0,75]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=e.$8N=void 0;const F=new WeakMap,P=(R,g)=>{const f={controllerId:g};return F.set(R,f),f};e.$8N=P;const L=R=>{const g=F.get(R);if(!g)throw new S.$5N(R?.id||"<unknown>");return g};e.$9N=L}),define(Fe[76],Le([1,0,12,2]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9wb=e.$8wb=e.$7wb=e.$6wb=e.$5wb=void 0,e.$5wb="vscode-cdn.net",e.$6wb=`vscode-resource.${e.$5wb}`,e.$7wb=`'self' https://*.${e.$5wb}`;function P(g,f){return g.scheme===S.Schemas.http||g.scheme===S.Schemas.https?g:(f&&f.authority&&f.isRemote&&g.scheme===S.Schemas.file&&(g=F.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:g.path})),F.URI.from({scheme:S.Schemas.https,authority:`${g.scheme}+${L(g.authority)}.${e.$6wb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$8wb=P;function L(g){return g.replace(/./g,f=>{const D=f.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?f:"-"+D.toString(16).padStart(4,"0")})}function R(g){return g.replace(/-([0-9a-f]{4})/g,(f,D)=>String.fromCharCode(parseInt(D,16)))}e.$9wb=R}),define(Fe[214],Le([1,0,5,6,76]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lhc=void 0;class L{constructor(g,f,D){this.d=g,this.e=f,this.f=D,this.a=0,this.b=new F.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const A=f.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,f,D,A,k){let h;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===g){h=n;break}if(!h)throw new Error("not a visible editor");const v=this,p=this.a++,s=new S.$3d,u=new S.$3d,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$8wb)(n,v.f)}get cspSource(){return P.$7wb}set options(n){this.b=n,v.d.$setOptions(p,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(p,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return v.d.$postMessage(p,n)}},i=new class{constructor(){this.editor=g,this.line=f,this.height=D,this.webview=r,this.onDidDispose=u.event}dispose(){v.c.has(p)&&(v.c.delete(p),v.d.$disposeEditorInset(p),u.fire(),u.dispose(),s.dispose())}};return this.d.$createEditorInset(p,h.id,h.value.document.uri,f+1,D,A||{},k.identifier,k.extensionLocation),this.c.set(p,{editor:g,inset:i,onDidReceiveMessage:s}),i}$onDidDispose(g){const f=this.c.get(g);f&&f.inset.dispose()}$onDidReceiveMessage(g,f){this.c.get(g)?.onDidReceiveMessage.fire(f)}}e.$lhc=L}),define(Fe[104],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.$2K=void 0,e.$2K="__",e.$3K=(0,S.$ci)("IAuthenticationService")}),define(Fe[215],Le([1,0,4]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZO=e.VariableKind=e.$YO=void 0,e.$YO=(0,S.$ci)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator",L.PathSeparatorAlias="/"})(F||(e.VariableKind=F={}));class P extends Error{constructor(R,g){super(g),this.variable=R}}e.$ZO=P}),define(Fe[216],Le([1,0,19,73,16,26,20,94,178,215,13]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bP=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,p,s,u){this.h=new Map,this.a=v,this.b=p,this.g=s,u&&(this.c=u.then(r=>this.i(r)))}i(v){if(R.$i){const p=Object.create(null);return Object.keys(v).forEach(s=>{p[s.toLowerCase()]=v[s]}),p}return v}resolveWithEnvironment(v,p,s){return this.l({env:this.i(v),userHome:void 0},p?p.uri:void 0,s)}async resolveAsync(v,p){const s={env:await this.c,userHome:await this.g};return this.l(s,v?v.uri:void 0,p)}async j(v,p,s,u){const r=L.$Fn(p);R.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):R.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):R.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,r,s,u)}async resolveAnyAsync(v,p,s){return this.j(v,p,s)}async resolveAnyMap(v,p,s){const u=new Map;return{newConfig:await this.j(v,p,s,u),resolvedVariables:u}}resolveWithInteractionReplace(v,p,s,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,p,s,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,p){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,p)}async l(v,p,s,u,r){if(P.$Qf(s))return this.m(v,p,s,u,r);if(Array.isArray(s))return Promise.all(s.map(i=>this.l(v,p,i,u,r)));if(P.$Sf(s)){const i=Object.create(null),n=await Promise.all(Object.keys(s).map(async o=>[await this.m(v,p,o,u,r),await this.l(v,p,s[o],u,r)]));for(const[o,l]of n)i[o]=l;return i}return s}m(v,p,s,u,r){return(0,A.$_e)(s,k.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(k.VARIABLE_LHS))return i;let o=await this.o(v,i,n,p,u);return r?.set(n,o),o!==i&&P.$Qf(o)&&o.match(k.VARIABLE_REGEXP)&&(o=await this.m(v,p,o,u,r)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,p,s,u,r){let i;const n=s.split(":");n.length>1&&(s=n[0],i=n[1]);const o=m=>{const a=this.a.getFilePath();if(a)return(0,g.$6v)(a);throw new D.$ZO(m,(0,f.localize)(0,null,p))},l=m=>{const a=o(m);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,g.$6v)(c)}throw new D.$ZO(m,(0,f.localize)(1,null,p,S.$nc(a)))},t=m=>{if(i){const a=this.a.getFolderUri(i);if(a)return a;throw new D.$ZO(m,(0,f.localize)(2,null,p,i))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new D.$ZO(m,(0,f.localize)(3,null,p)):new D.$ZO(m,(0,f.localize)(4,null,p))};switch(s){case"env":if(i){if(v.env){const m=v.env[R.$i?i.toLowerCase():i];if(P.$Qf(m))return m}return""}throw new D.$ZO(D.VariableKind.Env,(0,f.localize)(5,null,p));case"config":if(i){const m=this.a.getConfigurationValue(u,i);if(P.$Zf(m))throw new D.$ZO(D.VariableKind.Config,(0,f.localize)(6,null,p,i));if(P.$Sf(m))throw new D.$ZO(D.VariableKind.Config,(0,f.localize)(7,null,p,i));return m}throw new D.$ZO(D.VariableKind.Config,(0,f.localize)(8,null,p));case"command":return this.p(D.VariableKind.Command,p,i,r,"command");case"input":return this.p(D.VariableKind.Input,p,i,r,"input");case"extensionInstallFolder":if(i){const m=await this.a.getExtension(i);if(!m)throw new D.$ZO(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,p,i));return this.n(m.extensionLocation)}throw new D.$ZO(D.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,p));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,g.$6v)(this.n(t(D.VariableKind.WorkspaceFolder)));case"cwd":return u||i?(0,g.$6v)(this.n(t(D.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$6v)(S.$nc(this.n(t(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new D.$ZO(D.VariableKind.UserHome,(0,f.localize)(11,null,p))}case"lineNumber":{const m=this.a.getLineNumber();if(m)return m;throw new D.$ZO(D.VariableKind.LineNumber,(0,f.localize)(12,null,p))}case"selectedText":{const m=this.a.getSelectedText();if(m)return m;throw new D.$ZO(D.VariableKind.SelectedText,(0,f.localize)(13,null,p))}case"file":return o(D.VariableKind.File);case"fileWorkspaceFolder":return l(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(l(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return u||i?S.$lc(this.n(t(D.VariableKind.RelativeFile)),o(D.VariableKind.RelativeFile)):o(D.VariableKind.RelativeFile);case"relativeFileDirname":{const m=S.$mc(o(D.VariableKind.RelativeFileDirname));if(u||i){const a=S.$lc(this.n(t(D.VariableKind.RelativeFileDirname)),m);return a.length===0?".":a}return m}case"fileDirname":return S.$mc(o(D.VariableKind.FileDirname));case"fileExtname":return S.$oc(o(D.VariableKind.FileExtname));case"fileBasename":return S.$nc(o(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const m=S.$nc(o(D.VariableKind.FileBasenameNoExtension));return m.slice(0,m.length-S.$oc(m).length)}case"fileDirnameBasename":return S.$nc(S.$mc(o(D.VariableKind.FileDirnameBasename)));case"execPath":{const m=this.a.getExecPath();return m||p}case"execInstallFolder":{const m=this.a.getAppRoot();return m||p}case"pathSeparator":case"/":return S.sep;default:try{const m=i?`${s}:${i}`:s;return this.p(D.VariableKind.Unknown,p,m,r,void 0)}catch{return p}}}}p(v,p,s,u,r){if(s&&u){const i=r===void 0?u[s]:u[r+":"+s];if(typeof i=="string")return i;throw new D.$ZO(v,(0,f.localize)(14,null,p))}return p}}e.$bP=k}),define(Fe[105],Le([1,0,4,102]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kD=e.$jD=e.OpenEditorContext=e.GroupsOrder=e.$iD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$hD=void 0,e.$hD=(0,S.$ci)("editorGroupsService");var P;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var L;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var g;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var f;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function D(p){const s=p;return(0,F.$4E)(s?.editor)&&(0,F.$4E)(s?.replacement)}e.$iD=D;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function h(p){const s=p;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$jD=h;function v(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$kD=v}),define(Fe[217],Le([1,0,4,105]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=void 0,e.$lD=(0,S.$ci)("editorService"),e.$mD=-1,e.$nD=-2,e.$oD=-3;function P(L){const R=L;return typeof L=="number"||(0,F.$jD)(R)}e.$pD=P}),define(Fe[218],Le([1,0,4,185]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=void 0,e.$gL=(0,S.$di)(F.$ji)}),define(Fe[106],Le([1,0,22,5,19,6,11]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$98b=e.$88b=e.$78b=e.$68b=e.$58b=void 0;class g{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$58b=g;class f{static isHostExtension(i,n,o){if(n.getExtensionDescription(i))return!1;const l=o.getExtensionDescription(i);return l?!!((l.main||l.browser)&&l.api==="none"):!1}constructor(i,n){this.j=i,this.c=new F.$3d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$wm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=u(this.e,n),this.e=this.e.concat(i);const o=f.l(this.e);return this.e=u(this.e,o.map(l=>l.identifier)),this.k(),this.d++,this.c.fire(void 0),new g(this.d,o)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,c){this.addNode(a),this.addNode(c),this.c.has(a)?this.c.get(a).push(c):this.c.set(a,[c])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,c){const E=n.getArcs(a);for(let y=0;y<E.length;y++)if(!c.has(E[y]))return!1;return!0}getNodes(){return this.e}},o=new S.$wm;for(const a of i)if(o.set(a.identifier,a),a.extensionDependencies)for(const c of a.extensionDependencies)n.addArc(S.$um.toKey(a.identifier),S.$um.toKey(c));const l=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>l.add(a));const t=n.getNodes().filter(a=>!l.has(a));let m;do{m=!1;for(let a=0;a<t.length;a++){const c=t[a];n.hasOnlyGoodArcs(c,l)&&(t.splice(a,1),a--,l.add(c),m=!0)}}while(m);return t.map(a=>o.get(a))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$68b=f;class D{constructor(i,n){this.versionId=i,this.extensions=n}}e.$78b=D;class A{constructor(i){this.d=new v,this.c=new f(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new k(this,n)}deltaExtensions(i,n,o){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$88b=A;class k extends L.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$98b=k;class h{constructor(i){this.name=i;const n=(0,R.$8g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class v{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new h(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),l=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};i.resolve((0,L.$Rc)(l))}}var p;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(p||(p={}));function s(r,i){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,o=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==o)return n-o;const l=P.$gc.basename(r.extensionLocation.path),t=P.$gc.basename(i.extensionLocation.path);return l<t?-1:l>t?1:0}function u(r,i){const n=new S.$vm(i);return r.filter(o=>!n.has(o.identifier))}}),define(Fe[77],Le([1,0,24]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Dm=e.$Cm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(F||(e.UIKind=F={}));var P;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var L;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(D){const A=S.$qe.alloc(1);switch(D){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$Cm=R;function g(D,A){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$Dm=g;var f;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Fe[60],Le([1,0,4,5,14,27,77,56,57,26,2,6,166]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=e.$sO=e.$rO=void 0;let v=class extends k.$Tc{constructor(r,i){super(),this.s=r,this.t=i,this.a=this.B(new F.$3d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$3d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:f.$Zo,name:(0,h.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,P.$yj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,i,n){const o=this.getTelemetryDetails(),l=new p(i,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(r,i,n){this.f=r,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const i=Object.create(null);switch(i["common.extname"]=`${r.publisher}.${r.name}`,i["common.extversion"]=r.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,g.$kl)((0,f.$6o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const l=n.filter(t=>!t.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,i){const o=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(r.value),!1;let l=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),l=!0);return l}};e.$rO=v,e.$rO=v=Je([qe(0,L.$qO),qe(1,P.$xj)],v);class p{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,i,n,o,l,t,m){this.g=n,this.h=o,this.i=l,this.j=t,this.a=new F.$3d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:m.isUsageEnabled,isErrorsEnabled:m.isErrorsEnabled}}updateTelemetryEnablements(r,i){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let i="properties"in r?r.properties??{}:r;return i=(0,f.$9o)(i,[]),this.c&&(i=(0,D.$In)(i,this.c)),this.b||(i=(0,D.$In)(i,this.j)),"properties"in r?r.properties=i:r=i,r}k(r,i){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(r,i),this.h.trace(r,i))}logUsage(r,i){this.d.isUsageEnabled&&this.k(r,i)}logError(r,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,i);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},o=(0,f.$9o)(n,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(l,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const r=this,i={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$sO=p;function s(u){const r=Date.now()-new Date(u).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$tO=s,e.$uO=(0,S.$ci)("IExtHostTelemetry")}),define(Fe[23],Le([1,0,5,2,194,101,22,4]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.ActivationKind=e.$UF=e.$TF=e.$SF=e.$RF=e.$QF=e.ExtensionHostStartup=e.$PF=e.$OF=e.$NF=e.$MF=void 0,e.$MF=Object.freeze({identifier:new R.$um("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$NF="extensions.webWorker",e.$OF=(0,g.$ci)("extensionService");class f{constructor(l){this.dependency=l}}e.$PF=f;var D;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,m){this.c=l,this.d=t.slice(0),this.e=m.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$xF.createActivationEventsMap(this.d)}}set(l,t,m){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],c=[],E=[],y=[],$=k(this.d),I=k(t),d=(G,W)=>G.extensionLocation.toString()===W.extensionLocation.toString()||G.isBuiltin===W.isBuiltin||G.isUserBuiltin===W.isUserBuiltin||G.isUnderDevelopment===W.isUnderDevelopment;for(const G of this.d){const W=I.get(G.identifier);if(!W){a.push(G.identifier),$.delete(G.identifier);continue}if(!d(G,W)){a.push(G.identifier),$.delete(G.identifier);continue}}for(const G of t){const W=$.get(G.identifier);if(!W){c.push(G);continue}if(!d(W,G)){a.push(W.identifier),$.delete(W.identifier);continue}}const w=new R.$vm(this.e),b=new R.$vm(m);for(const G of this.e)b.has(G)||E.push(G);for(const G of m)w.has(G)||y.push(G);const M=L.$xF.createActivationEventsMap(c),T={versionId:l,toRemove:a,toAdd:c,addActivationEvents:M,myToRemove:E,myToAdd:y};return this.delta(T),T}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:m,myToRemove:a,myToAdd:c}=l,E=new R.$vm(t),y=new R.$vm(a);for(let $=0;$<this.d.length;$++)E.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)y.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of m)this.d.push($);for(const $ of c)this.e.push($);return this.f=null,l}containsExtension(l){for(const t of this.e)if(R.$um.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const m=L.$xF.readActivationEvents(t);for(const a of m)l.add(a)}return l}}e.$QF=A;function k(o){const l=new R.$wm;for(const t of o)l.set(t.identifier,t);return l}function h(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$RF=h;function v(o,l){if(!h(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$SF=v;class p{constructor(l,t,m,a){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=a}}e.$TF=p;class s{constructor(l,t){this.description=l,this.value=t}}e.$UF=s;var u;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(u||(e.ActivationKind=u={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$cp)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$VF=r;function i(o,l){return{identifier:new R.$um((0,P.$ap)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$WF=i;class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$XF=n}),define(Fe[219],Le([1,0,15,106,22,23,14,11]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mhc=e.$Lhc=e.$Khc=e.$Jhc=e.$Ihc=e.$Hhc=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,i,n,o){this.startup=r,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$Hhc=f;class D{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,i){return r===-1||i===-1?-1:i-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Ihc=D;class A{constructor(r,i,n,o,l,t){this.activationFailed=r,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=l,this.subscriptions=t}}e.$Jhc=A;class k extends A{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Khc=k;class h extends A{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lhc=h;class v extends A{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(r,i,n,o){this.g=o,this.a=r,this.b=i,this.c=n,this.d=new P.$wm,this.f=Object.create(null)}dispose(){for(const[r,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const r=[];for(const[i,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const i=this.d.get(r);return!!(i&&i.value)}getActivatedExtension(r){const i=this.d.get(r);if(!i||!i.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return i.value}async activateByEvent(r,i){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,i){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(r){const i=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const i=this.a.getExtensionDescription(r.id);if(!i){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new v(l));return this.c.onExtensionActivationError(r.id,l,new L.$PF(r.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const l of o){if(this.m(l))continue;const t=this.d.get(l);if(t){n.push(t);continue}if(this.l(l)){n.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:r.reason}));continue}const m=this.a.getExtensionDescription(l);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:r.reason}));continue}const a=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),E=this.k(r,i.displayName,[],new v(c));return this.c.onExtensionActivationError(i.identifier,c,new L.$PF(l)),E}return this.k(r,i.displayName,n,null)}k(r,i,n,o){const l=new s(r.id,i,r.reason,n,o,this.c,this.g);return this.d.set(r.id,l),l}l(r){return F.$68b.isHostExtension(r,this.a,this.b)}m(r){const i=this.b.getExtensionDescription(r);return i?!i.main&&!i.browser:!1}};e.$Mhc=p,e.$Mhc=p=Je([qe(3,R.$wj)],p);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,i,n,o,l,t,m){this.c=r,this.d=i,this.f=n,this.g=o,this.h=l,this.j=t,this.k=m,this.a=new g.$bh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const i=this.g[r];if(i.value&&!i.value.activationFailed){this.g.splice(r,1),r--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const i=new Error;if(r&&r.name&&(i.name=r.name),r&&r.message?i.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(i.stack=r.stack),this.h=new v(i),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([qe(6,R.$wj)],s)}),define(Fe[220],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Fe[221],Le([1,0,180,15,32,96,72,30,22,220,190,101]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.$JF=e.$IF=e.$HF=e.$GF=void 0;const h=g.$Rn.as(R.$Sn.JSONContribution);class v{constructor(l,t,m){this.a=l,this.b=t,this.c=m}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(P.default.Error,l)}warn(l){this.d(P.default.Warning,l)}info(l){this.d(P.default.Info,l)}}e.$GF=v;class p{static a(l){const t=new f.$vm;for(let m=0,a=l.length;m<a;m++)t.add(l[m].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new p(t,[]);if(!t||!t.length)return new p([],l);const m=this.a(l),a=this.a(t),c=t.filter(y=>!m.has(y.description.identifier)),E=l.filter(y=>!a.has(y.description.identifier));return new p(c,E)}constructor(l,t){this.added=l,this.removed=t}}e.$HF=p;class s{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=p.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,F.$1)(l)}}}e.$IF=s;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$JF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$tm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$wo}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$wo}},extensionKind:{description:S.localize(52,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new s(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&k.$xF.register(l.extensionPoint,l.activationEventsGenerator),e.$JF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,h.registerSchema(r,e.$JF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$KF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};g.$Rn.add(n.ExtensionsRegistry,new i),e.$LF=g.$Rn.as(n.ExtensionsRegistry),h.registerSchema(r,e.$JF),h.registerSchema(A.$Pj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Fe[222],Le([1,0,176,16,26,221,35,5]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var D;(function(h){function v(p,s,u){if(!p)return;const r=F.$Qf(p.type)?p.type:void 0;if(!r||r.length===0){u.error(S.localize(3,null));return}const i=[];if(Array.isArray(p.required))for(const n of p.required)F.$Qf(n)&&i.push(n);return{extensionId:s.value,taskType:r,required:i,properties:p.properties?P.$Fn(p.properties):{},when:p.when?R.$aj.deserialize(p.when):void 0}}h.from=v})(D||(D={}));const A=L.$LF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(h,v)=>{for(const p of h)p.type&&v.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class k{constructor(){this.d=new g.$3d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,p)=>{A.setHandler((s,u)=>{this.c=void 0;try{for(const r of u.removed){const i=r.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of u.added){const i=r.value;for(const n of i){const o=D.from(n,r.description.identifier,r.collector);o&&(this.a[o.taskType]=o)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const p of this.all()){const s={type:"object",additionalProperties:!1};p.required.length>0&&(s.required=p.required.slice(0)),p.properties!==void 0?s.properties=P.$Fn(p.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[p.taskType]},v.push(s)}this.c={oneOf:v}}return this.c}}e.$0G=new k}),define(Fe[223],Le([1,0,177,16,25,26,35,222]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$hH=e.JsonSchemaVersion=e.ExecutionEngine=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$bH=e.ShellQuoting=e.$aH=e.$_G=e.$$G=void 0,e.$$G="settings",e.$_G=new R.$tj("taskRunning",!1,S.localize(0,null)),e.$aH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$bH="$customized",function(C){function O(V){if(!V)return C.Strong;switch(V.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=O}(f||(e.ShellQuoting=f={}));var D;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=O}(A||(e.RevealKind=A={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function O(V){switch(V.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=O}(k||(e.RevealProblemKind=k={}));var h;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(h||(e.PanelKind=h={})),function(C){function O(V){switch(V.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=O}(h||(e.PanelKind=h={}));var v;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:h.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var p;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(C){function O(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=O;function V(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=V}(p||(e.RuntimeType=p={}));var s;(function(C){function O(V){return F.$Qf(V)?V:V.value}C.value=O})(s||(e.CommandString=s={}));var u;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function O(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=O;function V(re){if(re!==void 0)return F.$Qf(re)?O(re)?{_id:re,isDefault:!1}:void 0:re}C.from=V})(u||(e.TaskGroup=u={}));var r;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function O(V){switch(V){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(C){C.parallel="parallel",C.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class t{constructor(O,V,re,ce,ye,ke){this._label="",this._id=O,V&&(this._label=V),re&&(this.type=re),this.runOptions=ce,this.configurationProperties=ye,this._source=ke}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,V=!1){if(O===void 0)return!1;if(F.$Qf(O))return O===this._label||O===this.configurationProperties.identifier||V&&O===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$cH=t;class m extends t{constructor(O,V,re,ce,ye,ke,he,ve){super(O,re,void 0,he,ve,V),this.command={},this._source=V,this.hasDefinedMatchers=ke,ye&&(this.command=ye)}clone(){return new m(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case p.Shell:V="shell";break;case p.Process:V="process";break;case p.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(O){return O instanceof m}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$$G:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const re={type:e.$bH,folder:O,id:V};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Mg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new m(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$dH=m;class a extends t{constructor(O,V,re,ce,ye,ke,he){super(O,re,ce,ke,he,V),this._source=V,this.configures=ye}static is(O){return O instanceof a}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Mg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$$G:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let V=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(V+=this._source.kind);const re={type:e.$bH,folder:O,id:V};return JSON.stringify(re)}}e.$eH=a;class c extends t{constructor(O,V,re,ce,ye,ke,he,ve,se){super(O,re,ce,ve,se,V),this.defines=ye,this.hasDefinedMatchers=he,this.command=ke,this.icon=se.icon,this.hide=se.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof c}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new c(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$fH=c;class E extends t{constructor(O,V,re,ce,ye,ke){super(O,re,ce,ye,ke,V),this._source=V}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new E(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$gH=E;var y;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(y||(e.ExecutionEngine=y={})),function(C){C._default=C.Terminal}(y||(e.ExecutionEngine=y={}));var $;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class I{constructor(O){this.c=new Map;for(let V=0;V<O.length;V++)this.c.set(O[V].uri.toString(),V)}compare(O,V){const re=O.getWorkspaceFolder(),ce=V.getWorkspaceFolder();if(re&&ce){let ye=this.c.get(re.uri.toString());ye=ye===void 0?0:ye+1;let ke=this.c.get(ce.uri.toString());return ke=ke===void 0?0:ke+1,ye===ke?O._label.localeCompare(V._label):ye-ke}else return!re&&ce?-1:re&&!ce?1:0}}e.$hH=I;var d;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(d||(e.TaskEventKind=d={}));var w;(function(C){C.SingleRun="singleRun",C.Background="background"})(w||(e.TaskRunType=w={}));var b;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(C){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function V(ve,se,$e){return{...O(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=V;function re(ve,se,$e){return{...O(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ce(ve,se,$e){return{...O(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ce;function ye(ve,se,$e){return{...O(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=ye;function ke(ve,se,$e){return{...O(se),kind:ve,terminalId:$e}}C.general=ke;function he(){return{kind:"changed"}}C.changed=he})(M||(e.TaskEvent=M={}));var T;(function(C){function O(re){const ce=Object.keys(re).sort();let ye="";for(const ke of ce){let he=re[ke];he instanceof Object?he=O(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),ye+=ke+","+he+","}return ye}function V(re){const ye={_key:O(re),type:re.taskType};return Object.assign(ye,re),ye}C.create=V})(T||(e.KeyedTaskIdentifier=T={}));var G;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(G||(e.TaskSettingId=G={}));var W;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(C){function O(V,re){const ce=g.$0G.get(V.type);if(ce===void 0){const ve=L.$Fn(V);return delete ve._key,T.create(ve)}const ye=Object.create(null);ye.type=ce.taskType;const ke=new Set;ce.required.forEach(ve=>ke.add(ve));const he=ce.properties;for(const ve of Object.keys(he)){const se=V[ve];if(se!=null)ye[ve]=se;else if(ke.has(ve)){const $e=he[ve];if($e.default!==void 0)ye[ve]=L.$Fn($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(V,void 0,0),ve));return}}}return T.create(ye)}C.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Fe[224],Le([1,0,15]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$8b=e.$08b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,g)=>{this.b=R,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,g){return this.j().then(R,g)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$08b=F;class P extends F{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$$8b=P}),define(Fe[50],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3v=e.$2v=e.$1v=e.$Zv=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$Zv=S;const F=[];function P(g){const f=new S(g);return F[f.nid]=f,f}e.$1v=P;function L(g){return F[g].sid}e.$2v=L;class R{constructor(f){this.value=f}}e.$3v=R}),define(Fe[3],Le([1,0,50]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$UL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var L;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var g;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var D;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var A;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(u){return u._id=k.a++,u}}e.$UL=k;var h;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(h||(e.ISuggestDataDtoField=h={}));var v;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var p;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$VL={MainThreadAuthentication:(0,S.$1v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$1v)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$1v)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$1v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$1v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$1v)("MainThreadClipboard"),MainThreadCommands:(0,S.$1v)("MainThreadCommands"),MainThreadComments:(0,S.$1v)("MainThreadComments"),MainThreadConfiguration:(0,S.$1v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$1v)("MainThreadConsole"),MainThreadDebugService:(0,S.$1v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$1v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$1v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$1v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$1v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$1v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$1v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$1v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$1v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$1v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$1v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$1v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$1v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$1v)("MainThreadLanguages"),MainThreadLogger:(0,S.$1v)("MainThreadLogger"),MainThreadMessageService:(0,S.$1v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$1v)("MainThreadOutputService"),MainThreadProgress:(0,S.$1v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$1v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$1v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$1v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$1v)("MainThreadSecretState"),MainThreadStorage:(0,S.$1v)("MainThreadStorage"),MainThreadSpeech:(0,S.$1v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$1v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$1v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$1v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$1v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$1v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$1v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$1v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$1v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$1v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$1v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$1v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$1v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$1v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$1v)("MainThreadSCM"),MainThreadSearch:(0,S.$1v)("MainThreadSearch"),MainThreadShare:(0,S.$1v)("MainThreadShare"),MainThreadTask:(0,S.$1v)("MainThreadTask"),MainThreadWindow:(0,S.$1v)("MainThreadWindow"),MainThreadLabelService:(0,S.$1v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$1v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$1v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$1v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$1v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$1v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$1v)("MainThreadInteractive"),MainThreadChat:(0,S.$1v)("MainThreadChat"),MainThreadInlineChat:(0,S.$1v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$1v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$1v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$1v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$1v)("MainThreadTimeline"),MainThreadTesting:(0,S.$1v)("MainThreadTesting"),MainThreadLocalization:(0,S.$1v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$1v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$1v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$1v)("MainThreadIssueReporter")},e.$WL={ExtHostCommands:(0,S.$1v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$1v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$1v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$1v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$1v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$1v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$1v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$1v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$1v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$1v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$1v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$1v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$1v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$1v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$1v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$1v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$1v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$1v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$1v)("ExtHostStatusBar"),ExtHostShare:(0,S.$1v)("ExtHostShare"),ExtHostExtensionService:(0,S.$1v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$1v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$1v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$1v)("ExtHostSCM"),ExtHostSearch:(0,S.$1v)("ExtHostSearch"),ExtHostTask:(0,S.$1v)("ExtHostTask"),ExtHostWorkspace:(0,S.$1v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$1v)("ExtHostWindow"),ExtHostWebviews:(0,S.$1v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$1v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$1v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$1v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$1v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$1v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$1v)("ExtHostProgress"),ExtHostComments:(0,S.$1v)("ExtHostComments"),ExtHostSecretState:(0,S.$1v)("ExtHostSecretState"),ExtHostStorage:(0,S.$1v)("ExtHostStorage"),ExtHostUrls:(0,S.$1v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$1v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$1v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$1v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$1v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$1v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$1v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$1v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$1v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$1v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$1v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$1v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$1v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$1v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$1v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$1v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$1v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$1v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$1v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$1v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$1v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$1v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$1v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$1v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$1v)("ExtHostTimeline"),ExtHostTesting:(0,S.$1v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$1v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$1v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$1v)("ExtHostIssueReporter")}}),define(Fe[78],Le([1,0,4,14,3,17]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=void 0,e.$6gc=(0,S.$ci)("IExtHostApiDeprecationService");let R=class{constructor(f,D){this.c=D,this.a=new Set,this.b=f.getProxy(P.$VL.MainThreadTelemetry)}report(f,D,A){const k=this.d(f,D);this.a.has(k)||(this.a.add(k),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:f}))}d(f,D){return`${f}-${D.identifier.value}`}};e.$7gc=R,e.$7gc=R=Je([qe(0,L.$aO),qe(1,F.$wj)],R),e.$8gc=Object.freeze(new class{report(g,f,D){}})}),define(Fe[225],Le([1,0,68,6,3]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class L{static{this.a=0}constructor(f,D){this.extension=f,this.provider=D,this.handle=L.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(P.$VL.MainThreadChat)}registerChatProvider(f,D,A){const k=new L(f,A);return this.b.set(k.handle,k),this.d.$registerChatProvider(k.handle,D),(0,F.$Rc)(()=>{this.d.$unregisterChatProvider(k.handle),this.b.delete(k.handle)})}transferChatSession(f,D){const A=S.Iterable.find(this.c.keys(),k=>this.c.get(k)===f)??0;typeof A=="number"&&this.d.$transferChatSession(A,D)}sendInteractiveRequestToProvider(f,D){this.d.$sendRequestToProvider(f,D)}async $prepareChat(f,D){const A=this.b.get(f);if(!A)return;const k=await A.provider.prepareSession(D);if(!k)return;const h=R.a++;return this.c.set(h,k),{id:h,requesterUsername:k.requester?.name,requesterAvatarIconUri:k.requester?.icon,responderUsername:k.responder?.name,responderAvatarIconUri:k.responder?.icon,inputPlaceholder:k.inputPlaceholder}}$releaseSession(f){this.c.delete(f)}}e.$fhc=R}),define(Fe[226],Le([1,0,3]),function(fe,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;class F{constructor(L){const R=L.getProxy(S.$VL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(g){return R.$writeText(g)}})}}e.$jhc=F}),define(Fe[227],Le([1,0,26,3,27,17]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(F.$VL.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const h=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){h.e(A,k,v,arguments)}})}e(A,k,h,v){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:f(v,this.b)}),this.c&&this.f(A,h,v)}};e.$ajc=R,e.$ajc=R=Je([qe(0,L.$aO),qe(1,P.$qO)],R);const g=1e5;function f(D,A){const k=[];if(D.length)for(let h=0;h<D.length;h++){let v=D[h];if(typeof v>"u")v="undefined";else if(v instanceof Error){const p=v;p.stack?v=p.stack:v=p.toString()}k.push(v)}if(A){const h=new Error().stack;h&&k.push({__$stack:h.split(`
`).slice(3).join(`
`)})}try{const h=(0,S.$Kn)(k);return h.length>g?"Output omitted for a large object that exceeds the limits":h}catch(h){return`Output omitted for an object that cannot be inspected ('${h.toString()}')`}}}),define(Fe[228],Le([1,0,2,3,23]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class L{constructor(g){this.a=g.getProxy(F.$VL.MainThreadDialogs)}showOpenDialog(g,f){return f?.allowUIResources&&(0,P.$SF)(g,"showLocal"),this.a.$showOpenDialog(f).then(D=>D?D.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(f=>f?S.URI.revive(f):void 0)}}e.$eic=L}),define(Fe[229],Le([1,0,6,3]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(F.$VL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$zic=P}),define(Fe[79],Le([1,0,20,13,2,4,14,3,27,17]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0;let A=class{constructor(h,v,p){this.f=p,this.d=new Map,this.a=v.getProxy(g.$VL.MainThreadLocalization),this.b=h.environment.appLanguage,this.c=this.b===S.$g}getMessage(h,v){const{message:p,args:s,comment:u}=v;if(this.c)return(0,F.$Se)(p,s??{});let r=p;u&&u.length>0&&(r+=`/${Array.isArray(u)?u.join(""):u}`);const i=this.d.get(h)?.contents[r];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,F.$Se)(i??p,s??{})}getBundle(h){return this.d.get(h)?.contents}getBundleUri(h){return this.d.get(h)?.uri}async initializeLocalizedMessages(h){if(this.c||!h.l10n&&!h.isBuiltin||this.d.has(h.identifier.value))return;let v;const p=await this.g(h);if(!p){this.f.error(`No bundle location found for extension ${h.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(p),u=JSON.parse(s);v=h.isBuiltin?u.contents?.bundle:u}catch(s){this.f.error(`Failed to load translations for ${h.identifier.value} from ${p}: ${s.message}`);return}v&&this.d.set(h.identifier.value,{contents:v,uri:p})}async g(h){if(h.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(h.identifier.value,this.b);return P.URI.revive(v)}return h.l10n?P.URI.joinPath(h.extensionLocation,h.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Yhc=A,e.$Yhc=A=Je([qe(0,f.$qO),qe(1,D.$aO),qe(2,R.$wj)],A),e.$Zhc=(0,L.$ci)("IExtHostLocalizationService")}),define(Fe[230],Le([1,0,14,3,27,17,2,52]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;let f=class extends S.$Hj{constructor(k,h){super(h.logLevel,h.logsLocation,h.loggers.map(v=>(0,g.$Lh)(v))),this.r=k.getProxy(F.$VL.MainThreadLogger)}$setLogLevel(k,h){h?this.setLogLevel(R.URI.revive(h),k):this.setLogLevel(k)}setVisibility(k,h){super.setVisibility(k,h),this.r.$setVisibility(k,h)}s(k,h,v){return new D(this.r,k,h,v)}};e.$_ic=f,e.$_ic=f=Je([qe(0,L.$aO),qe(1,P.$qO)],f);class D extends S.$Cj{constructor(k,h,v,p){super(p?.logLevel==="always"),this.r=k,this.s=h,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(h,p).then(()=>{this.u(this.n),this.m=!0})}g(k,h){const v=[[k,h]];this.m?this.u(v):this.n.push(...v)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Fe[80],Le([1,0,3,4,6,17,24]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=void 0,e.$1hc=(0,F.$ci)("IExtHostManagedSockets");let g=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(S.$VL.MainThreadManagedSockets)}setFactory(k,h){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(k,h),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const h=++this.b,v=await this.c.makeConnection(),p=new P.$Sc;return this.d.set(h,new D(h,v,p)),p.add((0,P.$Rc)(()=>this.d.delete(h))),p.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(h),p.dispose()})),p.add(v.onDidClose(s=>{this.a.$onDidManagedSocketClose(h,s?.stack??s?.message),p.dispose()})),p.add(v.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(h,R.$qe.wrap(s)))),h}$remoteSocketWrite(k,h){this.d.get(k)?.actual.send(h.buffer)}$remoteSocketEnd(k){const h=this.d.get(k);h&&(h.actual.end(),h.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$2hc=g,e.$2hc=g=Je([qe(0,L.$aO)],g);class f{constructor(k,h){this.socketFactoryId=k,this.makeConnection=h}}class D extends P.$Tc{constructor(k,h,v){super(),this.socketId=k,this.actual=h,this.B(v)}}}),define(Fe[231],Le([1,0,3,14,23]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=void 0;function L(g){return g&&g.title}let R=class{constructor(f,D){this.b=D,this.a=f.getProxy(S.$VL.MainThreadMessageService)}showMessage(f,D,A,k,h){const v={source:{identifier:f.identifier,label:f.displayName||f.name}};let p;typeof k=="string"||L(k)?p=[k,...h]:(v.modal=k?.modal,v.useCustom=k?.useCustom,v.detail=k?.detail,p=h),v.useCustom&&(0,P.$SF)(f,"resolvers");const s=[];let u=!1;for(let r=0;r<p.length;r++){const i=p[r];if(typeof i=="string")s.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:o}=i;s.push({title:n,isCloseAffordance:!!o,handle:r}),o&&(u?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,i):u=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,i)}return this.a.$showMessage(D,A,v,s).then(r=>{if(typeof r=="number")return p[r]})}};e.$Bic=R,e.$Bic=R=Je([qe(1,F.$wj)],R)}),define(Fe[232],Le([1,0,6,16,2,23,3]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=void 0;class g{constructor(D){this.b=new Map,this.a=D.getProxy(R.$VL.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,A,k){if((0,L.$SF)(D,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,D.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(D,A,k,h){const v=this.b.get(D);if(!v)throw new Error(`Unknown handler with id: ${D}`);return v.saveProfile(A,k,h)}async $readProfile(D,A,k){const h=this.b.get(D);if(!h)throw new Error(`Unknown handler with id: ${D}`);return h.readProfile((0,F.$Qf)(A)?A:P.URI.revive(A),k)}}e.$Kic=g}),define(Fe[81],Le([1,0,3,5,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=e.$Vhc=void 0;class L{constructor(g){this.b=new F.$3d,this.onDidChangePassword=this.b.event,this.a=g.getProxy(S.$VL.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,f){return this.a.$getPassword(g,f)}store(g,f,D){return this.a.$setPassword(g,f,D)}delete(g,f){return this.a.$deletePassword(g,f)}}e.$Vhc=L,e.$Whc=(0,P.$ci)("IExtHostSecretState")}),define(Fe[233],Le([1,0,21,6,3]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=void 0;class L{static{this.a=1}constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(P.$VL.MainThreadSpeech)}async $createSpeechToTextSession(g,f){const D=this.c.get(g);if(!D)return;const A=new F.$Sc,k=new S.$ae;this.d.set(f,k);const h=A.add(D.provideSpeechToTextSession(k.token));A.add(h.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,v)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}async $createKeywordRecognitionSession(g,f){const D=this.c.get(g);if(!D)return;const A=new F.$Sc,k=new S.$ae;this.d.set(f,k);const h=A.add(D.provideKeywordRecognitionSession(k.token));A.add(h.onDidChange(v=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,v)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,f,D){const A=L.a++;return this.c.set(A,D),this.b.$registerProvider(A,f,{extension:g,displayName:g.value}),(0,F.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Ric=L}),define(Fe[82],Le([1,0,3,5,4]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=void 0;class L{constructor(g,f){this.c=f,this.b=new F.$3d,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(S.$VL.MainThreadStorage)}registerExtensionStorageKeysToSync(g,f){this.a.$registerExtensionStorageKeysToSync(g,f)}async initializeExtensionStorage(g,f,D){const A=await this.a.$initializeExtensionStorage(g,f);let k;return A&&(k=this.d(g,f,A)),k||D}setValue(g,f,D){return this.a.$setValue(g,f,D)}$acceptValue(g,f,D){const A=this.d(g,f,D);A&&this.b.fire({shared:g,key:f,value:A})}d(g,f,D){try{return JSON.parse(D)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${g}): ${A}`)}}}e.$Nhc=L,e.$Ohc=(0,P.$ci)("IExtHostStorage")}),define(Fe[234],Le([1,0,6,12,2,3]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(L.$VL.MainThreadUriOpeners)}registerExternalUriOpener(f,D,A,k){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const h=k.schemes.find(v=>!R.a.has(v));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this.c.set(D,A),this.b.$registerUriOpener(D,k.schemes,f,k.label),(0,S.$Rc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(f,D,A){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener with id: ${f}`);const h=P.URI.revive(D);return k.canOpenExternalUri(h,A)}async $openUri(f,D,A){const k=this.c.get(f);if(!k)throw new Error(`Unknown opener id: '${f}'`);return k.openExternalUri(P.URI.revive(D.resolvedUri),{sourceUri:P.URI.revive(D.sourceUri)},A)}}e.$6ic=R}),define(Fe[235],Le([1,0,3,2,6,15,22]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=void 0;class g{static{this.a=0}constructor(D){this.c=new R.$vm,this.d=new Map,this.b=D.getProxy(S.$VL.MainThreadUrls)}registerUriHandler(D,A){const k=D.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const h=g.a++;return this.c.add(k),this.d.set(h,A),this.b.$registerUriHandler(h,k,D.displayName||D.name),(0,P.$Rc)(()=>{this.c.delete(k),this.d.delete(h),this.b.$unregisterUriHandler(h)})}$handleExternalUri(D,A){const k=this.d.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(F.URI.revive(A))}catch(h){(0,L.$1)(h)}return Promise.resolve(void 0)}async createAppUri(D){return F.URI.revive(await this.b.$createAppUri(D))}}e.$7ic=g}),define(Fe[61],Le([1,0,5,6,12,26,2,183,205,76,3]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=e.$Ahc=e.$zhc=e.$yhc=void 0;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(o,l,t,m,a,c,E){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$3d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$3d,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#o=t,this.#n=m,this.#s=a,this.#r=c,this.#l=h(c),this.#d=v(c),this.#i=E}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,D.$8wb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+D.$7wb}return D.$7wb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),L.$Jn(this.#o,o)||this.#t.$setOptions(this.#e,u(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const l=(0,f.$Kmb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,a,c,E,y,$)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,D.$8wb)(I,{isRemote:l,authority:t}).toString();return`${a}${d}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,a,c,E,y,$)=>{const I=R.URI.from({scheme:E||"file",path:decodeURIComponent(y)}),d=(0,D.$8wb)(I,{isRemote:l,authority:t}).toString();return`${a}${d}${$}`})}}e.$yhc=k;function h(n){try{const o=(0,g.$lp)((0,g.$kp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$zhc=h;function v(n){try{const o=(0,g.$lp)((0,g.$kp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class p extends F.$Tc{constructor(o,l,t,m,a){super(),this.c=l,this.f=t,this.g=m,this.h=a,this.b=new Map,this.a=o.getProxy(A.$VL.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,t){const m=this.j(o);if(m){const{message:a}=(0,f.$Lmb)(l,t.value);m._onMessageEmitter.fire(a)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,t){const m=new k(o,this.a,r(l),this.c,this.f,t,this.h);this.b.set(o,m);const a=m._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return m}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$Ahc=p;function s(n){return{id:n.identifier,location:n.extensionLocation}}e.$Bhc=s;function u(n,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||i(n,o)}}e.$Chc=u;function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>R.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),n.extensionLocation]}}),define(Fe[107],Le([1,0,5,3,2,12,13,4,17,23]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=e.$9ic=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const p=this.d;return{get focused(){return p.focused},get active(){return(0,D.$SF)(v,"windowActivity"),p.active}}}constructor(v){this.c=new S.$3d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(F.$VL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:s})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,p){p!==this.d[v]&&(this.d={...this.d,[v]:p},this.c.fire(this.d))}openUri(v,p){let s;if(typeof v=="string"){s=v;try{v=P.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,R.$Qe)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,s,p)}async asExternalUri(v,p){if((0,R.$Qe)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(v,p);return P.URI.from(s)}};e.$9ic=k,e.$9ic=k=A=Je([qe(0,f.$aO)],k),e.$0ic=(0,g.$ci)("IExtHostWindow")}),define(Fe[236],Le([1,0,227,27,17]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jlc=void 0;let L=class extends S.$ajc{constructor(g,f){super(g,f)}f(g,f,D){f.apply(console,D)}};e.$jlc=L,e.$jlc=L=Je([qe(0,P.$aO),qe(1,F.$qO)],L)}),define(Fe[237],Le([1,0,11,24,21,15,5,6,140,224,50]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$b9b=e.ResponsiveState=e.RequestInitiator=e.$a9b=e.$_8b=void 0;function h(b,M){try{return JSON.stringify(b,M)}catch{return"null"}}const v="$$ref$$",p={[v]:-1};class s{constructor(M,T){this.jsonString=M,this.referencedBuffers=T}}function u(b,M=null,T=!1){const G=[];return{jsonString:(T?h:JSON.stringify)(b,(U,C)=>{if(typeof C>"u")return p;if(typeof C=="object"){if(C instanceof F.$qe){const O=G.push(C)-1;return{[v]:O}}if(M)return M(U,C)}return C}),referencedBuffers:G}}e.$_8b=u;function r(b,M,T){return JSON.parse(b,(G,W)=>{if(W){const U=W[v];if(typeof U=="number")return M[U];if(T&&W.$mid===1)return T.transformIncoming(W)}return W})}e.$a9b=r;function i(b,M){return JSON.stringify(b,M)}function n(b){return b?(M,T)=>T&&T.$mid===1?b.transformOutgoing(T):T:null}var o;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const t=()=>{},m=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class c extends g.$Tc{static{k=m}static{this.a=3*1e3}constructor(M,T=null,G=null){super(),this[k]=!0,this.b=this.B(new R.$3d),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=T,this.g=G,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=A.$Zv.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$oh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const T=this.w[M];delete this.w[M],T.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,f.$en)(M,this.g):M}getProxy(M){const{nid:T,sid:G}=M;return this.s[T]||(this.s[T]=this.J(T,G)),this.s[T]}J(M,T){const G={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...C)=>this.U(M,U,C)),U===a?T:W[U])};return new Proxy(Object.create(null),G)}set(M,T){return this.m[M.nid]=T,T}assertRegistered(M){for(let T=0,G=M.length;T<G;T++){const W=M[T];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(M){if(this.j)return;const T=M.byteLength,G=y.read(M,0),W=G.readUInt8(),U=G.readUInt32();switch(W){case 1:case 2:{let{rpcId:C,method:O,args:V}=I.deserializeRequestJSONArgs(G);this.g&&(V=(0,f.$en)(V,this.g)),this.M(T,U,C,O,V,W===2);break}case 3:case 4:{let{rpcId:C,method:O,args:V}=I.deserializeRequestMixedArgs(G);this.g&&(V=(0,f.$en)(V,this.g)),this.M(T,U,C,O,V,W===4);break}case 5:{this.f?.logIncoming(T,U,0,"ack"),this.G(U);break}case 6:{this.N(T,U);break}case 7:{this.O(T,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(G);this.g&&(C=(0,f.$en)(C,this.g)),this.O(T,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(T,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(G);this.O(T,U,C);break}case 11:{let C=I.deserializeReplyErrError(G);this.g&&(C=(0,f.$en)(C,this.g)),this.P(T,U,C);break}case 12:{this.P(T,U,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,T,G,W,U,C){this.f?.logIncoming(M,T,1,`receiveRequest ${(0,A.$2v)(G)}.${W}(`,U);const O=String(T);let V,re;if(C){const ye=new P.$ae;U.push(ye.token),V=this.Q(G,W,U),re=()=>ye.cancel()}else V=this.Q(G,W,U),re=t;this.u[O]=re;const ce=I.serializeAcknowledged(T);this.f?.logOutgoing(ce.byteLength,T,1,"ack"),this.c.send(ce),V.then(ye=>{delete this.u[O];const ke=I.serializeReplyOK(T,ye,this.h);this.f?.logOutgoing(ke.byteLength,T,1,"reply:",ye),this.c.send(ke)},ye=>{delete this.u[O];const ke=I.serializeReplyErr(T,ye);this.f?.logOutgoing(ke.byteLength,T,1,"replyErr:",ye),this.c.send(ke)})}N(M,T){this.f?.logIncoming(M,T,1,"receiveCancel");const G=String(T);this.u[G]?.()}O(M,T,G){this.f?.logIncoming(M,T,0,"receiveReply:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(G)}P(M,T,G){this.f?.logIncoming(M,T,0,"receiveReplyErr:",G);const W=String(T);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let C;G&&(G.$isError?(C=new Error,C.name=G.name,C.message=G.message,C.stack=G.stack):C=G),U.resolveErr(C)}Q(M,T,G){try{return Promise.resolve(this.S(M,T,G))}catch(W){return Promise.reject(W)}}S(M,T,G){const W=this.m[M];if(!W)throw new Error("Unknown actor "+(0,A.$2v)(M));const U=W[T];if(typeof U!="function")throw new Error("Unknown method "+T+" on actor "+(0,A.$2v)(M));return U.apply(W,G)}U(M,T,G){if(this.j)return new D.$$8b;let W=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(L.$6());const U=I.serializeRequestArguments(G,this.h),C=++this.t,O=String(C),V=new D.$08b,re=new g.$Sc;W&&re.add(W.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[O]=new E(V,re),this.F(C);const ce=I.serializeRequest(C,M,T,U,!!W);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,A.$2v)(M)}.${T}(`,G),this.c.send(ce),V}}e.$b9b=c;class E{constructor(M,T){this.a=M,this.b=T}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class y{static alloc(M,T,G){const W=new y(F.$qe.alloc(G+1+4),0);return W.writeUInt8(M),W.writeUInt32(T),W}static read(M,T){return new y(M,T)}get buffer(){return this.a}constructor(M,T){this.a=M,this.b=T}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+M).toString();return this.b+=M,G}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+M).toString();return this.b+=M,G}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const T=this.a.slice(this.b,this.b+M);return this.b+=M,T}static sizeMixedArray(M){let T=0;T+=1;for(let G=0,W=M.length;G<W;G++){const U=M[G];switch(T+=1,U.type){case 1:T+=this.sizeLongString(U.value);break;case 2:T+=this.sizeVSBuffer(U.value);break;case 3:T+=this.sizeUInt32,T+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)T+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return T}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let T=0,G=M.length;T<G;T++){const W=M[T];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const T=new Array(M);for(let G=0;G<M;G++)switch(this.readUInt8()){case 1:T[G]=this.readLongString();break;case 2:T[G]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),O=[];for(let V=0;V<U;++V)O.push(this.readVSBuffer());T[G]=new A.$3v(r(C,O,null));break}case 4:T[G]=void 0;break}return T}}var $;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})($||($={}));class I{static a(M){for(let T=0,G=M.length;T<G;T++)if(M[T]instanceof F.$qe||M[T]instanceof A.$3v||typeof M[T]>"u")return!0;return!1}static serializeRequestArguments(M,T){if(this.a(M)){const G=[];for(let W=0,U=M.length;W<U;W++){const C=M[W];if(C instanceof F.$qe)G[W]={type:2,value:C};else if(typeof C>"u")G[W]={type:4};else if(C instanceof A.$3v){const{jsonString:O,referencedBuffers:V}=u(C.value,T);G[W]={type:3,value:F.$qe.fromString(O),buffers:V}}else G[W]={type:1,value:F.$qe.fromString(i(C,T))}}return{type:1,args:G}}return{type:0,args:i(M,T)}}static serializeRequest(M,T,G,W,U){switch(W.type){case 0:return this.b(M,T,G,W.args,U);case 1:return this.c(M,T,G,W.args,U)}}static b(M,T,G,W,U){const C=F.$qe.fromString(G),O=F.$qe.fromString(W);let V=0;V+=y.sizeUInt8(),V+=y.sizeShortString(C),V+=y.sizeLongString(O);const re=y.alloc(U?2:1,M,V);return re.writeUInt8(T),re.writeShortString(C),re.writeLongString(O),re.buffer}static deserializeRequestJSONArgs(M){const T=M.readUInt8(),G=M.readShortString(),W=M.readLongString();return{rpcId:T,method:G,args:JSON.parse(W)}}static c(M,T,G,W,U){const C=F.$qe.fromString(G);let O=0;O+=y.sizeUInt8(),O+=y.sizeShortString(C),O+=y.sizeMixedArray(W);const V=y.alloc(U?4:3,M,O);return V.writeUInt8(T),V.writeShortString(C),V.writeMixedArray(W),V.buffer}static deserializeRequestMixedArgs(M){const T=M.readUInt8(),G=M.readShortString(),W=M.readMixedArray(),U=new Array(W.length);for(let C=0,O=W.length;C<O;C++){const V=W[C];typeof V=="string"?U[C]=JSON.parse(V):U[C]=V}return{rpcId:T,method:G,args:U}}static serializeAcknowledged(M){return y.alloc(5,M,0).buffer}static serializeCancel(M){return y.alloc(6,M,0).buffer}static serializeReplyOK(M,T,G){if(typeof T>"u")return this.d(M);if(T instanceof F.$qe)return this.e(M,T);if(T instanceof A.$3v){const{jsonString:W,referencedBuffers:U}=u(T.value,G,!0);return this.g(M,W,U)}else return this.f(M,h(T,G))}static d(M){return y.alloc(7,M,0).buffer}static e(M,T){let G=0;G+=y.sizeVSBuffer(T);const W=y.alloc(8,M,G);return W.writeVSBuffer(T),W.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,T){const G=F.$qe.fromString(T);let W=0;W+=y.sizeLongString(G);const U=y.alloc(9,M,W);return U.writeLongString(G),U.buffer}static g(M,T,G){const W=F.$qe.fromString(T);let U=0;U+=y.sizeUInt32,U+=y.sizeLongString(W);for(const O of G)U+=y.sizeVSBuffer(O);const C=y.alloc(10,M,U);C.writeUInt32(G.length),C.writeLongString(W);for(const O of G)C.writeBuffer(O);return C.buffer}static deserializeReplyOKJSON(M){const T=M.readLongString();return JSON.parse(T)}static deserializeReplyOKJSONWithBuffers(M,T){const G=M.readUInt32(),W=M.readLongString(),U=[];for(let C=0;C<G;++C)U.push(M.readVSBuffer());return new A.$3v(r(W,U,T))}static serializeReplyErr(M,T){const G=T?h(L.$3(T),null):void 0;if(typeof G!="string")return this.h(M);const W=F.$qe.fromString(G);let U=0;U+=y.sizeLongString(W);const C=y.alloc(11,M,U);return C.writeLongString(W),C.buffer}static deserializeReplyErrError(M){const T=M.readLongString();return JSON.parse(T)}static h(M){return y.alloc(12,M,0).buffer}}var d;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var w;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(w||(w={}))}),define(Fe[238],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=void 0;const S=function(L){const R=g=>{globalThis.removeEventListener("message",R);const f=g.data;Object.defineProperties(globalThis,{postMessage:{value(D,A){f.postMessage(D,A)}},onmessage:{get(){return f.onmessage},set(D){f.onmessage=D}}}),f.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(L,R,g){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,D=new Blob([f],{type:"application/javascript"}),A=URL.createObjectURL(D),k=new MessageChannel,h=A,v={type:"_newWorker",id:h,port:k.port2,url:A,options:g};L(v,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:h}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(p){k.port1.onmessage=p}},onmessageerror:{get(){return k.port1.onmessageerror},set(p){k.port1.onmessageerror=p}}}),k.port1.addEventListener("messageerror",p=>{const s=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(s)}),k.port1.addEventListener("message",p=>{const s=new MessageEvent("message",{data:p.data});this.dispatchEvent(s)}),k.port1.start()}}e.$llc=F}),define(Fe[239],Le([1,0,24,28,12,53,4]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HJ=e.$GJ=e.$FJ=e.$EJ=void 0,e.$EJ=(0,R.$ci)("notebookDocumentService");const g=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${g.join("")}]+`),D=7;function A(v){if(v.scheme!==P.Schemas.vscodeNotebookCell)return;const p=v.fragment.indexOf("s");if(p<0)return;const s=parseInt(v.fragment.substring(0,p).replace(f,""),D),u=(0,S.$Je)(v.fragment.substring(p+1)).toString();if(!isNaN(s))return{handle:s,notebook:v.with({scheme:u,fragment:null})}}e.$FJ=A;function k(v,p){const s=p.toString(D),r=`${s.length<g.length?g[s.length-1]:"z"}${s}s${(0,S.$Ke)(S.$qe.fromString(v.scheme),!0,!0)}`;return v.with({scheme:P.Schemas.vscodeNotebookCell,fragment:r})}e.$GJ=k;class h{constructor(){this.a=new F.$Ac}getNotebook(p){if(p.scheme===P.Schemas.vscodeNotebookCell){const s=A(p);if(s){const u=this.a.get(s.notebook);if(u)return u}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$HJ=h,(0,L.$8r)(e.$EJ,h,1)}),define(Fe[83],Le([1,0,24,34,68,69,12,19,20,35,239]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CellStatusbarAlignment=e.$VJ=e.$UJ=e.$TJ=e.NotebookEditorPriority=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.CellKind=e.$KJ=e.$JJ=e.$IJ=void 0,e.$IJ="workbench.editor.notebook",e.$JJ="workbench.editor.notebookTextDiffEditor",e.$KJ="workbench.editor.interactive";var k;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(k||(e.CellKind=k={})),e.$LJ=["application/json","application/javascript","text/html","image/svg+xml",L.$os.latex,L.$os.markdown,"image/png","image/jpeg",L.$os.text],e.$MJ=[L.$os.latex,L.$os.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$os.text],e.$NJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$OJ="_notAvailable";var h;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(h||(e.NotebookRunState=h={}));var v;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var p;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var s;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var u;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(u||(e.RendererMessagingSpec=u={}));var r;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(V){V.scheme=R.Schemas.vscodeNotebookCell;function re(se,$e){return(0,A.$GJ)(se,$e)}V.generate=re;function ce(se){return(0,A.$FJ)(se)}V.parse=ce;function ye(se,$e){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}V.generateCellOutputUri=ye;function ke(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const te=$e[1]&&$e[1]!==""?$e[1]:void 0,Y=$e[2];return{outputId:te,notebook:se.with({scheme:Y||R.Schemas.file,fragment:null})}}V.parseCellOutputUri=ke;function he(se,$e,te){return V.generate(se,$e).with({scheme:te})}V.generateCellPropertyUri=he;function ve(se,$e){if(se.scheme===$e)return V.parse(se.with({scheme:V.scheme}))}V.parseCellPropertyUri=ve})(o||(e.CellUri=o={}));const l=V=>f.$i?V.replace(/\//g,"\\"):V;class t{constructor(re=[],ce=e.$LJ){this.e=ce,this.d=[...new Set(re)].map(ye=>({pattern:ye,matches:F.$Vj(l(ye))}))}sort(re){const ce=new Map(P.Iterable.map(re,ke=>[ke,l(ke)]));let ye=[];for(const{matches:ke}of this.d)for(const[he,ve]of ce)if(ke(ve)){ye.push(he),ce.delete(he);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((ke,he)=>this.e.indexOf(ke)-this.e.indexOf(he)))),ye}prioritize(re,ce){const ye=this.f(re);if(ye===-1){this.d.unshift({pattern:re,matches:F.$Vj(l(re))});return}const ke=new Set(ce.map(ve=>this.f(ve,ye)));ke.delete(-1);const he=Array.from(ke).sort();this.d.splice(ye+1,0,...he.map(ve=>this.d[ve]));for(let ve=he.length-1;ve>=0;ve--)this.d.splice(he[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ce=this.d.length){const ye=l(re);for(let ke=0;ke<ce;ke++)if(this.d[ke].matches(ye))return ke;return-1}}e.$PJ=t;function m(V,re,ce,ye=(ke,he)=>ke===he){const ke=[];function he($e,te,Y){if(te===0&&Y.length===0)return;const q=ke[ke.length-1];q&&q.start+q.deleteCount===$e?(q.deleteCount+=te,q.toInsert.push(...Y)):ke.push({start:$e,deleteCount:te,toInsert:Y})}let ve=0,se=0;for(;;){if(ve===V.length){he(ve,0,re.slice(se));break}if(se===re.length){he(ve,V.length-ve,[]);break}const $e=V[ve],te=re[se];if(ye($e,te)){ve+=1,se+=1;continue}ce(te)?(he(ve,1,[]),ve+=1):(he(ve,0,[te]),se+=1)}return ke}e.$QJ=m,e.$RJ=new D.$tj("notebookEditorCursorAtBoundary","none"),e.$SJ=new D.$tj("notebookEditorCursorAtLineBoundary","none");var a;(function(V){V.default="default",V.option="option"})(a||(e.NotebookEditorPriority=a={}));function c(V){const re=V;return!!((typeof re.include=="string"||F.$Wj(re.include))&&(typeof re.exclude=="string"||F.$Wj(re.exclude)))}e.$TJ=c;function E(V,re,ce){if(Array.isArray(V.viewType)&&V.viewType.indexOf(re)>=0||V.viewType===re)return!0;if(V.filenamePattern){const ye=c(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,ke=c(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(F.$Uj(ye,(0,g.$nc)(ce.fsPath).toLowerCase()))return!(ke&&F.$Uj(ke,(0,g.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$UJ=E,e.$VJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var y;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class ${static{this.d="notebook/"}static create(re){return`${$.d}${re}`}static parse(re){if(re.startsWith($.d))return re.substring($.d.length)}}e.$WJ=$;function I(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}e.$XJ=I;const d=new TextDecoder;function w(V){const re=[];let ce=!1;for(const ve of V)(re.length===0||ce)&&(re.push(ve),ce=!0);let ye=T(re);const ke=S.$qe.concat(re.map(ve=>S.$qe.wrap(ve))),he=O(ke);return ye=ye||he.byteLength!==ke.byteLength,{data:he,didCompression:ye}}e.$YJ=w,e.$ZJ="\x1B[A";const b=e.$ZJ.split("").map(V=>V.charCodeAt(0)),M=10;function T(V){let re=!1;return V.forEach((ce,ye)=>{if(ye===0||ce.length<e.$ZJ.length)return;const ke=V[ye-1],he=ce.subarray(0,e.$ZJ.length);if(he[0]===b[0]&&he[1]===b[1]&&he[2]===b[2]){const ve=ke.lastIndexOf(M);if(ve===-1)return;re=!0,V[ye-1]=ke.subarray(0,ve),V[ye]=ce.subarray(e.$ZJ.length)}}),re}function G(V){let re=V;do V=re,re=V.replace(/[^\n]\x08/gm,"");while(re.length<V.length);return V}function W(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const re=V.match(/^(.*)\r+/m)[1];let ce=V.match(/\r+(.*)$/m)[1];ce=ce+re.slice(ce.length,re.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return V}const U=8,C=13;function O(V){return!V.buffer.includes(U)&&!V.buffer.includes(C)?V:S.$qe.fromString(W(G(d.decode(V.buffer))))}}),define(Fe[7],Le([1,0,18,15,46,28,69,13,16,2,33,22,42,100,83]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p){"use strict";var s,u,r,i,n,o,l,t,m,a,c,E,y,$,I,d,w;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.ChatAgentResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$PN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$xN=e.$wN=e.TestRunProfileKind=e.TestResultState=e.$vN=e.$uN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$tN=e.NotebookVariablesRequestKind=e.$sN=e.$rN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$qN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.ColorThemeKind=e.$kN=e.$jN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$iN=e.$hN=e.DebugConsoleMode=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$bN=e.$aN=e.FileChangeType=e.$_M=e.NewSymbolNameTag=e.$$M=e.$0M=e.$9M=e.$8M=e.InlineCompletionTriggerKind=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.ConfigurationTarget=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.$LM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$KM=e.ViewBadge=e.ProgressLocation=e.$JM=e.$IM=e.TaskScope=e.ShellQuoting=e.$HM=e.$GM=e.$FM=e.TaskPanelKind=e.TaskRevealKind=e.$EM=e.TerminalLocation=e.$DM=e.$CM=e.$BM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$AM=e.$zM=e.$yM=e.$xM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$wM=e.StatusBarAlignment=e.ViewColumn=e.$vM=e.$uM=e.$tM=e.$sM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$rM=e.$qM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.LanguageStatusSeverity=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.CodeActionTriggerKind=e.$eM=e.$dM=e.SymbolTag=e.SymbolKind=e.$cM=e.$bM=e.DocumentHighlightKind=e.$aM=e.$_L=e.$$L=e.$0L=e.DiagnosticSeverity=e.DiagnosticTag=e.$9L=e.$8L=e.FileEditType=e.$7L=e.$6L=e.$5L=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$4L=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function b(B){return Object.assign(B,{apply:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const Ie=ie.length===1?[]:ie[1];return Reflect.construct(B,Ie,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(B,[]);{const[Ie,...Ge]=ie;return Reflect.construct(B,Ge,Ie.constructor)}}})}var M;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var T;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(T||(e.TerminalQuickFixType=T={}));let G=s=class{static from(...z){let ie=z;return new s(function(){if(ie){for(const Ie of ie)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();ie=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$XL=G,e.$XL=G=s=Je([b],G);let W=u=class{static Min(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let Ie=1;Ie<z.length;Ie++){const Ge=z[Ie];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...z){if(z.length===0)throw new TypeError;let ie=z[0];for(let Ie=1;Ie<z.length;Ie++){const Ge=z[Ie];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(z){if(!z)return!1;if(z instanceof u)return!0;const{line:ie,character:Ie}=z;return typeof ie=="number"&&typeof Ie=="number"}static of(z){if(z instanceof u)return z;if(this.isPosition(z))return new u(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ie){if(z<0)throw(0,F.$7)("line must be non-negative");if(ie<0)throw(0,F.$7)("character must be non-negative");this.c=z,this.e=ie}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ie=0){if(z===null||ie===null)throw(0,F.$7)();let Ie;return typeof z>"u"?Ie=0:typeof z=="number"?Ie=z:(Ie=typeof z.lineDelta=="number"?z.lineDelta:0,ie=typeof z.characterDelta=="number"?z.characterDelta:0),Ie===0&&ie===0?this:new u(this.line+Ie,this.character+ie)}with(z,ie=this.character){if(z===null||ie===null)throw(0,F.$7)();let Ie;return typeof z>"u"?Ie=this.line:typeof z=="number"?Ie=z:(Ie=typeof z.line=="number"?z.line:this.line,ie=typeof z.character=="number"?z.character:this.character),Ie===this.line&&ie===this.character?this:new u(Ie,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$YL=W,e.$YL=W=u=Je([b],W);let U=r=class{static isRange(z){return z instanceof r?!0:z?W.isPosition(z.start)&&W.isPosition(z.end):!1}static of(z){if(z instanceof r)return z;if(this.isRange(z))return new r(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ie,Ie,Ge){let _e,ct;if(typeof z=="number"&&typeof ie=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(_e=new W(z,ie),ct=new W(Ie,Ge)):W.isPosition(z)&&W.isPosition(ie)&&(_e=W.of(z),ct=W.of(ie)),!_e||!ct)throw new Error("Invalid arguments");_e.isBefore(ct)?(this.c=_e,this.e=ct):(this.c=ct,this.e=_e)}contains(z){return r.isRange(z)?this.contains(z.start)&&this.contains(z.end):W.isPosition(z)?!(W.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ie=W.Max(z.start,this.c),Ie=W.Min(z.end,this.e);if(!ie.isAfter(Ie))return new r(ie,Ie)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ie=W.Min(z.start,this.c),Ie=W.Max(z.end,this.end);return new r(ie,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ie=this.end){if(z===null||ie===null)throw(0,F.$7)();let Ie;return z?W.isPosition(z)?Ie=z:(Ie=z.start||this.start,ie=z.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&ie.isEqual(this.end)?this:new r(Ie,ie)}toJSON(){return[this.start,this.end]}};e.$ZL=U,e.$ZL=U=r=Je([b],U);let C=i=class extends U{static isSelection(z){return z instanceof i?!0:z?U.isRange(z)&&W.isPosition(z.anchor)&&W.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ie,Ie,Ge){let _e,ct;if(typeof z=="number"&&typeof ie=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(_e=new W(z,ie),ct=new W(Ie,Ge)):W.isPosition(z)&&W.isPosition(ie)&&(_e=W.of(z),ct=W.of(ie)),!_e||!ct)throw new Error("Invalid arguments");super(_e,ct),this.f=_e,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$1L=C,e.$1L=C=i=Je([b],C);const O=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$7)("connectionToken")};class V{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie,Ie){if(typeof z!="string"||z.length===0)throw(0,F.$7)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,F.$7)("port");typeof Ie<"u"&&O(Ie),this.host=z,this.port=Math.round(ie),this.connectionToken=Ie}}e.$2L=V;class re{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ie){this.makeConnection=z,this.connectionToken=ie,typeof ie<"u"&&O(ie)}}e.$3L=re;class ce extends Error{static NotAvailable(z,ie){return new ce(z,v.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(z){return new ce(z,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ie=v.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(z),this._message=z,this._code=ie,this._detail=Ie,Object.setPrototypeOf(this,ce.prototype)}}e.$4L=ce;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var ke;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(ke||(e.EnvironmentVariableMutatorType=ke={}));let he=n=class{static isTextEdit(z){return z instanceof n?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ie){return new n(z,ie)}static insert(z,ie){return n.replace(new U(z,z),ie)}static delete(z){return n.replace(z,"")}static setEndOfLine(z){const ie=new n(new U(new W(0,0),new W(0,0)),"");return ie.newEol=z,ie}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,F.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,F.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,F.$7)("newEol");this.f=z}constructor(z,ie){this.c=z,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$5L=he,e.$5L=he=n=Je([b],he);let ve=o=class{static isNotebookCellEdit(z){return z instanceof o?!0:z?di.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ie){return new o(z,ie)}static insertCells(z,ie){return new o(new di(z,z),ie)}static deleteCells(z){return new o(z,[])}static updateCellMetadata(z,ie){const Ie=new o(new di(z,z),[]);return Ie.newCellMetadata=ie,Ie}static updateNotebookMetadata(z){const ie=new o(new di(0,0),[]);return ie.newNotebookMetadata=z,ie}constructor(z,ie){this.range=z,this.newCells=ie}};e.$6L=ve,e.$6L=ve=o=Je([b],ve);class se{static isSnippetTextEdit(z){return z instanceof se?!0:z?U.isRange(z.range)&&Y.isSnippetString(z.snippet):!1}static replace(z,ie){return new se(z,ie)}static insert(z,ie){return se.replace(new U(z,z),ie)}constructor(z,ie){this.range=z,this.snippet=ie}}e.$7L=se;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ie,Ie,Ge){this.c.push({_type:1,from:z,to:ie,options:Ie,metadata:Ge})}createFile(z,ie,Ie){this.c.push({_type:1,from:void 0,to:z,options:ie,metadata:Ie})}deleteFile(z,ie,Ie){this.c.push({_type:1,from:z,to:void 0,options:ie,metadata:Ie})}e(z,ie,Ie){this.c.push({_type:3,metadata:Ie,uri:z,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(z,ie,Ie,Ge){const _e=ie.start,ct=ie.end;(_e!==ct||Ie.length>0)&&this.c.push({_type:5,uri:z,index:_e,count:ct-_e,cells:Ie,metadata:Ge})}g(z,ie,Ie,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ie,metadata:Ie}})}replace(z,ie,Ie,Ge){this.c.push({_type:2,uri:z,edit:new he(ie,Ie),metadata:Ge})}insert(z,ie,Ie,Ge){this.replace(z,new U(ie,ie),Ie,Ge)}delete(z,ie,Ie){this.replace(z,ie,"",Ie)}has(z){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===z.toString())}set(z,ie){if(ie)for(const Ie of ie){if(!Ie)continue;let Ge,_e;Array.isArray(Ie)?(Ge=Ie[0],_e=Ie[1]):Ge=Ie,ve.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,_e):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,_e):this.f(z,Ge.range,Ge.newCells,_e):se.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:_e}):this.c.push({_type:2,uri:z,edit:Ge,metadata:_e})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Ge=this.c[Ie];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Ie]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const ie=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===z.toString()&&ie.push(Ie.edit);return ie}entries(){const z=new L.$Ac;for(const ie of this.c)if(ie._type===2){let Ie=z.get(ie.uri);Ie||(Ie=[ie.uri,[]],z.set(ie.uri,Ie)),Ie[1].push(ie.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$8L=te,e.$8L=te=Je([b],te);let Y=l=class{static isSnippetString(z){return z instanceof l?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=l.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ie=this.e++){if(typeof z=="function"){const Ie=new l;Ie.e=this.e,z(Ie),this.e=Ie.e,z=Ie.value}else z=l.c(z);return this.value+="${",this.value+=ie,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ie=this.e++){const Ie=z.map(Ge=>Ge.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(z,ie){if(typeof ie=="function"){const Ie=new l;Ie.e=this.e,ie(Ie),this.e=Ie.e,ie=Ie.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$9L=Y,e.$9L=Y=l=Je([b],Y);var q;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Pe=t=class{static isLocation(z){return z instanceof t?!0:z?U.isRange(z.range)&&D.URI.isUri(z.uri):!1}constructor(z,ie){if(this.uri=z,ie)if(U.isRange(ie))this.range=U.of(ie);else if(W.isPosition(ie))this.range=new U(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$0L=Pe,e.$0L=Pe=t=Je([b],Pe);let Oe=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&D.URI.isUri(z.location.uri):!1}constructor(z,ie){this.location=z,this.message=ie}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.location.range.isEqual(ie.location.range)&&z.location.uri.toString()===ie.location.uri.toString()}};e.$$L=Oe,e.$$L=Oe=Je([b],Oe);let Re=class{constructor(z,ie,Ie=ne.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=z,this.message=ie,this.severity=Ie}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ie){return z===ie?!0:!z||!ie?!1:z.message===ie.message&&z.severity===ie.severity&&z.code===ie.code&&z.severity===ie.severity&&z.source===ie.source&&z.range.isEqual(ie.range)&&(0,S.$ub)(z.tags,ie.tags)&&(0,S.$ub)(z.relatedInformation,ie.relatedInformation,Oe.isEqual)}};e.$_L=Re,e.$_L=Re=Je([b],Re);let be=class{constructor(z,ie){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ie}};e.$aM=be,e.$aM=be=Je([b],be);var me;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(me||(e.DocumentHighlightKind=me={}));let Q=class{constructor(z,ie=me.Text){this.range=z,this.kind=ie}toJSON(){return{range:this.range,kind:me[this.kind]}}};e.$bM=Q,e.$bM=Q=Je([b],Q);let x=class{constructor(z,ie){this.uri=z,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$cM=x,e.$cM=x=Je([b],x);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Me=m=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ie,Ie,Ge,_e){this.name=z,this.kind=ie,this.containerName=_e,typeof Ie=="string"&&(this.containerName=Ie),Ge instanceof Pe?this.location=Ge:Ie instanceof U&&(this.location=new Pe(Ge,Ie)),m.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$dM=Me,e.$dM=Me=m=Je([b],Me);let ge=a=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(a.validate)}constructor(z,ie,Ie,Ge,_e){this.name=z,this.detail=ie,this.kind=Ie,this.range=Ge,this.selectionRange=_e,this.children=[],a.validate(this)}};e.$eM=ge,e.$eM=ge=a=Je([b],ge);var Se;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Se||(e.CodeActionTriggerKind=Se={}));let Ce=class{constructor(z,ie){this.title=z,this.kind=ie}};e.$fM=Ce,e.$fM=Ce=Je([b],Ce);let N=class{static{c=this}static{this.c="."}constructor(z){this.value=z}append(z){return new c(this.value?this.value+c.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+c.c)}};e.$gM=N,e.$gM=N=c=Je([b],N),N.Empty=new N(""),N.QuickFix=N.Empty.append("quickfix"),N.Refactor=N.Empty.append("refactor"),N.RefactorExtract=N.Refactor.append("extract"),N.RefactorInline=N.Refactor.append("inline"),N.RefactorMove=N.Refactor.append("move"),N.RefactorRewrite=N.Refactor.append("rewrite"),N.Source=N.Empty.append("source"),N.SourceOrganizeImports=N.Source.append("organizeImports"),N.SourceFixAll=N.Source.append("fixAll"),N.Notebook=N.Empty.append("notebook");let K=class{constructor(z,ie){if(this.range=z,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$hM=K,e.$hM=K=Je([b],K);class j{constructor(z,ie,Ie,Ge,_e,ct){this.kind=z,this.name=ie,this.detail=Ie,this.uri=Ge,this.range=_e,this.selectionRange=ct}}e.$iM=j;class H{constructor(z,ie){this.fromRanges=ie,this.from=z}}e.$jM=H;class Z{constructor(z,ie){this.fromRanges=ie,this.to=z}}e.$kM=Z;var oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(oe||(e.LanguageStatusSeverity=oe={}));let Ee=class{constructor(z,ie){this.range=z,this.command=ie}get isResolved(){return!!this.command}};e.$lM=Ee,e.$lM=Ee=Je([b],Ee);let Be=E=class{#e;static isMarkdownString(z){return z instanceof E?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ie=!1){this.#e=new P.$qk(z,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ie){return this.#e.appendCodeblock(ie??"",z),this}};e.$mM=Be,e.$mM=Be=E=Je([b],Be);let Ve=class{constructor(z,ie){this.label=z,this.documentation=ie}};e.$nM=Ve,e.$nM=Ve=Je([b],Ve);let Ze=class{constructor(z,ie){this.label=z,this.documentation=ie,this.parameters=[]}};e.$oM=Ze,e.$oM=Ze=Je([b],Ze);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$pM=xe,e.$pM=xe=Je([b],xe);var at;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(at||(e.SignatureHelpTriggerKind=at={}));var nt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(nt||(e.InlayHintKind=nt={}));let et=class{constructor(z){this.value=z}};e.$qM=et,e.$qM=et=Je([b],et);let ut=class{constructor(z,ie,Ie){this.position=z,this.label=ie,this.kind=Ie}};e.$rM=ut,e.$rM=ut=Je([b],ut);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var pt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let _=class{constructor(z,ie){this.label=z,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$sM=_,e.$sM=_=Je([b],_);let pe=class{constructor(z=[],ie=!1){this.items=z,this.isIncomplete=ie}};e.$tM=pe,e.$tM=pe=Je([b],pe);let We=class{constructor(z,ie,Ie){this.insertText=z,this.range=ie,this.command=Ie}};e.$uM=We,e.$uM=We=Je([b],We);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$vM=Qe,e.$vM=Qe=Je([b],Qe);var it;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var rt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(rt||(e.StatusBarAlignment=rt={}));function Te(B,z){return`${k.$um.toKey(B)}.${z}`}e.$wM=Te;var Tt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Tt||(e.TextEditorLineNumbersStyle=Tt={}));var Xt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Xt||(e.TextDocumentSaveReason=Xt={}));var xt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(xt||(e.TextEditorRevealType=xt={}));var Ut;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Dt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Dt||(e.TextDocumentChangeReason=Dt={}));var ei;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ei||(e.DecorationRangeBehavior=ei={})),function(B){function z(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var jt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(jt||(e.SyntaxTokenType=jt={})),function(B){function z(ie){switch(ie){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(jt||(e.SyntaxTokenType=jt={}));let si=class{constructor(z,ie){if(ie&&!D.URI.isUri(ie))throw(0,F.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,F.$7)("range");this.range=z,this.target=ie}};e.$xM=si,e.$xM=si=Je([b],si);let Yt=class{constructor(z,ie,Ie,Ge){this.red=z,this.green=ie,this.blue=Ie,this.alpha=Ge}};e.$yM=Yt,e.$yM=Yt=Je([b],Yt);let _t=class{constructor(z,ie){if(ie&&!(ie instanceof Yt))throw(0,F.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,F.$7)("range");this.range=z,this.color=ie}};e.$zM=_t,e.$zM=_t=Je([b],_t);let Ye=class{constructor(z){if(!z||typeof z!="string")throw(0,F.$7)("label");this.label=z}};e.$AM=Ye,e.$AM=Ye=Je([b],Ye);var Bt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ti;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var ht;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class mt{constructor(z,ie,Ie){if(this.startIndex=z,this.length=ie,this.tooltip=Ie,typeof z!="number"||z<0)throw(0,F.$7)("startIndex");if(typeof ie!="number"||ie<1)throw(0,F.$7)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,F.$7)("tooltip")}}e.$BM=mt;class Gt{constructor(z){this.uri=z}}e.$CM=Gt;class ii{constructor(z){this.terminalCommand=z}}e.$DM=ii;var Pt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,F.$7)("options")}}e.$EM=dt;var At;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var oi;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(oi||(e.TaskPanelKind=oi={}));let Mt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(z){switch(z){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(z,ie){if(this.label=ie,typeof z!="string"||typeof ie!="string")throw(0,F.$7)("name");this.c=z}get id(){return this.c}};e.$FM=Mt,e.$FM=Mt=y=Je([b],Mt);function He(B){let z="";for(let ie=0;ie<B.length;ie++)z+=B[ie].replace(/,/g,",,")+",";return z}let Nt=class{constructor(z,ie,Ie){if(typeof z!="string")throw(0,F.$7)("process");this.e=[],this.c=z,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Ie):this.f=ie)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,F.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)z.push(ie);return He(z)}};e.$GM=Nt,e.$GM=Nt=Je([b],Nt);let Vt=class{constructor(z,ie,Ie){if(this.f=[],Array.isArray(ie)){if(!z)throw(0,F.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,F.$7)("command");this.e=z,this.f=ie,this.g=Ie}else{if(typeof z!="string")throw(0,F.$7)("commandLine");this.c=z,this.g=ie}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,F.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,F.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)z.push(typeof ie=="string"?ie:ie.value);return He(z)}};e.$HM=Vt,e.$HM=Vt=Je([b],Vt);var ni;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(ni||(e.ShellQuoting=ni={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Ft{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$yg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$IM=Ft;let Ct=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ie,Ie,Ge,_e,ct){this.k=!1,this.l=this.definition=z;let gt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=Ie,this.execution=Ge,gt=_e,this.k=!0):ie===ft.Global||ie===ft.Workspace?(this.target=ie,this.o=this.name=Ie,this.w=this.source=Ge,this.execution=_e,gt=ct):(this.target=ie,this.o=this.name=Ie,this.w=this.source=Ge,this.execution=_e,gt=ct),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Vt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,A.$yg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,F.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,F.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ie=this.l.type;($.g===ie||$.e===ie||$.f===ie||$.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,F.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$JM=Ct,e.$JM=Ct=$=Je([b],Ct);var zt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(zt||(e.ProgressLocation=zt={}));var Wt;(function(B){function z(ie){const Ie=ie;return(0,f.$Uf)(Ie.value)?Ie.tooltip&&!(0,f.$Qf)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}B.isViewBadge=z})(Wt||(e.ViewBadge=Wt={}));let qt=I=class{static isTreeItem(z,ie){const Ie=z;if(Ie.checkboxState!==void 0){const Ge=(0,f.$Uf)(Ie.checkboxState)?Ie.checkboxState:(0,f.$Sf)(Ie.checkboxState)&&(0,f.$Uf)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,_e=!(0,f.$Uf)(Ie.checkboxState)&&(0,f.$Sf)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Jt.Checked&&Ge!==Jt.Unchecked||_e!==void 0&&!(0,f.$Qf)(_e))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(z instanceof I)return!0;if(Ie.label!==void 0&&!(0,f.$Qf)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,f.$Qf)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,f.$Qf)(Ie.iconPath)&&!D.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,f.$Qf)(Ie.iconPath.id))){const Ge=Ie.iconPath;if(!Ge||!(0,f.$Qf)(Ge.light)&&!D.URI.isUri(Ge.light)&&!(0,f.$Qf)(Ge.dark)&&!D.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,f.$Qf)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!D.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,f.$Qf)(Ie.tooltip)&&!(Ie.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<St.None&&Ie.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,f.$Qf)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(z,ie=St.None){this.collapsibleState=ie,D.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$KM=qt,e.$KM=qt=I=Je([b],qt);var St;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var Jt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Jt||(e.TreeItemCheckboxState=Jt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$LM=Et,e.$LM=Et=Je([b],Et);class bt extends Et{}e.$MM=bt;class It extends bt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$NM=It;class kt{constructor(z,ie,Ie,Ge){this.name=z,this.uri=ie,this._itemId=Ie,this.c=Ge}data(){return this.c()}}e.$OM=kt;let ci=class{#e=new Map;constructor(z){for(const[ie,Ie]of z??[]){const Ge=this.#e.get(this.#t(ie));Ge?Ge.push(Ie):this.#e.set(this.#t(ie),[Ie])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ie){this.#e.set(this.#t(z),[ie])}forEach(z,ie){for(const[Ie,Ge]of this.#e)for(const _e of Ge)z.call(ie,_e,Ie,this)}*[Symbol.iterator](){for(const[z,ie]of this.#e)for(const Ie of ie)yield[z,Ie]}#t(z){return z.toLowerCase()}};e.$PM=ci,e.$PM=ci=Je([b],ci);let Qt=class{constructor(z){this.insertText=z}};e.$QM=Qt,e.$QM=Qt=Je([b],Qt);let pi=class{constructor(z,ie){this.label=ie,this.insertText=z}};e.$RM=pi,e.$RM=pi=Je([b],pi);let Ht=class{constructor(z,ie){this.id=z,this.color=ie}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$SM=Ht,e.$SM=Ht=Je([b],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let we=class{constructor(z){this.id=z}};e.$TM=we,e.$TM=we=Je([b],we);var Ae;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ae||(e.ConfigurationTarget=Ae={}));let ue=class{get base(){return this.c}set base(z){this.c=z,this.e=D.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ie){if(typeof z!="string"&&(!z||!D.URI.isUri(z)&&!D.URI.isUri(z.uri)))throw(0,F.$7)("base");if(typeof ie!="string")throw(0,F.$7)("pattern");typeof z=="string"?this.baseUri=D.URI.file(z):D.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$UM=ue,e.$UM=ue=Je([b],ue);const J=new WeakMap;function De(B,z){J.set(B,z)}e.$VM=De;let Ue=class{constructor(z,ie,Ie,Ge,_e){this.enabled=typeof z=="boolean"?z:!0,typeof ie=="string"&&(this.condition=ie),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ge=="string"&&(this.logMessage=Ge),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=J.get(this)??(0,A.$yg)()),this.c}};e.$WM=Ue,e.$WM=Ue=Je([b],Ue);let Xe=class extends Ue{constructor(z,ie,Ie,Ge,_e,ct){if(super(ie,Ie,Ge,_e,ct),z===null)throw(0,F.$7)("location");this.location=z}};e.$XM=Xe,e.$XM=Xe=Je([b],Xe);let Ke=class extends Ue{constructor(z,ie,Ie,Ge,_e,ct){super(ie,Ie,Ge,_e,ct),this.functionName=z}};e.$YM=Ke,e.$YM=Ke=Je([b],Ke);let st=class extends Ue{constructor(z,ie,Ie,Ge,_e,ct,gt,Kt){if(super(Ge,_e,ct,gt,Kt),!ie)throw(0,F.$7)("dataId");this.label=z,this.dataId=ie,this.canPersist=Ie}};e.$ZM=st,e.$ZM=st=Je([b],st);let wt=class{constructor(z,ie,Ie){this.command=z,this.args=ie||[],this.options=Ie}};e.$1M=wt,e.$1M=wt=Je([b],wt);let yt=class{constructor(z,ie){this.port=z,this.host=ie}};e.$2M=yt,e.$2M=yt=Je([b],yt);let Zt=class{constructor(z){this.path=z}};e.$3M=Zt,e.$3M=Zt=Je([b],Zt);let Rt=class{constructor(z){this.implementation=z}};e.$4M=Rt,e.$4M=Rt=Je([b],Rt);let Ot=class{constructor(z,ie,Ie){this.session=z,this.threadId=ie,this.frameId=Ie}};e.$5M=Ot,e.$5M=Ot=Je([b],Ot);let vi=class{constructor(z,ie){this.session=z,this.threadId=ie}};e.$6M=vi,e.$6M=vi=Je([b],vi);let lt=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$7M=lt,e.$7M=lt=Je([b],lt);var Xi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Xi||(e.InlineCompletionTriggerKind=Xi={}));let ui=class{constructor(z,ie){this.range=z,this.text=ie}};e.$8M=ui,e.$8M=ui=Je([b],ui);let gi=class{constructor(z,ie,Ie=!0){this.range=z,this.variableName=ie,this.caseSensitiveLookup=Ie}};e.$9M=gi,e.$9M=gi=Je([b],gi);let yi=class{constructor(z,ie){this.range=z,this.expression=ie}};e.$0M=yi,e.$0M=yi=Je([b],yi);let Ri=class{constructor(z,ie){this.frameId=z,this.stoppedLocation=ie}};e.$$M=Ri,e.$$M=Ri=Je([b],Ri);var Yi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Yi||(e.NewSymbolNameTag=Yi={}));class hn{constructor(z,ie){this.newSymbolName=z,this.tags=ie}}e.$_M=hn;var Ai;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ai||(e.FileChangeType=Ai={}));let Mi=d=class extends Error{static FileExists(z){return new d(z,h.FileSystemProviderErrorCode.FileExists,d.FileExists)}static FileNotFound(z){return new d(z,h.FileSystemProviderErrorCode.FileNotFound,d.FileNotFound)}static FileNotADirectory(z){return new d(z,h.FileSystemProviderErrorCode.FileNotADirectory,d.FileNotADirectory)}static FileIsADirectory(z){return new d(z,h.FileSystemProviderErrorCode.FileIsADirectory,d.FileIsADirectory)}static NoPermissions(z){return new d(z,h.FileSystemProviderErrorCode.NoPermissions,d.NoPermissions)}static Unavailable(z){return new d(z,h.FileSystemProviderErrorCode.Unavailable,d.Unavailable)}constructor(z,ie=h.FileSystemProviderErrorCode.Unknown,Ie){super(D.URI.isUri(z)?z.toString(!0):z),this.code=Ie?.name??"Unknown",(0,h.$Ok)(this,ie),Object.setPrototypeOf(this,d.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$aN=Mi,e.$aN=Mi=d=Je([b],Mi);let Ei=class{constructor(z,ie,Ie){this.start=z,this.end=ie,this.kind=Ie}};e.$bN=Ei,e.$bN=Ei=Je([b],Ei);var mi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(mi||(e.FoldingRangeKind=mi={}));var _i;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var Di;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Di||(e.CommentMode=Di={}));var ki;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ki||(e.CommentState=ki={}));var xi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(xi||(e.CommentThreadState=xi={}));class dn{constructor(z,ie=[]){this.tokenTypes=z,this.tokenModifiers=ie}}e.$cN=dn;function bi(B){return typeof B>"u"||(0,f.$Rf)(B)}class Fi{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ie=0,Ie=z.tokenTypes.length;ie<Ie;ie++)this.k.set(z.tokenTypes[ie],ie);for(let ie=0,Ie=z.tokenModifiers.length;ie<Ie;ie++)this.l.set(z.tokenModifiers[ie],ie)}}push(z,ie,Ie,Ge,_e){if(typeof z=="number"&&typeof ie=="number"&&typeof Ie=="number"&&typeof Ge=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(z,ie,Ie,Ge,_e);if(U.isRange(z)&&typeof ie=="string"&&bi(Ie))return this.o(z,ie,Ie);throw(0,F.$7)()}o(z,ie,Ie){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,_e=z.start.character,ct=z.end.character-z.start.character,gt=this.k.get(ie);let Kt=0;if(Ie)for(const ai of Ie){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Kt|=1<<hi>>>0}this.q(Ge,_e,ct,gt,Kt)}q(z,ie,Ie,Ge,_e){if(this.f&&(z<this.c||z===this.c&&ie<this.e)){this.f=!1;const Kt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Kt;fi++){let $i=this.g[5*fi],Qi=this.g[5*fi+1];$i===0?($i=ai,Qi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Qi,ai=$i,hi=Qi}}let ct=z,gt=ie;this.f&&this.j>0&&(ct-=this.c,ct===0&&(gt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=gt,this.g[this.j++]=Ie,this.g[this.j++]=Ge,this.g[this.j++]=_e,this.c=z,this.e=ie}static r(z){const ie=[],Ie=z.length/5|0;for(let gt=0;gt<Ie;gt++)ie[gt]=gt;ie.sort((gt,Kt)=>{const ai=z[5*gt],hi=z[5*Kt];if(ai===hi){const fi=z[5*gt+1],$i=z[5*Kt+1];return fi-$i}return ai-hi});const Ge=new Uint32Array(z.length);let _e=0,ct=0;for(let gt=0;gt<Ie;gt++){const Kt=5*ie[gt],ai=z[Kt+0],hi=z[Kt+1],fi=z[Kt+2],$i=z[Kt+3],Qi=z[Kt+4],Cn=ai-_e,Yn=Cn===0?hi-ct:hi,Zi=5*gt;Ge[Zi+0]=Cn,Ge[Zi+1]=Yn,Ge[Zi+2]=fi,Ge[Zi+3]=$i,Ge[Zi+4]=Qi,_e=ai,ct=hi}return Ge}build(z){return this.f?new Li(new Uint32Array(this.g),z):new Li(Fi.r(this.g),z)}}e.$dN=Fi;class Li{constructor(z,ie){this.resultId=ie,this.data=z}}e.$eN=Li;class fn{constructor(z,ie,Ie){this.start=z,this.deleteCount=ie,this.data=Ie}}e.$fN=fn;class Si{constructor(z,ie){this.resultId=ie,this.edits=z}}e.$gN=Si;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));class gn{constructor(z){this.name=z}}e.$hN=gn;let wi=class{static{this.Back={iconPath:new Ht("arrow-left")}}constructor(){}};e.$iN=wi,e.$iN=wi=Je([b],wi);var Oi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Oi||(e.QuickPickItemKind=Oi={}));var tn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var Ti;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class nn{static validate(z){if(typeof z.badge=="string"){let ie=(0,g.$rf)(z.badge,0);if(ie<z.badge.length&&(ie+=(0,g.$rf)(z.badge,ie)),z.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Ht.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ie,Ie){this.badge=z,this.tooltip=ie,this.color=Ie}}e.$jN=nn;let Ni=class{constructor(z){this.kind=z}};e.$kN=Ni,e.$kN=Ni=Je([b],Ni);var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class di{static isNotebookRange(z){return z instanceof di?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ie){if(z<0)throw(0,F.$7)("start must be positive");if(ie<0)throw(0,F.$7)("end must be positive");z<=ie?(this.c=z,this.e=ie):(this.c=ie,this.e=z)}with(z){let ie=this.c,Ie=this.e;return z.start!==void 0&&(ie=z.start),z.end!==void 0&&(Ie=z.end),ie===this.c&&Ie===this.e?this:new di(ie,Ie)}}e.$lN=di;class Ii{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ie=>Ii.isNotebookCellData(ie))}static isNotebookCellData(z){return!0}constructor(z,ie,Ie,Ge,_e,ct,gt){this.kind=z,this.value=ie,this.languageId=Ie,this.mime=Ge,this.outputs=_e??[],this.metadata=ct,this.executionSummary=gt,Ii.validate(this)}}e.$mN=Ii;class zi{constructor(z){this.cells=z}}e.$nN=zi;class ri{static isNotebookCellOutputItem(z){return z instanceof ri?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ie={name:z.name,message:z.message,stack:z.stack};return ri.json(ie,"application/vnd.code.notebook.error")}static stdout(z){return ri.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return ri.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ie="application/octet-stream"){return new ri(z,ie)}static#e=new TextEncoder;static text(z,ie=R.$os.text){const Ie=ri.#e.encode(String(z));return new ri(Ie,ie)}static json(z,ie="text/x-json"){const Ie=JSON.stringify(z,void 0,"	");return ri.text(Ie,ie)}constructor(z,ie){this.data=z,this.mime=ie;const Ie=(0,R.$ss)(ie,!0);if(!Ie)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$oN=ri;class Ne{static isNotebookCellOutput(z){return z instanceof Ne?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ie=!1){const Ie=new Set,Ge=new Set;for(let _e=0;_e<z.length;_e++){const ct=z[_e],gt=(0,R.$ss)(ct.mime);if(!Ie.has(gt)||(0,p.$XJ)(gt)){Ie.add(gt);continue}Ge.add(_e),ie&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ge.size===0?z:z.filter((_e,ct)=>!Ge.has(ct))}constructor(z,ie,Ie){this.items=Ne.ensureUniqueMimeTypes(z,!0),typeof ie=="string"?(this.id=ie,this.metadata=Ie):(this.id=(0,A.$yg)(),this.metadata=ie??Ie)}}e.$pN=Ne;var li;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var Ui;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ui||(e.NotebookCellExecutionState=Ui={}));var tt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(tt||(e.NotebookCellStatusBarAlignment=tt={}));var $t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})($t||(e.NotebookEditorRevealType=$t={}));class mn{constructor(z,ie){this.text=z,this.alignment=ie}}e.$qN=mn;var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var ji;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ji||(e.NotebookControllerAffinity2=ji={}));class $n{constructor(z,ie=[]){this.uri=z,this.provides=(0,S.$3b)(ie)}}e.$rN=$n;class Ci{constructor(z){this.label=z}}e.$sN=Ci;var on;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor(z,ie){this.label=z,this.timestamp=ie}};e.$tN=Bi,e.$tN=Bi=Je([b],Bi);var an;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(an||(e.ExtensionMode=an={}));var Vi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(Vi||(e.ExtensionRuntime=Vi={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class pn{constructor(z,ie){this.ranges=z,this.wordPattern=ie}}e.$uN=pn;class vn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$vN=vn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Wi=class{constructor(z=void 0,ie=void 0,Ie=void 0,Ge=!1){this.include=z,this.exclude=ie,this.profile=Ie,this.continuous=Ge}};e.$wN=Wi,e.$wN=Wi=Je([b],Wi);let qi=w=class{static diff(z,ie,Ie){const Ge=new w(z);return Ge.expectedOutput=ie,Ge.actualOutput=Ie,Ge}constructor(z){this.message=z}};e.$xN=qi,e.$xN=qi=w=Je([b],qi);let Hi=class{constructor(z){this.id=z}};e.$yN=Hi,e.$yN=Hi=Je([b],Hi);class Pi{constructor(z,ie){this.covered=z,this.total=ie}}e.$zN=Pi;const Ki=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Gi{static fromDetails(z,ie){const Ie=new Pi(0,0),Ge=new Pi(0,0),_e=new Pi(0,0);for(const gt of ie)if("branches"in gt){Ie.total+=1,Ie.covered+=gt.executed?1:0;for(const Kt of gt.branches)Ge.total+=1,Ge.covered+=Kt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const ct=new Gi(z,Ie,Ge.total>0?Ge:void 0,_e.total>0?_e:void 0);return ct.detailedCoverage=ie,ct}constructor(z,ie,Ie,Ge){this.uri=z,this.statementCoverage=ie,this.branchCoverage=Ie,this.declarationCoverage=Ge,Ki(ie),Ki(Ie),Ki(Ge)}}e.$AN=Gi;class ee{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Ie=[]){this.executed=z,this.location=ie,this.branches=Ie}}e.$BN=ee;class ae{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Ie){this.executed=z,this.location=ie,this.label=Ie}}e.$CN=ae;class ze{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ie,Ie){this.name=z,this.executed=ie,this.location=Ie}}e.$DN=ze;var ot;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ot||(e.ExternalUriOpenerPriority=ot={}));var vt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(vt||(e.WorkspaceTrustState=vt={}));var Lt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Lt||(e.PortAutoForwardAction=Lt={}));class Ji{constructor(z,ie,Ie,Ge,_e,ct){this.kind=z,this.name=ie,this.detail=Ie,this.uri=Ge,this.range=_e,this.selectionRange=ct}}e.$EN=Ji;class Pn{constructor(z){this.uri=z}}e.$FN=Pn;class Rn{constructor(z,ie){this.original=z,this.modified=ie}}e.$GN=Rn;class An{constructor(z,ie,Ie,Ge){this.base=z,this.input1=ie,this.input2=Ie,this.result=Ge}}e.$HN=An;class Mn{constructor(z,ie){this.uri=z,this.viewType=ie}}e.$IN=Mn;class Fn{constructor(z){this.viewType=z}}e.$JN=Fn;class Ln{constructor(z,ie){this.uri=z,this.notebookType=ie}}e.$KN=Ln;class On{constructor(z,ie,Ie){this.original=z,this.modified=ie,this.notebookType=Ie}}e.$LN=On;class Tn{constructor(){}}e.$MN=Tn;class Nn{constructor(z,ie){this.uri=z,this.inputBoxUri=ie}}e.$NN=Nn;class zn{constructor(z){this.providerId=z}}e.$ON=zn;var bn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var wn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(wn||(e.ChatAgentCopyKind=wn={}));var yn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Un{constructor(z,ie){this.label=z,this.values=ie}}e.$PN=Un;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));class jn{constructor(z){this.value=z}}e.$QN=jn;class Bn{constructor(z){this.value=typeof z=="string"?new Be(z):z}}e.$RN=Bn;class Vn{constructor(z,ie){this.value=z,this.baseUri=ie}}e.$SN=Vn;class Wn{constructor(z,ie){this.value=z,this.title=ie}}e.$TN=Wn;class qn{constructor(z){this.value=z}}e.$UN=qn;class Hn{constructor(z){this.value=z}}e.$VN=Hn;class Kn{constructor(z){this.value=z}}e.$WN=Kn;class Gn{constructor(z,ie,Ie,Ge){this.prompt=z,this.command=ie,this.variables=Ie,this.agent=Ge}}e.$XN=Gn;class Jn{constructor(z,ie,Ie){this.response=z,this.result=ie,this.agent=Ie}}e.$YN=Jn;class Qn{constructor(z){this.content=z}}e.$ZN=Qn;class Zn{constructor(z,ie){this.content=z,this.name=ie}}e.$1N=Zn;class Xn{constructor(z){this.content=z}}e.$2N=Xn;var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Fe[240],Le([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$VL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,g,f){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(R);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(g,f)??[]}getRelatedInformation(R,g,f){return this.c.$getAiRelatedInformation(g,f)}registerRelatedInformationProvider(R,g,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiRelatedInformationProvider(D,g),new F.$XL(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$5gc=P}),define(Fe[241],Le([1,0,5,3,7,22,104]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class g{constructor(A){this.b=new Map,this.c=new S.$3d,this.onDidChangeSessions=this.c.event,this.d=new f,this.f=new f,this.a=A.getProxy(F.$VL.MainThreadAuthentication)}async getSession(A,k,h,v={}){const p=L.$um.toKey(A.identifier),s=[...h].sort().join(" ");return await this.d.getOrCreate(`${p} ${k} ${s}`,async()=>{await this.a.$ensureProvider(k);const u=A.displayName||A.name;return this.a.$getSession(k,h,p,u,v)})}async getSessions(A,k,h){const v=L.$um.toKey(A.identifier),p=[...h].sort().join(" ");return await this.f.getOrCreate(`${v} ${p}`,async()=>{await this.a.$ensureProvider(k);const s=A.displayName||A.name;return this.a.$getSessions(k,h,v,s)})}async removeSession(A,k){const h=this.b.get(A);return h?h.provider.removeSession(k):this.a.$removeSession(A,k)}registerAuthenticationProvider(A,k,h,v){if(this.b.get(A))throw new Error(`An authentication provider with id '${A}' is already registered.`);this.b.set(A,{label:k,provider:h,options:v??{supportsMultipleAccounts:!1}});const p=h.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(A,s));return this.a.$registerAuthenticationProvider(A,k,v?.supportsMultipleAccounts??!1),new P.$XL(()=>{p.dispose(),this.b.delete(A),this.a.$unregisterAuthenticationProvider(A)})}$createSession(A,k,h){const v=this.b.get(A);if(v)return Promise.resolve(v.provider.createSession(k,h));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$removeSession(A,k){const h=this.b.get(A);if(h)return Promise.resolve(h.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$getSessions(A,k){const h=this.b.get(A);if(h)return Promise.resolve(h.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${A}`)}$onDidChangeAuthenticationSessions(A,k){return A.startsWith(R.$2K)||this.c.fire({provider:{id:A,label:k}}),Promise.resolve()}}e.$dhc=g;class f{constructor(){this.a=new Map}getOrCreate(A,k){const h=this.a.get(A);if(h)return h;const v=k().finally(()=>this.a.delete(A));return this.a.set(A,v),v}}}),define(Fe[108],Le([1,0,2,3,7,4,17,14,18,13,19,23]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=e.$cic=void 0;let v=class{static{h=this}static{this.c=0}static{this.d=250}constructor(s,u){this.h=u,this.f=new Map,this.g=s.getProxy(F.$VL.MainThreadDecorations)}registerFileDecorationProvider(s,u){const r=h.c++;this.f.set(r,{provider:s,extensionDescription:u}),this.g.$registerDecorationProvider(r,u.identifier.value);const i=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const o=(0,f.$3b)(n);if(o.length<=h.d){this.g.$onDidChange(r,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",u.identifier.value,o.length);const l=o.map(a=>({uri:a,rank:(0,D.$We)(a.path,"/")})),t=(0,f.$zb)(l,(a,c)=>a.rank-c.rank||(0,D.$af)(a.uri.path,c.uri.path)),m=[];e:for(const a of t){let c;for(const E of a){const y=(0,A.$mc)(E.uri.path);if(c!==y&&(c=y,m.push(E.uri)>=h.d))break e}}this.g.$onDidChange(r,m)});return new P.$XL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,u,r){if(!this.f.has(s))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(s);return await Promise.all(u.map(async l=>{try{const{uri:t,id:m}=l,a=await Promise.resolve(n.provideFileDecoration(S.URI.revive(t),r));if(!a)return;try{P.$jN.validate(a),a.badge&&typeof a.badge!="string"&&(0,k.$SF)(o,"codiconDecoration"),i[m]=[a.propagate,a.tooltip,a.badge,a.color]}catch(c){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),i}};e.$cic=v,e.$cic=v=h=Je([qe(0,R.$aO),qe(1,g.$wj)],v),e.$dic=(0,L.$ci)("IExtHostDecorations")}),define(Fe[242],Le([1,0,15,2,7,3,12,21,13]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;class D{static{this.a=0}constructor(k,h,v){this.d=h,this.e=v,this.b=new Map,this.c=k.getProxy(L.$VL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,h){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const v=D.a++;this.b.set(v,h),this.c.$registerTextContentProvider(v,k);let p;if(typeof h.onDidChange=="function"){let s;p=h.onDidChange(async u=>{if(u.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${u.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(u))return;s&&await s;const r=this.$provideTextDocumentContent(v,u).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(u);if(!n)return;const o=(0,f.$7e)(i);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(u,i)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new P.$XL(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(k,h){const v=this.b.get(k);return v?Promise.resolve(v.provideTextDocumentContent(F.URI.revive(h),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.$fic=D}),define(Fe[109],Le([1,0,54,12,13,298,148,7,18]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eO=e.$dO=e.$cO=void 0;const D=new Map;function A(p,s){s?D.set(p,s):D.delete(p)}e.$cO=A;function k(p){return D.get(p)}class h extends L.$uv{constructor(s,u,r,i,n,o,l,t){super(u,r,i,n),this.c=s,this.m=o,this.q=l,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===F.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(u){return u?s.s(u):s.getText()},get eol(){return s.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(u){return s.t(u)},offsetAt(u){return s.u(u)},positionAt(u){return s.v(u)},validateRange(u){return s.w(u)},validatePosition(u){return s.x(u)},getWordRangeAtPosition(u,r){return s.y(u,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const u=this.w(s);if(u.isEmpty)return"";if(u.isSingleLine)return this.f[u.start.line].substring(u.start.character,u.end.character);const r=this.g,i=u.start.line,n=u.end.line,o=[];o.push(this.f[i].substring(u.start.character));for(let l=i+1;l<n;l++)o.push(this.f[l]);return o.push(this.f[n].substring(0,u.end.character)),o.join(r)}t(s){let u;if(s instanceof g.$YL?u=s.line:typeof s=="number"&&(u=s),typeof u!="number"||u<0||u>=this.f.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new v(u,this.f[u],u===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const u=this.j.getIndexOf(s),r=this.f[u.index].length;return new g.$YL(u.index,Math.min(u.remainder,r))}w(s){if(!(s instanceof g.$ZL))throw new Error("Invalid argument");const u=this.x(s.start),r=this.x(s.end);return u===s.start&&r===s.end?s:new g.$ZL(u.line,u.character,r.line,r.character)}x(s){if(!(s instanceof g.$YL))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:u,character:r}=s,i=!1;if(u<0)u=0,r=0,i=!0;else if(u>=this.f.length)u=this.f.length-1,r=this.f[u].length,i=!0;else{const n=this.f[u].length;r<0?(r=0,i=!0):r>n&&(r=n,i=!0)}return i?new g.$YL(u,r):s}y(s,u){const r=this.x(s);if(!u)u=k(this.m);else if((0,P.$6e)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const i=(0,R.$Gs)(r.character+1,(0,R.$Es)(u),this.f[r.line],0);if(i)return new g.$ZL(r.line,i.startColumn-1,r.line,i.endColumn-1)}}e.$dO=h;class v{constructor(s,u,r){this.a=s,this.b=u,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$ZL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$ZL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$eO=v}),define(Fe[243],Le([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$VL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,g,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(R);if(!D)throw new Error("Embedding vector provider not found");const A=await D.provideEmbeddingVector(g,f);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,g,f){const D=this.b;return this.b++,this.a.set(D,f),this.c.$registerAiEmbeddingVectorProvider(g,D),new F.$XL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$hic=P}),define(Fe[62],Le([1,0,3,42,7,24,4,17,43,6,11,25,12]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=void 0;let p=v=class{constructor(u,r){this.b=new Map,this.c=new A.$lh,this.a=u.getProxy(S.$VL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const l=i.b.get(n.scheme);return l?(await i.a.$ensureActivation(n.scheme),o=await l.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(l.impl,l.extUri,l.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(l.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,L.$qe.wrap(o))}catch(l){return v.e(l)}},async delete(n,o){try{const l=i.b.get(n.scheme);return l&&!l.isReadonly&&!o?.useTrash?(await i.a.$ensureActivation(n.scheme),await l.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return v.e(l)}},async rename(n,o,l){try{return await i.a.$rename(n,o,{overwrite:!1,...l})}catch(t){return v.e(t)}},async copy(n,o,l){try{return await i.a.$copy(n,o,{overwrite:!1,...l})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=r.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(u,r,i){const n=[];for(;!r.isEqual(i,r.dirname(i));)try{if(!((await u.stat(i)).type&F.FileType.Directory))throw P.$aN.FileExists(`Unable to create folder '${i.scheme===h.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$Pk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(r.basename(i)),i=r.dirname(i)}for(let o=n.length-1;o>=0;o--){i=r.joinPath(i,n[o]);try{await u.createDirectory(i)}catch(l){if(F.$Pk(l)!==F.FileSystemProviderErrorCode.FileExists)throw l}}}static e(u){if(u instanceof P.$aN)throw u;if(u instanceof F.$Lk)switch(u.code){case F.FileSystemProviderErrorCode.FileExists:throw P.$aN.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$aN.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$aN.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$aN.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$aN.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$aN.Unavailable(u.message);default:throw new P.$aN(u.message,u.name)}if(!(u instanceof Error))throw new P.$aN(String(u));if(u.name==="ENOPRO"||u.message.includes("ENOPRO"))throw P.$aN.Unavailable(u.message);switch(u.name){case F.FileSystemProviderErrorCode.FileExists:throw P.$aN.FileExists(u.message);case F.FileSystemProviderErrorCode.FileNotFound:throw P.$aN.FileNotFound(u.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw P.$aN.FileNotADirectory(u.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw P.$aN.FileIsADirectory(u.message);case F.FileSystemProviderErrorCode.NoPermissions:throw P.$aN.NoPermissions(u.message);case F.FileSystemProviderErrorCode.Unavailable:throw P.$aN.Unavailable(u.message);default:throw new P.$aN(u.message,u.name)}}addFileSystemProvider(u,r,i){return this.b.set(u,{impl:r,extUri:i?.isCaseSensitive?k.$Fg:k.$Hg,isReadonly:!!i?.isReadonly}),(0,D.$Rc)(()=>this.b.delete(u))}getFileSystemProviderExtUri(u){return this.b.get(u)?.extUri??k.$Fg}};e.$uhc=p,e.$uhc=p=v=Je([qe(0,g.$aO),qe(1,f.$0gc)],p),e.$vhc=(0,R.$ci)("IExtHostConsumerFileSystem")}),define(Fe[244],Le([1,0,3,7]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yic=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$VL.MainThreadIssueReporter)}async $getIssueReporterUri(R,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const D=await f.handleIssueUrlRequest();if(!D)throw new Error("Issue request handler returned no result");return D}async $getIssueReporterData(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueData(g);if(!D)throw new Error("Issue data provider returned no result");return D}async $getIssueReporterTemplate(R,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const D=await f.provideIssueTemplate(g);if(!D)throw new Error("Issue template provider returned no result");return D}registerIssueUriRequestHandler(R,g){const f=R.identifier.value;return this.a.set(f,g),this.c.$registerIssueUriRequestHandler(f),new F.$XL(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,g){const f=R.identifier.value;return this.b.set(f,g),this.c.$registerIssueDataProvider(f),new F.$XL(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$yic=P}),define(Fe[84],Le([1,0,4,27,14,62,2]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0,e.$whc=(0,S.$ci)("IExtensionStoragePaths");let g=class{constructor(D,A,k){this.d=A,this.f=k,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(h=>this.c=h)}async g(D){return R.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,A=await this.g(D);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(D){if(this.c)return R.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return R.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$xhc=g,e.$xhc=g=Je([qe(0,F.$qO),qe(1,P.$wj),qe(2,L.$vhc)],g)}),define(Fe[245],Le([1,0,7,17,5]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let L=class{constructor(g){this.a=new S.$kN(S.ColorThemeKind.Dark),this.b=new P.$3d}get activeColorTheme(){return this.a}$onColorThemeChange(g){let f;switch(g){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$kN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$2ic=L,e.$2ic=L=Je([qe(0,F.$aO)],L)}),define(Fe[85],Le([1,0,21,5,6,169,4,14,198,3,27,17,7]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Szb=e.$Rzb=e.TunnelDtoConverter=void 0;class v extends f.$Sv{}var p;(function(u){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:n.protocol}}u.fromApiTunnel=r;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==f.TunnelPrivacyId.ConstantPrivate&&n.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}u.fromServiceTunnel=i})(p||(e.TunnelDtoConverter=p={})),e.$Rzb=(0,R.$ci)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(r,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$3d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(D.$VL.MainThreadTunnelService)}async openTunnel(r,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,r.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,i){const n=this.u();return this.r.set(n,{selector:r,provider:i}),this.a.$registerPortsAttributesProvider(r,n),new h.$XL(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,i,n,o,l){const t=[];for(const a of r){const c=this.r.get(a);if(!c)return[];t.push(...await Promise.all(i.map(async E=>{let y;try{y=await c.provider.providePortAttributes({port:E,pid:n,commandLine:o},l)}catch{y=await c.provider.providePortAttributes(E,n,o,l)}return{providedAttributes:y,port:E}})))}const m=t.filter(a=>!!a.providedAttributes);return m.length>0?m.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await r.provideTunnel(o,l,new S.$ae().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,i){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const l=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,i){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(i&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:o,disposeListener:l}),p.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const i=await Promise.all(r.map(o=>this.f(o.host,o.port,o.detail??""))),n=r.filter((o,l)=>i[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Szb=s,e.$Szb=s=Je([qe(0,k.$aO),qe(1,A.$qO),qe(2,g.$wj)],s)}),define(Fe[8],Le([1,0,18,24,128,246,46,28,121,52,69,26,25,16,2,29,86,98,103,102,83,49,59,217,23,7]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$_N=e.$$N=e.MarkdownString=e.$0N=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var E;(function(we){function Ae(J){const{selectionStartLineNumber:De,selectionStartColumn:Ue,positionLineNumber:Xe,positionColumn:Ke}=J,st=new c.$YL(De-1,Ue-1),wt=new c.$YL(Xe-1,Ke-1);return new c.$1L(st,wt)}we.to=Ae;function ue(J){const{anchor:De,active:Ue}=J;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}we.from=ue})(E||(e.Selection=E={}));var y;(function(we){function Ae(J){if(!J)return;const{start:De,end:Ue}=J;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}we.from=Ae;function ue(J){if(!J)return;const{startLineNumber:De,startColumn:Ue,endLineNumber:Xe,endColumn:Ke}=J;return new c.$ZL(De-1,Ue-1,Xe-1,Ke-1)}we.to=ue})(y||(e.Range=y={}));var $;(function(we){function Ae(J){return{uri:J.uri,range:y.from(J.range)}}we.from=Ae;function ue(J){return new c.$0L(p.URI.revive(J.uri),y.to(J.range))}we.to=ue})($||(e.Location=$={}));var I;(function(we){function Ae(ue){switch(ue){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 3:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}we.to=Ae})(I||(e.TokenType=I={}));var d;(function(we){function Ae(J){return new c.$YL(J.lineNumber-1,J.column-1)}we.to=Ae;function ue(J){return{lineNumber:J.line+1,column:J.character+1}}we.from=ue})(d||(e.Position=d={}));var w;(function(we){function Ae(De,Ue,Xe){return(0,S.$Hb)((0,S.$3b)(De).map(Ke=>ue(Ke,Ue,Xe)))}we.from=Ae;function ue(De,Ue,Xe){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Xe?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:J(De.scheme,Ue),pattern:pe.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Xe?.isBuiltin}}function J(De,Ue){return Ue&&typeof De=="string"?Ue.transformOutgoingScheme(De):De}})(w||(e.DocumentSelector=w={}));var b;(function(we){function Ae(J){switch(J){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}we.from=Ae;function ue(J){switch(J){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}we.to=ue})(b||(e.DiagnosticTag=b={}));var M;(function(we){function Ae(J){let De;return J.code&&((0,v.$Qf)(J.code)||(0,v.$Uf)(J.code)?De=String(J.code):De={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:De,severity:G.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(T.from),tags:Array.isArray(J.tags)?(0,S.$Hb)(J.tags.map(b.from)):void 0}}we.from=Ae;function ue(J){const De=new c.$_L(y.to(J),J.message,G.to(J.severity));return De.source=J.source,De.code=(0,v.$Qf)(J.code)?J.code:J.code?.value,De.relatedInformation=J.relatedInformation&&J.relatedInformation.map(T.to),De.tags=J.tags&&(0,S.$Hb)(J.tags.map(b.to)),De}we.to=ue})(M||(e.Diagnostic=M={}));var T;(function(we){function Ae(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}we.from=Ae;function ue(J){return new c.$$L(new c.$0L(J.resource,y.to(J)),J.message)}we.to=ue})(T||(e.DiagnosticRelatedInformation=T={}));var G;(function(we){function Ae(J){switch(J){case c.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=Ae;function ue(J){switch(J){case r.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}we.to=ue})(G||(e.DiagnosticSeverity=G={}));var W;(function(we){function Ae(J){return typeof J=="number"&&J>=c.ViewColumn.One?J-1:J===c.ViewColumn.Beside?m.$nD:m.$mD}we.from=Ae;function ue(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=ue})(W||(e.ViewColumn=W={}));function U(we){return typeof we.range<"u"}function C(we){return we.length===0?!0:!!U(we[0])}e.$0N=C;var O;(function(we){function Ae(Ke){return Ke.map(we.from)}we.fromMany=Ae;function ue(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function J(Ke){let st;if(ue(Ke)){const{language:Rt,value:Ot}=Ke;st={value:"```"+Rt+`
`+Ot+"\n```\n"}}else c.$mM.isMarkdownString(Ke)?st={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?st={value:Ke}:st={value:""};const wt=Object.create(null);st.uris=wt;const yt=Rt=>{try{let Ot=p.URI.parse(Rt,!0);Ot=Ot.with({query:De(Ot.query,wt)}),wt[Rt]=Ot}catch{}return""},Zt=new f.marked.Renderer;return Zt.link=yt,Zt.image=Rt=>typeof Rt=="string"?yt(R.$yk(Rt).href):"",(0,f.marked)(st.value,{renderer:Zt}),st}we.from=J;function De(Ke,st){if(!Ke)return Ke;let wt;try{wt=(0,D.$Kh)(Ke)}catch{}if(!wt)return Ke;let yt=!1;return wt=(0,k.$Hn)(wt,Zt=>{if(p.URI.isUri(Zt)){const Rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return st[Rt]=Zt,yt=!0,Rt}else return}),yt?JSON.stringify(wt):Ke}function Ue(Ke){const st=new c.$mM(Ke.value,Ke.supportThemeIcons);return st.isTrusted=Ke.isTrusted,st.supportHtml=Ke.supportHtml,st.baseUri=Ke.baseUri?p.URI.from(Ke.baseUri):void 0,st}we.to=Ue;function Xe(Ke){if(Ke)return typeof Ke=="string"?Ke:we.from(Ke)}we.fromStrict=Xe})(O||(e.MarkdownString=O={}));function V(we){return C(we)?we.map(Ae=>({range:y.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?O.fromMany(Ae.hoverMessage):Ae.hoverMessage?O.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):we.map(Ae=>({range:y.from(Ae)}))}e.$$N=V;function re(we){return typeof we>"u"?we:typeof we=="string"?p.URI.file(we):we}e.$_N=re;var ce;(function(we){function Ae(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?re(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}we.from=Ae})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var ye;(function(we){function Ae(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}we.from=Ae})(ye||(e.ThemableDecorationRenderOptions=ye={}));var ke;(function(we){function Ae(ue){if(typeof ue>"u")return ue;switch(ue){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Ae})(ke||(e.DecorationRangeBehavior=ke={}));var he;(function(we){function Ae(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?ke.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?ye.from(ue.light):void 0,dark:ue.dark?ye.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?re(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?ce.from(ue.before):void 0,after:ue.after?ce.from(ue.after):void 0}}we.from=Ae})(he||(e.DecorationRenderOptions=he={}));var ve;(function(we){function Ae(J){return{text:J.newText,eol:J.newEol&&ut.from(J.newEol),range:y.from(J.range)}}we.from=Ae;function ue(J){const De=new c.$5L(y.to(J.range),J.text);return De.newEol=typeof J.eol>"u"?void 0:ut.to(J.eol),De}we.to=ue})(ve||(e.TextEdit=ve={}));var se;(function(we){function Ae(J,De){const Ue={edits:[]};if(J instanceof c.$8L){const Xe=new g.$Bc;for(const Ke of J._allEntries())Ke._type===1&&p.URI.isUri(Ke.to)&&Ke.from===void 0&&Xe.add(Ke.to);for(const Ke of J._allEntries())if(Ke._type===1){let st;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?st={type:"base64",value:(0,F.$Ke)(F.$qe.wrap(Ke.options.contents))}:st={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:st},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:ve.from(Ke.edit),versionId:Xe.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:y.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ke.uri)?void 0:De?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(xt.from)}})}return Ue}we.from=Ae;function ue(J){const De=new c.$8L,Ue=new g.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const Ke=Xe,st=p.URI.revive(Ke.resource),wt=y.to(Ke.textEdit.range),yt=Ke.textEdit.text,Zt=Ke.textEdit.insertAsSnippet;let Rt;Zt?Rt=c.$7L.replace(wt,new c.$9L(yt)):Rt=c.$5L.replace(wt,yt);const Ot=Ue.get(st);Ot?Ot.push(Rt):Ue.set(st,[Rt])}else De.renameFile(p.URI.revive(Xe.oldResource),p.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ke]of Ue)De.set(Xe,Ke);return De}we.to=ue})(se||(e.WorkspaceEdit=se={}));var $e;(function(we){const Ae=Object.create(null);Ae[c.SymbolKind.File]=0,Ae[c.SymbolKind.Module]=1,Ae[c.SymbolKind.Namespace]=2,Ae[c.SymbolKind.Package]=3,Ae[c.SymbolKind.Class]=4,Ae[c.SymbolKind.Method]=5,Ae[c.SymbolKind.Property]=6,Ae[c.SymbolKind.Field]=7,Ae[c.SymbolKind.Constructor]=8,Ae[c.SymbolKind.Enum]=9,Ae[c.SymbolKind.Interface]=10,Ae[c.SymbolKind.Function]=11,Ae[c.SymbolKind.Variable]=12,Ae[c.SymbolKind.Constant]=13,Ae[c.SymbolKind.String]=14,Ae[c.SymbolKind.Number]=15,Ae[c.SymbolKind.Boolean]=16,Ae[c.SymbolKind.Array]=17,Ae[c.SymbolKind.Object]=18,Ae[c.SymbolKind.Key]=19,Ae[c.SymbolKind.Null]=20,Ae[c.SymbolKind.EnumMember]=21,Ae[c.SymbolKind.Struct]=22,Ae[c.SymbolKind.Event]=23,Ae[c.SymbolKind.Operator]=24,Ae[c.SymbolKind.TypeParameter]=25;function ue(De){return typeof Ae[De]=="number"?Ae[De]:6}we.from=ue;function J(De){for(const Ue in Ae)if(Ae[Ue]===De)return Number(Ue);return c.SymbolKind.Property}we.to=J})($e||(e.SymbolKind=$e={}));var te;(function(we){function Ae(J){switch(J){case c.SymbolTag.Deprecated:return 1}}we.from=Ae;function ue(J){switch(J){case 1:return c.SymbolTag.Deprecated}}we.to=ue})(te||(e.SymbolTag=te={}));var Y;(function(we){function Ae(J){return{name:J.name,kind:$e.from(J.kind),tags:J.tags&&J.tags.map(te.from),containerName:J.containerName,location:Re.from(J.location)}}we.from=Ae;function ue(J){const De=new c.$dM(J.name,$e.to(J.kind),J.containerName,Re.to(J.location));return De.tags=J.tags&&J.tags.map(te.to),De}we.to=ue})(Y||(e.WorkspaceSymbol=Y={}));var q;(function(we){function Ae(J){const De={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:$e.from(J.kind),tags:J.tags?.map(te.from)??[]};return J.children&&(De.children=J.children.map(Ae)),De}we.from=Ae;function ue(J){const De=new c.$eM(J.name,J.detail,$e.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,S.$Lb)(J.tags)&&(De.tags=J.tags.map(te.to)),J.children&&(De.children=J.children.map(ue)),De}we.to=ue})(q||(e.DocumentSymbol=q={}));var ne;(function(we){function Ae(J){const De=new c.$iM($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return De._sessionId=J._sessionId,De._itemId=J._itemId,De}we.to=Ae;function ue(J,De,Ue){if(De=De??J._sessionId,Ue=Ue??J._itemId,De===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ue,name:J.name,detail:J.detail,kind:$e.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(te.from)}}we.from=ue})(ne||(e.CallHierarchyItem=ne={}));var Pe;(function(we){function Ae(ue){return new c.$jM(ne.to(ue.from),ue.fromRanges.map(J=>y.to(J)))}we.to=Ae})(Pe||(e.CallHierarchyIncomingCall=Pe={}));var Oe;(function(we){function Ae(ue){return new c.$kM(ne.to(ue.to),ue.fromRanges.map(J=>y.to(J)))}we.to=Ae})(Oe||(e.CallHierarchyOutgoingCall=Oe={}));var Re;(function(we){function Ae(J){return{range:J.range&&y.from(J.range),uri:J.uri}}we.from=Ae;function ue(J){return new c.$0L(p.URI.revive(J.uri),y.to(J.range))}we.to=ue})(Re||(e.location=Re={}));var be;(function(we){function Ae(J){const De=J,Ue=J;return{originSelectionRange:De.originSelectionRange?y.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Ue.uri,range:y.from(De.targetRange?De.targetRange:Ue.range),targetSelectionRange:De.targetSelectionRange?y.from(De.targetSelectionRange):void 0}}we.from=Ae;function ue(J){return{targetUri:p.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}we.to=ue})(be||(e.DefinitionLink=be={}));var me;(function(we){function Ae(J){return{range:y.from(J.range),contents:O.fromMany(J.contents)}}we.from=Ae;function ue(J){return new c.$aM(J.contents.map(O.to),y.to(J.range))}we.to=ue})(me||(e.Hover=me={}));var Q;(function(we){function Ae(J){return{range:y.from(J.range),expression:J.expression}}we.from=Ae;function ue(J){return new c.$7M(y.to(J.range),J.expression)}we.to=ue})(Q||(e.EvaluatableExpression=Q={}));var x;(function(we){function Ae(J){if(J instanceof c.$8M)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof c.$9M)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof c.$0M)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Ae;function ue(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}we.to=ue})(x||(e.InlineValue=x={}));var le;(function(we){function Ae(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}we.from=Ae;function ue(J){return new c.$$M(J.frameId,y.to(J.stoppedLocation))}we.to=ue})(le||(e.InlineValueContext=le={}));var de;(function(we){function Ae(J){return{range:y.from(J.range),kind:J.kind}}we.from=Ae;function ue(J){return new c.$bM(y.to(J.range),J.kind)}we.to=ue})(de||(e.DocumentHighlight=de={}));var Me;(function(we){function Ae(J){return{uri:J.uri,highlights:J.highlights.map(de.from)}}we.from=Ae;function ue(J){return new c.$cM(p.URI.revive(J.uri),J.highlights.map(de.to))}we.to=ue})(Me||(e.MultiDocumentHighlight=Me={}));var ge;(function(we){function Ae(ue){switch(ue){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}we.to=Ae})(ge||(e.CompletionTriggerKind=ge={}));var Se;(function(we){function Ae(ue){return{triggerKind:ge.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}we.to=Ae})(Se||(e.CompletionContext=Se={}));var Ce;(function(we){function Ae(J){switch(J){case c.CompletionItemTag.Deprecated:return 1}}we.from=Ae;function ue(J){switch(J){case 1:return c.CompletionItemTag.Deprecated}}we.to=ue})(Ce||(e.CompletionItemTag=Ce={}));var N;(function(we){const Ae=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function ue(Ue){return Ae.get(Ue)??9}we.from=ue;const J=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function De(Ue){return J.get(Ue)??c.CompletionItemKind.Property}we.to=De})(N||(e.CompletionItemKind=N={}));var K;(function(we){function Ae(ue,J){const De=new c.$sM(ue.label);return De.insertText=ue.insertText,De.kind=N.to(ue.kind),De.tags=ue.tags?.map(Ce.to),De.detail=ue.detail,De.documentation=R.$sk(ue.documentation)?O.to(ue.documentation):ue.documentation,De.sortText=ue.sortText,De.filterText=ue.filterText,De.preselect=ue.preselect,De.commitCharacters=ue.commitCharacters,s.$4s.isIRange(ue.range)?De.range=y.to(ue.range):typeof ue.range=="object"&&(De.range={inserting:y.to(ue.range.insert),replacing:y.to(ue.range.replace)}),De.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&1),typeof ue.insertTextRules<"u"&&ue.insertTextRules&4?De.insertText=new c.$9L(ue.insertText):(De.insertText=ue.insertText,De.textEdit=De.range instanceof c.$ZL?new c.$5L(De.range,De.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(De.additionalTextEdits=ue.additionalTextEdits.map(Ue=>ve.to(Ue))),De.command=J&&ue.command?J.fromInternal(ue.command):void 0,De}we.to=Ae})(K||(e.CompletionItem=K={}));var j;(function(we){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:O.fromStrict(J.documentation)}}we.from=Ae;function ue(J){return{label:J.label,documentation:R.$sk(J.documentation)?O.to(J.documentation):J.documentation}}we.to=ue})(j||(e.ParameterInformation=j={}));var H;(function(we){function Ae(J){return{label:J.label,documentation:O.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(j.from):[],activeParameter:J.activeParameter}}we.from=Ae;function ue(J){return{label:J.label,documentation:R.$sk(J.documentation)?O.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(j.to):[],activeParameter:J.activeParameter}}we.to=ue})(H||(e.SignatureInformation=H={}));var Z;(function(we){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.from):[]}}we.from=Ae;function ue(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(H.to):[]}}we.to=ue})(Z||(e.SignatureHelp=Z={}));var oe;(function(we){function Ae(ue,J){const De=new c.$rM(d.to(J.position),typeof J.label=="string"?J.label:J.label.map(Ee.to.bind(void 0,ue)),J.kind&&Be.to(J.kind));return De.textEdits=J.textEdits&&J.textEdits.map(ve.to),De.tooltip=R.$sk(J.tooltip)?O.to(J.tooltip):J.tooltip,De.paddingLeft=J.paddingLeft,De.paddingRight=J.paddingRight,De}we.to=Ae})(oe||(e.InlayHint=oe={}));var Ee;(function(we){function Ae(ue,J){const De=new c.$qM(J.label);return De.tooltip=R.$sk(J.tooltip)?O.to(J.tooltip):J.tooltip,u.Command.is(J.command)&&(De.command=ue.fromInternal(J.command)),J.location&&(De.location=Re.to(J.location)),De}we.to=Ae})(Ee||(e.InlayHintLabelPart=Ee={}));var Be;(function(we){function Ae(J){return J}we.from=Ae;function ue(J){return J}we.to=ue})(Be||(e.InlayHintKind=Be={}));var Ve;(function(we){function Ae(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}we.from=Ae;function ue(J){let De;if(J.url)try{De=typeof J.url=="string"?p.URI.parse(J.url,!0):p.URI.revive(J.url)}catch{}return new c.$xM(y.to(J.range),De)}we.to=ue})(Ve||(e.DocumentLink=Ve={}));var Ze;(function(we){function Ae(J){const De=new c.$AM(J.label);return J.textEdit&&(De.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(De.additionalTextEdits=J.additionalTextEdits.map(Ue=>ve.to(Ue))),De}we.to=Ae;function ue(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(De=>ve.from(De)):void 0}}we.from=ue})(Ze||(e.ColorPresentation=Ze={}));var xe;(function(we){function Ae(J){return new c.$yM(J[0],J[1],J[2],J[3])}we.to=Ae;function ue(J){return[J.red,J.green,J.blue,J.alpha]}we.from=ue})(xe||(e.Color=xe={}));var at;(function(we){function Ae(J){return{range:y.from(J.range)}}we.from=Ae;function ue(J){return new c.$hM(y.to(J.range))}we.to=ue})(at||(e.SelectionRange=at={}));var nt;(function(we){function Ae(ue){switch(ue){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}we.to=Ae})(nt||(e.TextDocumentSaveReason=nt={}));var et;(function(we){function Ae(J){switch(J){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.Interval:return 3;case c.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Ae;function ue(J){switch(J){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 3:return c.TextEditorLineNumbersStyle.Interval;case 1:default:return c.TextEditorLineNumbersStyle.On}}we.to=ue})(et||(e.TextEditorLineNumbersStyle=et={}));var ut;(function(we){function Ae(J){if(J===c.EndOfLine.CRLF)return 1;if(J===c.EndOfLine.LF)return 0}we.from=Ae;function ue(J){if(J===1)return c.EndOfLine.CRLF;if(J===0)return c.EndOfLine.LF}we.to=ue})(ut||(e.EndOfLine=ut={}));var je;(function(we){function Ae(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Ae})(je||(e.ProgressLocation=je={}));var pt;(function(we){function Ae(J){const De={start:J.start+1,end:J.end+1};return J.kind&&(De.kind=X.from(J.kind)),De}we.from=Ae;function ue(J){const De={start:J.start-1,end:J.end-1};return J.kind&&(De.kind=X.to(J.kind)),De}we.to=ue})(pt||(e.FoldingRange=pt={}));var X;(function(we){function Ae(J){if(J)switch(J){case c.FoldingRangeKind.Comment:return u.$Tt.Comment;case c.FoldingRangeKind.Imports:return u.$Tt.Imports;case c.FoldingRangeKind.Region:return u.$Tt.Region}}we.from=Ae;function ue(J){if(J)switch(J.value){case u.$Tt.Comment.value:return c.FoldingRangeKind.Comment;case u.$Tt.Imports.value:return c.FoldingRangeKind.Imports;case u.$Tt.Region.value:return c.FoldingRangeKind.Region}}we.to=ue})(X||(e.FoldingRangeKind=X={}));var _;(function(we){function Ae(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?y.from(ue.selection):void 0,override:typeof ue.override=="boolean"?n.$PE.id:void 0}}we.from=Ae})(_||(e.TextEditorOpenOptions=_={}));var pe;(function(we){function Ae(Ue){return Ue instanceof c.$UM?Ue.toJSON():typeof Ue=="string"?Ue:ue(Ue)||J(Ue)?new c.$UM(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}we.from=Ae;function ue(Ue){const Xe=Ue;return Xe?p.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ue){const Xe=Ue;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function De(Ue){return typeof Ue=="string"?Ue:new c.$UM(p.URI.revive(Ue.baseUri),Ue.pattern)}we.to=De})(pe||(e.GlobPattern=pe={}));var We;(function(we){function Ae(ue){if(ue){if(Array.isArray(ue))return ue.map(Ae);if(typeof ue=="string")return ue;{const J=ue;return{language:J.language,scheme:J.scheme,pattern:pe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}we.from=Ae})(We||(e.LanguageSelector=We={}));var Qe;(function(we){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(De=>Array.isArray(De)&&De.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Xe=>Xe instanceof c.$ZL)))}we.is=Ae;function ue(J){return{documents:J.documents.map(De=>De.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>y.from(Xe))})))}}we.from=ue})(Qe||(e.MappedEditsContext=Qe={}));var it;(function(we){function Ae(J){return{start:J.start,end:J.end}}we.from=Ae;function ue(J){return new c.$lN(J.start,J.end)}we.to=ue})(it||(e.NotebookRange=it={}));var rt;(function(we){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}we.to=Ae;function ue(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}we.from=ue})(rt||(e.NotebookCellExecutionSummary=rt={}));var Te;(function(we){function Ae(ue){if(ue===o.NotebookCellExecutionState.Unconfirmed)return c.NotebookCellExecutionState.Pending;if(ue===o.NotebookCellExecutionState.Pending)return;if(ue===o.NotebookCellExecutionState.Executing)return c.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}we.to=Ae})(Te||(e.NotebookCellExecutionState=Te={}));var Tt;(function(we){function Ae(J){switch(J){case c.NotebookCellKind.Markup:return o.CellKind.Markup;case c.NotebookCellKind.Code:default:return o.CellKind.Code}}we.from=Ae;function ue(J){switch(J){case o.CellKind.Markup:return c.NotebookCellKind.Markup;case o.CellKind.Code:default:return c.NotebookCellKind.Code}}we.to=ue})(Tt||(e.NotebookCellKind=Tt={}));var Xt;(function(we){function Ae(J){const De={metadata:J.metadata??Object.create(null),cells:[]};for(const Ue of J.cells)c.$mN.validate(Ue),De.cells.push(xt.from(Ue));return De}we.from=Ae;function ue(J){const De=new c.$nN(J.cells.map(xt.to));return(0,v.$4f)(J.metadata)||(De.metadata=J.metadata),De}we.to=ue})(Xt||(e.NotebookData=Xt={}));var xt;(function(we){function Ae(J){return{cellKind:Tt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:rt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Dt.from):[]}}we.from=Ae;function ue(J){return new c.$mN(Tt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Dt.to):void 0,J.metadata,J.internalMetadata?rt.to(J.internalMetadata):void 0)}we.to=ue})(xt||(e.NotebookCellData=xt={}));var Ut;(function(we){function Ae(J){return{mime:J.mime,valueBytes:F.$qe.wrap(J.data)}}we.from=Ae;function ue(J){return new c.$oN(J.valueBytes.buffer,J.mime)}we.to=ue})(Ut||(e.NotebookCellOutputItem=Ut={}));var Dt;(function(we){function Ae(J){return{outputId:J.id,items:J.items.map(Ut.from),metadata:J.metadata}}we.from=Ae;function ue(J){const De=J.items.map(Ut.to);return new c.$pN(De,J.outputId,J.metadata)}we.to=ue})(Dt||(e.NotebookCellOutput=Dt={}));var ei;(function(we){function Ae(De){return J(De)?{include:pe.from(De.include)??void 0,exclude:pe.from(De.exclude)??void 0}:pe.from(De)??void 0}we.from=Ae;function ue(De){return J(De)?{include:pe.to(De.include),exclude:pe.to(De.exclude)}:pe.to(De)}we.to=ue;function J(De){const Ue=De;return Ue?!(0,v.$Zf)(Ue.include)&&!(0,v.$Zf)(Ue.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var jt;(function(we){function Ae(ue,J,De){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ue,De),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}we.from=Ae})(jt||(e.NotebookStatusBarItem=jt={}));var si;(function(we){function Ae(ue,J,De){const Ue=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:J.toInternal(Ue,De),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}we.from=Ae})(si||(e.NotebookKernelSourceAction=si={}));var Yt;(function(we){function Ae(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}we.from=Ae})(Yt||(e.NotebookDocumentContentOptions=Yt={}));var _t;(function(we){function Ae(J){return{uri:J.uri,provides:J.provides}}we.from=Ae;function ue(J){return new c.$rN(p.URI.revive(J.uri),J.provides)}we.to=ue})(_t||(e.NotebookRendererScript=_t={}));var Ye;(function(we){function Ae(J){return{message:O.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}we.from=Ae;function ue(J){const De=new c.$xN(typeof J.message=="string"?J.message:O.to(J.message));return De.actualOutput=J.actual,De.expectedOutput=J.expected,De.contextValue=J.contextValue,De.location=J.location?Re.to(J.location):void 0,De}we.to=ue})(Ye||(e.TestMessage=Ye={}));var Bt;(function(we){we.namespace=t.$QK,we.denamespace=t.$RK})(Bt||(e.TestTag=Bt={}));var ti;(function(we){function Ae(J){const De=(0,i.$9N)(J).controllerId;return{extId:l.$MK.fromExtHostTestItem(J,De).toString(),label:J.label,uri:p.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ue=>Bt.namespace(De,Ue.id)),range:s.$4s.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&O.fromStrict(J.error)||null}}we.from=Ae;function ue(J){return{parent:void 0,error:void 0,id:l.$MK.fromString(J.extId).localId,label:J.label,uri:p.URI.revive(J.uri),tags:(J.tags||[]).map(De=>{const{tagId:Ue}=Bt.denamespace(De);return new c.$yN(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}we.toPlain=ue})(ti||(e.TestItem=ti={})),function(we){function Ae(J){return{id:J.id}}we.from=Ae;function ue(J){return new c.$yN(J.id)}we.to=ue}(Bt||(e.TestTag=Bt={}));var ht;(function(we){const Ae=(J,De)=>{const Ue=[];for(const[Ke,st]of De)l.$MK.compare(st.item.extId,Ke)===2&&(De.delete(Ke),Ue.push(st));const Xe={...ti.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(st=>st.type===0).map(Ye.to)})),children:Ue.map(Ke=>Ae(Ke,De))};for(const Ke of Xe.children)Ke.parent=Xe;return Xe};function ue(J){const De=[],Ue=new Map;for(const Xe of J.items){Ue.set(Xe.item.extId,Xe);const Ke=l.$MK.root(Xe.item.extId);J.request.targets.some(st=>st.controllerId===Ke&&st.testIds.includes(Xe.item.extId))&&De.push(Xe)}return{completedAt:J.completedAt,results:De.map(Xe=>Ae(Xe,Ue))}}we.to=ue})(ht||(e.TestResults=ht={}));var mt;(function(we){function Ae(Ue){return{covered:Ue.covered,total:Ue.total}}function ue(Ue){return"line"in Ue?d.from(Ue):y.from(Ue)}function J(Ue){return"branches"in Ue?{count:Ue.executed,location:ue(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ue(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:ue(Ue.location)}}we.fromDetailed=J;function De(Ue){return{uri:Ue.uri,statement:Ae(Ue.statementCoverage),branch:Ue.branchCoverage&&Ae(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Ae(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(J)}}we.fromFile=De})(mt||(e.TestCoverage=mt={}));var Gt;(function(we){function Ae(ue){switch(ue){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}we.to=Ae})(Gt||(e.CodeActionTriggerKind=Gt={}));var ii;(function(we){function Ae(J){const De=new c.$EN($e.to(J.kind),J.name,J.detail||"",p.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return De._sessionId=J._sessionId,De._itemId=J._itemId,De}we.to=Ae;function ue(J,De,Ue){if(De=De??J._sessionId,Ue=Ue??J._itemId,De===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Ue,kind:$e.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(te.from)}}we.from=ue})(ii||(e.TypeHierarchyItem=ii={}));var Pt;(function(we){function Ae(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}we.from=Ae})(Pt||(e.ViewBadge=Pt={}));var dt;(function(we){function Ae(Ue,Xe,Ke){const st=Xe.fileData;return st?new c.$NM(new c.$OM(st.name,p.URI.revive(st.uri),st.id,(0,L.$db)(()=>Ke(st.id)))):Ue===A.$os.uriList&&Xe.uriListData?new c.$MM(De(Xe.uriListData)):new c.$MM(Xe.asString)}we.to=Ae;async function ue(Ue,Xe){const Ke=await Xe.asString();if(Ue===A.$os.uriList)return{asString:Ke,fileData:void 0,uriListData:J(Ke)};const st=Xe.asFile();return{asString:Ke,fileData:st?{name:st.name,uri:st.uri,id:st._itemId??st.id}:void 0}}we.from=ue;function J(Ue){return P.$At.split(Ue).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return p.URI.parse(Xe)}catch{}return Xe})}function De(Ue){return P.$At.create(Ue.map(Xe=>typeof Xe=="string"?Xe:p.URI.revive(Xe)))}})(dt||(e.DataTransferItem=dt={}));var At;(function(we){function Ae(J,De){const Ue=J.items.map(([Xe,Ke])=>[Xe,dt.to(Xe,Ke,De)]);return new c.$PM(Ue)}we.toDataTransfer=Ae;async function ue(J){const De={items:[]},Ue=[];for(const[Xe,Ke]of J)Ue.push((async()=>{De.items.push([Xe,await dt.from(Xe,Ke)])})());return await Promise.all(Ue),De}we.from=ue})(At||(e.DataTransfer=At={}));var oi;(function(we){function Ae(J,De){return{kind:"reply",agentId:J.agentId??De?.agentId??"",subCommand:J.command??De?.command,message:J.prompt,title:J.title,tooltip:J.tooltip}}we.from=Ae;function ue(J){return{prompt:J.message,title:J.title,agentId:J.agentId,command:J.subCommand,tooltip:J.tooltip}}we.to=ue})(oi||(e.ChatFollowup=oi={}));var Mt;(function(we){function Ae(ue){return"commandId"in ue?{kind:"command",title:ue.title??"",commandId:ue.commandId??"",when:ue.when??"",args:ue.args}:{kind:"reply",message:ue.message,title:ue.title,tooltip:ue.tooltip}}we.from=Ae})(Mt||(e.ChatInlineFollowup=Mt={}));var He;(function(we){function Ae(J){switch(J.role){case 0:return new c.$ZN(J.content);case 1:return new c.$1N(J.content);case 2:return new c.$2N(J.content)}}we.to=Ae;function ue(J){if(J instanceof c.$ZN)return{role:0,content:J.content};if(J instanceof c.$1N)return{role:1,content:J.content};if(J instanceof c.$2N)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}we.from=ue})(He||(e.LanguageModelMessage=He={}));var Nt;(function(we){function Ae(De){const Ue={};for(const Xe of Object.keys(De))Ue[Xe]=De[Xe].map(we.to);return Ue}we.objectTo=Ae;function ue(De){return{level:Vt.to(De.level),kind:De.kind,value:(0,p.$vc)(De.value)?p.URI.revive(De.value):De.value,description:De.description}}we.to=ue;function J(De){return{level:Vt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=J})(Nt||(e.ChatVariable=Nt={}));var Vt;(function(we){function Ae(J){switch(J){case"short":return c.ChatVariableLevel.Short;case"medium":return c.ChatVariableLevel.Medium;case"full":default:return c.ChatVariableLevel.Full}}we.to=Ae;function ue(J){switch(J){case c.ChatVariableLevel.Short:return"short";case c.ChatVariableLevel.Medium:return"medium";case c.ChatVariableLevel.Full:default:return"full"}}we.from=ue})(Vt||(e.ChatVariableLevel=Vt={}));var ni;(function(we){function Ae(ue){switch(ue){case 1:return c.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return c.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return c.InteractiveEditorResponseFeedbackKind.Undone;case 3:return c.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return c.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Ae})(ni||(e.InteractiveEditorResponseFeedbackKind=ni={}));var ft;(function(we){function Ae(J){return{kind:"markdownContent",content:O.from(new c.$mM().appendText(J.value))}}we.to=Ae;function ue(J){return new c.$QN(J.content.value)}we.from=ue})(ft||(e.ChatResponseTextPart=ft={}));var Ft;(function(we){function Ae(J){return{kind:"markdownContent",content:O.from(J.value)}}we.to=Ae;function ue(J){return new c.$RN(O.to(J.content))}we.from=ue})(Ft||(e.ChatResponseMarkdownPart=Ft={}));var Ct;(function(we){function Ae(J){const{value:De,baseUri:Ue}=J;function Xe(Ke,st){return Ke.map(wt=>{const yt=p.URI.joinPath(st,wt.name);return{label:wt.name,uri:yt,children:wt.children&&Xe(wt.children,yt)}})}return{kind:"treeData",treeData:{label:(0,h.$Mg)(Ue),uri:Ue,children:Xe(De,Ue)}}}we.to=Ae;function ue(J){const De=(0,D.$Lh)(J.treeData);function Ue(st){return st.map(wt=>({name:wt.label,children:wt.children&&Ue(wt.children)}))}const Xe=De.uri,Ke=De.children?Ue(De.children):[];return new c.$SN(Ke,Xe)}we.from=ue})(Ct||(e.ChatResponseFilesPart=Ct={}));var zt;(function(we){function Ae(J){return{kind:"inlineReference",name:J.title,inlineReference:p.URI.isUri(J.value)?J.value:$.from(J.value)}}we.to=Ae;function ue(J){const De=(0,D.$Lh)(J);return new c.$TN(p.URI.isUri(De.inlineReference)?De.inlineReference:$.to(De.inlineReference),J.name)}we.from=ue})(zt||(e.ChatResponseAnchorPart=zt={}));var Wt;(function(we){function Ae(J){return{kind:"progressMessage",content:O.from(J.value)}}we.to=Ae;function ue(J){return new c.$UN(J.content.value)}we.from=ue})(Wt||(e.ChatResponseProgressPart=Wt={}));var qt;(function(we){function Ae(J,De,Ue){return{kind:"command",command:De.toInternal(J.value,Ue)??{command:J.value.command,title:J.value.title}}}we.to=Ae;function ue(J,De){return new c.$VN(De.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}we.from=ue})(qt||(e.ChatResponseCommandButtonPart=qt={}));var St;(function(we){function Ae(J){return{kind:"reference",reference:p.URI.isUri(J.value)?J.value:$.from(J.value)}}we.to=Ae;function ue(J){const De=(0,D.$Lh)(J);return new c.$WN(p.URI.isUri(De.reference)?De.reference:$.to(De.reference))}we.from=ue})(St||(e.ChatResponseReferencePart=St={}));var Jt;(function(we){function Ae(J){return J instanceof c.$RN?Ft.to(J):J instanceof c.$TN?zt.to(J):J instanceof c.$WN?St.to(J):J instanceof c.$UN?Wt.to(J):J instanceof c.$SN?Ct.to(J):{kind:"content",content:""}}we.to=Ae;function ue(J,De){switch(J.kind){case"markdownContent":return Ft.from(J);case"inlineReference":return zt.from(J);case"reference":return St.from(J);case"progressMessage":return Wt.from(J);case"treeData":return Ct.from(J);case"command":return qt.from(J,De)}}we.from=ue})(Jt||(e.ChatResponsePart=Jt={}));var Et;(function(we){function Ae(De,Ue){return"markdownContent"in Ue?((0,a.$SF)(De,"chatAgents2Additions"),{content:O.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,a.$SF)(De,"chatAgents2Additions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,a.$SF)(De,"chatAgents2Additions"),{content:O.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(Ke=>y.from(Ke))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:y.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:y.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"agentName"in Ue?((0,a.$SF)(De,"chatAgents2Additions"),{agentName:Ue.agentName,command:Ue.command,kind:"agentDetection"}):"message"in Ue?{content:O.from(Ue.message),kind:"progressMessage"}:void 0}we.from=Ae;function ue(De){switch(De.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(De);case"content":return{content:De.content};case"usedContext":return{documents:De.documents.map(Ue=>({uri:p.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Xe=>y.to(Xe))}))};case"reference":return{reference:(0,p.$vc)(De.reference)?p.URI.revive(De.reference):$.to(De.reference)};case"agentDetection":return;case"progressMessage":return{message:De.content.value};case"vulnerability":return{content:De.content,vulnerabilities:De.vulnerabilities};default:return}}we.to=ue;function J(De,Ue){switch(De.kind){case"markdownContent":return{content:De.content.value};case"inlineReference":return{inlineReference:(0,p.$vc)(De.inlineReference)?p.URI.revive(De.inlineReference):$.to(De.inlineReference),title:De.name};case"command":return{command:Ue.fromInternal(De.command)??{command:De.command.id,title:De.command.title}};default:return}}we.toProgressContent=J})(Et||(e.ChatResponseProgress=Et={}));var bt;(function(we){function Ae(ue){return{prompt:ue.message,command:ue.command,variables:ue.variables.variables.map(It.to)}}we.to=Ae})(bt||(e.ChatAgentRequest=bt={}));var It;(function(we){function Ae(ue){return{name:ue.name,range:[ue.range.start,ue.range.endExclusive],values:ue.values.map(Nt.to)}}we.to=Ae})(It||(e.ChatAgentResolvedVariable=It={}));var kt;(function(we){function Ae(ue){return{label:ue.label,values:ue.values.map(Nt.from),insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation}}we.from=Ae})(kt||(e.ChatAgentCompletionItem=kt={}));var ci;(function(we){function Ae(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}we.to=Ae})(ci||(e.ChatAgentResult=ci={}));var Qt;(function(we){function Ae(ue,J,De){if(J.action.kind==="vote")return;const Ue=ci.to(ue);return J.action.kind==="command"?{action:{kind:"command",commandButton:Et.toProgressContent(J.action.commandButton,De)},result:Ue}:J.action.kind==="followUp"?{action:{kind:"followUp",followup:oi.to(J.action.followup)},result:Ue}:{action:J.action,result:Ue}}we.to=Ae})(Qt||(e.ChatAgentUserActionEvent=Qt={}));var pi;(function(we){function Ae(ue,J,De){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:J.toInternal(ue,De)}we.from=Ae})(pi||(e.TerminalQuickFix=pi={}));var Ht;(function(we){function Ae(ue,J){return{id:J,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||0,contextValue:ue.contextValue}}we.from=Ae})(Ht||(e.DebugTreeItem=Ht={}))}),define(Fe[247],Le([1,0,3,17,8]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;let L=class{constructor(g,f){this.a=g.getProxy(S.$VL.MainThreadBulkEdits),this.b={getTextDocumentVersion:D=>f.getDocument(D)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,f,D){const A=P.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,D?.isRefactoring??!1)}};e.$ehc=L,e.$ehc=L=Je([qe(0,F.$aO)],L)}),define(Fe[248],Le([1,0,18,11,41,5,46,6,63,16,2,158,3,8,7,207,23]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class r{constructor(l,t,m,a,c,E){this.i=l,this.j=t,this.k=m,this.l=a,this.m=c,this.n=E,this.a=f.$Yd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let t=function(a){if(l.b){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,a),c}};const l=this;this.a.reset();const m=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,a)};this.g={text(a){return t(this.text),this.markdown(new R.$qk().appendText(a)),this},markdown(a){t(this.markdown);const c=new p.$RN(a),E=v.ChatResponseMarkdownPart.to(c);return m(E),this},filetree(a,c){t(this.filetree);const E=new p.$SN(a,c),y=v.ChatResponseFilesPart.to(E);return m(y),this},anchor(a,c){t(this.anchor);const E=new p.$TN(a,c),y=v.ChatResponseAnchorPart.to(E);return m(y),this},button(a){t(this.anchor);const c=new p.$VN(a),E=v.ChatResponseCommandButtonPart.to(c,l.m,l.n);return m(E),this},progress(a){t(this.progress);const c=new p.$UN(a),E=v.ChatResponseProgressPart.to(c);return m(E),this},reference(a){t(this.reference);const c=new p.$WN(a),E=v.ChatResponseReferencePart.to(c);return m(E),this},push(a){t(this.push);const c=v.ChatResponsePart.to(a);return m(c),this},report(a){if(t(this.report),"placeholder"in a&&"resolvedContent"in a)return;const c=v.ChatResponseProgress.from(l.i,a);if(!c){l.l.error("Unknown progress type: "+JSON.stringify(a));return}return m(c),this}}}return this.g}}class i{static{this.a=0}constructor(l,t,m){this.i=t,this.j=m,this.b=new Map,this.g=new g.$3c,this.d=l.getProxy(h.$VL.MainThreadChatAgents2)}createChatAgent(l,t,m){const a=i.a++,c=new n(l,t,this.d,a,m);return this.b.set(a,c),this.d.$registerAgent(a,l.identifier,t,{}),c.apiAgent}async $invokeAgent(l,t,m,a){const c=this.b.get(l);if(!c)throw new Error(`[CHAT](${l}) CANNOT invoke agent because the agent is not registered`);let E=this.g.get(t.sessionId);E||(E=new g.$Sc,this.g.set(t.sessionId,E));const y=new r(c.extension,t,this.d,this.i,this.j.converter,E);try{const $=await this.k(t,m),I=c.invoke(v.ChatAgentRequest.to(t),{history:$},y.apiObject,a);return await(0,F.$3g)(Promise.resolve(I).then(d=>{if(d?.metadata)try{JSON.stringify(d.metadata)}catch(w){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${b}`,c.extension),{errorDetails:{message:b},timings:y.timings}}return{errorDetails:d?.errorDetails,timings:y.timings,metadata:d?.metadata}}),a)}catch($){return this.i.error($,c.extension),{errorDetails:{message:(0,k.localize)(0,null,(0,P.$Zi)($)),responseIsIncomplete:!0}}}finally{y.close()}}async k(l,t){const m=[];for(const a of t.history){const c=v.ChatAgentResult.to(a.result),E=l.agentId===a.request.agentId?c:{...c,metadata:void 0};m.push(new p.$XN(a.request.message,a.request.command,a.request.variables.variables.map(v.ChatAgentResolvedVariable.to),{extensionId:"",agent:a.request.agentId}));const y=(0,S.$Hb)(a.response.map($=>v.ChatResponsePart.from($,this.j.converter)));m.push(new p.$YN(y,E,{extensionId:"",agent:a.request.agentId}))}return m}$releaseSession(l){this.g.deleteAndDispose(l)}async $provideSlashCommands(l,t){const m=this.b.get(l);return m?m.provideSlashCommands(t):[]}async $provideFollowups(l,t,m,a){const c=this.b.get(t);if(!c)return Promise.resolve([]);const E=v.ChatAgentResult.to(m);return(await c.provideFollowups(E,a)).map(y=>v.ChatFollowup.from(y,l))}$acceptFeedback(l,t,m,a){const c=this.b.get(l);if(!c)return;const E=v.ChatAgentResult.to(t);let y;switch(m){case s.InteractiveSessionVoteDirection.Down:y=p.ChatAgentResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:y=p.ChatAgentResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(a?{result:E,kind:y,reportIssue:a}:{result:E,kind:y}))}$acceptAction(l,t,m){const a=this.b.get(l);if(!a||m.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(t,m,this.j.converter);c&&a.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(l,t,m){const a=this.b.get(l);return a?(await a.invokeCompletionProvider(t,m)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(l,t){const m=this.b.get(l);if(m)return await m.provideWelcomeMessage(t)}async $provideSampleQuestions(l,t){const m=this.b.get(l);if(m)return(await m.provideSampleQuestions(t)).map(a=>v.ChatFollowup.from(a,void 0))}}e.$ghc=i;class n{constructor(l,t,m,a,c){this.extension=l,this.id=t,this.w=m,this.x=a,this.y=c,this.o=new L.$3d,this.p=new L.$3d}acceptFeedback(l){this.o.fire(l)}acceptAction(l){this.p.fire(l)}async invokeCompletionProvider(l,t){return this.s?await this.s.provider.provideCompletionItems(l,t)??[]:[]}async provideSlashCommands(l){if(!this.a)return[];const t=await this.a.provideCommands(l);return t?t.map(m=>("repopulate2"in m&&(0,u.$SF)(this.extension,"chatAgents2Additions"),{name:m.name,description:m.description,followupPlaceholder:m.isSticky2?.placeholder,shouldRepopulate:m.isSticky2?.isSticky??m.isSticky,sampleRequest:m.sampleRequest})):[]}async provideFollowups(l,t){if(!this.b)return[];const m=await this.b.provideFollowups(l,t);return m?m.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(l){if(!this.t)return[];const t=await this.t.provideWelcomeMessage(l);return t?t.map(m=>typeof m=="string"?m:v.MarkdownString.from(m)):[]}async provideSampleQuestions(l){if(!this.t||!this.t.provideSampleQuestions)return[];const t=await this.t.provideSampleQuestions(l);return t||[]}get apiAgent(){let l=!1,t=!1;const m=()=>{l||t||(t=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof A.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$SM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u}),t=!1}))},a=this;return{get name(){return a.id},get description(){return a.d??""},set description(c){a.d=c,m()},get fullName(){return a.g??a.extension.displayName??a.extension.name},set fullName(c){a.g=c,m()},get iconPath(){return a.i},set iconPath(c){a.i=c,m()},get requestHandler(){return a.y},set requestHandler(c){(0,D.$1f)(typeof c=="function","Invalid request handler"),a.y=c},get commandProvider(){return a.a},set commandProvider(c){a.a=c,m()},get followupProvider(){return a.b},set followupProvider(c){a.b=c,m()},get isDefault(){return(0,u.$SF)(a.extension,"defaultChatAgent"),a.j},set isDefault(c){(0,u.$SF)(a.extension,"defaultChatAgent"),a.j=c,m()},get helpTextPrefix(){return(0,u.$SF)(a.extension,"defaultChatAgent"),a.k},set helpTextPrefix(c){if((0,u.$SF)(a.extension,"defaultChatAgent"),!a.j)throw new Error("helpTextPrefix is only available on the default chat agent");a.k=c,m()},get helpTextPostfix(){return(0,u.$SF)(a.extension,"defaultChatAgent"),a.l},set helpTextPostfix(c){if((0,u.$SF)(a.extension,"defaultChatAgent"),!a.j)throw new Error("helpTextPostfix is only available on the default chat agent");a.l=c,m()},get isSecondary(){return(0,u.$SF)(a.extension,"defaultChatAgent"),a.n},set isSecondary(c){(0,u.$SF)(a.extension,"defaultChatAgent"),a.n=c,m()},get sampleRequest(){return a.m},set sampleRequest(c){a.m=c,m()},get supportIssueReporting(){return(0,u.$SF)(a.extension,"chatAgents2Additions"),a.q},set supportIssueReporting(c){(0,u.$SF)(a.extension,"chatAgents2Additions"),a.q=c,m()},get onDidReceiveFeedback(){return a.o.event},set agentVariableProvider(c){if((0,u.$SF)(a.extension,"chatAgents2Additions"),a.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");a.w.$registerAgentCompletionsProvider(a.x,c.triggerCharacters)}else a.w.$unregisterAgentCompletionsProvider(a.x)},get agentVariableProvider(){return(0,u.$SF)(a.extension,"chatAgents2Additions"),a.s},set welcomeMessageProvider(c){(0,u.$SF)(a.extension,"defaultChatAgent"),a.t=c,m()},get welcomeMessageProvider(){return(0,u.$SF)(a.extension,"defaultChatAgent"),a.t},onDidPerformAction:(0,u.$RF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,get isSticky(){return a.u},set isSticky(c){a.u=c,m()},dispose(){l=!0,a.a=void 0,a.b=void 0,a.o.dispose(),a.w.$unregisterAgent(a.x)}}}invoke(l,t,m,a){return this.y(l,t,m,a)}}}),define(Fe[249],Le([1,0,21,6,3,8,99,22,11,5,159,104]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;class h{constructor(u,r){this.option=u,this.stream=new f.$Fh,this.stream=r??new f.$Fh}}class v{constructor(u,r){this.cts=r,this.a=new Map,this.b=new f.$Fh,this.c=!1;const i=this;this.apiObject={result:u,stream:i.b.asyncIterable},u.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,n]of this.a)n.stream.resolve();else this.b.resolve()})}handleFragment(u){if(this.c)return;let r=this.a.get(u.index);r||(this.a.size===0?r=new h(u.index,this.b):r=new h(u.index),this.a.set(u.index,r)),r.stream.emitOne(u.part)}}class p{static{this.a=1}constructor(u,r,i){this.j=r,this.k=i,this.c=new D.$3d,this.d=new D.$3d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new g.$wm,this.i=new Map,this.b=u.getProxy(P.$VL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(u,r,i,n){const o=p.a++;this.f.set(o,{extension:u.identifier,provider:i});let l;return n.auth&&(l={providerLabel:u.displayName||u.name,accountLabel:typeof n.auth=="object"?n.auth.label:void 0}),this.b.$registerProvider(o,r,{extension:u.identifier,model:n.name??"",auth:l}),(0,F.$Rc)(()=>{this.f.delete(o),this.b.$unregisterProvider(o)})}async $provideLanguageModelResponse(u,r,i,n,o,l){const t=this.f.get(u);if(!t)return;const m=new R.$Ev(async a=>{if(l.isCancellationRequested){this.j.warn(`[CHAT](${t.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:a.index,part:a.part})});return t.provider.provideLanguageModelResponse2(n.map(L.LanguageModelMessage.to),o,g.$um.toKey(i),m,l)}$updateLanguageModels(u){const r=[],i=[];if(u.added)for(const n of u.added)this.g.add(n),r.push(n);if(u.removed)for(const n of u.removed){this.g.delete(n),i.push(n);for(const[o,l]of this.i)l.languageModelId===n&&(l.res.cts.cancel(),this.i.delete(o))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(i)}))}getLanguageModelIds(){return Array.from(this.g)}$updateModelAccesslist(u){const r=new Array;for(const{from:i,to:n,enabled:o}of u){const l=this.h.get(i)??new g.$vm;if(l.has(n)!==o){o?l.add(n):l.delete(n),this.h.set(i,l);const m={from:i,to:n};r.push(m),this.c.fire(m)}}}async requestLanguageModelAccess(u,r,i){const n=u.identifier,o=i?.justification,l=await this.b.$prepareChatAccess(n,r,o);if(!l)throw new Error(`Language model '${r}' NOT found`);this.m(n,l)&&await this.l(u,{identifier:l.extension,displayName:l.auth.providerLabel},o);const t=this;return{get model(){return l.model},get isRevoked(){return t.m(n,l)&&!t.h.get(n)?.has(l.extension)||!t.g.has(r)},get onDidChangeAccess(){const m=D.Event.filter(t.d.event,c=>c.removed.includes(r)),a=D.Event.filter(t.c.event,c=>g.$um.equals(c.from,n)&&g.$um.equals(c.to,l.extension));return D.Event.signal(D.Event.any(m,a))},makeChatRequest(m,a,c){if(t.m(n,l)&&!t.h.get(n)?.has(l.extension))throw new Error("Access to chat has been revoked");if(!t.g.has(r))throw new Error("Language Model has been removed");const E=new S.$ae(c),y=Math.random()*1e6|0,$=t.b.$fetchResponse(n,r,y,m.map(L.LanguageModelMessage.from),a??{},E.token),I=new v($,E);return t.i.set(y,{languageModelId:r,res:I}),$.finally(()=>{t.i.delete(y),E.dispose()}),I.apiObject}}}async $handleResponseFragment(u,r){const i=this.i.get(u);i&&i.res.handleFragment(r)}async l(u,r,i){const n=k.$2K+r.identifier.value;if(!await this.k.getSession(u,n,[],{silent:!0}))try{const l=i?(0,A.localize)(0,null,r.displayName,i):(0,A.localize)(1,null,r.displayName);await this.k.getSession(u,n,[],{forceNewSession:{detail:l}})}catch{throw new Error("Access to language models has not been granted")}this.$updateModelAccesslist([{from:u.identifier,to:r.identifier,enabled:!0}])}m(u,r){return!!r.auth&&!g.$um.equals(r.extension,u)}}e.$hhc=p}),define(Fe[250],Le([1,0,15,6,3,8,7,23]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;class f{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(P.$VL.MainThreadChatVariables)}async $resolveVariable(k,h,v,p){const s=this.b.get(k);if(s)try{if(s.resolver.resolve2){(0,g.$SF)(s.extension,"chatAgents2Additions");const u=new D(h,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:v},u.apiObject,p);if(r)return r.map(L.ChatVariable.from)}else{const u=await s.resolver.resolve(s.data.name,{prompt:v},p);if(u)return u.map(L.ChatVariable.from)}}catch(u){(0,S.$2)(u)}}registerVariableResolver(k,h,v,p){const s=f.a++;return this.b.set(s,{extension:k,data:{name:h,description:v},resolver:p}),this.c.$registerVariable(s,{name:h,description:v}),(0,F.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$ihc=f;class D{constructor(k,h){this.c=k,this.d=h,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let h=function(p){if(k.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,p),s}};const k=this,v=p=>{this.d.$handleProgressChunk(this.c,p)};this.b={progress(p){h(this.progress);const s=new R.$UN(p),u=L.ChatResponseProgressPart.to(s);return v(u),this},reference(p){h(this.reference);const s=new R.$WN(p),u=L.ChatResponseReferencePart.to(s);return v(u),this},push(p){h(this.push);const s=L.ChatResponsePart.to(p);return v(s),this}}}return this.b}}}),define(Fe[251],Le([1,0,11,67,5,6,2,86,22,8,7,3,23]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=void 0;function v(p,s,u){const r=p.getProxy(k.$VL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$wm,s.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===6){const $=this.b.get(y.handle);return $?$.value:y}else if(y&&y.$mid===7){const $=this.b.get(y.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.commentThreadHandle);return I?I.value:y}else if(y&&(y.$mid===9||y.$mid===8)){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);return I?y.$mid===8?I.value:{thread:I.value,text:y.text}:y}else if(y&&y.$mid===10){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.commentUniqueId,w=I.getCommentByUniqueId(d);return w||y}else if(y&&y.$mid===11){const $=this.b.get(y.thread.commentControlHandle);if(!$)return y;const I=$.getCommentThread(y.thread.commentThreadHandle);if(!I)return y;const d=y.text,w=y.commentUniqueId,b=I.getCommentByUniqueId(w);return b?(typeof b.body=="string"?b.body=d:b.body=new A.$mM(d),b):y}return y}})}createCommentController(y,$,I){const d=i.a++,w=new o(y,d,$,I);this.b.set(w.handle,w);const b=this.c.get(y.identifier)||[];return b.push(w),this.c.set(y.identifier,b),w.value}async $createCommentThreadTemplate(y,$,I){const d=this.b.get(y);d&&d.$createCommentThreadTemplate($,I)}async $setActiveComment(y,$){const I=this.b.get(y);I&&I.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(y,$,I){const d=this.b.get(y);d&&d.$updateCommentThreadTemplate($,I)}$deleteCommentThread(y,$){this.b.get(y)?.$deleteCommentThread($)}$provideCommentingRanges(y,$,I){const d=this.b.get(y);if(!d||!d.commentingRangeProvider)return Promise.resolve(void 0);const w=u.getDocument(R.URI.revive($));return(0,S.$7g)(async()=>{const b=await d.commentingRangeProvider.provideCommentingRanges(w,I);let M;return Array.isArray(b)?M={ranges:b,fileComments:!1}:b?M={ranges:b.ranges||[],fileComments:b.fileComments||!1}:M=b??void 0,M}).then(b=>{let M;return b&&(M={ranges:b.ranges.map(T=>D.Range.from(T)),fileComments:b.fileComments}),M})}$toggleReaction(y,$,I,d,w){const b=this.b.get(y);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,S.$7g)(()=>{const M=b.getCommentThread($);if(M){const T=M.getCommentByUniqueId(d.uniqueIdInThread);if(b!==void 0&&T&&b.reactionHandler)return b.reactionHandler(T,m(w))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,$,I,d,w,b,M,T){this.m=$,this.n=I,this.o=d,this.p=w,this.q=b,this.extensionDescription=M,this.r=T,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$3d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Uc,this.l.value=new L.$Sc,this.n===void 0&&(this.n=`${y}.${this.handle}`),r.$createCommentThread($,this.handle,this.n,this.o,D.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{r.$deleteCommentThread($,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range(W){G.range=W},get comments(){return G.comments},set comments(W){G.comments=W},get collapsibleState(){return G.collapsibleState},set collapsibleState(W){G.collapsibleState=W},get canReply(){return G.canReply},set canReply(W){G.canReply=W},get contextValue(){return G.contextValue},set contextValue(W){G.contextValue=W},get label(){return G.label},set label(W){G.label=W},get state(){return G.state},set state(W){G.state=W},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Sc);const y=I=>Object.prototype.hasOwnProperty.call(this.b,I),$={};y("range")&&($.range=D.Range.from(this.p)),y("label")&&($.label=this.label),y("contextValue")&&($.contextValue=this.contextValue??null),y("comments")&&($.comments=this.q.map(I=>l(this,I,this.k,this.extensionDescription))),y("collapsibleState")&&($.collapseState=a(this.g)),y("canReply")&&($.canReply=this.canReply),y("state")&&($.state=c(this.h)),y("isTemplate")&&($.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(y){for(const $ of this.k){const I=$[0],d=$[1];if(y===d)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Je([(0,F.$Hh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,r.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,h.$SF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,h.$SF)(this.h,"activeComment"),this.f}constructor(y,$,I,d){this.h=y,this.i=$,this.j=I,this.k=d,this.a=new Map,r.$registerCommentController(this.handle,I,d,this.h.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(b){w.options=b},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(b){w.commentingRangeProvider=b},get reactionHandler(){return w.reactionHandler},set reactionHandler(b){w.reactionHandler=b},get activeCommentThread(){return w.activeCommentThread},createCommentThread(b,M,T){return w.createCommentThread(b,M,T).value},dispose:()=>{w.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(y,$,I){$===void 0&&(0,h.$SF)(this.h,"fileComments");const d=new n(this.id,this.handle,void 0,y,$,I,this.h,!1);return this.a.set(d.handle,d),d}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const $=this.a.get(y.commentThreadHandle);$&&(this.e=y.uniqueIdInThread?$.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(y,$){const I=new n(this.id,this.handle,void 0,R.URI.revive(y),D.Range.to($),[],this.h,!0);return I.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(y,$){const I=this.a.get(y);I&&(I.range=D.Range.to($))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function l(E,y,$,I){let d=$.get(y);return d||(d=++E.commentHandle,$.set(y,d)),y.state!==void 0&&(0,h.$SF)(I,"commentsDraftState"),y.reactions?.some(w=>w.reactors!==void 0)&&(0,h.$SF)(I,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:d,body:typeof y.body=="string"?y.body:D.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(w=>t(w)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function t(E){return{label:E.label,iconPath:E.iconPath?D.$_N(E.iconPath):void 0,count:E.count,hasReacted:E.authorHasReacted,reactors:E.reactors&&E.reactors.length>0&&typeof E.reactors[0]!="string"?E.reactors.map(y=>y.name):E.reactors}}function m(E){return{label:E.label||"",count:E.count||0,iconPath:E.iconPath?R.URI.revive(E.iconPath):"",authorHasReacted:E.hasReacted||!1,reactors:E.reactors?.map(y=>({name:y}))}}function a(E){if(E!==void 0)switch(E){case A.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function c(E){if(E!==void 0)switch(E){case A.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new i}e.$mhc=v}),define(Fe[252],Le([1,0,21,97,6,12,25,2,8,61,74,3,7]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;class v{constructor(m,a){this.document=m,this.b=a,this.a=1,this.c=new A.$4gc("custom documents")}addEdit(m){return this.c.add([m])}async undo(m,a){await this.f(m).undo(),a||this.disposeBackup()}async redo(m,a){await this.f(m).redo(),a||this.disposeBackup()}disposeEdits(m){for(const a of m)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const m=l(this.document.uri)+this.a++;return(0,R.$Pg)(this.b,m)}updateBackup(m){this.d?.delete(),this.d=m}disposeBackup(){this.d?.delete(),this.d=void 0}f(m){const a=this.c.get(m,0);if(!a)throw new Error("No edit found");return a}}class p{constructor(){this.a=new Map}get(m,a){return this.a.get(this.b(m,a))}add(m,a,c){const E=this.b(m,a.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${m} resource:${a.uri}`);const y=new v(a,c);return this.a.set(E,y),y}delete(m,a){const c=this.b(m,a.uri);this.a.delete(c)}b(m,a){return`${m}@@@${a}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class u{constructor(){this.a=new Map}addTextProvider(m,a,c){return this.b(0,m,a,c)}addCustomProvider(m,a,c){return this.b(1,m,a,c)}get(m){return this.a.get(m)}b(m,a,c,E){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:m,extension:c,provider:E}),new h.$XL(()=>this.a.delete(a))}}class r{constructor(m,a,c,E,y){this.d=a,this.f=c,this.g=E,this.h=y,this.b=new u,this.c=new p,this.a=m.getProxy(k.$VL.MainThreadCustomEditors)}registerCustomEditorProvider(m,a,c,E){const y=new P.$Sc;return n(c)?(y.add(this.b.addTextProvider(a,m,c)),this.a.$registerTextEditorProvider((0,D.$Bhc)(m),a,E.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,D.$zhc)(m))):(y.add(this.b.addCustomProvider(a,m,c)),i(c)&&y.add(c.onDidChangeCustomDocument($=>{const I=this.i(a,$.document.uri);if(o($)){const d=I.addEdit($);this.a.$onDidEdit($.document.uri,a,d,$.label)}else this.a.$onContentChange($.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.$Bhc)(m),a,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,D.$zhc)(m))),h.$XL.from(y,new h.$XL(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(m,a,c,E,y){const $=this.b.get(a);if(!$)throw new Error(`No provider found for '${a}'`);if($.type!==1)throw new Error(`Invalid provide type for '${a}'`);const I=g.URI.revive(m),d=await $.provider.openCustomDocument(I,{backupId:c,untitledDocumentData:E?.buffer},y);let w;return i($.provider)&&this.f&&(w=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(a,d,w),{editable:i($.provider)}}async $disposeCustomDocument(m,a){const c=this.b.get(a);if(!c)throw new Error(`No provider found for '${a}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${a}'`);const E=g.URI.revive(m),{document:y}=this.i(a,E);this.c.delete(a,y),y.dispose()}async $resolveCustomEditor(m,a,c,E,y,$){const I=this.b.get(c);if(!I)throw new Error(`No provider found for '${c}'`);const d=f.ViewColumn.to(y),w=this.g.createNewWebview(a,E.contentOptions,I.extension),b=this.h.createNewWebviewPanel(a,c,E.title,d,E.options,w,E.active),M=g.URI.revive(m);switch(I.type){case 1:{const{document:T}=this.i(c,M);return I.provider.resolveCustomEditor(T,b,$)}case 0:{const T=this.d.getDocument(M);return I.provider.resolveCustomTextEditor(T,b,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(m,a,c){this.i(a,m).disposeEdits(c)}async $onMoveCustomEditor(m,a,c){const E=this.b.get(c);if(!E)throw new Error(`No provider found for '${c}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const y=this.h.getWebviewPanel(m);if(!y)throw new Error("No webview found");const $=g.URI.revive(a),I=this.d.getDocument($);await E.provider.moveCustomTextEditor(I,y,S.CancellationToken.None)}async $undo(m,a,c,E){return this.i(a,m).undo(c,E)}async $redo(m,a,c,E){return this.i(a,m).redo(c,E)}async $revert(m,a,c){const E=this.i(a,m);await this.j(a).revertCustomDocument(E.document,c),E.disposeBackup()}async $onSave(m,a,c){const E=this.i(a,m);await this.j(a).saveCustomDocument(E.document,c),E.disposeBackup()}async $onSaveAs(m,a,c,E){const y=this.i(a,m);return this.j(a).saveCustomDocumentAs(y.document,g.URI.revive(c),E)}async $backup(m,a,c){const E=this.i(a,m),$=await this.j(a).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},c);return E.updateBackup($),$.id}i(m,a){const c=this.c.get(m,g.URI.revive(a));if(!c)throw new Error("No custom document found");return c}j(m){const c=this.b.get(m)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.$Ehc=r;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function l(t){const m=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,F.$3i)(m)+""}}),define(Fe[253],Le([1,0,160,98,2,3,7,8,5,14,28,43]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;class v{#e;#t;#i;constructor(u,r,i,n,o,l,t,m){this.d=u,this.e=r,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$Ac(a=>l.getComparisonKey(a)),this.#e=t,this.#t=m}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(u,r){if(!u){this.clear();return}this.j();let i=[];if(P.URI.isUri(u)){if(!r){this.delete(u);return}this.#i.set(u,r.slice()),i=[u]}else if(Array.isArray(u)){i=[];let l;u=[...u].sort(v.k);for(const t of u){const[m,a]=t;if((!l||m.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=m,i.push(m),this.#i.set(m,[])),a)this.#i.get(m)?.push(...a);else{const c=this.#i.get(m);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const l of i){let t=[];const m=this.#i.get(l);if(m)if(m.length>this.g){t=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const E of m)if(E.severity===a[c]&&t.push({...g.Diagnostic.from(E),modelVersionId:this.h(l)})===this.g)break e;t.push({severity:F.MarkerSeverity.Info,message:(0,S.localize)(0,null,m.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=m.map(a=>({...g.Diagnostic.from(a),modelVersionId:this.h(l)}));if(n.push([l,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(u){this.j(),this.#t.fire([u]),this.#i.delete(u),this.#e?.$changeMany(this.e,[[u,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(u,r){this.j();for(const[i,n]of this)u.call(r,i,n,this)}*[Symbol.iterator](){this.j();for(const u of this.#i.keys())yield[u,this.get(u)]}get(u){this.j();const r=this.#i.get(u);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(u){return this.j(),Array.isArray(this.#i.get(u))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(u,r){return u[0].toString()<r[0].toString()?-1:u[0].toString()>r[0].toString()?1:0}}e.$$gc=v;let p=class{static{h=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*h.d}static _mapper(u){const r=new A.$Ac;for(const i of u)r.set(i,i);return{uris:Object.freeze(Array.from(r.values()))}}constructor(u,r,i,n){this.j=r,this.k=i,this.l=n,this.g=new Map,this.h=new f.$7d({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,h._mapper),this.f=u.getProxy(L.$VL.MainThreadDiagnostics)}createDiagnosticCollection(u,r){const{g:i,f:n,h:o,j:l,k:t,l:m}=this,a=new class{$changeMany(y,$){n.$changeMany(y,$),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",u.value,y,$.length===0?"CLEARING":$)}$clear(y){n.$clear(y),l.trace("[DiagnosticCollection] remove all (extension, owner)",u.value,y)}dispose(){n.dispose()}};let c;if(!r)r="_generated_diagnostic_collection_name_#"+h.c++,c=r;else if(!i.has(r))c=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do c=r+h.c++;while(i.has(c))}return new class extends v{constructor(){super(r,c,h.e,h.d,y=>m.getDocument(y)?.version,t.extUri,a,o),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(u){if(u)return this.m(u);{const r=new Map,i=[];for(const n of this.g.values())n.forEach((o,l)=>{let t=r.get(o.toString());typeof t>"u"&&(t=i.length,r.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...l)});return i}}m(u){let r=[];for(const i of this.g.values())i.has(u)&&(r=r.concat(i.get(u)));return r}$acceptMarkersChange(u){if(!this.n){const r="_generated_mirror",i=new v(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,i),this.n=i}for(const[r,i]of u)this.n.set(P.URI.revive(r),i.map(g.Diagnostic.to))}};e.$_gc=p,e.$_gc=p=h=Je([qe(1,D.$wj),qe(2,k.$0gc)],p)}),define(Fe[254],Le([1,0,2,15,7,8,187]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=void 0;class g{constructor(D,A,k,h={timeout:1500,errors:3}){this.c=D,this.d=A,this.f=k,this.g=h,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(D){return(A,k,h)=>{const p={dispose:this.a.push([A,k,D])};return Array.isArray(h)&&h.push(p),p}}async $participateInSave(D,A){const k=S.URI.revive(D);let h=!1;const v=setTimeout(()=>h=!0,this.g.timeout),p=[];try{for(const s of[...this.a]){if(h)break;const u=this.d.getDocument(k),r=await this.h(s,{document:u,reason:L.TextDocumentSaveReason.to(A)});p.push(r)}}finally{clearTimeout(v)}return p}h([D,A,k],h){const v=this.b.get(D);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(k,D,A,h).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const s=this.b.get(D);this.b.set(D,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(D,A,k,h){const v=[],p=Date.now(),{document:s,reason:u}=h,{version:r}=s,i=Object.freeze({document:s,reason:u,waitUntil(n){if(Object.isFrozen(v))throw(0,F.$8)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(k,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(l),n(t)}).catch(t=>{clearTimeout(l),o(t)})}).then(n=>{const o={edits:[]};for(const l of n)if(Array.isArray(l)&&l.every(t=>t instanceof P.$5L))for(const{newText:t,newEol:m,range:a}of l)o.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:a&&L.Range.from(a),text:t,eol:m&&L.EndOfLine.from(m)}});if(o.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$gic=g}),define(Fe[255],Le([1,0,5,6,2,3,109,8,16,26,7]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;class k{constructor(v,p){this.a=new S.$3d,this.b=new S.$3d,this.c=new S.$3d,this.d=new S.$3d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Sc,this.h=new Map,this.f=v.getProxy(L.$VL.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(s=>{for(const u of s)this.b.fire(u.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const u of s)this.a.fire(u.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const p=this.g.getDocument(v);if(p)return p}getDocument(v){const p=this.getDocumentData(v);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return p.document}ensureDocumentData(v){const p=this.g.getDocument(v);if(p)return Promise.resolve(p);let s=this.h.get(v.toString());return s||(s=this.f.$tryOpenDocument(v).then(u=>{this.h.delete(v.toString());const r=P.URI.revive(u);return(0,f.$2f)(this.g.getDocument(r))},u=>(this.h.delete(v.toString()),Promise.reject(u))),this.h.set(v.toString(),s)),s}createDocumentData(v){return this.f.$tryCreateDocument(v).then(p=>P.URI.revive(p))}$acceptModelLanguageChanged(v,p){const s=P.URI.revive(v),u=this.g.getDocument(s);if(!u)throw new Error("unknown document");this.b.fire(u.document),u._acceptLanguageId(p),this.a.fire(u.document)}$acceptModelSaved(v){const p=P.URI.revive(v),s=this.g.getDocument(p);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(v,p){const s=P.URI.revive(v),u=this.g.getDocument(s);if(!u)throw new Error("unknown document");u._acceptIsDirty(p),this.c.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,p,s){const u=P.URI.revive(v),r=this.g.getDocument(u);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(p);let i;p.isUndoing?i=A.TextDocumentChangeReason.Undo:p.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,D.$Gn)({document:r.document,contentChanges:p.changes.map(n=>({range:g.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(v,p){(0,R.$cO)(v,p)}}e.$ahc=k}),define(Fe[64],Le([1,0,256,5,16,2,4,3,17,8,7]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ghc=e.$Fhc=void 0,e.$Fhc=(0,R.$ci)("IExtHostEditorTabs");class k{constructor(u,r,i){this.e=i,this.d=r,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,r={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$FN(L.URI.revive(this.b.input.uri));case 2:return new A.$GN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$HN(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$IN(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$JN(this.b.input.viewType);case 4:return new A.$KN(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$LN(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$MN;case 9:return new A.$NN(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$ON(this.b.input.providerId);default:return}}}class h{constructor(u,r){this.c=[],this.d="",this.b=u,this.e=r;for(const i of u.tabs)i.isActive&&(this.d=i.id),this.c.push(new k(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,r={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return D.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(i=>i.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(i=>i.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const i=new k(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,i),u.tabDto.isActive&&(this.d=i.tabId),i}else if(u.kind===1){const i=this.c.splice(u.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(u.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,i),i}const r=this.c.find(i=>i.tabId===u.tabDto.id);if(!r)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(u.tabDto),r}activeTabId(){return this.d}}let v=class{constructor(u){this.b=new F.$3d,this.c=new F.$3d,this.e=[],this.a=u.getProxy(g.$VL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,r={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(i=>i.apiObject))},get activeTabGroup(){const i=u.d;return(0,P.$2f)(u.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?p(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(u){const r=new Set(this.e.map(a=>a.groupId)),i=new Set(u.map(a=>a.groupId)),n=(0,S.$L)(r,i),o=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],t=[];this.e=u.map(a=>{const c=new h(a,()=>this.d);return n.added.includes(c.groupId)?l.push(c.apiObject):t.push(c.apiObject),c});const m=(0,P.$2f)(u.find(a=>a.isActive===!0)?.groupId);m!==void 0&&this.d!==m&&(this.d=m),this.c.fire(Object.freeze({opened:l,closed:o,changed:t}))}$acceptTabGroupUpdate(u){const r=this.e.find(i=>i.groupId===u.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const r=this.e.find(n=>n.groupId===u.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const i=r.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(u){for(const r of this.e)for(const i of r.tabs)if(i.apiObject===u)return i}h(u){return this.e.find(r=>r.apiObject===u)}async i(u,r){const i=[];for(const n of u){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,r)}async j(u,r){const i=[];for(const n of u){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,r)}};e.$Ghc=v,e.$Ghc=v=Je([qe(0,f.$aO)],v);function p(s){return s.tabs!==void 0}}),define(Fe[257],Le([1,0,2,3,6,7,8,299,13,24,23,46]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;class h{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const u=this.a.indexOf(s);u>=0&&(this.a.splice(u,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),u=[];let r,i,n=14,o=14;for(const l of s){let t=r?(0,f.$jf)(r,l):0;for(t===0?i=1:i=o;t<l.length;t++)t+1===l.length?(n=o,o=9):o+=1,u.push([i,l.toUpperCase().charCodeAt(t),o]),u.push([i,l.toLowerCase().charCodeAt(t),o]),i=o;r=l,o=n}u.push([9,58,10]),u.push([10,47,12]),this.b=new g.$B1(u)}}provideDocumentLinks(s){this.c();const u=[],r=g.$C1.computeLinks({getLineContent(i){return s.lineAt(i-1).text},getLineCount(){return s.lineCount}},this.b);for(const i of r){const n=R.DocumentLink.to(i);n.target&&u.push(n)}return u}}class v{constructor(s,u){this.i=u,this.b=new h,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(F.$VL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,u,r,i={}){if(v.j(r),this.d.has(u))throw new Error(`a provider for the scheme '${u}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(u),this.d.add(u),this.c.set(n,r);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof r.copy=="function"&&(o+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,A.$SF)(s,"fsChunks"),o+=4);let l;i.isReadonly&&(0,k.$sk)(i.isReadonly)&&i.isReadonly.value!==""&&(l={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,u,o,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${u}`),console.error(m)});const t=r.onDidChangeFile(m=>{const a=[];for(const c of m){const{uri:E,type:y}=c;if(E.scheme!==u)continue;let $;switch(y){case L.FileChangeType.Changed:$=0;break;case L.FileChangeType.Created:$=1;break;case L.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:E,type:$})}this.a.$onFileSystemChange(n,a)});return(0,P.$Rc)(()=>{t.dispose(),this.b.delete(u),this.d.delete(u),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:u,ctime:r,mtime:i,size:n,permissions:o}=s;return{type:u,ctime:r,mtime:i,size:n,permissions:o}}$stat(s,u){return Promise.resolve(this.l(s).stat(S.URI.revive(u))).then(r=>v.k(r))}$readdir(s,u){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(u)))}$readFile(s,u){return Promise.resolve(this.l(s).readFile(S.URI.revive(u))).then(r=>D.$qe.wrap(r))}$writeFile(s,u,r,i){return Promise.resolve(this.l(s).writeFile(S.URI.revive(u),r.buffer,i))}$delete(s,u,r){return Promise.resolve(this.l(s).delete(S.URI.revive(u),r))}$rename(s,u,r,i){return Promise.resolve(this.l(s).rename(S.URI.revive(u),S.URI.revive(r),i))}$copy(s,u,r,i){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(u),S.URI.revive(r),i))}$mkdir(s,u){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(u)))}$watch(s,u,r,i){const n=this.l(s).watch(S.URI.revive(r),i);this.f.set(u,n)}$unwatch(s,u){const r=this.f.get(u);r&&(r.dispose(),this.f.delete(u))}$open(s,u,r){const i=this.l(s);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(u),r))}$close(s,u){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(u))}$read(s,u,r,i){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=D.$qe.alloc(i);return Promise.resolve(n.read(u,r,o.buffer,0,i)).then(l=>o.slice(0,l))}$write(s,u,r,i){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(u,r,i.buffer,0,i.byteLength))}l(s){const u=this.c.get(s);if(!u){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return u}}e.$iic=v}),define(Fe[258],Le([1,0,5,34,2,3,8,7,39]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,p,s,u,r,i){this.a=Math.random(),this.b=new S.$3d,this.c=new S.$3d,this.d=new S.$3d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,F.$Vj)(r),o=typeof r=="string",l=i?.correlate,t=u(m=>{if(!(typeof m.session=="number"&&m.session!==this.a)&&!(l&&typeof m.session>"u")){if(!i?.ignoreCreateEvents)for(const a of m.created){const c=P.URI.revive(a);n(c.fsPath)&&(!o||p.getWorkspaceFolder(c))&&this.b.fire(c)}if(!i?.ignoreChangeEvents)for(const a of m.changed){const c=P.URI.revive(a);n(c.fsPath)&&(!o||p.getWorkspaceFolder(c))&&this.c.fire(c)}if(!i?.ignoreDeleteEvents)for(const a of m.deleted){const c=P.URI.revive(a);n(c.fsPath)&&(!o||p.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=g.$XL.from(this.i(v,s,r,i,i?.correlate),this.b,this.c,this.d,t)}i(v,p,s,u,r){const i=g.$XL.from();if(typeof s=="string")return i;const n=v.getProxy(L.$VL.MainThreadFileSystemEventService);let o=!1;return(s.pattern.includes(F.$Rj)||s.pattern.includes(F.$Sj))&&(o=!0),n.$watch(p.identifier.value,this.a,s.baseUri,{recursive:o,excludes:u?.excludes??[]},!!r),g.$XL.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(P.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(v,p,s){this.j=v,this.k=p,this.l=s,this.a=new S.$3d,this.b=new S.$3d,this.c=new S.$3d,this.d=new S.$3d,this.g=new S.$5d,this.h=new S.$5d,this.i=new S.$5d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,p,s,u){return new D(this.j,v,p,this.a.event,R.GlobPattern.from(s),u)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,p){switch(v){case 2:this.b.fire(Object.freeze({files:p.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,p){return(s,u,r)=>{const i=function(o){s.call(u,o)};return i.extension=v,p.event(i,void 0,r)}}async $onWillRunFileOperation(v,p,s,u){switch(v){case 2:return await this.n(this.g,{files:p.map(r=>({oldUri:P.URI.revive(r.source),newUri:P.URI.revive(r.target)}))},s,u);case 1:return await this.n(this.i,{files:p.map(r=>P.URI.revive(r.target))},s,u);case 0:case 3:return await this.n(this.h,{files:p.map(r=>P.URI.revive(r.target))},s,u)}}async n(v,p,s,u){const r=new Set,i=[];if(await v.fireAsync(p,u,async(o,l)=>{const t=Date.now(),m=await Promise.resolve(o);m instanceof g.$8L&&(i.push([l.extension,m]),r.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",l.extension.identifier)}),u.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:l}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(l)}return{edit:n,extensionNames:Array.from(r)}}}e.$jic=k}),define(Fe[259],Le([1,0,18,11,21,15,88,6,26,63,13,16,2,29,300,86,95,162,22,8,7,23,74,3]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class a{constructor(N,K){this.d=N,this.e=K}async provideDocumentSymbols(N,K){const j=this.d.getDocument(N),H=await this.e.provideDocumentSymbols(j,K);if(!(0,S.$Kb)(H))return H[0]instanceof o.$eM?H.map(n.DocumentSymbol.from):a.f(H)}static f(N){N=N.slice(0).sort((H,Z)=>{let oe=H.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(H.location.range.end)),oe});const K=[],j=[];for(const H of N){const Z={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(j.length===0){j.push(Z),K.push(Z);break}const oe=j[j.length-1];if(v.$4s.containsRange(oe.range,Z.range)&&!v.$4s.equalsRange(oe.range,Z.range)){oe.children?.push(Z),j.push(Z);break}j.pop()}}return K}}class c{constructor(N,K,j,H,Z,oe){this.f=N,this.g=K,this.h=j,this.j=H,this.k=Z,this.l=oe,this.d=new t.$4gc("CodeLens"),this.e=new Map}async provideCodeLenses(N,K){const j=this.f.getDocument(N),H=await this.h.provideCodeLenses(j,K);if(!H||K.isCancellationRequested)return;const Z=this.d.add(H),oe=new g.$Sc;this.e.set(Z,oe);const Ee={cacheId:Z,lenses:[]};for(let Be=0;Be<H.length;Be++)Ee.lenses.push({cacheId:[Z,Be],range:n.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,oe)});return Ee}async resolveCodeLens(N,K){const j=N.cacheId&&this.d.get(...N.cacheId);if(!j)return;let H;if(typeof this.h.resolveCodeLens!="function"||j.isResolved?H=j:H=await this.h.resolveCodeLens(j,K),H||(H=j),K.isCancellationRequested)return;const Z=N.cacheId&&this.e.get(N.cacheId[0]);if(Z){if(!H.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return N.command=this.g.toInternal(H.command,Z),N}}releaseCodeLenses(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}}function E(Ce){return Array.isArray(Ce)?Ce.map(n.DefinitionLink.from):Ce?[n.DefinitionLink.from(Ce)]:[]}class y{constructor(N,K){this.d=N,this.e=K}async provideDefinition(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideDefinition(H,Z,j);return E(oe)}}class ${constructor(N,K){this.d=N,this.e=K}async provideDeclaration(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideDeclaration(H,Z,j);return E(oe)}}class I{constructor(N,K){this.d=N,this.e=K}async provideImplementation(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideImplementation(H,Z,j);return E(oe)}}class d{constructor(N,K){this.d=N,this.e=K}async provideTypeDefinition(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideTypeDefinition(H,Z,j);return E(oe)}}class w{constructor(N,K){this.d=N,this.e=K}async provideHover(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideHover(H,Z,j);if(!(!oe||(0,S.$Kb)(oe.contents)))return oe.range||(oe.range=H.getWordRangeAtPosition(Z)),oe.range||(oe.range=new o.$ZL(Z,Z)),n.Hover.from(oe)}}class b{constructor(N,K){this.d=N,this.e=K}async provideEvaluatableExpression(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideEvaluatableExpression(H,Z,j);if(oe)return n.EvaluatableExpression.from(oe)}}class M{constructor(N,K){this.d=N,this.e=K}async provideInlineValues(N,K,j,H){const Z=this.d.getDocument(N),oe=await this.e.provideInlineValues(Z,n.Range.to(K),n.InlineValueContext.to(j),H);if(Array.isArray(oe))return oe.map(Ee=>n.InlineValue.from(Ee))}}class T{constructor(N,K){this.d=N,this.e=K}async provideDocumentHighlights(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideDocumentHighlights(H,Z,j);if(Array.isArray(oe))return oe.map(n.DocumentHighlight.from)}}class G{constructor(N,K){this.d=N,this.e=K}async provideMultiDocumentHighlights(N,K,j,H){const Z=this.d.getDocument(N),oe=j.map(Ve=>this.d.getDocument(Ve)),Ee=n.Position.to(K),Be=await this.e.provideMultiDocumentHighlights(Z,Ee,oe,H);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class W{constructor(N,K){this.d=N,this.e=K}async provideLinkedEditingRanges(N,K,j){const H=this.d.getDocument(N),Z=n.Position.to(K),oe=await this.e.provideLinkedEditingRanges(H,Z,j);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,S.$Hb)(oe.ranges.map(n.Range.from)),wordPattern:oe.wordPattern}}}class U{constructor(N,K){this.d=N,this.e=K}async provideReferences(N,K,j,H){const Z=this.d.getDocument(N),oe=n.Position.to(K),Ee=await this.e.provideReferences(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(n.location.from)}}class C{static{this.d=1e3}constructor(N,K,j,H,Z,oe,Ee){this.g=N,this.h=K,this.j=j,this.k=H,this.l=Z,this.m=oe,this.n=Ee,this.e=new t.$4gc("CodeAction"),this.f=new Map}async provideCodeActions(N,K,j,H){const Z=this.g.getDocument(N),oe=p.$6s.isISelection(K)?n.Selection.to(K):n.Range.to(K),Ee=[];for(const nt of this.j.getDiagnostics(N))if(oe.intersection(nt.range)&&Ee.push(nt)>C.d)break;const Be={diagnostics:Ee,only:j.only?new o.$gM(j.only):void 0,triggerKind:n.CodeActionTriggerKind.to(j.trigger)},Ve=await this.k.provideCodeActions(Z,oe,Be,H);if(!(0,S.$Lb)(Ve)||H.isCancellationRequested)return;const Ze=this.e.add(Ve),xe=new g.$Sc;this.f.set(Ze,xe);const at=[];for(let nt=0;nt<Ve.length;nt++){const et=Ve[nt];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,xe)});else{Be.only&&(et.kind?Be.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ut=et.ranges??[];at.push({cacheId:[Ze,nt],title:et.title,command:et.command&&this.h.toInternal(et.command,xe),diagnostics:et.diagnostics&&et.diagnostics.map(n.Diagnostic.from),edit:et.edit&&n.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,l.$RF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,l.$RF)(this.m,"codeActionRanges")?(0,S.$Hb)(ut.map(n.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ze,actions:at}}async resolveCodeAction(N,K){const[j,H]=N,Z=this.e.get(j,H);if(!Z||C.o(Z))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(Z,K)??Z;let Ee;oe.edit&&(Ee=n.WorkspaceEdit.from(oe.edit,void 0));let Be;if(oe.command){const Ve=this.f.get(j);Ve&&(Be=this.h.toInternal(oe.command,Ve))}return{edit:Ee,command:Be}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}class O{static toInternalProviderId(N,K){return N+"."+K}constructor(N,K,j,H,Z){this.d=N,this.e=K,this.f=j,this.g=H,this.h=Z}async prepareDocumentPaste(N,K,j,H){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(N),oe=K.map(Ve=>n.Range.to(Ve)),Ee=n.DataTransfer.toDataTransfer(j,()=>{throw new L.$$});if(await this.f.prepareDocumentPaste(Z,oe,Ee,H),H.isCancellationRequested)return;const Be=Array.from(Ee).filter(([,Ve])=>!(Ve instanceof o.$MM));return n.DataTransfer.from(Be)}async providePasteEdits(N,K,j,H,Z){if(!this.f.provideDocumentPasteEdits)return;const oe=this.e.getDocument(K),Ee=j.map(Ze=>n.Range.to(Ze)),Be=n.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolvePasteFileData(this.g,N,Ze)).buffer),Ve=await this.f.provideDocumentPasteEdits(oe,Ee,Be,Z);if(Ve)return{label:Ve.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ve.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:O.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?n.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class V{constructor(N,K){this.d=N,this.e=K}async provideDocumentFormattingEdits(N,K,j){const H=this.d.getDocument(N),Z=await this.e.provideDocumentFormattingEdits(H,K,j);if(Array.isArray(Z))return Z.map(n.TextEdit.from)}}class re{constructor(N,K){this.d=N,this.e=K}async provideDocumentRangeFormattingEdits(N,K,j,H){const Z=this.d.getDocument(N),oe=n.Range.to(K),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,K,j,H){(0,k.$1f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(N),oe=K.map(n.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(n.TextEdit.from)}}class ce{constructor(N,K){this.d=N,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,K,j,H,Z){const oe=this.d.getDocument(N),Ee=n.Position.to(K),Be=await this.e.provideOnTypeFormattingEdits(oe,Ee,j,H,Z);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class ye{constructor(N,K){this.e=N,this.f=K,this.d=new t.$4gc("WorkspaceSymbols")}async provideWorkspaceSymbols(N,K){const j=await this.e.provideWorkspaceSymbols(N,K);if(!(0,S.$Lb)(j))return{symbols:[]};const H=this.d.add(j),Z={cacheId:H,symbols:[]};for(let oe=0;oe<j.length;oe++){const Ee=j[oe];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...n.WorkspaceSymbol.from(Ee),cacheId:[H,oe]})}return Z}async resolveWorkspaceSymbol(N,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const j=this.d.get(...N.cacheId);if(j){const H=await this.e.resolveWorkspaceSymbol(j,K);return H&&(0,f.$In)(N,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class ke{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,K,j){this.d=N,this.e=K,this.f=j}async provideRenameEdits(N,K,j,H){const Z=this.d.getDocument(N),oe=n.Position.to(K);try{const Ee=await this.e.provideRenameEdits(Z,oe,j,H);return Ee?n.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Be=ke.g(Ee);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(N,K,j){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(N),Z=n.Position.to(K);try{const oe=await this.e.prepareRename(H,Z,j);let Ee,Be;if(o.$ZL.isRange(oe)?(Ee=oe,Be=H.getText(oe)):(0,k.$Sf)(oe)&&(Ee=oe.range,Be=oe.placeholder),!Ee||!Be)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ee),text:Be}}catch(oe){const Ee=ke.g(oe);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(oe)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class he{constructor(N,K,j){this.d=N,this.e=K,this.f=j}async provideNewSymbolNames(N,K,j){const H=this.d.getDocument(N),Z=n.Range.to(K);try{const oe=await this.e.provideNewSymbolNames(H,Z,j);return oe?oe.map(Ee=>typeof Ee=="string"?{newSymbolName:Ee}:{newSymbolName:Ee.newSymbolName,tags:Ee.tags}):void 0}catch(oe){this.f.error(he.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class ve{constructor(N,K){this.resultId=N,this.tokens=K}}class se{constructor(N,K){this.f=N,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,K,j){const H=this.f.getDocument(N),Z=K!==0?this.d.get(K):null;let oe=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,Z.resultId,j):await this.g.provideDocumentSemanticTokens(H,j);return Z&&this.d.delete(K),oe?(oe=se.h(oe),this.o(se.n(Z,oe),oe)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return se.j(N)?se.k(N)?N:new o.$eN(new Uint32Array(N.data),N.resultId):se.l(N)?se.m(N)?N:new o.$gN(N.edits.map(K=>new o.$fN(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const K of N.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(N,K){if(!se.j(K)||!N||!N.tokens)return K;const j=N.tokens,H=j.length,Z=K.data,oe=Z.length;let Ee=0;const Be=Math.min(H,oe);for(;Ee<Be&&j[Ee]===Z[Ee];)Ee++;if(Ee===H&&Ee===oe)return new o.$gN([],K.resultId);let Ve=0;const Ze=Be-Ee;for(;Ve<Ze&&j[H-Ve-1]===Z[oe-Ve-1];)Ve++;return new o.$gN([{start:Ee,deleteCount:H-Ee-Ve,data:Z.subarray(Ee,oe-Ve)}],K.resultId)}o(N,K){if(se.j(N)){const j=this.e++;return this.d.set(j,new ve(N.resultId,N.data)),(0,u.$I_)({id:j,type:"full",data:N.data})}if(se.l(N)){const j=this.e++;return se.j(K)?this.d.set(j,new ve(K.resultId,K.data)):this.d.set(j,new ve(N.resultId)),(0,u.$I_)({id:j,type:"delta",deltas:(N.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(N,K){this.d=N,this.e=K}async provideDocumentRangeSemanticTokens(N,K,j){const H=this.d.getDocument(N),Z=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(K),j);return Z?this.f(Z):null}f(N){return(0,u.$I_)({id:0,type:"full",data:N.data})}}class te{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,K,j,H,Z){this.f=N,this.g=K,this.h=j,this.j=H,this.k=Z,this.d=new t.$4gc("CompletionItem"),this.e=new Map}async provideCompletionItems(N,K,j,H){const Z=this.f.getDocument(N),oe=n.Position.to(K),Ee=Z.getWordRangeAtPosition(oe)||new o.$ZL(oe,oe),Be=Ee.with({end:oe}),Ve=new D.$Yd,Ze=await this.h.provideCompletionItems(Z,oe,H,n.CompletionContext.to(j));if(!Ze||H.isCancellationRequested)return;const xe=Array.isArray(Ze)?new o.$tM(Ze):Ze,at=te.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),nt=new g.$Sc;this.e.set(at,nt);const et=[],ut={x:at,b:et,a:{replace:n.Range.from(Ee),insert:n.Range.from(Be)},c:xe.isIncomplete||void 0,d:Ve.elapsed()};for(let je=0;je<xe.items.length;je++){const pt=xe.items[je],X=this.l(pt,[at,je],Be,Ee);et.push(X)}return ut}async resolveCompletionItem(N,K){if(typeof this.h.resolveCompletionItem!="function")return;const j=this.d.get(...N);if(!j)return;const H=this.l(j,N),Z=await this.h.resolveCompletionItem(j,K);if(!Z)return;const oe=this.l(Z,N);return(H.h!==oe.h||H.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==oe.n||H.o!==oe.o||!(0,f.$Jn)(H.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,K,j,H){const Z=this.e.get(K[0]);if(!Z)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(N.command,Z),Ee={x:K,a:N.label,b:N.kind!==void 0?n.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(n.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:n.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(n.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=N.textEdit.newText):typeof N.insertText=="string"?Ee.h=N.insertText:N.insertText instanceof o.$9L&&(Ee.h=N.insertText.value,Ee.i|=4);let Be;return N.textEdit?Be=N.textEdit.range:N.range&&(Be=N.range),o.$ZL.isRange(Be)?Ee.j=n.Range.from(Be):Be&&(!j?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ee.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Ee}}class Y{async provideInlineCompletions(N,K,j,H){}disposeCompletions(N){}handleDidShowCompletionItem(N,K,j){}handlePartialAccept(N,K,j){}}class q extends Y{constructor(N,K,j,H){super(),this.f=N,this.g=K,this.h=j,this.j=H,this.d=new ne,this.e=(0,l.$RF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,l.$RF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,K,j,H){const Z=this.g.getDocument(N),oe=n.Position.to(K),Ee=await this.h.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:n.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[j.triggerKind]},H);if(!Ee||H.isCancellationRequested)return;const Be=Array.isArray(Ee)?Ee:Ee.items,Ve=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ze=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((nt,et)=>{let ut;nt.command&&(xe||(xe=new g.$Sc),ut=this.j.toInternal(nt.command,xe));const je=nt.insertText;return{insertText:typeof je=="string"?je:{snippet:je.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:ut,idx:et,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ve.map(nt=>(xe||(xe=new g.$Sc),this.j.toInternal(nt,xe))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,K,j){const H=this.d.get(N)?.items[K];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,j)}handlePartialAccept(N,K,j){const H=this.d.get(N)?.items[K];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,j)}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const K=this.e++;return this.d.set(K,N),K}disposeReferenceId(N){const K=this.d.get(N);return this.d.delete(N),K}get(N){return this.d.get(N)}}class Pe{constructor(N,K){this.e=N,this.f=K,this.d=new t.$4gc("SignatureHelp")}async provideSignatureHelp(N,K,j,H){const Z=this.e.getDocument(N),oe=n.Position.to(K),Ee=this.g(j),Be=await this.f.provideSignatureHelp(Z,oe,H,Ee);if(Be){const Ve=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Ve}}}g(N){let K;if(N.activeSignatureHelp){const j=n.SignatureHelp.to(N.activeSignatureHelp),H=this.d.get(N.activeSignatureHelp.id,0);H?(K=H,K.activeSignature=j.activeSignature,K.activeParameter=j.activeParameter):K=j}return{...N,activeSignatureHelp:K}}releaseSignatureHelp(N){this.d.delete(N)}}class Oe{constructor(N,K,j,H,Z){this.f=N,this.g=K,this.h=j,this.j=H,this.k=Z,this.d=new t.$4gc("InlayHints"),this.e=new Map}async provideInlayHints(N,K,j){const H=this.f.getDocument(N),Z=n.Range.to(K),oe=await this.h.provideInlayHints(H,Z,j);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(j.isCancellationRequested)return;const Ee=this.d.add(oe);this.e.set(Ee,new g.$Sc);const Be={hints:[],cacheId:Ee};for(let Ve=0;Ve<oe.length;Ve++)this.l(oe[Ve],Z)&&Be.hints.push(this.m(oe[Ve],[Ee,Ve]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),Be}async resolveInlayHint(N,K){if(typeof this.h.resolveInlayHint!="function")return;const j=this.d.get(...N);if(!j)return;const H=await this.h.resolveInlayHint(j,K);if(H&&this.l(H))return this.m(H,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,K){return N.label.length===0||Array.isArray(N.label)&&N.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(K&&!K.contains(N.position))}m(N,K){const j=this.e.get(K[0]);if(!j)throw Error("DisposableStore is missing...");const H={label:"",cacheId:K,tooltip:n.MarkdownString.fromStrict(N.tooltip),position:n.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(n.TextEdit.from),kind:N.kind&&n.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};if(typeof N.label=="string")H.label=N.label;else{const Z=[];H.label=Z;for(const oe of N.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:oe.value,tooltip:n.MarkdownString.fromStrict(oe.tooltip)};o.$0L.isLocation(oe.location)&&(Ee.location=n.location.from(oe.location)),oe.command&&(Ee.command=this.g.toInternal(oe.command,j)),Z.push(Ee)}}return H}}class Re{constructor(N,K){this.e=N,this.f=K,this.d=new t.$4gc("DocumentLink")}async provideLinks(N,K){const j=this.e.getDocument(N),H=await this.f.provideDocumentLinks(j,K);if(!(!Array.isArray(H)||H.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(Re.g).map(n.DocumentLink.from)};{const Z=this.d.add(H),oe={links:[],cacheId:Z};for(let Ee=0;Ee<H.length;Ee++){if(!Re.g(H[Ee]))continue;const Be=n.DocumentLink.from(H[Ee]);Be.cacheId=[Z,Ee],oe.links.push(Be)}return oe}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,K){if(typeof this.f.resolveDocumentLink!="function")return;const j=this.d.get(...N);if(!j)return;const H=await this.f.resolveDocumentLink(j,K);if(!(!H||!Re.g(H)))return n.DocumentLink.from(H)}releaseLinks(N){this.d.delete(N)}}class be{constructor(N,K){this.d=N,this.e=K}async provideColors(N,K){const j=this.d.getDocument(N),H=await this.e.provideDocumentColors(j,K);return Array.isArray(H)?H.map(oe=>({color:n.Color.from(oe.color),range:n.Range.from(oe.range)})):[]}async provideColorPresentations(N,K,j){const H=this.d.getDocument(N),Z=n.Range.to(K.range),oe=n.Color.to(K.color),Ee=await this.e.provideColorPresentations(oe,{document:H,range:Z},j);if(Array.isArray(Ee))return Ee.map(n.ColorPresentation.from)}}class me{constructor(N,K){this.d=N,this.e=K}async provideFoldingRanges(N,K,j){const H=this.d.getDocument(N),Z=await this.e.provideFoldingRanges(H,K,j);if(Array.isArray(Z))return Z.map(n.FoldingRange.from)}}class Q{constructor(N,K,j){this.d=N,this.e=K,this.f=j}async provideSelectionRanges(N,K,j){const H=this.d.getDocument(N),Z=K.map(n.Position.to),oe=await this.e.provideSelectionRanges(H,Z,j);if(!(0,S.$Lb)(oe))return[];if(oe.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Be=0;Be<Z.length;Be++){const Ve=[];Ee.push(Ve);let Ze=Z[Be],xe=oe[Be];for(;;){if(!xe.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(n.SelectionRange.from(xe)),!xe.parent)break;Ze=xe.range,xe=xe.parent}}return Ee}}class x{constructor(N,K){this.f=N,this.g=K,this.d=new R.$fO(""),this.e=new Map}async prepareSession(N,K,j){const H=this.f.getDocument(N),Z=n.Position.to(K),oe=await this.g.prepareCallHierarchy(H,Z,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideCallsTo(N,K,j){const H=this.j(N,K);if(!H)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(H,j);if(Z)return Z.map(oe=>({from:this.h(N,oe.from),fromRanges:oe.fromRanges.map(Ee=>n.Range.from(Ee))}))}async provideCallsFrom(N,K,j){const H=this.j(N,K);if(!H)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(H,j);if(Z)return Z.map(oe=>({to:this.h(N,oe.to),fromRanges:oe.fromRanges.map(Ee=>n.Range.from(Ee))}))}releaseSession(N){this.e.delete(N)}h(N,K){const j=this.e.get(N),H=n.CallHierarchyItem.from(K,N,j.size.toString(36));return j.set(H._itemId,K),H}j(N,K){return this.e.get(N)?.get(K)}}class le{constructor(N,K){this.f=N,this.g=K,this.d=new R.$fO(""),this.e=new Map}async prepareSession(N,K,j){const H=this.f.getDocument(N),Z=n.Position.to(K),oe=await this.g.prepareTypeHierarchy(H,Z,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideSupertypes(N,K,j){const H=this.j(N,K);if(!H)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(H,j);if(Z)return Z.map(oe=>this.h(N,oe))}async provideSubtypes(N,K,j){const H=this.j(N,K);if(!H)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(H,j);if(Z)return Z.map(oe=>this.h(N,oe))}releaseSession(N){this.e.delete(N)}h(N,K){const j=this.e.get(N),H=n.TypeHierarchyItem.from(K,N,j.size.toString(36));return j.set(H._itemId,K),H}j(N,K){return this.e.get(N)?.get(K)}}class de{static toInternalProviderId(N,K){return N+"."+K}constructor(N,K,j,H,Z){this.d=N,this.e=K,this.f=j,this.g=H,this.h=Z}async provideDocumentOnDropEdits(N,K,j,H,Z){const oe=this.e.getDocument(K),Ee=n.Position.to(j),Be=n.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,Ze)).buffer),Ve=await this.f.provideDocumentDropEdits(oe,Ee,Be,Z);if(Ve)return{label:Ve.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ve.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ve.insertText=="string"?Ve.insertText:{snippet:Ve.insertText.value},additionalEdit:Ve.additionalEdit?n.WorkspaceEdit.from(Ve.additionalEdit,void 0):void 0}}}class Me{constructor(N,K){this.d=N,this.e=K}async provideMappedEdits(N,K,j,H){const Z=h.URI.revive(N),oe=this.d.getDocument(Z),Ee=j.documents.map(Ze=>Ze.map(xe=>({uri:h.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(at=>n.Range.to(at))}))),Be={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Ve=await this.e.provideMappedEdits(oe,K,Be,H);return Ve?n.WorkspaceEdit.from(Ve):null}}class ge{constructor(N,K){this.adapter=N,this.extension=K}}class Se{static{this.d=0}constructor(N,K,j,H,Z,oe,Ee,Be){this.g=K,this.h=j,this.j=H,this.k=Z,this.l=oe,this.m=Ee,this.n=Be,this.f=new Map,this.e=N.getProxy(m.$VL.MainThreadLanguageFeatures)}o(N,K){return n.DocumentSelector.from(N,this.g,K)}p(N){return new o.$XL(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return Se.d++}async s(N,K,j,H,Z,oe=!1){const Ee=this.f.get(N);if(!Ee||!(Ee.adapter instanceof K))return H;const Be=Date.now();oe||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const Ve=j(Ee.adapter,Ee.extension);return Promise.resolve(Ve).catch(Ze=>{(0,L.$4)(Ze)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Ee.extension.identifier,Ze))}).finally(()=>{oe||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),P.CancellationToken.isCancellationToken(Z)?(0,F.$4g)(Ve,Z):Ve}t(N,K){const j=this.q();return this.f.set(j,new ge(N,K)),j}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,K,j,H){const Z=this.t(new a(this.h,j),N),oe=H&&H.label||Se.u(N);return this.e.$registerDocumentSymbolProvider(Z,this.o(K,N),oe),this.p(Z)}$provideDocumentSymbols(N,K,j){return this.s(N,a,H=>H.provideDocumentSymbols(h.URI.revive(K),j),void 0,j)}registerCodeLensProvider(N,K,j){const H=this.q(),Z=typeof j.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ge(new c(this.h,this.j.converter,j,N,this.n,this.l),N)),this.e.$registerCodeLensSupport(H,this.o(K,N),Z);let oe=this.p(H);if(Z!==void 0){const Ee=j.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(Z));oe=o.$XL.from(oe,Ee)}return oe}$provideCodeLenses(N,K,j){return this.s(N,c,H=>H.provideCodeLenses(h.URI.revive(K),j),void 0,j)}$resolveCodeLens(N,K,j){return this.s(N,c,H=>H.resolveCodeLens(K,j),void 0,void 0)}$releaseCodeLenses(N,K){this.s(N,c,j=>Promise.resolve(j.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(N,K,j){const H=this.t(new y(this.h,j),N);return this.e.$registerDefinitionSupport(H,this.o(K,N)),this.p(H)}$provideDefinition(N,K,j,H){return this.s(N,y,Z=>Z.provideDefinition(h.URI.revive(K),j,H),[],H)}registerDeclarationProvider(N,K,j){const H=this.t(new $(this.h,j),N);return this.e.$registerDeclarationSupport(H,this.o(K,N)),this.p(H)}$provideDeclaration(N,K,j,H){return this.s(N,$,Z=>Z.provideDeclaration(h.URI.revive(K),j,H),[],H)}registerImplementationProvider(N,K,j){const H=this.t(new I(this.h,j),N);return this.e.$registerImplementationSupport(H,this.o(K,N)),this.p(H)}$provideImplementation(N,K,j,H){return this.s(N,I,Z=>Z.provideImplementation(h.URI.revive(K),j,H),[],H)}registerTypeDefinitionProvider(N,K,j){const H=this.t(new d(this.h,j),N);return this.e.$registerTypeDefinitionSupport(H,this.o(K,N)),this.p(H)}$provideTypeDefinition(N,K,j,H){return this.s(N,d,Z=>Z.provideTypeDefinition(h.URI.revive(K),j,H),[],H)}registerHoverProvider(N,K,j,H){const Z=this.t(new w(this.h,j),N);return this.e.$registerHoverProvider(Z,this.o(K,N)),this.p(Z)}$provideHover(N,K,j,H){return this.s(N,w,Z=>Z.provideHover(h.URI.revive(K),j,H),void 0,H)}registerEvaluatableExpressionProvider(N,K,j,H){const Z=this.t(new b(this.h,j),N);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(K,N)),this.p(Z)}$provideEvaluatableExpression(N,K,j,H){return this.s(N,b,Z=>Z.provideEvaluatableExpression(h.URI.revive(K),j,H),void 0,H)}registerInlineValuesProvider(N,K,j,H){const Z=typeof j.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new M(this.h,j),N);this.e.$registerInlineValuesProvider(oe,this.o(K,N),Z);let Ee=this.p(oe);if(Z!==void 0){const Be=j.onDidChangeInlineValues(Ve=>this.e.$emitInlineValuesEvent(Z));Ee=o.$XL.from(Ee,Be)}return Ee}$provideInlineValues(N,K,j,H,Z){return this.s(N,M,oe=>oe.provideInlineValues(h.URI.revive(K),j,H,Z),void 0,Z)}registerDocumentHighlightProvider(N,K,j){const H=this.t(new T(this.h,j),N);return this.e.$registerDocumentHighlightProvider(H,this.o(K,N)),this.p(H)}registerMultiDocumentHighlightProvider(N,K,j){const H=this.t(new G(this.h,j),N);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(K,N)),this.p(H)}$provideDocumentHighlights(N,K,j,H){return this.s(N,T,Z=>Z.provideDocumentHighlights(h.URI.revive(K),j,H),void 0,H)}$provideMultiDocumentHighlights(N,K,j,H,Z){return this.s(N,G,oe=>oe.provideMultiDocumentHighlights(h.URI.revive(K),j,H.map(Ee=>h.URI.revive(Ee)),Z),void 0,Z)}registerLinkedEditingRangeProvider(N,K,j){const H=this.t(new W(this.h,j),N);return this.e.$registerLinkedEditingRangeProvider(H,this.o(K,N)),this.p(H)}$provideLinkedEditingRanges(N,K,j,H){return this.s(N,W,async Z=>{const oe=await Z.provideLinkedEditingRanges(h.URI.revive(K),j,H);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?Se.w(oe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(N,K,j){const H=this.t(new U(this.h,j),N);return this.e.$registerReferenceSupport(H,this.o(K,N)),this.p(H)}$provideReferences(N,K,j,H,Z){return this.s(N,U,oe=>oe.provideReferences(h.URI.revive(K),j,H,Z),void 0,Z)}registerCodeActionProvider(N,K,j,H){const Z=new g.$Sc,oe=this.t(new C(this.h,this.j.converter,this.k,j,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(oe,this.o(K,N),{providedKinds:H?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:H?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},Se.u(N),!!j.resolveCodeAction),Z.add(this.p(oe)),Z}$provideCodeActions(N,K,j,H,Z){return this.s(N,C,oe=>oe.provideCodeActions(h.URI.revive(K),j,H,Z),void 0,Z)}$resolveCodeAction(N,K,j){return this.s(N,C,H=>H.resolveCodeAction(K,j),{},void 0)}$releaseCodeActions(N,K){this.s(N,C,j=>Promise.resolve(j.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(N,K,j){const H=this.t(new V(this.h,j),N);return this.e.$registerDocumentFormattingSupport(H,this.o(K,N),N.identifier,N.displayName||N.name),this.p(H)}$provideDocumentFormattingEdits(N,K,j,H){return this.s(N,V,Z=>Z.provideDocumentFormattingEdits(h.URI.revive(K),j,H),void 0,H)}registerDocumentRangeFormattingEditProvider(N,K,j){const H=typeof j.provideDocumentRangesFormattingEdits=="function",Z=this.t(new re(this.h,j),N);return this.e.$registerRangeFormattingSupport(Z,this.o(K,N),N.identifier,N.displayName||N.name,H),this.p(Z)}$provideDocumentRangeFormattingEdits(N,K,j,H,Z){return this.s(N,re,oe=>oe.provideDocumentRangeFormattingEdits(h.URI.revive(K),j,H,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(N,K,j,H,Z){return this.s(N,re,oe=>oe.provideDocumentRangesFormattingEdits(h.URI.revive(K),j,H,Z),void 0,Z)}registerOnTypeFormattingEditProvider(N,K,j,H){const Z=this.t(new ce(this.h,j),N);return this.e.$registerOnTypeFormattingSupport(Z,this.o(K,N),H,N.identifier),this.p(Z)}$provideOnTypeFormattingEdits(N,K,j,H,Z,oe){return this.s(N,ce,Ee=>Ee.provideOnTypeFormattingEdits(h.URI.revive(K),j,H,Z,oe),void 0,oe)}registerWorkspaceSymbolProvider(N,K){const j=this.t(new ye(K,this.l),N);return this.e.$registerNavigateTypeSupport(j,typeof K.resolveWorkspaceSymbol=="function"),this.p(j)}$provideWorkspaceSymbols(N,K,j){return this.s(N,ye,H=>H.provideWorkspaceSymbols(K,j),{symbols:[]},j)}$resolveWorkspaceSymbol(N,K,j){return this.s(N,ye,H=>H.resolveWorkspaceSymbol(K,j),void 0,void 0)}$releaseWorkspaceSymbols(N,K){this.s(N,ye,j=>j.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(N,K,j){const H=this.t(new ke(this.h,j,this.l),N);return this.e.$registerRenameSupport(H,this.o(K,N),ke.supportsResolving(j)),this.p(H)}$provideRenameEdits(N,K,j,H,Z){return this.s(N,ke,oe=>oe.provideRenameEdits(h.URI.revive(K),j,H,Z),void 0,Z)}$resolveRenameLocation(N,K,j,H){return this.s(N,ke,Z=>Z.resolveRenameLocation(h.URI.revive(K),j,H),void 0,H)}registerNewSymbolNamesProvider(N,K,j){const H=this.t(new he(this.h,j,this.l),N);return this.e.$registerNewSymbolNamesProvider(H,this.o(K,N)),this.p(H)}$provideNewSymbolNames(N,K,j,H){return this.s(N,he,Z=>Z.provideNewSymbolNames(h.URI.revive(K),j,H),void 0,H)}registerDocumentSemanticTokensProvider(N,K,j,H){const Z=this.t(new se(this.h,j),N),oe=typeof j.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(K,N),H,oe);let Ee=this.p(Z);if(oe){const Be=j.onDidChangeSemanticTokens(Ve=>this.e.$emitDocumentSemanticTokensEvent(oe));Ee=o.$XL.from(Ee,Be)}return Ee}$provideDocumentSemanticTokens(N,K,j,H){return this.s(N,se,Z=>Z.provideDocumentSemanticTokens(h.URI.revive(K),j,H),null,H)}$releaseDocumentSemanticTokens(N,K){this.s(N,se,j=>j.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,K,j,H){const Z=this.t(new $e(this.h,j),N);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(K,N),H),this.p(Z)}$provideDocumentRangeSemanticTokens(N,K,j,H){return this.s(N,$e,Z=>Z.provideDocumentRangeSemanticTokens(h.URI.revive(K),j,H),null,H)}registerCompletionItemProvider(N,K,j,H){const Z=this.t(new te(this.h,this.j.converter,j,this.m,N),N);return this.e.$registerCompletionsProvider(Z,this.o(K,N),H,te.supportsResolving(j),N.identifier),this.p(Z)}$provideCompletionItems(N,K,j,H,Z){return this.s(N,te,oe=>oe.provideCompletionItems(h.URI.revive(K),j,H,Z),void 0,Z)}$resolveCompletionItem(N,K,j){return this.s(N,te,H=>H.resolveCompletionItem(K,j),void 0,j)}$releaseCompletionItems(N,K){this.s(N,te,j=>j.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(N,K,j,H){const Z=new q(N,this.h,j,this.j.converter),oe=this.t(Z,N);return this.e.$registerInlineCompletionsSupport(oe,this.o(K,N),Z.supportsHandleEvents,i.$um.toKey(N.identifier.value),H?.yieldTo?.map(Ee=>i.$um.toKey(Ee))||[]),this.p(oe)}$provideInlineCompletions(N,K,j,H,Z){return this.s(N,Y,oe=>oe.provideInlineCompletions(h.URI.revive(K),j,H,Z),void 0,Z)}$handleInlineCompletionDidShow(N,K,j,H){this.s(N,Y,async Z=>{Z.handleDidShowCompletionItem(K,j,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,K,j,H){this.s(N,Y,async Z=>{Z.handlePartialAccept(K,j,H)},void 0,void 0)}$freeInlineCompletionsList(N,K){this.s(N,Y,async j=>{j.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(N,K,j,H){const Z=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,oe=this.t(new Pe(this.h,j),N);return this.e.$registerSignatureHelpProvider(oe,this.o(K,N),Z),this.p(oe)}$provideSignatureHelp(N,K,j,H,Z){return this.s(N,Pe,oe=>oe.provideSignatureHelp(h.URI.revive(K),j,H,Z),void 0,Z)}$releaseSignatureHelp(N,K){this.s(N,Pe,j=>j.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(N,K,j){const H=typeof j.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Oe(this.h,this.j.converter,j,this.l,N),N);this.e.$registerInlayHintsProvider(Z,this.o(K,N),typeof j.resolveInlayHint=="function",H,Se.u(N));let oe=this.p(Z);if(H!==void 0){const Ee=j.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));oe=o.$XL.from(oe,Ee)}return oe}$provideInlayHints(N,K,j,H){return this.s(N,Oe,Z=>Z.provideInlayHints(h.URI.revive(K),j,H),void 0,H)}$resolveInlayHint(N,K,j){return this.s(N,Oe,H=>H.resolveInlayHint(K,j),void 0,j)}$releaseInlayHints(N,K){this.s(N,Oe,j=>j.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(N,K,j){const H=this.t(new Re(this.h,j),N);return this.e.$registerDocumentLinkProvider(H,this.o(K,N),typeof j.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(N,K,j){return this.s(N,Re,H=>H.provideLinks(h.URI.revive(K),j),void 0,j,K.scheme==="output")}$resolveDocumentLink(N,K,j){return this.s(N,Re,H=>H.resolveLink(K,j),void 0,void 0,!0)}$releaseDocumentLinks(N,K){this.s(N,Re,j=>j.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(N,K,j){const H=this.t(new be(this.h,j),N);return this.e.$registerDocumentColorProvider(H,this.o(K,N)),this.p(H)}$provideDocumentColors(N,K,j){return this.s(N,be,H=>H.provideColors(h.URI.revive(K),j),[],j)}$provideColorPresentations(N,K,j,H){return this.s(N,be,Z=>Z.provideColorPresentations(h.URI.revive(K),j,H),void 0,H)}registerFoldingRangeProvider(N,K,j){const H=this.q(),Z=typeof j.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ge(new me(this.h,j),N)),this.e.$registerFoldingRangeProvider(H,this.o(K,N),N.identifier,Z);let oe=this.p(H);if(Z!==void 0){const Ee=j.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));oe=o.$XL.from(oe,Ee)}return oe}$provideFoldingRanges(N,K,j,H){return this.s(N,me,Z=>Z.provideFoldingRanges(h.URI.revive(K),j,H),void 0,H)}registerSelectionRangeProvider(N,K,j){const H=this.t(new Q(this.h,j,this.l),N);return this.e.$registerSelectionRangeProvider(H,this.o(K,N)),this.p(H)}$provideSelectionRanges(N,K,j,H){return this.s(N,Q,Z=>Z.provideSelectionRanges(h.URI.revive(K),j,H),[],H)}registerCallHierarchyProvider(N,K,j){const H=this.t(new x(this.h,j),N);return this.e.$registerCallHierarchyProvider(H,this.o(K,N)),this.p(H)}$prepareCallHierarchy(N,K,j,H){return this.s(N,x,Z=>Promise.resolve(Z.prepareSession(h.URI.revive(K),j,H)),void 0,H)}$provideCallHierarchyIncomingCalls(N,K,j,H){return this.s(N,x,Z=>Z.provideCallsTo(K,j,H),void 0,H)}$provideCallHierarchyOutgoingCalls(N,K,j,H){return this.s(N,x,Z=>Z.provideCallsFrom(K,j,H),void 0,H)}$releaseCallHierarchy(N,K){this.s(N,x,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(N,K,j){const H=this.t(new le(this.h,j),N);return this.e.$registerTypeHierarchyProvider(H,this.o(K,N)),this.p(H)}$prepareTypeHierarchy(N,K,j,H){return this.s(N,le,Z=>Promise.resolve(Z.prepareSession(h.URI.revive(K),j,H)),void 0,H)}$provideTypeHierarchySupertypes(N,K,j,H){return this.s(N,le,Z=>Z.provideSupertypes(K,j,H),void 0,H)}$provideTypeHierarchySubtypes(N,K,j,H){return this.s(N,le,Z=>Z.provideSubtypes(K,j,H),void 0,H)}$releaseTypeHierarchy(N,K){this.s(N,le,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(N,K,j,H){const Z=this.q();this.f.set(Z,new ge(new de(this.e,this.h,j,Z,N),N));const oe=(0,l.$RF)(N,"dropMetadata")&&H?de.toInternalProviderId(N.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(K,N),oe,(0,l.$RF)(N,"dropMetadata")?H:void 0),this.p(Z)}$provideDocumentOnDropEdits(N,K,j,H,Z,oe){return this.s(N,de,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(K,h.URI.revive(j),H,Z,oe)),void 0,void 0)}registerMappedEditsProvider(N,K,j){const H=this.t(new Me(this.h,j),N);return this.e.$registerMappedEditsProvider(H,this.o(K,N)),this.p(H)}$provideMappedEdits(N,K,j,H,Z){return this.s(N,Me,oe=>Promise.resolve(oe.provideMappedEdits(K,j,H,Z)),null,Z)}registerDocumentPasteEditProvider(N,K,j,H){const Z=this.q();this.f.set(Z,new ge(new O(this.e,this.h,j,Z,N),N));const oe=O.toInternalProviderId(N.identifier.value,H.id);return this.e.$registerPasteEditProvider(Z,this.o(K,N),oe,{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(N,K,j,H,Z){return this.s(N,O,oe=>oe.prepareDocumentPaste(h.URI.revive(K),j,H,Z),void 0,Z)}$providePasteEdits(N,K,j,H,Z,oe){return this.s(N,O,Ee=>Ee.providePasteEdits(K,h.URI.revive(j),H,Z,oe),void 0,oe)}static w(N){return{pattern:N.source,flags:N.flags}}static y(N){return{decreaseIndentPattern:Se.w(N.decreaseIndentPattern),increaseIndentPattern:Se.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?Se.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?Se.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:Se.w(N.beforeText),afterText:N.afterText?Se.w(N.afterText):void 0,previousLineText:N.previousLineText?Se.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(Se.z)}static C(N){return{open:N.open,close:N.close,notIn:N.notIn?N.notIn.map(K=>o.SyntaxTokenType.toString(K)):void 0}}static D(N){return N.map(Se.C)}setLanguageConfiguration(N,K,j){const{wordPattern:H}=j;if(H&&(0,A.$6e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(K,H):this.h.setWordDefinitionFor(K,void 0),j.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),j.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const Z=this.q(),oe={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?Se.w(j.wordPattern):void 0,indentationRules:j.indentationRules?Se.y(j.indentationRules):void 0,onEnterRules:j.onEnterRules?Se.B(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport,autoClosingPairs:j.autoClosingPairs?Se.D(j.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,K,oe),this.p(Z)}$setWordDefinitions(N){for(const K of N)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$bhc=Se}),define(Fe[260],Le([1,0,3,8,7,32,11,6,23]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aic=void 0;class D{constructor(k,h,v,p){this.c=h,this.d=v,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(S.$VL.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,h){await this.a.$changeLanguage(k,h);const v=this.c.getDocumentData(k);if(!v)throw new Error(`document '${k.toString()}' NOT found`);return v.document}async tokenAtPosition(k,h){const v=k.version,p=F.Position.from(h),s=await this.a.$tokensAtPosition(k.uri,p),u={type:P.StandardTokenType.Other,range:k.getWordRangeAtPosition(h)??new P.$ZL(h.line,h.character,h.line,h.character)};if(!s)return u;const r={range:F.Range.to(s.range),type:F.TokenType.to(s.type)};return!r.range.contains(h)||v!==k.version?u:r}createLanguageStatusItem(k,h,v){const p=this.f++,s=this.a,u=this.g,r=`${k.identifier.value}/${h}`;if(u.has(r))throw new Error(`LanguageStatusItem with id '${h}' ALREADY exists`);u.add(r);const i={selector:v,id:h,name:k.displayName??k.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new g.$Sc,l=()=>{if(n?.dispose(),!u.has(r)){console.warn(`LanguageStatusItem (${h}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$eh)(()=>{o.clear(),this.a.$setLanguageStatus(p,{id:r,name:i.name??k.displayName??k.name,source:k.displayName??k.name,selector:F.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===P.LanguageStatusSeverity.Error?L.default.Error:i.severity===P.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),s.$removeLanguageStatus(p),u.delete(r)},get id(){return i.id},get name(){return i.name},set name(m){i.name=m,l()},get selector(){return i.selector},set selector(m){i.selector=m,l()},get text(){return i.text},set text(m){i.text=m,l()},set text2(m){(0,f.$SF)(k,"languageStatusText"),i.text=m,l()},get text2(){return(0,f.$SF)(k,"languageStatusText"),i.text},get detail(){return i.detail},set detail(m){i.detail=m,l()},get severity(){return i.severity},set severity(m){i.severity=m,l()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(m){i.accessibilityInformation=m,l()},get command(){return i.command},set command(m){i.command=m,l()},get busy(){return i.busy},set busy(m){i.busy=m,l()}};return l(),t}}e.$Aic=D}),define(Fe[261],Le([1,0,12,2,8,7,83]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=void 0;class g{constructor(k,h,v,p){this.start=k,this.deletedCount=h,this.deletedItems=v,this.items=p}asApiEvent(){return{range:new L.$lN(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(k,h){return{EOL:h.eol,lines:h.source,languageId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,h,v){this.notebook=k,this.h=h,this.j=v,this.handle=v.handle,this.uri=F.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(P.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,h=this.h.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:h.document,get mime(){return k.g},set mime(p){k.g=p},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(v)}return this.f}setOutputs(k){this.a=k.map(P.NotebookCellOutput.to)}setOutputItems(k,h,v){const p=v.map(P.NotebookCellOutputItem.to),s=this.a.find(u=>u.id===k);if(s&&(h||(s.items.length=0),s.items.push(...p),s.items.length>1&&s.items.every(u=>R.$XJ(u.mime)))){const u=new Map,r=[];s.items.forEach(i=>{let n;u.has(i.mime)?n=u.get(i.mime):(n=[],u.set(i.mime,n),r.push(i.mime)),n.push(i.data)}),s.items.length=0,r.forEach(i=>{const n=R.$YJ(u.get(i));s.items.push({mime:i,data:n.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$lic=f;class D{static{this.a=0}constructor(k,h,v,p,s){this.k=k,this.l=h,this.m=v,this.uri=p,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,h={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===S.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(v){return v=k.n(v),k.b[v].apiCell},getCells(v){return(v?k.p(v):k.b).map(s=>s.apiCell)},save(){return k.q()}};this.e=Object.freeze(h)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,h,v){this.g=k.versionId,this.h=h,this.acceptDocumentPropertiesChanged({metadata:v});const p={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},s=[];for(const r of k.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,p.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,p.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const u=new Map;for(let r=0;r<s.length;r++){const i=s[r],n=u.get(i.cell);if(n===void 0){const o=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});u.set(i.cell,o-1)}else p.cellChanges[n]={...p.cellChanges[n],...i}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let h=k.start|0,v=k.end|0;return h<0&&(h=0),v>this.b.length&&(v=this.b.length),k.with({start:h,end:v})}p(k){k=this.o(k);const h=[];for(let v=k.start;v<k.end;v++)h.push(this.b[v]);return h}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,h,v){if(this.j)return;const p=[],s=[],u=[];if(k.reverse().forEach(r=>{const n=r[2].map(t=>{const m=new f(this,this.l,t);return h||s.push(f.asModelAddData(this.apiNotebook,t)),m}),o=new g(r[0],r[1],[],n),l=this.b.splice(r[0],r[1],...n);for(const t of l)u.push(t.uri),o.deletedItems.push(t.apiCell);p.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:u}),v)for(const r of p)v.push(r.asApiEvent())}s(k,h,v,p){const s=this.b.splice(k,h);this.b.splice(v,0,...s);const u=[new g(k,h,s.map(r=>r.apiCell),[]),new g(v,0,[],s)];for(const r of u)p.push(r.asApiEvent())}t(k,h){this.b[k].setOutputs(h)}u(k,h,v,p){this.b[k].setOutputItems(h,v,p)}v(k,h){const v=this.b[k];v.apiCell.document.languageId!==h&&this.m.$acceptModelLanguageChanged(v.uri,h)}w(k,h){const v=this.b[k];v.apiCell.mime=h}x(k,h){this.b[k].setMetadata(h)}y(k,h){this.b[k].setInternalMetadata(h)}getCellFromApiCell(k){return this.b.find(h=>h.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(h=>h.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$mic=D}),define(Fe[262],Le([1,0,5,2,8,7]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class R{constructor(f,D,A,k={timeout:1500,errors:3}){this.b=f,this.c=D,this.d=A,this.f=k,this.a=new S.$5d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(D,A,k)=>{const h=function(p){D.call(A,p)};return h.extension=f,this.a.event(h,void 0,k)}}async $participateInSave(f,D,A){const k=F.URI.revive(f),h=this.c.getNotebookDocument(k);if(!h)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:h.apiNotebook,reason:P.TextDocumentSaveReason.to(D)},A,async(s,u)=>{const r=Date.now(),i=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof L.$8L?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",u.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const p={edits:[]};for(const s of v){const{edits:u}=P.WorkspaceEdit.from(s);p.edits=p.edits.concat(u)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Cic=R}),define(Fe[110],Le([1,0,15,8,7]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(g,f,D,A,k,h){this.id=g,this.f=f,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=h}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(f){this.selections=[f]},get selections(){return g.a},set selections(f){if(!Array.isArray(f)||!f.every(P.$lN.isNotebookRange))throw(0,S.$7)("selections");g.a=f,g.g(f)},get visibleRanges(){return g.b},revealRange(f,D){g.f.$tryRevealRange(g.id,F.NotebookRange.from(f),D??P.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(F.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$nic=L}),define(Fe[263],Le([1,0,5,14,8]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;let L=class{constructor(g,f){this.c=g,this.d=f,this.a=new S.$3d,this.b=new S.$3d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,f);const D=this.d.getEditorById(g);f.visibleRanges&&D._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&D._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const f in g)this.d.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(g[f]))}};e.$Eic=L,e.$Eic=L=Je([qe(0,F.$wj)],L)}),define(Fe[264],Le([1,0,5,3,110]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class L{constructor(g,f){this.c=f,this.a=new Map,this.b=g.getProxy(F.$VL.MainThreadNotebookRenderers)}$postRendererMessage(g,f,D){const A=this.c.getEditorById(g);this.a.get(f)?.fire({editor:A.apiEditor,message:D})}createRendererMessaging(g,f){if(!g.contributes?.notebookRenderer?.some(A=>A.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(A,k,h)=>this.d(f).event(A,k,h),postMessage:(A,k)=>{P.$nic.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const h=k&&P.$nic.apiEditorsToExtHost.get(k);return this.b.$postMessage(h?.id,f,A)}}}d(g){let f=this.a.get(g);return f||(f=new S.$3d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(g)}}),this.a.set(g,f),f)}}e.$Hic=L}),define(Fe[265],Le([1,0,8,99,21,67,15]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;class g{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,h,v){const p=this.b++,{title:s,location:u,cancellable:r}=h,i={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(u),title:s,source:i,cancellable:r},k.isUnderDevelopment?void 0:k.identifier.value).catch(R.$2),this.d(p,v,!!r)}d(k,h,v){let p;v&&(p=new P.$ae,this.c.set(k,p));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),p?.dispose()};let u;try{u=h(new D(this.a,k),v&&p?p.token:P.CancellationToken.None)}catch(r){throw s(k),r}return u.then(r=>s(k),r=>s(k)),u}$acceptProgressCanceled(k){const h=this.c.get(k);h&&(h.cancel(),this.c.delete(k))}}e.$Lic=g;function f(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class D extends F.$Ev{constructor(k,h){super(v=>this.throttledReport(v)),this.c=k,this.d=h}throttledReport(k){this.c.$progressReport(this.d,k)}}Je([(0,L.$Ih)(100,(A,k)=>f(A,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Fe[266],Le([1,0,2,3,11,8]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;class R{static{this.a=0}constructor(f,D){this.d=D,this.c=new Map,this.b=f.getProxy(F.$VL.MainThreadQuickDiff)}$provideOriginalResource(f,D,A){const k=S.URI.revive(D),h=this.c.get(f);return h?(0,P.$7g)(()=>h.provideOriginalResource(k,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(f,D,A,k){const h=R.a++;return this.c.set(h,D),this.b.$registerQuickDiffProvider(h,L.DocumentSelector.from(f,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(h),this.c.delete(h)}}}}e.$Mic=R}),define(Fe[267],Le([1,0,21,5,6,3,2,7,15,18,32,40,23,8]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;function p(s,u,r){const i=s.getProxy(L.$VL.MainThreadQuickOpen);class n{constructor($,I){this.e=new Map,this.f=0,this.a=$,this.b=I}showQuickPick($,I,d,w=S.CancellationToken.None){this.c=void 0;const b=Promise.resolve(I),M=++this.f,T=i.$show(M,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},w),G={},W=T.then(()=>G);return Promise.race([W,b]).then(U=>{if(U===G)return;const C=(0,h.$RF)($,"quickPickItemTooltip");return b.then(O=>{const V=[];for(let re=0;re<O.length;re++){const ce=O[re];if(typeof ce=="string")V.push({label:ce,handle:re});else if(ce.kind===g.QuickPickItemKind.Separator)V.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const ye=ce.iconPath?a(ce.iconPath):void 0;V.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:re})}}return d&&typeof d.onDidSelectItem=="function"&&(this.c=re=>{d.onDidSelectItem(O[re])}),i.$setItems(M,V),T.then(re=>{if(typeof re=="number")return O[re];if(Array.isArray(re))return re.map(ce=>O[ce])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return i.$setError(M,U),Promise.reject(U)})}$onItemSelected($){this.c?.($)}showInput($,I=S.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",I).then(void 0,d=>{if(!(0,f.$4)(d))return Promise.reject(d)})}async $validateInput($){if(!this.d)return;const I=await this.d($);if(!I||typeof I=="string")return I;let d;switch(I.severity){case g.InputBoxValidationSeverity.Info:d=A.default.Info;break;case g.InputBoxValidationSeverity.Warning:d=A.default.Warning;break;case g.InputBoxValidationSeverity.Error:d=A.default.Error;break;default:d=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:d}}async showWorkspaceFolderPick($,I=S.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!d)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(b=>b.uri.toString()===d.uri.toString())}createQuickPick($){const I=new c($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox($){const I=new E($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue($,I){this.e.get($)?._fireDidChangeValue(I)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,I){const d=this.e.get($);d instanceof c&&d._fireDidChangeActive(I)}$onDidChangeSelection($,I){const d=this.e.get($);d instanceof c&&d._fireDidChangeSelection(I)}$onDidTriggerButton($,I){this.e.get($)?._fireDidTriggerButton(I)}$onDidTriggerItemButton($,I,d){const w=this.e.get($);w instanceof c&&w._fireDidTriggerItemButton(I,d)}$onDidHide($){this.e.get($)?._fireDidHide()}}class o{static{this.a=1}constructor($,I){this.x=$,this.y=I,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$3d,this.q=new F.$3d,this.r=new F.$3d,this.s=new F.$3d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((I,d)=>{const w=I===g.$iN.Back?-1:d;this.o.set(w,I)}),this.z({buttons:$.map((I,d)=>({...a(I.iconPath),tooltip:I.tooltip,handle:I===g.$iN.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const I=this.o.get($);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const I of Object.keys($)){const d=$[I];this.u[I]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function l(y){if(y instanceof g.$SM)return{id:y.id};const $=m(y),I=t(y);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof I=="string"?R.URI.file(I):I}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function m(y){return typeof y=="object"&&"dark"in y?y.dark:y}function a(y){const $=l(y);let I,d;return"id"in $?d=k.ThemeIcon.asClassName($):I=$,{iconPath:I,iconClass:d}}class c extends o{constructor($,I){super($.identifier,I),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$3d,this.L=[],this.M=new F.$3d,this.N=new F.$3d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((w,b)=>{this.C.set(b,w),this.D.set(w,b)});const I=(0,h.$RF)(this.O,"quickPickItemTooltip"),d=[];for(let w=0;w<$.length;w++){const b=$[w];if(b.kind===g.QuickPickItemKind.Separator)d.push({type:"separator",label:b.label});else{b.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=b.iconPath?a(b.iconPath):void 0;d.push({handle:w,label:b.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:I?v.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((T,G)=>({...a(T.iconPath),tooltip:T.tooltip,handle:G}))})}}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive($){const I=(0,D.$Hb)($.map(d=>this.C.get(d)));this.J=I,this.K.fire(I)}_fireDidChangeSelection($){const I=(0,D.$Hb)($.map(d=>this.C.get(d)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton($,I){const d=this.C.get($);if(!d||!d.buttons||!d.buttons.length)return;const w=d.buttons[I];w&&this.N.fire({button:w,item:d})}}class E extends o{constructor($,I){super($.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:A.default.Error}):this.z({validationMessage:$.message,severity:$.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(u,r)}e.$Nic=p}),define(Fe[268],Le([1,0,2,5,67,6,11,3,18,139,14,22,40,8,23,12,20]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;function i(M){return M instanceof S.URI}function n(M,T){return M.scheme===s.Schemas.file&&T.scheme===s.Schemas.file&&u.$k?M.toString()===T.toString():M.toString().toLowerCase()===T.toString().toLowerCase()}function o(M){if(M)return typeof M.iconPath=="string"?S.URI.file(M.iconPath):S.URI.isUri(M.iconPath)||h.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function l(M){if(M.icon){if(S.URI.isUri(M.icon))return M.icon;if(h.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const T=M.icon;return{light:T.light,dark:T.dark}}}else return}function t(M,T){if(!M.iconPath&&!T.iconPath)return 0;if(M.iconPath){if(!T.iconPath)return 1}else return-1;const G=typeof M.iconPath=="string"?M.iconPath:S.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,W=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,D.$2q)(G,W)}function m(M,T){let G=0;if(M.strikeThrough!==T.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==T.faded)return M.faded?1:-1;if(M.tooltip!==T.tooltip)return(M.tooltip||"").localeCompare(T.tooltip||"");if(G=t(M,T),G!==0)return G;if(M.light&&T.light)G=t(M.light,T.light);else{if(M.light)return 1;if(T.light)return-1}if(G!==0)return G;if(M.dark&&T.dark)G=t(M.dark,T.dark);else{if(M.dark)return 1;if(T.dark)return-1}return G}function a(M,T){if(M.command!==T.command)return M.command<T.command?-1:1;if(M.title!==T.title)return M.title<T.title?-1:1;if(M.tooltip!==T.tooltip){if(M.tooltip!==void 0&&T.tooltip!==void 0)return M.tooltip<T.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(M.arguments===T.arguments)return 0;if(M.arguments)if(T.arguments){if(M.arguments.length!==T.arguments.length)return M.arguments.length-T.arguments.length}else return 1;else return-1;for(let G=0;G<M.arguments.length;G++){const W=M.arguments[G],U=T.arguments[G];if(W!==U&&!(i(W)&&i(U)&&n(W,U)))return W<U?-1:1}return 0}function c(M,T){let G=(0,D.$2q)(M.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(G!==0)return G;if(M.command&&T.command)G=a(M.command,T.command);else{if(M.command)return 1;if(T.command)return-1}if(G!==0)return G;if(M.decorations&&T.decorations)G=m(M.decorations,T.decorations);else{if(M.decorations)return 1;if(T.decorations)return-1}if(M.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)G=(0,D.$2q)(M.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(M.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(M.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)G=(0,D.$2q)(M.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(M.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return G}function E(M,T){for(let G=0;G<M.length;G++)if(M[G]!==T[G])return!1;return!0}function y(M,T){return M.command===T.command&&M.title===T.title&&M.tooltip===T.tooltip&&(M.arguments&&T.arguments?E(M.arguments,T.arguments):M.arguments===T.arguments)}function $(M,T){return(0,f.$ub)(M,T,y)}class I{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,p.$SF)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,p.$SF)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,p.$SF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,G,W,U,C){this.k=T,this.l=U,this.m=C,this.d="",this.e=new F.$3d,this.f="",this.h=!0,this.j=!0,this.#t=G,this.#e=W}showValidationMessage(T,G){(0,p.$SF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,G)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$Oic=I;class d{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,G,W,U,C,O,V){this.q=T,this.s=G,this.t=W,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=O,this.w=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$3d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$3d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=d.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,G){const W=this.h.get(T);return W?(0,R.$7g)(()=>this.s.executeCommand(W.command,...W.arguments||[],G)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(c),W=(0,f.$Db)(this.o,T,c).map(O=>{const V=O.toInsert.map(re=>{const ce=this.e++;this.g.set(ce,re);const ye=re.resourceUri;let ke;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const me=new L.$Sc;ke=this.s.converter.toInternal(re.command,me),this.j.set(ce,me)}else this.h.set(ce,re.command);const he=(0,p.$RF)(this.w,"scmMultiDiffEditor"),ve=he?re.multiDiffEditorOriginalUri:void 0,se=he?re.multiFileDiffEditorModifiedUri:void 0,$e=o(re.decorations),te=re.decorations&&o(re.decorations.light)||$e,Y=re.decorations&&o(re.decorations.dark)||$e,q=[te,Y],ne=re.decorations&&re.decorations.tooltip||"",Pe=re.decorations&&!!re.decorations.strikeThrough,Oe=re.decorations&&!!re.decorations.faded,Re=re.contextValue||"";return{rawResource:[ce,ye,q,ne,Pe,Oe,Re,ke,ve,se],handle:ce}});return{start:O.start,deleteCount:O.deleteCount,toInsert:V}}),U=W.map(({start:O,deleteCount:V,toInsert:re})=>[O,V,re.map(ce=>ce.rawResource)]),C=W.reverse();for(const{start:O,deleteCount:V,toInsert:re}of C){const ce=re.map(ke=>ke.handle),ye=this.n.splice(O,V,...ce);for(const ke of ye)this.g.delete(ke),this.h.delete(ke),this.j.get(ke)?.dispose(),this.j.delete(ke)}return this.o=T,U}dispose(){this.l=!0,this.m.fire()}}class w{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let G;(0,p.$RF)(this.x,"quickDiffProvider")&&(G=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:G})}get historyProvider(){return(0,p.$SF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,p.$SF)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new L.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new L.$Sc,this.o=T;const G=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:G})}get actionButton(){return(0,p.$SF)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,p.$SF)(this.x,"scmActionButton"),this.p.value=new L.$Sc,this.q=T;const G=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:G??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.t&&T&&$(this.t,T))return;this.s.value=new L.$Sc,this.t=T;const G=(T||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:G})}get selected(){return this.u}constructor(T,G,W,U,C,O,V){this.x=T,this.y=U,this.z=C,this.A=O,this.B=V,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Uc,this.m=void 0,this.n=new L.$Uc,this.o=void 0,this.p=new L.$Uc,this.s=new L.$Uc,this.t=void 0,this.u=!1,this.v=new F.$3d,this.onDidChangeSelection=this.v.event,this.w=w.d++,this.C=new Map,this.D=new Set,this.#e=W;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:V?`rootUri=${encodeURIComponent(V.toString())}`:void 0});this.f=new I(T,G,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,O,V,re)}createResourceGroup(T,G,W){const U=(0,p.$RF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,C=new d(this.#e,this.y,this.w,T,G,U,this.x),O=F.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,O),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const T=[],G=[];for(const[W,U]of this.C){U.dispose();const C=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});F.Event.once(W.onDidDispose)(()=>{this.D.delete(W),C.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),T.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const O=W._takeResourceStateSnapshot();O.length>0&&G.push([W.handle,O]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,T,G),this.C.clear()}eventuallyUpdateResourceStates(){const T=[];this.D.forEach(G=>{const W=G._takeResourceStateSnapshot();W.length!==0&&T.push([G.handle,W])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.D.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,P.$Hh)(100)],w.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$Hh)(100)],w.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,G,W,U){this.l=G,this.m=W,this.n=U,this.g=new Map,this.h=new k.$wm,this.j=new F.$3d,this.e=T.getProxy(g.$VL.MainThreadSCM),this.f=T.getProxy(g.$VL.MainThreadTelemetry),G.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const O=this.g.get(C.sourceControlHandle);if(!O)return C;const V=O.getResourceGroup(C.groupHandle);return V?V.getResourceState(C.handle):C}else if(C&&C.$mid===4){const O=this.g.get(C.sourceControlHandle);return O?O.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const O=this.g.get(C.handle);return O||C}return C}})}createSourceControl(T,G,W,U){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,G,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const C=r.d++,O=new w(T,this.m,this.e,this.l,G,W,U);this.g.set(C,O);const V=this.h.get(T.identifier)||[];return V.push(O),this.h.set(T.identifier,V),O}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const G=this.h.get(T.identifier),W=G&&G[G.length-1];return W&&W.inputBox}$provideOriginalResource(T,G,W){const U=S.URI.revive(G);this.n.trace("ExtHostSCM#$provideOriginalResource",T,U.toString());const C=this.g.get(T);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$7g)(()=>C.quickDiffProvider.provideOriginalResource(U,W)).then(O=>O||null)}$onInputBoxValueChange(T,G){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const W=this.g.get(T);return W&&W.inputBox.$onInputBoxValueChange(G),Promise.resolve(void 0)}$executeResourceCommand(T,G,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",T,G,W);const C=this.g.get(T);if(!C)return Promise.resolve(void 0);const O=C.getResourceGroup(G);return O?O.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(T,G,W){this.n.trace("ExtHostSCM#$validateInput",T);const U=this.g.get(T);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$7g)(()=>U.inputBox.validateInput(G,W)).then(C=>{if(!C)return Promise.resolve(void 0);const O=v.MarkdownString.fromStrict(C.message);return O?Promise.resolve([O,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,G,W,U){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(G,W,U)??void 0}async $provideHistoryItems(T,G,W,U){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(G,W,U))?.map(V=>({...V,icon:l(V)}))??void 0}async $provideHistoryItemSummary(T,G,W,U){const C=this.g.get(T)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const O=await C.provideHistoryItemSummary(G,W,U);return O?{...O,icon:l(O)}:void 0}async $provideHistoryItemChanges(T,G,W,U){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(G,W,U)??void 0}};e.$Pic=b,e.$Pic=b=r=Je([qe(3,A.$wj)],b)}),define(Fe[269],Le([1,0,3,8,2]),function(fe,e,S,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qic=void 0;class L{static{this.a=0}constructor(g,f){this.d=f,this.c=new Map,this.b=g.getProxy(S.$VL.MainThreadShare)}async $provideShare(g,f,D){return await this.c.get(g)?.provideShare({selection:F.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},D)??void 0}registerShareProvider(g,f){const D=L.a++;return this.c.set(D,f),this.b.$registerShareProvider(D,F.DocumentSelector.from(g,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$Qic=L}),define(Fe[270],Le([1,0,7,3,165,6,8,16]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$TM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$TM("statusBarItem.warningForeground")]])}#e;#t;constructor(h,v,p,s,u,r=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new L.$Sc,this.#e=h,this.#t=v,u&&s){this.c=(0,S.$wM)(s.identifier,u);const n=p.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=u,this.g=r,this.h=this.u(i)}u(h){if((0,g.$Uf)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!f.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new L.$Sc,typeof h=="string"?this.r={fromApi:h,internal:this.#t.toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:this.#t.toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let v;this.m?v=this.m:v=(0,P.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,h,this.e?.identifier.value,v,this.k,s,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Sic=f;class D{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const v={message:h};return this.b.unshift(v),this.c(),new S.$XL(()=>{const p=this.b.indexOf(v);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(h,v){this.e=new Map,this.a=h.getProxy(F.$VL.MainThreadStatusBar),this.b=v,this.c=new D(this)}$acceptStaticEntries(h){for(const v of h)this.e.set(v.entryId,v)}createStatusBarEntry(h,v,p,s){return new f(this.a,this.b,this.e,h,v,p,s)}setStatusBarMessage(h,v){const p=this.c.setMessage(h);let s;return typeof v=="number"?s=setTimeout(()=>p.dispose(),v):typeof v<"u"&&v.then(()=>p.dispose(),()=>p.dispose()),new S.$XL(()=>{p.dispose(),clearTimeout(s)})}}e.$Tic=A}),define(Fe[111],Le([1,0,29,103,49,75,59,8,2]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=e.$oO=e.$nO=e.$mO=void 0;const D=(n,o,l,t)=>{let m=o;return{enumerable:!0,configurable:!1,get(){return m},set(a){if(!l(m,a)){const c=m;m=a,n.listener?.(t(a,c))}}}},A=(n,o)=>n===o,k={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(l=>!o.find(t=>l.id===t.id)))},h=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let l;const t=h(m=>({range:S.$4s.lift(g.Range.from(m))}));return{enumerable:!0,configurable:!1,get(){return l},set(m){n.listener?.({op:6}),k.range(l,m)||(l=m,n.listener?.(t(m)))}}})(),label:D(n,o,k.label,h(l=>({label:l}))),description:D(n,void 0,k.description,h(l=>({description:l}))),sortText:D(n,void 0,k.sortText,h(l=>({sortText:l}))),canResolveChildren:D(n,!1,k.canResolveChildren,l=>({op:2,state:l})),busy:D(n,!1,k.busy,h(l=>({busy:l}))),error:D(n,void 0,k.error,h(l=>({error:g.MarkdownString.fromStrict(l)||null}))),tags:D(n,[],k.tags,(l,t)=>({op:1,new:l.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),p=n=>{const o=P.$MK.fromString(n.extId),l=new u(o.controllerId,o.localId,n.label,f.URI.revive(n.uri)||void 0);return l.range=g.Range.to(n.range||void 0),l.description=n.description||void 0,l.sortText=n.sortText||void 0,l.tags=n.tags.map(t=>g.TestTag.to({id:(0,R.$RK)(t).tagId})),l},s=n=>{let o;for(const l of n.tests){const t=p(l.item);(0,F.$9N)(t).parent=o,o=t}return o};e.$mO=s;class u{constructor(o,l,t,m){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,F.$8N)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:m,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,L.$7N)(a,F.$9N,u),enumerable:!0,writable:!1},...v(a,t)})}}e.$nO=u;class r extends u{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$oO=r;class i extends L.$3N{constructor(o,l,t){super({controllerId:o,getDocumentVersion:m=>m&&t.getDocument(m)?.version,getApiFor:F.$9N,getChildren:m=>m.children,root:new r(o,l),toITestItem:g.TestItem.from})}}e.$pO=i}),define(Fe[31],Le([1,0,16,7,8,26,3,18,14,52,29,91,2,6,4,17,111,24,50,41,63,57,60,33]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=void 0;let a=class{#e;#t;#i;constructor(d,w,b){this.b=new Map,this.c=new Map,this.#e=d.getProxy(R.$VL.MainThreadCommands),this.d=w,this.#i=b,this.#t=d.getProxy(R.$VL.MainThreadTelemetry),this.converter=new c(this,M=>{const T=this.c.get(M);return T?.result===y.Void?T:void 0},w),this.f=[{processArgument(M){return(0,D.$Lh)(M)}},{processArgument(M){return(0,L.$Hn)(M,function(T){if(A.$4s.isIRange(T))return P.Range.to(T);if(k.$3s.isIPosition(T))return P.Position.to(T);if(A.$4s.isIRange(T.range)&&h.URI.isUri(T.uri))return P.location.to(T);if(T instanceof r.$qe)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const w=this.registerCommand(!1,d.id,async(...b)=>{const M=d.args.map((G,W)=>{if(!G.validate(b[W]))throw new Error(`Invalid argument '${G.name}' when running '${d.id}', received: ${typeof b[W]=="object"?JSON.stringify(b[W],null,"	"):b[W]} `);return G.convert(b[W])}),T=await this.executeCommand(d.internalId,...M);return d.result.convert(T,b,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new F.$XL(()=>{w.dispose(),this.c.delete(d.id)})}registerCommand(d,w,b,M,T,G){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:b,thisArg:M,metadata:T,extension:G}),d&&this.#e.$registerCommand(w),new F.$XL(()=>{this.b.delete(w)&&d&&this.#e.$unregisterCommand(w)})}executeCommand(d,...w){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,w,!0)}async g(d,w,b){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,w,!1);{let M=!1;const T=(0,L.$Hn)(w,function(G){if(G instanceof F.$YL)return P.Position.from(G);if(G instanceof F.$ZL)return P.Range.from(G);if(G instanceof F.$0L)return P.location.from(G);if(F.$lN.isNotebookRange(G))return P.NotebookRange.from(G);if(G instanceof ArrayBuffer)return M=!0,r.$qe.wrap(new Uint8Array(G));if(G instanceof Uint8Array)return M=!0,r.$qe.wrap(G);if(G instanceof r.$qe)return M=!0,G;if(!Array.isArray(G))return G});try{const G=await this.#e.$executeCommand(d,M?new i.$3v(T):T,b);return(0,D.$Lh)(G)}catch(G){if(G instanceof Error&&G.message==="$executeCommand:retry")return this.g(d,w,!1);throw G}}}async h(d,w,b){const M=this.b.get(d);if(!M)throw new Error("Unknown command");const{callback:T,thisArg:G,metadata:W}=M;if(W?.args)for(let C=0;C<W.args.length;C++)try{(0,S.$8f)(w[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const U=o.$Yd.create();try{return await T.apply(G,w)}catch(C){if(d===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(d=O.command)}if(this.d.error(C,d,M.extension?.identifier),!b)throw C;if(M.extension?.identifier){const O=this.#i.onExtensionError(M.extension.identifier,C);this.d.trace("forwarded error to extension?",O,M.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Zi)(C)),this.id=d,this.source=M.extension?.displayName??M.extension?.name}}}finally{this.j(M,d,U.elapsed())}}j(d,w,b){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new l.$Uo(w),duration:b})}$executeContributedCommand(d,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const b=this.b.get(d);return b?(w=w.map(M=>this.f.reduce((T,G)=>G.processArgument(T,b.extension?.identifier),M)),this.h(d,w,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(w=>(d&&(w=w.filter(b=>b[0]!=="_")),w))}$getContributedCommandMetadata(){const d=Object.create(null);for(const[w,b]of this.b){const{metadata:M}=b;M&&(d[w]=M)}return Promise.resolve(d)}};e.$vO=a,e.$vO=a=Je([qe(0,s.$aO),qe(1,f.$wj),qe(2,t.$uO)],a),e.$wO=(0,p.$ci)("IExtHostCommands");class c{constructor(d,w,b){this.d=d,this.f=w,this.g=b,this.delegatingCommandId=`__vsc${(0,m.$yg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,w){if(!d)return;const b={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return b;const M=this.f(d.command);if(M)b.id=M.internalId,b.arguments=M.args.map((T,G)=>T.convert(d.arguments&&d.arguments[G]));else if((0,g.$Lb)(d.arguments)){const T=`${d.command} /${++this.c}`;this.b.set(T,d),w.add((0,v.$Rc)(()=>{this.b.delete(T),this.g.trace("CommandsConverter#DISPOSE",T)})),b.$ident=T,b.id=this.delegatingCommandId,b.arguments=[T],this.g.trace("CommandsConverter#CREATE",d.command,T)}return b}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const w=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$xO=c;class E{static{this.Uri=new E("uri","Uri of a text document",d=>h.URI.isUri(d),d=>d)}static{this.Position=new E("position","A position in a text document",d=>F.$YL.isPosition(d),P.Position.from)}static{this.Range=new E("range","A range in a text document",d=>F.$ZL.isRange(d),P.Range.from)}static{this.Selection=new E("selection","A selection in a text document",d=>F.$1L.isSelection(d),P.Selection.from)}static{this.Number=new E("number","",d=>typeof d=="number",d=>d)}static{this.String=new E("string","",d=>typeof d=="string",d=>d)}static{this.StringArray=E.Arr(E.String)}static Arr(d){return new E(`${d.name}_array`,`Array of ${d.name}, ${d.description}`,w=>Array.isArray(w)&&w.every(b=>d.validate(b)),w=>w.map(b=>d.convert(b)))}static{this.CallHierarchyItem=new E("item","A call hierarchy item",d=>d instanceof F.$iM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new E("item","A type hierarchy item",d=>d instanceof F.$EN,P.TypeHierarchyItem.from)}static{this.TestItem=new E("testItem","A VS Code TestItem",d=>d instanceof u.$nO,P.TestItem.from)}constructor(d,w,b,M){this.name=d,this.description=w,this.validate=b,this.convert=M}optional(){return new E(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,w){return new E(d??this.name,w??this.description,this.validate,this.convert)}}e.$yO=E;class y{static{this.Void=new y("no result",d=>d)}constructor(d,w){this.description=d,this.convert=w}}e.$zO=y;class ${constructor(d,w,b,M,T){this.id=d,this.internalId=w,this.description=b,this.args=M,this.result=T}}e.$AO=$}),define(Fe[271],Le([1,0,18,12,2,86,95,35,31,8,7]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;const k=[new f.$AO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of DocumentHighlight-instances.",v(D.DocumentHighlight.to))),new f.$AO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$yO.Uri],new f.$zO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,u)=>{if((0,S.$Kb)(s))return;class r extends A.$dM{static to(n){const o=new r(n.name,D.SymbolKind.to(n.kind),n.containerName||"",new A.$0L(u[0],D.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=D.Range.to(n.selectionRange),o.children=n.children?n.children.map(r.to):[],o}}return s.map(r.to)})),new f.$AO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$yO.Uri,new f.$yO("options","Formatting options",s=>!0,s=>s)],new f.$zO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$AO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$yO.Uri,f.$yO.Range,new f.$yO("options","Formatting options",s=>!0,s=>s)],new f.$zO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$AO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$yO.Uri,f.$yO.Position,new f.$yO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$yO("options","Formatting options",s=>!0,s=>s)],new f.$zO("A promise that resolves to an array of TextEdits.",v(D.TextEdit.to))),new f.$AO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$AO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$AO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$AO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Location or LocationLink instances.",p)),new f.$AO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Location-instances.",v(D.location.to))),new f.$AO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of Hover-instances.",v(D.Hover.to))),new f.$AO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$yO.Uri,new f.$yO("position","A position in a text document",s=>Array.isArray(s)&&s.every(u=>A.$YL.isPosition(u)),s=>s.map(D.Position.from))],new f.$zO("A promise that resolves to an array of ranges.",s=>s.map(u=>{let r;for(const i of u.reverse())r=new A.$hM(D.Range.to(i),r);return r}))),new f.$AO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$yO.String.with("query","Search string")],new f.$zO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(D.WorkspaceSymbol.to))),new f.$AO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(D.CallHierarchyItem.to))),new f.$AO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$yO.CallHierarchyItem],new f.$zO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(D.CallHierarchyIncomingCall.to))),new f.$AO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$yO.CallHierarchyItem],new f.$zO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(D.CallHierarchyOutgoingCall.to))),new f.$AO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:D.Range.to(s.range),placeholder:s.text}})),new f.$AO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$yO.Uri,f.$yO.Position,f.$yO.String.with("newName","The new symbol name")],new f.$zO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return D.WorkspaceEdit.to(s)}})),new f.$AO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$yO.Uri,f.$yO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$zO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(D.DocumentLink.to))),new f.$AO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$yO.Uri],new f.$zO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$cN(s.tokenTypes,s.tokenModifiers)})),new f.$AO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$yO.Uri],new f.$zO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const u=(0,R.$J_)(s);if(u.type==="full")return new A.$eN(u.data,void 0)})),new f.$AO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$yO.Uri,f.$yO.Range.optional()],new f.$zO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new A.$cN(s.tokenTypes,s.tokenModifiers)})),new f.$AO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$yO.Uri,f.$yO.Range],new f.$zO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const u=(0,R.$J_)(s);if(u.type==="full")return new A.$eN(u.data,void 0)})),new f.$AO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$yO.Uri,f.$yO.Position,f.$yO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$yO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$zO("A promise that resolves to a CompletionList-instance.",(s,u,r)=>{if(!s)return new A.$tM([]);const i=s.suggestions.map(n=>D.CompletionItem.to(n,r));return new A.$tM(i,s.incomplete)})),new f.$AO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$yO.Uri,f.$yO.Position,f.$yO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$zO("A promise that resolves to SignatureHelp.",s=>{if(s)return D.SignatureHelp.to(s)})),new f.$AO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$yO.Uri,f.$yO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$zO("A promise that resolves to an array of CodeLens-instances.",(s,u,r)=>v(i=>new A.$lM(D.Range.to(i.range),i.command&&r.fromInternal(i.command)))(s))),new f.$AO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$yO.Uri,new f.$yO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>A.$ZL.isRange(s),s=>A.$1L.isSelection(s)?D.Selection.from(s):D.Range.from(s)),f.$yO.String.with("kind","Code action kind to return code actions for").optional(),f.$yO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$zO("A promise that resolves to an array of Command-instances.",(s,u,r)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(i.command)}else{const n=new A.$fM(i.title,i.kind?new A.$gM(i.kind):void 0);return i.edit&&(n.edit=D.WorkspaceEdit.to(i.edit)),i.command&&(n.command=r.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(s))),new f.$AO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$yO.Uri],new f.$zO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(u=>new A.$zM(D.Range.to(u.range),D.Color.to(u.color))):[])),new f.$AO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$yO("color","The color to show and insert",s=>s instanceof A.$yM,D.Color.from),new f.$yO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:D.Range.from(s.range)}))],new f.$zO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(D.ColorPresentation.to):[])),new f.$AO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$yO.Uri,f.$yO.Range],new f.$zO("A promise that resolves to an array of Inlay objects",(s,u,r)=>s.map(D.InlayHint.to.bind(void 0,r)))),new f.$AO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$yO.Uri],new f.$zO("A promise that resolves to an array of FoldingRange objects",(s,u)=>{if(s)return s.map(D.FoldingRange.to)})),new f.$AO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$zO("A promise that resolves to an array of NotebookContentProvider static info objects.",v(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(u=>D.NotebookExclusiveDocumentPattern.to(u))})))),new f.$AO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$yO.Uri,f.$yO.Range,new f.$yO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof A.$ZL,s=>D.InlineValueContext.from(s))],new f.$zO("A promise that resolves to an array of InlineValue objects",s=>s.map(D.InlineValue.to))),new f.$AO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$yO("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,F.$ng)(s,F.Schemas.http,F.Schemas.https),s=>s),new f.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional(),f.$yO.String.with("label","").optional()],f.$zO.Void),new f.$AO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$yO.Uri.with("resource","Resource to open"),f.$yO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[D.ViewColumn.from(s),void 0]:[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)])).optional()],f.$zO.Void),new f.$AO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$yO.Uri.with("left","Left-hand side resource of the diff editor"),f.$yO.Uri.with("right","Right-hand side resource of the diff editor"),f.$yO.String.with("title","Human readable title for the diff editor").optional(),new f.$yO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[D.ViewColumn.from(s.viewColumn),D.TextEditorOpenOptions.from(s)]).optional()],f.$zO.Void),new f.$AO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$yO.String.with("title","Human readable title for the changes editor"),new f.$yO("resourceList","List of resources to compare",s=>{for(const u of s){if(u.length!==3)return!1;const[r,i,n]=u;if(!P.URI.isUri(r)||!P.URI.isUri(i)&&i!==void 0&&i!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],f.$zO.Void),new f.$AO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$yO.Uri,f.$yO.Position],new f.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$AO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$yO.TypeHierarchyItem],new f.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$AO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$yO.TypeHierarchyItem],new f.$zO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(D.TypeHierarchyItem.to))),new f.$AO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$yO.TestItem],f.$zO.Void),new f.$AO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$yO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$zO.Void),new f.$AO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$yO.String.with("name","The context key name"),new f.$yO("value","The context key value",()=>!0,s=>s)],f.$zO.Void),new f.$AO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$yO.Uri,f.$yO.StringArray,new f.$yO("MappedEditsContext","Mapped Edits Context",s=>D.MappedEditsContext.is(s),s=>D.MappedEditsContext.from(s))],new f.$zO("A promise that resolves to a workspace edit or null",s=>s?D.WorkspaceEdit.to(s):null))];class h{static register(u){k.forEach(u.registerApiCommand,u),this.a(u)}static a(u){u.registerCommand(!1,"_validateWhenClauses",g.$bj)}}e.$chc=h;function v(s){return u=>{if(Array.isArray(u))return u.map(s)}}function p(s){if(!Array.isArray(s))return;const u=[];for(const r of s)L.$Pt(r)?u.push(D.DefinitionLink.to(r)):u.push(D.location.to(r));return u}}),define(Fe[272],Le([1,0,11,6,2,3,31,8,7]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class D{static{this.a=0}constructor(v,p){this.extension=v,this.provider=p,this.handle=D.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class k{static{this.a=0}constructor(v,p,s,u){this.f=s,this.g=u,this.b=new Map,this.d=new Map,this.e=v.getProxy(L.$VL.MainThreadInlineChat),p.registerApiCommand(new R.$AO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$yO("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?g.Range.from(r.initialRange):void 0,initialSelection:f.$1L.isSelection(r.initialSelection)?g.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?g.Position.from(r.position):void 0}})],R.$zO.Void))}registerProvider(v,p,s){const u=new D(v,p);return this.b.set(u.handle,u),this.e.$registerInteractiveEditorProvider(u.handle,s?.label??v.displayName??v.name,v.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",s?.supportReportIssue??!1),(0,F.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(u.handle),this.b.delete(u.handle)})}async $prepareSession(v,p,s,u){const r=this.b.get(v);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(P.URI.revive(p)),n=g.Selection.to(s),o=await r.provider.prepareInteractiveEditorSession({document:i,selection:n},u);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=k.a++;return this.d.set(l,new A(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:g.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,p,s,u){const r=this.b.get(v);if(!r)return;const i=this.d.get(p.id);if(!i)return;const n={prompt:s.prompt,selection:g.Selection.to(s.selection),wholeRange:g.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let o=!1;const l={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||u.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(g.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$mM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(i.session,n,l,u));let m;try{m=await(0,S.$3g)(t,u)}finally{o=!0}if(!m)return;const a=i.responses.push(m)-1,c={wholeRange:g.Range.from(m.wholeRange),placeholder:m.placeholder};if(!k.h(m))return{...c,id:a,type:"editorEdit",message:g.MarkdownString.from(m.contents),edits:[]};const{edits:E,contents:y}=m,$=y!==void 0?g.MarkdownString.from(y):void 0;return E instanceof f.$8L?{...c,id:a,type:"bulkEdit",edits:g.WorkspaceEdit.from(E),message:$}:{...c,id:a,type:"editorEdit",edits:E.map(g.TextEdit.from),message:$}}async $provideFollowups(v,p,s,u){const r=this.b.get(v),i=this.d.get(p),n=i?.responses[s];if(r&&n&&r.provider.provideFollowups){const o=Promise.resolve(r.provider.provideFollowups(i.session,n,u));return(await(0,S.$3g)(o,u))?.map(g.ChatInlineFollowup.from)}}$handleFeedback(v,p,s,u){const r=this.b.get(v),i=this.d.get(p),n=i?.responses[s];if(r&&n){const o=g.InteractiveEditorResponseFeedbackKind.to(u);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,p){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$kic=k}),define(Fe[273],Le([1,0,2,31]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;class P{constructor(R,g,f,D,A){this.a=g,this.b=f,this.c=D;const k=new F.$AO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$yO("showOptions","Show Options",h=>!0,h=>h),new F.$yO("resource","Interactive resource Uri",h=>!0,h=>h),new F.$yO("controllerId","Notebook controller Id",h=>!0,h=>h),new F.$yO("title","Interactive editor title",h=>!0,h=>h)],new F.$zO("Notebook and input URI",h=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",h.notebookEditorId),h.notebookEditorId!==void 0){const v=this.a.getEditorById(h.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:S.URI.revive(h.notebookUri),inputUri:S.URI.revive(h.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",h.notebookUri,h.inputUri),{notebookUri:S.URI.revive(h.notebookUri),inputUri:S.URI.revive(h.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,g,f,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(D))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$xic=P}),define(Fe[274],Le([1,0,18,11,21,5,6,28,2,22,14,3,31,8,7,76,211,23,50,212]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;let o=class{constructor($,I,d,w,b){this.m=I,this.n=d,this.o=w,this.q=b,this.b=new g.$Ac,this.c=new g.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$3d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(k.$VL.MainThreadNotebookKernels);const M=new h.$AO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new h.$yO("options","Select kernel options",G=>!0,G=>{if(G&&"notebookEditor"in G&&"id"in G){const W=this.n.getIdByEditor(G.notebookEditor);return{id:G.id,extension:G.extension,notebookEditorId:W}}else if(G&&"notebookEditor"in G){const W=this.n.getIdByEditor(G.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${G.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return G})],h.$zO.Void),T=new h.$AO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[h.$yO.Uri],new h.$zO("A promise that resolves to an array of variables",(G,W)=>G.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(M),this.o.registerApiCommand(T)}createNotebookController($,I,d,w,b,M){for(const $e of this.j.values())if($e.controller.id===I&&D.$um.equals($.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const T=this.k++,G=this;this.q.trace(`NotebookController[${T}], CREATED by ${$.identifier.value}, ${I}`);const W=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${$.identifier}'`);let U=!1;const C=new L.$3d,O=new L.$3d,V={id:E($.identifier,I),notebookType:d,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:w||$.identifier.value,preloads:M?M.map(v.NotebookRendererScript.from):[]};let re=b??W,ce,ye;this.a.$addKernel(T,V).catch($e=>{console.log($e),U=!0});let ke=0;const he=()=>{if(U)return;const $e=++ke;Promise.resolve().then(()=>{$e===ke&&this.a.$updateKernel(T,V)})},ve=new g.$Ac,se={get id(){return I},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return V.label},set label($e){V.label=$e??$.displayName??$.name,he()},get detail(){return V.detail??""},set detail($e){V.detail=$e,he()},get description(){return V.description??""},set description($e){V.description=$e,he()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages($e){V.supportedLanguages=$e,he()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder($e){V.supportsExecutionOrder=$e,he()},get rendererScripts(){return V.preloads?V.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??W},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,V.supportsInterrupt=!!$e,he()},set variableProvider($e){(0,r.$SF)($,"notebookVariableProvider"),ye=$e,V.hasVariableProvider=!!$e,$e?.onDidChangeVariables(te=>G.a.$variablesUpdated(te.uri)),he()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return G._createNotebookCellExecution($e,E($.identifier,this.id))},createNotebookExecution($e){if((0,r.$SF)($,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw G.q.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return G._createNotebookExecution($e,E($.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${T}], DISPOSED`),U=!0,this.j.delete(T),C.dispose(),O.dispose(),this.a.$removeKernel(T))},updateNotebookAffinity($e,te){te===p.NotebookControllerAffinity2.Hidden&&(0,r.$SF)($,"notebookControllerAffinityHidden"),G.a.$updateNotebookPriority(T,$e.uri,te)},onDidReceiveMessage:O.event,postMessage($e,te){return(0,r.$SF)($,"notebookMessaging"),G.a.$postMessage(T,te&&G.n.getIdByEditor(te),$e)},asWebviewUri($e){return(0,r.$SF)($,"notebookMessaging"),(0,s.$8wb)($e,G.m.remote)}};return this.j.set(T,{extensionId:$.identifier,controller:se,onDidReceiveMessage:O,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController($){for(const[I,d]of this.j)if(d.controller===$)return E(d.extensionId,$.id);return null}createNotebookControllerDetectionTask($,I){const d=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${d}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(d,I);const b={dispose:()=>{this.f.delete(d),w.a.$removeKernelDetectionTask(d)}};return this.f.set(d,b),b}registerKernelSourceActionProvider($,I,d){const w=this.i++,b=typeof d.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,M=this;this.h.set(w,d),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,I);let T;return b!==void 0&&(T=d.onDidChangeNotebookKernelSourceActions(G=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(w),M.a.$removeKernelSourceActionProvider(w,w),T?.dispose()}}}async $provideKernelSourceActions($,I){const d=this.h.get($);if(d){const w=new R.$Sc;return(await d.provideNotebookKernelSourceActions(I)??[]).map(M=>v.NotebookKernelSourceAction.from(M,this.o.converter,w))}return[]}$acceptNotebookAssociation($,I,d){const w=this.j.get($);if(w){const b=this.n.getNotebookDocument(f.URI.revive(I));d?w.associatedNotebooks.set(b.uri,!0):w.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,b.uri.toString(),d),w.onDidChangeSelection.fire({selected:d,notebook:b.apiNotebook})}}async $executeCells($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getNotebookDocument(f.URI.revive(I)),M=[];for(const T of d){const G=b.getCell(T);G&&M.push(G.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,b.uri.toString(),M.length),await w.controller.executeHandler.call(w.controller,M,b.apiNotebook,w.controller)}catch(T){this.q.error(`NotebookController[${$}] execute cells FAILED`,T),console.error(T)}}async $cancelCells($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getNotebookDocument(f.URI.revive(I));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,b.apiNotebook);else for(const M of d){const T=b.getCell(M);T&&this.b.get(T.uri)?.cancel()}if(w.controller.interruptHandler){const M=this.c.get(b.uri);d.length&&Array.isArray(M)&&M.length&&M.forEach(T=>T.dispose())}}async $provideVariables($,I,d,w,b,M,T){const G=this.j.get($);if(!G)return;const W=this.n.getNotebookDocument(f.URI.revive(d)),U=G.controller.variableProvider;if(!U)return;let C;if(w!==void 0){if(C=this.s[w],!C)return}else this.s={};const O=b==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,V=U.provideVariables(W.apiNotebook,C,O,M,T);let re=0;for await(const ce of V){if(T.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:G.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(I,ye),re++>=n.$ygb)return}}$acceptKernelMessageFromRenderer($,I,d){const w=this.j.get($);if(!w)return;const b=this.n.getEditorById(I);w.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:d}))}$cellExecutionChanged($,I,d){const b=this.n.getNotebookDocument(f.URI.revive($)).getCell(I);if(b){const M=d?v.NotebookCellExecutionState.to(d):p.NotebookCellExecutionState.Idle;M!==void 0&&this.l.fire({cell:b.apiCell,state:M})}}_createNotebookCellExecution($,I){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const b=new t(I,w,this.a);this.b.set(w.uri,b);const M=b.onDidChangeState(()=>{b.state===l.Resolved&&(b.dispose(),M.dispose(),this.b.delete(w.uri))});return b.asApiObject()}_createNotebookExecution($,I){const d=this.n.getNotebookDocument($.uri),w=$.getCells().find(T=>{const G=d.getCellFromApiCell(T);return G&&this.b.has(G.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(d.uri))throw new Error(`duplicate notebook execution for ${d.uri}`);const b=new a(I,d,this.a),M=b.onDidChangeState(()=>{b.state===m.Resolved&&(b.dispose(),M.dispose(),this.c.delete(d.uri))});return this.c.set(d.uri,[b,M]),b.asApiObject()}};e.$Fic=o,e.$Fic=o=Je([qe(4,A.$wj)],o);var l;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(l||(l={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,d){super(),this.m=I,this.n=d,this.b=t.a++,this.c=new L.$3d,this.onDidChangeState=this.c.event,this.f=l.Init,this.g=this.B(new P.$ae),this.h=new c(10,w=>this.s(w)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const I=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$3v(I))}t(){if(this.f===l.Init)throw new Error("Must call start before modifying cell output");if(this.f===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let I=this.m;if($&&(I=this.m.notebook.getCellFromApiCell($)),!I)throw new Error("INVALID cell");return I.handle}y($){return $.map(I=>{const d=p.$pN.ensureUniqueMimeTypes(I.items,!0);return d===I.items?v.NotebookCellOutput.from(I):v.NotebookCellOutput.from({items:d,id:I.id,metadata:I.metadata})})}async z($,I,d){const w=this.w(I),b=this.y((0,S.$3b)($));return this.r({editType:u.CellExecutionUpdateType.Output,cellHandle:w,append:d,outputs:b})}async C($,I,d){return $=p.$pN.ensureUniqueMimeTypes((0,S.$3b)($),!0),this.r({editType:u.CellExecutionUpdateType.OutputItems,items:$.map(v.NotebookCellOutputItem.from),outputId:I.id,append:d})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(d){$.j=d,$.s([{editType:u.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(d){if($.f===l.Resolved||$.f===l.Started)throw new Error("Cannot call start again");$.f=l.Started,$.c.fire(),$.s({editType:u.CellExecutionUpdateType.ExecutionState,runStartTime:d})},end(d,w){if($.f===l.Resolved)throw new Error("Cannot call resolve twice");$.f=l.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$3v({runEndTime:w,lastRunSuccess:d}))},clearOutput(d){return $.t(),$.z([],d,!1)},appendOutput(d,w){return $.t(),$.z(d,w,!0)},replaceOutput(d,w){return $.t(),$.z(d,w,!1)},appendOutputItems(d,w){return $.t(),$.C(d,w,!0)},replaceOutputItems(d,w){return $.t(),$.C(d,w,!1)}})}}var m;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(m||(m={}));class a extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,d){super(),this.h=I,this.j=d,this.b=a.a++,this.c=new L.$3d,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new P.$ae),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===m.Resolved||this.f===m.Started)throw new Error("Cannot call start again");this.f=m.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===m.Resolved)throw new Error("Cannot call resolve twice");this.f=m.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class c{constructor($,I){this.f=$,this.g=I,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new F.$zh,this.b=Date.now(),(0,F.$dh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>$.complete())}}function E(y,$){return`${y.value}/${$}`}e.$Gic=E}),define(Fe[65],Le([1,0,5,3,4,2,17,6,7,167,15,195,21,33,196,40,11,8,31]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=e.$Thc=e.$Shc=e.$Rhc=void 0,e.$Rhc=(0,P.$ci)("IExtHostTerminalService");class n{constructor(d,w,b,M){this.l=d,this._id=w,this.m=b,this.n=M,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(G=>this.f=G);const T=this;this.value={get name(){return T.n||""},get processId(){return T.b},get creationOptions(){return T.m},get exitStatus(){return T.h},get state(){return T.j},get selection(){return T.k},sendText(G,W=!0){T.q(),T.l.$sendText(T._id,G,W)},show(G){T.q(),T.l.$show(T._id,G)},hide(){T.q(),T.l.$hide(T._id)},dispose(){T.a||(T.a=!0,T.l.$dispose(T._id))},get dimensions(){if(!(T.d===void 0||T.g===void 0))return{columns:T.d,rows:T.g}}}}async create(d,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:d.name,shellPath:d.shellPath??void 0,shellArgs:d.shellArgs??void 0,cwd:d.cwd??w?.cwd??void 0,env:d.env??void 0,icon:E(d.iconPath)??void 0,color:s.ThemeColor.isThemeColor(d.color)?d.color.id:void 0,initialText:d.message??void 0,strictEnv:d.strictEnv??void 0,hideFromUser:d.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(d.location,w?.resolvedExtHostIdentifier),isTransient:d.isTransient??void 0})}async createExtensionTerminal(d,w,b,M,T){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:M,color:s.ThemeColor.isThemeColor(T)?T.id:void 0,location:w?.location||this.o(d,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(d,w){return typeof d=="object"?"parentTerminal"in d&&d.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in d?{viewColumn:r.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus}:void 0:d}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(d){this.n=d}setExitStatus(d,w){this.h=Object.freeze({code:d,reason:w})}setDimensions(d,w){return d===this.d&&w===this.g||d===0||w===0?!1:(this.d=d,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(d){this.k=d}_setProcessId(d){this.f?(this.f(d),this.f=void 0):this.b.then(w=>{w!==d&&(this.b=Promise.resolve(d))})}}e.$Shc=n;class o{get onProcessReady(){return this.b.event}constructor(d){this.g=d,this.id=0,this.shouldPersist=!1,this.a=new S.$3d,this.onProcessData=this.a.event,this.b=new S.$3d,this.d=new S.$3d,this.onDidChangeProperty=this.d.event,this.f=new S.$3d,this.onProcessExit=this.f.event}refreshProperty(d){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${d}`)}updateProperty(d,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${d}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(d){this.g.handleInput?.(d)}resize(d,w){this.g.setDimensions?.({columns:d,rows:w})}clearBuffer(){}async processBinary(d){}acknowledgeDataEvent(d){}async setUnicodeVersion(d){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(d){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(d||void 0),d&&this.g.setDimensions?.(d),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,t=class extends g.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(d=>d.value)}constructor(d,w,b){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$3d,this.onDidCloseTerminal=this.H.event,this.I=new S.$3d,this.onDidOpenTerminal=this.I.event,this.J=new S.$3d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$3d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$3d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$3d,this.onDidChangeShell=this.N.event,this.O=new S.$3d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$3d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(F.$VL.MainThreadTerminalService),this.y=new p.$ftb(this.a.$sendProcessData),this.a.$registerProcessSupport(d),this.Q.registerArgumentProcessor({processArgument:M=>{const T=G=>{const W=G;return this.W(W.instanceId)?.value};switch(M?.$mid){case 15:return T(M);default:{if(Array.isArray(M))for(let G=0;G<M.length&&M[G].$mid===15;G++)M[G]=T(M[G]);return M}}}}),this.B({dispose:()=>{for(const[M,T]of this.g)T.shutdown(!0)}})}getDefaultShell(d){return(d?this.u:this.s)?.path||""}getDefaultShellArgs(d){return(d?this.u:this.s)?.args||[]}createExtensionTerminal(d,w){const b=new n(this.a,(0,v.$yg)(),d,d.name),M=new o(d.pty);return b.createExtensionTerminal(d.location,w,this.R(d,w).resolvedExtHostIdentifier,E(d.iconPath),y(d.color)).then(T=>{const G=this.S(T,M);this.h[T]=G}),this.f.push(b),b.value}R(d,w){if(w=w||{},d.location&&typeof d.location=="object"&&"parentTerminal"in d.location){const b=d.location.parentTerminal;if(b){const M=this.f.find(T=>T.value===b);M&&(w.resolvedExtHostIdentifier=M._id)}}else d.location&&typeof d.location!="object"?w.location=d.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(d,w){if(!this.W(d))throw new Error(`Cannot resolve terminal with id ${d} for virtual process`);const M=new o(w),T=this.S(d,M);this.h[d]=T}async $acceptActiveTerminalChanged(d){const w=this.b;if(d===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const b=this.W(d);b&&(this.b=b,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(d,w){const b=this.W(d);b&&this.O.fire({terminal:b.value,data:w})}async $acceptTerminalDimensions(d,w,b){const M=this.W(d);M&&M.setDimensions(w,b)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(d,w){const b=this.W(d);b&&this.P.fire({terminal:b.value,...w})}async $acceptTerminalMaximumDimensions(d,w,b){this.g.get(d)?.resize(w,b)}async $acceptTerminalTitleChange(d,w){const b=this.W(d);b&&(b.name=w)}async $acceptTerminalClosed(d,w,b){const M=this.Y(this.f,d);if(M!==null){const T=this.f.splice(M,1)[0];T.setExitStatus(w,b),this.H.fire(T.value)}}$acceptTerminalOpened(d,w,b,M){if(w){const W=this.Y(this.f,w);if(W!==null){this.f[W]._id=d,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const T={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:L.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},G=new n(this.a,d,T,b);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(d,w){this.W(d)?._setProcessId(w)}async $startExtensionTerminal(d,w){const b=this.W(d);if(!b)return{message:(0,D.localize)(0,null,d)};b.isOpen||await new Promise(T=>{const G=this.onDidOpenTerminal(async W=>{W===b.value&&(G.dispose(),T())})});const M=this.g.get(d);M?M.startSendingEvents(w):this.j[d]={initialDimensions:w}}S(d,w){const b=new g.$Sc;b.add(w.onProcessReady(T=>this.a.$sendProcessReady(d,T.pid,T.cwd,T.windowsPty))),b.add(w.onDidChangeProperty(T=>this.a.$sendProcessProperty(d,T))),this.y.startBuffering(d,w.onProcessData),b.add(w.onProcessExit(T=>this.U(d,T))),this.g.set(d,w);const M=this.j[d];return M&&w instanceof o&&(w.startSendingEvents(M.initialDimensions),delete this.j[d]),b}$acceptProcessAckDataEvent(d,w){this.g.get(d)?.acknowledgeDataEvent(w)}$acceptProcessInput(d,w){this.g.get(d)?.input(w)}$acceptTerminalInteraction(d){const w=this.W(d);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(d,w){this.W(d)?.setSelection(w)}$acceptProcessResize(d,w,b){try{this.g.get(d)?.resize(w,b)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(d,w){this.g.get(d)?.shutdown(w)}$acceptProcessRequestInitialCwd(d){this.g.get(d)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(d,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(d){this.g.get(d)?.getCwd().then(w=>this.a.$sendProcessProperty(d,{type:"cwd",value:w}))}$acceptProcessRequestLatency(d){return Promise.resolve(d)}registerLinkProvider(d){return this.z.add(d),this.z.size===1&&this.a.$startLinkProvider(),new f.$XL(()=>{this.z.delete(d),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(d,w,b){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,b),this.a.$registerProfileProvider(w,d.identifier.value),new f.$XL(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(d,w,b){if(this.D.has(d))throw new Error(`Terminal quick fix provider "${d}" is already registered`);return this.D.set(d,b),this.a.$registerQuickFixProvider(d,w),new f.$XL(()=>{this.D.delete(d),this.a.$unregisterQuickFixProvider(d)})}async $provideTerminalQuickFixes(d,w){const b=new h.$ae().token;if(b.isCancellationRequested)return;const M=this.D.get(d);if(!M)return;const T=await M.provideTerminalQuickFixes(w,b);if(T===null||Array.isArray(T)&&T.length===0)return;const G=new g.$Sc;if(this.w.value=G,!Array.isArray(T))return T?r.TerminalQuickFix.from(T,this.Q.converter,G):void 0;const W=[];for(const U of T){const C=r.TerminalQuickFix.from(U,this.Q.converter,G);C&&W.push(C)}return W}async $createContributedProfileTerminal(d,w){const b=new h.$ae().token;let M=await this.C.get(d)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${d}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,w);return}this.createTerminalFromOptions(M.options,w)}}async $provideLinks(d,w){const b=this.W(d);if(!b)return[];this.F.delete(d),this.G.get(d)?.dispose(!0);const T=new h.$ae;this.G.set(d,T);const G=[],W={terminal:b.value,line:w},U=[];for(const V of this.z)U.push(u.Promises.withAsyncBody(async re=>{T.token.onCancellationRequested(()=>re({provider:V,links:[]}));const ce=await V.provideTerminalLinks(W,T.token)||[];T.token.isCancellationRequested||re({provider:V,links:ce})}));const C=await Promise.all(U);if(T.token.isCancellationRequested)return[];const O=new Map;for(const V of C)V&&V.links.length>0&&G.push(...V.links.map(re=>{const ce={id:l++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return O.set(ce.id,{provider:V.provider,link:re}),ce}));return this.F.set(d,O),G}$activateLink(d,w){const b=this.F.get(d)?.get(w);b&&b.provider.handleTerminalLink(b.link)}U(d,w){this.y.stopBuffering(d),this.g.delete(d),delete this.j[d];const b=this.h[d];b&&(b.dispose(),delete this.h[d]),this.a.$sendProcessExit(d,w)}W(d){return this.X(this.f,d)}X(d,w){const b=this.Y(d,w);return b!==null?d[b]:null}Y(d,w){const b=d.findIndex(M=>M._id===w);return b===-1?null:b}getEnvironmentVariableCollection(d){let w=this.n.get(d.identifier.value);return w||(w=new m,this.$(d.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(d,w){const b=(0,k.$Vr)(w.map),M=(0,k.$Wr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(d,w.persistent,b.length===0?void 0:b,M)}$initEnvironmentVariableCollections(d){d.forEach(w=>{const b=w[0],M=new m(w[1]);this.$(b,M)})}$acceptDefaultProfile(d,w){const b=this.s;this.s=d,this.u=w,b?.path!==d.path&&this.N.fire(d.path)}$(d,w){this.n.set(d,w),w.onDidChangeCollection(()=>{this.Z(d,w)})}};e.$Thc=t,e.$Thc=t=Je([qe(1,i.$wO),qe(2,R.$aO)],t);class m{get persistent(){return this.b}set persistent(d){this.b=d,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(d){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$3d,this.map=new Map(d)}getScopedEnvironmentVariableCollection(d){const w=this.h(d);let b=this.a.get(w);return b||(b=new a(this,d),this.a.set(w,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:M})}append(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:M})}prepend(d,w,b,M){this.f(d,{value:w,type:f.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:M})}f(d,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(d,w.scope),M=this.map.get(b),T=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==w.value||M.type!==w.type||M.options?.applyAtProcessCreation!==T.applyAtProcessCreation||M.options?.applyAtShellIntegration!==T.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const G=this.g(d,w.scope),W={variable:d,...w,options:T};this.map.set(G,W),this.d.fire()}}get(d,w){const b=this.g(d,w),M=this.map.get(b);return M?$(M):void 0}g(d,w){const b=this.h(w);return b.length?`${d}:::${b}`:d}h(d){return this.j(d?.workspaceFolder)??""}j(d){return d?d.uri.toString():void 0}getVariableMap(d){const w=new Map;for(const[b,M]of this.map)this.h(M.scope)===this.h(d)&&w.set(M.variable,$(M));return w}delete(d,w){const b=this.g(d,w);this.map.delete(b),this.d.fire()}clear(d){if(d?.workspaceFolder){for(const[w,b]of this.map)b.scope?.workspaceFolder?.index===d.workspaceFolder.index&&this.map.delete(w);this.k(d)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(d,w){const b=this.h(w),M=this.descriptionMap.get(b);if(!M||M.description!==d){let T;typeof d=="string"?T=d:T=d?.value.split(`

`)[0];const G={description:T,scope:w};this.descriptionMap.set(b,G),this.d.fire()}}getDescription(d){const w=this.h(d);return this.descriptionMap.get(w)?.description}k(d){const w=this.h(d);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(d){this.b.persistent=d}get onDidChangeCollection(){return this.a&&this.a.event}constructor(d,w){this.b=d,this.d=w,this.a=new S.$3d}getScoped(d){return this.b.getScopedEnvironmentVariableCollection(d)}replace(d,w,b){this.b.replace(d,w,b,this.d)}append(d,w,b){this.b.append(d,w,b,this.d)}prepend(d,w,b){this.b.prepend(d,w,b,this.d)}get(d){return this.b.get(d,this.d)}forEach(d,w){this.b.getVariableMap(this.d).forEach((b,M)=>d.call(w,M,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(d){this.b.delete(d,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(d){this.b.setDescription(d,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(d,w){super(!1,d,w)}createTerminal(d,w,b){throw new A.$_}createTerminalFromOptions(d,w){throw new A.$_}};e.$Uhc=c,e.$Uhc=c=Je([qe(0,i.$wO),qe(1,R.$aO)],c);function E(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function y(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function $(I){const d={...I};return delete d.scope,d.options=d.options??void 0,delete d.variable,d}}),define(Fe[275],Le([1,0,11,24,21,5,246,97,6,26,16,33,14,3,17,111,8,7,49,75,59,23]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=e.$Yic=e.$Xic=void 0;let t=class extends f.$Tc{constructor(U,C,O,V){super(),this.w=V,this.f=this.B(new L.$3d),this.g=new Map,this.s=this.B(new L.$3d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(v.$VL.MainThreadTesting),this.m=new b(this.h),this.j=new E(this.h,C),O.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ce=re,ye=ce.tests[ce.tests.length-1].item.extId;return this.g.get(i.$MK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$mO)(re)}case 18:{const{extId:ce,message:ye}=re;return{test:this.g.get(i.$MK.root(ce))?.collection.tree.get(ce)?.actual,message:u.TestMessage.to(ye)}}default:return re}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await O.executeCommand("_testing.getExplorerSelection"),ce=ye=>{const ke=this.g.get(i.$MK.root(ye));if(ke)return i.$MK.isRoot(ye)?ke.controller:ke.collection.tree.get(ye)?.actual};return{include:re?.include.map(ce).filter(A.$Yf)||[],exclude:re?.exclude.map(ce).filter(A.$Yf)||[]}})}createTestController(U,C,O,V){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new f.$Sc,ce=re.add(new s.$pO(C,O,this.w));ce.root.label=O;const ye=new Map,ke=new Set,he=this.h,ve={items:ce.root.children,get label(){return O},set label($e){O=$e,ce.root.label=$e,he.$updateController(C,{label:O})},get refreshHandler(){return V},set refreshHandler($e){V=$e,he.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,te,Y,q,ne,Pe)=>{let Oe=(0,g.$3i)($e);for(;ye.has(Oe);)Oe++;return new T(this.h,ye,ke,this.s.event,C,Oe,$e,te,Y,q,ne,Pe)},createTestItem($e,te,Y){return new s.$nO(C,$e,te,Y)},createTestRun:($e,te,Y=!0)=>this.j.createTestRun(U,C,ce,$e,te,Y),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const te=$e instanceof Array?$e:[$e];this.h.$markTestRetired(te.map(Y=>i.$MK.fromExtHostTestItem(Y,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{re.dispose()}};he.$registerTestController(C,O,!!V),re.add((0,f.$Rc)(()=>he.$unregisterTestController(C)));const se={controller:ve,collection:ce,profiles:ye,extension:U,activeProfiles:ke};return this.g.set(C,se),re.add((0,f.$Rc)(()=>this.g.delete(C))),re.add(ce.onDidGenerateDiff($e=>he.$publishDiff(C,$e.map(o.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const O=y(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const V=this.g.get(O.controllerId);if(!V)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>i.$MK.fromExtHostTestItem(re,V.collection.root.id).toString())??[V.collection.root.id],profileGroup:G[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,O){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(U,C,O,V){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(O,V)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[O,V]of Object.entries(U)){const re=this.g.get(O);if(!re)continue;const ce=new Map,ye=V.filter(he=>!re.activeProfiles.has(he)),ke=[...re.activeProfiles].filter(he=>!V.includes(he));for(const he of ye)ce.set(he,!0),re.activeProfiles.add(he);for(const he of ke)ce.set(he,!1),re.activeProfiles.delete(he);ce.size&&C.set(O,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,D.$Gn)(u.TestResults.to(C))).concat(this.results).sort((C,O)=>O.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const O=this.g.get(i.$MK.fromString(U).controllerId)?.collection;O&&(await O.expand(U,C<0?1/0:C),O.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>o.TestsDiffOp.deserialize({asCanonicalUri:O=>O},C)))}async $runControllerTests(U,C){return Promise.all(U.map(O=>this.y(O,!1,C)))}async $startContinuousRun(U,C){const O=new P.$ae(C),V=await Promise.all(U.map(re=>this.y(re,!0,O.token)));return!C.isCancellationRequested&&!V.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),O.dispose(!0),V}async y(U,C,O){const V=this.g.get(U.controllerId);if(!V)return{};const{collection:re,profiles:ce,extension:ye}=V,ke=ce.get(U.profileId);if(!ke)return{};const he=U.testIds.map(te=>re.tree.get(te)).filter(A.$Yf),ve=U.excludeExtIds.map(te=>V.collection.tree.get(te)).filter(A.$Yf).filter(te=>he.some(Y=>Y.fullId.compare(te.fullId)===2));if(!he.length)return{};const se=new r.$wN(he.some(te=>te.actual instanceof s.$oO)?void 0:he.map(te=>te.actual),ve.map(te=>te.actual),ke,C),$e=(0,o.$OK)(U)&&this.j.prepareForMainThreadTestRun(se,$.fromInternal(U,V.collection),ye,O);try{return await ke.runHandler(se,O),{}}catch(te){return{error:String(te)}}finally{$e&&($e.hasRunningTasks&&!O.isCancellationRequested&&await L.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Xic=t,e.$Xic=t=Je([qe(0,p.$aO),qe(1,h.$wj)],t);const m=1e4;var a;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(a||(a={}));class c extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,O,V,re){super(),this.s=U,this.w=C,this.y=O,this.z=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$3d),this.m=this.B(new L.$3d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$ae(re));const ce=this.B(new S.$oh(()=>this.C(),m));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,O=this.s.controllerId,V=(0,k.$yg)(),re=this.y,ce=this.m;let ye;const ke=$e=>(te,...Y)=>{if(ve){this.z.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.F(te),$e(te,...Y))},he=($e,te)=>{const Y=te instanceof Array?te.map(u.TestMessage.from):[u.TestMessage.from(te)];if($e.uri&&$e.range){const q={range:u.Range.from($e.range),uri:$e.uri};for(const ne of Y)ne.location=ne.location||q}this.w.$appendTestMessagesInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),Y)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,l.$SF)(re,"testCoverage"),ye=$e&&new I($e),ce.fire({taskId:V,runId:C,coverage:ye})},enqueued:ke($e=>{this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),1)}),skipped:ke($e=>{this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),5)}),started:ke($e=>{this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),2)}),errored:ke(($e,te,Y)=>{he($e,te),this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),6,Y)}),failed:ke(($e,te,Y)=>{he($e,te),this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,O).toString(),4,Y)}),passed:ke(($e,te)=>{this.w.$updateTestStateInRun(C,V,i.$MK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,te)}),appendOutput:($e,te,Y)=>{ve||(Y&&(this.s.isIncluded(Y)?this.F(Y):Y=void 0),this.w.$appendOutputToRun(C,V,F.$qe.fromString($e),te&&u.location.from(te),Y&&i.$MK.fromExtHostTestItem(Y,O).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,V),this.f.delete(V),this.f.size||this.D())}};return this.f.set(V,{run:se}),this.w.$startedTestRunTask(C,{id:V,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$nO))throw new n.$5N(U.id);if(this.g.has(i.$MK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],O=this.s.colllection.root;for(;;){const V=u.TestItem.from(U);if(C.unshift(V),this.g.has(V.extId)||(this.g.add(V.extId),U===O))break;U=U.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class E{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(O=>O.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,O,V){return this.j(U,C,O,V)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,O,V,re,ce){const ye=this.c.get(V);if(ye)return ye.createRun(re);const ke=$.fromPublic(C,O,V,ce),he=y(V);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!V.continuous,profile:he&&{group:G[he.kind],id:he.profileId},exclude:V.exclude?.map(se=>i.$MK.fromExtHostTestItem(se,O.root.id).toString())??[],id:ke.id,include:V.include?.map(se=>i.$MK.fromExtHostTestItem(se,O.root.id).toString())??[O.root.id],persist:ce});const ve=this.j(V,ke,U);return L.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(ke.id),ve.dispose()}),ve.createRun(re)}j(U,C,O,V){const re=new c(C,this.g,O,this.h,V);this.c.set(U,re);let ce;const ye=re.onDidCoverage(({runId:ke,taskId:he,coverage:ve})=>{ce||(ce={runId:ke,coverage:new Map},this.f.unshift(ce),this.f.length>o.$TK&&this.f.pop()),ce.coverage.set(he,ve),this.g.$signalCoverageAvailable(ke,he,!!ve)});return L.Event.once(re.onEnd)(()=>{this.c.delete(U),ye.dispose()}),re}}e.$Yic=E;const y=W=>{if(W.profile){if(!(W.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class ${static fromPublic(U,C,O,V){return new $(U,(0,k.$yg)(),O.include?.map(re=>i.$MK.fromExtHostTestItem(re,U).toString())??[U],O.exclude?.map(re=>i.$MK.fromExtHostTestItem(re,U).toString())??[],V,C)}static fromInternal(U,C){return new $(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,O,V,re,ce){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ce,this.c=O.map(ye=>ye+"\0"),this.f=V.map(ye=>ye+"\0")}isIncluded(U){const C=i.$MK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(C===O||C.startsWith(O))return!1;for(const O of this.c)if(C===O||C.startsWith(O))return!0;return!1}}e.$Zic=$;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(u.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const O=await this.c;let V=O?.[U];return!this.provider||!O||!V?[]:(V.detailedCoverage||(V=O[U]=await this.provider.resolveFileCoverage?.(V,C)??V),V.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,u.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$MK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:O}=this;return{get added(){return[...U].map(V=>V.revived)},get updated(){return[...C].map(V=>V.revived)},get removed(){return[...O].map(V=>V.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class w extends o.$UK{constructor(){super(...arguments),this.s=new L.$3d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:u.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new d(this.s)}}class b{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new w({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const M=(W,U,C,O)=>{C?Object.assign(C,O):U.$updateTestRunConfig(W.controllerId,W.profileId,O)};class T{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,M(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,M(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),M(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,M(this,this.#e,this.#n,{tag:U?u.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,M(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return L.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$Yf))}constructor(U,C,O,V,re,ce,ye,ke,he,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ce,this.f=ye,this.kind=ke,this.runHandler=he,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=O,this.#i=V,C.set(ce,this);const te=G[ke];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);ve&&O.add(ce),this.#n={profileId:ce,controllerId:re,tag:se?u.TestTag.namespace(this.controllerId,se.id):null,label:ye,group:te,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$1ic=T;const G={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Fe[112],Le([1,0,54,15,88,8,7]),function(fe,e,S,F,P,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=void 0;class g{static{this.c=new P.$fO("TextEditorDecorationType")}constructor(h,v,p){const s=g.c.nextId();h.$registerTextEditorDecorationType(v.identifier,s,L.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:s,dispose(){h.$removeTextEditorDecorationType(s)}})}}e.$hO=g;class f{constructor(h,v){this.g=[],this.h=void 0,this.j=!1,this.c=h,this.d=h.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(h,v){this.k();let p=null;if(h instanceof R.$YL)p=new R.$ZL(h,h);else if(h instanceof R.$ZL)p=h;else throw new Error("Unrecognized location");this.l(p,v,!1)}insert(h,v){this.k(),this.l(new R.$ZL(h,h),v,!0)}delete(h){this.k();let v=null;if(h instanceof R.$ZL)v=h;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(h,v,p){const s=this.c.validateRange(h);this.g.push({range:s,text:v,forceMoveMarkers:p})}setEndOfLine(h){if(this.k(),h!==R.EndOfLine.LF&&h!==R.EndOfLine.CRLF)throw(0,F.$7)("endOfLine");this.h=h}}class D{constructor(h,v,p,s){this.c=h,this.d=v,this._accept(p),this.e=s;const u=this;this.value={get tabSize(){return u.f},set tabSize(r){u.n(r)},get indentSize(){return u.g},set indentSize(r){u.p(r)},get insertSpaces(){return u.j},set insertSpaces(r){u.s(r)},get cursorStyle(){return u.k},set cursorStyle(r){u.t(r)},get lineNumbers(){return u.l},set lineNumbers(r){u.u(r)}}}_accept(h){this.f=h.tabSize,this.g=h.indentSize,this.h=h.originalIndentSize,this.j=h.insertSpaces,this.k=h.cursorStyle,this.l=L.TextEditorLineNumbersStyle.to(h.lineNumbers)}m(h){if(h==="auto")return"auto";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}n(h){const v=this.m(h);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}o(h){if(h==="tabSize")return"tabSize";if(typeof h=="number"){const v=Math.floor(h);return v>0?v:null}if(typeof h=="string"){const v=parseInt(h,10);return isNaN(v)?null:v>0?v:null}return null}p(h){const v=this.o(h);if(v!==null){if(typeof v=="number"){if(this.h===v)return;this.g=v,this.h=v}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}q(h){return h==="auto"?"auto":h==="false"?!1:!!h}s(h){const v=this.q(h);if(typeof v=="boolean"){if(this.j===v)return;this.j=v}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}t(h){this.k!==h&&(this.k=h,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:h})))}u(h){this.l!==h&&(this.l=h,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(h)})))}assign(h){const v={};let p=!1;if(typeof h.tabSize<"u"){const s=this.m(h.tabSize);s==="auto"?(p=!0,v.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,p=!0,v.tabSize=s)}if(typeof h.indentSize<"u"){const s=this.o(h.indentSize);s==="tabSize"?(p=!0,v.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,p=!0,v.indentSize=s)}if(typeof h.insertSpaces<"u"){const s=this.q(h.insertSpaces);s==="auto"?(p=!0,v.insertSpaces=s):this.j!==s&&(this.j=s,p=!0,v.insertSpaces=s)}typeof h.cursorStyle<"u"&&this.k!==h.cursorStyle&&(this.k=h.cursorStyle,p=!0,v.cursorStyle=h.cursorStyle),typeof h.lineNumbers<"u"&&this.l!==h.lineNumbers&&(this.l=h.lineNumbers,p=!0,v.lineNumbers=L.TextEditorLineNumbersStyle.from(h.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,v))}v(h,v){v.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${h}' failed:'`),this.e.warn(p)})}}e.$iO=D;class A{constructor(h,v,p,s,u,r,i,n){this.id=h,this.j=v,this.k=p,this.g=!1,this.h=new Set,this.c=u,this.d=new D(this.j,this.id,r,p),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return s.value},set document(l){throw new F.$9("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof R.$1L))throw(0,F.$7)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(t=>!(t instanceof R.$1L)))throw(0,F.$7)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new F.$9("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new F.$9("viewColumn")},edit(l,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const m=new f(s.value,t);return l(m),o.m(m)},insertSnippet(l,t,m={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=o.c.map(c=>L.Range.from(c));else if(t instanceof R.$YL){const{lineNumber:c,column:E}=L.Position.from(t);a=[{startLineNumber:c,startColumn:E,endLineNumber:c,endColumn:E}]}else if(t instanceof R.$ZL)a=[L.Range.from(t)];else{a=[];for(const c of t)if(c instanceof R.$ZL)a.push(L.Range.from(c));else{const{lineNumber:E,column:y}=L.Position.from(c);a.push({startLineNumber:E,startColumn:y,endLineNumber:E,endColumn:y})}}return v.$tryInsertSnippet(h,s.value.version,l.value,a,m)},setDecorations(l,t){const m=t.length===0;m&&!o.h.has(l.key)||(m?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(L.$0N(t))return v.$trySetDecorations(h,l.key,L.$$N(t));{const a=new Array(4*t.length);for(let c=0,E=t.length;c<E;c++){const y=t[c];a[4*c]=y.start.line+1,a[4*c+1]=y.start.character+1,a[4*c+2]=y.end.line+1,a[4*c+3]=y.end.character+1}return v.$trySetDecorationsFast(h,l.key,a)}}))},revealRange(l,t){o.n(()=>v.$tryRevealRange(h,L.Range.from(l),t||R.TextEditorRevealType.Default))},show(l){v.$tryShowEditor(h,L.ViewColumn.from(l))},hide(){v.$tryHideEditor(h)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(h){(0,S.ok)(!this.g),this.d._accept(h)}_acceptVisibleRanges(h){(0,S.ok)(!this.g),this.e=h}_acceptViewColumn(h){(0,S.ok)(!this.g),this.f=h}_acceptSelections(h){(0,S.ok)(!this.g),this.c=h}async l(){const h=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,h)),this.value}m(h){const v=h.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const p=v.edits.map(u=>u.range);p.sort((u,r)=>u.end.line===r.end.line?u.end.character===r.end.character?u.start.line===r.start.line?u.start.character-r.start.character:u.start.line-r.start.line:u.end.character-r.end.character:u.end.line-r.end.line);for(let u=0,r=p.length-1;u<r;u++){const i=p[u].end;if(p[u+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=v.edits.map(u=>({range:L.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,s,{setEndOfLine:typeof v.setEndOfLine=="number"?L.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(h){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$jO=A}),define(Fe[66],Le([1,0,54,5,6,2,4,3,109,17,112,8,14,28,12,68,39]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;class r{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new v.$Ac,this.d=new F.$3d,this.e=new F.$3d,this.f=new F.$3d,this.g=new F.$3d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],t=[],m=[];if(o.removedDocuments)for(const a of o.removedDocuments){const c=L.URI.revive(a),E=this.c.get(c);E?.unref()&&(this.c.delete(c),l.push(E.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const c=L.URI.revive(a.uri);let E=this.c.get(c);if(E&&c.scheme!==p.Schemas.vscodeNotebookCell&&c.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);E||(E=new r(new f.$dO(this.h.getProxy(g.$VL.MainThreadDocuments),c,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(c,E),t.push(E.value)),E.ref()}if(o.removedEditors)for(const a of o.removedEditors){const c=this.b.get(a);this.b.delete(a),c&&m.push(c)}if(o.addedEditors)for(const a of o.addedEditors){const c=L.URI.revive(a.documentUri);S.ok(this.c.has(c),`document '${c}' does not exist`),S.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const E=this.c.get(c).value,y=new A.$jO(a.id,this.h.getProxy(g.$VL.MainThreadTextEditors),this.i,new u.$V(()=>E.document),a.selections.map(k.Selection.to),a.options,a.visibleRanges.map($=>k.Range.to($)),typeof a.editorPosition=="number"?k.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,y)}o.newActiveEditor!==void 0&&(S.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Oc)(l),(0,P.$Oc)(m),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return s.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$kO=i,e.$kO=i=Je([qe(0,D.$aO),qe(1,h.$wj)],i),e.$lO=(0,R.$ci)("IExtHostDocumentsAndEditors")}),define(Fe[276],Le([1,0,18,5,3,112,8,7]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;class f{constructor(A,k){this.i=k,this.a=new F.$3d,this.b=new F.$3d,this.c=new F.$3d,this.d=new F.$3d,this.f=new F.$3d,this.g=new F.$3d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(P.$VL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(h=>this.g.fire(h)),this.i.onDidChangeActiveTextEditor(h=>this.f.fire(h))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(h=>h.value)}async showTextDocument(A,k,h){let v;typeof k=="number"?v={position:R.ViewColumn.from(k),preserveFocus:h}:typeof k=="object"?v={position:R.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?R.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:v={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(A.uri,v),s=p&&this.i.getEditor(p);if(s)return s.value;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new L.$hO(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const h=this.i.getEditor(A);if(!h)throw new Error("unknown text editor");if(k.options&&h._acceptOptions(k.options),k.selections){const v=k.selections.selections.map(R.Selection.to);h._acceptSelections(v)}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));h._acceptVisibleRanges(v)}if(k.options&&this.b.fire({textEditor:h.value,options:{...k.options,lineNumbers:R.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const v=g.TextEditorSelectionChangeKind.fromValue(k.selections.source),p=k.selections.selections.map(R.Selection.to);this.a.fire({textEditor:h.value,selections:p,kind:v})}if(k.visibleRanges){const v=S.$Hb(k.visibleRanges.map(R.Range.to));this.c.fire({textEditor:h.value,visibleRanges:v})}}$acceptEditorPositionData(A){for(const k in A){const h=this.i.getEditor(k);if(!h)throw new Error("Unknown text editor");const v=R.ViewColumn.to(A[k]);h.value.viewColumn!==v&&(h._acceptViewColumn(v),this.d.fire({textEditor:h.value,viewColumn:v}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$khc=f}),define(Fe[277],Le([1,0,2,4,3,6,7,8,22,16]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ic=e.$3ic=void 0,e.$3ic=(0,F.$ci)("IExtHostTimeline");class A{constructor(v,p){this.b=new Map,this.c=new Map,this.a=v.getProxy(P.$VL.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(s,u)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$um.equals(u,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(k(r))?.get(s.handle)}else return;return s}})}async $getTimeline(v,p,s,u){return this.b.get(v)?.provider.provideTimeline(S.URI.revive(p),s,u)}registerTimelineProvider(v,p,s,u){const r=new L.$Sc,i=this.d(p.id,u,r).bind(this);let n;p.onDidChange&&(n=p.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:p.id}),this));const o=this.c;return this.f({...p,scheme:v,onDidChange:void 0,async provideTimeline(l,t,m){t?.resetCache&&(r.clear(),o.get(p.id)?.clear());const a=await p.provideTimeline(l,t,m);if(a==null)return;const c=i(l,t);return{...a,source:p.id,items:a.items.map(c)}},dispose(){for(const l of o.values())l.get(p.id)?.clear();n?.dispose(),r.dispose()}},s)}d(v,p,s){return(u,r)=>{let i;if(r?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=k(u);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...l}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let m,a,c;n.iconPath&&(o instanceof R.$SM?c={id:o.id,color:o.color}:S.URI.isUri(o)?(m=o,a=o):{light:m,dark:a}=o);let E;return R.$mM.isMarkdownString(l.tooltip)?E=g.MarkdownString.from(l.tooltip):(0,D.$Qf)(l.tooltip)?E=l.tooltip:R.$mM.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.MarkdownString.from(l.detail)):(0,D.$Qf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=l.detail),{...l,id:l.id??void 0,handle:t,source:v,command:n.command?p.toInternal(n.command,s):void 0,icon:m,iconDark:a,themeIcon:c,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(v,p){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:p}),(0,L.$Rc)(()=>{for(const u of this.c.values())u.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$4ic=A;function k(h){return h?.toString()}}),define(Fe[278],Le([1,0,168,25,2,5,6,206,11,7,16,18,8,46,21,133,23]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=void 0;function r(o,l){if((0,A.$Qf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends R.$Tc{constructor(l,t,m){super(),this.f=l,this.g=t,this.h=m,this.a=new Map,this.b=new s.$w9;function a(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>a(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(E=>a(E)?this.r(E):E):c})}registerTreeDataProvider(l,t,m){const a=this.createTreeView(l,{treeDataProvider:t},m);return{dispose:()=>a.dispose()}}createTreeView(l,t,m){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],E=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,$=this.m(l,t,m),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:a,dragMimeTypes:c,hasHandleDrag:E,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},d=this.f.$registerTreeViewDataProvider(l,I),w={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,u.$SF)(m,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,u.$SF)(m,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(b){(0,v.$sk)(b)&&(0,u.$SF)(m,"treeViewMarkdownMessage"),$.message=b},get title(){return $.title},set title(b){$.title=b},get description(){return $.description},set description(b){$.description=b},get badge(){return $.badge},set badge(b){b!==void 0&&D.ViewBadge.isViewBadge(b)?$.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&($.badge=void 0)},reveal:(b,M)=>$.reveal(b,M),dispose:async()=>{await d,this.a.delete(l),$.dispose()}};return this.B(w),w}$getChildren(l,t){const m=this.a.get(l);return m?m.getChildren(t):Promise.reject(new g.$lF(l))}async $handleDrop(l,t,m,a,c,E,y,$){const I=this.a.get(l);if(!I)return Promise.reject(new g.$lF(l));const d=h.DataTransfer.toDataTransfer(m,async w=>(await this.f.$resolveDropFileData(l,t,w)).buffer);return y===l&&$&&await this.j(d,I,$,c,E),I.onDrop(d,a,c)}async j(l,t,m,a,c){const E=this.b.removeDragOperationTransfer(c);if(E)(await E)?.forEach((y,$)=>{y&&l.set($,y)});else if(c&&t.handleDrag){const y=t.handleDrag(m,l,a);this.b.addDragOperationTransfer(c,y),await y}return l}async $handleDrag(l,t,m,a){const c=this.a.get(l);if(!c)return Promise.reject(new g.$lF(l));const E=await this.j(new D.$PM,c,t,a,m);if(!(!E||a.isCancellationRequested))return h.DataTransfer.from(E)}async $hasResolve(l){const t=this.a.get(l);if(!t)throw new g.$lF(l);return t.hasResolve}$resolve(l,t,m){const a=this.a.get(l);if(!a)throw new g.$lF(l);return a.resolveTreeItem(t,m)}$setExpanded(l,t,m){const a=this.a.get(l);if(!a)throw new g.$lF(l);a.setExpanded(t,m)}$setSelectionAndFocus(l,t,m){const a=this.a.get(l);if(!a)throw new g.$lF(l);a.setSelectionAndFocus(t,m)}$setVisible(l,t){const m=this.a.get(l);if(!m){if(!t)return;throw new g.$lF(l)}m.setVisible(t)}$changeCheckboxState(l,t){const m=this.a.get(l);if(!m)throw new g.$lF(l);m.setCheckboxState(t)}m(l,t,m){const a=this.B(new n(l,t,this.f,this.g.converter,this.h,m));return this.a.set(l,a),a}r(l){const t=this.a.get(l.$treeViewId);return t&&"$treeItemHandle"in l?t.getExtensionElement(l.$treeItemHandle):t&&"$focusedTreeItem"in l&&l.$focusedTreeItem?t.focusedElement:null}}e.$5ic=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,A.$Zf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,t,m,a,c,E){if(super(),this.I=l,this.J=m,this.L=a,this.M=c,this.N=E,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$3d),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$3d),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$3d),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$3d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$3d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$3d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$3d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$ae,E.contributes&&E.contributes.views)for(const d in E.contributes.views)for(const w of E.contributes.views[d])w.id===l&&(this.P=w.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(d=>this.F.fire({message:!1,element:d})));let y,$;const I=L.Event.debounce(this.F.event,(d,w)=>(d||(d={message:!1,elements:[]}),w.element!==!1&&(y||(y=new Promise(b=>$=b),this.G=this.G.then(()=>y)),Array.isArray(w.element)?d.elements.push(...w.element):d.elements.push(w.element)),w.message&&(d.message=!0),d),200,!0);this.B(I(({message:d,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const b=$;return y=null,this.$(w).then(()=>b())})),d&&this.J.$setMessage(this.I,h.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const t=l?this.getExtensionElement(l):void 0;if(l&&!t)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let m=this.X(l);return m||(m=await this.Y(t)),m?m.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,t){t=t||{select:!0,focus:!1};const m=(0,A.$Zf)(t.select)?!0:t.select,a=(0,A.$Zf)(t.focus)?!1:t.focus,c=(0,A.$Zf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(E=>this.W(l,E[E.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:E.map($=>$.item)},{select:m,focus:a,expand:c})),E=>this.M.error(E)):this.J.$reveal(this.I,void 0,{select:m,focus:a,expand:c})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=h.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,t){const m=this.getExtensionElement(l);m&&(t?this.u.fire(Object.freeze({element:m})):this.w.fire(Object.freeze({element:m})))}setSelectionAndFocus(l,t){const m=!(0,k.$ub)(this.s,l);this.s=l;const a=this.t!==t;this.t=t,m&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const t=(await Promise.all(l.map(async m=>{const a=this.getExtensionElement(m.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:m.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(m=>m!==void 0);t.forEach(m=>{m.treeItem.checkboxState=m.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(m=>[m.extensionItem,m.newState])})}async handleDrag(l,t,m){const a=[];for(const c of l){const E=this.getExtensionElement(c);E&&a.push(E)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,t,m),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,t,m){const a=t?this.getExtensionElement(t):void 0;if(!(!a&&t||!this.g?.handleDrop))return(0,f.$7g)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,m):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,t){if(!this.f.resolveTreeItem)return;const m=this.j.get(l);if(m){const a=this.m.get(m);if(a){const c=await this.f.resolveTreeItem(a.extensionItem,m,t)??a.extensionItem;return this.hb(c),a.item.tooltip=this.eb(c.tooltip),a.item.command=this.fb(a.disposableStore,c.command),a.item}}}S(l){return this.U(l).then(t=>t?this.S(t).then(m=>this.W(t,m[m.length-1]).then(a=>(m.push(a),m))):Promise.resolve([]))}U(l){const t=this.m.get(l);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$7g)(()=>this.f.getParent(l))}W(l,t){const m=this.m.get(l);return m?Promise.resolve(m):(0,f.$7g)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,t,!0)).then(a=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(a);if(c){const E=this.m.get(c);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let t;if(typeof l=="string"){const m=this.getExtensionElement(l);t=m?this.m.get(m):void 0}else t=l;return t&&t.children||void 0}return this.h}async Y(l){this.rb(l);const t=new p.$ae(this.Z.token);try{const m=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(t.token.isCancellationRequested)return;const c=(0,k.$Hb)(a||[]),E=await Promise.all((0,k.$Hb)(c).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const y=E.map(($,I)=>$?this.db(c[I],$,m):null);return(0,k.$Hb)(y)}finally{t.dispose()}}$(l){if(l.some(m=>!m))return this.Z.dispose(!0),this.Z=new p.$ae,this.tb(),this.J.$refresh(this.I);{const m=this.ab(l);if(m.length)return this.bb(m)}return Promise.resolve(void 0)}ab(l){const t=new Set,m=l.map(c=>this.m.get(c));for(const c of m)if(c&&!t.has(c.item.handle)){let E=c;for(;E&&E.parent&&m.findIndex(y=>E&&E.parent&&y&&y.item.handle===E.parent.item.handle)===-1;){const y=this.j.get(E.parent.item.handle);E=y?this.m.get(y):void 0}E&&!E.parent&&t.add(c.item.handle)}const a=[];return t.forEach(c=>{const E=this.j.get(c);if(E){const y=this.m.get(E);y&&(!y.parent||!t.has(y.parent.item.handle))&&a.push(c)}}),a}bb(l){const t={};return Promise.all(l.map(m=>this.cb(m).then(a=>{a&&(t[m]=a.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(l){const t=this.getExtensionElement(l);if(t){const m=this.m.get(t);if(m)return this.rb(t),(0,f.$7g)(()=>this.f.getTreeItem(t)).then(a=>{if(a){const c=this.ib(t,a,m.parent);return this.pb(t,c,m,m.parent),m.dispose(),c}return null})}return Promise.resolve(null)}db(l,t,m){const a=this.ib(l,t,m);if(t.id&&this.j.has(a.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(l,a),this.qb(a,m),a}eb(l){return D.$mM.isMarkdownString(l)?h.MarkdownString.from(l):l}fb(l,t){return t?{...this.L.toInternal(t,l),originalId:t.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let t,m,a;return typeof l.checkboxState=="number"?t=l.checkboxState:(t=l.checkboxState.state,m=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:t===D.TreeItemCheckboxState.Checked,tooltip:m,accessibilityInformation:a}}hb(l){if(!D.$KM.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,t,m){this.hb(t);const a=this.B(new R.$Sc),c=this.kb(l,t,m),E=this.lb(t);return{item:{handle:c,parentHandle:m?m.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(a,t.command),contextValue:t.contextValue,icon:E,iconDark:this.mb(t)||E,themeIcon:this.jb(t),collapsibleState:(0,A.$Zf)(t.collapsibleState)?D.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:m,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof D.$SM?l.iconPath:void 0}kb(l,{id:t,label:m,resourceUri:a},c,E){if(t)return`${n.b}/${t}`;const y=r(m,this.N),$=c?c.item.handle:n.a;let I=y?y.label:a?(0,F.$Mg)(a):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const d=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(c)||[];let b,M=0;do{if(b=`${$}/${M}:${I}`,E||!this.j.has(b)||d===b)break;M++}while(M<=w.length);return b}lb(l){if(l.iconPath&&!(l.iconPath instanceof D.$SM))return typeof l.iconPath=="string"||P.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof D.$SM)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return P.URI.isUri(l)?l:P.URI.file(l)}ob(l,t){this.j.set(t.item.handle,l),this.m.set(l,t)}pb(l,t,m,a){this.j.delete(t.item.handle),this.m.delete(l),t.item.handle!==m.item.handle&&this.j.delete(m.item.handle),this.ob(l,t);const c=this.X(a)||[],E=c.filter(y=>y.item.handle===m.item.handle)[0];E&&c.splice(c.indexOf(E),1,t)}qb(l,t){t?(t.children||(t.children=[]),t.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const t=this.m.get(l);if(t){if(t.children)for(const m of t.children){const a=this.j.get(m.item.handle);a&&this.sb(a)}t.children=void 0}}else this.tb()}sb(l){const t=this.m.get(l);if(t){if(t.children)for(const m of t.children){const a=this.j.get(m.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Fe[279],Le([1,0,5,6,2,33,8,61,3,7]),function(fe,e,S,F,P,L,R,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class A extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,s,u,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$3d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$3d),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=s,this.#n=u,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,P.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:R.ViewColumn.from(p),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends F.$Tc{static c(){return(0,L.$yg)()}constructor(p,s,u){super(),this.j=s,this.m=u,this.g=new Map,this.h=new Map,this.f=p.getProxy(f.$VL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,s,u,r,i={}){const n=typeof r=="object"?r.viewColumn:r,o={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},l=(0,g.$zhc)(p),t=k.c();this.f.$createWebviewPanel((0,g.$Bhc)(p),t,s,{title:u,panelOptions:h(i),webviewOptions:(0,g.$Chc)(p,this.m,i),serializeBuffersForPostMessage:l},o);const m=this.j.createNewWebview(t,i,p);return this.createNewWebviewPanel(t,s,u,n,i,m,!0)}$onDidChangeWebviewPanelViewStates(p){const s=Object.keys(p);s.sort((u,r)=>{const i=p[u],n=p[r];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const u of s){const r=this.getWebviewPanel(u);if(!r)continue;const i=p[u];r._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,s,u){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:u,extension:p}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,g.$zhc)(p)}),new D.$XL(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(p,s,u,r){const i=this.h.get(s);if(!i)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:o}=i,l=this.j.createNewWebview(p,u.webviewOptions,o),t=this.createNewWebviewPanel(p,s,u.title,r,u.panelOptions,l,u.active);await n.deserializeWebviewPanel(t,u.state)}createNewWebviewPanel(p,s,u,r,i,n,o){const l=new A(p,this.f,n,{viewType:s,title:u,viewColumn:r,panelOptions:i,active:o});return this.g.set(p,l),l}getWebviewPanel(p){return this.g.get(p)}}e.$Dhc=k;function h(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Fe[280],Le([1,0,5,6,61,8,3,7]),function(fe,e,S,F,P,L,R,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=void 0;class f extends F.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,h,v,p,s,u){super(),this.#s=!1,this.#u=this.B(new S.$3d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$3d),this.onDidDispose=this.#l.event,this.#i=v,this.#a=p,this.#e=k,this.#t=h,this.#n=s,this.#r=u}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(k,h){this.d=h,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$VL.MainThreadWebviewViews)}registerWebviewViewProvider(k,h,v,p){if(this.b.has(h))throw new Error(`View provider for '${h}' already registered`);return this.b.set(h,{provider:v,extension:k}),this.a.$registerWebviewViewProvider((0,P.$Bhc)(k),h,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$zhc)(k)}),new g.$XL(()=>{this.b.delete(h),this.a.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(k,h,v,p,s){const u=this.b.get(h);if(!u)throw new Error(`No view provider found for '${h}'`);const{provider:r,extension:i}=u,n=this.d.createNewWebview(k,{},i),o=new f(k,this.a,h,v,n,!0);this.c.set(k,o),await r.resolveWebviewView(o,{state:p},s)}async $onDidChangeWebviewViewVisibility(k,h){this.e(k)._setVisible(h)}async $disposeWebviewView(k){const h=this.e(k);this.c.delete(k),h.dispose(),this.d.deleteWebview(k)}e(k){const h=this.c.get(k);if(!h)throw new Error("No webview found");return h}}e.$8ic=D}),define(Fe[281],Le([1,0,5,30,35,4]),function(fe,e,S,F,P,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fL=e.$eL=e.OutputChannelUpdateMode=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=void 0,e.$7K="text/x-code-output",e.$8K="output",e.$9K="Log",e.$0K="text/x-code-log-output",e.$$K="log",e.$_K="workbench.panel.output",e.$aL=new P.$tj("inOutput",!1),e.$bL=new P.$tj("activeLogOutput",!1),e.$cL=new P.$tj("outputView.scrollLock",!1),e.$dL=(0,L.$ci)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$eL={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new S.$3d,this.onDidRegisterChannel=this.b.event,this.c=new S.$3d,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(A=>D.push(A)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}F.$Rn.add(e.$eL.OutputChannels,new g),e.$fL=new P.$tj("activeOutputChannel","")}),define(Fe[113],Le([1,0,3,4,17,22,14,281,62,27,43,137,24,16,42,5,6]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jic=e.$Iic=void 0;class r extends R.$Cj{get disposed(){return this.n}constructor(l,t,m,a,c){super(),this.id=l,this.name=t,this.r=m,this.s=a,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(m.getLevel()),this.B(m.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,l)}replace(l){const t=this.m;this.info(l),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(l,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:t))}hide(){this.s.$close(this.id)}g(l,t){this.m+=h.$qe.fromString(t).byteLength,(0,R.log)(this.r,l,t),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends r{appendLine(l){this.append(l)}}let n=class{constructor(l,t,m,a,c,E){this.i=t,this.j=m,this.k=a,this.l=c,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(S.$VL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$Gm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[t,m]of this.g)m.visible=t===this.h}createOutputChannel(l,t,m){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof t=="object"&&t.log,c=(0,v.$Qf)(t)?t:void 0;if((0,v.$Qf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const y=this.i.environment.extensionLogLevel?.find(([I])=>L.$um.equals(m.identifier,I))?.[1];y&&(E=(0,R.$Mj)(y));const $=a?this.o(l,E,m):this.n(l,c,m);return $.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),a?this.r(l,E??this.m.getLevel(),$):this.q(l,$)}async n(l,t,m){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,c=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(l,c,t,m.identifier.value);return new r(y,l,E,this.a,m)}async o(l,t,m){const a=await this.p(m),c=l.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(a,`${c}.log`),y=`${m.identifier.value}.${c}`,$=this.l.createLogger(E,{id:y,name:l,logLevel:t,extensionId:m.identifier.value});return new i(y,l,$,this.a,m)}p(l){let t=this.d.get(l.identifier.value);if(!t){const m=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(m)}catch(a){if((0,p.$Pk)(a)!==p.FileSystemProviderErrorCode.FileExists)throw a}return m})())}return t}q(l,t){let m=!1;const a=()=>{if(m)throw new Error("Channel has been closed")};return{get name(){return l},append(c){a(),t.then(E=>E.append(c))},appendLine(c){a(),t.then(E=>E.appendLine(c))},clear(){a(),t.then(c=>c.clear())},replace(c){a(),t.then(E=>E.replace(c))},show(c,E){a(),t.then(y=>y.show(c,E))},hide(){a(),t.then(c=>c.hide())},dispose(){m=!0,t.then(c=>c.dispose())}}}r(l,t,m){const a=new u.$Sc,c=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},E=a.add(new s.$3d);function y($){t=$,E.fire($)}return m.then($=>{a.add($),$.logLevel!==t&&y($.logLevel),a.add($.onDidChangeLogLevel(I=>y(I)))}),{...this.q(l,m),get logLevel(){return t},onDidChangeLogLevel:E.event,trace($,...I){c(),m.then(d=>d.trace($,...I))},debug($,...I){c(),m.then(d=>d.debug($,...I))},info($,...I){c(),m.then(d=>d.info($,...I))},warn($,...I){c(),m.then(d=>d.warn($,...I))},error($,...I){c(),m.then(d=>d.error($,...I))},dispose(){a.dispose()}}}};e.$Iic=n,e.$Iic=n=Je([qe(0,P.$aO),qe(1,D.$qO),qe(2,f.$vhc),qe(3,A.$0gc),qe(4,R.$xj),qe(5,R.$wj)],n),e.$Jic=(0,F.$ci)("IExtHostOutputService")}),define(Fe[114],Le([1,0,4,11]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,S.$ci)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let L=1/0;for(let g=0;g<this.maxSampleCount;g++){const f=await P.getRoundTripTime();if(f===void 0)return;L=Math.min(L,f/2),await(0,F.$dh)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((g,f)=>g+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((g,f)=>g+f,0)/this.average.length,high:typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Fe[282],Le([1,0,171,55,30,48,47,6,5,114,20,26,11]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=void 0,e.$BI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$CI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$DI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$EI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$FI={ConfigurationMigration:"base.contributions.configuration.migration"};class v{constructor(){this.migrations=[],this.a=new f.$3d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const p=new v;P.$Rn.add(e.$FI.ConfigurationMigration,p);let s=class extends g.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const l of o.added)await this.f(l,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(o=>this.g(o,i?.uri))])}async g(i,n){const o=this.a.inspect(i.key,{resource:n}),l=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,m]of l){const a=o[t];if(!a)continue;const c=[];if(a.value!==void 0){const E=await this.h(i,t,a.value,n,void 0);for(const y of E??[])c.push([y,[]])}for(const{identifiers:E,value:y}of a.overrides??[])if(y!==void 0){const $=await this.h(i,t,y,n,E);for(const I of $??[])c.push([I,E])}c.length&&await Promise.allSettled(c.map(async([[E,y],$])=>this.a.updateValue(E,y.value,{resource:n,overrideIdentifiers:$},m)))}}async h(i,n,o,l,t){const m=c=>{const y=this.a.inspect(c,{resource:l})[n];if(y)return t?y.overrides?.find(({identifiers:$})=>(0,k.$Jn)($,t))?.value:y.value},a=await i.migrateFn(o,m);return Array.isArray(a)?a:[[i.key,a]]}};e.$GI=s,e.$GI=s=Je([qe(0,R.$Ii),qe(1,L.$li)],s);let u=class extends g.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new h.$zh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Rn.as(F.$Wn.Configuration).registerConfiguration({...e.$DI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$HI=u,e.$HI=u=Je([qe(0,D.$Vm)],u)}),define(Fe[283],Le([1,0,34,12,19,25,179,282,55,4,30]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Beb=e.$Aeb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$zeb=e.$yeb=void 0,e.$yeb=(0,D.$ci)("editorResolverService"),e.$zeb="workbench.editorAssociations";const k=A.$Rn.as(f.$Wn.Configuration),h={...g.$CI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(h);var v;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(v||(e.RegisteredEditorPriority=v={}));var p;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function s(r){switch(r){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Aeb=s;function u(r,i){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(i.scheme))return!1;const l=typeof r=="string"&&r.indexOf(P.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,L.$Mg)(i);return S.$Uj(typeof r=="string"?r.toLowerCase():r,l.toLowerCase())}e.$Beb=u}),define(Fe[284],Le([1,0,45,12,19,20,25,2,4,200,48,218,114]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$yL=e.$xL=void 0,e.$xL=(0,f.$ci)("pathService");let p=v=class{constructor(u,r,i,n){this.d=u,this.e=r,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??u})()}hasValidBasename(u,r,i){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(u,n,r)):this.h(u,r,i)}h(u,r,i){return u.scheme===F.Schemas.file||u.scheme===F.Schemas.vscodeRemote?(0,S.$bg)(i??(0,R.$Mg)(u),r===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(u,r){if(u.remoteAuthority)return F.Schemas.vscodeRemote;const i=(0,D.$uL)(r.getWorkspace());if(i)return i;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=r.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(u){return u?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(u=>u===1?P.$fc:P.$gc)}async fileURI(u){let r="";if(await this.a===1&&(u=u.replace(/\\/g,"/")),u[0]==="/"&&u[1]==="/"){const n=u.indexOf("/",2);n===-1?(r=u.substring(2),u="/"):(r=u.substring(2,n),u=u.substring(n)||"/")}return g.URI.from({scheme:F.Schemas.file,authority:r,path:u,query:"",fragment:""})}};e.$yL=p,e.$yL=p=v=Je([qe(1,h.$Vm),qe(2,k.$gL),qe(3,A.$li)],p)}),define(Fe[115],Le([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$$J=e.$0J=void 0;class S{constructor(R,g){this.line=R,this.character=g}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,g){return new S(0,0)}with(R){return new S(0,0)}}e.$0J=S;class F{constructor(R,g,f,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,g),this.end=new S(f,D)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$$J=F;var P;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Fe[44],Le([1,0,18,34,26,45,13,4,19,15,115,11]),function(fe,e,S,F,P,L,R,g,f,D,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.SearchErrorCode=e.$nK=e.$mK=e.SearchSortOrder=e.ViewMode=e.$lK=e.$kK=e.$jK=e.$iK=e.SearchCompletionExitCode=e.$hK=e.$gK=e.$fK=e.QueryType=e.SearchProviderType=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$_J="workbench.view.search",e.$aK="workbench.panel.search",e.$bK="workbench.view.search",e.$cK="search-result",e.$dK="search.exclude";const h="\u27EA ",v=" characters skipped \u27EB",p=(h.length+v.length+5)*2;e.$eK=(0,g.$ci)("searchService");var s;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(s||(e.SearchProviderType=s={}));var u;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(u||(e.QueryType=u={}));function r(he){return!!he.preview}e.$fK=r;function i(he){return!!he.resource}e.$gK=i;function n(he){return!!he.message}e.$hK=n;var o;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor(ve){this.resource=ve,this.results=[]}}e.$iK=l;class t{constructor(ve,se,$e,te){this.ranges=se,this.webviewIndex=te;const Y=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&m(Y)){ve=(0,R.$Jf)(ve,$e.matchLines);let q="",ne=0,Pe=0;const Oe=Math.floor($e.charsPerLine/5),Re=[];for(const be of Y){const me=Math.max(be.startColumn-Oe,0),Q=be.startColumn+$e.charsPerLine;if(me>Pe+Oe+p){const x=h+(me-Pe)+v;q+=x+ve.slice(me,Q),ne+=me-(Pe+x.length)}else q+=ve.slice(Pe,Q);Re.push(new c(0,be.startColumn-ne,be.endColumn-ne)),Pe=Q}this.preview={text:q,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const q=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ne=>new a(ne.startLineNumber-q,ne.startColumn,ne.endLineNumber-q,ne.endColumn))}}}}e.$jK=t;function m(he){const ve=he[0].startLineNumber;for(const se of he)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class a{constructor(ve,se,$e,te){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=te}}e.$kK=a;class c extends a{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$lK=c;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var y;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function $(he,ve=!0){const se=he&&he.files&&he.files.exclude,$e=ve&&he&&he.search&&he.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let te=Object.create(null);return te=P.$In(te,P.$Fn(se)),te=P.$In(te,P.$Fn($e),!0),te}e.$mK=$;function I(he,ve){return he.excludePattern&&F.$Uj(he.excludePattern,ve)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&F.$Uj(he.includePattern,ve)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(se=>{const $e=se.folder.fsPath;if(L.$dg(ve,$e)){const te=f.$lc($e,ve);return!se.includePattern||!!F.$Uj(se.includePattern,te)}else return!1}):!1:!0}e.$nK=I;var d;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(d||(e.SearchErrorCode=d={}));class w extends Error{constructor(ve,se){super(ve),this.code=se}}e.$oK=w;function b(he){const ve=he.message;if((0,D.$4)(he))return new w(ve,d.canceled);try{const se=JSON.parse(ve);return new w(se.message,se.code)}catch{return new w(ve,d.other)}}e.$pK=b;function M(he){const ve={message:he.message,code:he.code};return new Error(JSON.stringify(ve))}e.$qK=M;function T(he){return he.type==="error"?!0:he.type==="success"}e.$rK=T;function G(he){return he.type==="success"}e.$sK=G;function W(he){return!!he.path}e.$tK=W;function U(he,ve,se=!0){const $e=he.searchPath?he.searchPath:he.relativePath;return se?(0,R.$Gf)($e,ve):F.$Uj(ve,$e)}e.$uK=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$vK=C;function O(he,ve){const se={...he||{},...ve||{}};return Object.keys(se).filter($e=>{const te=se[$e];return typeof te=="boolean"&&te})}e.$wK=O;class V{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=F.$Vj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=F.$Vj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const te=this.b(ve,se,$e),Y=()=>this.c?!!this.c(ve,se,$e):!0;return(0,k.$1g)(te)?te.then(q=>q?!1:Y()):Y()}hasSiblingExcludeClauses(){return re(this.a)}}e.$xK=V;function re(he){for(const ve in he)if(typeof he[ve]!="boolean")return!0;return!1}function ce(he){if(!he)return;let ve;return se=>(ve||(ve=(he()||Promise.resolve([])).then($e=>$e?ke($e):{})),ve.then($e=>!!$e[se]))}e.$yK=ce;function ye(he){if(!he)return;let ve;return se=>{if(!ve){const $e=he();ve=$e?ke($e):{}}return!!ve[se]}}e.$zK=ye;function ke(he){const ve={};for(const se of he)ve[se]=!0;return ve}}),define(Fe[36],Le([1,0,18,11,21,5,6,51,12,123,25,13,2,170,4,14,189,48,43,27,17,8,7,58,44,3,52]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m,a,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=e.$phc=void 0;function y(G,W,U){return new A.$Eg(C=>w(C,U)).isEqual(G,W)}function $(G,W,U){return y(G.uri,W.uri,U)?0:(0,k.$af)(G.uri.toString(),W.uri.toString())}function I(G,W,U){return G.index!==W.index?G.index<W.index?-1:1:y(G.uri,W.uri,U)?(0,k.$af)(G.name,W.name):(0,k.$af)(G.uri.toString(),W.uri.toString())}function d(G,W,U,C){const O=G.slice(0).sort((re,ce)=>U(re,ce,C)),V=W.slice(0).sort((re,ce)=>U(re,ce,C));return(0,S.$Eb)(O,V,(re,ce)=>U(re,ce,C))}function w(G,W){const U=W.getCapabilities(G.scheme);return!(U&&U&1024)}class b extends r.$vi{static toExtHostWorkspace(W,U,C,O){if(!W)return{workspace:null,added:[],removed:[]};const{id:V,name:re,folders:ce,configuration:ye,transient:ke,isUntitled:he}=W,ve=[],se=U;U?ce.forEach((q,ne)=>{const Pe=h.URI.revive(q.uri),Oe=b.o(C||U,Pe,O);Oe?(Oe.name=q.name,Oe.index=q.index,ve.push(Oe)):ve.push({uri:Pe,name:q.name,index:ne})}):ve.push(...ce.map(({uri:q,name:ne,index:Pe})=>({uri:h.URI.revive(q),name:ne,index:Pe}))),ve.sort((q,ne)=>q.index<ne.index?-1:1);const $e=new b(V,re,ve,!!ke,ye?h.URI.revive(ye):null,!!he,q=>w(q,O)),{added:te,removed:Y}=d(se?se.workspaceFolders:[],$e.workspaceFolders,$,O);return{workspace:$e,added:te,removed:Y}}static o(W,U,C){for(let O=0;O<W.folders.length;O++){const V=W.workspaceFolders[O];if(y(V.uri,U,C))return V}}constructor(W,U,C,O,V,re,ce){super(W,C.map(ye=>new r.$wi(ye)),O,V,ce),this.t=U,this.u=re,this.q=[],this.s=g.$ii.forUris(ce),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,A.$Og)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let M=class{constructor(W,U,C,O,V){this.c=new L.$3d,this.onDidChangeWorkspace=this.c.event,this.g=new L.$3d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new L.$5d,this.C=new Map,this.h=O,this.s=C,this.t=V,this.j=new D.$fm,this.k=new F.$bh,this.o=W.getProxy(c.$VL.MainThreadWorkspace),this.q=W.getProxy(c.$VL.MainThreadMessageService);const re=U.workspace;this.l=re?new b(re.id,re.name,[],!!re.transient,re.configuration?h.URI.revive(re.configuration):null,!!re.isUntitled,ce=>w(ce,C)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?h.URI.from({scheme:f.Schemas.untitled,path:(0,A.$Mg)((0,A.$Og)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,C,...O){const V=[];if(Array.isArray(O)&&O.forEach(he=>{h.URI.isUri(he.uri)&&!V.some(ve=>y(ve.uri,he.uri,this.s))&&V.push({uri:he.uri,name:he.name||(0,A.$Lg)(he.uri)})}),this.n||[U,C].some(he=>typeof he!="number"||he<0)||C===0&&V.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ce=re.slice(0);ce.splice(U,C,...V.map(he=>({uri:he.uri,name:he.name||(0,A.$Lg)(he.uri),index:void 0})));for(let he=0;he<ce.length;he++){const ve=ce[he];if(ce.some((se,$e)=>$e!==he&&y(ve.uri,se.uri,this.s)))return!1}ce.forEach((he,ve)=>he.index=ve);const{added:ye,removed:ke}=d(re,ce,I,this.s);if(ye.length===0&&ke.length===0)return!1;if(this.o){const he=W.displayName||W.name;this.o.$updateWorkspaceFolders(he,U,C,V).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(u.Severity.Error,(0,v.localize)(0,null,he,ve.toString()),se,[])})}return this.y(ce),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let C,O="";if(typeof W=="string"?(C=h.URI.file(W),O=W):typeof W<"u"&&(C=W,O=W.fsPath),!C)return O;const V=this.getWorkspaceFolder(C,!0);if(!V)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,A.$Rg)(V.uri,C);return U&&V.name&&(re=`${V.name}/${re}`),re}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:C,removed:O}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:O}))}findFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let re="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(W,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},V)}findFiles2(W,U={},C,O=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,W,U,O)}async z(W,U,C,O=P.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const V=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:V,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ye,folder:ke}=T(l.GlobPattern.from(W));ce=ke,re.includePattern=ye}else{const{includePattern:ye,folder:ke}=T(l.GlobPattern.from(U));ce=ke,re.filePattern=ye}return this.o.$startFileSearch(ce??null,re,O).then(ye=>Array.isArray(ye)?ye.map(ke=>h.URI.revive(ke)):[])}async findTextInFiles(W,U,C,O,V=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:ke}=T(l.GlobPattern.from(U.include)),he=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:he},se=!1;if(this.u[re]=$e=>{if(se)return;const te=h.URI.revive($e.resource);$e.results.forEach(Y=>{const q=(0,E.$Lh)(Y);(0,a.$fK)(q)?C({uri:te,preview:{text:q.preview.text,matches:(0,S.$2b)(q.preview.matches,ne=>new t.$ZL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,S.$2b)(q.ranges,ne=>new t.$ZL(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:te,text:q.text,lineNumber:q.lineNumber})})},V.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(W,ke??null,ve,re,V);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return h.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return h.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,C),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const C=await this.resolveWorkspaceFolder(h.URI.revive(W));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const O=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!O),!O)return;const V=await O.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",V),!!V)return V}async $provideEditSessionIdentityMatch(W,U,C,O){this.h.info("Getting edit session identifier for workspaceFolder",W);const V=await this.resolveWorkspaceFolder(h.URI.revive(W));if(!V){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",V);const re=this.w.get(V.uri.scheme);if(this.h.info(`Provider for scheme ${V.uri.scheme} is defined: `,!!re),!re)return;const ce=await re.provideEditSessionIdentityMatch?.(U,C,O);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(U,C,O)=>{const V=function(ce){U.call(C,ce)};return V.extension=W,this.B.event(V,void 0,O)}}async $onWillCreateEditSessionIdentity(W,U,C){const O=await this.resolveWorkspaceFolder(h.URI.revive(W));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},U,async(V,re)=>{const ce=Date.now();await Promise.resolve(V),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerCanonicalUriProvider(O,C),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(W,U,C){const O=this.C.get(W.scheme);if(!O)return;const V=await O.provideCanonicalUri?.(h.URI.revive(W),U,C);if(V)return V}async $provideCanonicalUri(W,U,C){return this.provideCanonicalUri(h.URI.revive(W),{targetScheme:U},C)}};e.$phc=M,e.$phc=M=Je([qe(0,o.$aO),qe(1,n.$qO),qe(2,i.$0gc),qe(3,s.$wj),qe(4,m.$nhc)],M),e.$qhc=(0,p.$ci)("IExtHostWorkspace");function T(G){let W,U;return G&&(typeof G=="string"?W=G:(W=G.pattern,U=h.URI.revive(G.baseUri))),{includePattern:W,folder:U}}}),define(Fe[37],Le([1,0,26,5,36,3,7,191,55,16,11,4,17,14,2]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$thc=e.$shc=e.$rhc=void 0;function s(m,a){if(a){const c=a.split(".");let E=m;for(let y=0;E&&y<c.length;y++)E=E[c[y]];return E}}function u(m){return m instanceof p.URI}function r(m){return m&&m.uri instanceof p.URI&&m.languageId&&typeof m.languageId=="string"}function i(m){return m&&!m.uri&&m.languageId&&typeof m.languageId=="string"}function n(m){return m&&m.uri instanceof p.URI&&(!m.name||typeof m.name=="string")&&(!m.index||typeof m.index=="number")}function o(m){if(u(m))return{resource:m};if(r(m))return{resource:m.uri,overrideIdentifier:m.languageId};if(i(m))return{overrideIdentifier:m.languageId};if(n(m))return{resource:m.uri};if(m===null)return{resource:null}}let l=class{constructor(a,c,E){this.a=a.getProxy(L.$VL.MainThreadConfiguration),this.c=c,this.b=E,this.d=new A.$bh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new t(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,c){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(a,c))}};e.$rhc=l,e.$rhc=l=Je([qe(0,h.$aO),qe(1,P.$qhc),qe(2,v.$wj)],l);class t{constructor(a,c,E,y){this.a=new F.$3d,this.b=a,this.f=y,this.c=c,this.e=g.$do.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,c){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$do.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(c,E))}getConfiguration(a,c,E){const y=o(c)||{},$=this.g(a?s(this.e.getValue(void 0,y,this.c.workspace),a):this.e.getValue(void 0,y,this.c.workspace));a&&this.h(a,y,E?.identifier);function I(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(w){return typeof s($,w)<"u"},get:(w,b)=>{this.h(a?`${a}.${w}`:w,y,E?.identifier);let M=s($,w);if(typeof M>"u")M=b;else{let T;const G=(W,U)=>{if((0,D.$Sf)(W)){let C;const O=()=>{T=T||(0,S.$Fn)($),C=C||s(T,U)};return new Proxy(W,{get:(V,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return O(),()=>C;if(T)return C=C||s(T,U),C[re];const ce=V[re];return typeof re=="string"?G(ce,`${U}.${re}`):ce},set:(V,re,ce)=>(O(),C&&(C[re]=ce),!0),deleteProperty:(V,re)=>(O(),C&&delete C[re],!0),defineProperty:(V,re,ce)=>(O(),C&&Object.defineProperty(C,re,ce),!0)})}return Array.isArray(W)?(0,S.$Fn)(W):W};M=G(M,w)}return M},update:(w,b,M,T)=>{w=a?`${a}.${w}`:w;const G=I(M);return b!==void 0?this.b.$updateConfigurationOption(G,w,b,y,T):this.b.$removeConfigurationOption(G,w,y,T)},inspect:w=>{w=a?`${a}.${w}`:w;const b=this.e.inspect(w,y,this.c.workspace);if(b)return{key:w,defaultValue:(0,S.$Fn)(b.policy?.value??b.default?.value),globalValue:(0,S.$Fn)(b.user?.value??b.application?.value),workspaceValue:(0,S.$Fn)(b.workspace?.value),workspaceFolderValue:(0,S.$Fn)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.$Fn)(b.default?.override),globalLanguageValue:(0,S.$Fn)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.$Fn)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.$Fn)(b.workspaceFolder?.override),languageIds:(0,S.$Fn)(b.overrideIdentifiers)}}};return typeof $=="object"&&(0,S.$In)(d,$,!1),Object.freeze(d)}g(a){const c=E=>(0,D.$Sf)(E)?new Proxy(E,{get:(y,$)=>c(y[$]),set:(y,$,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(y,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(y,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:y=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return c(a)}h(a,c,E){const y=f.$7n.test(a)?4:this.d.get(a),$=E?`[${E.value}] `:"";if(y===4){typeof c?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(y===3){c?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,c){const E=new g.$fo(a,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(y,$)=>E.affectsConfiguration(y,o($))})}k(a){return a.reduce((c,E)=>(c.set(E[0],E[1]),c),new Map)}}e.$shc=t,e.$thc=(0,k.$ci)("IExtHostConfiguration")}),define(Fe[116],Le([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,14,78,223,15]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=e.$Vic=e.$Uic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(l||(l={}));var t;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(t||(t={}));var m;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(m||(m={}));var a;(function(G){function W(O){if(O){const V=O;return V&&!!V.process}else return!1}G.is=W;function U(O){if(O==null)return;const V={process:O.process,args:O.args};return O.options&&(V.options=m.from(O.options)),V}G.from=U;function C(O){if(O!=null)return new R.$GM(O.process,O.args,O.options)}G.to=C})(a||(a={}));var c;(function(G){function W(C){if(C!=null)return C}G.from=W;function U(C){if(C!=null)return C}G.to=U})(c||(c={}));var E;(function(G){function W(O){if(O){const V=O;return V&&(!!V.commandLine||!!V.command)}else return!1}G.is=W;function U(O){if(O==null)return;const V={};return O.commandLine!==void 0?V.commandLine=O.commandLine:(V.command=O.command,V.args=O.args),O.options&&(V.options=c.from(O.options)),V}G.from=U;function C(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$HM(O.commandLine,O.options):new R.$HM(O.command,O.args?O.args:[],O.options)}G.to=C})(E||(E={}));var y;(function(G){function W(O){if(O){const V=O;return V&&V.customExecution==="customExecution"}else return!1}G.is=W;function U(O){return{customExecution:"customExecution"}}G.from=U;function C(O,V){return V.get(O)}G.to=C})(y||(e.CustomExecutionDTO=y={}));var $;(function(G){function W(U,C){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?O=C.workspaceFile:O=n.$$G),{id:U._id,workspaceFolder:O}}G.from=W})($||(e.TaskHandleDTO=$={}));var I;(function(G){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}G.from=W})(I||(I={}));var d;(function(G){function W(O,V){if(O==null)return[];const re=[];for(const ce of O){const ye=U(ce,V);ye&&re.push(ye)}return re}G.fromMany=W;function U(O,V){if(O==null)return;let re;O.execution instanceof R.$GM?re=a.from(O.execution):O.execution instanceof R.$HM?re=E.from(O.execution):O.execution&&O.execution instanceof R.$IM&&(re=y.from(O.execution));const ce=l.from(O.definition);let ye;return O.scope?typeof O.scope=="number"?ye=O.scope:ye=O.scope.uri:ye=R.TaskScope.Workspace,!ce||!ye?void 0:{_id:O._id,definition:ce,name:O.name,source:{extensionId:V.identifier.value,label:O.source,scope:ye},execution:re,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}G.from=U;async function C(O,V,re){if(O==null)return;let ce;a.is(O.execution)?ce=a.to(O.execution):E.is(O.execution)?ce=E.to(O.execution):y.is(O.execution)&&(ce=y.to(O._id,re));const ye=l.to(O.definition);let ke;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ke=O.source.scope:ke=await V.resolveWorkspaceFolder(S.URI.revive(O.source.scope)):ke=R.TaskScope.Workspace),!ye||!ke)return;const he=new R.$JM(ye,ke,O.name,O.source.label,ce,O.problemMatchers);return O.isBackground!==void 0&&(he.isBackground=O.isBackground),O.group!==void 0&&(he.group=R.$FM.from(O.group._id),he.group&&O.group.isDefault&&(he.group=new R.$FM(he.group.id,he.group.label),O.group.isDefault===!0&&(he.group.isDefault=O.group.isDefault))),O.presentationOptions&&(he.presentationOptions=t.to(O.presentationOptions)),O._id&&(he._id=O._id),O.detail&&(he.detail=O.detail),he}G.to=C})(d||(e.TaskDTO=d={}));var w;(function(G){function W(C){return C}G.from=W;function U(C){if(C)return Object.assign(Object.create(null),C)}G.to=U})(w||(w={}));class b{#e;constructor(W,U,C){this._id=U,this.a=C,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let M=class{constructor(W,U,C,O,V,re,ce,ye){this.q=new P.$3d,this.r=new P.$3d,this.s=new P.$3d,this.u=new P.$3d,this.a=W.getProxy(L.$VL.MainThreadTask),this.b=C,this.c=O,this.d=V,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,C){if(!C)return new R.$XL(()=>{});const O=this.x();return this.j.set(O,{type:U,provider:C,extension:W}),this.a.$registerTaskProvider(O,U),new R.$XL(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(w.from(W)).then(async U=>{const C=[];for(const O of U){const V=await d.to(O,this.b,this.m);V&&C.push(V)}return C})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,C){const O=this.m.get(W.id);O&&(this.o.set(W.id,O),this.e.attachPtyToTerminal(U,await O.callback(C))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));const O=[],V=(0,F.$7g)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(re=>this.v(U,O,C,re));return new Promise(re=>{V.then(ce=>{Promise.all(O).then(()=>{re(ce)})})})}async $resolveTask(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const O=await d.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const V=await C.provider.resolveTask(O,A.CancellationToken.None);if(!V)return;this.A(V,C);const re=d.from(V,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(re.execution)&&await this.y(re,V,!0),await this.w(re)}x(){return this.h++}async y(W,U,C){const O=await this.a.$createTaskId(W);!C&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async z(W,U){if(typeof W=="string"){const V=this.l.get(W);if(!V)throw new o.$bb("Unexpected: The specified task is missing an execution");return V}const C=this.l.get(W.id);if(C)return C;let O;return U?O=Promise.resolve(new b(this,W.id,U)):O=d.to(W.task,this.b,this.m).then(V=>{if(!V)throw new o.$bb("Unexpected: Task does not exist.");return new b(this,W.id,V)}),this.l.set(W.id,O),O.then(V=>(this.k.set(W.id,V),V))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const C=this.n.values();let O=C.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=C.next()}};e.$Uic=M,e.$Uic=M=Je([qe(0,h.$aO),qe(1,v.$qO),qe(2,g.$qhc),qe(3,f.$lO),qe(4,D.$thc),qe(5,k.$Rhc),qe(6,r.$wj),qe(7,i.$6gc)],M);let T=class extends M{constructor(W,U,C,O,V,re,ce,ye){super(W,U,C,O,V,re,ce,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:u.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=d.from(U,W);if(C===void 0)throw new Error("Task is not valid");if(y.is(C.execution))await this.y(C,U,!1);else throw new o.$_;const O=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(V=>{throw new Error(V)}),O}v(W,U,C,O){const V=[];if(O)for(const re of O){if(this.A(re,C),!re.definition||!W[re.definition.type]){const ye=re.source?re.source:"No task source";this.f.warn(`The task [${ye}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=d.from(re,C.extension);ce&&y.is(ce.execution)?(V.push(ce),U.push(this.y(ce,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:C.extension}}async w(W){if(y.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,C){}};e.$Vic=T,e.$Vic=T=Je([qe(0,h.$aO),qe(1,v.$qO),qe(2,g.$qhc),qe(3,f.$lO),qe(4,D.$thc),qe(5,k.$Rhc),qe(6,r.$wj),qe(7,i.$6gc)],T),e.$Wic=(0,p.$ci)("IExtHostTask")}),define(Fe[285],Le([1,0,44,29]),function(fe,e,S,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=e.$FK=void 0;function P(R){return"cellResults"in R}e.$FK=P,e.$GK="rawCell#";function L(R,g){let f=-1;const D=[];let A=[];return R.forEach(h=>{h.range.startLineNumber!==f&&A.length>0&&(D.push([...A]),A=[]),A.push(h),f=h.range.endLineNumber}),A.length>0&&D.push([...A]),D.map(h=>{const v=[],p=h[0].range.startLineNumber,s=h[h.length-1].range.endLineNumber;for(let u=p;u<=s;u++)v.push(g.getLineContent(u));return new S.$jK(v.join(`
`)+`
`,h.map(u=>new F.$4s(u.range.startLineNumber-1,u.range.startColumn-1,u.range.endLineNumber-1,u.range.endColumn-1)))})}e.$HK=L}),define(Fe[286],Le([1,0,164,24,5,6,28,13,16,2,42,74,3,31,8,7,50,261,110,26,12,213,285,283]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(E=>E.apiEditor)}constructor(E,y,$,I,d,w){this.q=$,this.r=I,this.s=d,this.t=w,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$3d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$3d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$3d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$3d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$4gc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=E.getProxy(h.$VL.MainThreadNotebook),this.c=E.getProxy(h.$VL.MainThreadNotebookDocuments),this.d=E.getProxy(h.$VL.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const M=b.notebookEditor?.notebookUri,T=b.cell.handle,W=this.g.get(M)?.getCell(T);if(W)return W.apiCell}if(b&&b.$mid===14){const M=b.uri,T=this.g.get(M);if(T)return T.apiNotebook}return b}}),a.B(y)}getEditorById(E){const y=this.h.get(E);if(!y)throw new Error(`unknown text editor: ${E}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(E){for(const[y,$]of this.h)if($.apiEditor===E)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(E,y){const $=this.g.get(E);if(!$&&!y)throw new Error(`NO notebook document for '${E}'`);return $}static u(E,y){if(!y)return;const $=y.filenamePattern.map(I=>p.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(y.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:E.identifier,providerDisplayName:E.displayName||E.name,displayName:y.displayName,filenamePattern:$,exclusive:y.exclusive||!1}}registerNotebookCellStatusBarItemProvider(E,y,$){const I=a.a++,d=typeof $.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(I,$),this.b.$registerNotebookCellStatusBarItemProvider(I,d,y);let w;return d!==void 0&&(w=$.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(d))),new s.$XL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,d),w?.dispose()})}async createNotebookDocument(E){const y=await this.c.$tryCreateNotebook({viewType:E.viewType,content:E.content&&p.NotebookData.from(E.content)});return D.URI.revive(y)}async openNotebookDocument(E){const y=this.g.get(E);if(y)return y.apiNotebook;const $=await this.c.$tryOpenNotebook(E),I=this.g.get(D.URI.revive($));return(0,f.$2f)(I?.apiNotebook)}async showNotebookDocument(E,y){D.URI.isUri(E)&&(E=await this.openNotebookDocument(E));let $;typeof y=="object"?$={position:p.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(p.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:$={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(E.uri,E.notebookType,$),d=I&&this.h.get(I)?.apiEditor;if(d)return d;throw I?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(E,y,$,I){const d=this.f.get(E),w=D.URI.revive(y),b=this.g.get(w);if(!b||!d)return;const M=b.getCellFromIndex($);if(!M)return;const T=await d.provideCellStatusBarItems(M.apiCell,I);if(!T)return;const G=new L.$Sc,W=this.p.add([G]),C=(Array.isArray(T)?T:[T]).map(O=>p.NotebookStatusBarItem.from(O,this.i,G));return{cacheId:W,items:C}}$releaseNotebookCellStatusBarItems(E){this.p.delete(E)}registerNotebookSerializer(E,y,$,I,d){if((0,g.$Qe)(y))throw new Error("viewType cannot be empty or just whitespace");const w=this.w++;return this.x.set(w,{viewType:y,serializer:$,options:I}),this.b.$registerNotebookSerializer(w,{id:E.identifier,location:E.extensionLocation},y,p.NotebookDocumentContentOptions.from(I),a.u(E,d)),(0,L.$Rc)(()=>{this.b.$unregisterNotebookSerializer(w)})}async $dataToNotebook(E,y,$){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.deserializeNotebook(y.buffer,$);return new u.$3v(p.NotebookData.from(d))}async $notebookToData(E,y,$){const I=this.x.get(E);if(!I)throw new Error("NO serializer found");const d=await I.serializer.serializeNotebook(p.NotebookData.to(y.value),$);return F.$qe.wrap(d)}async $saveNotebook(E,y,$,I,d){const w=D.URI.revive(y),b=this.x.get(E);if(!b)throw new Error("NO serializer found");const M=this.g.get(w);if(!M)throw new Error("Document NOT found");if(M.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(w.scheme))throw new A.$Uk((0,S.localize)(0,null,this.z(w)),6);await this.y(w,I);const T={metadata:(0,n.$Nn)(M.apiNotebook.metadata,O=>!(b.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of M.apiNotebook.getCells()){const V=new s.$mN(O.kind,O.document.getText(),O.document.languageId,O.mime,b.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);V.metadata=(0,n.$Nn)(O.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),T.cells.push(V)}const G=await b.serializer.serializeNotebook(T,d);await this.s.value.writeFile(w,G);const W=this.s.getFileSystemProviderExtUri(w.scheme),U=await this.s.value.stat(w);return{name:W.basename(w),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(w.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$6k({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(E,y,$,I,d){const w=this.x.get(E)?.serializer;if(!w)return{limitHit:!1,results:[]};const b=new R.$Bc;await(async(U,C,O)=>{await Promise.all(U.map(async V=>await Promise.all(V.filenamePatterns.map(re=>{const ce={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ce,C,ye=>{ye.forEach(ke=>{b.has(ke)||I.some(ve=>V.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,m.$Beb)(se,ke)))||b.add(ke)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})($,d,y);const T=new R.$Ac;let G=!1;const W=Array.from(b).map(async U=>{const C=[];try{if(d.isCancellationRequested)return;if(y.maxResults&&[...T.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>y.maxResults){G=!0;return}const O=[],V=this.g.get(U);if(V)V.apiNotebook.getCells().forEach(ye=>O.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(ke=>ke.items.map(he=>he.data.toString()))}));else{const ce=await this.s.value.readFile(U),ye=F.$qe.fromString(ce.toString()),ke=await w.deserializeNotebook(ye.buffer,d);if(d.isCancellationRequested)return;p.NotebookData.from(ke).cells.forEach(ve=>O.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(d.isCancellationRequested)return;O.forEach((ce,ye)=>{const ke=y.contentPattern.pattern,he=new l.$ASb(ce.input,void 0,ce.outputs),ve=he.findInInputs(ke),se=he.findInOutputs(ke),$e=se.flatMap(te=>(0,t.$HK)(te.matches,te.textBuffer)).map((te,Y)=>(te.webviewIndex=Y,te));if(ve.length>0||se.length>0){const te={index:ye,contentResults:(0,t.$HK)(ve,he.inputTextBuffer),webviewResults:$e};C.push(te)}});const re={resource:U,cellResults:C};T.set(U,re);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...T.values()]}}async y(E,y){const $=await this.s.value.stat(E);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==A.$5k&&typeof $.mtime=="number"&&typeof $.size=="number"&&y.mtime<$.mtime&&y.etag!==A.$6k({mtime:y.mtime,size:$.size}))throw new A.$Uk((0,S.localize)(1,null),3,y)}z(E){return E.scheme===o.Schemas.file?E.fsPath:E.toString()}A(E,y,$){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const I=new i.$nic(y,this.d,E,$.visibleRanges.map(p.NotebookRange.to),$.selections.map(p.NotebookRange.to),typeof $.viewColumn=="number"?p.ViewColumn.to($.viewColumn):void 0);this.h.set(y,I)}$acceptDocumentAndEditorsDelta(E){if(E.value.removedDocuments)for(const $ of E.value.removedDocuments){const I=D.URI.revive($),d=this.g.get(I);d&&(d.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:d.apiNotebook.getCells().map(w=>w.document.uri)}),this.n.fire(d.apiNotebook));for(const w of this.h.values())w.notebookData.uri.toString()===I.toString()&&this.h.delete(w.id)}if(E.value.addedDocuments){const $=[];for(const I of E.value.addedDocuments){const d=D.URI.revive(I.uri);if(this.g.has(d))throw new Error(`adding EXISTING notebook ${d} `);const w=new r.$mic(this.c,this.q,this.r,d,I);$.push(...I.cells.map(b=>r.$lic.asModelAddData(w.apiNotebook,b))),this.g.get(d)?.dispose(),this.g.set(d,w),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(w.apiNotebook)}}if(E.value.addedEditors)for(const $ of E.value.addedEditors){if(this.h.has($.id))return;const I=D.URI.revive($.documentUri),d=this.g.get(I);d&&this.A(d,$.id,$)}const y=[];if(E.value.removedEditors)for(const $ of E.value.removedEditors){const I=this.h.get($);I&&(this.h.delete($),this.k?.id===I.id&&(this.k=void 0),y.push(I))}if(E.value.visibleEditors){this.l=E.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const $=new Set;this.l.forEach(I=>$.add(I.id));for(const I of this.h.values()){const d=$.has(I.id);I._acceptVisibility(d)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}E.value.newActiveEditor===null?this.k=void 0:E.value.newActiveEditor&&(this.h.get(E.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${E.value.newActiveEditor}`),this.k=this.h.get(E.value.newActiveEditor)),E.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(E){const y=v.$yO.String.with("notebookType","A notebook type"),$=new v.$AO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new v.$yO("data","Bytes to convert to data",d=>d instanceof Uint8Array,d=>F.$qe.wrap(d))],new v.$zO("Notebook Data",d=>p.NotebookData.to(d.value))),I=new v.$AO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new v.$yO("NotebookData","Notebook data to convert to bytes",d=>!0,d=>new u.$3v(p.NotebookData.from(d)))],new v.$zO("Bytes",d=>d.buffer));E.registerApiCommand($),E.registerApiCommand(I)}}e.$wic=a}),define(Fe[287],Le([1,0,19,21,41,34,25,63,44]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class D{constructor(h,v,p){this.k=h,this.l=v,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=h.filePattern,this.b=h.includePattern&&L.$Vj(h.includePattern),this.c=h.maxResults||void 0,this.d=h.exists,this.h=new Set,this.j=h.excludePattern&&L.$Vj(h.excludePattern)}cancel(){this.g=!0,this.h.forEach(h=>h.cancel()),this.h=new Set}search(h){const v=this.k.folderQueries||[];return new Promise((p,s)=>{const u=r=>{this.f++,h(r)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const i=r.toString(),n=S.$nc(i);this.j&&this.j(i,n)||this.v(u,{base:r,basename:n})}),Promise.all(v.map(r=>this.p(r,u))).then(r=>{p({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,P.$Zi)(r)))})})}async p(h,v){const p=new F.$ae,s=this.q(h),u=this.r(),r=new f.$xK(this.k,h),i=!r.hasSiblingExcludeClauses();let n;try{this.h.add(p),n=g.$Yd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,p.token),l=n.elapsed(),t=g.$Yd.create();return this.g&&!this.e||(o&&o.forEach(m=>{const a=S.$gc.relative(h.folder.path,m.path);if(i){const c=S.$nc(m.path);this.v(v,{base:h.folder,relativePath:a,basename:c});return}this.s(u,h.folder,a,v)}),this.g&&!this.e)?null:(this.u(u,r,v),{providerTime:l,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(h){const v=(0,f.$wK)(this.k.includePattern,h.includePattern),p=(0,f.$wK)(this.k.excludePattern,h.excludePattern);return{folder:h.folder,excludes:p,includes:v,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}s({pathToEntries:h},v,p,s){if(p===this.a){const r=S.$nc(this.a);this.v(s,{base:v,relativePath:this.a,basename:r})}function u(r){const i=S.$nc(r),n=S.$mc(r);let o=h[n];o||(o=h[n]=[],u(n)),o.push({base:v,relativePath:r,basename:i})}u(p)}u({rootEntries:h,pathToEntries:v},p,s){const u=this,r=this.a;function i(n){const o=(0,f.$zK)(()=>n.map(l=>l.basename));for(let l=0,t=n.length;l<t;l++){const m=n[l],{relativePath:a,basename:c}=m;if(p.matchesExcludesSync(a,c,r!==c?o:void 0))continue;const E=v[a];if(E)i(E);else{if(a===r)continue;u.v(s,m)}if(u.e)break}}i(h)}v(h,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||h(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(h,v,p,s){const u=this.c(h.cacheKey),r=new D(h,v,u&&u.token);let i=0;const n=o=>{i+=o.length,p(o.map(l=>this.d(l)))};return this.e(r,A.a,n,s).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(h){this.c(h)?.cancel()}c(h){if(h)return this.b.has(h)||this.b.set(h,new F.$ae),this.b.get(h)}d(h){return h.relativePath?{resource:R.$Pg(h.base,h.relativePath)}:{resource:h.base}}e(h,v,p,s){const u=s.onCancellationRequested(()=>{h.cancel()}),r=n=>{n&&(i.push(n),v>0&&i.length>=v&&(p(i),i=[]))};let i=[];return h.search(r).then(n=>(i.length&&p(i),u.dispose(),n),n=>(i.length&&p(i),u.dispose(),Promise.reject(n)))}}e.$oic=A}),define(Fe[288],Le([1,0,18,256,34,94,28,12,19,25,13,16,2,93,181,47,14,48,105,284,44]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=void 0;let l=class{constructor(w,b,M,T,G){this.a=w,this.b=b,this.c=M,this.d=T,this.e=G}text(w,b,M={}){w=this.f(w,M);const T=this.a.getValue(),G=b&&b.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(b?.map(r.$xi),M),type:2,contentPattern:w,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:T.search.usePCRE2||G||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(w,b){const M=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const T={...w,wordSeparators:M.editor.wordSeparators};return this.j(w,b)&&(T.isCaseSensitive=!0),this.k(w)&&(T.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(T.notebookInfo||(T.notebookInfo={}),T.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),T}file(w,b={}){return{...this.h(w,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(w,b){return w?(w=Array.isArray(w)?w.map(E):E(w),b?this.parseSearchPaths(w):{pattern:m(...Array.isArray(w)?w:[w])}):{}}h(w=[],b={}){const M=this.g(b.includePattern,b.expandPatterns),T=this.g(b.excludePattern,b.expandPatterns),G=w.length>1,W=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(O=>this.q(O,b,T)):w.map(O=>this.r(O,b,T,G))).filter(O=>!!O),U={_reason:b._reason,folderQueries:W,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:T.pattern,includePattern:M.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const O=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const V=O.filter(ce=>(0,o.$nK)(U,ce.fsPath)),re=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=b.extraFileResources&&b.extraFileResources.filter(O=>(0,o.$nK)(U,O.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(w){const b=[],M=new R.$Ac,T={};let G=!1;return w.forEach(W=>{if(W.scheme===g.Schemas.walkThrough)return;if((0,D.$Tg)(W)){const C=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let O=M.get(C);O||(G=!0,O={folder:C,includePattern:{}},b.push(O),M.set(C,O));const V=f.$lc(C.fsPath,W.fsPath);(0,k.$2f)(O.includePattern)[V.replace(/\\/g,"/")]=!0}else W.fsPath&&(G=!0,T[W.fsPath]=!0)}),{folderQueries:b,includePattern:T,usingSearchPaths:!0,excludePattern:G?void 0:{"**/*":!0}}}j(w,b){if(b.isSmartCase){if(w.isRegExp){if(A.$Hf(w.pattern,!0))return!0}else if(A.$Hf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,v.$aC)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const b=re=>f.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),T=(Array.isArray(w)?w:a(w)).map(re=>{const ce=this.e.resolvedUserHome;return ce?(0,L.$8v)(re,ce.scheme===g.Schemas.file?ce.fsPath:ce.path):re}),G=F.$K(T,re=>b(re)?"searchPaths":"exprSegments"),W=(G.exprSegments||[]).map(re=>A.$2e(re,"/")).map(re=>A.$2e(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),c(re))),U={},C=this.m(G.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const O=S.$Rb(W),V=m(...O);return V&&(U.pattern=V),U}l(w,b){return b.disregardExcludeSettings?void 0:(0,o.$mK)(w,!b.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const b=w.flatMap(T=>{let{pathPortion:G,globPortion:W}=t(T);return W&&(W=y(W)),this.n(G).flatMap(C=>this.o(C,W))}),M=new Map;return b.forEach(T=>{const G=T.searchPath.toString(),W=M.get(G);W?T.pattern&&(W.pattern=W.pattern||{},W.pattern[T.pattern]=!0):M.set(G,{searchPath:T.searchPath,pattern:T.pattern?m(T.pattern):void 0})}),Array.from(M.values())}n(w){if(f.$ic(w)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==g.Schemas.file?[{searchPath:b[0].uri.with({path:w})}]:[{searchPath:h.URI.file(f.$hc(w))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(w=E(w),w.startsWith("../")||w===".."){const T=f.$gc.resolve(b.path,w);return[{searchPath:b.with({path:T})}]}const M=y(w);return[{searchPath:b,pattern:M}]}else{if(w==="./"||w===".\\")return[];{const b=w.replace(/^\.[\/\\]/,""),T=this.b.getWorkspace().folders.map(G=>{const W=b.match(new RegExp(`^${A.$Ve(G.name)}(?:/(.*)|$)`));return W?{match:W,folder:G}:null}).filter(k.$Yf);if(T.length)return T.map(G=>{const W=G.match[1];return{searchPath:G.folder.uri,pattern:W&&y(W)}});{const G=w.match(/\.[\/\\](.+)[\/\\]?/),W=G?G[1]:w,U=p.localize(0,null,W);throw new Error(U)}}}}o(w,b){const M=w.pattern&&b?`${w.pattern}/${b}`:w.pattern||b,T=[{searchPath:w.searchPath,pattern:M}];return M&&!M.endsWith("**")&&T.push({searchPath:w.searchPath,pattern:M+"/**"}),T}q(w,b,M){const T=this.r((0,r.$xi)(w.searchPath),b,M,!1);return T?{...T,includePattern:w.pattern}:null}r(w,b,M,T){let G;const W=h.URI.isUri(w)?w:w.uri;if(M.searchPaths){const re=M.searchPaths.filter(ce=>(0,D.$Ig)(ce.searchPath,W))[0];if(re&&!re.pattern)return null;re&&(G=re.pattern)}const U=this.a.getValue({resource:W}),O={...this.l(U,b)||{},...G||{}},V=h.URI.isUri(w)?(0,D.$Mg)(w):w.name;return{folder:W,folderName:T?V:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!U.search.followSymlinks}}};e.$zL=l,e.$zL=l=Je([qe(0,s.$Ii),qe(1,r.$li),qe(2,i.$hD),qe(3,u.$wj),qe(4,n.$xL)],l);function t(d){const w=d.match(/[\*\{\}\(\)\[\]\?]/);if(w){const b=w.index,M=d.substr(0,b).match(/[/|\\][^/\\]*$/);if(M){let T=d.substr(0,M.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:d.substr((M.index||0)+1)}}}return{pathPortion:d}}function m(...d){return d.length?d.reduce((w,b)=>(w[b]=!0,w),Object.create(null)):void 0}function a(d){return P.$Tj(d,",").map(w=>w.trim()).filter(w=>!!w.length)}function c(d){return[`**/${d}/**`,`**/${d}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function E(d){return d.replace(/\\/g,"/")}function y(d){return E(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(d){return d.replace(/([?*[\]])/g,"[$1]")}function I(d,w){d=S.$Mb(d,T=>T.toString());const b=[],M=w.getWorkspace();return d&&d.forEach(T=>{let G;if(w.getWorkbenchState()===2)G=(0,D.$Rg)(M.folders[0].uri,T),G&&G!=="."&&(G="./"+G);else{const W=w.getWorkspaceFolder(T);if(W){const U=W.name;if(M.folders.filter(O=>O.name===U).length===1){const O=(0,D.$Rg)(W.uri,T);O===""?G=`./${W.name}`:G=`./${W.name}/${O}`}else G=T.fsPath}}G&&b.push($(G))}),b}e.$AL=I}),define(Fe[289],Le([1,0,25,2,21,15,4,288,44,48,11]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ytb=e.$Xtb=void 0;const k=7e3;function h(u,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],o=[];for(const E of i)if(/^workspaceContains:/.test(E)){const y=E.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||u.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:l,resolve:t}=(0,A.$8g)(),m=E=>t({activationEvent:E}),a=Promise.all(n.map(E=>v(u,E,m))).then(()=>{}),c=p(u,r.identifier,o,m);return Promise.all([a,c]).then(()=>{t(void 0)}),l}e.$Xtb=h;async function v(u,r,i){for(const n of u.folders)if(await u.exists(S.$Pg(F.URI.revive(n),r))){i(`workspaceContains:${r}`);return}}async function p(u,r,i,n){if(i.length===0)return Promise.resolve(void 0);const o=new P.$ae,l=u.checkExists(u.folders,i,o.token),t=setTimeout(async()=>{o.cancel(),u.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},k);let m=!1;try{m=await l}catch(a){L.$4(a)||L.$1(a)}o.dispose(),clearTimeout(t),m&&n(`workspaceContains:${i.join(",")}`)}function s(u,r,i,n){const o=u.get(R.$bi),l=u.get(f.$eK),m=o.createInstance(g.$zL).file(r.map(a=>(0,D.$xi)(F.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return l.fileSearch(m,n).then(a=>!!a.limitHit,a=>L.$4(a)?!1:Promise.reject(a))}e.$Ytb=s}),define(Fe[38],Le([1,0,161,19,87,25,11,6,51,2,14,3,37,219,82,36,23,106,15,22,24,202,7,100,4,27,84,17,71,85,65,5,289,81,204,12,79,63,20,80]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m,a,c,E,y,$,I,d,w,b,M,T,G,W,U,C,O){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=e.$5hc=e.$4hc=e.$3hc=void 0,e.$3hc=(0,a.$ci)("IHostUtils");let re=V=class extends g.$Tc{constructor(Y,q,ne,Pe,Oe,Re,be,me,Q,x,le,de){super(),this.X=de,this.a=this.B(new w.$3d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=q,this.g=ne,this.f=be,this.j=Pe,this.m=Oe,this.s=Re,this.t=Q,this.u=x,this.w=le,this.y=this.g.getProxy(k.$VL.MainThreadWorkspace),this.z=this.g.getProxy(k.$VL.MainThreadTelemetry),this.C=this.g.getProxy(k.$VL.MainThreadExtensionService),this.D=new R.$bh,this.F=new R.$bh,this.G=new R.$bh,this.H=new R.$bh,this.I=new $e(this.f.extensions.activationEvents),this.L=new r.$68b(this.I,this.f.extensions.allExtensions);const Me=new n.$vm(this.f.extensions.myExtensions);this.J=new r.$68b(this.I,ve(this.L,Me)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new p.$Nhc(this.g,this.s),this.N=new M.$Vhc(this.g),this.O=me,this.h=Y.createChild(new $.$ai([p.$Ohc,this.M],[M.$Whc,this.N])),this.P=this.B(new v.$Mhc(this.J,this.L,{onExtensionActivationError:(ge,Se,Ce)=>{this.C.$onExtensionActivationError(ge,i.$3(Se),Ce)},actualActivateExtension:async(ge,Se)=>{if(r.$68b.isHostExtension(ge,this.J,this.L))return await this.C.$activateExtension(ge,Se),new v.$Lhc;const Ce=this.J.getExtensionDescription(ge);return this.db(Ce,Se)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){i.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Oe=>Oe.identifier).filter(Oe=>this.isActivated(Oe)).map(Oe=>this.cb(Oe))}catch{}await Promise.all(Y)}terminate(Y,q=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Pe=>{this.s.error(Pe)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$dh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${q}`):this.s.info(`Extension host exiting with code ${q}`),this.s.flush(),this.s.dispose(),this.c.exit(q)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const q=await this.C.$getExtension(Y);return q&&{...q,identifier:new n.$um(q.identifier.value),extensionLocation:D.URI.revive(q.extensionLocation)}}Z(Y,q){return this.P.activateByEvent(Y,q)}$(Y,q){return this.P.activateById(Y,q)}activateByIdWithErrors(Y,q){return this.$(Y,q).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===G.Schemas.file&&this.c.fsRealpath){const q=await this.c.fsRealpath(Y.fsPath);return D.URI.file(q)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new se(Y))),this.Q}async bb(Y){const q=f.$ii.forUris(ne=>L.$Gg.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.ub(ne)){const Pe=await this.ab(ne.extensionLocation);q.set(Pe,ne)}})),q}cb(Y){let q=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return q;const ne=this.P.getActivatedExtension(Y);if(!ne)return q;try{typeof ne.module.deactivate=="function"&&(q=Promise.resolve(ne.module.deactivate()).then(void 0,Pe=>(this.s.error(Pe),Promise.resolve(void 0))))}catch(Pe){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Pe)}try{(0,g.$Oc)(ne.subscriptions)}catch(Pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Pe)}return q}async db(Y,q){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,q).then(ne=>{const Pe=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Pe.codeLoadingTime,Pe.activateCallTime,Pe.activateResolvedTime,q),this.eb(Y,q,"success",Pe),ne},ne=>{throw this.eb(Y,q,"failure"),ne})}eb(Y,q,ne,Pe){const Oe=ye(Y,q);this.z.$publicLog2("extensionActivationTimes",{...Oe,...Pe||{},outcome:ne})}fb(Y,q){const ne=ye(Y,q);this.z.$publicLog2("activatePlugin",ne);const Pe=this.ub(Y);if(!Pe)return Promise.resolve(new v.$Khc(v.$Hhc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${q.startup}, activationEvent: '${q.activationEvent}'${Y.identifier.value!==q.extensionId.value?`, root cause: ${q.extensionId.value}`:""}`),this.s.flush();const Oe=new v.$Ihc(q.startup);return Promise.all([this.vb(Y,(0,L.$Pg)(Y.extensionLocation,Pe),Oe),this.gb(Y)]).then(Re=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),V.hb(this.s,Y.identifier,Re[0],Re[1],Oe))).then(Re=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Re))}gb(Y){const q=new l.$Qhc(Y,this.M),ne=new l.$Phc(Y.identifier.value,!1,this.M),Pe=new T.$Xhc(Y,this.N),Oe=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([q.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const be=this;let me,Q;const x=(0,u.$RF)(Y,"ipc")?this.f.messagePorts?.get(n.$um.toKey(Y.identifier)):void 0;return Object.freeze({globalState:q,workspaceState:ne,secrets:Pe,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(le){return F.$jc(Y.extensionLocation.fsPath,le)},get storagePath(){return be.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return be.O.globalValue(Y).fsPath},get logPath(){return F.$jc(be.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return D.URI.joinPath(be.f.logsLocation,Y.identifier.value)},get storageUri(){return be.O.workspaceValue(Y)},get globalStorageUri(){return be.O.globalValue(Y)},get extensionMode(){return Oe},get extension(){return me===void 0&&(me=new he(be,Y.identifier,Y,Re,!1)),me},get extensionRuntime(){return(0,u.$SF)(Y,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Q){if(!x)return;const le=w.Event.buffer(w.Event.fromDOMEventEmitter(x,"message",de=>de.data));x.start(),Q={onDidReceiveMessage:le,postMessage:x.postMessage.bind(x)}}return Q}})})}static hb(Y,q,ne,Pe,Oe){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Y,q,ne,Pe,Oe).then(Re=>new v.$Jhc(!1,null,Oe.build(),ne,Re,Pe.subscriptions))}static ib(Y,q,ne,Pe,Oe){if(typeof ne.activate=="function")try{Oe.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${q.value}`);const Re=typeof global=="object"?global:self,be=ne.activate.apply(Re,[Pe]);return Oe.activateCallStop(),Oe.activateResolveStart(),Promise.resolve(be).then(me=>(Oe.activateResolveStop(),me))}catch(Re){return Promise.reject(Re)}else return Promise.resolve(ne)}jb(Y,q){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:q}).then(void 0,ne=>{this.s.error(ne)})}kb(Y,q=0){const Pe=Date.now();(0,C.$B)(()=>{for(let Oe=q;Oe<Y.length;Oe+=1){const Re=Y[Oe];for(const be of Re.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-Pe>50){this.kb(Y,Oe);break}else this.jb(Re,be)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const q=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(q)this.kb(ne);else for(const Pe of ne)if(Pe.activationEvents)for(const Oe of Pe.activationEvents)Oe==="onStartupFinished"&&this.jb(Pe,Oe)})}mb(){const Y=this.Z("*",!0).then(void 0,Re=>{this.s.error(Re)});this.B(this.j.onDidChangeWorkspace(Re=>this.nb(Re.added)));const q=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(q),Pe=this.pb(),Oe=Promise.all([Pe,Y,ne]).then(()=>{});return Promise.race([Oe,(0,R.$dh)(1e4)]).then(()=>{this.lb()}),Oe}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(q=>this.ob(Y,q))).then(()=>{})}async ob(Y,q){if(this.isActivated(q.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Pe={logService:this.s,folders:Y.map(Re=>Re.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Re=>this.c.fsExists(Re.fsPath),checkExists:(Re,be,me)=>this.y.$checkExists(Re,be,me)},Oe=await(0,b.$Xtb)(Pe,q);if(Oe)return this.$(q.identifier,{startup:!0,extensionId:q.identifier,activationEvent:Oe.activationEvent}).then(void 0,Re=>this.s.error(Re))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:q}=this.f.environment;if(!Y||!q)throw new Error(S.localize(0,null));const ne=await this.vb(null,q,new v.$Ihc(!1));if(!ne||typeof ne.run!="function")throw new Error(S.localize(1,null,q.toString()));return new Promise((Pe,Oe)=>{const Re=(Q,x)=>{Q?(C.$t&&this.s.error("Test runner called back with error",Q),Oe(Q)):(C.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),Pe(typeof x=="number"&&x>0?1:0))},be=(0,L.$Dg)(q),me=ne.run(be,Re);me&&me.then&&me.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Pe(0)}).catch(Q=>{C.$t&&this.s.error("Test runner finished with error",Q),Oe(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$dh)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,q){return this.R[Y]=q,(0,g.$Rc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:q}=await this.sb(Y);return q?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const q=Y.indexOf("+");if(q===-1)throw new t.$4L("Not an authority that can be resolved!",m.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,q);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Y,q){const ne=U.$Yd.create(!1),Pe=()=>`[resolveAuthority(${(0,m.$il)(Y)},${q})][${ne.elapsed()}ms] `,Oe=K=>this.s.info(`${Pe()}${K}`),Re=K=>this.s.warn(`${Pe()}${K}`),be=(K,j=void 0)=>this.s.error(`${Pe()}${K}`,j),me=K=>{if(K instanceof t.$4L)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},Q=async K=>{Oe(`activating resolver for ${K}...`);const{resolver:j,authorityPrefix:H}=await this.sb(K);if(!j)throw be(`no resolver for ${H}`),new t.$4L(`No remote extension installed to resolve ${H}.`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:H,remoteAuthority:K}},x=Y.split(/@|%40/g).reverse();Oe(`activating remote resolvers ${x.join(" -> ")}`);let le;try{le=await Promise.all(x.map(Q)).catch(async K=>{if(!(K instanceof t.$4L)||K._code!==m.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Re(`resolving nested authorities failed: ${K.message}`),[await Q(Y)]})}catch(K){return me(K)}const de=new R.$nh;de.cancelAndSet(()=>Oe("waiting..."),1e3);let Me,ge;for(const[K,{authorityPrefix:j,resolver:H,remoteAuthority:Z}]of le.entries())try{if(K===le.length-1)Oe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${j}`),Me=await H.resolve(Z,{resolveAttempt:q,execServer:ge}),P.mark(`code/extHost/didResolveAuthorityOK/${j}`),Oe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$3L.isManagedResolvedAuthority(Me)?Me:void 0));else{if(Oe(`invoking resolveExecServer() for ${Z}`),P.mark(`code/extHost/willResolveExecServer/${j}`),ge=await H.resolveExecServer?.(Z,{resolveAttempt:q,execServer:ge}),!ge)throw new t.$4L(`Exec server was not available for ${Z}`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(oe){return P.mark(`code/extHost/didResolveAuthorityError/${j}`),be("returned an error",oe),de.dispose(),me(oe)}de.dispose();const Se={environmentTunnels:Me.environmentTunnels,features:Me.tunnelFeatures?{elevation:Me.tunnelFeatures.elevation,privacyOptions:Me.tunnelFeatures.privacyOptions,protocol:Me.tunnelFeatures.protocol===void 0?!0:Me.tunnelFeatures.protocol}:void 0},Ce={extensionHostEnv:Me.extensionHostEnv,isTrusted:Me.isTrusted,authenticationSession:Me.authenticationSessionForInitializingExtensions?{id:Me.authenticationSessionForInitializingExtensions.id,providerId:Me.authenticationSessionForInitializingExtensions.providerId}:void 0};Oe(`returned ${t.$3L.isManagedResolvedAuthority(Me)?"managed authority":`${Me.host}:${Me.port}`}`);let N;if(t.$3L.isManagedResolvedAuthority(Me)){const K=q;this.X.setFactory(K,Me.makeConnection),N={authority:Y,connectTo:new m.$fl(K),connectionToken:Me.connectionToken}}else N={authority:Y,connectTo:new m.$gl(Me.host,Me.port),connectionToken:Me.connectionToken};return{type:"ok",value:{authority:N,options:Ce,tunnelInformation:Se}}}async $getCanonicalURI(Y,q){this.s.info(`$getCanonicalURI invoked for authority (${(0,m.$il)(Y)})`);const{resolver:ne}=await this.sb(Y);if(!ne)return null;const Pe=D.URI.revive(q);if(typeof ne.getCanonicalURI>"u")return Pe;const Oe=await(0,R.$7g)(()=>ne.getCanonicalURI(Pe));return Oe||Pe}$startExtensionHost(Y){Y.toAdd.forEach(Pe=>Pe.extensionLocation=D.URI.revive(Pe.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ce(this.I,this.L,this.J,Y);return this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Y,q){return q===1?this.D.wait().then(ne=>this.Z(Y,!1)):this.G.wait().then(ne=>this.Z(Y,!1))}async $activate(Y,q){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,q),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Re=>Re.extensionLocation=D.URI.revive(Re.extensionLocation));const{globalRegistry:q,myExtensions:ne}=ce(this.I,this.L,this.J,Y),Pe=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Pe),this.L.set(q.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const q=o.$qe.alloc(Y),ne=Math.random()%256;for(let Pe=0;Pe<Y;Pe++)q.writeUInt8(ne,Pe);return q}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$4hc=re,e.$4hc=re=V=Je([qe(0,a.$bi),qe(1,e.$3hc),qe(2,y.$aO),qe(3,s.$qhc),qe(4,h.$thc),qe(5,A.$wj),qe(6,c.$qO),qe(7,E.$whc),qe(8,I.$Rzb),qe(9,d.$Rhc),qe(10,W.$Zhc),qe(11,O.$1hc)],re);function ce(te,Y,q,ne){te.addActivationEvents(ne.addActivationEvents);const Pe=new r.$68b(te,Y.getAllExtensionDescriptions());Pe.deltaExtensions(ne.toAdd,ne.toRemove);const Oe=new n.$vm(q.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of ne.myToRemove)Oe.delete(be);for(const be of ne.myToAdd)Oe.add(be);const Re=ve(Pe,Oe);return{globalRegistry:Pe,myExtensions:Re}}function ye(te,Y){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ke(te){return te.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$5hc=(0,a.$ci)("IExtHostExtensionService");class he{#e;#t;#i;constructor(Y,q,ne,Pe,Oe){this.#e=Y,this.#t=q,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=F.$hc((0,L.$Dg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Pe,this.isFromDifferentExtensionHost=Oe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$6hc=he;function ve(te,Y){return te.getAllExtensionDescriptions().filter(q=>Y.has(q.identifier))}class se{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$7hc=se;class $e{constructor(Y){this.a=new n.$wm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const q of Object.keys(Y))this.a.set(q,Y[q])}}}),define(Fe[290],Le([1,0,87,2,3,37,23,22,17,27,4,38,14,13]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let s=class{constructor(o,l,t,m,a,c,E){this.c=o,this.d=l,this.e=t,this.f=m,this.g=a,this.h=c,this.i=E,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new r(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$cjc=s,e.$cjc=s=Je([qe(2,A.$bi),qe(3,L.$thc),qe(4,k.$5hc),qe(5,D.$qO),qe(6,h.$wj)],s);let u=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&p.a.size){const l=(0,v.$Ve)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",m=`@${t}+\\/${t}+|${t}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${m})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,t,m,a]=l,c=p.a.get(m);if(c!==void 0)return console.warn(`${m} as been renamed to ${c}, please update your imports`),t+c+a}c(o){return o.replace(/\\/g,"/")}};u=p=Je([qe(0,D.$qO)],u);class r{constructor(o,l,t,m,a){this.c=o,this.d=l,this.e=t,this.f=m,this.g=a,this.nodeModuleName="vscode",this.a=new g.$wm}load(o,l){const t=this.d.findSubstr(l);if(t){let m=this.a.get(t.identifier);return m||(m=this.c(t,this.e,this.f),this.a.set(t.identifier,m)),m}if(!this.b){let m="";this.d.forEach((a,c)=>m+=`	${c} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${m}`),this.b=this.c(R.$MF,this.e,this.f)}return this.b}}let i=class{constructor(o,l,t){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$VL.MainThreadTelemetry);const m=t.getProxy(P.$VL.MainThreadWindow);this.c=(a,c)=>{const E=F.URI.parse(a);return c?this.g(a,c):E.scheme==="http"||E.scheme==="https"?m.$openUri(E,a,{allowTunneling:!0}):E.scheme==="mailto"||E.scheme===this.f?m.$openUri(E,a,{}):this.g(a,c)}}load(o,l,t){const m=this.e.findSubstr(l);return m&&(this.a=m.identifier.value,this.h()),this.b=t(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Je([qe(2,f.$aO)],i)}),define(Fe[117],Le([1,0,39,6,19,73,4,66,64,38,7,36,216,37]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0,e.$8hc=(0,R.$ci)("IExtHostVariableResolverProvider");class p extends h.$bP{constructor(r,i,n,o,l,t,m){function a(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const E=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof A.$GN||E.input instanceof A.$LN)return E.input.modified;if(E.input instanceof A.$FN||E.input instanceof A.$KN||E.input instanceof A.$IN)return E.input.uri}}}super({getFolderUri:c=>{const E=t.folders.filter(y=>y.name===c);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,E)=>l.getConfiguration(void 0,c).get(E),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=a();if(c)return P.$hc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=a();if(c){const E=i.getWorkspaceFolder(c);if(E)return P.$hc(E.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>r.getExtension(c)},void 0,m?Promise.resolve(m):void 0,Promise.resolve(L.env))}}let s=class extends F.$Tc{constructor(r,i,n,o,l){super(),this.b=r,this.c=i,this.g=n,this.h=o,this.j=l,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$9hc=s,e.$9hc=s=Je([qe(0,D.$5hc),qe(1,k.$qhc),qe(2,g.$lO),qe(3,v.$thc),qe(4,f.$Fhc)],s)}),define(Fe[118],Le([1,0,11,5,2,22,4,3,64,38,17,7,36,208,210,37,117,6,40,31,8]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=e.$_hc=e.$$hc=e.$0hc=void 0,e.$0hc=(0,R.$ci)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,I,d,w,b,M,T){this.N=I,this.O=d,this.P=w,this.Q=b,this.R=M,this.S=T,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new F.$3d,this.o=new F.$3d,this.q=new F.$3d,this.w=new F.$3d,this.l=$.getProxy(g.$VL.MainThreadDebugService),this.A=new F.$3d,this.C=new F.$3d,this.y=new m(this.l),this.z=new Map,this.O.getExtensionRegistry().then(G=>{G.onDidChange(W=>{this.V(G)}),this.V(G)})}async $getVisualizerTreeItem($,I){const d=this.W(I);if(!d)return;const w=await this.H.get($)?.getTreeItem?.(d);return w?this.U($,w):void 0}registerDebugVisualizationTree($,I,d){const w=L.$um.toKey($.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(b,d),this.l.$registerDebugVisualizerTree(b,!!d.editItem),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(b),this.H.delete(I)})}async $getVisualizerTreeItemChildren($,I){const d=this.J.get(I)?.item;return d?(await this.H.get($)?.getChildren?.(d))?.map(b=>this.U($,b))||[]:[]}async $editVisualizerTreeItem($,I){const d=this.J.get($);if(!d)return;const w=await this.H.get(d.provider)?.editItem?.(d.item,I);return this.U(d.provider,w||d.item)}$disposeVisualizedTree($){const I=this.J.get($);if(!I)return;const d=[I.children];for(const w of d)if(w)for(const b of w)d.push(this.J.get(b)?.children),this.J.delete(b)}U($,I){let d=this.I.get(I);return d||(d=this.F++,this.I.set(I,d),this.J.set(d,{provider:$,item:I})),o.DebugTreeItem.from(I,d)}asDebugSourceUri($,I){const d=$;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let w=`debug:${encodeURIComponent(d.path||"")}`,b="?";return I&&(w+=`${b}session=${encodeURIComponent(I.id)}`,b="&"),w+=`${b}ref=${d.sourceReference}`,P.URI.parse(w)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const I=[];for(const d of $.getAllExtensionDescriptions())if(d.contributes){const w=d.contributes.debuggers;if(w&&w.length>0)for(const b of w)(0,p.$oG)(b)&&I.push(b.type)}this.l.$registerDebugTypes(I)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(I=>$.push(I)),$}async $resolveDebugVisualizer($,I){const d=this.L.get($);if(!d)throw new Error(`No debug visualizer found with id '${$}'`);let{v:w,provider:b,extensionId:M}=d;if(w.visualization||(w=await b.resolveDebugVisualization?.(w,I)||w,d.v=w),!w.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.kb(M,w.visualization)}async $executeDebugVisualizerCommand($){const I=this.L.get($);if(!I)throw new Error(`No debug visualizer found with id '${$}'`);const d=I.v.visualization;d&&"command"in d&&this.S.executeCommand(d.command,...d.arguments||[])}W($){const I=this.m.get($.sessionId);return I&&{session:I.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,I,d,w){const b=this.W(d),M=this.jb($,I),T=this.G.get(M);if(!b||!T)return[];const G=await T.provideDebugVisualization(b,w);return G?G.map(W=>{const U=++this.M;this.L.set(U,{v:W,provider:T,extensionId:$});const C=W.iconPath?this.lb(W.iconPath):void 0;return{id:U,name:W.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb($,W.visualization)}}):[]}$disposeDebugVisualizers($){for(const I of $)this.L.delete(I)}registerDebugVisualizationProvider($,I,d){if(!$.contributes?.debugVisualizers?.some(M=>M.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const w=L.$um.toKey($.identifier),b=this.jb(w,I);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(b,d),this.l.$registerDebugVisualizer(w,I),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizer(w,I),this.G.delete(I)})}addBreakpoints($){const I=$.filter(b=>{const M=b.id;return this.z.has(M)?!1:(this.z.set(M,b),!0)});this.gb(I,[],[]);const d=[],w=new Map;for(const b of I)if(b instanceof k.$XM){let M=w.get(b.location.uri.toString());M||(M={type:"sourceMulti",uri:b.location.uri,lines:[]},w.set(b.location.uri.toString(),M),d.push(M)),M.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character,mode:b.mode})}else b instanceof k.$YM&&d.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName,mode:b.mode});return this.l.$registerBreakpoints(d)}removeBreakpoints($){const I=$.filter(M=>this.z.delete(M.id));this.gb([],I,[]);const d=I.filter(M=>M instanceof k.$XM).map(M=>M.id),w=I.filter(M=>M instanceof k.$YM).map(M=>M.id),b=I.filter(M=>M instanceof k.$ZM).map(M=>M.id);return this.l.$unregisterBreakpoints(d,w,b)}startDebugging($,I,d){return this.l.$startDebugging($?$.uri:void 0,I,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,I,d){if(!I)return new k.$XL(()=>{});const w=this.d++;return this.f.push({type:$,handle:w,provider:I}),this.l.$registerDebugConfigurationProvider($,d,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,w),new k.$XL(()=>{this.f=this.f.filter(b=>b.provider!==I),this.l.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory($,I,d){if(!d)return new k.$XL(()=>{});if(!this.cb($,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:I,handle:w,factory:d}),this.l.$registerDebugAdapterDescriptorFactory(I,w),new k.$XL(()=>{this.h=this.h.filter(b=>b.factory!==d),this.l.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory($,I){if(!I)return new k.$XL(()=>{});const d=this.j++;return this.k.push({type:$,handle:d,factory:I}),new k.$XL(()=>{this.k=this.k.filter(w=>w.factory!==I)})}async $runInTerminal($,I){return Promise.resolve(void 0)}async $substituteVariables($,I){let d;const w=await this.ib($);return w&&(d={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(d,I)}X($,I){if($.type==="implementation")return new c($.implementation)}Y(){}async $startDASession($,I){const d=this,w=await this.hb(I);return this.eb(this.$(w.type),w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const M=this.Z(b),T=this.X(M,w);if(!T)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const G=T;return this.D.set($,G),this.db(w).then(W=>(W&&this.E.set($,W),G.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,O={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const V=await this.K.sign(C.arguments.value);O.body={signature:V},G.sendResponse(O)}else throw new Error("no signer")}catch(V){O.success=!1,O.message=V.message,G.sendResponse(O)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(U),U=(0,p.$tG)(U,!0),d.l.$acceptDAMessage($,U)}),G.onError(U=>{W&&W.onError&&W.onError(U),this.l.$acceptDAError($,U.name,U.message,U.stack)}),G.onExit(U=>{W&&W.onExit&&W.onExit(U??void 0,void 0),this.l.$acceptDAExit($,U??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),G.startSession()))})}$sendDAMessage($,I){I=(0,p.$sG)(I,!1);const d=this.E.get($);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(I),this.D.get($)?.sendMessage(I)}$stopDASession($){const I=this.E.get($);this.E.delete($),I&&I.onWillStopSession&&I.onWillStopSession();const d=this.D.get($);return this.D.delete($),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const I=[],d=[],w=[];if($.added)for(const b of $.added){const M=b.id;if(M&&!this.z.has(M)){let T;if(b.type==="function")T=new k.$YM(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode);else if(b.type==="data")T=new k.$ZM(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage,b.mode);else{const G=P.URI.revive(b.uri);T=new k.$XM(new k.$0L(G,new k.$YL(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode)}(0,k.$VM)(T,M),this.z.set(M,T),I.push(T)}}if($.removed)for(const b of $.removed){const M=this.z.get(b);M&&(this.z.delete(b),d.push(M))}if($.changed){for(const b of $.changed)if(b.id){const M=this.z.get(b.id);if(M){if(M instanceof k.$YM&&b.type==="function"){const T=M;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.functionName=b.functionName}else if(M instanceof k.$XM&&b.type==="source"){const T=M;T.enabled=b.enabled,T.condition=b.condition,T.hitCondition=b.hitCondition,T.logMessage=b.logMessage,T.location=new k.$0L(P.URI.revive(b.uri),new k.$YL(b.line,b.character))}w.push(M)}}}this.gb(I,d,w)}async $acceptStackFrameFocus($){let I;const d=$.sessionId?await this.hb($.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");$.kind==="thread"?I=new k.$6M(d.api,$.threadId):I=new k.$5M(d.api,$.threadId,$.frameId),this.B=I,this.C.fire(this.B)}$provideDebugConfigurations($,I,d){return(0,S.$7g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.ib(I);return w.provideDebugConfigurations(b,d)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration($,I,d,w){return(0,S.$7g)(async()=>{const b=this.bb($);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.ib(I);return b.resolveDebugConfiguration(M,d,w)})}$resolveDebugConfigurationWithSubstitutedVariables($,I,d,w){return(0,S.$7g)(async()=>{const b=this.bb($);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.ib(I);return b.resolveDebugConfigurationWithSubstitutedVariables(M,d,w)})}async $provideDebugAdapter($,I){const d=this.ab($);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.hb(I);return this.eb(d,w).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.Z(b)})}async $acceptDebugSessionStarted($){const I=await this.hb($);this.n.fire(I.api)}async $acceptDebugSessionTerminated($){const I=await this.hb($);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,I){(await this.hb($))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent($,I){const w={session:(await this.hb($)).api,event:I.event,body:I.body};this.w.fire(w)}Z($){if($ instanceof k.$1M)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof k.$2M)return{type:"server",port:$.port,host:$.host};if($ instanceof k.$3M)return{type:"pipeServer",path:$.path};if($ instanceof k.$4M)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const I=this.h.filter(d=>d.type===$);if(I.length>0)return I[0].factory}ab($){const I=this.h.filter(d=>d.handle===$);if(I.length>0)return I[0].factory}bb($){const I=this.f.filter(d=>d.handle===$);if(I.length>0)return I[0].provider}cb($,I){if($.contributes){const d=$.contributes.debuggers;if(d&&d.length>0){for(const w of d)if(w.label&&w.type&&w.type===I)return!0}}return!1}db($){const d=$.configuration.type,w=this.k.filter(b=>b.type===d||b.type==="*").map(b=>(0,S.$7g)(()=>b.factory.createDebugAdapterTracker($.api)).then(M=>M,M=>null));return Promise.race([Promise.all(w).then(b=>{const M=b.filter(T=>!!T);if(M.length>0)return new a(M)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async eb($,I){const d=I.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new k.$2M(d));if($){const b=await this.O.getExtensionRegistry();return(0,S.$7g)(()=>$.createDebugAdapterDescriptor(I.api,this.fb(I,b))).then(M=>{if(M)return M})}const w=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,w))}fb($,I){}gb($,I,d){($.length>0||I.length>0||d.length>0)&&this.A.fire(Object.freeze({added:$,removed:I,changed:d}))}async hb($){if($)if(typeof $=="string"){const I=this.m.get($);if(I)return I}else{let I=this.m.get($.id);if(!I){const d=await this.ib($.folderUri),w=$.parent?this.m.get($.parent):void 0;I=new t(this.l,$.id,$.type,$.name,d,$.configuration,w?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib($){if($){const I=P.URI.revive($);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb($,I){return`${$}\0${I}`}kb($,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${$}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const I=this.mb($);let d,w;return"id"in I?w=i.ThemeIcon.asClassName(I):d=I,{iconPath:d,iconClass:w}}mb($){if($ instanceof k.$SM)return{id:$.id};const I=typeof $=="object"&&"dark"in $?$.dark:$,d=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof d=="string"?P.URI.file(d):d}}};e.$$hc=l,e.$$hc=l=Je([qe(0,A.$aO),qe(1,h.$qhc),qe(2,D.$5hc),qe(3,s.$thc),qe(4,f.$Fhc),qe(5,u.$8hc),qe(6,n.$wO)],l);class t{constructor($,I,d,w,b,M,T){this.f=$,this.g=I,this.h=d,this.j=w,this.k=b,this.l=M,this.m=T}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(I){$.j=I,$.f.$setDebugSessionName($.g,I)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(I,d){return $.f.$customDebugAdapterRequest($.g,I,d)},getDebugProtocolBreakpoint(I){return $.f.$getDebugProtocolBreakpoint($.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$_hc=t;class m{constructor($){this.value=Object.freeze({append(I){$.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$aic=m;class a{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(I=>I.onError?I.onError($):void 0)}onExit($,I){this.d.forEach(d=>d.onExit?d.onExit($,I):void 0)}}class c extends v.$enb{constructor($){super(),this.h=$,$.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let E=class extends l{constructor($,I,d,w,b,M,T){super($,I,d,w,b,M,T)}};e.$bic=E,e.$bic=E=Je([qe(0,A.$aO),qe(1,h.$qhc),qe(2,D.$5hc),qe(3,s.$thc),qe(4,f.$Fhc),qe(5,u.$8hc),qe(6,n.$wO)],E)}),define(Fe[291],Le([1,0,15,87,2,3,237,14,53,71,27,186,17,58,38,60]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=void 0;class u{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(g.$wj),t=n.get(h.$aO).getProxy(L.$VL.MainThreadErrors);S.setUnexpectedErrorHandler(m=>{o.error(m);const a=S.$3(m);t.$onUnexpectedError(a)})}static async installFullHandler(n){const o=n.get(g.$wj),l=n.get(h.$aO),t=n.get(p.$5hc),m=n.get(s.$uO),a=l.getProxy(L.$VL.MainThreadExtensionService),c=l.getProxy(L.$VL.MainThreadErrors),E=await t.getExtensionPathIndex(),y=new WeakMap;function $(w,b){if(y.has(w))return y.get(w).stack;let M="",T,G;for(const U of b)M+=`
	at ${U.toString()}`,G=U.getFileName(),!T&&G&&(T=E.findSubstr(P.URI.file(G)));const W=`${w.name||"Error"}: ${w.message||""}${M}`;return y.set(w,{extensionIdentifier:T?.identifier,stack:W}),W}const I=Symbol("prepareStackTrace wrapped");let d=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return d},set(w){if(w===$||!w||w[I]){d=w||$;return}d=function(b,M){return $(b,M),w.call(Error,b,M)},Object.assign(d,{[I]:!0})}}),S.setUnexpectedErrorHandler(w=>{o.error(w);const b=S.$3(w),M=y.get(w);if(!M?.extensionIdentifier){c.$onUnexpectedError(b);return}a.$onExtensionRuntimeError(M.extensionIdentifier,b);const T=m.onExtensionError(M.extensionIdentifier,w);o.trace("forwarded error to extension?",T,M)})}}e.$djc=u;class r{constructor(n,o,l,t,m){this.a=l,this.b=new R.$b9b(n,null,t),o=r.e(o,this.b);const a=new D.$ai(...(0,f.$9r)());a.set(A.$qO,{_serviceBrand:void 0,...o,messagePorts:m}),a.set(h.$aO,new h.$bO(this.b)),a.set(v.$nhc,new v.$ohc(t)),a.set(p.$3hc,l);const c=new k.$Nq(a,!0);c.invokeFunction(u.installEarlyHandler),this.d=c.invokeFunction(E=>E.get(g.$wj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=c.invokeFunction(E=>E.get(p.$5hc)),this.c.initialize(),c.invokeFunction(u.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(L.$VL.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=P.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const l=n.environment.extensionDevelopmentLocationURI;return l&&(n.environment.extensionDevelopmentLocationURI=l.map(t=>P.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$ejc=r}),define(Fe[292],Le([1,0,18,11,21,41,12,19,25,2,44]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=e.$pic=void 0;class k{constructor(i,n,o,l){this.d=i,this.e=n,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],l=new P.$ae(n);return new Promise((t,m)=>{this.a=new v(i);let a=!1;const c=(E,y)=>{if(!a&&!this.b){const $=this.h(E);s(E)&&typeof this.d.maxResults=="number"&&this.c+$>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),E=this.j(E,this.d.maxResults-this.c));const I=this.h(E);this.c+=I,(I>0||!s(E))&&this.a.add(E,y)}};Promise.all(o.map((E,y)=>this.k(E,$=>c($,y),l.token))).then(E=>{l.dispose(),this.a.flush();const y=E.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||y,messages:(0,S.$Rb)(E.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.g}})},E=>{l.dispose();const y=(0,L.$Zi)(E);m(new Error(y))})})}h(i){return s(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],l=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:l.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const l=new A.$xK(this.d,i),t=[],m={report:E=>{if(!this.l(E))return;const y=i.folder.scheme===R.Schemas.file?(0,A.$yK)(()=>this.f.readdir(f.$Og(E.uri))):void 0,$=f.$Rg(i.folder,E.uri);if($){const I=l.includedInQuery($,g.$nc($),y);(0,F.$1g)(I)?t.push(I.then(d=>{d&&n(E)})):I&&n(E)}}},a=this.n(i),c=await this.e.provideTextSearchResults(h(this.d.contentPattern),a,m,o);return t.length&&await Promise.all(t),c}l(i){if(s(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$wK)(this.d.includePattern,i.includePattern),o=(0,A.$wK)(this.d.excludePattern,i.excludePattern),l={folder:D.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$pic=k;function h(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new u(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!f.$Ig(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(p(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$qic=v;function p(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}e.$ric=s;class u{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$sic=u}),define(Fe[119],Le([1,0,6,3,4,287,17,58,14,2,292]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=e.$uic=e.$tic=void 0,e.$tic=(0,P.$ci)("IExtHostSearch");let k=class{constructor(s,u,r){this.k=s,this.l=u,this.n=r,this.c=this.k.getProxy(F.$VL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$oic}o(s){return this.l.transformOutgoingScheme(s)}registerTextSearchProvider(s,u){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,u),this.c.$registerTextSearchProvider(r,this.o(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,u){if(this.i.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,u),this.c.$registerFileSearchProvider(r,this.o(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,u,r,i){const n=h(r),o=this.h.get(s);if(o)return this.j.fileSearch(n,o,l=>{this.c.$handleFileMatch(s,u,l.map(t=>t.resource))},i);throw new Error("unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,u,r){return{messages:[]}}$clearCache(s){return this.j.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,u,r,i){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const o=h(r);return this.q(o,n).search(t=>this.c.$handleTextMatch(s,u,t),i)}$enableExtensionHostSearch(){}q(s,u){return new A.$pic(s,u,{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}};e.$uic=k,e.$uic=k=Je([qe(0,R.$aO),qe(1,g.$nhc),qe(2,f.$wj)],k);function h(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(v),extraFileResources:p.extraFileResources&&p.extraFileResources.map(s=>D.URI.revive(s))}}e.$vic=h;function v(p){return{...p,folder:D.URI.revive(p.folder)}}}),define(Fe[293],Le([1,0,21,15,5,6,12,32,2,147,143,131,92,22,42,14,56,57,199,3,240,271,78,241,247,225,248,249,250,226,214,31,251,37,252,118,108,253,228,242,254,255,66,64,243,38,257,62,258,43,27,272,273,244,229,259,260,79,80,231,286,262,203,263,274,264,113,232,265,266,267,17,268,119,81,269,233,270,82,84,116,60,65,275,276,245,277,278,85,8,7,234,58,235,61,279,280,107,36,209,77,23,115]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m,a,c,E,y,$,I,d,w,b,M,T,G,W,U,C,O,V,re,ce,ye,ke,he,ve,se,$e,te,Y,q,ne,Pe,Oe,Re,be,me,Q,x,le,de,Me,ge,Se,Ce,N,K,j,H,Z,oe,Ee,Be,Ve,Ze,xe,at,nt,et,ut,je,pt,X,_,pe,We,Qe,it,rt,Te,Tt,Xt,xt,Ut,Dt,ei,jt,si,Yt,_t,Ye,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;function ti(ht){const mt=ht.get(Y.$qO),Gt=ht.get(te.$0gc),ii=ht.get(se.$vhc),Pt=ht.get(he.$5hc),dt=ht.get(si.$qhc),At=ht.get(je.$uO),oi=ht.get(M.$thc),Mt=ht.get(Xt.$nhc),He=ht.get(oe.$aO),Nt=ht.get(nt.$Ohc),Vt=ht.get(et.$whc),ni=ht.get(s.$xj),ft=ht.get(s.$wj),Ft=ht.get(it.$Rzb),Ct=ht.get(t.$6gc),zt=ht.get(jt.$0ic),Wt=ht.get(Ve.$Whc),qt=ht.get(ye.$Fhc),St=ht.get(Q.$1hc);He.set(n.$WL.ExtHostFileSystemInfo,Gt),He.set(n.$WL.ExtHostLogLevelServiceShape,ni),He.set(n.$WL.ExtHostWorkspace,dt),He.set(n.$WL.ExtHostConfiguration,oi),He.set(n.$WL.ExtHostExtensionService,Pt),He.set(n.$WL.ExtHostStorage,Nt),He.set(n.$WL.ExtHostTunnelService,Ft),He.set(n.$WL.ExtHostWindow,zt),He.set(n.$WL.ExtHostSecretState,Wt),He.set(n.$WL.ExtHostTelemetry,At),He.set(n.$WL.ExtHostEditorTabs,qt),He.set(n.$WL.ExtHostManagedSockets,St);const Jt=He.set(n.$WL.ExtHostDecorations,ht.get(W.$dic)),Et=He.set(n.$WL.ExtHostDocumentsAndEditors,ht.get(ce.$lO)),bt=He.set(n.$WL.ExtHostCommands,ht.get(w.$wO)),It=He.set(n.$WL.ExtHostTerminalService,ht.get(pt.$Rhc)),kt=He.set(n.$WL.ExtHostDebugService,ht.get(G.$0hc)),ci=He.set(n.$WL.ExtHostSearch,ht.get(Be.$tic)),Qt=He.set(n.$WL.ExtHostTask,ht.get(ut.$Wic)),pi=He.set(n.$WL.ExtHostOutputService,ht.get(N.$Jic)),Ht=He.set(n.$WL.ExtHostLocalization,ht.get(me.$Zhc)),we=He.set(n.$WL.ExtHostUrls,new xt.$7ic(He)),Ae=He.set(n.$WL.ExtHostDocuments,new re.$ahc(He,Et)),ue=He.set(n.$WL.ExtHostDocumentContentProviders,new O.$fic(He,Et,ft)),J=He.set(n.$WL.ExtHostDocumentSaveParticipant,new V.$gic(ft,Ae,He.getProxy(n.$VL.MainThreadBulkEdits))),De=He.set(n.$WL.ExtHostNotebook,new le.$wic(He,bt,Et,Ae,ii,ci)),Ue=He.set(n.$WL.ExtHostNotebookDocuments,new Me.$Dic(De)),Xe=He.set(n.$WL.ExtHostNotebookEditors,new ge.$Eic(ft,De)),Ke=He.set(n.$WL.ExtHostNotebookKernels,new Se.$Fic(He,mt,De,bt,ft)),st=He.set(n.$WL.ExtHostNotebookRenderers,new Ce.$Hic(He,De)),wt=He.set(n.$WL.ExtHostNotebookDocumentSaveParticipant,new de.$Cic(ft,De,He.getProxy(n.$VL.MainThreadBulkEdits))),yt=He.set(n.$WL.ExtHostEditors,new _.$khc(He,Et)),Zt=He.set(n.$WL.ExtHostTreeViews,new Qe.$5ic(He.getProxy(n.$VL.MainThreadTreeViews),bt,ft)),Rt=He.set(n.$WL.ExtHostEditorInsets,new d.$lhc(He.getProxy(n.$VL.MainThreadEditorInsets),yt,mt.remote)),Ot=He.set(n.$WL.ExtHostDiagnostics,new U.$_gc(He,ft,Gt,Et)),vi=He.set(n.$WL.ExtHostLanguages,new be.$Aic(He,Ae,bt.converter,Mt)),lt=He.set(n.$WL.ExtHostLanguageFeatures,new Re.$bhc(He,Mt,Ae,bt,Ot,ft,Ct,At)),Xi=He.set(n.$WL.ExtHostFileSystem,new ve.$iic(He,lt)),ui=He.set(n.$WL.ExtHostFileSystemEventService,new $e.$jic(He,ft,Et)),gi=He.set(n.$WL.ExtHostQuickOpen,(0,Z.$Nic)(He,dt,bt)),yi=He.set(n.$WL.ExtHostSCM,new Ee.$Pic(He,bt,Ae,ft)),Ri=He.set(n.$WL.ExtHostQuickDiff,new H.$Mic(He,Mt)),Yi=He.set(n.$WL.ExtHostShare,new Ze.$Qic(He,Mt)),hn=He.set(n.$WL.ExtHostComments,(0,b.$mhc)(He,bt,Ae)),Ai=He.set(n.$WL.ExtHostProgress,new j.$Lic(He.getProxy(n.$VL.MainThreadProgress))),Mi=He.set(n.$WL.ExtHostLabelService,new Oe.$zic(He)),Ei=He.set(n.$WL.ExtHostTheming,new pe.$2ic(He)),mi=He.set(n.$WL.ExtHostAuthentication,new m.$dhc(He)),_i=He.set(n.$WL.ExtHostTimeline,new We.$4ic(He,bt)),Di=He.set(n.$WL.ExtHostWebviews,new Ut.$Ahc(He,mt.remote,dt,ft,Ct)),ki=He.set(n.$WL.ExtHostWebviewPanels,new Dt.$Dhc(He,Di,dt)),xi=He.set(n.$WL.ExtHostCustomEditors,new T.$Ehc(He,Ae,Vt,Di,ki)),dn=He.set(n.$WL.ExtHostWebviewViews,new ei.$8ic(He,Di)),bi=He.set(n.$WL.ExtHostTesting,new X.$Xic(He,ft,bt,Et)),Fi=He.set(n.$WL.ExtHostUriOpeners,new Tt.$6ic(He)),Li=He.set(n.$WL.ExtHostProfileContentHandlers,new K.$Kic(He));He.set(n.$WL.ExtHostInteractive,new ne.$xic(He,De,Et,bt,ft));const fn=He.set(n.$WL.ExtHostInlineChat,new q.$kic(He,bt,Ae,ft)),Si=He.set(n.$WL.ExtHostChatProvider,new y.$hhc(He,ft,mi)),en=He.set(n.$WL.ExtHostChatAgents2,new E.$ghc(He,ft,bt)),gn=He.set(n.$WL.ExtHostChatVariables,new $.$ihc(He)),wi=He.set(n.$WL.ExtHostChat,new c.$fhc(He)),Oi=He.set(n.$WL.ExtHostAiRelatedInformation,new o.$5gc(He)),tn=He.set(n.$WL.ExtHostAiEmbeddingVector,new ke.$hic(He)),Ti=He.set(n.$WL.ExtHostIssueReporter,new Pe.$yic(He)),nn=He.set(n.$WL.ExtHostStatusBar,new at.$Tic(He,bt.converter)),Ni=He.set(n.$WL.ExtHostSpeech,new xe.$Ric(He)),rn=Object.values(n.$WL);He.assertRegistered(rn);const di=new a.$ehc(He,Et),Ii=new I.$jhc(He),zi=new x.$Bic(He,ft),ri=new C.$eic(He);return l.$chc.register(bt),function(Ne,li,Ui){function tt(ee){return(ae,ze,ot)=>{const vt=ee(Lt=>{try{ae.call(ze,Lt)}catch(Ji){F.$2(new Error(`[ExtensionListenerError] Extension '${Ne.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),At.onExtensionError(Ne.identifier,Ji)}});return ot?.push(vt),vt}}const $t=function(){let ee=!Ne.isUnderDevelopment;function ae(){ee||(ft.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ze(ot){if(Array.isArray(ot))ot.forEach(ze);else if(typeof ot=="string")ae();else{const vt=ot;typeof vt.scheme>"u"&&ae(),typeof vt.exclusive=="boolean"&&(0,Ye.$SF)(Ne,"documentFiltersExclusive")}return ot}}(),mn={getSession(ee,ae,ze){return mi.getSession(Ne,ee,ae,ze)},getSessions(ee,ae){return(0,Ye.$SF)(Ne,"authGetSessions"),mi.getSessions(Ne,ee,ae)},async hasSession(ee,ae){return(0,Ye.$SF)(Ne,"authSession"),!!await mi.getSession(Ne,ee,ae,{silent:!0})},get onDidChangeSessions(){return tt(mi.onDidChangeSessions)},registerAuthenticationProvider(ee,ae,ze,ot){return mi.registerAuthenticationProvider(ee,ae,ze,ot)}},sn={registerCommand(ee,ae,ze){return bt.registerCommand(!0,ee,ae,ze,void 0,Ne)},registerTextEditorCommand(ee,ae,ze){return bt.registerCommand(!0,ee,(...ot)=>{const vt=yt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}return vt.edit(Lt=>{ae.apply(ze,[vt,Lt,...ot])}).then(Lt=>{Lt||ft.warn("Edits from command "+ee+" were not applied.")},Lt=>{ft.warn("An error occurred while running command "+ee,Lt)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"diffCommand"),bt.registerCommand(!0,ee,async(...ot)=>{const vt=Et.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Lt=await yt.getDiffInformation(vt.id);ae.apply(ze,[Lt,...ot])},void 0,void 0,Ne)),executeCommand(ee,...ae){return bt.executeCommand(ee,...ae)},getCommands(ee=!1){return bt.getCommands(ee)}},ji={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return Ii.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return tt(It.onDidChangeShell)},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return tt(At.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$SF)(Ne,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$SF)(Ne,"telemetry"),tt(At.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$tO)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ae){return je.$sO.validateSender(ee),At.instantiateLogger(Ne,ee,ae)},openExternal(ee,ae){return zt.openUri(ee,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===mt.environment.appUriScheme)return we.createAppUri(ee);try{return await zt.asExternalUri(ee,{allowTunneling:!!mt.remote.authority})}catch(ae){if((0,R.$mg)(ee,R.Schemas.http)||(0,R.$mg)(ee,R.Schemas.https))return ee;throw ae}},get remoteName(){return(0,u.$kl)(mt.remote.authority)},get remoteAuthority(){return(0,Ye.$SF)(Ne,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return tt(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(ee){return(0,Ye.$SF)(Ne,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ne,ee)},registerIssueDataProvider(ee){return(0,Ye.$SF)(Ne,"handleIssueUri"),Ti.registerIssueDataProvider(Ne,ee)},get appQuality(){return(0,Ye.$SF)(Ne,"resolvers"),mt.quality},get appCommit(){return(0,Ye.$SF)(Ne,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ji);const $n={createTestController(ee,ae,ze){return bi.createTestController(Ne,ee,ae,ze)},createTestObserver(){return(0,Ye.$SF)(Ne,"testObserver"),bi.createTestObserver()},runTests(ee){return(0,Ye.$SF)(Ne,"testObserver"),bi.runTests(ee)},get onDidChangeTestResults(){return(0,Ye.$SF)(Ne,"testObserver"),tt(bi.onResultsChanged)},get testResults(){return(0,Ye.$SF)(Ne,"testObserver"),bi.results}},Ci=mt.remote.isRemote?Te.ExtensionKind.Workspace:Te.ExtensionKind.UI,on={getExtension(ee,ae){(0,Ye.$RF)(Ne,"extensionsAny")||(ae=!1);const ze=li.mine.getExtensionDescription(ee);if(ze)return new he.$6hc(Pt,Ne.identifier,ze,Ci,!1);if(ae){const ot=li.all.getExtensionDescription(ee);if(ot)return new he.$6hc(Pt,Ne.identifier,ot,Ci,!0)}},get all(){const ee=[];for(const ae of li.mine.getAllExtensionDescriptions())ee.push(new he.$6hc(Pt,Ne.identifier,ae,Ci,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$SF)(Ne,"extensionsAny");const ee=new v.$vm(li.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ae=[];for(const ze of li.all.getAllExtensionDescriptions()){const ot=!ee.has(ze.identifier);ae.push(new he.$6hc(Pt,Ne.identifier,ze,Ci,ot))}return ae},get onDidChange(){return(0,Ye.$RF)(Ne,"extensionsAny")?tt(P.Event.any(li.mine.onDidChange,li.all.onDidChange)):tt(li.mine.onDidChange)}},Bi={createDiagnosticCollection(ee){return Ot.createDiagnosticCollection(Ne.identifier,ee)},get onDidChangeDiagnostics(){return tt(Ot.onDidChangeDiagnostics)},getDiagnostics:ee=>Ot.getDiagnostics(ee),getLanguages(){return vi.getLanguages()},setTextDocumentLanguage(ee,ae){return vi.changeLanguage(ee.uri,ae)},match(ee,ae){const ze=Ae.getDocumentData(ae.uri)?.notebook;return(0,A.$Kt)(rt.LanguageSelector.from(ee),ae.uri,ae.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(ee,ae,ze){return lt.registerCodeActionProvider(Ne,$t(ee),ae,ze)},registerDocumentPasteEditProvider(ee,ae,ze){return(0,Ye.$SF)(Ne,"documentPaste"),lt.registerDocumentPasteEditProvider(Ne,$t(ee),ae,ze)},registerCodeLensProvider(ee,ae){return lt.registerCodeLensProvider(Ne,$t(ee),ae)},registerDefinitionProvider(ee,ae){return lt.registerDefinitionProvider(Ne,$t(ee),ae)},registerDeclarationProvider(ee,ae){return lt.registerDeclarationProvider(Ne,$t(ee),ae)},registerImplementationProvider(ee,ae){return lt.registerImplementationProvider(Ne,$t(ee),ae)},registerTypeDefinitionProvider(ee,ae){return lt.registerTypeDefinitionProvider(Ne,$t(ee),ae)},registerHoverProvider(ee,ae){return lt.registerHoverProvider(Ne,$t(ee),ae,Ne.identifier)},registerEvaluatableExpressionProvider(ee,ae){return lt.registerEvaluatableExpressionProvider(Ne,$t(ee),ae,Ne.identifier)},registerInlineValuesProvider(ee,ae){return lt.registerInlineValuesProvider(Ne,$t(ee),ae,Ne.identifier)},registerDocumentHighlightProvider(ee,ae){return lt.registerDocumentHighlightProvider(Ne,$t(ee),ae)},registerMultiDocumentHighlightProvider(ee,ae){return lt.registerMultiDocumentHighlightProvider(Ne,$t(ee),ae)},registerLinkedEditingRangeProvider(ee,ae){return lt.registerLinkedEditingRangeProvider(Ne,$t(ee),ae)},registerReferenceProvider(ee,ae){return lt.registerReferenceProvider(Ne,$t(ee),ae)},registerRenameProvider(ee,ae){return lt.registerRenameProvider(Ne,$t(ee),ae)},registerNewSymbolNamesProvider(ee,ae){return(0,Ye.$SF)(Ne,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(Ne,$t(ee),ae)},registerDocumentSymbolProvider(ee,ae,ze){return lt.registerDocumentSymbolProvider(Ne,$t(ee),ae,ze)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Ne,ee)},registerDocumentFormattingEditProvider(ee,ae){return lt.registerDocumentFormattingEditProvider(Ne,$t(ee),ae)},registerDocumentRangeFormattingEditProvider(ee,ae){return lt.registerDocumentRangeFormattingEditProvider(Ne,$t(ee),ae)},registerOnTypeFormattingEditProvider(ee,ae,ze,...ot){return lt.registerOnTypeFormattingEditProvider(Ne,$t(ee),ae,[ze].concat(ot))},registerDocumentSemanticTokensProvider(ee,ae,ze){return lt.registerDocumentSemanticTokensProvider(Ne,$t(ee),ae,ze)},registerDocumentRangeSemanticTokensProvider(ee,ae,ze){return lt.registerDocumentRangeSemanticTokensProvider(Ne,$t(ee),ae,ze)},registerSignatureHelpProvider(ee,ae,ze,...ot){return typeof ze=="object"?lt.registerSignatureHelpProvider(Ne,$t(ee),ae,ze):lt.registerSignatureHelpProvider(Ne,$t(ee),ae,typeof ze>"u"?[]:[ze,...ot])},registerCompletionItemProvider(ee,ae,...ze){return lt.registerCompletionItemProvider(Ne,$t(ee),ae,ze)},registerInlineCompletionItemProvider(ee,ae,ze){return ae.handleDidShowCompletionItem&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),ze&&(0,Ye.$SF)(Ne,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Ne,$t(ee),ae,ze)},registerDocumentLinkProvider(ee,ae){return lt.registerDocumentLinkProvider(Ne,$t(ee),ae)},registerColorProvider(ee,ae){return lt.registerColorProvider(Ne,$t(ee),ae)},registerFoldingRangeProvider(ee,ae){return lt.registerFoldingRangeProvider(Ne,$t(ee),ae)},registerSelectionRangeProvider(ee,ae){return lt.registerSelectionRangeProvider(Ne,ee,ae)},registerCallHierarchyProvider(ee,ae){return lt.registerCallHierarchyProvider(Ne,ee,ae)},registerTypeHierarchyProvider(ee,ae){return lt.registerTypeHierarchyProvider(Ne,ee,ae)},setLanguageConfiguration:(ee,ae)=>lt.setLanguageConfiguration(Ne,ee,ae),getTokenInformationAtPosition(ee,ae){return(0,Ye.$SF)(Ne,"tokenInformation"),vi.tokenAtPosition(ee,ae)},registerInlayHintsProvider(ee,ae){return lt.registerInlayHintsProvider(Ne,ee,ae)},createLanguageStatusItem(ee,ae){return vi.createLanguageStatusItem(Ne,ee,ae)},registerDocumentDropEditProvider(ee,ae,ze){return lt.registerDocumentOnDropEditProvider(Ne,ee,ae,(0,Ye.$RF)(Ne,"dropMetadata")?ze:void 0)}},an={get activeTextEditor(){return yt.getActiveTextEditor()},get visibleTextEditors(){return yt.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(ee,ae,ze){f.URI.isUri(ee)&&ee.scheme===R.Schemas.vscodeRemote&&!ee.authority&&Ct.report("workspace.showTextDocument",Ne,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(f.URI.isUri(ee)?Promise.resolve(Vi.openTextDocument(ee)):Promise.resolve(ee));return yt.showTextDocument(ot,ae,ze)},createTextEditorDecorationType(ee){return yt.createTextEditorDecorationType(Ne,ee)},onDidChangeActiveTextEditor(ee,ae,ze){return tt(yt.onDidChangeActiveTextEditor)(ee,ae,ze)},onDidChangeVisibleTextEditors(ee,ae,ze){return tt(yt.onDidChangeVisibleTextEditors)(ee,ae,ze)},onDidChangeTextEditorSelection(ee,ae,ze){return tt(yt.onDidChangeTextEditorSelection)(ee,ae,ze)},onDidChangeTextEditorOptions(ee,ae,ze){return tt(yt.onDidChangeTextEditorOptions)(ee,ae,ze)},onDidChangeTextEditorVisibleRanges(ee,ae,ze){return tt(yt.onDidChangeTextEditorVisibleRanges)(ee,ae,ze)},onDidChangeTextEditorViewColumn(ee,ae,ze){return tt(yt.onDidChangeTextEditorViewColumn)(ee,ae,ze)},onDidCloseTerminal(ee,ae,ze){return tt(It.onDidCloseTerminal)(ee,ae,ze)},onDidOpenTerminal(ee,ae,ze){return tt(It.onDidOpenTerminal)(ee,ae,ze)},onDidChangeActiveTerminal(ee,ae,ze){return tt(It.onDidChangeActiveTerminal)(ee,ae,ze)},onDidChangeTerminalDimensions(ee,ae,ze){return(0,Ye.$SF)(Ne,"terminalDimensions"),tt(It.onDidChangeTerminalDimensions)(ee,ae,ze)},onDidChangeTerminalState(ee,ae,ze){return tt(It.onDidChangeTerminalState)(ee,ae,ze)},onDidWriteTerminalData(ee,ae,ze){return(0,Ye.$SF)(Ne,"terminalDataWriteEvent"),tt(It.onDidWriteTerminalData)(ee,ae,ze)},onDidExecuteTerminalCommand(ee,ae,ze){return(0,Ye.$SF)(Ne,"terminalExecuteCommandEvent"),tt(It.onDidExecuteTerminalCommand)(ee,ae,ze)},get state(){return zt.getState(Ne)},onDidChangeWindowState(ee,ae,ze){return tt(zt.onDidChangeWindowState)(ee,ae,ze)},showInformationMessage(ee,...ae){return zi.showMessage(Ne,g.default.Info,ee,ae[0],ae.slice(1))},showWarningMessage(ee,...ae){return zi.showMessage(Ne,g.default.Warning,ee,ae[0],ae.slice(1))},showErrorMessage(ee,...ae){return zi.showMessage(Ne,g.default.Error,ee,ae[0],ae.slice(1))},showQuickPick(ee,ae,ze){return gi.showQuickPick(Ne,ee,ae,ze)},showWorkspaceFolderPick(ee){return gi.showWorkspaceFolderPick(ee)},showInputBox(ee,ae){return gi.showInput(ee,ae)},showOpenDialog(ee){return ri.showOpenDialog(Ne,ee)},showSaveDialog(ee){return ri.showSaveDialog(ee)},createStatusBarItem(ee,ae,ze){let ot,vt,Lt;return typeof ee=="string"?(ot=ee,vt=ae,Lt=ze):(vt=ee,Lt=ae),nn.createStatusBarEntry(Ne,ot,vt,Lt)},setStatusBarMessage(ee,ae){return nn.setStatusBarMessage(ee,ae)},withScmProgress(ee){return Ct.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),Ai.withProgress(Ne,{location:Te.ProgressLocation.SourceControl},(ae,ze)=>ee({report(ot){}}))},withProgress(ee,ae){return Ai.withProgress(Ne,ee,ae)},createOutputChannel(ee,ae){return pi.createOutputChannel(ee,ae,Ne)},createWebviewPanel(ee,ae,ze,ot){return ki.createWebviewPanel(Ne,ee,ae,ze,ot)},createWebviewTextEditorInset(ee,ae,ze,ot){return(0,Ye.$SF)(Ne,"editorInsets"),Rt.createWebviewEditorInset(ee,ae,ze,ot,Ne)},createTerminal(ee,ae,ze){return typeof ee=="object"?"pty"in ee?It.createExtensionTerminal(ee):It.createTerminalFromOptions(ee):It.createTerminal(ee,ae,ze)},registerTerminalLinkProvider(ee){return It.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ae){return It.registerProfileProvider(Ne,ee,ae)},registerTerminalQuickFixProvider(ee,ae){return(0,Ye.$SF)(Ne,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(ee,Ne.identifier.value,ae)},registerTreeDataProvider(ee,ae){return Zt.registerTreeDataProvider(ee,ae,Ne)},createTreeView(ee,ae){return Zt.createTreeView(ee,ae,Ne)},registerWebviewPanelSerializer:(ee,ae)=>ki.registerWebviewPanelSerializer(Ne,ee,ae),registerCustomEditorProvider:(ee,ae,ze={})=>xi.registerCustomEditorProvider(Ne,ee,ae,ze),registerFileDecorationProvider(ee){return Jt.registerFileDecorationProvider(ee,Ne)},registerUriHandler(ee){return we.registerUriHandler(Ne,ee)},createQuickPick(){return gi.createQuickPick(Ne)},createInputBox(){return gi.createInputBox(Ne)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(ee,ae,ze){return tt(Ei.onDidChangeActiveColorTheme)(ee,ae,ze)},registerWebviewViewProvider(ee,ae,ze){return dn.registerWebviewViewProvider(Ne,ee,ae,ze?.webviewOptions)},get activeNotebookEditor(){return De.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ae,ze){return tt(De.onDidChangeActiveNotebookEditor)(ee,ae,ze)},get visibleNotebookEditors(){return De.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return tt(De.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ae,ze){return tt(Xe.onDidChangeNotebookEditorSelection)(ee,ae,ze)},onDidChangeNotebookEditorVisibleRanges(ee,ae,ze){return tt(Xe.onDidChangeNotebookEditorVisibleRanges)(ee,ae,ze)},showNotebookDocument(ee,ae){return De.showNotebookDocument(ee,ae)},registerExternalUriOpener(ee,ae,ze){return(0,Ye.$SF)(Ne,"externalUriOpener"),Fi.registerExternalUriOpener(Ne.identifier,ee,ae,ze)},registerProfileContentHandler(ee,ae){return(0,Ye.$SF)(Ne,"profileContentHandlers"),Li.registerProfileContentHandler(Ne,ee,ae)},registerQuickDiffProvider(ee,ae,ze,ot){return(0,Ye.$SF)(Ne,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(ee),ae,ze,ot)},get tabGroups(){return qt.tabGroups},registerShareProvider(ee,ae){return(0,Ye.$SF)(Ne,"shareProvider"),Yi.registerShareProvider($t(ee),ae)}},Vi={get rootPath(){return Ct.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new F.$9("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new F.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new F.$9("workspaceFile")},updateWorkspaceFolders:(ee,ae,...ze)=>dt.updateWorkspaceFolders(Ne,ee,ae||0,...ze),onDidChangeWorkspaceFolders:function(ee,ae,ze){return tt(dt.onDidChangeWorkspace)(ee,ae,ze)},asRelativePath:(ee,ae)=>dt.getRelativePath(ee,ae),findFiles:(ee,ae,ze,ot)=>dt.findFiles(ee,ae,ze,Ne.identifier,ot),findFiles2:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"findFiles2"),dt.findFiles2(ee,ae,Ne.identifier,ze)),findTextInFiles:(ee,ae,ze,ot)=>{(0,Ye.$SF)(Ne,"findTextInFiles");let vt,Lt;return typeof ae=="object"?(vt=ae,Lt=ze):(vt={},Lt=ae,ot=ze),dt.findTextInFiles(ee,vt||{},Lt,Ne.identifier,ot)},save:ee=>dt.save(ee),saveAs:ee=>dt.saveAs(ee),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,ae){return di.applyWorkspaceEdit(ee,Ne,ae)},createFileSystemWatcher:(ee,ae,ze,ot)=>{let vt;return typeof ae=="boolean"?vt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!ot,correlate:!1}:ae&&((0,Ye.$SF)(Ne,"createFileSystemWatcher"),vt={...ae,correlate:!0}),ui.createFileSystemWatcher(dt,Ne,ee,vt)},get textDocuments(){return Ae.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new F.$9("textDocuments")},openTextDocument(ee){let ae;const ze=ee;if(typeof ee=="string")ae=Promise.resolve(f.URI.file(ee));else if(f.URI.isUri(ee))ae=Promise.resolve(ee);else if(!ze||typeof ze=="object")ae=Ae.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ot=>(ot.scheme===R.Schemas.vscodeRemote&&!ot.authority&&Ct.report("workspace.openTextDocument",Ne,"A URI of 'vscode-remote' scheme requires an authority."),Ae.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(ee,ae,ze)=>tt(Ae.onDidAddDocument)(ee,ae,ze),onDidCloseTextDocument:(ee,ae,ze)=>tt(Ae.onDidRemoveDocument)(ee,ae,ze),onDidChangeTextDocument:(ee,ae,ze)=>tt(Ae.onDidChangeDocument)(ee,ae,ze),onDidSaveTextDocument:(ee,ae,ze)=>tt(Ae.onDidSaveDocument)(ee,ae,ze),onWillSaveTextDocument:(ee,ae,ze)=>tt(J.getOnWillSaveTextDocumentEvent(Ne))(ee,ae,ze),get notebookDocuments(){return De.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ae){let ze;if(f.URI.isUri(ee))ze=ee,await De.openNotebookDocument(ee);else if(typeof ee=="string")ze=f.URI.revive(await De.createNotebookDocument({viewType:ee,content:ae}));else throw new Error("Invalid arguments");return De.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(ee,ae,ze){return tt(Ue.onDidSaveNotebookDocument)(ee,ae,ze)},onDidChangeNotebookDocument(ee,ae,ze){return tt(Ue.onDidChangeNotebookDocument)(ee,ae,ze)},onWillSaveNotebookDocument(ee,ae,ze){return tt(wt.getOnWillSaveNotebookDocumentEvent(Ne))(ee,ae,ze)},get onDidOpenNotebookDocument(){return tt(De.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return tt(De.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ae,ze,ot){return De.registerNotebookSerializer(Ne,ee,ae,ze,(0,Ye.$RF)(Ne,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ae,ze)=>tt(Ui.onDidChangeConfiguration)(ee,ae,ze),getConfiguration(ee,ae){return ae=arguments.length===1?void 0:ae,Ui.getConfiguration(ee,ae,Ne)},registerTextDocumentContentProvider(ee,ae){return ue.registerTextDocumentContentProvider(ee,ae)},registerTaskProvider:(ee,ae)=>(Ct.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Ne,ee,ae)),registerFileSystemProvider(ee,ae,ze){return(0,L.$Qc)(Xi.registerFileSystemProvider(Ne,ee,ae,ze),ii.addFileSystemProvider(ee,ae,ze))},get fs(){return ii.value},registerFileSearchProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"fileSearchProvider"),ci.registerFileSearchProvider(ee,ae)),registerTextSearchProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"textSearchProvider"),ci.registerTextSearchProvider(ee,ae)),registerRemoteAuthorityResolver:(ee,ae)=>((0,Ye.$SF)(Ne,"resolvers"),Pt.registerRemoteAuthorityResolver(ee,ae)),registerResourceLabelFormatter:ee=>((0,Ye.$SF)(Ne,"resolvers"),Mi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$SF)(Ne,"resolvers"),Pt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ae,ze)=>tt(ui.onDidCreateFile)(ee,ae,ze),onDidDeleteFiles:(ee,ae,ze)=>tt(ui.onDidDeleteFile)(ee,ae,ze),onDidRenameFiles:(ee,ae,ze)=>tt(ui.onDidRenameFile)(ee,ae,ze),onWillCreateFiles:(ee,ae,ze)=>tt(ui.getOnWillCreateFileEvent(Ne))(ee,ae,ze),onWillDeleteFiles:(ee,ae,ze)=>tt(ui.getOnWillDeleteFileEvent(Ne))(ee,ae,ze),onWillRenameFiles:(ee,ae,ze)=>tt(ui.getOnWillRenameFileEvent(Ne))(ee,ae,ze),openTunnel:ee=>((0,Ye.$SF)(Ne,"tunnels"),Ft.openTunnel(Ne,ee).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ye.$SF)(Ne,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"tunnels"),tt(Ft.onDidChangeTunnels)(ee,ae,ze)),registerPortAttributesProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"portsAttributes"),Ft.registerPortsAttributesProvider(ee,ae)),registerTunnelProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"tunnelFactory"),Ft.registerTunnelProvider(ee,ae)),registerTimelineProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"timeline"),_i.registerTimelineProvider(ee,ae,Ne.identifier,bt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Ye.$SF)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ae,ze)=>tt(dt.onDidGrantWorkspaceTrust)(ee,ae,ze),registerEditSessionIdentityProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,ae)),onWillCreateEditSessionIdentity:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"editSessionIdentityProvider"),tt(dt.getOnWillCreateEditSessionIdentityEvent(Ne))(ee,ae,ze)),registerCanonicalUriProvider:(ee,ae)=>((0,Ye.$SF)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,ae)),getCanonicalUri:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(ee,ae,ze))},cn={get inputBox(){return Ct.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Ne)},createSourceControl(ee,ae,ze){return yi.createSourceControl(Ne,ee,ae,ze)}},pn={createCommentController(ee,ae){return hn.createCommentController(Ne,ee,ae)}},vn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get stackFrameFocus(){return kt.stackFrameFocus},registerDebugVisualizationProvider(ee,ae){return(0,Ye.$SF)(Ne,"debugVisualization"),kt.registerDebugVisualizationProvider(Ne,ee,ae)},registerDebugVisualizationTreeProvider(ee,ae){return(0,Ye.$SF)(Ne,"debugVisualization"),kt.registerDebugVisualizationTree(Ne,ee,ae)},onDidStartDebugSession(ee,ae,ze){return tt(kt.onDidStartDebugSession)(ee,ae,ze)},onDidTerminateDebugSession(ee,ae,ze){return tt(kt.onDidTerminateDebugSession)(ee,ae,ze)},onDidChangeActiveDebugSession(ee,ae,ze){return tt(kt.onDidChangeActiveDebugSession)(ee,ae,ze)},onDidReceiveDebugSessionCustomEvent(ee,ae,ze){return tt(kt.onDidReceiveDebugSessionCustomEvent)(ee,ae,ze)},onDidChangeBreakpoints(ee,ae,ze){return tt(kt.onDidChangeBreakpoints)(ee,ae,ze)},onDidChangeStackFrameFocus(ee,ae,ze){return(0,Ye.$SF)(Ne,"debugFocus"),tt(kt.onDidChangeStackFrameFocus)(ee,ae,ze)},registerDebugConfigurationProvider(ee,ae,ze){return kt.registerDebugConfigurationProvider(ee,ae,ze||Yt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ae){return kt.registerDebugAdapterDescriptorFactory(Ne,ee,ae)},registerDebugAdapterTrackerFactory(ee,ae){return kt.registerDebugAdapterTrackerFactory(ee,ae)},startDebugging(ee,ae,ze){return!ze||typeof ze=="object"&&"configuration"in ze?kt.startDebugging(ee,ae,{parentSession:ze}):kt.startDebugging(ee,ae,ze||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,ae){return kt.asDebugSourceUri(ee,ae)}},un={registerTaskProvider:(ee,ae)=>Qt.registerTaskProvider(Ne,ee,ae),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Ne,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,ae,ze)=>tt(Qt.onDidStartTask)(ee,ae,ze),onDidEndTask:(ee,ae,ze)=>tt(Qt.onDidEndTask)(ee,ae,ze),onDidStartTaskProcess:(ee,ae,ze)=>tt(Qt.onDidStartTaskProcess)(ee,ae,ze),onDidEndTaskProcess:(ee,ae,ze)=>tt(Qt.onDidEndTaskProcess)(ee,ae,ze)},ln={createNotebookController(ee,ae,ze,ot,vt){return Ke.createNotebookController(Ne,ee,ae,ze,ot,(0,Ye.$RF)(Ne,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ae)=>De.registerNotebookCellStatusBarItemProvider(Ne,ee,ae),createRendererMessaging(ee){return st.createRendererMessaging(Ne,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$SF)(Ne,"notebookKernelSource"),Ke.createNotebookControllerDetectionTask(Ne,ee)},registerKernelSourceActionProvider(ee,ae){return(0,Ye.$SF)(Ne,"notebookKernelSource"),Ke.registerKernelSourceActionProvider(Ne,ee,ae)},onDidChangeNotebookCellExecutionState(ee,ae,ze){return(0,Ye.$SF)(Ne,"notebookCellExecutionState"),tt(Ke.onDidChangeNotebookCellExecutionState)(ee,ae,ze)}},Wi={t(...ee){if(typeof ee[0]=="string"){const ae=ee.shift(),ze=!ee||typeof ee[0]!="object"?ee:ee[0];return Ht.getMessage(Ne.identifier.value,{message:ae,args:ze})}return Ht.getMessage(Ne.identifier.value,ee[0])},get bundle(){return Ht.getBundle(Ne.identifier.value)},get uri(){return Ht.getBundleUri(Ne.identifier.value)}},qi={_version:1,registerInteractiveEditorSessionProvider(ee,ae){return(0,Ye.$SF)(Ne,"interactive"),fn.registerProvider(Ne,ee,ae)},registerInteractiveSessionProvider(ee,ae){return(0,Ye.$SF)(Ne,"interactive"),wi.registerChatProvider(Ne,ee,ae)},sendInteractiveRequestToProvider(ee,ae){return(0,Ye.$SF)(Ne,"interactive"),wi.sendInteractiveRequestToProvider(ee,ae)},transferChatSession(ee,ae){return(0,Ye.$SF)(Ne,"interactive"),wi.transferChatSession(ee,ae)}},Hi={getRelatedInformation(ee,ae){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),Oi.getRelatedInformation(Ne,ee,ae)},registerRelatedInformationProvider(ee,ae){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(Ne,ee,ae)},registerEmbeddingVectorProvider(ee,ae){return(0,Ye.$SF)(Ne,"aiRelatedInformation"),tn.registerEmbeddingVectorProvider(Ne,ee,ae)}},Pi={registerChatResponseProvider(ee,ae,ze){return(0,Ye.$SF)(Ne,"chatProvider"),Si.registerLanguageModel(Ne,ee,ae,ze)},registerVariable(ee,ae,ze){return(0,Ye.$SF)(Ne,"chatAgents2"),gn.registerVariableResolver(Ne,ee,ae,ze)},registerMappedEditsProvider(ee,ae){return(0,Ye.$SF)(Ne,"mappedEditsProvider"),lt.registerMappedEditsProvider(Ne,ee,ae)},createChatAgent(ee,ae){return(0,Ye.$SF)(Ne,"chatAgents2"),en.createChatAgent(Ne,ee,ae)}},Ki={requestLanguageModelAccess(ee,ae){return(0,Ye.$SF)(Ne,"languageModels"),Si.requestLanguageModelAccess(Ne,ee,ae)},get languageModels(){return(0,Ye.$SF)(Ne,"languageModels"),Si.getLanguageModelIds()},onDidChangeLanguageModels:(ee,ae,ze)=>((0,Ye.$SF)(Ne,"languageModels"),Si.onDidChangeProviders(ee,ae,ze))},Gi={registerSpeechProvider(ee,ae){return(0,Ye.$SF)(Ne,"speech"),Ni.registerProvider(Ne.identifier,ee,ae)}};return{version:mt.version,ai:Hi,authentication:mn,commands:sn,comments:pn,chat:Pi,debug:vn,env:ji,extensions:on,interactive:qi,l10n:Wi,languages:Bi,lm:Ki,notebooks:ln,scm:cn,speech:Gi,tasks:un,tests:$n,window:an,workspace:Vi,Breakpoint:Te.$WM,TerminalOutputAnchor:Te.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Te.ChatAgentResultFeedbackKind,ChatVariableLevel:Te.ChatVariableLevel,ChatAgentCompletionItem:Te.$PN,CallHierarchyIncomingCall:Te.$jM,CallHierarchyItem:Te.$iM,CallHierarchyOutgoingCall:Te.$kM,CancellationError:F.$5,CancellationTokenSource:S.$ae,CandidatePortSource:n.CandidatePortSource,CodeAction:Te.$fM,CodeActionKind:Te.$gM,CodeActionTriggerKind:Te.CodeActionTriggerKind,CodeLens:Te.$lM,Color:Te.$yM,ColorInformation:Te.$zM,ColorPresentation:Te.$AM,ColorThemeKind:Te.ColorThemeKind,CommentMode:Te.CommentMode,CommentState:Te.CommentState,CommentThreadCollapsibleState:Te.CommentThreadCollapsibleState,CommentThreadState:Te.CommentThreadState,CompletionItem:Te.$sM,CompletionItemKind:Te.CompletionItemKind,CompletionItemTag:Te.CompletionItemTag,CompletionList:Te.$tM,CompletionTriggerKind:Te.CompletionTriggerKind,ConfigurationTarget:Te.ConfigurationTarget,CustomExecution:Te.$IM,DebugAdapterExecutable:Te.$1M,DebugAdapterInlineImplementation:Te.$4M,DebugAdapterNamedPipeServer:Te.$3M,DebugAdapterServer:Te.$2M,DebugConfigurationProviderTriggerKind:Yt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Te.DebugConsoleMode,DebugVisualization:Te.$hN,DecorationRangeBehavior:Te.DecorationRangeBehavior,Diagnostic:Te.$_L,DiagnosticRelatedInformation:Te.$$L,DiagnosticSeverity:Te.DiagnosticSeverity,DiagnosticTag:Te.DiagnosticTag,Disposable:Te.$XL,DocumentHighlight:Te.$bM,DocumentHighlightKind:Te.DocumentHighlightKind,MultiDocumentHighlight:Te.$cM,DocumentLink:Te.$xM,DocumentSymbol:Te.$eM,EndOfLine:Te.EndOfLine,EnvironmentVariableMutatorType:Te.EnvironmentVariableMutatorType,EvaluatableExpression:Te.$7M,InlineValueText:Te.$8M,InlineValueVariableLookup:Te.$9M,InlineValueEvaluatableExpression:Te.$0M,InlineCompletionTriggerKind:Te.InlineCompletionTriggerKind,EventEmitter:P.$3d,ExtensionKind:Te.ExtensionKind,ExtensionMode:Te.ExtensionMode,ExternalUriOpenerPriority:Te.ExternalUriOpenerPriority,FileChangeType:Te.FileChangeType,FileDecoration:Te.$jN,FileDecoration2:Te.$jN,FileSystemError:Te.$aN,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Te.$bN,FoldingRangeKind:Te.FoldingRangeKind,FunctionBreakpoint:Te.$YM,InlineCompletionItem:Te.$uM,InlineCompletionList:Te.$vM,Hover:Te.$aM,IndentAction:k.IndentAction,Location:Te.$0L,MarkdownString:Te.$mM,OverviewRulerLane:h.OverviewRulerLane,ParameterInformation:Te.$nM,PortAutoForwardAction:Te.PortAutoForwardAction,Position:Te.$YL,ProcessExecution:Te.$GM,ProgressLocation:Te.ProgressLocation,QuickInputButtons:Te.$iN,Range:Te.$ZL,RelativePattern:Te.$UM,Selection:Te.$1L,SelectionRange:Te.$hM,SemanticTokens:Te.$eN,SemanticTokensBuilder:Te.$dN,SemanticTokensEdit:Te.$fN,SemanticTokensEdits:Te.$gN,SemanticTokensLegend:Te.$cN,ShellExecution:Te.$HM,ShellQuoting:Te.ShellQuoting,SignatureHelp:Te.$pM,SignatureHelpTriggerKind:Te.SignatureHelpTriggerKind,SignatureInformation:Te.$oM,SnippetString:Te.$9L,SourceBreakpoint:Te.$XM,StandardTokenType:Te.StandardTokenType,StatusBarAlignment:Te.StatusBarAlignment,SymbolInformation:Te.$dM,SymbolKind:Te.SymbolKind,SymbolTag:Te.SymbolTag,Task:Te.$JM,TaskGroup:Te.$FM,TaskPanelKind:Te.TaskPanelKind,TaskRevealKind:Te.TaskRevealKind,TaskScope:Te.TaskScope,TerminalLink:Te.$BM,TerminalQuickFixTerminalCommand:Te.$DM,TerminalQuickFixOpener:Te.$CM,TerminalLocation:Te.TerminalLocation,TerminalProfile:Te.$EM,TerminalExitReason:Te.TerminalExitReason,TextDocumentSaveReason:Te.TextDocumentSaveReason,TextEdit:Te.$5L,SnippetTextEdit:Te.$7L,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:Te.TextEditorLineNumbersStyle,TextEditorRevealType:Te.TextEditorRevealType,TextEditorSelectionChangeKind:Te.TextEditorSelectionChangeKind,SyntaxTokenType:Te.SyntaxTokenType,TextDocumentChangeReason:Te.TextDocumentChangeReason,ThemeColor:Te.$TM,ThemeIcon:Te.$SM,TreeItem:Te.$KM,TreeItemCheckboxState:Te.TreeItemCheckboxState,TreeItemCollapsibleState:Te.TreeItemCollapsibleState,TypeHierarchyItem:Te.$EN,UIKind:_t.UIKind,Uri:f.URI,ViewColumn:Te.ViewColumn,WorkspaceEdit:Te.$8L,DocumentDropEdit:Te.$QM,DocumentPasteEdit:Te.$RM,InlayHint:Te.$rM,InlayHintLabelPart:Te.$qM,InlayHintKind:Te.InlayHintKind,RemoteAuthorityResolverError:Te.$4L,ResolvedAuthority:Te.$2L,ManagedResolvedAuthority:Te.$3L,SourceControlInputBoxValidationType:Te.SourceControlInputBoxValidationType,ExtensionRuntime:Te.ExtensionRuntime,TimelineItem:Te.$tN,NotebookRange:Te.$lN,NotebookCellKind:Te.NotebookCellKind,NotebookCellExecutionState:Te.NotebookCellExecutionState,NotebookCellData:Te.$mN,NotebookData:Te.$nN,NotebookRendererScript:Te.$rN,NotebookCellStatusBarAlignment:Te.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Te.NotebookEditorRevealType,NotebookCellOutput:Te.$pN,NotebookCellOutputItem:Te.$oN,NotebookCellStatusBarItem:Te.$qN,NotebookControllerAffinity:Te.NotebookControllerAffinity,NotebookControllerAffinity2:Te.NotebookControllerAffinity2,NotebookEdit:Te.$6L,NotebookKernelSourceAction:Te.$sN,NotebookVariablesRequestKind:Te.NotebookVariablesRequestKind,PortAttributes:Te.$vN,LinkedEditingRanges:Te.$uN,TestResultState:Te.TestResultState,TestRunRequest:Te.$wN,TestMessage:Te.$xN,TestTag:Te.$yN,TestRunProfileKind:Te.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Te.$PM,DataTransferItem:Te.$LM,CoveredCount:Te.$zN,FileCoverage:Te.$AN,StatementCoverage:Te.$BN,BranchCoverage:Te.$CN,DeclarationCoverage:Te.$DN,FunctionCoverage:Te.$DN,WorkspaceTrustState:Te.WorkspaceTrustState,LanguageStatusSeverity:Te.LanguageStatusSeverity,QuickPickItemKind:Te.QuickPickItemKind,InputBoxValidationSeverity:Te.InputBoxValidationSeverity,TabInputText:Te.$FN,TabInputTextDiff:Te.$GN,TabInputTextMerge:Te.$HN,TabInputCustom:Te.$IN,TabInputNotebook:Te.$KN,TabInputNotebookDiff:Te.$LN,TabInputWebview:Te.$JN,TabInputTerminal:Te.$MN,TabInputInteractiveWindow:Te.$NN,TabInputChat:Te.$ON,TelemetryTrustedValue:r.$Uo,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Te.InteractiveSessionVoteDirection,ChatAgentCopyKind:Te.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Te.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Te.$5M,ThreadFocus:Te.$6M,RelatedInformationType:Te.RelatedInformationType,SpeechToTextStatus:Te.SpeechToTextStatus,KeywordRecognitionStatus:Te.KeywordRecognitionStatus,ChatResponseTextPart:Te.$QN,ChatResponseMarkdownPart:Te.$RN,ChatResponseFileTreePart:Te.$SN,ChatResponseAnchorPart:Te.$TN,ChatResponseProgressPart:Te.$UN,ChatResponseReferencePart:Te.$WN,ChatResponseCommandButtonPart:Te.$VN,ChatAgentRequestTurn:Te.$XN,ChatAgentResponseTurn:Te.$YN,LanguageModelSystemMessage:Te.$ZN,LanguageModelUserMessage:Te.$1N,LanguageModelAssistantMessage:Te.$2N,NewSymbolName:Te.$_M,NewSymbolNameTag:Te.NewSymbolNameTag}}}e.$$ic=ti}),define(Fe[294],Le([1,0,53,113,36,108,37,31,66,65,116,118,119,82,85,78,107,62,43,81,60,64,230,14,117,79,80]),function(fe,e,S,F,P,L,R,g,f,D,A,k,h,v,p,s,u,r,i,n,o,l,t,m,a,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$8r)(c.$Zhc,c.$Yhc,1),(0,S.$8r)(m.$xj,t.$_ic,1),(0,S.$8r)(s.$6gc,s.$7gc,1),(0,S.$8r)(g.$wO,g.$vO,0),(0,S.$8r)(R.$thc,R.$rhc,0),(0,S.$8r)(r.$vhc,r.$uhc,0),(0,S.$8r)(k.$0hc,k.$bic,0),(0,S.$8r)(L.$dic,L.$cic,0),(0,S.$8r)(f.$lO,f.$kO,0),(0,S.$8r)(E.$1hc,E.$2hc,0),(0,S.$8r)(i.$0gc,i.$9gc,0),(0,S.$8r)(F.$Jic,F.$Iic,1),(0,S.$8r)(h.$tic,h.$uic,0),(0,S.$8r)(v.$Ohc,v.$Nhc,0),(0,S.$8r)(A.$Wic,A.$Vic,0),(0,S.$8r)(D.$Rhc,D.$Uhc,0),(0,S.$8r)(p.$Rzb,p.$Szb,0),(0,S.$8r)(u.$0ic,u.$9ic,0),(0,S.$8r)(P.$qhc,P.$phc,0),(0,S.$8r)(n.$Whc,n.$Vhc,0),(0,S.$8r)(o.$uO,o.$rO,0),(0,S.$8r)(l.$Fhc,l.$Ghc,0),(0,S.$8r)(a.$8hc,a.$9hc,0)}),define(Fe[295],Le([1,0,293,38,2,290,7,11,236]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=void 0;class D extends L.$cjc{j(){}getModule(v,p){for(const s of this.b){const u=s(v);if(u){v=u;break}}if(this.a.has(v))return this.a.get(v).load(v,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends F.$4hc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(f.$jlc);const v=this.h.invokeFunction(S.$$ic);this.r=this.h.createInstance(D,v,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(v){return v.browser}async vb(v,p,s){p=p.with({path:k(p.path,".js")});const u=v?.identifier.value;u&&performance.mark(`code/extHost/willFetchExtensionCode/${u}`);const r=P.URI.revive(await this.C.$asBrowserUri(p)),i=await fetch(r.toString(!0));if(u&&performance.mark(`code/extHost/didFetchExtensionCode/${u}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),o=`${p.toString(!0)}#vscode-extension`,l=`${n}
//# sourceURL=${o}`;let t;try{t=new Function("module","exports","require",l)}catch(E){throw console.error(u?`Loading code for extension ${u} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${p.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}v&&await this.w.initializeLocalizedMessages(v);const m={},a={exports:m},c=E=>{const y=this.r.getModule(E,p);if(y===void 0)throw new Error(`Cannot load module '${E}'`);return y};try{return s.codeLoadingStart(),u&&performance.mark(`code/extHost/willLoadExtensionCode/${u}`),t(a,m,c),a.exports!==m?a.exports:m}finally{u&&performance.mark(`code/extHost/didLoadExtensionCode/${u}`),s.codeLoadingStop()}}async $setRemoteEnvironment(v){}async zb(v=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+v;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,g.$dh)(10)}}e.$klc=A;function k(h,v){return h.endsWith(v)?h:h+v}}),define(Fe[296],Le([1,0,70,53,14,38,201,84,295]),function(fe,e,S,F,P,L,R,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$8r)(P.$wj,new S.$_h(R.$bjc,[!0],!0)),(0,F.$8r)(L.$5hc,f.$klc,0),(0,F.$8r)(g.$whc,g.$xhc,0)}),define(Fe[301],Le([1,0,24,5,77,291,238,19,87,12,2,294,296]),function(fe,e,S,F,P,L,R,g,f,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const h=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function v(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function s(t){self.fetch=async function(m,a){return m instanceof Request||v(String(m))&&(m=(await t(A.URI.parse(String(m)))).toString(!0)),p(m,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,a,c,E,y){(async()=>(v(a.toString())&&(a=(await t(A.URI.parse(a.toString()))).toString(!0)),super.open(m,a,c??!0,E,y)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(m,a){if(/^file:/i.test(m.toString()))m=D.$wg.uriToBrowserUri(A.URI.parse(m.toString())).toString(!0);else if(/^vscode-remote:/i.test(m.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(d){function w(T){return typeof T=="string"||T instanceof URL?String(T).replace(/^file:\/\//i,"vscode-file://vscode-app"):T}const b=fetch.bind(self);self.fetch=function(T,G){return T instanceof Request?b(T,G):b(w(T),G)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,G,W,U,C){return super.open(T,w(G),W??!0,U,C)}};const M=importScripts.bind(self);self.importScripts=(...T)=>{M(...T.map(w))},M(d)}.toString()}('${m}'))`;a=a||{},a.name=`${name} -> ${a.name||g.$nc(m.toString())}`;const y=new Blob([E],{type:"application/javascript"}),$=URL.createObjectURL(y);return new t($,a)}}else self.Worker=class extends R.$llc{constructor(t,m){super(h,t,{name:g.$nc(t.toString()),...m})}};const u=new class{constructor(){this.pid=void 0}exit(t){k()}};class r{constructor(){const m=new MessageChannel,a=new F.$3d;let c=!1;h(m.port2,[m.port2]),m.port1.onmessage=E=>{const{data:y}=E;if(!(y instanceof ArrayBuffer)){console.warn("UNKNOWN data received",y);return}const $=S.$qe.wrap(new Uint8Array(y,0,y.byteLength));if((0,P.$Dm)($,2)){c=!0,n("received terminate message from renderer");return}a.fire($)},this.protocol={onMessage:a.event,send:E=>{if(!c){const y=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);m.port1.postMessage(y,[y])}}}}}function i(t){return new Promise(m=>{const a=t.onMessage(c=>{a.dispose();const E=JSON.parse(c.toString());t.send((0,P.$Cm)(0)),m({protocol:t,initData:E})});t.send((0,P.$Cm)(1))})}let n=t=>k();function o(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function l(){f.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(m){o(m)&&i(t.protocol).then(a=>{f.mark("code/extHost/didWaitForInitData");const c=new L.$ejc(a.protocol,a.initData,u,null,m.data);s(E=>c.asBrowserUri(E)),n=E=>c.terminate(E)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d84c946d27b649d614319c796911871320befd42/core/vs/workbench/api/worker/extensionHostWorker.js.map
