/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],W=function(B){for(var e=[],A=0,S=B.length;A<S;A++)e[A]=V[B[A]];return e};define(V[23],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const k=new Map,O=new Map,r=new Map,f=new Map;function t(a,i){a.has(i.detail)||a.set(i.detail,-i.timestamp)}function l(a,i){const n=a.get(i.detail);n&&(n>=0||a.set(i.detail,n+i.timestamp))}let $=[];typeof B=="function"&&typeof B.getStats=="function"&&($=B.getStats().slice(0).sort((a,i)=>a.timestamp-i.timestamp));for(const a of $)switch(a.type){case 10:t(k,a);break;case 11:case 12:l(k,a);break;case 21:t(O,a);break;case 22:l(O,a);break;case 33:t(r,a);break;case 34:l(r,a);break;case 31:t(f,a);break;case 32:l(f,a);break}let d=0;r.forEach(a=>d+=a);function h(a){const i=[];return a.forEach((n,s)=>i.push([s,n])),i}return{amdLoad:h(k),amdInvoke:h(O),nodeRequire:h(r),nodeEval:h(f),nodeRequireTotal:d}}static toMarkdownTable(k,O){let r="";const f=[];return k.forEach((t,l)=>{f[l]=t.length}),O.forEach(t=>{t.forEach((l,$)=>{typeof l>"u"&&(l=t[$]="-");const d=l.toString().length;f[$]=Math.max(d,f[$])})}),k.forEach((t,l)=>{r+=`| ${t+" ".repeat(f[l]-t.toString().length)} `}),r+=`|
`,k.forEach((t,l)=>{r+=`| ${"-".repeat(f[l])} `}),r+=`|
`,O.forEach(t=>{t.forEach((l,$)=>{typeof l<"u"&&(r+=`| ${l+" ".repeat(f[$]-l.toString().length)} `)}),r+=`|
`}),r}}e.$U=A}),define(V[5],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=void 0;class A{constructor(i,n,s){this.owner=i,this.debugNameSource=n,this.referenceFn=s}getDebugName(i){return O(i,this)}}e.$5c=A;const S=new Map,k=new WeakMap;function O(a,i){const n=k.get(a);if(n)return n;const s=r(a,i);if(s){let g=S.get(s)??0;g++,S.set(s,g);const y=g===1?s:`${s}#${g}`;return k.set(a,y),y}}e.$6c=O;function r(a,i){const n=k.get(a);if(n)return n;const s=i.owner?$(i.owner)+".":"";let g;const y=i.debugNameSource;if(y!==void 0)if(typeof y=="function"){if(g=y(),g!==void 0)return s+g}else return s+y;const P=i.referenceFn;if(P!==void 0&&(g=h(P),g!==void 0))return s+g;if(i.owner!==void 0){const N=f(i.owner,a);if(N!==void 0)return s+N}}function f(a,i){for(const n in a)if(a[n]===i)return n}const t=new Map,l=new WeakMap;function $(a){const i=l.get(a);if(i)return i;const n=d(a);let s=t.get(n)??0;s++,t.set(n,s);const g=s===1?n:`${n}#${s}`;return l.set(a,g),g}function d(a){const i=a.constructor;return i?i.name:"Object"}function h(a){const i=a.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(i);return(s?s[1]:void 0)?.trim()}e.$7c=h}),define(V[4],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yd=e.$xd=e.$wd=void 0;let A;function S(n){A=n}e.$wd=S;function k(){return A}e.$xd=k;class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return r([f(a("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[f(" "),l($(s.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),l($(s.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),l($(s.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(s,g){console.log(...this.b([t("observable value changed"),l(s.debugName,{color:"BlueViolet"}),...this.c(g)]))}formatChanges(s){if(s.size!==0)return l(" (changed deps: "+[...s].map(g=>g.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const g=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,P)=>(this.d.get(s).add(y),g.apply(s,[y,P]))}handleDerivedRecomputed(s,g){const y=this.d.get(s);console.log(...this.b([t("derived recomputed"),l(s.debugName,{color:"BlueViolet"}),...this.c(g),this.formatChanges(y),{data:[{fn:s._computeFn}]}])),y.clear()}handleFromEventObservableTriggered(s,g){console.log(...this.b([t("observable from event triggered"),l(s.debugName,{color:"BlueViolet"}),...this.c(g),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const g=s.handleChange;this.d.set(s,new Set),s.handleChange=(y,P)=>(this.d.get(s).add(y),g.apply(s,[y,P]))}handleAutorunTriggered(s){const g=this.d.get(s);console.log(...this.b([t("autorun"),l(s.debugName,{color:"BlueViolet"}),this.formatChanges(g),{data:[{fn:s._runFn}]}])),g.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let g=s.getDebugName();g===void 0&&(g=""),console.log(...this.b([t("transaction"),l(g,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$yd=O;function r(n){const s=new Array,g=[];let y="";function P(E){if("length"in E)for(const c of E)c&&P(c);else"text"in E?(y+=`%c${E.text}`,s.push(E.style),E.data&&g.push(...E.data)):"data"in E&&g.push(...E.data)}P(n);const N=[y,...s];return N.push(...g),N}function f(n){return l(n,{color:"black"})}function t(n){return l(i(`${n}: `,10),{color:"black",bold:!0})}function l(n,s={color:"black"}){function g(P){return Object.entries(P).reduce((N,[E,c])=>`${N}${E}:${c};`,"")}const y={color:s.color};return s.strikeThrough&&(y["text-decoration"]="line-through"),s.bold&&(y["font-weight"]="bold"),{text:n,style:g(y)}}function $(n,s){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=s?`"${n}"`:`"${n.substr(0,s-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?d(n,s):h(n,s);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function d(n,s){let g="[ ",y=!0;for(const P of n){if(y||(g+=", "),g.length-5>s){g+="...";break}y=!1,g+=`${$(P,s-g.length)}`}return g+=" ]",g}function h(n,s){let g="{ ",y=!0;for(const[P,N]of Object.entries(n)){if(y||(g+=", "),g.length-5>s){g+="...";break}y=!1,g+=`${P}: ${$(N,s-g.length)}`}return g+=" }",g}function a(n,s){let g="";for(let y=1;y<=s;y++)g+=n;return g}function i(n,s){for(;n.length<s;)n+=" ";return n}}),define(V[7],W([0,1,24,2,5,4]),function(B,e,A,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.$bd=void 0;function r(i){return new a(new k.$5c(void 0,void 0,i),i,void 0,void 0)}e.$bd=r;function f(i,n){return new a(new k.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,void 0,void 0)}e.$cd=f;function t(i,n){return new a(new k.$5c(i.owner,i.debugName,i.debugReferenceFn??n),n,i.createEmptyChangeSummary,i.handleChange)}e.$dd=t;function l(i,n){const s=new S.$Sc,g=t({owner:i.owner,debugName:i.debugName,debugReferenceFn:i.debugReferenceFn,createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(y,P)=>{s.clear(),n(y,P,s)});return(0,S.$Rc)(()=>{g.dispose(),s.dispose()})}e.$ed=l;function $(i){const n=new S.$Sc,s=f({owner:void 0,debugName:void 0,debugReferenceFn:i},g=>{n.clear(),i(g,n)});return(0,S.$Rc)(()=>{s.dispose(),n.dispose()})}e.$fd=$;function d(i,n){let s;return f({debugReferenceFn:n},g=>{const y=i.read(g),P=s;s=y,n({lastValue:P,newValue:y})})}e.$gd=d;var h;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class a{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(n,s,g,y){this.h=n,this._runFn=s,this.i=g,this.j=y,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,O.$xd)()?.handleAutorunCreated(this),this.k(),(0,S.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,S.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const s=this.c;try{if(!s){(0,O.$xd)()?.handleAutorunTriggered(this);const g=this.g;this.g=this.i?.(),this._runFn(this,g)}}finally{s||(0,O.$xd)()?.handleAutorunFinished(this);for(const g of this.f)g.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,A.$_c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,s){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:s,didChange:y=>y===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const s=n.get();return this.e.add(n),this.f.delete(n),s}}e.$hd=a,function(i){i.Observer=a}(r||(e.$bd=r={}))}),define(V[6],W([0,1,5,4]),function(B,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;let k;function O(c){k=c}e.$Fd=O;let r;function f(c){r=c}e.$Gd=f;let t;function l(c){t=c}e.$Hd=l;class ${get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,w){const D=w===void 0?void 0:b,M=w===void 0?b:w;return t({owner:D,debugName:()=>{const o=(0,A.$7c)(M);if(o!==void 0)return o;const j=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(M.toString());if(j)return`${this.debugName}.${j[2]}`;if(!D)return`${this.debugName} (mapped)`}},o=>M(this.read(o),o))}recomputeInitiallyAndOnChange(b,w){return b.add(k(this,w)),this}keepObserved(b){return b.add(r(this)),this}}e.$Id=$;class d extends ${constructor(){super(...arguments),this.c=new Set}addObserver(b){const w=this.c.size;this.c.add(b),w===0&&this.f()}removeObserver(b){this.c.delete(b)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Jd=d;function h(c,b){const w=new g(c,b);try{c(w)}finally{w.finish()}}e.$Kd=h;let a;function i(c){if(a)c(a);else{const b=new g(c,void 0);a=b;try{c(b)}finally{b.finish(),a=void 0}}}e.$Ld=i;async function n(c,b){const w=new g(c,b);try{await c(w)}finally{w.finish()}}e.$Md=n;function s(c,b,w){c?b(c):h(b,w)}e.$Nd=s;class g{constructor(b,w){this._fn=b,this.b=w,this.a=[],(0,S.$xd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,A.$7c)(this._fn)}updateObserver(b,w){this.a.push({observer:b,observable:w}),b.beginUpdate(w)}finish(){const b=this.a;for(let w=0;w<b.length;w++){const{observer:D,observable:M}=b[w];D.endUpdate(M)}this.a=null,(0,S.$xd)()?.handleEndTransaction()}}e.$Od=g;function y(c,b){return typeof c=="string"?new P(void 0,c,b):new P(c,void 0,b)}e.$Pd=y;class P extends d{get debugName(){return new A.$5c(this.b,this.d,void 0).getDebugName(this)??"ObservableValue"}constructor(b,w,D){super(),this.b=b,this.d=w,this.a=D}get(){return this.a}set(b,w,D){if(this.a===b)return;let M;w||(w=M=new g(()=>{},()=>`Setting ${this.debugName}`));try{const o=this.a;this.e(b),(0,S.$xd)()?.handleObservableChanged(this,{oldValue:o,newValue:b,change:D,didChange:!0,hadValue:!0});for(const T of this.c)w.updateObserver(T,this),T.handleChange(this,D)}finally{M&&M.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(b){this.a=b}}e.$Qd=P;function N(c,b){return typeof c=="string"?new E(void 0,c,b):new E(c,void 0,b)}e.$Rd=N;class E extends P{e(b){this.a!==b&&(this.a&&this.a.dispose(),this.a=b)}dispose(){this.a?.dispose()}}e.$Sd=E}),define(V[8],W([0,1,24,2,6,5,4]),function(B,e,A,S,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=void 0;const f=(n,s)=>n===s;function t(n,s){return s!==void 0?new i(new O.$5c(n,void 0,s),s,void 0,void 0,void 0,f):new i(new O.$5c(void 0,void 0,n),n,void 0,void 0,void 0,f)}e.$zd=t;function l(n,s){return new i(new O.$5c(n.owner,n.debugName,n.debugReferenceFn),s,void 0,void 0,n.onLastObserverRemoved,n.equalityComparer??f)}e.$Ad=l,(0,k.$Hd)(l);function $(n,s){return new i(new O.$5c(n.owner,n.debugName,void 0),s,n.createEmptyChangeSummary,n.handleChange,void 0,n.equalityComparer??f)}e.$Bd=$;function d(n,s){let g,y;s===void 0?(g=n,y=void 0):(y=n,g=s);const P=new S.$Sc;return new i(new O.$5c(y,void 0,g),N=>(P.clear(),g(N,P)),void 0,void 0,()=>P.dispose(),f)}e.$Cd=d;function h(n,s){let g,y;s===void 0?(g=n,y=void 0):(y=n,g=s);const P=new S.$Sc;return new i(new O.$5c(y,void 0,g),N=>{P.clear();const E=g(N);return E&&P.add(E),E},void 0,void 0,()=>P.dispose(),f)}e.$Dd=h;var a;(function(n){n[n.initial=0]="initial",n[n.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",n[n.stale=2]="stale",n[n.upToDate=3]="upToDate"})(a||(a={}));class i extends k.$Jd{get debugName(){return this.n.getDebugName(this)??"(anonymous)"}constructor(s,g,y,P,N=void 0,E){super(),this.n=s,this._computeFn=g,this.p=y,this.q=P,this.s=N,this.t=E,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.p?.(),(0,r.$xd)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const s of this.k)s.removeObserver(this);this.k.clear(),this.s?.()}get(){if(this.c.size===0){const s=this._computeFn(this,this.p?.());return this.g(),s}else{do{if(this.e===1){for(const s of this.k)if(s.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.v()}while(this.e!==3);return this.h}}v(){if(this.e===3)return;const s=this.l;this.l=this.k,this.k=s;const g=this.e!==0,y=this.h;this.e=3;const P=this.m;this.m=this.p?.();try{this.h=this._computeFn(this,P)}finally{for(const E of this.l)E.removeObserver(this);this.l.clear()}const N=g&&!this.t(y,this.h);if((0,r.$xd)()?.handleDerivedRecomputed(this,{oldValue:y,newValue:this.h,change:void 0,didChange:N,hadValue:g}),N)for(const E of this.c)E.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(s){this.j++;const g=this.j===1;if(this.e===3&&(this.e=1,!g))for(const y of this.c)y.handlePossibleChange(this);if(g)for(const y of this.c)y.beginUpdate(this)}endUpdate(s){if(this.j--,this.j===0){const g=[...this.c];for(const y of g)y.endUpdate(this)}(0,A.$_c)(()=>this.j>=0)}handlePossibleChange(s){if(this.e===3&&this.k.has(s)&&!this.l.has(s)){this.e=1;for(const g of this.c)g.handlePossibleChange(this)}}handleChange(s,g){if(this.k.has(s)&&!this.l.has(s)){const y=this.q?this.q({changedObservable:s,change:g,didChange:N=>N===s},this.m):!0,P=this.e===3;if(y&&(this.e===1||P)&&(this.e=2,P))for(const N of this.c)N.handlePossibleChange(this)}}readObservable(s){s.addObserver(this);const g=s.get();return this.k.add(s),this.l.delete(s),g}addObserver(s){const g=!this.c.has(s)&&this.j>0;super.addObserver(s),g&&s.beginUpdate(this)}removeObserver(s){const g=this.c.has(s)&&this.j>0;super.removeObserver(s),g&&s.endUpdate(this)}}e.$Ed=i}),define(V[25],W([0,1,7,6,8]),function(B,e,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=void 0;class O{get cachedValue(){return this.a}constructor(d){this.b=d,this.a=(0,S.$Pd)(this,void 0)}getValue(){let d=this.a.get();return d||(d=this.b(),this.a.set(d,void 0)),d}}e.$Td=O;class r{constructor(d){this.a=(0,S.$Pd)(this,void 0),this.value=this.a,this.promise=d.then(h=>(this.a.set(new f(h,void 0),void 0),h),h=>{throw this.a.set(new f(void 0,h),void 0),h})}}e.$Ud=r;class f{constructor(d,h){this.value=d,this.error=h}getValue(){if(this.error)throw this.error;return this.value}}e.$Vd=f;class t{constructor(d){this.b=d,this.a=new O(()=>new r(this.b())),this.cachedValue=(0,k.$zd)(this,h=>this.a.cachedValue.read(h)?.value.read(h))}getValue(){return this.a.getValue().promise}}e.$Wd=t;function l($,d,h){return new Promise((a,i)=>{let n=!0,s=!1;const g=$.map(P=>({isFinished:d(P),error:h?h(P):!1,state:P})),y=(0,A.$bd)(P=>{const{isFinished:N,error:E,state:c}=g.read(P);(N||E)&&(n?s=!0:y.dispose(),E?i(E===!0?c:E):a(c))});n=!1,s&&y.dispose()})}e.$Xd=l}),define(V[26],W([0,1,2,7,6,5,8,4]),function(B,e,A,S,k,O,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=void 0;function t(M){return new l(M)}e.$id=t;class l extends k.$Id{constructor(o){super(),this.a=o}get debugName(){return this.toString()}get(){return this.a}addObserver(o){}removeObserver(o){}toString(){return`Const: ${this.a}`}}function $(M){const o=(0,k.$Pd)("promiseValue",{});return M.then(T=>{o.set({value:T},void 0)}),o}e.$jd=$;function d(M,o){return new h(M,o)}e.$kd=d;class h extends k.$Jd{constructor(o,T){super(),this.e=o,this._getValue=T,this.b=!1,this.k=j=>{const U=this._getValue(j),C=this.a,m=!this.b||C!==U;let R=!1;m&&(this.a=U,this.b&&(R=!0,(0,k.$Nd)(h.globalTransaction,q=>{(0,f.$xd)()?.handleFromEventObservableTriggered(this,{oldValue:C,newValue:U,change:void 0,didChange:m,hadValue:this.b});for(const G of this.c)q.updateObserver(G,this),G.handleChange(this,void 0)},()=>{const q=this.h();return"Event fired"+(q?`: ${q}`:"")})),this.b=!0),R||(0,f.$xd)()?.handleFromEventObservableTriggered(this,{oldValue:C,newValue:U,change:void 0,didChange:m,hadValue:this.b})}}h(){return(0,O.$7c)(this._getValue)}get debugName(){const o=this.h();return"From Event"+(o?`: ${o}`:"")}f(){this.d=this.e(this.k)}g(){this.d.dispose(),this.d=void 0,this.b=!1,this.a=void 0}get(){return this.d?(this.b||this.k(void 0),this.a):this._getValue(void 0)}}e.$ld=h,function(M){M.Observer=h;function o(T,j){let U=!1;h.globalTransaction===void 0&&(h.globalTransaction=T,U=!0);try{j()}finally{U&&(h.globalTransaction=void 0)}}M.batchEventsGlobally=o}(d||(e.$kd=d={}));function a(M,o){return new i(M,o)}e.$md=a;class i extends k.$Jd{constructor(o,T){super(),this.debugName=o,this.b=T,this.e=()=>{(0,k.$Kd)(j=>{for(const U of this.c)j.updateObserver(U,this),U.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.e)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(M){return typeof M=="string"?new s(M):new s(void 0,M)}e.$nd=n;class s extends k.$Jd{get debugName(){return new O.$5c(this.b,this.a,void 0).getDebugName(this)??"Observable Signal"}constructor(o,T){super(),this.a=o,this.b=T}trigger(o,T){if(!o){(0,k.$Kd)(j=>{this.trigger(j,T)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.c)o.updateObserver(j,this),j.handleChange(this,T)}get(){}}function g(M,o,T){const j=(0,k.$Pd)("debounced",void 0);let U;return T.add((0,S.$bd)(C=>{const m=M.read(C);U&&clearTimeout(U),U=setTimeout(()=>{(0,k.$Kd)(R=>{j.set(m,R)})},o)})),j}e.$od=g;function y(M,o,T){const j=(0,k.$Pd)("triggeredRecently",!1);let U;return T.add(M(()=>{j.set(!0,void 0),U&&clearTimeout(U),U=setTimeout(()=>{j.set(!1,void 0)},o)})),j}e.$pd=y;function P(M){const o=new E(!1,void 0);return M.addObserver(o),(0,A.$Rc)(()=>{M.removeObserver(o)})}e.$qd=P,(0,k.$Gd)(P);function N(M,o){const T=new E(!0,o);return M.addObserver(T),o?o(M.get()):M.reportChanges(),(0,A.$Rc)(()=>{M.removeObserver(T)})}e.$rd=N,(0,k.$Fd)(N);class E{constructor(o,T){this.b=o,this.c=T,this.a=0}beginUpdate(o){this.a++}endUpdate(o){this.a--,this.a===0&&this.b&&(this.c?this.c(o.get()):o.reportChanges())}handlePossibleChange(o){}handleChange(o,T){}}e.$sd=E;function c(M){let o;return(0,r.$zd)(j=>(o=M(j,o),o))}e.$td=c;function b(M,o){let T;const j=(0,k.$Pd)("derivedObservableWithWritableCache.counter",0),U=(0,r.$zd)(M,C=>(j.read(C),T=o(C,T),T));return Object.assign(U,{clearCache:C=>{T=void 0,j.set(j.get()+1,C)}})}e.$ud=b;function w(M,o,T,j){let U=new D(T,j);return(0,r.$Ad)({debugReferenceFn:T,owner:M,onLastObserverRemoved:()=>{U.dispose(),U=new D(T)}},m=>(U.setItems(o.read(m)),U.getItems()))}e.$vd=w;class D{constructor(o,T){this.c=o,this.d=T,this.a=new Map,this.b=[]}dispose(){this.a.forEach(o=>o.store.dispose()),this.a.clear()}setItems(o){const T=[],j=new Set(this.a.keys());for(const U of o){const C=this.d?this.d(U):U;let m=this.a.get(C);if(m)j.delete(C);else{const R=new A.$Sc;m={out:this.c(U,R),store:R},this.a.set(C,m)}T.push(m.out)}for(const U of j)this.a.get(U).store.dispose(),this.a.delete(U);this.b=T}getItems(){return this.b}}}),define(V[12],W([0,1,6,8,7,26,25,4]),function(B,e,A,S,k,O,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.waitForState=e.PromiseResult=e.ObservablePromise=e.ObservableLazyStatefulPromise=e.ObservableLazy=e.wasEventTriggeredRecently=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return A.$Pd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return A.$Rd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return A.$Kd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return A.$Nd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$zd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$Ad}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$Bd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$Cd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return k.$bd}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return k.$gd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return k.$dd}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return k.$fd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return k.$cd}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return k.$ed}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return O.$id}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return O.$od}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return O.$td}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return O.$ud}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return O.$qd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return O.$rd}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return O.$kd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return O.$jd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return O.$nd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return O.$md}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return O.$pd}}),Object.defineProperty(e,"ObservableLazy",{enumerable:!0,get:function(){return r.$Td}}),Object.defineProperty(e,"ObservableLazyStatefulPromise",{enumerable:!0,get:function(){return r.$Wd}}),Object.defineProperty(e,"ObservablePromise",{enumerable:!0,get:function(){return r.$Ud}}),Object.defineProperty(e,"PromiseResult",{enumerable:!0,get:function(){return r.$Vd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return r.$Xd}}),!1&&(0,f.$wd)(new f.$yd)}),define(V[27],W([0,1,9,2]),function(B,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=void 0;function k(N){const E=N;return E?typeof E.read=="function":!1}e.$be=k;function O(N){const E=N;return E?[E.on,E.pause,E.resume,E.destroy].every(c=>typeof c=="function"):!1}e.$ce=O;function r(N){const E=N;return E?O(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$de=r;function f(N,E){return new t(N,E)}e.$ee=f;class t{constructor(E,c){this.e=E,this.f=c,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(c=>this.d.push(c))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(c=>c(E))}h(E){this.c.error.length===0?(0,A.$1)(E):this.c.error.slice(0).forEach(c=>c(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,c){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(c),this.resume();break;case"end":this.c.end.push(c),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(c),this.a.flowing&&this.k();break}}removeListener(E,c){if(this.a.destroyed)return;let b;switch(E){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const w=b.indexOf(c);w>=0&&b.splice(w,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const c=[...this.d];this.d.length=0,c.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(N,E){const c=[];let b;for(;(b=N.read())!==null;)c.push(b);return E(c)}e.$fe=l;function $(N,E,c){const b=[];let w;for(;(w=N.read())!==null&&b.length<c;)b.push(w);return w===null&&b.length>0?E(b):{read:()=>{if(b.length>0)return b.shift();if(typeof w<"u"){const D=w;return w=void 0,D}return N.read()}}}e.$ge=$;function d(N,E){return new Promise((c,b)=>{const w=[];h(N,{onData:D=>{E&&w.push(D)},onError:D=>{E?b(D):c(void 0)},onEnd:()=>{c(E?E(w):void 0)}})})}e.$he=d;function h(N,E,c){N.on("error",b=>{c?.isCancellationRequested||E.onError(b)}),N.on("end",()=>{c?.isCancellationRequested||E.onEnd()}),N.on("data",b=>{c?.isCancellationRequested||E.onData(b)})}e.$ie=h;function a(N,E){return new Promise((c,b)=>{const w=new S.$Sc,D=[],M=j=>{if(D.push(j),D.length>E)return w.dispose(),N.pause(),c({stream:N,buffer:D,ended:!1})},o=j=>(w.dispose(),b(j)),T=()=>(w.dispose(),c({stream:N,buffer:D,ended:!0}));w.add((0,S.$Rc)(()=>N.removeListener("error",o))),N.on("error",o),w.add((0,S.$Rc)(()=>N.removeListener("end",T))),N.on("end",T),w.add((0,S.$Rc)(()=>N.removeListener("data",M))),N.on("data",M)})}e.$je=a;function i(N,E){const c=f(E);return c.end(N),c}e.$ke=i;function n(){const N=f(()=>{throw new Error("not supported")});return N.end(),N}e.$le=n;function s(N){let E=!1;return{read:()=>E?null:(E=!0,N)}}e.$me=s;function g(N,E,c){const b=f(c);return h(N,{onData:w=>b.write(E.data(w)),onError:w=>b.error(E.error?E.error(w):w),onEnd:()=>b.end()}),b}e.$ne=g;function y(N,E,c){let b=!1;return{read:()=>{const w=E.read();return b?w:(b=!0,w!==null?c([N,w]):N)}}}e.$oe=y;function P(N,E,c){let b=!1;const w=f(c);return h(E,{onData:D=>b?w.write(D):(b=!0,w.write(c([N,D]))),onError:D=>w.error(D),onEnd:()=>{b||(b=!0,w.write(N)),w.end()}}),w}e.$pe=P}),define(V[13],W([0,1,28,27]),function(B,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=void 0;const k=typeof Buffer<"u",O=new A.$V(()=>new Uint8Array(256));let r,f;class t{static alloc(m){return k?new t(Buffer.allocUnsafe(m)):new t(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new t(m)}static fromString(m,R){return!(R?.dontUseNodeBuffer||!1)&&k?new t(Buffer.from(m)):(r||(r=new TextEncoder),new t(r.encode(m)))}static fromByteArray(m){const R=t.alloc(m.length);for(let q=0,G=m.length;q<G;q++)R.buffer[q]=m[q];return R}static concat(m,R){if(typeof R>"u"){R=0;for(let p=0,_=m.length;p<_;p++)R+=m[p].byteLength}const q=t.alloc(R);let G=0;for(let p=0,_=m.length;p<_;p++){const K=m[p];q.set(K,G),G+=K.byteLength}return q}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=t.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(m,R){return new t(this.buffer.subarray(m,R))}set(m,R){if(m instanceof t)this.buffer.set(m.buffer,R);else if(m instanceof Uint8Array)this.buffer.set(m,R);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),R);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return h(this.buffer,m)}writeUInt32BE(m,R){a(this.buffer,m,R)}readUInt32LE(m){return i(this.buffer,m)}writeUInt32LE(m,R){n(this.buffer,m,R)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,R){g(this.buffer,m,R)}indexOf(m,R=0){return l(this.buffer,m instanceof t?m.buffer:m,R)}}e.$qe=t;function l(C,m,R=0){const q=m.byteLength,G=C.byteLength;if(q===0)return 0;if(q===1)return C.indexOf(m[0]);if(q>G-R)return-1;const p=O.value;p.fill(m.length);for(let X=0;X<m.length;X++)p[m[X]]=m.length-X-1;let _=R+m.length-1,K=_,H=-1;for(;_<G;)if(C[_]===m[K]){if(K===0){H=_;break}_--,K--}else _+=Math.max(m.length-K,p[C[_]]),K=m.length-1;return H}e.$re=l;function $(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0}e.$se=$;function d(C,m,R){C[R+0]=m&255,m=m>>>8,C[R+1]=m&255}e.$te=d;function h(C,m){return C[m]*2**24+C[m+1]*2**16+C[m+2]*2**8+C[m+3]}e.$ue=h;function a(C,m,R){C[R+3]=m,m=m>>>8,C[R+2]=m,m=m>>>8,C[R+1]=m,m=m>>>8,C[R]=m}e.$ve=a;function i(C,m){return C[m+0]<<0>>>0|C[m+1]<<8>>>0|C[m+2]<<16>>>0|C[m+3]<<24>>>0}e.$we=i;function n(C,m,R){C[R+0]=m&255,m=m>>>8,C[R+1]=m&255,m=m>>>8,C[R+2]=m&255,m=m>>>8,C[R+3]=m&255}e.$xe=n;function s(C,m){return C[m]}e.$ye=s;function g(C,m,R){C[R]=m}e.$ze=g;function y(C){return S.$fe(C,m=>t.concat(m))}e.$Ae=y;function P(C){return S.$me(C)}e.$Be=P;function N(C){return S.$he(C,m=>t.concat(m))}e.$Ce=N;async function E(C){return C.ended?t.concat(C.buffer):t.concat([...C.buffer,await N(C.stream)])}e.$De=E;function c(C){return S.$ke(C,m=>t.concat(m))}e.$Ee=c;function b(C){return S.$ne(C,{data:m=>typeof m=="string"?t.fromString(m):t.wrap(m)},m=>t.concat(m))}e.$Fe=b;function w(C){return S.$ee(m=>t.concat(m),C)}e.$Ge=w;function D(C,m){return S.$oe(C,m,R=>t.concat(R))}e.$He=D;function M(C,m){return S.$pe(C,m,R=>t.concat(R))}e.$Ie=M;function o(C){let m=0,R=0,q=0;const G=new Uint8Array(Math.floor(C.length/4*3)),p=K=>{switch(R){case 3:G[q++]=m|K,R=0;break;case 2:G[q++]=m|K>>>2,m=K<<6,R=3;break;case 1:G[q++]=m|K>>>4,m=K<<4,R=2;break;default:m=K<<2,R=1}};for(let K=0;K<C.length;K++){const H=C.charCodeAt(K);if(H>=65&&H<=90)p(H-65);else if(H>=97&&H<=122)p(H-97+26);else if(H>=48&&H<=57)p(H-48+52);else if(H===43||H===45)p(62);else if(H===47||H===95)p(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${C[K]}`)}}const _=q;for(;R>0;)p(0);return t.wrap(G).slice(0,_)}e.$Je=o;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:C},m=!0,R=!1){const q=R?j:T;let G="";const p=C.byteLength%3;let _=0;for(;_<C.byteLength-p;_+=3){const K=C[_+0],H=C[_+1],X=C[_+2];G+=q[K>>>2],G+=q[(K<<4|H>>>4)&63],G+=q[(H<<2|X>>>6)&63],G+=q[X&63]}if(p===1){const K=C[_+0];G+=q[K>>>2],G+=q[K<<4&63],m&&(G+="==")}else if(p===2){const K=C[_+0],H=C[_+1];G+=q[K>>>2],G+=q[(K<<4|H>>>4)&63],G+=q[H<<2&63],m&&(G+="=")}return G}e.$Ke=U}),define(V[29],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=void 0,e.$Zd=Symbol("MicrotaskDelay")}),define(V[14],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=e.StringEOL=void 0;var A;(function(k){k[k.Unknown=0]="Unknown",k[k.Invalid=3]="Invalid",k[k.LF=1]="LF",k[k.CRLF=2]="CRLF"})(A||(e.StringEOL=A={}));function S(k){let O=0,r=0,f=0,t=0;for(let l=0,$=k.length;l<$;l++){const d=k.charCodeAt(l);d===13?(O===0&&(r=l),O++,l+1<$&&k.charCodeAt(l+1)===10?(t|=2,l++):t|=3,f=l+1):d===10&&(t|=1,O===0&&(r=l),O++,f=l+1)}return O===0&&(r=k.length),[O,r,k.length-f,t]}e.$Dt=S}),define(V[15],W([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(A||(e.LanguageId=A={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var k;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(k||(e.ColorId=k={}));var O;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(O||(e.StandardTokenType=O={}));var r;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(r||(e.MetadataConsts=r={}));class f{static getLanguageId(l){return(l&255)>>>0}static getTokenType(l){return(l&768)>>>8}static containsBalancedBrackets(l){return(l&1024)!==0}static getFontStyle(l){return(l&30720)>>>11}static getForeground(l){return(l&16744448)>>>15}static getBackground(l){return(l&4278190080)>>>24}static getClassNameFromMetadata(l){let d="mtk"+this.getForeground(l);const h=this.getFontStyle(l);return h&1&&(d+=" mtki"),h&2&&(d+=" mtkb"),h&4&&(d+=" mtku"),h&8&&(d+=" mtks"),d}static getInlineStyleFromMetadata(l,$){const d=this.getForeground(l),h=this.getFontStyle(l);let a=`color: ${$[d]};`;h&1&&(a+="font-style: italic;"),h&2&&(a+="font-weight: bold;");let i="";return h&4&&(i+=" underline"),h&8&&(i+=" line-through"),i&&(a+=`text-decoration:${i};`),a}static getPresentationFromMetadata(l){const $=this.getForeground(l),d=this.getFontStyle(l);return{foreground:$,italic:!!(d&1),bold:!!(d&2),underline:!!(d&4),strikethrough:!!(d&8)}}}e.$Bt=f}),define(V[30],W([0,1,31]),function(B,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pC=void 0;class S{constructor(r){this.b=r,this.a=[]}get(r){return r<this.a.length?this.a[r]:this.b}set(r,f){for(;r>=this.a.length;)this.a[this.a.length]=this.b;this.a[r]=f}replace(r,f,t){if(r>=this.a.length)return;if(f===0){this.insert(r,t);return}else if(t===0){this.delete(r,f);return}const l=this.a.slice(0,r),$=this.a.slice(r+f),d=k(t,this.b);this.a=l.concat(d,$)}delete(r,f){f===0||r>=this.a.length||this.a.splice(r,f)}insert(r,f){if(f===0||r>=this.a.length)return;const t=[];for(let l=0;l<f;l++)t[l]=this.b;this.a=(0,A.$Wb)(this.a,r,t)}}e.$pC=S;function k(O,r){const f=[];for(let t=0;t<O;t++)f[t]=r;return f}}),define(V[10],W([0,1,15]),function(B,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0;class S{static{this.defaultTokenMetadata=(32768|2<<24)>>>0}static createEmpty(r,f){const t=S.defaultTokenMetadata,l=new Uint32Array(2);return l[0]=r.length,l[1]=t,new S(l,r,f)}constructor(r,f,t){this._lineTokensBrand=void 0,this.a=r,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(r){return r instanceof S?this.slicedEquals(r,0,this.b):!1}slicedEquals(r,f,t){if(this.c!==r.c||this.b!==r.b)return!1;const l=f<<1,$=l+(t<<1);for(let d=l;d<$;d++)if(this.a[d]!==r.a[d])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(r){return r>0?this.a[r-1<<1]:0}getMetadata(r){return this.a[(r<<1)+1]}getLanguageId(r){const f=this.a[(r<<1)+1],t=A.$Bt.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(r){const f=this.a[(r<<1)+1];return A.$Bt.getTokenType(f)}getForeground(r){const f=this.a[(r<<1)+1];return A.$Bt.getForeground(f)}getClassName(r){const f=this.a[(r<<1)+1];return A.$Bt.getClassNameFromMetadata(f)}getInlineStyle(r,f){const t=this.a[(r<<1)+1];return A.$Bt.getInlineStyleFromMetadata(t,f)}getPresentation(r){const f=this.a[(r<<1)+1];return A.$Bt.getPresentationFromMetadata(f)}getEndOffset(r){return this.a[r<<1]}findTokenIndexAtOffset(r){return S.findIndexInTokensArray(this.a,r)}inflate(){return this}sliceAndInflate(r,f,t){return new k(this,r,f,t)}static convertToEndOffset(r,f){const l=(r.length>>>1)-1;for(let $=0;$<l;$++)r[$<<1]=r[$+1<<1];r[l<<1]=f}static findIndexInTokensArray(r,f){if(r.length<=2)return 0;let t=0,l=(r.length>>>1)-1;for(;t<l;){const $=t+Math.floor((l-t)/2),d=r[$<<1];if(d===f)return $+1;d<f?t=$+1:d>f&&(l=$)}return t}withInserted(r){if(r.length===0)return this;let f=0,t=0,l="";const $=new Array;let d=0;for(;;){const h=f<this.b?this.a[f<<1]:-1,a=t<r.length?r[t]:null;if(h!==-1&&(a===null||h<=a.offset)){l+=this.c.substring(d,h);const i=this.a[(f<<1)+1];$.push(l.length,i),f++,d=h}else if(a){if(a.offset>d){l+=this.c.substring(d,a.offset);const i=this.a[(f<<1)+1];$.push(l.length,i),d=a.offset}l+=a.text,$.push(l.length,a.tokenMetadata),t++}else break}return new S(new Uint32Array($),l,this.d)}}e.$Et=S;class k{constructor(r,f,t,l){this.a=r,this.b=f,this.c=t,this.d=l,this.e=r.findTokenIndexAtOffset(f),this.f=0;for(let $=this.e,d=r.getCount();$<d&&!(r.getStartOffset($)>=t);$++)this.f++}getMetadata(r){return this.a.getMetadata(this.e+r)}getLanguageId(r){return this.a.getLanguageId(this.e+r)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(r){return r instanceof k?this.b===r.b&&this.c===r.c&&this.d===r.d&&this.a.slicedEquals(r.a,this.e,this.f):!1}getCount(){return this.f}getForeground(r){return this.a.getForeground(this.e+r)}getEndOffset(r){const f=this.a.getEndOffset(this.e+r);return Math.min(this.c,f)-this.b+this.d}getClassName(r){return this.a.getClassName(this.e+r)}getInlineStyle(r,f){return this.a.getInlineStyle(this.e+r,f)}getPresentation(r){return this.a.getPresentation(this.e+r)}findTokenIndexAtOffset(r){return this.a.findTokenIndexAtOffset(r+this.b-this.d)-this.e}}}),define(V[32],W([0,1,10]),function(B,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=e.$Gt=e.$Ft=void 0,e.$Ft=new Uint32Array(0).buffer;class S{static deleteBeginning(r,f){return r===null||r===e.$Ft?r:S.delete(r,0,f)}static deleteEnding(r,f){if(r===null||r===e.$Ft)return r;const t=k(r),l=t[t.length-2];return S.delete(r,f,l)}static delete(r,f,t){if(r===null||r===e.$Ft||f===t)return r;const l=k(r),$=l.length>>>1;if(f===0&&l[l.length-2]===t)return e.$Ft;const d=A.$Et.findIndexInTokensArray(l,f),h=d>0?l[d-1<<1]:0,a=l[d<<1];if(t<a){const y=t-f;for(let P=d;P<$;P++)l[P<<1]-=y;return r}let i,n;h!==f?(l[d<<1]=f,i=d+1<<1,n=f):(i=d<<1,n=h);const s=t-f;for(let y=d+1;y<$;y++){const P=l[y<<1]-s;P>n&&(l[i++]=P,l[i++]=l[(y<<1)+1],n=P)}if(i===l.length)return r;const g=new Uint32Array(i);return g.set(l.subarray(0,i),0),g.buffer}static append(r,f){if(f===e.$Ft)return r;if(r===e.$Ft)return f;if(r===null)return r;if(f===null)return null;const t=k(r),l=k(f),$=l.length>>>1,d=new Uint32Array(t.length+l.length);d.set(t,0);let h=t.length;const a=t[t.length-2];for(let i=0;i<$;i++)d[h++]=l[i<<1]+a,d[h++]=l[(i<<1)+1];return d.buffer}static insert(r,f,t){if(r===null||r===e.$Ft)return r;const l=k(r),$=l.length>>>1;let d=A.$Et.findIndexInTokensArray(l,f);d>0&&l[d-1<<1]===f&&d--;for(let h=d;h<$;h++)l[h<<1]+=t;return r}}e.$Gt=S;function k(O){return O instanceof Uint32Array?O:new Uint32Array(O)}e.$Ht=k}),define(V[33],W([0,1,31,13,46,14,32,16]),function(B,e,A,S,k,O,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0;class t{static deserialize($,d,h){const a=new Uint32Array($.buffer),i=(0,S.$ue)($,d);d+=4;const n=(0,S.$ue)($,d);d+=4;const s=[];for(let g=0;g<n;g++){const y=(0,S.$ue)($,d);d+=4,s.push(a.subarray(d/4,d/4+y/4)),d+=y}return h.push(new t(i,s)),d}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,d){this.a=$,this.b=d}getLineRange(){return new f.$at(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let d=0;d<this.b.length;d++){const h=this.b[d];if(!(h instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=h.byteLength}return $}serialize($,d){(0,S.$ve)($,this.a,d),d+=4,(0,S.$ve)($,this.b.length,d),d+=4;for(let h=0;h<this.b.length;h++){const a=this.b[h];if(!(a instanceof Uint32Array))throw new Error("Not supported!");(0,S.$ve)($,a.byteLength,d),d+=4,$.set(new Uint8Array(a.buffer),d),d+=a.byteLength}return d}applyEdit($,d){const[h,a]=(0,O.$Dt)(d);this.c($),this.d(new k.$3s($.startLineNumber,$.startColumn),h,a)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const d=$.startLineNumber-this.a,h=$.endLineNumber-this.a;if(h<0){const a=h-d;this.a-=a;return}if(!(d>=this.b.length)){if(d<0&&h>=this.b.length){this.a=0,this.b=[];return}if(d===h){this.b[d]=r.$Gt.delete(this.b[d],$.startColumn-1,$.endColumn-1);return}if(d>=0)if(this.b[d]=r.$Gt.deleteEnding(this.b[d],$.startColumn-1),h<this.b.length){const a=r.$Gt.deleteBeginning(this.b[h],$.endColumn-1);this.b[d]=r.$Gt.append(this.b[d],a),this.b.splice(d+1,h-d)}else this.b[d]=r.$Gt.append(this.b[d],null),this.b=this.b.slice(0,d+1);else{const a=-d;this.a-=a,this.b[h]=r.$Gt.deleteBeginning(this.b[h],$.endColumn-1),this.b=this.b.slice(h)}}}d($,d,h){if(d===0&&h===0)return;const a=$.lineNumber-this.a;if(a<0){this.a+=d;return}if(!(a>=this.b.length)){if(d===0){this.b[a]=r.$Gt.insert(this.b[a],$.column-1,h);return}this.b[a]=r.$Gt.deleteEnding(this.b[a],$.column-1),this.b[a]=r.$Gt.insert(this.b[a],$.column-1,h),this.e($.lineNumber,d)}}e($,d){if(d===0)return;const h=[];for(let a=0;a<d;a++)h[a]=null;this.b=A.$Wb(this.b,$,h)}}e.$It=t}),define(V[17],W([0,1,13,33]),function(B,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=void 0;class k{static deserialize(r){let f=0;const t=(0,A.$ue)(r,f);f+=4;const l=[];for(let $=0;$<t;$++)f=S.$It.deserialize(r,f,l);return l}constructor(){this.a=[]}add(r,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===r){t.appendLineTokens(f);return}}this.a.push(new S.$It(r,[f]))}finalize(){return this.a}serialize(){const r=this.b(),f=new Uint8Array(r);return this.c(f),f}b(){let r=0;r+=4;for(let f=0;f<this.a.length;f++)r+=this.a[f].serializeSize();return r}c(r){let f=0;(0,A.$ve)(r,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(r,f)}}e.$qC=k}),define(V[34],W([0,1,35,3,18,47]),function(B,e,A,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function r(o){return o===47||o===92}e.$9f=r;function f(o){return o.replace(/[\\/]/g,A.$gc.sep)}e.$0f=f;function t(o){return o.indexOf("/")===-1&&(o=f(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$$f=t;function l(o,T=A.$gc.sep){if(!o)return"";const j=o.length,U=o.charCodeAt(0);if(r(U)){if(r(o.charCodeAt(1))&&!r(o.charCodeAt(2))){let m=3;const R=m;for(;m<j&&!r(o.charCodeAt(m));m++);if(R!==m&&!r(o.charCodeAt(m+1))){for(m+=1;m<j;m++)if(r(o.charCodeAt(m)))return o.slice(0,m+1).replace(/[\\/]/g,T)}}return T}else if(g(U)&&o.charCodeAt(1)===58)return r(o.charCodeAt(2))?o.slice(0,2)+T:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<j;C++)if(r(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.$_f=l;function $(o){if(!S.$i||!o||o.length<5)return!1;let T=o.charCodeAt(0);if(T!==92||(T=o.charCodeAt(1),T!==92))return!1;let j=2;const U=j;for(;j<o.length&&(T=o.charCodeAt(j),T!==92);j++);return!(U===j||(T=o.charCodeAt(j+1),isNaN(T)||T===92))}e.$ag=$;const d=/[\\/:\*\?"<>\|]/g,h=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(o,T=S.$i){const j=T?d:h;return!(!o||o.length===0||/^\s+$/.test(o)||(j.lastIndex=0,j.test(o))||T&&a.test(o)||o==="."||o===".."||T&&o[o.length-1]==="."||T&&o.length!==o.trim().length||o.length>255)}e.$bg=i;function n(o,T,j){const U=o===T;return!j||U?U:!o||!T?!1:(0,k.$hf)(o,T)}e.$cg=n;function s(o,T,j,U=A.sep){if(o===T)return!0;if(!o||!T||T.length>o.length)return!1;if(j){if(!(0,k.$if)(o,T))return!1;if(T.length===o.length)return!0;let m=T.length;return T.charAt(T.length-1)===U&&m--,o.charAt(m)===U}return T.charAt(T.length-1)!==U&&(T+=U),o.indexOf(T)===0}e.$dg=s;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.$eg=g;function y(o,T){return S.$i&&o.endsWith(":")&&(o+=A.sep),(0,A.$ic)(o)||(o=(0,A.$jc)(T,o)),o=(0,A.$hc)(o),S.$i?(o=(0,k.$2e)(o,A.sep),o.endsWith(":")&&(o+=A.sep)):(o=(0,k.$2e)(o,A.sep),o||(o=A.sep)),o}e.$fg=y;function P(o){const T=(0,A.$hc)(o);return S.$i?o.length>3?!1:N(T)&&(o.length===2||T.charCodeAt(2)===92):T===A.$gc.sep}e.$gg=P;function N(o,T=S.$i){return T?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$hg=N;function E(o,T=S.$i){return N(o,T)?o[0]:void 0}e.$ig=E;function c(o,T,j){return T.length>o.length?-1:o===T?0:(j&&(o=o.toLowerCase(),T=T.toLowerCase()),o.indexOf(T))}e.$jg=c;function b(o){const T=o.split(":");let j,U,C;for(const m of T){const R=Number(m);(0,O.$Uf)(R)?U===void 0?U=R:C===void 0&&(C=R):j=j?[j,m].join(":"):m}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:U!==void 0?U:void 0,column:C!==void 0?C:U!==void 0?1:void 0}}e.$kg=b;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function M(o,T,j=8){let U="";for(let m=0;m<j;m++){let R;m===0&&S.$i&&!T&&(j===3||j===4)?R=D:R=w,U+=R.charAt(Math.floor(Math.random()*R.length))}let C;return T?C=`${T}-${U}`:C=U,o?(0,A.$jc)(o,C):C}e.$lg=M}),define(V[19],W([0,1,9,3,18,11]),function(B,e,A,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.Schemas=void 0;var r;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.codeSetting="code-setting",h.codeFeature="code-feature"})(r||(e.Schemas=r={}));function f(h,a){return O.URI.isUri(h)?(0,k.$hf)(h.scheme,a):(0,k.$if)(h,a+":")}e.$mg=f;function t(h,...a){return a.some(i=>f(h,i))}e.$ng=t,e.$og="vscode-tkn",e.$pg="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${r.vscodeRemoteResource}`}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a){this.f=`${a}/${r.vscodeRemoteResource}`}set(a,i,n){this.a[a]=i,this.b[a]=n}setConnectionToken(a,i){this.c[a]=i}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(P){return A.$1(P),a}const i=a.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[i],g=this.c[i];let y=`path=${encodeURIComponent(a.path)}`;return typeof g=="string"&&(y+=`&${e.$pg}=${encodeURIComponent(g)}`),O.URI.from({scheme:S.$o?this.d:r.vscodeRemoteResource,authority:`${n}:${s}`,path:this.f,query:y})}}e.$qg=new l,e.$rg="vs/../../extensions",e.$sg="vs/../../node_modules",e.$tg="vs/../../node_modules.asar",e.$ug="vs/../../node_modules.asar.unpacked",e.$vg="vscode-app";class ${static{this.a=e.$vg}asBrowserUri(a){const i=this.b(a,B);return this.uriToBrowserUri(i)}uriToBrowserUri(a){return a.scheme===r.vscodeRemote?e.$qg.rewrite(a):a.scheme===r.file&&(S.$m||S.$q===`${r.vscodeFileResource}://${$.a}`)?a.with({scheme:r.vscodeFileResource,authority:a.authority||$.a,query:null,fragment:null}):a}asFileUri(a){const i=this.b(a,B);return this.uriToFileUri(i)}uriToFileUri(a){return a.scheme===r.vscodeFileResource?a.with({scheme:r.file,authority:a.authority!==$.a?a.authority:null,query:null,fragment:null}):a}b(a,i){return O.URI.isUri(a)?a:O.URI.parse(i.toUrl(a))}}e.$wg=new $;var d;(function(h){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(a.get("3"));const i="vscode-coi";function n(g){let y;typeof g=="string"?y=new URL(g).searchParams:g instanceof URL?y=g.searchParams:O.URI.isUri(g)&&(y=new URL(g.toString(!0)).searchParams);const P=y?.get(i);if(P)return a.get(P)}h.getHeadersFromQuery=n;function s(g,y,P){if(!globalThis.crossOriginIsolated)return;const N=y&&P?"3":P?"2":"1";g instanceof URLSearchParams?g.set(i,N):g[i]=N}h.addSearchParam=s})(d||(e.COI=d={}))}),define(V[36],W([0,1,23,19,3,11]),function(B,e,A,S,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qD=void 0;class r{constructor(h,a,i){this.id=h,this.dependencies=a,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,a,i)=>{typeof h!="string"&&(i=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(i=a,a=null),this.c.push(new r(h,a,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const a=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!a)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(a.dependencies)&&a.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${a.dependencies.join(", ")}`);return typeof a.callback=="function"?a.callback([]):a.callback}h(h){return new Promise((a,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const s=()=>{n.removeEventListener("load",g),n.removeEventListener("error",y)},g=P=>{s(),a(this.c.pop())},y=P=>{s(),i(P)};n.addEventListener("load",g),n.addEventListener("error",y),this.f&&(h=this.f.createScriptURL(h)),n.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(h){return new Promise((a,i)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),a(this.c.pop())}catch(n){i(n)}})}async j(h){try{const a=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,s=O.URI.parse(h).fsPath,g=a.readFileSync(s).toString(),y=n.wrap(g.replace(/^#!.*/,""));return new i.Script(y).runInThisContext().apply(),this.c.pop()}catch(a){throw a}}}const t=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function $(d,h,a){if(A.$T){a===void 0&&(a=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[d]&&(d=l[d]);const i=`${d}/${h}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const P=`${a&&!k.$o?S.$tg:S.$sg}/${i}`;n=S.$wg.asBrowserUri(P).toString(!0)}const s=f.INSTANCE.load(n);return t.set(i,s),s}else return await new Promise((i,n)=>{B([d],i,n)})}e.$qD=$}),define(V[20],W([0,1,34,19,35,3,18,11]),function(B,e,A,S,k,O,r,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=e.DataUri=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function t(a){return(0,f.$wc)(a,!0)}e.$Dg=t;class l{constructor(i){this.a=i}compare(i,n,s=!1){return i===n?0:(0,r.$af)(this.getComparisonKey(i,s),this.getComparisonKey(n,s))}isEqual(i,n,s=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,s)===this.getComparisonKey(n,s)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,s=!1){if(i.scheme===n.scheme){if(i.scheme===S.Schemas.file)return A.$dg(t(i),t(n),this.a(i))&&i.query===n.query&&(s||i.fragment===n.fragment);if((0,e.$Ug)(i.authority,n.authority))return A.$dg(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(s||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Mg)(i)||i.authority}basename(i){return k.$gc.basename(i.path)}extname(i){return k.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(k.$mc(t(i))).path:(n=k.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(k.$hc(t(i))).path:n=k.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Ug)(i.authority,n.authority))return;if(i.scheme===S.Schemas.file){const y=k.$lc(t(i),t(n));return O.$i?A.$0f(y):y}let s=i.path||"/";const g=n.path||"/";if(this.a(i)){let y=0;for(const P=Math.min(s.length,g.length);y<P&&!(s.charCodeAt(y)!==g.charCodeAt(y)&&s.charAt(y).toLowerCase()!==g.charAt(y).toLowerCase());y++);s=g.substr(0,y)+s.substr(y)}return k.$gc.relative(s,g)}resolvePath(i,n){if(i.scheme===S.Schemas.file){const s=f.URI.file(k.$kc(t(i),n));return i.with({authority:s.authority,path:s.path})}return n=A.$$f(n),i.with({path:k.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,r.$hf)(i,n)}hasTrailingPathSeparator(i,n=k.sep){if(i.scheme===S.Schemas.file){const s=t(i);return s.length>A.$_f(s).length&&s[s.length-1]===n}else{const s=i.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=k.sep){return(0,e.$Vg)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=k.sep){let s=!1;if(i.scheme===S.Schemas.file){const g=t(i);s=g!==void 0&&g.length===A.$_f(g).length&&g[g.length-1]===n}else{n="/";const g=i.path;s=g.length===1&&g.charCodeAt(g.length-1)===47}return!s&&!(0,e.$Vg)(i,n)?i.with({path:i.path+"/"}):i}}e.$Eg=l,e.$Fg=new l(()=>!1),e.$Gg=new l(a=>a.scheme===S.Schemas.file?!O.$k:!0),e.$Hg=new l(a=>!0),e.$Ig=e.$Fg.isEqual.bind(e.$Fg),e.$Jg=e.$Fg.isEqualOrParent.bind(e.$Fg),e.$Kg=e.$Fg.getComparisonKey.bind(e.$Fg),e.$Lg=e.$Fg.basenameOrAuthority.bind(e.$Fg),e.$Mg=e.$Fg.basename.bind(e.$Fg),e.$Ng=e.$Fg.extname.bind(e.$Fg),e.$Og=e.$Fg.dirname.bind(e.$Fg),e.$Pg=e.$Fg.joinPath.bind(e.$Fg),e.$Qg=e.$Fg.normalizePath.bind(e.$Fg),e.$Rg=e.$Fg.relativePath.bind(e.$Fg),e.$Sg=e.$Fg.resolvePath.bind(e.$Fg),e.$Tg=e.$Fg.isAbsolutePath.bind(e.$Fg),e.$Ug=e.$Fg.isEqualAuthority.bind(e.$Fg),e.$Vg=e.$Fg.hasTrailingPathSeparator.bind(e.$Fg),e.$Wg=e.$Fg.removeTrailingPathSeparator.bind(e.$Fg),e.$Xg=e.$Fg.addTrailingPathSeparator.bind(e.$Fg);function $(a,i){const n=[];for(let s=0;s<a.length;s++){const g=i(a[s]);a.some((y,P)=>P===s?!1:(0,e.$Jg)(g,i(y)))||n.push(a[s])}return n}e.$Yg=$;var d;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function i(n){const s=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(P=>{const[N,E]=P.split(":");N&&E&&s.set(N,E)});const y=n.path.substring(0,n.path.indexOf(";"));return y&&s.set(a.META_DATA_MIME,y),s}a.parseMetaData=i})(d||(e.DataUri=d={}));function h(a,i,n){if(i){let s=a.path;return s&&s[0]!==k.$gc.sep&&(s=k.$gc.sep+s),a.with({scheme:n,authority:i,path:s})}return a.with({scheme:n})}e.$Zg=h}),define(V[21],W([0,1,48,9,37,2,20,3,29,28]),function(B,e,A,S,k,O,r,f,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.Promises=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0;function $(L){return!!L&&typeof L.then=="function"}e.$1g=$;function d(L){const u=new A.$ae,v=L(u.token),I=new Promise((F,z)=>{const Z=u.token.onCancellationRequested(()=>{Z.dispose(),z(new S.$5)});Promise.resolve(v).then(Y=>{Z.dispose(),u.dispose(),F(Y)},Y=>{Z.dispose(),u.dispose(),z(Y)})});return new class{cancel(){u.cancel(),u.dispose()}then(F,z){return I.then(F,z)}catch(F){return this.then(void 0,F)}finally(F){return I.finally(F)}}}e.$2g=d;function h(L,u,v){return new Promise((I,F)=>{const z=u.onCancellationRequested(()=>{z.dispose(),I(v)});L.then(I,F).finally(()=>z.dispose())})}e.$3g=h;function a(L,u){return new Promise((v,I)=>{const F=u.onCancellationRequested(()=>{F.dispose(),I(new S.$5)});L.then(v,I).finally(()=>F.dispose())})}e.$4g=a;async function i(L){let u=-1;const v=L.map((I,F)=>I.then(z=>(u=F,z)));try{return await Promise.race(v)}finally{L.forEach((I,F)=>{F!==u&&I.cancel()})}}e.$5g=i;function n(L,u,v){let I;const F=setTimeout(()=>{I?.(void 0),v?.()},u);return Promise.race([L.finally(()=>clearTimeout(F)),new Promise(z=>I=z)])}e.$6g=n;function s(L){return new Promise((u,v)=>{const I=L();$(I)?I.then(u,v):u(I)})}e.$7g=s;function g(){let L,u;return{promise:new Promise((I,F)=>{L=I,u=F}),resolve:L,reject:u}}e.$8g=g;class y{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const v=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(v,v).then(I)})}return new Promise((v,I)=>{this.b.then(v,I)})}return this.a=u(),new Promise((v,I)=>{this.a.then(F=>{this.a=null,v(F)},F=>{this.a=null,I(F)})})}dispose(){this.f=!0}}e.$9g=y;class P{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$0g=P;class N{constructor(){this.a=new Map}queue(u,v){const F=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(u)===F&&this.a.delete(u)});return this.a.set(u,F),F}}e.$$g=N;const E=(L,u)=>{let v=!0;const I=setTimeout(()=>{v=!1,u()},L);return{isTriggered:()=>v,dispose:()=>{clearTimeout(I),v=!1}}},c=L=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,L())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class b{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,v=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((F,z)=>{this.d=F,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=v===t.$Zd?c(I):E(v,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$_g=b;class w{constructor(u){this.a=new b(u),this.b=new y}trigger(u,v){return this.a.trigger(()=>this.b.queue(u),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$ah=w;class D{constructor(){this.a=!1,this.b=new Promise((u,v)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$bh=D;class M extends D{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$ch=M;function o(L,u){return u?new Promise((v,I)=>{const F=setTimeout(()=>{z.dispose(),v()},L),z=u.onCancellationRequested(()=>{clearTimeout(F),z.dispose(),I(new S.$5)})}):d(v=>o(L,v))}e.$dh=o;function T(L,u=0,v){const I=setTimeout(()=>{L(),v&&F.dispose()},u),F=(0,O.$Rc)(()=>{clearTimeout(I),v?.deleteAndLeak(F)});return v?.add(F),F}e.$eh=T;function j(L){const u=[];let v=0;const I=L.length;function F(){return v<I?L[v++]():null}function z(Z){Z!=null&&u.push(Z);const Y=F();return Y?Y.then(z):Promise.resolve(u)}return Promise.resolve(null).then(z)}e.$fh=j;function U(L,u=I=>!!I,v=null){let I=0;const F=L.length,z=()=>{if(I>=F)return Promise.resolve(v);const Z=L[I++];return Promise.resolve(Z()).then(Q=>u(Q)?Promise.resolve(Q):z())};return z()}e.$gh=U;function C(L,u=I=>!!I,v=null){if(L.length===0)return Promise.resolve(v);let I=L.length;const F=()=>{I=-1;for(const z of L)z.cancel?.()};return new Promise((z,Z)=>{for(const Y of L)Y.then(Q=>{--I>=0&&u(Q)?(F(),z(Q)):I===0&&z(v)}).catch(Q=>{--I>=0&&(F(),Z(Q))})})}e.$hh=C;class m{constructor(u){this.a=0,this.b=!1,this.f=u,this.g=[],this.d=0,this.h=new k.$3d}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(u){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,I)=>{this.g.push({factory:u,c:v,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const u=this.g.shift();this.d++;const v=u.factory();v.then(u.c,u.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$ih=m;class R extends m{constructor(){super(1)}}e.$jh=R;class q{constructor(){this.a=new te,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$kh=q;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueSize(u,v=r.$Fg){const I=v.getComparisonKey(u);return this.a.get(I)?.size??0}queueFor(u,v,I=r.$Fg){const F=I.getComparisonKey(u);let z=this.a.get(F);if(!z){z=new R;const Z=this.f++,Y=k.Event.once(z.onDrained)(()=>{z?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(Z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$3c),this.d.set(Z,Y),this.a.set(F,z)}return z.queue(v)}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$lh=G;class p{constructor(u,v){this.a=-1,typeof u=="function"&&typeof v=="number"&&this.setIfNotSet(u,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},v)}setIfNotSet(u,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},v))}}e.$mh=p;class _{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,v,I=globalThis){this.cancel();const F=I.setInterval(()=>{u()},v);this.d=(0,O.$Rc)(()=>{I.clearInterval(F),this.d=void 0})}dispose(){this.cancel()}}e.$nh=_;class K{constructor(u,v){this.b=-1,this.a=u,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$oh=K;class H{constructor(u,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=u,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ph=H;class X extends K{constructor(u,v){super(u,v),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$qh=X;class he extends O.$Tc{constructor(u,v){super(),this.g=u,this.h=v,this.a=[],this.b=this.B(new O.$Uc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of u)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$rh=he,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$th=(L,u)=>{(0,f.$B)(()=>{if(v)return;const I=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:e.$th=(L,u,v)=>{const I=L.requestIdleCallback(u,typeof v=="number"?{timeout:v}:void 0);let F=!1;return{dispose(){F||(F=!0,L.cancelIdleCallback(I))}}},e.$sh=L=>(0,e.$th)(globalThis,L)}();class ee{constructor(u,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,e.$th)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$uh=ee;class ue extends ee{constructor(u){super(globalThis,u)}}e.$vh=ue;async function oe(L,u,v){let I;for(let F=0;F<v;F++)try{return await L()}catch(z){I=z,await o(u)}throw I}e.$wh=oe;class te{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,v,I){return this.a={taskId:u,cancel:()=>I?.(),promise:v},v.then(()=>this.d(u),()=>this.d(u)),v}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{const{promise:v,resolve:I,reject:F}=g();this.b={run:u,promise:v,promiseResolve:I,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$xh=te;class ce{constructor(u,v=()=>Date.now()){this.d=u,this.f=v,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$yh=ce;var ne;(function(L){L[L.Resolved=0]="Resolved",L[L.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,v)=>{this.a=u,this.b=v})}complete(u){return new Promise(v=>{this.a(u),this.d={outcome:0,value:u},v()})}error(u){return new Promise(v=>{this.b(u),this.d={outcome:1,value:u},v()})}cancel(){return this.error(new S.$5)}}e.$zh=x;var ie;(function(L){async function u(I){let F;const z=await Promise.all(I.map(Z=>Z.then(Y=>Y,Y=>{F||(F=Y)})));if(typeof F<"u")throw F;return z}L.settled=u;function v(I){return new Promise(async(F,z)=>{try{await I(F,z)}catch(Z){z(Z)}})}L.withAsyncBody=v})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Ah=se;class de{constructor(u){this.b=u,this.a=new l.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Bh=de;var re;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(re||(re={}));class J{static fromArray(u){return new J(v=>{v.emitMany(u)})}static fromPromise(u){return new J(async v=>{v.emitMany(await u)})}static fromPromises(u){return new J(async v=>{await Promise.all(u.map(async I=>v.emitOne(await I)))})}static merge(u){return new J(async v=>{await Promise.all(u.map(async I=>{for await(const F of I)v.emitOne(F)}))})}static{this.EMPTY=J.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new k.$3d,queueMicrotask(async()=>{const v={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(u(v)),this.j()}catch(I){this.k(I)}finally{v.emitOne=void 0,v.emitMany=void 0,v.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(u,v){return new J(async I=>{for await(const F of u)I.emitOne(v(F))})}map(u){return J.map(this,u)}static filter(u,v){return new J(async I=>{for await(const F of u)v(F)&&I.emitOne(F)})}filter(u){return J.filter(this,u)}static coalesce(u){return J.filter(u,v=>!!v)}coalesce(){return J.coalesce(this)}static async toPromise(u){const v=[];for await(const I of u)v.push(I);return v}toPromise(){return J.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$Ch=J;class ae extends J{constructor(u,v){super(v),this.l=u}cancel(){this.l.cancel()}}e.$Dh=ae;function le(L){const u=new A.$ae,v=L(u.token);return new ae(u,async I=>{const F=u.token.onCancellationRequested(()=>{F.dispose(),u.dispose(),I.reject(new S.$5)});try{for await(const z of v){if(u.token.isCancellationRequested)return;I.emitOne(z)}F.dispose(),u.dispose()}catch(z){F.dispose(),u.dispose(),I.reject(z)}})}e.$Eh=le;class fe{constructor(){this.a=new x,this.b=new J(I=>{if(u){I.reject(u);return}return v&&I.emitMany(v),this.d=F=>I.reject(F),this.f=F=>I.emitOne(F),this.a.p});let u,v;this.f=I=>{v||(v=[]),v.push(I)},this.d=I=>{u||(u=I)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$Fh=fe}),define(V[22],W([0,1,38]),function(B,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oC=e.$nC=e.$mC=void 0,e.$mC=new class{clone(){return this}equals(O){return this===O}};function S(O,r){return new A.$Mt([new A.$Lt(0,"",O)],r)}e.$nC=S;function k(O,r){const f=new Uint32Array(2);return f[0]=0,f[1]=(O<<0|0|0|32768|2<<24)>>>0,new A.$Nt(f,r===null?e.$mC:r)}e.$oC=k}),define(V[39],W([0,1,21,9,3,40,14,16,49,22,30,17,10]),function(B,e,A,S,k,O,r,f,t,l,$,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wC=e.$vC=e.$uC=e.$tC=e.$sC=e.$rC=void 0;var a;(function(E){E[E.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(a||(a={}));class i{constructor(c,b){this.tokenizationSupport=b,this.a=this.tokenizationSupport.getInitialState(),this.store=new s(c)}getStartState(c){return this.store.getStartState(c,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$rC=i;class n extends i{constructor(c,b,w,D){super(c,b),this._textModel=w,this._languageIdCodec=D}updateTokensUntilLine(c,b){const w=this._textModel.getLanguageId();for(;;){const D=this.getFirstInvalidLine();if(!D||D.lineNumber>b)break;const M=this._textModel.getLineContent(D.lineNumber),o=P(this._languageIdCodec,w,this.tokenizationSupport,M,!0,D.startState);c.add(D.lineNumber,o.tokens),this.store.setEndState(D.lineNumber,o.endState)}}getTokenTypeIfInsertingCharacter(c,b){const w=this.getStartState(c.lineNumber);if(!w)return 0;const D=this._textModel.getLanguageId(),M=this._textModel.getLineContent(c.lineNumber),o=M.substring(0,c.column-1)+b+M.substring(c.column-1),T=P(this._languageIdCodec,D,this.tokenizationSupport,o,!0,w),j=new h.$Et(T.tokens,o,this._languageIdCodec);if(j.getCount()===0)return 0;const U=j.findTokenIndexAtOffset(c.column-1);return j.getStandardTokenType(U)}tokenizeLineWithEdit(c,b,w){const D=c.lineNumber,M=c.column,o=this.getStartState(D);if(!o)return null;const T=this._textModel.getLineContent(D),j=T.substring(0,M-1)+w+T.substring(M-1+b),U=this._textModel.getLanguageIdAtPosition(D,0),C=P(this._languageIdCodec,U,this.tokenizationSupport,j,!0,o);return new h.$Et(C.tokens,j,this._languageIdCodec)}isCheapToTokenize(c){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return c<b||c===b&&this._textModel.getLineLength(c)<2048}tokenizeHeuristically(c,b,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(c,w),{heuristicTokens:!1};let D=this.b(b);const M=this._textModel.getLanguageId();for(let o=b;o<=w;o++){const T=this._textModel.getLineContent(o),j=P(this._languageIdCodec,M,this.tokenizationSupport,T,!0,D);c.add(o,j.tokens),D=j.endState}return{heuristicTokens:!0}}b(c){let b=this._textModel.getLineFirstNonWhitespaceColumn(c);const w=[];let D=null;for(let T=c-1;b>1&&T>=1;T--){const j=this._textModel.getLineFirstNonWhitespaceColumn(T);if(j!==0&&j<b&&(w.push(this._textModel.getLineContent(T)),b=j,D=this.getStartState(T),D))break}D||(D=this.tokenizationSupport.getInitialState()),w.reverse();const M=this._textModel.getLanguageId();let o=D;for(const T of w)o=P(this._languageIdCodec,M,this.tokenizationSupport,T,!1,o).endState;return o}}e.$sC=n;class s{constructor(c){this.d=c,this.a=new g,this.b=new y,this.b.addRange(new t.$$s(1,c+1))}getEndState(c){return this.a.getEndState(c)}setEndState(c,b){if(!b)throw new S.$cb("Cannot set null/undefined state");this.b.delete(c);const w=this.a.setEndState(c,b);return w&&c<this.d&&this.b.addRange(new t.$$s(c+1,c+2)),w}acceptChange(c,b){this.d+=b-c.length,this.a.acceptChange(c,b),this.b.addRangeAndResize(new t.$$s(c.startLineNumber,c.endLineNumberExclusive),b)}acceptChanges(c){for(const b of c){const[w]=(0,r.$Dt)(b.text);this.acceptChange(new f.$at(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}invalidateEndStateRange(c){this.b.addRange(new t.$$s(c.startLineNumber,c.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(c,b){return c===1?b:this.getEndState(c-1)}getFirstInvalidLine(c){const b=this.getFirstInvalidEndStateLineNumber();if(b===null)return null;const w=this.getStartState(b,c);if(!w)throw new S.$cb("Start state must be defined");return{lineNumber:b,startState:w}}}e.$tC=s;class g{constructor(){this.a=new $.$pC(null)}getEndState(c){return this.a.get(c)}setEndState(c,b){const w=this.a.get(c);return w&&w.equals(b)?!1:(this.a.set(c,b),!0)}acceptChange(c,b){let w=c.length;b>0&&w>0&&(w--,b--),this.a.replace(c.startLineNumber,w,b)}acceptChanges(c){for(const b of c){const[w]=(0,r.$Dt)(b.text);this.acceptChange(new f.$at(b.range.startLineNumber,b.range.endLineNumber+1),w+1)}}}e.$uC=g;class y{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const c=this.a[0];return c.start+1===c.endExclusive?this.a.shift():this.a[0]=new t.$$s(c.start+1,c.endExclusive),c.start}delete(c){const b=this.a.findIndex(w=>w.contains(c));if(b!==-1){const w=this.a[b];w.start===c?w.endExclusive===c+1?this.a.splice(b,1):this.a[b]=new t.$$s(c+1,w.endExclusive):w.endExclusive===c+1?this.a[b]=new t.$$s(w.start,c):this.a.splice(b,1,new t.$$s(w.start,c),new t.$$s(c+1,w.endExclusive))}}addRange(c){t.$$s.addRange(c,this.a)}addRangeAndResize(c,b){let w=0;for(;!(w>=this.a.length||c.start<=this.a[w].endExclusive);)w++;let D=w;for(;!(D>=this.a.length||c.endExclusive<this.a[D].start);)D++;const M=b-c.length;for(let o=D;o<this.a.length;o++)this.a[o]=this.a[o].delta(M);if(w===D){const o=new t.$$s(c.start,c.start+b);o.isEmpty||this.a.splice(w,0,o)}else{const o=Math.min(c.start,this.a[w].start),T=Math.max(c.endExclusive,this.a[D-1].endExclusive),j=new t.$$s(o,T+M);j.isEmpty?this.a.splice(w,D-w):this.a.splice(w,D-w,j)}}toString(){return this.a.map(c=>c.toString()).join(" + ")}}e.$vC=y;function P(E,c,b,w,D,M){let o=null;if(b)try{o=b.tokenizeEncoded(w,D,M.clone())}catch(T){(0,S.$1)(T)}return o||(o=(0,l.$oC)(E.encodeLanguageId(c),M)),h.$Et.convertToEndOffset(o.tokens,w.length),o}class N{constructor(c,b){this.b=c,this.d=b,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,A.$sh)(c=>{this.f=!1,this.h(c)}))}h(c){const b=Date.now()+c.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<b?(0,k.$B)(w):this.g())};w()}j(){const c=this.b._textModel.getLineCount(),b=new d.$qC,w=O.$Yd.create(!1);do if(w.elapsed()>1||this.l(b)>=c)break;while(this.k());this.d.setTokens(b.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(c){const b=this.b?.getFirstInvalidLine();return b?(this.b.updateTokensUntilLine(c,b.lineNumber),b.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(c,b){this.b.store.invalidateEndStateRange(new f.$at(c,b))}}e.$wC=N}),define(V[41],W([0,1,37,2,40,15,38]),function(B,e,A,S,k,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kIb=void 0;class f extends S.$Tc{constructor(l,$,d,h,a,i,n){super(),this.c=l,this.f=$,this.g=d,this.h=h,this.j=a,this.m=i,this.n=n,this.a=[],this.b=this.B(new A.$3d),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(l,$,d){throw new Error("Not supported!")}createBackgroundTokenizer(l,$){if(this.h)return this.h(l,$)}tokenizeEncoded(l,$,d){const h=Math.random()*1e4<1,a=this.n||h,i=a?new k.$Yd(!0):void 0,n=this.c.tokenizeLine2(l,d,500);if(a){const g=i.elapsed();(h||g>32)&&this.m(g,l.length,h)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${l.substring(0,100)}`),new r.$Nt(n.tokens,d);if(this.g){const g=this.a,y=n.tokens;for(let P=0,N=y.length>>>1;P<N;P++){const E=y[(P<<1)+1],c=O.$Bt.getLanguageId(E);g[c]||(g[c]=!0,this.b.fire(c))}}let s;return d.equals(n.ruleStack)?s=d:s=n.ruleStack,new r.$Nt(n.tokens,s)}}e.$kIb=f}),define(V[42],W([0,1,22,2,12]),function(B,e,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lIb=void 0;class O extends S.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,l){super(),this.a=f,this.b=t,this.c=l,this.B((0,k.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,l){throw new Error("Not supported!")}tokenizeEncoded(f,t,l){return f.length>=this.c.get()?(0,A.$oC)(this.a,l):this.b.tokenizeEncoded(f,t,l)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$lIb=O}),define(V[43],W([0,1,36,21,12,3,16,50,39,17,10,41,42]),function(B,e,A,S,k,O,r,f,t,l,$,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qIb=void 0;class a extends f.$uv{constructor(s,g,y,P,N,E,c,b){super(s,g,y,P),this.s=N,this.t=E,this.u=c,this.a=null,this.b=!1,this.c=(0,k.observableValue)(this,-1),this.q=new S.$oh(()=>this.w(),10),this.c.set(b,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(s,g){this.t=s,this.u=g,this.v()}onEvents(s){super.onEvents(s),this.a?.store.acceptChanges(s.changes),this.q.schedule()}acceptMaxTokenizationLineLength(s){this.c.set(s,void 0)}retokenize(s,g){this.a&&(this.a.store.invalidateEndStateRange(new r.$at(s,g)),this.q.schedule())}async v(){this.a=null;const s=this.t,g=this.u,y=await this.s.getOrCreateGrammar(s,g);if(!(this.b||s!==this.t||g!==this.u||!y)){if(y.grammar){const P=new h.$lIb(this.u,new d.$kIb(y.grammar,y.initialState,!1,void 0,()=>!1,(N,E,c)=>{this.s.reportTokenizationTime(N,s,y.sourceExtensionId,E,c)},!1),this.c);this.a=new t.$rC(this.f.length,P)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:g}=await(0,A.$qD)("vscode-textmate","release/main.js");this.m=g}const s=new Date().getTime();for(;;){let g=0;const y=new l.$qC,P=new i;for(;;){const c=this.a.getFirstInvalidLine();if(c===null||g>200)break;g++;const b=this.f[c.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded(b,!0,c.startState);if(this.a.store.setEndState(c.lineNumber,w.endState)){const M=this.m(c.startState,w.endState);P.setState(c.lineNumber,M)}else P.setState(c.lineNumber,null);if($.$Et.convertToEndOffset(w.tokens,b.length),y.add(c.lineNumber,w.tokens),new Date().getTime()-s>20)break}if(g===0)break;const N=P.getStateDeltas();if(this.s.setTokensAndStates(this.h,y.serialize(),N),new Date().getTime()-s>20){(0,O.$B)(()=>this.w());return}}}}e.$qIb=a;class i{constructor(){this.a=-1,this.b=[]}setState(s,g){s===this.a+1?this.b[this.b.length-1].stateDeltas.push(g):this.b.push({startLineNumber:s,stateDeltas:[g]}),this.a=s}getStateDeltas(){return this.b}}}),define(V[44],W([0,1,20]),function(B,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nIb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(O){if(this.a[O.scopeName]){const r=this.a[O.scopeName];A.$Ig(r.location,O.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${O.scopeName}.
Old grammar file: ${r.location.toString()}.
New grammar file: ${O.location.toString()}`)}this.a[O.scopeName]=O}getGrammarDefinition(O){return this.a[O]||null}}e.$nIb=S}),define(V[45],W([0,1,2,44]),function(B,e,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pIb=e.$oIb=void 0,e.$oIb="No TM Grammar registered for this language.";class k extends A.$Tc{constructor(r,f,t,l){super(),this.a=r,this.b=t.INITIAL,this.c=new S.$nIb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:l,loadGrammar:async $=>{const d=this.c.getGrammarDefinition($);if(!d)return this.a.logTrace(`No grammar found for scope ${$}`),null;const h=d.location;try{const a=await this.a.readFile(h);return t.parseRawGrammar(a,h.path)}catch(a){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${h}`,a),null}},getInjections:$=>{const d=$.split(".");let h=[];for(let a=1;a<=d.length;a++){const i=d.slice(0,a).join(".");h=[...h,...this.f[i]||[]]}return h}}));for(const $ of f){if(this.c.register($),$.injectTo){for(const d of $.injectTo){let h=this.f[d];h||(this.f[d]=h=[]),h.push($.scopeName)}if($.embeddedLanguages)for(const d of $.injectTo){let h=this.g[d];h||(this.g[d]=h=[]),h.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(r){return this.h.has(r)}setTheme(r,f){this.j.setTheme(r,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(r,f){const t=this.h.get(r);if(typeof t!="string")throw new Error(e.$oIb);const l=this.c.getGrammarDefinition(t);if(!l)throw new Error(e.$oIb);const $=l.embeddedLanguages;if(this.g[t]){const a=this.g[t];for(const i of a)for(const n of Object.keys(i))$[n]=i[n]}const d=Object.keys($).length>0;let h;try{h=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:$,tokenTypes:l.tokenTypes,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors})}catch(a){throw a.message&&a.message.startsWith("No grammar provided for")?new Error(e.$oIb):a}return{languageId:r,grammar:h,initialState:this.b,containsEmbeddedLanguages:d,sourceExtensionId:l.sourceExtensionId}}}e.$pIb=k}),define(V[51],W([0,1,11,45,43]),function(B,e,A,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function O(f,t){return new r(f,t)}e.create=O;class r{constructor(t,l){this.f=l,this.b=new Map,this.c=[],this.a=t.host;const $=l.grammarDefinitions.map(d=>({location:A.URI.revive(d.location),language:d.language,scopeName:d.scopeName,embeddedLanguages:d.embeddedLanguages,tokenTypes:d.tokenTypes,injectTo:d.injectTo,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors,sourceExtensionId:d.sourceExtensionId}));this.d=this.g($)}async g(t){const l=this.f.textmateMainUri,$=await new Promise((n,s)=>{B([l],n,s)}),d=await new Promise((n,s)=>{B([this.f.onigurumaMainUri],n,s)}),a=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await d.loadWASM(a);const i=Promise.resolve({createOnigScanner:n=>d.createOnigScanner(n),createOnigString:n=>d.createOnigString(n)});return new S.$pIb({logTrace:n=>{},logError:(n,s)=>console.error(n,s),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const l=A.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new k.$qIb(l,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(d,h){const a=await $.d;return a?($.c[h]||($.c[h]=a.createGrammar(d,h)),$.c[h]):Promise.resolve(null)},setTokensAndStates(d,h,a){$.a.setTokensAndStates(t.controllerId,d,h,a)},reportTokenizationTime(d,h,a,i,n){$.a.reportTokenizationTime(d,h,a,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,l){this.b.get(t).onEvents(l)}retokenize(t,l,$){this.b.get(t).retokenize(l,$)}acceptModelLanguageChanged(t,l,$){this.b.get(t).onLanguageId(l,$)}acceptRemovedModel(t){const l=this.b.get(t);l&&(l.dispose(),this.b.delete(t))}async acceptTheme(t,l){(await this.d)?.setTheme(t,l)}acceptMaxTokenizationLineLength(t,l){this.b.get(t).acceptMaxTokenizationLineLength(l)}}e.TextMateTokenizationWorker=r})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d84c946d27b649d614319c796911871320befd42/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
